**********************************************************************
        subroutine  HHtoWW4f_tree_sesm(F,pw12,pw34)
**********************************************************************
*       LO formfactors for HH -> WW -> 4f in the SESM
*---------------------------------------------------------------------
*       6.2.17 Stefan Dittmaier
**********************************************************************
	implicit none
	complex*16 pre,F(13,-1:1,-1:1),pw12,pw34

c mandelstam variables
      	real*8 s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
      	common/mandel/s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
c fermion charges of isospin duplets
	real*8 qf(4)
	common/fcharge/qf
c fermion masses as flag (i*1d-20)
      	complex*16 cme2,cmf2(5)
      	real*8 me2,rme2,mf2(5),rmf2(5)
      	common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2
	include '../COMMON/param.inc'
	include '../COMMON/xparam.inc'
        include '../COMMON/param_sesm.inc'
        include '../COMMON/param_bsm.inc'

C       Process: S4F21aF22F23aF24,   Model: Singlet

        PRE = (PW12*PW34*SA*XMW)/(2D0*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+PRE

	end

**********************************************************************
        subroutine  HHtoWW4f_count_bos_sesm(F,pw12,pw34)
**********************************************************************
*       HH -> WW -> 4f in the SESM
*	bosonic counterterms
*---------------------------------------------------------------------
*       6.2.17 Stefan Dittmaier
**********************************************************************
	implicit none
	complex*16 pre,F(13,-1:1,-1:1),pw12,pw34,ct

c mandelstam variables
      	real*8 s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
      	common/mandel/s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
c fermion charges of isospin duplets
	real*8 qf(4)
	common/fcharge/qf
c fermion masses as flag (i*1d-20)
      	complex*16 cme2,cmf2(5)
      	real*8 me2,rme2,mf2(5),rmf2(5)
      	common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2
	include '../COMMON/param.inc'
	include '../COMMON/xparam.inc'
        include '../COMMON/param_sesm.inc'
        include '../COMMON/param_bsm.inc'
c ren. constants
        complex*16 dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw
        complex*16 dmh02,dmHH2,dZh0,dZHH,dZh0HH,dZHHh0,dsa,dl12
        complex*16 dZeer,dZeel,dZnnl,dZffr(4),dZffl(4)
        complex*16 ct_aww,ct_zww,ct_wen,ct_wf1f2,ct_wf3f4
        complex*16 ct_annl,ct_aeer,ct_aeel,ct_affr(4),ct_affl(4)
        complex*16 ct_znnl,ct_zeer,ct_zeel,ct_zffr(4),ct_zffl(4)
        complex*16 ct_h0ww,ct_HHww,ct_h0zz,ct_HHzz,ct_h0za,ct_HHza
        common/xrenc_sesm/
     &         dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw,
     &         dmh02,dmHH2,dZh0,dZHH,dZh0HH,dZHHh0,dsa,dl12,
     &         dZeer,dZeel,dZnnl,dZffr,dZffl,
     &         ct_aww,ct_zww,ct_wen,ct_wf1f2,ct_wf3f4,
     &         ct_annl,ct_aeer,ct_aeel,ct_affr,ct_affl,
     &         ct_znnl,ct_zeer,ct_zeel,ct_zffr,ct_zffl,
     &         ct_h0ww,ct_HHww,ct_h0zz,ct_HHzz,ct_h0za,ct_HHza

c counterterms for self energies
      	ct =  dmw2/(s12-xmw2) - dZw
     &	     +dmw2/(s34-xmw2) - dZw

        PRE = (PW12*PW34*SA*XMW)/(2D0*XSW*XSW2) *ct

      	F(1,-1,-1) = F(1,-1,-1)+PRE

c Vff vertex counterterms
      	ct = ct_wf1f2 + ct_wf3f4

        PRE = (PW12*PW34*SA*XMW)/(2D0*XSW*XSW2) *ct

      	F(1,-1,-1) = F(1,-1,-1)+PRE

c HVV vertex counterterm
      	ct = ct_HHww 

        PRE = (PW12*PW34*SA*XMW)/(2D0*XSW*XSW2) *ct

      	F(1,-1,-1) = F(1,-1,-1)+PRE

	end

**********************************************************************
        subroutine  HHtoWW4f_count_ferm_sesm(F,pw12,pw34)
**********************************************************************
*       HH -> WW -> 4f in the SESM
*	bosonic counterterms
*---------------------------------------------------------------------
*       7.2.17 Stefan Dittmaier
**********************************************************************
	implicit none
	complex*16 pre,F(13,-1:1,-1:1),pw12,pw34,ct

c mandelstam variables
      	real*8 s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
      	common/mandel/s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
c fermion charges of isospin duplets
	real*8 qf(4)
	common/fcharge/qf
c fermion masses as flag (i*1d-20)
      	complex*16 cme2,cmf2(5)
      	real*8 me2,rme2,mf2(5),rmf2(5)
      	common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2
	include '../COMMON/param.inc'
	include '../COMMON/xparam.inc'
        include '../COMMON/param_sesm.inc'
        include '../COMMON/param_bsm.inc'
c ren. constants
        complex*16 dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw
        complex*16 dmh02,dmHH2,dZh0,dZHH,dZh0HH,dZHHh0,dsa,dl12
        complex*16 dZeer,dZeel,dZnnl,dZffr(4),dZffl(4)
        complex*16 ct_aww,ct_zww,ct_wen,ct_wf1f2,ct_wf3f4
        complex*16 ct_annl,ct_aeer,ct_aeel,ct_affr(4),ct_affl(4)
        complex*16 ct_znnl,ct_zeer,ct_zeel,ct_zffr(4),ct_zffl(4)
        complex*16 ct_h0ww,ct_HHww,ct_h0zz,ct_HHzz,ct_h0za,ct_HHza
        common/xrenc_ferm_sesm/
     &         dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw,
     &         dmh02,dmHH2,dZh0,dZHH,dZh0HH,dZHHh0,dsa,dl12,
     &         dZeer,dZeel,dZnnl,dZffr,dZffl,
     &         ct_aww,ct_zww,ct_wen,ct_wf1f2,ct_wf3f4,
     &         ct_annl,ct_aeer,ct_aeel,ct_affr,ct_affl,
     &         ct_znnl,ct_zeer,ct_zeel,ct_zffr,ct_zffl,
     &         ct_h0ww,ct_HHww,ct_h0zz,ct_HHzz,ct_h0za,ct_HHza

c counterterms for self energies
      	ct =  dmw2/(s12-xmw2) - dZw
     &	     +dmw2/(s34-xmw2) - dZw

        PRE = (PW12*PW34*SA*XMW)/(2D0*XSW*XSW2) *ct

      	F(1,-1,-1) = F(1,-1,-1)+PRE

c Vff vertex counterterms
      	ct = ct_wf1f2 + ct_wf3f4

        PRE = (PW12*PW34*SA*XMW)/(2D0*XSW*XSW2) *ct

      	F(1,-1,-1) = F(1,-1,-1)+PRE

c HVV vertex counterterm
      	ct = ct_HHww 

        PRE = (PW12*PW34*SA*XMW)/(2D0*XSW*XSW2) *ct

      	F(1,-1,-1) = F(1,-1,-1)+PRE

	end

**********************************************************************
        subroutine  HHtoWW4f_self_bos2_sesm(F,pw12,pw34)
**********************************************************************
*       self-energy contributions for HH -> WW -> 4f in the SESM
*       bosonic loops
*---------------------------------------------------------------------
*       6.2.17 Stefan Dittmaier
**********************************************************************
	implicit none
	complex*16 pre,F(13,-1:1,-1:1),pw12,pw34

c mandelstam variables
      	real*8 s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
      	common/mandel/s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
c fermion charges of isospin duplets
	real*8 qf(4)
	common/fcharge/qf
c fermion masses as flag (i*1d-20)
      	complex*16 cme2,cmf2(5)
      	real*8 me2,rme2,mf2(5),rmf2(5)
      	common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2
        complex*16 fact,xseww_sesm
	include '../COMMON/param.inc'
	include '../COMMON/xparam.inc'
        include '../COMMON/param_sesm.inc'
        include '../COMMON/param_bsm.inc'

        fact = - xseww_sesm(s12)*pw12 - xseww_sesm(s34)*pw34

        PRE = (PW12*PW34*SA*XMW)/(2D0*XSW*XSW2) *fact

        F(1,-1,-1) = F(1,-1,-1)+PRE

	end

**********************************************************************
        subroutine  HHtoWW4f_self_bos_sesm(F,pw12,pw34)
**********************************************************************
*       self-energy contributions for HH -> WW -> 4f in the SESM
*       bosonic loops
*---------------------------------------------------------------------
*       6.2.17 Stefan Dittmaier
**********************************************************************
	implicit none
	complex*16 pre,F(13,-1:1,-1:1),pw12,pw34
	complex*16 A0,xA0_,B0_,xB0_,DB0_,xDB0_,B1_,xB1_,DB1_,xDB1_
        complex*16 B0,B1(1),B2(0:2,0:2),B3(0:2,0:2,2)
        complex*16 B4(0:2,0:2,0:2,0:2),B5(0:2,0:2,0:2,0:2,2)
        complex*16 C0_,C0,C1(2),C2(0:2,0:2),C3(0:2,0:2,2)
        complex*16 C4(0:2,0:2,0:2,0:2)
	complex*16 D0,D1(3),D2(0:3,0:3),D3(0:3,0:3,3)
        complex*16 D4(0:3,0:3,0:3,0:3),D5(0:3,0:3,0:3,0:3,3)
	complex*16 E0n,E1n(4),E2n(0:4,0:4),E3n(0:4,0:4,4)
	complex*16 E4n(0:4,0:4,0:4,0:4)

c mandelstam variables
      	real*8 s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
      	common/mandel/s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
c fermion charges of isospin duplets
	real*8 qf(4)
	common/fcharge/qf
c fermion masses as flag (i*1d-20)
      	complex*16 cme2,cmf2(5)
      	real*8 me2,rme2,mf2(5),rmf2(5)
      	common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2
	include '../COMMON/param.inc'
	include '../COMMON/xparam.inc'
        include '../COMMON/param_sesm.inc'
        include '../COMMON/param_bsm.inc'

C       Process: S4F21aF22F23aF24,   Model: Singlet

C       G(T1,N1,FULL)

C       G(T1,N2,FULL)

C       G(T1,N3,FULL)

C       G(T1,N4,FULL)

C       G(T1,N5,FULL)

C       G(T1,N6,FULL)

C       G(T1,N7,FULL)

C       G(T2,N8,FULL)
        A0 = xA0_(XMW2)

        PRE = -((A0*ALPHA*PW12**2*PW34*SA*XMW*XSW2**(-2))/(16D0*PI*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T2,N9,FULL)
        A0 = xA0_(XMH2)

        PRE = -((A0*ALPHA*CA**2*PW12**2*PW34*SA*XMW*XSW2**(-2))/
     &  (32D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T2,N10,FULL)
        A0 = xA0_(XMZ2)

        PRE = -((A0*ALPHA*PW12**2*PW34*SA*XMW*XSW2**(-2))/(32D0*PI*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T2,N11,FULL)
        A0 = xA0_(XMHH2)

        PRE = -((A0*ALPHA*PW12**2*PW34*SA**3*XMW*XSW2**(-2))/(32D0*
     &  PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T2,N12,FULL)
        A0 = xA0_(XMW2)

        PRE = -((ALPHA*PW12**2*PW34*SA*XMW*(3D0*A0-2D0*XMW2)*XSW2**
     &  (-2))/(8D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T2,N13,FULL)

C       G(T2,N14,FULL)
        A0 = xA0_(XMZ2)

        PRE = -((ALPHA*PW12**2*PW34*SA*XCW2*XMW*(3D0*A0-2D0*XMZ2)*
     &  XSW2**(-2))/(8D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T3,N15,FULL)

C       G(T3,N16,FULL)

C       G(T3,N17,FULL)

C       G(T3,N18,FULL)

C       G(T3,N19,FULL)

C       G(T3,N20,FULL)

C       G(T3,N21,FULL)

C       G(T4,N22,FULL)

C       G(T4,N23,FULL)

C       G(T4,N24,FULL)

C       G(T4,N25,FULL)

C       G(T4,N26,FULL)

C       G(T4,N27,FULL)

C       G(T4,N28,FULL)

C       G(T5,N29,FULL)
        A0 = xA0_(XMW2)

        PRE = -((A0*ALPHA*PW12*PW34**2*SA*XMW*XSW2**(-2))/(16D0*PI*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T5,N30,FULL)
        A0 = xA0_(XMH2)

        PRE = -((A0*ALPHA*CA**2*PW12*PW34**2*SA*XMW*XSW2**(-2))/
     &  (32D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T5,N31,FULL)
        A0 = xA0_(XMZ2)

        PRE = -((A0*ALPHA*PW12*PW34**2*SA*XMW*XSW2**(-2))/(32D0*PI*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T5,N32,FULL)
        A0 = xA0_(XMHH2)

        PRE = -((A0*ALPHA*PW12*PW34**2*SA**3*XMW*XSW2**(-2))/(32D0*
     &  PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T5,N33,FULL)
        A0 = xA0_(XMW2)

        PRE = -((ALPHA*PW12*PW34**2*SA*XMW*(3D0*A0-2D0*XMW2)*XSW2**
     &  (-2))/(8D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T5,N34,FULL)

C       G(T5,N35,FULL)
        A0 = xA0_(XMZ2)

        PRE = -((ALPHA*PW12*PW34**2*SA*XCW2*XMW*(3D0*A0-2D0*XMZ2)*
     &  XSW2**(-2))/(8D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T6,N36,FULL)

C       G(T6,N37,FULL)

C       G(T6,N38,FULL)

C       G(T6,N39,FULL)

C       G(T6,N40,FULL)

C       G(T6,N41,FULL)

C       G(T6,N42,FULL)

C       G(T7,N43,FULL)

C       G(T7,N44,FULL)

C       G(T7,N45,FULL)

C       G(T7,N46,FULL)

C       G(T7,N47,FULL)

C       G(T7,N48,FULL)

C       G(T7,N49,FULL)

C       G(T7,N50,FULL)

C       G(T7,N51,FULL)

C       G(T7,N52,FULL)

C       G(T7,N53,FULL)

C       G(T7,N58,FULL)
        CALL xB012345_(S12,XMW2,XMH2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (B2(0,0)*ALPHA*CA**2*PW12**2*PW34*SA*XMW*XSW2**(-2))/
     &  (8D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T7,N59,FULL)
        CALL xB012345_(S12,XMW2,XMZ2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (B2(0,0)*ALPHA*PW12**2*PW34*SA*XMW*XSW2**(-2))/(8D0*
     &  PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T7,N60,FULL)
        CALL xB012345_(S12,XMW2,XMHH2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (B2(0,0)*ALPHA*PW12**2*PW34*SA**3*XMW*XSW2**(-2))/
     &  (8D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T7,N61,FULL)
        CALL xB012345_(S12,NULL,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PW12**2*PW34*SA*XMW*XMW2)/(8D0*PI*XSW*
     &  XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T7,N62,FULL)
        CALL xB012345_(S12,XMW2,XMZ2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PW12**2*PW34*SA*XMW*XMW2)/(8D0*PI*XCW2*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T7,N63,FULL)
        CALL xB012345_(S12,XMW2,XMH2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*CA**2*PW12**2*PW34*SA*XMW*XMW2*XSW2**(-
     &  2))/(8D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T7,N64,FULL)
        CALL xB012345_(S12,XMW2,XMHH2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PW12**2*PW34*SA**3*XMW*XMW2*XSW2**(-2))/
     &  (8D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T7,N65,FULL)
        CALL xB012345_(S12,XMW2,XMZ2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = -((B2(0,0)*ALPHA*PW12**2*PW34*SA*XCW2*XMW*XSW2**(-2))/
     &  (8D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T7,N66,FULL)
        CALL xB012345_(S12,NULL,XMW2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = -((B2(0,0)*ALPHA*PW12**2*PW34*SA*XMW)/(8D0*PI*XSW*
     &  XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T7,N67,FULL)
        CALL xB012345_(S12,XMW2,XMZ2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = -((B2(0,0)*ALPHA*PW12**2*PW34*SA*XCW2*XMW*XSW2**(-2))/
     &  (8D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T7,N68,FULL)
        CALL xB012345_(S12,NULL,XMW2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = -((B2(0,0)*ALPHA*PW12**2*PW34*SA*XMW)/(8D0*PI*XSW*
     &  XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T7,N69,FULL)
        CALL xB012345_(S12,NULL,XMW2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (ALPHA*PW12**2*PW34*SA*XMW*(18D0*B2(0,0)+S12+2D0*
     &  B1(1)*S12+2D0*B2(1,1)*S12+5D0*B0*S12-3D0*XMW2))/(8D0*PI*XSW*
     &  XSW2)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T7,N70,FULL)
        CALL xB012345_(S12,XMW2,XMZ2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (ALPHA*PW12**2*PW34*SA*XCW2*XMW*(18D0*B2(0,0)+S12+2D0*
     &  B1(1)*S12+2D0*B2(1,1)*S12+5D0*B0*S12-3D0*XMW2-3D0*XMZ2)*
     &  XSW2**(-2))/(8D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T8,N75,FULL)

C       G(T8,N76,FULL)

C       G(T8,N77,FULL)

C       G(T8,N78,FULL)

C       G(T8,N79,FULL)

C       G(T8,N80,FULL)

C       G(T8,N81,FULL)

C       G(T8,N82,FULL)

C       G(T8,N83,FULL)

C       G(T8,N84,FULL)

C       G(T8,N85,FULL)

C       G(T8,N86,FULL)

C       G(T8,N87,FULL)

C       G(T9,N92,FULL)

C       G(T9,N93,FULL)

C       G(T9,N94,FULL)

C       G(T9,N95,FULL)

C       G(T9,N96,FULL)

C       G(T9,N97,FULL)

C       G(T9,N98,FULL)

C       G(T9,N99,FULL)

C       G(T9,N100,FULL)

C       G(T9,N101,FULL)

C       G(T9,N102,FULL)

C       G(T9,N103,FULL)

C       G(T9,N104,FULL)

C       G(T10,N105,FULL)

C       G(T10,N106,FULL)

C       G(T10,N107,FULL)

C       G(T10,N108,FULL)

C       G(T11,N109,FULL)

C       G(T11,N110,FULL)

C       G(T11,N111,FULL)

C       G(T11,N112,FULL)

C       G(T12,N113,FULL)

C       G(T12,N114,FULL)

C       G(T12,N115,FULL)

C       G(T12,N116,FULL)

C       G(T13,N117,FULL)

C       G(T13,N118,FULL)

C       G(T13,N119,FULL)

C       G(T13,N120,FULL)

C       G(T14,N121,FULL)

C       G(T14,N122,FULL)

C       G(T14,N123,FULL)

C       G(T14,N124,FULL)

C       G(T14,N125,FULL)

C       G(T14,N126,FULL)

C       G(T14,N127,FULL)

C       G(T14,N128,FULL)

C       G(T14,N129,FULL)

C       G(T14,N130,FULL)

C       G(T14,N131,FULL)

C       G(T14,N136,FULL)
        CALL xB012345_(S34,XMW2,XMH2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (B2(0,0)*ALPHA*CA**2*PW12*PW34**2*SA*XMW*XSW2**(-2))/
     &  (8D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T14,N137,FULL)
        CALL xB012345_(S34,XMW2,XMZ2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (B2(0,0)*ALPHA*PW12*PW34**2*SA*XMW*XSW2**(-2))/(8D0*
     &  PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T14,N138,FULL)
        CALL xB012345_(S34,XMW2,XMHH2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (B2(0,0)*ALPHA*PW12*PW34**2*SA**3*XMW*XSW2**(-2))/
     &  (8D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T14,N139,FULL)
        CALL xB012345_(S34,NULL,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PW12*PW34**2*SA*XMW*XMW2)/(8D0*PI*XSW*
     &  XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T14,N140,FULL)
        CALL xB012345_(S34,XMW2,XMZ2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PW12*PW34**2*SA*XMW*XMW2)/(8D0*PI*XCW2*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T14,N141,FULL)
        CALL xB012345_(S34,XMW2,XMH2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*CA**2*PW12*PW34**2*SA*XMW*XMW2*XSW2**(-
     &  2))/(8D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T14,N142,FULL)
        CALL xB012345_(S34,XMW2,XMHH2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PW12*PW34**2*SA**3*XMW*XMW2*XSW2**(-2))/
     &  (8D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T14,N143,FULL)
        CALL xB012345_(S34,XMW2,XMZ2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = -((B2(0,0)*ALPHA*PW12*PW34**2*SA*XCW2*XMW*XSW2**(-2))/
     &  (8D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T14,N144,FULL)
        CALL xB012345_(S34,NULL,XMW2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = -((B2(0,0)*ALPHA*PW12*PW34**2*SA*XMW)/(8D0*PI*XSW*
     &  XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T14,N145,FULL)
        CALL xB012345_(S34,XMW2,XMZ2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = -((B2(0,0)*ALPHA*PW12*PW34**2*SA*XCW2*XMW*XSW2**(-2))/
     &  (8D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T14,N146,FULL)
        CALL xB012345_(S34,NULL,XMW2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = -((B2(0,0)*ALPHA*PW12*PW34**2*SA*XMW)/(8D0*PI*XSW*
     &  XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T14,N147,FULL)
        CALL xB012345_(S34,NULL,XMW2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (ALPHA*PW12*PW34**2*SA*XMW*(18D0*B2(0,0)+S34+2D0*
     &  B1(1)*S34+2D0*B2(1,1)*S34+5D0*B0*S34-3D0*XMW2))/(8D0*PI*XSW*
     &  XSW2)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T14,N148,FULL)
        CALL xB012345_(S34,XMW2,XMZ2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (ALPHA*PW12*PW34**2*SA*XCW2*XMW*(18D0*B2(0,0)+S34+2D0*
     &  B1(1)*S34+2D0*B2(1,1)*S34+5D0*B0*S34-3D0*XMW2-3D0*XMZ2)*
     &  XSW2**(-2))/(8D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T15,N153,FULL)

C       G(T15,N154,FULL)

C       G(T15,N155,FULL)

C       G(T15,N156,FULL)

C       G(T15,N157,FULL)

C       G(T15,N158,FULL)

C       G(T15,N159,FULL)

C       G(T15,N160,FULL)

C       G(T15,N161,FULL)

C       G(T15,N162,FULL)

C       G(T15,N163,FULL)

C       G(T15,N164,FULL)

C       G(T15,N165,FULL)

C       G(T16,N170,FULL)

C       G(T16,N171,FULL)

C       G(T16,N172,FULL)

C       G(T16,N173,FULL)

C       G(T16,N174,FULL)

C       G(T16,N175,FULL)

C       G(T16,N176,FULL)

C       G(T16,N177,FULL)

C       G(T16,N178,FULL)

C       G(T16,N179,FULL)

C       G(T16,N180,FULL)

C       G(T16,N181,FULL)

C       G(T16,N182,FULL)

	end

**********************************************************************
        subroutine  HHtoWW4f_vert_bos_sesm(F,pw12,pw34)
**********************************************************************
*       vertex corrections for HH -> WW -> 4f in the SESM
*       bosonic loops
*---------------------------------------------------------------------
*       6.2.17 Stefan Dittmaier
**********************************************************************
	implicit none
	complex*16 pre,F(13,-1:1,-1:1),pw12,pw34
	complex*16 A0,xA0_,B0_,xB0_,DB0_,xDB0_,B1_,xB1_,DB1_,xDB1_
        complex*16 B0,B1(1),B2(0:2,0:2),B3(0:2,0:2,2)
        complex*16 B4(0:2,0:2,0:2,0:2),B5(0:2,0:2,0:2,0:2,2)
        complex*16 C0_,C0,C1(2),C2(0:2,0:2),C3(0:2,0:2,2)
        complex*16 C4(0:2,0:2,0:2,0:2)
	complex*16 D0,D1(3),D2(0:3,0:3),D3(0:3,0:3,3)
        complex*16 D4(0:3,0:3,0:3,0:3),D5(0:3,0:3,0:3,0:3,3)
	complex*16 E0n,E1n(4),E2n(0:4,0:4),E3n(0:4,0:4,4)
	complex*16 E4n(0:4,0:4,0:4,0:4)
        COMPLEX*16 K(1)

c mandelstam variables
      	real*8 s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
      	common/mandel/s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
c fermion charges of isospin duplets
	real*8 qf(4)
	common/fcharge/qf
c fermion masses as flag (i*1d-20)
      	complex*16 cme2,cmf2(5)
      	real*8 me2,rme2,mf2(5),rmf2(5)
      	common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2
	include '../COMMON/param.inc'
	include '../COMMON/xparam.inc'
        include '../COMMON/param_sesm.inc'
        include '../COMMON/param_bsm.inc'

C       Process: S4F21aF22F23aF24,   Model: Singlet

C       G(T1,N24,FULL)

C       G(T1,N25,FULL)

C       G(T1,N27,FULL)

C       G(T1,N28,FULL)

C       G(T1,N29,FULL)

C       G(T1,N30,FULL)

C       G(T1,N31,FULL)

C       G(T1,N32,FULL)

C       G(T1,N34,FULL)

C       G(T1,N36,FULL)

C       G(T1,N61,FULL)

C       G(T1,N64,FULL)

C       G(T1,N65,FULL)

C       G(T1,N66,FULL)

C       G(T1,N67,FULL)
        CALL xC01234_(RMF2(2),RMF2(1),S12,NULL,CMF2(2),XMW2,C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,1)

        PRE = (QF(2)*ALPHA*PW12*PW34*(1D0-6D0*C2(0,0)-C1(1)*S12-
     &  C1(2)*S12-C2(1,2)*S12-C2(2,2)*S12-C0*S12)*SA*XMW)/(4D0*PI*
     &  XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T1,N68,FULL)
        CALL xC01234_(RMF2(1),S12,RMF2(2),CMF2(2),XMW2,XMZ2,C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,1)

        PRE = -((ALPHA*PW12*PW34*(1D0-6D0*C2(0,0)+C1(1)*S12+C1(2)*
     &  S12+C2(1,2)*S12)*SA*XMW*XSW2**(-2)*(1D0+2D0*QF(2)*XSW2))/
     &  (8D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T1,N70,FULL)
        CALL xC01234_(RMF2(1),S12,RMF2(2),CMF2(1),NULL,XMW2,C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,1)

        PRE = -((QF(1)*ALPHA*PW12*PW34*(1D0-6D0*C2(0,0)+C1(1)*S12+
     &  C1(2)*S12+C2(1,2)*S12)*SA*XMW)/(4D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T1,N72,FULL)
        CALL xC01234_(RMF2(1),S12,RMF2(2),CMF2(1),XMZ2,XMW2,C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,1)

        PRE = -((ALPHA*PW12*PW34*(1D0-6D0*C2(0,0)+C1(1)*S12+C1(2)*
     &  S12+C2(1,2)*S12)*SA*XMW*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2))/
     &  (8D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T1,N88,FULL)

C       G(T1,N89,FULL)

C       G(T1,N90,FULL)

C       G(T1,N91,FULL)
        CALL xC01234_(RMF2(2),S12,RMF2(1),NULL,CMF2(2),CMF2(1),C0,C1,C2,
     &  C3,C4,B0,B1,B2,B3,2,1)

        PRE = -((QF(1)*QF(2)*ALPHA*PW12*PW34*(1D0-2D0*C2(0,0)+C1(1)*
     &  S12+C1(2)*S12+C2(1,2)*S12+C0*S12)*SA*XMW)/(4D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T1,N92,FULL)
        CALL xC01234_(S12,RMF2(1),RMF2(2),CMF2(2),CMF2(1),XMZ2,C0,C1,C2,
     &  C3,C4,B0,B1,B2,B3,2,1)

        PRE = (ALPHA*PW12*PW34*(1D0-2D0*C2(0,0)-C1(1)*S12-C1(2)*S12-
     &  C2(1,1)*S12-C2(1,2)*S12)*SA*XMW*XSW2**(-2)*(1D0-2D0*QF(1)*
     &  XSW2)*(1D0+2D0*QF(2)*XSW2))/(16D0*PI*XCW2*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T2,N117,FULL)

C       G(T2,N120,FULL)

C       G(T2,N121,FULL)

C       G(T2,N122,FULL)

C       G(T2,N123,FULL)

C       G(T2,N124,FULL)

C       G(T2,N126,FULL)

C       G(T2,N128,FULL)

C       G(T2,N134,FULL)

C       G(T2,N135,FULL)

C       G(T2,N136,FULL)

C       G(T2,N137,FULL)

C       G(T2,N138,FULL)

C       G(T3,N163,FULL)

C       G(T3,N166,FULL)

C       G(T3,N167,FULL)

C       G(T3,N168,FULL)

C       G(T3,N169,FULL)

C       G(T3,N170,FULL)

C       G(T3,N172,FULL)

C       G(T3,N174,FULL)

C       G(T3,N180,FULL)

C       G(T3,N181,FULL)

C       G(T3,N182,FULL)

C       G(T3,N183,FULL)

C       G(T3,N184,FULL)

C       G(T4,N197,FULL)

C       G(T4,N198,FULL)

C       G(T4,N199,FULL)

C       G(T4,N200,FULL)

C       G(T4,N203,FULL)

C       G(T4,N204,FULL)

C       G(T4,N205,FULL)

C       G(T4,N206,FULL)
        CALL xC01234_(T12,MHH2,RMF2(2),CMF2(2),XMZ2,XMZ2,C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,1,1)

        PRE = (C1(1)*ALPHA*PW34*SA*XCW2**(-2)*XMW*XSW2**(-2)*(1D0+
     &  2D0*QF(2)*XSW2)**2)/(16D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T4,N208,FULL)
        CALL xC01234_(RMF2(2),MHH2,T12,CMF2(1),XMW2,XMW2,C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,1,1)

        PRE = (C1(2)*ALPHA*PW34*SA*XMW*XSW2**(-2))/(8D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T4,N212,FULL)

C       G(T4,N218,FULL)

C       G(T4,N219,FULL)

C       G(T4,N220,FULL)

C       G(T4,N221,FULL)

C       G(T4,N222,FULL)

C       G(T5,N237,FULL)

C       G(T5,N238,FULL)

C       G(T5,N239,FULL)

C       G(T5,N240,FULL)

C       G(T5,N241,FULL)

C       G(T5,N242,FULL)

C       G(T5,N244,FULL)
        CALL xC01234_(RMF2(1),MHH2,T11,CMF2(2),XMW2,XMW2,C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,1,1)

        PRE = (C1(2)*ALPHA*PW34*SA*XMW*XSW2**(-2))/(8D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T5,N245,FULL)

C       G(T5,N246,FULL)
        CALL xC01234_(RMF2(1),MHH2,T11,CMF2(1),XMZ2,XMZ2,C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,1,1)

        PRE = (C1(2)*ALPHA*PW34*SA*XCW2**(-2)*XMW*XSW2**(-2)*(1D0-
     &  2D0*QF(1)*XSW2)**2)/(16D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T5,N250,FULL)

C       G(T5,N256,FULL)

C       G(T5,N257,FULL)

C       G(T5,N258,FULL)

C       G(T5,N259,FULL)

C       G(T5,N260,FULL)

C       G(T6,N267,FULL)

C       G(T6,N268,FULL)

C       G(T6,N269,FULL)

C       G(T6,N270,FULL)

C       G(T6,N271,FULL)

C       G(T6,N282,FULL)

C       G(T6,N284,FULL)

C       G(T6,N286,FULL)

C       G(T6,N288,FULL)

C       G(T6,N293,FULL)

C       G(T6,N294,FULL)

C       G(T6,N295,FULL)

C       G(T6,N296,FULL)

C       G(T7,N321,FULL)

C       G(T7,N322,FULL)

C       G(T7,N323,FULL)

C       G(T7,N324,FULL)

C       G(T7,N325,FULL)

C       G(T7,N326,FULL)

C       G(T7,N328,FULL)
        CALL xC01234_(RMF2(3),MHH2,T13,CMF2(4),XMW2,XMW2,C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,1,1)

        PRE = (C1(2)*ALPHA*PW12*SA*XMW*XSW2**(-2))/(8D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T7,N329,FULL)

C       G(T7,N330,FULL)
        CALL xC01234_(T13,MHH2,RMF2(3),CMF2(3),XMZ2,XMZ2,C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,1,1)

        PRE = (C1(1)*ALPHA*PW12*SA*XCW2**(-2)*XMW*XSW2**(-2)*(1D0+
     &  2D0*QF(3)*XSW2)**2)/(16D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T7,N334,FULL)

C       G(T7,N340,FULL)

C       G(T7,N341,FULL)

C       G(T7,N342,FULL)

C       G(T7,N343,FULL)

C       G(T7,N344,FULL)

C       G(T8,N352,FULL)

C       G(T8,N353,FULL)

C       G(T8,N354,FULL)

C       G(T8,N355,FULL)

C       G(T8,N356,FULL)

C       G(T8,N366,FULL)

C       G(T8,N368,FULL)

C       G(T8,N370,FULL)

C       G(T8,N372,FULL)

C       G(T8,N377,FULL)

C       G(T8,N378,FULL)

C       G(T8,N379,FULL)

C       G(T8,N380,FULL)

C       G(T9,N436,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMZ2,XMZ2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)

        PRE = (ALPHA*PW12*PW34*SA*XMHH2*XSW2**(-2))/(16D0*PI*XMW*
     &  XSW)

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)-C2(1,2)*PRE
        F(6,-1,-1) = F(6,-1,-1)-C2(1,2)*PRE
        F(7,-1,-1) = F(7,-1,-1)-C2(1,2)*PRE
        F(8,-1,-1) = F(8,-1,-1)-C2(1,2)*PRE

C       G(T9,N437,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMZ2,XMZ2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)

        PRE = (ALPHA*PW12*PW34*SA*XMW)/(16D0*PI*XCW2*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(-(2D0*C1(2))-C2(1,2))*PRE
        F(6,-1,-1) = F(6,-1,-1)+(-(2D0*C1(2))-C2(1,2))*PRE
        F(7,-1,-1) = F(7,-1,-1)+(-(2D0*C1(2))-C2(1,2))*PRE
        F(8,-1,-1) = F(8,-1,-1)+(-(2D0*C1(2))-C2(1,2))*PRE

C       G(T9,N438,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMZ2,XMZ2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)

        PRE = -((ALPHA*PW12*PW34*SA*XMW*XSW2**(-2))/(16D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)-C2(1,2)*PRE
        F(6,-1,-1) = F(6,-1,-1)-C2(1,2)*PRE
        F(7,-1,-1) = F(7,-1,-1)-C2(1,2)*PRE
        F(8,-1,-1) = F(8,-1,-1)-C2(1,2)*PRE

C       G(T9,N439,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMZ2,XMZ2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)

        PRE = -((ALPHA*PW12*PW34*SA*XMW*XSW2**(-2))/(16D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)-C2(1,2)*PRE
        F(6,-1,-1) = F(6,-1,-1)-C2(1,2)*PRE
        F(7,-1,-1) = F(7,-1,-1)-C2(1,2)*PRE
        F(8,-1,-1) = F(8,-1,-1)-C2(1,2)*PRE

C       G(T9,N440,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMZ2,XMZ2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)

        PRE = (ALPHA*PW12*PW34*SA*XMW)/(16D0*PI*XCW2*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(-(2D0*C1(1))-C2(1,2))*PRE
        F(6,-1,-1) = F(6,-1,-1)+(-(2D0*C1(1))-C2(1,2))*PRE
        F(7,-1,-1) = F(7,-1,-1)+(-(2D0*C1(1))-C2(1,2))*PRE
        F(8,-1,-1) = F(8,-1,-1)+(-(2D0*C1(1))-C2(1,2))*PRE

C       G(T9,N475,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMH2,XMH2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)

        PRE = (CA**2*PI**(-2)*PW12*PW34*SA*(2D0*XMH2+XMHH2)*XSW2**(-
     &  2)*(4D0*ALPHA*PI*XMH2+12D0*ALPHA*CA**2*PI*XMH2-4D0*ALPHA*PI*
     &  SA**2*XMH2-4D0*ALPHA*PI*XMHH2-12D0*ALPHA*CA**2*PI*XMHH2+4D0*
     &  ALPHA*PI*SA**2*XMHH2-32D0*L12*XMW2*XSW2))/(256D0*(XMH+XMHH)*
     &  (XMH-XMHH)*XMW*XSW)

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)-C2(1,2)*PRE
        F(6,-1,-1) = F(6,-1,-1)-C2(1,2)*PRE
        F(7,-1,-1) = F(7,-1,-1)-C2(1,2)*PRE
        F(8,-1,-1) = F(8,-1,-1)-C2(1,2)*PRE

C       G(T9,N476,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMH2,XMH2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,0,0)

        PRE = -((C0*CA**2*PI**(-2)*PW12*PW34*SA*(2D0*XMH2+XMHH2)*
     &  XMW*XSW2**(-2)*(4D0*ALPHA*PI*XMH2+12D0*ALPHA*CA**2*PI*XMH2-
     &  4D0*ALPHA*PI*SA**2*XMH2-4D0*ALPHA*PI*XMHH2-12D0*ALPHA*CA**2*
     &  PI*XMHH2+4D0*ALPHA*PI*SA**2*XMHH2-32D0*L12*XMW2*XSW2))/
     &  (256D0*(XMH+XMHH)*(XMH-XMHH)*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T9,N477,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMH2,XMHH2,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,2,0)

        PRE = (CA**2*PI**(-2)*PW12*PW34*SA*(XMH2+2D0*XMHH2)*XSW2**(-
     &  2)*(4D0*ALPHA*PI*XMH2-4D0*ALPHA*CA**2*PI*XMH2+12D0*ALPHA*PI*
     &  SA**2*XMH2-4D0*ALPHA*PI*XMHH2+4D0*ALPHA*CA**2*PI*XMHH2-12D0*
     &  ALPHA*PI*SA**2*XMHH2+32D0*L12*XMW2*XSW2))/(256D0*(XMH+XMHH)*
     &  (XMH-XMHH)*XMW*XSW)

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)-C2(1,2)*PRE
        F(6,-1,-1) = F(6,-1,-1)-C2(1,2)*PRE
        F(7,-1,-1) = F(7,-1,-1)-C2(1,2)*PRE
        F(8,-1,-1) = F(8,-1,-1)-C2(1,2)*PRE

C       G(T9,N478,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMH2,XMHH2,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,0,0)

        PRE = -((C0*CA**2*PI**(-2)*PW12*PW34*SA*(XMH2+2D0*XMHH2)*
     &  XMW*XSW2**(-2)*(4D0*ALPHA*PI*XMH2-4D0*ALPHA*CA**2*PI*XMH2+
     &  12D0*ALPHA*PI*SA**2*XMH2-4D0*ALPHA*PI*XMHH2+4D0*ALPHA*CA**2*
     &  PI*XMHH2-12D0*ALPHA*PI*SA**2*XMHH2+32D0*L12*XMW2*XSW2))/
     &  (256D0*(XMH+XMHH)*(XMH-XMHH)*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T9,N479,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMHH2,XMH2,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,2,0)

        PRE = (CA**2*PI**(-2)*PW12*PW34*SA*(XMH2+2D0*XMHH2)*XSW2**(-
     &  2)*(4D0*ALPHA*PI*XMH2-4D0*ALPHA*CA**2*PI*XMH2+12D0*ALPHA*PI*
     &  SA**2*XMH2-4D0*ALPHA*PI*XMHH2+4D0*ALPHA*CA**2*PI*XMHH2-12D0*
     &  ALPHA*PI*SA**2*XMHH2+32D0*L12*XMW2*XSW2))/(256D0*(XMH+XMHH)*
     &  (XMH-XMHH)*XMW*XSW)

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)-C2(1,2)*PRE
        F(6,-1,-1) = F(6,-1,-1)-C2(1,2)*PRE
        F(7,-1,-1) = F(7,-1,-1)-C2(1,2)*PRE
        F(8,-1,-1) = F(8,-1,-1)-C2(1,2)*PRE

C       G(T9,N480,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMHH2,XMH2,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,0,0)

        PRE = -((C0*CA**2*PI**(-2)*PW12*PW34*SA*(XMH2+2D0*XMHH2)*
     &  XMW*XSW2**(-2)*(4D0*ALPHA*PI*XMH2-4D0*ALPHA*CA**2*PI*XMH2+
     &  12D0*ALPHA*PI*SA**2*XMH2-4D0*ALPHA*PI*XMHH2+4D0*ALPHA*CA**2*
     &  PI*XMHH2-12D0*ALPHA*PI*SA**2*XMHH2+32D0*L12*XMW2*XSW2))/
     &  (256D0*(XMH+XMHH)*(XMH-XMHH)*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T9,N481,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMHH2,XMHH2,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,2,0)

        PRE = (3D0*PI**(-2)*PW12*PW34*SA*XMHH2*XSW2**(-2)*(12D0*
     &  ALPHA*PI*XMH2-16D0*ALPHA*CA**2*PI*XMH2+4D0*ALPHA*CA**4*PI*
     &  XMH2+16D0*ALPHA*PI*SA**2*XMH2-24D0*ALPHA*CA**2*PI*SA**2*
     &  XMH2+4D0*ALPHA*PI*SA**4*XMH2-12D0*ALPHA*PI*XMHH2+16D0*ALPHA*
     &  CA**2*PI*XMHH2-4D0*ALPHA*CA**4*PI*XMHH2-16D0*ALPHA*PI*SA**2*
     &  XMHH2+24D0*ALPHA*CA**2*PI*SA**2*XMHH2-4D0*ALPHA*PI*SA**4*
     &  XMHH2-32D0*L12*XMW2*XSW2-32D0*CA**2*L12*XMW2*XSW2+32D0*L12*
     &  SA**2*XMW2*XSW2))/(512D0*(XMH+XMHH)*(XMH-XMHH)*XMW*XSW)

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)-C2(1,2)*PRE
        F(6,-1,-1) = F(6,-1,-1)-C2(1,2)*PRE
        F(7,-1,-1) = F(7,-1,-1)-C2(1,2)*PRE
        F(8,-1,-1) = F(8,-1,-1)-C2(1,2)*PRE

C       G(T9,N482,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMHH2,XMHH2,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,0,0)

        PRE = -((3D0*C0*PI**(-2)*PW12*PW34*SA*XMHH2*XMW*XSW2**(-2)*
     &  (12D0*ALPHA*PI*XMH2-16D0*ALPHA*CA**2*PI*XMH2+4D0*ALPHA*CA**
     &  4*PI*XMH2+16D0*ALPHA*PI*SA**2*XMH2-24D0*ALPHA*CA**2*PI*SA**
     &  2*XMH2+4D0*ALPHA*PI*SA**4*XMH2-12D0*ALPHA*PI*XMHH2+16D0*
     &  ALPHA*CA**2*PI*XMHH2-4D0*ALPHA*CA**4*PI*XMHH2-16D0*ALPHA*PI*
     &  SA**2*XMHH2+24D0*ALPHA*CA**2*PI*SA**2*XMHH2-4D0*ALPHA*PI*
     &  SA**4*XMHH2-32D0*L12*XMW2*XSW2-32D0*CA**2*L12*XMW2*XSW2+
     &  32D0*L12*SA**2*XMW2*XSW2))/(512D0*(XMH+XMHH)*(XMH-XMHH)*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T9,N483,FULL)
        CALL xC01234_(S12,MHH2,S34,XMZ2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)

        PRE = -((ALPHA*PW12*PW34*SA*XCW2*XMW*XSW2**(-2))/(16D0*PI*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)-C2(1,2)*PRE
        F(6,-1,-1) = F(6,-1,-1)-C2(1,2)*PRE
        F(7,-1,-1) = F(7,-1,-1)-C2(1,2)*PRE
        F(8,-1,-1) = F(8,-1,-1)-C2(1,2)*PRE

C       G(T9,N484,FULL)
        CALL xC01234_(S12,MHH2,S34,NULL,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)

        PRE = -((ALPHA*PW12*PW34*SA*XMW)/(16D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)-C2(1,2)*PRE
        F(6,-1,-1) = F(6,-1,-1)-C2(1,2)*PRE
        F(7,-1,-1) = F(7,-1,-1)-C2(1,2)*PRE
        F(8,-1,-1) = F(8,-1,-1)-C2(1,2)*PRE

C       G(T9,N485,FULL)
        CALL xC01234_(S12,MHH2,S34,NULL,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)

        PRE = -((ALPHA*PW12*PW34*SA*XMW)/(16D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)-C2(1,2)*PRE
        F(6,-1,-1) = F(6,-1,-1)-C2(1,2)*PRE
        F(7,-1,-1) = F(7,-1,-1)-C2(1,2)*PRE
        F(8,-1,-1) = F(8,-1,-1)-C2(1,2)*PRE

C       G(T9,N486,FULL)
        CALL xC01234_(S12,MHH2,S34,XMZ2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)

        PRE = -((ALPHA*PW12*PW34*SA*XCW2*XMW*XSW2**(-2))/(16D0*PI*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)-C2(1,2)*PRE
        F(6,-1,-1) = F(6,-1,-1)-C2(1,2)*PRE
        F(7,-1,-1) = F(7,-1,-1)-C2(1,2)*PRE
        F(8,-1,-1) = F(8,-1,-1)-C2(1,2)*PRE

C       G(T9,N487,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMZ2,XMZ2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,0,0)

        PRE = -((ALPHA*C0*PW12*PW34*SA*XCW2**(-2)*XMW*XMW2)/(8D0*PI*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T9,N488,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMZ2,XMZ2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = -(C1(1))-C1(2)-10D0*C2(1,2)+4D0*C0

        PRE = -((ALPHA*PW12*PW34*SA*XMW*XSW2**(-2))/(16D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(6D0-36D0*C2(0,0)-4D0*C2(1,1)*
     &  S12+4D0*C2(1,2)*(S13+S14+S23+S24)+5D0*C0*(S13+S14+S23+S24)-
     &  C1(1)*(2D0*S12-S13-S14-S23-S24)-4D0*C2(2,2)*S34+C1(2)*(S13+
     &  S14+S23+S24-2D0*S34))
        F(5,-1,-1) = F(5,-1,-1)-2D0*K(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)-2D0*K(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)-2D0*K(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)-2D0*K(1)*PRE

C       G(T9,N525,FULL)
        CALL xC01234_(S12,MHH2,S34,XMH2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)

        PRE = (ALPHA*CA**2*PW12*PW34*SA*XMW*XSW2**(-2))/(16D0*PI*
     &  XSW)

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(-(2D0*C1(2))-C2(1,2))*PRE
        F(6,-1,-1) = F(6,-1,-1)+(-(2D0*C1(2))-C2(1,2))*PRE
        F(7,-1,-1) = F(7,-1,-1)+(-(2D0*C1(2))-C2(1,2))*PRE
        F(8,-1,-1) = F(8,-1,-1)+(-(2D0*C1(2))-C2(1,2))*PRE

C       G(T9,N526,FULL)
        CALL xC01234_(S12,MHH2,S34,XMHH2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,2,0)

        PRE = (ALPHA*PW12*PW34*SA**3*XMW*XSW2**(-2))/(16D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(-(2D0*C1(2))-C2(1,2))*PRE
        F(6,-1,-1) = F(6,-1,-1)+(-(2D0*C1(2))-C2(1,2))*PRE
        F(7,-1,-1) = F(7,-1,-1)+(-(2D0*C1(2))-C2(1,2))*PRE
        F(8,-1,-1) = F(8,-1,-1)+(-(2D0*C1(2))-C2(1,2))*PRE

C       G(T9,N527,FULL)
        CALL xC01234_(S12,MHH2,S34,NULL,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 4D0*C1(1)+2D0*C1(2)-C2(1,2)+4D0*C0

        PRE = -((ALPHA*PW12*PW34*SA*XMW)/(32D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(1D0-6D0*C2(0,0)-2D0*C2(1,1)*
     &  S12+2D0*C2(1,2)*(S13+S14+S23+S24)-2D0*C1(1)*(2D0*S12+S13+
     &  S14+S23+S24)-2D0*C2(2,2)*S34+2D0*C1(2)*(S13+S14+S23+S24+2D0*
     &  S34)-2D0*C0*(S23+S24+T12))
        F(5,-1,-1) = F(5,-1,-1)+2D0*K(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)+2D0*K(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)+2D0*K(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)+2D0*K(1)*PRE

C       G(T9,N528,FULL)
        CALL xC01234_(S12,MHH2,S34,XMZ2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 4D0*C1(1)+2D0*C1(2)-C2(1,2)+4D0*C0

        PRE = (ALPHA*PW12*PW34*SA*XMW)/(32D0*PI*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+PRE*(1D0-6D0*C2(0,0)-2D0*C2(1,1)*
     &  S12+2D0*C2(1,2)*(S13+S14+S23+S24)-2D0*C1(1)*(2D0*S12+S13+
     &  S14+S23+S24)-2D0*C2(2,2)*S34+2D0*C1(2)*(S13+S14+S23+S24+2D0*
     &  S34)-2D0*C0*(S23+S24+T12))
        F(5,-1,-1) = F(5,-1,-1)+2D0*K(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)+2D0*K(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)+2D0*K(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)+2D0*K(1)*PRE

C       G(T9,N529,FULL)
        CALL xC01234_(S12,MHH2,S34,XMH2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)

        PRE = (ALPHA*CA**2*PW12*PW34*SA*XMW*XSW2**(-2))/(16D0*PI*
     &  XSW)

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(-(2D0*C1(1))-C2(1,2))*PRE
        F(6,-1,-1) = F(6,-1,-1)+(-(2D0*C1(1))-C2(1,2))*PRE
        F(7,-1,-1) = F(7,-1,-1)+(-(2D0*C1(1))-C2(1,2))*PRE
        F(8,-1,-1) = F(8,-1,-1)+(-(2D0*C1(1))-C2(1,2))*PRE

C       G(T9,N530,FULL)
        CALL xC01234_(S12,MHH2,S34,XMHH2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,2,0)

        PRE = (ALPHA*PW12*PW34*SA**3*XMW*XSW2**(-2))/(16D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(-(2D0*C1(1))-C2(1,2))*PRE
        F(6,-1,-1) = F(6,-1,-1)+(-(2D0*C1(1))-C2(1,2))*PRE
        F(7,-1,-1) = F(7,-1,-1)+(-(2D0*C1(1))-C2(1,2))*PRE
        F(8,-1,-1) = F(8,-1,-1)+(-(2D0*C1(1))-C2(1,2))*PRE

C       G(T9,N531,FULL)
        CALL xC01234_(S12,MHH2,S34,NULL,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 2D0*C1(1)+4D0*C1(2)-C2(1,2)+4D0*C0

        PRE = -((ALPHA*PW12*PW34*SA*XMW)/(32D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(1D0-6D0*C2(0,0)-2D0*C2(1,1)*
     &  S12+2D0*C2(1,2)*(S13+S14+S23+S24)+2D0*C1(1)*(2D0*S12+S13+
     &  S14+S23+S24)-2D0*C2(2,2)*S34-2D0*C1(2)*(S13+S14+S23+S24+2D0*
     &  S34)-2D0*C0*(S14+S24+T14))
        F(5,-1,-1) = F(5,-1,-1)+2D0*K(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)+2D0*K(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)+2D0*K(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)+2D0*K(1)*PRE

C       G(T9,N532,FULL)
        CALL xC01234_(S12,MHH2,S34,XMZ2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 2D0*C1(1)+4D0*C1(2)-C2(1,2)+4D0*C0

        PRE = (ALPHA*PW12*PW34*SA*XMW)/(32D0*PI*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+PRE*(1D0-6D0*C2(0,0)-2D0*C2(1,1)*
     &  S12+2D0*C2(1,2)*(S13+S14+S23+S24)+2D0*C1(1)*(2D0*S12+S13+
     &  S14+S23+S24)-2D0*C2(2,2)*S34-2D0*C1(2)*(S13+S14+S23+S24+2D0*
     &  S34)-2D0*C0*(S14+S24+T14))
        F(5,-1,-1) = F(5,-1,-1)+2D0*K(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)+2D0*K(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)+2D0*K(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)+2D0*K(1)*PRE

C       G(T9,N533,FULL)
        CALL xC01234_(S12,MHH2,S34,XMH2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,0,0)

        PRE = -((ALPHA*C0*CA**2*PW12*PW34*SA*XMW*XMW2*XSW2**(-2))/
     &  (8D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T9,N534,FULL)
        CALL xC01234_(S12,MHH2,S34,XMHH2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,0,0)

        PRE = -((ALPHA*C0*PW12*PW34*SA**3*XMW*XMW2*XSW2**(-2))/(8D0*
     &  PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T9,N535,FULL)
        CALL xC01234_(S12,MHH2,S34,NULL,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = -(C1(1))-C1(2)-10D0*C2(1,2)+4D0*C0

        PRE = -((ALPHA*PW12*PW34*SA*XMW)/(16D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(6D0-36D0*C2(0,0)-4D0*C2(1,1)*
     &  S12+4D0*C2(1,2)*(S13+S14+S23+S24)+5D0*C0*(S13+S14+S23+S24)-
     &  C1(1)*(2D0*S12-S13-S14-S23-S24)-4D0*C2(2,2)*S34+C1(2)*(S13+
     &  S14+S23+S24-2D0*S34))
        F(5,-1,-1) = F(5,-1,-1)-2D0*K(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)-2D0*K(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)-2D0*K(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)-2D0*K(1)*PRE

C       G(T9,N536,FULL)
        CALL xC01234_(S12,MHH2,S34,XMZ2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = -(C1(1))-C1(2)-10D0*C2(1,2)+4D0*C0

        PRE = -((ALPHA*PW12*PW34*SA*XCW2*XMW*XSW2**(-2))/(16D0*PI*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(6D0-36D0*C2(0,0)-4D0*C2(1,1)*
     &  S12+4D0*C2(1,2)*(S13+S14+S23+S24)+5D0*C0*(S13+S14+S23+S24)-
     &  C1(1)*(2D0*S12-S13-S14-S23-S24)-4D0*C2(2,2)*S34+C1(2)*(S13+
     &  S14+S23+S24-2D0*S34))
        F(5,-1,-1) = F(5,-1,-1)-2D0*K(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)-2D0*K(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)-2D0*K(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)-2D0*K(1)*PRE

C       G(T9,N552,FULL)
        CALL xC01234_(S12,MHH2,S34,XMH2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)

        PRE = (ALPHA*CA**2*PW12*PW34*SA*XMHH2*XSW2**(-2))/(16D0*PI*
     &  XMW*XSW)

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)-C2(1,2)*PRE
        F(6,-1,-1) = F(6,-1,-1)-C2(1,2)*PRE
        F(7,-1,-1) = F(7,-1,-1)-C2(1,2)*PRE
        F(8,-1,-1) = F(8,-1,-1)-C2(1,2)*PRE

C       G(T9,N553,FULL)
        CALL xC01234_(S12,MHH2,S34,XMZ2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)

        PRE = (ALPHA*PW12*PW34*SA*XMHH2*XSW2**(-2))/(16D0*PI*XMW*
     &  XSW)

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)-C2(1,2)*PRE
        F(6,-1,-1) = F(6,-1,-1)-C2(1,2)*PRE
        F(7,-1,-1) = F(7,-1,-1)-C2(1,2)*PRE
        F(8,-1,-1) = F(8,-1,-1)-C2(1,2)*PRE

C       G(T9,N554,FULL)
        CALL xC01234_(S12,MHH2,S34,XMHH2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,2,0)

        PRE = (ALPHA*PW12*PW34*SA**3*XMHH2*XSW2**(-2))/(16D0*PI*XMW*
     &  XSW)

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)-C2(1,2)*PRE
        F(6,-1,-1) = F(6,-1,-1)-C2(1,2)*PRE
        F(7,-1,-1) = F(7,-1,-1)-C2(1,2)*PRE
        F(8,-1,-1) = F(8,-1,-1)-C2(1,2)*PRE

C       G(T9,N555,FULL)
        CALL xC01234_(S12,MHH2,S34,NULL,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,0,0)

        PRE = -((ALPHA*C0*PW12*PW34*SA*XMHH2*XMW)/(16D0*PI*XSW*
     &  XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T9,N556,FULL)
        CALL xC01234_(S12,MHH2,S34,XMZ2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,0,0)

        PRE = -((ALPHA*C0*PW12*PW34*SA*XMHH2*XMW)/(16D0*PI*XCW2*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T10,N564,FULL)

C       G(T10,N565,FULL)

C       G(T10,N566,FULL)

C       G(T10,N567,FULL)

C       G(T10,N568,FULL)

C       G(T10,N578,FULL)

C       G(T10,N580,FULL)

C       G(T10,N582,FULL)

C       G(T10,N584,FULL)

C       G(T10,N589,FULL)

C       G(T10,N590,FULL)

C       G(T10,N591,FULL)

C       G(T10,N592,FULL)

C       G(T11,N609,FULL)

C       G(T11,N610,FULL)

C       G(T11,N611,FULL)

C       G(T11,N612,FULL)

C       G(T11,N613,FULL)

C       G(T11,N624,FULL)

C       G(T11,N626,FULL)

C       G(T11,N628,FULL)

C       G(T11,N630,FULL)

C       G(T11,N635,FULL)

C       G(T11,N636,FULL)

C       G(T11,N637,FULL)

C       G(T11,N638,FULL)

C       G(T12,N663,FULL)

C       G(T12,N664,FULL)

C       G(T12,N665,FULL)

C       G(T12,N666,FULL)

C       G(T12,N667,FULL)

C       G(T12,N668,FULL)

C       G(T12,N670,FULL)
        CALL xC01234_(T14,MHH2,RMF2(4),CMF2(3),XMW2,XMW2,C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,1,1)

        PRE = (C1(1)*ALPHA*PW12*SA*XMW*XSW2**(-2))/(8D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T12,N671,FULL)

C       G(T12,N672,FULL)
        CALL xC01234_(T14,MHH2,RMF2(4),CMF2(4),XMZ2,XMZ2,C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,1,1)

        PRE = (C1(1)*ALPHA*PW12*SA*XCW2**(-2)*XMW*XSW2**(-2)*(1D0-
     &  2D0*QF(4)*XSW2)**2)/(16D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T12,N676,FULL)

C       G(T12,N682,FULL)

C       G(T12,N683,FULL)

C       G(T12,N684,FULL)

C       G(T12,N685,FULL)

C       G(T12,N686,FULL)

C       G(T13,N706,FULL)

C       G(T13,N707,FULL)

C       G(T13,N713,FULL)

C       G(T13,N715,FULL)

C       G(T13,N717,FULL)

C       G(T13,N718,FULL)

C       G(T13,N719,FULL)

C       G(T13,N720,FULL)

C       G(T13,N721,FULL)

C       G(T13,N722,FULL)

C       G(T13,N742,FULL)

C       G(T13,N750,FULL)

C       G(T13,N752,FULL)
        CALL xC01234_(RMF2(3),S34,RMF2(4),CMF2(3),NULL,XMW2,C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,1)

        PRE = (QF(3)*ALPHA*PW12*PW34*(1D0-6D0*C2(0,0)+C1(1)*S34+
     &  C1(2)*S34+C2(1,2)*S34)*SA*XMW)/(4D0*PI*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T13,N754,FULL)
        CALL xC01234_(RMF2(3),S34,RMF2(4),CMF2(3),XMZ2,XMW2,C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,1)

        PRE = -((ALPHA*PW12*PW34*(1D0-6D0*C2(0,0)+C1(1)*S34+C1(2)*
     &  S34+C2(1,2)*S34)*SA*XMW*XSW2**(-2)*(1D0+2D0*QF(3)*XSW2))/
     &  (8D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T13,N755,FULL)

C       G(T13,N756,FULL)

C       G(T13,N757,FULL)
        CALL xC01234_(RMF2(4),RMF2(3),S34,NULL,CMF2(4),XMW2,C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,1)

        PRE = -((QF(4)*ALPHA*PW12*PW34*(1D0-6D0*C2(0,0)-C1(1)*S34-
     &  C1(2)*S34-C2(1,2)*S34-C2(2,2)*S34-C0*S34)*SA*XMW)/(4D0*PI*
     &  XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T13,N758,FULL)
        CALL xC01234_(RMF2(3),S34,RMF2(4),CMF2(4),XMW2,XMZ2,C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,1)

        PRE = -((ALPHA*PW12*PW34*(1D0-6D0*C2(0,0)+C1(1)*S34+C1(2)*
     &  S34+C2(1,2)*S34)*SA*XMW*XSW2**(-2)*(1D0-2D0*QF(4)*XSW2))/
     &  (8D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T13,N774,FULL)

C       G(T13,N775,FULL)

C       G(T13,N776,FULL)

C       G(T13,N777,FULL)
        CALL xC01234_(RMF2(3),S34,RMF2(4),NULL,CMF2(3),CMF2(4),C0,C1,C2,
     &  C3,C4,B0,B1,B2,B3,2,1)

        PRE = -((QF(3)*QF(4)*ALPHA*PW12*PW34*(1D0-2D0*C2(0,0)+C1(1)*
     &  S34+C1(2)*S34+C2(1,2)*S34+C0*S34)*SA*XMW)/(4D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T13,N778,FULL)
        CALL xC01234_(S34,RMF2(4),RMF2(3),CMF2(3),CMF2(4),XMZ2,C0,C1,C2,
     &  C3,C4,B0,B1,B2,B3,2,1)

        PRE = (ALPHA*PW12*PW34*(1D0-2D0*C2(0,0)-C1(1)*S34-C1(2)*S34-
     &  C2(1,1)*S34-C2(1,2)*S34)*SA*XMW*XSW2**(-2)*(1D0+2D0*QF(3)*
     &  XSW2)*(1D0-2D0*QF(4)*XSW2))/(16D0*PI*XCW2*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T14,N798,FULL)

C       G(T14,N806,FULL)

C       G(T14,N808,FULL)

C       G(T14,N810,FULL)

C       G(T14,N811,FULL)

C       G(T14,N812,FULL)

C       G(T14,N813,FULL)

C       G(T14,N814,FULL)

C       G(T14,N820,FULL)

C       G(T14,N821,FULL)

C       G(T14,N822,FULL)

C       G(T14,N823,FULL)

C       G(T14,N824,FULL)

C       G(T15,N844,FULL)

C       G(T15,N852,FULL)

C       G(T15,N854,FULL)

C       G(T15,N856,FULL)

C       G(T15,N857,FULL)

C       G(T15,N858,FULL)

C       G(T15,N859,FULL)

C       G(T15,N860,FULL)

C       G(T15,N866,FULL)

C       G(T15,N867,FULL)

C       G(T15,N868,FULL)

C       G(T15,N869,FULL)

C       G(T15,N870,FULL)

C       G(T16,N882,FULL)
        CALL xB012345_(MHH2,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PW12*PW34*SA*XMHH2*XSW2**(-2))/(32D0*PI*
     &  XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T16,N883,FULL)
        CALL xB012345_(MHH2,XMH2,XMH2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((B0*CA**2*PI**(-2)*PW12*PW34*SA*(2D0*XMH2+XMHH2)*
     &  XSW2**(-2)*(4D0*ALPHA*PI*XMH2+12D0*ALPHA*CA**2*PI*XMH2-4D0*
     &  ALPHA*PI*SA**2*XMH2-4D0*ALPHA*PI*XMHH2-12D0*ALPHA*CA**2*PI*
     &  XMHH2+4D0*ALPHA*PI*SA**2*XMHH2-32D0*L12*XMW2*XSW2))/(1024D0*
     &  (XMH+XMHH)*(XMH-XMHH)*XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T16,N884,FULL)
        CALL xB012345_(MHH2,XMHH2,XMH2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((B0*CA**2*PI**(-2)*PW12*PW34*SA*(XMH2+2D0*XMHH2)*
     &  XSW2**(-2)*(4D0*ALPHA*PI*XMH2-4D0*ALPHA*CA**2*PI*XMH2+12D0*
     &  ALPHA*PI*SA**2*XMH2-4D0*ALPHA*PI*XMHH2+4D0*ALPHA*CA**2*PI*
     &  XMHH2-12D0*ALPHA*PI*SA**2*XMHH2+32D0*L12*XMW2*XSW2))/(512D0*
     &  (XMH+XMHH)*(XMH-XMHH)*XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T16,N885,FULL)
        CALL xB012345_(MHH2,XMZ2,XMZ2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PW12*PW34*SA*XMHH2*XSW2**(-2))/(64D0*PI*
     &  XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T16,N886,FULL)
        CALL xB012345_(MHH2,XMHH2,XMHH2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((3D0*B0*PI**(-2)*PW12*PW34*SA*XMHH2*XSW2**(-2)*
     &  (12D0*ALPHA*PI*XMH2-16D0*ALPHA*CA**2*PI*XMH2+4D0*ALPHA*CA**
     &  4*PI*XMH2+16D0*ALPHA*PI*SA**2*XMH2-24D0*ALPHA*CA**2*PI*SA**
     &  2*XMH2+4D0*ALPHA*PI*SA**4*XMH2-12D0*ALPHA*PI*XMHH2+16D0*
     &  ALPHA*CA**2*PI*XMHH2-4D0*ALPHA*CA**4*PI*XMHH2-16D0*ALPHA*PI*
     &  SA**2*XMHH2+24D0*ALPHA*CA**2*PI*SA**2*XMHH2-4D0*ALPHA*PI*
     &  SA**4*XMHH2-32D0*L12*XMW2*XSW2-32D0*CA**2*L12*XMW2*XSW2+
     &  32D0*L12*SA**2*XMW2*XSW2))/(2048D0*(XMH+XMHH)*(XMH-XMHH)*
     &  XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T16,N887,FULL)
        CALL xB012345_(MHH2,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = (ALPHA*(2D0-3D0*B0)*PW12*PW34*SA*XMW*XSW2**(-2))/(8D0*
     &  PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T16,N888,FULL)
        CALL xB012345_(MHH2,XMZ2,XMZ2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = (ALPHA*(2D0-3D0*B0)*PW12*PW34*SA*XMW*XSW2**(-2))/(8D0*
     &  PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T17,N901,FULL)
        CALL xB012345_(S34,NULL,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PW12*PW34*SA*XMW)/(16D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T17,N902,FULL)
        CALL xB012345_(S34,XMW2,XMZ2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PW12*PW34*SA*XMW)/(16D0*PI*XCW2*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T17,N903,FULL)
        CALL xB012345_(S34,XMW2,XMH2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*CA**2*PW12*PW34*SA*XMW*XSW2**(-2))/(16D0*
     &  PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T17,N904,FULL)
        CALL xB012345_(S34,XMW2,XMHH2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PW12*PW34*SA**3*XMW*XSW2**(-2))/(16D0*PI*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T18,N917,FULL)
        CALL xB012345_(S12,NULL,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PW12*PW34*SA*XMW)/(16D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T18,N918,FULL)
        CALL xB012345_(S12,XMW2,XMZ2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PW12*PW34*SA*XMW)/(16D0*PI*XCW2*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T18,N919,FULL)
        CALL xB012345_(S12,XMW2,XMH2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*CA**2*PW12*PW34*SA*XMW*XSW2**(-2))/(16D0*
     &  PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T18,N920,FULL)
        CALL xB012345_(S12,XMW2,XMHH2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PW12*PW34*SA**3*XMW*XSW2**(-2))/(16D0*PI*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

	end

**********************************************************************
        subroutine  HHtoWW4f_box_sesm(F,pw12,pw34)
**********************************************************************
*       box corrections for HH -> WW -> 4f in the SESM
*---------------------------------------------------------------------
*       6.2.17 Stefan Dittmaier
**********************************************************************
	implicit none
	complex*16 pre,F(13,-1:1,-1:1),pw12,pw34
	complex*16 A0,xA0_,B0_,xB0_,DB0_,xDB0_,B1_,xB1_,DB1_,xDB1_
        complex*16 B0,B1(1),B2(0:2,0:2),B3(0:2,0:2,2)
        complex*16 B4(0:2,0:2,0:2,0:2),B5(0:2,0:2,0:2,0:2,2)
        complex*16 C0_,C0,C1(2),C2(0:2,0:2),C3(0:2,0:2,2)
        complex*16 C4(0:2,0:2,0:2,0:2)
	complex*16 D0,D1(3),D2(0:3,0:3),D3(0:3,0:3,3)
        complex*16 D4(0:3,0:3,0:3,0:3),D5(0:3,0:3,0:3,0:3,3)
	complex*16 E0n,E1n(4),E2n(0:4,0:4),E3n(0:4,0:4,4)
	complex*16 E4n(0:4,0:4,0:4,0:4)
        COMPLEX*16 K(1)

c mandelstam variables
      	real*8 s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
      	common/mandel/s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
c fermion charges of isospin duplets
	real*8 qf(4)
	common/fcharge/qf
c fermion masses as flag (i*1d-20)
      	complex*16 cme2,cmf2(5)
      	real*8 me2,rme2,mf2(5),rmf2(5)
      	common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2
	include '../COMMON/param.inc'
	include '../COMMON/xparam.inc'
        include '../COMMON/param_sesm.inc'
        include '../COMMON/param_bsm.inc'

C       Process: S4F21aF22F23aF24,   Model: Singlet

C       G(T1,N1,FULL)

C       G(T1,N2,FULL)

C       G(T2,N3,FULL)

C       G(T2,N4,FULL)

C       G(T3,N5,FULL)

C       G(T3,N6,FULL)

C       G(T3,N7,FULL)

C       G(T3,N8,FULL)

C       G(T3,N9,FULL)

C       G(T3,N10,FULL)

C       G(T4,N11,FULL)

C       G(T4,N12,FULL)

C       G(T4,N13,FULL)

C       G(T4,N14,FULL)

C       G(T4,N15,FULL)

C       G(T4,N16,FULL)
        CALL xD012345_(RMF2(2),MHH2,S34,RMF2(1),S12,T12,CMF2(2),XMZ2,
     &  XMZ2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = -((ALPHA*PW34*SA*XMW*XSW2**(-2)*(1D0+2D0*QF(2)*XSW2))/
     &  (16D0*PI*XCW2*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(12D0*D2(0,0))+2D0*D2(1,3)*
     &  S12-2D0*D1(3)*(S13+S14)-2D0*D2(2,3)*(S13+S14)+D1(1)*(S12-
     &  S23-S24)-D1(2)*(3D0*S13+3D0*S14+S34)-2D0*D2(2,2)*T12+2D0*
     &  D2(1,2)*(MHH2-T12))
        F(5,-1,-1) = F(5,-1,-1)+2D0*(D1(3)-2D0*D2(2,2)-2D0*D2(2,3))*
     &  PRE
        F(6,-1,-1) = F(6,-1,-1)+4D0*(D1(1)+D2(1,2))*PRE
        F(7,-1,-1) = F(7,-1,-1)+2D0*(D1(3)-2D0*D2(2,2)-2D0*D2(2,3))*
     &  PRE
        F(8,-1,-1) = F(8,-1,-1)+4D0*(D1(1)+D2(1,2))*PRE

C       G(T4,N17,FULL)

C       G(T4,N18,FULL)
        CALL xD012345_(RMF2(1),RMF2(2),MHH2,S34,T12,S12,NULL,CMF2(1),
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = -((QF(1)*ALPHA*PW34*SA*XMW)/(16D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(4D0*D2(0,0))-D2(1,2)*S12-
     &  D2(2,2)*S12+D2(1,3)*(S13+S14)+D2(2,3)*(S13+S14+S23+S24)+
     &  D1(2)*(S12+2D0*S23+2D0*S24)-D2(3,3)*S34-D1(3)*(S13+S14+2D0*
     &  S34))
        F(5,-1,-1) = F(5,-1,-1)+4D0*(D1(1)+D1(2)+D1(3)+D0)*PRE
        F(7,-1,-1) = F(7,-1,-1)+4D0*(D1(1)+D1(2)+D1(3)+D0)*PRE

C       G(T4,N19,FULL)
        CALL xD012345_(RMF2(2),MHH2,S34,RMF2(1),S12,T12,CMF2(1),XMW2,
     &  XMW2,XMZ2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = (ALPHA*PW34*SA*XMW*(1D0-2D0*QF(1)*XSW2))/(32D0*PI*
     &  XCW2*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(4D0*D2(0,0))+D2(1,3)*S12-
     &  D2(2,3)*(S13+S14)-2D0*D1(2)*T12-D2(2,2)*T12+2D0*D1(1)*(MHH2-
     &  T12)+D2(1,2)*(MHH2-T12))
        F(5,-1,-1) = F(5,-1,-1)-4D0*D1(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)-4D0*D1(3)*PRE

C       G(T4,N20,FULL)

C       G(T4,N21,FULL)
        CALL xD012345_(RMF2(1),RMF2(2),MHH2,S34,T12,S12,NULL,CMF2(1),
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = D1(1)+D1(2)-D1(3)-2D0*D2(1,3)-2D0*D2(2,3)+D0

        PRE = -((QF(1)*ALPHA*PW34*SA*XMW)/(8D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(12D0*D2(0,0))-2D0*D2(1,2)*
     &  S12-2D0*D2(2,2)*S12+2D0*D1(1)*(S13+S14)+2D0*D2(1,3)*(S13+
     &  S14)+2D0*D0*(S13+S14)+2D0*D2(2,3)*(S13+S14+S23+S24)-2D0*
     &  D2(3,3)*S34+D1(3)*(S13+S14-S34)-D1(2)*(MHH2-2D0*S13-2D0*S14-
     &  T12))
        F(5,-1,-1) = F(5,-1,-1)-2D0*K(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)+4D0*(D1(2)+D2(2,3))*PRE
        F(7,-1,-1) = F(7,-1,-1)-2D0*K(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)+4D0*(D1(2)+D2(2,3))*PRE

C       G(T4,N22,FULL)
        CALL xD012345_(RMF2(2),MHH2,S34,RMF2(1),S12,T12,CMF2(1),XMW2,
     &  XMW2,XMZ2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = -((ALPHA*PW34*SA*XMW*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2))/
     &  (16D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(12D0*D2(0,0))+2D0*D2(1,3)*
     &  S12-2D0*D1(3)*(S13+S14)-2D0*D2(2,3)*(S13+S14)+D1(1)*(S12-
     &  S23-S24)-D1(2)*(3D0*S13+3D0*S14+S34)-2D0*D2(2,2)*T12+2D0*
     &  D2(1,2)*(MHH2-T12))
        F(5,-1,-1) = F(5,-1,-1)+2D0*(D1(3)-2D0*D2(2,2)-2D0*D2(2,3))*
     &  PRE
        F(6,-1,-1) = F(6,-1,-1)+4D0*(D1(1)+D2(1,2))*PRE
        F(7,-1,-1) = F(7,-1,-1)+2D0*(D1(3)-2D0*D2(2,2)-2D0*D2(2,3))*
     &  PRE
        F(8,-1,-1) = F(8,-1,-1)+4D0*(D1(1)+D2(1,2))*PRE

C       G(T6,N28,FULL)

C       G(T6,N29,FULL)

C       G(T6,N30,FULL)

C       G(T6,N31,FULL)

C       G(T6,N32,FULL)

C       G(T6,N33,FULL)

C       G(T8,N39,FULL)

C       G(T8,N40,FULL)

C       G(T8,N41,FULL)

C       G(T8,N42,FULL)

C       G(T8,N43,FULL)
        CALL xD012345_(S34,RMF2(2),MHH2,RMF2(1),T12,T11,CMF2(1),
     &  CMF2(2),XMZ2,XMZ2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = -((ALPHA*PW34*SA*XCW2**(-2)*XMW*XSW2**(-2)*(1D0-2D0*
     &  QF(1)*XSW2)*(1D0+2D0*QF(2)*XSW2))/(16D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(2D0*D2(0,0)-D1(3)*(S13+S14)-
     &  D2(1,3)*(S13+S14)+D1(1)*S34+D1(2)*S34+D2(1,1)*S34+D2(1,2)*
     &  (S23+S24+2D0*S34)+D2(2,2)*T11-D2(2,3)*(MHH2-T11))
        F(5,-1,-1) = F(5,-1,-1)+2D0*(D1(3)+D2(1,3)+D2(2,3))*PRE
        F(6,-1,-1) = F(6,-1,-1)-2D0*(D2(1,2)+D2(2,2))*PRE
        F(7,-1,-1) = F(7,-1,-1)+2D0*(D1(3)+D2(1,3)+D2(2,3))*PRE
        F(8,-1,-1) = F(8,-1,-1)-2D0*(D2(1,2)+D2(2,2))*PRE

C       G(T8,N44,FULL)

C       G(T8,N45,FULL)

C       G(T8,N46,FULL)

C       G(T11,N59,FULL)

C       G(T11,N60,FULL)

C       G(T11,N61,FULL)

C       G(T11,N62,FULL)

C       G(T11,N63,FULL)
        CALL xD012345_(S12,RMF2(3),MHH2,RMF2(4),T13,T14,CMF2(4),
     &  CMF2(3),XMZ2,XMZ2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = -((ALPHA*PW12*SA*XCW2**(-2)*XMW*XSW2**(-2)*(1D0+2D0*
     &  QF(3)*XSW2)*(1D0-2D0*QF(4)*XSW2))/(16D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(2D0*D2(0,0)+D1(1)*S12+D1(2)*
     &  S12+D2(1,1)*S12+D2(1,2)*(2D0*S12+S13+S23)-D1(3)*(S14+S24)-
     &  D2(1,3)*(S14+S24)+D2(2,2)*T14-D2(2,3)*(MHH2-T14))
        F(5,-1,-1) = F(5,-1,-1)-2D0*(D2(1,2)+D2(2,2))*PRE
        F(6,-1,-1) = F(6,-1,-1)-2D0*(D2(1,2)+D2(2,2))*PRE
        F(7,-1,-1) = F(7,-1,-1)+2D0*(D1(3)+D2(1,3)+D2(2,3))*PRE
        F(8,-1,-1) = F(8,-1,-1)+2D0*(D1(3)+D2(1,3)+D2(2,3))*PRE

C       G(T11,N64,FULL)

C       G(T11,N65,FULL)

C       G(T11,N66,FULL)

C       G(T12,N67,FULL)

C       G(T12,N68,FULL)

C       G(T12,N69,FULL)

C       G(T12,N70,FULL)

C       G(T12,N71,FULL)

C       G(T12,N72,FULL)

C       G(T14,N79,FULL)

C       G(T14,N80,FULL)

C       G(T14,N81,FULL)

C       G(T14,N82,FULL)

C       G(T14,N83,FULL)

C       G(T14,N84,FULL)
        CALL xD012345_(RMF2(1),MHH2,S34,RMF2(2),S12,T11,CMF2(1),XMZ2,
     &  XMZ2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = -((ALPHA*PW34*SA*XMW*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2))/
     &  (16D0*PI*XCW2*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(12D0*D2(0,0))+2D0*D2(1,3)*
     &  S12+D1(1)*(S12-S13-S14)-2D0*D1(3)*(S23+S24)-2D0*D2(2,3)*
     &  (S23+S24)-D1(2)*(3D0*S23+3D0*S24+S34)-2D0*D2(2,2)*T11+2D0*
     &  D2(1,2)*(MHH2-T11))
        F(5,-1,-1) = F(5,-1,-1)+4D0*(D1(1)+D2(1,2))*PRE
        F(6,-1,-1) = F(6,-1,-1)+2D0*(D1(3)-2D0*D2(2,2)-2D0*D2(2,3))*
     &  PRE
        F(7,-1,-1) = F(7,-1,-1)+4D0*(D1(1)+D2(1,2))*PRE
        F(8,-1,-1) = F(8,-1,-1)+2D0*(D1(3)-2D0*D2(2,2)-2D0*D2(2,3))*
     &  PRE

C       G(T14,N85,FULL)

C       G(T14,N86,FULL)
        CALL xD012345_(RMF2(2),RMF2(1),MHH2,S34,T11,S12,NULL,CMF2(2),
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = (QF(2)*ALPHA*PW34*SA*XMW)/(16D0*PI*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(4D0*D2(0,0))-D2(1,2)*S12-
     &  D2(2,2)*S12+D1(2)*(S12+2D0*S13+2D0*S14)+D2(1,3)*(S23+S24)+
     &  D2(2,3)*(S13+S14+S23+S24)-D2(3,3)*S34-D1(3)*(S23+S24+2D0*
     &  S34))
        F(6,-1,-1) = F(6,-1,-1)+4D0*(D1(1)+D1(2)+D1(3)+D0)*PRE
        F(8,-1,-1) = F(8,-1,-1)+4D0*(D1(1)+D1(2)+D1(3)+D0)*PRE

C       G(T14,N87,FULL)
        CALL xD012345_(RMF2(1),MHH2,S34,RMF2(2),S12,T11,CMF2(2),XMW2,
     &  XMW2,XMZ2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = (ALPHA*PW34*SA*XMW*(1D0+2D0*QF(2)*XSW2))/(32D0*PI*
     &  XCW2*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(4D0*D2(0,0))+D2(1,3)*S12-
     &  D2(2,3)*(S23+S24)-2D0*D1(2)*T11-D2(2,2)*T11+2D0*D1(1)*(MHH2-
     &  T11)+D2(1,2)*(MHH2-T11))
        F(6,-1,-1) = F(6,-1,-1)-4D0*D1(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)-4D0*D1(3)*PRE

C       G(T14,N88,FULL)

C       G(T14,N89,FULL)
        CALL xD012345_(RMF2(2),RMF2(1),MHH2,S34,T11,S12,NULL,CMF2(2),
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = D1(1)+D1(2)-D1(3)-2D0*D2(1,3)-2D0*D2(2,3)+D0

        PRE = (QF(2)*ALPHA*PW34*SA*XMW)/(8D0*PI*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(12D0*D2(0,0))-2D0*D2(1,2)*
     &  S12-2D0*D2(2,2)*S12+2D0*D1(1)*(S23+S24)+2D0*D2(1,3)*(S23+
     &  S24)+2D0*D0*(S23+S24)+2D0*D2(2,3)*(S13+S14+S23+S24)-2D0*
     &  D2(3,3)*S34+D1(3)*(S23+S24-S34)-D1(2)*(MHH2-2D0*S23-2D0*S24-
     &  T11))
        F(5,-1,-1) = F(5,-1,-1)+4D0*(D1(2)+D2(2,3))*PRE
        F(6,-1,-1) = F(6,-1,-1)-2D0*K(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)+4D0*(D1(2)+D2(2,3))*PRE
        F(8,-1,-1) = F(8,-1,-1)-2D0*K(1)*PRE

C       G(T14,N90,FULL)
        CALL xD012345_(RMF2(1),MHH2,S34,RMF2(2),S12,T11,CMF2(2),XMW2,
     &  XMW2,XMZ2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = -((ALPHA*PW34*SA*XMW*XSW2**(-2)*(1D0+2D0*QF(2)*XSW2))/
     &  (16D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(12D0*D2(0,0))+2D0*D2(1,3)*
     &  S12+D1(1)*(S12-S13-S14)-2D0*D1(3)*(S23+S24)-2D0*D2(2,3)*
     &  (S23+S24)-D1(2)*(3D0*S23+3D0*S24+S34)-2D0*D2(2,2)*T11+2D0*
     &  D2(1,2)*(MHH2-T11))
        F(5,-1,-1) = F(5,-1,-1)+4D0*(D1(1)+D2(1,2))*PRE
        F(6,-1,-1) = F(6,-1,-1)+2D0*(D1(3)-2D0*D2(2,2)-2D0*D2(2,3))*
     &  PRE
        F(7,-1,-1) = F(7,-1,-1)+4D0*(D1(1)+D2(1,2))*PRE
        F(8,-1,-1) = F(8,-1,-1)+2D0*(D1(3)-2D0*D2(2,2)-2D0*D2(2,3))*
     &  PRE

C       G(T15,N91,FULL)

C       G(T15,N92,FULL)

C       G(T15,N93,FULL)

C       G(T15,N94,FULL)

C       G(T15,N95,FULL)

C       G(T15,N96,FULL)

C       G(T16,N97,FULL)

C       G(T16,N98,FULL)
        CALL xD012345_(RMF2(4),RMF2(3),MHH2,S12,T13,S34,NULL,CMF2(4),
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = -((QF(4)*ALPHA*PW12*SA*XMW)/(16D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(4D0*D2(0,0))-D2(3,3)*S12+
     &  D2(1,3)*(S14+S24)-D1(3)*(2D0*S12+S14+S24)+D2(2,3)*(S13+S14+
     &  S23+S24)-D2(1,2)*S34-D2(2,2)*S34+D1(2)*(2D0*S13+2D0*S23+
     &  S34))
        F(7,-1,-1) = F(7,-1,-1)+4D0*(D1(1)+D1(2)+D1(3)+D0)*PRE
        F(8,-1,-1) = F(8,-1,-1)+4D0*(D1(1)+D1(2)+D1(3)+D0)*PRE

C       G(T16,N99,FULL)
        CALL xD012345_(RMF2(3),MHH2,S12,RMF2(4),S34,T13,CMF2(4),XMW2,
     &  XMW2,XMZ2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = (ALPHA*PW12*SA*XMW*(1D0-2D0*QF(4)*XSW2))/(32D0*PI*
     &  XCW2*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(4D0*D2(0,0))-D2(2,3)*(S14+
     &  S24)+D2(1,3)*S34-2D0*D1(2)*T13-D2(2,2)*T13+2D0*D1(1)*(MHH2-
     &  T13)+D2(1,2)*(MHH2-T13))
        F(7,-1,-1) = F(7,-1,-1)-4D0*D1(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)-4D0*D1(3)*PRE

C       G(T16,N100,FULL)

C       G(T16,N101,FULL)

C       G(T16,N102,FULL)

C       G(T16,N103,FULL)
        CALL xD012345_(RMF2(4),RMF2(3),MHH2,S12,T13,S34,NULL,CMF2(4),
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = D1(1)+D1(2)-D1(3)-2D0*D2(1,3)-2D0*D2(2,3)+D0

        PRE = -((QF(4)*ALPHA*PW12*SA*XMW)/(8D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(12D0*D2(0,0))-2D0*D2(3,3)*
     &  S12+2D0*D1(1)*(S14+S24)+2D0*D2(1,3)*(S14+S24)+2D0*D0*(S14+
     &  S24)+2D0*D2(2,3)*(S13+S14+S23+S24)-D1(3)*(S12-S14-S24)-2D0*
     &  D2(1,2)*S34-2D0*D2(2,2)*S34-D1(2)*(MHH2-2D0*S14-2D0*S24-
     &  T13))
        F(5,-1,-1) = F(5,-1,-1)+4D0*(D1(2)+D2(2,3))*PRE
        F(6,-1,-1) = F(6,-1,-1)+4D0*(D1(2)+D2(2,3))*PRE
        F(7,-1,-1) = F(7,-1,-1)-2D0*K(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)-2D0*K(1)*PRE

C       G(T16,N104,FULL)
        CALL xD012345_(RMF2(3),MHH2,S12,RMF2(4),S34,T13,CMF2(4),XMW2,
     &  XMW2,XMZ2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = (ALPHA*PW12*SA*XMW*XSW2**(-2)*(1D0-2D0*QF(4)*XSW2))/
     &  (16D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE*(12D0*D2(0,0)+2D0*D1(3)*(S14+
     &  S24)+2D0*D2(2,3)*(S14+S24)+D1(2)*(S12+3D0*S14+3D0*S24)-2D0*
     &  D2(1,3)*S34+D1(1)*(S13+S23-S34)+2D0*D2(2,2)*T13-2D0*D2(1,2)*
     &  (MHH2-T13))
        F(5,-1,-1) = F(5,-1,-1)-4D0*(D1(1)+D2(1,2))*PRE
        F(6,-1,-1) = F(6,-1,-1)-4D0*(D1(1)+D2(1,2))*PRE
        F(7,-1,-1) = F(7,-1,-1)-2D0*(D1(3)-2D0*D2(2,2)-2D0*D2(2,3))*
     &  PRE
        F(8,-1,-1) = F(8,-1,-1)-2D0*(D1(3)-2D0*D2(2,2)-2D0*D2(2,3))*
     &  PRE

C       G(T16,N105,FULL)
        CALL xD012345_(RMF2(3),MHH2,S12,RMF2(4),S34,T13,CMF2(3),XMZ2,
     &  XMZ2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = (ALPHA*PW12*SA*XMW*XSW2**(-2)*(1D0+2D0*QF(3)*XSW2))/
     &  (16D0*PI*XCW2*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE*(12D0*D2(0,0)+2D0*D1(3)*(S14+
     &  S24)+2D0*D2(2,3)*(S14+S24)+D1(2)*(S12+3D0*S14+3D0*S24)-2D0*
     &  D2(1,3)*S34+D1(1)*(S13+S23-S34)+2D0*D2(2,2)*T13-2D0*D2(1,2)*
     &  (MHH2-T13))
        F(5,-1,-1) = F(5,-1,-1)-4D0*(D1(1)+D2(1,2))*PRE
        F(6,-1,-1) = F(6,-1,-1)-4D0*(D1(1)+D2(1,2))*PRE
        F(7,-1,-1) = F(7,-1,-1)-2D0*(D1(3)-2D0*D2(2,2)-2D0*D2(2,3))*
     &  PRE
        F(8,-1,-1) = F(8,-1,-1)-2D0*(D1(3)-2D0*D2(2,2)-2D0*D2(2,3))*
     &  PRE

C       G(T16,N106,FULL)

C       G(T16,N107,FULL)

C       G(T16,N108,FULL)

C       G(T17,N109,FULL)

C       G(T17,N110,FULL)

C       G(T17,N111,FULL)

C       G(T17,N112,FULL)

C       G(T17,N113,FULL)

C       G(T17,N114,FULL)

C       G(T19,N120,FULL)

C       G(T19,N121,FULL)

C       G(T19,N122,FULL)

C       G(T19,N123,FULL)

C       G(T19,N124,FULL)

C       G(T19,N125,FULL)

C       G(T21,N132,FULL)

C       G(T21,N133,FULL)

C       G(T21,N134,FULL)

C       G(T21,N135,FULL)

C       G(T21,N136,FULL)

C       G(T21,N137,FULL)

C       G(T22,N138,FULL)

C       G(T22,N139,FULL)
        CALL xD012345_(RMF2(3),S12,MHH2,RMF2(4),S34,T14,CMF2(3),NULL,
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = (QF(3)*ALPHA*PW12*SA*XMW)/(16D0*PI*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(4D0*D2(0,0))-D2(1,2)*(S13+
     &  S23)+D2(1,3)*S34-2D0*D1(2)*T14-D2(2,2)*T14+2D0*D1(3)*(MHH2-
     &  T14)+D2(2,3)*(MHH2-T14))
        F(5,-1,-1) = F(5,-1,-1)-4D0*D1(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)-4D0*D1(1)*PRE

C       G(T22,N140,FULL)
        CALL xD012345_(RMF2(3),S12,MHH2,RMF2(4),S34,T14,CMF2(3),XMZ2,
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = (ALPHA*PW12*SA*XMW*(1D0+2D0*QF(3)*XSW2))/(32D0*PI*
     &  XCW2*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(4D0*D2(0,0))-D2(1,2)*(S13+
     &  S23)+D2(1,3)*S34-2D0*D1(2)*T14-D2(2,2)*T14+2D0*D1(3)*(MHH2-
     &  T14)+D2(2,3)*(MHH2-T14))
        F(5,-1,-1) = F(5,-1,-1)-4D0*D1(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)-4D0*D1(1)*PRE

C       G(T22,N141,FULL)

C       G(T22,N142,FULL)

C       G(T22,N143,FULL)

C       G(T22,N144,FULL)
        CALL xD012345_(RMF2(3),S12,MHH2,RMF2(4),S34,T14,CMF2(3),NULL,
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = (QF(3)*ALPHA*PW12*SA*XMW)/(8D0*PI*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(12D0*D2(0,0))-2D0*D1(1)*(S13+
     &  S23)-2D0*D2(1,2)*(S13+S23)-D1(2)*(S12+3D0*S13+3D0*S23)+2D0*
     &  D2(1,3)*S34-D1(3)*(S14+S24-S34)-2D0*D2(2,2)*T14+2D0*D2(2,3)*
     &  (MHH2-T14))
        F(5,-1,-1) = F(5,-1,-1)+2D0*(D1(1)-2D0*D2(1,2)-2D0*D2(2,2))*
     &  PRE
        F(6,-1,-1) = F(6,-1,-1)+2D0*(D1(1)-2D0*D2(1,2)-2D0*D2(2,2))*
     &  PRE
        F(7,-1,-1) = F(7,-1,-1)+4D0*(D1(3)+D2(2,3))*PRE
        F(8,-1,-1) = F(8,-1,-1)+4D0*(D1(3)+D2(2,3))*PRE

C       G(T22,N145,FULL)
        CALL xD012345_(RMF2(3),S12,MHH2,RMF2(4),S34,T14,CMF2(3),XMZ2,
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = -((ALPHA*PW12*SA*XMW*XSW2**(-2)*(1D0+2D0*QF(3)*XSW2))/
     &  (16D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(12D0*D2(0,0))-2D0*D1(1)*(S13+
     &  S23)-2D0*D2(1,2)*(S13+S23)-D1(2)*(S12+3D0*S13+3D0*S23)+2D0*
     &  D2(1,3)*S34-D1(3)*(S14+S24-S34)-2D0*D2(2,2)*T14+2D0*D2(2,3)*
     &  (MHH2-T14))
        F(5,-1,-1) = F(5,-1,-1)+2D0*(D1(1)-2D0*D2(1,2)-2D0*D2(2,2))*
     &  PRE
        F(6,-1,-1) = F(6,-1,-1)+2D0*(D1(1)-2D0*D2(1,2)-2D0*D2(2,2))*
     &  PRE
        F(7,-1,-1) = F(7,-1,-1)+4D0*(D1(3)+D2(2,3))*PRE
        F(8,-1,-1) = F(8,-1,-1)+4D0*(D1(3)+D2(2,3))*PRE

C       G(T22,N146,FULL)
        CALL xD012345_(RMF2(3),S12,MHH2,RMF2(4),S34,T14,CMF2(4),XMW2,
     &  XMZ2,XMZ2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = -((ALPHA*PW12*SA*XMW*XSW2**(-2)*(1D0-2D0*QF(4)*XSW2))/
     &  (16D0*PI*XCW2*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(12D0*D2(0,0))-2D0*D1(1)*(S13+
     &  S23)-2D0*D2(1,2)*(S13+S23)-D1(2)*(S12+3D0*S13+3D0*S23)+2D0*
     &  D2(1,3)*S34-D1(3)*(S14+S24-S34)-2D0*D2(2,2)*T14+2D0*D2(2,3)*
     &  (MHH2-T14))
        F(5,-1,-1) = F(5,-1,-1)+2D0*(D1(1)-2D0*D2(1,2)-2D0*D2(2,2))*
     &  PRE
        F(6,-1,-1) = F(6,-1,-1)+2D0*(D1(1)-2D0*D2(1,2)-2D0*D2(2,2))*
     &  PRE
        F(7,-1,-1) = F(7,-1,-1)+4D0*(D1(3)+D2(2,3))*PRE
        F(8,-1,-1) = F(8,-1,-1)+4D0*(D1(3)+D2(2,3))*PRE

C       G(T22,N147,FULL)

C       G(T22,N148,FULL)

C       G(T22,N149,FULL)

C       G(T23,N150,FULL)

C       G(T23,N151,FULL)

C       G(T23,N152,FULL)

C       G(T23,N153,FULL)

C       G(T23,N154,FULL)

C       G(T23,N155,FULL)

	end

**********************************************************************
        subroutine  HHtoWW4f_pent_sesm(F,pw12,pw34)
**********************************************************************
*       pentagon corrections for HH -> WW -> 4f in the SESM
*---------------------------------------------------------------------
*       6.2.17 Stefan Dittmaier
**********************************************************************
	implicit none
	complex*16 pre,F(13,-1:1,-1:1),pw12,pw34
	complex*16 A0,xA0_,B0_,xB0_,DB0_,xDB0_,B1_,xB1_,DB1_,xDB1_
        complex*16 B0,B1(1),B2(0:2,0:2),B3(0:2,0:2,2)
        complex*16 B4(0:2,0:2,0:2,0:2),B5(0:2,0:2,0:2,0:2,2)
        complex*16 C0_,C0,C1(2),C2(0:2,0:2),C3(0:2,0:2,2)
        complex*16 C4(0:2,0:2,0:2,0:2)
	complex*16 D0,D1(3),D2(0:3,0:3),D3(0:3,0:3,3)
        complex*16 D4(0:3,0:3,0:3,0:3),D5(0:3,0:3,0:3,0:3,3)
	complex*16 E0n,E1n(4),E2n(0:4,0:4),E3n(0:4,0:4,4)
	complex*16 E4n(0:4,0:4,0:4,0:4)
        COMPLEX*16 K(1)

c mandelstam variables
      	real*8 s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
      	common/mandel/s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
c fermion charges of isospin duplets
	real*8 qf(4)
	common/fcharge/qf
c fermion masses as flag (i*1d-20)
      	complex*16 cme2,cmf2(5)
      	real*8 me2,rme2,mf2(5),rmf2(5)
      	common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2
	include '../COMMON/param.inc'
	include '../COMMON/xparam.inc'
        include '../COMMON/param_sesm.inc'
        include '../COMMON/param_bsm.inc'

C       Process: S4F21aF22F23aF24,   Model: Singlet

C       G(T5,N23,FULL)

C       G(T5,N24,FULL)

C       G(T5,N25,FULL)
        CALL xE01234_NEW(RMF2(3),RMF2(1),RMF2(2),MHH2,RMF2(4),S13,
     &  S12,T12,T14,S34,CMF2(3),NULL,CMF2(1),XMW2,XMW2,E0N,E1N,E2N,
     &  E3N,E4N,D0,D1,D2,D3,2,1)
        K(1) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)

        PRE = -((QF(1)*QF(3)*ALPHA*SA*XMW)/(8D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+2D0*(E1N(1)+2D0*E1N(2)+2D0*E1N(3)+
     &  2D0*E2N(1,2)+2D0*E2N(1,3)+2D0*E2N(2,2)+4D0*E2N(2,3)+2D0*
     &  E2N(3,3))*PRE*S13
        F(2,-1,-1) = F(2,-1,-1)+2D0*(E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,
     &  3))*PRE
        F(3,-1,-1) = F(3,-1,-1)-2D0*(E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,
     &  4)+2D0*E2N(3,4))*PRE
        F(5,-1,-1) = F(5,-1,-1)-8D0*K(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)-4D0*E1N(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)-4D0*E1N(4)*PRE
        F(9,-1,-1) = F(9,-1,-1)+K(1)*PRE
        F(10,-1,-1) = F(10,-1,-1)+(E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,
     &  3))*PRE
        F(11,-1,-1) = F(11,-1,-1)+(-(E2N(2,4))-E2N(3,4))*PRE
        F(12,-1,-1) = F(12,-1,-1)-E2N(3,4)*PRE
        F(13,-1,-1) = F(13,-1,-1)+E2N(0,0)*PRE

C       G(T5,N26,FULL)
        CALL xE01234_NEW(RMF2(3),RMF2(1),RMF2(2),MHH2,RMF2(4),S13,
     &  S12,T12,T14,S34,CMF2(3),XMZ2,CMF2(1),XMW2,XMW2,E0N,E1N,E2N,
     &  E3N,E4N,D0,D1,D2,D3,2,1)
        K(1) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)

        PRE = (ALPHA*SA*XMW*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*(1D0+
     &  2D0*QF(3)*XSW2))/(32D0*PI*XCW2*XSW)

        F(1,-1,-1) = F(1,-1,-1)+2D0*(E1N(1)+2D0*E1N(2)+2D0*E1N(3)+
     &  2D0*E2N(1,2)+2D0*E2N(1,3)+2D0*E2N(2,2)+4D0*E2N(2,3)+2D0*
     &  E2N(3,3))*PRE*S13
        F(2,-1,-1) = F(2,-1,-1)+2D0*(E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,
     &  3))*PRE
        F(3,-1,-1) = F(3,-1,-1)-2D0*(E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,
     &  4)+2D0*E2N(3,4))*PRE
        F(5,-1,-1) = F(5,-1,-1)-8D0*K(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)-4D0*E1N(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)-4D0*E1N(4)*PRE
        F(9,-1,-1) = F(9,-1,-1)+K(1)*PRE
        F(10,-1,-1) = F(10,-1,-1)+(E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,
     &  3))*PRE
        F(11,-1,-1) = F(11,-1,-1)+(-(E2N(2,4))-E2N(3,4))*PRE
        F(12,-1,-1) = F(12,-1,-1)-E2N(3,4)*PRE
        F(13,-1,-1) = F(13,-1,-1)+E2N(0,0)*PRE

C       G(T5,N27,FULL)
        CALL xE01234_NEW(RMF2(3),RMF2(1),RMF2(2),MHH2,RMF2(4),S13,
     &  S12,T12,T14,S34,CMF2(4),XMW2,CMF2(2),XMZ2,XMZ2,E0N,E1N,E2N,
     &  E3N,E4N,D0,D1,D2,D3,2,1)
        K(1) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)

        PRE = (ALPHA*SA*XCW2**(-2)*XMW*XSW2**(-2)*(1D0+2D0*QF(2)*
     &  XSW2)*(1D0-2D0*QF(4)*XSW2))/(32D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+2D0*(E1N(1)+2D0*E1N(2)+2D0*E1N(3)+
     &  2D0*E2N(1,2)+2D0*E2N(1,3)+2D0*E2N(2,2)+4D0*E2N(2,3)+2D0*
     &  E2N(3,3))*PRE*S13
        F(2,-1,-1) = F(2,-1,-1)+2D0*(E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,
     &  3))*PRE
        F(3,-1,-1) = F(3,-1,-1)-2D0*(E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,
     &  4)+2D0*E2N(3,4))*PRE
        F(5,-1,-1) = F(5,-1,-1)-8D0*K(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)-4D0*E1N(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)-4D0*E1N(4)*PRE
        F(9,-1,-1) = F(9,-1,-1)+K(1)*PRE
        F(10,-1,-1) = F(10,-1,-1)+(E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,
     &  3))*PRE
        F(11,-1,-1) = F(11,-1,-1)+(-(E2N(2,4))-E2N(3,4))*PRE
        F(12,-1,-1) = F(12,-1,-1)-E2N(3,4)*PRE
        F(13,-1,-1) = F(13,-1,-1)+E2N(0,0)*PRE

C       G(T7,N34,FULL)

C       G(T7,N35,FULL)

C       G(T7,N36,FULL)
        CALL xE01234_NEW(RMF2(1),RMF2(4),RMF2(3),MHH2,RMF2(2),S14,
     &  S34,T13,T12,S12,CMF2(1),NULL,CMF2(4),XMW2,XMW2,E0N,E1N,E2N,
     &  E3N,E4N,D0,D1,D2,D3,2,1)
        K(1) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)

        PRE = -((QF(1)*QF(4)*ALPHA*SA*XMW)/(8D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)-2D0*PRE*(10D0*E2N(0,0)-E1N(4)*S12-
     &  2D0*E2N(1,4)*S12+E1N(1)*S14+2D0*E1N(2)*S14+2D0*E2N(1,2)*S14+
     &  2D0*E2N(1,3)*S14+2D0*E2N(2,2)*S14-2D0*E2N(2,4)*(S12+S24)+
     &  2D0*E2N(3,3)*(S14+S34)+E1N(3)*(2D0*S14+S34)+2D0*E2N(2,3)*
     &  (2D0*S14+S34)-2D0*E2N(3,4)*(MHH2-T12))
        F(2,-1,-1) = F(2,-1,-1)-2D0*(E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,
     &  4)+2D0*E2N(3,4))*PRE
        F(3,-1,-1) = F(3,-1,-1)+2D0*(E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,
     &  3))*PRE
        F(5,-1,-1) = F(5,-1,-1)-4D0*(2D0*E1N(3)+3D0*E2N(1,3)+3D0*
     &  E2N(2,3)+3D0*E2N(3,3))*PRE
        F(6,-1,-1) = F(6,-1,-1)+4D0*E2N(3,4)*PRE
        F(7,-1,-1) = F(7,-1,-1)-4D0*K(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)+4D0*(E1N(4)+E2N(2,4)+E2N(3,4))*PRE
        F(9,-1,-1) = F(9,-1,-1)+(E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,3))*
     &  PRE
        F(10,-1,-1) = F(10,-1,-1)-E2N(3,4)*PRE
        F(11,-1,-1) = F(11,-1,-1)+K(1)*PRE
        F(12,-1,-1) = F(12,-1,-1)+(-(E2N(2,4))-E2N(3,4))*PRE
        F(13,-1,-1) = F(13,-1,-1)+E2N(0,0)*PRE

C       G(T7,N37,FULL)
        CALL xE01234_NEW(RMF2(1),RMF2(4),RMF2(3),MHH2,RMF2(2),S14,
     &  S34,T13,T12,S12,CMF2(1),XMZ2,CMF2(4),XMW2,XMW2,E0N,E1N,E2N,
     &  E3N,E4N,D0,D1,D2,D3,2,1)
        K(1) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)

        PRE = -((ALPHA*SA*XMW*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*(1D0-
     &  2D0*QF(4)*XSW2))/(32D0*PI*XCW2*XSW))

        F(1,-1,-1) = F(1,-1,-1)-2D0*PRE*(10D0*E2N(0,0)-E1N(4)*S12-
     &  2D0*E2N(1,4)*S12+E1N(1)*S14+2D0*E1N(2)*S14+2D0*E2N(1,2)*S14+
     &  2D0*E2N(1,3)*S14+2D0*E2N(2,2)*S14-2D0*E2N(2,4)*(S12+S24)+
     &  2D0*E2N(3,3)*(S14+S34)+E1N(3)*(2D0*S14+S34)+2D0*E2N(2,3)*
     &  (2D0*S14+S34)-2D0*E2N(3,4)*(MHH2-T12))
        F(2,-1,-1) = F(2,-1,-1)-2D0*(E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,
     &  4)+2D0*E2N(3,4))*PRE
        F(3,-1,-1) = F(3,-1,-1)+2D0*(E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,
     &  3))*PRE
        F(5,-1,-1) = F(5,-1,-1)-4D0*(2D0*E1N(3)+3D0*E2N(1,3)+3D0*
     &  E2N(2,3)+3D0*E2N(3,3))*PRE
        F(6,-1,-1) = F(6,-1,-1)+4D0*E2N(3,4)*PRE
        F(7,-1,-1) = F(7,-1,-1)-4D0*K(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)+4D0*(E1N(4)+E2N(2,4)+E2N(3,4))*PRE
        F(9,-1,-1) = F(9,-1,-1)+(E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,3))*
     &  PRE
        F(10,-1,-1) = F(10,-1,-1)-E2N(3,4)*PRE
        F(11,-1,-1) = F(11,-1,-1)+K(1)*PRE
        F(12,-1,-1) = F(12,-1,-1)+(-(E2N(2,4))-E2N(3,4))*PRE
        F(13,-1,-1) = F(13,-1,-1)+E2N(0,0)*PRE

C       G(T7,N38,FULL)
        CALL xE01234_NEW(RMF2(1),RMF2(4),RMF2(3),MHH2,RMF2(2),S14,
     &  S34,T13,T12,S12,CMF2(2),XMW2,CMF2(3),XMZ2,XMZ2,E0N,E1N,E2N,
     &  E3N,E4N,D0,D1,D2,D3,2,1)
        K(1) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)

        PRE = -((ALPHA*SA*XCW2**(-2)*XMW*XSW2**(-2)*(1D0+2D0*QF(2)*
     &  XSW2)*(1D0+2D0*QF(3)*XSW2))/(32D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)-2D0*PRE*(10D0*E2N(0,0)-E1N(4)*S12-
     &  2D0*E2N(1,4)*S12+E1N(1)*S14+2D0*E1N(2)*S14+2D0*E2N(1,2)*S14+
     &  2D0*E2N(1,3)*S14+2D0*E2N(2,2)*S14-2D0*E2N(2,4)*(S12+S24)+
     &  2D0*E2N(3,3)*(S14+S34)+E1N(3)*(2D0*S14+S34)+2D0*E2N(2,3)*
     &  (2D0*S14+S34)-2D0*E2N(3,4)*(MHH2-T12))
        F(2,-1,-1) = F(2,-1,-1)-2D0*(E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,
     &  4)+2D0*E2N(3,4))*PRE
        F(3,-1,-1) = F(3,-1,-1)+2D0*(E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,
     &  3))*PRE
        F(5,-1,-1) = F(5,-1,-1)-4D0*(2D0*E1N(3)+3D0*E2N(1,3)+3D0*
     &  E2N(2,3)+3D0*E2N(3,3))*PRE
        F(6,-1,-1) = F(6,-1,-1)+4D0*E2N(3,4)*PRE
        F(7,-1,-1) = F(7,-1,-1)-4D0*K(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)+4D0*(E1N(4)+E2N(2,4)+E2N(3,4))*PRE
        F(9,-1,-1) = F(9,-1,-1)+(E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,3))*
     &  PRE
        F(10,-1,-1) = F(10,-1,-1)-E2N(3,4)*PRE
        F(11,-1,-1) = F(11,-1,-1)+K(1)*PRE
        F(12,-1,-1) = F(12,-1,-1)+(-(E2N(2,4))-E2N(3,4))*PRE
        F(13,-1,-1) = F(13,-1,-1)+E2N(0,0)*PRE

C       G(T9,N47,FULL)

C       G(T9,N48,FULL)

C       G(T9,N49,FULL)

C       G(T9,N50,FULL)

C       G(T9,N51,FULL)

C       G(T9,N52,FULL)

C       G(T10,N53,FULL)

C       G(T10,N54,FULL)

C       G(T10,N55,FULL)

C       G(T10,N56,FULL)

C       G(T10,N57,FULL)

C       G(T10,N58,FULL)

C       G(T13,N73,FULL)

C       G(T13,N74,FULL)

C       G(T13,N75,FULL)

C       G(T13,N76,FULL)

C       G(T13,N77,FULL)

C       G(T13,N78,FULL)

C       G(T18,N115,FULL)

C       G(T18,N116,FULL)

C       G(T18,N117,FULL)
        CALL xE01234_NEW(RMF2(2),RMF2(4),RMF2(3),MHH2,RMF2(1),S24,
     &  S34,T13,T11,S12,CMF2(2),NULL,CMF2(4),XMW2,XMW2,E0N,E1N,E2N,
     &  E3N,E4N,D0,D1,D2,D3,2,1)

        PRE = (QF(2)*QF(4)*ALPHA*SA*XMW)/(8D0*PI*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)-2D0*PRE*(-(2D0*E2N(3,4)*S13)+E1N(1)*
     &  S24)
        F(2,-1,-1) = F(2,-1,-1)+2D0*(E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,
     &  4)+2D0*E2N(3,4))*PRE
        F(3,-1,-1) = F(3,-1,-1)-2D0*(E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,
     &  3))*PRE
        F(5,-1,-1) = F(5,-1,-1)-8D0*E2N(3,4)*PRE
        F(6,-1,-1) = F(6,-1,-1)+4D0*E1N(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+4D0*E1N(4)*PRE
        F(9,-1,-1) = F(9,-1,-1)+E2N(3,4)*PRE
        F(10,-1,-1) = F(10,-1,-1)+(-(E1N(3))-E2N(1,3)-E2N(2,3)-
     &  E2N(3,3))*PRE
        F(11,-1,-1) = F(11,-1,-1)+(E2N(2,4)+E2N(3,4))*PRE
        F(12,-1,-1) = F(12,-1,-1)+(-(E1N(2))-E1N(3)-E2N(1,2)-E2N(1,
     &  3)-E2N(2,2)-2D0*E2N(2,3)-E2N(3,3))*PRE
        F(13,-1,-1) = F(13,-1,-1)-E2N(0,0)*PRE

C       G(T18,N118,FULL)
        CALL xE01234_NEW(RMF2(2),RMF2(4),RMF2(3),MHH2,RMF2(1),S24,
     &  S34,T13,T11,S12,CMF2(2),XMZ2,CMF2(4),XMW2,XMW2,E0N,E1N,E2N,
     &  E3N,E4N,D0,D1,D2,D3,2,1)

        PRE = -((ALPHA*SA*XMW*XSW2**(-2)*(1D0+2D0*QF(2)*XSW2)*(1D0-
     &  2D0*QF(4)*XSW2))/(32D0*PI*XCW2*XSW))

        F(1,-1,-1) = F(1,-1,-1)-2D0*PRE*(-(2D0*E2N(3,4)*S13)+E1N(1)*
     &  S24)
        F(2,-1,-1) = F(2,-1,-1)+2D0*(E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,
     &  4)+2D0*E2N(3,4))*PRE
        F(3,-1,-1) = F(3,-1,-1)-2D0*(E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,
     &  3))*PRE
        F(5,-1,-1) = F(5,-1,-1)-8D0*E2N(3,4)*PRE
        F(6,-1,-1) = F(6,-1,-1)+4D0*E1N(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+4D0*E1N(4)*PRE
        F(9,-1,-1) = F(9,-1,-1)+E2N(3,4)*PRE
        F(10,-1,-1) = F(10,-1,-1)+(-(E1N(3))-E2N(1,3)-E2N(2,3)-
     &  E2N(3,3))*PRE
        F(11,-1,-1) = F(11,-1,-1)+(E2N(2,4)+E2N(3,4))*PRE
        F(12,-1,-1) = F(12,-1,-1)+(-(E1N(2))-E1N(3)-E2N(1,2)-E2N(1,
     &  3)-E2N(2,2)-2D0*E2N(2,3)-E2N(3,3))*PRE
        F(13,-1,-1) = F(13,-1,-1)-E2N(0,0)*PRE

C       G(T18,N119,FULL)
        CALL xE01234_NEW(RMF2(2),RMF2(4),RMF2(3),MHH2,RMF2(1),S24,
     &  S34,T13,T11,S12,CMF2(1),XMW2,CMF2(3),XMZ2,XMZ2,E0N,E1N,E2N,
     &  E3N,E4N,D0,D1,D2,D3,2,1)

        PRE = -((ALPHA*SA*XCW2**(-2)*XMW*XSW2**(-2)*(1D0-2D0*QF(1)*
     &  XSW2)*(1D0+2D0*QF(3)*XSW2))/(32D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)-2D0*PRE*(-(2D0*E2N(3,4)*S13)+E1N(1)*
     &  S24)
        F(2,-1,-1) = F(2,-1,-1)+2D0*(E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,
     &  4)+2D0*E2N(3,4))*PRE
        F(3,-1,-1) = F(3,-1,-1)-2D0*(E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,
     &  3))*PRE
        F(5,-1,-1) = F(5,-1,-1)-8D0*E2N(3,4)*PRE
        F(6,-1,-1) = F(6,-1,-1)+4D0*E1N(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+4D0*E1N(4)*PRE
        F(9,-1,-1) = F(9,-1,-1)+E2N(3,4)*PRE
        F(10,-1,-1) = F(10,-1,-1)+(-(E1N(3))-E2N(1,3)-E2N(2,3)-
     &  E2N(3,3))*PRE
        F(11,-1,-1) = F(11,-1,-1)+(E2N(2,4)+E2N(3,4))*PRE
        F(12,-1,-1) = F(12,-1,-1)+(-(E1N(2))-E1N(3)-E2N(1,2)-E2N(1,
     &  3)-E2N(2,2)-2D0*E2N(2,3)-E2N(3,3))*PRE
        F(13,-1,-1) = F(13,-1,-1)-E2N(0,0)*PRE

C       G(T20,N126,FULL)

C       G(T20,N127,FULL)

C       G(T20,N128,FULL)

C       G(T20,N129,FULL)

C       G(T20,N130,FULL)

C       G(T20,N131,FULL)

C       G(T24,N156,FULL)

C       G(T24,N157,FULL)

C       G(T24,N158,FULL)
        CALL xE01234_NEW(RMF2(3),RMF2(2),RMF2(1),MHH2,RMF2(4),S23,
     &  S12,T11,T14,S34,CMF2(3),NULL,CMF2(2),XMW2,XMW2,E0N,E1N,E2N,
     &  E3N,E4N,D0,D1,D2,D3,2,1)
        K(1) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)

        PRE = -((QF(2)*QF(3)*ALPHA*SA*XMW)/(8D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)-2D0*PRE*(10D0*E2N(0,0)+E1N(1)*S23+
     &  2D0*E1N(2)*S23+2D0*E2N(1,2)*S23+2D0*E2N(1,3)*S23+2D0*E2N(2,
     &  2)*S23+2D0*E2N(3,3)*(S12+S23)+E1N(3)*(S12+2D0*S23)+2D0*
     &  E2N(2,3)*(S12+2D0*S23)-E1N(4)*S34-2D0*E2N(1,4)*S34-2D0*
     &  E2N(2,4)*(S24+S34)-2D0*E2N(3,4)*(MHH2-T14))
        F(2,-1,-1) = F(2,-1,-1)+2D0*(E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,
     &  3))*PRE
        F(3,-1,-1) = F(3,-1,-1)-2D0*(E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,
     &  4)+2D0*E2N(3,4))*PRE
        F(5,-1,-1) = F(5,-1,-1)-4D0*(2D0*E1N(3)+3D0*E2N(1,3)+3D0*
     &  E2N(2,3)+3D0*E2N(3,3))*PRE
        F(6,-1,-1) = F(6,-1,-1)-4D0*K(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)+4D0*E2N(3,4)*PRE
        F(8,-1,-1) = F(8,-1,-1)+4D0*(E1N(4)+E2N(2,4)+E2N(3,4))*PRE
        F(9,-1,-1) = F(9,-1,-1)+(E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,3))*
     &  PRE
        F(10,-1,-1) = F(10,-1,-1)+K(1)*PRE
        F(11,-1,-1) = F(11,-1,-1)-E2N(3,4)*PRE
        F(12,-1,-1) = F(12,-1,-1)+(-(E2N(2,4))-E2N(3,4))*PRE
        F(13,-1,-1) = F(13,-1,-1)+E2N(0,0)*PRE

C       G(T24,N159,FULL)
        CALL xE01234_NEW(RMF2(3),RMF2(2),RMF2(1),MHH2,RMF2(4),S23,
     &  S12,T11,T14,S34,CMF2(3),XMZ2,CMF2(2),XMW2,XMW2,E0N,E1N,E2N,
     &  E3N,E4N,D0,D1,D2,D3,2,1)
        K(1) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)

        PRE = -((ALPHA*SA*XMW*XSW2**(-2)*(1D0+2D0*QF(2)*XSW2)*(1D0+
     &  2D0*QF(3)*XSW2))/(32D0*PI*XCW2*XSW))

        F(1,-1,-1) = F(1,-1,-1)-2D0*PRE*(10D0*E2N(0,0)+E1N(1)*S23+
     &  2D0*E1N(2)*S23+2D0*E2N(1,2)*S23+2D0*E2N(1,3)*S23+2D0*E2N(2,
     &  2)*S23+2D0*E2N(3,3)*(S12+S23)+E1N(3)*(S12+2D0*S23)+2D0*
     &  E2N(2,3)*(S12+2D0*S23)-E1N(4)*S34-2D0*E2N(1,4)*S34-2D0*
     &  E2N(2,4)*(S24+S34)-2D0*E2N(3,4)*(MHH2-T14))
        F(2,-1,-1) = F(2,-1,-1)+2D0*(E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,
     &  3))*PRE
        F(3,-1,-1) = F(3,-1,-1)-2D0*(E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,
     &  4)+2D0*E2N(3,4))*PRE
        F(5,-1,-1) = F(5,-1,-1)-4D0*(2D0*E1N(3)+3D0*E2N(1,3)+3D0*
     &  E2N(2,3)+3D0*E2N(3,3))*PRE
        F(6,-1,-1) = F(6,-1,-1)-4D0*K(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)+4D0*E2N(3,4)*PRE
        F(8,-1,-1) = F(8,-1,-1)+4D0*(E1N(4)+E2N(2,4)+E2N(3,4))*PRE
        F(9,-1,-1) = F(9,-1,-1)+(E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,3))*
     &  PRE
        F(10,-1,-1) = F(10,-1,-1)+K(1)*PRE
        F(11,-1,-1) = F(11,-1,-1)-E2N(3,4)*PRE
        F(12,-1,-1) = F(12,-1,-1)+(-(E2N(2,4))-E2N(3,4))*PRE
        F(13,-1,-1) = F(13,-1,-1)+E2N(0,0)*PRE

C       G(T24,N160,FULL)
        CALL xE01234_NEW(RMF2(3),RMF2(2),RMF2(1),MHH2,RMF2(4),S23,
     &  S12,T11,T14,S34,CMF2(4),XMW2,CMF2(1),XMZ2,XMZ2,E0N,E1N,E2N,
     &  E3N,E4N,D0,D1,D2,D3,2,1)
        K(1) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)

        PRE = -((ALPHA*SA*XCW2**(-2)*XMW*XSW2**(-2)*(1D0-2D0*QF(1)*
     &  XSW2)*(1D0-2D0*QF(4)*XSW2))/(32D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)-2D0*PRE*(10D0*E2N(0,0)+E1N(1)*S23+
     &  2D0*E1N(2)*S23+2D0*E2N(1,2)*S23+2D0*E2N(1,3)*S23+2D0*E2N(2,
     &  2)*S23+2D0*E2N(3,3)*(S12+S23)+E1N(3)*(S12+2D0*S23)+2D0*
     &  E2N(2,3)*(S12+2D0*S23)-E1N(4)*S34-2D0*E2N(1,4)*S34-2D0*
     &  E2N(2,4)*(S24+S34)-2D0*E2N(3,4)*(MHH2-T14))
        F(2,-1,-1) = F(2,-1,-1)+2D0*(E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,
     &  3))*PRE
        F(3,-1,-1) = F(3,-1,-1)-2D0*(E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,
     &  4)+2D0*E2N(3,4))*PRE
        F(5,-1,-1) = F(5,-1,-1)-4D0*(2D0*E1N(3)+3D0*E2N(1,3)+3D0*
     &  E2N(2,3)+3D0*E2N(3,3))*PRE
        F(6,-1,-1) = F(6,-1,-1)-4D0*K(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)+4D0*E2N(3,4)*PRE
        F(8,-1,-1) = F(8,-1,-1)+4D0*(E1N(4)+E2N(2,4)+E2N(3,4))*PRE
        F(9,-1,-1) = F(9,-1,-1)+(E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,3))*
     &  PRE
        F(10,-1,-1) = F(10,-1,-1)+K(1)*PRE
        F(11,-1,-1) = F(11,-1,-1)-E2N(3,4)*PRE
        F(12,-1,-1) = F(12,-1,-1)+(-(E2N(2,4))-E2N(3,4))*PRE
        F(13,-1,-1) = F(13,-1,-1)+E2N(0,0)*PRE

	end

**********************************************************************
        subroutine  HHtoWW4f_self_ferm2_sesm(F,pw12,pw34)
**********************************************************************
*       self-energy contributions for HH -> WW -> 4f in the SESM
*       closed fermion loops
*---------------------------------------------------------------------
*       6.2.17 Stefan Dittmaier
**********************************************************************
	implicit none
	complex*16 pre,F(13,-1:1,-1:1),pw12,pw34

c mandelstam variables
      	real*8 s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
      	common/mandel/s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
c fermion charges of isospin duplets
	real*8 qf(4)
	common/fcharge/qf
c fermion masses as flag (i*1d-20)
      	complex*16 cme2,cmf2(5)
      	real*8 me2,rme2,mf2(5),rmf2(5)
      	common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2
        complex*16 fact,xseww_ferm
	include '../COMMON/param.inc'
	include '../COMMON/xparam.inc'
        include '../COMMON/param_sesm.inc'
        include '../COMMON/param_bsm.inc'

        fact = - xseww_ferm(s12)*pw12 - xseww_ferm(s34)*pw34

        PRE = (PW12*PW34*SA*XMW)/(2D0*XSW*XSW2) *fact

        F(1,-1,-1) = F(1,-1,-1)+PRE

	end

**********************************************************************
        subroutine  HHtoWW4f_self_ferm_sesm(F,pw12,pw34)
**********************************************************************
*       self-energy contributions for HH -> WW -> 4f in the SESM
*       closed fermion loops
*---------------------------------------------------------------------
*       6.2.17 Stefan Dittmaier
**********************************************************************
	implicit none
	complex*16 pre,F(13,-1:1,-1:1),pw12,pw34
	complex*16 A0,xA0_,B0_,xB0_,DB0_,xDB0_,B1_,xB1_,DB1_,xDB1_
        complex*16 B0,B1(1),B2(0:2,0:2),B3(0:2,0:2,2)
        complex*16 B4(0:2,0:2,0:2,0:2),B5(0:2,0:2,0:2,0:2,2)
        complex*16 C0_,C0,C1(2),C2(0:2,0:2),C3(0:2,0:2,2)
        complex*16 C4(0:2,0:2,0:2,0:2)
	complex*16 D0,D1(3),D2(0:3,0:3),D3(0:3,0:3,3)
        complex*16 D4(0:3,0:3,0:3,0:3),D5(0:3,0:3,0:3,0:3,3)
	complex*16 E0n,E1n(4),E2n(0:4,0:4),E3n(0:4,0:4,4)
	complex*16 E4n(0:4,0:4,0:4,0:4)
	integer i

c mandelstam variables
      	real*8 s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
      	common/mandel/s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
c fermion charges of isospin duplets
	real*8 qf(4)
	common/fcharge/qf
c fermion masses as flag (i*1d-20)
      	complex*16 cme2,cmf2(5)
      	real*8 me2,rme2,mf2(5),rmf2(5)
      	common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2
	include '../COMMON/param.inc'
	include '../COMMON/xparam.inc'
        include '../COMMON/param_sesm.inc'
        include '../COMMON/param_bsm.inc'

	do 100 i=1,3

C       Process: S4F21aF22F23aF24,   Model: Singlet

C       G(T7,N56,FULL)
        CALL xB012345_(S12,XMQP2(I),XMQM2(I),B0,B1,B2,B3,B4,B5,2,0)

        PRE = (ALPHA*PW12**2*PW34*SA*XMW*XSW2**(-2)*(12D0*B2(0,0)+
     &  S12+6D0*B1(1)*S12+6D0*B2(1,1)*S12-3D0*XMQM2(I)-3D0*
     &  XMQP2(I)))/(16D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T7,N57,FULL)
        CALL xB012345_(S12,NULL,XML2(I),B0,B1,B2,B3,B4,B5,2,0)

        PRE = (ALPHA*PW12**2*PW34*SA*XMW*XSW2**(-2)*(12D0*B2(0,0)+
     &  S12+6D0*B1(1)*S12+6D0*B2(1,1)*S12-3D0*XML2(I)))/(48D0*PI*
     &  XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T8,N73,FULL)

C       G(T8,N74,FULL)

C       G(T9,N90,FULL)

C       G(T9,N91,FULL)

C       G(T14,N134,FULL)
        CALL xB012345_(S34,XMQM2(I),XMQP2(I),B0,B1,B2,B3,B4,B5,2,0)

        PRE = (ALPHA*PW12*PW34**2*SA*XMW*XSW2**(-2)*(12D0*B2(0,0)+
     &  S34+6D0*B1(1)*S34+6D0*B2(1,1)*S34-3D0*XMQM2(I)-3D0*
     &  XMQP2(I)))/(16D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T14,N135,FULL)
        CALL xB012345_(S34,NULL,XML2(I),B0,B1,B2,B3,B4,B5,2,0)

        PRE = (ALPHA*PW12*PW34**2*SA*XMW*XSW2**(-2)*(12D0*B2(0,0)+
     &  S34+6D0*B1(1)*S34+6D0*B2(1,1)*S34-3D0*XML2(I)))/(48D0*PI*
     &  XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T15,N151,FULL)

C       G(T15,N152,FULL)

C       G(T16,N168,FULL)

C       G(T16,N169,FULL)

100	continue

	end

**********************************************************************
        subroutine  HHtoWW4f_vert_ferm_sesm(F,pw12,pw34)
**********************************************************************
*       self-energy contributions for HH -> WW -> 4f in the SESM
*       closed fermion loops
*---------------------------------------------------------------------
*       6.2.17 Stefan Dittmaier
**********************************************************************
	implicit none
	complex*16 pre,F(13,-1:1,-1:1),pw12,pw34
	complex*16 A0,xA0_,B0_,xB0_,DB0_,xDB0_,B1_,xB1_,DB1_,xDB1_
        complex*16 B0,B1(1),B2(0:2,0:2),B3(0:2,0:2,2)
        complex*16 B4(0:2,0:2,0:2,0:2),B5(0:2,0:2,0:2,0:2,2)
        complex*16 C0_,C0,C1(2),C2(0:2,0:2),C3(0:2,0:2,2)
        complex*16 C4(0:2,0:2,0:2,0:2)
	complex*16 D0,D1(3),D2(0:3,0:3),D3(0:3,0:3,3)
        complex*16 D4(0:3,0:3,0:3,0:3),D5(0:3,0:3,0:3,0:3,3)
	complex*16 E0n,E1n(4),E2n(0:4,0:4),E3n(0:4,0:4,4)
	complex*16 E4n(0:4,0:4,0:4,0:4)
	real *8 qeps
	integer i

c mandelstam variables
      	real*8 s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
      	common/mandel/s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
c fermion charges of isospin duplets
	real*8 qf(4)
	common/fcharge/qf
c fermion masses as flag (i*1d-20)
      	complex*16 cme2,cmf2(5)
      	real*8 me2,rme2,mf2(5),rmf2(5)
      	common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2
	include '../COMMON/param.inc'
	include '../COMMON/xparam.inc'
        include '../COMMON/param_sesm.inc'
        include '../COMMON/param_bsm.inc'

	qeps = 1d0

	do 100 i=1,3

C       Process: S4F21aF22F23aF24,   Model: Singlet

C       G(T9,N429,FULL)

C       G(T9,N430,FULL)

C       G(T9,N431,FULL)
        CALL xC01234_(S12,MHH2,S34,XMQP2(I),XMQM2(I),XMQM2(I),C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,0)

        PRE = -((3D0*ALPHA*PW12*PW34*SA*XSW2**(-2)*XMQM2(I))/(32D0*
     &  PI*XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(2D0-8D0*C2(0,0)-4D0*C2(1,1)*
     &  S12+4D0*C2(1,2)*(S13+S14+S23+S24)-C1(1)*(2D0*S12-S13-QEPS*
     &  S13-S14-QEPS*S14-S23+QEPS*S23-S24+QEPS*S24)-4D0*C2(2,2)*S34+
     &  C1(2)*(S13-QEPS*S13+S14-QEPS*S14+S23+QEPS*S23+S24+QEPS*S24-
     &  2D0*S34))
        F(5,-1,-1) = F(5,-1,-1)-2D0*PRE*(4D0*C2(1,2)+C1(1)*(1D0+
     &  QEPS)+C1(2)*(1D0-QEPS))
        F(6,-1,-1) = F(6,-1,-1)-2D0*PRE*(4D0*C2(1,2)+C1(2)*(1D0+
     &  QEPS)+C1(1)*(1D0-QEPS))
        F(7,-1,-1) = F(7,-1,-1)-2D0*PRE*(4D0*C2(1,2)+C1(1)*(1D0+
     &  QEPS)+C1(2)*(1D0-QEPS))
        F(8,-1,-1) = F(8,-1,-1)-2D0*PRE*(4D0*C2(1,2)+C1(2)*(1D0+
     &  QEPS)+C1(1)*(1D0-QEPS))

C       G(T9,N432,FULL)
        CALL xC01234_(S12,MHH2,S34,NULL,XML2(I),XML2(I),C0,C1,C2,C3,C4,B0,
     &  B1,B2,B3,2,0)

        PRE = -((ALPHA*PW12*PW34*SA*XSW2**(-2)*XML2(I))/(32D0*PI*
     &  XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(2D0-8D0*C2(0,0)-4D0*C2(1,1)*
     &  S12+4D0*C2(1,2)*(S13+S14+S23+S24)-C1(1)*(2D0*S12-S13-QEPS*
     &  S13-S14-QEPS*S14-S23+QEPS*S23-S24+QEPS*S24)-4D0*C2(2,2)*S34+
     &  C1(2)*(S13-QEPS*S13+S14-QEPS*S14+S23+QEPS*S23+S24+QEPS*S24-
     &  2D0*S34))
        F(5,-1,-1) = F(5,-1,-1)-2D0*PRE*(4D0*C2(1,2)+C1(1)*(1D0+
     &  QEPS)+C1(2)*(1D0-QEPS))
        F(6,-1,-1) = F(6,-1,-1)-2D0*PRE*(4D0*C2(1,2)+C1(2)*(1D0+
     &  QEPS)+C1(1)*(1D0-QEPS))
        F(7,-1,-1) = F(7,-1,-1)-2D0*PRE*(4D0*C2(1,2)+C1(1)*(1D0+
     &  QEPS)+C1(2)*(1D0-QEPS))
        F(8,-1,-1) = F(8,-1,-1)-2D0*PRE*(4D0*C2(1,2)+C1(2)*(1D0+
     &  QEPS)+C1(1)*(1D0-QEPS))

C       G(T9,N433,FULL)
        CALL xC01234_(S12,MHH2,S34,XMQM2(I),XMQP2(I),XMQP2(I),C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,0)

        PRE = -((3D0*ALPHA*PW12*PW34*SA*XSW2**(-2)*XMQP2(I))/(32D0*
     &  PI*XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(2D0-8D0*C2(0,0)-4D0*C2(1,1)*
     &  S12+4D0*C2(1,2)*(S13+S14+S23+S24)-C1(1)*(2D0*S12-S13+QEPS*
     &  S13-S14+QEPS*S14-S23-QEPS*S23-S24-QEPS*S24)-4D0*C2(2,2)*S34+
     &  C1(2)*(S13+QEPS*S13+S14+QEPS*S14+S23-QEPS*S23+S24-QEPS*S24-
     &  2D0*S34))
        F(5,-1,-1) = F(5,-1,-1)-2D0*PRE*(4D0*C2(1,2)+C1(2)*(1D0+
     &  QEPS)+C1(1)*(1D0-QEPS))
        F(6,-1,-1) = F(6,-1,-1)-2D0*PRE*(4D0*C2(1,2)+C1(1)*(1D0+
     &  QEPS)+C1(2)*(1D0-QEPS))
        F(7,-1,-1) = F(7,-1,-1)-2D0*PRE*(4D0*C2(1,2)+C1(2)*(1D0+
     &  QEPS)+C1(1)*(1D0-QEPS))
        F(8,-1,-1) = F(8,-1,-1)-2D0*PRE*(4D0*C2(1,2)+C1(1)*(1D0+
     &  QEPS)+C1(2)*(1D0-QEPS))

C       G(T9,N434,FULL)

C       G(T9,N435,FULL)

100	continue

	end
