**********************************************************************
	subroutine sesm_setcoupl(hbos)
**********************************************************************
*	set coupling factors of the SESM
*---------------------------------------------------------------------
*	6.2.17 Stefan Dittmaier
**********************************************************************
        integer hbos

        include '../COMMON/param.inc'
        include '../COMMON/xparam.inc'
	include '../COMMON/param_sesm.inc'
	include '../COMMON/param_bsm.inc'

c Higgs-V-V couplings relative to the SM
	Ch0VV = CA
	CHHVV = SA

c some 3-Higgs couplings
        Ch0h0HH = -(2d0*MH02+MHH2)*SA/(8d0*(MH02-MHH2)*xMW*xSW)
     &	           *( (MH02-MHH2)*(1d0+3d0*CA2-SA2)
     &	              -32d0*L12/el**2*xMW2*xSW2 )
        Ch0HHHH = CA*(MH02+2d0*MHH2)/(8d0*(MH02-MHH2)*xMW*xSW)
     &	          *( (MH02-MHH2)*(-1d0+CA2-3d0*SA2)
     &	             -32d0*L12/el**2*xMW2*xSW2 )

c Higgs-fermion couplings
          Cleph0 = CA
          ClepHH = SA
          ClepG = 1d0 
          Cuph0 = CA
          CupHH = SA
          CupG = 1d0 
          Cdoh0 = CA
          CdoHH = SA
          CdoG = 1d0

c process-specific couplings
	if (hbos.eq.1) then
	  CVH   = Ch0VV 
	  CLEPH = Cleph0
	  CUPH  = Cuph0
	  CDOH  = Cdoh0
	elseif (hbos.eq.2) then
	  CVH   = CHHVV 
	  CLEPH = ClepHH
	  CUPH  = CupHH
	  CDOH  = CdoHH
	endif

c perturbativity bound
	lam_np_sesm = 4d0*pi
	lam1_sesm  = 2d0*(sa2*mh02+ca2*mhh2)*l12**2*(2d0*mw/el*sw)**2
     &              /s2a**2/(mhh2-mh02)**2
	lam2_sesm  = 2d0*(ca2*mh02+sa2*mhh2)/(2d0*mw/el*sw)**2
	lam12_sesm = l12

	end
