#ifdef mpiuse

      Subroutine mpi_intermediate(average,sigma)
      implicit none

      include "mpif.h"
      integer status(MPI_STATUS_SIZE)

      integer iNumProcs, iErr, iMyRank,proccount,i2
      common/mpistuff/iNumProcs,iMyRank

      real*8 keep_average,keep_sigma,average,sigma

      if(iMyRank.EQ.0.AND.iNumProcs.NE.1) Then
        do i2=1,iNumProcs-1
          call MPI_Recv(keep_sigma, 1, MPI_DOUBLE_PRECISION,
     &  		i2, 2, MPI_COMM_WORLD, status, iErr)
          call MPI_Recv(keep_average, 1, MPI_DOUBLE_PRECISION,
     &  		i2, 1, MPI_COMM_WORLD, status, iErr)
          average=average+keep_average
          sigma=sigma+keep_sigma
        enddo
      else if(iMyRank.NE.0.AND.iNumProcs.NE.1) Then
        call MPI_Send(sigma, 1, MPI_DOUBLE_PRECISION,
     &  	      0, 2, MPI_COMM_WORLD, iErr)
        call MPI_Send(average, 1, MPI_DOUBLE_PRECISION,
     &  	      0, 1, MPI_COMM_WORLD, iErr)
        average=0D0
        sigma=0D0
      endif

      End

**********************************************************************

      Subroutine mpi_optimize(nev)
      implicit none

      include "mpif.h"
      integer status(MPI_STATUS_SIZE)

      include 'COMMON/max.inc'

      integer nev,gen,i1

      integer iNumProcs, iErr, iMyRank,proccount,i2
      common/mpistuff/iNumProcs,iMyRank

      integer do_optimize
      common/do_optimize_common/do_optimize

      real*8 al(maxchan,maxopt,maxgen),be(0:maxchan,maxgen)
      real*8 wi(maxchan,maxgen),almin(maxgen)
      real*8 wi_ext(maxchan,maxgen),chweight(maxchan)
      integer nopt(0:maxopt,maxgen),opt(maxgen)
      common/adaptopt/al,be,wi,almin,nopt,opt

      real*8 nu(3,maxchan,maxgen)
      integer ep(7,maxchan,maxgen),ip(3,maxchan,maxgen)
      integer topology(maxchan,maxgen),emps(maxchan,maxgen)
      integer spps(maxchan,maxgen),nchannels(maxgen)
      common/channels/nu,ep,ip,topology,emps,spps,nchannels

      do gen=1,maxgen
         if(nev.eq.nopt(opt(gen),gen).AND.iNumProcs.NE.1)then
            if(iMyRank.NE.0) then
              call MPI_Send(wi, maxchan*maxgen,
     &  		    MPI_DOUBLE_PRECISION,
     &  		    0, 1, MPI_COMM_WORLD, iErr)
              do i2=1,nchannels(gen)
        	 wi(i2,gen)=0D0
              enddo
            endif

            if (iMyRank.EQ.0) then
              do i2=1,iNumProcs-1
        	call MPI_Recv(wi_ext, maxchan*maxgen,
     &  		      MPI_DOUBLE_PRECISION,
     &  		      i2, 1, MPI_COMM_WORLD, status, iErr)
        	do i1=1,nchannels(gen)
        	  wi(i1,gen)=wi(i1,gen)+wi_ext(i1,gen)
        	enddo
              enddo

              do_optimize=1
              call optimization(0D0,chweight,1D0,gen,nchannels(gen))
              do_optimize=0

              do i2=1,iNumProcs-1
        	call MPI_Send(be, (maxchan+1)*maxgen,
     &  		      MPI_DOUBLE_PRECISION,
     &  		      i2, 2, MPI_COMM_WORLD, iErr)
        	call MPI_Send(al, maxchan*maxopt*maxgen,
     &  		      MPI_DOUBLE_PRECISION,
     &  		      i2, 3, MPI_COMM_WORLD, iErr)
              enddo
            endif

            if(iMyRank.NE.0) then
              call MPI_Recv(be, (maxchan+1)*maxgen,
     &  		    MPI_DOUBLE_PRECISION,
     &  		    0, 2, MPI_COMM_WORLD, status, iErr)
              call MPI_Recv(al, maxchan*maxopt*maxgen,
     &  		    MPI_DOUBLE_PRECISION,
     &  		    0, 3, MPI_COMM_WORLD, status, iErr)
              opt(gen)=opt(gen)+1
            endif
         endif
      enddo

      end

**********************************************************************

      Subroutine mpi_end(average,sigma,subav,subsi,
     &                   maxweight,maxbornweight)
      Implicit None

      include "mpif.h"
      integer status(MPI_STATUS_SIZE)

      include 'COMMON/max.inc'

      integer iNumProcs, iErr, iMyRank,proccount, i2, ii
      common/mpistuff/iNumProcs,iMyRank

      real*8 average,sigma
      real*8 subav(maxsubc),subsi(maxsubc)
      real*8 maxweight(maxw),maxbornweight
      real*8 keep_average,keep_sigma
      real*8 keep_subav(maxsubc),keep_subsi(maxsubc)
      real*8 keep_maxweight(maxw),keep_maxbornweight

      if(iMyRank.EQ.0.AND.iNumProcs.NE.1) Then
	do i2=1,iNumProcs-1
	  call MPI_Recv(keep_sigma, 1, MPI_DOUBLE_PRECISION,
     &                  i2, 2, MPI_COMM_WORLD, status, iErr)
	  call MPI_Recv(keep_average, 1, MPI_DOUBLE_PRECISION,
     &                  i2, 1, MPI_COMM_WORLD, status, iErr)
	  call MPI_Recv(keep_subav, maxsubc, MPI_DOUBLE_PRECISION,
     &                  i2, 3, MPI_COMM_WORLD, status, iErr)
	  call MPI_Recv(keep_subsi, maxsubc, MPI_DOUBLE_PRECISION,
     &                  i2, 4, MPI_COMM_WORLD, status, iErr)
	  call MPI_Recv(keep_maxweight, maxw, MPI_DOUBLE_PRECISION,
     &                  i2, 5, MPI_COMM_WORLD, status, iErr)
	  call MPI_Recv(keep_maxbornweight, 1, MPI_DOUBLE_PRECISION,
     &                  i2, 6, MPI_COMM_WORLD, status, iErr)
          average=average+keep_average
          sigma=sigma+keep_sigma
	  do ii=1,maxsubc
	     subav(ii)=subav(ii)+keep_subav(ii)
	     subsi(ii)=subsi(ii)+keep_subsi(ii)
	  enddo
	  do ii=1,maxw
	     If(keep_maxweight(ii).GT.maxweight(ii)) then
	        maxweight(ii)=keep_maxweight(ii)
	     Endif
	  enddo
	  If(keep_maxbornweight.GT.maxbornweight) then
	     maxbornweight=keep_maxbornweight
	  Endif
	enddo
	do i2=1,iNumProcs-1
	  call MPI_Send(maxweight, maxW, MPI_DOUBLE_PRECISION,
     &                i2, 7, MPI_COMM_WORLD, iErr)
	  call MPI_Send(average, 1, MPI_DOUBLE_PRECISION,
     &                i2, 8, MPI_COMM_WORLD, iErr)
	  call MPI_Send(subav, maxsubc, MPI_DOUBLE_PRECISION,
     &                i2, 9, MPI_COMM_WORLD, iErr)
	  call MPI_Send(maxbornweight, 1, MPI_DOUBLE_PRECISION,
     &                i2, 10, MPI_COMM_WORLD, iErr)
	enddo
      else if(iMyRank.NE.0.AND.iNumProcs.NE.1) Then
	call MPI_Send(sigma, 1, MPI_DOUBLE_PRECISION,
     &                0, 2, MPI_COMM_WORLD, iErr)
	call MPI_Send(average, 1, MPI_DOUBLE_PRECISION,
     &                0, 1, MPI_COMM_WORLD, iErr)
	call MPI_Send(subav, maxsubc, MPI_DOUBLE_PRECISION,
     &                0, 3, MPI_COMM_WORLD, iErr)
	call MPI_Send(subsi, maxsubc, MPI_DOUBLE_PRECISION,
     &                0, 4, MPI_COMM_WORLD, iErr)
	call MPI_Send(maxweight, maxW, MPI_DOUBLE_PRECISION,
     &                0, 5, MPI_COMM_WORLD, iErr)
	call MPI_Send(maxbornweight, 1, MPI_DOUBLE_PRECISION,
     &                0, 6, MPI_COMM_WORLD, iErr)
        average=0D0
	sigma=0D0
	do ii=1,maxsubc
	   subav(ii)=0D0
	   subsi(ii)=0D0
	enddo
	call MPI_Recv(maxweight, maxw, MPI_DOUBLE_PRECISION,
     &                0, 7, MPI_COMM_WORLD, status, iErr)
	call MPI_Recv(average, 1, MPI_DOUBLE_PRECISION,
     &                0, 8, MPI_COMM_WORLD, status, iErr)
	call MPI_Recv(subav, maxsubc, MPI_DOUBLE_PRECISION,
     &                0, 9, MPI_COMM_WORLD, status, iErr)
	call MPI_Recv(maxbornweight, 1, MPI_DOUBLE_PRECISION,
     &                0, 10, MPI_COMM_WORLD, status, iErr)
      endif

      End

*******************************************************************

      Subroutine mympi_unweighted(genunwev,genwev,negev,genunwbornev)
      Implicit None

      include "mpif.h"
      integer status(MPI_STATUS_SIZE)

      integer iNumProcs, iErr, iMyRank,proccount, i2, ii
      common/mpistuff/iNumProcs,iMyRank

      integer genunwev,genwev,negev,genunwbornev
      integer keep_genunwev,keep_genwev,keep_negev,keep_genunwbornev

      if(iMyRank.NE.0) then
        call MPI_Send(genunwev, 1, MPI_INTEGER,
     &  	      0, 121, MPI_COMM_WORLD, iErr)
        call MPI_Send(genwev, 1, MPI_INTEGER,
     &  	      0, 122, MPI_COMM_WORLD, iErr)
        call MPI_Send(negev, 1, MPI_INTEGER,
     &  	      0, 123, MPI_COMM_WORLD, iErr)
        call MPI_Send(genunwbornev, 1, MPI_INTEGER,
     &  	      0, 124, MPI_COMM_WORLD, iErr)
      endif
      if (iMyRank.EQ.0) then
        do i2=1,iNumProcs-1
          call MPI_Recv(keep_genunwev, 1, MPI_INTEGER,
     &  		i2, 121, MPI_COMM_WORLD, status, iErr)
          genunwev=genunwev+keep_genunwev
          call MPI_Recv(keep_genwev, 1, MPI_INTEGER,
     &  		i2, 122, MPI_COMM_WORLD, status, iErr)
          genwev=genwev+keep_genwev
          call MPI_Recv(keep_negev, 1, MPI_INTEGER,
     &  		i2, 123, MPI_COMM_WORLD, status, iErr)
          negev=negev+keep_negev
          call MPI_Recv(keep_genunwbornev, 1, MPI_INTEGER,
     &  		i2, 124, MPI_COMM_WORLD, status, iErr)
          genunwbornev=genunwbornev+keep_genunwbornev
        enddo
        genwev=genwev/iNumProcs
      endif

      End

*******************************************************************

      Subroutine mpi_input_comm(
     &  outputfile,nevents,nunwevents,contrib,qqcd,qalp,
     &  count_final,fnameinput,finalstateinput,qrecomb,qllfsr,ranshift,
     &  randomseed,
     &  mh,alpha0,alphas,gf,mzi,mwi,gzi,gwi,ml,mqm,mqp,precomb,
     &  deltae,deltath,massmapping,mininvmass,nfsrfact,
     &  qsoftcoll,qhist,moreout,qrecombcolle,lheoutput,resonancesinlhe,
     &  model,modeltype,hboson,mffcutrel,qsm4,ml4,mn4,md4,mu4,
     &  renscheme,mrenbsm1,mrenbsm2,tb,tb_in,ta,ta_in,sa,ca,
     &  mh0,mhh,ma0,mhp,lam5,lam5_in,l12,l12_in)

      Implicit None

      integer iNumProcs, iErr, iMyRank
      common/mpistuff/iNumProcs,iMyRank

      include "mpif.h"
      integer status(MPI_STATUS_SIZE),ii

      character*90 outputfile
      character*8 fnameinput(4,100)
      character*100 finalstateinput(100)
      integer nevents,nunwevents,contrib,qqcd,qalp
      integer count_final(0:4)
      integer qrecomb,qllfsr,ranshift,randomseed
      integer qsoftcoll,qhist,moreout
      integer qrecombcolle,lheoutput,resonancesinlhe
      double precision mh,alpha0,alphas,gf,mzi,mwi,gzi,gwi
      double precision ml(3),mqm(3),mqp(3),precomb(3)
      double precision deltae,deltath,massmapping,mininvmass,nfsrfact

      integer model,modeltype,hboson,renscheme
      integer qsm4
      real*8 mrenbsm1,mrenbsm2
      real*8 Mh0,MHH,MA0,MHp
      real*8 TB,tb_in
      real*8 TA,CA,SA,ta_in
      real*8 CBA,CAB,SBA,SAB
      real*8 l12,l12_in
      real*8 lam5,lam5_in
      real*8 mffcutrel
      real*8 ml4,mn4,md4,mu4  

      if(iMyRank.NE.0) then
        call MPI_Recv(outputfile, 90, MPI_CHARACTER,
     &  		0, 201, MPI_COMM_WORLD, status, iErr)
	call MPI_Recv(fnameinput, 3200, MPI_CHARACTER,
     & 	                0, 202, MPI_COMM_WORLD, status, iErr)
	call MPI_Recv(finalstateinput, 10000, MPI_CHARACTER,
     & 	                0, 203, MPI_COMM_WORLD, status, iErr)

	call MPI_Recv(nevents, 1, MPI_INTEGER,
     & 	                0, 204, MPI_COMM_WORLD, status, iErr)
	call MPI_Recv(nunwevents, 1, MPI_INTEGER,
     & 	                0, 205, MPI_COMM_WORLD, status, iErr)
	call MPI_Recv(contrib, 1, MPI_INTEGER,
     & 	                0, 206, MPI_COMM_WORLD, status, iErr)
	call MPI_Recv(qqcd, 1, MPI_INTEGER,
     & 	                0, 207, MPI_COMM_WORLD, status, iErr)
	call MPI_Recv(qalp, 1, MPI_INTEGER,
     & 	                0, 208, MPI_COMM_WORLD, status, iErr)
	call MPI_Recv(count_final, 5, MPI_INTEGER,
     & 	                0, 209, MPI_COMM_WORLD, status, iErr)
	call MPI_Recv(qrecomb, 1, MPI_INTEGER,
     & 	                0, 210, MPI_COMM_WORLD, status, iErr)
	call MPI_Recv(qllfsr, 1, MPI_INTEGER,
     & 	                0, 211, MPI_COMM_WORLD, status, iErr)
	call MPI_Recv(ranshift, 1, MPI_INTEGER,
     & 	                0, 212, MPI_COMM_WORLD, status, iErr)
	call MPI_Recv(randomseed, 1, MPI_INTEGER,
     & 	                0, 212, MPI_COMM_WORLD, status, iErr)
	call MPI_Recv(qsoftcoll, 1, MPI_INTEGER,
     & 	                0, 213, MPI_COMM_WORLD, status, iErr)
	call MPI_Recv(qhist, 1, MPI_INTEGER,
     & 	                0, 214, MPI_COMM_WORLD, status, iErr)
	call MPI_Recv(moreout, 1, MPI_INTEGER,
     & 	                0, 215, MPI_COMM_WORLD, status, iErr)
	call MPI_Recv(qrecombcolle, 1, MPI_INTEGER,
     & 	                0, 233, MPI_COMM_WORLD, status, iErr)
	call MPI_Recv(lheoutput, 1, MPI_INTEGER,
     & 	                0, 234, MPI_COMM_WORLD, status, iErr)
	call MPI_Recv(resonancesinlhe, 1, MPI_INTEGER,
     & 	                0, 235, MPI_COMM_WORLD, status, iErr)
	call MPI_Recv(model, 1, MPI_INTEGER,
     & 	                0, 236, MPI_COMM_WORLD, status, iErr)
	call MPI_Recv(modeltype, 1, MPI_INTEGER,
     & 	                0, 237, MPI_COMM_WORLD, status, iErr)
	call MPI_Recv(hboson, 1, MPI_INTEGER,
     & 	                0, 238, MPI_COMM_WORLD, status, iErr)
	call MPI_Recv(renscheme, 1, MPI_INTEGER,
     & 	                0, 239, MPI_COMM_WORLD, status, iErr)
	call MPI_Recv(qsm4, 1, MPI_INTEGER,
     & 	                0, 240, MPI_COMM_WORLD, status, iErr)

	call MPI_Recv(mh, 1, MPI_DOUBLE_PRECISION,
     &  		0, 216, MPI_COMM_WORLD, status, iErr)
	call MPI_Recv(alpha0, 1, MPI_DOUBLE_PRECISION,
     &  		0, 217, MPI_COMM_WORLD, status, iErr)
	call MPI_Recv(alphas, 1, MPI_DOUBLE_PRECISION,
     &  		0, 218, MPI_COMM_WORLD, status, iErr)
	call MPI_Recv(gf, 1, MPI_DOUBLE_PRECISION,
     &  		0, 219, MPI_COMM_WORLD, status, iErr)
	call MPI_Recv(mzi, 1, MPI_DOUBLE_PRECISION,
     &  		0, 220, MPI_COMM_WORLD, status, iErr)
	call MPI_Recv(mwi, 1, MPI_DOUBLE_PRECISION,
     &  		0, 221, MPI_COMM_WORLD, status, iErr)
	call MPI_Recv(gzi, 1, MPI_DOUBLE_PRECISION,
     &  		0, 222, MPI_COMM_WORLD, status, iErr)
	call MPI_Recv(gwi, 1, MPI_DOUBLE_PRECISION,
     &  		0, 223, MPI_COMM_WORLD, status, iErr)
	call MPI_Recv(ml, 3, MPI_DOUBLE_PRECISION,
     &  		0, 224, MPI_COMM_WORLD, status, iErr)
	call MPI_Recv(mqm, 3, MPI_DOUBLE_PRECISION,
     &  		0, 225, MPI_COMM_WORLD, status, iErr)
	call MPI_Recv(mqp, 3, MPI_DOUBLE_PRECISION,
     &  		0, 226, MPI_COMM_WORLD, status, iErr)
	call MPI_Recv(precomb, 3, MPI_DOUBLE_PRECISION,
     &  		0, 227, MPI_COMM_WORLD, status, iErr)
	call MPI_Recv(deltae, 1, MPI_DOUBLE_PRECISION,
     &  		0, 228, MPI_COMM_WORLD, status, iErr)
	call MPI_Recv(deltath, 1, MPI_DOUBLE_PRECISION,
     &  	        0, 229, MPI_COMM_WORLD, status, iErr)
	call MPI_Recv(massmapping, 1, MPI_DOUBLE_PRECISION,
     &  	        0, 230, MPI_COMM_WORLD, status, iErr)
	call MPI_Recv(mininvmass, 1, MPI_DOUBLE_PRECISION,
     &  	        0, 231, MPI_COMM_WORLD, status, iErr)
	call MPI_Recv(nfsrfact, 1, MPI_DOUBLE_PRECISION,
     &  	        0, 232, MPI_COMM_WORLD, status, iErr)
	call MPI_Recv(mrenbsm1, 1, MPI_DOUBLE_PRECISION,
     &  	        0, 241, MPI_COMM_WORLD, status, iErr)
	call MPI_Recv(mrenbsm2, 1, MPI_DOUBLE_PRECISION,
     &  	        0, 242, MPI_COMM_WORLD, status, iErr)
	call MPI_Recv(Mh0, 1, MPI_DOUBLE_PRECISION,
     &  	        0, 243, MPI_COMM_WORLD, status, iErr)
	call MPI_Recv(MHH, 1, MPI_DOUBLE_PRECISION,
     &  	        0, 244, MPI_COMM_WORLD, status, iErr)
	call MPI_Recv(MA0, 1, MPI_DOUBLE_PRECISION,
     &  	        0, 245, MPI_COMM_WORLD, status, iErr)
	call MPI_Recv(MHp, 1, MPI_DOUBLE_PRECISION,
     &  	        0, 246, MPI_COMM_WORLD, status, iErr)
	call MPI_Recv(TB, 1, MPI_DOUBLE_PRECISION,
     &  	        0, 247, MPI_COMM_WORLD, status, iErr)
	call MPI_Recv(tb_in, 1, MPI_DOUBLE_PRECISION,
     &  	        0, 248, MPI_COMM_WORLD, status, iErr)
	call MPI_Recv(TA, 1, MPI_DOUBLE_PRECISION,
     &  	        0, 249, MPI_COMM_WORLD, status, iErr)
	call MPI_Recv(CA, 1, MPI_DOUBLE_PRECISION,
     &  	        0, 250, MPI_COMM_WORLD, status, iErr)
	call MPI_Recv(SA, 1, MPI_DOUBLE_PRECISION,
     &  	        0, 251, MPI_COMM_WORLD, status, iErr)
	call MPI_Recv(ta_in, 1, MPI_DOUBLE_PRECISION,
     &  	        0, 252, MPI_COMM_WORLD, status, iErr)
	call MPI_Recv(CBA, 1, MPI_DOUBLE_PRECISION,
     &  	        0, 253, MPI_COMM_WORLD, status, iErr)
	call MPI_Recv(CAB, 1, MPI_DOUBLE_PRECISION,
     &  	        0, 254, MPI_COMM_WORLD, status, iErr)
	call MPI_Recv(SBA, 1, MPI_DOUBLE_PRECISION,
     &  	        0, 255, MPI_COMM_WORLD, status, iErr)
	call MPI_Recv(SAB, 1, MPI_DOUBLE_PRECISION,
     &  	        0, 256, MPI_COMM_WORLD, status, iErr)
	call MPI_Recv(l12, 1, MPI_DOUBLE_PRECISION,
     &  	        0, 257, MPI_COMM_WORLD, status, iErr)
	call MPI_Recv(l12_in, 1, MPI_DOUBLE_PRECISION,
     &  	        0, 258, MPI_COMM_WORLD, status, iErr)
	call MPI_Recv(lam5, 1, MPI_DOUBLE_PRECISION,
     &  	        0, 259, MPI_COMM_WORLD, status, iErr)
	call MPI_Recv(lam5_in, 1, MPI_DOUBLE_PRECISION,
     &  	        0, 260, MPI_COMM_WORLD, status, iErr)
	call MPI_Recv(mffcutrel, 1, MPI_DOUBLE_PRECISION,
     &  	        0, 261, MPI_COMM_WORLD, status, iErr)
	call MPI_Recv(ml4, 1, MPI_DOUBLE_PRECISION,
     &  	        0, 262, MPI_COMM_WORLD, status, iErr)
	call MPI_Recv(mn4, 1, MPI_DOUBLE_PRECISION,
     &  	        0, 263, MPI_COMM_WORLD, status, iErr)
	call MPI_Recv(md4, 1, MPI_DOUBLE_PRECISION,
     &  	        0, 264, MPI_COMM_WORLD, status, iErr)
	call MPI_Recv(mu4, 1, MPI_DOUBLE_PRECISION,
     &  	        0, 265, MPI_COMM_WORLD, status, iErr)
      endif
      if (iMyRank.EQ.0) then
        do ii=1,iNumProcs-1
          call MPI_Send(outputfile, 90, MPI_CHARACTER,
     &  	      ii, 201, MPI_COMM_WORLD, iErr)
	  call MPI_Send(fnameinput, 3200, MPI_CHARACTER,
     & 	              ii, 202, MPI_COMM_WORLD, iErr)
	  call MPI_Send(finalstateinput, 10000, MPI_CHARACTER,
     & 	              ii, 203, MPI_COMM_WORLD, iErr)

	  call MPI_Send(nevents, 1, MPI_INTEGER,
     & 	              ii, 204, MPI_COMM_WORLD, iErr)
	  call MPI_Send(nunwevents, 1, MPI_INTEGER,
     & 	              ii, 205, MPI_COMM_WORLD, iErr)
	  call MPI_Send(contrib, 1, MPI_INTEGER,
     & 	              ii, 206, MPI_COMM_WORLD, iErr)
	  call MPI_Send(qqcd, 1, MPI_INTEGER,
     &  	      ii, 207, MPI_COMM_WORLD, iErr)
	  call MPI_Send(qalp, 1, MPI_INTEGER,
     &  	      ii, 208, MPI_COMM_WORLD, iErr)
	  call MPI_Send(count_final, 5, MPI_INTEGER,
     &  	      ii, 209, MPI_COMM_WORLD, iErr)
	  call MPI_Send(qrecomb, 1, MPI_INTEGER,
     &  	      ii, 210, MPI_COMM_WORLD, iErr)
	  call MPI_Send(qllfsr, 1, MPI_INTEGER,
     &  	      ii, 211, MPI_COMM_WORLD, iErr)
	  call MPI_Send(ranshift, 1, MPI_INTEGER,
     &  	      ii, 212, MPI_COMM_WORLD, iErr)
	  call MPI_Send(randomseed, 1, MPI_INTEGER,
     &  	      ii, 212, MPI_COMM_WORLD, iErr)
	  call MPI_Send(qsoftcoll, 1, MPI_INTEGER,
     &  	      ii, 213, MPI_COMM_WORLD, iErr)
	  call MPI_Send(qhist, 1, MPI_INTEGER,
     &  	      ii, 214, MPI_COMM_WORLD, iErr)
	  call MPI_Send(moreout, 1, MPI_INTEGER,
     &  	      ii, 215, MPI_COMM_WORLD, iErr)
	  call MPI_Send(qrecombcolle, 1, MPI_INTEGER,
     &  	      ii, 233, MPI_COMM_WORLD, iErr)
	  call MPI_Send(lheoutput, 1, MPI_INTEGER,
     &  	      ii, 234, MPI_COMM_WORLD, iErr)
	  call MPI_Send(resonancesinlhe, 1, MPI_INTEGER,
     &  	      ii, 235, MPI_COMM_WORLD, iErr)
	  call MPI_Send(model, 1, MPI_INTEGER,
     & 	              ii, 236, MPI_COMM_WORLD, iErr)
	  call MPI_Send(modeltype, 1, MPI_INTEGER,
     & 	              ii, 237, MPI_COMM_WORLD, iErr)
	  call MPI_Send(hboson, 1, MPI_INTEGER,
     & 	              ii, 238, MPI_COMM_WORLD, iErr)
	  call MPI_Send(renscheme, 1, MPI_INTEGER,
     & 	              ii, 239, MPI_COMM_WORLD, iErr)
	  call MPI_Send(qsm4, 1, MPI_INTEGER,
     & 	              ii, 240, MPI_COMM_WORLD, iErr)

	  call MPI_Send(mh, 1, MPI_DOUBLE_PRECISION,
     &  	      ii, 216, MPI_COMM_WORLD, iErr)
	  call MPI_Send(alpha0, 1, MPI_DOUBLE_PRECISION,
     &  	      ii, 217, MPI_COMM_WORLD, iErr)
	  call MPI_Send(alphas, 1, MPI_DOUBLE_PRECISION,
     &  	      ii, 218, MPI_COMM_WORLD, iErr)
	  call MPI_Send(gf, 1, MPI_DOUBLE_PRECISION,
     &  	      ii, 219, MPI_COMM_WORLD, iErr)
	  call MPI_Send(mzi, 1, MPI_DOUBLE_PRECISION,
     &  	      ii, 220, MPI_COMM_WORLD, iErr)
	  call MPI_Send(mwi, 1, MPI_DOUBLE_PRECISION,
     &  	      ii, 221, MPI_COMM_WORLD, iErr)
	  call MPI_Send(gzi, 1, MPI_DOUBLE_PRECISION,
     &  	      ii, 222, MPI_COMM_WORLD, iErr)
	  call MPI_Send(gwi, 1, MPI_DOUBLE_PRECISION,
     &  	      ii, 223, MPI_COMM_WORLD, iErr)
	  call MPI_Send(ml, 3, MPI_DOUBLE_PRECISION,
     &  	      ii, 224, MPI_COMM_WORLD, iErr)
	  call MPI_Send(mqm, 3, MPI_DOUBLE_PRECISION,
     &  	      ii, 225, MPI_COMM_WORLD, iErr)
	  call MPI_Send(mqp, 3, MPI_DOUBLE_PRECISION,
     &  	      ii, 226, MPI_COMM_WORLD, iErr)
	  call MPI_Send(precomb, 3, MPI_DOUBLE_PRECISION,
     &  	      ii, 227, MPI_COMM_WORLD, iErr)
	  call MPI_Send(deltae, 1, MPI_DOUBLE_PRECISION,
     &  	      ii, 228, MPI_COMM_WORLD, iErr)
	  call MPI_Send(deltath, 1, MPI_DOUBLE_PRECISION,
     &  	      ii, 229, MPI_COMM_WORLD, iErr)
	  call MPI_Send(massmapping, 1, MPI_DOUBLE_PRECISION,
     &  	      ii, 230, MPI_COMM_WORLD, iErr)
	  call MPI_Send(mininvmass, 1, MPI_DOUBLE_PRECISION,
     &  	      ii, 231, MPI_COMM_WORLD, iErr)
	  call MPI_Send(nfsrfact, 1, MPI_DOUBLE_PRECISION,
     &  	      ii, 232, MPI_COMM_WORLD, iErr)
	  call MPI_Send(mrenbsm1, 1, MPI_DOUBLE_PRECISION,
     &  	      ii, 241, MPI_COMM_WORLD, iErr)
	  call MPI_Send(mrenbsm2, 1, MPI_DOUBLE_PRECISION,
     &  	      ii, 242, MPI_COMM_WORLD, iErr)
	  call MPI_Send(Mh0, 1, MPI_DOUBLE_PRECISION,
     &  	      ii, 243, MPI_COMM_WORLD, iErr)
	  call MPI_Send(MHH, 1, MPI_DOUBLE_PRECISION,
     &  	      ii, 244, MPI_COMM_WORLD, iErr)
	  call MPI_Send(MA0, 1, MPI_DOUBLE_PRECISION,
     &  	      ii, 245, MPI_COMM_WORLD, iErr)
	  call MPI_Send(MHp, 1, MPI_DOUBLE_PRECISION,
     &  	      ii, 246, MPI_COMM_WORLD, iErr)
	  call MPI_Send(TB, 1, MPI_DOUBLE_PRECISION,
     &  	      ii, 247, MPI_COMM_WORLD, iErr)
	  call MPI_Send(tb_in, 1, MPI_DOUBLE_PRECISION,
     &  	      ii, 248, MPI_COMM_WORLD, iErr)
	  call MPI_Send(TA, 1, MPI_DOUBLE_PRECISION,
     &  	      ii, 249, MPI_COMM_WORLD, iErr)
	  call MPI_Send(CA, 1, MPI_DOUBLE_PRECISION,
     &  	      ii, 250, MPI_COMM_WORLD, iErr)
	  call MPI_Send(SA, 1, MPI_DOUBLE_PRECISION,
     &  	      ii, 251, MPI_COMM_WORLD, iErr)
	  call MPI_Send(ta_in, 1, MPI_DOUBLE_PRECISION,
     &  	      ii, 252, MPI_COMM_WORLD, iErr)
	  call MPI_Send(CBA, 1, MPI_DOUBLE_PRECISION,
     &  	      ii, 253, MPI_COMM_WORLD, iErr)
	  call MPI_Send(CAB, 1, MPI_DOUBLE_PRECISION,
     &  	      ii, 254, MPI_COMM_WORLD, iErr)
	  call MPI_Send(SBA, 1, MPI_DOUBLE_PRECISION,
     &  	      ii, 255, MPI_COMM_WORLD, iErr)
	  call MPI_Send(SAB, 1, MPI_DOUBLE_PRECISION,
     &  	      ii, 256, MPI_COMM_WORLD, iErr)
	  call MPI_Send(l12, 1, MPI_DOUBLE_PRECISION,
     &  	      ii, 257, MPI_COMM_WORLD, iErr)
	  call MPI_Send(l12_in, 1, MPI_DOUBLE_PRECISION,
     &  	      ii, 258, MPI_COMM_WORLD, iErr)
	  call MPI_Send(lam5, 1, MPI_DOUBLE_PRECISION,
     &  	      ii, 259, MPI_COMM_WORLD, iErr)
	  call MPI_Send(lam5_in, 1, MPI_DOUBLE_PRECISION,
     &  	      ii, 260, MPI_COMM_WORLD, iErr)
	  call MPI_Send(mffcutrel, 1, MPI_DOUBLE_PRECISION,
     &  	      ii, 261, MPI_COMM_WORLD, iErr)
	  call MPI_Send(ml4, 1, MPI_DOUBLE_PRECISION,
     &  	      ii, 262, MPI_COMM_WORLD, iErr)
	  call MPI_Send(mn4, 1, MPI_DOUBLE_PRECISION,
     &  	      ii, 263, MPI_COMM_WORLD, iErr)
	  call MPI_Send(md4, 1, MPI_DOUBLE_PRECISION,
     &  	      ii, 264, MPI_COMM_WORLD, iErr)
	  call MPI_Send(mu4, 1, MPI_DOUBLE_PRECISION,
     &  	      ii, 265, MPI_COMM_WORLD, iErr)
        enddo
      endif

      End

#endif


