************************************************************************
	subroutine c2fit(fu,x,xlow,xhigh,y,dim1,dim2)
************************************************************************
*	chi2 fit for function fu                    		       *
*	8.12.95 SD                                                     *
************************************************************************
	implicit real*8 (a-z)
	real*8 x(10),x1(10),xlow(10),xhigh(10),yy(10)
	integer i,j,dim0,dim1,dim2,n,sgn,conv
	external fu

	do 5 i=1,10
	x1(i) = x(i)
5	continue

	dim0 = 0
	call mini(fu,x,y,dim0,dim1,dim2,conv)
c	write(98,*) 'y min  ',y
c	write(98,*) 'centre ',(x(i),i=dim1,dim2)

 	do 10 i=dim1,dim2
	dim0  = i

	do 40 sgn=1,-1,-2

	do 11 j=dim1,dim2
	x1(j) = x(j)
11 	continue

	if (x(i).ne.0d0) then
	  x1(i) = x(i)*(1d0+sgn*0.01d0)
	else
	  x1(i) = sgn
	endif
	call mini(fu,x1,y1,dim0,dim1,dim2,conv)

	if ((y1-y.gt.0d0).and.(x(i).ne.0d0)) then
	  dx = x(i)*sgn*0.01d0/sqrt(y1-y) / 5d0
	else
	  dx = sgn
	endif

20	continue
	x1(i) = x(i) + dx
	call mini(fu,x1,y1,dim0,dim1,dim2,conv)
 	if (y1.lt.y+1d0) then
	  dx = dx*1.2d0
	  goto 20
	endif

	y0 = y
	x0 = x(i)
	y2 = y1
	x2 = x1(i)
30	continue

	if (y1.gt.y+1d0) then
	  y2 = y1
	  x2 = x1(i)
	else
	  y0 = y1
	  x0 = x1(i)
	endif 
	x1(i) = (x2+x0)/2d0
	call mini(fu,x1,y1,dim0,dim1,dim2,conv)
 	if (abs(x2-x0).gt.1d-10) goto 30

	yy(i) = y1
	if (sgn.eq.-1) then
	   xlow(i)  = x1(i)-x(i)
c	   write(98,*) 'low    ',xlow(i),yy(i)
	endif
	if (sgn.eq.+1) then
	   xhigh(i) = x1(i)-x(i)
c	   write(98,*) 'high   ',xhigh(i),yy(i)
	endif
40	continue
	
10	continue

	end

************************************************************************
	subroutine mini(fu,x,y,dim0,dim1,dim2,conv)
************************************************************************
*	searching minimum of function fu            		       *
*	5.12.95 SD                                                     *
************************************************************************
	implicit real*8 (a-z)
	real*8 x(10),x1(10),x2(10)
	real*8 g(10),s(10),p(10),q(10),hq(10),h(10,10)
	integer i,j,dim0,dim1,dim2,n,heq1,count,maxcount,conv
	logical misnan
	
	external fu

	conv  = 0          ! flag for convergence
	count = 0          ! counter for iterations
	maxcount = 20000   ! maximal iteration number

	if ((dim0.eq.dim1).and.(dim0.eq.dim2)) then
	  y = fu(x)
	  return
	endif

	xacc  = 1d-10
	yacc  = 1d-15
	eps   = 1d-4

	heq1 = 0
	n    = 0
	dx   = 0d0

	if ( (dim2.eq.dim1) .or.
     *	     ((dim2-dim1.eq.1).and.((dim0.eq.dim1).or.(dim0.eq.dim2))) )
     *	   then
	   heq1 = -1
	endif 

	do 5 i=1,10
	x1(i) = x(i)
	x2(i) = x(i)
5	continue

	call grad(fu,x,g,dim1,dim2)
	y = fu(x)

12	continue

	do 10 i=dim1,dim2
	if (i.eq.dim0) goto 10
	do 20 j=dim1,i-1
	h(i,j) = 0d0
	h(j,i) = h(i,j)
20	continue
	h(i,i) = 1d0
10	continue

11	continue

	dxold = dx

	s2 = 0d0
	g2 = 0d0
	gs = 0d0
	do 30 i=dim1,dim2
	if (i.eq.dim0) goto 30
	s(i) = 0d0
	q(i) = g(i)
	do 31 j=dim1,dim2
	if (j.eq.dim0) goto 31
	s(i) = s(i)+h(i,j)*g(j)
31	continue
	s2 = s2 + s(i)**2
	g2 = g2 + g(i)**2
	gs = gs + g(i)*s(i)
30	continue
	if ((g2.eq.0d0).or.(s2.eq.0d0)) return

	dfu = 0d0
	do 40 i=dim1,dim2
	if (i.eq.dim0) goto 40
	x1(i) = x(i)+eps*s(i)/sqrt(s2)
	x2(i) = x(i)-eps*s(i)/sqrt(s2)
	dfu  = dfu + s(i)*g(i)
40	continue
	y1 = fu(x1)
	y2 = fu(x2)
	ddfu = (y1+y2-2d0*y)/eps**2*s2

	t0 = 0d0
	dt = dfu/ddfu

45	continue
	t2 = dt
	t1 = dt/2d0

	do 50 i=dim1,dim2
	if (i.eq.dim0) goto 50
	x1(i) = x(i)-t1*s(i)
	x2(i) = x(i)-t2*s(i)
50	continue
	y1 = fu(x1)
	y2 = fu(x2)
	if (y.lt.y2) then
	  dt = -dt/2d0
	  goto 45
	endif

60	continue
        count = count + 1
	if (count.ge.maxcount) conv = 1
	if (y2.ge.y1) then
	  dt = dt/2d0
	  t2 = t1
	  t1 = t0+dt
	  do 65 i=dim1,dim2
	  if (i.eq.dim0) goto 65
	  x2(i) = x1(i)
	  x1(i) = x(i)-t1*s(i)
65	  continue
	  y2 = y1
	  y1 = fu(x1)
	else
	  t0 = t1
	  t1 = t2
	  t2 = t2+dt
	  do 66 i=dim1,dim2
	  if (i.eq.dim0) goto 66
	  x1(i) = x2(i)
	  x2(i) = x(i)-t2*s(i)
66	  continue
	  y1 = y2
	  y2 = fu(x2)
	endif

	if (((abs(dt)*sqrt(s2).gt.xacc/1000d0).or.(y.lt.y1)) 
     &	    .and.(conv.eq.0)) goto 60 

	do 70 i=dim1,dim2
	if (i.eq.dim0) goto 70
	p(i) = x1(i)-x(i)
 	x(i) = x1(i)
70	continue
	dy = abs(y1-y)
	y  = y1
	dx = abs(t1)*sqrt(s2)

    	if (misnan(y1)) return

	if ( (((heq1.gt.5).or.(heq1.eq.-1)) 
     *	      .and.(dx.lt.xacc).and.(dy.lt.yacc))
     *	     .or.(conv.ne.0) ) return

	n = n+1
	call grad(fu,x,g,dim1,dim2)

c ***** part below relevant for general Oren-Luenberger method
c ***** h(i,j)=delta(i,j) ==> gradient as search direction

	if (heq1.eq.-1) goto 11

	gsold = 0d0
	pq    = 0d0
	do 80 i=dim1,dim2
	if (i.eq.dim0) goto 80
	gsold = gsold + g(i)*s(i)
	q(i)  = g(i)-q(i)
	pq    = pq + p(i)*q(i)
80	continue

	qhq = 0d0
	do 90 i=dim1,dim2
	if (i.eq.dim0) goto 90
	hq(i) = 0d0
	do 100 j=dim1,dim2
	if (j.eq.dim0) goto 100
	hq(i) = hq(i) + h(i,j)*q(j)
100	continue
	qhq = q(i)*hq(i)
90	continue

	if ((pq.eq.0d0).or.(qhq.eq.0d0).or.abs(qhq).gt.1d80) then
     	   heq1 = heq1 + 1
	   goto 12
	endif

	if ((dx.lt.xacc).and.(dxold.lt.xacc*1000d0)) then
     	   heq1 = heq1 + 1
	   goto 12
	endif
	if (dxold.gt.xacc*1000d0) heq1 = 0

c 	theta = 1d0
 	theta = sin(float(n)-100d0*float(n/100))**2
c	theta = 0d0
c	theta = pq/(pq-qhq)
	if ( int(60*(float(n)/60d0+1d-8-n/60)).eq.0 ) heq1=1
	if ( int(61*(float(n)/61d0+1d-8-n/61)).eq.0 ) heq1=0

	do 110 i=dim1,dim2
	if (i.eq.dim0) goto 110
	do 120 j=dim1,i-1
	if (j.eq.dim0) goto 120
    	if ((heq1.gt.0).and.
     *	    (int(2*(float(n)/2d0+1d-8-n/2)).ne.0)) then
	   h(i,j) = 0d0
	else
	   h(i,j) = h(i,j) + (1d0+theta*qhq/pq)*p(i)*p(j)/pq
     *			- (1d0-theta)*hq(i)*hq(j)/qhq
     *			- theta*(p(i)*hq(j)+hq(i)*p(j))/pq
	endif
 	h(j,i) = h(i,j) 
120	continue

    	if ((heq1.gt.0).and.
     *	    (int(2*(float(n)/2d0+1d-8-n/2)).ne.0)) then
	   h(i,i) = 1d0
 	else
	   h(i,i) = h(i,i) + (1d0+qhq/pq)*p(i)**2/pq
     *			      - 2d0*p(i)*hq(i)/pq
	endif
110	continue

1000	format(i2,10e16.8)
c 	write(*,1000) n,(x(i),i=1,2),dx,y1
c 	write(*,*) 'gsold/gs,gs ',gsold/gs,gs
c	write(*,*) 'cos[<(g,s)]  ',gs/sqrt(g2)/sqrt(s2)
	goto 11

	end

************************************************************************
	subroutine grad(fu,x,g,dim1,dim2)
************************************************************************
*	gradient of scalar function fu(x) 			       *
*	5.12.95 SD                                                     *
************************************************************************
	implicit real*8 (a-z)
	real*8 x(10),x1(10),g(10)
	integer i,j,dim1,dim2

	external fu
	
	eps = 1d-8

	do 5 i=1,10
	x1(i) = x(i)
5 	continue

	do 10 i=dim1,dim2
	x1(i) = x(i)+eps
	yp   = fu(x1)
	x1(i) = x(i)-eps
	ym   = fu(x1)
	g(i) = (yp-ym)/2d0/eps
	x1(i) = x(i)
10	continue

	end

