************************************************************************
*
*     initialize Les Houches Accord common block (hep-ph/0109068)
*       for unweighted events
*
************************************************************************
      subroutine init_hepup()
      implicit none
      include 'COMMON/output.inc'
      include 'COMMON/param.inc'
      include 'COMMON/processpar.inc'
      integer i
      double precision mom(0:3,2),mass(2)
c Les Houches accord common block
      integer MAXNUP
      parameter (MAXNUP=500)
      integer NUP,IDPRUP,IDUP,ISTUP,MOTHUP,ICOLUP,Itest
      double precision XWGTUP,SCALUP,AQEDUP,AQCDUP,
     &                 PUP,VTIMUP,SPINUP
      common/HEPEUP/NUP,IDPRUP,XWGTUP,SCALUP,AQEDUP,AQCDUP,
     &              IDUP(MAXNUP),ISTUP(MAXNUP),MOTHUP(2,MAXNUP),
     &              ICOLUP(2,MAXNUP),PUP(5,MAXNUP),VTIMUP(MAXNUP),
     &              SPINUP(MAXNUP)

      aqedup = alpha
      aqcdup = alphas

C Final state fermion: idup(4)-idup(7)
      do i = 1,4
         istup(i+3) = +1  !particles are outgoing
         idup(i+3) = 0
         if (fname(i).eq.'dq')       idup(i+3) = 1
         if (fname(i).eq.'anti-dq')  idup(i+3) = -1
         if (fname(i).eq.'uq')       idup(i+3) = 2
         if (fname(i).eq.'anti-uq')  idup(i+3) = -2
         if (fname(i).eq.'sq')       idup(i+3) = 3
         if (fname(i).eq.'anti-sq')  idup(i+3) = -3
         if (fname(i).eq.'cq')       idup(i+3) = 4
         if (fname(i).eq.'anti-cq')  idup(i+3) = -4
         if (fname(i).eq.'e')        idup(i+3) = 11
         if (fname(i).eq.'anti-e')   idup(i+3) = -11
         if (fname(i).eq.'nue')      idup(i+3) = 12
         if (fname(i).eq.'anti-nue') idup(i+3) = -12
         if (fname(i).eq.'mu')       idup(i+3) = 13
         if (fname(i).eq.'anti-mu')  idup(i+3) = -13
         if (fname(i).eq.'num')      idup(i+3) = 14
         if (fname(i).eq.'anti-num') idup(i+3) = -14
         if (idup(i+3).eq.0) then
            write(nout,*) 'Process not supported.'
            close(nout)
	    stop
         endif
      enddo
C Final state boson in real emission events
      istup(8) = +1
      idup(8)  = 22  !photon (unweighted events for QCD not yet supported)

C Higgs as mother particle: idup(1)
      idup(1) = 25   ! Higgs
      istup(1) = 2   ! Higgs is a resonance
      MOTHUP(1,1)=0  ! no mother for Higgs
      MOTHUP(2,1)=0  ! no mother for Higgs
      pup(1,1) = 0D0 ! Higgs rest frame
      pup(2,1) = 0D0 ! Higgs rest frame
      pup(3,1) = 0D0 ! Higgs rest frame
      pup(4,1) = mh  ! Higgs rest frame
      pup(5,1) = mh  ! Higgs mass
      ICOLUP(1,1)=0  ! Higgs is colorless
      ICOLUP(2,1)=0  ! Higgs is colorless

      MOTHUP(1,2)=1  ! Higgs is mother
      MOTHUP(2,2)=1  ! Higgs is mother
      istup(2) = 2   ! Boson is a resonance
      ICOLUP(1,2)=0  ! Boson is colorless
      ICOLUP(2,2)=0  ! Boson is colorless
      MOTHUP(1,3)=1  ! Higgs is mother
      MOTHUP(2,3)=1  ! Higgs is mother
      istup(3) = 2   ! Boson is a resonance
      ICOLUP(1,3)=0  ! Boson is colorless
      ICOLUP(2,3)=0  ! Boson is colorless

      end

**************************************************************

      Subroutine set_mothers(mother,photonmother,mom,mass)
      Implicit None

      include 'COMMON/processpar.inc'

      Integer mother,photonmother,ii
      double precision p(0:3,5),mom(0:3,2),mass(2)

c Les Houches accord common block
      integer MAXNUP
      parameter (MAXNUP=500)
      integer NUP,IDPRUP,IDUP,ISTUP,MOTHUP,ICOLUP,Itest
      double precision XWGTUP,SCALUP,AQEDUP,AQCDUP,
     &                 PUP,VTIMUP,SPINUP
      common/HEPEUP/NUP,IDPRUP,XWGTUP,SCALUP,AQEDUP,AQCDUP,
     &              IDUP(MAXNUP),ISTUP(MAXNUP),MOTHUP(2,MAXNUP),
     &              ICOLUP(2,MAXNUP),PUP(5,MAXNUP),VTIMUP(MAXNUP),
     &              SPINUP(MAXNUP)

      If(mother.EQ.-1) Return

      MOTHUP(1,4)=2                               ! first fermion always has mother 2
      MOTHUP(2,4)=2                               ! first fermion always has mother 2
      If(abs(IDUP(4)).LT.10) Then
        ICOLUP(1,4)=501
      Else
        ICOLUP(1,4)=0
      Endif
      do ii=5,7
        if(ii.EQ.mother+3) then
          MOTHUP(1,ii)=2
          MOTHUP(2,ii)=2
          If(abs(IDUP(ii)).LT.10) Then
            ICOLUP(1,ii)=501
          Else
            ICOLUP(1,ii)=0
          Endif
	else
          MOTHUP(1,ii)=3
          MOTHUP(2,ii)=3
          If(abs(IDUP(ii)).LT.10) Then
            ICOLUP(1,ii)=502
          Else
            ICOLUP(1,ii)=0
          Endif
	endif
      enddo
      if(photonmother.EQ.2) Then
          MOTHUP(1,8)=2
          MOTHUP(2,8)=2
      else if(photonmother.EQ.3) Then
          MOTHUP(1,8)=3
          MOTHUP(2,8)=3
      else
          MOTHUP(1,8)=0
          MOTHUP(2,8)=0
      endif

      If(q(1).EQ.q(mother)) Then
	IDUP(2)=23                 ! Z boson
	IDUP(3)=23                 ! Z boson
      Else
	If(q(1).LT.0.OR.q(mother).LT.0) Then
	  IDUP(2)=-24              ! W- boson
	  IDUP(3)=24               ! W+ boson
        Else
	  IDUP(2)=24               ! W+ boson
	  IDUP(3)=-24              ! W- boson
	Endif
      Endif

      pup(1,2) = mom(1,1)
      pup(2,2) = mom(2,1)
      pup(3,2) = mom(3,1)
      pup(4,2) = mom(0,1)
      pup(5,2) = mass(1)
      pup(1,3) = mom(1,2)
      pup(2,3) = mom(2,2)
      pup(3,3) = mom(3,2)
      pup(4,3) = mom(0,2)
      pup(5,3) = mass(2)

      End

**************************************************************

      Subroutine find_mother_and_helicities(nw,evprop,mother
     &                    ,helicity,random,weight,nweight,resonancesinlhe)
      Implicit None

      include 'COMMON/output.inc'
      include 'COMMON/param.inc'
      include 'COMMON/processpar.inc'

      integer iNumProcs, iErr, iMyRank
      common/mpistuff/iNumProcs,iMyRank

      integer ii,jj,nw,i1,i2,i3,i4,evprop,perm,nweight,resonancesinlhe
      real*8 random,weight

      real*8 M2B_dg_hel(-1:1,-1:1,-1:1,-1:1)
      real*8 M2B_dg42_hel(-1:1,-1:1,-1:1,-1:1)
      real*8 M2B_ndg_hel(-1:1,-1:1,-1:1,-1:1)
      common/m2bornhel/M2B_dg_hel,M2B_dg42_hel,M2B_ndg_hel
      real*8 M2vEW_dg_hel(-1:1,-1:1,-1:1,-1:1)
      real*8 M2vEW_dg42_hel(-1:1,-1:1,-1:1,-1:1)
      real*8 M2vEW_ndg_hel(-1:1,-1:1,-1:1,-1:1)
      common/m2vEWhel/M2vEW_dg_hel,M2vEW_dg42_hel,M2vEW_ndg_hel
      real*8 abbr1,abbr2
      real*8 M2ncs_dg_hel(4,-1:1,-1:1,-1:1,-1:1)
      real*8 M2ncs_dg42_hel(4,-1:1,-1:1,-1:1,-1:1)
      real*8 M2ncs_ndg_hel(4,-1:1,-1:1,-1:1,-1:1)
      common/m2ncshel/M2ncs_dg_hel,M2ncs_dg42_hel,M2ncs_ndg_hel
      real*8 M2r_dg_hel(-1:1,-1:1,-1:1,-1:1,-1:1)
      real*8 M2r_dg42_hel(-1:1,-1:1,-1:1,-1:1,-1:1)
      real*8 M2r_ndg_hel(-1:1,-1:1,-1:1,-1:1,-1:1)
      common/m2realhel/M2r_dg_hel,M2r_dg42_hel,M2r_ndg_hel
      real*8 tot,findhel
      real*8 hel(-1:1,-1:1,-1:1,-1:1)
      real*8 hel_dg(-1:1,-1:1,-1:1,-1:1)
      real*8 hel_dg42(-1:1,-1:1,-1:1,-1:1)
      real*8 hel_ndg(-1:1,-1:1,-1:1,-1:1)
      real*8 hel_tot(-1:1,-1:1,-1:1,-1:1)
      integer mother,helicity(4),problem,firstproblem

      real*8 weightfac(2)
      common/weightfac_common/weightfac

      save firstproblem

      if (fname(1).eq.fname(3)) then
        perm=1
      else
        perm=0
      endif

      if(cc.eq.1)then
        if(nc.eq.1) then
	  mother=4
	else
	  mother=2
	endif
      else
        if(perm.eq.1) then
	  mother=4
	else
	  mother=2
	endif
      endif


      tot=0D0

      do i1 = -1,1,2
      do i2 = -1,1,2
      do i3 = -1,1,2
      do i4 = -1,1,2
      if(nw.EQ.1) then
	  hel_dg(i1,i2,i3,i4)=M2B_dg_hel(i1,i2,i3,i4)
          if(mother.ne.2) then
	    hel_dg42(i1,i2,i3,i4)=M2B_dg42_hel(i1,i2,i3,i4)
            hel_ndg(i1,i2,i3,i4)=M2B_ndg_hel(i1,i2,i3,i4)
	  endif
	  if(evprop.GE.0) then
            hel_dg(i1,i2,i3,i4)=hel_dg(i1,i2,i3,i4)+
     &                          M2vEW_dg_hel(i1,i2,i3,i4)
            if(mother.ne.2) then
              hel_dg42(i1,i2,i3,i4)=hel_dg42(i1,i2,i3,i4)+
     &                            M2vEW_dg42_hel(i1,i2,i3,i4)
              hel_ndg(i1,i2,i3,i4)=hel_ndg(i1,i2,i3,i4)+
     &                            M2vEW_ndg_hel(i1,i2,i3,i4)
	    endif
	  endif
      else if(nw.EQ.4.OR.nw.EQ.5.OR.nw.EQ.6.OR.nw.EQ.7) then
	  hel_dg(i1,i2,i3,i4)=M2ncs_dg_hel(nw-3,i1,i2,i3,i4)
          if(mother.ne.2) then
            hel_dg42(i1,i2,i3,i4)=M2ncs_dg42_hel(nw-3,i1,i2,i3,i4)
            hel_ndg(i1,i2,i3,i4)=M2ncs_ndg_hel(nw-3,i1,i2,i3,i4)
          endif
      else if(nw.EQ.23) then
          hel_dg(i1,i2,i3,i4)=M2r_dg_hel(i1,i2,i3,i4,-1)+
     &                        M2r_dg_hel(i1,i2,i3,i4,1)
          if(mother.ne.2) then
            hel_dg42(i1,i2,i3,i4)=M2r_dg42_hel(i1,i2,i3,i4,-1)+
     &                            M2r_dg42_hel(i1,i2,i3,i4,1)
            hel_ndg(i1,i2,i3,i4)=M2r_ndg_hel(i1,i2,i3,i4,-1)+
     &                           M2r_ndg_hel(i1,i2,i3,i4,1)
          endif
      endif
      hel_tot(i1,i2,i3,i4)=hel_dg(i1,i2,i3,i4)
      if(mother.ne.2) then
        hel_tot(i1,i2,i3,i4)=hel_dg(i1,i2,i3,i4)+
     &                       hel_dg42(i1,i2,i3,i4)+
     &                       hel_ndg(i1,i2,i3,i4)
      endif
      tot=tot+hel_tot(i1,i2,i3,i4)
      enddo
      enddo
      enddo
      enddo

      problem=0
      If(nw.EQ.23) then
        If(abs(tot/(weight/weightfac(2)/nweight)-1D0).GT.1D-12) then
C          If(firstproblem.NE.1) then
	   If(resonancesinlhe.eq.1) Then  
	    If(iMyRank.EQ.0) then
	      Write(nout,*) 'problems with finding helicities/mothers: no output in *.lhe'
	      Write(nout2,*) 'problems with finding helicities/mothers: no output in *.lhe'
            Endif
	    firstproblem=1
	  Endif
C	  Endif
	  problem=1
	Endif
      else
        If(abs(tot/(weight/weightfac(1)/nweight)-1D0).GT.1D-12) then
C          If(firstproblem.NE.1) then
	  If(resonancesinlhe.eq.1) Then  
	    If(iMyRank.EQ.0) then
	      Write(nout,*) 'problems with finding helicities/mothers: no output in *.lhe'
	      Write(nout2,*) 'problems with finding helicities/mothers: no output in *.lhe'
            Endif
	    firstproblem=1
          Endif
C	  Endif          
          problem=1
	Endif
      endif
      helicity(1)=9
      helicity(2)=9
      helicity(3)=9
      helicity(4)=9
      If(problem.eq.0) then
        findhel=0D0
        do i1 = -1,1,2
        do i2 = -1,1,2
        do i3 = -1,1,2
        do i4 = -1,1,2
          findhel=findhel+hel_tot(i1,i2,i3,i4)
          if(findhel.GE.random*tot) then
	    helicity(1)=i1
	    helicity(2)=i2
	    helicity(3)=i3
	    helicity(4)=i4
            if(mother.ne.2) then
	      findhel=findhel+hel_tot(i1,i2,i3,i4)*
     &                 (-1D0+hel_dg(i1,i2,i3,i4)/
     &                 (hel_dg(i1,i2,i3,i4)+hel_dg42(i1,i2,i3,i4)))
              if(findhel.GE.random*tot) then
	        mother=2
	      endif
	    endif
	    goto 99
	  endif
        enddo
        enddo
        enddo
        enddo
      else
        mother=-1
      endif

 99   continue

      End


**************************************************************

      Subroutine find_photonmother(p,mother,photonmother,nw)
      Implicit None

      double precision p(0:3,5),inv(4),min
      integer mother,photonmother,nw,ii

      photonmother=0
      if(nw.EQ.4.OR.nw.EQ.3+mother) then
        photonmother=2
      else if(nw.EQ.5.OR.nw.EQ.6.OR.nw.EQ.7.) then
        photonmother=3
      endif

      if(nw.EQ.23) then
        photonmother=2
	do ii=1,4
	  inv(ii)=(p(0,ii)+p(0,5))**2-(p(1,ii)+p(0,5))**2-
     &            (p(2,ii)+p(0,5))**2-(p(3,ii)+p(0,5))**2
	  If(ii.eq.1) min=inv(1)
	  If(ii.GE.2.AND.inv(ii).LT.min) Then
	     min=inv(ii)
	     If(ii.EQ.mother) then
	       photonmother=2
	     Else
	       photonmother=3
	     Endif
	  Endif
	enddo
      endif

      End

**************************************************************

      Subroutine find_vb_momenta(i1,i2,photonmother,p,mom,mass)
      Implicit None

      Integer i1,i2,photonmother,ii,jj
      double precision p(0:3,5),mom(0:3,2),mass(2)

      do ii=0,3
	mom(ii,1)=0D0
	mom(ii,2)=0D0
        do jj=1,4
	  If(i1.EQ.jj.OR.i2.EQ.jj) Then
	    mom(ii,1)=mom(ii,1)+p(ii,jj)
	  Else
	    mom(ii,2)=mom(ii,2)+p(ii,jj)
	  Endif
	enddo
      enddo

      If(photonmother.EQ.2) Then
        do ii=0,3
	  mom(ii,1)=mom(ii,1)+p(ii,5)
        enddo
      Else If(photonmother.EQ.3) Then
        do ii=0,3
	  mom(ii,2)=mom(ii,2)+p(ii,5)
        enddo
      Endif

      mass(1)=sqrt(abs(mom(0,1)**2-mom(1,1)**2-
     &                 mom(2,1)**2-mom(3,1)**2))
      mass(2)=sqrt(abs(mom(0,2)**2-mom(1,2)**2-
     &                 mom(2,2)**2-mom(3,2)**2))

      end

**************************************************************
*
*     output of unweighted events
*
*         p:momentum(Lorentz index;fermion 1..4+photon/gluon)
*         evprop:0=only fermions, 1=photon event, 2=gluon event
*         weight: +/- integrated decay width
*
**************************************************************
      subroutine unweighted_output(p,evprop,weight,nw,random,we,nweight)
      implicit none

      include 'COMMON/param.inc'
      include 'COMMON/processpar.inc'
      include 'COMMON/options.inc'

      integer outch,evprop,i,nw,mother,helicity(4),nweight
      integer photonmother
      real*8 p(0:3,5),ip(0:3,2),weight,random,we
      real*8 mom(0:3,2,2),mass(2,2)
c Les Houches accord common block
      integer MAXNUP
      parameter (MAXNUP=500)
      integer NUP,IDPRUP,IDUP,ISTUP,MOTHUP,ICOLUP
      integer IVTIMUP(MAXNUP),ISPINUP(MAXNUP),ISCALUP
      double precision XWGTUP,SCALUP,AQEDUP,AQCDUP,
     &                 PUP,VTIMUP,SPINUP
      common/HEPEUP/NUP,IDPRUP,XWGTUP,SCALUP,AQEDUP,AQCDUP,
     &              IDUP(MAXNUP),ISTUP(MAXNUP),MOTHUP(2,MAXNUP),
     &              ICOLUP(2,MAXNUP),PUP(5,MAXNUP),VTIMUP(MAXNUP),
     &              SPINUP(MAXNUP)

      xwgtup = sign(1D0,weight)

      call find_mother_and_helicities(nw,evprop,mother,
     &                                helicity,random,we,nweight,resonancesinlhe)

      call find_photonmother(p,mother,photonmother,nw)

      call find_vb_momenta(1,mother,photonmother,p,mom(0,1,1),mass(1,1))

      call set_mothers(mother,photonmother,mom(0,1,1),mass(1,1))

      IVTIMUP(1)=0
      ISPINUP(1)=9
      IVTIMUP(2)=0
      ISPINUP(2)=9
      IVTIMUP(3)=0
      ISPINUP(3)=9
      IVTIMUP(8)=0
      ISPINUP(8)=9

      do i = 1,5
         pup(1,i+3) = p(1,i)
         pup(2,i+3) = p(2,i)
         pup(3,i+3) = p(3,i)
         pup(4,i+3) = p(0,i)
         pup(5,i+3) = 0d0
      enddo
      do i = 1,4
	 IVTIMUP(i+3)=0
	 ISPINUP(i+3)=helicity(i)
      enddo

      if (evprop.eq.0 .or. evprop.eq.-1) then
         nup = 7      !4 final state particles
      else
         nup = 8      !4 fermions + photon
      endif

      if (evprop.eq.-1) then
        outch=27
      else
        outch=26
      endif

      IDPRUP=1
      ISCALUP=-1

      if(resonancesinlhe.EQ.0) then
        mother=-1
        do i=4,nup
	  ISPINUP(i)=9
	  MOTHUP(1,i)=0
	  MOTHUP(2,i)=0
	  ICOLUP(1,i)=0
	enddo
      endif

      if(mother.EQ.-1) then
        nup=nup-3
      endif

      write(outch,12) '<event>'
      write(outch,11) nup,IDPRUP,XWGTUP,ISCALUP,AQEDUP,AQCDUP
      if(mother.NE.-1) then
        do i =1,nup
          write(outch,10) IDUP(i),ISTUP(i),MOTHUP(1,i),MOTHUP(2,i),
     &                 ICOLUP(1,i),ICOLUP(1,i),
     &                 pup(1,i),pup(2,i),pup(3,i),pup(4,i),pup(5,i),
     &                 IVTIMUP(i),ISPINUP(i)
        enddo
      else
        do i =4,nup+3
          write(outch,10) IDUP(i),ISTUP(i),MOTHUP(1,i),MOTHUP(2,i),
     &                 ICOLUP(1,i),ICOLUP(1,i),
     &                 pup(1,i),pup(2,i),pup(3,i),pup(4,i),pup(5,i),
     &                 IVTIMUP(i),ISPINUP(i)
        enddo
      endif
      write(outch,13) '</event>'

 10   format(I9,' ',I3,' ',I3,' ',I3,' ',I3,' ',I3,' ',
     &       5(E22.15,' '),' ',I3,' ',I3)
 11   format(I3,' ',I3,' ',E22.15,' ',I3,' ',E22.15,' ',E22.15)
 12   format(A7)
 13   format(A8)
      end

************************************************************************
*
* Write intro to lhe event file
*
************************************************************************
      Subroutine write_lhe_file_intro(average,sigma,maxweight)
      Implicit None

      include 'COMMON/output.inc'

      double precision average,sigma,maxweight

      integer iNumProcs, iErr, iMyRank,proccount,i2,ii
      integer event_number_unw
      common/mpistuff/iNumProcs,iMyRank

c for output file of unweighted events
      integer length,startpos,outch,fehler
      character*90 name,rankstring
      character*90 outputfile
      common/outputfile/outputfile

      integer MAXPUP
      integer IDBMUP,PDFGUP,PDFSUP,IDWTUP,NPRUP,LPRUP
      integer IEBMUP(2)
      double precision  EBMUP,XSECUP,XERRUP,XMAXUP
      parameter ( MAXPUP=100 )
      common/HEPRUP/ IDBMUP(2),EBMUP(2),PDFGUP(2),PDFSUP(2),
     &               IDWTUP,NPRUP,XSECUP(MAXPUP),XERRUP(MAXPUP),
     &               XMAXUP(MAXPUP),LPRUP(MAXPUP)

C#ifdef mpiuse
      Write(rankstring,*) iMyRank
      name='UNWEIGHTEDEVENTS/'//outputfile(1:length(outputfile))//'_unweighted'//
     &     rankstring(startpos(rankstring):length(rankstring))//'.lhe'
      open(unit=26,file=name,status='unknown',iostat=fehler)
      if (fehler.ne.0) then
         write(nout,*)'Cannot open ',name
         write(nout,*)'Please create directory.'
         close(nout)
	 stop
      endif
      name='UNWEIGHTEDEVENTS/'//outputfile(1:length(outputfile))//'_unweighted'//
     &     rankstring(startpos(rankstring):length(rankstring))//'_born.lhe'
      open(unit=27,file=name,status='unknown')
C#else
C      name=outputfile(1:length(outputfile))//'_unweighted.lhe'
C      open(unit=26,file=name,status='unknown')
C      name=outputfile(1:length(outputfile))//'_unweighted_born.lhe'
C      open(unit=27,file=name,status='unknown')
C#endif

C beam and pdf information does not apply
      IDBMUP(1)=-1
      IDBMUP(2)=-1
      PDFGUP(1)=-1
      PDFGUP(2)=-1
      PDFSUP(1)=-1
      PDFSUP(2)=-1
      IEBMUP(1)=-1
      IEBMUP(2)=-1
C partial width and error
      XSECUP(1)=average
      XERRUP(1)=sigma
      XMAXUP(1)=maxweight
C only one partial width per file
      NPRUP=1
      LPRUP(1)=1
C unweighted events
      IDWTUP=3

      do outch=26,27
      write(outch,12) '<init>'
      write(outch,10) IDBMUP(1),IDBMUP(2),IEBMUP(1),IEBMUP(1),
     &             PDFGUP(1),PDFGUP(2),PDFSUP(2),PDFSUP(2),
     &             IDWTUP,NPRUP
      write(outch,11) XSECUP(1),XERRUP(1),XMAXUP(1),LPRUP(1)
      write(outch,13) '</init>'
      enddo

 10   format(10(I3,' '))
 11   format(3(E22.15,' '),I3)
 12   format(A6)
 13   format(A7)

      End

*******************************************************************

      Subroutine write_header()
      Implicit None

      include 'COMMON/output.inc'

      integer iNumProcs, iErr, iMyRank,proccount, i2, ii,jj
      common/mpistuff/iNumProcs,iMyRank

      integer startpos,length
      character*200 name
      character*153 line,rankstring,intro(8)
      character*100 outputfileline
      character*90 outputfile
      common/outputfile/outputfile
      character*90 keep_outputfile
      common/keep_outputfile/keep_outputfile
      character*90 scratchoutputfile
      common/scratchoutputfile/scratchoutputfile

      If(iMyRank.EQ.0) Then
        name='UNWEIGHTEDEVENTS/'//outputfile(1:length(outputfile))//
     &       '_unweighted.lhe'
        open(unit=28,file=name,status='unknown')
        name='UNWEIGHTEDEVENTS/'//outputfile(1:length(outputfile))//
     &       '_unweighted_born.lhe'
        open(unit=29,file=name,status='unknown')
	write(28,'((a))') '<LesHouchesEvents>'
	write(29,'((a))') '<LesHouchesEvents>'

	close(nout2)
	open(unit=nout2,file=scratchoutputfile)
	ii=0
	do while(.true.)
	  ii=ii+1
	  read(nout2,'((a))',end=55,err=56) outputfileline
	  if(ii.LE.8) write(intro(ii),*) outputfileline
	  if(outputfileline(1:9).EQ.' Process:') then
	    close(28)
	    close(29)
            name='UNWEIGHTEDEVENTS/'//outputfile(1:length(outputfile))//
     &  	 '_unweighted.lhe'
            open(unit=28,file=name,status='unknown')
            name='UNWEIGHTEDEVENTS/'//outputfile(1:length(outputfile))//
     &  	 '_unweighted_born.lhe'
            open(unit=29,file=name,status='unknown')
	    write(28,'((a))') '<LesHouchesEvents>'
	    write(28,'((a))') '<header>'
	    write(29,'((a))') '<LesHouchesEvents>'
	    write(29,'((a))') '<header>'
	    do jj=1,8
	      write(28,'((a))') intro(jj)
	      write(29,'((a))') intro(jj)
	    enddo
	  endif
	  write(28,'((a))') outputfileline
	  write(29,'((a))') outputfileline
	enddo
 55     continue
 56     continue
	write(28,'((a))') '</header>'
	write(29,'((a))') '</header>'
	close(nout2)
	open(unit=nout2,file=scratchoutputfile,
     &  		      status='unknown',access='append')

	do i2=0,iNumProcs-1
           Write(rankstring,*) i2
           name='UNWEIGHTEDEVENTS/'//outputfile(1:length(outputfile))//'_unweighted'//
     &          rankstring(startpos(rankstring):length(rankstring))//'.lhe'
           open(unit=26,file=name,status='unknown')
           name='UNWEIGHTEDEVENTS/'//outputfile(1:length(outputfile))//'_unweighted'//
     &          rankstring(startpos(rankstring):length(rankstring))//'_born.lhe'
           open(unit=27,file=name,status='unknown')

	   ii=0
	   do while(.true.)
	     ii=ii+1
	     read(26,'((a))',end=51,err=52) line
	     if(ii.GT.4.or.i2.eq.0) then
	       write(28,'((a))') line
	     endif
	   enddo
 51        continue
 52        continue
	   ii=0
	   do while(.true.)
	     ii=ii+1
	     read(27,'((a))',end=53,err=54) line
	     if(ii.GT.4.or.i2.eq.0) then
	       write(29,'((a))') line
	     endif
	   enddo
 53        continue
 54        continue

	   close(26,Status='Delete')
	   close(27,Status='Delete')
	enddo
	write(28,'((a))') '</LesHouchesEvents>'
	write(29,'((a))') '</LesHouchesEvents>'
        close(28)
	close(29)
      Endif

      End

************************************************************************
*
* close lhe event file
*
************************************************************************
      subroutine close_lhe_file()
      implicit none

      close(26)
      close(27)

      end


************************************************************************
*
*     definition of histograms
*
*  input:
*  ------
*  weight        : weight of subevent
*  outmom(0:3,5) : four-momenta of outgoing particles
*  steps=1: initialization
*  steps=2: start filling histograms
*  steps=3: finish filling of histograms
*  steps=4: print data for histograms
*
************************************************************************
      subroutine create_histo(weight,outmom,step,unweighted)
      implicit none
      real*8 weight,outmom(0:3,5),boostmom(0:3,4)
      integer step,i1,i2,i3,length,num,unweighted,nevt,nevtb
      integer coltype
      real*8 s(5,5),kp(0:3),km(0:3),kpvec,kmvec,pvec(5),boostvec(4)
      real*8 energy,x,q1(0:3),q2(0:3),q3(0:3),denum,en(4),entr(4)
      character*100 name
      character*25 dir
      include 'COMMON/options.inc'
      include 'COMMON/param.inc'
      include 'COMMON/processpar.inc'
      include 'COMMON/output.inc'
c outputfile
      character*90 outputfile
      common/outputfile/outputfile

      if (qhist.eq.0) return
      if (weight.eq.0d0.and.step.eq.2) return

      if (step.eq.1) then
        do i1=0,3
        do i2=1,5
          outmom(i1,i2) = 0d0
        enddo
        enddo
      endif
      if (unweighted.eq.0) then
         dir='HISTOGRAMS/'
         nevt=nevents
         nevtb=nevents
      else
         dir='HISTUNWEIGHTED/'
         nevt  = genunwev - 2*negev
         nevtb = genunwbornev
      endif
      energy = mh     !Higgs mass
      num = 0         !number of distribution
c calculation of sum of pairs of momenta and the
c according invariant masses squared:
      do i1=1,5
      do i2=i1+1,5
        do i3=0,3
          q1(i3)=outmom(i3,i1)+outmom(i3,i2)
        enddo
        s(i1,i2)=q1(0)*q1(0)-q1(1)*q1(1)-q1(2)*q1(2)-q1(3)*q1(3)
        s(i2,i1)=s(i1,i2)
      enddo
      enddo
c calculation of the W+ and W- momenta:
      do i1=0,3
        kp(i1)=outmom(i1,1)+outmom(i1,2)
        km(i1)=outmom(i1,3)+outmom(i1,4)
      enddo
      kpvec=dsqrt(kp(1)*kp(1)+kp(2)*kp(2)+kp(3)*kp(3))
      kmvec=dsqrt(km(1)*km(1)+km(2)*km(2)+km(3)*km(3))
      do i1=1,5
        pvec(i1)=dsqrt(outmom(1,i1)**2+outmom(2,i1)**2+outmom(3,i1)**2)
      enddo
c type of process, used to selectively switch of histograms
c 0 = leptonic,  1 = semileptonic,  2 = hadronic
      coltype = quark(1) + quark(3)

c no histograms for hadronic processes
      if (coltype.eq.2 .and. debug.eq.0) then
         return
      endif

c invariant mass distributions
      name=dir(1:length(dir))//outputfile(1:length(outputfile))
     &     //'.inv12.7585'
      num = num+1
      call histogram(75d0,85d0,dsqrt(s(1,2)),weight,num,nevt,nevtb,name,50
     &     ,step)
      name=dir(1:length(dir))//outputfile(1:length(outputfile))
     &     //'.inv34.7585'
      num = num+1
      call histogram(75d0,85d0,dsqrt(s(3,4)),weight,num,nevt,nevtb,name,50
     &     ,step)
      name=dir(1:length(dir))//outputfile(1:length(outputfile))
     &     //'.inv12.5090'
      num = num+1
      call histogram(50d0,90d0,dsqrt(s(1,2)),weight,num,nevt,nevtb,name,50
     &     ,step)
      name=dir(1:length(dir))//outputfile(1:length(outputfile))
     &     //'.inv34.5090'
      num = num+1
      call histogram(50d0,90d0,dsqrt(s(3,4)),weight,num,nevt,nevtb,name,50
     &     ,step)
      name=dir(1:length(dir))//outputfile(1:length(outputfile))
     &     //'.inv12.8595'
      num = num+1
      call histogram(85d0,95d0,dsqrt(s(1,2)),weight,num,nevt,nevtb,name,50
     &     ,step)
      name=dir(1:length(dir))//outputfile(1:length(outputfile))
     &     //'.inv34.8595'
      num = num+1
      call histogram(85d0,95d0,dsqrt(s(3,4)),weight,num,nevt,nevtb,name,50
     &     ,step)
      name=dir(1:length(dir))//outputfile(1:length(outputfile))
     &     //'.inv12.60100'
      num = num+1
      call histogram(60d0,100d0,dsqrt(s(1,2)),weight,num,nevt,nevtb,name,50
     &     ,step)
      name=dir(1:length(dir))//outputfile(1:length(outputfile))
     &     //'.inv34.60100'
      num = num+1
      call histogram(60d0,100d0,dsqrt(s(3,4)),weight,num,nevt,nevtb,name,50
     &     ,step)

c decay angle distribution of f3 in rest frame of km(f3+f4)
      if (coltype .eq. 0) then
      call boostrestframe(km,outmom(0,3),boostmom(0,3))
      boostvec(3)=dsqrt( boostmom(1,3)**2+boostmom(2,3)**2
     &                  +boostmom(3,3)**2)
      x = 2d0 ! events that are screwed up are sorted in non-existing bin
      if (kmvec*boostvec(3).gt.0d0)
     &  x = (km(1)*boostmom(1,3)+km(2)*boostmom(2,3)
     &       +km(3)*boostmom(3,3))/kmvec/boostvec(3)
      name=dir(1:length(dir))//outputfile(1:length(outputfile))
     &     //'.cthv2f3'
      num = num+1
      call histogram(-1d0,1d0,x,weight,num,nevt,nevtb,name,50,step)
      endif

c angle between decay planes (called in phi' in publication)
c cos(phi) = (k_12 x k_1) (k_12 x k_3)/   k_12 -> k_1 + k_2
c            |k_12 x k_1| |k_12 x k_3)|
c sgn(sin(phi)) = sgn(k_12*((k_12 x k_1) x (k_12 x k_3)))
      if (coltype .eq. 0) then
      q1(1)=kp(2)*outmom(3,1)-kp(3)*outmom(2,1)
      q1(2)=kp(3)*outmom(1,1)-kp(1)*outmom(3,1)
      q1(3)=kp(1)*outmom(2,1)-kp(2)*outmom(1,1)
      q2(1)=kp(2)*outmom(3,3)-kp(3)*outmom(2,3)
      q2(2)=kp(3)*outmom(1,3)-kp(1)*outmom(3,3)
      q2(3)=kp(1)*outmom(2,3)-kp(2)*outmom(1,3)
      denum=dsqrt(q1(1)**2+q1(2)**2+q1(3)**2)
     &     *dsqrt(q2(1)**2+q2(2)**2+q2(3)**2)
      x=-1d0
      if(denum.ne.0d0)then
        x=(q1(1)*q2(1)+q1(2)*q2(2)+q1(3)*q2(3))/denum
        if(dabs(x).le.1d0)then
          x=dacos(x)*180d0/pi
          q3(1)=q1(2)*q2(3)-q1(3)*q2(2)
          q3(2)=q1(3)*q2(1)-q1(1)*q2(3)
          q3(3)=q1(1)*q2(2)-q1(2)*q2(1)
          if((kp(1)*q3(1)+kp(2)*q3(2)+kp(3)*q3(3)).lt.0d0)x=360d0-x
        else
          x=-1d0
        endif
      endif
      name=dir(1:length(dir))//outputfile(1:length(outputfile))//'.phi'
      num = num+1
      call histogram(0d0,360d0,x,weight,num,nevt,nevtb,name,50,step)
      endif

c angle between decay planes (H->uu(dd)ee)
c |cos phi| = |(k_12 x k_1) (k_12 x k_3)|/    (k_12->qq)
c              |k_12 x k_1| |k_12 x k_3)|
      if (coltype .eq. 1) then
      q1(1)=kp(2)*outmom(3,1)-kp(3)*outmom(2,1)
      q1(2)=kp(3)*outmom(1,1)-kp(1)*outmom(3,1)
      q1(3)=kp(1)*outmom(2,1)-kp(2)*outmom(1,1)
      q2(1)=kp(2)*outmom(3,3)-kp(3)*outmom(2,3)
      q2(2)=kp(3)*outmom(1,3)-kp(1)*outmom(3,3)
      q2(3)=kp(1)*outmom(2,3)-kp(2)*outmom(1,3)
      denum=dsqrt(q1(1)**2+q1(2)**2+q1(3)**2)
     &     *dsqrt(q2(1)**2+q2(2)**2+q2(3)**2)
      x=-2d0
      if(denum.ne.0d0)then
        x=dabs(q1(1)*q2(1)+q1(2)*q2(2)+q1(3)*q2(3))/denum
        if (dabs(x).gt.1d0) x=-2d0
      endif
      name=dir(1:length(dir))//outputfile(1:length(outputfile))
     &     //'.cphihad'
      num = num+1
      call histogram(0d0,1d0,x,weight,num,nevt,nevtb,name,50,step)
      endif

c angle between W(34) and e(2) for H -> nu e q q
      denum = kmvec*pvec(2)
      if (denum.ne.0d0) then
        x = (km(1)*outmom(1,2)+km(2)*outmom(2,2)+km(3)*outmom(3,2))
     &        /denum
      endif
      name=dir(1:length(dir))//outputfile(1:length(outputfile))
     &     //'.cthv2f2'
      num = num+1
      call histogram(-1d0,1d0,x,weight,num,nevt,nevtb,name,50,step)

c angle between fermion 1 and 3
      if (coltype .eq. 0) then
      en(1) = dsqrt(outmom(1,1)**2+outmom(2,1)**2+outmom(3,1)**2)
      en(3) = dsqrt(outmom(1,3)**2+outmom(2,3)**2+outmom(3,3)**2)
      denum = en(1)*en(3)
      x = -10d0
      if (denum.ne.0d0) then
        x = (outmom(1,1)*outmom(1,3)+outmom(2,1)*outmom(2,3)
     &      +outmom(3,1)*outmom(3,3))/denum
      endif
      name=dir(1:length(dir))//outputfile(1:length(outputfile))
     &     //'.cthf1f3'
      num = num+1
      call histogram(-1d0,1d0,x,weight,num,nevt,nevtb,name,50,step)
      endif

c angle between transverse part of fermion 2 and 3
      if (coltype .eq. 0) then
      entr(2) = dsqrt(outmom(1,2)**2+outmom(2,2)**2)
      entr(3) = dsqrt(outmom(1,3)**2+outmom(2,3)**2)
      denum = entr(2)*entr(3)
      x = -1d0
      if (denum.ne.0d0) then
        x = (outmom(1,2)*outmom(1,3)+outmom(2,2)*outmom(2,3))/denum
        if(dabs(x).le.1d0)then
          x = dacos(x)*180d0/pi
          if ((outmom(1,2)*outmom(2,3)-outmom(2,2)*outmom(1,3)).lt.0d0)
     &         x = 360d0-x
        else
          x = -1d0
        endif
      endif
      name=dir(1:length(dir))//outputfile(1:length(outputfile))
     &     //'.phitrf2f3'
      num = num+1
      call histogram(0d0,360d0,x,weight,num,nevt,nevtb,name,50,step)
      endif

      end

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c                                                                 c
c     histogram routine                                           c
c     Markus Roth, 11. August 2000, modified by Axel              c
c                                                                 c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine histogram(min,max,x,y,histo,n,nb,name,parts,step)
      implicit none

#ifdef mpiuse
      include "mpif.h"
      integer status(MPI_STATUS_SIZE)
#endif
      integer iNumProcs,iMyRank,iErr
      common/mpistuff/iNumProcs,iMyRank

      include 'COMMON/output.inc'
      include 'COMMON/max.inc'
      real*8 keep_average(maxh,maxp),keep_sigma(maxh,maxp)
      real*8 keep_avborn(maxh,maxp),keep_siborn(maxh,maxp)
      real*8 average(maxh,maxp),sigma(maxh,maxp),ysum(maxh,maxp)
      real*8 avborn(maxh,maxp),siborn(maxh,maxp)
      real*8 min,max,x,y,av,si,avb,sib,shift,pos
      integer i,isum(maxh,maxp),imax(maxh),rhs
      integer i1,i2,histo,parts,n,nb,nn,nnb,hiout,step,fehler
      character*100 name
      save average,sigma,ysum,isum,imax,avborn,siborn
c smearing
      integer smear
      real*8 smrat
      common/smearing/smrat,smear
c unweighting
      integer unweighting,wflag(maxw)
      common/unweighting/unweighting,wflag
      integer ini,do_unweighted_progress_output
c initialization
      if(step.eq.1)then
        hiout=25
        open(unit=hiout,file=name,status='unknown',iostat=fehler)
        if (fehler.ne.0) then
           write(nout,*)'Cannot open ',name
           write(nout,*)'Please create directory.'
           close(nout)
	   stop
        endif
        close(hiout)
        do i1=1,maxh
          imax(i1)=0
          do i2=1,maxp
            ysum(i1,i2)=0d0
            average(i1,i2)=0d0
            sigma(i1,i2)=0d0
            avborn(i1,i2)=0d0
            siborn(i1,i2)=0d0
            isum(i1,i2)=0
          enddo
        enddo
      endif
c input of single subevents
      if(step.eq.2)then
        if(x.ge.min.and.x.lt.max)then
          i=int((x-min)/(max-min)*parts)+1
          imax(histo)=imax(histo)+1   !# of contributing subevents
          isum(histo,imax(histo))=i   !# of bin for subevent
          if (smear.eq.0) then
            ysum(histo,i)=y+ysum(histo,i)
          elseif (smear.eq.1) then
            pos = (x-min)/(max-min)*parts - (i-1)
            if (pos.lt.smrat/2d0.and.i.ne.1) then
              ysum(histo,i)=(0.5d0+pos/smrat)*y+ysum(histo,i)
              ysum(histo,i-1)=(0.5d0-pos/smrat)*y+ysum(histo,i-1)
            elseif (pos.gt.(1d0-smrat/2d0).and.i.ne.parts) then
              ysum(histo,i)=(0.5d0+(1d0-pos)/smrat)*y+ysum(histo,i)
              ysum(histo,i+1)=(0.5d0-(1d0-pos)/smrat)*y+ysum(histo,i+1)
            else
              ysum(histo,i)=y+ysum(histo,i)
            endif
          endif
        endif
c input born event and final calculation of whole event
      elseif(step.eq.3)then
        if(x.ge.min.and.x.lt.max)then
          i=int((x-min)/(max-min)*parts)+1
          if (smear.eq.0) then
            avborn(histo,i)=y+avborn(histo,i)
            siborn(histo,i)=y*y+siborn(histo,i)
          elseif (smear.eq.1) then
            pos = (x-min)/(max-min)*parts - (i-1)
            if (pos.lt.smrat/2d0.and.i.ne.1) then
              avborn(histo,i)=(0.5d0+pos/smrat)*y+avborn(histo,i)
              avborn(histo,i-1)=(0.5d0-pos/smrat)*y+avborn(histo,i-1)
              siborn(histo,i)=(0.5d0+pos/smrat)*y*y+siborn(histo,i)
              siborn(histo,i-1)=(0.5d0-pos/smrat)*y*y+siborn(histo,i-1)
            elseif (pos.gt.(1d0-smrat/2d0).and.i.ne.parts) then
              avborn(histo,i)=(0.5d0+(1d0-pos)/smrat)*y
     &                          +avborn(histo,i)
              avborn(histo,i+1)=(0.5d0-(1d0-pos)/smrat)*y
     &                          +avborn(histo,i+1)
              siborn(histo,i)=(0.5d0+(1d0-pos)/smrat)*y*y
     &                          +siborn(histo,i)
              siborn(histo,i+1)=(0.5d0-(1d0-pos)/smrat)*y*y
     &                          +siborn(histo,i+1)
            else
              avborn(histo,i)=y+avborn(histo,i)
              siborn(histo,i)=y*y+siborn(histo,i)
            endif
          endif
        endif
        if(imax(histo).ge.1)then
          do i1=1,imax(histo)
            i=isum(histo,i1)
            average(histo,i)=ysum(histo,i)+average(histo,i)
            sigma(histo,i)=ysum(histo,i)*ysum(histo,i)+sigma(histo,i)
            ysum(histo,i)=0d0
            if (smear.eq.1) then
              if (i.ne.1) then
                average(histo,i-1)=ysum(histo,i-1)+average(histo,i-1)
                sigma(histo,i-1)=ysum(histo,i-1)**2+sigma(histo,i-1)
                ysum(histo,i-1)=0d0
              endif
              if (i.ne.parts) then
                average(histo,i+1)=ysum(histo,i+1)+average(histo,i+1)
                sigma(histo,i+1)=ysum(histo,i+1)**2+sigma(histo,i+1)
                ysum(histo,i+1)=0d0
              endif
            endif
          enddo
        endif
        imax(histo)=0
c output
      elseif(step.eq.4)then
#ifdef mpiuse
	if(iNumProcs.NE.1) Then
	  if(iMyRank.EQ.0) Then
	    do i2=1,iNumProcs-1
	      call MPI_Recv(keep_average, maxh*maxp,
     &                      MPI_DOUBLE_PRECISION,
     &                      i2, 101, MPI_COMM_WORLD, status, iErr)
	      call MPI_Recv(keep_sigma, maxh*maxp,
     &                      MPI_DOUBLE_PRECISION,
     &                      i2, 102, MPI_COMM_WORLD, status, iErr)
	      call MPI_Recv(keep_avborn, maxh*maxp,
     &                      MPI_DOUBLE_PRECISION,
     &                      i2, 103, MPI_COMM_WORLD, status, iErr)
	      call MPI_Recv(keep_siborn, maxh*maxp,
     &                      MPI_DOUBLE_PRECISION,
     &                      i2, 104, MPI_COMM_WORLD, status, iErr)
              do i=1,parts
        	average(histo,i)=average(histo,i)+keep_average(histo,i)
        	sigma(histo,i)=sigma(histo,i)+keep_sigma(histo,i)
        	avborn(histo,i)=avborn(histo,i)+keep_avborn(histo,i)
        	siborn(histo,i)=siborn(histo,i)+keep_siborn(histo,i)
	      enddo
            enddo
	  else
	    call MPI_Send(average, maxh*maxp,
     &                    MPI_DOUBLE_PRECISION,
     &                    0, 101, MPI_COMM_WORLD, iErr)
	    call MPI_Send(sigma, maxh*maxp,
     &                    MPI_DOUBLE_PRECISION,
     &                    0, 102, MPI_COMM_WORLD, iErr)
	    call MPI_Send(avborn, maxh*maxp,
     &                    MPI_DOUBLE_PRECISION,
     &                    0, 103, MPI_COMM_WORLD, iErr)
	    call MPI_Send(siborn, maxh*maxp,
     &                    MPI_DOUBLE_PRECISION,
     &                    0, 104, MPI_COMM_WORLD, iErr)
            do i=1,parts
              avborn(histo,i)=0D0
              siborn(histo,i)=0D0
	    enddo
	  endif
	endif

	if(iMyRank.EQ.0) Then
#endif
        hiout=25
        open(unit=hiout,file=name,status='unknown')
        shift=1d0
        rhs=1
        write(hiout,'("# histogram:",i3,", bins:",i4)') histo,parts
        write(hiout,'(a)')
     &       '# columns: x, NLO result, corresponding MC error,',
     &       '#              LO result, corresponding MC error'
        if(shift.eq.0d0)write(hiout,'(a)')
     &       '# x = right corner of histogram bin'
        if(shift.eq.0.5d0)write(hiout,'(a)')
     &       '# x = middle of histogram bin'
        if(shift.eq.1d0)write(hiout,'(a)')
     &       '# x = left corner of histogram bin'
        write(hiout,'(a)')'# '
#ifdef mpiuse
        If(unweighting.EQ.1) then
	  nn=n*iNumProcs
	  nnb=nb*iNumProcs
        Else
	  nn=n
	  nnb=nb
	Endif
#else
        nn=n
	nnb=nb
#endif
        do i=1,parts
          av=average(histo,i)/dble(nn)/(max-min)*dble(parts)
          si=sigma(histo,i)/(dble(nn)*(max-min)/dble(parts))**2
          si=dsqrt(dabs(si-av*av/dble(nn)))
          avb=avborn(histo,i)/dble(nnb)/(max-min)*dble(parts)
          sib=siborn(histo,i)/(dble(nnb)*(max-min)/dble(parts))**2
          sib=dsqrt(dabs(sib-avb*avb/dble(nnb)))
          write(hiout,'(5(e13.6,2x))')
     *      min+(max-min)/dble(parts)*(dble(i)-shift),av,si,avb,sib
        enddo
        if(rhs.eq.1)write(hiout,'(5(e13.6,2x))')
     *      max,av,si,avb,sib
        write(hiout,'(a)') '# '
        close(hiout)
#ifdef mpiuse
        endif
#endif
      endif

      end

************************************************************************
*     cut subroutine
*
* perform photon/gluon recombination and apply cuts (to recombined momenta)
*
* photon recombination for qrecomb=1 (qrecomb=0: no recombination)
* jet recombination for gluon=1
* phase-space cuts for qcuts.ne.0
*
* gluon=0: 4-particle phsp or photon radiation
* gluon=1: gluon radiation
* qrecomb=1: invariant-mass condition (precomb(1))

*
* input:
* ------
* four-momenta of external particles: outmom(0:3,5)
* outmom(0:3,1-4): fermions
* outmom(0:3,5): photon/gluon
* p(0,n): energy, p(1-3,n): x,y,z component
* nparticles: number of particles in the final state (4 or 5)
*
* output:
* -------
* nocut: 1: event passes cuts, 0: event is rejected
* recmom(0:3,5): momenta (after possible recombination)
*
************************************************************************
      subroutine cut(outmom,recmom,nparticles,nocut,gluon)
      implicit none
      real*8 outmom(0:3,5),recmom(0:3,5),p(0:3),pvec(5),s,prod
      real*8 ctheta(4),cthetamax,si(4),simin,sij(5,5),sijmin
      integer nparticles,npart,nocut,comb,fcomb,i1,i2,i3,jet1,jet2
      integer smalljet,bigjet,gluon
      include 'COMMON/param.inc'
      include 'COMMON/processpar.inc'
      include 'COMMON/options.inc'
c cuts
      real*8 ecut(5),scut(5,5),ccut(5,5),precomb(3)
      integer qcuts
      common/cuts/ecut,scut,ccut,precomb,qcuts

      npart = nparticles
      do i1=1,5
      do i2=0,3 !momentum after recombination and for histograms
        recmom(i2,i1) = outmom(i2,i1)
      enddo
      enddo
c photon recombination
      if (nparticles.eq.5.and.gluon.eq.0) then
        comb=0
        if (qrecomb.eq.1) then
           do i1=1,4
             if(q(i1).ne.0d0)then
               do i2 = 0,3
                 p(i2) = outmom(i2,i1) + outmom(i2,5)
               enddo
               si(i1) = p(0)**2-p(1)**2-p(2)**2-p(3)**2
               if(si(i1).lt.precomb(1)**2) comb=1
             endif
           enddo
           simin = 1d10
           do i1=1,4
              if(q(i1).ne.0d0.and.simin.gt.si(i1))then
                simin = si(i1)
                fcomb=i1
              endif
           enddo
        endif
c photon is recombined with fermion fcomb if comb=1
        if(comb.eq.1)then
          do i1=0,3
            recmom(i1,fcomb)=outmom(i1,fcomb)+outmom(i1,5)
            recmom(i1,5)=0d0
          enddo
          npart = 4     ! apply cuts only to fermions (after recombination)
        endif
      endif
c jet recombination
      sijmin = 1d10
      if (nparticles.eq.5.and.gluon.eq.1) then
        do i1=1,4
        do i2=i1+1,5
          if ((i2.eq.5.and.quark(i1).eq.1).or.(quark(i1).eq.1
     &          .and.quark(i2).eq.1)) then
            do i3=0,3
              p(i3) = outmom(i3,i1) + outmom(i3,i2)
            enddo
            sij(i1,i2) = p(0)**2 - p(1)**2 - p(2)**2 - p(3)**2
            if (sij(i1,i2).lt.sijmin) then
              sijmin = sij(i1,i2)
              jet1 = i1
              jet2 = i2
            endif
          endif
        enddo
        enddo
        if (jet2.eq.5) then !gluon and quark are recombined
          do i3=0,3
            recmom(i3,jet1) = outmom(i3,jet1) + outmom(i3,5)
            recmom(i3,5) = 0d0
          enddo
        else    !2 quarks are recombined, smaller one is replaced with gluon
          if (outmom(0,jet1).gt.outmom(0,jet2)) then
            bigjet = jet1
            smalljet = jet2
          else
            bigjet = jet2
            smalljet = jet1
          endif
          do i3=0,3
            recmom(i3,bigjet) = outmom(i3,bigjet) + outmom(i3,smalljet)
            recmom(i3,smalljet) = outmom(i3,5)
            recmom(i3,5) = 0d0
          enddo
        endif
        npart = 4     ! apply cuts only to fermions (after recombination)
      endif

c apply cuts
      if (qcuts.ne.0) then
        nocut=0
c energy cuts
        do i1=1,npart
          if(recmom(0,i1).lt.ecut(i1))return
        enddo
c invariant-mass cuts
        do i1=1,npart
        do i2=i1+1,npart
          do i3=0,3
            p(i3)=recmom(i3,i1)+recmom(i3,i2)
          enddo
          s=p(0)*p(0)-p(1)*p(1)-p(2)*p(2)-p(3)*p(3)
          if(s.lt.scut(i1,i2))return
        enddo
        enddo
c angular cuts
        do i1=1,npart
          pvec(i1)=dsqrt(recmom(1,i1)**2+recmom(2,i1)**2
     &          +recmom(3,i1)**2)
        enddo
        do i1=1,npart
        do i2=i1+1,npart
          prod=(recmom(1,i1)*recmom(1,i2)+recmom(2,i1)*recmom(2,i2)
     &          +recmom(3,i1)*recmom(3,i2))
          if(prod.gt.ccut(i1,i2)*pvec(i1)*pvec(i2))return
        enddo
        enddo
      endif

      nocut=1

      end

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c                                                                c
c     boost particle with momentum pold into restframe           c
c     of particle with momentum q -> pnew                        c
c                                                                c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine boostrestframe(q,pold,pnew)
      implicit none
c local variable
      real*8 pold(0:3),pnew(0:3),q(0:3),m,m2,bx,by,bz,gamma
      real*8 bp,a
      integer i
      m2=q(0)*q(0)-q(1)*q(1)-q(2)*q(2)-q(3)*q(3)
      if(m2.le.0d0) then
        do i=0,3
          pnew(i)=0d0
        enddo
        return
      endif
      m=dsqrt(dabs(m2))
      bx=-q(1)/m
      by=-q(2)/m
      bz=-q(3)/m
      gamma=q(0)/m
      a=1d0/(1d0+gamma)
      bp=bx*pold(1)+by*pold(2)+bz*pold(3)
      pnew(0)=gamma*pold(0)+bp
      pnew(1)=pold(1)+bx*pold(0)+a*bp*bx
      pnew(2)=pold(2)+by*pold(0)+a*bp*by
      pnew(3)=pold(3)+bz*pold(0)+a*bp*bz
      end
