**********************************************************************
        subroutine  HHtoZZ1133_tree_sesm(F,pz12,pz34)
**********************************************************************
*       LO formfactors for HH -> ZZ -> uudd in the SESM
*---------------------------------------------------------------------
*       7.2.16 Stefan Dittmaier
**********************************************************************
	implicit none
	complex*16 pre,F(13,-1:1,-1:1),pz12,pz34

c mandelstam variables
      	real*8 s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
      	common/mandel/s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
c fermion charges of isospin duplets
	real*8 qf(4)
	common/fcharge/qf
c fermion masses as flag (i*1d-20)
      	complex*16 cme2,cmf2(5)
      	real*8 me2,rme2,mf2(5),rmf2(5)
      	common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2
	include '../COMMON/param.inc'
	include '../COMMON/xparam.inc'
        include '../COMMON/param_sesm.inc'
        include '../COMMON/param_bsm.inc'

C       Process: S4F21aF21F23aF23,   Model: Singlet

        PRE = (PZ12*PZ34*SA*XCW2**(-2)*XMW)/4D0

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*XSW

	end

**********************************************************************
        subroutine  HHtoZZ1133_count_bos_sesm(F,pz12,pz34)
**********************************************************************
*       HH -> ZZ -> uudd in the SESM
*       bosonic counterterms
*---------------------------------------------------------------------
*       7.2.17 Stefan Dittmaier
**********************************************************************
        implicit none
        complex*16 pre,F(13,-1:1,-1:1),pz12,pz34
        complex*16 ct,ct12,ct34,cazff12(-1:1),cazff34(-1:1)
c mandelstam variables
        real*8 s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
        common/mandel/s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
c fermion charges of isospin duplets
        real*8 qf(4)
        common/fcharge/qf
c fermion masses as flag (i*1d-20)
        complex*16 cme2,cmf2(5)
        real*8 me2,rme2,mf2(5),rmf2(5)
        common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2
        include '../COMMON/param.inc'
        include '../COMMON/xparam.inc'
        include '../COMMON/param_sesm.inc'
        include '../COMMON/param_bsm.inc'
c ren. constants
        complex*16 dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw
        complex*16 dmh02,dmHH2,dZh0,dZHH,dZh0HH,dZHHh0,dsa,dl12
        complex*16 dZeer,dZeel,dZnnl,dZffr(4),dZffl(4)
        complex*16 ct_aww,ct_zww,ct_wen,ct_wf1f2,ct_wf3f4
        complex*16 ct_annl,ct_aeer,ct_aeel,ct_affr(4),ct_affl(4)
        complex*16 ct_znnl,ct_zeer,ct_zeel,ct_zffr(4),ct_zffl(4)
        complex*16 ct_h0ww,ct_HHww,ct_h0zz,ct_HHzz,ct_h0za,ct_HHza
        common/xrenc_sesm/
     &         dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw,
     &         dmh02,dmHH2,dZh0,dZHH,dZh0HH,dZHHh0,dsa,dl12,
     &         dZeer,dZeel,dZnnl,dZffr,dZffl,
     &         ct_aww,ct_zww,ct_wen,ct_wf1f2,ct_wf3f4,
     &         ct_annl,ct_aeer,ct_aeel,ct_affr,ct_affl,
     &         ct_znnl,ct_zeer,ct_zeel,ct_zffr,ct_zffl,
     &         ct_h0ww,ct_HHww,ct_h0zz,ct_HHzz,ct_h0za,ct_HHza

c Aff/Zff couplings
c note that qf is charge of isospin duplet (particle, not anti-particle)
c charges of outgoing fermions according to 2233/1133/1144
      cazff12(-1) = qf(1)/(-1d0+2d0*qf(1)*xsw2)*2d0*xsw*xcw
      cazff12(+1) = xcw/xsw
      cazff34(-1) = qf(3)/(1d0+2d0*qf(3)*xsw2)*2d0*xsw*xcw
      cazff34(+1) = xcw/xsw

c counterterms for self energies
      ct =  dmz2/(s12-xmz2) - dZzz
     &     +dmz2/(s34-xmz2) - dZzz

      PRE = SA*(PZ12*PZ34*XCW2**(-2)*XMW)/4D0  *ct

      F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/(XSW*XSW2)
      F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW
      F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW
      F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*XSW

c ZA-mixing self energy counterterms
      ct12 = xmz2/s12*dZza/2d0 - (dZaz+dZza)/2d0
      ct34 = xmz2/s34*dZza/2d0 - (dZaz+dZza)/2d0

      PRE = SA*(PZ12*PZ34*XCW2**(-2)*XMW)/4D0

      F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/(XSW*XSW2)    *(ct12*cazff12(-1)+ct34*cazff34(-1))
      F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW                        *(ct12*cazff12(-1)+ct34*cazff34(+1))
      F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW                        *(ct12*cazff12(+1)+ct34*cazff34(-1))
      F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*XSW
     &                             *(ct12*cazff12(+1)+ct34*cazff34(+1))

c counterterms for vertex diagrams
      PRE = SA*(PZ12*PZ34*XCW2**(-2)*XMW)/4D0

      F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/(XSW*XSW2)      *(ct_HHzz+ct_Zffl(1)+ct_Zffl(3))
      F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW                          *(ct_HHzz+ct_Zffl(1)+ct_Zffr(3))
      F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW                          *(ct_HHzz+ct_Zffr(1)+ct_Zffl(3))
      F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*XSW
     &                               *(ct_HHzz+ct_Zffr(1)+ct_Zffr(3))

c ZA-mixing vertex counter terms
      PRE = SA*(PZ12*PZ34*XCW2**(-2)*XMW)/4D0

      F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/(XSW*XSW2)
     &     *(ct_HHza*cazff12(-1)/pz12/s12 + ct_HHza*cazff34(-1)/pz34/s34)
      F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW
     &     *(ct_HHza*cazff12(-1)/pz12/s12 + ct_HHza*cazff34(+1)/pz34/s34)
      F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW
     &     *(ct_HHza*cazff12(+1)/pz12/s12 + ct_HHza*cazff34(-1)/pz34/s34)
      F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*XSW
     &     *(ct_HHza*cazff12(+1)/pz12/s12 + ct_HHza*cazff34(+1)/pz34/s34)

      end

**********************************************************************
        subroutine  HHtoZZ1133_count_ferm_sesm(F,pz12,pz34)
**********************************************************************
*       HH -> ZZ -> uudd in the SESM
*       fermion-loop counterterms
*---------------------------------------------------------------------
*       7.2.17 Stefan Dittmaier
**********************************************************************
        implicit none
        complex*16 pre,F(13,-1:1,-1:1),pz12,pz34
        complex*16 ct,ct12,ct34,cazff12(-1:1),cazff34(-1:1)
c mandelstam variables
        real*8 s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
        common/mandel/s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
c fermion charges of isospin duplets
        real*8 qf(4)
        common/fcharge/qf
c fermion masses as flag (i*1d-20)
        complex*16 cme2,cmf2(5)
        real*8 me2,rme2,mf2(5),rmf2(5)
        common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2
        include '../COMMON/param.inc'
        include '../COMMON/xparam.inc'
        include '../COMMON/param_sesm.inc'
        include '../COMMON/param_bsm.inc'
c ren. constants
        complex*16 dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw
        complex*16 dmh02,dmHH2,dZh0,dZHH,dZh0HH,dZHHh0,dsa,dl12
        complex*16 dZeer,dZeel,dZnnl,dZffr(4),dZffl(4)
        complex*16 ct_aww,ct_zww,ct_wen,ct_wf1f2,ct_wf3f4
        complex*16 ct_annl,ct_aeer,ct_aeel,ct_affr(4),ct_affl(4)
        complex*16 ct_znnl,ct_zeer,ct_zeel,ct_zffr(4),ct_zffl(4)
        complex*16 ct_h0ww,ct_HHww,ct_h0zz,ct_HHzz,ct_h0za,ct_HHza
        common/xrenc_ferm_sesm/
     &         dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw,
     &         dmh02,dmHH2,dZh0,dZHH,dZh0HH,dZHHh0,dsa,dl12,
     &         dZeer,dZeel,dZnnl,dZffr,dZffl,
     &         ct_aww,ct_zww,ct_wen,ct_wf1f2,ct_wf3f4,
     &         ct_annl,ct_aeer,ct_aeel,ct_affr,ct_affl,
     &         ct_znnl,ct_zeer,ct_zeel,ct_zffr,ct_zffl,
     &         ct_h0ww,ct_HHww,ct_h0zz,ct_HHzz,ct_h0za,ct_HHza

c Aff/Zff couplings
c note that qf is charge of isospin duplet (particle, not anti-particle)
c charges of outgoing fermions according to 2233/1133/1144
      cazff12(-1) = qf(1)/(-1d0+2d0*qf(1)*xsw2)*2d0*xsw*xcw
      cazff12(+1) = xcw/xsw
      cazff34(-1) = qf(3)/(1d0+2d0*qf(3)*xsw2)*2d0*xsw*xcw
      cazff34(+1) = xcw/xsw

c counterterms for self energies
      ct =  dmz2/(s12-xmz2) - dZzz
     &     +dmz2/(s34-xmz2) - dZzz

      PRE = SA*(PZ12*PZ34*XCW2**(-2)*XMW)/4D0  *ct

      F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/(XSW*XSW2)
      F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW
      F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW
      F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*XSW

c ZA-mixing self energy counterterms
      ct12 = xmz2/s12*dZza/2d0 - (dZaz+dZza)/2d0
      ct34 = xmz2/s34*dZza/2d0 - (dZaz+dZza)/2d0

      PRE = SA*(PZ12*PZ34*XCW2**(-2)*XMW)/4D0

      F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/(XSW*XSW2)    *(ct12*cazff12(-1)+ct34*cazff34(-1))
      F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW                        *(ct12*cazff12(-1)+ct34*cazff34(+1))
      F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW                        *(ct12*cazff12(+1)+ct34*cazff34(-1))
      F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*XSW
     &                             *(ct12*cazff12(+1)+ct34*cazff34(+1))

c counterterms for vertex diagrams
      PRE = SA*(PZ12*PZ34*XCW2**(-2)*XMW)/4D0

      F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/(XSW*XSW2)      *(ct_HHzz+ct_Zffl(1)+ct_Zffl(3))
      F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW                          *(ct_HHzz+ct_Zffl(1)+ct_Zffr(3))
      F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW                          *(ct_HHzz+ct_Zffr(1)+ct_Zffl(3))
      F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*XSW
     &                               *(ct_HHzz+ct_Zffr(1)+ct_Zffr(3))

c ZA-mixing vertex counter terms
      PRE = SA*(PZ12*PZ34*XCW2**(-2)*XMW)/4D0

      F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/(XSW*XSW2)
     &     *(ct_HHza*cazff12(-1)/pz12/s12 + ct_HHza*cazff34(-1)/pz34/s34)
      F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW
     &     *(ct_HHza*cazff12(-1)/pz12/s12 + ct_HHza*cazff34(+1)/pz34/s34)
      F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW
     &     *(ct_HHza*cazff12(+1)/pz12/s12 + ct_HHza*cazff34(-1)/pz34/s34)
      F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*XSW
     &     *(ct_HHza*cazff12(+1)/pz12/s12 + ct_HHza*cazff34(+1)/pz34/s34)

      end

**********************************************************************
        subroutine  HHtoZZ1133_self_bos2_sesm(F,pz12,pz34)
**********************************************************************
*       self-energy contributions for HH -> ZZ -> uudd in the SESM
*       bosonic loops
*---------------------------------------------------------------------
*       7.2.17 Stefan Dittmaier
**********************************************************************
	implicit none
	complex*16 pre,F(13,-1:1,-1:1),pz12,pz34
	complex*16 A0,xA0_,B0_,xB0_,DB0_,xDB0_,B1_,xB1_,DB1_,xDB1_
        complex*16 B0,B1(1),B2(0:2,0:2),B3(0:2,0:2,2)
        complex*16 B4(0:2,0:2,0:2,0:2),B5(0:2,0:2,0:2,0:2,2)
        complex*16 C0_,C0,C1(2),C2(0:2,0:2),C3(0:2,0:2,2)
        complex*16 C4(0:2,0:2,0:2,0:2)
	complex*16 D0,D1(3),D2(0:3,0:3),D3(0:3,0:3,3)
        complex*16 D4(0:3,0:3,0:3,0:3),D5(0:3,0:3,0:3,0:3,3)
	complex*16 E0n,E1n(4),E2n(0:4,0:4),E3n(0:4,0:4,4)
	complex*16 E4n(0:4,0:4,0:4,0:4)
        complex*16 seaa,seaz,sezz

c mandelstam variables
      	real*8 s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
      	common/mandel/s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
c fermion charges of isospin duplets
	real*8 qf(4)
	common/fcharge/qf
c fermion masses as flag (i*1d-20)
      	complex*16 cme2,cmf2(5)
      	real*8 me2,rme2,mf2(5),rmf2(5)
      	common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2
	include '../COMMON/param.inc'
	include '../COMMON/xparam.inc'
        include '../COMMON/param_sesm.inc'
        include '../COMMON/param_bsm.inc'

        call xsevv_sesm(s12,seaa,seaz,sezz)

      PRE = SA*(PZ12*PZ34*XCW2**(-2)*XMW)/4D0  *(-sezz)*pz12

      F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/(XSW*XSW2)
      F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW
      F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW
      F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*XSW

      PRE = SA*(PZ12*PZ34/XCW**3/XSW*XMW)/4D0  *(-seaz)/s12

      F(1,-1,-1) = F(1,-1,-1)-(PRE*(-2D0*QF(1)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/(XSW*XSW2)
      F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(-2D0*QF(1)*XSW2))/
     &  XSW
      F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW
      F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*XSW

        call xsevv_sesm(s34,seaa,seaz,sezz)

      PRE = SA*(PZ12*PZ34*XCW2**(-2)*XMW)/4D0  *(-sezz)*pz34

      F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/(XSW*XSW2)
      F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW
      F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW
      F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*XSW

      PRE = SA*(PZ12*PZ34/XCW**3/XSW*XMW)/4D0  *(-seaz)/s34

      F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2)*(+2D0*
     &  QF(3)*XSW2))/(XSW*XSW2)
      F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW
      F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(2D0*QF(3)*XSW2))/
     &  XSW
      F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*XSW

	end

**********************************************************************
        subroutine  HHtoZZ1133_self_bos_sesm(F,pz12,pz34)
**********************************************************************
*       self-energy contributions for HH -> ZZ -> uudd in the SESM
*       bosonic loops
*---------------------------------------------------------------------
*       7.2.17 Stefan Dittmaier
**********************************************************************
	implicit none
	complex*16 pre,F(13,-1:1,-1:1),pz12,pz34
	complex*16 A0,xA0_,B0_,xB0_,DB0_,xDB0_,B1_,xB1_,DB1_,xDB1_
        complex*16 B0,B1(1),B2(0:2,0:2),B3(0:2,0:2,2)
        complex*16 B4(0:2,0:2,0:2,0:2),B5(0:2,0:2,0:2,0:2,2)
        complex*16 C0_,C0,C1(2),C2(0:2,0:2),C3(0:2,0:2,2)
        complex*16 C4(0:2,0:2,0:2,0:2)
	complex*16 D0,D1(3),D2(0:3,0:3),D3(0:3,0:3,3)
        complex*16 D4(0:3,0:3,0:3,0:3),D5(0:3,0:3,0:3,0:3,3)
	complex*16 E0n,E1n(4),E2n(0:4,0:4),E3n(0:4,0:4,4)
	complex*16 E4n(0:4,0:4,0:4,0:4)

c mandelstam variables
      	real*8 s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
      	common/mandel/s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
c fermion charges of isospin duplets
	real*8 qf(4)
	common/fcharge/qf
c fermion masses as flag (i*1d-20)
      	complex*16 cme2,cmf2(5)
      	real*8 me2,rme2,mf2(5),rmf2(5)
      	common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2
	include '../COMMON/param.inc'
	include '../COMMON/xparam.inc'
        include '../COMMON/param_sesm.inc'
        include '../COMMON/param_bsm.inc'

C       Process: S4F21aF21F23aF23,   Model: Singlet

C       G(T1,N1,FULL)

C       G(T1,N2,FULL)

C       G(T1,N3,FULL)

C       G(T1,N4,FULL)

C       G(T1,N5,FULL)

C       G(T1,N6,FULL)

C       G(T1,N7,FULL)

C       G(T1,N8,FULL)

C       G(T1,N9,FULL)

C       G(T1,N10,FULL)

C       G(T1,N11,FULL)

C       G(T1,N12,FULL)

C       G(T1,N13,FULL)

C       G(T1,N14,FULL)

C       G(T1,N15,FULL)

C       G(T1,N16,FULL)

C       G(T1,N17,FULL)

C       G(T2,N18,FULL)

C       G(T2,N19,FULL)

C       G(T2,N20,FULL)

C       G(T2,N21,FULL)

C       G(T2,N22,FULL)

C       G(T2,N23,FULL)

C       G(T2,N24,FULL)

C       G(T2,N25,FULL)

C       G(T2,N26,FULL)

C       G(T2,N27,FULL)

C       G(T2,N28,FULL)

C       G(T2,N29,FULL)

C       G(T2,N30,FULL)
        A0 = xA0_(XMW2)

        PRE = (QF(1)*A0*ALPHA*PZ12*PZ34*SA*XCW2**(-2)*XMW*(XCW+XSW)*
     &  (XCW-XSW))/(8D0*PI*S12*XSW)

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE
        F(1,1,-1) = F(1,1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,1,1) = F(1,1,1)+2D0*QF(3)*PRE

C       G(T2,N31,FULL)
        A0 = xA0_(XMW2)

        PRE = (QF(1)*ALPHA*PZ12*PZ34*SA*XMW*(3D0*A0-2D0*XMW2))/(4D0*
     &  PI*S12*XCW2*XSW)

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE
        F(1,1,-1) = F(1,1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,1,1) = F(1,1,1)+2D0*QF(3)*PRE

C       G(T2,N32,FULL)
        A0 = xA0_(XMW2)

        PRE = -((A0*ALPHA*PZ12**2*PZ34*SA*XCW2**(-3)*XMW*(XCW+XSW)**
     &  2*(XCW-XSW)**2)/(32D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T2,N33,FULL)
        A0 = xA0_(XMH2)

        PRE = -((A0*ALPHA*CA**2*PZ12**2*PZ34*SA*XCW2**(-3)*XMW)/
     &  (64D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T2,N34,FULL)
        A0 = xA0_(XMZ2)

        PRE = -((A0*ALPHA*PZ12**2*PZ34*SA*XCW2**(-3)*XMW)/(64D0*PI*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T2,N35,FULL)
        A0 = xA0_(XMHH2)

        PRE = -((A0*ALPHA*PZ12**2*PZ34*SA**3*XCW2**(-3)*XMW)/(64D0*
     &  PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T2,N36,FULL)
        A0 = xA0_(XMW2)

        PRE = -((ALPHA*PZ12**2*PZ34*SA*XMW*(3D0*A0-2D0*XMW2))/(8D0*
     &  PI*XCW2*XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T3,N37,FULL)

C       G(T3,N38,FULL)

C       G(T3,N39,FULL)

C       G(T3,N40,FULL)

C       G(T3,N41,FULL)

C       G(T3,N42,FULL)

C       G(T3,N43,FULL)

C       G(T3,N44,FULL)

C       G(T3,N45,FULL)

C       G(T3,N46,FULL)

C       G(T3,N47,FULL)

C       G(T3,N48,FULL)

C       G(T3,N49,FULL)

C       G(T3,N50,FULL)

C       G(T3,N51,FULL)

C       G(T3,N52,FULL)

C       G(T3,N53,FULL)

C       G(T4,N54,FULL)

C       G(T4,N55,FULL)

C       G(T4,N56,FULL)

C       G(T4,N57,FULL)

C       G(T4,N58,FULL)

C       G(T4,N59,FULL)

C       G(T4,N60,FULL)

C       G(T4,N61,FULL)

C       G(T4,N62,FULL)

C       G(T4,N63,FULL)

C       G(T4,N64,FULL)

C       G(T4,N65,FULL)

C       G(T4,N66,FULL)

C       G(T4,N67,FULL)

C       G(T4,N68,FULL)

C       G(T4,N69,FULL)

C       G(T4,N70,FULL)

C       G(T5,N71,FULL)

C       G(T5,N72,FULL)

C       G(T5,N73,FULL)

C       G(T5,N74,FULL)

C       G(T5,N75,FULL)

C       G(T5,N76,FULL)

C       G(T5,N77,FULL)

C       G(T5,N78,FULL)

C       G(T5,N79,FULL)

C       G(T5,N80,FULL)

C       G(T5,N81,FULL)

C       G(T5,N82,FULL)

C       G(T5,N83,FULL)
        A0 = xA0_(XMW2)

        PRE = (QF(3)*A0*ALPHA*PZ12*PZ34*SA*XCW2**(-2)*XMW*(XCW+XSW)*
     &  (XCW-XSW))/(8D0*PI*S34*XSW)

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE
        F(1,1,1) = F(1,1,1)+2D0*QF(1)*PRE

C       G(T5,N84,FULL)
        A0 = xA0_(XMW2)

        PRE = (QF(3)*ALPHA*PZ12*PZ34*SA*XMW*(3D0*A0-2D0*XMW2))/(4D0*
     &  PI*S34*XCW2*XSW)

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE
        F(1,1,1) = F(1,1,1)+2D0*QF(1)*PRE

C       G(T5,N85,FULL)
        A0 = xA0_(XMW2)

        PRE = -((A0*ALPHA*PZ12*PZ34**2*SA*XCW2**(-3)*XMW*(XCW+XSW)**
     &  2*(XCW-XSW)**2)/(32D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T5,N86,FULL)
        A0 = xA0_(XMH2)

        PRE = -((A0*ALPHA*CA**2*PZ12*PZ34**2*SA*XCW2**(-3)*XMW)/
     &  (64D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T5,N87,FULL)
        A0 = xA0_(XMZ2)

        PRE = -((A0*ALPHA*PZ12*PZ34**2*SA*XCW2**(-3)*XMW)/(64D0*PI*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T5,N88,FULL)
        A0 = xA0_(XMHH2)

        PRE = -((A0*ALPHA*PZ12*PZ34**2*SA**3*XCW2**(-3)*XMW)/(64D0*
     &  PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T5,N89,FULL)
        A0 = xA0_(XMW2)

        PRE = -((ALPHA*PZ12*PZ34**2*SA*XMW*(3D0*A0-2D0*XMW2))/(8D0*
     &  PI*XCW2*XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T6,N90,FULL)

C       G(T6,N91,FULL)

C       G(T6,N92,FULL)

C       G(T6,N93,FULL)

C       G(T6,N94,FULL)

C       G(T6,N95,FULL)

C       G(T6,N96,FULL)

C       G(T6,N97,FULL)

C       G(T6,N98,FULL)

C       G(T6,N99,FULL)

C       G(T6,N100,FULL)

C       G(T6,N101,FULL)

C       G(T6,N102,FULL)

C       G(T6,N103,FULL)

C       G(T6,N104,FULL)

C       G(T6,N105,FULL)

C       G(T6,N106,FULL)

C       G(T7,N107,FULL)

C       G(T7,N108,FULL)

C       G(T7,N109,FULL)

C       G(T7,N110,FULL)

C       G(T7,N111,FULL)

C       G(T7,N112,FULL)

C       G(T7,N113,FULL)

C       G(T7,N114,FULL)

C       G(T7,N115,FULL)

C       G(T7,N116,FULL)

C       G(T7,N117,FULL)

C       G(T7,N118,FULL)

C       G(T7,N119,FULL)

C       G(T7,N120,FULL)

C       G(T7,N121,FULL)

C       G(T7,N122,FULL)

C       G(T7,N123,FULL)

C       G(T7,N124,FULL)

C       G(T7,N125,FULL)

C       G(T7,N126,FULL)

C       G(T7,N127,FULL)

C       G(T7,N128,FULL)

C       G(T7,N129,FULL)

C       G(T7,N130,FULL)

C       G(T7,N131,FULL)

C       G(T7,N132,FULL)

C       G(T7,N133,FULL)

C       G(T7,N134,FULL)

C       G(T7,N135,FULL)

C       G(T7,N136,FULL)

C       G(T7,N137,FULL)

C       G(T7,N138,FULL)

C       G(T7,N139,FULL)

C       G(T7,N140,FULL)

C       G(T7,N141,FULL)

C       G(T7,N142,FULL)

C       G(T7,N143,FULL)

C       G(T7,N144,FULL)

C       G(T7,N145,FULL)

C       G(T7,N146,FULL)

C       G(T7,N147,FULL)

C       G(T7,N155,FULL)

C       G(T7,N156,FULL)

C       G(T7,N157,FULL)

C       G(T7,N158,FULL)

C       G(T7,N159,FULL)

C       G(T7,N160,FULL)

C       G(T7,N161,FULL)

C       G(T7,N162,FULL)

C       G(T7,N163,FULL)

C       G(T7,N164,FULL)

C       G(T7,N165,FULL)

C       G(T7,N166,FULL)

C       G(T7,N167,FULL)

C       G(T7,N175,FULL)

C       G(T7,N176,FULL)

C       G(T7,N177,FULL)

C       G(T7,N178,FULL)

C       G(T7,N179,FULL)

C       G(T7,N180,FULL)

C       G(T7,N188,FULL)

C       G(T7,N189,FULL)

C       G(T7,N190,FULL)

C       G(T7,N191,FULL)

C       G(T7,N192,FULL)

C       G(T7,N193,FULL)

C       G(T7,N201,FULL)

C       G(T7,N202,FULL)

C       G(T7,N203,FULL)

C       G(T7,N204,FULL)

C       G(T7,N205,FULL)

C       G(T7,N206,FULL)

C       G(T7,N214,FULL)
        CALL xB012345_(S12,XMW2,XMW2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = -((B2(0,0)*QF(1)*ALPHA*PZ12*PZ34*SA*XCW2**(-2)*XMW*
     &  (XCW+XSW)*(XCW-XSW))/(4D0*PI*S12*XSW))

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE
        F(1,1,-1) = F(1,1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,1,1) = F(1,1,1)+2D0*QF(3)*PRE

C       G(T7,N215,FULL)
        CALL xB012345_(S12,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((QF(1)*ALPHA*B0*PZ12*PZ34*SA*XCW2**(-2)*XMW*XMW2)/
     &  (8D0*PI*S12))

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE*XSW
        F(1,1,-1) = F(1,1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW
        F(1,1,1) = F(1,1,1)+2D0*QF(3)*PRE*XSW

C       G(T7,N216,FULL)
        CALL xB012345_(S12,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((QF(1)*ALPHA*B0*PZ12*PZ34*SA*XCW2**(-2)*XMW*XMW2)/
     &  (8D0*PI*S12))

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE*XSW
        F(1,1,-1) = F(1,1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW
        F(1,1,1) = F(1,1,1)+2D0*QF(3)*PRE*XSW

C       G(T7,N217,FULL)
        CALL xB012345_(S12,XMW2,XMW2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (B2(0,0)*QF(1)*ALPHA*PZ12*PZ34*SA*XMW)/(8D0*PI*S12*
     &  XCW2*XSW)

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE
        F(1,1,-1) = F(1,1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,1,1) = F(1,1,1)+2D0*QF(3)*PRE

C       G(T7,N218,FULL)
        CALL xB012345_(S12,XMW2,XMW2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (B2(0,0)*QF(1)*ALPHA*PZ12*PZ34*SA*XMW)/(8D0*PI*S12*
     &  XCW2*XSW)

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE
        F(1,1,-1) = F(1,1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,1,1) = F(1,1,1)+2D0*QF(3)*PRE

C       G(T7,N219,FULL)
        CALL xB012345_(S12,XMW2,XMW2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = -((QF(1)*ALPHA*PZ12*PZ34*SA*XMW*(2D0*B1(1)+2D0*B2(1,
     &  1)+5D0*B0+(18D0*B2(0,0))/S12+(S12-6D0*XMW2)/S12))/(8D0*PI*
     &  XCW2*XSW))

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE
        F(1,1,-1) = F(1,1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,1,1) = F(1,1,1)+2D0*QF(3)*PRE

C       G(T7,N228,FULL)
        CALL xB012345_(S12,XMW2,XMW2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (B2(0,0)*ALPHA*PZ12**2*PZ34*SA*XCW2**(-3)*XMW*(XCW+
     &  XSW)**2*(XCW-XSW)**2)/(16D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T7,N229,FULL)
        CALL xB012345_(S12,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PZ12**2*PZ34*SA*XCW2**(-3)*XMW*XMW2)/
     &  (16D0*PI))

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)-2D0*QF(3)*PRE*XSW*(1D0-2D0*QF(1)*XSW2)
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE*XSW*(1D0+2D0*QF(3)*XSW2)
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*XSW*XSW2

C       G(T7,N230,FULL)
        CALL xB012345_(S12,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PZ12**2*PZ34*SA*XCW2**(-3)*XMW*XMW2)/
     &  (16D0*PI))

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)-2D0*QF(3)*PRE*XSW*(1D0-2D0*QF(1)*XSW2)
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE*XSW*(1D0+2D0*QF(3)*XSW2)
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*XSW*XSW2

C       G(T7,N231,FULL)
        CALL xB012345_(S12,XMZ2,XMH2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (B2(0,0)*ALPHA*CA**2*PZ12**2*PZ34*SA*XCW2**(-3)*XMW)/
     &  (16D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T7,N232,FULL)
        CALL xB012345_(S12,XMZ2,XMH2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*CA**2*PZ12**2*PZ34*SA*XCW2**(-4)*XMW*
     &  XMW2)/(16D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T7,N233,FULL)
        CALL xB012345_(S12,XMHH2,XMZ2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (B2(0,0)*ALPHA*PZ12**2*PZ34*SA**3*XCW2**(-3)*XMW)/
     &  (16D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T7,N234,FULL)
        CALL xB012345_(S12,XMZ2,XMHH2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PZ12**2*PZ34*SA**3*XCW2**(-4)*XMW*XMW2)/
     &  (16D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T7,N235,FULL)
        CALL xB012345_(S12,XMW2,XMW2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = -((B2(0,0)*ALPHA*PZ12**2*PZ34*SA*XMW)/(16D0*PI*XCW2*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T7,N236,FULL)
        CALL xB012345_(S12,XMW2,XMW2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = -((B2(0,0)*ALPHA*PZ12**2*PZ34*SA*XMW)/(16D0*PI*XCW2*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T7,N237,FULL)
        CALL xB012345_(S12,XMW2,XMW2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (ALPHA*PZ12**2*PZ34*SA*XMW*(18D0*B2(0,0)+S12+2D0*
     &  B1(1)*S12+2D0*B2(1,1)*S12+5D0*B0*S12-6D0*XMW2))/(16D0*PI*
     &  XCW2*XSW)

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T8,N245,FULL)

C       G(T8,N246,FULL)

C       G(T8,N247,FULL)

C       G(T8,N248,FULL)

C       G(T8,N249,FULL)

C       G(T8,N250,FULL)

C       G(T8,N251,FULL)

C       G(T8,N252,FULL)

C       G(T8,N253,FULL)

C       G(T8,N254,FULL)

C       G(T8,N255,FULL)

C       G(T8,N256,FULL)

C       G(T8,N257,FULL)

C       G(T8,N265,FULL)

C       G(T8,N266,FULL)

C       G(T8,N267,FULL)

C       G(T8,N268,FULL)

C       G(T8,N269,FULL)

C       G(T8,N270,FULL)

C       G(T8,N278,FULL)

C       G(T8,N279,FULL)

C       G(T8,N280,FULL)

C       G(T8,N281,FULL)

C       G(T8,N282,FULL)

C       G(T8,N283,FULL)

C       G(T8,N291,FULL)

C       G(T8,N292,FULL)

C       G(T8,N293,FULL)

C       G(T8,N294,FULL)

C       G(T8,N295,FULL)

C       G(T8,N296,FULL)

C       G(T8,N304,FULL)

C       G(T8,N305,FULL)

C       G(T8,N306,FULL)

C       G(T8,N307,FULL)

C       G(T8,N308,FULL)

C       G(T8,N309,FULL)

C       G(T8,N317,FULL)

C       G(T8,N318,FULL)

C       G(T8,N319,FULL)

C       G(T8,N320,FULL)

C       G(T8,N321,FULL)

C       G(T8,N322,FULL)

C       G(T8,N330,FULL)

C       G(T8,N331,FULL)

C       G(T8,N332,FULL)

C       G(T8,N333,FULL)

C       G(T8,N334,FULL)

C       G(T8,N335,FULL)

C       G(T8,N343,FULL)

C       G(T8,N344,FULL)

C       G(T8,N345,FULL)

C       G(T8,N346,FULL)

C       G(T8,N347,FULL)

C       G(T8,N348,FULL)

C       G(T8,N357,FULL)

C       G(T8,N358,FULL)

C       G(T8,N359,FULL)

C       G(T8,N360,FULL)

C       G(T8,N361,FULL)

C       G(T8,N362,FULL)

C       G(T8,N363,FULL)

C       G(T8,N364,FULL)

C       G(T8,N365,FULL)

C       G(T8,N366,FULL)

C       G(T9,N374,FULL)

C       G(T9,N375,FULL)

C       G(T9,N376,FULL)

C       G(T9,N377,FULL)

C       G(T9,N378,FULL)

C       G(T9,N379,FULL)

C       G(T9,N380,FULL)

C       G(T9,N381,FULL)

C       G(T9,N382,FULL)

C       G(T9,N383,FULL)

C       G(T9,N384,FULL)

C       G(T9,N385,FULL)

C       G(T9,N386,FULL)

C       G(T9,N394,FULL)

C       G(T9,N395,FULL)

C       G(T9,N396,FULL)

C       G(T9,N397,FULL)

C       G(T9,N398,FULL)

C       G(T9,N399,FULL)

C       G(T9,N407,FULL)

C       G(T9,N408,FULL)

C       G(T9,N409,FULL)

C       G(T9,N410,FULL)

C       G(T9,N411,FULL)

C       G(T9,N412,FULL)

C       G(T9,N420,FULL)

C       G(T9,N421,FULL)

C       G(T9,N422,FULL)

C       G(T9,N423,FULL)

C       G(T9,N424,FULL)

C       G(T9,N425,FULL)

C       G(T9,N433,FULL)

C       G(T9,N434,FULL)

C       G(T9,N435,FULL)

C       G(T9,N436,FULL)

C       G(T9,N437,FULL)

C       G(T9,N438,FULL)

C       G(T9,N446,FULL)

C       G(T9,N447,FULL)

C       G(T9,N448,FULL)

C       G(T9,N449,FULL)

C       G(T9,N450,FULL)

C       G(T9,N451,FULL)

C       G(T9,N459,FULL)

C       G(T9,N460,FULL)

C       G(T9,N461,FULL)

C       G(T9,N462,FULL)

C       G(T9,N463,FULL)

C       G(T9,N464,FULL)

C       G(T9,N472,FULL)

C       G(T9,N473,FULL)

C       G(T9,N474,FULL)

C       G(T9,N475,FULL)

C       G(T9,N476,FULL)

C       G(T9,N477,FULL)

C       G(T9,N486,FULL)

C       G(T9,N487,FULL)

C       G(T9,N488,FULL)

C       G(T9,N489,FULL)

C       G(T9,N490,FULL)

C       G(T9,N491,FULL)

C       G(T9,N492,FULL)

C       G(T9,N493,FULL)

C       G(T9,N494,FULL)

C       G(T9,N495,FULL)

C       G(T10,N496,FULL)

C       G(T10,N497,FULL)

C       G(T10,N498,FULL)

C       G(T10,N499,FULL)

C       G(T10,N500,FULL)

C       G(T10,N501,FULL)

C       G(T10,N502,FULL)

C       G(T10,N503,FULL)

C       G(T10,N504,FULL)

C       G(T10,N505,FULL)

C       G(T10,N506,FULL)

C       G(T10,N507,FULL)

C       G(T11,N508,FULL)

C       G(T11,N509,FULL)

C       G(T11,N510,FULL)

C       G(T11,N511,FULL)

C       G(T11,N512,FULL)

C       G(T11,N513,FULL)

C       G(T11,N514,FULL)

C       G(T11,N515,FULL)

C       G(T11,N516,FULL)

C       G(T11,N517,FULL)

C       G(T11,N518,FULL)

C       G(T11,N519,FULL)

C       G(T12,N520,FULL)

C       G(T12,N521,FULL)

C       G(T12,N522,FULL)

C       G(T12,N523,FULL)

C       G(T12,N524,FULL)

C       G(T12,N525,FULL)

C       G(T12,N526,FULL)

C       G(T12,N527,FULL)

C       G(T12,N528,FULL)

C       G(T12,N529,FULL)

C       G(T12,N530,FULL)

C       G(T12,N531,FULL)

C       G(T13,N532,FULL)

C       G(T13,N533,FULL)

C       G(T13,N534,FULL)

C       G(T13,N535,FULL)

C       G(T13,N536,FULL)

C       G(T13,N537,FULL)

C       G(T13,N538,FULL)

C       G(T13,N539,FULL)

C       G(T13,N540,FULL)

C       G(T13,N541,FULL)

C       G(T13,N542,FULL)

C       G(T13,N543,FULL)

C       G(T14,N544,FULL)

C       G(T14,N545,FULL)

C       G(T14,N546,FULL)

C       G(T14,N547,FULL)

C       G(T14,N548,FULL)

C       G(T14,N549,FULL)

C       G(T14,N550,FULL)

C       G(T14,N551,FULL)

C       G(T14,N552,FULL)

C       G(T14,N553,FULL)

C       G(T14,N554,FULL)

C       G(T14,N555,FULL)

C       G(T14,N556,FULL)

C       G(T14,N557,FULL)

C       G(T14,N558,FULL)

C       G(T14,N559,FULL)

C       G(T14,N560,FULL)

C       G(T14,N561,FULL)

C       G(T14,N562,FULL)

C       G(T14,N563,FULL)

C       G(T14,N564,FULL)

C       G(T14,N565,FULL)

C       G(T14,N566,FULL)

C       G(T14,N567,FULL)

C       G(T14,N568,FULL)

C       G(T14,N569,FULL)

C       G(T14,N570,FULL)

C       G(T14,N571,FULL)

C       G(T14,N572,FULL)

C       G(T14,N573,FULL)

C       G(T14,N574,FULL)

C       G(T14,N575,FULL)

C       G(T14,N576,FULL)

C       G(T14,N577,FULL)

C       G(T14,N578,FULL)

C       G(T14,N579,FULL)

C       G(T14,N580,FULL)

C       G(T14,N581,FULL)

C       G(T14,N582,FULL)

C       G(T14,N583,FULL)

C       G(T14,N584,FULL)

C       G(T14,N592,FULL)

C       G(T14,N593,FULL)

C       G(T14,N594,FULL)

C       G(T14,N595,FULL)

C       G(T14,N596,FULL)

C       G(T14,N597,FULL)

C       G(T14,N598,FULL)

C       G(T14,N599,FULL)

C       G(T14,N600,FULL)

C       G(T14,N601,FULL)

C       G(T14,N602,FULL)

C       G(T14,N603,FULL)

C       G(T14,N604,FULL)

C       G(T14,N612,FULL)

C       G(T14,N613,FULL)

C       G(T14,N614,FULL)

C       G(T14,N615,FULL)

C       G(T14,N616,FULL)

C       G(T14,N617,FULL)

C       G(T14,N625,FULL)

C       G(T14,N626,FULL)

C       G(T14,N627,FULL)

C       G(T14,N628,FULL)

C       G(T14,N629,FULL)

C       G(T14,N630,FULL)

C       G(T14,N638,FULL)

C       G(T14,N639,FULL)

C       G(T14,N640,FULL)

C       G(T14,N641,FULL)

C       G(T14,N642,FULL)

C       G(T14,N643,FULL)

C       G(T14,N651,FULL)
        CALL xB012345_(S34,XMW2,XMW2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = -((B2(0,0)*QF(3)*ALPHA*PZ12*PZ34*SA*XCW2**(-2)*XMW*
     &  (XCW+XSW)*(XCW-XSW))/(4D0*PI*S34*XSW))

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE
        F(1,1,1) = F(1,1,1)+2D0*QF(1)*PRE

C       G(T14,N652,FULL)
        CALL xB012345_(S34,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((QF(3)*ALPHA*B0*PZ12*PZ34*SA*XCW2**(-2)*XMW*XMW2)/
     &  (8D0*PI*S34))

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE*XSW
        F(1,1,1) = F(1,1,1)+2D0*QF(1)*PRE*XSW

C       G(T14,N653,FULL)
        CALL xB012345_(S34,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((QF(3)*ALPHA*B0*PZ12*PZ34*SA*XCW2**(-2)*XMW*XMW2)/
     &  (8D0*PI*S34))

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE*XSW
        F(1,1,1) = F(1,1,1)+2D0*QF(1)*PRE*XSW

C       G(T14,N654,FULL)
        CALL xB012345_(S34,XMW2,XMW2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (B2(0,0)*QF(3)*ALPHA*PZ12*PZ34*SA*XMW)/(8D0*PI*S34*
     &  XCW2*XSW)

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE
        F(1,1,1) = F(1,1,1)+2D0*QF(1)*PRE

C       G(T14,N655,FULL)
        CALL xB012345_(S34,XMW2,XMW2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (B2(0,0)*QF(3)*ALPHA*PZ12*PZ34*SA*XMW)/(8D0*PI*S34*
     &  XCW2*XSW)

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE
        F(1,1,1) = F(1,1,1)+2D0*QF(1)*PRE

C       G(T14,N656,FULL)
        CALL xB012345_(S34,XMW2,XMW2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = -((QF(3)*ALPHA*PZ12*PZ34*SA*XMW*(2D0*B1(1)+2D0*B2(1,
     &  1)+5D0*B0+(18D0*B2(0,0))/S34+(S34-6D0*XMW2)/S34))/(8D0*PI*
     &  XCW2*XSW))

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE
        F(1,1,1) = F(1,1,1)+2D0*QF(1)*PRE

C       G(T14,N665,FULL)
        CALL xB012345_(S34,XMW2,XMW2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (B2(0,0)*ALPHA*PZ12*PZ34**2*SA*XCW2**(-3)*XMW*(XCW+
     &  XSW)**2*(XCW-XSW)**2)/(16D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T14,N666,FULL)
        CALL xB012345_(S34,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PZ12*PZ34**2*SA*XCW2**(-3)*XMW*XMW2)/
     &  (16D0*PI))

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)-2D0*QF(3)*PRE*XSW*(1D0-2D0*QF(1)*XSW2)
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE*XSW*(1D0+2D0*QF(3)*XSW2)
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*XSW*XSW2

C       G(T14,N667,FULL)
        CALL xB012345_(S34,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PZ12*PZ34**2*SA*XCW2**(-3)*XMW*XMW2)/
     &  (16D0*PI))

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)-2D0*QF(3)*PRE*XSW*(1D0-2D0*QF(1)*XSW2)
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE*XSW*(1D0+2D0*QF(3)*XSW2)
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*XSW*XSW2

C       G(T14,N668,FULL)
        CALL xB012345_(S34,XMZ2,XMH2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (B2(0,0)*ALPHA*CA**2*PZ12*PZ34**2*SA*XCW2**(-3)*XMW)/
     &  (16D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T14,N669,FULL)
        CALL xB012345_(S34,XMZ2,XMH2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*CA**2*PZ12*PZ34**2*SA*XCW2**(-4)*XMW*
     &  XMW2)/(16D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T14,N670,FULL)
        CALL xB012345_(S34,XMHH2,XMZ2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (B2(0,0)*ALPHA*PZ12*PZ34**2*SA**3*XCW2**(-3)*XMW)/
     &  (16D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T14,N671,FULL)
        CALL xB012345_(S34,XMZ2,XMHH2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PZ12*PZ34**2*SA**3*XCW2**(-4)*XMW*XMW2)/
     &  (16D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T14,N672,FULL)
        CALL xB012345_(S34,XMW2,XMW2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = -((B2(0,0)*ALPHA*PZ12*PZ34**2*SA*XMW)/(16D0*PI*XCW2*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T14,N673,FULL)
        CALL xB012345_(S34,XMW2,XMW2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = -((B2(0,0)*ALPHA*PZ12*PZ34**2*SA*XMW)/(16D0*PI*XCW2*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T14,N674,FULL)
        CALL xB012345_(S34,XMW2,XMW2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (ALPHA*PZ12*PZ34**2*SA*XMW*(18D0*B2(0,0)+S34+2D0*
     &  B1(1)*S34+2D0*B2(1,1)*S34+5D0*B0*S34-6D0*XMW2))/(16D0*PI*
     &  XCW2*XSW)

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T15,N682,FULL)

C       G(T15,N683,FULL)

C       G(T15,N684,FULL)

C       G(T15,N685,FULL)

C       G(T15,N686,FULL)

C       G(T15,N687,FULL)

C       G(T15,N688,FULL)

C       G(T15,N689,FULL)

C       G(T15,N690,FULL)

C       G(T15,N691,FULL)

C       G(T15,N692,FULL)

C       G(T15,N693,FULL)

C       G(T15,N694,FULL)

C       G(T15,N702,FULL)

C       G(T15,N703,FULL)

C       G(T15,N704,FULL)

C       G(T15,N705,FULL)

C       G(T15,N706,FULL)

C       G(T15,N707,FULL)

C       G(T15,N715,FULL)

C       G(T15,N716,FULL)

C       G(T15,N717,FULL)

C       G(T15,N718,FULL)

C       G(T15,N719,FULL)

C       G(T15,N720,FULL)

C       G(T15,N728,FULL)

C       G(T15,N729,FULL)

C       G(T15,N730,FULL)

C       G(T15,N731,FULL)

C       G(T15,N732,FULL)

C       G(T15,N733,FULL)

C       G(T15,N741,FULL)

C       G(T15,N742,FULL)

C       G(T15,N743,FULL)

C       G(T15,N744,FULL)

C       G(T15,N745,FULL)

C       G(T15,N746,FULL)

C       G(T15,N754,FULL)

C       G(T15,N755,FULL)

C       G(T15,N756,FULL)

C       G(T15,N757,FULL)

C       G(T15,N758,FULL)

C       G(T15,N759,FULL)

C       G(T15,N767,FULL)

C       G(T15,N768,FULL)

C       G(T15,N769,FULL)

C       G(T15,N770,FULL)

C       G(T15,N771,FULL)

C       G(T15,N772,FULL)

C       G(T15,N780,FULL)

C       G(T15,N781,FULL)

C       G(T15,N782,FULL)

C       G(T15,N783,FULL)

C       G(T15,N784,FULL)

C       G(T15,N785,FULL)

C       G(T15,N794,FULL)

C       G(T15,N795,FULL)

C       G(T15,N796,FULL)

C       G(T15,N797,FULL)

C       G(T15,N798,FULL)

C       G(T15,N799,FULL)

C       G(T15,N800,FULL)

C       G(T15,N801,FULL)

C       G(T15,N802,FULL)

C       G(T15,N803,FULL)

C       G(T16,N811,FULL)

C       G(T16,N812,FULL)

C       G(T16,N813,FULL)

C       G(T16,N814,FULL)

C       G(T16,N815,FULL)

C       G(T16,N816,FULL)

C       G(T16,N817,FULL)

C       G(T16,N818,FULL)

C       G(T16,N819,FULL)

C       G(T16,N820,FULL)

C       G(T16,N821,FULL)

C       G(T16,N822,FULL)

C       G(T16,N823,FULL)

C       G(T16,N831,FULL)

C       G(T16,N832,FULL)

C       G(T16,N833,FULL)

C       G(T16,N834,FULL)

C       G(T16,N835,FULL)

C       G(T16,N836,FULL)

C       G(T16,N844,FULL)

C       G(T16,N845,FULL)

C       G(T16,N846,FULL)

C       G(T16,N847,FULL)

C       G(T16,N848,FULL)

C       G(T16,N849,FULL)

C       G(T16,N857,FULL)

C       G(T16,N858,FULL)

C       G(T16,N859,FULL)

C       G(T16,N860,FULL)

C       G(T16,N861,FULL)

C       G(T16,N862,FULL)

C       G(T16,N870,FULL)

C       G(T16,N871,FULL)

C       G(T16,N872,FULL)

C       G(T16,N873,FULL)

C       G(T16,N874,FULL)

C       G(T16,N875,FULL)

C       G(T16,N883,FULL)

C       G(T16,N884,FULL)

C       G(T16,N885,FULL)

C       G(T16,N886,FULL)

C       G(T16,N887,FULL)

C       G(T16,N888,FULL)

C       G(T16,N896,FULL)

C       G(T16,N897,FULL)

C       G(T16,N898,FULL)

C       G(T16,N899,FULL)

C       G(T16,N900,FULL)

C       G(T16,N901,FULL)

C       G(T16,N909,FULL)

C       G(T16,N910,FULL)

C       G(T16,N911,FULL)

C       G(T16,N912,FULL)

C       G(T16,N913,FULL)

C       G(T16,N914,FULL)

C       G(T16,N923,FULL)

C       G(T16,N924,FULL)

C       G(T16,N925,FULL)

C       G(T16,N926,FULL)

C       G(T16,N927,FULL)

C       G(T16,N928,FULL)

C       G(T16,N929,FULL)

C       G(T16,N930,FULL)

C       G(T16,N931,FULL)

C       G(T16,N932,FULL)

	end

**********************************************************************
        subroutine  HHtoZZ1133_vert_bos_sesm(F,pz12,pz34)
**********************************************************************
*       vertex corrections for HH -> ZZ -> uudd in the SESM
*       bosonic loops
*---------------------------------------------------------------------
*       7.2.17 Stefan Dittmaier
**********************************************************************
	implicit none
	complex*16 pre,F(13,-1:1,-1:1),pz12,pz34
	complex*16 A0,xA0_,B0_,xB0_,DB0_,xDB0_,B1_,xB1_,DB1_,xDB1_
        complex*16 B0,B1(1),B2(0:2,0:2),B3(0:2,0:2,2)
        complex*16 B4(0:2,0:2,0:2,0:2),B5(0:2,0:2,0:2,0:2,2)
        complex*16 C0_,C0,C1(2),C2(0:2,0:2),C3(0:2,0:2,2)
        complex*16 C4(0:2,0:2,0:2,0:2)
	complex*16 D0,D1(3),D2(0:3,0:3),D3(0:3,0:3,3)
        complex*16 D4(0:3,0:3,0:3,0:3),D5(0:3,0:3,0:3,0:3,3)
	complex*16 E0n,E1n(4),E2n(0:4,0:4),E3n(0:4,0:4,4)
	complex*16 E4n(0:4,0:4,0:4,0:4)
        COMPLEX*16 K(8)

c mandelstam variables
      	real*8 s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
      	common/mandel/s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
c fermion charges of isospin duplets
	real*8 qf(4)
	common/fcharge/qf
c fermion masses as flag (i*1d-20)
      	complex*16 cme2,cmf2(5)
      	real*8 me2,rme2,mf2(5),rmf2(5)
      	common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2
	include '../COMMON/param.inc'
	include '../COMMON/xparam.inc'
        include '../COMMON/param_sesm.inc'
        include '../COMMON/param_bsm.inc'

C       Process: S4F21aF21F23aF23,   Model: Singlet

C       G(T1,N3,FULL)

C       G(T1,N4,FULL)

C       G(T1,N5,FULL)

C       G(T1,N6,FULL)

C       G(T1,N7,FULL)

C       G(T1,N8,FULL)

C       G(T1,N10,FULL)

C       G(T1,N11,FULL)

C       G(T1,N12,FULL)

C       G(T1,N15,FULL)

C       G(T1,N16,FULL)

C       G(T1,N17,FULL)

C       G(T1,N18,FULL)

C       G(T1,N19,FULL)

C       G(T1,N20,FULL)

C       G(T1,N22,FULL)

C       G(T1,N23,FULL)

C       G(T1,N24,FULL)

C       G(T1,N26,FULL)

C       G(T1,N27,FULL)

C       G(T1,N28,FULL)

C       G(T1,N29,FULL)

C       G(T1,N30,FULL)

C       G(T1,N31,FULL)

C       G(T1,N33,FULL)

C       G(T1,N34,FULL)

C       G(T1,N36,FULL)

C       G(T1,N37,FULL)

C       G(T1,N38,FULL)

C       G(T1,N39,FULL)

C       G(T1,N40,FULL)

C       G(T1,N41,FULL)

C       G(T1,N43,FULL)

C       G(T1,N44,FULL)

C       G(T1,N47,FULL)

C       G(T1,N48,FULL)

C       G(T1,N49,FULL)

C       G(T1,N50,FULL)

C       G(T1,N51,FULL)

C       G(T1,N52,FULL)

C       G(T1,N54,FULL)

C       G(T1,N55,FULL)

C       G(T1,N56,FULL)

C       G(T1,N59,FULL)

C       G(T1,N60,FULL)

C       G(T1,N61,FULL)

C       G(T1,N62,FULL)

C       G(T1,N63,FULL)

C       G(T1,N64,FULL)

C       G(T1,N66,FULL)

C       G(T1,N67,FULL)

C       G(T1,N68,FULL)

C       G(T1,N71,FULL)

C       G(T1,N72,FULL)

C       G(T1,N73,FULL)

C       G(T1,N74,FULL)

C       G(T1,N75,FULL)

C       G(T1,N76,FULL)

C       G(T1,N78,FULL)

C       G(T1,N79,FULL)

C       G(T1,N80,FULL)

C       G(T1,N83,FULL)

C       G(T1,N84,FULL)

C       G(T1,N85,FULL)

C       G(T1,N86,FULL)

C       G(T1,N87,FULL)

C       G(T1,N88,FULL)

C       G(T1,N90,FULL)
        CALL xC01234_(RMF2(1),S12,RMF2(1),CMF2(2),XMW2,XMW2,C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,1)

        PRE = (ALPHA*PZ12*PZ34*(1D0-6D0*C2(0,0)+C1(1)*S12+C1(2)*S12+
     &  C2(1,2)*S12)*SA*XMW)/(8D0*PI*XCW2*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE

C       G(T1,N91,FULL)

C       G(T1,N92,FULL)

C       G(T1,N94,FULL)

C       G(T1,N96,FULL)

C       G(T1,N98,FULL)

C       G(T1,N100,FULL)

C       G(T1,N102,FULL)

C       G(T1,N104,FULL)

C       G(T1,N106,FULL)

C       G(T1,N108,FULL)
        CALL xC01234_(S12,RMF2(1),RMF2(1),CMF2(2),CMF2(2),XMW2,C0,C1,C2,
     &  C3,C4,B0,B1,B2,B3,2,1)

        PRE = -((ALPHA*PZ12*PZ34*(1D0-2D0*C2(0,0)-C1(1)*S12-C1(2)*
     &  S12-C2(1,1)*S12-C2(1,2)*S12)*SA*XCW2**(-2)*XMW*(1D0+2D0*
     &  QF(2)*XSW2))/(16D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE

C       G(T1,N109,FULL)

C       G(T1,N110,FULL)

C       G(T1,N111,FULL)

C       G(T1,N112,FULL)

C       G(T1,N113,FULL)

C       G(T1,N114,FULL)

C       G(T1,N115,FULL)

C       G(T1,N116,FULL)

C       G(T1,N117,FULL)

C       G(T1,N118,FULL)

C       G(T1,N119,FULL)

C       G(T1,N120,FULL)

C       G(T1,N121,FULL)

C       G(T1,N122,FULL)

C       G(T1,N123,FULL)

C       G(T1,N124,FULL)

C       G(T1,N125,FULL)

C       G(T1,N126,FULL)

C       G(T1,N127,FULL)

C       G(T1,N128,FULL)

C       G(T1,N129,FULL)

C       G(T1,N130,FULL)

C       G(T1,N131,FULL)

C       G(T1,N132,FULL)

C       G(T1,N133,FULL)

C       G(T1,N134,FULL)

C       G(T1,N135,FULL)

C       G(T1,N136,FULL)

C       G(T1,N137,FULL)

C       G(T1,N138,FULL)

C       G(T1,N139,FULL)

C       G(T1,N140,FULL)

C       G(T1,N141,FULL)

C       G(T1,N142,FULL)

C       G(T1,N143,FULL)

C       G(T1,N144,FULL)

C       G(T1,N145,FULL)

C       G(T1,N146,FULL)

C       G(T1,N147,FULL)
        CALL xC01234_(RMF2(1),S12,RMF2(1),NULL,CMF2(1),CMF2(1),C0,C1,C2,
     &  C3,C4,B0,B1,B2,B3,2,1)

        PRE = -((QF(1)**2*ALPHA*PZ12*PZ34*(1D0-2D0*C2(0,0)+C1(1)*
     &  S12+C1(2)*S12+C2(1,2)*S12+C0*S12)*SA*XCW2**(-2)*XMW)/(8D0*
     &  PI))

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*XSW

C       G(T1,N148,FULL)
        CALL xC01234_(S12,RMF2(1),RMF2(1),CMF2(1),CMF2(1),XMZ2,C0,C1,C2,
     &  C3,C4,B0,B1,B2,B3,2,1)

        PRE = -((ALPHA*PZ12*PZ34*(1D0-2D0*C2(0,0)-C1(1)*S12-C1(2)*
     &  S12-C2(1,1)*S12-C2(1,2)*S12)*SA*XCW2**(-3)*XMW)/(32D0*PI))

        F(1,-1,-1) = F(1,-1,-1)-(PRE*XSW2**(-2)*(1D0-2D0*QF(1)*
     &  XSW2)**3*(1D0+2D0*QF(3)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2)**
     &  3)/(XSW*XSW2)
        F(1,1,-1) = F(1,1,-1)+8D0*QF(1)**3*PRE*XSW*(1D0+2D0*QF(3)*
     &  XSW2)
        F(1,1,1) = F(1,1,1)+16D0*QF(1)**3*QF(3)*PRE*XSW*XSW2

C       G(T2,N151,FULL)

C       G(T2,N152,FULL)

C       G(T2,N153,FULL)

C       G(T2,N154,FULL)

C       G(T2,N155,FULL)

C       G(T2,N156,FULL)

C       G(T2,N158,FULL)

C       G(T2,N159,FULL)

C       G(T2,N160,FULL)

C       G(T2,N162,FULL)

C       G(T2,N163,FULL)

C       G(T2,N164,FULL)

C       G(T2,N165,FULL)

C       G(T2,N166,FULL)

C       G(T2,N167,FULL)

C       G(T2,N169,FULL)

C       G(T2,N170,FULL)

C       G(T2,N173,FULL)

C       G(T2,N174,FULL)

C       G(T2,N175,FULL)

C       G(T2,N176,FULL)

C       G(T2,N177,FULL)

C       G(T2,N178,FULL)

C       G(T2,N180,FULL)

C       G(T2,N181,FULL)

C       G(T2,N182,FULL)

C       G(T2,N186,FULL)

C       G(T2,N189,FULL)

C       G(T2,N190,FULL)

C       G(T2,N191,FULL)

C       G(T2,N192,FULL)

C       G(T2,N193,FULL)

C       G(T2,N194,FULL)

C       G(T2,N196,FULL)

C       G(T2,N197,FULL)

C       G(T2,N198,FULL)

C       G(T2,N200,FULL)

C       G(T2,N202,FULL)

C       G(T2,N204,FULL)

C       G(T2,N206,FULL)

C       G(T2,N208,FULL)

C       G(T2,N209,FULL)

C       G(T2,N210,FULL)

C       G(T2,N211,FULL)

C       G(T2,N212,FULL)

C       G(T2,N213,FULL)

C       G(T2,N214,FULL)

C       G(T2,N215,FULL)

C       G(T2,N216,FULL)

C       G(T2,N217,FULL)

C       G(T2,N218,FULL)

C       G(T2,N219,FULL)

C       G(T2,N220,FULL)

C       G(T2,N221,FULL)

C       G(T2,N222,FULL)

C       G(T2,N223,FULL)

C       G(T2,N224,FULL)

C       G(T2,N225,FULL)

C       G(T2,N226,FULL)

C       G(T2,N227,FULL)

C       G(T2,N228,FULL)

C       G(T2,N229,FULL)

C       G(T2,N230,FULL)

C       G(T2,N231,FULL)

C       G(T2,N232,FULL)

C       G(T2,N233,FULL)

C       G(T3,N236,FULL)

C       G(T3,N237,FULL)

C       G(T3,N238,FULL)

C       G(T3,N239,FULL)

C       G(T3,N240,FULL)

C       G(T3,N241,FULL)

C       G(T3,N243,FULL)

C       G(T3,N244,FULL)

C       G(T3,N245,FULL)

C       G(T3,N247,FULL)

C       G(T3,N248,FULL)

C       G(T3,N249,FULL)

C       G(T3,N250,FULL)

C       G(T3,N251,FULL)

C       G(T3,N252,FULL)

C       G(T3,N254,FULL)

C       G(T3,N255,FULL)

C       G(T3,N258,FULL)

C       G(T3,N259,FULL)

C       G(T3,N260,FULL)

C       G(T3,N261,FULL)

C       G(T3,N262,FULL)

C       G(T3,N263,FULL)

C       G(T3,N265,FULL)

C       G(T3,N266,FULL)

C       G(T3,N267,FULL)

C       G(T3,N271,FULL)

C       G(T3,N274,FULL)

C       G(T3,N275,FULL)

C       G(T3,N276,FULL)

C       G(T3,N277,FULL)

C       G(T3,N278,FULL)

C       G(T3,N279,FULL)

C       G(T3,N281,FULL)

C       G(T3,N282,FULL)

C       G(T3,N283,FULL)

C       G(T3,N285,FULL)

C       G(T3,N287,FULL)

C       G(T3,N289,FULL)

C       G(T3,N291,FULL)

C       G(T3,N293,FULL)

C       G(T3,N294,FULL)

C       G(T3,N295,FULL)

C       G(T3,N296,FULL)

C       G(T3,N297,FULL)

C       G(T3,N298,FULL)

C       G(T3,N299,FULL)

C       G(T3,N300,FULL)

C       G(T3,N301,FULL)

C       G(T3,N302,FULL)

C       G(T3,N303,FULL)

C       G(T3,N304,FULL)

C       G(T3,N305,FULL)

C       G(T3,N306,FULL)

C       G(T3,N307,FULL)

C       G(T3,N308,FULL)

C       G(T3,N309,FULL)

C       G(T3,N310,FULL)

C       G(T3,N311,FULL)

C       G(T3,N312,FULL)

C       G(T3,N313,FULL)

C       G(T3,N314,FULL)

C       G(T3,N315,FULL)

C       G(T3,N316,FULL)

C       G(T3,N317,FULL)

C       G(T3,N318,FULL)

C       G(T4,N321,FULL)

C       G(T4,N322,FULL)

C       G(T4,N323,FULL)

C       G(T4,N324,FULL)

C       G(T4,N325,FULL)

C       G(T4,N326,FULL)

C       G(T4,N328,FULL)

C       G(T4,N329,FULL)

C       G(T4,N330,FULL)

C       G(T4,N333,FULL)

C       G(T4,N334,FULL)

C       G(T4,N335,FULL)

C       G(T4,N336,FULL)

C       G(T4,N337,FULL)

C       G(T4,N338,FULL)

C       G(T4,N340,FULL)

C       G(T4,N341,FULL)

C       G(T4,N342,FULL)

C       G(T4,N345,FULL)

C       G(T4,N346,FULL)

C       G(T4,N347,FULL)

C       G(T4,N348,FULL)

C       G(T4,N349,FULL)

C       G(T4,N350,FULL)

C       G(T4,N352,FULL)

C       G(T4,N353,FULL)

C       G(T4,N354,FULL)

C       G(T4,N357,FULL)

C       G(T4,N358,FULL)

C       G(T4,N359,FULL)

C       G(T4,N360,FULL)

C       G(T4,N361,FULL)

C       G(T4,N362,FULL)

C       G(T4,N364,FULL)
        CALL xC01234_(RMF2(1),MHH2,T12,CMF2(2),XMW2,XMW2,C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,1,1)

        PRE = (C1(2)*QF(1)*QF(3)*ALPHA*SA*XMW)/(4D0*PI*S34*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+PRE
        F(1,-1,1) = F(1,-1,1)+PRE

C       G(T4,N365,FULL)

C       G(T4,N366,FULL)
        CALL xC01234_(T12,MHH2,RMF2(1),CMF2(1),XMZ2,XMZ2,C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,1,1)

        PRE = (C1(1)*QF(1)*QF(3)*ALPHA*SA*XCW2**(-2)*XMW)/(8D0*PI*
     &  S34)

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0-2D0*QF(1)*XSW2)**2)/(XSW*
     &  XSW2)
        F(1,-1,1) = F(1,-1,1)+(PRE*(1D0-2D0*QF(1)*XSW2)**2)/(XSW*
     &  XSW2)
        F(1,1,-1) = F(1,1,-1)+4D0*QF(1)**2*PRE*XSW
        F(1,1,1) = F(1,1,1)+4D0*QF(1)**2*PRE*XSW

C       G(T4,N369,FULL)

C       G(T4,N370,FULL)

C       G(T4,N371,FULL)

C       G(T4,N372,FULL)

C       G(T4,N373,FULL)

C       G(T4,N374,FULL)

C       G(T4,N376,FULL)
        CALL xC01234_(RMF2(1),MHH2,T12,CMF2(2),XMW2,XMW2,C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,1,1)

        PRE = -((C1(2)*ALPHA*PZ34*SA*XMW*(1D0-2D0*QF(1)*XSW2))/
     &  (16D0*PI*XCW2*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE

C       G(T4,N377,FULL)

C       G(T4,N378,FULL)
        CALL xC01234_(T12,MHH2,RMF2(1),CMF2(1),XMZ2,XMZ2,C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,1,1)

        PRE = (C1(1)*ALPHA*PZ34*SA*XCW2**(-3)*XMW)/(32D0*PI)

        F(1,-1,-1) = F(1,-1,-1)-(PRE*XSW2**(-2)*(1D0-2D0*QF(1)*
     &  XSW2)**3*(1D0+2D0*QF(3)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2)**
     &  3)/(XSW*XSW2)
        F(1,1,-1) = F(1,1,-1)+8D0*QF(1)**3*PRE*XSW*(1D0+2D0*QF(3)*
     &  XSW2)
        F(1,1,1) = F(1,1,1)+16D0*QF(1)**3*QF(3)*PRE*XSW*XSW2

C       G(T4,N380,FULL)

C       G(T4,N382,FULL)

C       G(T4,N384,FULL)

C       G(T4,N386,FULL)

C       G(T4,N388,FULL)

C       G(T4,N389,FULL)

C       G(T4,N390,FULL)

C       G(T4,N391,FULL)

C       G(T4,N392,FULL)

C       G(T4,N393,FULL)

C       G(T4,N394,FULL)

C       G(T4,N395,FULL)

C       G(T4,N396,FULL)

C       G(T4,N397,FULL)

C       G(T4,N398,FULL)

C       G(T4,N399,FULL)

C       G(T4,N400,FULL)

C       G(T4,N401,FULL)

C       G(T4,N402,FULL)

C       G(T4,N403,FULL)

C       G(T4,N404,FULL)

C       G(T4,N405,FULL)

C       G(T4,N406,FULL)

C       G(T4,N407,FULL)

C       G(T4,N408,FULL)

C       G(T4,N409,FULL)

C       G(T4,N410,FULL)

C       G(T4,N411,FULL)

C       G(T4,N412,FULL)

C       G(T4,N413,FULL)

C       G(T5,N416,FULL)

C       G(T5,N417,FULL)

C       G(T5,N418,FULL)

C       G(T5,N419,FULL)

C       G(T5,N420,FULL)

C       G(T5,N421,FULL)

C       G(T5,N423,FULL)

C       G(T5,N424,FULL)

C       G(T5,N425,FULL)

C       G(T5,N428,FULL)

C       G(T5,N429,FULL)

C       G(T5,N430,FULL)

C       G(T5,N431,FULL)

C       G(T5,N432,FULL)

C       G(T5,N433,FULL)

C       G(T5,N435,FULL)

C       G(T5,N436,FULL)

C       G(T5,N437,FULL)

C       G(T5,N440,FULL)

C       G(T5,N441,FULL)

C       G(T5,N442,FULL)

C       G(T5,N443,FULL)

C       G(T5,N444,FULL)

C       G(T5,N445,FULL)

C       G(T5,N447,FULL)

C       G(T5,N448,FULL)

C       G(T5,N449,FULL)

C       G(T5,N452,FULL)

C       G(T5,N453,FULL)

C       G(T5,N454,FULL)

C       G(T5,N455,FULL)

C       G(T5,N456,FULL)

C       G(T5,N457,FULL)

C       G(T5,N459,FULL)
        CALL xC01234_(RMF2(1),MHH2,T11,CMF2(2),XMW2,XMW2,C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,1,1)

        PRE = (C1(2)*QF(1)*QF(3)*ALPHA*SA*XMW)/(4D0*PI*S34*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+PRE
        F(1,-1,1) = F(1,-1,1)+PRE

C       G(T5,N460,FULL)

C       G(T5,N461,FULL)
        CALL xC01234_(RMF2(1),MHH2,T11,CMF2(1),XMZ2,XMZ2,C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,1,1)

        PRE = (C1(2)*QF(1)*QF(3)*ALPHA*SA*XCW2**(-2)*XMW)/(8D0*PI*
     &  S34)

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0-2D0*QF(1)*XSW2)**2)/(XSW*
     &  XSW2)
        F(1,-1,1) = F(1,-1,1)+(PRE*(1D0-2D0*QF(1)*XSW2)**2)/(XSW*
     &  XSW2)
        F(1,1,-1) = F(1,1,-1)+4D0*QF(1)**2*PRE*XSW
        F(1,1,1) = F(1,1,1)+4D0*QF(1)**2*PRE*XSW

C       G(T5,N464,FULL)

C       G(T5,N465,FULL)

C       G(T5,N466,FULL)

C       G(T5,N467,FULL)

C       G(T5,N468,FULL)

C       G(T5,N469,FULL)

C       G(T5,N471,FULL)
        CALL xC01234_(RMF2(1),MHH2,T11,CMF2(2),XMW2,XMW2,C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,1,1)

        PRE = -((C1(2)*ALPHA*PZ34*SA*XMW*(1D0-2D0*QF(1)*XSW2))/
     &  (16D0*PI*XCW2*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE

C       G(T5,N472,FULL)

C       G(T5,N473,FULL)
        CALL xC01234_(RMF2(1),MHH2,T11,CMF2(1),XMZ2,XMZ2,C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,1,1)

        PRE = (C1(2)*ALPHA*PZ34*SA*XCW2**(-3)*XMW)/(32D0*PI)

        F(1,-1,-1) = F(1,-1,-1)-(PRE*XSW2**(-2)*(1D0-2D0*QF(1)*
     &  XSW2)**3*(1D0+2D0*QF(3)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2)**
     &  3)/(XSW*XSW2)
        F(1,1,-1) = F(1,1,-1)+8D0*QF(1)**3*PRE*XSW*(1D0+2D0*QF(3)*
     &  XSW2)
        F(1,1,1) = F(1,1,1)+16D0*QF(1)**3*QF(3)*PRE*XSW*XSW2

C       G(T5,N475,FULL)

C       G(T5,N477,FULL)

C       G(T5,N479,FULL)

C       G(T5,N481,FULL)

C       G(T5,N483,FULL)

C       G(T5,N484,FULL)

C       G(T5,N485,FULL)

C       G(T5,N486,FULL)

C       G(T5,N487,FULL)

C       G(T5,N488,FULL)

C       G(T5,N489,FULL)

C       G(T5,N490,FULL)

C       G(T5,N491,FULL)

C       G(T5,N492,FULL)

C       G(T5,N493,FULL)

C       G(T5,N494,FULL)

C       G(T5,N495,FULL)

C       G(T5,N496,FULL)

C       G(T5,N497,FULL)

C       G(T5,N498,FULL)

C       G(T5,N499,FULL)

C       G(T5,N500,FULL)

C       G(T5,N501,FULL)

C       G(T5,N502,FULL)

C       G(T5,N503,FULL)

C       G(T5,N504,FULL)

C       G(T5,N505,FULL)

C       G(T5,N506,FULL)

C       G(T5,N507,FULL)

C       G(T5,N508,FULL)

C       G(T6,N509,FULL)

C       G(T6,N510,FULL)

C       G(T6,N511,FULL)

C       G(T6,N512,FULL)

C       G(T6,N513,FULL)

C       G(T6,N515,FULL)

C       G(T6,N516,FULL)

C       G(T6,N517,FULL)

C       G(T6,N518,FULL)

C       G(T6,N519,FULL)

C       G(T6,N520,FULL)

C       G(T6,N522,FULL)

C       G(T6,N525,FULL)

C       G(T6,N526,FULL)

C       G(T6,N527,FULL)

C       G(T6,N528,FULL)

C       G(T6,N529,FULL)

C       G(T6,N531,FULL)

C       G(T6,N532,FULL)

C       G(T6,N533,FULL)

C       G(T6,N534,FULL)

C       G(T6,N535,FULL)

C       G(T6,N536,FULL)

C       G(T6,N538,FULL)

C       G(T6,N539,FULL)

C       G(T6,N540,FULL)

C       G(T6,N541,FULL)

C       G(T6,N542,FULL)

C       G(T6,N543,FULL)

C       G(T6,N545,FULL)

C       G(T6,N546,FULL)

C       G(T6,N547,FULL)

C       G(T6,N548,FULL)

C       G(T6,N549,FULL)

C       G(T6,N552,FULL)

C       G(T6,N553,FULL)

C       G(T6,N554,FULL)

C       G(T6,N555,FULL)

C       G(T6,N557,FULL)

C       G(T6,N558,FULL)

C       G(T6,N559,FULL)

C       G(T6,N560,FULL)

C       G(T6,N561,FULL)

C       G(T6,N562,FULL)

C       G(T6,N563,FULL)

C       G(T6,N564,FULL)

C       G(T6,N565,FULL)

C       G(T6,N566,FULL)

C       G(T6,N567,FULL)

C       G(T6,N568,FULL)

C       G(T6,N569,FULL)

C       G(T6,N572,FULL)

C       G(T6,N573,FULL)

C       G(T6,N574,FULL)

C       G(T6,N575,FULL)

C       G(T6,N577,FULL)

C       G(T6,N581,FULL)

C       G(T6,N582,FULL)

C       G(T6,N583,FULL)

C       G(T6,N584,FULL)

C       G(T6,N585,FULL)

C       G(T6,N588,FULL)

C       G(T6,N589,FULL)

C       G(T6,N590,FULL)

C       G(T6,N591,FULL)

C       G(T6,N593,FULL)

C       G(T7,N596,FULL)

C       G(T7,N597,FULL)

C       G(T7,N598,FULL)

C       G(T7,N599,FULL)

C       G(T7,N600,FULL)

C       G(T7,N601,FULL)

C       G(T7,N603,FULL)

C       G(T7,N604,FULL)

C       G(T7,N605,FULL)

C       G(T7,N608,FULL)

C       G(T7,N609,FULL)

C       G(T7,N610,FULL)

C       G(T7,N611,FULL)

C       G(T7,N612,FULL)

C       G(T7,N613,FULL)

C       G(T7,N615,FULL)

C       G(T7,N616,FULL)

C       G(T7,N617,FULL)

C       G(T7,N620,FULL)

C       G(T7,N621,FULL)

C       G(T7,N622,FULL)

C       G(T7,N623,FULL)

C       G(T7,N624,FULL)

C       G(T7,N625,FULL)

C       G(T7,N627,FULL)

C       G(T7,N628,FULL)

C       G(T7,N629,FULL)

C       G(T7,N632,FULL)

C       G(T7,N633,FULL)

C       G(T7,N634,FULL)

C       G(T7,N635,FULL)

C       G(T7,N636,FULL)

C       G(T7,N637,FULL)

C       G(T7,N639,FULL)
        CALL xC01234_(RMF2(3),MHH2,T13,CMF2(4),XMW2,XMW2,C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,1,1)

        PRE = (C1(2)*QF(1)*QF(3)*ALPHA*SA*XMW)/(4D0*PI*S12*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+PRE
        F(1,1,-1) = F(1,1,-1)+PRE

C       G(T7,N640,FULL)

C       G(T7,N641,FULL)
        CALL xC01234_(T13,MHH2,RMF2(3),CMF2(3),XMZ2,XMZ2,C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,1,1)

        PRE = (C1(1)*QF(1)*QF(3)*ALPHA*SA*XCW2**(-2)*XMW)/(8D0*PI*
     &  S12)

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2)**2)/(XSW*
     &  XSW2)
        F(1,-1,1) = F(1,-1,1)+4D0*QF(3)**2*PRE*XSW
        F(1,1,-1) = F(1,1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2)**2)/(XSW*
     &  XSW2)
        F(1,1,1) = F(1,1,1)+4D0*QF(3)**2*PRE*XSW

C       G(T7,N644,FULL)

C       G(T7,N645,FULL)

C       G(T7,N646,FULL)

C       G(T7,N647,FULL)

C       G(T7,N648,FULL)

C       G(T7,N649,FULL)

C       G(T7,N651,FULL)
        CALL xC01234_(RMF2(3),MHH2,T13,CMF2(4),XMW2,XMW2,C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,1,1)

        PRE = (C1(2)*ALPHA*PZ12*SA*XMW*(1D0+2D0*QF(3)*XSW2))/(16D0*
     &  PI*XCW2*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE

C       G(T7,N652,FULL)

C       G(T7,N653,FULL)
        CALL xC01234_(T13,MHH2,RMF2(3),CMF2(3),XMZ2,XMZ2,C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,1,1)

        PRE = (C1(1)*ALPHA*PZ12*SA*XCW2**(-3)*XMW)/(32D0*PI)

        F(1,-1,-1) = F(1,-1,-1)-(PRE*XSW2**(-2)*(1D0-2D0*QF(1)*
     &  XSW2)*(1D0+2D0*QF(3)*XSW2)**3)/XSW
        F(1,-1,1) = F(1,-1,1)-8D0*QF(3)**3*PRE*XSW*(1D0-2D0*QF(1)*
     &  XSW2)
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2)**
     &  3)/(XSW*XSW2)
        F(1,1,1) = F(1,1,1)+16D0*QF(1)*QF(3)**3*PRE*XSW*XSW2

C       G(T7,N655,FULL)

C       G(T7,N657,FULL)

C       G(T7,N659,FULL)

C       G(T7,N661,FULL)

C       G(T7,N663,FULL)

C       G(T7,N664,FULL)

C       G(T7,N665,FULL)

C       G(T7,N666,FULL)

C       G(T7,N667,FULL)

C       G(T7,N668,FULL)

C       G(T7,N669,FULL)

C       G(T7,N670,FULL)

C       G(T7,N671,FULL)

C       G(T7,N672,FULL)

C       G(T7,N673,FULL)

C       G(T7,N674,FULL)

C       G(T7,N675,FULL)

C       G(T7,N676,FULL)

C       G(T7,N677,FULL)

C       G(T7,N678,FULL)

C       G(T7,N679,FULL)

C       G(T7,N680,FULL)

C       G(T7,N681,FULL)

C       G(T7,N682,FULL)

C       G(T7,N683,FULL)

C       G(T7,N684,FULL)

C       G(T7,N685,FULL)

C       G(T7,N686,FULL)

C       G(T7,N687,FULL)

C       G(T7,N688,FULL)

C       G(T8,N690,FULL)

C       G(T8,N691,FULL)

C       G(T8,N692,FULL)

C       G(T8,N693,FULL)

C       G(T8,N694,FULL)

C       G(T8,N695,FULL)

C       G(T8,N699,FULL)

C       G(T8,N700,FULL)

C       G(T8,N701,FULL)

C       G(T8,N702,FULL)

C       G(T8,N703,FULL)

C       G(T8,N704,FULL)

C       G(T8,N706,FULL)

C       G(T8,N707,FULL)

C       G(T8,N708,FULL)

C       G(T8,N709,FULL)

C       G(T8,N710,FULL)

C       G(T8,N711,FULL)

C       G(T8,N713,FULL)

C       G(T8,N714,FULL)

C       G(T8,N715,FULL)

C       G(T8,N716,FULL)

C       G(T8,N717,FULL)

C       G(T8,N718,FULL)

C       G(T8,N720,FULL)

C       G(T8,N721,FULL)

C       G(T8,N722,FULL)

C       G(T8,N723,FULL)

C       G(T8,N724,FULL)

C       G(T8,N725,FULL)

C       G(T8,N726,FULL)

C       G(T8,N727,FULL)

C       G(T8,N728,FULL)

C       G(T8,N729,FULL)

C       G(T8,N730,FULL)

C       G(T8,N731,FULL)

C       G(T8,N732,FULL)

C       G(T8,N733,FULL)

C       G(T8,N737,FULL)

C       G(T8,N738,FULL)

C       G(T8,N739,FULL)

C       G(T8,N740,FULL)

C       G(T8,N741,FULL)

C       G(T8,N742,FULL)

C       G(T8,N743,FULL)

C       G(T8,N744,FULL)

C       G(T8,N745,FULL)

C       G(T8,N746,FULL)

C       G(T8,N747,FULL)

C       G(T8,N748,FULL)

C       G(T8,N749,FULL)

C       G(T8,N750,FULL)

C       G(T8,N751,FULL)

C       G(T8,N752,FULL)

C       G(T8,N753,FULL)

C       G(T8,N757,FULL)

C       G(T8,N761,FULL)

C       G(T8,N762,FULL)

C       G(T8,N763,FULL)

C       G(T8,N764,FULL)

C       G(T8,N765,FULL)

C       G(T8,N766,FULL)

C       G(T8,N767,FULL)

C       G(T8,N768,FULL)

C       G(T8,N769,FULL)

C       G(T8,N773,FULL)

C       G(T9,N788,FULL)

C       G(T9,N789,FULL)

C       G(T9,N790,FULL)

C       G(T9,N791,FULL)

C       G(T9,N792,FULL)

C       G(T9,N793,FULL)

C       G(T9,N808,FULL)

C       G(T9,N809,FULL)

C       G(T9,N810,FULL)

C       G(T9,N811,FULL)

C       G(T9,N812,FULL)

C       G(T9,N813,FULL)

C       G(T9,N814,FULL)

C       G(T9,N815,FULL)

C       G(T9,N816,FULL)

C       G(T9,N817,FULL)

C       G(T9,N818,FULL)

C       G(T9,N819,FULL)

C       G(T9,N834,FULL)

C       G(T9,N835,FULL)

C       G(T9,N836,FULL)

C       G(T9,N837,FULL)

C       G(T9,N838,FULL)

C       G(T9,N839,FULL)

C       G(T9,N854,FULL)

C       G(T9,N855,FULL)

C       G(T9,N856,FULL)

C       G(T9,N857,FULL)

C       G(T9,N872,FULL)

C       G(T9,N873,FULL)

C       G(T9,N874,FULL)

C       G(T9,N875,FULL)

C       G(T9,N890,FULL)

C       G(T9,N891,FULL)

C       G(T9,N892,FULL)

C       G(T9,N893,FULL)

C       G(T9,N894,FULL)

C       G(T9,N895,FULL)

C       G(T9,N896,FULL)

C       G(T9,N897,FULL)

C       G(T9,N898,FULL)

C       G(T9,N899,FULL)

C       G(T9,N900,FULL)

C       G(T9,N901,FULL)

C       G(T9,N916,FULL)

C       G(T9,N917,FULL)

C       G(T9,N918,FULL)

C       G(T9,N919,FULL)

C       G(T9,N920,FULL)

C       G(T9,N921,FULL)

C       G(T9,N922,FULL)

C       G(T9,N923,FULL)

C       G(T9,N938,FULL)

C       G(T9,N939,FULL)

C       G(T9,N940,FULL)

C       G(T9,N941,FULL)

C       G(T9,N942,FULL)

C       G(T9,N943,FULL)

C       G(T9,N944,FULL)

C       G(T9,N945,FULL)

C       G(T9,N946,FULL)

C       G(T9,N947,FULL)

C       G(T9,N948,FULL)

C       G(T9,N949,FULL)

C       G(T9,N964,FULL)

C       G(T9,N965,FULL)

C       G(T9,N966,FULL)

C       G(T9,N967,FULL)

C       G(T9,N968,FULL)

C       G(T9,N969,FULL)

C       G(T9,N970,FULL)

C       G(T9,N971,FULL)

C       G(T9,N972,FULL)

C       G(T9,N973,FULL)

C       G(T9,N974,FULL)

C       G(T9,N975,FULL)

C       G(T9,N990,FULL)

C       G(T9,N991,FULL)

C       G(T9,N992,FULL)

C       G(T9,N993,FULL)

C       G(T9,N994,FULL)

C       G(T9,N995,FULL)

C       G(T9,N996,FULL)

C       G(T9,N997,FULL)

C       G(T9,N998,FULL)

C       G(T9,N999,FULL)

C       G(T9,N1000,FULL)

C       G(T9,N1001,FULL)

C       G(T9,N1016,FULL)

C       G(T9,N1017,FULL)

C       G(T9,N1018,FULL)

C       G(T9,N1019,FULL)

C       G(T9,N1020,FULL)

C       G(T9,N1021,FULL)

C       G(T9,N1036,FULL)

C       G(T9,N1037,FULL)

C       G(T9,N1038,FULL)

C       G(T9,N1039,FULL)

C       G(T9,N1040,FULL)

C       G(T9,N1041,FULL)

C       G(T9,N1042,FULL)

C       G(T9,N1043,FULL)

C       G(T9,N1044,FULL)

C       G(T9,N1045,FULL)

C       G(T9,N1046,FULL)

C       G(T9,N1047,FULL)

C       G(T9,N1062,FULL)

C       G(T9,N1063,FULL)

C       G(T9,N1064,FULL)

C       G(T9,N1065,FULL)

C       G(T9,N1066,FULL)

C       G(T9,N1067,FULL)

C       G(T9,N1082,FULL)

C       G(T9,N1083,FULL)

C       G(T9,N1084,FULL)

C       G(T9,N1085,FULL)

C       G(T9,N1100,FULL)

C       G(T9,N1101,FULL)

C       G(T9,N1102,FULL)

C       G(T9,N1103,FULL)

C       G(T9,N1118,FULL)

C       G(T9,N1119,FULL)

C       G(T9,N1120,FULL)

C       G(T9,N1121,FULL)

C       G(T9,N1136,FULL)

C       G(T9,N1137,FULL)

C       G(T9,N1138,FULL)

C       G(T9,N1139,FULL)

C       G(T9,N1140,FULL)

C       G(T9,N1141,FULL)

C       G(T9,N1142,FULL)

C       G(T9,N1143,FULL)

C       G(T9,N1144,FULL)

C       G(T9,N1145,FULL)

C       G(T9,N1146,FULL)

C       G(T9,N1147,FULL)

C       G(T9,N1162,FULL)

C       G(T9,N1163,FULL)

C       G(T9,N1164,FULL)

C       G(T9,N1165,FULL)

C       G(T9,N1180,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)

        PRE = -((QF(1)*QF(3)*ALPHA*SA*XMW)/(8D0*PI*S12*S34*XSW))

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(1,-1,1) = F(1,-1,1)+C2(0,0)*PRE
        F(1,1,-1) = F(1,1,-1)+C2(0,0)*PRE
        F(1,1,1) = F(1,1,1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)-C2(1,2)*PRE
        F(5,-1,1) = F(5,-1,1)-C2(1,2)*PRE
        F(5,1,-1) = F(5,1,-1)-C2(1,2)*PRE
        F(5,1,1) = F(5,1,1)-C2(1,2)*PRE
        F(6,-1,-1) = F(6,-1,-1)-C2(1,2)*PRE
        F(6,-1,1) = F(6,-1,1)-C2(1,2)*PRE
        F(6,1,-1) = F(6,1,-1)-C2(1,2)*PRE
        F(6,1,1) = F(6,1,1)-C2(1,2)*PRE
        F(7,-1,-1) = F(7,-1,-1)-C2(1,2)*PRE
        F(7,-1,1) = F(7,-1,1)-C2(1,2)*PRE
        F(7,1,-1) = F(7,1,-1)-C2(1,2)*PRE
        F(7,1,1) = F(7,1,1)-C2(1,2)*PRE
        F(8,-1,-1) = F(8,-1,-1)-C2(1,2)*PRE
        F(8,-1,1) = F(8,-1,1)-C2(1,2)*PRE
        F(8,1,-1) = F(8,1,-1)-C2(1,2)*PRE
        F(8,1,1) = F(8,1,1)-C2(1,2)*PRE

C       G(T9,N1181,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)

        PRE = -((QF(1)*QF(3)*ALPHA*SA*XMW)/(8D0*PI*S12*S34*XSW))

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(1,-1,1) = F(1,-1,1)+C2(0,0)*PRE
        F(1,1,-1) = F(1,1,-1)+C2(0,0)*PRE
        F(1,1,1) = F(1,1,1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)-C2(1,2)*PRE
        F(5,-1,1) = F(5,-1,1)-C2(1,2)*PRE
        F(5,1,-1) = F(5,1,-1)-C2(1,2)*PRE
        F(5,1,1) = F(5,1,1)-C2(1,2)*PRE
        F(6,-1,-1) = F(6,-1,-1)-C2(1,2)*PRE
        F(6,-1,1) = F(6,-1,1)-C2(1,2)*PRE
        F(6,1,-1) = F(6,1,-1)-C2(1,2)*PRE
        F(6,1,1) = F(6,1,1)-C2(1,2)*PRE
        F(7,-1,-1) = F(7,-1,-1)-C2(1,2)*PRE
        F(7,-1,1) = F(7,-1,1)-C2(1,2)*PRE
        F(7,1,-1) = F(7,1,-1)-C2(1,2)*PRE
        F(7,1,1) = F(7,1,1)-C2(1,2)*PRE
        F(8,-1,-1) = F(8,-1,-1)-C2(1,2)*PRE
        F(8,-1,1) = F(8,-1,1)-C2(1,2)*PRE
        F(8,1,-1) = F(8,1,-1)-C2(1,2)*PRE
        F(8,1,1) = F(8,1,1)-C2(1,2)*PRE

C       G(T9,N1182,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)

        PRE = -((QF(1)*QF(3)*ALPHA*SA*XMW)/(8D0*PI*S12*S34*XSW))

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(1,-1,1) = F(1,-1,1)+C2(0,0)*PRE
        F(1,1,-1) = F(1,1,-1)+C2(0,0)*PRE
        F(1,1,1) = F(1,1,1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)-C2(1,2)*PRE
        F(5,-1,1) = F(5,-1,1)-C2(1,2)*PRE
        F(5,1,-1) = F(5,1,-1)-C2(1,2)*PRE
        F(5,1,1) = F(5,1,1)-C2(1,2)*PRE
        F(6,-1,-1) = F(6,-1,-1)-C2(1,2)*PRE
        F(6,-1,1) = F(6,-1,1)-C2(1,2)*PRE
        F(6,1,-1) = F(6,1,-1)-C2(1,2)*PRE
        F(6,1,1) = F(6,1,1)-C2(1,2)*PRE
        F(7,-1,-1) = F(7,-1,-1)-C2(1,2)*PRE
        F(7,-1,1) = F(7,-1,1)-C2(1,2)*PRE
        F(7,1,-1) = F(7,1,-1)-C2(1,2)*PRE
        F(7,1,1) = F(7,1,1)-C2(1,2)*PRE
        F(8,-1,-1) = F(8,-1,-1)-C2(1,2)*PRE
        F(8,-1,1) = F(8,-1,1)-C2(1,2)*PRE
        F(8,1,-1) = F(8,1,-1)-C2(1,2)*PRE
        F(8,1,1) = F(8,1,1)-C2(1,2)*PRE

C       G(T9,N1183,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)

        PRE = -((QF(1)*QF(3)*ALPHA*SA*XMW)/(8D0*PI*S12*S34*XSW))

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(1,-1,1) = F(1,-1,1)+C2(0,0)*PRE
        F(1,1,-1) = F(1,1,-1)+C2(0,0)*PRE
        F(1,1,1) = F(1,1,1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)-C2(1,2)*PRE
        F(5,-1,1) = F(5,-1,1)-C2(1,2)*PRE
        F(5,1,-1) = F(5,1,-1)-C2(1,2)*PRE
        F(5,1,1) = F(5,1,1)-C2(1,2)*PRE
        F(6,-1,-1) = F(6,-1,-1)-C2(1,2)*PRE
        F(6,-1,1) = F(6,-1,1)-C2(1,2)*PRE
        F(6,1,-1) = F(6,1,-1)-C2(1,2)*PRE
        F(6,1,1) = F(6,1,1)-C2(1,2)*PRE
        F(7,-1,-1) = F(7,-1,-1)-C2(1,2)*PRE
        F(7,-1,1) = F(7,-1,1)-C2(1,2)*PRE
        F(7,1,-1) = F(7,1,-1)-C2(1,2)*PRE
        F(7,1,1) = F(7,1,1)-C2(1,2)*PRE
        F(8,-1,-1) = F(8,-1,-1)-C2(1,2)*PRE
        F(8,-1,1) = F(8,-1,1)-C2(1,2)*PRE
        F(8,1,-1) = F(8,1,-1)-C2(1,2)*PRE
        F(8,1,1) = F(8,1,1)-C2(1,2)*PRE

C       G(T9,N1198,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0+2D0*QF(3)*XSW2

        PRE = (QF(1)*ALPHA*PZ34*SA*XMW)/(16D0*PI*S12*XSW)

        F(1,-1,-1) = F(1,-1,-1)+(C2(0,0)*K(1)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*C2(0,0)*QF(3)*PRE
        F(1,1,-1) = F(1,1,-1)+(C2(0,0)*K(1)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+2D0*C2(0,0)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(5,-1,1) = F(5,-1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(5,1,-1) = F(5,1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(6,-1,1) = F(6,-1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(6,1,-1) = F(6,1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(7,-1,1) = F(7,-1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(7,1,-1) = F(7,1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(8,-1,1) = F(8,-1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(8,1,-1) = F(8,1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-2D0*C2(1,2)*QF(3)*PRE

C       G(T9,N1199,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0+2D0*QF(3)*XSW2

        PRE = (QF(1)*ALPHA*PZ34*SA*XMW)/(16D0*PI*S12*XSW)

        F(1,-1,-1) = F(1,-1,-1)+(C2(0,0)*K(1)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*C2(0,0)*QF(3)*PRE
        F(1,1,-1) = F(1,1,-1)+(C2(0,0)*K(1)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+2D0*C2(0,0)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(5,-1,1) = F(5,-1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(5,1,-1) = F(5,1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(6,-1,1) = F(6,-1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(6,1,-1) = F(6,1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(7,-1,1) = F(7,-1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(7,1,-1) = F(7,1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(8,-1,1) = F(8,-1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(8,1,-1) = F(8,1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-2D0*C2(1,2)*QF(3)*PRE

C       G(T9,N1200,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0+2D0*QF(3)*XSW2

        PRE = (QF(1)*ALPHA*PZ34*SA*XMW)/(16D0*PI*S12*XSW)

        F(1,-1,-1) = F(1,-1,-1)+(C2(0,0)*K(1)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*C2(0,0)*QF(3)*PRE
        F(1,1,-1) = F(1,1,-1)+(C2(0,0)*K(1)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+2D0*C2(0,0)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(5,-1,1) = F(5,-1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(5,1,-1) = F(5,1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(6,-1,1) = F(6,-1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(6,1,-1) = F(6,1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(7,-1,1) = F(7,-1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(7,1,-1) = F(7,1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(8,-1,1) = F(8,-1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(8,1,-1) = F(8,1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-2D0*C2(1,2)*QF(3)*PRE

C       G(T9,N1201,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0+2D0*QF(3)*XSW2

        PRE = (QF(1)*ALPHA*PZ34*SA*XMW)/(16D0*PI*S12*XSW)

        F(1,-1,-1) = F(1,-1,-1)+(C2(0,0)*K(1)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*C2(0,0)*QF(3)*PRE
        F(1,1,-1) = F(1,1,-1)+(C2(0,0)*K(1)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+2D0*C2(0,0)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(5,-1,1) = F(5,-1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(5,1,-1) = F(5,1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(6,-1,1) = F(6,-1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(6,1,-1) = F(6,1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(7,-1,1) = F(7,-1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(7,1,-1) = F(7,1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(8,-1,1) = F(8,-1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(8,1,-1) = F(8,1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-2D0*C2(1,2)*QF(3)*PRE

C       G(T9,N1216,FULL)

C       G(T9,N1217,FULL)

C       G(T9,N1218,FULL)

C       G(T9,N1219,FULL)

C       G(T9,N1234,FULL)

C       G(T9,N1235,FULL)

C       G(T9,N1236,FULL)

C       G(T9,N1237,FULL)

C       G(T9,N1238,FULL)

C       G(T9,N1239,FULL)

C       G(T9,N1240,FULL)

C       G(T9,N1241,FULL)

C       G(T9,N1242,FULL)

C       G(T9,N1243,FULL)

C       G(T9,N1244,FULL)

C       G(T9,N1245,FULL)

C       G(T9,N1260,FULL)

C       G(T9,N1261,FULL)

C       G(T9,N1262,FULL)

C       G(T9,N1263,FULL)

C       G(T9,N1278,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2

        PRE = (QF(3)*ALPHA*PZ12*SA*XMW)/(16D0*PI*S34*XSW)

        F(1,-1,-1) = F(1,-1,-1)-(C2(0,0)*K(1)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)-(C2(0,0)*K(1)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*C2(0,0)*QF(1)*PRE
        F(1,1,1) = F(1,1,1)+2D0*C2(0,0)*QF(1)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(5,-1,1) = F(5,-1,1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-2D0*C2(1,2)*QF(1)*PRE
        F(5,1,1) = F(5,1,1)-2D0*C2(1,2)*QF(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(6,-1,1) = F(6,-1,1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-2D0*C2(1,2)*QF(1)*PRE
        F(6,1,1) = F(6,1,1)-2D0*C2(1,2)*QF(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(7,-1,1) = F(7,-1,1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-2D0*C2(1,2)*QF(1)*PRE
        F(7,1,1) = F(7,1,1)-2D0*C2(1,2)*QF(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(8,-1,1) = F(8,-1,1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-2D0*C2(1,2)*QF(1)*PRE
        F(8,1,1) = F(8,1,1)-2D0*C2(1,2)*QF(1)*PRE

C       G(T9,N1279,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2

        PRE = (QF(3)*ALPHA*PZ12*SA*XMW)/(16D0*PI*S34*XSW)

        F(1,-1,-1) = F(1,-1,-1)-(C2(0,0)*K(1)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)-(C2(0,0)*K(1)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*C2(0,0)*QF(1)*PRE
        F(1,1,1) = F(1,1,1)+2D0*C2(0,0)*QF(1)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(5,-1,1) = F(5,-1,1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-2D0*C2(1,2)*QF(1)*PRE
        F(5,1,1) = F(5,1,1)-2D0*C2(1,2)*QF(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(6,-1,1) = F(6,-1,1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-2D0*C2(1,2)*QF(1)*PRE
        F(6,1,1) = F(6,1,1)-2D0*C2(1,2)*QF(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(7,-1,1) = F(7,-1,1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-2D0*C2(1,2)*QF(1)*PRE
        F(7,1,1) = F(7,1,1)-2D0*C2(1,2)*QF(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(8,-1,1) = F(8,-1,1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-2D0*C2(1,2)*QF(1)*PRE
        F(8,1,1) = F(8,1,1)-2D0*C2(1,2)*QF(1)*PRE

C       G(T9,N1280,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2

        PRE = (QF(3)*ALPHA*PZ12*SA*XMW)/(16D0*PI*S34*XSW)

        F(1,-1,-1) = F(1,-1,-1)-(C2(0,0)*K(1)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)-(C2(0,0)*K(1)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*C2(0,0)*QF(1)*PRE
        F(1,1,1) = F(1,1,1)+2D0*C2(0,0)*QF(1)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(5,-1,1) = F(5,-1,1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-2D0*C2(1,2)*QF(1)*PRE
        F(5,1,1) = F(5,1,1)-2D0*C2(1,2)*QF(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(6,-1,1) = F(6,-1,1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-2D0*C2(1,2)*QF(1)*PRE
        F(6,1,1) = F(6,1,1)-2D0*C2(1,2)*QF(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(7,-1,1) = F(7,-1,1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-2D0*C2(1,2)*QF(1)*PRE
        F(7,1,1) = F(7,1,1)-2D0*C2(1,2)*QF(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(8,-1,1) = F(8,-1,1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-2D0*C2(1,2)*QF(1)*PRE
        F(8,1,1) = F(8,1,1)-2D0*C2(1,2)*QF(1)*PRE

C       G(T9,N1281,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2

        PRE = (QF(3)*ALPHA*PZ12*SA*XMW)/(16D0*PI*S34*XSW)

        F(1,-1,-1) = F(1,-1,-1)-(C2(0,0)*K(1)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)-(C2(0,0)*K(1)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*C2(0,0)*QF(1)*PRE
        F(1,1,1) = F(1,1,1)+2D0*C2(0,0)*QF(1)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(5,-1,1) = F(5,-1,1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-2D0*C2(1,2)*QF(1)*PRE
        F(5,1,1) = F(5,1,1)-2D0*C2(1,2)*QF(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(6,-1,1) = F(6,-1,1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-2D0*C2(1,2)*QF(1)*PRE
        F(6,1,1) = F(6,1,1)-2D0*C2(1,2)*QF(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(7,-1,1) = F(7,-1,1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-2D0*C2(1,2)*QF(1)*PRE
        F(7,1,1) = F(7,1,1)-2D0*C2(1,2)*QF(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(8,-1,1) = F(8,-1,1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-2D0*C2(1,2)*QF(1)*PRE
        F(8,1,1) = F(8,1,1)-2D0*C2(1,2)*QF(1)*PRE

C       G(T9,N1296,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2

        PRE = -((ALPHA*PZ12*PZ34*SA*XMW)/(32D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)-C2(0,0)*K(1)*K(2)*PRE*XSW2**(-2)
        F(1,-1,1) = F(1,-1,1)-(2D0*C2(0,0)*K(1)*QF(3)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*C2(0,0)*K(2)*QF(1)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+4D0*C2(0,0)*QF(1)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(5,-1,1) = F(5,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(6,-1,1) = F(6,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(7,-1,1) = F(7,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(8,-1,1) = F(8,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE

C       G(T9,N1297,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2

        PRE = -((ALPHA*PZ12*PZ34*SA*XMW)/(32D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)-C2(0,0)*K(1)*K(2)*PRE*XSW2**(-2)
        F(1,-1,1) = F(1,-1,1)-(2D0*C2(0,0)*K(1)*QF(3)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*C2(0,0)*K(2)*QF(1)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+4D0*C2(0,0)*QF(1)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(5,-1,1) = F(5,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(6,-1,1) = F(6,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(7,-1,1) = F(7,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(8,-1,1) = F(8,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE

C       G(T9,N1298,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2

        PRE = -((ALPHA*PZ12*PZ34*SA*XMW)/(32D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)-C2(0,0)*K(1)*K(2)*PRE*XSW2**(-2)
        F(1,-1,1) = F(1,-1,1)-(2D0*C2(0,0)*K(1)*QF(3)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*C2(0,0)*K(2)*QF(1)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+4D0*C2(0,0)*QF(1)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(5,-1,1) = F(5,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(6,-1,1) = F(6,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(7,-1,1) = F(7,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(8,-1,1) = F(8,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE

C       G(T9,N1299,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2

        PRE = -((ALPHA*PZ12*PZ34*SA*XMW)/(32D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)-C2(0,0)*K(1)*K(2)*PRE*XSW2**(-2)
        F(1,-1,1) = F(1,-1,1)-(2D0*C2(0,0)*K(1)*QF(3)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*C2(0,0)*K(2)*QF(1)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+4D0*C2(0,0)*QF(1)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(5,-1,1) = F(5,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(6,-1,1) = F(6,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(7,-1,1) = F(7,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(8,-1,1) = F(8,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE

C       G(T9,N1300,FULL)

C       G(T9,N1301,FULL)

C       G(T9,N1302,FULL)

C       G(T9,N1303,FULL)

C       G(T9,N1304,FULL)

C       G(T9,N1305,FULL)

C       G(T9,N1306,FULL)

C       G(T9,N1307,FULL)

C       G(T9,N1308,FULL)

C       G(T9,N1309,FULL)

C       G(T9,N1310,FULL)

C       G(T9,N1311,FULL)

C       G(T9,N1312,FULL)

C       G(T9,N1313,FULL)

C       G(T9,N1314,FULL)

C       G(T9,N1315,FULL)

C       G(T9,N1316,FULL)

C       G(T9,N1317,FULL)

C       G(T9,N1318,FULL)

C       G(T9,N1319,FULL)

C       G(T9,N1320,FULL)

C       G(T9,N1321,FULL)

C       G(T9,N1322,FULL)

C       G(T9,N1323,FULL)

C       G(T9,N1324,FULL)

C       G(T9,N1325,FULL)

C       G(T9,N1326,FULL)

C       G(T9,N1327,FULL)

C       G(T9,N1328,FULL)

C       G(T9,N1329,FULL)

C       G(T9,N1330,FULL)

C       G(T9,N1331,FULL)

C       G(T9,N1332,FULL)

C       G(T9,N1333,FULL)

C       G(T9,N1334,FULL)

C       G(T9,N1335,FULL)

C       G(T9,N1336,FULL)

C       G(T9,N1337,FULL)

C       G(T9,N1338,FULL)

C       G(T9,N1339,FULL)

C       G(T9,N1340,FULL)

C       G(T9,N1341,FULL)

C       G(T9,N1342,FULL)

C       G(T9,N1343,FULL)

C       G(T9,N1344,FULL)

C       G(T9,N1345,FULL)

C       G(T9,N1346,FULL)

C       G(T9,N1347,FULL)

C       G(T9,N1348,FULL)

C       G(T9,N1349,FULL)

C       G(T9,N1350,FULL)

C       G(T9,N1351,FULL)

C       G(T9,N1352,FULL)

C       G(T9,N1353,FULL)

C       G(T9,N1354,FULL)

C       G(T9,N1355,FULL)

C       G(T9,N1356,FULL)

C       G(T9,N1357,FULL)

C       G(T9,N1358,FULL)

C       G(T9,N1359,FULL)

C       G(T9,N1360,FULL)

C       G(T9,N1361,FULL)

C       G(T9,N1362,FULL)

C       G(T9,N1363,FULL)

C       G(T9,N1364,FULL)

C       G(T9,N1365,FULL)

C       G(T9,N1366,FULL)

C       G(T9,N1367,FULL)

C       G(T9,N1368,FULL)

C       G(T9,N1369,FULL)

C       G(T9,N1370,FULL)

C       G(T9,N1371,FULL)

C       G(T9,N1372,FULL)

C       G(T9,N1373,FULL)

C       G(T9,N1374,FULL)

C       G(T9,N1375,FULL)

C       G(T9,N1376,FULL)

C       G(T9,N1377,FULL)

C       G(T9,N1378,FULL)

C       G(T9,N1379,FULL)

C       G(T9,N1380,FULL)

C       G(T9,N1381,FULL)

C       G(T9,N1382,FULL)

C       G(T9,N1383,FULL)

C       G(T9,N1384,FULL)

C       G(T9,N1385,FULL)

C       G(T9,N1386,FULL)

C       G(T9,N1387,FULL)

C       G(T9,N1388,FULL)

C       G(T9,N1389,FULL)

C       G(T9,N1390,FULL)

C       G(T9,N1391,FULL)

C       G(T9,N1392,FULL)

C       G(T9,N1393,FULL)

C       G(T9,N1394,FULL)

C       G(T9,N1395,FULL)

C       G(T9,N1396,FULL)

C       G(T9,N1397,FULL)

C       G(T9,N1398,FULL)

C       G(T9,N1399,FULL)

C       G(T9,N1400,FULL)

C       G(T9,N1401,FULL)

C       G(T9,N1402,FULL)

C       G(T9,N1403,FULL)

C       G(T9,N1404,FULL)

C       G(T9,N1405,FULL)

C       G(T9,N1406,FULL)

C       G(T9,N1407,FULL)

C       G(T9,N1408,FULL)

C       G(T9,N1409,FULL)

C       G(T9,N1410,FULL)

C       G(T9,N1411,FULL)

C       G(T9,N1412,FULL)

C       G(T9,N1413,FULL)

C       G(T9,N1414,FULL)

C       G(T9,N1415,FULL)

C       G(T9,N1416,FULL)

C       G(T9,N1417,FULL)

C       G(T9,N1418,FULL)

C       G(T9,N1419,FULL)

C       G(T9,N1420,FULL)

C       G(T9,N1421,FULL)

C       G(T9,N1422,FULL)

C       G(T9,N1423,FULL)

C       G(T9,N1424,FULL)

C       G(T9,N1425,FULL)

C       G(T9,N1426,FULL)

C       G(T9,N1427,FULL)

C       G(T9,N1428,FULL)

C       G(T9,N1429,FULL)

C       G(T9,N1430,FULL)

C       G(T9,N1431,FULL)

C       G(T9,N1432,FULL)

C       G(T9,N1433,FULL)

C       G(T9,N1434,FULL)

C       G(T9,N1435,FULL)

C       G(T9,N1436,FULL)

C       G(T9,N1437,FULL)

C       G(T9,N1438,FULL)

C       G(T9,N1439,FULL)

C       G(T9,N1440,FULL)

C       G(T9,N1441,FULL)

C       G(T9,N1442,FULL)

C       G(T9,N1443,FULL)

C       G(T9,N1444,FULL)

C       G(T9,N1445,FULL)

C       G(T9,N1446,FULL)

C       G(T9,N1447,FULL)

C       G(T9,N1448,FULL)

C       G(T9,N1449,FULL)

C       G(T9,N1450,FULL)

C       G(T9,N1451,FULL)

C       G(T9,N1452,FULL)

C       G(T9,N1453,FULL)

C       G(T9,N1454,FULL)

C       G(T9,N1455,FULL)

C       G(T9,N1456,FULL)

C       G(T9,N1457,FULL)

C       G(T9,N1458,FULL)

C       G(T9,N1459,FULL)

C       G(T9,N1460,FULL)

C       G(T9,N1461,FULL)

C       G(T9,N1462,FULL)

C       G(T9,N1463,FULL)

C       G(T9,N1464,FULL)

C       G(T9,N1465,FULL)

C       G(T9,N1466,FULL)

C       G(T9,N1467,FULL)

C       G(T9,N1468,FULL)

C       G(T9,N1469,FULL)

C       G(T9,N1470,FULL)

C       G(T9,N1471,FULL)

C       G(T9,N1472,FULL)

C       G(T9,N1473,FULL)

C       G(T9,N1474,FULL)

C       G(T9,N1475,FULL)

C       G(T9,N1476,FULL)

C       G(T9,N1477,FULL)

C       G(T9,N1478,FULL)

C       G(T9,N1479,FULL)

C       G(T9,N1480,FULL)

C       G(T9,N1481,FULL)

C       G(T9,N1482,FULL)

C       G(T9,N1483,FULL)

C       G(T9,N1484,FULL)

C       G(T9,N1485,FULL)

C       G(T9,N1486,FULL)

C       G(T9,N1487,FULL)

C       G(T9,N1488,FULL)

C       G(T9,N1489,FULL)

C       G(T9,N1490,FULL)

C       G(T9,N1491,FULL)

C       G(T9,N1492,FULL)

C       G(T9,N1493,FULL)

C       G(T9,N1494,FULL)

C       G(T9,N1495,FULL)

C       G(T9,N1496,FULL)

C       G(T9,N1497,FULL)

C       G(T9,N1498,FULL)

C       G(T9,N1499,FULL)

C       G(T9,N1500,FULL)

C       G(T9,N1501,FULL)

C       G(T9,N1502,FULL)

C       G(T9,N1503,FULL)

C       G(T9,N1504,FULL)

C       G(T9,N1505,FULL)

C       G(T9,N1506,FULL)

C       G(T9,N1507,FULL)

C       G(T9,N1508,FULL)

C       G(T9,N1509,FULL)

C       G(T9,N1510,FULL)

C       G(T9,N1511,FULL)

C       G(T9,N1512,FULL)

C       G(T9,N1513,FULL)

C       G(T9,N1514,FULL)

C       G(T9,N1515,FULL)

C       G(T9,N1516,FULL)

C       G(T9,N1517,FULL)

C       G(T9,N1518,FULL)

C       G(T9,N1519,FULL)

C       G(T9,N1520,FULL)

C       G(T9,N1521,FULL)

C       G(T9,N1522,FULL)

C       G(T9,N1523,FULL)

C       G(T9,N1524,FULL)

C       G(T9,N1525,FULL)

C       G(T9,N1526,FULL)

C       G(T9,N1527,FULL)

C       G(T9,N1528,FULL)

C       G(T9,N1529,FULL)

C       G(T9,N1530,FULL)

C       G(T9,N1531,FULL)

C       G(T9,N1532,FULL)

C       G(T9,N1533,FULL)

C       G(T9,N1534,FULL)

C       G(T9,N1535,FULL)

C       G(T9,N1536,FULL)

C       G(T9,N1537,FULL)

C       G(T9,N1538,FULL)

C       G(T9,N1539,FULL)

C       G(T9,N1540,FULL)

C       G(T9,N1541,FULL)

C       G(T9,N1542,FULL)

C       G(T9,N1543,FULL)

C       G(T9,N1544,FULL)

C       G(T9,N1545,FULL)

C       G(T9,N1546,FULL)

C       G(T9,N1547,FULL)

C       G(T9,N1548,FULL)

C       G(T9,N1549,FULL)

C       G(T9,N1550,FULL)

C       G(T9,N1551,FULL)

C       G(T9,N1552,FULL)

C       G(T9,N1553,FULL)

C       G(T9,N1554,FULL)

C       G(T9,N1555,FULL)

C       G(T9,N1556,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)

        PRE = (QF(1)*QF(3)*ALPHA*SA*XMHH2)/(2D0*PI*S12*S34*XMW*XSW)

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(1,-1,1) = F(1,-1,1)+C2(0,0)*PRE
        F(1,1,-1) = F(1,1,-1)+C2(0,0)*PRE
        F(1,1,1) = F(1,1,1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)-C2(1,2)*PRE
        F(5,-1,1) = F(5,-1,1)-C2(1,2)*PRE
        F(5,1,-1) = F(5,1,-1)-C2(1,2)*PRE
        F(5,1,1) = F(5,1,1)-C2(1,2)*PRE
        F(6,-1,-1) = F(6,-1,-1)-C2(1,2)*PRE
        F(6,-1,1) = F(6,-1,1)-C2(1,2)*PRE
        F(6,1,-1) = F(6,1,-1)-C2(1,2)*PRE
        F(6,1,1) = F(6,1,1)-C2(1,2)*PRE
        F(7,-1,-1) = F(7,-1,-1)-C2(1,2)*PRE
        F(7,-1,1) = F(7,-1,1)-C2(1,2)*PRE
        F(7,1,-1) = F(7,1,-1)-C2(1,2)*PRE
        F(7,1,1) = F(7,1,1)-C2(1,2)*PRE
        F(8,-1,-1) = F(8,-1,-1)-C2(1,2)*PRE
        F(8,-1,1) = F(8,-1,1)-C2(1,2)*PRE
        F(8,1,-1) = F(8,1,-1)-C2(1,2)*PRE
        F(8,1,1) = F(8,1,1)-C2(1,2)*PRE

C       G(T9,N1557,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,0,0)

        PRE = -((QF(1)*QF(3)*ALPHA*C0*SA*XMHH2*XMW)/(8D0*PI*S12*S34*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE
        F(1,-1,1) = F(1,-1,1)+PRE
        F(1,1,-1) = F(1,1,-1)+PRE
        F(1,1,1) = F(1,1,1)+PRE

C       G(T9,N1558,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 2D0*C1(2)+C2(1,2)

        PRE = (QF(1)*QF(3)*ALPHA*SA*XMW)/(4D0*PI*S12*S34*XSW)

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(1,-1,1) = F(1,-1,1)+C2(0,0)*PRE
        F(1,1,-1) = F(1,1,-1)+C2(0,0)*PRE
        F(1,1,1) = F(1,1,1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)-K(1)*PRE
        F(5,-1,1) = F(5,-1,1)-K(1)*PRE
        F(5,1,-1) = F(5,1,-1)-K(1)*PRE
        F(5,1,1) = F(5,1,1)-K(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)-K(1)*PRE
        F(6,-1,1) = F(6,-1,1)-K(1)*PRE
        F(6,1,-1) = F(6,1,-1)-K(1)*PRE
        F(6,1,1) = F(6,1,1)-K(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)-K(1)*PRE
        F(7,-1,1) = F(7,-1,1)-K(1)*PRE
        F(7,1,-1) = F(7,1,-1)-K(1)*PRE
        F(7,1,1) = F(7,1,1)-K(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)-K(1)*PRE
        F(8,-1,1) = F(8,-1,1)-K(1)*PRE
        F(8,1,-1) = F(8,1,-1)-K(1)*PRE
        F(8,1,1) = F(8,1,1)-K(1)*PRE

C       G(T9,N1559,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = S23+S24+T12
        K(2) = 4D0*C1(1)+2D0*C1(2)-C2(1,2)+4D0*C0
        K(3) = S13+S14+S23+S24
        K(4) = 2D0*S12+S13+S14+S23+S24
        K(5) = S13+S14+S23+S24+2D0*S34
        K(6) = -((2D0*C2(2,2))/S12)-(2D0*C2(1,1))/S34+1/(S12*S34)-
     &  (6D0*C2(0,0))/(S12*S34)+(2D0*C2(1,2)*(S13+S14+S23+S24))/
     &  (S12*S34)-(2D0*C1(1)*(2D0*S12+S13+S14+S23+S24))/(S12*S34)+
     &  (2D0*C1(2)*(S13+S14+S23+S24+2D0*S34))/(S12*S34)-(2D0*C0*
     &  (S23+S24+T12))/(S12*S34)

        PRE = (QF(1)*QF(3)*ALPHA*SA*XMW)/(16D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+K(6)*PRE
        F(1,-1,1) = F(1,-1,1)+K(6)*PRE
        F(1,1,-1) = F(1,1,-1)+K(6)*PRE
        F(1,1,1) = F(1,1,1)+K(6)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(2)*PRE)/(S12*S34)
        F(5,-1,1) = F(5,-1,1)+(2D0*K(2)*PRE)/(S12*S34)
        F(5,1,-1) = F(5,1,-1)+(2D0*K(2)*PRE)/(S12*S34)
        F(5,1,1) = F(5,1,1)+(2D0*K(2)*PRE)/(S12*S34)
        F(6,-1,-1) = F(6,-1,-1)+(2D0*K(2)*PRE)/(S12*S34)
        F(6,-1,1) = F(6,-1,1)+(2D0*K(2)*PRE)/(S12*S34)
        F(6,1,-1) = F(6,1,-1)+(2D0*K(2)*PRE)/(S12*S34)
        F(6,1,1) = F(6,1,1)+(2D0*K(2)*PRE)/(S12*S34)
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(2)*PRE)/(S12*S34)
        F(7,-1,1) = F(7,-1,1)+(2D0*K(2)*PRE)/(S12*S34)
        F(7,1,-1) = F(7,1,-1)+(2D0*K(2)*PRE)/(S12*S34)
        F(7,1,1) = F(7,1,1)+(2D0*K(2)*PRE)/(S12*S34)
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(2)*PRE)/(S12*S34)
        F(8,-1,1) = F(8,-1,1)+(2D0*K(2)*PRE)/(S12*S34)
        F(8,1,-1) = F(8,1,-1)+(2D0*K(2)*PRE)/(S12*S34)
        F(8,1,1) = F(8,1,1)+(2D0*K(2)*PRE)/(S12*S34)

C       G(T9,N1560,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)

        PRE = (QF(1)*QF(3)*ALPHA*SA*XMHH2)/(2D0*PI*S12*S34*XMW*XSW)

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(1,-1,1) = F(1,-1,1)+C2(0,0)*PRE
        F(1,1,-1) = F(1,1,-1)+C2(0,0)*PRE
        F(1,1,1) = F(1,1,1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)-C2(1,2)*PRE
        F(5,-1,1) = F(5,-1,1)-C2(1,2)*PRE
        F(5,1,-1) = F(5,1,-1)-C2(1,2)*PRE
        F(5,1,1) = F(5,1,1)-C2(1,2)*PRE
        F(6,-1,-1) = F(6,-1,-1)-C2(1,2)*PRE
        F(6,-1,1) = F(6,-1,1)-C2(1,2)*PRE
        F(6,1,-1) = F(6,1,-1)-C2(1,2)*PRE
        F(6,1,1) = F(6,1,1)-C2(1,2)*PRE
        F(7,-1,-1) = F(7,-1,-1)-C2(1,2)*PRE
        F(7,-1,1) = F(7,-1,1)-C2(1,2)*PRE
        F(7,1,-1) = F(7,1,-1)-C2(1,2)*PRE
        F(7,1,1) = F(7,1,1)-C2(1,2)*PRE
        F(8,-1,-1) = F(8,-1,-1)-C2(1,2)*PRE
        F(8,-1,1) = F(8,-1,1)-C2(1,2)*PRE
        F(8,1,-1) = F(8,1,-1)-C2(1,2)*PRE
        F(8,1,1) = F(8,1,1)-C2(1,2)*PRE

C       G(T9,N1561,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,0,0)

        PRE = -((QF(1)*QF(3)*ALPHA*C0*SA*XMHH2*XMW)/(8D0*PI*S12*S34*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE
        F(1,-1,1) = F(1,-1,1)+PRE
        F(1,1,-1) = F(1,1,-1)+PRE
        F(1,1,1) = F(1,1,1)+PRE

C       G(T9,N1562,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 2D0*C1(2)+C2(1,2)

        PRE = (QF(1)*QF(3)*ALPHA*SA*XMW)/(4D0*PI*S12*S34*XSW)

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(1,-1,1) = F(1,-1,1)+C2(0,0)*PRE
        F(1,1,-1) = F(1,1,-1)+C2(0,0)*PRE
        F(1,1,1) = F(1,1,1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)-K(1)*PRE
        F(5,-1,1) = F(5,-1,1)-K(1)*PRE
        F(5,1,-1) = F(5,1,-1)-K(1)*PRE
        F(5,1,1) = F(5,1,1)-K(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)-K(1)*PRE
        F(6,-1,1) = F(6,-1,1)-K(1)*PRE
        F(6,1,-1) = F(6,1,-1)-K(1)*PRE
        F(6,1,1) = F(6,1,1)-K(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)-K(1)*PRE
        F(7,-1,1) = F(7,-1,1)-K(1)*PRE
        F(7,1,-1) = F(7,1,-1)-K(1)*PRE
        F(7,1,1) = F(7,1,1)-K(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)-K(1)*PRE
        F(8,-1,1) = F(8,-1,1)-K(1)*PRE
        F(8,1,-1) = F(8,1,-1)-K(1)*PRE
        F(8,1,1) = F(8,1,1)-K(1)*PRE

C       G(T9,N1563,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = S23+S24+T12
        K(2) = 4D0*C1(1)+2D0*C1(2)-C2(1,2)+4D0*C0
        K(3) = S13+S14+S23+S24
        K(4) = 2D0*S12+S13+S14+S23+S24
        K(5) = S13+S14+S23+S24+2D0*S34
        K(6) = -((2D0*C2(2,2))/S12)-(2D0*C2(1,1))/S34+1/(S12*S34)-
     &  (6D0*C2(0,0))/(S12*S34)+(2D0*C2(1,2)*(S13+S14+S23+S24))/
     &  (S12*S34)-(2D0*C1(1)*(2D0*S12+S13+S14+S23+S24))/(S12*S34)+
     &  (2D0*C1(2)*(S13+S14+S23+S24+2D0*S34))/(S12*S34)-(2D0*C0*
     &  (S23+S24+T12))/(S12*S34)

        PRE = (QF(1)*QF(3)*ALPHA*SA*XMW)/(16D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+K(6)*PRE
        F(1,-1,1) = F(1,-1,1)+K(6)*PRE
        F(1,1,-1) = F(1,1,-1)+K(6)*PRE
        F(1,1,1) = F(1,1,1)+K(6)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(2)*PRE)/(S12*S34)
        F(5,-1,1) = F(5,-1,1)+(2D0*K(2)*PRE)/(S12*S34)
        F(5,1,-1) = F(5,1,-1)+(2D0*K(2)*PRE)/(S12*S34)
        F(5,1,1) = F(5,1,1)+(2D0*K(2)*PRE)/(S12*S34)
        F(6,-1,-1) = F(6,-1,-1)+(2D0*K(2)*PRE)/(S12*S34)
        F(6,-1,1) = F(6,-1,1)+(2D0*K(2)*PRE)/(S12*S34)
        F(6,1,-1) = F(6,1,-1)+(2D0*K(2)*PRE)/(S12*S34)
        F(6,1,1) = F(6,1,1)+(2D0*K(2)*PRE)/(S12*S34)
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(2)*PRE)/(S12*S34)
        F(7,-1,1) = F(7,-1,1)+(2D0*K(2)*PRE)/(S12*S34)
        F(7,1,-1) = F(7,1,-1)+(2D0*K(2)*PRE)/(S12*S34)
        F(7,1,1) = F(7,1,1)+(2D0*K(2)*PRE)/(S12*S34)
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(2)*PRE)/(S12*S34)
        F(8,-1,1) = F(8,-1,1)+(2D0*K(2)*PRE)/(S12*S34)
        F(8,1,-1) = F(8,1,-1)+(2D0*K(2)*PRE)/(S12*S34)
        F(8,1,1) = F(8,1,1)+(2D0*K(2)*PRE)/(S12*S34)

C       G(T9,N1564,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 2D0*C1(1)+C2(1,2)

        PRE = (QF(1)*QF(3)*ALPHA*SA*XMW)/(4D0*PI*S12*S34*XSW)

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(1,-1,1) = F(1,-1,1)+C2(0,0)*PRE
        F(1,1,-1) = F(1,1,-1)+C2(0,0)*PRE
        F(1,1,1) = F(1,1,1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)-K(1)*PRE
        F(5,-1,1) = F(5,-1,1)-K(1)*PRE
        F(5,1,-1) = F(5,1,-1)-K(1)*PRE
        F(5,1,1) = F(5,1,1)-K(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)-K(1)*PRE
        F(6,-1,1) = F(6,-1,1)-K(1)*PRE
        F(6,1,-1) = F(6,1,-1)-K(1)*PRE
        F(6,1,1) = F(6,1,1)-K(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)-K(1)*PRE
        F(7,-1,1) = F(7,-1,1)-K(1)*PRE
        F(7,1,-1) = F(7,1,-1)-K(1)*PRE
        F(7,1,1) = F(7,1,1)-K(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)-K(1)*PRE
        F(8,-1,1) = F(8,-1,1)-K(1)*PRE
        F(8,1,-1) = F(8,1,-1)-K(1)*PRE
        F(8,1,1) = F(8,1,1)-K(1)*PRE

C       G(T9,N1565,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = S14+S24+T14
        K(2) = 2D0*C1(1)+4D0*C1(2)-C2(1,2)+4D0*C0
        K(3) = S13+S14+S23+S24
        K(4) = 2D0*S12+S13+S14+S23+S24
        K(5) = S13+S14+S23+S24+2D0*S34
        K(6) = -((2D0*C2(2,2))/S12)-(2D0*C2(1,1))/S34+1/(S12*S34)-
     &  (6D0*C2(0,0))/(S12*S34)+(2D0*C2(1,2)*(S13+S14+S23+S24))/
     &  (S12*S34)+(2D0*C1(1)*(2D0*S12+S13+S14+S23+S24))/(S12*S34)-
     &  (2D0*C1(2)*(S13+S14+S23+S24+2D0*S34))/(S12*S34)-(2D0*C0*
     &  (S14+S24+T14))/(S12*S34)

        PRE = (QF(1)*QF(3)*ALPHA*SA*XMW)/(16D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+K(6)*PRE
        F(1,-1,1) = F(1,-1,1)+K(6)*PRE
        F(1,1,-1) = F(1,1,-1)+K(6)*PRE
        F(1,1,1) = F(1,1,1)+K(6)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(2)*PRE)/(S12*S34)
        F(5,-1,1) = F(5,-1,1)+(2D0*K(2)*PRE)/(S12*S34)
        F(5,1,-1) = F(5,1,-1)+(2D0*K(2)*PRE)/(S12*S34)
        F(5,1,1) = F(5,1,1)+(2D0*K(2)*PRE)/(S12*S34)
        F(6,-1,-1) = F(6,-1,-1)+(2D0*K(2)*PRE)/(S12*S34)
        F(6,-1,1) = F(6,-1,1)+(2D0*K(2)*PRE)/(S12*S34)
        F(6,1,-1) = F(6,1,-1)+(2D0*K(2)*PRE)/(S12*S34)
        F(6,1,1) = F(6,1,1)+(2D0*K(2)*PRE)/(S12*S34)
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(2)*PRE)/(S12*S34)
        F(7,-1,1) = F(7,-1,1)+(2D0*K(2)*PRE)/(S12*S34)
        F(7,1,-1) = F(7,1,-1)+(2D0*K(2)*PRE)/(S12*S34)
        F(7,1,1) = F(7,1,1)+(2D0*K(2)*PRE)/(S12*S34)
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(2)*PRE)/(S12*S34)
        F(8,-1,1) = F(8,-1,1)+(2D0*K(2)*PRE)/(S12*S34)
        F(8,1,-1) = F(8,1,-1)+(2D0*K(2)*PRE)/(S12*S34)
        F(8,1,1) = F(8,1,1)+(2D0*K(2)*PRE)/(S12*S34)

C       G(T9,N1566,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,0,0)

        PRE = -((QF(1)*QF(3)*ALPHA*C0*SA*XMW*XMW2)/(4D0*PI*S12*S34*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE
        F(1,-1,1) = F(1,-1,1)+PRE
        F(1,1,-1) = F(1,1,-1)+PRE
        F(1,1,1) = F(1,1,1)+PRE

C       G(T9,N1567,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = -(C1(1))-C1(2)-10D0*C2(1,2)+4D0*C0
        K(2) = S13+S14+S23+S24
        K(3) = 2D0*S12-S13-S14-S23-S24
        K(4) = S13+S14+S23+S24-2D0*S34
        K(5) = -((4D0*C2(2,2))/S12)-(4D0*C2(1,1))/S34+6D0/(S12*S34)-
     &  (36D0*C2(0,0))/(S12*S34)+(4D0*C2(1,2)*(S13+S14+S23+S24))/
     &  (S12*S34)+(5D0*C0*(S13+S14+S23+S24))/(S12*S34)-(C1(1)*(2D0*
     &  S12-S13-S14-S23-S24))/(S12*S34)+(C1(2)*(S13+S14+S23+S24-2D0*
     &  S34))/(S12*S34)

        PRE = -((QF(1)*QF(3)*ALPHA*SA*XMW)/(8D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+K(5)*PRE
        F(1,-1,1) = F(1,-1,1)+K(5)*PRE
        F(1,1,-1) = F(1,1,-1)+K(5)*PRE
        F(1,1,1) = F(1,1,1)+K(5)*PRE
        F(5,-1,-1) = F(5,-1,-1)-(2D0*K(1)*PRE)/(S12*S34)
        F(5,-1,1) = F(5,-1,1)-(2D0*K(1)*PRE)/(S12*S34)
        F(5,1,-1) = F(5,1,-1)-(2D0*K(1)*PRE)/(S12*S34)
        F(5,1,1) = F(5,1,1)-(2D0*K(1)*PRE)/(S12*S34)
        F(6,-1,-1) = F(6,-1,-1)-(2D0*K(1)*PRE)/(S12*S34)
        F(6,-1,1) = F(6,-1,1)-(2D0*K(1)*PRE)/(S12*S34)
        F(6,1,-1) = F(6,1,-1)-(2D0*K(1)*PRE)/(S12*S34)
        F(6,1,1) = F(6,1,1)-(2D0*K(1)*PRE)/(S12*S34)
        F(7,-1,-1) = F(7,-1,-1)-(2D0*K(1)*PRE)/(S12*S34)
        F(7,-1,1) = F(7,-1,1)-(2D0*K(1)*PRE)/(S12*S34)
        F(7,1,-1) = F(7,1,-1)-(2D0*K(1)*PRE)/(S12*S34)
        F(7,1,1) = F(7,1,1)-(2D0*K(1)*PRE)/(S12*S34)
        F(8,-1,-1) = F(8,-1,-1)-(2D0*K(1)*PRE)/(S12*S34)
        F(8,-1,1) = F(8,-1,1)-(2D0*K(1)*PRE)/(S12*S34)
        F(8,1,-1) = F(8,1,-1)-(2D0*K(1)*PRE)/(S12*S34)
        F(8,1,1) = F(8,1,1)-(2D0*K(1)*PRE)/(S12*S34)

C       G(T9,N1568,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 2D0*C1(1)+C2(1,2)

        PRE = (QF(1)*QF(3)*ALPHA*SA*XMW)/(4D0*PI*S12*S34*XSW)

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(1,-1,1) = F(1,-1,1)+C2(0,0)*PRE
        F(1,1,-1) = F(1,1,-1)+C2(0,0)*PRE
        F(1,1,1) = F(1,1,1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)-K(1)*PRE
        F(5,-1,1) = F(5,-1,1)-K(1)*PRE
        F(5,1,-1) = F(5,1,-1)-K(1)*PRE
        F(5,1,1) = F(5,1,1)-K(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)-K(1)*PRE
        F(6,-1,1) = F(6,-1,1)-K(1)*PRE
        F(6,1,-1) = F(6,1,-1)-K(1)*PRE
        F(6,1,1) = F(6,1,1)-K(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)-K(1)*PRE
        F(7,-1,1) = F(7,-1,1)-K(1)*PRE
        F(7,1,-1) = F(7,1,-1)-K(1)*PRE
        F(7,1,1) = F(7,1,1)-K(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)-K(1)*PRE
        F(8,-1,1) = F(8,-1,1)-K(1)*PRE
        F(8,1,-1) = F(8,1,-1)-K(1)*PRE
        F(8,1,1) = F(8,1,1)-K(1)*PRE

C       G(T9,N1569,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = S14+S24+T14
        K(2) = 2D0*C1(1)+4D0*C1(2)-C2(1,2)+4D0*C0
        K(3) = S13+S14+S23+S24
        K(4) = 2D0*S12+S13+S14+S23+S24
        K(5) = S13+S14+S23+S24+2D0*S34
        K(6) = -((2D0*C2(2,2))/S12)-(2D0*C2(1,1))/S34+1/(S12*S34)-
     &  (6D0*C2(0,0))/(S12*S34)+(2D0*C2(1,2)*(S13+S14+S23+S24))/
     &  (S12*S34)+(2D0*C1(1)*(2D0*S12+S13+S14+S23+S24))/(S12*S34)-
     &  (2D0*C1(2)*(S13+S14+S23+S24+2D0*S34))/(S12*S34)-(2D0*C0*
     &  (S14+S24+T14))/(S12*S34)

        PRE = (QF(1)*QF(3)*ALPHA*SA*XMW)/(16D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+K(6)*PRE
        F(1,-1,1) = F(1,-1,1)+K(6)*PRE
        F(1,1,-1) = F(1,1,-1)+K(6)*PRE
        F(1,1,1) = F(1,1,1)+K(6)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(2)*PRE)/(S12*S34)
        F(5,-1,1) = F(5,-1,1)+(2D0*K(2)*PRE)/(S12*S34)
        F(5,1,-1) = F(5,1,-1)+(2D0*K(2)*PRE)/(S12*S34)
        F(5,1,1) = F(5,1,1)+(2D0*K(2)*PRE)/(S12*S34)
        F(6,-1,-1) = F(6,-1,-1)+(2D0*K(2)*PRE)/(S12*S34)
        F(6,-1,1) = F(6,-1,1)+(2D0*K(2)*PRE)/(S12*S34)
        F(6,1,-1) = F(6,1,-1)+(2D0*K(2)*PRE)/(S12*S34)
        F(6,1,1) = F(6,1,1)+(2D0*K(2)*PRE)/(S12*S34)
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(2)*PRE)/(S12*S34)
        F(7,-1,1) = F(7,-1,1)+(2D0*K(2)*PRE)/(S12*S34)
        F(7,1,-1) = F(7,1,-1)+(2D0*K(2)*PRE)/(S12*S34)
        F(7,1,1) = F(7,1,1)+(2D0*K(2)*PRE)/(S12*S34)
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(2)*PRE)/(S12*S34)
        F(8,-1,1) = F(8,-1,1)+(2D0*K(2)*PRE)/(S12*S34)
        F(8,1,-1) = F(8,1,-1)+(2D0*K(2)*PRE)/(S12*S34)
        F(8,1,1) = F(8,1,1)+(2D0*K(2)*PRE)/(S12*S34)

C       G(T9,N1570,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,0,0)

        PRE = -((QF(1)*QF(3)*ALPHA*C0*SA*XMW*XMW2)/(4D0*PI*S12*S34*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE
        F(1,-1,1) = F(1,-1,1)+PRE
        F(1,1,-1) = F(1,1,-1)+PRE
        F(1,1,1) = F(1,1,1)+PRE

C       G(T9,N1571,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = -(C1(1))-C1(2)-10D0*C2(1,2)+4D0*C0
        K(2) = S13+S14+S23+S24
        K(3) = 2D0*S12-S13-S14-S23-S24
        K(4) = S13+S14+S23+S24-2D0*S34
        K(5) = -((4D0*C2(2,2))/S12)-(4D0*C2(1,1))/S34+6D0/(S12*S34)-
     &  (36D0*C2(0,0))/(S12*S34)+(4D0*C2(1,2)*(S13+S14+S23+S24))/
     &  (S12*S34)+(5D0*C0*(S13+S14+S23+S24))/(S12*S34)-(C1(1)*(2D0*
     &  S12-S13-S14-S23-S24))/(S12*S34)+(C1(2)*(S13+S14+S23+S24-2D0*
     &  S34))/(S12*S34)

        PRE = -((QF(1)*QF(3)*ALPHA*SA*XMW)/(8D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+K(5)*PRE
        F(1,-1,1) = F(1,-1,1)+K(5)*PRE
        F(1,1,-1) = F(1,1,-1)+K(5)*PRE
        F(1,1,1) = F(1,1,1)+K(5)*PRE
        F(5,-1,-1) = F(5,-1,-1)-(2D0*K(1)*PRE)/(S12*S34)
        F(5,-1,1) = F(5,-1,1)-(2D0*K(1)*PRE)/(S12*S34)
        F(5,1,-1) = F(5,1,-1)-(2D0*K(1)*PRE)/(S12*S34)
        F(5,1,1) = F(5,1,1)-(2D0*K(1)*PRE)/(S12*S34)
        F(6,-1,-1) = F(6,-1,-1)-(2D0*K(1)*PRE)/(S12*S34)
        F(6,-1,1) = F(6,-1,1)-(2D0*K(1)*PRE)/(S12*S34)
        F(6,1,-1) = F(6,1,-1)-(2D0*K(1)*PRE)/(S12*S34)
        F(6,1,1) = F(6,1,1)-(2D0*K(1)*PRE)/(S12*S34)
        F(7,-1,-1) = F(7,-1,-1)-(2D0*K(1)*PRE)/(S12*S34)
        F(7,-1,1) = F(7,-1,1)-(2D0*K(1)*PRE)/(S12*S34)
        F(7,1,-1) = F(7,1,-1)-(2D0*K(1)*PRE)/(S12*S34)
        F(7,1,1) = F(7,1,1)-(2D0*K(1)*PRE)/(S12*S34)
        F(8,-1,-1) = F(8,-1,-1)-(2D0*K(1)*PRE)/(S12*S34)
        F(8,-1,1) = F(8,-1,1)-(2D0*K(1)*PRE)/(S12*S34)
        F(8,1,-1) = F(8,1,-1)-(2D0*K(1)*PRE)/(S12*S34)
        F(8,1,1) = F(8,1,1)-(2D0*K(1)*PRE)/(S12*S34)

C       G(T9,N1572,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0+2D0*QF(3)*XSW2

        PRE = -((QF(1)*ALPHA*PZ34*SA*XMHH2*(XCW+XSW)*(XCW-XSW))/
     &  (8D0*PI*S12*XCW2*XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)+(C2(0,0)*K(1)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*C2(0,0)*QF(3)*PRE
        F(1,1,-1) = F(1,1,-1)+(C2(0,0)*K(1)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+2D0*C2(0,0)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(5,-1,1) = F(5,-1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(5,1,-1) = F(5,1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(6,-1,1) = F(6,-1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(6,1,-1) = F(6,1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(7,-1,1) = F(7,-1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(7,1,-1) = F(7,1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(8,-1,1) = F(8,-1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(8,1,-1) = F(8,1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-2D0*C2(1,2)*QF(3)*PRE

C       G(T9,N1573,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,0,0)

        PRE = -((QF(1)*ALPHA*C0*PZ34*SA*XMHH2*XMW)/(16D0*PI*S12*
     &  XCW2))

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE*XSW
        F(1,1,-1) = F(1,1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW
        F(1,1,1) = F(1,1,1)+2D0*QF(3)*PRE*XSW

C       G(T9,N1574,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0+2D0*QF(3)*XSW2
        K(2) = 2D0*C1(2)+C2(1,2)

        PRE = (QF(1)*ALPHA*PZ34*SA*XMW)/(8D0*PI*S12*XCW2)

        F(1,-1,-1) = F(1,-1,-1)+(C2(0,0)*K(1)*PRE)/XSW
        F(1,-1,1) = F(1,-1,1)+2D0*C2(0,0)*QF(3)*PRE*XSW
        F(1,1,-1) = F(1,1,-1)+(C2(0,0)*K(1)*PRE)/XSW
        F(1,1,1) = F(1,1,1)+2D0*C2(0,0)*QF(3)*PRE*XSW
        F(5,-1,-1) = F(5,-1,-1)-(K(1)*K(2)*PRE)/XSW
        F(5,-1,1) = F(5,-1,1)-2D0*K(2)*QF(3)*PRE*XSW
        F(5,1,-1) = F(5,1,-1)-(K(1)*K(2)*PRE)/XSW
        F(5,1,1) = F(5,1,1)-2D0*K(2)*QF(3)*PRE*XSW
        F(6,-1,-1) = F(6,-1,-1)-(K(1)*K(2)*PRE)/XSW
        F(6,-1,1) = F(6,-1,1)-2D0*K(2)*QF(3)*PRE*XSW
        F(6,1,-1) = F(6,1,-1)-(K(1)*K(2)*PRE)/XSW
        F(6,1,1) = F(6,1,1)-2D0*K(2)*QF(3)*PRE*XSW
        F(7,-1,-1) = F(7,-1,-1)-(K(1)*K(2)*PRE)/XSW
        F(7,-1,1) = F(7,-1,1)-2D0*K(2)*QF(3)*PRE*XSW
        F(7,1,-1) = F(7,1,-1)-(K(1)*K(2)*PRE)/XSW
        F(7,1,1) = F(7,1,1)-2D0*K(2)*QF(3)*PRE*XSW
        F(8,-1,-1) = F(8,-1,-1)-(K(1)*K(2)*PRE)/XSW
        F(8,-1,1) = F(8,-1,1)-2D0*K(2)*QF(3)*PRE*XSW
        F(8,1,-1) = F(8,1,-1)-(K(1)*K(2)*PRE)/XSW
        F(8,1,1) = F(8,1,1)-2D0*K(2)*QF(3)*PRE*XSW

C       G(T9,N1575,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0+2D0*QF(3)*XSW2
        K(2) = S23+S24+T12
        K(3) = 4D0*C1(1)+2D0*C1(2)-C2(1,2)+4D0*C0
        K(4) = S13+S14+S23+S24
        K(5) = 2D0*S12+S13+S14+S23+S24
        K(6) = S13+S14+S23+S24+2D0*S34
        K(7) = -(2D0*C2(1,1))+S12**(-1)-(6D0*C2(0,0))/S12+(2D0*C2(1,
     &  2)*(S13+S14+S23+S24))/S12-(2D0*C1(1)*(2D0*S12+S13+S14+S23+
     &  S24))/S12-(2D0*C2(2,2)*S34)/S12+(2D0*C1(2)*(S13+S14+S23+S24+
     &  2D0*S34))/S12-(2D0*C0*(S23+S24+T12))/S12

        PRE = -((QF(1)*ALPHA*PZ34*SA*XMW)/(32D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+(K(1)*K(7)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*K(7)*QF(3)*PRE
        F(1,1,-1) = F(1,1,-1)+(K(1)*K(7)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+2D0*K(7)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(1)*K(3)*PRE)/(S12*XSW2)
        F(5,-1,1) = F(5,-1,1)+(4D0*K(3)*QF(3)*PRE)/S12
        F(5,1,-1) = F(5,1,-1)+(2D0*K(1)*K(3)*PRE)/(S12*XSW2)
        F(5,1,1) = F(5,1,1)+(4D0*K(3)*QF(3)*PRE)/S12
        F(6,-1,-1) = F(6,-1,-1)+(2D0*K(1)*K(3)*PRE)/(S12*XSW2)
        F(6,-1,1) = F(6,-1,1)+(4D0*K(3)*QF(3)*PRE)/S12
        F(6,1,-1) = F(6,1,-1)+(2D0*K(1)*K(3)*PRE)/(S12*XSW2)
        F(6,1,1) = F(6,1,1)+(4D0*K(3)*QF(3)*PRE)/S12
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(1)*K(3)*PRE)/(S12*XSW2)
        F(7,-1,1) = F(7,-1,1)+(4D0*K(3)*QF(3)*PRE)/S12
        F(7,1,-1) = F(7,1,-1)+(2D0*K(1)*K(3)*PRE)/(S12*XSW2)
        F(7,1,1) = F(7,1,1)+(4D0*K(3)*QF(3)*PRE)/S12
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(1)*K(3)*PRE)/(S12*XSW2)
        F(8,-1,1) = F(8,-1,1)+(4D0*K(3)*QF(3)*PRE)/S12
        F(8,1,-1) = F(8,1,-1)+(2D0*K(1)*K(3)*PRE)/(S12*XSW2)
        F(8,1,1) = F(8,1,1)+(4D0*K(3)*QF(3)*PRE)/S12

C       G(T9,N1576,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0+2D0*QF(3)*XSW2

        PRE = -((QF(1)*ALPHA*PZ34*SA*XMHH2*(XCW+XSW)*(XCW-XSW))/
     &  (8D0*PI*S12*XCW2*XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)+(C2(0,0)*K(1)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*C2(0,0)*QF(3)*PRE
        F(1,1,-1) = F(1,1,-1)+(C2(0,0)*K(1)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+2D0*C2(0,0)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(5,-1,1) = F(5,-1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(5,1,-1) = F(5,1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(6,-1,1) = F(6,-1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(6,1,-1) = F(6,1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(7,-1,1) = F(7,-1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(7,1,-1) = F(7,1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(8,-1,1) = F(8,-1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(8,1,-1) = F(8,1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-2D0*C2(1,2)*QF(3)*PRE

C       G(T9,N1577,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,0,0)

        PRE = -((QF(1)*ALPHA*C0*PZ34*SA*XMHH2*XMW)/(16D0*PI*S12*
     &  XCW2))

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE*XSW
        F(1,1,-1) = F(1,1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW
        F(1,1,1) = F(1,1,1)+2D0*QF(3)*PRE*XSW

C       G(T9,N1578,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0+2D0*QF(3)*XSW2
        K(2) = 2D0*C1(2)+C2(1,2)

        PRE = (QF(1)*ALPHA*PZ34*SA*XMW)/(8D0*PI*S12*XCW2)

        F(1,-1,-1) = F(1,-1,-1)+(C2(0,0)*K(1)*PRE)/XSW
        F(1,-1,1) = F(1,-1,1)+2D0*C2(0,0)*QF(3)*PRE*XSW
        F(1,1,-1) = F(1,1,-1)+(C2(0,0)*K(1)*PRE)/XSW
        F(1,1,1) = F(1,1,1)+2D0*C2(0,0)*QF(3)*PRE*XSW
        F(5,-1,-1) = F(5,-1,-1)-(K(1)*K(2)*PRE)/XSW
        F(5,-1,1) = F(5,-1,1)-2D0*K(2)*QF(3)*PRE*XSW
        F(5,1,-1) = F(5,1,-1)-(K(1)*K(2)*PRE)/XSW
        F(5,1,1) = F(5,1,1)-2D0*K(2)*QF(3)*PRE*XSW
        F(6,-1,-1) = F(6,-1,-1)-(K(1)*K(2)*PRE)/XSW
        F(6,-1,1) = F(6,-1,1)-2D0*K(2)*QF(3)*PRE*XSW
        F(6,1,-1) = F(6,1,-1)-(K(1)*K(2)*PRE)/XSW
        F(6,1,1) = F(6,1,1)-2D0*K(2)*QF(3)*PRE*XSW
        F(7,-1,-1) = F(7,-1,-1)-(K(1)*K(2)*PRE)/XSW
        F(7,-1,1) = F(7,-1,1)-2D0*K(2)*QF(3)*PRE*XSW
        F(7,1,-1) = F(7,1,-1)-(K(1)*K(2)*PRE)/XSW
        F(7,1,1) = F(7,1,1)-2D0*K(2)*QF(3)*PRE*XSW
        F(8,-1,-1) = F(8,-1,-1)-(K(1)*K(2)*PRE)/XSW
        F(8,-1,1) = F(8,-1,1)-2D0*K(2)*QF(3)*PRE*XSW
        F(8,1,-1) = F(8,1,-1)-(K(1)*K(2)*PRE)/XSW
        F(8,1,1) = F(8,1,1)-2D0*K(2)*QF(3)*PRE*XSW

C       G(T9,N1579,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0+2D0*QF(3)*XSW2
        K(2) = S23+S24+T12
        K(3) = 4D0*C1(1)+2D0*C1(2)-C2(1,2)+4D0*C0
        K(4) = S13+S14+S23+S24
        K(5) = 2D0*S12+S13+S14+S23+S24
        K(6) = S13+S14+S23+S24+2D0*S34
        K(7) = -(2D0*C2(1,1))+S12**(-1)-(6D0*C2(0,0))/S12+(2D0*C2(1,
     &  2)*(S13+S14+S23+S24))/S12-(2D0*C1(1)*(2D0*S12+S13+S14+S23+
     &  S24))/S12-(2D0*C2(2,2)*S34)/S12+(2D0*C1(2)*(S13+S14+S23+S24+
     &  2D0*S34))/S12-(2D0*C0*(S23+S24+T12))/S12

        PRE = -((QF(1)*ALPHA*PZ34*SA*XMW)/(32D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+(K(1)*K(7)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*K(7)*QF(3)*PRE
        F(1,1,-1) = F(1,1,-1)+(K(1)*K(7)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+2D0*K(7)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(1)*K(3)*PRE)/(S12*XSW2)
        F(5,-1,1) = F(5,-1,1)+(4D0*K(3)*QF(3)*PRE)/S12
        F(5,1,-1) = F(5,1,-1)+(2D0*K(1)*K(3)*PRE)/(S12*XSW2)
        F(5,1,1) = F(5,1,1)+(4D0*K(3)*QF(3)*PRE)/S12
        F(6,-1,-1) = F(6,-1,-1)+(2D0*K(1)*K(3)*PRE)/(S12*XSW2)
        F(6,-1,1) = F(6,-1,1)+(4D0*K(3)*QF(3)*PRE)/S12
        F(6,1,-1) = F(6,1,-1)+(2D0*K(1)*K(3)*PRE)/(S12*XSW2)
        F(6,1,1) = F(6,1,1)+(4D0*K(3)*QF(3)*PRE)/S12
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(1)*K(3)*PRE)/(S12*XSW2)
        F(7,-1,1) = F(7,-1,1)+(4D0*K(3)*QF(3)*PRE)/S12
        F(7,1,-1) = F(7,1,-1)+(2D0*K(1)*K(3)*PRE)/(S12*XSW2)
        F(7,1,1) = F(7,1,1)+(4D0*K(3)*QF(3)*PRE)/S12
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(1)*K(3)*PRE)/(S12*XSW2)
        F(8,-1,1) = F(8,-1,1)+(4D0*K(3)*QF(3)*PRE)/S12
        F(8,1,-1) = F(8,1,-1)+(2D0*K(1)*K(3)*PRE)/(S12*XSW2)
        F(8,1,1) = F(8,1,1)+(4D0*K(3)*QF(3)*PRE)/S12

C       G(T9,N1580,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0+2D0*QF(3)*XSW2
        K(2) = 2D0*C1(1)+C2(1,2)

        PRE = -((QF(1)*ALPHA*PZ34*SA*XMW*(XCW+XSW)*(XCW-XSW))/(16D0*
     &  PI*S12*XCW2*XSW))

        F(1,-1,-1) = F(1,-1,-1)+(C2(0,0)*K(1)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*C2(0,0)*QF(3)*PRE
        F(1,1,-1) = F(1,1,-1)+(C2(0,0)*K(1)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+2D0*C2(0,0)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)-(K(1)*K(2)*PRE)/XSW2
        F(5,-1,1) = F(5,-1,1)-2D0*K(2)*QF(3)*PRE
        F(5,1,-1) = F(5,1,-1)-(K(1)*K(2)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-2D0*K(2)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)-(K(1)*K(2)*PRE)/XSW2
        F(6,-1,1) = F(6,-1,1)-2D0*K(2)*QF(3)*PRE
        F(6,1,-1) = F(6,1,-1)-(K(1)*K(2)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-2D0*K(2)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)-(K(1)*K(2)*PRE)/XSW2
        F(7,-1,1) = F(7,-1,1)-2D0*K(2)*QF(3)*PRE
        F(7,1,-1) = F(7,1,-1)-(K(1)*K(2)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-2D0*K(2)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)-(K(1)*K(2)*PRE)/XSW2
        F(8,-1,1) = F(8,-1,1)-2D0*K(2)*QF(3)*PRE
        F(8,1,-1) = F(8,1,-1)-(K(1)*K(2)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-2D0*K(2)*QF(3)*PRE

C       G(T9,N1581,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0+2D0*QF(3)*XSW2
        K(2) = S14+S24+T14
        K(3) = 2D0*C1(1)+4D0*C1(2)-C2(1,2)+4D0*C0
        K(4) = S13+S14+S23+S24
        K(5) = 2D0*S12+S13+S14+S23+S24
        K(6) = S13+S14+S23+S24+2D0*S34
        K(7) = -(2D0*C2(1,1))+S12**(-1)-(6D0*C2(0,0))/S12+(2D0*C2(1,
     &  2)*(S13+S14+S23+S24))/S12+(2D0*C1(1)*(2D0*S12+S13+S14+S23+
     &  S24))/S12-(2D0*C2(2,2)*S34)/S12-(2D0*C1(2)*(S13+S14+S23+S24+
     &  2D0*S34))/S12-(2D0*C0*(S14+S24+T14))/S12

        PRE = (QF(1)*ALPHA*PZ34*SA*XMW)/(32D0*PI*XCW2)

        F(1,-1,-1) = F(1,-1,-1)+(K(1)*K(7)*PRE)/XSW
        F(1,-1,1) = F(1,-1,1)+2D0*K(7)*QF(3)*PRE*XSW
        F(1,1,-1) = F(1,1,-1)+(K(1)*K(7)*PRE)/XSW
        F(1,1,1) = F(1,1,1)+2D0*K(7)*QF(3)*PRE*XSW
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(1)*K(3)*PRE)/(S12*XSW)
        F(5,-1,1) = F(5,-1,1)+(4D0*K(3)*QF(3)*PRE*XSW)/S12
        F(5,1,-1) = F(5,1,-1)+(2D0*K(1)*K(3)*PRE)/(S12*XSW)
        F(5,1,1) = F(5,1,1)+(4D0*K(3)*QF(3)*PRE*XSW)/S12
        F(6,-1,-1) = F(6,-1,-1)+(2D0*K(1)*K(3)*PRE)/(S12*XSW)
        F(6,-1,1) = F(6,-1,1)+(4D0*K(3)*QF(3)*PRE*XSW)/S12
        F(6,1,-1) = F(6,1,-1)+(2D0*K(1)*K(3)*PRE)/(S12*XSW)
        F(6,1,1) = F(6,1,1)+(4D0*K(3)*QF(3)*PRE*XSW)/S12
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(1)*K(3)*PRE)/(S12*XSW)
        F(7,-1,1) = F(7,-1,1)+(4D0*K(3)*QF(3)*PRE*XSW)/S12
        F(7,1,-1) = F(7,1,-1)+(2D0*K(1)*K(3)*PRE)/(S12*XSW)
        F(7,1,1) = F(7,1,1)+(4D0*K(3)*QF(3)*PRE*XSW)/S12
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(1)*K(3)*PRE)/(S12*XSW)
        F(8,-1,1) = F(8,-1,1)+(4D0*K(3)*QF(3)*PRE*XSW)/S12
        F(8,1,-1) = F(8,1,-1)+(2D0*K(1)*K(3)*PRE)/(S12*XSW)
        F(8,1,1) = F(8,1,1)+(4D0*K(3)*QF(3)*PRE*XSW)/S12

C       G(T9,N1582,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,0,0)

        PRE = -((QF(1)*ALPHA*C0*PZ34*SA*XMW*XMW2)/(8D0*PI*S12*XCW2))

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE*XSW
        F(1,1,-1) = F(1,1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW
        F(1,1,1) = F(1,1,1)+2D0*QF(3)*PRE*XSW

C       G(T9,N1583,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0+2D0*QF(3)*XSW2
        K(2) = -(C1(1))-C1(2)-10D0*C2(1,2)+4D0*C0
        K(3) = S13+S14+S23+S24
        K(4) = 2D0*S12-S13-S14-S23-S24
        K(5) = S13+S14+S23+S24-2D0*S34
        K(6) = -(4D0*C2(1,1))+6D0/S12-(36D0*C2(0,0))/S12+(4D0*C2(1,
     &  2)*(S13+S14+S23+S24))/S12+(5D0*C0*(S13+S14+S23+S24))/S12-
     &  (C1(1)*(2D0*S12-S13-S14-S23-S24))/S12-(4D0*C2(2,2)*S34)/S12+
     &  (C1(2)*(S13+S14+S23+S24-2D0*S34))/S12

        PRE = (QF(1)*ALPHA*PZ34*SA*XMW)/(16D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+(K(1)*K(6)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*K(6)*QF(3)*PRE
        F(1,1,-1) = F(1,1,-1)+(K(1)*K(6)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+2D0*K(6)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)-(2D0*K(1)*K(2)*PRE)/(S12*XSW2)
        F(5,-1,1) = F(5,-1,1)-(4D0*K(2)*QF(3)*PRE)/S12
        F(5,1,-1) = F(5,1,-1)-(2D0*K(1)*K(2)*PRE)/(S12*XSW2)
        F(5,1,1) = F(5,1,1)-(4D0*K(2)*QF(3)*PRE)/S12
        F(6,-1,-1) = F(6,-1,-1)-(2D0*K(1)*K(2)*PRE)/(S12*XSW2)
        F(6,-1,1) = F(6,-1,1)-(4D0*K(2)*QF(3)*PRE)/S12
        F(6,1,-1) = F(6,1,-1)-(2D0*K(1)*K(2)*PRE)/(S12*XSW2)
        F(6,1,1) = F(6,1,1)-(4D0*K(2)*QF(3)*PRE)/S12
        F(7,-1,-1) = F(7,-1,-1)-(2D0*K(1)*K(2)*PRE)/(S12*XSW2)
        F(7,-1,1) = F(7,-1,1)-(4D0*K(2)*QF(3)*PRE)/S12
        F(7,1,-1) = F(7,1,-1)-(2D0*K(1)*K(2)*PRE)/(S12*XSW2)
        F(7,1,1) = F(7,1,1)-(4D0*K(2)*QF(3)*PRE)/S12
        F(8,-1,-1) = F(8,-1,-1)-(2D0*K(1)*K(2)*PRE)/(S12*XSW2)
        F(8,-1,1) = F(8,-1,1)-(4D0*K(2)*QF(3)*PRE)/S12
        F(8,1,-1) = F(8,1,-1)-(2D0*K(1)*K(2)*PRE)/(S12*XSW2)
        F(8,1,1) = F(8,1,1)-(4D0*K(2)*QF(3)*PRE)/S12

C       G(T9,N1584,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0+2D0*QF(3)*XSW2
        K(2) = 2D0*C1(1)+C2(1,2)

        PRE = -((QF(1)*ALPHA*PZ34*SA*XMW*(XCW+XSW)*(XCW-XSW))/(16D0*
     &  PI*S12*XCW2*XSW))

        F(1,-1,-1) = F(1,-1,-1)+(C2(0,0)*K(1)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*C2(0,0)*QF(3)*PRE
        F(1,1,-1) = F(1,1,-1)+(C2(0,0)*K(1)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+2D0*C2(0,0)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)-(K(1)*K(2)*PRE)/XSW2
        F(5,-1,1) = F(5,-1,1)-2D0*K(2)*QF(3)*PRE
        F(5,1,-1) = F(5,1,-1)-(K(1)*K(2)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-2D0*K(2)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)-(K(1)*K(2)*PRE)/XSW2
        F(6,-1,1) = F(6,-1,1)-2D0*K(2)*QF(3)*PRE
        F(6,1,-1) = F(6,1,-1)-(K(1)*K(2)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-2D0*K(2)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)-(K(1)*K(2)*PRE)/XSW2
        F(7,-1,1) = F(7,-1,1)-2D0*K(2)*QF(3)*PRE
        F(7,1,-1) = F(7,1,-1)-(K(1)*K(2)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-2D0*K(2)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)-(K(1)*K(2)*PRE)/XSW2
        F(8,-1,1) = F(8,-1,1)-2D0*K(2)*QF(3)*PRE
        F(8,1,-1) = F(8,1,-1)-(K(1)*K(2)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-2D0*K(2)*QF(3)*PRE

C       G(T9,N1585,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0+2D0*QF(3)*XSW2
        K(2) = S14+S24+T14
        K(3) = 2D0*C1(1)+4D0*C1(2)-C2(1,2)+4D0*C0
        K(4) = S13+S14+S23+S24
        K(5) = 2D0*S12+S13+S14+S23+S24
        K(6) = S13+S14+S23+S24+2D0*S34
        K(7) = -(2D0*C2(1,1))+S12**(-1)-(6D0*C2(0,0))/S12+(2D0*C2(1,
     &  2)*(S13+S14+S23+S24))/S12+(2D0*C1(1)*(2D0*S12+S13+S14+S23+
     &  S24))/S12-(2D0*C2(2,2)*S34)/S12-(2D0*C1(2)*(S13+S14+S23+S24+
     &  2D0*S34))/S12-(2D0*C0*(S14+S24+T14))/S12

        PRE = (QF(1)*ALPHA*PZ34*SA*XMW)/(32D0*PI*XCW2)

        F(1,-1,-1) = F(1,-1,-1)+(K(1)*K(7)*PRE)/XSW
        F(1,-1,1) = F(1,-1,1)+2D0*K(7)*QF(3)*PRE*XSW
        F(1,1,-1) = F(1,1,-1)+(K(1)*K(7)*PRE)/XSW
        F(1,1,1) = F(1,1,1)+2D0*K(7)*QF(3)*PRE*XSW
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(1)*K(3)*PRE)/(S12*XSW)
        F(5,-1,1) = F(5,-1,1)+(4D0*K(3)*QF(3)*PRE*XSW)/S12
        F(5,1,-1) = F(5,1,-1)+(2D0*K(1)*K(3)*PRE)/(S12*XSW)
        F(5,1,1) = F(5,1,1)+(4D0*K(3)*QF(3)*PRE*XSW)/S12
        F(6,-1,-1) = F(6,-1,-1)+(2D0*K(1)*K(3)*PRE)/(S12*XSW)
        F(6,-1,1) = F(6,-1,1)+(4D0*K(3)*QF(3)*PRE*XSW)/S12
        F(6,1,-1) = F(6,1,-1)+(2D0*K(1)*K(3)*PRE)/(S12*XSW)
        F(6,1,1) = F(6,1,1)+(4D0*K(3)*QF(3)*PRE*XSW)/S12
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(1)*K(3)*PRE)/(S12*XSW)
        F(7,-1,1) = F(7,-1,1)+(4D0*K(3)*QF(3)*PRE*XSW)/S12
        F(7,1,-1) = F(7,1,-1)+(2D0*K(1)*K(3)*PRE)/(S12*XSW)
        F(7,1,1) = F(7,1,1)+(4D0*K(3)*QF(3)*PRE*XSW)/S12
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(1)*K(3)*PRE)/(S12*XSW)
        F(8,-1,1) = F(8,-1,1)+(4D0*K(3)*QF(3)*PRE*XSW)/S12
        F(8,1,-1) = F(8,1,-1)+(2D0*K(1)*K(3)*PRE)/(S12*XSW)
        F(8,1,1) = F(8,1,1)+(4D0*K(3)*QF(3)*PRE*XSW)/S12

C       G(T9,N1586,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,0,0)

        PRE = -((QF(1)*ALPHA*C0*PZ34*SA*XMW*XMW2)/(8D0*PI*S12*XCW2))

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE*XSW
        F(1,1,-1) = F(1,1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW
        F(1,1,1) = F(1,1,1)+2D0*QF(3)*PRE*XSW

C       G(T9,N1587,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0+2D0*QF(3)*XSW2
        K(2) = -(C1(1))-C1(2)-10D0*C2(1,2)+4D0*C0
        K(3) = S13+S14+S23+S24
        K(4) = 2D0*S12-S13-S14-S23-S24
        K(5) = S13+S14+S23+S24-2D0*S34
        K(6) = -(4D0*C2(1,1))+6D0/S12-(36D0*C2(0,0))/S12+(4D0*C2(1,
     &  2)*(S13+S14+S23+S24))/S12+(5D0*C0*(S13+S14+S23+S24))/S12-
     &  (C1(1)*(2D0*S12-S13-S14-S23-S24))/S12-(4D0*C2(2,2)*S34)/S12+
     &  (C1(2)*(S13+S14+S23+S24-2D0*S34))/S12

        PRE = (QF(1)*ALPHA*PZ34*SA*XMW)/(16D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+(K(1)*K(6)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*K(6)*QF(3)*PRE
        F(1,1,-1) = F(1,1,-1)+(K(1)*K(6)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+2D0*K(6)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)-(2D0*K(1)*K(2)*PRE)/(S12*XSW2)
        F(5,-1,1) = F(5,-1,1)-(4D0*K(2)*QF(3)*PRE)/S12
        F(5,1,-1) = F(5,1,-1)-(2D0*K(1)*K(2)*PRE)/(S12*XSW2)
        F(5,1,1) = F(5,1,1)-(4D0*K(2)*QF(3)*PRE)/S12
        F(6,-1,-1) = F(6,-1,-1)-(2D0*K(1)*K(2)*PRE)/(S12*XSW2)
        F(6,-1,1) = F(6,-1,1)-(4D0*K(2)*QF(3)*PRE)/S12
        F(6,1,-1) = F(6,1,-1)-(2D0*K(1)*K(2)*PRE)/(S12*XSW2)
        F(6,1,1) = F(6,1,1)-(4D0*K(2)*QF(3)*PRE)/S12
        F(7,-1,-1) = F(7,-1,-1)-(2D0*K(1)*K(2)*PRE)/(S12*XSW2)
        F(7,-1,1) = F(7,-1,1)-(4D0*K(2)*QF(3)*PRE)/S12
        F(7,1,-1) = F(7,1,-1)-(2D0*K(1)*K(2)*PRE)/(S12*XSW2)
        F(7,1,1) = F(7,1,1)-(4D0*K(2)*QF(3)*PRE)/S12
        F(8,-1,-1) = F(8,-1,-1)-(2D0*K(1)*K(2)*PRE)/(S12*XSW2)
        F(8,-1,1) = F(8,-1,1)-(4D0*K(2)*QF(3)*PRE)/S12
        F(8,1,-1) = F(8,1,-1)-(2D0*K(1)*K(2)*PRE)/(S12*XSW2)
        F(8,1,1) = F(8,1,1)-(4D0*K(2)*QF(3)*PRE)/S12

C       G(T9,N1588,FULL)

C       G(T9,N1589,FULL)

C       G(T9,N1590,FULL)

C       G(T9,N1591,FULL)

C       G(T9,N1592,FULL)

C       G(T9,N1593,FULL)

C       G(T9,N1594,FULL)

C       G(T9,N1595,FULL)

C       G(T9,N1596,FULL)

C       G(T9,N1597,FULL)

C       G(T9,N1598,FULL)

C       G(T9,N1599,FULL)

C       G(T9,N1600,FULL)

C       G(T9,N1601,FULL)

C       G(T9,N1602,FULL)

C       G(T9,N1603,FULL)

C       G(T9,N1604,FULL)

C       G(T9,N1605,FULL)

C       G(T9,N1606,FULL)

C       G(T9,N1607,FULL)

C       G(T9,N1608,FULL)

C       G(T9,N1609,FULL)

C       G(T9,N1610,FULL)

C       G(T9,N1611,FULL)

C       G(T9,N1612,FULL)

C       G(T9,N1613,FULL)

C       G(T9,N1614,FULL)

C       G(T9,N1615,FULL)

C       G(T9,N1616,FULL)

C       G(T9,N1617,FULL)

C       G(T9,N1618,FULL)

C       G(T9,N1619,FULL)

C       G(T9,N1620,FULL)

C       G(T9,N1621,FULL)

C       G(T9,N1622,FULL)

C       G(T9,N1623,FULL)

C       G(T9,N1624,FULL)

C       G(T9,N1625,FULL)

C       G(T9,N1626,FULL)

C       G(T9,N1627,FULL)

C       G(T9,N1628,FULL)

C       G(T9,N1629,FULL)

C       G(T9,N1630,FULL)

C       G(T9,N1631,FULL)

C       G(T9,N1632,FULL)

C       G(T9,N1633,FULL)

C       G(T9,N1634,FULL)

C       G(T9,N1635,FULL)

C       G(T9,N1636,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2

        PRE = -((QF(3)*ALPHA*PZ12*SA*XMHH2*(XCW+XSW)*(XCW-XSW))/
     &  (8D0*PI*S34*XCW2*XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)-(C2(0,0)*K(1)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)-(C2(0,0)*K(1)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*C2(0,0)*QF(1)*PRE
        F(1,1,1) = F(1,1,1)+2D0*C2(0,0)*QF(1)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(5,-1,1) = F(5,-1,1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-2D0*C2(1,2)*QF(1)*PRE
        F(5,1,1) = F(5,1,1)-2D0*C2(1,2)*QF(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(6,-1,1) = F(6,-1,1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-2D0*C2(1,2)*QF(1)*PRE
        F(6,1,1) = F(6,1,1)-2D0*C2(1,2)*QF(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(7,-1,1) = F(7,-1,1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-2D0*C2(1,2)*QF(1)*PRE
        F(7,1,1) = F(7,1,1)-2D0*C2(1,2)*QF(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(8,-1,1) = F(8,-1,1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-2D0*C2(1,2)*QF(1)*PRE
        F(8,1,1) = F(8,1,1)-2D0*C2(1,2)*QF(1)*PRE

C       G(T9,N1637,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,0,0)

        PRE = -((QF(3)*ALPHA*C0*PZ12*SA*XMHH2*XMW)/(16D0*PI*S34*
     &  XCW2))

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE*XSW
        F(1,1,1) = F(1,1,1)+2D0*QF(1)*PRE*XSW

C       G(T9,N1638,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 2D0*C1(2)+C2(1,2)

        PRE = -((QF(3)*ALPHA*PZ12*SA*XMW*(XCW+XSW)*(XCW-XSW))/(16D0*
     &  PI*S34*XCW2*XSW))

        F(1,-1,-1) = F(1,-1,-1)-(C2(0,0)*K(1)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)-(C2(0,0)*K(1)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*C2(0,0)*QF(1)*PRE
        F(1,1,1) = F(1,1,1)+2D0*C2(0,0)*QF(1)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(K(1)*K(2)*PRE)/XSW2
        F(5,-1,1) = F(5,-1,1)+(K(1)*K(2)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-2D0*K(2)*QF(1)*PRE
        F(5,1,1) = F(5,1,1)-2D0*K(2)*QF(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)+(K(1)*K(2)*PRE)/XSW2
        F(6,-1,1) = F(6,-1,1)+(K(1)*K(2)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-2D0*K(2)*QF(1)*PRE
        F(6,1,1) = F(6,1,1)-2D0*K(2)*QF(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)+(K(1)*K(2)*PRE)/XSW2
        F(7,-1,1) = F(7,-1,1)+(K(1)*K(2)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-2D0*K(2)*QF(1)*PRE
        F(7,1,1) = F(7,1,1)-2D0*K(2)*QF(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)+(K(1)*K(2)*PRE)/XSW2
        F(8,-1,1) = F(8,-1,1)+(K(1)*K(2)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-2D0*K(2)*QF(1)*PRE
        F(8,1,1) = F(8,1,1)-2D0*K(2)*QF(1)*PRE

C       G(T9,N1639,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = S23+S24+T12
        K(3) = 4D0*C1(1)+2D0*C1(2)-C2(1,2)+4D0*C0
        K(4) = S13+S14+S23+S24
        K(5) = 2D0*S12+S13+S14+S23+S24
        K(6) = S13+S14+S23+S24+2D0*S34
        K(7) = -(2D0*C2(2,2))+S34**(-1)-(6D0*C2(0,0))/S34-(2D0*C2(1,
     &  1)*S12)/S34+(2D0*C2(1,2)*(S13+S14+S23+S24))/S34-(2D0*C1(1)*
     &  (2D0*S12+S13+S14+S23+S24))/S34+(2D0*C1(2)*(S13+S14+S23+S24+
     &  2D0*S34))/S34-(2D0*C0*(S23+S24+T12))/S34

        PRE = (QF(3)*ALPHA*PZ12*SA*XMW)/(32D0*PI*XCW2)

        F(1,-1,-1) = F(1,-1,-1)-(K(1)*K(7)*PRE)/XSW
        F(1,-1,1) = F(1,-1,1)-(K(1)*K(7)*PRE)/XSW
        F(1,1,-1) = F(1,1,-1)+2D0*K(7)*QF(1)*PRE*XSW
        F(1,1,1) = F(1,1,1)+2D0*K(7)*QF(1)*PRE*XSW
        F(5,-1,-1) = F(5,-1,-1)-(2D0*K(1)*K(3)*PRE)/(S34*XSW)
        F(5,-1,1) = F(5,-1,1)-(2D0*K(1)*K(3)*PRE)/(S34*XSW)
        F(5,1,-1) = F(5,1,-1)+(4D0*K(3)*QF(1)*PRE*XSW)/S34
        F(5,1,1) = F(5,1,1)+(4D0*K(3)*QF(1)*PRE*XSW)/S34
        F(6,-1,-1) = F(6,-1,-1)-(2D0*K(1)*K(3)*PRE)/(S34*XSW)
        F(6,-1,1) = F(6,-1,1)-(2D0*K(1)*K(3)*PRE)/(S34*XSW)
        F(6,1,-1) = F(6,1,-1)+(4D0*K(3)*QF(1)*PRE*XSW)/S34
        F(6,1,1) = F(6,1,1)+(4D0*K(3)*QF(1)*PRE*XSW)/S34
        F(7,-1,-1) = F(7,-1,-1)-(2D0*K(1)*K(3)*PRE)/(S34*XSW)
        F(7,-1,1) = F(7,-1,1)-(2D0*K(1)*K(3)*PRE)/(S34*XSW)
        F(7,1,-1) = F(7,1,-1)+(4D0*K(3)*QF(1)*PRE*XSW)/S34
        F(7,1,1) = F(7,1,1)+(4D0*K(3)*QF(1)*PRE*XSW)/S34
        F(8,-1,-1) = F(8,-1,-1)-(2D0*K(1)*K(3)*PRE)/(S34*XSW)
        F(8,-1,1) = F(8,-1,1)-(2D0*K(1)*K(3)*PRE)/(S34*XSW)
        F(8,1,-1) = F(8,1,-1)+(4D0*K(3)*QF(1)*PRE*XSW)/S34
        F(8,1,1) = F(8,1,1)+(4D0*K(3)*QF(1)*PRE*XSW)/S34

C       G(T9,N1640,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2

        PRE = -((QF(3)*ALPHA*PZ12*SA*XMHH2*(XCW+XSW)*(XCW-XSW))/
     &  (8D0*PI*S34*XCW2*XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)-(C2(0,0)*K(1)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)-(C2(0,0)*K(1)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*C2(0,0)*QF(1)*PRE
        F(1,1,1) = F(1,1,1)+2D0*C2(0,0)*QF(1)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(5,-1,1) = F(5,-1,1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-2D0*C2(1,2)*QF(1)*PRE
        F(5,1,1) = F(5,1,1)-2D0*C2(1,2)*QF(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(6,-1,1) = F(6,-1,1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-2D0*C2(1,2)*QF(1)*PRE
        F(6,1,1) = F(6,1,1)-2D0*C2(1,2)*QF(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(7,-1,1) = F(7,-1,1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-2D0*C2(1,2)*QF(1)*PRE
        F(7,1,1) = F(7,1,1)-2D0*C2(1,2)*QF(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(8,-1,1) = F(8,-1,1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-2D0*C2(1,2)*QF(1)*PRE
        F(8,1,1) = F(8,1,1)-2D0*C2(1,2)*QF(1)*PRE

C       G(T9,N1641,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,0,0)

        PRE = -((QF(3)*ALPHA*C0*PZ12*SA*XMHH2*XMW)/(16D0*PI*S34*
     &  XCW2))

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE*XSW
        F(1,1,1) = F(1,1,1)+2D0*QF(1)*PRE*XSW

C       G(T9,N1642,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 2D0*C1(2)+C2(1,2)

        PRE = -((QF(3)*ALPHA*PZ12*SA*XMW*(XCW+XSW)*(XCW-XSW))/(16D0*
     &  PI*S34*XCW2*XSW))

        F(1,-1,-1) = F(1,-1,-1)-(C2(0,0)*K(1)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)-(C2(0,0)*K(1)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*C2(0,0)*QF(1)*PRE
        F(1,1,1) = F(1,1,1)+2D0*C2(0,0)*QF(1)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(K(1)*K(2)*PRE)/XSW2
        F(5,-1,1) = F(5,-1,1)+(K(1)*K(2)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-2D0*K(2)*QF(1)*PRE
        F(5,1,1) = F(5,1,1)-2D0*K(2)*QF(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)+(K(1)*K(2)*PRE)/XSW2
        F(6,-1,1) = F(6,-1,1)+(K(1)*K(2)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-2D0*K(2)*QF(1)*PRE
        F(6,1,1) = F(6,1,1)-2D0*K(2)*QF(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)+(K(1)*K(2)*PRE)/XSW2
        F(7,-1,1) = F(7,-1,1)+(K(1)*K(2)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-2D0*K(2)*QF(1)*PRE
        F(7,1,1) = F(7,1,1)-2D0*K(2)*QF(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)+(K(1)*K(2)*PRE)/XSW2
        F(8,-1,1) = F(8,-1,1)+(K(1)*K(2)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-2D0*K(2)*QF(1)*PRE
        F(8,1,1) = F(8,1,1)-2D0*K(2)*QF(1)*PRE

C       G(T9,N1643,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = S23+S24+T12
        K(3) = 4D0*C1(1)+2D0*C1(2)-C2(1,2)+4D0*C0
        K(4) = S13+S14+S23+S24
        K(5) = 2D0*S12+S13+S14+S23+S24
        K(6) = S13+S14+S23+S24+2D0*S34
        K(7) = -(2D0*C2(2,2))+S34**(-1)-(6D0*C2(0,0))/S34-(2D0*C2(1,
     &  1)*S12)/S34+(2D0*C2(1,2)*(S13+S14+S23+S24))/S34-(2D0*C1(1)*
     &  (2D0*S12+S13+S14+S23+S24))/S34+(2D0*C1(2)*(S13+S14+S23+S24+
     &  2D0*S34))/S34-(2D0*C0*(S23+S24+T12))/S34

        PRE = (QF(3)*ALPHA*PZ12*SA*XMW)/(32D0*PI*XCW2)

        F(1,-1,-1) = F(1,-1,-1)-(K(1)*K(7)*PRE)/XSW
        F(1,-1,1) = F(1,-1,1)-(K(1)*K(7)*PRE)/XSW
        F(1,1,-1) = F(1,1,-1)+2D0*K(7)*QF(1)*PRE*XSW
        F(1,1,1) = F(1,1,1)+2D0*K(7)*QF(1)*PRE*XSW
        F(5,-1,-1) = F(5,-1,-1)-(2D0*K(1)*K(3)*PRE)/(S34*XSW)
        F(5,-1,1) = F(5,-1,1)-(2D0*K(1)*K(3)*PRE)/(S34*XSW)
        F(5,1,-1) = F(5,1,-1)+(4D0*K(3)*QF(1)*PRE*XSW)/S34
        F(5,1,1) = F(5,1,1)+(4D0*K(3)*QF(1)*PRE*XSW)/S34
        F(6,-1,-1) = F(6,-1,-1)-(2D0*K(1)*K(3)*PRE)/(S34*XSW)
        F(6,-1,1) = F(6,-1,1)-(2D0*K(1)*K(3)*PRE)/(S34*XSW)
        F(6,1,-1) = F(6,1,-1)+(4D0*K(3)*QF(1)*PRE*XSW)/S34
        F(6,1,1) = F(6,1,1)+(4D0*K(3)*QF(1)*PRE*XSW)/S34
        F(7,-1,-1) = F(7,-1,-1)-(2D0*K(1)*K(3)*PRE)/(S34*XSW)
        F(7,-1,1) = F(7,-1,1)-(2D0*K(1)*K(3)*PRE)/(S34*XSW)
        F(7,1,-1) = F(7,1,-1)+(4D0*K(3)*QF(1)*PRE*XSW)/S34
        F(7,1,1) = F(7,1,1)+(4D0*K(3)*QF(1)*PRE*XSW)/S34
        F(8,-1,-1) = F(8,-1,-1)-(2D0*K(1)*K(3)*PRE)/(S34*XSW)
        F(8,-1,1) = F(8,-1,1)-(2D0*K(1)*K(3)*PRE)/(S34*XSW)
        F(8,1,-1) = F(8,1,-1)+(4D0*K(3)*QF(1)*PRE*XSW)/S34
        F(8,1,1) = F(8,1,1)+(4D0*K(3)*QF(1)*PRE*XSW)/S34

C       G(T9,N1644,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 2D0*C1(1)+C2(1,2)

        PRE = (QF(3)*ALPHA*PZ12*SA*XMW)/(8D0*PI*S34*XCW2)

        F(1,-1,-1) = F(1,-1,-1)-(C2(0,0)*K(1)*PRE)/XSW
        F(1,-1,1) = F(1,-1,1)-(C2(0,0)*K(1)*PRE)/XSW
        F(1,1,-1) = F(1,1,-1)+2D0*C2(0,0)*QF(1)*PRE*XSW
        F(1,1,1) = F(1,1,1)+2D0*C2(0,0)*QF(1)*PRE*XSW
        F(5,-1,-1) = F(5,-1,-1)+(K(1)*K(2)*PRE)/XSW
        F(5,-1,1) = F(5,-1,1)+(K(1)*K(2)*PRE)/XSW
        F(5,1,-1) = F(5,1,-1)-2D0*K(2)*QF(1)*PRE*XSW
        F(5,1,1) = F(5,1,1)-2D0*K(2)*QF(1)*PRE*XSW
        F(6,-1,-1) = F(6,-1,-1)+(K(1)*K(2)*PRE)/XSW
        F(6,-1,1) = F(6,-1,1)+(K(1)*K(2)*PRE)/XSW
        F(6,1,-1) = F(6,1,-1)-2D0*K(2)*QF(1)*PRE*XSW
        F(6,1,1) = F(6,1,1)-2D0*K(2)*QF(1)*PRE*XSW
        F(7,-1,-1) = F(7,-1,-1)+(K(1)*K(2)*PRE)/XSW
        F(7,-1,1) = F(7,-1,1)+(K(1)*K(2)*PRE)/XSW
        F(7,1,-1) = F(7,1,-1)-2D0*K(2)*QF(1)*PRE*XSW
        F(7,1,1) = F(7,1,1)-2D0*K(2)*QF(1)*PRE*XSW
        F(8,-1,-1) = F(8,-1,-1)+(K(1)*K(2)*PRE)/XSW
        F(8,-1,1) = F(8,-1,1)+(K(1)*K(2)*PRE)/XSW
        F(8,1,-1) = F(8,1,-1)-2D0*K(2)*QF(1)*PRE*XSW
        F(8,1,1) = F(8,1,1)-2D0*K(2)*QF(1)*PRE*XSW

C       G(T9,N1645,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = S14+S24+T14
        K(3) = 2D0*C1(1)+4D0*C1(2)-C2(1,2)+4D0*C0
        K(4) = S13+S14+S23+S24
        K(5) = 2D0*S12+S13+S14+S23+S24
        K(6) = S13+S14+S23+S24+2D0*S34
        K(7) = -(2D0*C2(2,2))+S34**(-1)-(6D0*C2(0,0))/S34-(2D0*C2(1,
     &  1)*S12)/S34+(2D0*C2(1,2)*(S13+S14+S23+S24))/S34+(2D0*C1(1)*
     &  (2D0*S12+S13+S14+S23+S24))/S34-(2D0*C1(2)*(S13+S14+S23+S24+
     &  2D0*S34))/S34-(2D0*C0*(S14+S24+T14))/S34

        PRE = -((QF(3)*ALPHA*PZ12*SA*XMW)/(32D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)-(K(1)*K(7)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)-(K(1)*K(7)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*K(7)*QF(1)*PRE
        F(1,1,1) = F(1,1,1)+2D0*K(7)*QF(1)*PRE
        F(5,-1,-1) = F(5,-1,-1)-(2D0*K(1)*K(3)*PRE)/(S34*XSW2)
        F(5,-1,1) = F(5,-1,1)-(2D0*K(1)*K(3)*PRE)/(S34*XSW2)
        F(5,1,-1) = F(5,1,-1)+(4D0*K(3)*QF(1)*PRE)/S34
        F(5,1,1) = F(5,1,1)+(4D0*K(3)*QF(1)*PRE)/S34
        F(6,-1,-1) = F(6,-1,-1)-(2D0*K(1)*K(3)*PRE)/(S34*XSW2)
        F(6,-1,1) = F(6,-1,1)-(2D0*K(1)*K(3)*PRE)/(S34*XSW2)
        F(6,1,-1) = F(6,1,-1)+(4D0*K(3)*QF(1)*PRE)/S34
        F(6,1,1) = F(6,1,1)+(4D0*K(3)*QF(1)*PRE)/S34
        F(7,-1,-1) = F(7,-1,-1)-(2D0*K(1)*K(3)*PRE)/(S34*XSW2)
        F(7,-1,1) = F(7,-1,1)-(2D0*K(1)*K(3)*PRE)/(S34*XSW2)
        F(7,1,-1) = F(7,1,-1)+(4D0*K(3)*QF(1)*PRE)/S34
        F(7,1,1) = F(7,1,1)+(4D0*K(3)*QF(1)*PRE)/S34
        F(8,-1,-1) = F(8,-1,-1)-(2D0*K(1)*K(3)*PRE)/(S34*XSW2)
        F(8,-1,1) = F(8,-1,1)-(2D0*K(1)*K(3)*PRE)/(S34*XSW2)
        F(8,1,-1) = F(8,1,-1)+(4D0*K(3)*QF(1)*PRE)/S34
        F(8,1,1) = F(8,1,1)+(4D0*K(3)*QF(1)*PRE)/S34

C       G(T9,N1646,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,0,0)

        PRE = -((QF(3)*ALPHA*C0*PZ12*SA*XMW*XMW2)/(8D0*PI*S34*XCW2))

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE*XSW
        F(1,1,1) = F(1,1,1)+2D0*QF(1)*PRE*XSW

C       G(T9,N1647,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = -(C1(1))-C1(2)-10D0*C2(1,2)+4D0*C0
        K(3) = S13+S14+S23+S24
        K(4) = 2D0*S12-S13-S14-S23-S24
        K(5) = S13+S14+S23+S24-2D0*S34
        K(6) = -(4D0*C2(2,2))+6D0/S34-(36D0*C2(0,0))/S34-(4D0*C2(1,
     &  1)*S12)/S34+(4D0*C2(1,2)*(S13+S14+S23+S24))/S34+(5D0*C0*
     &  (S13+S14+S23+S24))/S34-(C1(1)*(2D0*S12-S13-S14-S23-S24))/
     &  S34+(C1(2)*(S13+S14+S23+S24-2D0*S34))/S34

        PRE = (QF(3)*ALPHA*PZ12*SA*XMW)/(16D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)-(K(1)*K(6)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)-(K(1)*K(6)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*K(6)*QF(1)*PRE
        F(1,1,1) = F(1,1,1)+2D0*K(6)*QF(1)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(1)*K(2)*PRE)/(S34*XSW2)
        F(5,-1,1) = F(5,-1,1)+(2D0*K(1)*K(2)*PRE)/(S34*XSW2)
        F(5,1,-1) = F(5,1,-1)-(4D0*K(2)*QF(1)*PRE)/S34
        F(5,1,1) = F(5,1,1)-(4D0*K(2)*QF(1)*PRE)/S34
        F(6,-1,-1) = F(6,-1,-1)+(2D0*K(1)*K(2)*PRE)/(S34*XSW2)
        F(6,-1,1) = F(6,-1,1)+(2D0*K(1)*K(2)*PRE)/(S34*XSW2)
        F(6,1,-1) = F(6,1,-1)-(4D0*K(2)*QF(1)*PRE)/S34
        F(6,1,1) = F(6,1,1)-(4D0*K(2)*QF(1)*PRE)/S34
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(1)*K(2)*PRE)/(S34*XSW2)
        F(7,-1,1) = F(7,-1,1)+(2D0*K(1)*K(2)*PRE)/(S34*XSW2)
        F(7,1,-1) = F(7,1,-1)-(4D0*K(2)*QF(1)*PRE)/S34
        F(7,1,1) = F(7,1,1)-(4D0*K(2)*QF(1)*PRE)/S34
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(1)*K(2)*PRE)/(S34*XSW2)
        F(8,-1,1) = F(8,-1,1)+(2D0*K(1)*K(2)*PRE)/(S34*XSW2)
        F(8,1,-1) = F(8,1,-1)-(4D0*K(2)*QF(1)*PRE)/S34
        F(8,1,1) = F(8,1,1)-(4D0*K(2)*QF(1)*PRE)/S34

C       G(T9,N1648,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 2D0*C1(1)+C2(1,2)

        PRE = (QF(3)*ALPHA*PZ12*SA*XMW)/(8D0*PI*S34*XCW2)

        F(1,-1,-1) = F(1,-1,-1)-(C2(0,0)*K(1)*PRE)/XSW
        F(1,-1,1) = F(1,-1,1)-(C2(0,0)*K(1)*PRE)/XSW
        F(1,1,-1) = F(1,1,-1)+2D0*C2(0,0)*QF(1)*PRE*XSW
        F(1,1,1) = F(1,1,1)+2D0*C2(0,0)*QF(1)*PRE*XSW
        F(5,-1,-1) = F(5,-1,-1)+(K(1)*K(2)*PRE)/XSW
        F(5,-1,1) = F(5,-1,1)+(K(1)*K(2)*PRE)/XSW
        F(5,1,-1) = F(5,1,-1)-2D0*K(2)*QF(1)*PRE*XSW
        F(5,1,1) = F(5,1,1)-2D0*K(2)*QF(1)*PRE*XSW
        F(6,-1,-1) = F(6,-1,-1)+(K(1)*K(2)*PRE)/XSW
        F(6,-1,1) = F(6,-1,1)+(K(1)*K(2)*PRE)/XSW
        F(6,1,-1) = F(6,1,-1)-2D0*K(2)*QF(1)*PRE*XSW
        F(6,1,1) = F(6,1,1)-2D0*K(2)*QF(1)*PRE*XSW
        F(7,-1,-1) = F(7,-1,-1)+(K(1)*K(2)*PRE)/XSW
        F(7,-1,1) = F(7,-1,1)+(K(1)*K(2)*PRE)/XSW
        F(7,1,-1) = F(7,1,-1)-2D0*K(2)*QF(1)*PRE*XSW
        F(7,1,1) = F(7,1,1)-2D0*K(2)*QF(1)*PRE*XSW
        F(8,-1,-1) = F(8,-1,-1)+(K(1)*K(2)*PRE)/XSW
        F(8,-1,1) = F(8,-1,1)+(K(1)*K(2)*PRE)/XSW
        F(8,1,-1) = F(8,1,-1)-2D0*K(2)*QF(1)*PRE*XSW
        F(8,1,1) = F(8,1,1)-2D0*K(2)*QF(1)*PRE*XSW

C       G(T9,N1649,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = S14+S24+T14
        K(3) = 2D0*C1(1)+4D0*C1(2)-C2(1,2)+4D0*C0
        K(4) = S13+S14+S23+S24
        K(5) = 2D0*S12+S13+S14+S23+S24
        K(6) = S13+S14+S23+S24+2D0*S34
        K(7) = -(2D0*C2(2,2))+S34**(-1)-(6D0*C2(0,0))/S34-(2D0*C2(1,
     &  1)*S12)/S34+(2D0*C2(1,2)*(S13+S14+S23+S24))/S34+(2D0*C1(1)*
     &  (2D0*S12+S13+S14+S23+S24))/S34-(2D0*C1(2)*(S13+S14+S23+S24+
     &  2D0*S34))/S34-(2D0*C0*(S14+S24+T14))/S34

        PRE = -((QF(3)*ALPHA*PZ12*SA*XMW)/(32D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)-(K(1)*K(7)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)-(K(1)*K(7)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*K(7)*QF(1)*PRE
        F(1,1,1) = F(1,1,1)+2D0*K(7)*QF(1)*PRE
        F(5,-1,-1) = F(5,-1,-1)-(2D0*K(1)*K(3)*PRE)/(S34*XSW2)
        F(5,-1,1) = F(5,-1,1)-(2D0*K(1)*K(3)*PRE)/(S34*XSW2)
        F(5,1,-1) = F(5,1,-1)+(4D0*K(3)*QF(1)*PRE)/S34
        F(5,1,1) = F(5,1,1)+(4D0*K(3)*QF(1)*PRE)/S34
        F(6,-1,-1) = F(6,-1,-1)-(2D0*K(1)*K(3)*PRE)/(S34*XSW2)
        F(6,-1,1) = F(6,-1,1)-(2D0*K(1)*K(3)*PRE)/(S34*XSW2)
        F(6,1,-1) = F(6,1,-1)+(4D0*K(3)*QF(1)*PRE)/S34
        F(6,1,1) = F(6,1,1)+(4D0*K(3)*QF(1)*PRE)/S34
        F(7,-1,-1) = F(7,-1,-1)-(2D0*K(1)*K(3)*PRE)/(S34*XSW2)
        F(7,-1,1) = F(7,-1,1)-(2D0*K(1)*K(3)*PRE)/(S34*XSW2)
        F(7,1,-1) = F(7,1,-1)+(4D0*K(3)*QF(1)*PRE)/S34
        F(7,1,1) = F(7,1,1)+(4D0*K(3)*QF(1)*PRE)/S34
        F(8,-1,-1) = F(8,-1,-1)-(2D0*K(1)*K(3)*PRE)/(S34*XSW2)
        F(8,-1,1) = F(8,-1,1)-(2D0*K(1)*K(3)*PRE)/(S34*XSW2)
        F(8,1,-1) = F(8,1,-1)+(4D0*K(3)*QF(1)*PRE)/S34
        F(8,1,1) = F(8,1,1)+(4D0*K(3)*QF(1)*PRE)/S34

C       G(T9,N1650,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,0,0)

        PRE = -((QF(3)*ALPHA*C0*PZ12*SA*XMW*XMW2)/(8D0*PI*S34*XCW2))

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE*XSW
        F(1,1,1) = F(1,1,1)+2D0*QF(1)*PRE*XSW

C       G(T9,N1651,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = -(C1(1))-C1(2)-10D0*C2(1,2)+4D0*C0
        K(3) = S13+S14+S23+S24
        K(4) = 2D0*S12-S13-S14-S23-S24
        K(5) = S13+S14+S23+S24-2D0*S34
        K(6) = -(4D0*C2(2,2))+6D0/S34-(36D0*C2(0,0))/S34-(4D0*C2(1,
     &  1)*S12)/S34+(4D0*C2(1,2)*(S13+S14+S23+S24))/S34+(5D0*C0*
     &  (S13+S14+S23+S24))/S34-(C1(1)*(2D0*S12-S13-S14-S23-S24))/
     &  S34+(C1(2)*(S13+S14+S23+S24-2D0*S34))/S34

        PRE = (QF(3)*ALPHA*PZ12*SA*XMW)/(16D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)-(K(1)*K(6)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)-(K(1)*K(6)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*K(6)*QF(1)*PRE
        F(1,1,1) = F(1,1,1)+2D0*K(6)*QF(1)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(1)*K(2)*PRE)/(S34*XSW2)
        F(5,-1,1) = F(5,-1,1)+(2D0*K(1)*K(2)*PRE)/(S34*XSW2)
        F(5,1,-1) = F(5,1,-1)-(4D0*K(2)*QF(1)*PRE)/S34
        F(5,1,1) = F(5,1,1)-(4D0*K(2)*QF(1)*PRE)/S34
        F(6,-1,-1) = F(6,-1,-1)+(2D0*K(1)*K(2)*PRE)/(S34*XSW2)
        F(6,-1,1) = F(6,-1,1)+(2D0*K(1)*K(2)*PRE)/(S34*XSW2)
        F(6,1,-1) = F(6,1,-1)-(4D0*K(2)*QF(1)*PRE)/S34
        F(6,1,1) = F(6,1,1)-(4D0*K(2)*QF(1)*PRE)/S34
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(1)*K(2)*PRE)/(S34*XSW2)
        F(7,-1,1) = F(7,-1,1)+(2D0*K(1)*K(2)*PRE)/(S34*XSW2)
        F(7,1,-1) = F(7,1,-1)-(4D0*K(2)*QF(1)*PRE)/S34
        F(7,1,1) = F(7,1,1)-(4D0*K(2)*QF(1)*PRE)/S34
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(1)*K(2)*PRE)/(S34*XSW2)
        F(8,-1,1) = F(8,-1,1)+(2D0*K(1)*K(2)*PRE)/(S34*XSW2)
        F(8,1,-1) = F(8,1,-1)-(4D0*K(2)*QF(1)*PRE)/S34
        F(8,1,1) = F(8,1,1)-(4D0*K(2)*QF(1)*PRE)/S34

C       G(T9,N1652,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2

        PRE = (ALPHA*PZ12*PZ34*SA*XCW2**(-2)*XMHH2*(XCW+XSW)**2*
     &  (XCW-XSW)**2)/(32D0*PI*XMW*XSW)

        F(1,-1,-1) = F(1,-1,-1)-C2(0,0)*K(1)*K(2)*PRE*XSW2**(-2)
        F(1,-1,1) = F(1,-1,1)-(2D0*C2(0,0)*K(1)*QF(3)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*C2(0,0)*K(2)*QF(1)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+4D0*C2(0,0)*QF(1)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(5,-1,1) = F(5,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(6,-1,1) = F(6,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(7,-1,1) = F(7,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(8,-1,1) = F(8,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE

C       G(T9,N1653,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,0,0)

        PRE = -((ALPHA*C0*PZ12*PZ34*SA*XCW2**(-2)*XMHH2*XMW)/(32D0*
     &  PI))

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)-2D0*QF(3)*PRE*XSW*(1D0-2D0*QF(1)*XSW2)
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE*XSW*(1D0+2D0*QF(3)*XSW2)
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*XSW*XSW2

C       G(T9,N1654,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = 2D0*C1(2)+C2(1,2)

        PRE = -((ALPHA*PZ12*PZ34*SA*XCW2**(-2)*XMW*(XCW+XSW)*(XCW-
     &  XSW))/(32D0*PI))

        F(1,-1,-1) = F(1,-1,-1)-(C2(0,0)*K(1)*K(2)*PRE)/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*C2(0,0)*K(1)*QF(3)*PRE)/XSW
        F(1,1,-1) = F(1,1,-1)+(2D0*C2(0,0)*K(2)*QF(1)*PRE)/XSW
        F(1,1,1) = F(1,1,1)+4D0*C2(0,0)*QF(1)*QF(3)*PRE*XSW
        F(5,-1,-1) = F(5,-1,-1)+(K(1)*K(2)*K(3)*PRE)/(XSW*XSW2)
        F(5,-1,1) = F(5,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW
        F(5,1,-1) = F(5,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW
        F(5,1,1) = F(5,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE*XSW
        F(6,-1,-1) = F(6,-1,-1)+(K(1)*K(2)*K(3)*PRE)/(XSW*XSW2)
        F(6,-1,1) = F(6,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW
        F(6,1,-1) = F(6,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW
        F(6,1,1) = F(6,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE*XSW
        F(7,-1,-1) = F(7,-1,-1)+(K(1)*K(2)*K(3)*PRE)/(XSW*XSW2)
        F(7,-1,1) = F(7,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW
        F(7,1,-1) = F(7,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW
        F(7,1,1) = F(7,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE*XSW
        F(8,-1,-1) = F(8,-1,-1)+(K(1)*K(2)*K(3)*PRE)/(XSW*XSW2)
        F(8,-1,1) = F(8,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW
        F(8,1,-1) = F(8,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW
        F(8,1,1) = F(8,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE*XSW

C       G(T9,N1655,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = S23+S24+T12
        K(4) = 4D0*C1(1)+2D0*C1(2)-C2(1,2)+4D0*C0
        K(5) = S13+S14+S23+S24
        K(6) = 2D0*S12+S13+S14+S23+S24
        K(7) = S13+S14+S23+S24+2D0*S34
        K(8) = 1D0-6D0*C2(0,0)-2D0*C2(1,1)*S12+2D0*C2(1,2)*(S13+S14+
     &  S23+S24)-2D0*C1(1)*(2D0*S12+S13+S14+S23+S24)-2D0*C2(2,2)*
     &  S34+2D0*C1(2)*(S13+S14+S23+S24+2D0*S34)-2D0*C0*(S23+S24+T12)

        PRE = -((ALPHA*PZ12*PZ34*SA*XMW)/(64D0*PI*XCW2))

        F(1,-1,-1) = F(1,-1,-1)-(K(1)*K(2)*K(8)*PRE)/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*K(1)*K(8)*QF(3)*PRE)/XSW
        F(1,1,-1) = F(1,1,-1)+(2D0*K(2)*K(8)*QF(1)*PRE)/XSW
        F(1,1,1) = F(1,1,1)+4D0*K(8)*QF(1)*QF(3)*PRE*XSW
        F(5,-1,-1) = F(5,-1,-1)-(2D0*K(1)*K(2)*K(4)*PRE)/(XSW*XSW2)
        F(5,-1,1) = F(5,-1,1)-(4D0*K(1)*K(4)*QF(3)*PRE)/XSW
        F(5,1,-1) = F(5,1,-1)+(4D0*K(2)*K(4)*QF(1)*PRE)/XSW
        F(5,1,1) = F(5,1,1)+8D0*K(4)*QF(1)*QF(3)*PRE*XSW
        F(6,-1,-1) = F(6,-1,-1)-(2D0*K(1)*K(2)*K(4)*PRE)/(XSW*XSW2)
        F(6,-1,1) = F(6,-1,1)-(4D0*K(1)*K(4)*QF(3)*PRE)/XSW
        F(6,1,-1) = F(6,1,-1)+(4D0*K(2)*K(4)*QF(1)*PRE)/XSW
        F(6,1,1) = F(6,1,1)+8D0*K(4)*QF(1)*QF(3)*PRE*XSW
        F(7,-1,-1) = F(7,-1,-1)-(2D0*K(1)*K(2)*K(4)*PRE)/(XSW*XSW2)
        F(7,-1,1) = F(7,-1,1)-(4D0*K(1)*K(4)*QF(3)*PRE)/XSW
        F(7,1,-1) = F(7,1,-1)+(4D0*K(2)*K(4)*QF(1)*PRE)/XSW
        F(7,1,1) = F(7,1,1)+8D0*K(4)*QF(1)*QF(3)*PRE*XSW
        F(8,-1,-1) = F(8,-1,-1)-(2D0*K(1)*K(2)*K(4)*PRE)/(XSW*XSW2)
        F(8,-1,1) = F(8,-1,1)-(4D0*K(1)*K(4)*QF(3)*PRE)/XSW
        F(8,1,-1) = F(8,1,-1)+(4D0*K(2)*K(4)*QF(1)*PRE)/XSW
        F(8,1,1) = F(8,1,1)+8D0*K(4)*QF(1)*QF(3)*PRE*XSW

C       G(T9,N1656,FULL)
        CALL xC01234_(S12,MHH2,S34,XMZ2,XMH2,XMH2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2

        PRE = (CA**2*PI**(-2)*PZ12*PZ34*SA*XCW2**(-2)*(2D0*XMH2+
     &  XMHH2)*(4D0*ALPHA*PI*XMH2+12D0*ALPHA*CA**2*PI*XMH2-4D0*
     &  ALPHA*PI*SA**2*XMH2-4D0*ALPHA*PI*XMHH2-12D0*ALPHA*CA**2*PI*
     &  XMHH2+4D0*ALPHA*PI*SA**2*XMHH2-32D0*L12*XMW2*XSW2))/(512D0*
     &  (XMH+XMHH)*(XMH-XMHH)*XMW*XSW)

        F(1,-1,-1) = F(1,-1,-1)-C2(0,0)*K(1)*K(2)*PRE*XSW2**(-2)
        F(1,-1,1) = F(1,-1,1)-(2D0*C2(0,0)*K(1)*QF(3)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*C2(0,0)*K(2)*QF(1)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+4D0*C2(0,0)*QF(1)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(5,-1,1) = F(5,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(6,-1,1) = F(6,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(7,-1,1) = F(7,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(8,-1,1) = F(8,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE

C       G(T9,N1657,FULL)
        CALL xC01234_(S12,MHH2,S34,XMZ2,XMH2,XMH2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,0,0)

        PRE = -((C0*CA**2*PI**(-2)*PZ12*PZ34*SA*XCW2**(-3)*(2D0*
     &  XMH2+XMHH2)*XMW*(4D0*ALPHA*PI*XMH2+12D0*ALPHA*CA**2*PI*XMH2-
     &  4D0*ALPHA*PI*SA**2*XMH2-4D0*ALPHA*PI*XMHH2-12D0*ALPHA*CA**2*
     &  PI*XMHH2+4D0*ALPHA*PI*SA**2*XMHH2-32D0*L12*XMW2*XSW2))/
     &  (512D0*(XMH+XMHH)*(XMH-XMHH)*XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T9,N1658,FULL)
        CALL xC01234_(S12,MHH2,S34,XMZ2,XMH2,XMHH2,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2

        PRE = (CA**2*PI**(-2)*PZ12*PZ34*SA*XCW2**(-2)*(XMH2+2D0*
     &  XMHH2)*(4D0*ALPHA*PI*XMH2-4D0*ALPHA*CA**2*PI*XMH2+12D0*
     &  ALPHA*PI*SA**2*XMH2-4D0*ALPHA*PI*XMHH2+4D0*ALPHA*CA**2*PI*
     &  XMHH2-12D0*ALPHA*PI*SA**2*XMHH2+32D0*L12*XMW2*XSW2))/(512D0*
     &  (XMH+XMHH)*(XMH-XMHH)*XMW*XSW)

        F(1,-1,-1) = F(1,-1,-1)-C2(0,0)*K(1)*K(2)*PRE*XSW2**(-2)
        F(1,-1,1) = F(1,-1,1)-(2D0*C2(0,0)*K(1)*QF(3)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*C2(0,0)*K(2)*QF(1)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+4D0*C2(0,0)*QF(1)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(5,-1,1) = F(5,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(6,-1,1) = F(6,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(7,-1,1) = F(7,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(8,-1,1) = F(8,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE

C       G(T9,N1659,FULL)
        CALL xC01234_(S12,MHH2,S34,XMZ2,XMH2,XMHH2,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,0,0)

        PRE = -((C0*CA**2*PI**(-2)*PZ12*PZ34*SA*XCW2**(-3)*(XMH2+
     &  2D0*XMHH2)*XMW*(4D0*ALPHA*PI*XMH2-4D0*ALPHA*CA**2*PI*XMH2+
     &  12D0*ALPHA*PI*SA**2*XMH2-4D0*ALPHA*PI*XMHH2+4D0*ALPHA*CA**2*
     &  PI*XMHH2-12D0*ALPHA*PI*SA**2*XMHH2+32D0*L12*XMW2*XSW2))/
     &  (512D0*(XMH+XMHH)*(XMH-XMHH)*XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T9,N1660,FULL)
        CALL xC01234_(S12,MHH2,S34,XMH2,XMZ2,XMZ2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2

        PRE = (ALPHA*CA**2*PZ12*PZ34*SA*XCW2**(-2)*XMHH2)/(32D0*PI*
     &  XMW*XSW)

        F(1,-1,-1) = F(1,-1,-1)-C2(0,0)*K(1)*K(2)*PRE*XSW2**(-2)
        F(1,-1,1) = F(1,-1,1)-(2D0*C2(0,0)*K(1)*QF(3)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*C2(0,0)*K(2)*QF(1)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+4D0*C2(0,0)*QF(1)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(5,-1,1) = F(5,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(6,-1,1) = F(6,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(7,-1,1) = F(7,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(8,-1,1) = F(8,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE

C       G(T9,N1661,FULL)
        CALL xC01234_(S12,MHH2,S34,XMHH2,XMZ2,XMZ2,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2

        PRE = (ALPHA*PZ12*PZ34*SA**3*XCW2**(-2)*XMHH2)/(32D0*PI*XMW*
     &  XSW)

        F(1,-1,-1) = F(1,-1,-1)-C2(0,0)*K(1)*K(2)*PRE*XSW2**(-2)
        F(1,-1,1) = F(1,-1,1)-(2D0*C2(0,0)*K(1)*QF(3)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*C2(0,0)*K(2)*QF(1)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+4D0*C2(0,0)*QF(1)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(5,-1,1) = F(5,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(6,-1,1) = F(6,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(7,-1,1) = F(7,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(8,-1,1) = F(8,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE

C       G(T9,N1662,FULL)
        CALL xC01234_(S12,MHH2,S34,XMH2,XMZ2,XMZ2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = 2D0*C1(2)+C2(1,2)

        PRE = (ALPHA*CA**2*PZ12*PZ34*SA*XCW2**(-3)*XMW)/(32D0*PI*
     &  XSW)

        F(1,-1,-1) = F(1,-1,-1)-C2(0,0)*K(1)*K(2)*PRE*XSW2**(-2)
        F(1,-1,1) = F(1,-1,1)-(2D0*C2(0,0)*K(1)*QF(3)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*C2(0,0)*K(2)*QF(1)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+4D0*C2(0,0)*QF(1)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+K(1)*K(2)*K(3)*PRE*XSW2**(-2)
        F(5,-1,1) = F(5,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)+K(1)*K(2)*K(3)*PRE*XSW2**(-2)
        F(6,-1,1) = F(6,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+K(1)*K(2)*K(3)*PRE*XSW2**(-2)
        F(7,-1,1) = F(7,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)+K(1)*K(2)*K(3)*PRE*XSW2**(-2)
        F(8,-1,1) = F(8,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE

C       G(T9,N1663,FULL)
        CALL xC01234_(S12,MHH2,S34,XMHH2,XMZ2,XMZ2,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = 2D0*C1(2)+C2(1,2)

        PRE = (ALPHA*PZ12*PZ34*SA**3*XCW2**(-3)*XMW)/(32D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)-C2(0,0)*K(1)*K(2)*PRE*XSW2**(-2)
        F(1,-1,1) = F(1,-1,1)-(2D0*C2(0,0)*K(1)*QF(3)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*C2(0,0)*K(2)*QF(1)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+4D0*C2(0,0)*QF(1)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+K(1)*K(2)*K(3)*PRE*XSW2**(-2)
        F(5,-1,1) = F(5,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)+K(1)*K(2)*K(3)*PRE*XSW2**(-2)
        F(6,-1,1) = F(6,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+K(1)*K(2)*K(3)*PRE*XSW2**(-2)
        F(7,-1,1) = F(7,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)+K(1)*K(2)*K(3)*PRE*XSW2**(-2)
        F(8,-1,1) = F(8,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE

C       G(T9,N1664,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2

        PRE = (ALPHA*PZ12*PZ34*SA*XCW2**(-2)*XMHH2*(XCW+XSW)**2*
     &  (XCW-XSW)**2)/(32D0*PI*XMW*XSW)

        F(1,-1,-1) = F(1,-1,-1)-C2(0,0)*K(1)*K(2)*PRE*XSW2**(-2)
        F(1,-1,1) = F(1,-1,1)-(2D0*C2(0,0)*K(1)*QF(3)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*C2(0,0)*K(2)*QF(1)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+4D0*C2(0,0)*QF(1)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(5,-1,1) = F(5,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(6,-1,1) = F(6,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(7,-1,1) = F(7,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(8,-1,1) = F(8,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE

C       G(T9,N1665,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,0,0)

        PRE = -((ALPHA*C0*PZ12*PZ34*SA*XCW2**(-2)*XMHH2*XMW)/(32D0*
     &  PI))

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)-2D0*QF(3)*PRE*XSW*(1D0-2D0*QF(1)*XSW2)
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE*XSW*(1D0+2D0*QF(3)*XSW2)
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*XSW*XSW2

C       G(T9,N1666,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = 2D0*C1(2)+C2(1,2)

        PRE = -((ALPHA*PZ12*PZ34*SA*XCW2**(-2)*XMW*(XCW+XSW)*(XCW-
     &  XSW))/(32D0*PI))

        F(1,-1,-1) = F(1,-1,-1)-(C2(0,0)*K(1)*K(2)*PRE)/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*C2(0,0)*K(1)*QF(3)*PRE)/XSW
        F(1,1,-1) = F(1,1,-1)+(2D0*C2(0,0)*K(2)*QF(1)*PRE)/XSW
        F(1,1,1) = F(1,1,1)+4D0*C2(0,0)*QF(1)*QF(3)*PRE*XSW
        F(5,-1,-1) = F(5,-1,-1)+(K(1)*K(2)*K(3)*PRE)/(XSW*XSW2)
        F(5,-1,1) = F(5,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW
        F(5,1,-1) = F(5,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW
        F(5,1,1) = F(5,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE*XSW
        F(6,-1,-1) = F(6,-1,-1)+(K(1)*K(2)*K(3)*PRE)/(XSW*XSW2)
        F(6,-1,1) = F(6,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW
        F(6,1,-1) = F(6,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW
        F(6,1,1) = F(6,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE*XSW
        F(7,-1,-1) = F(7,-1,-1)+(K(1)*K(2)*K(3)*PRE)/(XSW*XSW2)
        F(7,-1,1) = F(7,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW
        F(7,1,-1) = F(7,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW
        F(7,1,1) = F(7,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE*XSW
        F(8,-1,-1) = F(8,-1,-1)+(K(1)*K(2)*K(3)*PRE)/(XSW*XSW2)
        F(8,-1,1) = F(8,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW
        F(8,1,-1) = F(8,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW
        F(8,1,1) = F(8,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE*XSW

C       G(T9,N1667,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = S23+S24+T12
        K(4) = 4D0*C1(1)+2D0*C1(2)-C2(1,2)+4D0*C0
        K(5) = S13+S14+S23+S24
        K(6) = 2D0*S12+S13+S14+S23+S24
        K(7) = S13+S14+S23+S24+2D0*S34
        K(8) = 1D0-6D0*C2(0,0)-2D0*C2(1,1)*S12+2D0*C2(1,2)*(S13+S14+
     &  S23+S24)-2D0*C1(1)*(2D0*S12+S13+S14+S23+S24)-2D0*C2(2,2)*
     &  S34+2D0*C1(2)*(S13+S14+S23+S24+2D0*S34)-2D0*C0*(S23+S24+T12)

        PRE = -((ALPHA*PZ12*PZ34*SA*XMW)/(64D0*PI*XCW2))

        F(1,-1,-1) = F(1,-1,-1)-(K(1)*K(2)*K(8)*PRE)/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*K(1)*K(8)*QF(3)*PRE)/XSW
        F(1,1,-1) = F(1,1,-1)+(2D0*K(2)*K(8)*QF(1)*PRE)/XSW
        F(1,1,1) = F(1,1,1)+4D0*K(8)*QF(1)*QF(3)*PRE*XSW
        F(5,-1,-1) = F(5,-1,-1)-(2D0*K(1)*K(2)*K(4)*PRE)/(XSW*XSW2)
        F(5,-1,1) = F(5,-1,1)-(4D0*K(1)*K(4)*QF(3)*PRE)/XSW
        F(5,1,-1) = F(5,1,-1)+(4D0*K(2)*K(4)*QF(1)*PRE)/XSW
        F(5,1,1) = F(5,1,1)+8D0*K(4)*QF(1)*QF(3)*PRE*XSW
        F(6,-1,-1) = F(6,-1,-1)-(2D0*K(1)*K(2)*K(4)*PRE)/(XSW*XSW2)
        F(6,-1,1) = F(6,-1,1)-(4D0*K(1)*K(4)*QF(3)*PRE)/XSW
        F(6,1,-1) = F(6,1,-1)+(4D0*K(2)*K(4)*QF(1)*PRE)/XSW
        F(6,1,1) = F(6,1,1)+8D0*K(4)*QF(1)*QF(3)*PRE*XSW
        F(7,-1,-1) = F(7,-1,-1)-(2D0*K(1)*K(2)*K(4)*PRE)/(XSW*XSW2)
        F(7,-1,1) = F(7,-1,1)-(4D0*K(1)*K(4)*QF(3)*PRE)/XSW
        F(7,1,-1) = F(7,1,-1)+(4D0*K(2)*K(4)*QF(1)*PRE)/XSW
        F(7,1,1) = F(7,1,1)+8D0*K(4)*QF(1)*QF(3)*PRE*XSW
        F(8,-1,-1) = F(8,-1,-1)-(2D0*K(1)*K(2)*K(4)*PRE)/(XSW*XSW2)
        F(8,-1,1) = F(8,-1,1)-(4D0*K(1)*K(4)*QF(3)*PRE)/XSW
        F(8,1,-1) = F(8,1,-1)+(4D0*K(2)*K(4)*QF(1)*PRE)/XSW
        F(8,1,1) = F(8,1,1)+8D0*K(4)*QF(1)*QF(3)*PRE*XSW

C       G(T9,N1668,FULL)
        CALL xC01234_(S12,MHH2,S34,XMZ2,XMHH2,XMH2,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2

        PRE = (CA**2*PI**(-2)*PZ12*PZ34*SA*XCW2**(-2)*(XMH2+2D0*
     &  XMHH2)*(4D0*ALPHA*PI*XMH2-4D0*ALPHA*CA**2*PI*XMH2+12D0*
     &  ALPHA*PI*SA**2*XMH2-4D0*ALPHA*PI*XMHH2+4D0*ALPHA*CA**2*PI*
     &  XMHH2-12D0*ALPHA*PI*SA**2*XMHH2+32D0*L12*XMW2*XSW2))/(512D0*
     &  (XMH+XMHH)*(XMH-XMHH)*XMW*XSW)

        F(1,-1,-1) = F(1,-1,-1)-C2(0,0)*K(1)*K(2)*PRE*XSW2**(-2)
        F(1,-1,1) = F(1,-1,1)-(2D0*C2(0,0)*K(1)*QF(3)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*C2(0,0)*K(2)*QF(1)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+4D0*C2(0,0)*QF(1)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(5,-1,1) = F(5,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(6,-1,1) = F(6,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(7,-1,1) = F(7,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(8,-1,1) = F(8,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE

C       G(T9,N1669,FULL)
        CALL xC01234_(S12,MHH2,S34,XMZ2,XMHH2,XMH2,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,0,0)

        PRE = -((C0*CA**2*PI**(-2)*PZ12*PZ34*SA*XCW2**(-3)*(XMH2+
     &  2D0*XMHH2)*XMW*(4D0*ALPHA*PI*XMH2-4D0*ALPHA*CA**2*PI*XMH2+
     &  12D0*ALPHA*PI*SA**2*XMH2-4D0*ALPHA*PI*XMHH2+4D0*ALPHA*CA**2*
     &  PI*XMHH2-12D0*ALPHA*PI*SA**2*XMHH2+32D0*L12*XMW2*XSW2))/
     &  (512D0*(XMH+XMHH)*(XMH-XMHH)*XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T9,N1670,FULL)
        CALL xC01234_(S12,MHH2,S34,XMZ2,XMHH2,XMHH2,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2

        PRE = (3D0*PI**(-2)*PZ12*PZ34*SA*XCW2**(-2)*XMHH2*(12D0*
     &  ALPHA*PI*XMH2-16D0*ALPHA*CA**2*PI*XMH2+4D0*ALPHA*CA**4*PI*
     &  XMH2+16D0*ALPHA*PI*SA**2*XMH2-24D0*ALPHA*CA**2*PI*SA**2*
     &  XMH2+4D0*ALPHA*PI*SA**4*XMH2-12D0*ALPHA*PI*XMHH2+16D0*ALPHA*
     &  CA**2*PI*XMHH2-4D0*ALPHA*CA**4*PI*XMHH2-16D0*ALPHA*PI*SA**2*
     &  XMHH2+24D0*ALPHA*CA**2*PI*SA**2*XMHH2-4D0*ALPHA*PI*SA**4*
     &  XMHH2-32D0*L12*XMW2*XSW2-32D0*CA**2*L12*XMW2*XSW2+32D0*L12*
     &  SA**2*XMW2*XSW2))/(1024D0*(XMH+XMHH)*(XMH-XMHH)*XMW*XSW)

        F(1,-1,-1) = F(1,-1,-1)-C2(0,0)*K(1)*K(2)*PRE*XSW2**(-2)
        F(1,-1,1) = F(1,-1,1)-(2D0*C2(0,0)*K(1)*QF(3)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*C2(0,0)*K(2)*QF(1)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+4D0*C2(0,0)*QF(1)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(5,-1,1) = F(5,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(6,-1,1) = F(6,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(7,-1,1) = F(7,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(8,-1,1) = F(8,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE

C       G(T9,N1671,FULL)
        CALL xC01234_(S12,MHH2,S34,XMZ2,XMHH2,XMHH2,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,0,0)

        PRE = -((3D0*C0*PI**(-2)*PZ12*PZ34*SA*XCW2**(-3)*XMHH2*XMW*
     &  (12D0*ALPHA*PI*XMH2-16D0*ALPHA*CA**2*PI*XMH2+4D0*ALPHA*CA**
     &  4*PI*XMH2+16D0*ALPHA*PI*SA**2*XMH2-24D0*ALPHA*CA**2*PI*SA**
     &  2*XMH2+4D0*ALPHA*PI*SA**4*XMH2-12D0*ALPHA*PI*XMHH2+16D0*
     &  ALPHA*CA**2*PI*XMHH2-4D0*ALPHA*CA**4*PI*XMHH2-16D0*ALPHA*PI*
     &  SA**2*XMHH2+24D0*ALPHA*CA**2*PI*SA**2*XMHH2-4D0*ALPHA*PI*
     &  SA**4*XMHH2-32D0*L12*XMW2*XSW2-32D0*CA**2*L12*XMW2*XSW2+
     &  32D0*L12*SA**2*XMW2*XSW2))/(1024D0*(XMH+XMHH)*(XMH-XMHH)*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T9,N1672,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = 2D0*C1(1)+C2(1,2)

        PRE = -((ALPHA*PZ12*PZ34*SA*XCW2**(-2)*XMW*(XCW+XSW)*(XCW-
     &  XSW))/(32D0*PI))

        F(1,-1,-1) = F(1,-1,-1)-(C2(0,0)*K(1)*K(2)*PRE)/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*C2(0,0)*K(1)*QF(3)*PRE)/XSW
        F(1,1,-1) = F(1,1,-1)+(2D0*C2(0,0)*K(2)*QF(1)*PRE)/XSW
        F(1,1,1) = F(1,1,1)+4D0*C2(0,0)*QF(1)*QF(3)*PRE*XSW
        F(5,-1,-1) = F(5,-1,-1)+(K(1)*K(2)*K(3)*PRE)/(XSW*XSW2)
        F(5,-1,1) = F(5,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW
        F(5,1,-1) = F(5,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW
        F(5,1,1) = F(5,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE*XSW
        F(6,-1,-1) = F(6,-1,-1)+(K(1)*K(2)*K(3)*PRE)/(XSW*XSW2)
        F(6,-1,1) = F(6,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW
        F(6,1,-1) = F(6,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW
        F(6,1,1) = F(6,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE*XSW
        F(7,-1,-1) = F(7,-1,-1)+(K(1)*K(2)*K(3)*PRE)/(XSW*XSW2)
        F(7,-1,1) = F(7,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW
        F(7,1,-1) = F(7,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW
        F(7,1,1) = F(7,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE*XSW
        F(8,-1,-1) = F(8,-1,-1)+(K(1)*K(2)*K(3)*PRE)/(XSW*XSW2)
        F(8,-1,1) = F(8,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW
        F(8,1,-1) = F(8,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW
        F(8,1,1) = F(8,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE*XSW

C       G(T9,N1673,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = S14+S24+T14
        K(4) = 2D0*C1(1)+4D0*C1(2)-C2(1,2)+4D0*C0
        K(5) = S13+S14+S23+S24
        K(6) = 2D0*S12+S13+S14+S23+S24
        K(7) = S13+S14+S23+S24+2D0*S34
        K(8) = 1D0-6D0*C2(0,0)-2D0*C2(1,1)*S12+2D0*C2(1,2)*(S13+S14+
     &  S23+S24)+2D0*C1(1)*(2D0*S12+S13+S14+S23+S24)-2D0*C2(2,2)*
     &  S34-2D0*C1(2)*(S13+S14+S23+S24+2D0*S34)-2D0*C0*(S14+S24+T14)

        PRE = -((ALPHA*PZ12*PZ34*SA*XMW)/(64D0*PI*XCW2))

        F(1,-1,-1) = F(1,-1,-1)-(K(1)*K(2)*K(8)*PRE)/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*K(1)*K(8)*QF(3)*PRE)/XSW
        F(1,1,-1) = F(1,1,-1)+(2D0*K(2)*K(8)*QF(1)*PRE)/XSW
        F(1,1,1) = F(1,1,1)+4D0*K(8)*QF(1)*QF(3)*PRE*XSW
        F(5,-1,-1) = F(5,-1,-1)-(2D0*K(1)*K(2)*K(4)*PRE)/(XSW*XSW2)
        F(5,-1,1) = F(5,-1,1)-(4D0*K(1)*K(4)*QF(3)*PRE)/XSW
        F(5,1,-1) = F(5,1,-1)+(4D0*K(2)*K(4)*QF(1)*PRE)/XSW
        F(5,1,1) = F(5,1,1)+8D0*K(4)*QF(1)*QF(3)*PRE*XSW
        F(6,-1,-1) = F(6,-1,-1)-(2D0*K(1)*K(2)*K(4)*PRE)/(XSW*XSW2)
        F(6,-1,1) = F(6,-1,1)-(4D0*K(1)*K(4)*QF(3)*PRE)/XSW
        F(6,1,-1) = F(6,1,-1)+(4D0*K(2)*K(4)*QF(1)*PRE)/XSW
        F(6,1,1) = F(6,1,1)+8D0*K(4)*QF(1)*QF(3)*PRE*XSW
        F(7,-1,-1) = F(7,-1,-1)-(2D0*K(1)*K(2)*K(4)*PRE)/(XSW*XSW2)
        F(7,-1,1) = F(7,-1,1)-(4D0*K(1)*K(4)*QF(3)*PRE)/XSW
        F(7,1,-1) = F(7,1,-1)+(4D0*K(2)*K(4)*QF(1)*PRE)/XSW
        F(7,1,1) = F(7,1,1)+8D0*K(4)*QF(1)*QF(3)*PRE*XSW
        F(8,-1,-1) = F(8,-1,-1)-(2D0*K(1)*K(2)*K(4)*PRE)/(XSW*XSW2)
        F(8,-1,1) = F(8,-1,1)-(4D0*K(1)*K(4)*QF(3)*PRE)/XSW
        F(8,1,-1) = F(8,1,-1)+(4D0*K(2)*K(4)*QF(1)*PRE)/XSW
        F(8,1,1) = F(8,1,1)+8D0*K(4)*QF(1)*QF(3)*PRE*XSW

C       G(T9,N1674,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,0,0)

        PRE = -((ALPHA*C0*PZ12*PZ34*SA*XCW2**(-2)*XMW*XMW2)/(16D0*
     &  PI))

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)-2D0*QF(3)*PRE*XSW*(1D0-2D0*QF(1)*XSW2)
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE*XSW*(1D0+2D0*QF(3)*XSW2)
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*XSW*XSW2

C       G(T9,N1675,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = -(C1(1))-C1(2)-10D0*C2(1,2)+4D0*C0
        K(4) = S13+S14+S23+S24
        K(5) = 2D0*S12-S13-S14-S23-S24
        K(6) = S13+S14+S23+S24-2D0*S34
        K(7) = 6D0-36D0*C2(0,0)-4D0*C2(1,1)*S12+4D0*C2(1,2)*(S13+
     &  S14+S23+S24)+5D0*C0*(S13+S14+S23+S24)-C1(1)*(2D0*S12-S13-
     &  S14-S23-S24)-4D0*C2(2,2)*S34+C1(2)*(S13+S14+S23+S24-2D0*S34)

        PRE = -((ALPHA*PZ12*PZ34*SA*XMW)/(32D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)-K(1)*K(2)*K(7)*PRE*XSW2**(-2)
        F(1,-1,1) = F(1,-1,1)-(2D0*K(1)*K(7)*QF(3)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*K(2)*K(7)*QF(1)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+4D0*K(7)*QF(1)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+2D0*K(1)*K(2)*K(3)*PRE*XSW2**(-2)
        F(5,-1,1) = F(5,-1,1)+(4D0*K(1)*K(3)*QF(3)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-(4D0*K(2)*K(3)*QF(1)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-8D0*K(3)*QF(1)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)+2D0*K(1)*K(2)*K(3)*PRE*XSW2**(-2)
        F(6,-1,1) = F(6,-1,1)+(4D0*K(1)*K(3)*QF(3)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-(4D0*K(2)*K(3)*QF(1)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-8D0*K(3)*QF(1)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+2D0*K(1)*K(2)*K(3)*PRE*XSW2**(-2)
        F(7,-1,1) = F(7,-1,1)+(4D0*K(1)*K(3)*QF(3)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-(4D0*K(2)*K(3)*QF(1)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-8D0*K(3)*QF(1)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)+2D0*K(1)*K(2)*K(3)*PRE*XSW2**(-2)
        F(8,-1,1) = F(8,-1,1)+(4D0*K(1)*K(3)*QF(3)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-(4D0*K(2)*K(3)*QF(1)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-8D0*K(3)*QF(1)*QF(3)*PRE

C       G(T9,N1676,FULL)
        CALL xC01234_(S12,MHH2,S34,XMH2,XMZ2,XMZ2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = 2D0*C1(1)+C2(1,2)

        PRE = (ALPHA*CA**2*PZ12*PZ34*SA*XCW2**(-3)*XMW)/(32D0*PI*
     &  XSW)

        F(1,-1,-1) = F(1,-1,-1)-C2(0,0)*K(1)*K(2)*PRE*XSW2**(-2)
        F(1,-1,1) = F(1,-1,1)-(2D0*C2(0,0)*K(1)*QF(3)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*C2(0,0)*K(2)*QF(1)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+4D0*C2(0,0)*QF(1)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+K(1)*K(2)*K(3)*PRE*XSW2**(-2)
        F(5,-1,1) = F(5,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)+K(1)*K(2)*K(3)*PRE*XSW2**(-2)
        F(6,-1,1) = F(6,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+K(1)*K(2)*K(3)*PRE*XSW2**(-2)
        F(7,-1,1) = F(7,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)+K(1)*K(2)*K(3)*PRE*XSW2**(-2)
        F(8,-1,1) = F(8,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE

C       G(T9,N1677,FULL)
        CALL xC01234_(S12,MHH2,S34,XMHH2,XMZ2,XMZ2,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = 2D0*C1(1)+C2(1,2)

        PRE = (ALPHA*PZ12*PZ34*SA**3*XCW2**(-3)*XMW)/(32D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)-C2(0,0)*K(1)*K(2)*PRE*XSW2**(-2)
        F(1,-1,1) = F(1,-1,1)-(2D0*C2(0,0)*K(1)*QF(3)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*C2(0,0)*K(2)*QF(1)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+4D0*C2(0,0)*QF(1)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+K(1)*K(2)*K(3)*PRE*XSW2**(-2)
        F(5,-1,1) = F(5,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)+K(1)*K(2)*K(3)*PRE*XSW2**(-2)
        F(6,-1,1) = F(6,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+K(1)*K(2)*K(3)*PRE*XSW2**(-2)
        F(7,-1,1) = F(7,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)+K(1)*K(2)*K(3)*PRE*XSW2**(-2)
        F(8,-1,1) = F(8,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE

C       G(T9,N1678,FULL)
        CALL xC01234_(S12,MHH2,S34,XMH2,XMZ2,XMZ2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,0,0)

        PRE = -((ALPHA*C0*CA**2*PZ12*PZ34*SA*XCW2**(-4)*XMW*XMW2)/
     &  (16D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T9,N1679,FULL)
        CALL xC01234_(S12,MHH2,S34,XMHH2,XMZ2,XMZ2,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,0,0)

        PRE = -((ALPHA*C0*PZ12*PZ34*SA**3*XCW2**(-4)*XMW*XMW2)/
     &  (16D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T9,N1680,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = 2D0*C1(1)+C2(1,2)

        PRE = -((ALPHA*PZ12*PZ34*SA*XCW2**(-2)*XMW*(XCW+XSW)*(XCW-
     &  XSW))/(32D0*PI))

        F(1,-1,-1) = F(1,-1,-1)-(C2(0,0)*K(1)*K(2)*PRE)/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*C2(0,0)*K(1)*QF(3)*PRE)/XSW
        F(1,1,-1) = F(1,1,-1)+(2D0*C2(0,0)*K(2)*QF(1)*PRE)/XSW
        F(1,1,1) = F(1,1,1)+4D0*C2(0,0)*QF(1)*QF(3)*PRE*XSW
        F(5,-1,-1) = F(5,-1,-1)+(K(1)*K(2)*K(3)*PRE)/(XSW*XSW2)
        F(5,-1,1) = F(5,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW
        F(5,1,-1) = F(5,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW
        F(5,1,1) = F(5,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE*XSW
        F(6,-1,-1) = F(6,-1,-1)+(K(1)*K(2)*K(3)*PRE)/(XSW*XSW2)
        F(6,-1,1) = F(6,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW
        F(6,1,-1) = F(6,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW
        F(6,1,1) = F(6,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE*XSW
        F(7,-1,-1) = F(7,-1,-1)+(K(1)*K(2)*K(3)*PRE)/(XSW*XSW2)
        F(7,-1,1) = F(7,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW
        F(7,1,-1) = F(7,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW
        F(7,1,1) = F(7,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE*XSW
        F(8,-1,-1) = F(8,-1,-1)+(K(1)*K(2)*K(3)*PRE)/(XSW*XSW2)
        F(8,-1,1) = F(8,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW
        F(8,1,-1) = F(8,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW
        F(8,1,1) = F(8,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE*XSW

C       G(T9,N1681,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = S14+S24+T14
        K(4) = 2D0*C1(1)+4D0*C1(2)-C2(1,2)+4D0*C0
        K(5) = S13+S14+S23+S24
        K(6) = 2D0*S12+S13+S14+S23+S24
        K(7) = S13+S14+S23+S24+2D0*S34
        K(8) = 1D0-6D0*C2(0,0)-2D0*C2(1,1)*S12+2D0*C2(1,2)*(S13+S14+
     &  S23+S24)+2D0*C1(1)*(2D0*S12+S13+S14+S23+S24)-2D0*C2(2,2)*
     &  S34-2D0*C1(2)*(S13+S14+S23+S24+2D0*S34)-2D0*C0*(S14+S24+T14)

        PRE = -((ALPHA*PZ12*PZ34*SA*XMW)/(64D0*PI*XCW2))

        F(1,-1,-1) = F(1,-1,-1)-(K(1)*K(2)*K(8)*PRE)/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*K(1)*K(8)*QF(3)*PRE)/XSW
        F(1,1,-1) = F(1,1,-1)+(2D0*K(2)*K(8)*QF(1)*PRE)/XSW
        F(1,1,1) = F(1,1,1)+4D0*K(8)*QF(1)*QF(3)*PRE*XSW
        F(5,-1,-1) = F(5,-1,-1)-(2D0*K(1)*K(2)*K(4)*PRE)/(XSW*XSW2)
        F(5,-1,1) = F(5,-1,1)-(4D0*K(1)*K(4)*QF(3)*PRE)/XSW
        F(5,1,-1) = F(5,1,-1)+(4D0*K(2)*K(4)*QF(1)*PRE)/XSW
        F(5,1,1) = F(5,1,1)+8D0*K(4)*QF(1)*QF(3)*PRE*XSW
        F(6,-1,-1) = F(6,-1,-1)-(2D0*K(1)*K(2)*K(4)*PRE)/(XSW*XSW2)
        F(6,-1,1) = F(6,-1,1)-(4D0*K(1)*K(4)*QF(3)*PRE)/XSW
        F(6,1,-1) = F(6,1,-1)+(4D0*K(2)*K(4)*QF(1)*PRE)/XSW
        F(6,1,1) = F(6,1,1)+8D0*K(4)*QF(1)*QF(3)*PRE*XSW
        F(7,-1,-1) = F(7,-1,-1)-(2D0*K(1)*K(2)*K(4)*PRE)/(XSW*XSW2)
        F(7,-1,1) = F(7,-1,1)-(4D0*K(1)*K(4)*QF(3)*PRE)/XSW
        F(7,1,-1) = F(7,1,-1)+(4D0*K(2)*K(4)*QF(1)*PRE)/XSW
        F(7,1,1) = F(7,1,1)+8D0*K(4)*QF(1)*QF(3)*PRE*XSW
        F(8,-1,-1) = F(8,-1,-1)-(2D0*K(1)*K(2)*K(4)*PRE)/(XSW*XSW2)
        F(8,-1,1) = F(8,-1,1)-(4D0*K(1)*K(4)*QF(3)*PRE)/XSW
        F(8,1,-1) = F(8,1,-1)+(4D0*K(2)*K(4)*QF(1)*PRE)/XSW
        F(8,1,1) = F(8,1,1)+8D0*K(4)*QF(1)*QF(3)*PRE*XSW

C       G(T9,N1682,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,0,0)

        PRE = -((ALPHA*C0*PZ12*PZ34*SA*XCW2**(-2)*XMW*XMW2)/(16D0*
     &  PI))

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)-2D0*QF(3)*PRE*XSW*(1D0-2D0*QF(1)*XSW2)
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE*XSW*(1D0+2D0*QF(3)*XSW2)
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*XSW*XSW2

C       G(T9,N1683,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = -(C1(1))-C1(2)-10D0*C2(1,2)+4D0*C0
        K(4) = S13+S14+S23+S24
        K(5) = 2D0*S12-S13-S14-S23-S24
        K(6) = S13+S14+S23+S24-2D0*S34
        K(7) = 6D0-36D0*C2(0,0)-4D0*C2(1,1)*S12+4D0*C2(1,2)*(S13+
     &  S14+S23+S24)+5D0*C0*(S13+S14+S23+S24)-C1(1)*(2D0*S12-S13-
     &  S14-S23-S24)-4D0*C2(2,2)*S34+C1(2)*(S13+S14+S23+S24-2D0*S34)

        PRE = -((ALPHA*PZ12*PZ34*SA*XMW)/(32D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)-K(1)*K(2)*K(7)*PRE*XSW2**(-2)
        F(1,-1,1) = F(1,-1,1)-(2D0*K(1)*K(7)*QF(3)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*K(2)*K(7)*QF(1)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+4D0*K(7)*QF(1)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+2D0*K(1)*K(2)*K(3)*PRE*XSW2**(-2)
        F(5,-1,1) = F(5,-1,1)+(4D0*K(1)*K(3)*QF(3)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-(4D0*K(2)*K(3)*QF(1)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-8D0*K(3)*QF(1)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)+2D0*K(1)*K(2)*K(3)*PRE*XSW2**(-2)
        F(6,-1,1) = F(6,-1,1)+(4D0*K(1)*K(3)*QF(3)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-(4D0*K(2)*K(3)*QF(1)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-8D0*K(3)*QF(1)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+2D0*K(1)*K(2)*K(3)*PRE*XSW2**(-2)
        F(7,-1,1) = F(7,-1,1)+(4D0*K(1)*K(3)*QF(3)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-(4D0*K(2)*K(3)*QF(1)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-8D0*K(3)*QF(1)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)+2D0*K(1)*K(2)*K(3)*PRE*XSW2**(-2)
        F(8,-1,1) = F(8,-1,1)+(4D0*K(1)*K(3)*QF(3)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-(4D0*K(2)*K(3)*QF(1)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-8D0*K(3)*QF(1)*QF(3)*PRE

C       G(T10,N1684,FULL)

C       G(T10,N1685,FULL)

C       G(T10,N1687,FULL)

C       G(T10,N1688,FULL)

C       G(T10,N1689,FULL)

C       G(T10,N1690,FULL)

C       G(T10,N1693,FULL)

C       G(T10,N1694,FULL)

C       G(T10,N1696,FULL)

C       G(T10,N1697,FULL)

C       G(T10,N1698,FULL)

C       G(T10,N1699,FULL)

C       G(T10,N1700,FULL)

C       G(T10,N1701,FULL)

C       G(T10,N1703,FULL)

C       G(T10,N1704,FULL)

C       G(T10,N1705,FULL)

C       G(T10,N1706,FULL)

C       G(T10,N1707,FULL)

C       G(T10,N1708,FULL)

C       G(T10,N1710,FULL)

C       G(T10,N1711,FULL)

C       G(T10,N1712,FULL)

C       G(T10,N1713,FULL)

C       G(T10,N1714,FULL)

C       G(T10,N1715,FULL)

C       G(T10,N1717,FULL)

C       G(T10,N1718,FULL)

C       G(T10,N1719,FULL)

C       G(T10,N1720,FULL)

C       G(T10,N1724,FULL)

C       G(T10,N1725,FULL)

C       G(T10,N1726,FULL)

C       G(T10,N1727,FULL)

C       G(T10,N1728,FULL)

C       G(T10,N1729,FULL)

C       G(T10,N1730,FULL)

C       G(T10,N1731,FULL)

C       G(T10,N1732,FULL)

C       G(T10,N1733,FULL)

C       G(T10,N1734,FULL)

C       G(T10,N1735,FULL)

C       G(T10,N1736,FULL)

C       G(T10,N1737,FULL)

C       G(T10,N1738,FULL)

C       G(T10,N1739,FULL)

C       G(T10,N1740,FULL)

C       G(T10,N1744,FULL)

C       G(T10,N1745,FULL)

C       G(T10,N1746,FULL)

C       G(T10,N1747,FULL)

C       G(T10,N1748,FULL)

C       G(T10,N1749,FULL)

C       G(T10,N1750,FULL)

C       G(T10,N1751,FULL)

C       G(T10,N1752,FULL)

C       G(T10,N1756,FULL)

C       G(T10,N1760,FULL)

C       G(T10,N1761,FULL)

C       G(T10,N1762,FULL)

C       G(T10,N1763,FULL)

C       G(T10,N1764,FULL)

C       G(T10,N1765,FULL)

C       G(T10,N1766,FULL)

C       G(T10,N1767,FULL)

C       G(T10,N1768,FULL)

C       G(T11,N1770,FULL)

C       G(T11,N1771,FULL)

C       G(T11,N1772,FULL)

C       G(T11,N1773,FULL)

C       G(T11,N1774,FULL)

C       G(T11,N1775,FULL)

C       G(T11,N1777,FULL)

C       G(T11,N1778,FULL)

C       G(T11,N1779,FULL)

C       G(T11,N1780,FULL)

C       G(T11,N1781,FULL)

C       G(T11,N1782,FULL)

C       G(T11,N1786,FULL)

C       G(T11,N1787,FULL)

C       G(T11,N1788,FULL)

C       G(T11,N1789,FULL)

C       G(T11,N1790,FULL)

C       G(T11,N1791,FULL)

C       G(T11,N1793,FULL)

C       G(T11,N1794,FULL)

C       G(T11,N1795,FULL)

C       G(T11,N1796,FULL)

C       G(T11,N1797,FULL)

C       G(T11,N1798,FULL)

C       G(T11,N1800,FULL)

C       G(T11,N1801,FULL)

C       G(T11,N1802,FULL)

C       G(T11,N1803,FULL)

C       G(T11,N1804,FULL)

C       G(T11,N1805,FULL)

C       G(T11,N1808,FULL)

C       G(T11,N1809,FULL)

C       G(T11,N1810,FULL)

C       G(T11,N1811,FULL)

C       G(T11,N1812,FULL)

C       G(T11,N1813,FULL)

C       G(T11,N1815,FULL)

C       G(T11,N1816,FULL)

C       G(T11,N1817,FULL)

C       G(T11,N1818,FULL)

C       G(T11,N1819,FULL)

C       G(T11,N1820,FULL)

C       G(T11,N1821,FULL)

C       G(T11,N1822,FULL)

C       G(T11,N1823,FULL)

C       G(T11,N1824,FULL)

C       G(T11,N1825,FULL)

C       G(T11,N1828,FULL)

C       G(T11,N1829,FULL)

C       G(T11,N1830,FULL)

C       G(T11,N1831,FULL)

C       G(T11,N1832,FULL)

C       G(T11,N1833,FULL)

C       G(T11,N1835,FULL)

C       G(T11,N1836,FULL)

C       G(T11,N1837,FULL)

C       G(T11,N1841,FULL)

C       G(T11,N1844,FULL)

C       G(T11,N1845,FULL)

C       G(T11,N1846,FULL)

C       G(T11,N1847,FULL)

C       G(T11,N1848,FULL)

C       G(T11,N1849,FULL)

C       G(T11,N1851,FULL)

C       G(T11,N1852,FULL)

C       G(T11,N1853,FULL)

C       G(T12,N1854,FULL)

C       G(T12,N1855,FULL)

C       G(T12,N1856,FULL)

C       G(T12,N1857,FULL)

C       G(T12,N1860,FULL)

C       G(T12,N1861,FULL)

C       G(T12,N1862,FULL)

C       G(T12,N1863,FULL)

C       G(T12,N1865,FULL)

C       G(T12,N1866,FULL)

C       G(T12,N1867,FULL)

C       G(T12,N1868,FULL)

C       G(T12,N1869,FULL)

C       G(T12,N1872,FULL)

C       G(T12,N1873,FULL)

C       G(T12,N1874,FULL)

C       G(T12,N1875,FULL)

C       G(T12,N1877,FULL)

C       G(T12,N1878,FULL)

C       G(T12,N1879,FULL)

C       G(T12,N1880,FULL)

C       G(T12,N1881,FULL)

C       G(T12,N1884,FULL)

C       G(T12,N1885,FULL)

C       G(T12,N1886,FULL)

C       G(T12,N1887,FULL)

C       G(T12,N1889,FULL)

C       G(T12,N1890,FULL)

C       G(T12,N1891,FULL)

C       G(T12,N1892,FULL)

C       G(T12,N1893,FULL)

C       G(T12,N1896,FULL)

C       G(T12,N1897,FULL)

C       G(T12,N1898,FULL)

C       G(T12,N1899,FULL)
        CALL xC01234_(T14,MHH2,RMF2(3),CMF2(3),XMZ2,XMZ2,C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,1,1)

        PRE = (C1(1)*QF(1)*QF(3)*ALPHA*SA*XCW2**(-2)*XMW)/(8D0*PI*
     &  S12)

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2)**2)/(XSW*
     &  XSW2)
        F(1,-1,1) = F(1,-1,1)+4D0*QF(3)**2*PRE*XSW
        F(1,1,-1) = F(1,1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2)**2)/(XSW*
     &  XSW2)
        F(1,1,1) = F(1,1,1)+4D0*QF(3)**2*PRE*XSW

C       G(T12,N1901,FULL)
        CALL xC01234_(T14,MHH2,RMF2(3),CMF2(4),XMW2,XMW2,C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,1,1)

        PRE = (C1(1)*QF(1)*QF(3)*ALPHA*SA*XMW)/(4D0*PI*S12*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+PRE
        F(1,1,-1) = F(1,1,-1)+PRE

C       G(T12,N1902,FULL)

C       G(T12,N1903,FULL)

C       G(T12,N1904,FULL)

C       G(T12,N1905,FULL)

C       G(T12,N1908,FULL)

C       G(T12,N1909,FULL)

C       G(T12,N1910,FULL)

C       G(T12,N1911,FULL)
        CALL xC01234_(T14,MHH2,RMF2(3),CMF2(3),XMZ2,XMZ2,C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,1,1)

        PRE = (C1(1)*ALPHA*PZ12*SA*XCW2**(-3)*XMW)/(32D0*PI)

        F(1,-1,-1) = F(1,-1,-1)-(PRE*XSW2**(-2)*(1D0-2D0*QF(1)*
     &  XSW2)*(1D0+2D0*QF(3)*XSW2)**3)/XSW
        F(1,-1,1) = F(1,-1,1)-8D0*QF(3)**3*PRE*XSW*(1D0-2D0*QF(1)*
     &  XSW2)
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2)**
     &  3)/(XSW*XSW2)
        F(1,1,1) = F(1,1,1)+16D0*QF(1)*QF(3)**3*PRE*XSW*XSW2

C       G(T12,N1913,FULL)
        CALL xC01234_(T14,MHH2,RMF2(3),CMF2(4),XMW2,XMW2,C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,1,1)

        PRE = (C1(1)*ALPHA*PZ12*SA*XMW*(1D0+2D0*QF(3)*XSW2))/(16D0*
     &  PI*XCW2*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE

C       G(T12,N1915,FULL)

C       G(T12,N1917,FULL)

C       G(T12,N1919,FULL)

C       G(T12,N1921,FULL)

C       G(T12,N1923,FULL)

C       G(T12,N1924,FULL)

C       G(T12,N1925,FULL)

C       G(T12,N1926,FULL)

C       G(T12,N1927,FULL)

C       G(T12,N1928,FULL)

C       G(T12,N1929,FULL)

C       G(T12,N1930,FULL)

C       G(T12,N1931,FULL)

C       G(T12,N1932,FULL)

C       G(T12,N1933,FULL)

C       G(T12,N1934,FULL)

C       G(T12,N1935,FULL)

C       G(T12,N1936,FULL)

C       G(T12,N1937,FULL)

C       G(T12,N1938,FULL)

C       G(T12,N1939,FULL)

C       G(T12,N1940,FULL)

C       G(T12,N1941,FULL)

C       G(T12,N1942,FULL)

C       G(T12,N1943,FULL)

C       G(T12,N1944,FULL)

C       G(T12,N1945,FULL)

C       G(T12,N1946,FULL)

C       G(T12,N1947,FULL)

C       G(T12,N1948,FULL)

C       G(T13,N1949,FULL)

C       G(T13,N1950,FULL)

C       G(T13,N1951,FULL)

C       G(T13,N1952,FULL)

C       G(T13,N1955,FULL)

C       G(T13,N1956,FULL)

C       G(T13,N1957,FULL)

C       G(T13,N1958,FULL)

C       G(T13,N1960,FULL)

C       G(T13,N1961,FULL)

C       G(T13,N1962,FULL)

C       G(T13,N1963,FULL)

C       G(T13,N1964,FULL)

C       G(T13,N1967,FULL)

C       G(T13,N1968,FULL)

C       G(T13,N1969,FULL)

C       G(T13,N1970,FULL)

C       G(T13,N1972,FULL)

C       G(T13,N1973,FULL)

C       G(T13,N1974,FULL)

C       G(T13,N1975,FULL)

C       G(T13,N1976,FULL)

C       G(T13,N1978,FULL)

C       G(T13,N1979,FULL)

C       G(T13,N1980,FULL)

C       G(T13,N1981,FULL)

C       G(T13,N1983,FULL)

C       G(T13,N1984,FULL)

C       G(T13,N1985,FULL)

C       G(T13,N1986,FULL)

C       G(T13,N1988,FULL)

C       G(T13,N1989,FULL)

C       G(T13,N1990,FULL)

C       G(T13,N1991,FULL)

C       G(T13,N1993,FULL)

C       G(T13,N1994,FULL)

C       G(T13,N1995,FULL)

C       G(T13,N1996,FULL)

C       G(T13,N1999,FULL)

C       G(T13,N2000,FULL)

C       G(T13,N2001,FULL)

C       G(T13,N2002,FULL)

C       G(T13,N2004,FULL)

C       G(T13,N2005,FULL)

C       G(T13,N2006,FULL)

C       G(T13,N2007,FULL)

C       G(T13,N2008,FULL)

C       G(T13,N2011,FULL)

C       G(T13,N2012,FULL)

C       G(T13,N2013,FULL)

C       G(T13,N2014,FULL)

C       G(T13,N2016,FULL)

C       G(T13,N2017,FULL)

C       G(T13,N2018,FULL)

C       G(T13,N2019,FULL)

C       G(T13,N2020,FULL)

C       G(T13,N2023,FULL)

C       G(T13,N2024,FULL)

C       G(T13,N2025,FULL)

C       G(T13,N2026,FULL)

C       G(T13,N2028,FULL)

C       G(T13,N2029,FULL)

C       G(T13,N2030,FULL)

C       G(T13,N2031,FULL)

C       G(T13,N2032,FULL)

C       G(T13,N2035,FULL)

C       G(T13,N2036,FULL)

C       G(T13,N2037,FULL)

C       G(T13,N2038,FULL)

C       G(T13,N2040,FULL)
        CALL xC01234_(RMF2(3),S34,RMF2(3),CMF2(4),XMW2,XMW2,C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,1)

        PRE = -((ALPHA*PZ12*PZ34*(1D0-6D0*C2(0,0)+C1(1)*S34+C1(2)*
     &  S34+C2(1,2)*S34)*SA*XMW)/(8D0*PI*XCW2*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE

C       G(T13,N2042,FULL)

C       G(T13,N2044,FULL)

C       G(T13,N2046,FULL)

C       G(T13,N2048,FULL)

C       G(T13,N2050,FULL)

C       G(T13,N2052,FULL)

C       G(T13,N2054,FULL)

C       G(T13,N2056,FULL)
        CALL xC01234_(S34,RMF2(3),RMF2(3),CMF2(4),CMF2(4),XMW2,C0,C1,C2,
     &  C3,C4,B0,B1,B2,B3,2,1)

        PRE = (ALPHA*PZ12*PZ34*(1D0-2D0*C2(0,0)-C1(1)*S34-C1(2)*S34-
     &  C2(1,1)*S34-C2(1,2)*S34)*SA*XCW2**(-2)*XMW*(1D0-2D0*QF(4)*
     &  XSW2))/(16D0*PI*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE

C       G(T13,N2057,FULL)

C       G(T13,N2058,FULL)

C       G(T13,N2059,FULL)

C       G(T13,N2060,FULL)

C       G(T13,N2061,FULL)

C       G(T13,N2062,FULL)

C       G(T13,N2063,FULL)

C       G(T13,N2064,FULL)

C       G(T13,N2065,FULL)

C       G(T13,N2066,FULL)

C       G(T13,N2067,FULL)

C       G(T13,N2068,FULL)

C       G(T13,N2069,FULL)

C       G(T13,N2070,FULL)

C       G(T13,N2071,FULL)

C       G(T13,N2072,FULL)

C       G(T13,N2073,FULL)

C       G(T13,N2074,FULL)

C       G(T13,N2075,FULL)

C       G(T13,N2076,FULL)

C       G(T13,N2077,FULL)

C       G(T13,N2078,FULL)

C       G(T13,N2079,FULL)

C       G(T13,N2080,FULL)

C       G(T13,N2081,FULL)

C       G(T13,N2082,FULL)

C       G(T13,N2083,FULL)

C       G(T13,N2084,FULL)

C       G(T13,N2085,FULL)

C       G(T13,N2086,FULL)

C       G(T13,N2087,FULL)

C       G(T13,N2088,FULL)

C       G(T13,N2089,FULL)

C       G(T13,N2090,FULL)

C       G(T13,N2091,FULL)

C       G(T13,N2092,FULL)

C       G(T13,N2093,FULL)

C       G(T13,N2094,FULL)

C       G(T13,N2095,FULL)
        CALL xC01234_(RMF2(3),S34,RMF2(3),NULL,CMF2(3),CMF2(3),C0,C1,C2,
     &  C3,C4,B0,B1,B2,B3,2,1)

        PRE = -((QF(3)**2*ALPHA*PZ12*PZ34*(1D0-2D0*C2(0,0)+C1(1)*
     &  S34+C1(2)*S34+C2(1,2)*S34+C0*S34)*SA*XCW2**(-2)*XMW)/(8D0*
     &  PI))

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*XSW

C       G(T13,N2096,FULL)
        CALL xC01234_(S34,RMF2(3),RMF2(3),CMF2(3),CMF2(3),XMZ2,C0,C1,C2,
     &  C3,C4,B0,B1,B2,B3,2,1)

        PRE = -((ALPHA*PZ12*PZ34*(1D0-2D0*C2(0,0)-C1(1)*S34-C1(2)*
     &  S34-C2(1,1)*S34-C2(1,2)*S34)*SA*XCW2**(-3)*XMW)/(32D0*PI))

        F(1,-1,-1) = F(1,-1,-1)-(PRE*XSW2**(-2)*(1D0-2D0*QF(1)*
     &  XSW2)*(1D0+2D0*QF(3)*XSW2)**3)/XSW
        F(1,-1,1) = F(1,-1,1)-8D0*QF(3)**3*PRE*XSW*(1D0-2D0*QF(1)*
     &  XSW2)
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2)**
     &  3)/(XSW*XSW2)
        F(1,1,1) = F(1,1,1)+16D0*QF(1)*QF(3)**3*PRE*XSW*XSW2

C       G(T14,N2097,FULL)

C       G(T14,N2098,FULL)

C       G(T14,N2099,FULL)

C       G(T14,N2100,FULL)

C       G(T14,N2103,FULL)

C       G(T14,N2104,FULL)

C       G(T14,N2105,FULL)

C       G(T14,N2106,FULL)

C       G(T14,N2108,FULL)

C       G(T14,N2109,FULL)

C       G(T14,N2110,FULL)

C       G(T14,N2111,FULL)

C       G(T14,N2112,FULL)

C       G(T14,N2114,FULL)

C       G(T14,N2115,FULL)

C       G(T14,N2116,FULL)

C       G(T14,N2117,FULL)

C       G(T14,N2119,FULL)

C       G(T14,N2120,FULL)

C       G(T14,N2121,FULL)

C       G(T14,N2122,FULL)

C       G(T14,N2125,FULL)

C       G(T14,N2126,FULL)

C       G(T14,N2127,FULL)

C       G(T14,N2128,FULL)

C       G(T14,N2130,FULL)

C       G(T14,N2134,FULL)

C       G(T14,N2135,FULL)

C       G(T14,N2136,FULL)

C       G(T14,N2137,FULL)

C       G(T14,N2138,FULL)

C       G(T14,N2141,FULL)

C       G(T14,N2142,FULL)

C       G(T14,N2143,FULL)

C       G(T14,N2144,FULL)

C       G(T14,N2146,FULL)

C       G(T14,N2148,FULL)

C       G(T14,N2150,FULL)

C       G(T14,N2152,FULL)

C       G(T14,N2154,FULL)

C       G(T14,N2156,FULL)

C       G(T14,N2157,FULL)

C       G(T14,N2158,FULL)

C       G(T14,N2159,FULL)

C       G(T14,N2160,FULL)

C       G(T14,N2161,FULL)

C       G(T14,N2162,FULL)

C       G(T14,N2163,FULL)

C       G(T14,N2164,FULL)

C       G(T14,N2165,FULL)

C       G(T14,N2166,FULL)

C       G(T14,N2167,FULL)

C       G(T14,N2168,FULL)

C       G(T14,N2169,FULL)

C       G(T14,N2170,FULL)

C       G(T14,N2171,FULL)

C       G(T14,N2172,FULL)

C       G(T14,N2173,FULL)

C       G(T14,N2174,FULL)

C       G(T14,N2175,FULL)

C       G(T14,N2176,FULL)

C       G(T14,N2177,FULL)

C       G(T14,N2178,FULL)

C       G(T14,N2179,FULL)

C       G(T14,N2180,FULL)

C       G(T14,N2181,FULL)

C       G(T15,N2182,FULL)

C       G(T15,N2183,FULL)

C       G(T15,N2184,FULL)

C       G(T15,N2185,FULL)

C       G(T15,N2188,FULL)

C       G(T15,N2189,FULL)

C       G(T15,N2190,FULL)

C       G(T15,N2191,FULL)

C       G(T15,N2193,FULL)

C       G(T15,N2194,FULL)

C       G(T15,N2195,FULL)

C       G(T15,N2196,FULL)

C       G(T15,N2197,FULL)

C       G(T15,N2199,FULL)

C       G(T15,N2200,FULL)

C       G(T15,N2201,FULL)

C       G(T15,N2202,FULL)

C       G(T15,N2204,FULL)

C       G(T15,N2205,FULL)

C       G(T15,N2206,FULL)

C       G(T15,N2207,FULL)

C       G(T15,N2210,FULL)

C       G(T15,N2211,FULL)

C       G(T15,N2212,FULL)

C       G(T15,N2213,FULL)

C       G(T15,N2215,FULL)

C       G(T15,N2219,FULL)

C       G(T15,N2220,FULL)

C       G(T15,N2221,FULL)

C       G(T15,N2222,FULL)

C       G(T15,N2223,FULL)

C       G(T15,N2226,FULL)

C       G(T15,N2227,FULL)

C       G(T15,N2228,FULL)

C       G(T15,N2229,FULL)

C       G(T15,N2231,FULL)

C       G(T15,N2233,FULL)

C       G(T15,N2235,FULL)

C       G(T15,N2237,FULL)

C       G(T15,N2239,FULL)

C       G(T15,N2241,FULL)

C       G(T15,N2242,FULL)

C       G(T15,N2243,FULL)

C       G(T15,N2244,FULL)

C       G(T15,N2245,FULL)

C       G(T15,N2246,FULL)

C       G(T15,N2247,FULL)

C       G(T15,N2248,FULL)

C       G(T15,N2249,FULL)

C       G(T15,N2250,FULL)

C       G(T15,N2251,FULL)

C       G(T15,N2252,FULL)

C       G(T15,N2253,FULL)

C       G(T15,N2254,FULL)

C       G(T15,N2255,FULL)

C       G(T15,N2256,FULL)

C       G(T15,N2257,FULL)

C       G(T15,N2258,FULL)

C       G(T15,N2259,FULL)

C       G(T15,N2260,FULL)

C       G(T15,N2261,FULL)

C       G(T15,N2262,FULL)

C       G(T15,N2263,FULL)

C       G(T15,N2264,FULL)

C       G(T15,N2265,FULL)

C       G(T15,N2266,FULL)

C       G(T16,N2267,FULL)

C       G(T16,N2268,FULL)

C       G(T16,N2269,FULL)

C       G(T16,N2270,FULL)

C       G(T16,N2271,FULL)

C       G(T16,N2272,FULL)

C       G(T16,N2273,FULL)

C       G(T16,N2274,FULL)

C       G(T16,N2275,FULL)

C       G(T16,N2276,FULL)

C       G(T16,N2277,FULL)

C       G(T16,N2278,FULL)

C       G(T16,N2279,FULL)

C       G(T16,N2280,FULL)

C       G(T16,N2281,FULL)

C       G(T16,N2282,FULL)

C       G(T16,N2283,FULL)

C       G(T16,N2284,FULL)

C       G(T16,N2285,FULL)

C       G(T16,N2286,FULL)

C       G(T16,N2287,FULL)

C       G(T16,N2288,FULL)

C       G(T16,N2289,FULL)

C       G(T16,N2290,FULL)

C       G(T16,N2291,FULL)

C       G(T16,N2292,FULL)

C       G(T16,N2293,FULL)

C       G(T16,N2294,FULL)

C       G(T16,N2295,FULL)

C       G(T16,N2296,FULL)

C       G(T16,N2297,FULL)

C       G(T16,N2298,FULL)

C       G(T16,N2299,FULL)

C       G(T16,N2300,FULL)

C       G(T16,N2301,FULL)

C       G(T16,N2302,FULL)

C       G(T16,N2303,FULL)

C       G(T16,N2304,FULL)

C       G(T16,N2305,FULL)

C       G(T16,N2306,FULL)

C       G(T16,N2307,FULL)

C       G(T16,N2308,FULL)

C       G(T16,N2309,FULL)

C       G(T16,N2310,FULL)

C       G(T16,N2311,FULL)

C       G(T16,N2312,FULL)

C       G(T16,N2313,FULL)

C       G(T16,N2314,FULL)

C       G(T16,N2315,FULL)

C       G(T16,N2316,FULL)

C       G(T16,N2317,FULL)

C       G(T16,N2318,FULL)

C       G(T16,N2319,FULL)

C       G(T16,N2320,FULL)

C       G(T16,N2321,FULL)
        CALL xB012345_(MHH2,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((QF(1)*QF(3)*ALPHA*B0*SA*XMHH2)/(4D0*PI*S12*S34*XMW*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE
        F(1,-1,1) = F(1,-1,1)+PRE
        F(1,1,-1) = F(1,1,-1)+PRE
        F(1,1,1) = F(1,1,1)+PRE

C       G(T16,N2322,FULL)
        CALL xB012345_(MHH2,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = (QF(1)*QF(3)*ALPHA*(2D0-3D0*B0)*SA*XMW)/(2D0*PI*S12*
     &  S34*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE
        F(1,-1,1) = F(1,-1,1)+PRE
        F(1,1,-1) = F(1,1,-1)+PRE
        F(1,1,1) = F(1,1,1)+PRE

C       G(T16,N2323,FULL)
        CALL xB012345_(MHH2,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = (QF(1)*ALPHA*B0*PZ34*SA*XMHH2*(XCW+XSW)*(XCW-XSW))/
     &  (16D0*PI*S12*XCW2*XMW*XSW)

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE
        F(1,1,-1) = F(1,1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,1,1) = F(1,1,1)+2D0*QF(3)*PRE

C       G(T16,N2324,FULL)
        CALL xB012345_(MHH2,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((QF(1)*ALPHA*(2D0-3D0*B0)*PZ34*SA*XMW)/(4D0*PI*S12*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE
        F(1,1,-1) = F(1,1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,1,1) = F(1,1,1)+2D0*QF(3)*PRE

C       G(T16,N2325,FULL)

C       G(T16,N2326,FULL)

C       G(T16,N2327,FULL)

C       G(T16,N2328,FULL)

C       G(T16,N2329,FULL)

C       G(T16,N2330,FULL)

C       G(T16,N2331,FULL)

C       G(T16,N2332,FULL)
        CALL xB012345_(MHH2,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = (QF(3)*ALPHA*B0*PZ12*SA*XMHH2*(XCW+XSW)*(XCW-XSW))/
     &  (16D0*PI*S34*XCW2*XMW*XSW)

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE
        F(1,1,1) = F(1,1,1)+2D0*QF(1)*PRE

C       G(T16,N2333,FULL)
        CALL xB012345_(MHH2,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((QF(3)*ALPHA*(2D0-3D0*B0)*PZ12*SA*XMW)/(4D0*PI*S34*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE
        F(1,1,1) = F(1,1,1)+2D0*QF(1)*PRE

C       G(T16,N2334,FULL)
        CALL xB012345_(MHH2,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PZ12*PZ34*SA*XCW2**(-2)*XMHH2*(XCW+XSW)**
     &  2*(XCW-XSW)**2)/(64D0*PI*XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T16,N2335,FULL)
        CALL xB012345_(MHH2,XMH2,XMH2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((B0*CA**2*PI**(-2)*PZ12*PZ34*SA*XCW2**(-2)*(2D0*
     &  XMH2+XMHH2)*(4D0*ALPHA*PI*XMH2+12D0*ALPHA*CA**2*PI*XMH2-4D0*
     &  ALPHA*PI*SA**2*XMH2-4D0*ALPHA*PI*XMHH2-12D0*ALPHA*CA**2*PI*
     &  XMHH2+4D0*ALPHA*PI*SA**2*XMHH2-32D0*L12*XMW2*XSW2))/(2048D0*
     &  (XMH+XMHH)*(XMH-XMHH)*XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T16,N2336,FULL)
        CALL xB012345_(MHH2,XMHH2,XMH2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((B0*CA**2*PI**(-2)*PZ12*PZ34*SA*XCW2**(-2)*(XMH2+
     &  2D0*XMHH2)*(4D0*ALPHA*PI*XMH2-4D0*ALPHA*CA**2*PI*XMH2+12D0*
     &  ALPHA*PI*SA**2*XMH2-4D0*ALPHA*PI*XMHH2+4D0*ALPHA*CA**2*PI*
     &  XMHH2-12D0*ALPHA*PI*SA**2*XMHH2+32D0*L12*XMW2*XSW2))/
     &  (1024D0*(XMH+XMHH)*(XMH-XMHH)*XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T16,N2337,FULL)
        CALL xB012345_(MHH2,XMZ2,XMZ2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PZ12*PZ34*SA*XCW2**(-2)*XMHH2)/(128D0*PI*
     &  XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T16,N2338,FULL)
        CALL xB012345_(MHH2,XMHH2,XMHH2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((3D0*B0*PI**(-2)*PZ12*PZ34*SA*XCW2**(-2)*XMHH2*
     &  (12D0*ALPHA*PI*XMH2-16D0*ALPHA*CA**2*PI*XMH2+4D0*ALPHA*CA**
     &  4*PI*XMH2+16D0*ALPHA*PI*SA**2*XMH2-24D0*ALPHA*CA**2*PI*SA**
     &  2*XMH2+4D0*ALPHA*PI*SA**4*XMH2-12D0*ALPHA*PI*XMHH2+16D0*
     &  ALPHA*CA**2*PI*XMHH2-4D0*ALPHA*CA**4*PI*XMHH2-16D0*ALPHA*PI*
     &  SA**2*XMHH2+24D0*ALPHA*CA**2*PI*SA**2*XMHH2-4D0*ALPHA*PI*
     &  SA**4*XMHH2-32D0*L12*XMW2*XSW2-32D0*CA**2*L12*XMW2*XSW2+
     &  32D0*L12*SA**2*XMW2*XSW2))/(4096D0*(XMH+XMHH)*(XMH-XMHH)*
     &  XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T16,N2339,FULL)
        CALL xB012345_(MHH2,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = (ALPHA*(2D0-3D0*B0)*PZ12*PZ34*SA*XMW)/(8D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T17,N2340,FULL)

C       G(T17,N2341,FULL)

C       G(T17,N2342,FULL)

C       G(T17,N2343,FULL)

C       G(T17,N2344,FULL)

C       G(T17,N2345,FULL)

C       G(T17,N2346,FULL)

C       G(T17,N2347,FULL)

C       G(T17,N2348,FULL)

C       G(T17,N2349,FULL)

C       G(T17,N2350,FULL)

C       G(T17,N2351,FULL)

C       G(T17,N2352,FULL)

C       G(T17,N2353,FULL)

C       G(T17,N2354,FULL)

C       G(T17,N2355,FULL)

C       G(T17,N2356,FULL)

C       G(T17,N2357,FULL)

C       G(T17,N2358,FULL)

C       G(T17,N2359,FULL)

C       G(T17,N2360,FULL)

C       G(T17,N2361,FULL)

C       G(T17,N2362,FULL)

C       G(T17,N2363,FULL)

C       G(T17,N2364,FULL)

C       G(T17,N2365,FULL)

C       G(T17,N2366,FULL)

C       G(T17,N2367,FULL)

C       G(T17,N2368,FULL)

C       G(T17,N2369,FULL)

C       G(T17,N2370,FULL)

C       G(T17,N2371,FULL)

C       G(T17,N2372,FULL)

C       G(T17,N2373,FULL)

C       G(T17,N2374,FULL)

C       G(T17,N2375,FULL)

C       G(T17,N2376,FULL)

C       G(T17,N2377,FULL)

C       G(T17,N2378,FULL)

C       G(T17,N2379,FULL)

C       G(T17,N2380,FULL)

C       G(T17,N2381,FULL)

C       G(T17,N2382,FULL)

C       G(T17,N2383,FULL)

C       G(T17,N2384,FULL)

C       G(T17,N2385,FULL)

C       G(T17,N2386,FULL)
        CALL xB012345_(S34,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((QF(1)*QF(3)*ALPHA*B0*SA*XMW)/(8D0*PI*S12*S34*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE
        F(1,-1,1) = F(1,-1,1)+PRE
        F(1,1,-1) = F(1,1,-1)+PRE
        F(1,1,1) = F(1,1,1)+PRE

C       G(T17,N2387,FULL)
        CALL xB012345_(S34,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((QF(1)*QF(3)*ALPHA*B0*SA*XMW)/(8D0*PI*S12*S34*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE
        F(1,-1,1) = F(1,-1,1)+PRE
        F(1,1,-1) = F(1,1,-1)+PRE
        F(1,1,1) = F(1,1,1)+PRE

C       G(T17,N2388,FULL)
        CALL xB012345_(S34,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((QF(1)*ALPHA*B0*PZ34*SA*XMW)/(16D0*PI*S12*XCW2))

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE*XSW
        F(1,1,-1) = F(1,1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW
        F(1,1,1) = F(1,1,1)+2D0*QF(3)*PRE*XSW

C       G(T17,N2389,FULL)
        CALL xB012345_(S34,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((QF(1)*ALPHA*B0*PZ34*SA*XMW)/(16D0*PI*S12*XCW2))

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE*XSW
        F(1,1,-1) = F(1,1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW
        F(1,1,1) = F(1,1,1)+2D0*QF(3)*PRE*XSW

C       G(T17,N2390,FULL)

C       G(T17,N2391,FULL)

C       G(T17,N2392,FULL)

C       G(T17,N2393,FULL)

C       G(T17,N2394,FULL)

C       G(T17,N2395,FULL)

C       G(T17,N2396,FULL)

C       G(T17,N2397,FULL)

C       G(T17,N2398,FULL)
        CALL xB012345_(S34,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((QF(3)*ALPHA*B0*PZ12*SA*XMW)/(16D0*PI*S34*XCW2))

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE*XSW
        F(1,1,1) = F(1,1,1)+2D0*QF(1)*PRE*XSW

C       G(T17,N2399,FULL)
        CALL xB012345_(S34,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((QF(3)*ALPHA*B0*PZ12*SA*XMW)/(16D0*PI*S34*XCW2))

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE*XSW
        F(1,1,1) = F(1,1,1)+2D0*QF(1)*PRE*XSW

C       G(T17,N2400,FULL)
        CALL xB012345_(S34,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PZ12*PZ34*SA*XCW2**(-2)*XMW)/(32D0*PI))

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)-2D0*QF(3)*PRE*XSW*(1D0-2D0*QF(1)*XSW2)
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE*XSW*(1D0+2D0*QF(3)*XSW2)
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*XSW*XSW2

C       G(T17,N2401,FULL)
        CALL xB012345_(S34,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PZ12*PZ34*SA*XCW2**(-2)*XMW)/(32D0*PI))

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)-2D0*QF(3)*PRE*XSW*(1D0-2D0*QF(1)*XSW2)
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE*XSW*(1D0+2D0*QF(3)*XSW2)
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*XSW*XSW2

C       G(T17,N2402,FULL)
        CALL xB012345_(S34,XMZ2,XMH2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*CA**2*PZ12*PZ34*SA*XCW2**(-3)*XMW)/(32D0*
     &  PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T17,N2403,FULL)
        CALL xB012345_(S34,XMZ2,XMHH2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PZ12*PZ34*SA**3*XCW2**(-3)*XMW)/(32D0*PI*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T18,N2404,FULL)

C       G(T18,N2405,FULL)

C       G(T18,N2406,FULL)

C       G(T18,N2407,FULL)

C       G(T18,N2408,FULL)

C       G(T18,N2409,FULL)

C       G(T18,N2410,FULL)

C       G(T18,N2411,FULL)

C       G(T18,N2412,FULL)

C       G(T18,N2413,FULL)

C       G(T18,N2414,FULL)

C       G(T18,N2415,FULL)

C       G(T18,N2416,FULL)

C       G(T18,N2417,FULL)

C       G(T18,N2418,FULL)

C       G(T18,N2419,FULL)

C       G(T18,N2420,FULL)

C       G(T18,N2421,FULL)

C       G(T18,N2422,FULL)

C       G(T18,N2423,FULL)

C       G(T18,N2424,FULL)

C       G(T18,N2425,FULL)

C       G(T18,N2426,FULL)

C       G(T18,N2427,FULL)

C       G(T18,N2428,FULL)

C       G(T18,N2429,FULL)

C       G(T18,N2430,FULL)

C       G(T18,N2431,FULL)

C       G(T18,N2432,FULL)

C       G(T18,N2433,FULL)

C       G(T18,N2434,FULL)

C       G(T18,N2435,FULL)

C       G(T18,N2436,FULL)

C       G(T18,N2437,FULL)

C       G(T18,N2438,FULL)

C       G(T18,N2439,FULL)

C       G(T18,N2440,FULL)

C       G(T18,N2441,FULL)

C       G(T18,N2442,FULL)

C       G(T18,N2443,FULL)

C       G(T18,N2444,FULL)

C       G(T18,N2445,FULL)

C       G(T18,N2446,FULL)

C       G(T18,N2447,FULL)

C       G(T18,N2448,FULL)

C       G(T18,N2449,FULL)

C       G(T18,N2450,FULL)

C       G(T18,N2451,FULL)

C       G(T18,N2452,FULL)
        CALL xB012345_(S12,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((QF(1)*QF(3)*ALPHA*B0*SA*XMW)/(8D0*PI*S12*S34*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE
        F(1,-1,1) = F(1,-1,1)+PRE
        F(1,1,-1) = F(1,1,-1)+PRE
        F(1,1,1) = F(1,1,1)+PRE

C       G(T18,N2453,FULL)
        CALL xB012345_(S12,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((QF(1)*QF(3)*ALPHA*B0*SA*XMW)/(8D0*PI*S12*S34*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE
        F(1,-1,1) = F(1,-1,1)+PRE
        F(1,1,-1) = F(1,1,-1)+PRE
        F(1,1,1) = F(1,1,1)+PRE

C       G(T18,N2454,FULL)
        CALL xB012345_(S12,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((QF(1)*ALPHA*B0*PZ34*SA*XMW)/(16D0*PI*S12*XCW2))

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE*XSW
        F(1,1,-1) = F(1,1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW
        F(1,1,1) = F(1,1,1)+2D0*QF(3)*PRE*XSW

C       G(T18,N2455,FULL)
        CALL xB012345_(S12,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((QF(1)*ALPHA*B0*PZ34*SA*XMW)/(16D0*PI*S12*XCW2))

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE*XSW
        F(1,1,-1) = F(1,1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW
        F(1,1,1) = F(1,1,1)+2D0*QF(3)*PRE*XSW

C       G(T18,N2456,FULL)

C       G(T18,N2457,FULL)

C       G(T18,N2458,FULL)

C       G(T18,N2459,FULL)

C       G(T18,N2460,FULL)

C       G(T18,N2461,FULL)

C       G(T18,N2462,FULL)
        CALL xB012345_(S12,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((QF(3)*ALPHA*B0*PZ12*SA*XMW)/(16D0*PI*S34*XCW2))

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE*XSW
        F(1,1,1) = F(1,1,1)+2D0*QF(1)*PRE*XSW

C       G(T18,N2463,FULL)
        CALL xB012345_(S12,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((QF(3)*ALPHA*B0*PZ12*SA*XMW)/(16D0*PI*S34*XCW2))

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE*XSW
        F(1,1,1) = F(1,1,1)+2D0*QF(1)*PRE*XSW

C       G(T18,N2464,FULL)
        CALL xB012345_(S12,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PZ12*PZ34*SA*XCW2**(-2)*XMW)/(32D0*PI))

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)-2D0*QF(3)*PRE*XSW*(1D0-2D0*QF(1)*XSW2)
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE*XSW*(1D0+2D0*QF(3)*XSW2)
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*XSW*XSW2

C       G(T18,N2465,FULL)
        CALL xB012345_(S12,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PZ12*PZ34*SA*XCW2**(-2)*XMW)/(32D0*PI))

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)-2D0*QF(3)*PRE*XSW*(1D0-2D0*QF(1)*XSW2)
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE*XSW*(1D0+2D0*QF(3)*XSW2)
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*XSW*XSW2

C       G(T18,N2466,FULL)
        CALL xB012345_(S12,XMZ2,XMH2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*CA**2*PZ12*PZ34*SA*XCW2**(-3)*XMW)/(32D0*
     &  PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T18,N2467,FULL)
        CALL xB012345_(S12,XMZ2,XMHH2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PZ12*PZ34*SA**3*XCW2**(-3)*XMW)/(32D0*PI*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

	end

**********************************************************************
        subroutine  HHtoZZ1133_box_sesm(F,pz12,pz34)
**********************************************************************
*       box corrections for HH -> ZZ -> uudd in the SESM
*---------------------------------------------------------------------
*       7.2.17 Stefan Dittmaier
**********************************************************************
	implicit none
	complex*16 pre,F(13,-1:1,-1:1),pz12,pz34
	complex*16 A0,xA0_,B0_,xB0_,DB0_,xDB0_,B1_,xB1_,DB1_,xDB1_
        complex*16 B0,B1(1),B2(0:2,0:2),B3(0:2,0:2,2)
        complex*16 B4(0:2,0:2,0:2,0:2),B5(0:2,0:2,0:2,0:2,2)
        complex*16 C0_,C0,C1(2),C2(0:2,0:2),C3(0:2,0:2,2)
        complex*16 C4(0:2,0:2,0:2,0:2)
	complex*16 D0,D1(3),D2(0:3,0:3),D3(0:3,0:3,3)
        complex*16 D4(0:3,0:3,0:3,0:3),D5(0:3,0:3,0:3,0:3,3)
	complex*16 E0n,E1n(4),E2n(0:4,0:4),E3n(0:4,0:4,4)
	complex*16 E4n(0:4,0:4,0:4,0:4)
        COMPLEX*16 K(7)

c mandelstam variables
      	real*8 s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
      	common/mandel/s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
c fermion charges of isospin duplets
	real*8 qf(4)
	common/fcharge/qf
c fermion masses as flag (i*1d-20)
      	complex*16 cme2,cmf2(5)
      	real*8 me2,rme2,mf2(5),rmf2(5)
      	common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2
	include '../COMMON/param.inc'
	include '../COMMON/xparam.inc'
        include '../COMMON/param_sesm.inc'
        include '../COMMON/param_bsm.inc'

C       Process: S4F21aF21F23aF23,   Model: Singlet

C       G(T1,N1,FULL)

C       G(T1,N2,FULL)

C       G(T1,N3,FULL)

C       G(T1,N4,FULL)

C       G(T1,N5,FULL)

C       G(T2,N6,FULL)

C       G(T2,N7,FULL)

C       G(T2,N8,FULL)

C       G(T2,N9,FULL)

C       G(T2,N10,FULL)

C       G(T3,N11,FULL)

C       G(T3,N12,FULL)

C       G(T3,N13,FULL)

C       G(T3,N14,FULL)

C       G(T3,N15,FULL)

C       G(T3,N16,FULL)

C       G(T3,N17,FULL)

C       G(T3,N18,FULL)

C       G(T3,N19,FULL)

C       G(T3,N20,FULL)

C       G(T4,N21,FULL)

C       G(T4,N22,FULL)

C       G(T4,N23,FULL)

C       G(T4,N24,FULL)

C       G(T4,N25,FULL)

C       G(T4,N26,FULL)

C       G(T4,N27,FULL)

C       G(T4,N28,FULL)

C       G(T4,N29,FULL)

C       G(T4,N30,FULL)

C       G(T4,N31,FULL)

C       G(T4,N32,FULL)

C       G(T4,N33,FULL)

C       G(T4,N34,FULL)

C       G(T4,N35,FULL)
        CALL xD012345_(RMF2(1),MHH2,S34,RMF2(1),S12,T12,CMF2(2),XMW2,
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = -(4D0*D2(0,0))+D2(1,3)*S12-D2(2,3)*(S13+S14)-2D0*
     &  D1(2)*T12-D2(2,2)*T12+2D0*D1(1)*(MHH2-T12)+D2(1,2)*(MHH2-
     &  T12)

        PRE = (QF(3)*ALPHA*SA*XMW)/(16D0*PI*S34*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+K(1)*PRE
        F(1,-1,1) = F(1,-1,1)+K(1)*PRE
        F(5,-1,-1) = F(5,-1,-1)-4D0*D1(3)*PRE
        F(5,-1,1) = F(5,-1,1)-4D0*D1(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)-4D0*D1(3)*PRE
        F(7,-1,1) = F(7,-1,1)-4D0*D1(3)*PRE

C       G(T4,N36,FULL)
        CALL xD012345_(RMF2(1),MHH2,S34,RMF2(1),S12,T12,CMF2(2),XMW2,
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = D1(3)-2D0*D2(2,2)-2D0*D2(2,3)
        K(2) = -(12D0*D2(0,0))+2D0*D2(1,3)*S12-2D0*D1(3)*(S13+S14)-
     &  2D0*D2(2,3)*(S13+S14)+D1(1)*(S12-S23-S24)-D1(2)*(3D0*S13+
     &  3D0*S14+S34)-2D0*D2(2,2)*T12+2D0*D2(1,2)*(MHH2-T12)

        PRE = -((QF(3)*ALPHA*SA*XMW)/(8D0*PI*S34*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+K(2)*PRE
        F(1,-1,1) = F(1,-1,1)+K(2)*PRE
        F(5,-1,-1) = F(5,-1,-1)+2D0*K(1)*PRE
        F(5,-1,1) = F(5,-1,1)+2D0*K(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)+4D0*(D1(1)+D2(1,2))*PRE
        F(6,-1,1) = F(6,-1,1)+4D0*(D1(1)+D2(1,2))*PRE
        F(7,-1,-1) = F(7,-1,-1)+2D0*K(1)*PRE
        F(7,-1,1) = F(7,-1,1)+2D0*K(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)+4D0*(D1(1)+D2(1,2))*PRE
        F(8,-1,1) = F(8,-1,1)+4D0*(D1(1)+D2(1,2))*PRE

C       G(T4,N37,FULL)

C       G(T4,N38,FULL)

C       G(T4,N39,FULL)

C       G(T4,N40,FULL)

C       G(T4,N41,FULL)

C       G(T4,N42,FULL)

C       G(T4,N43,FULL)

C       G(T4,N44,FULL)

C       G(T4,N45,FULL)
        CALL xD012345_(RMF2(1),MHH2,S34,RMF2(1),S12,T12,CMF2(2),XMW2,
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = -(4D0*D2(0,0))+D2(1,3)*S12-D2(2,3)*(S13+S14)-2D0*
     &  D1(2)*T12-D2(2,2)*T12+2D0*D1(1)*(MHH2-T12)+D2(1,2)*(MHH2-
     &  T12)

        PRE = -((ALPHA*PZ34*SA*XMW)/(32D0*PI*XCW2*XSW))

        F(1,-1,-1) = F(1,-1,-1)-(K(1)*PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)-2D0*K(1)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(4D0*D1(3)*PRE*(1D0+2D0*QF(3)*
     &  XSW2))/XSW2
        F(5,-1,1) = F(5,-1,1)+8D0*D1(3)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+(4D0*D1(3)*PRE*(1D0+2D0*QF(3)*
     &  XSW2))/XSW2
        F(7,-1,1) = F(7,-1,1)+8D0*D1(3)*QF(3)*PRE

C       G(T4,N46,FULL)
        CALL xD012345_(RMF2(1),MHH2,S34,RMF2(1),S12,T12,CMF2(2),XMW2,
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = D1(3)-2D0*D2(2,2)-2D0*D2(2,3)
        K(2) = -(12D0*D2(0,0))+2D0*D2(1,3)*S12-2D0*D1(3)*(S13+S14)-
     &  2D0*D2(2,3)*(S13+S14)+D1(1)*(S12-S23-S24)-D1(2)*(3D0*S13+
     &  3D0*S14+S34)-2D0*D2(2,2)*T12+2D0*D2(1,2)*(MHH2-T12)

        PRE = (ALPHA*PZ34*SA*XMW)/(16D0*PI*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+(K(2)*PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*K(2)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(5,-1,1) = F(5,-1,1)+4D0*K(1)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)+(4D0*(D1(1)+D2(1,2))*PRE*(1D0+2D0*
     &  QF(3)*XSW2))/XSW2
        F(6,-1,1) = F(6,-1,1)+8D0*(D1(1)+D2(1,2))*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(7,-1,1) = F(7,-1,1)+4D0*K(1)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)+(4D0*(D1(1)+D2(1,2))*PRE*(1D0+2D0*
     &  QF(3)*XSW2))/XSW2
        F(8,-1,1) = F(8,-1,1)+8D0*(D1(1)+D2(1,2))*QF(3)*PRE

C       G(T6,N54,FULL)

C       G(T6,N55,FULL)

C       G(T6,N56,FULL)

C       G(T6,N57,FULL)

C       G(T6,N58,FULL)

C       G(T6,N59,FULL)

C       G(T6,N60,FULL)

C       G(T6,N61,FULL)

C       G(T6,N62,FULL)

C       G(T8,N69,FULL)

C       G(T8,N70,FULL)

C       G(T8,N71,FULL)

C       G(T8,N72,FULL)

C       G(T8,N73,FULL)

C       G(T8,N74,FULL)

C       G(T8,N75,FULL)

C       G(T8,N76,FULL)

C       G(T8,N77,FULL)
        CALL xD012345_(S34,RMF2(1),MHH2,RMF2(1),T12,T11,CMF2(2),
     &  CMF2(2),XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = D1(3)+D2(1,3)+D2(2,3)
        K(2) = D1(1)+D1(2)+D2(1,1)+(2D0*D2(0,0))/S34-(D1(3)*(S13+
     &  S14))/S34-(D2(1,3)*(S13+S14))/S34+(D2(1,2)*(S23+S24+2D0*
     &  S34))/S34+(D2(2,2)*T11)/S34-(D2(2,3)*(MHH2-T11))/S34

        PRE = (QF(2)*QF(3)*ALPHA*SA*XMW)/(4D0*PI*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+K(2)*PRE
        F(1,-1,1) = F(1,-1,1)+K(2)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(1)*PRE)/S34
        F(5,-1,1) = F(5,-1,1)+(2D0*K(1)*PRE)/S34
        F(6,-1,-1) = F(6,-1,-1)-(2D0*(D2(1,2)+D2(2,2))*PRE)/S34
        F(6,-1,1) = F(6,-1,1)-(2D0*(D2(1,2)+D2(2,2))*PRE)/S34
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(1)*PRE)/S34
        F(7,-1,1) = F(7,-1,1)+(2D0*K(1)*PRE)/S34
        F(8,-1,-1) = F(8,-1,-1)-(2D0*(D2(1,2)+D2(2,2))*PRE)/S34
        F(8,-1,1) = F(8,-1,1)-(2D0*(D2(1,2)+D2(2,2))*PRE)/S34

C       G(T8,N78,FULL)
        CALL xD012345_(S34,RMF2(1),MHH2,RMF2(1),T12,T11,CMF2(1),
     &  CMF2(1),XMZ2,XMZ2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = S13+S14
        K(3) = D2(1,2)+D2(2,2)
        K(4) = S23+S24+2D0*S34
        K(5) = D1(3)+D2(1,3)+D2(2,3)
        K(6) = D1(1)+D1(2)+D2(1,1)+(2D0*D2(0,0))/S34-(D1(3)*(S13+
     &  S14))/S34-(D2(1,3)*(S13+S14))/S34+(D2(1,2)*(S23+S24+2D0*
     &  S34))/S34+(D2(2,2)*T11)/S34-(D2(2,3)*(MHH2-T11))/S34

        PRE = (QF(1)*QF(3)*ALPHA*SA*XCW2**(-2)*XMW)/(8D0*PI)

        F(1,-1,-1) = F(1,-1,-1)+(K(1)**2*K(6)*PRE)/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)+(K(1)**2*K(6)*PRE)/(XSW*XSW2)
        F(1,1,-1) = F(1,1,-1)+4D0*K(6)*QF(1)**2*PRE*XSW
        F(1,1,1) = F(1,1,1)+4D0*K(6)*QF(1)**2*PRE*XSW
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(1)**2*K(5)*PRE)/(S34*XSW*
     &  XSW2)
        F(5,-1,1) = F(5,-1,1)+(2D0*K(1)**2*K(5)*PRE)/(S34*XSW*XSW2)
        F(5,1,-1) = F(5,1,-1)+(8D0*K(5)*QF(1)**2*PRE*XSW)/S34
        F(5,1,1) = F(5,1,1)+(8D0*K(5)*QF(1)**2*PRE*XSW)/S34
        F(6,-1,-1) = F(6,-1,-1)-(2D0*K(1)**2*K(3)*PRE)/(S34*XSW*
     &  XSW2)
        F(6,-1,1) = F(6,-1,1)-(2D0*K(1)**2*K(3)*PRE)/(S34*XSW*XSW2)
        F(6,1,-1) = F(6,1,-1)-(8D0*K(3)*QF(1)**2*PRE*XSW)/S34
        F(6,1,1) = F(6,1,1)-(8D0*K(3)*QF(1)**2*PRE*XSW)/S34
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(1)**2*K(5)*PRE)/(S34*XSW*
     &  XSW2)
        F(7,-1,1) = F(7,-1,1)+(2D0*K(1)**2*K(5)*PRE)/(S34*XSW*XSW2)
        F(7,1,-1) = F(7,1,-1)+(8D0*K(5)*QF(1)**2*PRE*XSW)/S34
        F(7,1,1) = F(7,1,1)+(8D0*K(5)*QF(1)**2*PRE*XSW)/S34
        F(8,-1,-1) = F(8,-1,-1)-(2D0*K(1)**2*K(3)*PRE)/(S34*XSW*
     &  XSW2)
        F(8,-1,1) = F(8,-1,1)-(2D0*K(1)**2*K(3)*PRE)/(S34*XSW*XSW2)
        F(8,1,-1) = F(8,1,-1)-(8D0*K(3)*QF(1)**2*PRE*XSW)/S34
        F(8,1,1) = F(8,1,1)-(8D0*K(3)*QF(1)**2*PRE*XSW)/S34

C       G(T8,N79,FULL)

C       G(T8,N80,FULL)

C       G(T8,N81,FULL)

C       G(T8,N82,FULL)

C       G(T8,N83,FULL)
        CALL xD012345_(S34,RMF2(1),MHH2,RMF2(1),T12,T11,CMF2(2),
     &  CMF2(2),XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = D1(3)+D2(1,3)+D2(2,3)
        K(2) = 2D0*D2(0,0)-D1(3)*(S13+S14)-D2(1,3)*(S13+S14)+D1(1)*
     &  S34+D1(2)*S34+D2(1,1)*S34+D2(1,2)*(S23+S24+2D0*S34)+D2(2,2)*
     &  T11-D2(2,3)*(MHH2-T11)

        PRE = (ALPHA*PZ34*SA*XMW*(1D0+2D0*QF(2)*XSW2))/(16D0*PI*
     &  XCW2*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+(K(2)*PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*K(2)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(5,-1,1) = F(5,-1,1)+4D0*K(1)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)-(2D0*(D2(1,2)+D2(2,2))*PRE*(1D0+2D0*
     &  QF(3)*XSW2))/XSW2
        F(6,-1,1) = F(6,-1,1)-4D0*(D2(1,2)+D2(2,2))*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(7,-1,1) = F(7,-1,1)+4D0*K(1)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)-(2D0*(D2(1,2)+D2(2,2))*PRE*(1D0+2D0*
     &  QF(3)*XSW2))/XSW2
        F(8,-1,1) = F(8,-1,1)-4D0*(D2(1,2)+D2(2,2))*QF(3)*PRE

C       G(T8,N84,FULL)
        CALL xD012345_(S34,RMF2(1),MHH2,RMF2(1),T12,T11,CMF2(1),
     &  CMF2(1),XMZ2,XMZ2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = S13+S14
        K(4) = D2(1,2)+D2(2,2)
        K(5) = S23+S24+2D0*S34
        K(6) = D1(3)+D2(1,3)+D2(2,3)
        K(7) = 2D0*D2(0,0)-D1(3)*(S13+S14)-D2(1,3)*(S13+S14)+D1(1)*
     &  S34+D1(2)*S34+D2(1,1)*S34+D2(1,2)*(S23+S24+2D0*S34)+D2(2,2)*
     &  T11-D2(2,3)*(MHH2-T11)

        PRE = (ALPHA*PZ34*SA*XCW2**(-3)*XMW)/(32D0*PI)

        F(1,-1,-1) = F(1,-1,-1)-(K(1)**3*K(2)*K(7)*PRE*XSW2**(-2))/
     &  XSW
        F(1,-1,1) = F(1,-1,1)-(2D0*K(1)**3*K(7)*QF(3)*PRE)/(XSW*
     &  XSW2)
        F(1,1,-1) = F(1,1,-1)+8D0*K(2)*K(7)*QF(1)**3*PRE*XSW
        F(1,1,1) = F(1,1,1)+16D0*K(7)*QF(1)**3*QF(3)*PRE*XSW*XSW2
        F(5,-1,-1) = F(5,-1,-1)-(2D0*K(1)**3*K(2)*K(6)*PRE*XSW2**(-
     &  2))/XSW
        F(5,-1,1) = F(5,-1,1)-(4D0*K(1)**3*K(6)*QF(3)*PRE)/(XSW*
     &  XSW2)
        F(5,1,-1) = F(5,1,-1)+16D0*K(2)*K(6)*QF(1)**3*PRE*XSW
        F(5,1,1) = F(5,1,1)+32D0*K(6)*QF(1)**3*QF(3)*PRE*XSW*XSW2
        F(6,-1,-1) = F(6,-1,-1)+(2D0*K(1)**3*K(2)*K(4)*PRE*XSW2**(-
     &  2))/XSW
        F(6,-1,1) = F(6,-1,1)+(4D0*K(1)**3*K(4)*QF(3)*PRE)/(XSW*
     &  XSW2)
        F(6,1,-1) = F(6,1,-1)-16D0*K(2)*K(4)*QF(1)**3*PRE*XSW
        F(6,1,1) = F(6,1,1)-32D0*K(4)*QF(1)**3*QF(3)*PRE*XSW*XSW2
        F(7,-1,-1) = F(7,-1,-1)-(2D0*K(1)**3*K(2)*K(6)*PRE*XSW2**(-
     &  2))/XSW
        F(7,-1,1) = F(7,-1,1)-(4D0*K(1)**3*K(6)*QF(3)*PRE)/(XSW*
     &  XSW2)
        F(7,1,-1) = F(7,1,-1)+16D0*K(2)*K(6)*QF(1)**3*PRE*XSW
        F(7,1,1) = F(7,1,1)+32D0*K(6)*QF(1)**3*QF(3)*PRE*XSW*XSW2
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(1)**3*K(2)*K(4)*PRE*XSW2**(-
     &  2))/XSW
        F(8,-1,1) = F(8,-1,1)+(4D0*K(1)**3*K(4)*QF(3)*PRE)/(XSW*
     &  XSW2)
        F(8,1,-1) = F(8,1,-1)-16D0*K(2)*K(4)*QF(1)**3*PRE*XSW
        F(8,1,1) = F(8,1,1)-32D0*K(4)*QF(1)**3*QF(3)*PRE*XSW*XSW2

C       G(T11,N104,FULL)

C       G(T11,N105,FULL)

C       G(T11,N106,FULL)

C       G(T11,N107,FULL)

C       G(T11,N108,FULL)

C       G(T11,N109,FULL)

C       G(T11,N110,FULL)

C       G(T11,N111,FULL)

C       G(T11,N112,FULL)
        CALL xD012345_(S12,RMF2(3),MHH2,RMF2(3),T13,T14,CMF2(3),
     &  CMF2(3),XMZ2,XMZ2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = 1D0+2D0*QF(3)*XSW2
        K(2) = S14+S24
        K(3) = D2(1,2)+D2(2,2)
        K(4) = 2D0*S12+S13+S23
        K(5) = D1(3)+D2(1,3)+D2(2,3)
        K(6) = D1(1)+D1(2)+D2(1,1)+(2D0*D2(0,0))/S12+(D2(1,2)*(2D0*
     &  S12+S13+S23))/S12-(D1(3)*(S14+S24))/S12-(D2(1,3)*(S14+S24))/
     &  S12+(D2(2,2)*T14)/S12-(D2(2,3)*(MHH2-T14))/S12

        PRE = (QF(1)*QF(3)*ALPHA*SA*XCW2**(-2)*XMW)/(8D0*PI)

        F(1,-1,-1) = F(1,-1,-1)+(K(1)**2*K(6)*PRE)/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)+4D0*K(6)*QF(3)**2*PRE*XSW
        F(1,1,-1) = F(1,1,-1)+(K(1)**2*K(6)*PRE)/(XSW*XSW2)
        F(1,1,1) = F(1,1,1)+4D0*K(6)*QF(3)**2*PRE*XSW
        F(5,-1,-1) = F(5,-1,-1)-(2D0*K(1)**2*K(3)*PRE)/(S12*XSW*
     &  XSW2)
        F(5,-1,1) = F(5,-1,1)-(8D0*K(3)*QF(3)**2*PRE*XSW)/S12
        F(5,1,-1) = F(5,1,-1)-(2D0*K(1)**2*K(3)*PRE)/(S12*XSW*XSW2)
        F(5,1,1) = F(5,1,1)-(8D0*K(3)*QF(3)**2*PRE*XSW)/S12
        F(6,-1,-1) = F(6,-1,-1)-(2D0*K(1)**2*K(3)*PRE)/(S12*XSW*
     &  XSW2)
        F(6,-1,1) = F(6,-1,1)-(8D0*K(3)*QF(3)**2*PRE*XSW)/S12
        F(6,1,-1) = F(6,1,-1)-(2D0*K(1)**2*K(3)*PRE)/(S12*XSW*XSW2)
        F(6,1,1) = F(6,1,1)-(8D0*K(3)*QF(3)**2*PRE*XSW)/S12
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(1)**2*K(5)*PRE)/(S12*XSW*
     &  XSW2)
        F(7,-1,1) = F(7,-1,1)+(8D0*K(5)*QF(3)**2*PRE*XSW)/S12
        F(7,1,-1) = F(7,1,-1)+(2D0*K(1)**2*K(5)*PRE)/(S12*XSW*XSW2)
        F(7,1,1) = F(7,1,1)+(8D0*K(5)*QF(3)**2*PRE*XSW)/S12
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(1)**2*K(5)*PRE)/(S12*XSW*
     &  XSW2)
        F(8,-1,1) = F(8,-1,1)+(8D0*K(5)*QF(3)**2*PRE*XSW)/S12
        F(8,1,-1) = F(8,1,-1)+(2D0*K(1)**2*K(5)*PRE)/(S12*XSW*XSW2)
        F(8,1,1) = F(8,1,1)+(8D0*K(5)*QF(3)**2*PRE*XSW)/S12

C       G(T11,N113,FULL)
        CALL xD012345_(S12,RMF2(3),MHH2,RMF2(3),T13,T14,CMF2(4),
     &  CMF2(4),XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = D1(3)+D2(1,3)+D2(2,3)
        K(2) = D1(1)+D1(2)+D2(1,1)+(2D0*D2(0,0))/S12+(D2(1,2)*(2D0*
     &  S12+S13+S23))/S12-(D1(3)*(S14+S24))/S12-(D2(1,3)*(S14+S24))/
     &  S12+(D2(2,2)*T14)/S12-(D2(2,3)*(MHH2-T14))/S12

        PRE = (QF(1)*QF(4)*ALPHA*SA*XMW)/(4D0*PI*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+K(2)*PRE
        F(1,1,-1) = F(1,1,-1)+K(2)*PRE
        F(5,-1,-1) = F(5,-1,-1)-(2D0*(D2(1,2)+D2(2,2))*PRE)/S12
        F(5,1,-1) = F(5,1,-1)-(2D0*(D2(1,2)+D2(2,2))*PRE)/S12
        F(6,-1,-1) = F(6,-1,-1)-(2D0*(D2(1,2)+D2(2,2))*PRE)/S12
        F(6,1,-1) = F(6,1,-1)-(2D0*(D2(1,2)+D2(2,2))*PRE)/S12
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(1)*PRE)/S12
        F(7,1,-1) = F(7,1,-1)+(2D0*K(1)*PRE)/S12
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(1)*PRE)/S12
        F(8,1,-1) = F(8,1,-1)+(2D0*K(1)*PRE)/S12

C       G(T11,N114,FULL)

C       G(T11,N115,FULL)

C       G(T11,N116,FULL)

C       G(T11,N117,FULL)

C       G(T11,N118,FULL)
        CALL xD012345_(S12,RMF2(3),MHH2,RMF2(3),T13,T14,CMF2(3),
     &  CMF2(3),XMZ2,XMZ2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = S14+S24
        K(4) = D2(1,2)+D2(2,2)
        K(5) = 2D0*S12+S13+S23
        K(6) = D1(3)+D2(1,3)+D2(2,3)
        K(7) = 2D0*D2(0,0)+D1(1)*S12+D1(2)*S12+D2(1,1)*S12+D2(1,2)*
     &  (2D0*S12+S13+S23)-D1(3)*(S14+S24)-D2(1,3)*(S14+S24)+D2(2,2)*
     &  T14-D2(2,3)*(MHH2-T14)

        PRE = (ALPHA*PZ12*SA*XCW2**(-3)*XMW)/(32D0*PI)

        F(1,-1,-1) = F(1,-1,-1)-(K(1)*K(2)**3*K(7)*PRE*XSW2**(-2))/
     &  XSW
        F(1,-1,1) = F(1,-1,1)-8D0*K(1)*K(7)*QF(3)**3*PRE*XSW
        F(1,1,-1) = F(1,1,-1)+(2D0*K(2)**3*K(7)*QF(1)*PRE)/(XSW*
     &  XSW2)
        F(1,1,1) = F(1,1,1)+16D0*K(7)*QF(1)*QF(3)**3*PRE*XSW*XSW2
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(1)*K(2)**3*K(4)*PRE*XSW2**(-
     &  2))/XSW
        F(5,-1,1) = F(5,-1,1)+16D0*K(1)*K(4)*QF(3)**3*PRE*XSW
        F(5,1,-1) = F(5,1,-1)-(4D0*K(2)**3*K(4)*QF(1)*PRE)/(XSW*
     &  XSW2)
        F(5,1,1) = F(5,1,1)-32D0*K(4)*QF(1)*QF(3)**3*PRE*XSW*XSW2
        F(6,-1,-1) = F(6,-1,-1)+(2D0*K(1)*K(2)**3*K(4)*PRE*XSW2**(-
     &  2))/XSW
        F(6,-1,1) = F(6,-1,1)+16D0*K(1)*K(4)*QF(3)**3*PRE*XSW
        F(6,1,-1) = F(6,1,-1)-(4D0*K(2)**3*K(4)*QF(1)*PRE)/(XSW*
     &  XSW2)
        F(6,1,1) = F(6,1,1)-32D0*K(4)*QF(1)*QF(3)**3*PRE*XSW*XSW2
        F(7,-1,-1) = F(7,-1,-1)-(2D0*K(1)*K(2)**3*K(6)*PRE*XSW2**(-
     &  2))/XSW
        F(7,-1,1) = F(7,-1,1)-16D0*K(1)*K(6)*QF(3)**3*PRE*XSW
        F(7,1,-1) = F(7,1,-1)+(4D0*K(2)**3*K(6)*QF(1)*PRE)/(XSW*
     &  XSW2)
        F(7,1,1) = F(7,1,1)+32D0*K(6)*QF(1)*QF(3)**3*PRE*XSW*XSW2
        F(8,-1,-1) = F(8,-1,-1)-(2D0*K(1)*K(2)**3*K(6)*PRE*XSW2**(-
     &  2))/XSW
        F(8,-1,1) = F(8,-1,1)-16D0*K(1)*K(6)*QF(3)**3*PRE*XSW
        F(8,1,-1) = F(8,1,-1)+(4D0*K(2)**3*K(6)*QF(1)*PRE)/(XSW*
     &  XSW2)
        F(8,1,1) = F(8,1,1)+32D0*K(6)*QF(1)*QF(3)**3*PRE*XSW*XSW2

C       G(T11,N119,FULL)
        CALL xD012345_(S12,RMF2(3),MHH2,RMF2(3),T13,T14,CMF2(4),
     &  CMF2(4),XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = D1(3)+D2(1,3)+D2(2,3)
        K(2) = 2D0*D2(0,0)+D1(1)*S12+D1(2)*S12+D2(1,1)*S12+D2(1,2)*
     &  (2D0*S12+S13+S23)-D1(3)*(S14+S24)-D2(1,3)*(S14+S24)+D2(2,2)*
     &  T14-D2(2,3)*(MHH2-T14)

        PRE = -((ALPHA*PZ12*SA*XMW*(1D0-2D0*QF(4)*XSW2))/(16D0*PI*
     &  XCW2*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)-(K(2)*PRE*(1D0-2D0*QF(1)*XSW2))/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*K(2)*QF(1)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(2D0*(D2(1,2)+D2(2,2))*PRE*(1D0-2D0*
     &  QF(1)*XSW2))/XSW2
        F(5,1,-1) = F(5,1,-1)-4D0*(D2(1,2)+D2(2,2))*QF(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)+(2D0*(D2(1,2)+D2(2,2))*PRE*(1D0-2D0*
     &  QF(1)*XSW2))/XSW2
        F(6,1,-1) = F(6,1,-1)-4D0*(D2(1,2)+D2(2,2))*QF(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)-(2D0*K(1)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(7,1,-1) = F(7,1,-1)+4D0*K(1)*QF(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)-(2D0*K(1)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(8,1,-1) = F(8,1,-1)+4D0*K(1)*QF(1)*PRE

C       G(T12,N120,FULL)

C       G(T12,N121,FULL)

C       G(T12,N122,FULL)

C       G(T12,N123,FULL)

C       G(T12,N124,FULL)

C       G(T12,N125,FULL)

C       G(T12,N126,FULL)

C       G(T12,N127,FULL)

C       G(T12,N128,FULL)

C       G(T14,N138,FULL)

C       G(T14,N139,FULL)

C       G(T14,N140,FULL)

C       G(T14,N141,FULL)

C       G(T14,N142,FULL)

C       G(T14,N143,FULL)

C       G(T14,N144,FULL)

C       G(T14,N145,FULL)

C       G(T14,N146,FULL)

C       G(T14,N147,FULL)

C       G(T14,N148,FULL)

C       G(T14,N149,FULL)

C       G(T14,N150,FULL)

C       G(T14,N151,FULL)

C       G(T14,N152,FULL)
        CALL xD012345_(RMF2(1),MHH2,S34,RMF2(1),S12,T11,CMF2(2),XMW2,
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = -(4D0*D2(0,0))+D2(1,3)*S12-D2(2,3)*(S23+S24)-2D0*
     &  D1(2)*T11-D2(2,2)*T11+2D0*D1(1)*(MHH2-T11)+D2(1,2)*(MHH2-
     &  T11)

        PRE = (QF(3)*ALPHA*SA*XMW)/(16D0*PI*S34*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+K(1)*PRE
        F(1,-1,1) = F(1,-1,1)+K(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)-4D0*D1(3)*PRE
        F(6,-1,1) = F(6,-1,1)-4D0*D1(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)-4D0*D1(3)*PRE
        F(8,-1,1) = F(8,-1,1)-4D0*D1(3)*PRE

C       G(T14,N153,FULL)
        CALL xD012345_(RMF2(1),MHH2,S34,RMF2(1),S12,T11,CMF2(2),XMW2,
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = D1(3)-2D0*D2(2,2)-2D0*D2(2,3)
        K(2) = -(12D0*D2(0,0))+2D0*D2(1,3)*S12+D1(1)*(S12-S13-S14)-
     &  2D0*D1(3)*(S23+S24)-2D0*D2(2,3)*(S23+S24)-D1(2)*(3D0*S23+
     &  3D0*S24+S34)-2D0*D2(2,2)*T11+2D0*D2(1,2)*(MHH2-T11)

        PRE = -((QF(3)*ALPHA*SA*XMW)/(8D0*PI*S34*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+K(2)*PRE
        F(1,-1,1) = F(1,-1,1)+K(2)*PRE
        F(5,-1,-1) = F(5,-1,-1)+4D0*(D1(1)+D2(1,2))*PRE
        F(5,-1,1) = F(5,-1,1)+4D0*(D1(1)+D2(1,2))*PRE
        F(6,-1,-1) = F(6,-1,-1)+2D0*K(1)*PRE
        F(6,-1,1) = F(6,-1,1)+2D0*K(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)+4D0*(D1(1)+D2(1,2))*PRE
        F(7,-1,1) = F(7,-1,1)+4D0*(D1(1)+D2(1,2))*PRE
        F(8,-1,-1) = F(8,-1,-1)+2D0*K(1)*PRE
        F(8,-1,1) = F(8,-1,1)+2D0*K(1)*PRE

C       G(T14,N154,FULL)

C       G(T14,N155,FULL)

C       G(T14,N156,FULL)

C       G(T14,N157,FULL)

C       G(T14,N158,FULL)

C       G(T14,N159,FULL)

C       G(T14,N160,FULL)
        CALL xD012345_(RMF2(1),MHH2,S34,RMF2(1),S12,T11,CMF2(2),XMW2,
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = -(4D0*D2(0,0))+D2(1,3)*S12-D2(2,3)*(S23+S24)-2D0*
     &  D1(2)*T11-D2(2,2)*T11+2D0*D1(1)*(MHH2-T11)+D2(1,2)*(MHH2-
     &  T11)

        PRE = -((ALPHA*PZ34*SA*XMW)/(32D0*PI*XCW2*XSW))

        F(1,-1,-1) = F(1,-1,-1)-(K(1)*PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)-2D0*K(1)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)+(4D0*D1(3)*PRE*(1D0+2D0*QF(3)*
     &  XSW2))/XSW2
        F(6,-1,1) = F(6,-1,1)+8D0*D1(3)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)+(4D0*D1(3)*PRE*(1D0+2D0*QF(3)*
     &  XSW2))/XSW2
        F(8,-1,1) = F(8,-1,1)+8D0*D1(3)*QF(3)*PRE

C       G(T14,N161,FULL)
        CALL xD012345_(RMF2(1),MHH2,S34,RMF2(1),S12,T11,CMF2(2),XMW2,
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = D1(3)-2D0*D2(2,2)-2D0*D2(2,3)
        K(2) = -(12D0*D2(0,0))+2D0*D2(1,3)*S12+D1(1)*(S12-S13-S14)-
     &  2D0*D1(3)*(S23+S24)-2D0*D2(2,3)*(S23+S24)-D1(2)*(3D0*S23+
     &  3D0*S24+S34)-2D0*D2(2,2)*T11+2D0*D2(1,2)*(MHH2-T11)

        PRE = (ALPHA*PZ34*SA*XMW)/(16D0*PI*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+(K(2)*PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*K(2)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(4D0*(D1(1)+D2(1,2))*PRE*(1D0+2D0*
     &  QF(3)*XSW2))/XSW2
        F(5,-1,1) = F(5,-1,1)+8D0*(D1(1)+D2(1,2))*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)+(2D0*K(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(6,-1,1) = F(6,-1,1)+4D0*K(1)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+(4D0*(D1(1)+D2(1,2))*PRE*(1D0+2D0*
     &  QF(3)*XSW2))/XSW2
        F(7,-1,1) = F(7,-1,1)+8D0*(D1(1)+D2(1,2))*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(8,-1,1) = F(8,-1,1)+4D0*K(1)*QF(3)*PRE

C       G(T14,N162,FULL)

C       G(T14,N163,FULL)

C       G(T15,N164,FULL)

C       G(T15,N165,FULL)

C       G(T15,N166,FULL)

C       G(T15,N167,FULL)

C       G(T15,N168,FULL)

C       G(T15,N169,FULL)

C       G(T15,N170,FULL)

C       G(T15,N171,FULL)

C       G(T15,N172,FULL)

C       G(T16,N173,FULL)

C       G(T16,N174,FULL)

C       G(T16,N175,FULL)

C       G(T16,N176,FULL)

C       G(T16,N177,FULL)

C       G(T16,N178,FULL)

C       G(T16,N179,FULL)

C       G(T16,N180,FULL)

C       G(T16,N181,FULL)
        CALL xD012345_(RMF2(3),MHH2,S12,RMF2(3),S34,T13,CMF2(4),XMW2,
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = -(4D0*D2(0,0))-D2(2,3)*(S14+S24)+D2(1,3)*S34-2D0*
     &  D1(2)*T13-D2(2,2)*T13+2D0*D1(1)*(MHH2-T13)+D2(1,2)*(MHH2-
     &  T13)

        PRE = -((QF(1)*ALPHA*SA*XMW)/(16D0*PI*S12*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+K(1)*PRE
        F(1,1,-1) = F(1,1,-1)+K(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)-4D0*D1(3)*PRE
        F(7,1,-1) = F(7,1,-1)-4D0*D1(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)-4D0*D1(3)*PRE
        F(8,1,-1) = F(8,1,-1)-4D0*D1(3)*PRE

C       G(T16,N182,FULL)
        CALL xD012345_(RMF2(3),MHH2,S12,RMF2(3),S34,T13,CMF2(4),XMW2,
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = D1(3)-2D0*D2(2,2)-2D0*D2(2,3)
        K(2) = 12D0*D2(0,0)+2D0*D1(3)*(S14+S24)+2D0*D2(2,3)*(S14+
     &  S24)+D1(2)*(S12+3D0*S14+3D0*S24)-2D0*D2(1,3)*S34+D1(1)*(S13+
     &  S23-S34)+2D0*D2(2,2)*T13-2D0*D2(1,2)*(MHH2-T13)

        PRE = -((QF(1)*ALPHA*SA*XMW)/(8D0*PI*S12*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+K(2)*PRE
        F(1,1,-1) = F(1,1,-1)+K(2)*PRE
        F(5,-1,-1) = F(5,-1,-1)-4D0*(D1(1)+D2(1,2))*PRE
        F(5,1,-1) = F(5,1,-1)-4D0*(D1(1)+D2(1,2))*PRE
        F(6,-1,-1) = F(6,-1,-1)-4D0*(D1(1)+D2(1,2))*PRE
        F(6,1,-1) = F(6,1,-1)-4D0*(D1(1)+D2(1,2))*PRE
        F(7,-1,-1) = F(7,-1,-1)-2D0*K(1)*PRE
        F(7,1,-1) = F(7,1,-1)-2D0*K(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)-2D0*K(1)*PRE
        F(8,1,-1) = F(8,1,-1)-2D0*K(1)*PRE

C       G(T16,N183,FULL)

C       G(T16,N184,FULL)
        CALL xD012345_(RMF2(3),MHH2,S12,RMF2(3),S34,T13,CMF2(4),XMW2,
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = -(4D0*D2(0,0))-D2(2,3)*(S14+S24)+D2(1,3)*S34-2D0*
     &  D1(2)*T13-D2(2,2)*T13+2D0*D1(1)*(MHH2-T13)+D2(1,2)*(MHH2-
     &  T13)

        PRE = (ALPHA*PZ12*SA*XMW)/(32D0*PI*XCW2*XSW)

        F(1,-1,-1) = F(1,-1,-1)+(K(1)*PRE*(1D0-2D0*QF(1)*XSW2))/XSW2
        F(1,1,-1) = F(1,1,-1)-2D0*K(1)*QF(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)-(4D0*D1(3)*PRE*(1D0-2D0*QF(1)*
     &  XSW2))/XSW2
        F(7,1,-1) = F(7,1,-1)+8D0*D1(3)*QF(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)-(4D0*D1(3)*PRE*(1D0-2D0*QF(1)*
     &  XSW2))/XSW2
        F(8,1,-1) = F(8,1,-1)+8D0*D1(3)*QF(1)*PRE

C       G(T16,N185,FULL)

C       G(T16,N186,FULL)

C       G(T16,N187,FULL)

C       G(T16,N188,FULL)
        CALL xD012345_(RMF2(3),MHH2,S12,RMF2(3),S34,T13,CMF2(4),XMW2,
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = D1(3)-2D0*D2(2,2)-2D0*D2(2,3)
        K(2) = 12D0*D2(0,0)+2D0*D1(3)*(S14+S24)+2D0*D2(2,3)*(S14+
     &  S24)+D1(2)*(S12+3D0*S14+3D0*S24)-2D0*D2(1,3)*S34+D1(1)*(S13+
     &  S23-S34)+2D0*D2(2,2)*T13-2D0*D2(1,2)*(MHH2-T13)

        PRE = (ALPHA*PZ12*SA*XMW)/(16D0*PI*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)-(K(2)*PRE*(1D0-2D0*QF(1)*XSW2))/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*K(2)*QF(1)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(4D0*(D1(1)+D2(1,2))*PRE*(1D0-2D0*
     &  QF(1)*XSW2))/XSW2
        F(5,1,-1) = F(5,1,-1)-8D0*(D1(1)+D2(1,2))*QF(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)+(4D0*(D1(1)+D2(1,2))*PRE*(1D0-2D0*
     &  QF(1)*XSW2))/XSW2
        F(6,1,-1) = F(6,1,-1)-8D0*(D1(1)+D2(1,2))*QF(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(1)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(7,1,-1) = F(7,1,-1)-4D0*K(1)*QF(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(1)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(8,1,-1) = F(8,1,-1)-4D0*K(1)*QF(1)*PRE

C       G(T16,N189,FULL)

C       G(T16,N190,FULL)

C       G(T16,N191,FULL)

C       G(T16,N192,FULL)

C       G(T16,N193,FULL)

C       G(T16,N194,FULL)

C       G(T16,N195,FULL)

C       G(T16,N196,FULL)

C       G(T16,N197,FULL)

C       G(T16,N198,FULL)

C       G(T17,N199,FULL)

C       G(T17,N200,FULL)

C       G(T17,N201,FULL)

C       G(T17,N202,FULL)

C       G(T17,N203,FULL)

C       G(T17,N204,FULL)

C       G(T17,N205,FULL)

C       G(T17,N206,FULL)

C       G(T17,N207,FULL)

C       G(T17,N208,FULL)

C       G(T19,N216,FULL)

C       G(T19,N217,FULL)

C       G(T19,N218,FULL)

C       G(T19,N219,FULL)

C       G(T19,N220,FULL)

C       G(T19,N221,FULL)

C       G(T19,N222,FULL)

C       G(T19,N223,FULL)

C       G(T19,N224,FULL)

C       G(T19,N225,FULL)

C       G(T21,N236,FULL)

C       G(T21,N237,FULL)

C       G(T21,N238,FULL)

C       G(T21,N239,FULL)

C       G(T21,N240,FULL)

C       G(T21,N241,FULL)

C       G(T21,N242,FULL)

C       G(T21,N243,FULL)

C       G(T21,N244,FULL)

C       G(T21,N245,FULL)

C       G(T22,N246,FULL)

C       G(T22,N247,FULL)

C       G(T22,N248,FULL)

C       G(T22,N249,FULL)

C       G(T22,N250,FULL)

C       G(T22,N251,FULL)

C       G(T22,N252,FULL)

C       G(T22,N253,FULL)

C       G(T22,N254,FULL)
        CALL xD012345_(RMF2(3),S12,MHH2,RMF2(3),S34,T14,CMF2(4),XMW2,
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = -(4D0*D2(0,0))-D2(1,2)*(S13+S23)+D2(1,3)*S34-2D0*
     &  D1(2)*T14-D2(2,2)*T14+2D0*D1(3)*(MHH2-T14)+D2(2,3)*(MHH2-
     &  T14)

        PRE = -((QF(1)*ALPHA*SA*XMW)/(16D0*PI*S12*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+K(1)*PRE
        F(1,1,-1) = F(1,1,-1)+K(1)*PRE
        F(5,-1,-1) = F(5,-1,-1)-4D0*D1(1)*PRE
        F(5,1,-1) = F(5,1,-1)-4D0*D1(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)-4D0*D1(1)*PRE
        F(6,1,-1) = F(6,1,-1)-4D0*D1(1)*PRE

C       G(T22,N255,FULL)
        CALL xD012345_(RMF2(3),S12,MHH2,RMF2(3),S34,T14,CMF2(4),XMW2,
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = D1(1)-2D0*D2(1,2)-2D0*D2(2,2)
        K(2) = -(12D0*D2(0,0))-2D0*D1(1)*(S13+S23)-2D0*D2(1,2)*(S13+
     &  S23)-D1(2)*(S12+3D0*S13+3D0*S23)+2D0*D2(1,3)*S34-D1(3)*(S14+
     &  S24-S34)-2D0*D2(2,2)*T14+2D0*D2(2,3)*(MHH2-T14)

        PRE = (QF(1)*ALPHA*SA*XMW)/(8D0*PI*S12*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+K(2)*PRE
        F(1,1,-1) = F(1,1,-1)+K(2)*PRE
        F(5,-1,-1) = F(5,-1,-1)+2D0*K(1)*PRE
        F(5,1,-1) = F(5,1,-1)+2D0*K(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)+2D0*K(1)*PRE
        F(6,1,-1) = F(6,1,-1)+2D0*K(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)+4D0*(D1(3)+D2(2,3))*PRE
        F(7,1,-1) = F(7,1,-1)+4D0*(D1(3)+D2(2,3))*PRE
        F(8,-1,-1) = F(8,-1,-1)+4D0*(D1(3)+D2(2,3))*PRE
        F(8,1,-1) = F(8,1,-1)+4D0*(D1(3)+D2(2,3))*PRE

C       G(T22,N256,FULL)

C       G(T22,N257,FULL)

C       G(T22,N258,FULL)

C       G(T22,N259,FULL)
        CALL xD012345_(RMF2(3),S12,MHH2,RMF2(3),S34,T14,CMF2(4),XMW2,
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = -(4D0*D2(0,0))-D2(1,2)*(S13+S23)+D2(1,3)*S34-2D0*
     &  D1(2)*T14-D2(2,2)*T14+2D0*D1(3)*(MHH2-T14)+D2(2,3)*(MHH2-
     &  T14)

        PRE = (ALPHA*PZ12*SA*XMW)/(32D0*PI*XCW2*XSW)

        F(1,-1,-1) = F(1,-1,-1)+(K(1)*PRE*(1D0-2D0*QF(1)*XSW2))/XSW2
        F(1,1,-1) = F(1,1,-1)-2D0*K(1)*QF(1)*PRE
        F(5,-1,-1) = F(5,-1,-1)-(4D0*D1(1)*PRE*(1D0-2D0*QF(1)*
     &  XSW2))/XSW2
        F(5,1,-1) = F(5,1,-1)+8D0*D1(1)*QF(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)-(4D0*D1(1)*PRE*(1D0-2D0*QF(1)*
     &  XSW2))/XSW2
        F(6,1,-1) = F(6,1,-1)+8D0*D1(1)*QF(1)*PRE

C       G(T22,N260,FULL)

C       G(T22,N261,FULL)

C       G(T22,N262,FULL)
        CALL xD012345_(RMF2(3),S12,MHH2,RMF2(3),S34,T14,CMF2(4),XMW2,
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = D1(1)-2D0*D2(1,2)-2D0*D2(2,2)
        K(2) = -(12D0*D2(0,0))-2D0*D1(1)*(S13+S23)-2D0*D2(1,2)*(S13+
     &  S23)-D1(2)*(S12+3D0*S13+3D0*S23)+2D0*D2(1,3)*S34-D1(3)*(S14+
     &  S24-S34)-2D0*D2(2,2)*T14+2D0*D2(2,3)*(MHH2-T14)

        PRE = -((ALPHA*PZ12*SA*XMW)/(16D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)-(K(2)*PRE*(1D0-2D0*QF(1)*XSW2))/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*K(2)*QF(1)*PRE
        F(5,-1,-1) = F(5,-1,-1)-(2D0*K(1)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(5,1,-1) = F(5,1,-1)+4D0*K(1)*QF(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)-(2D0*K(1)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(6,1,-1) = F(6,1,-1)+4D0*K(1)*QF(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)-(4D0*(D1(3)+D2(2,3))*PRE*(1D0-2D0*
     &  QF(1)*XSW2))/XSW2
        F(7,1,-1) = F(7,1,-1)+8D0*(D1(3)+D2(2,3))*QF(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)-(4D0*(D1(3)+D2(2,3))*PRE*(1D0-2D0*
     &  QF(1)*XSW2))/XSW2
        F(8,1,-1) = F(8,1,-1)+8D0*(D1(3)+D2(2,3))*QF(1)*PRE

C       G(T22,N263,FULL)

C       G(T22,N264,FULL)

C       G(T22,N265,FULL)

C       G(T22,N266,FULL)

C       G(T22,N267,FULL)

C       G(T22,N268,FULL)

C       G(T22,N269,FULL)

C       G(T22,N270,FULL)

C       G(T22,N271,FULL)

C       G(T23,N272,FULL)

C       G(T23,N273,FULL)

C       G(T23,N274,FULL)

C       G(T23,N275,FULL)

C       G(T23,N276,FULL)

C       G(T23,N277,FULL)

C       G(T23,N278,FULL)

C       G(T23,N279,FULL)

C       G(T23,N280,FULL)

	end

**********************************************************************
        subroutine  HHtoZZ1133_pent_sesm(F,pz12,pz34)
**********************************************************************
*       pentagon corrections for HH -> ZZ -> uudd in the SESM
*---------------------------------------------------------------------
*       7.2.17 Stefan Dittmaier
**********************************************************************
	implicit none
	complex*16 pre,F(13,-1:1,-1:1),pz12,pz34
	complex*16 A0,xA0_,B0_,xB0_,DB0_,xDB0_,B1_,xB1_,DB1_,xDB1_
        complex*16 B0,B1(1),B2(0:2,0:2),B3(0:2,0:2,2)
        complex*16 B4(0:2,0:2,0:2,0:2),B5(0:2,0:2,0:2,0:2,2)
        complex*16 C0_,C0,C1(2),C2(0:2,0:2),C3(0:2,0:2,2)
        complex*16 C4(0:2,0:2,0:2,0:2)
	complex*16 D0,D1(3),D2(0:3,0:3),D3(0:3,0:3,3)
        complex*16 D4(0:3,0:3,0:3,0:3),D5(0:3,0:3,0:3,0:3,3)
	complex*16 E0n,E1n(4),E2n(0:4,0:4),E3n(0:4,0:4,4)
	complex*16 E4n(0:4,0:4,0:4,0:4)
        COMPLEX*16 K(10)

c mandelstam variables
      	real*8 s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
      	common/mandel/s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
c fermion charges of isospin duplets
	real*8 qf(4)
	common/fcharge/qf
c fermion masses as flag (i*1d-20)
      	complex*16 cme2,cmf2(5)
      	real*8 me2,rme2,mf2(5),rmf2(5)
      	common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2
	include '../COMMON/param.inc'
	include '../COMMON/xparam.inc'
        include '../COMMON/param_sesm.inc'
        include '../COMMON/param_bsm.inc'

C       Process: S4F21aF21F23aF23,   Model: Singlet

C       G(T5,N47,FULL)

C       G(T5,N48,FULL)

C       G(T5,N49,FULL)

C       G(T5,N50,FULL)

C       G(T5,N51,FULL)
        CALL xE01234_NEW(RMF2(3),RMF2(1),RMF2(1),MHH2,RMF2(3),S13,
     &  S12,T12,T14,S34,CMF2(3),NULL,CMF2(1),XMZ2,XMZ2,E0N,E1N,E2N,
     &  E3N,E4N,D0,D1,D2,D3,2,1)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,3)
        K(4) = E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,3)
        K(5) = E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,4)+2D0*E2N(3,4)
        K(6) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)
        K(7) = E1N(1)+2D0*E1N(2)+2D0*E1N(3)+2D0*E2N(1,2)+2D0*E2N(1,
     &  3)+2D0*E2N(2,2)+4D0*E2N(2,3)+2D0*E2N(3,3)

        PRE = -((QF(1)*QF(3)*ALPHA*SA*XCW2**(-2)*XMW)/(16D0*PI))

        F(1,-1,-1) = F(1,-1,-1)-(2D0*K(1)*K(2)*K(7)*PRE*S13)/(XSW*
     &  XSW2)
        F(1,-1,1) = F(1,-1,1)-(4D0*K(1)*K(7)*QF(3)*PRE*S13)/XSW
        F(1,1,-1) = F(1,1,-1)+(4D0*K(2)*K(7)*QF(1)*PRE*S13)/XSW
        F(1,1,1) = F(1,1,1)+8D0*K(7)*QF(1)*QF(3)*PRE*S13*XSW
        F(2,-1,-1) = F(2,-1,-1)-(2D0*K(1)*K(2)*K(3)*PRE)/(XSW*XSW2)
        F(2,-1,1) = F(2,-1,1)-(4D0*K(1)*K(3)*QF(3)*PRE)/XSW
        F(2,1,-1) = F(2,1,-1)+(4D0*K(2)*K(3)*QF(1)*PRE)/XSW
        F(2,1,1) = F(2,1,1)+8D0*K(3)*QF(1)*QF(3)*PRE*XSW
        F(3,-1,-1) = F(3,-1,-1)+(2D0*K(1)*K(2)*K(5)*PRE)/(XSW*XSW2)
        F(3,-1,1) = F(3,-1,1)+(4D0*K(1)*K(5)*QF(3)*PRE)/XSW
        F(3,1,-1) = F(3,1,-1)-(4D0*K(2)*K(5)*QF(1)*PRE)/XSW
        F(3,1,1) = F(3,1,1)-8D0*K(5)*QF(1)*QF(3)*PRE*XSW
        F(5,-1,-1) = F(5,-1,-1)+(8D0*K(1)*K(2)*K(6)*PRE)/(XSW*XSW2)
        F(5,-1,1) = F(5,-1,1)+(16D0*K(1)*K(6)*QF(3)*PRE)/XSW
        F(5,1,-1) = F(5,1,-1)-(16D0*K(2)*K(6)*QF(1)*PRE)/XSW
        F(5,1,1) = F(5,1,1)-32D0*K(6)*QF(1)*QF(3)*PRE*XSW
        F(6,-1,-1) = F(6,-1,-1)+(4D0*E1N(3)*K(1)*K(2)*PRE)/(XSW*
     &  XSW2)
        F(6,-1,1) = F(6,-1,1)+(8D0*E1N(3)*K(1)*QF(3)*PRE)/XSW
        F(6,1,-1) = F(6,1,-1)-(8D0*E1N(3)*K(2)*QF(1)*PRE)/XSW
        F(6,1,1) = F(6,1,1)-16D0*E1N(3)*QF(1)*QF(3)*PRE*XSW
        F(7,-1,-1) = F(7,-1,-1)+(4D0*E1N(4)*K(1)*K(2)*PRE)/(XSW*
     &  XSW2)
        F(7,-1,1) = F(7,-1,1)+(8D0*E1N(4)*K(1)*QF(3)*PRE)/XSW
        F(7,1,-1) = F(7,1,-1)-(8D0*E1N(4)*K(2)*QF(1)*PRE)/XSW
        F(7,1,1) = F(7,1,1)-16D0*E1N(4)*QF(1)*QF(3)*PRE*XSW
        F(9,-1,-1) = F(9,-1,-1)-(K(1)*K(2)*K(6)*PRE)/(XSW*XSW2)
        F(9,-1,1) = F(9,-1,1)-(2D0*K(1)*K(6)*QF(3)*PRE)/XSW
        F(9,1,-1) = F(9,1,-1)+(2D0*K(2)*K(6)*QF(1)*PRE)/XSW
        F(9,1,1) = F(9,1,1)+4D0*K(6)*QF(1)*QF(3)*PRE*XSW
        F(10,-1,-1) = F(10,-1,-1)-(K(1)*K(2)*K(4)*PRE)/(XSW*XSW2)
        F(10,-1,1) = F(10,-1,1)-(2D0*K(1)*K(4)*QF(3)*PRE)/XSW
        F(10,1,-1) = F(10,1,-1)+(2D0*K(2)*K(4)*QF(1)*PRE)/XSW
        F(10,1,1) = F(10,1,1)+4D0*K(4)*QF(1)*QF(3)*PRE*XSW
        F(11,-1,-1) = F(11,-1,-1)+((E2N(2,4)+E2N(3,4))*K(1)*K(2)*
     &  PRE)/(XSW*XSW2)
        F(11,-1,1) = F(11,-1,1)+(2D0*(E2N(2,4)+E2N(3,4))*K(1)*QF(3)*
     &  PRE)/XSW
        F(11,1,-1) = F(11,1,-1)-(2D0*(E2N(2,4)+E2N(3,4))*K(2)*QF(1)*
     &  PRE)/XSW
        F(11,1,1) = F(11,1,1)-4D0*(E2N(2,4)+E2N(3,4))*QF(1)*QF(3)*
     &  PRE*XSW
        F(12,-1,-1) = F(12,-1,-1)+(E2N(3,4)*K(1)*K(2)*PRE)/(XSW*
     &  XSW2)
        F(12,-1,1) = F(12,-1,1)+(2D0*E2N(3,4)*K(1)*QF(3)*PRE)/XSW
        F(12,1,-1) = F(12,1,-1)-(2D0*E2N(3,4)*K(2)*QF(1)*PRE)/XSW
        F(12,1,1) = F(12,1,1)-4D0*E2N(3,4)*QF(1)*QF(3)*PRE*XSW
        F(13,-1,-1) = F(13,-1,-1)-(E2N(0,0)*K(1)*K(2)*PRE)/(XSW*
     &  XSW2)
        F(13,-1,1) = F(13,-1,1)-(2D0*E2N(0,0)*K(1)*QF(3)*PRE)/XSW
        F(13,1,-1) = F(13,1,-1)+(2D0*E2N(0,0)*K(2)*QF(1)*PRE)/XSW
        F(13,1,1) = F(13,1,1)+4D0*E2N(0,0)*QF(1)*QF(3)*PRE*XSW

C       G(T5,N52,FULL)
        CALL xE01234_NEW(RMF2(3),RMF2(1),RMF2(1),MHH2,RMF2(3),S13,
     &  S12,T12,T14,S34,CMF2(3),XMZ2,CMF2(1),XMZ2,XMZ2,E0N,E1N,E2N,
     &  E3N,E4N,D0,D1,D2,D3,2,1)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,3)
        K(4) = E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,3)
        K(5) = E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,4)+2D0*E2N(3,4)
        K(6) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)
        K(7) = E1N(1)+2D0*E1N(2)+2D0*E1N(3)+2D0*E2N(1,2)+2D0*E2N(1,
     &  3)+2D0*E2N(2,2)+4D0*E2N(2,3)+2D0*E2N(3,3)

        PRE = -((ALPHA*SA*XCW2**(-3)*XMW)/(64D0*PI))

        F(1,-1,-1) = F(1,-1,-1)+(2D0*K(1)**2*K(2)**2*K(7)*PRE*S13*
     &  XSW2**(-2))/XSW
        F(1,-1,1) = F(1,-1,1)+(8D0*K(1)**2*K(7)*QF(3)**2*PRE*S13)/
     &  XSW
        F(1,1,-1) = F(1,1,-1)+(8D0*K(2)**2*K(7)*QF(1)**2*PRE*S13)/
     &  XSW
        F(1,1,1) = F(1,1,1)+32D0*K(7)*QF(1)**2*QF(3)**2*PRE*S13*XSW*
     &  XSW2
        F(2,-1,-1) = F(2,-1,-1)+(2D0*K(1)**2*K(2)**2*K(3)*PRE*XSW2**
     &  (-2))/XSW
        F(2,-1,1) = F(2,-1,1)+(8D0*K(1)**2*K(3)*QF(3)**2*PRE)/XSW
        F(2,1,-1) = F(2,1,-1)+(8D0*K(2)**2*K(3)*QF(1)**2*PRE)/XSW
        F(2,1,1) = F(2,1,1)+32D0*K(3)*QF(1)**2*QF(3)**2*PRE*XSW*XSW2
        F(3,-1,-1) = F(3,-1,-1)-(2D0*K(1)**2*K(2)**2*K(5)*PRE*XSW2**
     &  (-2))/XSW
        F(3,-1,1) = F(3,-1,1)-(8D0*K(1)**2*K(5)*QF(3)**2*PRE)/XSW
        F(3,1,-1) = F(3,1,-1)-(8D0*K(2)**2*K(5)*QF(1)**2*PRE)/XSW
        F(3,1,1) = F(3,1,1)-32D0*K(5)*QF(1)**2*QF(3)**2*PRE*XSW*XSW2
        F(5,-1,-1) = F(5,-1,-1)-(8D0*K(1)**2*K(2)**2*K(6)*PRE*XSW2**
     &  (-2))/XSW
        F(5,-1,1) = F(5,-1,1)-(32D0*K(1)**2*K(6)*QF(3)**2*PRE)/XSW
        F(5,1,-1) = F(5,1,-1)-(32D0*K(2)**2*K(6)*QF(1)**2*PRE)/XSW
        F(5,1,1) = F(5,1,1)-128D0*K(6)*QF(1)**2*QF(3)**2*PRE*XSW*
     &  XSW2
        F(6,-1,-1) = F(6,-1,-1)-(4D0*E1N(3)*K(1)**2*K(2)**2*PRE*
     &  XSW2**(-2))/XSW
        F(6,-1,1) = F(6,-1,1)-(16D0*E1N(3)*K(1)**2*QF(3)**2*PRE)/XSW
        F(6,1,-1) = F(6,1,-1)-(16D0*E1N(3)*K(2)**2*QF(1)**2*PRE)/XSW
        F(6,1,1) = F(6,1,1)-64D0*E1N(3)*QF(1)**2*QF(3)**2*PRE*XSW*
     &  XSW2
        F(7,-1,-1) = F(7,-1,-1)-(4D0*E1N(4)*K(1)**2*K(2)**2*PRE*
     &  XSW2**(-2))/XSW
        F(7,-1,1) = F(7,-1,1)-(16D0*E1N(4)*K(1)**2*QF(3)**2*PRE)/XSW
        F(7,1,-1) = F(7,1,-1)-(16D0*E1N(4)*K(2)**2*QF(1)**2*PRE)/XSW
        F(7,1,1) = F(7,1,1)-64D0*E1N(4)*QF(1)**2*QF(3)**2*PRE*XSW*
     &  XSW2
        F(9,-1,-1) = F(9,-1,-1)+(K(1)**2*K(2)**2*K(6)*PRE*XSW2**(-
     &  2))/XSW
        F(9,-1,1) = F(9,-1,1)+(4D0*K(1)**2*K(6)*QF(3)**2*PRE)/XSW
        F(9,1,-1) = F(9,1,-1)+(4D0*K(2)**2*K(6)*QF(1)**2*PRE)/XSW
        F(9,1,1) = F(9,1,1)+16D0*K(6)*QF(1)**2*QF(3)**2*PRE*XSW*XSW2
        F(10,-1,-1) = F(10,-1,-1)+(K(1)**2*K(2)**2*K(4)*PRE*XSW2**(-
     &  2))/XSW
        F(10,-1,1) = F(10,-1,1)+(4D0*K(1)**2*K(4)*QF(3)**2*PRE)/XSW
        F(10,1,-1) = F(10,1,-1)+(4D0*K(2)**2*K(4)*QF(1)**2*PRE)/XSW
        F(10,1,1) = F(10,1,1)+16D0*K(4)*QF(1)**2*QF(3)**2*PRE*XSW*
     &  XSW2
        F(11,-1,-1) = F(11,-1,-1)-((E2N(2,4)+E2N(3,4))*K(1)**2*
     &  K(2)**2*PRE*XSW2**(-2))/XSW
        F(11,-1,1) = F(11,-1,1)-(4D0*(E2N(2,4)+E2N(3,4))*K(1)**2*
     &  QF(3)**2*PRE)/XSW
        F(11,1,-1) = F(11,1,-1)-(4D0*(E2N(2,4)+E2N(3,4))*K(2)**2*
     &  QF(1)**2*PRE)/XSW
        F(11,1,1) = F(11,1,1)-16D0*(E2N(2,4)+E2N(3,4))*QF(1)**2*
     &  QF(3)**2*PRE*XSW*XSW2
        F(12,-1,-1) = F(12,-1,-1)-(E2N(3,4)*K(1)**2*K(2)**2*PRE*
     &  XSW2**(-2))/XSW
        F(12,-1,1) = F(12,-1,1)-(4D0*E2N(3,4)*K(1)**2*QF(3)**2*PRE)/
     &  XSW
        F(12,1,-1) = F(12,1,-1)-(4D0*E2N(3,4)*K(2)**2*QF(1)**2*PRE)/
     &  XSW
        F(12,1,1) = F(12,1,1)-16D0*E2N(3,4)*QF(1)**2*QF(3)**2*PRE*
     &  XSW*XSW2
        F(13,-1,-1) = F(13,-1,-1)+(E2N(0,0)*K(1)**2*K(2)**2*PRE*
     &  XSW2**(-2))/XSW
        F(13,-1,1) = F(13,-1,1)+(4D0*E2N(0,0)*K(1)**2*QF(3)**2*PRE)/
     &  XSW
        F(13,1,-1) = F(13,1,-1)+(4D0*E2N(0,0)*K(2)**2*QF(1)**2*PRE)/
     &  XSW
        F(13,1,1) = F(13,1,1)+16D0*E2N(0,0)*QF(1)**2*QF(3)**2*PRE*
     &  XSW*XSW2

C       G(T5,N53,FULL)
        CALL xE01234_NEW(RMF2(3),RMF2(1),RMF2(1),MHH2,RMF2(3),S13,
     &  S12,T12,T14,S34,CMF2(4),XMW2,CMF2(2),XMW2,XMW2,E0N,E1N,E2N,
     &  E3N,E4N,D0,D1,D2,D3,2,1)
        K(1) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)

        PRE = -((ALPHA*SA*XMW*XSW2**(-2))/(16D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+2D0*(E1N(1)+2D0*E1N(2)+2D0*E1N(3)+
     &  2D0*E2N(1,2)+2D0*E2N(1,3)+2D0*E2N(2,2)+4D0*E2N(2,3)+2D0*
     &  E2N(3,3))*PRE*S13
        F(2,-1,-1) = F(2,-1,-1)+2D0*(E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,
     &  3))*PRE
        F(3,-1,-1) = F(3,-1,-1)-2D0*(E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,
     &  4)+2D0*E2N(3,4))*PRE
        F(5,-1,-1) = F(5,-1,-1)-8D0*K(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)-4D0*E1N(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)-4D0*E1N(4)*PRE
        F(9,-1,-1) = F(9,-1,-1)+K(1)*PRE
        F(10,-1,-1) = F(10,-1,-1)+(E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,
     &  3))*PRE
        F(11,-1,-1) = F(11,-1,-1)+(-(E2N(2,4))-E2N(3,4))*PRE
        F(12,-1,-1) = F(12,-1,-1)-E2N(3,4)*PRE
        F(13,-1,-1) = F(13,-1,-1)+E2N(0,0)*PRE

C       G(T7,N63,FULL)

C       G(T7,N64,FULL)

C       G(T7,N65,FULL)

C       G(T7,N66,FULL)

C       G(T7,N67,FULL)
        CALL xE01234_NEW(RMF2(1),RMF2(3),RMF2(3),MHH2,RMF2(1),S14,
     &  S34,T13,T12,S12,CMF2(1),NULL,CMF2(3),XMZ2,XMZ2,E0N,E1N,E2N,
     &  E3N,E4N,D0,D1,D2,D3,2,1)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = 2D0*S14+S34
        K(4) = E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,3)
        K(5) = E1N(4)+E2N(2,4)+E2N(3,4)
        K(6) = E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,3)
        K(7) = 2D0*E1N(3)+3D0*E2N(1,3)+3D0*E2N(2,3)+3D0*E2N(3,3)
        K(8) = E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,4)+2D0*E2N(3,4)
        K(9) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)
        K(10) = 10D0*E2N(0,0)-E1N(4)*S12-2D0*E2N(1,4)*S12+E1N(1)*
     &  S14+2D0*E1N(2)*S14+2D0*E2N(1,2)*S14+2D0*E2N(1,3)*S14+2D0*
     &  E2N(2,2)*S14-2D0*E2N(2,4)*(S12+S24)+2D0*E2N(3,3)*(S14+S34)+
     &  E1N(3)*(2D0*S14+S34)+2D0*E2N(2,3)*(2D0*S14+S34)-2D0*E2N(3,
     &  4)*(MHH2-T12)

        PRE = -((QF(1)*QF(3)*ALPHA*SA*XCW2**(-2)*XMW)/(16D0*PI))

        F(1,-1,-1) = F(1,-1,-1)+(2D0*K(1)*K(10)*K(2)*PRE)/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)+(4D0*K(1)*K(10)*QF(3)*PRE)/XSW
        F(1,1,-1) = F(1,1,-1)-(4D0*K(10)*K(2)*QF(1)*PRE)/XSW
        F(1,1,1) = F(1,1,1)-8D0*K(10)*QF(1)*QF(3)*PRE*XSW
        F(2,-1,-1) = F(2,-1,-1)+(2D0*K(1)*K(2)*K(8)*PRE)/(XSW*XSW2)
        F(2,-1,1) = F(2,-1,1)+(4D0*K(1)*K(8)*QF(3)*PRE)/XSW
        F(2,1,-1) = F(2,1,-1)-(4D0*K(2)*K(8)*QF(1)*PRE)/XSW
        F(2,1,1) = F(2,1,1)-8D0*K(8)*QF(1)*QF(3)*PRE*XSW
        F(3,-1,-1) = F(3,-1,-1)-(2D0*K(1)*K(2)*K(4)*PRE)/(XSW*XSW2)
        F(3,-1,1) = F(3,-1,1)-(4D0*K(1)*K(4)*QF(3)*PRE)/XSW
        F(3,1,-1) = F(3,1,-1)+(4D0*K(2)*K(4)*QF(1)*PRE)/XSW
        F(3,1,1) = F(3,1,1)+8D0*K(4)*QF(1)*QF(3)*PRE*XSW
        F(5,-1,-1) = F(5,-1,-1)+(4D0*K(1)*K(2)*K(7)*PRE)/(XSW*XSW2)
        F(5,-1,1) = F(5,-1,1)+(8D0*K(1)*K(7)*QF(3)*PRE)/XSW
        F(5,1,-1) = F(5,1,-1)-(8D0*K(2)*K(7)*QF(1)*PRE)/XSW
        F(5,1,1) = F(5,1,1)-16D0*K(7)*QF(1)*QF(3)*PRE*XSW
        F(6,-1,-1) = F(6,-1,-1)-(4D0*E2N(3,4)*K(1)*K(2)*PRE)/(XSW*
     &  XSW2)
        F(6,-1,1) = F(6,-1,1)-(8D0*E2N(3,4)*K(1)*QF(3)*PRE)/XSW
        F(6,1,-1) = F(6,1,-1)+(8D0*E2N(3,4)*K(2)*QF(1)*PRE)/XSW
        F(6,1,1) = F(6,1,1)+16D0*E2N(3,4)*QF(1)*QF(3)*PRE*XSW
        F(7,-1,-1) = F(7,-1,-1)+(4D0*K(1)*K(2)*K(9)*PRE)/(XSW*XSW2)
        F(7,-1,1) = F(7,-1,1)+(8D0*K(1)*K(9)*QF(3)*PRE)/XSW
        F(7,1,-1) = F(7,1,-1)-(8D0*K(2)*K(9)*QF(1)*PRE)/XSW
        F(7,1,1) = F(7,1,1)-16D0*K(9)*QF(1)*QF(3)*PRE*XSW
        F(8,-1,-1) = F(8,-1,-1)-(4D0*K(1)*K(2)*K(5)*PRE)/(XSW*XSW2)
        F(8,-1,1) = F(8,-1,1)-(8D0*K(1)*K(5)*QF(3)*PRE)/XSW
        F(8,1,-1) = F(8,1,-1)+(8D0*K(2)*K(5)*QF(1)*PRE)/XSW
        F(8,1,1) = F(8,1,1)+16D0*K(5)*QF(1)*QF(3)*PRE*XSW
        F(9,-1,-1) = F(9,-1,-1)-(K(1)*K(2)*K(6)*PRE)/(XSW*XSW2)
        F(9,-1,1) = F(9,-1,1)-(2D0*K(1)*K(6)*QF(3)*PRE)/XSW
        F(9,1,-1) = F(9,1,-1)+(2D0*K(2)*K(6)*QF(1)*PRE)/XSW
        F(9,1,1) = F(9,1,1)+4D0*K(6)*QF(1)*QF(3)*PRE*XSW
        F(10,-1,-1) = F(10,-1,-1)+(E2N(3,4)*K(1)*K(2)*PRE)/(XSW*
     &  XSW2)
        F(10,-1,1) = F(10,-1,1)+(2D0*E2N(3,4)*K(1)*QF(3)*PRE)/XSW
        F(10,1,-1) = F(10,1,-1)-(2D0*E2N(3,4)*K(2)*QF(1)*PRE)/XSW
        F(10,1,1) = F(10,1,1)-4D0*E2N(3,4)*QF(1)*QF(3)*PRE*XSW
        F(11,-1,-1) = F(11,-1,-1)-(K(1)*K(2)*K(9)*PRE)/(XSW*XSW2)
        F(11,-1,1) = F(11,-1,1)-(2D0*K(1)*K(9)*QF(3)*PRE)/XSW
        F(11,1,-1) = F(11,1,-1)+(2D0*K(2)*K(9)*QF(1)*PRE)/XSW
        F(11,1,1) = F(11,1,1)+4D0*K(9)*QF(1)*QF(3)*PRE*XSW
        F(12,-1,-1) = F(12,-1,-1)+((E2N(2,4)+E2N(3,4))*K(1)*K(2)*
     &  PRE)/(XSW*XSW2)
        F(12,-1,1) = F(12,-1,1)+(2D0*(E2N(2,4)+E2N(3,4))*K(1)*QF(3)*
     &  PRE)/XSW
        F(12,1,-1) = F(12,1,-1)-(2D0*(E2N(2,4)+E2N(3,4))*K(2)*QF(1)*
     &  PRE)/XSW
        F(12,1,1) = F(12,1,1)-4D0*(E2N(2,4)+E2N(3,4))*QF(1)*QF(3)*
     &  PRE*XSW
        F(13,-1,-1) = F(13,-1,-1)-(E2N(0,0)*K(1)*K(2)*PRE)/(XSW*
     &  XSW2)
        F(13,-1,1) = F(13,-1,1)-(2D0*E2N(0,0)*K(1)*QF(3)*PRE)/XSW
        F(13,1,-1) = F(13,1,-1)+(2D0*E2N(0,0)*K(2)*QF(1)*PRE)/XSW
        F(13,1,1) = F(13,1,1)+4D0*E2N(0,0)*QF(1)*QF(3)*PRE*XSW

C       G(T7,N68,FULL)
        CALL xE01234_NEW(RMF2(1),RMF2(3),RMF2(3),MHH2,RMF2(1),S14,
     &  S34,T13,T12,S12,CMF2(1),XMZ2,CMF2(3),XMZ2,XMZ2,E0N,E1N,E2N,
     &  E3N,E4N,D0,D1,D2,D3,2,1)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = 2D0*S14+S34
        K(4) = E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,3)
        K(5) = E1N(4)+E2N(2,4)+E2N(3,4)
        K(6) = E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,3)
        K(7) = 2D0*E1N(3)+3D0*E2N(1,3)+3D0*E2N(2,3)+3D0*E2N(3,3)
        K(8) = E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,4)+2D0*E2N(3,4)
        K(9) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)
        K(10) = 10D0*E2N(0,0)-E1N(4)*S12-2D0*E2N(1,4)*S12+E1N(1)*
     &  S14+2D0*E1N(2)*S14+2D0*E2N(1,2)*S14+2D0*E2N(1,3)*S14+2D0*
     &  E2N(2,2)*S14-2D0*E2N(2,4)*(S12+S24)+2D0*E2N(3,3)*(S14+S34)+
     &  E1N(3)*(2D0*S14+S34)+2D0*E2N(2,3)*(2D0*S14+S34)-2D0*E2N(3,
     &  4)*(MHH2-T12)

        PRE = -((ALPHA*SA*XCW2**(-3)*XMW)/(64D0*PI))

        F(1,-1,-1) = F(1,-1,-1)-(2D0*K(1)**2*K(10)*K(2)**2*PRE*
     &  XSW2**(-2))/XSW
        F(1,-1,1) = F(1,-1,1)-(8D0*K(1)**2*K(10)*QF(3)**2*PRE)/XSW
        F(1,1,-1) = F(1,1,-1)-(8D0*K(10)*K(2)**2*QF(1)**2*PRE)/XSW
        F(1,1,1) = F(1,1,1)-32D0*K(10)*QF(1)**2*QF(3)**2*PRE*XSW*
     &  XSW2
        F(2,-1,-1) = F(2,-1,-1)-(2D0*K(1)**2*K(2)**2*K(8)*PRE*XSW2**
     &  (-2))/XSW
        F(2,-1,1) = F(2,-1,1)-(8D0*K(1)**2*K(8)*QF(3)**2*PRE)/XSW
        F(2,1,-1) = F(2,1,-1)-(8D0*K(2)**2*K(8)*QF(1)**2*PRE)/XSW
        F(2,1,1) = F(2,1,1)-32D0*K(8)*QF(1)**2*QF(3)**2*PRE*XSW*XSW2
        F(3,-1,-1) = F(3,-1,-1)+(2D0*K(1)**2*K(2)**2*K(4)*PRE*XSW2**
     &  (-2))/XSW
        F(3,-1,1) = F(3,-1,1)+(8D0*K(1)**2*K(4)*QF(3)**2*PRE)/XSW
        F(3,1,-1) = F(3,1,-1)+(8D0*K(2)**2*K(4)*QF(1)**2*PRE)/XSW
        F(3,1,1) = F(3,1,1)+32D0*K(4)*QF(1)**2*QF(3)**2*PRE*XSW*XSW2
        F(5,-1,-1) = F(5,-1,-1)-(4D0*K(1)**2*K(2)**2*K(7)*PRE*XSW2**
     &  (-2))/XSW
        F(5,-1,1) = F(5,-1,1)-(16D0*K(1)**2*K(7)*QF(3)**2*PRE)/XSW
        F(5,1,-1) = F(5,1,-1)-(16D0*K(2)**2*K(7)*QF(1)**2*PRE)/XSW
        F(5,1,1) = F(5,1,1)-64D0*K(7)*QF(1)**2*QF(3)**2*PRE*XSW*XSW2
        F(6,-1,-1) = F(6,-1,-1)+(4D0*E2N(3,4)*K(1)**2*K(2)**2*PRE*
     &  XSW2**(-2))/XSW
        F(6,-1,1) = F(6,-1,1)+(16D0*E2N(3,4)*K(1)**2*QF(3)**2*PRE)/
     &  XSW
        F(6,1,-1) = F(6,1,-1)+(16D0*E2N(3,4)*K(2)**2*QF(1)**2*PRE)/
     &  XSW
        F(6,1,1) = F(6,1,1)+64D0*E2N(3,4)*QF(1)**2*QF(3)**2*PRE*XSW*
     &  XSW2
        F(7,-1,-1) = F(7,-1,-1)-(4D0*K(1)**2*K(2)**2*K(9)*PRE*XSW2**
     &  (-2))/XSW
        F(7,-1,1) = F(7,-1,1)-(16D0*K(1)**2*K(9)*QF(3)**2*PRE)/XSW
        F(7,1,-1) = F(7,1,-1)-(16D0*K(2)**2*K(9)*QF(1)**2*PRE)/XSW
        F(7,1,1) = F(7,1,1)-64D0*K(9)*QF(1)**2*QF(3)**2*PRE*XSW*XSW2
        F(8,-1,-1) = F(8,-1,-1)+(4D0*K(1)**2*K(2)**2*K(5)*PRE*XSW2**
     &  (-2))/XSW
        F(8,-1,1) = F(8,-1,1)+(16D0*K(1)**2*K(5)*QF(3)**2*PRE)/XSW
        F(8,1,-1) = F(8,1,-1)+(16D0*K(2)**2*K(5)*QF(1)**2*PRE)/XSW
        F(8,1,1) = F(8,1,1)+64D0*K(5)*QF(1)**2*QF(3)**2*PRE*XSW*XSW2
        F(9,-1,-1) = F(9,-1,-1)+(K(1)**2*K(2)**2*K(6)*PRE*XSW2**(-
     &  2))/XSW
        F(9,-1,1) = F(9,-1,1)+(4D0*K(1)**2*K(6)*QF(3)**2*PRE)/XSW
        F(9,1,-1) = F(9,1,-1)+(4D0*K(2)**2*K(6)*QF(1)**2*PRE)/XSW
        F(9,1,1) = F(9,1,1)+16D0*K(6)*QF(1)**2*QF(3)**2*PRE*XSW*XSW2
        F(10,-1,-1) = F(10,-1,-1)-(E2N(3,4)*K(1)**2*K(2)**2*PRE*
     &  XSW2**(-2))/XSW
        F(10,-1,1) = F(10,-1,1)-(4D0*E2N(3,4)*K(1)**2*QF(3)**2*PRE)/
     &  XSW
        F(10,1,-1) = F(10,1,-1)-(4D0*E2N(3,4)*K(2)**2*QF(1)**2*PRE)/
     &  XSW
        F(10,1,1) = F(10,1,1)-16D0*E2N(3,4)*QF(1)**2*QF(3)**2*PRE*
     &  XSW*XSW2
        F(11,-1,-1) = F(11,-1,-1)+(K(1)**2*K(2)**2*K(9)*PRE*XSW2**(-
     &  2))/XSW
        F(11,-1,1) = F(11,-1,1)+(4D0*K(1)**2*K(9)*QF(3)**2*PRE)/XSW
        F(11,1,-1) = F(11,1,-1)+(4D0*K(2)**2*K(9)*QF(1)**2*PRE)/XSW
        F(11,1,1) = F(11,1,1)+16D0*K(9)*QF(1)**2*QF(3)**2*PRE*XSW*
     &  XSW2
        F(12,-1,-1) = F(12,-1,-1)-((E2N(2,4)+E2N(3,4))*K(1)**2*
     &  K(2)**2*PRE*XSW2**(-2))/XSW
        F(12,-1,1) = F(12,-1,1)-(4D0*(E2N(2,4)+E2N(3,4))*K(1)**2*
     &  QF(3)**2*PRE)/XSW
        F(12,1,-1) = F(12,1,-1)-(4D0*(E2N(2,4)+E2N(3,4))*K(2)**2*
     &  QF(1)**2*PRE)/XSW
        F(12,1,1) = F(12,1,1)-16D0*(E2N(2,4)+E2N(3,4))*QF(1)**2*
     &  QF(3)**2*PRE*XSW*XSW2
        F(13,-1,-1) = F(13,-1,-1)+(E2N(0,0)*K(1)**2*K(2)**2*PRE*
     &  XSW2**(-2))/XSW
        F(13,-1,1) = F(13,-1,1)+(4D0*E2N(0,0)*K(1)**2*QF(3)**2*PRE)/
     &  XSW
        F(13,1,-1) = F(13,1,-1)+(4D0*E2N(0,0)*K(2)**2*QF(1)**2*PRE)/
     &  XSW
        F(13,1,1) = F(13,1,1)+16D0*E2N(0,0)*QF(1)**2*QF(3)**2*PRE*
     &  XSW*XSW2

C       G(T9,N85,FULL)

C       G(T9,N86,FULL)

C       G(T9,N87,FULL)

C       G(T9,N88,FULL)

C       G(T9,N89,FULL)

C       G(T9,N90,FULL)

C       G(T9,N91,FULL)

C       G(T9,N92,FULL)

C       G(T9,N93,FULL)

C       G(T10,N94,FULL)

C       G(T10,N95,FULL)

C       G(T10,N96,FULL)

C       G(T10,N97,FULL)

C       G(T10,N98,FULL)

C       G(T10,N99,FULL)

C       G(T10,N100,FULL)

C       G(T10,N101,FULL)

C       G(T10,N102,FULL)

C       G(T10,N103,FULL)

C       G(T13,N129,FULL)

C       G(T13,N130,FULL)

C       G(T13,N131,FULL)

C       G(T13,N132,FULL)

C       G(T13,N133,FULL)

C       G(T13,N134,FULL)

C       G(T13,N135,FULL)

C       G(T13,N136,FULL)

C       G(T13,N137,FULL)

C       G(T18,N209,FULL)

C       G(T18,N210,FULL)

C       G(T18,N211,FULL)

C       G(T18,N212,FULL)
        CALL xE01234_NEW(RMF2(1),RMF2(3),RMF2(3),MHH2,RMF2(1),S24,
     &  S34,T13,T11,S12,CMF2(2),XMW2,CMF2(4),XMW2,XMW2,E0N,E1N,E2N,
     &  E3N,E4N,D0,D1,D2,D3,2,1)

        PRE = (ALPHA*SA*XMW*XSW2**(-2))/(16D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)-2D0*PRE*(-(2D0*E2N(3,4)*S13)+E1N(1)*
     &  S24)
        F(2,-1,-1) = F(2,-1,-1)+2D0*(E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,
     &  4)+2D0*E2N(3,4))*PRE
        F(3,-1,-1) = F(3,-1,-1)-2D0*(E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,
     &  3))*PRE
        F(5,-1,-1) = F(5,-1,-1)-8D0*E2N(3,4)*PRE
        F(6,-1,-1) = F(6,-1,-1)+4D0*E1N(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+4D0*E1N(4)*PRE
        F(9,-1,-1) = F(9,-1,-1)+E2N(3,4)*PRE
        F(10,-1,-1) = F(10,-1,-1)+(-(E1N(3))-E2N(1,3)-E2N(2,3)-
     &  E2N(3,3))*PRE
        F(11,-1,-1) = F(11,-1,-1)+(E2N(2,4)+E2N(3,4))*PRE
        F(12,-1,-1) = F(12,-1,-1)+(-(E1N(2))-E1N(3)-E2N(1,2)-E2N(1,
     &  3)-E2N(2,2)-2D0*E2N(2,3)-E2N(3,3))*PRE
        F(13,-1,-1) = F(13,-1,-1)-E2N(0,0)*PRE

C       G(T18,N213,FULL)

C       G(T18,N214,FULL)
        CALL xE01234_NEW(RMF2(1),RMF2(3),RMF2(3),MHH2,RMF2(1),S24,
     &  S34,T13,T11,S12,CMF2(1),NULL,CMF2(3),XMZ2,XMZ2,E0N,E1N,E2N,
     &  E3N,E4N,D0,D1,D2,D3,2,1)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,3)
        K(4) = E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,3)
        K(5) = E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,4)+2D0*E2N(3,4)
        K(6) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)

        PRE = (QF(1)*QF(3)*ALPHA*SA*XCW2**(-2)*XMW)/(16D0*PI)

        F(1,-1,-1) = F(1,-1,-1)+(2D0*K(1)*K(2)*PRE*(-(2D0*E2N(3,4)*
     &  S13)+E1N(1)*S24))/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)+(4D0*K(1)*QF(3)*PRE*(-(2D0*E2N(3,4)*
     &  S13)+E1N(1)*S24))/XSW
        F(1,1,-1) = F(1,1,-1)-(4D0*K(2)*QF(1)*PRE*(-(2D0*E2N(3,4)*
     &  S13)+E1N(1)*S24))/XSW
        F(1,1,1) = F(1,1,1)-8D0*QF(1)*QF(3)*PRE*(-(2D0*E2N(3,4)*
     &  S13)+E1N(1)*S24)*XSW
        F(2,-1,-1) = F(2,-1,-1)-(2D0*K(1)*K(2)*K(5)*PRE)/(XSW*XSW2)
        F(2,-1,1) = F(2,-1,1)-(4D0*K(1)*K(5)*QF(3)*PRE)/XSW
        F(2,1,-1) = F(2,1,-1)+(4D0*K(2)*K(5)*QF(1)*PRE)/XSW
        F(2,1,1) = F(2,1,1)+8D0*K(5)*QF(1)*QF(3)*PRE*XSW
        F(3,-1,-1) = F(3,-1,-1)+(2D0*K(1)*K(2)*K(3)*PRE)/(XSW*XSW2)
        F(3,-1,1) = F(3,-1,1)+(4D0*K(1)*K(3)*QF(3)*PRE)/XSW
        F(3,1,-1) = F(3,1,-1)-(4D0*K(2)*K(3)*QF(1)*PRE)/XSW
        F(3,1,1) = F(3,1,1)-8D0*K(3)*QF(1)*QF(3)*PRE*XSW
        F(5,-1,-1) = F(5,-1,-1)+(8D0*E2N(3,4)*K(1)*K(2)*PRE)/(XSW*
     &  XSW2)
        F(5,-1,1) = F(5,-1,1)+(16D0*E2N(3,4)*K(1)*QF(3)*PRE)/XSW
        F(5,1,-1) = F(5,1,-1)-(16D0*E2N(3,4)*K(2)*QF(1)*PRE)/XSW
        F(5,1,1) = F(5,1,1)-32D0*E2N(3,4)*QF(1)*QF(3)*PRE*XSW
        F(6,-1,-1) = F(6,-1,-1)-(4D0*E1N(3)*K(1)*K(2)*PRE)/(XSW*
     &  XSW2)
        F(6,-1,1) = F(6,-1,1)-(8D0*E1N(3)*K(1)*QF(3)*PRE)/XSW
        F(6,1,-1) = F(6,1,-1)+(8D0*E1N(3)*K(2)*QF(1)*PRE)/XSW
        F(6,1,1) = F(6,1,1)+16D0*E1N(3)*QF(1)*QF(3)*PRE*XSW
        F(7,-1,-1) = F(7,-1,-1)-(4D0*E1N(4)*K(1)*K(2)*PRE)/(XSW*
     &  XSW2)
        F(7,-1,1) = F(7,-1,1)-(8D0*E1N(4)*K(1)*QF(3)*PRE)/XSW
        F(7,1,-1) = F(7,1,-1)+(8D0*E1N(4)*K(2)*QF(1)*PRE)/XSW
        F(7,1,1) = F(7,1,1)+16D0*E1N(4)*QF(1)*QF(3)*PRE*XSW
        F(9,-1,-1) = F(9,-1,-1)-(E2N(3,4)*K(1)*K(2)*PRE)/(XSW*XSW2)
        F(9,-1,1) = F(9,-1,1)-(2D0*E2N(3,4)*K(1)*QF(3)*PRE)/XSW
        F(9,1,-1) = F(9,1,-1)+(2D0*E2N(3,4)*K(2)*QF(1)*PRE)/XSW
        F(9,1,1) = F(9,1,1)+4D0*E2N(3,4)*QF(1)*QF(3)*PRE*XSW
        F(10,-1,-1) = F(10,-1,-1)+(K(1)*K(2)*K(4)*PRE)/(XSW*XSW2)
        F(10,-1,1) = F(10,-1,1)+(2D0*K(1)*K(4)*QF(3)*PRE)/XSW
        F(10,1,-1) = F(10,1,-1)-(2D0*K(2)*K(4)*QF(1)*PRE)/XSW
        F(10,1,1) = F(10,1,1)-4D0*K(4)*QF(1)*QF(3)*PRE*XSW
        F(11,-1,-1) = F(11,-1,-1)-((E2N(2,4)+E2N(3,4))*K(1)*K(2)*
     &  PRE)/(XSW*XSW2)
        F(11,-1,1) = F(11,-1,1)-(2D0*(E2N(2,4)+E2N(3,4))*K(1)*QF(3)*
     &  PRE)/XSW
        F(11,1,-1) = F(11,1,-1)+(2D0*(E2N(2,4)+E2N(3,4))*K(2)*QF(1)*
     &  PRE)/XSW
        F(11,1,1) = F(11,1,1)+4D0*(E2N(2,4)+E2N(3,4))*QF(1)*QF(3)*
     &  PRE*XSW
        F(12,-1,-1) = F(12,-1,-1)+(K(1)*K(2)*K(6)*PRE)/(XSW*XSW2)
        F(12,-1,1) = F(12,-1,1)+(2D0*K(1)*K(6)*QF(3)*PRE)/XSW
        F(12,1,-1) = F(12,1,-1)-(2D0*K(2)*K(6)*QF(1)*PRE)/XSW
        F(12,1,1) = F(12,1,1)-4D0*K(6)*QF(1)*QF(3)*PRE*XSW
        F(13,-1,-1) = F(13,-1,-1)+(E2N(0,0)*K(1)*K(2)*PRE)/(XSW*
     &  XSW2)
        F(13,-1,1) = F(13,-1,1)+(2D0*E2N(0,0)*K(1)*QF(3)*PRE)/XSW
        F(13,1,-1) = F(13,1,-1)-(2D0*E2N(0,0)*K(2)*QF(1)*PRE)/XSW
        F(13,1,1) = F(13,1,1)-4D0*E2N(0,0)*QF(1)*QF(3)*PRE*XSW

C       G(T18,N215,FULL)
        CALL xE01234_NEW(RMF2(1),RMF2(3),RMF2(3),MHH2,RMF2(1),S24,
     &  S34,T13,T11,S12,CMF2(1),XMZ2,CMF2(3),XMZ2,XMZ2,E0N,E1N,E2N,
     &  E3N,E4N,D0,D1,D2,D3,2,1)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,3)
        K(4) = E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,3)
        K(5) = E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,4)+2D0*E2N(3,4)
        K(6) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)

        PRE = (ALPHA*SA*XCW2**(-3)*XMW)/(64D0*PI)

        F(1,-1,-1) = F(1,-1,-1)-(2D0*K(1)**2*K(2)**2*PRE*(-(2D0*
     &  E2N(3,4)*S13)+E1N(1)*S24)*XSW2**(-2))/XSW
        F(1,-1,1) = F(1,-1,1)-(8D0*K(1)**2*QF(3)**2*PRE*(-(2D0*
     &  E2N(3,4)*S13)+E1N(1)*S24))/XSW
        F(1,1,-1) = F(1,1,-1)-(8D0*K(2)**2*QF(1)**2*PRE*(-(2D0*
     &  E2N(3,4)*S13)+E1N(1)*S24))/XSW
        F(1,1,1) = F(1,1,1)-32D0*QF(1)**2*QF(3)**2*PRE*(-(2D0*E2N(3,
     &  4)*S13)+E1N(1)*S24)*XSW*XSW2
        F(2,-1,-1) = F(2,-1,-1)+(2D0*K(1)**2*K(2)**2*K(5)*PRE*XSW2**
     &  (-2))/XSW
        F(2,-1,1) = F(2,-1,1)+(8D0*K(1)**2*K(5)*QF(3)**2*PRE)/XSW
        F(2,1,-1) = F(2,1,-1)+(8D0*K(2)**2*K(5)*QF(1)**2*PRE)/XSW
        F(2,1,1) = F(2,1,1)+32D0*K(5)*QF(1)**2*QF(3)**2*PRE*XSW*XSW2
        F(3,-1,-1) = F(3,-1,-1)-(2D0*K(1)**2*K(2)**2*K(3)*PRE*XSW2**
     &  (-2))/XSW
        F(3,-1,1) = F(3,-1,1)-(8D0*K(1)**2*K(3)*QF(3)**2*PRE)/XSW
        F(3,1,-1) = F(3,1,-1)-(8D0*K(2)**2*K(3)*QF(1)**2*PRE)/XSW
        F(3,1,1) = F(3,1,1)-32D0*K(3)*QF(1)**2*QF(3)**2*PRE*XSW*XSW2
        F(5,-1,-1) = F(5,-1,-1)-(8D0*E2N(3,4)*K(1)**2*K(2)**2*PRE*
     &  XSW2**(-2))/XSW
        F(5,-1,1) = F(5,-1,1)-(32D0*E2N(3,4)*K(1)**2*QF(3)**2*PRE)/
     &  XSW
        F(5,1,-1) = F(5,1,-1)-(32D0*E2N(3,4)*K(2)**2*QF(1)**2*PRE)/
     &  XSW
        F(5,1,1) = F(5,1,1)-128D0*E2N(3,4)*QF(1)**2*QF(3)**2*PRE*
     &  XSW*XSW2
        F(6,-1,-1) = F(6,-1,-1)+(4D0*E1N(3)*K(1)**2*K(2)**2*PRE*
     &  XSW2**(-2))/XSW
        F(6,-1,1) = F(6,-1,1)+(16D0*E1N(3)*K(1)**2*QF(3)**2*PRE)/XSW
        F(6,1,-1) = F(6,1,-1)+(16D0*E1N(3)*K(2)**2*QF(1)**2*PRE)/XSW
        F(6,1,1) = F(6,1,1)+64D0*E1N(3)*QF(1)**2*QF(3)**2*PRE*XSW*
     &  XSW2
        F(7,-1,-1) = F(7,-1,-1)+(4D0*E1N(4)*K(1)**2*K(2)**2*PRE*
     &  XSW2**(-2))/XSW
        F(7,-1,1) = F(7,-1,1)+(16D0*E1N(4)*K(1)**2*QF(3)**2*PRE)/XSW
        F(7,1,-1) = F(7,1,-1)+(16D0*E1N(4)*K(2)**2*QF(1)**2*PRE)/XSW
        F(7,1,1) = F(7,1,1)+64D0*E1N(4)*QF(1)**2*QF(3)**2*PRE*XSW*
     &  XSW2
        F(9,-1,-1) = F(9,-1,-1)+(E2N(3,4)*K(1)**2*K(2)**2*PRE*XSW2**
     &  (-2))/XSW
        F(9,-1,1) = F(9,-1,1)+(4D0*E2N(3,4)*K(1)**2*QF(3)**2*PRE)/
     &  XSW
        F(9,1,-1) = F(9,1,-1)+(4D0*E2N(3,4)*K(2)**2*QF(1)**2*PRE)/
     &  XSW
        F(9,1,1) = F(9,1,1)+16D0*E2N(3,4)*QF(1)**2*QF(3)**2*PRE*XSW*
     &  XSW2
        F(10,-1,-1) = F(10,-1,-1)-(K(1)**2*K(2)**2*K(4)*PRE*XSW2**(-
     &  2))/XSW
        F(10,-1,1) = F(10,-1,1)-(4D0*K(1)**2*K(4)*QF(3)**2*PRE)/XSW
        F(10,1,-1) = F(10,1,-1)-(4D0*K(2)**2*K(4)*QF(1)**2*PRE)/XSW
        F(10,1,1) = F(10,1,1)-16D0*K(4)*QF(1)**2*QF(3)**2*PRE*XSW*
     &  XSW2
        F(11,-1,-1) = F(11,-1,-1)+((E2N(2,4)+E2N(3,4))*K(1)**2*
     &  K(2)**2*PRE*XSW2**(-2))/XSW
        F(11,-1,1) = F(11,-1,1)+(4D0*(E2N(2,4)+E2N(3,4))*K(1)**2*
     &  QF(3)**2*PRE)/XSW
        F(11,1,-1) = F(11,1,-1)+(4D0*(E2N(2,4)+E2N(3,4))*K(2)**2*
     &  QF(1)**2*PRE)/XSW
        F(11,1,1) = F(11,1,1)+16D0*(E2N(2,4)+E2N(3,4))*QF(1)**2*
     &  QF(3)**2*PRE*XSW*XSW2
        F(12,-1,-1) = F(12,-1,-1)-(K(1)**2*K(2)**2*K(6)*PRE*XSW2**(-
     &  2))/XSW
        F(12,-1,1) = F(12,-1,1)-(4D0*K(1)**2*K(6)*QF(3)**2*PRE)/XSW
        F(12,1,-1) = F(12,1,-1)-(4D0*K(2)**2*K(6)*QF(1)**2*PRE)/XSW
        F(12,1,1) = F(12,1,1)-16D0*K(6)*QF(1)**2*QF(3)**2*PRE*XSW*
     &  XSW2
        F(13,-1,-1) = F(13,-1,-1)-(E2N(0,0)*K(1)**2*K(2)**2*PRE*
     &  XSW2**(-2))/XSW
        F(13,-1,1) = F(13,-1,1)-(4D0*E2N(0,0)*K(1)**2*QF(3)**2*PRE)/
     &  XSW
        F(13,1,-1) = F(13,1,-1)-(4D0*E2N(0,0)*K(2)**2*QF(1)**2*PRE)/
     &  XSW
        F(13,1,1) = F(13,1,1)-16D0*E2N(0,0)*QF(1)**2*QF(3)**2*PRE*
     &  XSW*XSW2

C       G(T20,N226,FULL)

C       G(T20,N227,FULL)

C       G(T20,N228,FULL)

C       G(T20,N229,FULL)

C       G(T20,N230,FULL)

C       G(T20,N231,FULL)

C       G(T20,N232,FULL)

C       G(T20,N233,FULL)

C       G(T20,N234,FULL)

C       G(T20,N235,FULL)

C       G(T24,N281,FULL)

C       G(T24,N282,FULL)

C       G(T24,N283,FULL)

C       G(T24,N284,FULL)

C       G(T24,N285,FULL)
        CALL xE01234_NEW(RMF2(3),RMF2(1),RMF2(1),MHH2,RMF2(3),S23,
     &  S12,T11,T14,S34,CMF2(3),NULL,CMF2(1),XMZ2,XMZ2,E0N,E1N,E2N,
     &  E3N,E4N,D0,D1,D2,D3,2,1)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = S12+2D0*S23
        K(4) = E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,3)
        K(5) = E1N(4)+E2N(2,4)+E2N(3,4)
        K(6) = E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,3)
        K(7) = 2D0*E1N(3)+3D0*E2N(1,3)+3D0*E2N(2,3)+3D0*E2N(3,3)
        K(8) = E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,4)+2D0*E2N(3,4)
        K(9) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)
        K(10) = 10D0*E2N(0,0)+E1N(1)*S23+2D0*E1N(2)*S23+2D0*E2N(1,
     &  2)*S23+2D0*E2N(1,3)*S23+2D0*E2N(2,2)*S23+2D0*E2N(3,3)*(S12+
     &  S23)+E1N(3)*(S12+2D0*S23)+2D0*E2N(2,3)*(S12+2D0*S23)-E1N(4)*
     &  S34-2D0*E2N(1,4)*S34-2D0*E2N(2,4)*(S24+S34)-2D0*E2N(3,4)*
     &  (MHH2-T14)

        PRE = -((QF(1)*QF(3)*ALPHA*SA*XCW2**(-2)*XMW)/(16D0*PI))

        F(1,-1,-1) = F(1,-1,-1)+(2D0*K(1)*K(10)*K(2)*PRE)/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)+(4D0*K(1)*K(10)*QF(3)*PRE)/XSW
        F(1,1,-1) = F(1,1,-1)-(4D0*K(10)*K(2)*QF(1)*PRE)/XSW
        F(1,1,1) = F(1,1,1)-8D0*K(10)*QF(1)*QF(3)*PRE*XSW
        F(2,-1,-1) = F(2,-1,-1)-(2D0*K(1)*K(2)*K(4)*PRE)/(XSW*XSW2)
        F(2,-1,1) = F(2,-1,1)-(4D0*K(1)*K(4)*QF(3)*PRE)/XSW
        F(2,1,-1) = F(2,1,-1)+(4D0*K(2)*K(4)*QF(1)*PRE)/XSW
        F(2,1,1) = F(2,1,1)+8D0*K(4)*QF(1)*QF(3)*PRE*XSW
        F(3,-1,-1) = F(3,-1,-1)+(2D0*K(1)*K(2)*K(8)*PRE)/(XSW*XSW2)
        F(3,-1,1) = F(3,-1,1)+(4D0*K(1)*K(8)*QF(3)*PRE)/XSW
        F(3,1,-1) = F(3,1,-1)-(4D0*K(2)*K(8)*QF(1)*PRE)/XSW
        F(3,1,1) = F(3,1,1)-8D0*K(8)*QF(1)*QF(3)*PRE*XSW
        F(5,-1,-1) = F(5,-1,-1)+(4D0*K(1)*K(2)*K(7)*PRE)/(XSW*XSW2)
        F(5,-1,1) = F(5,-1,1)+(8D0*K(1)*K(7)*QF(3)*PRE)/XSW
        F(5,1,-1) = F(5,1,-1)-(8D0*K(2)*K(7)*QF(1)*PRE)/XSW
        F(5,1,1) = F(5,1,1)-16D0*K(7)*QF(1)*QF(3)*PRE*XSW
        F(6,-1,-1) = F(6,-1,-1)+(4D0*K(1)*K(2)*K(9)*PRE)/(XSW*XSW2)
        F(6,-1,1) = F(6,-1,1)+(8D0*K(1)*K(9)*QF(3)*PRE)/XSW
        F(6,1,-1) = F(6,1,-1)-(8D0*K(2)*K(9)*QF(1)*PRE)/XSW
        F(6,1,1) = F(6,1,1)-16D0*K(9)*QF(1)*QF(3)*PRE*XSW
        F(7,-1,-1) = F(7,-1,-1)-(4D0*E2N(3,4)*K(1)*K(2)*PRE)/(XSW*
     &  XSW2)
        F(7,-1,1) = F(7,-1,1)-(8D0*E2N(3,4)*K(1)*QF(3)*PRE)/XSW
        F(7,1,-1) = F(7,1,-1)+(8D0*E2N(3,4)*K(2)*QF(1)*PRE)/XSW
        F(7,1,1) = F(7,1,1)+16D0*E2N(3,4)*QF(1)*QF(3)*PRE*XSW
        F(8,-1,-1) = F(8,-1,-1)-(4D0*K(1)*K(2)*K(5)*PRE)/(XSW*XSW2)
        F(8,-1,1) = F(8,-1,1)-(8D0*K(1)*K(5)*QF(3)*PRE)/XSW
        F(8,1,-1) = F(8,1,-1)+(8D0*K(2)*K(5)*QF(1)*PRE)/XSW
        F(8,1,1) = F(8,1,1)+16D0*K(5)*QF(1)*QF(3)*PRE*XSW
        F(9,-1,-1) = F(9,-1,-1)-(K(1)*K(2)*K(6)*PRE)/(XSW*XSW2)
        F(9,-1,1) = F(9,-1,1)-(2D0*K(1)*K(6)*QF(3)*PRE)/XSW
        F(9,1,-1) = F(9,1,-1)+(2D0*K(2)*K(6)*QF(1)*PRE)/XSW
        F(9,1,1) = F(9,1,1)+4D0*K(6)*QF(1)*QF(3)*PRE*XSW
        F(10,-1,-1) = F(10,-1,-1)-(K(1)*K(2)*K(9)*PRE)/(XSW*XSW2)
        F(10,-1,1) = F(10,-1,1)-(2D0*K(1)*K(9)*QF(3)*PRE)/XSW
        F(10,1,-1) = F(10,1,-1)+(2D0*K(2)*K(9)*QF(1)*PRE)/XSW
        F(10,1,1) = F(10,1,1)+4D0*K(9)*QF(1)*QF(3)*PRE*XSW
        F(11,-1,-1) = F(11,-1,-1)+(E2N(3,4)*K(1)*K(2)*PRE)/(XSW*
     &  XSW2)
        F(11,-1,1) = F(11,-1,1)+(2D0*E2N(3,4)*K(1)*QF(3)*PRE)/XSW
        F(11,1,-1) = F(11,1,-1)-(2D0*E2N(3,4)*K(2)*QF(1)*PRE)/XSW
        F(11,1,1) = F(11,1,1)-4D0*E2N(3,4)*QF(1)*QF(3)*PRE*XSW
        F(12,-1,-1) = F(12,-1,-1)+((E2N(2,4)+E2N(3,4))*K(1)*K(2)*
     &  PRE)/(XSW*XSW2)
        F(12,-1,1) = F(12,-1,1)+(2D0*(E2N(2,4)+E2N(3,4))*K(1)*QF(3)*
     &  PRE)/XSW
        F(12,1,-1) = F(12,1,-1)-(2D0*(E2N(2,4)+E2N(3,4))*K(2)*QF(1)*
     &  PRE)/XSW
        F(12,1,1) = F(12,1,1)-4D0*(E2N(2,4)+E2N(3,4))*QF(1)*QF(3)*
     &  PRE*XSW
        F(13,-1,-1) = F(13,-1,-1)-(E2N(0,0)*K(1)*K(2)*PRE)/(XSW*
     &  XSW2)
        F(13,-1,1) = F(13,-1,1)-(2D0*E2N(0,0)*K(1)*QF(3)*PRE)/XSW
        F(13,1,-1) = F(13,1,-1)+(2D0*E2N(0,0)*K(2)*QF(1)*PRE)/XSW
        F(13,1,1) = F(13,1,1)+4D0*E2N(0,0)*QF(1)*QF(3)*PRE*XSW

C       G(T24,N286,FULL)
        CALL xE01234_NEW(RMF2(3),RMF2(1),RMF2(1),MHH2,RMF2(3),S23,
     &  S12,T11,T14,S34,CMF2(3),XMZ2,CMF2(1),XMZ2,XMZ2,E0N,E1N,E2N,
     &  E3N,E4N,D0,D1,D2,D3,2,1)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = S12+2D0*S23
        K(4) = E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,3)
        K(5) = E1N(4)+E2N(2,4)+E2N(3,4)
        K(6) = E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,3)
        K(7) = 2D0*E1N(3)+3D0*E2N(1,3)+3D0*E2N(2,3)+3D0*E2N(3,3)
        K(8) = E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,4)+2D0*E2N(3,4)
        K(9) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)
        K(10) = 10D0*E2N(0,0)+E1N(1)*S23+2D0*E1N(2)*S23+2D0*E2N(1,
     &  2)*S23+2D0*E2N(1,3)*S23+2D0*E2N(2,2)*S23+2D0*E2N(3,3)*(S12+
     &  S23)+E1N(3)*(S12+2D0*S23)+2D0*E2N(2,3)*(S12+2D0*S23)-E1N(4)*
     &  S34-2D0*E2N(1,4)*S34-2D0*E2N(2,4)*(S24+S34)-2D0*E2N(3,4)*
     &  (MHH2-T14)

        PRE = -((ALPHA*SA*XCW2**(-3)*XMW)/(64D0*PI))

        F(1,-1,-1) = F(1,-1,-1)-(2D0*K(1)**2*K(10)*K(2)**2*PRE*
     &  XSW2**(-2))/XSW
        F(1,-1,1) = F(1,-1,1)-(8D0*K(1)**2*K(10)*QF(3)**2*PRE)/XSW
        F(1,1,-1) = F(1,1,-1)-(8D0*K(10)*K(2)**2*QF(1)**2*PRE)/XSW
        F(1,1,1) = F(1,1,1)-32D0*K(10)*QF(1)**2*QF(3)**2*PRE*XSW*
     &  XSW2
        F(2,-1,-1) = F(2,-1,-1)+(2D0*K(1)**2*K(2)**2*K(4)*PRE*XSW2**
     &  (-2))/XSW
        F(2,-1,1) = F(2,-1,1)+(8D0*K(1)**2*K(4)*QF(3)**2*PRE)/XSW
        F(2,1,-1) = F(2,1,-1)+(8D0*K(2)**2*K(4)*QF(1)**2*PRE)/XSW
        F(2,1,1) = F(2,1,1)+32D0*K(4)*QF(1)**2*QF(3)**2*PRE*XSW*XSW2
        F(3,-1,-1) = F(3,-1,-1)-(2D0*K(1)**2*K(2)**2*K(8)*PRE*XSW2**
     &  (-2))/XSW
        F(3,-1,1) = F(3,-1,1)-(8D0*K(1)**2*K(8)*QF(3)**2*PRE)/XSW
        F(3,1,-1) = F(3,1,-1)-(8D0*K(2)**2*K(8)*QF(1)**2*PRE)/XSW
        F(3,1,1) = F(3,1,1)-32D0*K(8)*QF(1)**2*QF(3)**2*PRE*XSW*XSW2
        F(5,-1,-1) = F(5,-1,-1)-(4D0*K(1)**2*K(2)**2*K(7)*PRE*XSW2**
     &  (-2))/XSW
        F(5,-1,1) = F(5,-1,1)-(16D0*K(1)**2*K(7)*QF(3)**2*PRE)/XSW
        F(5,1,-1) = F(5,1,-1)-(16D0*K(2)**2*K(7)*QF(1)**2*PRE)/XSW
        F(5,1,1) = F(5,1,1)-64D0*K(7)*QF(1)**2*QF(3)**2*PRE*XSW*XSW2
        F(6,-1,-1) = F(6,-1,-1)-(4D0*K(1)**2*K(2)**2*K(9)*PRE*XSW2**
     &  (-2))/XSW
        F(6,-1,1) = F(6,-1,1)-(16D0*K(1)**2*K(9)*QF(3)**2*PRE)/XSW
        F(6,1,-1) = F(6,1,-1)-(16D0*K(2)**2*K(9)*QF(1)**2*PRE)/XSW
        F(6,1,1) = F(6,1,1)-64D0*K(9)*QF(1)**2*QF(3)**2*PRE*XSW*XSW2
        F(7,-1,-1) = F(7,-1,-1)+(4D0*E2N(3,4)*K(1)**2*K(2)**2*PRE*
     &  XSW2**(-2))/XSW
        F(7,-1,1) = F(7,-1,1)+(16D0*E2N(3,4)*K(1)**2*QF(3)**2*PRE)/
     &  XSW
        F(7,1,-1) = F(7,1,-1)+(16D0*E2N(3,4)*K(2)**2*QF(1)**2*PRE)/
     &  XSW
        F(7,1,1) = F(7,1,1)+64D0*E2N(3,4)*QF(1)**2*QF(3)**2*PRE*XSW*
     &  XSW2
        F(8,-1,-1) = F(8,-1,-1)+(4D0*K(1)**2*K(2)**2*K(5)*PRE*XSW2**
     &  (-2))/XSW
        F(8,-1,1) = F(8,-1,1)+(16D0*K(1)**2*K(5)*QF(3)**2*PRE)/XSW
        F(8,1,-1) = F(8,1,-1)+(16D0*K(2)**2*K(5)*QF(1)**2*PRE)/XSW
        F(8,1,1) = F(8,1,1)+64D0*K(5)*QF(1)**2*QF(3)**2*PRE*XSW*XSW2
        F(9,-1,-1) = F(9,-1,-1)+(K(1)**2*K(2)**2*K(6)*PRE*XSW2**(-
     &  2))/XSW
        F(9,-1,1) = F(9,-1,1)+(4D0*K(1)**2*K(6)*QF(3)**2*PRE)/XSW
        F(9,1,-1) = F(9,1,-1)+(4D0*K(2)**2*K(6)*QF(1)**2*PRE)/XSW
        F(9,1,1) = F(9,1,1)+16D0*K(6)*QF(1)**2*QF(3)**2*PRE*XSW*XSW2
        F(10,-1,-1) = F(10,-1,-1)+(K(1)**2*K(2)**2*K(9)*PRE*XSW2**(-
     &  2))/XSW
        F(10,-1,1) = F(10,-1,1)+(4D0*K(1)**2*K(9)*QF(3)**2*PRE)/XSW
        F(10,1,-1) = F(10,1,-1)+(4D0*K(2)**2*K(9)*QF(1)**2*PRE)/XSW
        F(10,1,1) = F(10,1,1)+16D0*K(9)*QF(1)**2*QF(3)**2*PRE*XSW*
     &  XSW2
        F(11,-1,-1) = F(11,-1,-1)-(E2N(3,4)*K(1)**2*K(2)**2*PRE*
     &  XSW2**(-2))/XSW
        F(11,-1,1) = F(11,-1,1)-(4D0*E2N(3,4)*K(1)**2*QF(3)**2*PRE)/
     &  XSW
        F(11,1,-1) = F(11,1,-1)-(4D0*E2N(3,4)*K(2)**2*QF(1)**2*PRE)/
     &  XSW
        F(11,1,1) = F(11,1,1)-16D0*E2N(3,4)*QF(1)**2*QF(3)**2*PRE*
     &  XSW*XSW2
        F(12,-1,-1) = F(12,-1,-1)-((E2N(2,4)+E2N(3,4))*K(1)**2*
     &  K(2)**2*PRE*XSW2**(-2))/XSW
        F(12,-1,1) = F(12,-1,1)-(4D0*(E2N(2,4)+E2N(3,4))*K(1)**2*
     &  QF(3)**2*PRE)/XSW
        F(12,1,-1) = F(12,1,-1)-(4D0*(E2N(2,4)+E2N(3,4))*K(2)**2*
     &  QF(1)**2*PRE)/XSW
        F(12,1,1) = F(12,1,1)-16D0*(E2N(2,4)+E2N(3,4))*QF(1)**2*
     &  QF(3)**2*PRE*XSW*XSW2
        F(13,-1,-1) = F(13,-1,-1)+(E2N(0,0)*K(1)**2*K(2)**2*PRE*
     &  XSW2**(-2))/XSW
        F(13,-1,1) = F(13,-1,1)+(4D0*E2N(0,0)*K(1)**2*QF(3)**2*PRE)/
     &  XSW
        F(13,1,-1) = F(13,1,-1)+(4D0*E2N(0,0)*K(2)**2*QF(1)**2*PRE)/
     &  XSW
        F(13,1,1) = F(13,1,1)+16D0*E2N(0,0)*QF(1)**2*QF(3)**2*PRE*
     &  XSW*XSW2

	end

**********************************************************************
        subroutine  HHtoZZ1133_self_ferm2_sesm(F,pz12,pz34)
**********************************************************************
*       self-energy contributions for HH -> ZZ -> uudd in the SESM
*       fermionic loops
*---------------------------------------------------------------------
*       7.2.17 Stefan Dittmaier
**********************************************************************
	implicit none
	complex*16 pre,F(13,-1:1,-1:1),pz12,pz34
	complex*16 A0,xA0_,B0_,xB0_,DB0_,xDB0_,B1_,xB1_,DB1_,xDB1_
        complex*16 B0,B1(1),B2(0:2,0:2),B3(0:2,0:2,2)
        complex*16 B4(0:2,0:2,0:2,0:2),B5(0:2,0:2,0:2,0:2,2)
        complex*16 C0_,C0,C1(2),C2(0:2,0:2),C3(0:2,0:2,2)
        complex*16 C4(0:2,0:2,0:2,0:2)
	complex*16 D0,D1(3),D2(0:3,0:3),D3(0:3,0:3,3)
        complex*16 D4(0:3,0:3,0:3,0:3),D5(0:3,0:3,0:3,0:3,3)
	complex*16 E0n,E1n(4),E2n(0:4,0:4),E3n(0:4,0:4,4)
	complex*16 E4n(0:4,0:4,0:4,0:4)
        complex*16 seaa,seaz,sezz

c mandelstam variables
      	real*8 s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
      	common/mandel/s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
c fermion charges of isospin duplets
	real*8 qf(4)
	common/fcharge/qf
c fermion masses as flag (i*1d-20)
      	complex*16 cme2,cmf2(5)
      	real*8 me2,rme2,mf2(5),rmf2(5)
      	common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2
	include '../COMMON/param.inc'
	include '../COMMON/xparam.inc'
        include '../COMMON/param_sesm.inc'
        include '../COMMON/param_bsm.inc'

        call xsevv_ferm(s12,seaa,seaz,sezz)

      PRE = SA*(PZ12*PZ34*XCW2**(-2)*XMW)/4D0  *(-sezz)*pz12

      F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/(XSW*XSW2)
      F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW
      F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW
      F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*XSW

      PRE = SA*(PZ12*PZ34/XCW**3/XSW*XMW)/4D0  *(-seaz)/s12

      F(1,-1,-1) = F(1,-1,-1)-(PRE*(-2D0*QF(1)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/(XSW*XSW2)
      F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(-2D0*QF(1)*XSW2))/
     &  XSW
      F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW
      F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*XSW

        call xsevv_ferm(s34,seaa,seaz,sezz)

      PRE = SA*(PZ12*PZ34*XCW2**(-2)*XMW)/4D0  *(-sezz)*pz34

      F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/(XSW*XSW2)
      F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW
      F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW
      F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*XSW

      PRE = SA*(PZ12*PZ34/XCW**3/XSW*XMW)/4D0  *(-seaz)/s34

      F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2)*(+2D0*
     &  QF(3)*XSW2))/(XSW*XSW2)
      F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW
      F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(2D0*QF(3)*XSW2))/
     &  XSW
      F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*XSW

	end

**********************************************************************
        subroutine  HHtoZZ1133_self_ferm_sesm(F,pz12,pz34)
**********************************************************************
*       self-energy contributions for HH -> ZZ -> uudd in the SESM
*       closed fermion loops
*---------------------------------------------------------------------
*       7.2.17 Stefan Dittmaier
**********************************************************************
	implicit none
	complex*16 pre,F(13,-1:1,-1:1),pz12,pz34
	complex*16 A0,xA0_,B0_,xB0_,DB0_,xDB0_,B1_,xB1_,DB1_,xDB1_
        complex*16 B0,B1(1),B2(0:2,0:2),B3(0:2,0:2,2)
        complex*16 B4(0:2,0:2,0:2,0:2),B5(0:2,0:2,0:2,0:2,2)
        complex*16 C0_,C0,C1(2),C2(0:2,0:2),C3(0:2,0:2,2)
        complex*16 C4(0:2,0:2,0:2,0:2)
	complex*16 D0,D1(3),D2(0:3,0:3),D3(0:3,0:3,3)
        complex*16 D4(0:3,0:3,0:3,0:3),D5(0:3,0:3,0:3,0:3,3)
	complex*16 E0n,E1n(4),E2n(0:4,0:4),E3n(0:4,0:4,4)
	complex*16 E4n(0:4,0:4,0:4,0:4)
        COMPLEX*16 K(2)
	integer i

c mandelstam variables
      	real*8 s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
      	common/mandel/s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
c fermion charges of isospin duplets
	real*8 qf(4)
	common/fcharge/qf
c fermion masses as flag (i*1d-20)
      	complex*16 cme2,cmf2(5)
      	real*8 me2,rme2,mf2(5),rmf2(5)
      	common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2
	include '../COMMON/param.inc'
	include '../COMMON/xparam.inc'
        include '../COMMON/param_sesm.inc'
        include '../COMMON/param_bsm.inc'

	do 100 i=1,3

C       Process: S4F21aF21F23aF23,   Model: Singlet

C       G(T7,N152,FULL)

C       G(T7,N153,FULL)

C       G(T7,N154,FULL)

C       G(T7,N172,FULL)

C       G(T7,N173,FULL)

C       G(T7,N174,FULL)

C       G(T7,N185,FULL)

C       G(T7,N186,FULL)

C       G(T7,N187,FULL)

C       G(T7,N198,FULL)

C       G(T7,N199,FULL)

C       G(T7,N200,FULL)

C       G(T7,N211,FULL)
        CALL xB012345_(S12,XMQM2(I),XMQM2(I),B0,B1,B2,B3,B4,B5,2,0)

        PRE = (QF(1)*ALPHA*PZ12*PZ34*SA*XCW2**(-2)*XMW*(3D0-4D0*
     &  XSW2)*(-(6D0*B1(1))-6D0*B2(1,1)-(12D0*B2(0,0))/S12+(6D0*B0*
     &  XMQM2(I))/S12-((S12-6D0*XMQM2(I)))/S12))/(144D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE
        F(1,1,-1) = F(1,1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,1,1) = F(1,1,1)+2D0*QF(3)*PRE

C       G(T7,N212,FULL)
        CALL xB012345_(S12,XMQP2(I),XMQP2(I),B0,B1,B2,B3,B4,B5,2,0)

        PRE = (QF(1)*ALPHA*PZ12*PZ34*SA*XCW2**(-2)*XMW*(3D0-8D0*
     &  XSW2)*(-(6D0*B1(1))-6D0*B2(1,1)-(12D0*B2(0,0))/S12+(6D0*B0*
     &  XMQP2(I))/S12-((S12-6D0*XMQP2(I)))/S12))/(72D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE
        F(1,1,-1) = F(1,1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,1,1) = F(1,1,1)+2D0*QF(3)*PRE

C       G(T7,N213,FULL)
        CALL xB012345_(S12,XML2(I),XML2(I),B0,B1,B2,B3,B4,B5,2,0)

        PRE = (QF(1)*ALPHA*PZ12*PZ34*SA*XCW2**(-2)*XMW*(1D0-2D0*
     &  XSW)*(1D0+2D0*XSW)*(-(6D0*B1(1))-6D0*B2(1,1)-(12D0*B2(0,0))/
     &  S12+(6D0*B0*XML2(I))/S12-((S12-6D0*XML2(I)))/S12))/(48D0*PI*
     &  XSW)

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE
        F(1,1,-1) = F(1,1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,1,1) = F(1,1,1)+2D0*QF(3)*PRE

C       G(T7,N224,FULL)
        CALL xB012345_(S12,XMQM2(I),XMQM2(I),B0,B1,B2,B3,B4,B5,2,0)
        K(1) = 9D0-12D0*XSW2+8D0*XSW2**2
        K(2) = (12D0*B2(0,0)*(9D0-12D0*XSW2+8D0*XSW2**2))/XSW2+(6D0*
     &  B1(1)*S12*(9D0-12D0*XSW2+8D0*XSW2**2))/XSW2+(6D0*B2(1,1)*
     &  S12*(9D0-12D0*XSW2+8D0*XSW2**2))/XSW2+24D0*B0*(3D0-2D0*
     &  XSW2)*XMQM2(I)+((9D0-12D0*XSW2+8D0*XSW2**2)*(S12-6D0*
     &  XMQM2(I)))/XSW2

        PRE = (ALPHA*PZ12**2*PZ34*SA*XCW2**(-3)*XMW)/(576D0*PI)

        F(1,-1,-1) = F(1,-1,-1)-(K(2)*PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+
     &  2D0*QF(3)*XSW2))/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*K(2)*QF(3)*PRE*(1D0-2D0*QF(1)*
     &  XSW2))/XSW
        F(1,1,-1) = F(1,1,-1)+(2D0*K(2)*QF(1)*PRE*(1D0+2D0*QF(3)*
     &  XSW2))/XSW
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*((12D0*B2(0,0)*
     &  K(1))/XSW+(6D0*B1(1)*K(1)*S12)/XSW+(6D0*B2(1,1)*K(1)*S12)/
     &  XSW+24D0*B0*XSW*(3D0-2D0*XSW2)*XMQM2(I)+(K(1)*(S12-6D0*
     &  XMQM2(I)))/XSW)

C       G(T7,N225,FULL)
        CALL xB012345_(S12,XMQP2(I),XMQP2(I),B0,B1,B2,B3,B4,B5,2,0)
        K(1) = 9D0-24D0*XSW2+32D0*XSW2**2
        K(2) = (12D0*B2(0,0)*(9D0-24D0*XSW2+32D0*XSW2**2))/XSW2+
     &  (6D0*B1(1)*S12*(9D0-24D0*XSW2+32D0*XSW2**2))/XSW2+(6D0*B2(1,
     &  1)*S12*(9D0-24D0*XSW2+32D0*XSW2**2))/XSW2+48D0*B0*(3D0-4D0*
     &  XSW2)*XMQP2(I)+((9D0-24D0*XSW2+32D0*XSW2**2)*(S12-6D0*
     &  XMQP2(I)))/XSW2

        PRE = (ALPHA*PZ12**2*PZ34*SA*XCW2**(-3)*XMW)/(576D0*PI)

        F(1,-1,-1) = F(1,-1,-1)-(K(2)*PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+
     &  2D0*QF(3)*XSW2))/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*K(2)*QF(3)*PRE*(1D0-2D0*QF(1)*
     &  XSW2))/XSW
        F(1,1,-1) = F(1,1,-1)+(2D0*K(2)*QF(1)*PRE*(1D0+2D0*QF(3)*
     &  XSW2))/XSW
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*((12D0*B2(0,0)*
     &  K(1))/XSW+(6D0*B1(1)*K(1)*S12)/XSW+(6D0*B2(1,1)*K(1)*S12)/
     &  XSW+48D0*B0*XSW*(3D0-4D0*XSW2)*XMQP2(I)+(K(1)*(S12-6D0*
     &  XMQP2(I)))/XSW)

C       G(T7,N226,FULL)
        CALL xB012345_(S12,NULL,NULL,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (ALPHA*PZ12**2*PZ34*(12D0*B2(0,0)+S12+6D0*B1(1)*S12+
     &  6D0*B2(1,1)*S12)*SA*XCW2**(-3)*XMW)/(192D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T7,N227,FULL)
        CALL xB012345_(S12,XML2(I),XML2(I),B0,B1,B2,B3,B4,B5,2,0)
        K(1) = 1D0-4D0*XSW2+8D0*XSW2**2
        K(2) = (12D0*B2(0,0)*(1D0-4D0*XSW2+8D0*XSW2**2))/XSW2+(6D0*
     &  B1(1)*S12*(1D0-4D0*XSW2+8D0*XSW2**2))/XSW2+(6D0*B2(1,1)*S12*
     &  (1D0-4D0*XSW2+8D0*XSW2**2))/XSW2+24D0*B0*(1D0-2D0*XSW2)*
     &  XML2(I)+((1D0-4D0*XSW2+8D0*XSW2**2)*(S12-6D0*XML2(I)))/XSW2

        PRE = (ALPHA*PZ12**2*PZ34*SA*XCW2**(-3)*XMW)/(192D0*PI)

        F(1,-1,-1) = F(1,-1,-1)-(K(2)*PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+
     &  2D0*QF(3)*XSW2))/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*K(2)*QF(3)*PRE*(1D0-2D0*QF(1)*
     &  XSW2))/XSW
        F(1,1,-1) = F(1,1,-1)+(2D0*K(2)*QF(1)*PRE*(1D0+2D0*QF(3)*
     &  XSW2))/XSW
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*((12D0*B2(0,0)*
     &  K(1))/XSW+(6D0*B1(1)*K(1)*S12)/XSW+(6D0*B2(1,1)*K(1)*S12)/
     &  XSW+24D0*B0*XSW*(1D0-2D0*XSW2)*XML2(I)+(K(1)*(S12-6D0*
     &  XML2(I)))/XSW)

C       G(T8,N242,FULL)

C       G(T8,N243,FULL)

C       G(T8,N244,FULL)

C       G(T8,N262,FULL)

C       G(T8,N263,FULL)

C       G(T8,N264,FULL)

C       G(T8,N275,FULL)

C       G(T8,N276,FULL)

C       G(T8,N277,FULL)

C       G(T8,N288,FULL)

C       G(T8,N289,FULL)

C       G(T8,N290,FULL)

C       G(T8,N301,FULL)

C       G(T8,N302,FULL)

C       G(T8,N303,FULL)

C       G(T8,N314,FULL)

C       G(T8,N315,FULL)

C       G(T8,N316,FULL)

C       G(T8,N327,FULL)

C       G(T8,N328,FULL)

C       G(T8,N329,FULL)

C       G(T8,N340,FULL)

C       G(T8,N341,FULL)

C       G(T8,N342,FULL)

C       G(T8,N353,FULL)

C       G(T8,N354,FULL)

C       G(T8,N355,FULL)

C       G(T8,N356,FULL)

C       G(T9,N371,FULL)

C       G(T9,N372,FULL)

C       G(T9,N373,FULL)

C       G(T9,N391,FULL)

C       G(T9,N392,FULL)

C       G(T9,N393,FULL)

C       G(T9,N404,FULL)

C       G(T9,N405,FULL)

C       G(T9,N406,FULL)

C       G(T9,N417,FULL)

C       G(T9,N418,FULL)

C       G(T9,N419,FULL)

C       G(T9,N430,FULL)

C       G(T9,N431,FULL)

C       G(T9,N432,FULL)

C       G(T9,N443,FULL)

C       G(T9,N444,FULL)

C       G(T9,N445,FULL)

C       G(T9,N456,FULL)

C       G(T9,N457,FULL)

C       G(T9,N458,FULL)

C       G(T9,N469,FULL)

C       G(T9,N470,FULL)

C       G(T9,N471,FULL)

C       G(T9,N482,FULL)

C       G(T9,N483,FULL)

C       G(T9,N484,FULL)

C       G(T9,N485,FULL)

C       G(T14,N589,FULL)

C       G(T14,N590,FULL)

C       G(T14,N591,FULL)

C       G(T14,N609,FULL)

C       G(T14,N610,FULL)

C       G(T14,N611,FULL)

C       G(T14,N622,FULL)

C       G(T14,N623,FULL)

C       G(T14,N624,FULL)

C       G(T14,N635,FULL)

C       G(T14,N636,FULL)

C       G(T14,N637,FULL)

C       G(T14,N648,FULL)
        CALL xB012345_(S34,XMQM2(I),XMQM2(I),B0,B1,B2,B3,B4,B5,2,0)

        PRE = (QF(3)*ALPHA*PZ12*PZ34*SA*XCW2**(-2)*XMW*(3D0-4D0*
     &  XSW2)*(-(6D0*B1(1))-6D0*B2(1,1)-(12D0*B2(0,0))/S34+(6D0*B0*
     &  XMQM2(I))/S34-((S34-6D0*XMQM2(I)))/S34))/(144D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE
        F(1,1,1) = F(1,1,1)+2D0*QF(1)*PRE

C       G(T14,N649,FULL)
        CALL xB012345_(S34,XMQP2(I),XMQP2(I),B0,B1,B2,B3,B4,B5,2,0)

        PRE = (QF(3)*ALPHA*PZ12*PZ34*SA*XCW2**(-2)*XMW*(3D0-8D0*
     &  XSW2)*(-(6D0*B1(1))-6D0*B2(1,1)-(12D0*B2(0,0))/S34+(6D0*B0*
     &  XMQP2(I))/S34-((S34-6D0*XMQP2(I)))/S34))/(72D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE
        F(1,1,1) = F(1,1,1)+2D0*QF(1)*PRE

C       G(T14,N650,FULL)
        CALL xB012345_(S34,XML2(I),XML2(I),B0,B1,B2,B3,B4,B5,2,0)

        PRE = (QF(3)*ALPHA*PZ12*PZ34*SA*XCW2**(-2)*XMW*(1D0-2D0*
     &  XSW)*(1D0+2D0*XSW)*(-(6D0*B1(1))-6D0*B2(1,1)-(12D0*B2(0,0))/
     &  S34+(6D0*B0*XML2(I))/S34-((S34-6D0*XML2(I)))/S34))/(48D0*PI*
     &  XSW)

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE
        F(1,1,1) = F(1,1,1)+2D0*QF(1)*PRE

C       G(T14,N661,FULL)
        CALL xB012345_(S34,XMQM2(I),XMQM2(I),B0,B1,B2,B3,B4,B5,2,0)
        K(1) = 9D0-12D0*XSW2+8D0*XSW2**2
        K(2) = (12D0*B2(0,0)*(9D0-12D0*XSW2+8D0*XSW2**2))/XSW2+(6D0*
     &  B1(1)*S34*(9D0-12D0*XSW2+8D0*XSW2**2))/XSW2+(6D0*B2(1,1)*
     &  S34*(9D0-12D0*XSW2+8D0*XSW2**2))/XSW2+24D0*B0*(3D0-2D0*
     &  XSW2)*XMQM2(I)+((9D0-12D0*XSW2+8D0*XSW2**2)*(S34-6D0*
     &  XMQM2(I)))/XSW2

        PRE = (ALPHA*PZ12*PZ34**2*SA*XCW2**(-3)*XMW)/(576D0*PI)

        F(1,-1,-1) = F(1,-1,-1)-(K(2)*PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+
     &  2D0*QF(3)*XSW2))/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*K(2)*QF(3)*PRE*(1D0-2D0*QF(1)*
     &  XSW2))/XSW
        F(1,1,-1) = F(1,1,-1)+(2D0*K(2)*QF(1)*PRE*(1D0+2D0*QF(3)*
     &  XSW2))/XSW
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*((12D0*B2(0,0)*
     &  K(1))/XSW+(6D0*B1(1)*K(1)*S34)/XSW+(6D0*B2(1,1)*K(1)*S34)/
     &  XSW+24D0*B0*XSW*(3D0-2D0*XSW2)*XMQM2(I)+(K(1)*(S34-6D0*
     &  XMQM2(I)))/XSW)

C       G(T14,N662,FULL)
        CALL xB012345_(S34,XMQP2(I),XMQP2(I),B0,B1,B2,B3,B4,B5,2,0)
        K(1) = 9D0-24D0*XSW2+32D0*XSW2**2
        K(2) = (12D0*B2(0,0)*(9D0-24D0*XSW2+32D0*XSW2**2))/XSW2+
     &  (6D0*B1(1)*S34*(9D0-24D0*XSW2+32D0*XSW2**2))/XSW2+(6D0*B2(1,
     &  1)*S34*(9D0-24D0*XSW2+32D0*XSW2**2))/XSW2+48D0*B0*(3D0-4D0*
     &  XSW2)*XMQP2(I)+((9D0-24D0*XSW2+32D0*XSW2**2)*(S34-6D0*
     &  XMQP2(I)))/XSW2

        PRE = (ALPHA*PZ12*PZ34**2*SA*XCW2**(-3)*XMW)/(576D0*PI)

        F(1,-1,-1) = F(1,-1,-1)-(K(2)*PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+
     &  2D0*QF(3)*XSW2))/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*K(2)*QF(3)*PRE*(1D0-2D0*QF(1)*
     &  XSW2))/XSW
        F(1,1,-1) = F(1,1,-1)+(2D0*K(2)*QF(1)*PRE*(1D0+2D0*QF(3)*
     &  XSW2))/XSW
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*((12D0*B2(0,0)*
     &  K(1))/XSW+(6D0*B1(1)*K(1)*S34)/XSW+(6D0*B2(1,1)*K(1)*S34)/
     &  XSW+48D0*B0*XSW*(3D0-4D0*XSW2)*XMQP2(I)+(K(1)*(S34-6D0*
     &  XMQP2(I)))/XSW)

C       G(T14,N663,FULL)
        CALL xB012345_(S34,NULL,NULL,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (ALPHA*PZ12*PZ34**2*(12D0*B2(0,0)+S34+6D0*B1(1)*S34+
     &  6D0*B2(1,1)*S34)*SA*XCW2**(-3)*XMW)/(192D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T14,N664,FULL)
        CALL xB012345_(S34,XML2(I),XML2(I),B0,B1,B2,B3,B4,B5,2,0)
        K(1) = 1D0-4D0*XSW2+8D0*XSW2**2
        K(2) = (12D0*B2(0,0)*(1D0-4D0*XSW2+8D0*XSW2**2))/XSW2+(6D0*
     &  B1(1)*S34*(1D0-4D0*XSW2+8D0*XSW2**2))/XSW2+(6D0*B2(1,1)*S34*
     &  (1D0-4D0*XSW2+8D0*XSW2**2))/XSW2+24D0*B0*(1D0-2D0*XSW2)*
     &  XML2(I)+((1D0-4D0*XSW2+8D0*XSW2**2)*(S34-6D0*XML2(I)))/XSW2

        PRE = (ALPHA*PZ12*PZ34**2*SA*XCW2**(-3)*XMW)/(192D0*PI)

        F(1,-1,-1) = F(1,-1,-1)-(K(2)*PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+
     &  2D0*QF(3)*XSW2))/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*K(2)*QF(3)*PRE*(1D0-2D0*QF(1)*
     &  XSW2))/XSW
        F(1,1,-1) = F(1,1,-1)+(2D0*K(2)*QF(1)*PRE*(1D0+2D0*QF(3)*
     &  XSW2))/XSW
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*((12D0*B2(0,0)*
     &  K(1))/XSW+(6D0*B1(1)*K(1)*S34)/XSW+(6D0*B2(1,1)*K(1)*S34)/
     &  XSW+24D0*B0*XSW*(1D0-2D0*XSW2)*XML2(I)+(K(1)*(S34-6D0*
     &  XML2(I)))/XSW)

C       G(T15,N679,FULL)

C       G(T15,N680,FULL)

C       G(T15,N681,FULL)

C       G(T15,N699,FULL)

C       G(T15,N700,FULL)

C       G(T15,N701,FULL)

C       G(T15,N712,FULL)

C       G(T15,N713,FULL)

C       G(T15,N714,FULL)

C       G(T15,N725,FULL)

C       G(T15,N726,FULL)

C       G(T15,N727,FULL)

C       G(T15,N738,FULL)

C       G(T15,N739,FULL)

C       G(T15,N740,FULL)

C       G(T15,N751,FULL)

C       G(T15,N752,FULL)

C       G(T15,N753,FULL)

C       G(T15,N764,FULL)

C       G(T15,N765,FULL)

C       G(T15,N766,FULL)

C       G(T15,N777,FULL)

C       G(T15,N778,FULL)

C       G(T15,N779,FULL)

C       G(T15,N790,FULL)

C       G(T15,N791,FULL)

C       G(T15,N792,FULL)

C       G(T15,N793,FULL)

C       G(T16,N808,FULL)

C       G(T16,N809,FULL)

C       G(T16,N810,FULL)

C       G(T16,N828,FULL)

C       G(T16,N829,FULL)

C       G(T16,N830,FULL)

C       G(T16,N841,FULL)

C       G(T16,N842,FULL)

C       G(T16,N843,FULL)

C       G(T16,N854,FULL)

C       G(T16,N855,FULL)

C       G(T16,N856,FULL)

C       G(T16,N867,FULL)

C       G(T16,N868,FULL)

C       G(T16,N869,FULL)

C       G(T16,N880,FULL)

C       G(T16,N881,FULL)

C       G(T16,N882,FULL)

C       G(T16,N893,FULL)

C       G(T16,N894,FULL)

C       G(T16,N895,FULL)

C       G(T16,N906,FULL)

C       G(T16,N907,FULL)

C       G(T16,N908,FULL)

C       G(T16,N919,FULL)

C       G(T16,N920,FULL)

C       G(T16,N921,FULL)

C       G(T16,N922,FULL)

100	continue

	end

**********************************************************************
        subroutine  HHtoZZ1133_vert_ferm_sesm(F,pz12,pz34)
**********************************************************************
*       self-energy contributions for HH -> ZZ -> uudd in the SESM
*       closed fermion loops
*---------------------------------------------------------------------
*       7.2.17 Stefan Dittmaier
**********************************************************************
	implicit none
	complex*16 pre,F(13,-1:1,-1:1),pz12,pz34
	complex*16 A0,xA0_,B0_,xB0_,DB0_,xDB0_,B1_,xB1_,DB1_,xDB1_
        complex*16 B0,B1(1),B2(0:2,0:2),B3(0:2,0:2,2)
        complex*16 B4(0:2,0:2,0:2,0:2),B5(0:2,0:2,0:2,0:2,2)
        complex*16 C0_,C0,C1(2),C2(0:2,0:2),C3(0:2,0:2,2)
        complex*16 C4(0:2,0:2,0:2,0:2)
	complex*16 D0,D1(3),D2(0:3,0:3),D3(0:3,0:3,3)
        complex*16 D4(0:3,0:3,0:3,0:3),D5(0:3,0:3,0:3,0:3,3)
	complex*16 E0n,E1n(4),E2n(0:4,0:4),E3n(0:4,0:4,4)
	complex*16 E4n(0:4,0:4,0:4,0:4)
        COMPLEX*16 K(17)
	real *8 qeps
	integer i

c mandelstam variables
      	real*8 s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
      	common/mandel/s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
c fermion charges of isospin duplets
	real*8 qf(4)
	common/fcharge/qf
c fermion masses as flag (i*1d-20)
      	complex*16 cme2,cmf2(5)
      	real*8 me2,rme2,mf2(5),rmf2(5)
      	common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2
	include '../COMMON/param.inc'
	include '../COMMON/xparam.inc'
        include '../COMMON/param_sesm.inc'
        include '../COMMON/param_bsm.inc'

	qeps = 1d0

	do 100 i=1,3

C       Process: S4F21aF21F23aF23,   Model: Singlet

C       G(T9,N774,FULL)

C       G(T9,N775,FULL)

C       G(T9,N776,FULL)

C       G(T9,N777,FULL)

C       G(T9,N778,FULL)

C       G(T9,N779,FULL)

C       G(T9,N780,FULL)

C       G(T9,N781,FULL)

C       G(T9,N782,FULL)

C       G(T9,N783,FULL)

C       G(T9,N784,FULL)

C       G(T9,N785,FULL)

C       G(T9,N786,FULL)

C       G(T9,N787,FULL)

C       G(T9,N794,FULL)

C       G(T9,N795,FULL)

C       G(T9,N796,FULL)

C       G(T9,N797,FULL)

C       G(T9,N798,FULL)

C       G(T9,N799,FULL)

C       G(T9,N800,FULL)

C       G(T9,N801,FULL)

C       G(T9,N802,FULL)

C       G(T9,N803,FULL)

C       G(T9,N804,FULL)

C       G(T9,N805,FULL)

C       G(T9,N806,FULL)

C       G(T9,N807,FULL)

C       G(T9,N820,FULL)

C       G(T9,N821,FULL)

C       G(T9,N822,FULL)

C       G(T9,N823,FULL)

C       G(T9,N824,FULL)

C       G(T9,N825,FULL)

C       G(T9,N826,FULL)

C       G(T9,N827,FULL)

C       G(T9,N828,FULL)

C       G(T9,N829,FULL)

C       G(T9,N830,FULL)

C       G(T9,N831,FULL)

C       G(T9,N832,FULL)

C       G(T9,N833,FULL)

C       G(T9,N840,FULL)

C       G(T9,N841,FULL)

C       G(T9,N842,FULL)

C       G(T9,N843,FULL)

C       G(T9,N844,FULL)

C       G(T9,N845,FULL)

C       G(T9,N846,FULL)

C       G(T9,N847,FULL)

C       G(T9,N848,FULL)

C       G(T9,N849,FULL)

C       G(T9,N850,FULL)

C       G(T9,N851,FULL)

C       G(T9,N852,FULL)

C       G(T9,N853,FULL)

C       G(T9,N858,FULL)

C       G(T9,N859,FULL)

C       G(T9,N860,FULL)

C       G(T9,N861,FULL)

C       G(T9,N862,FULL)

C       G(T9,N863,FULL)

C       G(T9,N864,FULL)

C       G(T9,N865,FULL)

C       G(T9,N866,FULL)

C       G(T9,N867,FULL)

C       G(T9,N868,FULL)

C       G(T9,N869,FULL)

C       G(T9,N870,FULL)

C       G(T9,N871,FULL)

C       G(T9,N876,FULL)

C       G(T9,N877,FULL)

C       G(T9,N878,FULL)

C       G(T9,N879,FULL)

C       G(T9,N880,FULL)

C       G(T9,N881,FULL)

C       G(T9,N882,FULL)

C       G(T9,N883,FULL)

C       G(T9,N884,FULL)

C       G(T9,N885,FULL)

C       G(T9,N886,FULL)

C       G(T9,N887,FULL)

C       G(T9,N888,FULL)

C       G(T9,N889,FULL)

C       G(T9,N902,FULL)

C       G(T9,N903,FULL)

C       G(T9,N904,FULL)

C       G(T9,N905,FULL)

C       G(T9,N906,FULL)

C       G(T9,N907,FULL)

C       G(T9,N908,FULL)

C       G(T9,N909,FULL)

C       G(T9,N910,FULL)

C       G(T9,N911,FULL)

C       G(T9,N912,FULL)

C       G(T9,N913,FULL)

C       G(T9,N914,FULL)

C       G(T9,N915,FULL)

C       G(T9,N924,FULL)

C       G(T9,N925,FULL)

C       G(T9,N926,FULL)

C       G(T9,N927,FULL)

C       G(T9,N928,FULL)

C       G(T9,N929,FULL)

C       G(T9,N930,FULL)

C       G(T9,N931,FULL)

C       G(T9,N932,FULL)

C       G(T9,N933,FULL)

C       G(T9,N934,FULL)

C       G(T9,N935,FULL)

C       G(T9,N936,FULL)

C       G(T9,N937,FULL)

C       G(T9,N950,FULL)

C       G(T9,N951,FULL)

C       G(T9,N952,FULL)

C       G(T9,N953,FULL)

C       G(T9,N954,FULL)

C       G(T9,N955,FULL)

C       G(T9,N956,FULL)

C       G(T9,N957,FULL)

C       G(T9,N958,FULL)

C       G(T9,N959,FULL)

C       G(T9,N960,FULL)

C       G(T9,N961,FULL)

C       G(T9,N962,FULL)

C       G(T9,N963,FULL)

C       G(T9,N976,FULL)

C       G(T9,N977,FULL)

C       G(T9,N978,FULL)

C       G(T9,N979,FULL)

C       G(T9,N980,FULL)

C       G(T9,N981,FULL)

C       G(T9,N982,FULL)

C       G(T9,N983,FULL)

C       G(T9,N984,FULL)

C       G(T9,N985,FULL)

C       G(T9,N986,FULL)

C       G(T9,N987,FULL)

C       G(T9,N988,FULL)

C       G(T9,N989,FULL)

C       G(T9,N1002,FULL)

C       G(T9,N1003,FULL)

C       G(T9,N1004,FULL)

C       G(T9,N1005,FULL)

C       G(T9,N1006,FULL)

C       G(T9,N1007,FULL)

C       G(T9,N1008,FULL)

C       G(T9,N1009,FULL)

C       G(T9,N1010,FULL)

C       G(T9,N1011,FULL)

C       G(T9,N1012,FULL)

C       G(T9,N1013,FULL)

C       G(T9,N1014,FULL)

C       G(T9,N1015,FULL)

C       G(T9,N1022,FULL)

C       G(T9,N1023,FULL)

C       G(T9,N1024,FULL)

C       G(T9,N1025,FULL)

C       G(T9,N1026,FULL)

C       G(T9,N1027,FULL)

C       G(T9,N1028,FULL)

C       G(T9,N1029,FULL)

C       G(T9,N1030,FULL)

C       G(T9,N1031,FULL)

C       G(T9,N1032,FULL)

C       G(T9,N1033,FULL)

C       G(T9,N1034,FULL)

C       G(T9,N1035,FULL)

C       G(T9,N1048,FULL)

C       G(T9,N1049,FULL)

C       G(T9,N1050,FULL)

C       G(T9,N1051,FULL)

C       G(T9,N1052,FULL)

C       G(T9,N1053,FULL)

C       G(T9,N1054,FULL)

C       G(T9,N1055,FULL)

C       G(T9,N1056,FULL)

C       G(T9,N1057,FULL)

C       G(T9,N1058,FULL)

C       G(T9,N1059,FULL)

C       G(T9,N1060,FULL)

C       G(T9,N1061,FULL)

C       G(T9,N1068,FULL)

C       G(T9,N1069,FULL)

C       G(T9,N1070,FULL)

C       G(T9,N1071,FULL)

C       G(T9,N1072,FULL)

C       G(T9,N1073,FULL)

C       G(T9,N1074,FULL)

C       G(T9,N1075,FULL)

C       G(T9,N1076,FULL)

C       G(T9,N1077,FULL)

C       G(T9,N1078,FULL)

C       G(T9,N1079,FULL)

C       G(T9,N1080,FULL)

C       G(T9,N1081,FULL)

C       G(T9,N1086,FULL)

C       G(T9,N1087,FULL)

C       G(T9,N1088,FULL)

C       G(T9,N1089,FULL)

C       G(T9,N1090,FULL)

C       G(T9,N1091,FULL)

C       G(T9,N1092,FULL)

C       G(T9,N1093,FULL)

C       G(T9,N1094,FULL)

C       G(T9,N1095,FULL)

C       G(T9,N1096,FULL)

C       G(T9,N1097,FULL)

C       G(T9,N1098,FULL)

C       G(T9,N1099,FULL)

C       G(T9,N1104,FULL)

C       G(T9,N1105,FULL)

C       G(T9,N1106,FULL)

C       G(T9,N1107,FULL)

C       G(T9,N1108,FULL)

C       G(T9,N1109,FULL)

C       G(T9,N1110,FULL)

C       G(T9,N1111,FULL)

C       G(T9,N1112,FULL)

C       G(T9,N1113,FULL)

C       G(T9,N1114,FULL)

C       G(T9,N1115,FULL)

C       G(T9,N1116,FULL)

C       G(T9,N1117,FULL)

C       G(T9,N1122,FULL)

C       G(T9,N1123,FULL)

C       G(T9,N1124,FULL)

C       G(T9,N1125,FULL)

C       G(T9,N1126,FULL)

C       G(T9,N1127,FULL)

C       G(T9,N1128,FULL)

C       G(T9,N1129,FULL)

C       G(T9,N1130,FULL)

C       G(T9,N1131,FULL)

C       G(T9,N1132,FULL)

C       G(T9,N1133,FULL)

C       G(T9,N1134,FULL)

C       G(T9,N1135,FULL)

C       G(T9,N1148,FULL)

C       G(T9,N1149,FULL)

C       G(T9,N1150,FULL)

C       G(T9,N1151,FULL)

C       G(T9,N1152,FULL)

C       G(T9,N1153,FULL)

C       G(T9,N1154,FULL)

C       G(T9,N1155,FULL)

C       G(T9,N1156,FULL)

C       G(T9,N1157,FULL)

C       G(T9,N1158,FULL)

C       G(T9,N1159,FULL)

C       G(T9,N1160,FULL)

C       G(T9,N1161,FULL)

C       G(T9,N1166,FULL)

C       G(T9,N1167,FULL)

C       G(T9,N1168,FULL)

C       G(T9,N1169,FULL)

C       G(T9,N1170,FULL)
        CALL xC01234_(S12,MHH2,S34,XMQM2(I),XMQM2(I),XMQM2(I),C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,0)
        K(1) = -(4D0*C2(1,2))+C0
        K(2) = S13+S14+S23+S24
        K(3) = S13+S14+S23+S24-2D0*XMQM2(I)
        K(4) = -((2D0*C2(2,2))/S12)-(2D0*C2(1,1))/S34+1/(S12*S34)+
     &  (2D0*C2(1,2)*(S13+S14+S23+S24))/(S12*S34)-(C0*(S13+S14+S23+
     &  S24-2D0*XMQM2(I)))/(S12*S34)

        PRE = -((QF(1)*QF(3)*ALPHA*SA*XMQM2(I))/(12D0*PI*XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)+K(4)*PRE
        F(1,-1,1) = F(1,-1,1)+K(4)*PRE
        F(1,1,-1) = F(1,1,-1)+K(4)*PRE
        F(1,1,1) = F(1,1,1)+K(4)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(5,-1,1) = F(5,-1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(5,1,-1) = F(5,1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(5,1,1) = F(5,1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(6,-1,-1) = F(6,-1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(6,-1,1) = F(6,-1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(6,1,-1) = F(6,1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(6,1,1) = F(6,1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(7,-1,1) = F(7,-1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(7,1,-1) = F(7,1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(7,1,1) = F(7,1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(8,-1,1) = F(8,-1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(8,1,-1) = F(8,1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(8,1,1) = F(8,1,1)+(2D0*K(1)*PRE)/(S12*S34)

C       G(T9,N1171,FULL)
        CALL xC01234_(S12,MHH2,S34,XMQP2(I),XMQP2(I),XMQP2(I),C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,0)
        K(1) = -(4D0*C2(1,2))+C0
        K(2) = S13+S14+S23+S24
        K(3) = S13+S14+S23+S24-2D0*XMQP2(I)
        K(4) = -((2D0*C2(2,2))/S12)-(2D0*C2(1,1))/S34+1/(S12*S34)+
     &  (2D0*C2(1,2)*(S13+S14+S23+S24))/(S12*S34)-(C0*(S13+S14+S23+
     &  S24-2D0*XMQP2(I)))/(S12*S34)

        PRE = -((QF(1)*QF(3)*ALPHA*SA*XMQP2(I))/(3D0*PI*XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)+K(4)*PRE
        F(1,-1,1) = F(1,-1,1)+K(4)*PRE
        F(1,1,-1) = F(1,1,-1)+K(4)*PRE
        F(1,1,1) = F(1,1,1)+K(4)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(5,-1,1) = F(5,-1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(5,1,-1) = F(5,1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(5,1,1) = F(5,1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(6,-1,-1) = F(6,-1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(6,-1,1) = F(6,-1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(6,1,-1) = F(6,1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(6,1,1) = F(6,1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(7,-1,1) = F(7,-1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(7,1,-1) = F(7,1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(7,1,1) = F(7,1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(8,-1,1) = F(8,-1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(8,1,-1) = F(8,1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(8,1,1) = F(8,1,1)+(2D0*K(1)*PRE)/(S12*S34)

C       G(T9,N1172,FULL)
        CALL xC01234_(S12,MHH2,S34,XML2(I),XML2(I),XML2(I),C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,2,0)
        K(1) = -(4D0*C2(1,2))+C0
        K(2) = S13+S14+S23+S24
        K(3) = S13+S14+S23+S24-2D0*XML2(I)
        K(4) = -((2D0*C2(2,2))/S12)-(2D0*C2(1,1))/S34+1/(S12*S34)+
     &  (2D0*C2(1,2)*(S13+S14+S23+S24))/(S12*S34)-(C0*(S13+S14+S23+
     &  S24-2D0*XML2(I)))/(S12*S34)

        PRE = -((QF(1)*QF(3)*ALPHA*SA*XML2(I))/(4D0*PI*XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)+K(4)*PRE
        F(1,-1,1) = F(1,-1,1)+K(4)*PRE
        F(1,1,-1) = F(1,1,-1)+K(4)*PRE
        F(1,1,1) = F(1,1,1)+K(4)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(5,-1,1) = F(5,-1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(5,1,-1) = F(5,1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(5,1,1) = F(5,1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(6,-1,-1) = F(6,-1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(6,-1,1) = F(6,-1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(6,1,-1) = F(6,1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(6,1,1) = F(6,1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(7,-1,1) = F(7,-1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(7,1,-1) = F(7,1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(7,1,1) = F(7,1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(8,-1,1) = F(8,-1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(8,1,-1) = F(8,1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(8,1,1) = F(8,1,1)+(2D0*K(1)*PRE)/(S12*S34)

C       G(T9,N1173,FULL)
        CALL xC01234_(S12,MHH2,S34,XML2(I),XML2(I),XML2(I),C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,2,0)
        K(1) = -(4D0*C2(1,2))+C0
        K(2) = S13+S14+S23+S24
        K(3) = S13+S14+S23+S24-2D0*XML2(I)
        K(4) = -((2D0*C2(2,2))/S12)-(2D0*C2(1,1))/S34+1/(S12*S34)+
     &  (2D0*C2(1,2)*(S13+S14+S23+S24))/(S12*S34)-(C0*(S13+S14+S23+
     &  S24-2D0*XML2(I)))/(S12*S34)

        PRE = -((QF(1)*QF(3)*ALPHA*SA*XML2(I))/(4D0*PI*XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)+K(4)*PRE
        F(1,-1,1) = F(1,-1,1)+K(4)*PRE
        F(1,1,-1) = F(1,1,-1)+K(4)*PRE
        F(1,1,1) = F(1,1,1)+K(4)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(5,-1,1) = F(5,-1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(5,1,-1) = F(5,1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(5,1,1) = F(5,1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(6,-1,-1) = F(6,-1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(6,-1,1) = F(6,-1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(6,1,-1) = F(6,1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(6,1,1) = F(6,1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(7,-1,1) = F(7,-1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(7,1,-1) = F(7,1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(7,1,1) = F(7,1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(8,-1,1) = F(8,-1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(8,1,-1) = F(8,1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(8,1,1) = F(8,1,1)+(2D0*K(1)*PRE)/(S12*S34)

C       G(T9,N1174,FULL)
        CALL xC01234_(S12,MHH2,S34,XMQP2(I),XMQP2(I),XMQP2(I),C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,0)
        K(1) = -(4D0*C2(1,2))+C0
        K(2) = S13+S14+S23+S24
        K(3) = S13+S14+S23+S24-2D0*XMQP2(I)
        K(4) = -((2D0*C2(2,2))/S12)-(2D0*C2(1,1))/S34+1/(S12*S34)+
     &  (2D0*C2(1,2)*(S13+S14+S23+S24))/(S12*S34)-(C0*(S13+S14+S23+
     &  S24-2D0*XMQP2(I)))/(S12*S34)

        PRE = -((QF(1)*QF(3)*ALPHA*SA*XMQP2(I))/(3D0*PI*XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)+K(4)*PRE
        F(1,-1,1) = F(1,-1,1)+K(4)*PRE
        F(1,1,-1) = F(1,1,-1)+K(4)*PRE
        F(1,1,1) = F(1,1,1)+K(4)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(5,-1,1) = F(5,-1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(5,1,-1) = F(5,1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(5,1,1) = F(5,1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(6,-1,-1) = F(6,-1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(6,-1,1) = F(6,-1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(6,1,-1) = F(6,1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(6,1,1) = F(6,1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(7,-1,1) = F(7,-1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(7,1,-1) = F(7,1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(7,1,1) = F(7,1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(8,-1,1) = F(8,-1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(8,1,-1) = F(8,1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(8,1,1) = F(8,1,1)+(2D0*K(1)*PRE)/(S12*S34)

C       G(T9,N1175,FULL)
        CALL xC01234_(S12,MHH2,S34,XMQM2(I),XMQM2(I),XMQM2(I),C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,0)
        K(1) = -(4D0*C2(1,2))+C0
        K(2) = S13+S14+S23+S24
        K(3) = S13+S14+S23+S24-2D0*XMQM2(I)
        K(4) = -((2D0*C2(2,2))/S12)-(2D0*C2(1,1))/S34+1/(S12*S34)+
     &  (2D0*C2(1,2)*(S13+S14+S23+S24))/(S12*S34)-(C0*(S13+S14+S23+
     &  S24-2D0*XMQM2(I)))/(S12*S34)

        PRE = -((QF(1)*QF(3)*ALPHA*SA*XMQM2(I))/(12D0*PI*XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)+K(4)*PRE
        F(1,-1,1) = F(1,-1,1)+K(4)*PRE
        F(1,1,-1) = F(1,1,-1)+K(4)*PRE
        F(1,1,1) = F(1,1,1)+K(4)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(5,-1,1) = F(5,-1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(5,1,-1) = F(5,1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(5,1,1) = F(5,1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(6,-1,-1) = F(6,-1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(6,-1,1) = F(6,-1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(6,1,-1) = F(6,1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(6,1,1) = F(6,1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(7,-1,1) = F(7,-1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(7,1,-1) = F(7,1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(7,1,1) = F(7,1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(8,-1,1) = F(8,-1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(8,1,-1) = F(8,1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(8,1,1) = F(8,1,1)+(2D0*K(1)*PRE)/(S12*S34)

C       G(T9,N1176,FULL)

C       G(T9,N1177,FULL)

C       G(T9,N1178,FULL)

C       G(T9,N1179,FULL)

C       G(T9,N1184,FULL)

C       G(T9,N1185,FULL)

C       G(T9,N1186,FULL)

C       G(T9,N1187,FULL)

C       G(T9,N1188,FULL)
        CALL xC01234_(S12,MHH2,S34,XMQM2(I),XMQM2(I),XMQM2(I),C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,0)
        K(1) = 1D0+2D0*QF(3)*XSW2
        K(2) = 3D0-4D0*XSW2
        K(3) = 3D0-3D0*QEPS-4D0*XSW2
        K(4) = 3D0+3D0*QEPS-4D0*XSW2
        K(5) = -(6D0*C1(2)*QEPS)-4D0*C2(1,2)*(3D0-4D0*XSW2)+C0*(3D0-
     &  3D0*QEPS-4D0*XSW2)
        K(6) = 6D0*C1(2)*QEPS-4D0*C2(1,2)*(3D0-4D0*XSW2)+C0*(3D0+
     &  3D0*QEPS-4D0*XSW2)
        K(7) = S13+S14-S23-S24
        K(8) = S13+S14+S23+S24
        K(9) = -((6D0*C1(2)*QEPS*(S13+S14-S23-S24))/S12)-2D0*C2(1,
     &  1)*(3D0-4D0*XSW2)+(3D0-4D0*XSW2)/S12+(2D0*C2(1,2)*(S13+S14+
     &  S23+S24)*(3D0-4D0*XSW2))/S12-(2D0*C2(2,2)*S34*(3D0-4D0*
     &  XSW2))/S12+(C0*(-(3D0*S13)-3D0*QEPS*S13-3D0*S14-3D0*QEPS*
     &  S14-3D0*S23+3D0*QEPS*S23-3D0*S24+3D0*QEPS*S24+4D0*S13*XSW2+
     &  4D0*S14*XSW2+4D0*S23*XSW2+4D0*S24*XSW2+6D0*XMQM2(I)-8D0*
     &  XSW2*XMQM2(I)))/S12
        K(10) = (6D0*C1(2)*QEPS*(S13+S14-S23-S24))/S12-2D0*C2(1,1)*
     &  (3D0-4D0*XSW2)+(3D0-4D0*XSW2)/S12+(2D0*C2(1,2)*(S13+S14+S23+
     &  S24)*(3D0-4D0*XSW2))/S12-(2D0*C2(2,2)*S34*(3D0-4D0*XSW2))/
     &  S12+(C0*(-(3D0*S13)+3D0*QEPS*S13-3D0*S14+3D0*QEPS*S14-3D0*
     &  S23-3D0*QEPS*S23-3D0*S24-3D0*QEPS*S24+4D0*S13*XSW2+4D0*S14*
     &  XSW2+4D0*S23*XSW2+4D0*S24*XSW2+6D0*XMQM2(I)-8D0*XSW2*
     &  XMQM2(I)))/S12
        K(11) = -(3D0*S13)-3D0*QEPS*S13-3D0*S14-3D0*QEPS*S14-3D0*
     &  S23+3D0*QEPS*S23-3D0*S24+3D0*QEPS*S24+4D0*S13*XSW2+4D0*S14*
     &  XSW2+4D0*S23*XSW2+4D0*S24*XSW2+6D0*XMQM2(I)-8D0*XSW2*
     &  XMQM2(I)
        K(12) = -(3D0*S13)+3D0*QEPS*S13-3D0*S14+3D0*QEPS*S14-3D0*
     &  S23-3D0*QEPS*S23-3D0*S24-3D0*QEPS*S24+4D0*S13*XSW2+4D0*S14*
     &  XSW2+4D0*S23*XSW2+4D0*S24*XSW2+6D0*XMQM2(I)-8D0*XSW2*
     &  XMQM2(I)

        PRE = (QF(1)*ALPHA*PZ34*SA*XMQM2(I))/(96D0*PI*XCW2*XMW*XSW)

        F(1,-1,-1) = F(1,-1,-1)+(K(1)*K(9)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*K(9)*QF(3)*PRE
        F(1,1,-1) = F(1,1,-1)+(K(1)*K(10)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+2D0*K(10)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(1)*K(6)*PRE)/(S12*XSW2)
        F(5,-1,1) = F(5,-1,1)+(4D0*K(6)*QF(3)*PRE)/S12
        F(5,1,-1) = F(5,1,-1)+(2D0*K(1)*K(5)*PRE)/(S12*XSW2)
        F(5,1,1) = F(5,1,1)+(4D0*K(5)*QF(3)*PRE)/S12
        F(6,-1,-1) = F(6,-1,-1)+(2D0*K(1)*K(5)*PRE)/(S12*XSW2)
        F(6,-1,1) = F(6,-1,1)+(4D0*K(5)*QF(3)*PRE)/S12
        F(6,1,-1) = F(6,1,-1)+(2D0*K(1)*K(6)*PRE)/(S12*XSW2)
        F(6,1,1) = F(6,1,1)+(4D0*K(6)*QF(3)*PRE)/S12
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(1)*K(6)*PRE)/(S12*XSW2)
        F(7,-1,1) = F(7,-1,1)+(4D0*K(6)*QF(3)*PRE)/S12
        F(7,1,-1) = F(7,1,-1)+(2D0*K(1)*K(5)*PRE)/(S12*XSW2)
        F(7,1,1) = F(7,1,1)+(4D0*K(5)*QF(3)*PRE)/S12
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(1)*K(5)*PRE)/(S12*XSW2)
        F(8,-1,1) = F(8,-1,1)+(4D0*K(5)*QF(3)*PRE)/S12
        F(8,1,-1) = F(8,1,-1)+(2D0*K(1)*K(6)*PRE)/(S12*XSW2)
        F(8,1,1) = F(8,1,1)+(4D0*K(6)*QF(3)*PRE)/S12

C       G(T9,N1189,FULL)
        CALL xC01234_(S12,MHH2,S34,XMQP2(I),XMQP2(I),XMQP2(I),C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,0)
        K(1) = 1D0+2D0*QF(3)*XSW2
        K(2) = 3D0-8D0*XSW2
        K(3) = 3D0-3D0*QEPS-8D0*XSW2
        K(4) = 3D0+3D0*QEPS-8D0*XSW2
        K(5) = -(6D0*C1(2)*QEPS)-4D0*C2(1,2)*(3D0-8D0*XSW2)+C0*(3D0-
     &  3D0*QEPS-8D0*XSW2)
        K(6) = 6D0*C1(2)*QEPS-4D0*C2(1,2)*(3D0-8D0*XSW2)+C0*(3D0+
     &  3D0*QEPS-8D0*XSW2)
        K(7) = S13+S14-S23-S24
        K(8) = S13+S14+S23+S24
        K(9) = -((6D0*C1(2)*QEPS*(S13+S14-S23-S24))/S12)-2D0*C2(1,
     &  1)*(3D0-8D0*XSW2)+(3D0-8D0*XSW2)/S12+(2D0*C2(1,2)*(S13+S14+
     &  S23+S24)*(3D0-8D0*XSW2))/S12-(2D0*C2(2,2)*S34*(3D0-8D0*
     &  XSW2))/S12+(C0*(-(3D0*S13)-3D0*QEPS*S13-3D0*S14-3D0*QEPS*
     &  S14-3D0*S23+3D0*QEPS*S23-3D0*S24+3D0*QEPS*S24+8D0*S13*XSW2+
     &  8D0*S14*XSW2+8D0*S23*XSW2+8D0*S24*XSW2+6D0*XMQP2(I)-16D0*
     &  XSW2*XMQP2(I)))/S12
        K(10) = (6D0*C1(2)*QEPS*(S13+S14-S23-S24))/S12-2D0*C2(1,1)*
     &  (3D0-8D0*XSW2)+(3D0-8D0*XSW2)/S12+(2D0*C2(1,2)*(S13+S14+S23+
     &  S24)*(3D0-8D0*XSW2))/S12-(2D0*C2(2,2)*S34*(3D0-8D0*XSW2))/
     &  S12+(C0*(-(3D0*S13)+3D0*QEPS*S13-3D0*S14+3D0*QEPS*S14-3D0*
     &  S23-3D0*QEPS*S23-3D0*S24-3D0*QEPS*S24+8D0*S13*XSW2+8D0*S14*
     &  XSW2+8D0*S23*XSW2+8D0*S24*XSW2+6D0*XMQP2(I)-16D0*XSW2*
     &  XMQP2(I)))/S12
        K(11) = -(3D0*S13)-3D0*QEPS*S13-3D0*S14-3D0*QEPS*S14-3D0*
     &  S23+3D0*QEPS*S23-3D0*S24+3D0*QEPS*S24+8D0*S13*XSW2+8D0*S14*
     &  XSW2+8D0*S23*XSW2+8D0*S24*XSW2+6D0*XMQP2(I)-16D0*XSW2*
     &  XMQP2(I)
        K(12) = -(3D0*S13)+3D0*QEPS*S13-3D0*S14+3D0*QEPS*S14-3D0*
     &  S23-3D0*QEPS*S23-3D0*S24-3D0*QEPS*S24+8D0*S13*XSW2+8D0*S14*
     &  XSW2+8D0*S23*XSW2+8D0*S24*XSW2+6D0*XMQP2(I)-16D0*XSW2*
     &  XMQP2(I)

        PRE = (QF(1)*ALPHA*PZ34*SA*XMQP2(I))/(48D0*PI*XCW2*XMW*XSW)

        F(1,-1,-1) = F(1,-1,-1)+(K(1)*K(9)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*K(9)*QF(3)*PRE
        F(1,1,-1) = F(1,1,-1)+(K(1)*K(10)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+2D0*K(10)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(1)*K(6)*PRE)/(S12*XSW2)
        F(5,-1,1) = F(5,-1,1)+(4D0*K(6)*QF(3)*PRE)/S12
        F(5,1,-1) = F(5,1,-1)+(2D0*K(1)*K(5)*PRE)/(S12*XSW2)
        F(5,1,1) = F(5,1,1)+(4D0*K(5)*QF(3)*PRE)/S12
        F(6,-1,-1) = F(6,-1,-1)+(2D0*K(1)*K(5)*PRE)/(S12*XSW2)
        F(6,-1,1) = F(6,-1,1)+(4D0*K(5)*QF(3)*PRE)/S12
        F(6,1,-1) = F(6,1,-1)+(2D0*K(1)*K(6)*PRE)/(S12*XSW2)
        F(6,1,1) = F(6,1,1)+(4D0*K(6)*QF(3)*PRE)/S12
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(1)*K(6)*PRE)/(S12*XSW2)
        F(7,-1,1) = F(7,-1,1)+(4D0*K(6)*QF(3)*PRE)/S12
        F(7,1,-1) = F(7,1,-1)+(2D0*K(1)*K(5)*PRE)/(S12*XSW2)
        F(7,1,1) = F(7,1,1)+(4D0*K(5)*QF(3)*PRE)/S12
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(1)*K(5)*PRE)/(S12*XSW2)
        F(8,-1,1) = F(8,-1,1)+(4D0*K(5)*QF(3)*PRE)/S12
        F(8,1,-1) = F(8,1,-1)+(2D0*K(1)*K(6)*PRE)/(S12*XSW2)
        F(8,1,1) = F(8,1,1)+(4D0*K(6)*QF(3)*PRE)/S12

C       G(T9,N1190,FULL)
        CALL xC01234_(S12,MHH2,S34,XML2(I),XML2(I),XML2(I),C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,2,0)
        K(1) = 1D0-2D0*XSW
        K(2) = 1D0+2D0*XSW
        K(3) = 1D0+2D0*QF(3)*XSW2
        K(4) = 1D0-QEPS-4D0*XSW2
        K(5) = 1D0+QEPS-4D0*XSW2
        K(6) = -(2D0*C1(2)*QEPS)-4D0*C2(1,2)*(1D0-2D0*XSW)*(1D0+2D0*
     &  XSW)+C0*(1D0-QEPS-4D0*XSW2)
        K(7) = 2D0*C1(2)*QEPS-4D0*C2(1,2)*(1D0-2D0*XSW)*(1D0+2D0*
     &  XSW)+C0*(1D0+QEPS-4D0*XSW2)
        K(8) = S13+S14-S23-S24
        K(9) = S13+S14+S23+S24
        K(10) = -((2D0*C1(2)*QEPS*(S13+S14-S23-S24))/S12)-2D0*C2(1,
     &  1)*(1D0-2D0*XSW)*(1D0+2D0*XSW)+((1D0-2D0*XSW)*(1D0+2D0*
     &  XSW))/S12+(2D0*C2(1,2)*(S13+S14+S23+S24)*(1D0-2D0*XSW)*(1D0+
     &  2D0*XSW))/S12-(2D0*C2(2,2)*S34*(1D0-2D0*XSW)*(1D0+2D0*XSW))/
     &  S12-(C0*(S13+QEPS*S13+S14+QEPS*S14+S23-QEPS*S23+S24-QEPS*
     &  S24-4D0*S13*XSW2-4D0*S14*XSW2-4D0*S23*XSW2-4D0*S24*XSW2-2D0*
     &  XML2(I)+8D0*XSW2*XML2(I)))/S12
        K(11) = (2D0*C1(2)*QEPS*(S13+S14-S23-S24))/S12-2D0*C2(1,1)*
     &  (1D0-2D0*XSW)*(1D0+2D0*XSW)+((1D0-2D0*XSW)*(1D0+2D0*XSW))/
     &  S12+(2D0*C2(1,2)*(S13+S14+S23+S24)*(1D0-2D0*XSW)*(1D0+2D0*
     &  XSW))/S12-(2D0*C2(2,2)*S34*(1D0-2D0*XSW)*(1D0+2D0*XSW))/S12-
     &  (C0*(S13-QEPS*S13+S14-QEPS*S14+S23+QEPS*S23+S24+QEPS*S24-
     &  4D0*S13*XSW2-4D0*S14*XSW2-4D0*S23*XSW2-4D0*S24*XSW2-2D0*
     &  XML2(I)+8D0*XSW2*XML2(I)))/S12
        K(12) = S13-QEPS*S13+S14-QEPS*S14+S23+QEPS*S23+S24+QEPS*S24-
     &  4D0*S13*XSW2-4D0*S14*XSW2-4D0*S23*XSW2-4D0*S24*XSW2-2D0*
     &  XML2(I)+8D0*XSW2*XML2(I)
        K(13) = S13+QEPS*S13+S14+QEPS*S14+S23-QEPS*S23+S24-QEPS*S24-
     &  4D0*S13*XSW2-4D0*S14*XSW2-4D0*S23*XSW2-4D0*S24*XSW2-2D0*
     &  XML2(I)+8D0*XSW2*XML2(I)

        PRE = (QF(1)*ALPHA*PZ34*SA*XML2(I))/(32D0*PI*XCW2*XMW*XSW)

        F(1,-1,-1) = F(1,-1,-1)+(K(10)*K(3)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*K(10)*QF(3)*PRE
        F(1,1,-1) = F(1,1,-1)+(K(11)*K(3)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+2D0*K(11)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(3)*K(7)*PRE)/(S12*XSW2)
        F(5,-1,1) = F(5,-1,1)+(4D0*K(7)*QF(3)*PRE)/S12
        F(5,1,-1) = F(5,1,-1)+(2D0*K(3)*K(6)*PRE)/(S12*XSW2)
        F(5,1,1) = F(5,1,1)+(4D0*K(6)*QF(3)*PRE)/S12
        F(6,-1,-1) = F(6,-1,-1)+(2D0*K(3)*K(6)*PRE)/(S12*XSW2)
        F(6,-1,1) = F(6,-1,1)+(4D0*K(6)*QF(3)*PRE)/S12
        F(6,1,-1) = F(6,1,-1)+(2D0*K(3)*K(7)*PRE)/(S12*XSW2)
        F(6,1,1) = F(6,1,1)+(4D0*K(7)*QF(3)*PRE)/S12
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(3)*K(7)*PRE)/(S12*XSW2)
        F(7,-1,1) = F(7,-1,1)+(4D0*K(7)*QF(3)*PRE)/S12
        F(7,1,-1) = F(7,1,-1)+(2D0*K(3)*K(6)*PRE)/(S12*XSW2)
        F(7,1,1) = F(7,1,1)+(4D0*K(6)*QF(3)*PRE)/S12
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(3)*K(6)*PRE)/(S12*XSW2)
        F(8,-1,1) = F(8,-1,1)+(4D0*K(6)*QF(3)*PRE)/S12
        F(8,1,-1) = F(8,1,-1)+(2D0*K(3)*K(7)*PRE)/(S12*XSW2)
        F(8,1,1) = F(8,1,1)+(4D0*K(7)*QF(3)*PRE)/S12

C       G(T9,N1191,FULL)
        CALL xC01234_(S12,MHH2,S34,XML2(I),XML2(I),XML2(I),C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,2,0)
        K(1) = 1D0-2D0*XSW
        K(2) = 1D0+2D0*XSW
        K(3) = 1D0+2D0*QF(3)*XSW2
        K(4) = 1D0-QEPS-4D0*XSW2
        K(5) = 1D0+QEPS-4D0*XSW2
        K(6) = -(2D0*C1(2)*QEPS)-4D0*C2(1,2)*(1D0-2D0*XSW)*(1D0+2D0*
     &  XSW)+C0*(1D0-QEPS-4D0*XSW2)
        K(7) = 2D0*C1(2)*QEPS-4D0*C2(1,2)*(1D0-2D0*XSW)*(1D0+2D0*
     &  XSW)+C0*(1D0+QEPS-4D0*XSW2)
        K(8) = S13+S14-S23-S24
        K(9) = S13+S14+S23+S24
        K(10) = -((2D0*C1(2)*QEPS*(S13+S14-S23-S24))/S12)-2D0*C2(1,
     &  1)*(1D0-2D0*XSW)*(1D0+2D0*XSW)+((1D0-2D0*XSW)*(1D0+2D0*
     &  XSW))/S12+(2D0*C2(1,2)*(S13+S14+S23+S24)*(1D0-2D0*XSW)*(1D0+
     &  2D0*XSW))/S12-(2D0*C2(2,2)*S34*(1D0-2D0*XSW)*(1D0+2D0*XSW))/
     &  S12-(C0*(S13+QEPS*S13+S14+QEPS*S14+S23-QEPS*S23+S24-QEPS*
     &  S24-4D0*S13*XSW2-4D0*S14*XSW2-4D0*S23*XSW2-4D0*S24*XSW2-2D0*
     &  XML2(I)+8D0*XSW2*XML2(I)))/S12
        K(11) = (2D0*C1(2)*QEPS*(S13+S14-S23-S24))/S12-2D0*C2(1,1)*
     &  (1D0-2D0*XSW)*(1D0+2D0*XSW)+((1D0-2D0*XSW)*(1D0+2D0*XSW))/
     &  S12+(2D0*C2(1,2)*(S13+S14+S23+S24)*(1D0-2D0*XSW)*(1D0+2D0*
     &  XSW))/S12-(2D0*C2(2,2)*S34*(1D0-2D0*XSW)*(1D0+2D0*XSW))/S12-
     &  (C0*(S13-QEPS*S13+S14-QEPS*S14+S23+QEPS*S23+S24+QEPS*S24-
     &  4D0*S13*XSW2-4D0*S14*XSW2-4D0*S23*XSW2-4D0*S24*XSW2-2D0*
     &  XML2(I)+8D0*XSW2*XML2(I)))/S12
        K(12) = S13-QEPS*S13+S14-QEPS*S14+S23+QEPS*S23+S24+QEPS*S24-
     &  4D0*S13*XSW2-4D0*S14*XSW2-4D0*S23*XSW2-4D0*S24*XSW2-2D0*
     &  XML2(I)+8D0*XSW2*XML2(I)
        K(13) = S13+QEPS*S13+S14+QEPS*S14+S23-QEPS*S23+S24-QEPS*S24-
     &  4D0*S13*XSW2-4D0*S14*XSW2-4D0*S23*XSW2-4D0*S24*XSW2-2D0*
     &  XML2(I)+8D0*XSW2*XML2(I)

        PRE = (QF(1)*ALPHA*PZ34*SA*XML2(I))/(32D0*PI*XCW2*XMW*XSW)

        F(1,-1,-1) = F(1,-1,-1)+(K(11)*K(3)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*K(11)*QF(3)*PRE
        F(1,1,-1) = F(1,1,-1)+(K(10)*K(3)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+2D0*K(10)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(3)*K(6)*PRE)/(S12*XSW2)
        F(5,-1,1) = F(5,-1,1)+(4D0*K(6)*QF(3)*PRE)/S12
        F(5,1,-1) = F(5,1,-1)+(2D0*K(3)*K(7)*PRE)/(S12*XSW2)
        F(5,1,1) = F(5,1,1)+(4D0*K(7)*QF(3)*PRE)/S12
        F(6,-1,-1) = F(6,-1,-1)+(2D0*K(3)*K(7)*PRE)/(S12*XSW2)
        F(6,-1,1) = F(6,-1,1)+(4D0*K(7)*QF(3)*PRE)/S12
        F(6,1,-1) = F(6,1,-1)+(2D0*K(3)*K(6)*PRE)/(S12*XSW2)
        F(6,1,1) = F(6,1,1)+(4D0*K(6)*QF(3)*PRE)/S12
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(3)*K(6)*PRE)/(S12*XSW2)
        F(7,-1,1) = F(7,-1,1)+(4D0*K(6)*QF(3)*PRE)/S12
        F(7,1,-1) = F(7,1,-1)+(2D0*K(3)*K(7)*PRE)/(S12*XSW2)
        F(7,1,1) = F(7,1,1)+(4D0*K(7)*QF(3)*PRE)/S12
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(3)*K(7)*PRE)/(S12*XSW2)
        F(8,-1,1) = F(8,-1,1)+(4D0*K(7)*QF(3)*PRE)/S12
        F(8,1,-1) = F(8,1,-1)+(2D0*K(3)*K(6)*PRE)/(S12*XSW2)
        F(8,1,1) = F(8,1,1)+(4D0*K(6)*QF(3)*PRE)/S12

C       G(T9,N1192,FULL)
        CALL xC01234_(S12,MHH2,S34,XMQP2(I),XMQP2(I),XMQP2(I),C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,0)
        K(1) = 1D0+2D0*QF(3)*XSW2
        K(2) = 3D0-8D0*XSW2
        K(3) = 3D0-3D0*QEPS-8D0*XSW2
        K(4) = 3D0+3D0*QEPS-8D0*XSW2
        K(5) = -(6D0*C1(2)*QEPS)-4D0*C2(1,2)*(3D0-8D0*XSW2)+C0*(3D0-
     &  3D0*QEPS-8D0*XSW2)
        K(6) = 6D0*C1(2)*QEPS-4D0*C2(1,2)*(3D0-8D0*XSW2)+C0*(3D0+
     &  3D0*QEPS-8D0*XSW2)
        K(7) = S13+S14-S23-S24
        K(8) = S13+S14+S23+S24
        K(9) = -((6D0*C1(2)*QEPS*(S13+S14-S23-S24))/S12)-2D0*C2(1,
     &  1)*(3D0-8D0*XSW2)+(3D0-8D0*XSW2)/S12+(2D0*C2(1,2)*(S13+S14+
     &  S23+S24)*(3D0-8D0*XSW2))/S12-(2D0*C2(2,2)*S34*(3D0-8D0*
     &  XSW2))/S12+(C0*(-(3D0*S13)-3D0*QEPS*S13-3D0*S14-3D0*QEPS*
     &  S14-3D0*S23+3D0*QEPS*S23-3D0*S24+3D0*QEPS*S24+8D0*S13*XSW2+
     &  8D0*S14*XSW2+8D0*S23*XSW2+8D0*S24*XSW2+6D0*XMQP2(I)-16D0*
     &  XSW2*XMQP2(I)))/S12
        K(10) = (6D0*C1(2)*QEPS*(S13+S14-S23-S24))/S12-2D0*C2(1,1)*
     &  (3D0-8D0*XSW2)+(3D0-8D0*XSW2)/S12+(2D0*C2(1,2)*(S13+S14+S23+
     &  S24)*(3D0-8D0*XSW2))/S12-(2D0*C2(2,2)*S34*(3D0-8D0*XSW2))/
     &  S12+(C0*(-(3D0*S13)+3D0*QEPS*S13-3D0*S14+3D0*QEPS*S14-3D0*
     &  S23-3D0*QEPS*S23-3D0*S24-3D0*QEPS*S24+8D0*S13*XSW2+8D0*S14*
     &  XSW2+8D0*S23*XSW2+8D0*S24*XSW2+6D0*XMQP2(I)-16D0*XSW2*
     &  XMQP2(I)))/S12
        K(11) = -(3D0*S13)-3D0*QEPS*S13-3D0*S14-3D0*QEPS*S14-3D0*
     &  S23+3D0*QEPS*S23-3D0*S24+3D0*QEPS*S24+8D0*S13*XSW2+8D0*S14*
     &  XSW2+8D0*S23*XSW2+8D0*S24*XSW2+6D0*XMQP2(I)-16D0*XSW2*
     &  XMQP2(I)
        K(12) = -(3D0*S13)+3D0*QEPS*S13-3D0*S14+3D0*QEPS*S14-3D0*
     &  S23-3D0*QEPS*S23-3D0*S24-3D0*QEPS*S24+8D0*S13*XSW2+8D0*S14*
     &  XSW2+8D0*S23*XSW2+8D0*S24*XSW2+6D0*XMQP2(I)-16D0*XSW2*
     &  XMQP2(I)

        PRE = (QF(1)*ALPHA*PZ34*SA*XMQP2(I))/(48D0*PI*XCW2*XMW*XSW)

        F(1,-1,-1) = F(1,-1,-1)+(K(1)*K(10)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*K(10)*QF(3)*PRE
        F(1,1,-1) = F(1,1,-1)+(K(1)*K(9)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+2D0*K(9)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(1)*K(5)*PRE)/(S12*XSW2)
        F(5,-1,1) = F(5,-1,1)+(4D0*K(5)*QF(3)*PRE)/S12
        F(5,1,-1) = F(5,1,-1)+(2D0*K(1)*K(6)*PRE)/(S12*XSW2)
        F(5,1,1) = F(5,1,1)+(4D0*K(6)*QF(3)*PRE)/S12
        F(6,-1,-1) = F(6,-1,-1)+(2D0*K(1)*K(6)*PRE)/(S12*XSW2)
        F(6,-1,1) = F(6,-1,1)+(4D0*K(6)*QF(3)*PRE)/S12
        F(6,1,-1) = F(6,1,-1)+(2D0*K(1)*K(5)*PRE)/(S12*XSW2)
        F(6,1,1) = F(6,1,1)+(4D0*K(5)*QF(3)*PRE)/S12
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(1)*K(5)*PRE)/(S12*XSW2)
        F(7,-1,1) = F(7,-1,1)+(4D0*K(5)*QF(3)*PRE)/S12
        F(7,1,-1) = F(7,1,-1)+(2D0*K(1)*K(6)*PRE)/(S12*XSW2)
        F(7,1,1) = F(7,1,1)+(4D0*K(6)*QF(3)*PRE)/S12
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(1)*K(6)*PRE)/(S12*XSW2)
        F(8,-1,1) = F(8,-1,1)+(4D0*K(6)*QF(3)*PRE)/S12
        F(8,1,-1) = F(8,1,-1)+(2D0*K(1)*K(5)*PRE)/(S12*XSW2)
        F(8,1,1) = F(8,1,1)+(4D0*K(5)*QF(3)*PRE)/S12

C       G(T9,N1193,FULL)
        CALL xC01234_(S12,MHH2,S34,XMQM2(I),XMQM2(I),XMQM2(I),C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,0)
        K(1) = 1D0+2D0*QF(3)*XSW2
        K(2) = 3D0-4D0*XSW2
        K(3) = 3D0-3D0*QEPS-4D0*XSW2
        K(4) = 3D0+3D0*QEPS-4D0*XSW2
        K(5) = -(6D0*C1(2)*QEPS)-4D0*C2(1,2)*(3D0-4D0*XSW2)+C0*(3D0-
     &  3D0*QEPS-4D0*XSW2)
        K(6) = 6D0*C1(2)*QEPS-4D0*C2(1,2)*(3D0-4D0*XSW2)+C0*(3D0+
     &  3D0*QEPS-4D0*XSW2)
        K(7) = S13+S14-S23-S24
        K(8) = S13+S14+S23+S24
        K(9) = -((6D0*C1(2)*QEPS*(S13+S14-S23-S24))/S12)-2D0*C2(1,
     &  1)*(3D0-4D0*XSW2)+(3D0-4D0*XSW2)/S12+(2D0*C2(1,2)*(S13+S14+
     &  S23+S24)*(3D0-4D0*XSW2))/S12-(2D0*C2(2,2)*S34*(3D0-4D0*
     &  XSW2))/S12+(C0*(-(3D0*S13)-3D0*QEPS*S13-3D0*S14-3D0*QEPS*
     &  S14-3D0*S23+3D0*QEPS*S23-3D0*S24+3D0*QEPS*S24+4D0*S13*XSW2+
     &  4D0*S14*XSW2+4D0*S23*XSW2+4D0*S24*XSW2+6D0*XMQM2(I)-8D0*
     &  XSW2*XMQM2(I)))/S12
        K(10) = (6D0*C1(2)*QEPS*(S13+S14-S23-S24))/S12-2D0*C2(1,1)*
     &  (3D0-4D0*XSW2)+(3D0-4D0*XSW2)/S12+(2D0*C2(1,2)*(S13+S14+S23+
     &  S24)*(3D0-4D0*XSW2))/S12-(2D0*C2(2,2)*S34*(3D0-4D0*XSW2))/
     &  S12+(C0*(-(3D0*S13)+3D0*QEPS*S13-3D0*S14+3D0*QEPS*S14-3D0*
     &  S23-3D0*QEPS*S23-3D0*S24-3D0*QEPS*S24+4D0*S13*XSW2+4D0*S14*
     &  XSW2+4D0*S23*XSW2+4D0*S24*XSW2+6D0*XMQM2(I)-8D0*XSW2*
     &  XMQM2(I)))/S12
        K(11) = -(3D0*S13)-3D0*QEPS*S13-3D0*S14-3D0*QEPS*S14-3D0*
     &  S23+3D0*QEPS*S23-3D0*S24+3D0*QEPS*S24+4D0*S13*XSW2+4D0*S14*
     &  XSW2+4D0*S23*XSW2+4D0*S24*XSW2+6D0*XMQM2(I)-8D0*XSW2*
     &  XMQM2(I)
        K(12) = -(3D0*S13)+3D0*QEPS*S13-3D0*S14+3D0*QEPS*S14-3D0*
     &  S23-3D0*QEPS*S23-3D0*S24-3D0*QEPS*S24+4D0*S13*XSW2+4D0*S14*
     &  XSW2+4D0*S23*XSW2+4D0*S24*XSW2+6D0*XMQM2(I)-8D0*XSW2*
     &  XMQM2(I)

        PRE = (QF(1)*ALPHA*PZ34*SA*XMQM2(I))/(96D0*PI*XCW2*XMW*XSW)

        F(1,-1,-1) = F(1,-1,-1)+(K(1)*K(10)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*K(10)*QF(3)*PRE
        F(1,1,-1) = F(1,1,-1)+(K(1)*K(9)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+2D0*K(9)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(1)*K(5)*PRE)/(S12*XSW2)
        F(5,-1,1) = F(5,-1,1)+(4D0*K(5)*QF(3)*PRE)/S12
        F(5,1,-1) = F(5,1,-1)+(2D0*K(1)*K(6)*PRE)/(S12*XSW2)
        F(5,1,1) = F(5,1,1)+(4D0*K(6)*QF(3)*PRE)/S12
        F(6,-1,-1) = F(6,-1,-1)+(2D0*K(1)*K(6)*PRE)/(S12*XSW2)
        F(6,-1,1) = F(6,-1,1)+(4D0*K(6)*QF(3)*PRE)/S12
        F(6,1,-1) = F(6,1,-1)+(2D0*K(1)*K(5)*PRE)/(S12*XSW2)
        F(6,1,1) = F(6,1,1)+(4D0*K(5)*QF(3)*PRE)/S12
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(1)*K(5)*PRE)/(S12*XSW2)
        F(7,-1,1) = F(7,-1,1)+(4D0*K(5)*QF(3)*PRE)/S12
        F(7,1,-1) = F(7,1,-1)+(2D0*K(1)*K(6)*PRE)/(S12*XSW2)
        F(7,1,1) = F(7,1,1)+(4D0*K(6)*QF(3)*PRE)/S12
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(1)*K(6)*PRE)/(S12*XSW2)
        F(8,-1,1) = F(8,-1,1)+(4D0*K(6)*QF(3)*PRE)/S12
        F(8,1,-1) = F(8,1,-1)+(2D0*K(1)*K(5)*PRE)/(S12*XSW2)
        F(8,1,1) = F(8,1,1)+(4D0*K(5)*QF(3)*PRE)/S12

C       G(T9,N1194,FULL)

C       G(T9,N1195,FULL)

C       G(T9,N1196,FULL)

C       G(T9,N1197,FULL)

C       G(T9,N1202,FULL)

C       G(T9,N1203,FULL)

C       G(T9,N1204,FULL)

C       G(T9,N1205,FULL)

C       G(T9,N1206,FULL)

C       G(T9,N1207,FULL)

C       G(T9,N1208,FULL)

C       G(T9,N1209,FULL)

C       G(T9,N1210,FULL)

C       G(T9,N1211,FULL)

C       G(T9,N1212,FULL)

C       G(T9,N1213,FULL)

C       G(T9,N1214,FULL)

C       G(T9,N1215,FULL)

C       G(T9,N1220,FULL)

C       G(T9,N1221,FULL)

C       G(T9,N1222,FULL)

C       G(T9,N1223,FULL)

C       G(T9,N1224,FULL)

C       G(T9,N1225,FULL)

C       G(T9,N1226,FULL)

C       G(T9,N1227,FULL)

C       G(T9,N1228,FULL)

C       G(T9,N1229,FULL)

C       G(T9,N1230,FULL)

C       G(T9,N1231,FULL)

C       G(T9,N1232,FULL)

C       G(T9,N1233,FULL)

C       G(T9,N1246,FULL)

C       G(T9,N1247,FULL)

C       G(T9,N1248,FULL)

C       G(T9,N1249,FULL)

C       G(T9,N1250,FULL)

C       G(T9,N1251,FULL)

C       G(T9,N1252,FULL)

C       G(T9,N1253,FULL)

C       G(T9,N1254,FULL)

C       G(T9,N1255,FULL)

C       G(T9,N1256,FULL)

C       G(T9,N1257,FULL)

C       G(T9,N1258,FULL)

C       G(T9,N1259,FULL)

C       G(T9,N1264,FULL)

C       G(T9,N1265,FULL)

C       G(T9,N1266,FULL)

C       G(T9,N1267,FULL)

C       G(T9,N1268,FULL)
        CALL xC01234_(S12,MHH2,S34,XMQM2(I),XMQM2(I),XMQM2(I),C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 3D0-4D0*XSW2
        K(3) = 3D0-3D0*QEPS-4D0*XSW2
        K(4) = 3D0+3D0*QEPS-4D0*XSW2
        K(5) = -(6D0*C1(1)*QEPS)-4D0*C2(1,2)*(3D0-4D0*XSW2)+C0*(3D0-
     &  3D0*QEPS-4D0*XSW2)
        K(6) = 6D0*C1(1)*QEPS-4D0*C2(1,2)*(3D0-4D0*XSW2)+C0*(3D0+
     &  3D0*QEPS-4D0*XSW2)
        K(7) = S13+S14-S23-S24
        K(8) = S13+S14+S23+S24
        K(9) = -((6D0*C1(1)*QEPS*(S13+S14-S23-S24))/S34)-2D0*C2(2,
     &  2)*(3D0-4D0*XSW2)+(3D0-4D0*XSW2)/S34-(2D0*C2(1,1)*S12*(3D0-
     &  4D0*XSW2))/S34+(2D0*C2(1,2)*(S13+S14+S23+S24)*(3D0-4D0*
     &  XSW2))/S34+(C0*(-(3D0*S13)-3D0*QEPS*S13-3D0*S14-3D0*QEPS*
     &  S14-3D0*S23+3D0*QEPS*S23-3D0*S24+3D0*QEPS*S24+4D0*S13*XSW2+
     &  4D0*S14*XSW2+4D0*S23*XSW2+4D0*S24*XSW2+6D0*XMQM2(I)-8D0*
     &  XSW2*XMQM2(I)))/S34
        K(10) = (6D0*C1(1)*QEPS*(S13+S14-S23-S24))/S34-2D0*C2(2,2)*
     &  (3D0-4D0*XSW2)+(3D0-4D0*XSW2)/S34-(2D0*C2(1,1)*S12*(3D0-4D0*
     &  XSW2))/S34+(2D0*C2(1,2)*(S13+S14+S23+S24)*(3D0-4D0*XSW2))/
     &  S34+(C0*(-(3D0*S13)+3D0*QEPS*S13-3D0*S14+3D0*QEPS*S14-3D0*
     &  S23-3D0*QEPS*S23-3D0*S24-3D0*QEPS*S24+4D0*S13*XSW2+4D0*S14*
     &  XSW2+4D0*S23*XSW2+4D0*S24*XSW2+6D0*XMQM2(I)-8D0*XSW2*
     &  XMQM2(I)))/S34
        K(11) = -(3D0*S13)-3D0*QEPS*S13-3D0*S14-3D0*QEPS*S14-3D0*
     &  S23+3D0*QEPS*S23-3D0*S24+3D0*QEPS*S24+4D0*S13*XSW2+4D0*S14*
     &  XSW2+4D0*S23*XSW2+4D0*S24*XSW2+6D0*XMQM2(I)-8D0*XSW2*
     &  XMQM2(I)
        K(12) = -(3D0*S13)+3D0*QEPS*S13-3D0*S14+3D0*QEPS*S14-3D0*
     &  S23-3D0*QEPS*S23-3D0*S24-3D0*QEPS*S24+4D0*S13*XSW2+4D0*S14*
     &  XSW2+4D0*S23*XSW2+4D0*S24*XSW2+6D0*XMQM2(I)-8D0*XSW2*
     &  XMQM2(I)

        PRE = (QF(3)*ALPHA*PZ12*SA*XMQM2(I))/(96D0*PI*XCW2*XMW*XSW)

        F(1,-1,-1) = F(1,-1,-1)-(K(1)*K(10)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)-(K(1)*K(10)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*K(9)*QF(1)*PRE
        F(1,1,1) = F(1,1,1)+2D0*K(9)*QF(1)*PRE
        F(5,-1,-1) = F(5,-1,-1)-(2D0*K(1)*K(5)*PRE)/(S34*XSW2)
        F(5,-1,1) = F(5,-1,1)-(2D0*K(1)*K(5)*PRE)/(S34*XSW2)
        F(5,1,-1) = F(5,1,-1)+(4D0*K(6)*QF(1)*PRE)/S34
        F(5,1,1) = F(5,1,1)+(4D0*K(6)*QF(1)*PRE)/S34
        F(6,-1,-1) = F(6,-1,-1)-(2D0*K(1)*K(6)*PRE)/(S34*XSW2)
        F(6,-1,1) = F(6,-1,1)-(2D0*K(1)*K(6)*PRE)/(S34*XSW2)
        F(6,1,-1) = F(6,1,-1)+(4D0*K(5)*QF(1)*PRE)/S34
        F(6,1,1) = F(6,1,1)+(4D0*K(5)*QF(1)*PRE)/S34
        F(7,-1,-1) = F(7,-1,-1)-(2D0*K(1)*K(5)*PRE)/(S34*XSW2)
        F(7,-1,1) = F(7,-1,1)-(2D0*K(1)*K(5)*PRE)/(S34*XSW2)
        F(7,1,-1) = F(7,1,-1)+(4D0*K(6)*QF(1)*PRE)/S34
        F(7,1,1) = F(7,1,1)+(4D0*K(6)*QF(1)*PRE)/S34
        F(8,-1,-1) = F(8,-1,-1)-(2D0*K(1)*K(6)*PRE)/(S34*XSW2)
        F(8,-1,1) = F(8,-1,1)-(2D0*K(1)*K(6)*PRE)/(S34*XSW2)
        F(8,1,-1) = F(8,1,-1)+(4D0*K(5)*QF(1)*PRE)/S34
        F(8,1,1) = F(8,1,1)+(4D0*K(5)*QF(1)*PRE)/S34

C       G(T9,N1269,FULL)
        CALL xC01234_(S12,MHH2,S34,XMQP2(I),XMQP2(I),XMQP2(I),C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 3D0-8D0*XSW2
        K(3) = 3D0-3D0*QEPS-8D0*XSW2
        K(4) = 3D0+3D0*QEPS-8D0*XSW2
        K(5) = -(6D0*C1(1)*QEPS)-4D0*C2(1,2)*(3D0-8D0*XSW2)+C0*(3D0-
     &  3D0*QEPS-8D0*XSW2)
        K(6) = 6D0*C1(1)*QEPS-4D0*C2(1,2)*(3D0-8D0*XSW2)+C0*(3D0+
     &  3D0*QEPS-8D0*XSW2)
        K(7) = S13+S14-S23-S24
        K(8) = S13+S14+S23+S24
        K(9) = -((6D0*C1(1)*QEPS*(S13+S14-S23-S24))/S34)-2D0*C2(2,
     &  2)*(3D0-8D0*XSW2)+(3D0-8D0*XSW2)/S34-(2D0*C2(1,1)*S12*(3D0-
     &  8D0*XSW2))/S34+(2D0*C2(1,2)*(S13+S14+S23+S24)*(3D0-8D0*
     &  XSW2))/S34+(C0*(-(3D0*S13)-3D0*QEPS*S13-3D0*S14-3D0*QEPS*
     &  S14-3D0*S23+3D0*QEPS*S23-3D0*S24+3D0*QEPS*S24+8D0*S13*XSW2+
     &  8D0*S14*XSW2+8D0*S23*XSW2+8D0*S24*XSW2+6D0*XMQP2(I)-16D0*
     &  XSW2*XMQP2(I)))/S34
        K(10) = (6D0*C1(1)*QEPS*(S13+S14-S23-S24))/S34-2D0*C2(2,2)*
     &  (3D0-8D0*XSW2)+(3D0-8D0*XSW2)/S34-(2D0*C2(1,1)*S12*(3D0-8D0*
     &  XSW2))/S34+(2D0*C2(1,2)*(S13+S14+S23+S24)*(3D0-8D0*XSW2))/
     &  S34+(C0*(-(3D0*S13)+3D0*QEPS*S13-3D0*S14+3D0*QEPS*S14-3D0*
     &  S23-3D0*QEPS*S23-3D0*S24-3D0*QEPS*S24+8D0*S13*XSW2+8D0*S14*
     &  XSW2+8D0*S23*XSW2+8D0*S24*XSW2+6D0*XMQP2(I)-16D0*XSW2*
     &  XMQP2(I)))/S34
        K(11) = -(3D0*S13)-3D0*QEPS*S13-3D0*S14-3D0*QEPS*S14-3D0*
     &  S23+3D0*QEPS*S23-3D0*S24+3D0*QEPS*S24+8D0*S13*XSW2+8D0*S14*
     &  XSW2+8D0*S23*XSW2+8D0*S24*XSW2+6D0*XMQP2(I)-16D0*XSW2*
     &  XMQP2(I)
        K(12) = -(3D0*S13)+3D0*QEPS*S13-3D0*S14+3D0*QEPS*S14-3D0*
     &  S23-3D0*QEPS*S23-3D0*S24-3D0*QEPS*S24+8D0*S13*XSW2+8D0*S14*
     &  XSW2+8D0*S23*XSW2+8D0*S24*XSW2+6D0*XMQP2(I)-16D0*XSW2*
     &  XMQP2(I)

        PRE = (QF(3)*ALPHA*PZ12*SA*XMQP2(I))/(48D0*PI*XCW2*XMW*XSW)

        F(1,-1,-1) = F(1,-1,-1)-(K(1)*K(10)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)-(K(1)*K(10)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*K(9)*QF(1)*PRE
        F(1,1,1) = F(1,1,1)+2D0*K(9)*QF(1)*PRE
        F(5,-1,-1) = F(5,-1,-1)-(2D0*K(1)*K(5)*PRE)/(S34*XSW2)
        F(5,-1,1) = F(5,-1,1)-(2D0*K(1)*K(5)*PRE)/(S34*XSW2)
        F(5,1,-1) = F(5,1,-1)+(4D0*K(6)*QF(1)*PRE)/S34
        F(5,1,1) = F(5,1,1)+(4D0*K(6)*QF(1)*PRE)/S34
        F(6,-1,-1) = F(6,-1,-1)-(2D0*K(1)*K(6)*PRE)/(S34*XSW2)
        F(6,-1,1) = F(6,-1,1)-(2D0*K(1)*K(6)*PRE)/(S34*XSW2)
        F(6,1,-1) = F(6,1,-1)+(4D0*K(5)*QF(1)*PRE)/S34
        F(6,1,1) = F(6,1,1)+(4D0*K(5)*QF(1)*PRE)/S34
        F(7,-1,-1) = F(7,-1,-1)-(2D0*K(1)*K(5)*PRE)/(S34*XSW2)
        F(7,-1,1) = F(7,-1,1)-(2D0*K(1)*K(5)*PRE)/(S34*XSW2)
        F(7,1,-1) = F(7,1,-1)+(4D0*K(6)*QF(1)*PRE)/S34
        F(7,1,1) = F(7,1,1)+(4D0*K(6)*QF(1)*PRE)/S34
        F(8,-1,-1) = F(8,-1,-1)-(2D0*K(1)*K(6)*PRE)/(S34*XSW2)
        F(8,-1,1) = F(8,-1,1)-(2D0*K(1)*K(6)*PRE)/(S34*XSW2)
        F(8,1,-1) = F(8,1,-1)+(4D0*K(5)*QF(1)*PRE)/S34
        F(8,1,1) = F(8,1,1)+(4D0*K(5)*QF(1)*PRE)/S34

C       G(T9,N1270,FULL)
        CALL xC01234_(S12,MHH2,S34,XML2(I),XML2(I),XML2(I),C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,2,0)
        K(1) = 1D0-2D0*XSW
        K(2) = 1D0+2D0*XSW
        K(3) = 1D0-2D0*QF(1)*XSW2
        K(4) = 1D0-QEPS-4D0*XSW2
        K(5) = 1D0+QEPS-4D0*XSW2
        K(6) = -(2D0*C1(1)*QEPS)-4D0*C2(1,2)*(1D0-2D0*XSW)*(1D0+2D0*
     &  XSW)+C0*(1D0-QEPS-4D0*XSW2)
        K(7) = 2D0*C1(1)*QEPS-4D0*C2(1,2)*(1D0-2D0*XSW)*(1D0+2D0*
     &  XSW)+C0*(1D0+QEPS-4D0*XSW2)
        K(8) = S13+S14-S23-S24
        K(9) = S13+S14+S23+S24
        K(10) = -((2D0*C1(1)*QEPS*(S13+S14-S23-S24))/S34)-2D0*C2(2,
     &  2)*(1D0-2D0*XSW)*(1D0+2D0*XSW)+((1D0-2D0*XSW)*(1D0+2D0*
     &  XSW))/S34-(2D0*C2(1,1)*S12*(1D0-2D0*XSW)*(1D0+2D0*XSW))/S34+
     &  (2D0*C2(1,2)*(S13+S14+S23+S24)*(1D0-2D0*XSW)*(1D0+2D0*XSW))/
     &  S34-(C0*(S13+QEPS*S13+S14+QEPS*S14+S23-QEPS*S23+S24-QEPS*
     &  S24-4D0*S13*XSW2-4D0*S14*XSW2-4D0*S23*XSW2-4D0*S24*XSW2-2D0*
     &  XML2(I)+8D0*XSW2*XML2(I)))/S34
        K(11) = (2D0*C1(1)*QEPS*(S13+S14-S23-S24))/S34-2D0*C2(2,2)*
     &  (1D0-2D0*XSW)*(1D0+2D0*XSW)+((1D0-2D0*XSW)*(1D0+2D0*XSW))/
     &  S34-(2D0*C2(1,1)*S12*(1D0-2D0*XSW)*(1D0+2D0*XSW))/S34+(2D0*
     &  C2(1,2)*(S13+S14+S23+S24)*(1D0-2D0*XSW)*(1D0+2D0*XSW))/S34-
     &  (C0*(S13-QEPS*S13+S14-QEPS*S14+S23+QEPS*S23+S24+QEPS*S24-
     &  4D0*S13*XSW2-4D0*S14*XSW2-4D0*S23*XSW2-4D0*S24*XSW2-2D0*
     &  XML2(I)+8D0*XSW2*XML2(I)))/S34
        K(12) = S13-QEPS*S13+S14-QEPS*S14+S23+QEPS*S23+S24+QEPS*S24-
     &  4D0*S13*XSW2-4D0*S14*XSW2-4D0*S23*XSW2-4D0*S24*XSW2-2D0*
     &  XML2(I)+8D0*XSW2*XML2(I)
        K(13) = S13+QEPS*S13+S14+QEPS*S14+S23-QEPS*S23+S24-QEPS*S24-
     &  4D0*S13*XSW2-4D0*S14*XSW2-4D0*S23*XSW2-4D0*S24*XSW2-2D0*
     &  XML2(I)+8D0*XSW2*XML2(I)

        PRE = (QF(3)*ALPHA*PZ12*SA*XML2(I))/(32D0*PI*XCW2*XMW*XSW)

        F(1,-1,-1) = F(1,-1,-1)-(K(11)*K(3)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)-(K(11)*K(3)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*K(10)*QF(1)*PRE
        F(1,1,1) = F(1,1,1)+2D0*K(10)*QF(1)*PRE
        F(5,-1,-1) = F(5,-1,-1)-(2D0*K(3)*K(6)*PRE)/(S34*XSW2)
        F(5,-1,1) = F(5,-1,1)-(2D0*K(3)*K(6)*PRE)/(S34*XSW2)
        F(5,1,-1) = F(5,1,-1)+(4D0*K(7)*QF(1)*PRE)/S34
        F(5,1,1) = F(5,1,1)+(4D0*K(7)*QF(1)*PRE)/S34
        F(6,-1,-1) = F(6,-1,-1)-(2D0*K(3)*K(7)*PRE)/(S34*XSW2)
        F(6,-1,1) = F(6,-1,1)-(2D0*K(3)*K(7)*PRE)/(S34*XSW2)
        F(6,1,-1) = F(6,1,-1)+(4D0*K(6)*QF(1)*PRE)/S34
        F(6,1,1) = F(6,1,1)+(4D0*K(6)*QF(1)*PRE)/S34
        F(7,-1,-1) = F(7,-1,-1)-(2D0*K(3)*K(6)*PRE)/(S34*XSW2)
        F(7,-1,1) = F(7,-1,1)-(2D0*K(3)*K(6)*PRE)/(S34*XSW2)
        F(7,1,-1) = F(7,1,-1)+(4D0*K(7)*QF(1)*PRE)/S34
        F(7,1,1) = F(7,1,1)+(4D0*K(7)*QF(1)*PRE)/S34
        F(8,-1,-1) = F(8,-1,-1)-(2D0*K(3)*K(7)*PRE)/(S34*XSW2)
        F(8,-1,1) = F(8,-1,1)-(2D0*K(3)*K(7)*PRE)/(S34*XSW2)
        F(8,1,-1) = F(8,1,-1)+(4D0*K(6)*QF(1)*PRE)/S34
        F(8,1,1) = F(8,1,1)+(4D0*K(6)*QF(1)*PRE)/S34

C       G(T9,N1271,FULL)
        CALL xC01234_(S12,MHH2,S34,XML2(I),XML2(I),XML2(I),C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,2,0)
        K(1) = 1D0-2D0*XSW
        K(2) = 1D0+2D0*XSW
        K(3) = 1D0-2D0*QF(1)*XSW2
        K(4) = 1D0-QEPS-4D0*XSW2
        K(5) = 1D0+QEPS-4D0*XSW2
        K(6) = -(2D0*C1(1)*QEPS)-4D0*C2(1,2)*(1D0-2D0*XSW)*(1D0+2D0*
     &  XSW)+C0*(1D0-QEPS-4D0*XSW2)
        K(7) = 2D0*C1(1)*QEPS-4D0*C2(1,2)*(1D0-2D0*XSW)*(1D0+2D0*
     &  XSW)+C0*(1D0+QEPS-4D0*XSW2)
        K(8) = S13+S14-S23-S24
        K(9) = S13+S14+S23+S24
        K(10) = -((2D0*C1(1)*QEPS*(S13+S14-S23-S24))/S34)-2D0*C2(2,
     &  2)*(1D0-2D0*XSW)*(1D0+2D0*XSW)+((1D0-2D0*XSW)*(1D0+2D0*
     &  XSW))/S34-(2D0*C2(1,1)*S12*(1D0-2D0*XSW)*(1D0+2D0*XSW))/S34+
     &  (2D0*C2(1,2)*(S13+S14+S23+S24)*(1D0-2D0*XSW)*(1D0+2D0*XSW))/
     &  S34-(C0*(S13+QEPS*S13+S14+QEPS*S14+S23-QEPS*S23+S24-QEPS*
     &  S24-4D0*S13*XSW2-4D0*S14*XSW2-4D0*S23*XSW2-4D0*S24*XSW2-2D0*
     &  XML2(I)+8D0*XSW2*XML2(I)))/S34
        K(11) = (2D0*C1(1)*QEPS*(S13+S14-S23-S24))/S34-2D0*C2(2,2)*
     &  (1D0-2D0*XSW)*(1D0+2D0*XSW)+((1D0-2D0*XSW)*(1D0+2D0*XSW))/
     &  S34-(2D0*C2(1,1)*S12*(1D0-2D0*XSW)*(1D0+2D0*XSW))/S34+(2D0*
     &  C2(1,2)*(S13+S14+S23+S24)*(1D0-2D0*XSW)*(1D0+2D0*XSW))/S34-
     &  (C0*(S13-QEPS*S13+S14-QEPS*S14+S23+QEPS*S23+S24+QEPS*S24-
     &  4D0*S13*XSW2-4D0*S14*XSW2-4D0*S23*XSW2-4D0*S24*XSW2-2D0*
     &  XML2(I)+8D0*XSW2*XML2(I)))/S34
        K(12) = S13-QEPS*S13+S14-QEPS*S14+S23+QEPS*S23+S24+QEPS*S24-
     &  4D0*S13*XSW2-4D0*S14*XSW2-4D0*S23*XSW2-4D0*S24*XSW2-2D0*
     &  XML2(I)+8D0*XSW2*XML2(I)
        K(13) = S13+QEPS*S13+S14+QEPS*S14+S23-QEPS*S23+S24-QEPS*S24-
     &  4D0*S13*XSW2-4D0*S14*XSW2-4D0*S23*XSW2-4D0*S24*XSW2-2D0*
     &  XML2(I)+8D0*XSW2*XML2(I)

        PRE = (QF(3)*ALPHA*PZ12*SA*XML2(I))/(32D0*PI*XCW2*XMW*XSW)

        F(1,-1,-1) = F(1,-1,-1)-(K(10)*K(3)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)-(K(10)*K(3)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*K(11)*QF(1)*PRE
        F(1,1,1) = F(1,1,1)+2D0*K(11)*QF(1)*PRE
        F(5,-1,-1) = F(5,-1,-1)-(2D0*K(3)*K(7)*PRE)/(S34*XSW2)
        F(5,-1,1) = F(5,-1,1)-(2D0*K(3)*K(7)*PRE)/(S34*XSW2)
        F(5,1,-1) = F(5,1,-1)+(4D0*K(6)*QF(1)*PRE)/S34
        F(5,1,1) = F(5,1,1)+(4D0*K(6)*QF(1)*PRE)/S34
        F(6,-1,-1) = F(6,-1,-1)-(2D0*K(3)*K(6)*PRE)/(S34*XSW2)
        F(6,-1,1) = F(6,-1,1)-(2D0*K(3)*K(6)*PRE)/(S34*XSW2)
        F(6,1,-1) = F(6,1,-1)+(4D0*K(7)*QF(1)*PRE)/S34
        F(6,1,1) = F(6,1,1)+(4D0*K(7)*QF(1)*PRE)/S34
        F(7,-1,-1) = F(7,-1,-1)-(2D0*K(3)*K(7)*PRE)/(S34*XSW2)
        F(7,-1,1) = F(7,-1,1)-(2D0*K(3)*K(7)*PRE)/(S34*XSW2)
        F(7,1,-1) = F(7,1,-1)+(4D0*K(6)*QF(1)*PRE)/S34
        F(7,1,1) = F(7,1,1)+(4D0*K(6)*QF(1)*PRE)/S34
        F(8,-1,-1) = F(8,-1,-1)-(2D0*K(3)*K(6)*PRE)/(S34*XSW2)
        F(8,-1,1) = F(8,-1,1)-(2D0*K(3)*K(6)*PRE)/(S34*XSW2)
        F(8,1,-1) = F(8,1,-1)+(4D0*K(7)*QF(1)*PRE)/S34
        F(8,1,1) = F(8,1,1)+(4D0*K(7)*QF(1)*PRE)/S34

C       G(T9,N1272,FULL)
        CALL xC01234_(S12,MHH2,S34,XMQP2(I),XMQP2(I),XMQP2(I),C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 3D0-8D0*XSW2
        K(3) = 3D0-3D0*QEPS-8D0*XSW2
        K(4) = 3D0+3D0*QEPS-8D0*XSW2
        K(5) = -(6D0*C1(1)*QEPS)-4D0*C2(1,2)*(3D0-8D0*XSW2)+C0*(3D0-
     &  3D0*QEPS-8D0*XSW2)
        K(6) = 6D0*C1(1)*QEPS-4D0*C2(1,2)*(3D0-8D0*XSW2)+C0*(3D0+
     &  3D0*QEPS-8D0*XSW2)
        K(7) = S13+S14-S23-S24
        K(8) = S13+S14+S23+S24
        K(9) = -((6D0*C1(1)*QEPS*(S13+S14-S23-S24))/S34)-2D0*C2(2,
     &  2)*(3D0-8D0*XSW2)+(3D0-8D0*XSW2)/S34-(2D0*C2(1,1)*S12*(3D0-
     &  8D0*XSW2))/S34+(2D0*C2(1,2)*(S13+S14+S23+S24)*(3D0-8D0*
     &  XSW2))/S34+(C0*(-(3D0*S13)-3D0*QEPS*S13-3D0*S14-3D0*QEPS*
     &  S14-3D0*S23+3D0*QEPS*S23-3D0*S24+3D0*QEPS*S24+8D0*S13*XSW2+
     &  8D0*S14*XSW2+8D0*S23*XSW2+8D0*S24*XSW2+6D0*XMQP2(I)-16D0*
     &  XSW2*XMQP2(I)))/S34
        K(10) = (6D0*C1(1)*QEPS*(S13+S14-S23-S24))/S34-2D0*C2(2,2)*
     &  (3D0-8D0*XSW2)+(3D0-8D0*XSW2)/S34-(2D0*C2(1,1)*S12*(3D0-8D0*
     &  XSW2))/S34+(2D0*C2(1,2)*(S13+S14+S23+S24)*(3D0-8D0*XSW2))/
     &  S34+(C0*(-(3D0*S13)+3D0*QEPS*S13-3D0*S14+3D0*QEPS*S14-3D0*
     &  S23-3D0*QEPS*S23-3D0*S24-3D0*QEPS*S24+8D0*S13*XSW2+8D0*S14*
     &  XSW2+8D0*S23*XSW2+8D0*S24*XSW2+6D0*XMQP2(I)-16D0*XSW2*
     &  XMQP2(I)))/S34
        K(11) = -(3D0*S13)-3D0*QEPS*S13-3D0*S14-3D0*QEPS*S14-3D0*
     &  S23+3D0*QEPS*S23-3D0*S24+3D0*QEPS*S24+8D0*S13*XSW2+8D0*S14*
     &  XSW2+8D0*S23*XSW2+8D0*S24*XSW2+6D0*XMQP2(I)-16D0*XSW2*
     &  XMQP2(I)
        K(12) = -(3D0*S13)+3D0*QEPS*S13-3D0*S14+3D0*QEPS*S14-3D0*
     &  S23-3D0*QEPS*S23-3D0*S24-3D0*QEPS*S24+8D0*S13*XSW2+8D0*S14*
     &  XSW2+8D0*S23*XSW2+8D0*S24*XSW2+6D0*XMQP2(I)-16D0*XSW2*
     &  XMQP2(I)

        PRE = (QF(3)*ALPHA*PZ12*SA*XMQP2(I))/(48D0*PI*XCW2*XMW*XSW)

        F(1,-1,-1) = F(1,-1,-1)-(K(1)*K(9)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)-(K(1)*K(9)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*K(10)*QF(1)*PRE
        F(1,1,1) = F(1,1,1)+2D0*K(10)*QF(1)*PRE
        F(5,-1,-1) = F(5,-1,-1)-(2D0*K(1)*K(6)*PRE)/(S34*XSW2)
        F(5,-1,1) = F(5,-1,1)-(2D0*K(1)*K(6)*PRE)/(S34*XSW2)
        F(5,1,-1) = F(5,1,-1)+(4D0*K(5)*QF(1)*PRE)/S34
        F(5,1,1) = F(5,1,1)+(4D0*K(5)*QF(1)*PRE)/S34
        F(6,-1,-1) = F(6,-1,-1)-(2D0*K(1)*K(5)*PRE)/(S34*XSW2)
        F(6,-1,1) = F(6,-1,1)-(2D0*K(1)*K(5)*PRE)/(S34*XSW2)
        F(6,1,-1) = F(6,1,-1)+(4D0*K(6)*QF(1)*PRE)/S34
        F(6,1,1) = F(6,1,1)+(4D0*K(6)*QF(1)*PRE)/S34
        F(7,-1,-1) = F(7,-1,-1)-(2D0*K(1)*K(6)*PRE)/(S34*XSW2)
        F(7,-1,1) = F(7,-1,1)-(2D0*K(1)*K(6)*PRE)/(S34*XSW2)
        F(7,1,-1) = F(7,1,-1)+(4D0*K(5)*QF(1)*PRE)/S34
        F(7,1,1) = F(7,1,1)+(4D0*K(5)*QF(1)*PRE)/S34
        F(8,-1,-1) = F(8,-1,-1)-(2D0*K(1)*K(5)*PRE)/(S34*XSW2)
        F(8,-1,1) = F(8,-1,1)-(2D0*K(1)*K(5)*PRE)/(S34*XSW2)
        F(8,1,-1) = F(8,1,-1)+(4D0*K(6)*QF(1)*PRE)/S34
        F(8,1,1) = F(8,1,1)+(4D0*K(6)*QF(1)*PRE)/S34

C       G(T9,N1273,FULL)
        CALL xC01234_(S12,MHH2,S34,XMQM2(I),XMQM2(I),XMQM2(I),C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 3D0-4D0*XSW2
        K(3) = 3D0-3D0*QEPS-4D0*XSW2
        K(4) = 3D0+3D0*QEPS-4D0*XSW2
        K(5) = -(6D0*C1(1)*QEPS)-4D0*C2(1,2)*(3D0-4D0*XSW2)+C0*(3D0-
     &  3D0*QEPS-4D0*XSW2)
        K(6) = 6D0*C1(1)*QEPS-4D0*C2(1,2)*(3D0-4D0*XSW2)+C0*(3D0+
     &  3D0*QEPS-4D0*XSW2)
        K(7) = S13+S14-S23-S24
        K(8) = S13+S14+S23+S24
        K(9) = -((6D0*C1(1)*QEPS*(S13+S14-S23-S24))/S34)-2D0*C2(2,
     &  2)*(3D0-4D0*XSW2)+(3D0-4D0*XSW2)/S34-(2D0*C2(1,1)*S12*(3D0-
     &  4D0*XSW2))/S34+(2D0*C2(1,2)*(S13+S14+S23+S24)*(3D0-4D0*
     &  XSW2))/S34+(C0*(-(3D0*S13)-3D0*QEPS*S13-3D0*S14-3D0*QEPS*
     &  S14-3D0*S23+3D0*QEPS*S23-3D0*S24+3D0*QEPS*S24+4D0*S13*XSW2+
     &  4D0*S14*XSW2+4D0*S23*XSW2+4D0*S24*XSW2+6D0*XMQM2(I)-8D0*
     &  XSW2*XMQM2(I)))/S34
        K(10) = (6D0*C1(1)*QEPS*(S13+S14-S23-S24))/S34-2D0*C2(2,2)*
     &  (3D0-4D0*XSW2)+(3D0-4D0*XSW2)/S34-(2D0*C2(1,1)*S12*(3D0-4D0*
     &  XSW2))/S34+(2D0*C2(1,2)*(S13+S14+S23+S24)*(3D0-4D0*XSW2))/
     &  S34+(C0*(-(3D0*S13)+3D0*QEPS*S13-3D0*S14+3D0*QEPS*S14-3D0*
     &  S23-3D0*QEPS*S23-3D0*S24-3D0*QEPS*S24+4D0*S13*XSW2+4D0*S14*
     &  XSW2+4D0*S23*XSW2+4D0*S24*XSW2+6D0*XMQM2(I)-8D0*XSW2*
     &  XMQM2(I)))/S34
        K(11) = -(3D0*S13)-3D0*QEPS*S13-3D0*S14-3D0*QEPS*S14-3D0*
     &  S23+3D0*QEPS*S23-3D0*S24+3D0*QEPS*S24+4D0*S13*XSW2+4D0*S14*
     &  XSW2+4D0*S23*XSW2+4D0*S24*XSW2+6D0*XMQM2(I)-8D0*XSW2*
     &  XMQM2(I)
        K(12) = -(3D0*S13)+3D0*QEPS*S13-3D0*S14+3D0*QEPS*S14-3D0*
     &  S23-3D0*QEPS*S23-3D0*S24-3D0*QEPS*S24+4D0*S13*XSW2+4D0*S14*
     &  XSW2+4D0*S23*XSW2+4D0*S24*XSW2+6D0*XMQM2(I)-8D0*XSW2*
     &  XMQM2(I)

        PRE = (QF(3)*ALPHA*PZ12*SA*XMQM2(I))/(96D0*PI*XCW2*XMW*XSW)

        F(1,-1,-1) = F(1,-1,-1)-(K(1)*K(9)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)-(K(1)*K(9)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*K(10)*QF(1)*PRE
        F(1,1,1) = F(1,1,1)+2D0*K(10)*QF(1)*PRE
        F(5,-1,-1) = F(5,-1,-1)-(2D0*K(1)*K(6)*PRE)/(S34*XSW2)
        F(5,-1,1) = F(5,-1,1)-(2D0*K(1)*K(6)*PRE)/(S34*XSW2)
        F(5,1,-1) = F(5,1,-1)+(4D0*K(5)*QF(1)*PRE)/S34
        F(5,1,1) = F(5,1,1)+(4D0*K(5)*QF(1)*PRE)/S34
        F(6,-1,-1) = F(6,-1,-1)-(2D0*K(1)*K(5)*PRE)/(S34*XSW2)
        F(6,-1,1) = F(6,-1,1)-(2D0*K(1)*K(5)*PRE)/(S34*XSW2)
        F(6,1,-1) = F(6,1,-1)+(4D0*K(6)*QF(1)*PRE)/S34
        F(6,1,1) = F(6,1,1)+(4D0*K(6)*QF(1)*PRE)/S34
        F(7,-1,-1) = F(7,-1,-1)-(2D0*K(1)*K(6)*PRE)/(S34*XSW2)
        F(7,-1,1) = F(7,-1,1)-(2D0*K(1)*K(6)*PRE)/(S34*XSW2)
        F(7,1,-1) = F(7,1,-1)+(4D0*K(5)*QF(1)*PRE)/S34
        F(7,1,1) = F(7,1,1)+(4D0*K(5)*QF(1)*PRE)/S34
        F(8,-1,-1) = F(8,-1,-1)-(2D0*K(1)*K(5)*PRE)/(S34*XSW2)
        F(8,-1,1) = F(8,-1,1)-(2D0*K(1)*K(5)*PRE)/(S34*XSW2)
        F(8,1,-1) = F(8,1,-1)+(4D0*K(6)*QF(1)*PRE)/S34
        F(8,1,1) = F(8,1,1)+(4D0*K(6)*QF(1)*PRE)/S34

C       G(T9,N1274,FULL)

C       G(T9,N1275,FULL)

C       G(T9,N1276,FULL)

C       G(T9,N1277,FULL)

C       G(T9,N1282,FULL)

C       G(T9,N1283,FULL)

C       G(T9,N1284,FULL)

C       G(T9,N1285,FULL)

C       G(T9,N1286,FULL)
        CALL xC01234_(S12,MHH2,S34,XMQM2(I),XMQM2(I),XMQM2(I),C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = 3D0-2D0*XSW2
        K(4) = 3D0-3D0*QEPS+4D0*QEPS*XSW2
        K(5) = 3D0+3D0*QEPS-4D0*QEPS*XSW2
        K(6) = 9D0-12D0*XSW2+8D0*XSW2**2
        K(7) = 9D0-6D0*XSW2+4D0*XSW2**2
        K(8) = S13+S14+S23+S24
        K(9) = 4D0*C0*(3D0-2D0*XSW2)+(3D0*C1(2)*(3D0+3D0*QEPS-4D0*
     &  QEPS*XSW2))/XSW2+(3D0*C1(1)*(3D0-3D0*QEPS+4D0*QEPS*XSW2))/
     &  XSW2+(4D0*C2(1,2)*(9D0-12D0*XSW2+8D0*XSW2**2))/XSW2
        K(10) = 4D0*C0*(3D0-2D0*XSW2)+(3D0*C1(1)*(3D0+3D0*QEPS-4D0*
     &  QEPS*XSW2))/XSW2+(3D0*C1(2)*(3D0-3D0*QEPS+4D0*QEPS*XSW2))/
     &  XSW2+(4D0*C2(1,2)*(9D0-12D0*XSW2+8D0*XSW2**2))/XSW2
        K(11) = S13+S14+S23+S24-2D0*XMQM2(I)
        K(12) = -((72D0*C2(0,0))/XSW2)-(3D0*C1(1)*(6D0*S12-3D0*S13-
     &  3D0*QEPS*S13-3D0*S14-3D0*QEPS*S14-3D0*S23+3D0*QEPS*S23-3D0*
     &  S24+3D0*QEPS*S24+4D0*QEPS*S13*XSW2+4D0*QEPS*S14*XSW2-4D0*
     &  QEPS*S23*XSW2-4D0*QEPS*S24*XSW2))/XSW2+(3D0*C1(2)*(3D0*S13-
     &  3D0*QEPS*S13+3D0*S14-3D0*QEPS*S14+3D0*S23+3D0*QEPS*S23+3D0*
     &  S24+3D0*QEPS*S24-6D0*S34+4D0*QEPS*S13*XSW2+4D0*QEPS*S14*
     &  XSW2-4D0*QEPS*S23*XSW2-4D0*QEPS*S24*XSW2))/XSW2+(2D0*(9D0-
     &  6D0*XSW2+4D0*XSW2**2))/XSW2-(4D0*C2(1,1)*S12*(9D0-6D0*XSW2+
     &  4D0*XSW2**2))/XSW2+(4D0*C2(1,2)*(S13+S14+S23+S24)*(9D0-6D0*
     &  XSW2+4D0*XSW2**2))/XSW2-(4D0*C2(2,2)*S34*(9D0-6D0*XSW2+4D0*
     &  XSW2**2))/XSW2+4D0*C0*(3D0-2D0*XSW2)*(S13+S14+S23+S24-2D0*
     &  XMQM2(I))
        K(13) = 6D0*S12-3D0*S13-3D0*QEPS*S13-3D0*S14-3D0*QEPS*S14-
     &  3D0*S23+3D0*QEPS*S23-3D0*S24+3D0*QEPS*S24+4D0*QEPS*S13*XSW2+
     &  4D0*QEPS*S14*XSW2-4D0*QEPS*S23*XSW2-4D0*QEPS*S24*XSW2
        K(14) = 6D0*S12-3D0*S13+3D0*QEPS*S13-3D0*S14+3D0*QEPS*S14-
     &  3D0*S23-3D0*QEPS*S23-3D0*S24-3D0*QEPS*S24-4D0*QEPS*S13*XSW2-
     &  4D0*QEPS*S14*XSW2+4D0*QEPS*S23*XSW2+4D0*QEPS*S24*XSW2
        K(15) = -(3D0*S13)-3D0*QEPS*S13-3D0*S14-3D0*QEPS*S14-3D0*
     &  S23+3D0*QEPS*S23-3D0*S24+3D0*QEPS*S24+6D0*S34+4D0*QEPS*S13*
     &  XSW2+4D0*QEPS*S14*XSW2-4D0*QEPS*S23*XSW2-4D0*QEPS*S24*XSW2
        K(16) = 3D0*S13-3D0*QEPS*S13+3D0*S14-3D0*QEPS*S14+3D0*S23+
     &  3D0*QEPS*S23+3D0*S24+3D0*QEPS*S24-6D0*S34+4D0*QEPS*S13*XSW2+
     &  4D0*QEPS*S14*XSW2-4D0*QEPS*S23*XSW2-4D0*QEPS*S24*XSW2

        PRE = -((ALPHA*PZ12*PZ34*SA*XCW2**(-2)*XMQM2(I))/(384D0*PI*
     &  XMW))

        F(1,-1,-1) = F(1,-1,-1)-(K(1)*K(12)*K(2)*PRE)/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*K(1)*K(12)*QF(3)*PRE)/XSW
        F(1,1,-1) = F(1,1,-1)+(2D0*K(2)*QF(1)*PRE*(-((72D0*C2(0,0))/
     &  XSW2)-(3D0*C1(1)*K(14))/XSW2-(3D0*C1(2)*K(15))/XSW2+(2D0*
     &  K(7))/XSW2+(4D0*C2(1,2)*K(7)*K(8))/XSW2-(4D0*C2(1,1)*K(7)*
     &  S12)/XSW2-(4D0*C2(2,2)*K(7)*S34)/XSW2+4D0*K(3)*C0*(K(8)-2D0*
     &  XMQM2(I))))/XSW
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*(-((72D0*C2(0,0))/
     &  XSW)-(3D0*C1(1)*K(14))/XSW-(3D0*C1(2)*K(15))/XSW+(2D0*K(7))/
     &  XSW+(4D0*C2(1,2)*K(7)*K(8))/XSW-(4D0*C2(1,1)*K(7)*S12)/XSW-
     &  (4D0*C2(2,2)*K(7)*S34)/XSW+4D0*K(3)*C0*XSW*(K(8)-2D0*
     &  XMQM2(I)))
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(1)*K(10)*K(2)*PRE)/(XSW*XSW2)
        F(5,-1,1) = F(5,-1,1)+(4D0*K(1)*K(10)*QF(3)*PRE)/XSW
        F(5,1,-1) = F(5,1,-1)-(4D0*K(2)*K(9)*QF(1)*PRE)/XSW
        F(5,1,1) = F(5,1,1)-8D0*QF(1)*QF(3)*PRE*(4D0*K(3)*C0*XSW+
     &  (3D0*C1(1)*K(4))/XSW+(3D0*C1(2)*K(5))/XSW+(4D0*C2(1,2)*
     &  K(6))/XSW)
        F(6,-1,-1) = F(6,-1,-1)+(2D0*K(1)*K(2)*K(9)*PRE)/(XSW*XSW2)
        F(6,-1,1) = F(6,-1,1)+(4D0*K(1)*K(9)*QF(3)*PRE)/XSW
        F(6,1,-1) = F(6,1,-1)-(4D0*K(10)*K(2)*QF(1)*PRE)/XSW
        F(6,1,1) = F(6,1,1)-8D0*QF(1)*QF(3)*PRE*(4D0*K(3)*C0*XSW+
     &  (3D0*C1(2)*K(4))/XSW+(3D0*C1(1)*K(5))/XSW+(4D0*C2(1,2)*
     &  K(6))/XSW)
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(1)*K(10)*K(2)*PRE)/(XSW*XSW2)
        F(7,-1,1) = F(7,-1,1)+(4D0*K(1)*K(10)*QF(3)*PRE)/XSW
        F(7,1,-1) = F(7,1,-1)-(4D0*K(2)*K(9)*QF(1)*PRE)/XSW
        F(7,1,1) = F(7,1,1)-8D0*QF(1)*QF(3)*PRE*(4D0*K(3)*C0*XSW+
     &  (3D0*C1(1)*K(4))/XSW+(3D0*C1(2)*K(5))/XSW+(4D0*C2(1,2)*
     &  K(6))/XSW)
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(1)*K(2)*K(9)*PRE)/(XSW*XSW2)
        F(8,-1,1) = F(8,-1,1)+(4D0*K(1)*K(9)*QF(3)*PRE)/XSW
        F(8,1,-1) = F(8,1,-1)-(4D0*K(10)*K(2)*QF(1)*PRE)/XSW
        F(8,1,1) = F(8,1,1)-8D0*QF(1)*QF(3)*PRE*(4D0*K(3)*C0*XSW+
     &  (3D0*C1(2)*K(4))/XSW+(3D0*C1(1)*K(5))/XSW+(4D0*C2(1,2)*
     &  K(6))/XSW)

C       G(T9,N1287,FULL)
        CALL xC01234_(S12,MHH2,S34,XMQP2(I),XMQP2(I),XMQP2(I),C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = 3D0-4D0*XSW2
        K(4) = 3D0-3D0*QEPS+8D0*QEPS*XSW2
        K(5) = 3D0+3D0*QEPS-8D0*QEPS*XSW2
        K(6) = 3D0-6D0*XSW+4D0*XSW2
        K(7) = 3D0+6D0*XSW+4D0*XSW2
        K(8) = 9D0-24D0*XSW2+32D0*XSW2**2
        K(9) = S13+S14+S23+S24
        K(10) = 8D0*C0*(3D0-4D0*XSW2)+(3D0*C1(2)*(3D0+3D0*QEPS-8D0*
     &  QEPS*XSW2))/XSW2+(3D0*C1(1)*(3D0-3D0*QEPS+8D0*QEPS*XSW2))/
     &  XSW2+(4D0*C2(1,2)*(9D0-24D0*XSW2+32D0*XSW2**2))/XSW2
        K(11) = 8D0*C0*(3D0-4D0*XSW2)+(3D0*C1(1)*(3D0+3D0*QEPS-8D0*
     &  QEPS*XSW2))/XSW2+(3D0*C1(2)*(3D0-3D0*QEPS+8D0*QEPS*XSW2))/
     &  XSW2+(4D0*C2(1,2)*(9D0-24D0*XSW2+32D0*XSW2**2))/XSW2
        K(12) = S13+S14+S23+S24-2D0*XMQP2(I)
        K(13) = -((72D0*C2(0,0))/XSW2)+(2D0*(3D0-6D0*XSW+4D0*XSW2)*
     &  (3D0+6D0*XSW+4D0*XSW2))/XSW2-(4D0*C2(1,1)*S12*(3D0-6D0*XSW+
     &  4D0*XSW2)*(3D0+6D0*XSW+4D0*XSW2))/XSW2+(4D0*C2(1,2)*(S13+
     &  S14+S23+S24)*(3D0-6D0*XSW+4D0*XSW2)*(3D0+6D0*XSW+4D0*XSW2))/
     &  XSW2-(4D0*C2(2,2)*S34*(3D0-6D0*XSW+4D0*XSW2)*(3D0+6D0*XSW+
     &  4D0*XSW2))/XSW2-(3D0*C1(1)*(6D0*S12-3D0*S13-3D0*QEPS*S13-
     &  3D0*S14-3D0*QEPS*S14-3D0*S23+3D0*QEPS*S23-3D0*S24+3D0*QEPS*
     &  S24+8D0*QEPS*S13*XSW2+8D0*QEPS*S14*XSW2-8D0*QEPS*S23*XSW2-
     &  8D0*QEPS*S24*XSW2))/XSW2+(3D0*C1(2)*(3D0*S13-3D0*QEPS*S13+
     &  3D0*S14-3D0*QEPS*S14+3D0*S23+3D0*QEPS*S23+3D0*S24+3D0*QEPS*
     &  S24-6D0*S34+8D0*QEPS*S13*XSW2+8D0*QEPS*S14*XSW2-8D0*QEPS*
     &  S23*XSW2-8D0*QEPS*S24*XSW2))/XSW2+8D0*C0*(3D0-4D0*XSW2)*
     &  (S13+S14+S23+S24-2D0*XMQP2(I))
        K(14) = 6D0*S12-3D0*S13-3D0*QEPS*S13-3D0*S14-3D0*QEPS*S14-
     &  3D0*S23+3D0*QEPS*S23-3D0*S24+3D0*QEPS*S24+8D0*QEPS*S13*XSW2+
     &  8D0*QEPS*S14*XSW2-8D0*QEPS*S23*XSW2-8D0*QEPS*S24*XSW2
        K(15) = 6D0*S12-3D0*S13+3D0*QEPS*S13-3D0*S14+3D0*QEPS*S14-
     &  3D0*S23-3D0*QEPS*S23-3D0*S24-3D0*QEPS*S24-8D0*QEPS*S13*XSW2-
     &  8D0*QEPS*S14*XSW2+8D0*QEPS*S23*XSW2+8D0*QEPS*S24*XSW2
        K(16) = -(3D0*S13)-3D0*QEPS*S13-3D0*S14-3D0*QEPS*S14-3D0*
     &  S23+3D0*QEPS*S23-3D0*S24+3D0*QEPS*S24+6D0*S34+8D0*QEPS*S13*
     &  XSW2+8D0*QEPS*S14*XSW2-8D0*QEPS*S23*XSW2-8D0*QEPS*S24*XSW2
        K(17) = 3D0*S13-3D0*QEPS*S13+3D0*S14-3D0*QEPS*S14+3D0*S23+
     &  3D0*QEPS*S23+3D0*S24+3D0*QEPS*S24-6D0*S34+8D0*QEPS*S13*XSW2+
     &  8D0*QEPS*S14*XSW2-8D0*QEPS*S23*XSW2-8D0*QEPS*S24*XSW2

        PRE = -((ALPHA*PZ12*PZ34*SA*XCW2**(-2)*XMQP2(I))/(384D0*PI*
     &  XMW))

        F(1,-1,-1) = F(1,-1,-1)-(K(1)*K(13)*K(2)*PRE)/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*K(1)*K(13)*QF(3)*PRE)/XSW
        F(1,1,-1) = F(1,1,-1)+(2D0*K(2)*QF(1)*PRE*(-((72D0*C2(0,0))/
     &  XSW2)-(3D0*C1(1)*K(15))/XSW2-(3D0*C1(2)*K(16))/XSW2+(2D0*
     &  K(6)*K(7))/XSW2+(4D0*C2(1,2)*K(6)*K(7)*K(9))/XSW2-(4D0*C2(1,
     &  1)*K(6)*K(7)*S12)/XSW2-(4D0*C2(2,2)*K(6)*K(7)*S34)/XSW2+8D0*
     &  K(3)*C0*(K(9)-2D0*XMQP2(I))))/XSW
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*(-((72D0*C2(0,0))/
     &  XSW)-(3D0*C1(1)*K(15))/XSW-(3D0*C1(2)*K(16))/XSW+(2D0*K(6)*
     &  K(7))/XSW+(4D0*C2(1,2)*K(6)*K(7)*K(9))/XSW-(4D0*C2(1,1)*
     &  K(6)*K(7)*S12)/XSW-(4D0*C2(2,2)*K(6)*K(7)*S34)/XSW+8D0*K(3)*
     &  C0*XSW*(K(9)-2D0*XMQP2(I)))
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(1)*K(11)*K(2)*PRE)/(XSW*XSW2)
        F(5,-1,1) = F(5,-1,1)+(4D0*K(1)*K(11)*QF(3)*PRE)/XSW
        F(5,1,-1) = F(5,1,-1)-(4D0*K(10)*K(2)*QF(1)*PRE)/XSW
        F(5,1,1) = F(5,1,1)-8D0*QF(1)*QF(3)*PRE*(8D0*K(3)*C0*XSW+
     &  (3D0*C1(1)*K(4))/XSW+(3D0*C1(2)*K(5))/XSW+(4D0*C2(1,2)*
     &  K(8))/XSW)
        F(6,-1,-1) = F(6,-1,-1)+(2D0*K(1)*K(10)*K(2)*PRE)/(XSW*XSW2)
        F(6,-1,1) = F(6,-1,1)+(4D0*K(1)*K(10)*QF(3)*PRE)/XSW
        F(6,1,-1) = F(6,1,-1)-(4D0*K(11)*K(2)*QF(1)*PRE)/XSW
        F(6,1,1) = F(6,1,1)-8D0*QF(1)*QF(3)*PRE*(8D0*K(3)*C0*XSW+
     &  (3D0*C1(2)*K(4))/XSW+(3D0*C1(1)*K(5))/XSW+(4D0*C2(1,2)*
     &  K(8))/XSW)
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(1)*K(11)*K(2)*PRE)/(XSW*XSW2)
        F(7,-1,1) = F(7,-1,1)+(4D0*K(1)*K(11)*QF(3)*PRE)/XSW
        F(7,1,-1) = F(7,1,-1)-(4D0*K(10)*K(2)*QF(1)*PRE)/XSW
        F(7,1,1) = F(7,1,1)-8D0*QF(1)*QF(3)*PRE*(8D0*K(3)*C0*XSW+
     &  (3D0*C1(1)*K(4))/XSW+(3D0*C1(2)*K(5))/XSW+(4D0*C2(1,2)*
     &  K(8))/XSW)
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(1)*K(10)*K(2)*PRE)/(XSW*XSW2)
        F(8,-1,1) = F(8,-1,1)+(4D0*K(1)*K(10)*QF(3)*PRE)/XSW
        F(8,1,-1) = F(8,1,-1)-(4D0*K(11)*K(2)*QF(1)*PRE)/XSW
        F(8,1,1) = F(8,1,1)-8D0*QF(1)*QF(3)*PRE*(8D0*K(3)*C0*XSW+
     &  (3D0*C1(2)*K(4))/XSW+(3D0*C1(1)*K(5))/XSW+(4D0*C2(1,2)*
     &  K(8))/XSW)

C       G(T9,N1288,FULL)
        CALL xC01234_(S12,MHH2,S34,XML2(I),XML2(I),XML2(I),C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,2,0)
        K(1) = 1D0-2D0*XSW2
        K(2) = 1D0-2D0*QF(1)*XSW2
        K(3) = 1D0+2D0*QF(3)*XSW2
        K(4) = 1D0-QEPS+4D0*QEPS*XSW2
        K(5) = 1D0+QEPS-4D0*QEPS*XSW2
        K(6) = 1D0-4D0*XSW2+8D0*XSW2**2
        K(7) = 1D0-2D0*XSW2+4D0*XSW2**2
        K(8) = S13+S14+S23+S24
        K(9) = 4D0*C0*(1D0-2D0*XSW2)+(C1(2)*(1D0+QEPS-4D0*QEPS*
     &  XSW2))/XSW2+(C1(1)*(1D0-QEPS+4D0*QEPS*XSW2))/XSW2+(4D0*C2(1,
     &  2)*(1D0-4D0*XSW2+8D0*XSW2**2))/XSW2
        K(10) = 4D0*C0*(1D0-2D0*XSW2)+(C1(1)*(1D0+QEPS-4D0*QEPS*
     &  XSW2))/XSW2+(C1(2)*(1D0-QEPS+4D0*QEPS*XSW2))/XSW2+(4D0*C2(1,
     &  2)*(1D0-4D0*XSW2+8D0*XSW2**2))/XSW2
        K(11) = S13+S14+S23+S24-2D0*XML2(I)
        K(12) = -((8D0*C2(0,0))/XSW2)-(C1(1)*(2D0*S12-S13-QEPS*S13-
     &  S14-QEPS*S14-S23+QEPS*S23-S24+QEPS*S24+4D0*QEPS*S13*XSW2+
     &  4D0*QEPS*S14*XSW2-4D0*QEPS*S23*XSW2-4D0*QEPS*S24*XSW2))/
     &  XSW2+(C1(2)*(S13-QEPS*S13+S14-QEPS*S14+S23+QEPS*S23+S24+
     &  QEPS*S24-2D0*S34+4D0*QEPS*S13*XSW2+4D0*QEPS*S14*XSW2-4D0*
     &  QEPS*S23*XSW2-4D0*QEPS*S24*XSW2))/XSW2+(2D0*(1D0-2D0*XSW2+
     &  4D0*XSW2**2))/XSW2-(4D0*C2(1,1)*S12*(1D0-2D0*XSW2+4D0*XSW2**
     &  2))/XSW2+(4D0*C2(1,2)*(S13+S14+S23+S24)*(1D0-2D0*XSW2+4D0*
     &  XSW2**2))/XSW2-(4D0*C2(2,2)*S34*(1D0-2D0*XSW2+4D0*XSW2**2))/
     &  XSW2+4D0*C0*(1D0-2D0*XSW2)*(S13+S14+S23+S24-2D0*XML2(I))
        K(13) = 2D0*S12-S13-QEPS*S13-S14-QEPS*S14-S23+QEPS*S23-S24+
     &  QEPS*S24+4D0*QEPS*S13*XSW2+4D0*QEPS*S14*XSW2-4D0*QEPS*S23*
     &  XSW2-4D0*QEPS*S24*XSW2
        K(14) = 2D0*S12-S13+QEPS*S13-S14+QEPS*S14-S23-QEPS*S23-S24-
     &  QEPS*S24-4D0*QEPS*S13*XSW2-4D0*QEPS*S14*XSW2+4D0*QEPS*S23*
     &  XSW2+4D0*QEPS*S24*XSW2
        K(15) = S13-QEPS*S13+S14-QEPS*S14+S23+QEPS*S23+S24+QEPS*S24-
     &  2D0*S34+4D0*QEPS*S13*XSW2+4D0*QEPS*S14*XSW2-4D0*QEPS*S23*
     &  XSW2-4D0*QEPS*S24*XSW2
        K(16) = S13+QEPS*S13+S14+QEPS*S14+S23-QEPS*S23+S24-QEPS*S24-
     &  2D0*S34-4D0*QEPS*S13*XSW2-4D0*QEPS*S14*XSW2+4D0*QEPS*S23*
     &  XSW2+4D0*QEPS*S24*XSW2

        PRE = -((ALPHA*PZ12*PZ34*SA*XCW2**(-2)*XML2(I))/(128D0*PI*
     &  XMW))

        F(1,-1,-1) = F(1,-1,-1)-(K(12)*K(2)*K(3)*PRE)/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*K(12)*K(2)*QF(3)*PRE)/XSW
        F(1,1,-1) = F(1,1,-1)+(2D0*K(3)*QF(1)*PRE*(-((8D0*C2(0,0))/
     &  XSW2)-(C1(1)*K(14))/XSW2+(C1(2)*(K(8)+QEPS*S13+QEPS*S14-
     &  QEPS*S23-QEPS*S24-2D0*S34-4D0*QEPS*S13*XSW2-4D0*QEPS*S14*
     &  XSW2+4D0*QEPS*S23*XSW2+4D0*QEPS*S24*XSW2))/XSW2+(2D0*(K(1)+
     &  4D0*XSW2**2))/XSW2+(4D0*C2(1,2)*K(8)*(K(1)+4D0*XSW2**2))/
     &  XSW2-(4D0*C2(1,1)*S12*(K(1)+4D0*XSW2**2))/XSW2-(4D0*C2(2,2)*
     &  S34*(K(1)+4D0*XSW2**2))/XSW2+4D0*K(1)*C0*(K(8)-2D0*
     &  XML2(I))))/XSW
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*(-((8D0*C2(0,0))/
     &  XSW)-(C1(1)*K(14))/XSW+(C1(2)*(K(8)+QEPS*S13+QEPS*S14-QEPS*
     &  S23-QEPS*S24-2D0*S34-4D0*QEPS*S13*XSW2-4D0*QEPS*S14*XSW2+
     &  4D0*QEPS*S23*XSW2+4D0*QEPS*S24*XSW2))/XSW+(2D0*(K(1)+4D0*
     &  XSW2**2))/XSW+(4D0*C2(1,2)*K(8)*(K(1)+4D0*XSW2**2))/XSW-
     &  (4D0*C2(1,1)*S12*(K(1)+4D0*XSW2**2))/XSW-(4D0*C2(2,2)*S34*
     &  (K(1)+4D0*XSW2**2))/XSW+4D0*K(1)*C0*XSW*(K(8)-2D0*XML2(I)))
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(10)*K(2)*K(3)*PRE)/(XSW*XSW2)
        F(5,-1,1) = F(5,-1,1)+(4D0*K(10)*K(2)*QF(3)*PRE)/XSW
        F(5,1,-1) = F(5,1,-1)-(4D0*K(3)*K(9)*QF(1)*PRE)/XSW
        F(5,1,1) = F(5,1,1)-8D0*QF(1)*QF(3)*PRE*(4D0*K(1)*C0*XSW+
     &  (C1(1)*K(4))/XSW+(C1(2)*K(5))/XSW+(4D0*C2(1,2)*K(6))/XSW)
        F(6,-1,-1) = F(6,-1,-1)+(2D0*K(2)*K(3)*K(9)*PRE)/(XSW*XSW2)
        F(6,-1,1) = F(6,-1,1)+(4D0*K(2)*K(9)*QF(3)*PRE)/XSW
        F(6,1,-1) = F(6,1,-1)-(4D0*K(10)*K(3)*QF(1)*PRE)/XSW
        F(6,1,1) = F(6,1,1)-8D0*QF(1)*QF(3)*PRE*(4D0*K(1)*C0*XSW+
     &  (C1(2)*K(4))/XSW+(C1(1)*K(5))/XSW+(4D0*C2(1,2)*K(6))/XSW)
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(10)*K(2)*K(3)*PRE)/(XSW*XSW2)
        F(7,-1,1) = F(7,-1,1)+(4D0*K(10)*K(2)*QF(3)*PRE)/XSW
        F(7,1,-1) = F(7,1,-1)-(4D0*K(3)*K(9)*QF(1)*PRE)/XSW
        F(7,1,1) = F(7,1,1)-8D0*QF(1)*QF(3)*PRE*(4D0*K(1)*C0*XSW+
     &  (C1(1)*K(4))/XSW+(C1(2)*K(5))/XSW+(4D0*C2(1,2)*K(6))/XSW)
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(2)*K(3)*K(9)*PRE)/(XSW*XSW2)
        F(8,-1,1) = F(8,-1,1)+(4D0*K(2)*K(9)*QF(3)*PRE)/XSW
        F(8,1,-1) = F(8,1,-1)-(4D0*K(10)*K(3)*QF(1)*PRE)/XSW
        F(8,1,1) = F(8,1,1)-8D0*QF(1)*QF(3)*PRE*(4D0*K(1)*C0*XSW+
     &  (C1(2)*K(4))/XSW+(C1(1)*K(5))/XSW+(4D0*C2(1,2)*K(6))/XSW)

C       G(T9,N1289,FULL)
        CALL xC01234_(S12,MHH2,S34,XML2(I),XML2(I),XML2(I),C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,2,0)
        K(1) = 1D0-2D0*XSW2
        K(2) = 1D0-2D0*QF(1)*XSW2
        K(3) = 1D0+2D0*QF(3)*XSW2
        K(4) = 1D0-QEPS+4D0*QEPS*XSW2
        K(5) = 1D0+QEPS-4D0*QEPS*XSW2
        K(6) = 1D0-4D0*XSW2+8D0*XSW2**2
        K(7) = 1D0-2D0*XSW2+4D0*XSW2**2
        K(8) = S13+S14+S23+S24
        K(9) = 4D0*C0*(1D0-2D0*XSW2)+(C1(2)*(1D0+QEPS-4D0*QEPS*
     &  XSW2))/XSW2+(C1(1)*(1D0-QEPS+4D0*QEPS*XSW2))/XSW2+(4D0*C2(1,
     &  2)*(1D0-4D0*XSW2+8D0*XSW2**2))/XSW2
        K(10) = 4D0*C0*(1D0-2D0*XSW2)+(C1(1)*(1D0+QEPS-4D0*QEPS*
     &  XSW2))/XSW2+(C1(2)*(1D0-QEPS+4D0*QEPS*XSW2))/XSW2+(4D0*C2(1,
     &  2)*(1D0-4D0*XSW2+8D0*XSW2**2))/XSW2
        K(11) = S13+S14+S23+S24-2D0*XML2(I)
        K(12) = -((8D0*C2(0,0))/XSW2)-(C1(1)*(2D0*S12-S13+QEPS*S13-
     &  S14+QEPS*S14-S23-QEPS*S23-S24-QEPS*S24-4D0*QEPS*S13*XSW2-
     &  4D0*QEPS*S14*XSW2+4D0*QEPS*S23*XSW2+4D0*QEPS*S24*XSW2))/
     &  XSW2+(C1(2)*(S13+QEPS*S13+S14+QEPS*S14+S23-QEPS*S23+S24-
     &  QEPS*S24-2D0*S34-4D0*QEPS*S13*XSW2-4D0*QEPS*S14*XSW2+4D0*
     &  QEPS*S23*XSW2+4D0*QEPS*S24*XSW2))/XSW2+(2D0*(1D0-2D0*XSW2+
     &  4D0*XSW2**2))/XSW2-(4D0*C2(1,1)*S12*(1D0-2D0*XSW2+4D0*XSW2**
     &  2))/XSW2+(4D0*C2(1,2)*(S13+S14+S23+S24)*(1D0-2D0*XSW2+4D0*
     &  XSW2**2))/XSW2-(4D0*C2(2,2)*S34*(1D0-2D0*XSW2+4D0*XSW2**2))/
     &  XSW2+4D0*C0*(1D0-2D0*XSW2)*(S13+S14+S23+S24-2D0*XML2(I))
        K(13) = 2D0*S12-S13-QEPS*S13-S14-QEPS*S14-S23+QEPS*S23-S24+
     &  QEPS*S24+4D0*QEPS*S13*XSW2+4D0*QEPS*S14*XSW2-4D0*QEPS*S23*
     &  XSW2-4D0*QEPS*S24*XSW2
        K(14) = 2D0*S12-S13+QEPS*S13-S14+QEPS*S14-S23-QEPS*S23-S24-
     &  QEPS*S24-4D0*QEPS*S13*XSW2-4D0*QEPS*S14*XSW2+4D0*QEPS*S23*
     &  XSW2+4D0*QEPS*S24*XSW2
        K(15) = S13-QEPS*S13+S14-QEPS*S14+S23+QEPS*S23+S24+QEPS*S24-
     &  2D0*S34+4D0*QEPS*S13*XSW2+4D0*QEPS*S14*XSW2-4D0*QEPS*S23*
     &  XSW2-4D0*QEPS*S24*XSW2
        K(16) = S13+QEPS*S13+S14+QEPS*S14+S23-QEPS*S23+S24-QEPS*S24-
     &  2D0*S34-4D0*QEPS*S13*XSW2-4D0*QEPS*S14*XSW2+4D0*QEPS*S23*
     &  XSW2+4D0*QEPS*S24*XSW2

        PRE = -((ALPHA*PZ12*PZ34*SA*XCW2**(-2)*XML2(I))/(128D0*PI*
     &  XMW))

        F(1,-1,-1) = F(1,-1,-1)-(K(12)*K(2)*K(3)*PRE)/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*K(12)*K(2)*QF(3)*PRE)/XSW
        F(1,1,-1) = F(1,1,-1)+(2D0*K(3)*QF(1)*PRE*(-((8D0*C2(0,0))/
     &  XSW2)-(C1(1)*K(13))/XSW2+(C1(2)*(K(8)-QEPS*S13-QEPS*S14+
     &  QEPS*S23+QEPS*S24-2D0*S34+4D0*QEPS*S13*XSW2+4D0*QEPS*S14*
     &  XSW2-4D0*QEPS*S23*XSW2-4D0*QEPS*S24*XSW2))/XSW2+(2D0*(K(1)+
     &  4D0*XSW2**2))/XSW2+(4D0*C2(1,2)*K(8)*(K(1)+4D0*XSW2**2))/
     &  XSW2-(4D0*C2(1,1)*S12*(K(1)+4D0*XSW2**2))/XSW2-(4D0*C2(2,2)*
     &  S34*(K(1)+4D0*XSW2**2))/XSW2+4D0*K(1)*C0*(K(8)-2D0*
     &  XML2(I))))/XSW
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*(-((8D0*C2(0,0))/
     &  XSW)-(C1(1)*K(13))/XSW+(C1(2)*(K(8)-QEPS*S13-QEPS*S14+QEPS*
     &  S23+QEPS*S24-2D0*S34+4D0*QEPS*S13*XSW2+4D0*QEPS*S14*XSW2-
     &  4D0*QEPS*S23*XSW2-4D0*QEPS*S24*XSW2))/XSW+(2D0*(K(1)+4D0*
     &  XSW2**2))/XSW+(4D0*C2(1,2)*K(8)*(K(1)+4D0*XSW2**2))/XSW-
     &  (4D0*C2(1,1)*S12*(K(1)+4D0*XSW2**2))/XSW-(4D0*C2(2,2)*S34*
     &  (K(1)+4D0*XSW2**2))/XSW+4D0*K(1)*C0*XSW*(K(8)-2D0*XML2(I)))
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(2)*K(3)*K(9)*PRE)/(XSW*XSW2)
        F(5,-1,1) = F(5,-1,1)+(4D0*K(2)*K(9)*QF(3)*PRE)/XSW
        F(5,1,-1) = F(5,1,-1)-(4D0*K(10)*K(3)*QF(1)*PRE)/XSW
        F(5,1,1) = F(5,1,1)-8D0*QF(1)*QF(3)*PRE*(4D0*K(1)*C0*XSW+
     &  (C1(2)*K(4))/XSW+(C1(1)*K(5))/XSW+(4D0*C2(1,2)*K(6))/XSW)
        F(6,-1,-1) = F(6,-1,-1)+(2D0*K(10)*K(2)*K(3)*PRE)/(XSW*XSW2)
        F(6,-1,1) = F(6,-1,1)+(4D0*K(10)*K(2)*QF(3)*PRE)/XSW
        F(6,1,-1) = F(6,1,-1)-(4D0*K(3)*K(9)*QF(1)*PRE)/XSW
        F(6,1,1) = F(6,1,1)-8D0*QF(1)*QF(3)*PRE*(4D0*K(1)*C0*XSW+
     &  (C1(1)*K(4))/XSW+(C1(2)*K(5))/XSW+(4D0*C2(1,2)*K(6))/XSW)
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(2)*K(3)*K(9)*PRE)/(XSW*XSW2)
        F(7,-1,1) = F(7,-1,1)+(4D0*K(2)*K(9)*QF(3)*PRE)/XSW
        F(7,1,-1) = F(7,1,-1)-(4D0*K(10)*K(3)*QF(1)*PRE)/XSW
        F(7,1,1) = F(7,1,1)-8D0*QF(1)*QF(3)*PRE*(4D0*K(1)*C0*XSW+
     &  (C1(2)*K(4))/XSW+(C1(1)*K(5))/XSW+(4D0*C2(1,2)*K(6))/XSW)
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(10)*K(2)*K(3)*PRE)/(XSW*XSW2)
        F(8,-1,1) = F(8,-1,1)+(4D0*K(10)*K(2)*QF(3)*PRE)/XSW
        F(8,1,-1) = F(8,1,-1)-(4D0*K(3)*K(9)*QF(1)*PRE)/XSW
        F(8,1,1) = F(8,1,1)-8D0*QF(1)*QF(3)*PRE*(4D0*K(1)*C0*XSW+
     &  (C1(1)*K(4))/XSW+(C1(2)*K(5))/XSW+(4D0*C2(1,2)*K(6))/XSW)

C       G(T9,N1290,FULL)
        CALL xC01234_(S12,MHH2,S34,XMQP2(I),XMQP2(I),XMQP2(I),C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = 3D0-4D0*XSW2
        K(4) = 3D0-3D0*QEPS+8D0*QEPS*XSW2
        K(5) = 3D0+3D0*QEPS-8D0*QEPS*XSW2
        K(6) = 3D0-6D0*XSW+4D0*XSW2
        K(7) = 3D0+6D0*XSW+4D0*XSW2
        K(8) = 9D0-24D0*XSW2+32D0*XSW2**2
        K(9) = S13+S14+S23+S24
        K(10) = 8D0*C0*(3D0-4D0*XSW2)+(3D0*C1(2)*(3D0+3D0*QEPS-8D0*
     &  QEPS*XSW2))/XSW2+(3D0*C1(1)*(3D0-3D0*QEPS+8D0*QEPS*XSW2))/
     &  XSW2+(4D0*C2(1,2)*(9D0-24D0*XSW2+32D0*XSW2**2))/XSW2
        K(11) = 8D0*C0*(3D0-4D0*XSW2)+(3D0*C1(1)*(3D0+3D0*QEPS-8D0*
     &  QEPS*XSW2))/XSW2+(3D0*C1(2)*(3D0-3D0*QEPS+8D0*QEPS*XSW2))/
     &  XSW2+(4D0*C2(1,2)*(9D0-24D0*XSW2+32D0*XSW2**2))/XSW2
        K(12) = S13+S14+S23+S24-2D0*XMQP2(I)
        K(13) = -((72D0*C2(0,0))/XSW2)+(2D0*(3D0-6D0*XSW+4D0*XSW2)*
     &  (3D0+6D0*XSW+4D0*XSW2))/XSW2-(4D0*C2(1,1)*S12*(3D0-6D0*XSW+
     &  4D0*XSW2)*(3D0+6D0*XSW+4D0*XSW2))/XSW2+(4D0*C2(1,2)*(S13+
     &  S14+S23+S24)*(3D0-6D0*XSW+4D0*XSW2)*(3D0+6D0*XSW+4D0*XSW2))/
     &  XSW2-(4D0*C2(2,2)*S34*(3D0-6D0*XSW+4D0*XSW2)*(3D0+6D0*XSW+
     &  4D0*XSW2))/XSW2-(3D0*C1(2)*(-(3D0*S13)-3D0*QEPS*S13-3D0*S14-
     &  3D0*QEPS*S14-3D0*S23+3D0*QEPS*S23-3D0*S24+3D0*QEPS*S24+6D0*
     &  S34+8D0*QEPS*S13*XSW2+8D0*QEPS*S14*XSW2-8D0*QEPS*S23*XSW2-
     &  8D0*QEPS*S24*XSW2))/XSW2-(3D0*C1(1)*(6D0*S12-3D0*S13+3D0*
     &  QEPS*S13-3D0*S14+3D0*QEPS*S14-3D0*S23-3D0*QEPS*S23-3D0*S24-
     &  3D0*QEPS*S24-8D0*QEPS*S13*XSW2-8D0*QEPS*S14*XSW2+8D0*QEPS*
     &  S23*XSW2+8D0*QEPS*S24*XSW2))/XSW2+8D0*C0*(3D0-4D0*XSW2)*
     &  (S13+S14+S23+S24-2D0*XMQP2(I))
        K(14) = 6D0*S12-3D0*S13-3D0*QEPS*S13-3D0*S14-3D0*QEPS*S14-
     &  3D0*S23+3D0*QEPS*S23-3D0*S24+3D0*QEPS*S24+8D0*QEPS*S13*XSW2+
     &  8D0*QEPS*S14*XSW2-8D0*QEPS*S23*XSW2-8D0*QEPS*S24*XSW2
        K(15) = 6D0*S12-3D0*S13+3D0*QEPS*S13-3D0*S14+3D0*QEPS*S14-
     &  3D0*S23-3D0*QEPS*S23-3D0*S24-3D0*QEPS*S24-8D0*QEPS*S13*XSW2-
     &  8D0*QEPS*S14*XSW2+8D0*QEPS*S23*XSW2+8D0*QEPS*S24*XSW2
        K(16) = -(3D0*S13)-3D0*QEPS*S13-3D0*S14-3D0*QEPS*S14-3D0*
     &  S23+3D0*QEPS*S23-3D0*S24+3D0*QEPS*S24+6D0*S34+8D0*QEPS*S13*
     &  XSW2+8D0*QEPS*S14*XSW2-8D0*QEPS*S23*XSW2-8D0*QEPS*S24*XSW2
        K(17) = 3D0*S13-3D0*QEPS*S13+3D0*S14-3D0*QEPS*S14+3D0*S23+
     &  3D0*QEPS*S23+3D0*S24+3D0*QEPS*S24-6D0*S34+8D0*QEPS*S13*XSW2+
     &  8D0*QEPS*S14*XSW2-8D0*QEPS*S23*XSW2-8D0*QEPS*S24*XSW2

        PRE = -((ALPHA*PZ12*PZ34*SA*XCW2**(-2)*XMQP2(I))/(384D0*PI*
     &  XMW))

        F(1,-1,-1) = F(1,-1,-1)-(K(1)*K(13)*K(2)*PRE)/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*K(1)*K(13)*QF(3)*PRE)/XSW
        F(1,1,-1) = F(1,1,-1)+(2D0*K(2)*QF(1)*PRE*(-((72D0*C2(0,0))/
     &  XSW2)-(3D0*C1(1)*K(14))/XSW2+(3D0*C1(2)*K(17))/XSW2+(2D0*
     &  K(6)*K(7))/XSW2+(4D0*C2(1,2)*K(6)*K(7)*K(9))/XSW2-(4D0*C2(1,
     &  1)*K(6)*K(7)*S12)/XSW2-(4D0*C2(2,2)*K(6)*K(7)*S34)/XSW2+8D0*
     &  K(3)*C0*(K(9)-2D0*XMQP2(I))))/XSW
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*(-((72D0*C2(0,0))/
     &  XSW)-(3D0*C1(1)*K(14))/XSW+(3D0*C1(2)*K(17))/XSW+(2D0*K(6)*
     &  K(7))/XSW+(4D0*C2(1,2)*K(6)*K(7)*K(9))/XSW-(4D0*C2(1,1)*
     &  K(6)*K(7)*S12)/XSW-(4D0*C2(2,2)*K(6)*K(7)*S34)/XSW+8D0*K(3)*
     &  C0*XSW*(K(9)-2D0*XMQP2(I)))
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(1)*K(10)*K(2)*PRE)/(XSW*XSW2)
        F(5,-1,1) = F(5,-1,1)+(4D0*K(1)*K(10)*QF(3)*PRE)/XSW
        F(5,1,-1) = F(5,1,-1)-(4D0*K(11)*K(2)*QF(1)*PRE)/XSW
        F(5,1,1) = F(5,1,1)-8D0*QF(1)*QF(3)*PRE*(8D0*K(3)*C0*XSW+
     &  (3D0*C1(2)*K(4))/XSW+(3D0*C1(1)*K(5))/XSW+(4D0*C2(1,2)*
     &  K(8))/XSW)
        F(6,-1,-1) = F(6,-1,-1)+(2D0*K(1)*K(11)*K(2)*PRE)/(XSW*XSW2)
        F(6,-1,1) = F(6,-1,1)+(4D0*K(1)*K(11)*QF(3)*PRE)/XSW
        F(6,1,-1) = F(6,1,-1)-(4D0*K(10)*K(2)*QF(1)*PRE)/XSW
        F(6,1,1) = F(6,1,1)-8D0*QF(1)*QF(3)*PRE*(8D0*K(3)*C0*XSW+
     &  (3D0*C1(1)*K(4))/XSW+(3D0*C1(2)*K(5))/XSW+(4D0*C2(1,2)*
     &  K(8))/XSW)
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(1)*K(10)*K(2)*PRE)/(XSW*XSW2)
        F(7,-1,1) = F(7,-1,1)+(4D0*K(1)*K(10)*QF(3)*PRE)/XSW
        F(7,1,-1) = F(7,1,-1)-(4D0*K(11)*K(2)*QF(1)*PRE)/XSW
        F(7,1,1) = F(7,1,1)-8D0*QF(1)*QF(3)*PRE*(8D0*K(3)*C0*XSW+
     &  (3D0*C1(2)*K(4))/XSW+(3D0*C1(1)*K(5))/XSW+(4D0*C2(1,2)*
     &  K(8))/XSW)
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(1)*K(11)*K(2)*PRE)/(XSW*XSW2)
        F(8,-1,1) = F(8,-1,1)+(4D0*K(1)*K(11)*QF(3)*PRE)/XSW
        F(8,1,-1) = F(8,1,-1)-(4D0*K(10)*K(2)*QF(1)*PRE)/XSW
        F(8,1,1) = F(8,1,1)-8D0*QF(1)*QF(3)*PRE*(8D0*K(3)*C0*XSW+
     &  (3D0*C1(1)*K(4))/XSW+(3D0*C1(2)*K(5))/XSW+(4D0*C2(1,2)*
     &  K(8))/XSW)

C       G(T9,N1291,FULL)
        CALL xC01234_(S12,MHH2,S34,XMQM2(I),XMQM2(I),XMQM2(I),C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = 3D0-2D0*XSW2
        K(4) = 3D0-3D0*QEPS+4D0*QEPS*XSW2
        K(5) = 3D0+3D0*QEPS-4D0*QEPS*XSW2
        K(6) = 9D0-12D0*XSW2+8D0*XSW2**2
        K(7) = 9D0-6D0*XSW2+4D0*XSW2**2
        K(8) = S13+S14+S23+S24
        K(9) = 4D0*C0*(3D0-2D0*XSW2)+(3D0*C1(2)*(3D0+3D0*QEPS-4D0*
     &  QEPS*XSW2))/XSW2+(3D0*C1(1)*(3D0-3D0*QEPS+4D0*QEPS*XSW2))/
     &  XSW2+(4D0*C2(1,2)*(9D0-12D0*XSW2+8D0*XSW2**2))/XSW2
        K(10) = 4D0*C0*(3D0-2D0*XSW2)+(3D0*C1(1)*(3D0+3D0*QEPS-4D0*
     &  QEPS*XSW2))/XSW2+(3D0*C1(2)*(3D0-3D0*QEPS+4D0*QEPS*XSW2))/
     &  XSW2+(4D0*C2(1,2)*(9D0-12D0*XSW2+8D0*XSW2**2))/XSW2
        K(11) = S13+S14+S23+S24-2D0*XMQM2(I)
        K(12) = -((72D0*C2(0,0))/XSW2)-(3D0*C1(2)*(-(3D0*S13)-3D0*
     &  QEPS*S13-3D0*S14-3D0*QEPS*S14-3D0*S23+3D0*QEPS*S23-3D0*S24+
     &  3D0*QEPS*S24+6D0*S34+4D0*QEPS*S13*XSW2+4D0*QEPS*S14*XSW2-
     &  4D0*QEPS*S23*XSW2-4D0*QEPS*S24*XSW2))/XSW2-(3D0*C1(1)*(6D0*
     &  S12-3D0*S13+3D0*QEPS*S13-3D0*S14+3D0*QEPS*S14-3D0*S23-3D0*
     &  QEPS*S23-3D0*S24-3D0*QEPS*S24-4D0*QEPS*S13*XSW2-4D0*QEPS*
     &  S14*XSW2+4D0*QEPS*S23*XSW2+4D0*QEPS*S24*XSW2))/XSW2+(2D0*
     &  (9D0-6D0*XSW2+4D0*XSW2**2))/XSW2-(4D0*C2(1,1)*S12*(9D0-6D0*
     &  XSW2+4D0*XSW2**2))/XSW2+(4D0*C2(1,2)*(S13+S14+S23+S24)*(9D0-
     &  6D0*XSW2+4D0*XSW2**2))/XSW2-(4D0*C2(2,2)*S34*(9D0-6D0*XSW2+
     &  4D0*XSW2**2))/XSW2+4D0*C0*(3D0-2D0*XSW2)*(S13+S14+S23+S24-
     &  2D0*XMQM2(I))
        K(13) = 6D0*S12-3D0*S13-3D0*QEPS*S13-3D0*S14-3D0*QEPS*S14-
     &  3D0*S23+3D0*QEPS*S23-3D0*S24+3D0*QEPS*S24+4D0*QEPS*S13*XSW2+
     &  4D0*QEPS*S14*XSW2-4D0*QEPS*S23*XSW2-4D0*QEPS*S24*XSW2
        K(14) = 6D0*S12-3D0*S13+3D0*QEPS*S13-3D0*S14+3D0*QEPS*S14-
     &  3D0*S23-3D0*QEPS*S23-3D0*S24-3D0*QEPS*S24-4D0*QEPS*S13*XSW2-
     &  4D0*QEPS*S14*XSW2+4D0*QEPS*S23*XSW2+4D0*QEPS*S24*XSW2
        K(15) = -(3D0*S13)-3D0*QEPS*S13-3D0*S14-3D0*QEPS*S14-3D0*
     &  S23+3D0*QEPS*S23-3D0*S24+3D0*QEPS*S24+6D0*S34+4D0*QEPS*S13*
     &  XSW2+4D0*QEPS*S14*XSW2-4D0*QEPS*S23*XSW2-4D0*QEPS*S24*XSW2
        K(16) = 3D0*S13-3D0*QEPS*S13+3D0*S14-3D0*QEPS*S14+3D0*S23+
     &  3D0*QEPS*S23+3D0*S24+3D0*QEPS*S24-6D0*S34+4D0*QEPS*S13*XSW2+
     &  4D0*QEPS*S14*XSW2-4D0*QEPS*S23*XSW2-4D0*QEPS*S24*XSW2

        PRE = -((ALPHA*PZ12*PZ34*SA*XCW2**(-2)*XMQM2(I))/(384D0*PI*
     &  XMW))

        F(1,-1,-1) = F(1,-1,-1)-(K(1)*K(12)*K(2)*PRE)/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*K(1)*K(12)*QF(3)*PRE)/XSW
        F(1,1,-1) = F(1,1,-1)+(2D0*K(2)*QF(1)*PRE*(-((72D0*C2(0,0))/
     &  XSW2)-(3D0*C1(1)*K(13))/XSW2+(3D0*C1(2)*K(16))/XSW2+(2D0*
     &  K(7))/XSW2+(4D0*C2(1,2)*K(7)*K(8))/XSW2-(4D0*C2(1,1)*K(7)*
     &  S12)/XSW2-(4D0*C2(2,2)*K(7)*S34)/XSW2+4D0*K(3)*C0*(K(8)-2D0*
     &  XMQM2(I))))/XSW
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*(-((72D0*C2(0,0))/
     &  XSW)-(3D0*C1(1)*K(13))/XSW+(3D0*C1(2)*K(16))/XSW+(2D0*K(7))/
     &  XSW+(4D0*C2(1,2)*K(7)*K(8))/XSW-(4D0*C2(1,1)*K(7)*S12)/XSW-
     &  (4D0*C2(2,2)*K(7)*S34)/XSW+4D0*K(3)*C0*XSW*(K(8)-2D0*
     &  XMQM2(I)))
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(1)*K(2)*K(9)*PRE)/(XSW*XSW2)
        F(5,-1,1) = F(5,-1,1)+(4D0*K(1)*K(9)*QF(3)*PRE)/XSW
        F(5,1,-1) = F(5,1,-1)-(4D0*K(10)*K(2)*QF(1)*PRE)/XSW
        F(5,1,1) = F(5,1,1)-8D0*QF(1)*QF(3)*PRE*(4D0*K(3)*C0*XSW+
     &  (3D0*C1(2)*K(4))/XSW+(3D0*C1(1)*K(5))/XSW+(4D0*C2(1,2)*
     &  K(6))/XSW)
        F(6,-1,-1) = F(6,-1,-1)+(2D0*K(1)*K(10)*K(2)*PRE)/(XSW*XSW2)
        F(6,-1,1) = F(6,-1,1)+(4D0*K(1)*K(10)*QF(3)*PRE)/XSW
        F(6,1,-1) = F(6,1,-1)-(4D0*K(2)*K(9)*QF(1)*PRE)/XSW
        F(6,1,1) = F(6,1,1)-8D0*QF(1)*QF(3)*PRE*(4D0*K(3)*C0*XSW+
     &  (3D0*C1(1)*K(4))/XSW+(3D0*C1(2)*K(5))/XSW+(4D0*C2(1,2)*
     &  K(6))/XSW)
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(1)*K(2)*K(9)*PRE)/(XSW*XSW2)
        F(7,-1,1) = F(7,-1,1)+(4D0*K(1)*K(9)*QF(3)*PRE)/XSW
        F(7,1,-1) = F(7,1,-1)-(4D0*K(10)*K(2)*QF(1)*PRE)/XSW
        F(7,1,1) = F(7,1,1)-8D0*QF(1)*QF(3)*PRE*(4D0*K(3)*C0*XSW+
     &  (3D0*C1(2)*K(4))/XSW+(3D0*C1(1)*K(5))/XSW+(4D0*C2(1,2)*
     &  K(6))/XSW)
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(1)*K(10)*K(2)*PRE)/(XSW*XSW2)
        F(8,-1,1) = F(8,-1,1)+(4D0*K(1)*K(10)*QF(3)*PRE)/XSW
        F(8,1,-1) = F(8,1,-1)-(4D0*K(2)*K(9)*QF(1)*PRE)/XSW
        F(8,1,1) = F(8,1,1)-8D0*QF(1)*QF(3)*PRE*(4D0*K(3)*C0*XSW+
     &  (3D0*C1(1)*K(4))/XSW+(3D0*C1(2)*K(5))/XSW+(4D0*C2(1,2)*
     &  K(6))/XSW)

C       G(T9,N1292,FULL)

C       G(T9,N1293,FULL)

C       G(T9,N1294,FULL)

C       G(T9,N1295,FULL)

100	continue

	end

