cxx2
**********************************************************************
        subroutine xsehh_sesm(s,seh0h0,seh0HH,seHHHH)
**********************************************************************
*       unrenormalized neutral CP-even Higgs-boson self-energies
*       bosonic loops only
*       SESM
*---------------------------------------------------------------------
*       10.5.16 Stefan Dittmaier
**********************************************************************
        implicit real*8 (a-z)
        complex*16 seh0h0,seh0HH,seHHHH
        complex*16 B0_,xB0_
        complex*16 B00H0,B00HH,B00A0,B00HP,B00W,B00Z 
        complex*16 BSA0A0,BSA0Z,BSH0H0,BSH0HH,BSHHHH,BSHPHP,BSHPW
	complex*16 BSWW,BSZZ   

        include '../COMMON/param.inc'
        include '../COMMON/xparam.inc'
        include '../COMMON/param_sesm.inc'
        include '../COMMON/param_bsm.inc'

        B00H0  = xB0_(0D0,null,xMH02,0)	
        B00HH  = xB0_(0D0,null,xMHH2,0)
        B00W   = xB0_(0D0,null,xMW2,0)	
        B00Z   = xB0_(0D0,null,xMZ2,0)

        BSH0H0 = xB0_(S,xMH02,xMH02,0)	
        BSH0HH = xB0_(S,xMH02,xMHH2,0)	
        BSHHHH = xB0_(S,xMHH2,xMHH2,0)	
        BSWW   = xB0_(S,xMW2,xMW2,0)	
        BSZZ   = xB0_(S,xMZ2,xMZ2,0)	

	seh0h0 = 
     &  (L12*PI**(-2)*(18D0*BSH0H0*CA**2*SA**2*XMH02**2*(XMH0+
     &  XMHH)**(-2)*(XMH0-XMHH)**(-2)*(XMH02-XMHH2)-4D0*BSH0HH*CA**
     &  2*SA**2*(XMH0+XMHH)**(-2)*(XMH0-XMHH)**(-2)*(2D0*XMH02+
     &  XMHH2)**2*(XMH02-XMHH2)+6D0*B00H0*CA**2*SA**2*XMH02*(XMH0+
     &  XMHH)**(-2)*(XMH0-XMHH)**(-2)*(XMH02-XMHH2)**2+B00HH*(1D0-
     &  6D0*CA**2+6D0*CA**4)*(XMH0+XMHH)**(-2)*(XMH0-XMHH)**(-2)*
     &  XMHH2*(XMH02-XMHH2)**2+2D0*BSHHHH*CA**2*SA**2*(XMH0+XMHH)**
     &  (-2)*(XMH0-XMHH)**(-2)*(XMH02-XMHH2)*(XMH02+2D0*XMHH2)**2+
     &  2D0*B00W*SA**2*XMW2+B00Z*SA**2*XMZ2))/16D0+(L12**2*PI**(-3)*
     &  (XMH0+XMHH)**(-2)*(XMH0-XMHH)**(-2)*(9D0*BSH0H0*CA**(-2)*
     &  SA**4*XMH02**2+2D0*BSH0HH*SA**2*(2D0*XMH02+XMHH2)**2+BSHHHH*
     &  CA**2*(XMH02+2D0*XMHH2)**2+3D0*B00H0*CA**(-2)*SA**2*XMH02*
     &  (XMH02-CA**2*XMH02+CA**2*XMHH2)+3D0*B00HH*XMHH2*(XMH02-CA**
     &  2*XMH02+CA**2*XMHH2))*XMW2*XSW2)/(8D0*ALPHA)+(ALPHA*CA**2*
     &  ((9D0*BSH0H0*CA**4*XMH02**2*(XMH0+XMHH)**(-2)*(XMH0-XMHH)**
     &  (-2)*(XMH02-XMHH2)**2)/XMW2+(2D0*BSH0HH*CA**2*SA**2*(XMH0+
     &  XMHH)**(-2)*(XMH0-XMHH)**(-2)*(2D0*XMH02+XMHH2)**2*(XMH02-
     &  XMHH2)**2)/XMW2+(BSHHHH*SA**4*(XMH0+XMHH)**(-2)*(XMH0-
     &  XMHH)**(-2)*(XMH02-XMHH2)**2*(XMH02+2D0*XMHH2)**2)/XMW2+
     &  (3D0*B00H0*CA**2*XMH02*(XMH0+XMHH)**(-2)*(XMH0-XMHH)**(-2)*
     &  (XMH02-XMHH2)**2*(CA**2*XMH02+XMHH2-CA**2*XMHH2))/XMW2+(3D0*
     &  B00HH*SA**2*(XMH0+XMHH)**(-2)*(XMH0-XMHH)**(-2)*XMHH2*
     &  (XMH02-XMHH2)**2*(CA**2*XMH02+XMHH2-CA**2*XMHH2))/XMW2+2D0*
     &  B00W*(CA**2*XMH02+XMHH2-CA**2*XMHH2+6D0*XMW2)+(2D0*BSWW*
     &  (XMH02**2-4D0*S*XMW2+12D0*XMW2**2))/XMW2+(B00Z*(CA**2*XCW2*
     &  XMH02+XCW2*XMHH2-CA**2*XCW2*XMHH2+6D0*XMW2)*XMZ2)/(XCW2*
     &  XMW2)-4D0*XCW2**(-2)*(2D0*XMW2+6D0*XCW2**2*XMW2+XCW2*XMZ2)+
     &  (BSZZ*XCW2**(-2)*(XCW2**2*XMH02**2-4D0*S*XCW2*XMW2+14D0*
     &  XMW2**2-2D0*XCW2*XMW2*XMZ2))/XMW2))/(32D0*PI*XSW2)

	seh0HH = 
     &  (CA*L12*PI**(-2)*SA*(3D0*B00H0*(1D0-2D0*CA**2)*XMH02-3D0*
     &  B00HH*(1D0-2D0*CA**2)*XMHH2+(3D0*BSH0H0*(1D0-2D0*CA**2)*
     &  XMH02*(2D0*XMH02+XMHH2))/((XMH0+XMHH)*(XMH0-XMHH))+(3D0*
     &  BSHHHH*(1D0-2D0*CA**2)*XMHH2*(XMH02+2D0*XMHH2))/((XMH0+
     &  XMHH)*(XMH0-XMHH))-(2D0*BSH0HH*(1D0-2D0*CA**2)*(2D0*XMH02+
     &  XMHH2)*(XMH02+2D0*XMHH2))/((XMH0+XMHH)*(XMH0-XMHH))-2D0*
     &  B00W*XMW2-B00Z*XMZ2))/16D0-(L12**2*PI**(-3)*(XMH0+XMHH)**(-
     &  2)*(XMH0-XMHH)**(-2)*((3D0*BSH0H0*SA**4*XMH02*(2D0*XMH02+
     &  XMHH2))/CA+3D0*BSHHHH*CA**3*XMHH2*(XMH02+2D0*XMHH2)+2D0*
     &  BSH0HH*CA*SA**2*(2D0*XMH02+XMHH2)*(XMH02+2D0*XMHH2)+(3D0*
     &  B00H0*SA**2*XMH02*(XMH02-CA**2*XMH02+CA**2*XMHH2))/CA+3D0*
     &  B00HH*CA*XMHH2*(XMH02-CA**2*XMH02+CA**2*XMHH2))*XMW2*XSW2)/
     &  (8D0*ALPHA*SA)+(ALPHA*CA*SA*((3D0*BSH0H0*CA**4*XMH02*(2D0*
     &  XMH02+XMHH2))/XMW2+(3D0*BSHHHH*SA**4*XMHH2*(XMH02+2D0*
     &  XMHH2))/XMW2+(2D0*BSH0HH*CA**2*SA**2*(2D0*XMH02+XMHH2)*
     &  (XMH02+2D0*XMHH2))/XMW2+(3D0*B00H0*CA**2*XMH02*(CA**2*XMH02+
     &  XMHH2-CA**2*XMHH2))/XMW2+(3D0*B00HH*SA**2*XMHH2*(CA**2*
     &  XMH02+XMHH2-CA**2*XMHH2))/XMW2+2D0*B00W*(CA**2*XMH02+XMHH2-
     &  CA**2*XMHH2+6D0*XMW2)+(2D0*BSWW*(XMH02*XMHH2-4D0*S*XMW2+
     &  12D0*XMW2**2))/XMW2+(B00Z*(CA**2*XCW2*XMH02+XCW2*XMHH2-CA**
     &  2*XCW2*XMHH2+6D0*XMW2)*XMZ2)/(XCW2*XMW2)-4D0*XCW2**(-2)*
     &  (2D0*XMW2+6D0*XCW2**2*XMW2+XCW2*XMZ2)+(BSZZ*XCW2**(-2)*
     &  (XCW2**2*XMH02*XMHH2-4D0*S*XCW2*XMW2+14D0*XMW2**2-2D0*XCW2*
     &  XMW2*XMZ2))/XMW2))/(32D0*PI*XSW2)

	seHHHH = 
     &  (L12*PI**(-2)*(-(18D0*BSHHHH*CA**2*SA**2*(XMH0+XMHH)**(-2)*
     &  (XMH0-XMHH)**(-2)*XMHH2**2*(XMH02-XMHH2))-2D0*BSH0H0*CA**2*
     &  SA**2*(XMH0+XMHH)**(-2)*(XMH0-XMHH)**(-2)*(2D0*XMH02+
     &  XMHH2)**2*(XMH02-XMHH2)+B00H0*(1D0-6D0*CA**2+6D0*CA**4)*
     &  XMH02*(XMH0+XMHH)**(-2)*(XMH0-XMHH)**(-2)*(XMH02-XMHH2)**2+
     &  6D0*B00HH*CA**2*SA**2*(XMH0+XMHH)**(-2)*(XMH0-XMHH)**(-2)*
     &  XMHH2*(XMH02-XMHH2)**2+4D0*BSH0HH*CA**2*SA**2*(XMH0+XMHH)**
     &  (-2)*(XMH0-XMHH)**(-2)*(XMH02-XMHH2)*(XMH02+2D0*XMHH2)**2+
     &  2D0*B00W*CA**2*XMW2+B00Z*CA**2*XMZ2))/16D0+(L12**2*PI**(-3)*
     &  (XMH0+XMHH)**(-2)*(XMH0-XMHH)**(-2)*(9D0*BSHHHH*CA**4*SA**(-
     &  2)*XMHH2**2+BSH0H0*SA**2*(2D0*XMH02+XMHH2)**2+2D0*BSH0HH*
     &  CA**2*(XMH02+2D0*XMHH2)**2+3D0*B00H0*XMH02*(XMH02-CA**2*
     &  XMH02+CA**2*XMHH2)+3D0*B00HH*CA**2*SA**(-2)*XMHH2*(XMH02-
     &  CA**2*XMH02+CA**2*XMHH2))*XMW2*XSW2)/(8D0*ALPHA)+(ALPHA*SA**
     &  2*((9D0*BSHHHH*SA**4*(XMH0+XMHH)**(-2)*(XMH0-XMHH)**(-2)*
     &  XMHH2**2*(XMH02-XMHH2)**2)/XMW2+(BSH0H0*CA**4*(XMH0+XMHH)**
     &  (-2)*(XMH0-XMHH)**(-2)*(2D0*XMH02+XMHH2)**2*(XMH02-XMHH2)**
     &  2)/XMW2+(2D0*BSH0HH*CA**2*SA**2*(XMH0+XMHH)**(-2)*(XMH0-
     &  XMHH)**(-2)*(XMH02-XMHH2)**2*(XMH02+2D0*XMHH2)**2)/XMW2+
     &  (3D0*B00H0*CA**2*XMH02*(XMH0+XMHH)**(-2)*(XMH0-XMHH)**(-2)*
     &  (XMH02-XMHH2)**2*(CA**2*XMH02+XMHH2-CA**2*XMHH2))/XMW2+(3D0*
     &  B00HH*SA**2*(XMH0+XMHH)**(-2)*(XMH0-XMHH)**(-2)*XMHH2*
     &  (XMH02-XMHH2)**2*(CA**2*XMH02+XMHH2-CA**2*XMHH2))/XMW2+2D0*
     &  B00W*(CA**2*XMH02+XMHH2-CA**2*XMHH2+6D0*XMW2)+(2D0*BSWW*
     &  (XMHH2**2-4D0*S*XMW2+12D0*XMW2**2))/XMW2+(B00Z*(CA**2*XCW2*
     &  XMH02+XCW2*XMHH2-CA**2*XCW2*XMHH2+6D0*XMW2)*XMZ2)/(XCW2*
     &  XMW2)-4D0*XCW2**(-2)*(2D0*XMW2+6D0*XCW2**2*XMW2+XCW2*XMZ2)+
     &  (BSZZ*XCW2**(-2)*(XCW2**2*XMHH2**2-4D0*S*XCW2*XMW2+14D0*
     &  XMW2**2-2D0*XCW2*XMW2*XMZ2))/XMW2))/(32D0*PI*XSW2)

	end

**********************************************************************
        subroutine xsehh_ferm_sesm(s,seh0h0,seh0HH,seHHHH)
**********************************************************************
*       unrenormalized neutral CP-even Higgs-boson self-energies
*       closed fermion loops only
*       THDM
*---------------------------------------------------------------------
*       24.5.16 Stefan Dittmaier
**********************************************************************
        implicit real*8 (a-z)
        complex*16 seh0h0,seh0HH,seHHHH
        complex*16 B0_,xB0_
        complex*16 B00l,B00u,B00d,Bsll,Bsdd,Bsuu 
	integer i

        include '../COMMON/param.inc'
        include '../COMMON/xparam.inc'
        include '../COMMON/param_sesm.inc'
        include '../COMMON/param_bsm.inc'

	seh0h0 = 0d0
	seh0HH = 0d0
	seHHHH = 0d0

	do 100 i=1,3

	B00l  =  xB0_(0D0,null, xML2(I),0)
	B00u  =  xB0_(0D0,null,xMQP2(I),0)
	B00d  =  xB0_(0D0,null,xMQM2(I),0)
	Bsll  =  xB0_(s, xML2(I),xML2(I),0)
	Bsdd  =  xB0_(s,xMQM2(I),xMQM2(I),0)
	Bsuu  =  xB0_(s,xMQP2(I),xMQP2(I),0)

	seh0h0 = seh0h0 
     &  -ALPHA*CLEPh0**2/(8D0*PI*XMW2*XSW2)
     &	*(2D0*B00L*XML2(I)**2+BSLL*XML2(I)*(-S+4D0*XML2(I)))
     &	-ALPHA*CDOh0**2/(8D0*PI*XMW2*XSW2)
     &	*(6D0*B00D*XMQM2(I)**2+3D0*BSDD*XMQM2(I)*(-S+4D0*XMQM2(I)))
     &	-ALPHA*CUPh0**2/(8D0*PI*XMW2*XSW2)
     &	*(6D0*B00U*XMQP2(I)**2+3D0*BSUU*XMQP2(I)*(-S+4D0*XMQP2(I)))

	seh0HH = seh0HH 
     &  -ALPHA*CLEPh0*CLEPHH/(8D0*PI*XMW2*XSW2)
     &	*(2D0*B00L*XML2(I)**2+BSLL*XML2(I)*(-S+4D0*XML2(I)))
     &	-ALPHA*CDOh0*CDOHH/(8D0*PI*XMW2*XSW2)
     &	*(6D0*B00D*XMQM2(I)**2+3D0*BSDD*XMQM2(I)*(-S+4D0*XMQM2(I)))
     &	-ALPHA*CUPh0*CUPHH/(8D0*PI*XMW2*XSW2)
     &	*(6D0*B00U*XMQP2(I)**2+3D0*BSUU*XMQP2(I)*(-S+4D0*XMQP2(I)))

	seHHHH = seHHHH 
     &  -ALPHA*CLEPHH**2/(8D0*PI*XMW2*XSW2)
     &	*(2D0*B00L*XML2(I)**2+BSLL*XML2(I)*(-S+4D0*XML2(I)))
     &	-ALPHA*CDOHH**2/(8D0*PI*XMW2*XSW2)
     &	*(6D0*B00D*XMQM2(I)**2+3D0*BSDD*XMQM2(I)*(-S+4D0*XMQM2(I)))
     &	-ALPHA*CUPHH**2/(8D0*PI*XMW2*XSW2)
     &	*(6D0*B00U*XMQP2(I)**2+3D0*BSUU*XMQP2(I)*(-S+4D0*XMQP2(I)))

100	continue
	
	end

**********************************************************************
        function xseww_sesm(s)
**********************************************************************
*       unrenormalized W self-energy
*       bosonic loops only
*       SESM
*---------------------------------------------------------------------
*       4.5.16 Stefan Dittmaier
**********************************************************************
        implicit real*8 (a-z)
        complex*16 B00A0,B00h0,B00HH,B00HP,B00W,B00Z 
        complex*16 BsA0HP,Bs0W,Bsh0W,BsHHW,BsWZ,Bsh0HP,BsHHHP 
        complex*16 B0A0HP,B0H0HP,B0H0W,B0HHHP,B0HHW,B0WZ   
        complex*16 DB0A0HP,DB00W,DB0h0W,DB0HHW,DB0WZ,DB0h0HP,DB0HHHP 
        complex*16 xseww_sesm,B0_,xB0_,xDB0_
        complex*16 B0,B1(1),B2(0:2,0:2),B3(0:2,0:2,2)
        complex*16 B4(0:2,0:2,0:2,0:2),B5(0:2,0:2,0:2,0:2,2)

        include '../COMMON/param.inc'
        include '../COMMON/xparam.inc'
        include '../COMMON/param_sesm.inc'
        include '../COMMON/param_bsm.inc'

        B00h0  = xB0_(0D0,null,xMh02,0)
        B00HH  = xB0_(0D0,null,xMHH2,0)
        B00W   = xB0_(0D0,null,xMW2,0)
        B00Z   = xB0_(0D0,null,xMZ2,0)
        Bs0W   = xB0_(S,null,xMW2,0)
        Bsh0W  = xB0_(S,xMh02,xMW2,0)
        BsHHW  = xB0_(S,xMHH2,xMW2,0)
        BsWZ   = xB0_(S,xMW2,xMZ2,0)

	B0H0W  = xB0_(0d0,xMh02,xMW2,0)
	B0HHW  = xB0_(0d0,xMHH2,xMW2,0)
	B0WZ   = xB0_(0d0,xMW2,xMZ2,0)

        DB00W   = xDB0_(0d0,null,xMW2,0)
        DB0h0W  = xDB0_(0d0,xMh02,xMW2,0)
        DB0HHW  = xDB0_(0d0,xMHH2,xMW2,0)
        DB0WZ   = xDB0_(0d0,xMW2,xMZ2,0)

        if (s.ne.0d0) then
        xseww_sesm = ALPHA/PI*(
     &  CA2*( (-3D0*xMh02-57D0*xMW2-2D0*S+3D0*xMh02*xSW2+54D0*xMW2*xSW2
     &      +2D0*S*xSW2)/72D0/xCW2/xSW2
     &    -xMh02*(xMh02-xMW2-2D0*S)/xSW2*B00h0/(48D0*S)
     &    +xMW2/xSW2/xCW2*(xMh02-xMW2+20D0*S-xMh02*xSW2+2D0*xMW2*xSW2
     &      -20D0*S*xSW2)*B00W/(48D0*S)
     &    +(xMh0**4-2D0*xMh02*xMW2+xMW**4-2D0*xMh02*S+10D0*xMW2*S+S**2)
     &      /xSW2*Bsh0W/(48D0*S) )
     &  +SA2*( (-3D0*xMHH2-57D0*xMW2-2D0*S+3D0*xMHH2*xSW2+54D0*xMW2*xSW2
     &      +2D0*S*xSW2)/72D0/xCW2/xSW2
     &    -xMHH2*(xMHH2-xMW2-2D0*S)/xSW2*B00HH/(48D0*S)
     &    +xMW2/xSW2/xCW2*(xMHH2-xMW2+20D0*S-xMHH2*xSW2+2D0*xMW2*xSW2
     &      -20D0*S*xSW2)*B00W/(48D0*S)
     &    +(xMHH**4-2D0*xMHH2*xMW2+xMW**4-2D0*xMHH2*S+10D0*xMW2*S+S**2)
     &      /xSW2*BsHHW/(48D0*S) )
     &  +xMW2/xSW2/xCW**4*(-9D0+8D0*xSW2)*(-2D0*S+xMW2*xSW2+2D0*S*xSW2)
     &    *B00Z/(48D0*S)
     &  -(-xMW**4+2D0*xMW2*S+5D0*S**2)*Bs0W/(6D0*S)
     &  +(-60D0*xMW2*S-39D0*S**2+146D0*xMW2*S*xSW2+118D0*S**2*xSW2
     &    +9D0*xMW**4*xSW**4-102D0*xMW2*S*xSW**4-119D0*S**2*xSW**4
     &    -8D0*xMW**4*xSW**6+16D0*xMW2*S*xSW**6+40D0*S**2*xSW**6)
     &    /xCW**4/xSW2*BsWZ/(48D0*S)       )
	else
        xseww_sesm = ALPHA/(48D0*PI)*(
     &  CA2*(-2D0/xCW2/xSW2*(xMh02+19D0*xMW2-xMh02*xSW2-18D0*xMW2*xSW2)
     &    +8D0*xMh02*xMW2/xSW2*B00h0/(xMh02-xMW2)
     &    +4D0*xMW2/xSW**4*(15D0*xMh02-15D0*xMW2-16D0*xMh02*xSW2
     &     +14D0*xMW2*xSW2)*B00W/(xMh02-xMW2)
     &    -4D0/xCW2*xMW2/xSW**4*(5D0-2D0*xSW2)*(3D0-4D0*xSW2)*B00Z
     &    +8D0*xMW**4*DB00W+(xMh02-xMW2)**2/xSW2*DB0h0W )
     &  +SA2*(-2D0/xCW2/xSW2*(xMHH2+19D0*xMW2-xMHH2*xSW2-18D0*xMW2*xSW2)
     &    +8D0*xMHH2*xMW2/xSW2*B00HH/(xMHH2-xMW2)
     &    +4D0*xMW2/xSW**4*(15D0*xMHH2-15D0*xMW2-16D0*xMHH2*xSW2
     &     +14D0*xMW2*xSW2)*B00W/(xMHH2-xMW2)
     &    -4D0/xCW2*xMW2/xSW**4*(5D0-2D0*xSW2)*(3D0-4D0*xSW2)*B00Z
     &    +8D0*xMW**4*DB00W+(xMHH2-xMW2)**2/xSW2*DB0HHW )
     &  +xMW**4/xCW**4*xSW2*(9D0-8D0*xSW2)*DB0WZ        )

	endif

        end

**********************************************************************
        subroutine xsevv_sesm(s,seaa,seaz,sezz)
**********************************************************************
*       unrenormalized neutral boson self-energies
*       bosonic loops only
*       THDM
*---------------------------------------------------------------------
*       4.5.16 Stefan Dittmaier
**********************************************************************
        implicit real*8 (a-z)
        complex*16 seaa,seaz,sezz
        complex*16 B0_,xB0_,xDB0_
        complex*16 B00H0,B00HH,B00A0,B00HP,B00W,B00Z 
        complex*16 BSHPHP,BSWW,BSH0Z,BSHHZ,BSA0H0,BSA0HH
        complex*16 B0A0H0,B0A0HH,B0H0Z,B0HHZ,B0HPHP,B0WW   
        complex*16 DB0H0Z,DB0HHZ,DB0A0H0,DB0A0HH
        include '../COMMON/param.inc'
        include '../COMMON/xparam.inc'
        include '../COMMON/param_sesm.inc'
        include '../COMMON/param_bsm.inc'

        B00H0  = xB0_(0D0,null,xMH02,0)	
        B00HH  = xB0_(0D0,null,xMHH2,0)
        B00W   = xB0_(0D0,null,xMW2,0)	
        B00Z   = xB0_(0D0,null,xMZ2,0)
        BSWW   = xB0_(S,xMW2,xMW2,0)	
        BSH0Z  = xB0_(S,xMH02,xMZ2,0)	
        BSHHZ  = xB0_(S,xMHH2,xMZ2,0)

	B0H0Z  = xB0_(0d0,xMH02,xMZ2,0)	
	B0HHZ  = xB0_(0d0,xMHH2,xMZ2,0)
	B0WW   = xB0_(0d0,xMW2,xMW2,0)	

        DB0H0Z  = xDB0_(0D0,XMH02,XMZ2,0)	
        DB0HHZ  = xDB0_(0D0,XMHH2,XMZ2,0)	

        seaa = -ALPHA/(4D0*PI)*(
     &  -4d0*xMW2*(B00W-1d0) + (3D0*S+4D0*xMW2)*BSWW )

        seaz = ALPHA/(72D0*xCW*PI*xSW)*(
     &  2D0*S+12D0*(1D0-6D0*xCW2)*xMW2*(B00W-1D0)
     &  +3D0*(8D0*(1D0+3D0*xCW2)*xMW2+S+18D0*xCW2*S)*BSWW)

        if (s.ne.0d0) then
          sezz = ALPHA/PI*(
     &	CA2*( (-3D0*xMh02-57D0*xMZ2-2D0*S+174D0*xMZ2*xSW2+4D0*S*xSW2
     &      -192D0*xMZ2*xSW**4+72D0*xMZ2*xSW**6)/72D0/xCW2/xSW2
     &    -xMh02*(xMh02-xMZ2-2D0*S)/xSW2/xCW2*B00h0/(48D0*S)
     &    -xMZ2*(-xMh02+xMZ2-2D0*S)/xSW2/xCW2*B00Z/(48D0*S)
     &    +(xMh0**4-2D0*xMh02*xMZ2+xMZ**4-2D0*xMh02*S+10D0*xMZ2*S+S**2)
     &      /xSW2/xCW2*BSh0Z/(48D0*S) )
     &	+SA2*( (-3D0*xMHH2-57D0*xMZ2-2D0*S+174D0*xMZ2*xSW2+4D0*S*xSW2
     &      -192D0*xMZ2*xSW**4+72D0*xMZ2*xSW**6)/72D0/xCW2/xSW2
     &    -xMHH2*(xMHH2-xMZ2-2D0*S)/xSW2/xCW2*B00HH/(48D0*S)
     &    -xMZ2*(-xMHH2+xMZ2-2D0*S)/xSW2/xCW2*B00Z/(48D0*S)
     &    +(xMHH**4-2D0*xMHH2*xMZ2+xMZ**4-2D0*xMHH2*S+10D0*xMZ2*S+S**2)
     &      /xSW2/xCW2*BSHHZ/(48D0*S) )
     &    +xMZ2/xSW2*(9D0-20D0*xSW2+12D0*xSW**4)*B00W/12D0
     &    +(-60D0*xMZ2-39D0*S+188D0*xMZ2*xSW2+76D0*S*xSW2
     &      -176D0*xMZ2*xSW**4-36D0*S*xSW**4+48D0*xMZ2*xSW**6)
     &      /xSW2/xCW2*BSWW/48D0   )
        else
          sezz = ALPHA/(48D0*PI*XCW2*XSW2)*(
     &	CA2*( -2D0*(XMh02+(1D0+12D0*XCW2-24D0*XCW2**2)*XMZ2)
     &    +8D0*XMh02*XMW2*B00h0/(XCW2*(XMh02-XMZ2))
     &    +4D0*XMZ2*(XMh02-3D0*XMZ2)*B00Z/(XMh02-XMZ2)
     &    +(XMh02-XMZ2)**2*DB0h0Z )
     &	+SA2*( -2D0*(XMHH2+(1D0+12D0*XCW2-24D0*XCW2**2)*XMZ2)
     &    +8D0*XMHH2*XMW2*B00HH/(XCW2*(XMHH2-XMZ2))
     &    +4D0*XMZ2*(XMHH2-3D0*XMZ2)*B00Z/(XMHH2-XMZ2)
     &    +(XMHH2-XMZ2)**2*DB0HHZ )
     &    -24D0*XMW2*(XCW2-XSW2)*B00W  )
        endif

        end

************************************************************************
        subroutine xcalcrenc_sesm
************************************************************************
*	calculate renormalization constants
*	bosonic loops only
*	SESM
*-----------------------------------------------------------------------
*       6.2.17 Stefan Dittmaier
************************************************************************

        use COLLIER

        implicit real*8 (a-z)
	complex*16 xseww_sesm,seaa,seaz,sezz,dZff_a
	complex*16 xseaa_sesm,xsehp_sesm,seh0HH_mh02,seh0HH_mHH2
        complex*16 seh0h0,seh0HH,seHHHH,seh0HH_mh02_div
	complex*16 xA0_,xB0_,xDB0_,xB1_,B1Z,B1W
	complex*16 B00A0,B00H0,B00HH,B00HP,B00W,B00Z   
	complex*16 BW0W,BWWZ,BWH0W,BWHHW,BWA0HP,BWH0HP,BWHHHP
	complex*16 BZWW,BZA0H0,BZA0HH,BZH0Z,BZHHZ,BZHPHP 
	complex*16 BH0WW,BHHWW,BH0ZZ,BHHZZ    
	complex*16 DBW0W,DBWH0W,DBWHHW,DBWA0HP,DBWH0HP,DBWHHHP,DBWWZ  
	complex*16 DBZA0H0,DBZA0HH,DBZH0Z,DBZHHZ,DBZHPHP,DBZWW  
	complex*16 DB0WW,DB0HPHP
	complex*16 BSA0Z,BSHPW,BSWW,BSZZ    
	complex*16 DBSA0A0,DBSA0Z,DBSH0H0,DBSH0HH,DBSHHHH,DBSHPHP,DBSHPW
	complex*16 DBSWW,DBSZZ   
	complex*16 seww0
        complex*16 gnnl,geer,geel,gffr(4),gffl(4)
	complex*16 th0,tHH,th0div,tHHdiv
        complex*16 dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw
        complex*16 dmh02,dmHH2,dZh0,dZHH,dZh0HH,dZHHh0,dsa,dl12
        complex*16 dZeer,dZeel,dZnnl,dZffr(4),dZffl(4)
        complex*16 ct_aww,ct_zww,ct_wen,ct_wf1f2,ct_wf3f4
        complex*16 ct_annl,ct_aeer,ct_aeel,ct_affr(4),ct_affl(4)
        complex*16 ct_znnl,ct_zeer,ct_zeel,ct_zffr(4),ct_zffl(4)
        complex*16 ct_h0ww,ct_HHww,ct_h0zz,ct_HHzz,ct_h0za,ct_HHza
        complex*16 dmw2tad,dmz2tad,dtbtad
        complex*16 dZh0div,dZHHdiv,dZh0HHdiv,dZHHh0div
        complex*16 ddZh0bfm,ddZHHbfm,ddZHHh0bfm,ddZh0HHbfm,dl1
        real*8 iw3f(4)
	integer i,dir(7)

        include '../COMMON/param.inc'
        include '../COMMON/options.inc'
        include '../COMMON/xparam.inc'
        include '../COMMON/processpar.inc'
        include '../COMMON/param_sesm.inc'
        include '../COMMON/param_bsm.inc'
        include '../COMMON/model.inc'
        COMMON/UV/MUDIM2
        COMMON/IR/LAMBDA,LAMBDA2
        common/xrenc_sesm/
     &	       dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw,
     &	       dmh02,dmHH2,dZh0,dZHH,dZh0HH,dZHHh0,dsa,dl12,
     &         dZeer,dZeel,dZnnl,dZffr,dZffl,
     &         ct_aww,ct_zww,ct_wen,ct_wf1f2,ct_wf3f4,
     &         ct_annl,ct_aeer,ct_aeel,ct_affr,ct_affl,
     &         ct_znnl,ct_zeer,ct_zeel,ct_zffr,ct_zffl,
     &         ct_h0ww,ct_HHww,ct_h0zz,ct_HHzz,ct_h0za,ct_HHza

c collier parameters
	real*8 deltaUV,muv2,delta1ir,delta2ir,mir2

	call GetMuUV2_cll(muv2)
	call GetDeltaUV_cll(deltaUV)
	mudim2 = exp(deltauv + log(muv2))
        call GetDeltaIR_cll(delta1ir,delta2ir)
        call GetMuIR2_cll(mir2)
	lambda2 = exp(delta1ir + log(mir2))
	lambda  = sqrt(lambda2)

	B00H0   = xB0_(0d0,null,xmh02,0)
	B00HH   = xB0_(0d0,null,xmHH2,0)
	B00W    = xB0_(0d0,null,xmw2,0)
	B00Z    = xB0_(0d0,null,xmz2,0)
	BW0W    = xB0_(mw2,null,xmw2,0)
	BWWZ    = xB0_(mw2,xmw2,xmz2,0)
	BWH0W   = xB0_(mw2,xmh02,xmw2,0)
	BWHHW   = xB0_(mw2,xmHH2,xmw2,0)
	BZWW    = xB0_(mz2,xmw2,xmw2,0)
	BZH0Z   = xB0_(mz2,xmh02,xmz2,0)
	BZHHZ   = xB0_(mz2,xmHH2,xmz2,0)

	BH0WW    = xB0_(mh02,xmw2,xmw2,0)
	BHHWW    = xB0_(mhh2,xmw2,xmw2,0)
	BH0ZZ    = xB0_(mh02,xmz2,xmz2,0)
	BHHZZ    = xB0_(mhh2,xmz2,xmz2,0)

	DB0WW   = xDB0_(0d0,xmw2,xmw2,0)
	DBW0W   = xDB0_(mw2,null,xmw2,0)
	DBWH0W  = xDB0_(mw2,xmh02,xmw2,0)
	DBWHHW  = xDB0_(mw2,xmHH2,xmw2,0)
	DBWWZ   = xDB0_(mw2,xmw2,xmz2,0)
	DBZH0Z  = xDB0_(mz2,xmh02,xmz2,0)
	DBZHHZ  = xDB0_(mz2,xmHH2,xmz2,0)
	DBZWW   = xDB0_(mz2,xmw2,xmw2,0)

        B1W   = xB1_(0D0,null,xMW2,0)
        B1Z   = xB1_(0D0,null,xMZ2,0)

	dmw2 = xseww_sesm(mw2)

	call xsevv_sesm(mz2,seaa,seaz,sezz)
	dmz2 = sezz
	dZaz = -2d0*seaz/mz2

	call xsevv_sesm(0d0,seaa,seaz,sezz)

	dZza = 2d0*seaz/xmz2

	dZaz = dZaz + (xmz2-mz2)/mz2*dZza

        dZaa = -ALPHA/(4D0*PI)*(3D0-3D0*B00W-4D0*xMW2*DB0WW)

	x = mw2
        dZw = -ALPHA/(144D0*PI)*(
     &  CA2*( -(4D0/XSW2)+(3D0*X**(-2)*XMh02*(XMh02-XMW2)*B00h0)/XSW2
     &  -(3D0*X**(-2)*XMW2*(XMh02-2D0*XMW2+XMZ2)*B00W)/XSW2
     &  +(3D0*X**(-2)*(X**2-XMh02**2+2D0*XMh02*XMW2-XMW2**2)*BWh0W)/XSW2
     &  +3D0*(X**2+XMh02**2+10D0*X*XMW2+XMW2**2-2D0*XMh02*(X+XMW2))
     &    *DBWh0W/(X*XSW2) )
     &  +SA2*( -(4D0/XSW2)+(3D0*X**(-2)*XMHH2*(XMHH2-XMW2)*B00HH)/XSW2
     &  -(3D0*X**(-2)*XMW2*(XMHH2-2D0*XMW2+XMZ2)*B00W)/XSW2
     &  +(3D0*X**(-2)*(X**2-XMHH2**2+2D0*XMHH2*XMW2-XMW2**2)*BWHHW)/XSW2
     &  +3D0*(X**2+XMHH2**2+10D0*X*XMW2+XMW2**2-2D0*XMHH2*(X+XMW2))
     &    *DBWHHW/(X*XSW2) )
     &  -(3D0*X**(-2)*(1D0+8D0*XCW2)*XMZ2*(XMW2-XMZ2)*B00Z)/XSW2
     &  -24D0*X**(-2)*(5D0*X**2+XMW2**2)*BW0W
     &  -3D0*X**(-2)*XMW2*XMZ2**(-2)*(8D0*XMW2**3-X**2*XMZ2
     &    -15D0*XMW2**2*XMZ2+XMZ2**3+XMW2*(40D0*X**2+6D0*XMZ2**2))*BWWZ
     &    /(XCW2*XSW2)
     &  +(24D0*(-(5D0*X**2)-2D0*X*XMW2+XMW2**2)*DBW0W)/X
     &  +(3D0*XMW2*XMZ2**(-2)*(8D0*XMW2**3-XMW2**2*(16D0*X+15D0*XMZ2)
     &    +XMZ2*(X**2+10D0*X*XMZ2+XMZ2**2)+XMW2*(-(40D0*X**2)
     &    -54D0*X*XMZ2+6D0*XMZ2**2))*DBWWZ)/(X*XCW2*XSW2)
     &  )

	x = mz2
        dZzz = -ALPHA/(144D0*PI*XCW2*XSW2)*(
     &  CA2*( +3D0*X**(-2)*XMh02*(XMh02-XMZ2)*B00h0
     &  -3D0*X**(-2)*XMZ2*(XMh02-XMZ2)*B00Z
     &  +3D0*X**(-2)*(X**2-XMh02**2+2D0*XMh02*XMZ2-XMZ2**2)*BZh0Z
     &  +(3D0*(X**2+XMh02**2+10D0*X*XMZ2+XMZ2**2-2D0*XMh02*(X+XMZ2))
     &    *DBZh0Z)/X )
     &  +SA2*( +3D0*X**(-2)*XMHH2*(XMHH2-XMZ2)*B00HH
     &  -3D0*X**(-2)*XMZ2*(XMHH2-XMZ2)*B00Z
     &  +3D0*X**(-2)*(X**2-XMHH2**2+2D0*XMHH2*XMZ2-XMZ2**2)*BZHHZ
     &  +(3D0*(X**2+XMHH2**2+10D0*X*XMZ2+XMZ2**2-2D0*XMHH2*(X+XMZ2))
     &    *DBZHHZ)/X )
     &  -(4D0*(1D0-2D0*XSW2))
     &  -3D0*(39D0-76D0*XSW2+36D0*XSW2**2)*BZWW
     &  -3D0*(4D0*XMW2*(15D0-32D0*XSW2+12D0*XSW2**2)
     &    +X*(39D0-76D0*XSW2+36D0*XSW2**2))*DBZWW)

        call xsehh_sesm(mh02,seh0h0,seh0HH,seHHHH)
	dmh02  = seh0h0
	seh0HH_mh02 = seh0HH

        call xsehh_sesm(mHH2,seh0h0,seh0HH,seHHHH)
	dmHH2  = seHHHH
	seh0HH_mHH2 = seh0HH

	dZh0HH  = -2d0*seh0HH_mHH2/(mHH2-mh02)
	dZHHh0  = -2d0*seh0HH_mh02/(mh02-mHH2)

	s = mh02
        BSWW    = xB0_(S,xMW2,xMW2,0)	
        BSZZ    = xB0_(S,xMZ2,xMZ2,0)	
        DBSH0H0 = xDB0_(S,xMH02,xMH02,0)	
        DBSH0HH = xDB0_(S,xMH02,xMHH2,0)	
        DBSHHHH = xDB0_(S,xMHH2,xMHH2,0)	
        DBSWW   = xDB0_(S,xMW2,xMW2,0)	
        DBSZZ   = xDB0_(S,xMZ2,xMZ2,0)	

	dZh0  = 
     &  -( (L12*PI**(-2)*(18D0*CA**2*DBSH0H0*SA**2*XMH02**2*(XMH0+
     &  XMHH)**(-2)*(XMH0-XMHH)**(-2)*(XMH02-XMHH2)-4D0*CA**2*
     &  DBSH0HH*SA**2*(XMH0+XMHH)**(-2)*(XMH0-XMHH)**(-2)*(2D0*
     &  XMH02+XMHH2)**2*(XMH02-XMHH2)+2D0*CA**2*DBSHHHH*SA**2*(XMH0+
     &  XMHH)**(-2)*(XMH0-XMHH)**(-2)*(XMH02-XMHH2)*(XMH02+2D0*
     &  XMHH2)**2))/16D0+(L12**2*PI**(-3)*(XMH0+XMHH)**(-2)*(XMH0-
     &  XMHH)**(-2)*(9D0*CA**(-2)*DBSH0H0*SA**4*XMH02**2+2D0*
     &  DBSH0HH*SA**2*(2D0*XMH02+XMHH2)**2+CA**2*DBSHHHH*(XMH02+2D0*
     &  XMHH2)**2)*XMW2*XSW2)/(8D0*ALPHA)+(ALPHA*CA**2*(-(8D0*BSWW)-
     &  (4D0*BSZZ)/XCW2+(9D0*CA**4*DBSH0H0*XMH02**2*(XMH0+XMHH)**(-
     &  2)*(XMH0-XMHH)**(-2)*(XMH02-XMHH2)**2)/XMW2+(2D0*CA**2*
     &  DBSH0HH*SA**2*(XMH0+XMHH)**(-2)*(XMH0-XMHH)**(-2)*(2D0*
     &  XMH02+XMHH2)**2*(XMH02-XMHH2)**2)/XMW2+(DBSHHHH*SA**4*(XMH0+
     &  XMHH)**(-2)*(XMH0-XMHH)**(-2)*(XMH02-XMHH2)**2*(XMH02+2D0*
     &  XMHH2)**2)/XMW2+(2D0*DBSWW*(XMH02**2-4D0*S*XMW2+12D0*XMW2**
     &  2))/XMW2+(DBSZZ*XCW2**(-2)*(XCW2**2*XMH02**2-4D0*S*XCW2*
     &  XMW2+14D0*XMW2**2-2D0*XCW2*XMW2*XMZ2))/XMW2))/(32D0*PI*XSW2) )

	dZh0div = ( deltauv + log(muv2/mren2bsm) )
     &		  *ALPHA*CA2*(1D0+2D0*XCW2)/(8D0*PI*XCW2*XSW2)

	s = mHH2
        BSWW    = xB0_(S,xMW2,xMW2,0)	
        BSZZ    = xB0_(S,xMZ2,xMZ2,0)	
        DBSH0H0 = xDB0_(S,xMH02,xMH02,0)	
        DBSH0HH = xDB0_(S,xMH02,xMHH2,0)	
        DBSHHHH = xDB0_(S,xMHH2,xMHH2,0)	
        DBSWW   = xDB0_(S,xMW2,xMW2,0)	
        DBSZZ   = xDB0_(S,xMZ2,xMZ2,0)	

	dZHH  = 
     &  -( (L12*PI**(-2)*(-(18D0*CA**2*DBSHHHH*SA**2*(XMH0+XMHH)**(-2)*
     &  (XMH0-XMHH)**(-2)*XMHH2**2*(XMH02-XMHH2))-2D0*CA**2*DBSH0H0*
     &  SA**2*(XMH0+XMHH)**(-2)*(XMH0-XMHH)**(-2)*(2D0*XMH02+
     &  XMHH2)**2*(XMH02-XMHH2)+4D0*CA**2*DBSH0HH*SA**2*(XMH0+
     &  XMHH)**(-2)*(XMH0-XMHH)**(-2)*(XMH02-XMHH2)*(XMH02+2D0*
     &  XMHH2)**2))/16D0+(L12**2*PI**(-3)*(XMH0+XMHH)**(-2)*(XMH0-
     &  XMHH)**(-2)*(9D0*CA**4*DBSHHHH*SA**(-2)*XMHH2**2+DBSH0H0*
     &  SA**2*(2D0*XMH02+XMHH2)**2+2D0*CA**2*DBSH0HH*(XMH02+2D0*
     &  XMHH2)**2)*XMW2*XSW2)/(8D0*ALPHA)+(ALPHA*SA**2*(-(8D0*BSWW)-
     &  (4D0*BSZZ)/XCW2+(9D0*DBSHHHH*SA**4*(XMH0+XMHH)**(-2)*(XMH0-
     &  XMHH)**(-2)*XMHH2**2*(XMH02-XMHH2)**2)/XMW2+(CA**4*DBSH0H0*
     &  (XMH0+XMHH)**(-2)*(XMH0-XMHH)**(-2)*(2D0*XMH02+XMHH2)**2*
     &  (XMH02-XMHH2)**2)/XMW2+(2D0*CA**2*DBSH0HH*SA**2*(XMH0+
     &  XMHH)**(-2)*(XMH0-XMHH)**(-2)*(XMH02-XMHH2)**2*(XMH02+2D0*
     &  XMHH2)**2)/XMW2+(2D0*DBSWW*(XMHH2**2-4D0*S*XMW2+12D0*XMW2**
     &  2))/XMW2+(DBSZZ*XCW2**(-2)*(XCW2**2*XMHH2**2-4D0*S*XCW2*
     &  XMW2+14D0*XMW2**2-2D0*XCW2*XMW2*XMZ2))/XMW2))/(32D0*PI*XSW2) )

	dZHHdiv = ( deltauv + log(muv2/mren2bsm) )
     &            *ALPHA*SA2*(1D0+2D0*XCW2)/(8D0*PI*XCW2*XSW2)

	s = mh02
	seh0HH_mh02_div = ( deltauv + log(muv2/mren2bsm) )
     &  *( -((CA*L12*PI**(-2)*SA*(-(3D0*XCW2*XMH0**2*XMH02)+6D0*CA**2*
     &  XCW2*XMH0**2*XMH02-2D0*XCW2*XMH02**2+4D0*CA**2*XCW2*XMH02**
     &  2+3D0*XCW2*XMH02*XMHH**2-6D0*CA**2*XCW2*XMH02*XMHH**2+3D0*
     &  XCW2*XMH0**2*XMHH2-6D0*CA**2*XCW2*XMH0**2*XMHH2+4D0*XCW2*
     &  XMH02*XMHH2-8D0*CA**2*XCW2*XMH02*XMHH2-3D0*XCW2*XMHH**2*
     &  XMHH2+6D0*CA**2*XCW2*XMHH**2*XMHH2-2D0*XCW2*XMHH2**2+4D0*
     &  CA**2*XCW2*XMHH2**2+XMH0**2*XMW2+2D0*XCW2*XMH0**2*XMW2-
     &  XMHH**2*XMW2-2D0*XCW2*XMHH**2*XMW2))/(16D0*XCW2*(XMH0+XMHH)*
     &  (XMH0-XMHH)))-(L12**2*PI**(-3)*(XMH0+XMHH)**(-2)*(XMH0-
     &  XMHH)**(-2)*(9D0*XMH02**2-14D0*CA**2*XMH02**2+5D0*CA**4*
     &  XMH02**2+3D0*XMH02*XMHH2+10D0*CA**2*XMH02*XMHH2-10D0*CA**4*
     &  XMH02*XMHH2+4D0*CA**2*XMHH2**2+5D0*CA**4*XMHH2**2)*XMW2*
     &  XSW2)/(8D0*ALPHA*CA*SA)+(ALPHA*CA*SA*XCW2**(-2)*(4D0*CA**2*
     &  XCW2**2*XMH02**2+5D0*CA**4*XCW2**2*XMH02**2+6D0*XCW2**2*
     &  XMH02*XMHH2+10D0*CA**2*XCW2**2*XMH02*XMHH2-10D0*CA**4*XCW2**
     &  2*XMH02*XMHH2+9D0*XCW2**2*XMHH2**2-14D0*CA**2*XCW2**2*
     &  XMHH2**2+5D0*CA**4*XCW2**2*XMHH2**2-4D0*S*XCW2*XMW2-8D0*S*
     &  XCW2**2*XMW2+CA**2*XCW2*XMH02*XMW2+2D0*CA**2*XCW2**2*XMH02*
     &  XMW2+XCW2*XMHH2*XMW2-CA**2*XCW2*XMHH2*XMW2+2D0*XCW2**2*
     &  XMHH2*XMW2-2D0*CA**2*XCW2**2*XMHH2*XMW2+18D0*XMW2**2+36D0*
     &  XCW2**2*XMW2**2))/(32D0*PI*XMW2*XSW2) )

	th0 = 
     &  (L12*PI**(-2)*((3D0*B00H0*SA**2*XMH02**2)/CA+B00HH*CA*XMHH2*
     &  (XMH02+2D0*XMHH2))*XMW*XSW)/(8D0*EL*(XMH0+XMHH)*(XMH0-
     &  XMHH))+(CA*EL*PI**(-2)*((3D0*B00H0*CA**2*XMH02**2)/XMW+
     &  (B00HH*SA**2*XMHH2*(XMH02+2D0*XMHH2))/XMW+2D0*B00W*XMW*
     &  (XMH02+6D0*XMW2)+(B00Z*(XCW2*XMH02+6D0*XMW2)*XMZ2)/(XCW2*
     &  XMW)-(4D0*XMW*(2D0*XCW2*XMW2+XMZ2))/XCW2))/(64D0*XSW)

	tHH = 
     &  -((L12*PI**(-2)*(3D0*B00HH*CA**2*XMHH2**2+B00H0*SA**2*XMH02*
     &  (2D0*XMH02+XMHH2))*XMW*XSW)/(8D0*EL*SA*(XMH0+XMHH)*(XMH0-
     &  XMHH)))+(EL*PI**(-2)*SA*((3D0*B00HH*SA**2*XMHH2**2)/XMW+
     &  (B00H0*CA**2*XMH02*(2D0*XMH02+XMHH2))/XMW+2D0*B00W*XMW*
     &  (XMHH2+6D0*XMW2)+(B00Z*(XCW2*XMHH2+6D0*XMW2)*XMZ2)/(XCW2*
     &  XMW)-(4D0*XMW*(2D0*XCW2*XMW2+XMZ2))/XCW2))/(64D0*XSW)

 	th0div = ( deltauv + log(muv2/mren2bsm) )
     &  *( (L12*PI**(-2)*((3D0*SA**2*XMH02**2)/CA+CA*XMHH2*(XMH02+2D0*
     &  XMHH2))*XMW*XSW)/(8D0*EL*(XMH0+XMHH)*(XMH0-XMHH))+(CA*EL*
     &  PI**(-2)*((3D0*CA**2*XMH02**2)/XMW+(SA**2*XMHH2*(XMH02+2D0*
     &  XMHH2))/XMW+2D0*XMW*(XMH02+6D0*XMW2)+((XCW2*XMH02+6D0*XMW2)*
     &  XMZ2)/(XCW2*XMW)))/(64D0*XSW) )

	tHHdiv = ( deltauv + log(muv2/mren2bsm) )
     &  *( -((L12*PI**(-2)*(3D0*CA**2*XMHH2**2+SA**2*XMH02*(2D0*XMH02+
     &  XMHH2))*XMW*XSW)/(8D0*EL*SA*(XMH0+XMHH)*(XMH0-XMHH)))+(EL*
     &  PI**(-2)*SA*((3D0*SA**2*XMHH2**2)/XMW+(CA**2*XMH02*(2D0*
     &  XMH02+XMHH2))/XMW+2D0*XMW*(XMHH2+6D0*XMW2)+((XCW2*XMHH2+6D0*
     &  XMW2)*XMZ2)/(XCW2*XMW)))/(64D0*XSW) )

	seww0 =  xseww_sesm(0d0)

c modifications for complex renormalization
        dmw2 = dmw2 + dcmplx(0d0,mw*gw*alpha/pi)
        dmw2 = dmw2 - (xmw2-mw2)*dZw
        dmz2 = dmz2 - (xmz2-mz2)*dZzz

c dependent parameters
        dsw  = xcw2/2d0/xsw*( dmz2/xmz2 - dmw2/xmw2 )

	drbos = -dZaa-2d0*dsw/xsw+(seww0-dmw2)/xmw2+xcw/xsw*dZza
     &		+alpha/4d0/pi/xsw2*(6d0+(7d0-4d0*xsw2)
     &			/2d0/xsw2*log(xcw2))

	if ((qalp.eq.0).or.(qalp.eq.2)) then
	  dZe = -dZaa/2d0-dZza*xsw/2d0/xcw
	elseif (qalp.eq.1) then
	  dZe = -dZaa/2d0-dZza*xsw/2d0/xcw - drbos/2d0
	endif

cxxx Test!!!!!!!
c	th0div = th0
c	tHHdiv = tHH

c SESM Higgs sector renormalization
	dl12  = ( deltauv + log(muv2/mren2bsm) ) * l12
     &     *( - 3d0/2d0*ALPHA*(1D0+2D0*XCW2)/(8D0*PI*XCW2*XSW2)
     &        + l12/4d0/pi**2
     &        + 3d0/32d0/pi**2 * (ca2*mh02+sa2*mhh2)/2d0/xmw2/xsw2*el**2
     &        + 3d0/4d0/pi**2 * 2d0*(sa2*mh02+ca2*mhh2)*l12**2
     &	                      * xmw2*xsw2/el**2/(mhh2-mh02)**2/sa2/ca2 )
	dl1 = ( deltauv + log(muv2/mren2bsm) ) * (
     &		L12**2/(16*Pi**2)
     &		+ (9d0*L12**4*xMW**4*(CA2*MHH2+Mh02*SA2)**2*xSW**4)
     &		  /(16d0*ALPHA**2*CA**4*(Mh02-MHH2)**4*Pi**4*SA**4) )

c scheme 0: alpha MSbar (running la12)
	dZHHh0div = -2d0*seh0HH_mh02_div/(mh02-mHH2)
	dsa_bos_RSsesm(0)  = ca*( dZHHh0div/2d0
     &	                      +s2a/4d0/c2a*(dZHHdiv-dZh0div) )
	dl12_bos_RSsesm(0) = dl12

c scheme 1: alpha MSbar a la FJ (running la12) --  implemented in "t-variant" !
	dZHHh0div = -2d0/(mh02-mHH2)*(seh0HH_mh02_div
     &               + el*(th0div*Ch0h0HH/xMh02+tHHdiv*Ch0HHHH/xMHH2) )
	dsa_bos_RSsesm(1)  = ca*( dZHHh0div/2d0
     &	                      +s2a/4d0/c2a*(dZHHdiv-dZh0div) )
	dl12_bos_RSsesm(1) = dl12

c scheme 2: on-shell scheme (running la12)
	dl12_bos_RSsesm(2) = dl12
	dsa_bos_RSsesm(2)  = 
     &	    -ca/2d0*(sa*ca*(dZh0-dZHH)-ca2*dZHHh0+sa2*dZh0HH)

c scheme 3: alpha MSbar (running la1)
	dZHHh0div = -2d0*seh0HH_mh02_div/(mh02-mHH2)
	dsa_bos_RSsesm(3)  = ca*( dZHHh0div/2d0
     &	                      +s2a/4d0/c2a*(dZHHdiv-dZh0div) )
        dsa = dsa_bos_RSsesm(3)
	dl12_bos_RSsesm(3) = 
     &	dZe*L12 - dMW2*L12/(2d0*xMW2) - dSW*L12/xSW 
     &	+ dMHH2*L12*((-2d0+CA2)*Mh02-CA2*MHH2)
     &	       /(2d0*(Mh02-MHH2)*(CA2*MHH2+Mh02*SA2)) 
     &	+ dMh02*L12*((1d0+CA2)*MHH2+Mh02*SA2)
     &	       /(2d0*(Mh02-MHH2)*(CA2*MHH2+Mh02*SA2)) 
     &	+ dsa*L12*(CA**4*MHH2-Mh02*SA**4)
     &	       /(CA**4*MHH2*SA+CA2*Mh02*SA**3) 
     &	+ CA2*dl1*EL**2*(Mh02-MHH2)**2*SA2
     &	       /(4d0*L12*xMW2*(CA2*MHH2+Mh02*SA2)*xSW2) 
     &	+ 2d0*L12**2*xMW*xSW*Th0/(CA*EL*(Mh02-MHH2)*(CA2*MHH2+Mh02*SA2)) 
     &	- 2d0*L12**2*xMW*xSW*THH/(SA*EL*(Mh02-MHH2)*(CA2*MHH2+Mh02*SA2))

c scheme 4: alpha MSbar a la FJ (running la1) --  implemented in "t-variant" !
	dZHHh0div = -2d0/(mh02-mHH2)*(seh0HH_mh02_div
     &               + el*(th0div*Ch0h0HH/xMh02+tHHdiv*Ch0HHHH/xMHH2) )
	dsa_bos_RSsesm(4)  = ca*( dZHHh0div/2d0
     &	                      +s2a/4d0/c2a*(dZHHdiv-dZh0div) )
        dsa = dsa_bos_RSsesm(4)
	dl12_bos_RSsesm(4) = 
     &	dZe*L12 - dMW2*L12/(2d0*xMW2) - dSW*L12/xSW 
     &	+ dMHH2*L12*((-2d0+CA2)*Mh02-CA2*MHH2)
     &	       /(2d0*(Mh02-MHH2)*(CA2*MHH2+Mh02*SA2)) 
     &	+ dMh02*L12*((1d0+CA2)*MHH2+Mh02*SA2)
     &	       /(2d0*(Mh02-MHH2)*(CA2*MHH2+Mh02*SA2)) 
     &	+ dsa*L12*(CA**4*MHH2-Mh02*SA**4)
     &	       /(CA**4*MHH2*SA+CA2*Mh02*SA**3) 
     &	+ CA2*dl1*EL**2*(Mh02-MHH2)**2*SA2
     &	       /(4d0*L12*xMW2*(CA2*MHH2+Mh02*SA2)*xSW2) 
     &	+ 2d0*L12**2*xMW*xSW*Th0/(CA*EL*(Mh02-MHH2)*(CA2*MHH2+Mh02*SA2)) 
     &	- 2d0*L12**2*xMW*xSW*THH/(SA*EL*(Mh02-MHH2)*(CA2*MHH2+Mh02*SA2))
c correct for double counting of tadpoles in dsa
     &	- ca/2d0*(-2d0/(mh02-mHH2)*
     &                el*(th0*Ch0h0HH/xMh02+tHH*Ch0HHHH/xMHH2) )
     &	  *L12*(CA**4*MHH2-Mh02*SA**4)
     &	       /(CA**4*MHH2*SA+CA2*Mh02*SA**3) 

c scheme 5: on-shell scheme (running la1)
	dsa_bos_RSsesm(5)  = 
     &	    -ca/2d0*(sa*ca*(dZh0-dZHH)-ca2*dZHHh0+sa2*dZh0HH)
        dsa = dsa_bos_RSsesm(5)
	dl12_bos_RSsesm(5) = 
     &	dZe*L12 - dMW2*L12/(2d0*xMW2) - dSW*L12/xSW 
     &	+ dMHH2*L12*((-2d0+CA2)*Mh02-CA2*MHH2)
     &	       /(2d0*(Mh02-MHH2)*(CA2*MHH2+Mh02*SA2)) 
     &	+ dMh02*L12*((1d0+CA2)*MHH2+Mh02*SA2)
     &	       /(2d0*(Mh02-MHH2)*(CA2*MHH2+Mh02*SA2)) 
     &	+ dsa*L12*(CA**4*MHH2-Mh02*SA**4)
     &	       /(CA**4*MHH2*SA+CA2*Mh02*SA**3) 
     &	+ CA2*dl1*EL**2*(Mh02-MHH2)**2*SA2
     &	       /(4d0*L12*xMW2*(CA2*MHH2+Mh02*SA2)*xSW2) 
     &	+ 2d0*L12**2*xMW*xSW*Th0/(CA*EL*(Mh02-MHH2)*(CA2*MHH2+Mh02*SA2)) 
     &	- 2d0*L12**2*xMW*xSW*THH/(SA*EL*(Mh02-MHH2)*(CA2*MHH2+Mh02*SA2))

c scheme 6: BFM-inspired scheme 1
	ddZHHh0bfm = sa*ca*alpha/8d0/pi/xsw2/xcw2*(2d0*xcw2*BH0WW+BH0ZZ)
	ddZh0HHbfm = sa*ca*alpha/8d0/pi/xsw2/xcw2*(2d0*xcw2*BHHWW+BHHZZ)
	dsa_bos_RSsesm(6)  =  
     &	        ca/4d0*(dZHHh0   -dZh0HH)
     &	       +ca/2d0*( -2d0/(mh02-mHH2)
     &                *el*(th0*Ch0h0HH/xMh02+tHH*Ch0HHHH/xMHH2) )
     &	       +ca*(ddZHHh0bfm-ddZh0HHbfm)/4d0
c	dl12_bos_RSsesm(6) = dl12
	dl12_bos_RSsesm(6) = l12*( (dmhh2-dmh02)/(mhh2-mh02)
     &	                          -2d0*(dmw2/xmw2/2d0-dZe+dsw/xsw)
     &	                          +(sa2*dZh0HH    +ca2*dZHHh0)/s2a
     &	                          +(sa2*ddZh0HHbfm+ca2*ddZHHh0bfm)/s2a )

c scheme 7: BFM-inspired scheme 2
	ddZh0bfm = ca2*alpha/8d0/pi/xsw2/xcw2*(2d0*xcw2*BH0WW+BH0ZZ)
	ddZHHbfm = sa2*alpha/8d0/pi/xsw2/xcw2*(2d0*xcw2*BHHWW+BHHZZ)
	dsa_bos_RSsesm(7)  =  dsa_bos_RSsesm(6)
c	dl12_bos_RSsesm(7) = dl12
	dl12_bos_RSsesm(7) = l12*( (dmhh2-dmh02)/(mhh2-mh02)
     &	                          -2d0*(dmw2/xmw2/2d0-dZe+dsw/xsw)
     &	                          +c2a/2d0*(dZh0-dZHH)
     &	                          +c2a/2d0*(ddZh0bfm-ddZHHbfm)
     &	                          +s2a/2d0*(dZHHh0+dZh0HH)
     &	                          +s2a/2d0*(ddZHHh0bfm+ddZh0HHbfm)
     &	                          +c2a/2d0/s2a*(dZHHh0-dZh0HH) 
     &	                          +c2a/2d0/s2a*(ddZHHh0bfm-ddZh0HHbfm) )

        dsa = dsa_bos_RSsesm(renscheme)

	if ((renscheme.eq.1).or.(renscheme.eq.4).or.
     &	    (renscheme.eq.6).or.(renscheme.eq.7)) then
          seh0HH_mh02 = seh0HH_mh02 
     &                + el*(th0*Ch0h0HH/xMh02+tHH*Ch0HHHH/xMHH2)
          seh0HH_mHH2 = seh0HH_mHH2 
     &                + el*(th0*Ch0h0HH/xMh02+tHH*Ch0HHHH/xMHH2)
	  dZh0HH  = -2d0*seh0HH_mHH2/(mHH2-mh02)
	  dZHHh0  = -2d0*seh0HH_mh02/(mh02-mHH2)
	endif

c redistribute tadpoles in schemes 1,4,6 before calculating RS shift ("t-variant")
	dsa_bos_RSsesm(1) = dsa_bos_RSsesm(1)
     &        + ca/(mh02-mHH2)* el*(th0*Ch0h0HH/xMh02+tHH*Ch0HHHH/xMHH2)
	dsa_bos_RSsesm(4) = dsa_bos_RSsesm(4)
     &        + ca/(mh02-mHH2)* el*(th0*Ch0h0HH/xMh02+tHH*Ch0HHHH/xMHH2)
	dsa_bos_RSsesm(6) = dsa_bos_RSsesm(6)
     &        + ca/(mh02-mHH2)* el*(th0*Ch0h0HH/xMh02+tHH*Ch0HHHH/xMHH2)
	dsa_bos_RSsesm(7) = dsa_bos_RSsesm(7)
     &        + ca/(mh02-mHH2)* el*(th0*Ch0h0HH/xMh02+tHH*Ch0HHHH/xMHH2)
 
        iw3f(1) = iso(1)/2d0
        iw3f(2) = iso(2)/2d0
        iw3f(3) = iso(3)/2d0
        iw3f(4) = iso(4)/2d0
        do i=1,4
          gffr(i) = -q(i)*xsw/xcw
          gffl(i) = -q(i)*xsw/xcw+iw3f(i)/xsw/xcw
	  if (q(i).eq.0d0) then
	    dZff_a = 0d0
	  else
	    dZff_a  = -ALPHA/4D0/PI*q(i)**2*( log(mudim2/mf(i)**2)+4d0
     &		  	                      +4d0*log(lambda/mf(i)) )
	  endif
          dZffl(i) = dZff_a + ALPHA/4D0/PI*(
     &              + gffl(i)**2*(2D0*B1Z+1D0)
     &              + (2D0*B1W+1D0)/2D0/xSW2               )
          dZffr(i) = dZff_a + ALPHA/4D0/PI*(
     &              + gffr(i)**2*(2D0*B1Z+1D0) )
	enddo

c*** vertex counterterms
	ct_wf1f2 = dZe-dsw/xsw+(dZw+dZffl(1)+dZffl(2))/2d0
	ct_wf3f4 = dZe-dsw/xsw+(dZw+dZffl(3)+dZffl(4))/2d0

	do i=1,4
	  ct_zffr(i) = dZe+dsw/xsw/xcw2+dZzz/2d0+dZffr(i)
     &			+dZaz/2d0/xsw*xcw
	  ct_zffl(i) = dZe+dsw/xsw/xcw2-2d0*iw3f(i)/xsw2/xcw*dsw/gffl(i)
     &			+dZzz/2d0+dZffl(i)
     &			-q(i)*dZaz/2d0/gffl(i)
	enddo

c HVV counterterms
        ct_h0ww = dZe - dsw/xsw + dmw2/xmw2/2d0 + dZw   
     &	    + dZh0/2d0 + dZHHh0/2d0*sa/ca - sa*dsa/ca2
        ct_HHww = dZe - dsw/xsw + dmw2/xmw2/2d0 + dZw 
     &	    + dZHH/2d0 + dZh0HH/2d0*ca/sa + dsa/sa
        ct_h0zz = dZe - dsw/xsw + dsw*xsw/xcw2 + dmz2/xmz2/2d0 + dZzz   
     &	    + dZh0/2d0 + dZHHh0/2d0*sa/ca  - sa*dsa/ca2
        ct_h0za = dZza/2d0
        ct_HHzz = dZe - dsw/xsw + dsw*xsw/xcw2 + dmz2/xmz2/2d0 + dZzz  
     &	    + dZHH/2d0 + dZh0HH/2d0*ca/sa  + dsa/sa
        ct_HHza = dZza/2d0
	if ((renscheme.eq.1).or.(renscheme.eq.4).or.
     &	    (renscheme.eq.6).or.(renscheme.eq.7)) then
	  dmw2tad = - el*xMW/xsw*(ca*th0/xMh02+sa*tHH/xMHH2)
 	  dmz2tad = - el*xMW/xsw*(ca*th0/xMh02+sa*tHH/xMHH2)/xcw2
	  ct_h0ww = ct_h0ww + dmw2tad/xmw2/2d0 
     &	                    + CA*EL/(2d0*xMW*xSW)*th0/xMh02
     &	                    + SA*EL/(2d0*xMW*xSW)*tHH/xMHH2
	  ct_h0zz = ct_h0zz + dmw2tad/xmw2/2d0 
     &	                    + CA*EL/(2d0*xMW*xSW)*th0/xMh02
     &	                    + SA*EL/(2d0*xMW*xSW)*tHH/xMHH2
	  ct_HHww = ct_HHww + dmz2tad/xmz2/2d0 
     &	                    + SA*EL/(2d0*xMW*xSW)*tHH/xMHH2
     &	                    + CA*EL/(2d0*xMW*xSW)*th0/xMh02
	  ct_HHzz = ct_HHzz + dmz2tad/xmz2/2d0 
     &	                    + SA*EL/(2d0*xMW*xSW)*tHH/xMHH2
     &	                    + CA*EL/(2d0*xMW*xSW)*th0/xMh02
	endif

c      print*
c      print*,'CT bosonic:'
c      write(*,'((a),2g26.18)')'dmw2    =',dmw2
c      write(*,'((a),2g26.18)')'dmz2    =',dmz2
c      write(*,'((a),2g26.18)')'dmh02   =',dmh02
c      write(*,'((a),2g26.18)')'dmHH2   =',dmHH2
c      write(*,'((a),2g26.18)')'dsw     =',dsw
c      write(*,'((a),2g26.18)')'dZe     =',dZe
c      write(*,'((a),2g26.18)')'dZaa    =',dZaa
c      write(*,'((a),2g26.18)')'dZaz    =',dZaz
c      write(*,'((a),2g26.18)')'dZza    =',dZza
c      write(*,'((a),2g26.18)')'dZzz    =',dZzz
c      write(*,'((a),2g26.18)')'dZw     =',dZw
c      write(*,'((a),2g26.18)')'dZh0    =',dZh0
c      write(*,'((a),2g26.18)')'dZHH    =',dZHH
c      write(*,'((a),2g26.18)')'dZh0HH  =',dZh0HH
c      write(*,'((a),2g26.18)')'dZHHh0  =',dZHHh0
c      write(*,'((a),2g26.18)')'dsa     =',dsa 
c      write(*,'((a),2g26.18)')'dsa_OS  =',dsa_bos_RSsesm(2)
c      write(*,'((a),2g26.18)')'da_OS   =',dsa_bos_RSsesm(2)/ca
c      write(*,'((a),2g26.18)')'th0     =',th0
c      write(*,'((a),2g26.18)')'tHH     =',tHH
c      write(*,'((a),2g26.18)')'dZffr(1)=',dZffr(1)
c      write(*,'((a),2g26.18)')'dZffr(2)=',dZffr(2)
c      write(*,'((a),2g26.18)')'dZffr(3)=',dZffr(3)
c      write(*,'((a),2g26.18)')'dZffr(4)=',dZffr(4)
c      write(*,'((a),2g26.18)')'dZffl(1)=',dZffl(1)
c      write(*,'((a),2g26.18)')'dZffl(2)=',dZffl(2)
c      write(*,'((a),2g26.18)')'dZffl(3)=',dZffl(3)
c      write(*,'((a),2g26.18)')'dZffl(4)=',dZffl(4)
c	stop

	end

************************************************************************
        subroutine xcalcrenc_ferm_sesm
************************************************************************
*	calculate renormalization constants
*	fermion-loop contributions only
*	SESM
*-----------------------------------------------------------------------
*       6.2.17 Stefan Dittmaier
************************************************************************

        use COLLIER

        implicit real*8 (a-z)
	complex*16 xseww_ferm,xseaa,xseaz,xsezz
	complex*16 xseaa_ferm_sesm,xsehp_ferm_sesm
	complex*16 seh0HH_mh02,seh0HH_mHH2
	complex*16 seh0HH_mh02_div,seh0HH_mHH2_div
	complex*16 seh0h0,seh0HH,seHHHH
	complex*16 xA0_,xB0_
	complex*16 B00l,B00u,B00d,B0du,BWnl,BWud,BZnn,BZll,BZdd,BZuu
	complex*16 xDB0_,DBWnl,DBWud,DBZnn,DBZll,DBZdd,DBZuu
	complex*16 DB0ll,DB0dd,DB0uu,DB0nl,DB0du,seww0
	complex*16 B00n,B0nl
	complex*16 gnnl,geer,geel,gffr(4),gffl(4)
	complex*16 th0,tHH,th0div,tHHdiv
        complex*16 dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw
        complex*16 dmh02,dmHH2,dZh0,dZHH,dZh0HH,dZHHh0,dsa,dl12
        complex*16 dZeer,dZeel,dZnnl,dZffr(4),dZffl(4)
        complex*16 ct_aww,ct_zww,ct_wen,ct_wf1f2,ct_wf3f4
        complex*16 ct_annl,ct_aeer,ct_aeel,ct_affr(4),ct_affl(4)
        complex*16 ct_znnl,ct_zeer,ct_zeel,ct_zffr(4),ct_zffl(4)
        complex*16 ct_h0ww,ct_HHww,ct_h0zz,ct_HHzz,ct_h0za,ct_HHza
        complex*16 ymn2(4),yml2(4),ymqm2(4),ymqp2(4)
        complex*16 dmw2tad,dmz2tad,dtbtad
        complex*16 dZh0div,dZHHdiv,dZh0HHdiv,dZHHh0div
        complex*16 seZA0div,dl1
	real*8 iw3f(4)
	integer i,dir(7)
        include '../COMMON/param.inc'
        include '../COMMON/options.inc'
        include '../COMMON/xparam.inc'
        include '../COMMON/processpar.inc'
        include '../COMMON/param_sesm.inc'
        include '../COMMON/param_bsm.inc'
        include '../COMMON/model.inc'
        common/xrenc_ferm_sesm/
     &	       dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw,
     &	       dmh02,dmHH2,dZh0,dZHH,dZh0HH,dZHHh0,dsa,dl12,
     &         dZeer,dZeel,dZnnl,dZffr,dZffl,
     &         ct_aww,ct_zww,ct_wen,ct_wf1f2,ct_wf3f4,
     &         ct_annl,ct_aeer,ct_aeel,ct_affr,ct_affl,
     &         ct_znnl,ct_zeer,ct_zeel,ct_zffr,ct_zffl,
     &         ct_h0ww,ct_HHww,ct_h0zz,ct_HHzz,ct_h0za,ct_HHza

c collier parameters
	real*8 deltaUV,muv2,delta1ir,delta2ir,mir2

	call GetMuUV2_cll(muv2)
	call GetDeltaUV_cll(deltaUV)
	mudim2 = exp(deltauv + log(muv2))
        call GetDeltaIR_cll(delta1ir,delta2ir)
        call GetMuIR2_cll(mir2)
	lambda2 = exp(delta1ir + log(mir2))
	lambda  = sqrt(lambda2)

	dmw2   = 0d0
	dmz2   = 0d0
	dZw    = 0d0
	dZzz   = 0d0
	dZaa   = 0d0
	dZza   = 0d0
	dZaz   = 0d0
	dZh0   = 0d0
	dZHH   = 0d0
        dZh0div= 0d0
	dZHHdiv= 0d0
	dalpz  = 0d0
	seww0  = 0d0
	seh0HH_mh02_div = 0d0
	seh0HH_mHH2_div = 0d0
        seZA0div        = 0d0
	th0    = 0d0
	tHH    = 0d0
	th0div = 0d0
	tHHdiv = 0d0
	dtb    = 0d0
	dl12   = 0d0
	dl1    = 0d0

	do 10 i=1,3

	  ymn2(i)  = null
	  yml2(i)  = xml2(i)
	  ymqm2(i) = xmqm2(i)
	  ymqp2(i) = xmqp2(i)
	  B00n     = null

	B00l  =  xB0_(0D0,   null, yML2(I),0)
	B00u  =  xB0_(0D0,   null,yMQP2(I),0)
	B00d  =  xB0_(0D0,   null,yMQM2(I),0)
	B0nl  =  xB0_(0D0,yMN2(I), yML2(I),0)
	B0du  =  xB0_(0D0,yMQM2(I),yMQP2(I),0)
	BWnl  =  xB0_(MW2,yMN2(I), yML2(I),0)
	BWud  =  xB0_(MW2,yMQP2(I),yMQM2(I),0)
	DBWnl = xDB0_(MW2,yMN2(I), yML2(I),0)
	DBWud = xDB0_(MW2,yMQP2(I),yMQM2(I),0)
	BZnn  =  xB0_(MZ2,yMN2(I),yMN2(I),0)
	BZll  =  xB0_(MZ2,yML2(I),yML2(I),0)
	BZdd  =  xB0_(MZ2,yMQM2(I),yMQM2(I),0)
	BZuu  =  xB0_(MZ2,yMQP2(I),yMQP2(I),0)
	DBZnn = xDB0_(MZ2,yMN2(I),yMN2(I),0)
	DBZll = xDB0_(MZ2,yML2(I),yML2(I),0)
	DBZdd = xDB0_(MZ2,yMQM2(I),yMQM2(I),0)
	DBZuu = xDB0_(MZ2,yMQP2(I),yMQP2(I),0)
	DB0ll = xDB0_(0d0,yML2(I),yML2(I),0)
	DB0dd = xDB0_(0d0,yMQM2(I),yMQM2(I),0)
	DB0uu = xDB0_(0d0,yMQP2(I),yMQP2(I),0)
	DB0nl = xDB0_(0d0,yMN2(I),yML2(I),0)
	DB0du = xDB0_(0d0,yMQM2(I),yMQP2(I),0)

	dZw   = dZw  + ALPHA/(72D0*PI*xSW2)*(
     &	8D0
     &	+3D0*MW2**(-2)*B00l*yML2(I) *(yML2(I) -yMN2(I))
     &	-3D0*MW2**(-2)*B00n*yMN2(I) *(yML2(I) -yMN2(I))
     & 	+9D0*MW2**(-2)*B00d*yMQM2(I)*(yMQM2(I)-yMQP2(I))
     & 	-9D0*MW2**(-2)*B00u*yMQP2(I)*(yMQM2(I)-yMQP2(I))
     &	-3D0*MW2**(-2)*BWnl*(2D0*MW2**2+yML2(I)**2-2D0*yML2(I)*yMN2(I)
     &			     +yMN2(I)**2)
     &	-9D0*MW2**(-2)*BWud*(2D0*MW2**2+yMQM2(I)**2-2D0*yMQM2(I)*yMQP2(I)
     &			     +yMQP2(I)**2)
     &	+3D0*DBWnl*(-2D0*MW2**2+MW2*yML2(I)+yML2(I)**2+MW2*yMN2(I)
     &  	    -2D0*yML2(I)*yMN2(I)+yMN2(I)**2)/MW2
     &	+9D0*DBWud*(-2D0*MW2**2+MW2*yMQM2(I)+yMQM2(I)**2+MW2*yMQP2(I)
     &  	    -2D0*yMQM2(I)*yMQP2(I)+yMQP2(I)**2)/MW2	    )

	dZzz  = dZzz - ALPHA/(216D0*xCW2*PI)*(
     &	48D0-64D0*xSW2-24D0/xSW2
     &	+9D0*BZnn/xSW2
     &  +9D0*(1D0-4D0*xSW2+8D0*xSW2**2)*BZll/xSW2
     &  +3D0*(9D0-12D0*xSW2+8D0*xSW2**2)*BZdd/xSW2
     &  +3D0*(9D0-24D0*xSW2+32D0*xSW2**2)*BZuu/xSW2
     &	+9D0*(MZ2-yMN2(I))*DBZnn/xSW2
     &	-9D0*DBZll*(-MZ2+4D0*MZ2*xSW2-8D0*MZ2*xSW2**2+yML2(I)
     &  	    +8D0*xSW2*yML2(I)-16D0*xSW2**2*yML2(I))/xSW2
     &	+3D0*DBZdd*(9D0*MZ2-12D0*MZ2*xSW2+8D0*MZ2*xSW2**2-9D0*yMQM2(I)
     &  	    -24D0*xSW2*yMQM2(I)+16D0*xSW2**2*yMQM2(I))/xSW2
     &	+3D0*DBZuu*(9D0*MZ2-24D0*MZ2*xSW2+32D0*MZ2*xSW2**2-9D0*yMQP2(I)
     &		    -48D0*xSW2*yMQP2(I)+64D0*xSW2**2*yMQP2(I))/xSW2     )

	dZaa  = dZaa - ALPHA/(27D0*PI)*(
     &	-32D0+9D0*B00l+3D0*B00d+12D0*B00u
     &	+18D0*DB0ll*yML2(I)+6D0*DB0dd*yMQM2(I)+24D0*DB0uu*yMQP2(I)	)

	s = mh02
	dZh0 = dZh0
     &  +ALPHA*CLEPh0**2*yML2(I)/(8D0*PI*XMW2*XSW2)
     &	*(-xB0_(S,yML2(I),yML2(I),0)
     &    +xDB0_(S,yML2(I),yML2(I),0)*(-S+4D0*yML2(I)))
     &	+3D0*ALPHA*CDOh0**2*yMQM2(I)/(8D0*PI*XMW2*XSW2)
     &	*(-xB0_(S,yMQM2(I),yMQM2(I),0)
     &    +xDB0_(S,yMQM2(I),yMQM2(I),0)*(-S+4D0*yMQM2(I)))
     &	+3D0*ALPHA*CUPh0**2*yMQP2(I)/(8D0*PI*XMW2*XSW2)
     &	*(-xB0_(S,yMQP2(I),yMQP2(I),0)
     &    +xDB0_(S,yMQP2(I),yMQP2(I),0)*(-S+4D0*yMQP2(I)))

	s = mHH2
	dZHH = dZHH
     &  +ALPHA*CLEPHH**2*yML2(I)/(8D0*PI*XMW2*XSW2)
     &	*(-xB0_(S,yML2(I),yML2(I),0)
     &    +xDB0_(S,yML2(I),yML2(I),0)*(-S+4D0*yML2(I)))
     &	+3D0*ALPHA*CDOHH**2*yMQM2(I)/(8D0*PI*XMW2*XSW2)
     &	*(-xB0_(S,yMQM2(I),yMQM2(I),0)
     &    +xDB0_(S,yMQM2(I),yMQM2(I),0)*(-S+4D0*yMQM2(I)))
     &	+3D0*ALPHA*CUPHH**2*yMQP2(I)/(8D0*PI*XMW2*XSW2)
     &	*(-xB0_(S,yMQP2(I),yMQP2(I),0)
     &    +xDB0_(S,yMQP2(I),yMQP2(I),0)*(-S+4D0*yMQP2(I)))

	dZh0div = dZh0div
     &	+ ( deltauv + log(muv2/mren2bsm) ) * (
     &    -ALPHA*CLEPh0**2*yML2(I)/(8D0*PI*XMW2*XSW2)
     &	  -3D0*ALPHA*CDOh0**2*yMQM2(I)/(8D0*PI*XMW2*XSW2)
     &	  -3D0*ALPHA*CUPh0**2*yMQP2(I)/(8D0*PI*XMW2*XSW2) )

	dZHHdiv = dZHHdiv
     &	+ ( deltauv + log(muv2/mren2bsm) ) * (
     &    -ALPHA*CLEPHH**2*yML2(I)/(8D0*PI*XMW2*XSW2)
     &	  -3D0*ALPHA*CDOHH**2*yMQM2(I)/(8D0*PI*XMW2*XSW2)
     &	  -3D0*ALPHA*CUPHH**2*yMQP2(I)/(8D0*PI*XMW2*XSW2) )

	s = mh02
	seh0HH_mh02_div = seh0HH_mh02_div
     &	+ ( deltauv + log(muv2/mren2bsm) ) * (
     &      -3D0*ALPHA*CDOh0*CDOHH*yMQM2(I)*(-S+6D0*yMQM2(I))
     &        /(8D0*PI*XMW2*XSW2)
     &      -3D0*ALPHA*CUPh0*CUPHH*yMQP2(I)*(-S+6D0*yMQP2(I))
     &        /(8D0*PI*XMW2*XSW2)
     &      -ALPHA*CLEPh0*CLEPHH*yML2(I)*(-S+6D0*yML2(I))
     &        /(8D0*PI*XMW2*XSW2) )

	s = mHH2
	seh0HH_mHH2_div = seh0HH_mHH2_div
     &	+ ( deltauv + log(muv2/mren2bsm) ) * (
     &      -3D0*ALPHA*CDOh0*CDOHH*yMQM2(I)*(-S+6D0*yMQM2(I))
     &        /(8D0*PI*XMW2*XSW2)
     &      -3D0*ALPHA*CUPh0*CUPHH*yMQP2(I)*(-S+6D0*yMQP2(I))
     &        /(8D0*PI*XMW2*XSW2)
     &      -ALPHA*CLEPh0*CLEPHH*yML2(I)*(-S+6D0*yML2(I))
     &        /(8D0*PI*XMW2*XSW2) )

	th0 = th0 
     &  -(CLEPh0*EL/PI**2*xA0_(XML2(I))*XML2(I))/(8D0*XMW*XSW)
     &  -(3D0*CDOh0*EL/PI**2*xA0_(XMQM2(I))*XMQM2(I))/(8D0*XMW*XSW)
     &  -(3D0*CUPh0*EL/PI**2*xA0_(XMQP2(I))*XMQP2(I))/(8D0*XMW*XSW)
 
	tHH = tHH 
     &	-(CLEPHH*EL/PI**2*xA0_(XML2(I))*XML2(I))/(8D0*XMW*XSW)
     &  -(3D0*CDOHH*EL/PI**2*xA0_(XMQM2(I))*XMQM2(I))/(8D0*XMW*XSW)
     &  -(3D0*CUPHH*EL/PI**2*xA0_(XMQP2(I))*XMQP2(I))/(8D0*XMW*XSW)

	th0div = th0div + (deltauv+log(muv2/mren2bsm))*(
     &  -(CLEPh0*EL/PI**2*(XML2(I))*XML2(I))/(8D0*XMW*XSW)
     &  -(3D0*CDOh0*EL/PI**2*(XMQM2(I))*XMQM2(I))/(8D0*XMW*XSW)
     &  -(3D0*CUPh0*EL/PI**2*(XMQP2(I))*XMQP2(I))/(8D0*XMW*XSW) )
 
	tHHdiv = tHHdiv + (deltauv+log(muv2/mren2bsm))*(
     &	-(CLEPHH*EL/PI**2*(XML2(I))*XML2(I))/(8D0*XMW*XSW)
     &  -(3D0*CDOHH*EL/PI**2*(XMQM2(I))*XMQM2(I))/(8D0*XMW*XSW)
     &  -(3D0*CUPHH*EL/PI**2*(XMQP2(I))*XMQP2(I))/(8D0*XMW*XSW) )

	dalpz = dalpz + alpha/3d0/pi*dreal(
     & 	     ( 1d0/3d0+(1d0+2d0* yml2(i)/mz2)*(B00l-1d0-BZll) )
     & 	    +( 1d0/3d0+(1d0+2d0*ymqm2(i)/mz2)*(B00d-1d0-BZdd) )/3d0 )
	if (i.ne.3)
     &  dalpz = dalpz + alpha/3d0/pi*dreal(
     &    ( 1d0/3d0+(1d0+2d0*ymqp2(i)/mz2)*(B00u-1d0-BZuu) )*4d0/3d0 )

	seww0 = seww0 - ALPHA/(24D0*PI*xSW2)*(
     & 	-6D0*ymqm2(i)-6D0*ymqp2(i)-2D0*yml2(i)-2D0*ymn2(i)
     &	+6D0*ymqm2(i)*B00d+6D0*ymqp2(i)*B00u
     &	+3D0*(ymqm2(i)+ymqp2(i))*B0du
     &	+2D0*yml2(i)*B00l+2D0*ymn2(i)*B00n
     &	+(yml2(i)+ymn2(i))*B0nl
     &	+(yml2(i)-ymn2(i))**2*DB0nl
     &	+3D0*(ymqm2(i)-ymqp2(i))**2*DB0du	)

	dl12   = dl12   
     &	- l12/ca2 * ( deltauv + log(muv2/mren2bsm) ) * (
     &    -ALPHA*CLEPh0**2*yML2(I)/(8D0*PI*XMW2*XSW2)
     &	  -3D0*ALPHA*CDOh0**2*yMQM2(I)/(8D0*PI*XMW2*XSW2)
     &	  -3D0*ALPHA*CUPh0**2*yMQP2(I)/(8D0*PI*XMW2*XSW2) )

10	continue

        call xsehh_ferm_sesm(mh02,seh0h0,seh0HH,seHHHH)
	dmh02  = seh0h0
	seh0HH_mh02 = seh0HH

        call xsehh_ferm_sesm(mHH2,seh0h0,seh0HH,seHHHH)
	dmHH2  = seHHHH
	seh0HH_mHH2 = seh0HH

	dZh0HH = -2d0*seh0HH_mHH2/(mHH2-mh02)
	dZHHh0 = -2d0*seh0HH_mh02/(mh02-mHH2)

	dmw2 = xseww_ferm(mw2)
        call xsevv_ferm(mz2,xseaa,xseaz,xsezz)
	dmz2 = xsezz
	dZaz = -2d0*xseaz/mz2
        call xsevv_ferm(0d0,xseaa,xseaz,xsezz)
c	dZza = 2d0*xseaz/xmz2
	dZza = 0d0

c modifications for complex renormalization
	dmw2 = dmw2 - (xmw2-mw2)*dZw
	dmz2 = dmz2 - (xmz2-mz2)*dZzz
	dZaz = dZaz + (xmz2-mz2)/mz2*dZza

c dependent parameters
	dsw  = xcw2/2d0/xsw*( dmz2/xmz2 - dmw2/xmw2 )

	drferm = -dZaa-2d0*dsw/xsw+(seww0-dmw2)/xmw2

	if (qalp.eq.0) then
	  dZe = -dZaa/2d0 - dZza/2d0*xsw/xcw
	elseif (qalp.eq.2) then
	  dZe = -dZaa/2d0 - dZza/2d0*xsw/xcw - dalpz/2d0
	elseif (qalp.eq.1) then
	  dZe = -dZaa/2d0 - dZza/2d0*xsw/xcw - drferm/2d0
	endif

cxxx Test!!!!!!!
c	th0div = th0
c	tHHdiv = tHH

c scheme 0: alpha MSbar (running la12)
	dZHHh0div = -2d0*seh0HH_mh02_div/(mh02-mHH2)

	dsa_ferm_RSsesm(0) = ca*( dZHHh0div/2d0
     &	                      +s2a/4d0/c2a*(dZHHdiv-dZh0div) )
	dl12_ferm_RSsesm(0) = dl12

c scheme 1: alpha MSbar a la FJ (running la12) --  implemented in "t-variant" !
	dZHHh0div = -2d0/(mh02-mHH2)*(seh0HH_mh02_div
     &               + el*(th0div*Ch0h0HH/xMh02+tHHdiv*Ch0HHHH/xMHH2) )
	dsa_ferm_RSsesm(1) = ca*( dZHHh0div/2d0
     &	                    +s2a/4d0/c2a*(dZHHdiv-dZh0div) )
	dl12_ferm_RSsesm(1) = dl12

c scheme 2: on-shell scheme (running la12)
	dl12_ferm_RSsesm(2) = dl12
	dsa_ferm_RSsesm(2)  = 
     &	    -ca/2d0*(sa*ca*(dZh0-dZHH)-ca2*dZHHh0+sa2*dZh0HH)

c scheme 3: alpha MSbar (running la1)
	dZHHh0div = -2d0*seh0HH_mh02_div/(mh02-mHH2)
	dsa_ferm_RSsesm(3) = ca*( dZHHh0div/2d0
     &	                      +s2a/4d0/c2a*(dZHHdiv-dZh0div) )
        dsa = dsa_ferm_RSsesm(3)
	dl12_ferm_RSsesm(3) = 
     &	dZe*L12 - dMW2*L12/(2d0*xMW2) - dSW*L12/xSW 
     &	+ dMHH2*L12*((-2d0+CA2)*Mh02-CA2*MHH2)
     &	       /(2d0*(Mh02-MHH2)*(CA2*MHH2+Mh02*SA2)) 
     &	+ dMh02*L12*((1d0+CA2)*MHH2+Mh02*SA2)
     &	       /(2d0*(Mh02-MHH2)*(CA2*MHH2+Mh02*SA2)) 
     &	+ dsa*L12*(CA**4*MHH2-Mh02*SA**4)
     &	       /(CA**4*MHH2*SA+CA2*Mh02*SA**3) 
     &	+ CA2*dl1*EL**2*(Mh02-MHH2)**2*SA2
     &	       /(4d0*L12*xMW2*(CA2*MHH2+Mh02*SA2)*xSW2) 
     &	+ 2d0*L12**2*xMW*xSW*Th0/(CA*EL*(Mh02-MHH2)*(CA2*MHH2+Mh02*SA2)) 
     &	- 2d0*L12**2*xMW*xSW*THH/(SA*EL*(Mh02-MHH2)*(CA2*MHH2+Mh02*SA2))

c scheme 4: alpha MSbar a la FJ (running la1) --  implemented in "t-variant" !
	dZHHh0div = -2d0/(mh02-mHH2)*(seh0HH_mh02_div
     &               + el*(th0div*Ch0h0HH/xMh02+tHHdiv*Ch0HHHH/xMHH2) )
	dsa_ferm_RSsesm(4) = ca*( dZHHh0div/2d0
     &	                    +s2a/4d0/c2a*(dZHHdiv-dZh0div) )
        dsa = dsa_ferm_RSsesm(4)
	dl12_ferm_RSsesm(4) = 
     &	dZe*L12 - dMW2*L12/(2d0*xMW2) - dSW*L12/xSW 
     &	+ dMHH2*L12*((-2d0+CA2)*Mh02-CA2*MHH2)
     &	       /(2d0*(Mh02-MHH2)*(CA2*MHH2+Mh02*SA2)) 
     &	+ dMh02*L12*((1d0+CA2)*MHH2+Mh02*SA2)
     &	       /(2d0*(Mh02-MHH2)*(CA2*MHH2+Mh02*SA2)) 
     &	+ dsa*L12*(CA**4*MHH2-Mh02*SA**4)
     &	       /(CA**4*MHH2*SA+CA2*Mh02*SA**3) 
     &	+ CA2*dl1*EL**2*(Mh02-MHH2)**2*SA2
     &	       /(4d0*L12*xMW2*(CA2*MHH2+Mh02*SA2)*xSW2) 
     &	+ 2d0*L12**2*xMW*xSW*Th0/(CA*EL*(Mh02-MHH2)*(CA2*MHH2+Mh02*SA2)) 
     &	- 2d0*L12**2*xMW*xSW*THH/(SA*EL*(Mh02-MHH2)*(CA2*MHH2+Mh02*SA2))
c correct for double counting of tadpoles in dsa
     &	- ca/2d0*(-2d0/(mh02-mHH2)*
     &                el*(th0*Ch0h0HH/xMh02+tHH*Ch0HHHH/xMHH2) )
     &	  *L12*(CA**4*MHH2-Mh02*SA**4)
     &	       /(CA**4*MHH2*SA+CA2*Mh02*SA**3) 

c scheme 5: on-shell scheme (running la1)
	dsa_ferm_RSsesm(5)  = 
     &	    -ca/2d0*(sa*ca*(dZh0-dZHH)-ca2*dZHHh0+sa2*dZh0HH)
        dsa = dsa_ferm_RSsesm(5)
	dl12_ferm_RSsesm(5) = 
     &	dZe*L12 - dMW2*L12/(2d0*xMW2) - dSW*L12/xSW 
     &	+ dMHH2*L12*((-2d0+CA2)*Mh02-CA2*MHH2)
     &	       /(2d0*(Mh02-MHH2)*(CA2*MHH2+Mh02*SA2)) 
     &	+ dMh02*L12*((1d0+CA2)*MHH2+Mh02*SA2)
     &	       /(2d0*(Mh02-MHH2)*(CA2*MHH2+Mh02*SA2)) 
     &	+ dsa*L12*(CA**4*MHH2-Mh02*SA**4)
     &	       /(CA**4*MHH2*SA+CA2*Mh02*SA**3) 
     &	+ CA2*dl1*EL**2*(Mh02-MHH2)**2*SA2
     &	       /(4d0*L12*xMW2*(CA2*MHH2+Mh02*SA2)*xSW2) 
     &	+ 2d0*L12**2*xMW*xSW*Th0/(CA*EL*(Mh02-MHH2)*(CA2*MHH2+Mh02*SA2)) 
     &	- 2d0*L12**2*xMW*xSW*THH/(SA*EL*(Mh02-MHH2)*(CA2*MHH2+Mh02*SA2))

c scheme 6: BFM-inspired scheme 1
	dsa_ferm_RSsesm(6)  = ca*(dZHHh0-dZh0HH)/4d0
     &	   + ca/2d0*( -2d0/(mh02-mHH2)
     &	              *el*(th0*Ch0h0HH/xMh02+tHH*Ch0HHHH/xMHH2) )
c	dl12_ferm_RSsesm(6) = dl12
	dl12_ferm_RSsesm(6) = l12*( (dmhh2-dmh02)/(mhh2-mh02)
     &	                          -2d0*(dmw2/xmw2/2d0-dZe+dsw/xsw)
     &	                          +(sa2*dZh0HH    +ca2*dZHHh0)/s2a )

c scheme 7: BFM-inspired scheme 2
	dsa_ferm_RSsesm(7)  = dsa_ferm_RSsesm(6)
c	dl12_ferm_RSsesm(7) = dl12
	dl12_ferm_RSsesm(7) = l12*( (dmhh2-dmh02)/(mhh2-mh02)
     &	                          -2d0*(dmw2/xmw2/2d0-dZe+dsw/xsw)
     &	                          +c2a/2d0*(dZh0-dZHH)
     &	                          +s2a/2d0*(dZHHh0+dZh0HH)
     &	                          +c2a/2d0/s2a*(dZHHh0-dZh0HH) )

        dsa = dsa_ferm_RSsesm(renscheme)

	if ((renscheme.eq.1).or.(renscheme.eq.4).or.
     &	    (renscheme.eq.6).or.(renscheme.eq.7)) then
          seh0HH_mh02 = seh0HH_mh02 
     &                 +el*(th0*Ch0h0HH/xMh02+tHH*Ch0HHHH/xMHH2)
          seh0HH_mHH2 = seh0HH_mHH2 
     &                 +el*(th0*Ch0h0HH/xMh02+tHH*Ch0HHHH/xMHH2)
	  dZh0HH = -2d0*seh0HH_mHH2/(mHH2-mh02)
	  dZHHh0 = -2d0*seh0HH_mh02/(mh02-mHH2)
	endif

c redistribute tadpoles in schemes 1,4,6 before calculating RS shift ("t-variant")
	dsa_ferm_RSsesm(1) = dsa_ferm_RSsesm(1)
     &        + ca/(mh02-mHH2)* el*(th0*Ch0h0HH/xMh02+tHH*Ch0HHHH/xMHH2)
	dsa_ferm_RSsesm(4) = dsa_ferm_RSsesm(4)
     &        + ca/(mh02-mHH2)* el*(th0*Ch0h0HH/xMh02+tHH*Ch0HHHH/xMHH2)
	dsa_ferm_RSsesm(6) = dsa_ferm_RSsesm(6)
     &        + ca/(mh02-mHH2)* el*(th0*Ch0h0HH/xMh02+tHH*Ch0HHHH/xMHH2)
	dsa_ferm_RSsesm(7) = dsa_ferm_RSsesm(7)
     &        + ca/(mh02-mHH2)* el*(th0*Ch0h0HH/xMh02+tHH*Ch0HHHH/xMHH2)

	do i=1,4
	  dZffr(i) = 0d0
	  dZffl(i) = 0d0
	enddo

c*** vertex counterterms
	ct_aww = dZe+dZw+dZaa/2d0-xcw/xsw*dZza/2d0
	ct_zww = dZe-dsw/xsw/xcw2+dZw+dZzz/2d0+dZaz/2d0/(-xcw/xsw)

	ct_wf1f2 = dZe-dsw/xsw+(dZw+dZffl(1)+dZffl(2))/2d0
	ct_wf3f4 = dZe-dsw/xsw+(dZw+dZffl(3)+dZffl(4))/2d0

        iw3f(1) = iso(1)/2d0
        iw3f(2) = iso(2)/2d0
        iw3f(3) = iso(3)/2d0
        iw3f(4) = iso(4)/2d0
	do i=1,4
	  gffr(i) = -q(i)*xsw/xcw
	  gffl(i) = -q(i)*xsw/xcw+iw3f(i)/xsw/xcw
	enddo

	do i=1,4
	  ct_zffr(i) = dZe+dsw/xsw/xcw2+dZzz/2d0+dZffr(i)
     &                  +dZaz/2d0/xsw*xcw
	  ct_zffl(i) = dZe+dsw/xsw/xcw2-2d0*iw3f(i)/xsw2/xcw*dsw/gffl(i)
     &			+dZzz/2d0+dZffl(i)
     &			-q(i)*dZaz/2d0/gffl(i)
	enddo

c HVV counterterms
        ct_h0ww = dZe - dsw/xsw + dmw2/xmw2/2d0 + dZw      
     &	    + dZh0/2d0 + dZHHh0/2d0*sa/ca - sa*dsa/ca2  
        ct_HHww = dZe - dsw/xsw + dmw2/xmw2/2d0 + dZw 
     &	    + dZHH/2d0 + dZh0HH/2d0*ca/sa + dsa/sa
        ct_h0zz = dZe - dsw/xsw + dsw*xsw/xcw2 + dmz2/xmz2/2d0 + dZzz   
     &	    + dZh0/2d0 + dZHHh0/2d0*sa/ca  - sa*dsa/ca2
        ct_h0za = dZza/2d0
        ct_HHzz = dZe - dsw/xsw + dsw*xsw/xcw2 + dmz2/xmz2/2d0 + dZzz  
     &	    + dZHH/2d0 + dZh0HH/2d0*ca/sa  + dsa/sa
        ct_HHza = dZza/2d0
	if ((renscheme.eq.1).or.(renscheme.eq.4).or.
     &	    (renscheme.eq.6).or.(renscheme.eq.7)) then
	  dmw2tad = - el*xMW/xsw*(ca*th0/xMh02+sa*tHH/xMHH2)
 	  dmz2tad = - el*xMW/xsw*(ca*th0/xMh02+sa*tHH/xMHH2)/xcw2
	  ct_h0ww = ct_h0ww + dmw2tad/xmw2/2d0 
     &	                    + CA*EL/(2d0*xMW*xSW)*th0/xMh02
     &	                    + SA*EL/(2d0*xMW*xSW)*tHH/xMHH2
	  ct_h0zz = ct_h0zz + dmw2tad/xmw2/2d0 
     &	                    + CA*EL/(2d0*xMW*xSW)*th0/xMh02
     &	                    + SA*EL/(2d0*xMW*xSW)*tHH/xMHH2
	  ct_HHww = ct_HHww + dmz2tad/xmz2/2d0 
     &	                    + SA*EL/(2d0*xMW*xSW)*tHH/xMHH2
     &	                    + CA*EL/(2d0*xMW*xSW)*th0/xMh02
	  ct_HHzz = ct_HHzz + dmz2tad/xmz2/2d0 
     &	                    + SA*EL/(2d0*xMW*xSW)*tHH/xMHH2
     &	                    + CA*EL/(2d0*xMW*xSW)*th0/xMh02
	endif

c      print*
c      print*,'CT fermionic:'
c      write(*,'((a),2g26.18)')'dmw2    =',dmw2
c      write(*,'((a),2g26.18)')'dmz2    =',dmz2
c      write(*,'((a),2g26.18)')'dmh02   =',dmh02
c      write(*,'((a),2g26.18)')'dmHH2   =',dmHH2
c      write(*,'((a),2g26.18)')'dsw     =',dsw
c      write(*,'((a),2g26.18)')'dZe     =',dZe
c      write(*,'((a),2g26.18)')'dZaa    =',dZaa
c      write(*,'((a),2g26.18)')'dZaz    =',dZaz
c      write(*,'((a),2g26.18)')'dZza    =',dZza
c      write(*,'((a),2g26.18)')'dZzz    =',dZzz
c      write(*,'((a),2g26.18)')'dZw     =',dZw
c      write(*,'((a),2g26.18)')'dZh0    =',dZh0
c      write(*,'((a),2g26.18)')'dZHH    =',dZHH
c      write(*,'((a),2g26.18)')'dZh0HH  =',dZh0HH
c      write(*,'((a),2g26.18)')'dZHHh0  =',dZHHh0
c      write(*,'((a),2g26.18)')'dsa     =',dsa 
c      write(*,'((a),2g26.18)')'dsa_OS  =',dsa_ferm_RSsesm(2)
c      write(*,'((a),2g26.18)')'da_OS   =',dsa_ferm_RSsesm(2)/ca
c      write(*,'((a),2g26.18)')'th0     =',th0
c      write(*,'((a),2g26.18)')'tHH     =',tHH
c      write(*,'((a),2g26.18)')'dZffr(1)=',dZffr(1)
c      write(*,'((a),2g26.18)')'dZffr(2)=',dZffr(2)
c      write(*,'((a),2g26.18)')'dZffr(3)=',dZffr(3)
c      write(*,'((a),2g26.18)')'dZffr(4)=',dZffr(4)
c      write(*,'((a),2g26.18)')'dZffl(1)=',dZffl(1)
c      write(*,'((a),2g26.18)')'dZffl(2)=',dZffl(2)
c      write(*,'((a),2g26.18)')'dZffl(3)=',dZffl(3)
c      write(*,'((a),2g26.18)')'dZffl(4)=',dZffl(4)
c      write(*,'((a),2g26.18)')'ct_h0ww =',ct_h0ww
c      stop

	end

**********************************************************************
        subroutine transinput_sesm(qmethod)
**********************************************************************
*       translate THDM input parameters beta and alpha
*       between renormalization  schemes
*       qmethod = 0: linearized approach
*       qmethod = 1: matching the bare parameters
*---------------------------------------------------------------------
*       28.3.17 Stefan Dittmaier
**********************************************************************
        use COLLIER

        implicit real*8 (a-z)
	real*8 x(10)
        integer i,qmethod,conv
	logical misnan

        include '../COMMON/model.inc'
        include '../COMMON/param.inc'
        include '../COMMON/xparam.inc'
        include '../COMMON/param_sesm.inc'
        include '../COMMON/param_bsm.inc'

        external chi2bare_sesm

c store parameters
        ta_store  = ta
        l12_store = l12
        call GetDeltaUV_cll(deltaUV)
        call GetMuUV2_cll(muv2)
        muv2_store    = muv2
        deltaUV_store = deltaUV

c bare parameters
        deltauv  = 0d0
        muv2     = mren2bsm
        call SetDeltaUV_cll(deltaUV)
        call SetMuUV2_cll(muv2)
        call bsm_setparams()
        call sesm_setcoupl(hboson)
        call xcalcrenc_sesm
        call xcalcrenc_ferm_sesm
        ta_bare = ta + dsa_bos_RSsesm(renscheme)/ca**3
     &               + dsa_ferm_RSsesm(renscheme)/ca**3
        l12_bare = l12 + dl12_bos_RSsesm(renscheme)
     &                 + dl12_ferm_RSsesm(renscheme)

        do i=0,7

	if (i.eq.renscheme) then
          sa_RSsesm_lin(i)  = ta_store/sqrt(1d0+ta_store**2)
          l12_RSsesm_lin(i) = l12_store
          sa_RSsesm(i)      = ta_store/sqrt(1d0+ta_store**2)
          l12_RSsesm(i)     = l12_store
	else

c linearized approach
        if (qmethod.eq.0) then
          ta  = ta_store
          l12 = l12_store
          call bsm_setparams()
          call sesm_setcoupl(hboson)
          call xcalcrenc_sesm
          call xcalcrenc_ferm_sesm

          ta_RSsesm = ta_bare
     &                -(dsa_bos_RSsesm(i)+dsa_ferm_RSsesm(i) )/ca**3

          sa_RSsesm_lin(i)  = ta_RSsesm/sqrt(1d0+ta_RSsesm**2)
          l12_RSsesm_lin(i) = l12_bare
     &	                  -dl12_bos_RSsesm(i)-dl12_ferm_RSsesm(i)

c matching the bare parameters
        elseif (qmethod.eq.1) then
          x(1) = ta_store
          x(2) = l12_store
          x(3) = ta_bare
          x(4) = l12_bare
          x(5) = i
          call mini(chi2bare_sesm,x,y,0,1,2,conv)
          conv_sesm(i) = conv
          ta   = x(1)
          l12  = x(2)
          ta_RSsesm     = x(1)
          sa_RSsesm(i)  = ta_RSsesm/sqrt(1d0+ta_RSsesm**2)
          l12_RSsesm(i) = l12
          if (misnan(x(1)*x(2))) conv_sesm(i) = 1

        endif
        endif

        enddo

c restore parameters
        ta      = ta_store
        l12     = l12_store
        muv2    = muv2_store
        deltaUV = deltaUV_store
        call SetDeltaUV_cll(deltaUV)
        call SetMuUV2_cll(muv2)
        call bsm_setparams()
        call sesm_setcoupl(hboson)
        call xcalcrenc_sesm
        call xcalcrenc_ferm_sesm

        end

**********************************************************************
        function chi2bare_sesm(x)
**********************************************************************
*       chi2 for matching of bare parameters
*---------------------------------------------------------------------
*       28.3.17 Stefan Dittmaier
**********************************************************************
        use COLLIER

        implicit real*8 (a-z)
        real*8 x(10)
        integer i,qren

        include '../COMMON/model.inc'
        include '../COMMON/param.inc'
        include '../COMMON/xparam.inc'
        include '../COMMON/param_sesm.inc'
        include '../COMMON/param_bsm.inc'

        ta   = x(1)
        l12  = x(2)
        qren = nint(x(5))
        deltauv  = 0d0
        muv2     = mren2bsm
        call SetDeltaUV_cll(deltaUV)
        call SetMuUV2_cll(muv2)

        call bsm_setparams()
        call sesm_setcoupl(hboson)
        call xcalcrenc_sesm
        call xcalcrenc_ferm_sesm

        ta_bare = ta + dsa_bos_RSsesm(qren)/ca**3
     &               + dsa_ferm_RSsesm(qren)/ca**3
        l12_bare = l12 + dl12_bos_RSsesm(qren)
     &                 + dl12_ferm_RSsesm(qren)

        chi2bare_sesm = (ta_bare-x(3))**2 + (l12_bare-x(4))**2

        end

**********************************************************************
        subroutine beta_sesm(Bta,Bl12,Bl1,Mh0,MHH,ta,l12)
**********************************************************************
*	beta functions of MSbar renormalized SESM input parameters 
*	Note: All input masses taken real !
*---------------------------------------------------------------------
*       6.2.17 Stefan Dittmaier
**********************************************************************
        implicit real*8 (a-z)
	complex*16 Ch0h0HH,Ch0HHHH
	complex*16 seh0HH_mh02_div,seh0HH_mHH2_div
	complex*16 th0div,tHHdiv
	integer i

        include '../COMMON/model.inc'
        include '../COMMON/param.inc'
        include '../COMMON/xparam.inc'

c*** dependent variables
        Mh02 = Mh0**2
        MHH2 = MHH**2

c angle alpha
c	TA  = sa/sqrt(1d0-sa**2)
        TA2 = TA**2
        if (ta.eq.0d0) then
          SA = 0d0
          CA = 1d0
        elseif (ta.eq.1d30) then
          SA = 1d0
          CA = 0d0
        else
          SA = TA/sqrt(1d0+TA2)
          CA = SA/TA
        endif
        CA2 = CA**2
        SA2 = SA**2
        S2A = 2d0*CA*SA
        C2A = CA**2 - SA**2

c*** some 3-Higgs couplings
        Ch0h0HH = -(2d0*MH02+MHH2)*SA/(8d0*(MH02-MHH2)*MW*SW)
     &             *( (MH02-MHH2)*(1d0+3d0*CA2-SA2)
     &                -32d0*L12/el**2*MW2*SW2 )
        Ch0HHHH = CA*(MH02+2d0*MHH2)/(8d0*(MH02-MHH2)*MW*SW)
     &            *( (MH02-MHH2)*(-1d0+CA2-3d0*SA2)
     &               -32d0*L12/el**2*MW2*SW2 )

c*** fermion couplings
        Cleph0 = CA
        ClepHH = SA
        ClepG = 1d0
        Cuph0 = CA
        CupHH = SA
        CupG = 1d0
        Cdoh0 = CA
        CdoHH = SA
        CdoG = 1d0

c beta functions derived from UV-divergent parts of counterterms
c	div = deltauv + log(muv2/mren2bsm)
	div = 1d0

	s = mhh2
	seh0HH_mHH2_div = div
     &  *( -((CA*L12*PI**(-2)*SA*(-(3D0*CW2*MH0**2*MH02)+6D0*CA**2*
     &  CW2*MH0**2*MH02-2D0*CW2*MH02**2+4D0*CA**2*CW2*MH02**
     &  2+3D0*CW2*MH02*MHH**2-6D0*CA**2*CW2*MH02*MHH**2+3D0*
     &  CW2*MH0**2*MHH2-6D0*CA**2*CW2*MH0**2*MHH2+4D0*CW2*
     &  MH02*MHH2-8D0*CA**2*CW2*MH02*MHH2-3D0*CW2*MHH**2*
     &  MHH2+6D0*CA**2*CW2*MHH**2*MHH2-2D0*CW2*MHH2**2+4D0*
     &  CA**2*CW2*MHH2**2+MH0**2*MW2+2D0*CW2*MH0**2*MW2-
     &  MHH**2*MW2-2D0*CW2*MHH**2*MW2))/(16D0*CW2*(MH0+MHH)*
     &  (MH0-MHH)))-(L12**2*PI**(-3)*(MH0+MHH)**(-2)*(MH0-
     &  MHH)**(-2)*(9D0*MH02**2-14D0*CA**2*MH02**2+5D0*CA**4*
     &  MH02**2+3D0*MH02*MHH2+10D0*CA**2*MH02*MHH2-10D0*CA**4*
     &  MH02*MHH2+4D0*CA**2*MHH2**2+5D0*CA**4*MHH2**2)*MW2*
     &  SW2)/(8D0*ALPHA*CA*SA)+(ALPHA*CA*SA*CW2**(-2)*(4D0*CA**2*
     &  CW2**2*MH02**2+5D0*CA**4*CW2**2*MH02**2+6D0*CW2**2*
     &  MH02*MHH2+10D0*CA**2*CW2**2*MH02*MHH2-10D0*CA**4*CW2**
     &  2*MH02*MHH2+9D0*CW2**2*MHH2**2-14D0*CA**2*CW2**2*
     &  MHH2**2+5D0*CA**4*CW2**2*MHH2**2-4D0*S*CW2*MW2-8D0*S*
     &  CW2**2*MW2+CA**2*CW2*MH02*MW2+2D0*CA**2*CW2**2*MH02*
     &  MW2+CW2*MHH2*MW2-CA**2*CW2*MHH2*MW2+2D0*CW2**2*
     &  MHH2*MW2-2D0*CA**2*CW2**2*MHH2*MW2+18D0*MW2**2+36D0*
     &  CW2**2*MW2**2))/(32D0*PI*MW2*SW2) )

	s = mh02
	seh0HH_mh02_div = div
     &  *( -((CA*L12*PI**(-2)*SA*(-(3D0*CW2*MH0**2*MH02)+6D0*CA**2*
     &  CW2*MH0**2*MH02-2D0*CW2*MH02**2+4D0*CA**2*CW2*MH02**
     &  2+3D0*CW2*MH02*MHH**2-6D0*CA**2*CW2*MH02*MHH**2+3D0*
     &  CW2*MH0**2*MHH2-6D0*CA**2*CW2*MH0**2*MHH2+4D0*CW2*
     &  MH02*MHH2-8D0*CA**2*CW2*MH02*MHH2-3D0*CW2*MHH**2*
     &  MHH2+6D0*CA**2*CW2*MHH**2*MHH2-2D0*CW2*MHH2**2+4D0*
     &  CA**2*CW2*MHH2**2+MH0**2*MW2+2D0*CW2*MH0**2*MW2-
     &  MHH**2*MW2-2D0*CW2*MHH**2*MW2))/(16D0*CW2*(MH0+MHH)*
     &  (MH0-MHH)))-(L12**2*PI**(-3)*(MH0+MHH)**(-2)*(MH0-
     &  MHH)**(-2)*(9D0*MH02**2-14D0*CA**2*MH02**2+5D0*CA**4*
     &  MH02**2+3D0*MH02*MHH2+10D0*CA**2*MH02*MHH2-10D0*CA**4*
     &  MH02*MHH2+4D0*CA**2*MHH2**2+5D0*CA**4*MHH2**2)*MW2*
     &  SW2)/(8D0*ALPHA*CA*SA)+(ALPHA*CA*SA*CW2**(-2)*(4D0*CA**2*
     &  CW2**2*MH02**2+5D0*CA**4*CW2**2*MH02**2+6D0*CW2**2*
     &  MH02*MHH2+10D0*CA**2*CW2**2*MH02*MHH2-10D0*CA**4*CW2**
     &  2*MH02*MHH2+9D0*CW2**2*MHH2**2-14D0*CA**2*CW2**2*
     &  MHH2**2+5D0*CA**4*CW2**2*MHH2**2-4D0*S*CW2*MW2-8D0*S*
     &  CW2**2*MW2+CA**2*CW2*MH02*MW2+2D0*CA**2*CW2**2*MH02*
     &  MW2+CW2*MHH2*MW2-CA**2*CW2*MHH2*MW2+2D0*CW2**2*
     &  MHH2*MW2-2D0*CA**2*CW2**2*MHH2*MW2+18D0*MW2**2+36D0*
     &  CW2**2*MW2**2))/(32D0*PI*MW2*SW2) )

 	th0div = div
     &  *( (L12*PI**(-2)*((3D0*SA**2*MH02**2)/CA+CA*MHH2*(MH02+2D0*
     &  MHH2))*MW*SW)/(8D0*EL*(MH0+MHH)*(MH0-MHH))+(CA*EL*
     &  PI**(-2)*((3D0*CA**2*MH02**2)/MW+(SA**2*MHH2*(MH02+2D0*
     &  MHH2))/MW+2D0*MW*(MH02+6D0*MW2)+((CW2*MH02+6D0*MW2)*
     &  MZ2)/(CW2*MW)))/(64D0*SW) )

	tHHdiv = div
     &  *( -((L12*PI**(-2)*(3D0*CA**2*MHH2**2+SA**2*MH02*(2D0*MH02+
     &  MHH2))*MW*SW)/(8D0*EL*SA*(MH0+MHH)*(MH0-MHH)))+(EL*
     &  PI**(-2)*SA*((3D0*SA**2*MHH2**2)/MW+(CA**2*MH02*(2D0*
     &  MH02+MHH2))/MW+2D0*MW*(MHH2+6D0*MW2)+((CW2*MHH2+6D0*
     &  MW2)*MZ2)/(CW2*MW)))/(64D0*SW) )

	dl12  = div * l12
     &     *( - 3d0/2d0*ALPHA*(1D0+2D0*CW2)/(8D0*PI*CW2*SW2)
     &        + l12/4d0/pi**2
     &        + 3d0/32d0/pi**2 * (ca2*mh02+sa2*mhh2)/2d0/mw2/sw2*el**2
     &        + 3d0/4d0/pi**2 * 2d0*(sa2*mh02+ca2*mhh2)*l12**2
     &	                      * mw2*sw2/el**2/(mhh2-mh02)**2/sa2/ca2 )

	dl1  = div * ( L12**2/(16d0*Pi**2)
     &		+ 9d0*L12**4*MW**4*(CA2*MHH2+Mh02*SA2)**2*SW**4
     &		  /(16d0*ALPHA**2*CA**4*(Mh02-MHH2)**4*Pi**4*SA**4) )

	do 100 i=1,3

	s = mh02
	seh0HH_mh02_div = seh0HH_mh02_div
     &	+ div * (
     &      -3D0*ALPHA*CDOh0*CDOHH*MQM2(I)*(-S+6D0*MQM2(I))
     &        /(8D0*PI*MW2*SW2)
     &      -3D0*ALPHA*CUPh0*CUPHH*MQP2(I)*(-S+6D0*MQP2(I))
     &        /(8D0*PI*MW2*SW2)
     &      -ALPHA*CLEPh0*CLEPHH*ML2(I)*(-S+6D0*ML2(I))
     &        /(8D0*PI*MW2*SW2) )

	s = mHH2
	seh0HH_mHH2_div = seh0HH_mHH2_div
     &	+ div * (
     &      -3D0*ALPHA*CDOh0*CDOHH*MQM2(I)*(-S+6D0*MQM2(I))
     &        /(8D0*PI*MW2*SW2)
     &      -3D0*ALPHA*CUPh0*CUPHH*MQP2(I)*(-S+6D0*MQP2(I))
     &        /(8D0*PI*MW2*SW2)
     &      -ALPHA*CLEPh0*CLEPHH*ML2(I)*(-S+6D0*ML2(I))
     &        /(8D0*PI*MW2*SW2) )

	th0div = th0div + div*(
     &  -(CLEPh0*EL/PI**2*(ML2(I))*ML2(I))/(8D0*MW*SW)
     &  -(3D0*CDOh0*EL/PI**2*(MQM2(I))*MQM2(I))/(8D0*MW*SW)
     &  -(3D0*CUPh0*EL/PI**2*(MQP2(I))*MQP2(I))/(8D0*MW*SW) )
 
	tHHdiv = tHHdiv + div*(
     &	-(CLEPHH*EL/PI**2*(ML2(I))*ML2(I))/(8D0*MW*SW)
     &  -(3D0*CDOHH*EL/PI**2*(MQM2(I))*MQM2(I))/(8D0*MW*SW)
     &  -(3D0*CUPHH*EL/PI**2*(MQP2(I))*MQP2(I))/(8D0*MW*SW) )

	dl12 = dl12 
     &	- l12/ca2 * div * (
     &    -ALPHA*CLEPh0**2*ML2(I)/(8D0*PI*MW2*SW2)
     &	  -3D0*ALPHA*CDOh0**2*MQM2(I)/(8D0*PI*MW2*SW2)
     &	  -3D0*ALPHA*CUPh0**2*MQP2(I)/(8D0*PI*MW2*SW2) )

100	continue

c scheme 0: alpha MSbar	        (running la12)
c scheme 1: alpha MSbar a la FJ	(running la12)
c scheme 2: on-shell	        (running la12)
c scheme 3: alpha MSbar	        (running la1)
c scheme 4: alpha MSbar a la FJ	(running la1)
c scheme 5: on-shell	        (running la1)
c scheme 6: BFM-inspired

	if ((renscheme.eq.1).or.(renscheme.eq.4)) then
	  seh0HH_mh02_div = seh0HH_mh02_div
     &                   +el*(th0div*Ch0h0HH/Mh02+tHHdiv*Ch0HHHH/MHH2)
	  seh0HH_mHH2_div = seh0HH_mHH2_div
     &                   +el*(th0div*Ch0h0HH/Mh02+tHHdiv*Ch0HHHH/MHH2)
	endif

	if ((renscheme.eq.0).or.(renscheme.eq.1).or.
     &	    (renscheme.eq.3).or.(renscheme.eq.4)) then
	  dsa = ca*(seh0HH_mh02_div+seh0HH_mHH2_div)/2d0/(MHH2-Mh02)
	else
	  dsa = 0d0
	endif

	if ((renscheme.eq.6).or.(renscheme.eq.7)) then
	  dl12 = 0d0
	  dl1  = 0d0
	endif

c beta functions
	Bta   = dsa/ca**3
	Bl12  = dl12 
	Bl1   = dl1  

	end

**********************************************************************
        subroutine RGE_sesm(ta_1,l12_1,mren2bsm_1,
     &                      ta_2,l12_2,mren2bsm_2)
**********************************************************************
*	Solve RGEs for SESM via Runge-Kutta method
*---------------------------------------------------------------------
*       13.2.17 Stefan Dittmaier
**********************************************************************
        implicit real*8 (a-z)
	real*8 y(3),y0(3)

        include '../COMMON/model.inc'
        include '../COMMON/param.inc'
        include '../COMMON/xparam.inc'
        include '../COMMON/param_sesm.inc'
        include '../COMMON/param_bsm.inc'

c test RK4 routine
c	x0 = 0d0
c	x  = 1d0
c	y0(1) = 1d0
c	y0(2) = 0d0
c	call RK4_sesm(x,y,x0,y0,2)

	x0 = log(mren2bsm_1)
	x  = log(mren2bsm_2)
        if (ta_1.eq.0d0) then
          sa_1 = 0d0
          ca_1 = 1d0
        elseif (ta_1.eq.1d30) then
          sa_1 = 1d0
          ca_1 = 0d0
	else
          sa_1 = ta_1/sqrt(1d0+ta_1**2)
          ca_1 = sa_1/ta_1
	endif

	y0(1) = ta_1
        if ((renscheme.eq.0).or.(renscheme.eq.1).or.
     &      (renscheme.eq.2).or.(renscheme.eq.6).or.
     &      (renscheme.eq.7)) then
	  y0(2) = l12_1
	elseif ((renscheme.eq.3).or.(renscheme.eq.4).or.
     &          (renscheme.eq.5)) then
	  l1_1 = 2d0*l12_1**2*MW2*(ca_1**2*MHH2+Mh02*sa_1**2)*SW2
     &		 /(ca_1**2*EL**2*(Mh02-MHH2)**2*sa_1**2)
	  y0(2) = l1_1
	endif

	call RK4_sesm(x,y,x0,y0,2)

	ta_2 = y(1)
        if (ta_2.eq.0d0) then
          sa_2 = 0d0
          ca_2 = 1d0
        elseif (ta_2.eq.1d30) then
          sa_2 = 1d0
          ca_2 = 0d0
	else
	  sa_2 = ta_2/sqrt(1d0+ta_2**2)
	  ca_2 = sa_2/ta_2
	endif
        if ((renscheme.eq.0).or.(renscheme.eq.1).or.
     &      (renscheme.eq.2).or.(renscheme.eq.6).or.
     &      (renscheme.eq.7)) then
	  l12_2 = y(2) 
	elseif ((renscheme.eq.3).or.(renscheme.eq.4).or.
     &          (renscheme.eq.5)) then
	  l1_2  = y(2)
	  l12_2 = EL*ca_2*sa_2*(MHH2-Mh02)/MW/SW
     &	            *sqrt( l1_2/(2d0*(ca_2**2*MHH2+Mh02*sa_2**2)) )
	endif

	end

**********************************************************************
        subroutine RK4_sesm(x,y,x0,y0,d)
**********************************************************************
*	classical Runge-Kutta method for solving
*	y' = f(x,y) with y0 = y(x0)
*	result: y = y(x), y = ( y(1), ... ,y(d) )
*---------------------------------------------------------------------
*       13.2.17 Stefan Dittmaier
**********************************************************************
	implicit none
	integer d,nh,nhmin,nhmax,m,n,r
        real*8 x0,x1,x,y(d),y0(d),dy(d),xa,ya(d),yold(d)
	real*8 f(d),k(4,d),h,acc,aimacc

	aimacc = 1d-14
	acc    = 1d8
	nhmin = 1000
	nhmax = 10**5
	nh    = nhmin

100	continue
	h   = (x-x0)/nh
	if (nh.gt.nhmin) then
	  do n=1,d
	    yold(n) = y(n)
	  enddo
	endif
	do n=1,d
	  y(n) = y0(n)
	enddo

	do r=0,nh-1
	  x1 = x0 + r*h

	do m=1,4

	  if (m.eq.1) then
	    xa = x1
            do n=1,d
	      ya(n) = y(n)
	    enddo
	  elseif (m.eq.2) then
	    xa = x1 + h/2d0
            do n=1,d
	      ya(n) = y(n) + h/2d0*k(1,n)
	    enddo
	  elseif (m.eq.3) then
	    xa = x1 + h/2d0
            do n=1,d
	      ya(n) = y(n) + h/2d0*k(2,n)
	    enddo
	  elseif (m.eq.4) then
	    xa = x1 + h
            do n=1,d
	      ya(n) = y(n) + h*k(3,n)
	    enddo
	  endif

	  call fRK_sesm(f,xa,ya,d)

	  do n=1,d
	    k(m,n) = f(n)
	  enddo

	enddo

	do n=1,d
	  y(n) = y(n) + h/6d0*(k(1,n)+2d0*k(2,n)+2d0*k(3,n)+k(4,n))
	enddo

cxxx
c 	write(*,*) r,x1,y(1)/sqrt(1d0+y(1)**2),y(2)

	enddo

	if (nh.gt.nhmin) then
	  acc = 0d0
	  do n=1,d
	    if (y(n).ne.0d0) acc = max(acc,abs(yold(n)/y(n)-1d0))
	  enddo
	endif

cxxx
c 	write(*,*) nh, y(1),y(2),acc
c 	write(*,*) nh, y(1)/sqrt(1d0+y(1)**2),y(2),acc

	if ((acc.gt.aimacc).and.(nh.lt.nhmax)) then
	  nh = nh * 2
	  goto 100
	endif

c	write(*,*) 'result: ',exp(x)+x, exp(-x), exp(x)*sin(x) 

	end

**********************************************************************
        subroutine fRK_sesm(f,x,y,d)
**********************************************************************
*	function f for Runge-Kutta method for solving
*	y' = f(x,y) 
*---------------------------------------------------------------------
*       28.9.16 Stefan Dittmaier
**********************************************************************
	implicit real*8 (a-z)
	integer d
        real*8 x,y(d),f(d)

        include '../COMMON/model.inc'
        include '../COMMON/param.inc'
        include '../COMMON/xparam.inc'
        include '../COMMON/param_sesm.inc'
        include '../COMMON/param_bsm.inc'

c test function y1 = exp(x)+x,      y2 = exp(-x),          y3 = exp(x)*sin(x) 
c	        f1 = y1+1 = 1/y2+1, f2 = -y2 = -1/(y1-1),  f3 = y3+(y1-1)*cos(x)
c	
c	f(1) = 1d0/y(2)+1d0 
c	f(2) = -1d0/(y(1)-x)
c	f(3) = y(3)+(y(1)-x)*cos(x)

	ta  = y(1)
        TA2 = TA**2
        SA  = TA/sqrt(1d0+TA2)
        CA  = SA/TA

        if ((renscheme.eq.0).or.(renscheme.eq.1).or.
     &      (renscheme.eq.2).or.(renscheme.eq.6).or.
     &      (renscheme.eq.7)) then
	  l12 = y(2) 
	elseif ((renscheme.eq.3).or.(renscheme.eq.4).or.
     &          (renscheme.eq.5)) then
	  l1  = y(2)
	  l12 = EL*ca*sa*(MHH2-Mh02)/MW/SW
     &	            *sqrt( l1/(2d0*(ca**2*MHH2+Mh02*sa**2)) )
	endif

        call beta_sesm(Bta,Bl12,Bl1,Mh0,MHH,ta,l12)

	f(1) = Bta
        if ((renscheme.eq.0).or.(renscheme.eq.1).or.
     &      (renscheme.eq.2).or.(renscheme.eq.6).or.
     &      (renscheme.eq.7)) then
	  f(2) = Bl12
	elseif ((renscheme.eq.3).or.(renscheme.eq.4).or.
     &          (renscheme.eq.5)) then
	  f(2) = Bl1
	endif

cxxx	write(*,*) 'yyy ',y
cxxx	write(*,*) 'fff ',f
cxxx	stop

	end

**********************************************************************
        subroutine hvv_sesm(Gh0WW_lo,Gh0WW_nlo,GHHWW_lo,GHHWW_nlo,
     &                      Gh0ZZ_lo,Gh0ZZ_nlo,GHHZZ_lo,GHHZZ_nlo)
**********************************************************************
*       Decay widths h0/HH -> VV with on-shell V=W/Z
*       SESM
*---------------------------------------------------------------------
*       15.5.18 Stefan Dittmaier
**********************************************************************

        use COLLIER

        implicit real*8 (a-z)
	complex*16 k(22),xb0_,xc0_,beta,b1,cspen_dd
	integer i
c collier parameters
        real*8 deltaUV,muv2,delta1ir,delta2ir,mir2

        complex*16 dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw
        complex*16 dmh02,dmHH2,dZh0,dZHH,dZh0HH,dZHHh0,dsa,dl12
        complex*16 dZeer,dZeel,dZnnl,dZffr(4),dZffl(4)
        complex*16 ct_aww,ct_zww,ct_wen,ct_wf1f2,ct_wf3f4
        complex*16 ct_annl,ct_aeer,ct_aeel,ct_affr(4),ct_affl(4)
        complex*16 ct_znnl,ct_zeer,ct_zeel,ct_zffr(4),ct_zffl(4)
        complex*16 ct_h0ww,ct_HHww,ct_h0zz,ct_HHzz,ct_h0za,ct_HHza
        complex*16 dmw2_f,dmz2_f,dsw_f,dZe_f,dZaa_f,dZaz_f,dZza_f
	complex*16 dZzz_f,dZw_f
        complex*16 dmh02_f,dmHH2_f,dZh0_f,dZHH_f,dZh0HH_f,dZHHh0_f
	complex*16 dsa_f,dl12_f
        complex*16 dZeer_f,dZeel_f,dZnnl_f,dZffr_f(4),dZffl_f(4)
        complex*16 ct_aww_f,ct_zww_f,ct_wen_f,ct_wf1f2_f,ct_wf3f4_f
        complex*16 ct_annl_f,ct_aeer_f,ct_aeel_f,ct_affr_f(4)
	complex*16 ct_affl_f(4)
        complex*16 ct_znnl_f,ct_zeer_f,ct_zeel_f,ct_zffr_f(4)
	complex*16 ct_zffl_f(4)
        complex*16 ct_h0ww_f,ct_HHww_f,ct_h0zz_f,ct_HHzz_f
	complex*16 ct_h0za_f,ct_HHza_f

        include '../COMMON/param.inc'
        include '../COMMON/xparam.inc'
        include '../COMMON/param_sesm.inc'
        include '../COMMON/param_bsm.inc'

        common/xrenc_sesm/
     &	       dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw,
     &	       dmh02,dmHH2,dZh0,dZHH,dZh0HH,dZHHh0,dsa,dl12,
     &         dZeer,dZeel,dZnnl,dZffr,dZffl,
     &         ct_aww,ct_zww,ct_wen,ct_wf1f2,ct_wf3f4,
     &         ct_annl,ct_aeer,ct_aeel,ct_affr,ct_affl,
     &         ct_znnl,ct_zeer,ct_zeel,ct_zffr,ct_zffl,
     &         ct_h0ww,ct_HHww,ct_h0zz,ct_HHzz,ct_h0za,ct_HHza
        common/xrenc_ferm_sesm/
     &	       dmw2_f,dmz2_f,dsw_f,dZe_f,dZaa_f,dZaz_f,dZza_f,dZzz_f,
     &	       dZw_f,
     &	       dmh02_f,dmHH2_f,dZh0_f,dZHH_f,dZh0HH_f,dZHHh0_f,dsa_f,
     &	       dl12_f,
     &         dZeer_f,dZeel_f,dZnnl_f,dZffr_f,dZffl_f,
     &         ct_aww_f,ct_zww_f,ct_wen_f,ct_wf1f2_f,ct_wf3f4_f,
     &         ct_annl_f,ct_aeer_f,ct_aeel_f,ct_affr_f,ct_affl_f,
     &         ct_znnl_f,ct_zeer_f,ct_zeel_f,ct_zffr_f,ct_zffl_f,
     &         ct_h0ww_f,ct_HHww_f,ct_h0zz_f,ct_HHzz_f,ct_h0za_f,
     &	       ct_HHza_f

c switch V widths temporarily off
	call fix_param(1)

	Gh0WW_lo  = 0d0
	Gh0WW_nlo = 0d0
	GHHWW_lo  = 0d0
	GHHWW_nlo = 0d0
	Gh0ZZ_lo  = 0d0
	Gh0ZZ_nlo = 0d0
	GHHZZ_lo  = 0d0
	GHHZZ_nlo = 0D0

        call GetMuUV2_cll(muv2)
        call GetDeltaUV_cll(deltaUV)
        mudim2 = exp(deltauv + log(muv2))
        call GetDeltaIR_cll(delta1ir,delta2ir)
        call GetMuIR2_cll(mir2)
        lambda2 = exp(delta1ir + log(mir2))
        lambda  = sqrt(lambda2)

	if (Mh0.gt.2d0*mw) then

        Gh0WW_lo = sqrt(1d0-4d0*mw2/Mh02)/16d0/pi/Mh0
     &	*(CA2*EL**2*(Mh02**2-4D0*Mh02*MW2+12D0*MW2**2))/(4D0*MW2*SW2)

        K(1) = XB0_(0D0,NULL,XMh02,0)
        K(2) = XB0_(0D0,NULL,XMHH2,0)
        K(3) = XB0_(0D0,NULL,XMW2,0)
        K(4) = XB0_(0D0,NULL,XMZ2,0)
        K(5) = XB0_(Mh02,XMh02,XMh02,0)
        K(6) = XB0_(Mh02,XMh02,XMHH2,0)
        K(7) = XB0_(Mh02,XMHH2,XMHH2,0)
        K(8) = XB0_(Mh02,XMW2,XMW2,0)
        K(9) = XB0_(Mh02,XMZ2,XMZ2,0)
        K(10) = XB0_(MW2,NULL,XMW2,0)
        K(11) = XB0_(MW2,XMh02,XMW2,0)
        K(12) = XB0_(MW2,XMHH2,XMW2,0)
        K(13) = XB0_(MW2,XMW2,XMZ2,0)
        K(14) = XC0_(MW2,Mh02,MW2,NULL,XMW2,XMW2,0)
        K(15) = XC0_(MW2,Mh02,MW2,XMh02,XMW2,XMW2,0)
        K(16) = XC0_(MW2,Mh02,MW2,XMHH2,XMW2,XMW2,0)
        K(17) = XC0_(MW2,Mh02,MW2,XMW2,XMh02,XMh02,0)
        K(18) = XC0_(MW2,Mh02,MW2,XMW2,XMh02,XMHH2,0)
        K(19) = XC0_(MW2,Mh02,MW2,XMW2,XMHH2,XMh02,0)
        K(20) = XC0_(MW2,Mh02,MW2,XMW2,XMHH2,XMHH2,0)
        K(21) = XC0_(MW2,Mh02,MW2,XMW2,XMZ2,XMZ2,0)
        K(22) = XC0_(MW2,Mh02,MW2,XMZ2,XMW2,XMW2,0)
        MAT2 = -((ALPHA*(-(64D0*K(10)*ALPHA*CA2*Mh02*(Mh02-2D0*MW2))+
     &  32D0*K(14)*ALPHA*CA2*(Mh02**3-6D0*Mh02**2*MW2+20D0*Mh02*MW2**2-
     &  24D0*MW2**3)+(4D0*K(15)*ALPHA*CA*CA2**(3D0/2D0)*(Mh02**4+8D0*
     &  Mh02**3*MW2-8D0*Mh02**2*MW2**2-32D0*Mh02*MW2**3+48D0*MW2**4))/
     &  (MW2*SW2)+(4D0*K(16)*ALPHA*CA2*(Mh02**2*(MHH2+2D0*MW2)**2+
     &  4D0*MW2**2*(MHH2**2-4D0*MHH2*MW2+12D0*MW2**2)+4D0*Mh02*MW2*
     &  (MHH2**2-4D0*MHH2*MW2-4D0*MW2**2))*SA2)/(MW2*SW2)+(8D0*K(4)*
     &  ALPHA*CA2*(1D0-CW2)*(Mh02-2D0*MW2)*MZ2*(9D0*CW2+SW2))/(CW2*
     &  SW2)+(K(2)*CA2*MHH2*(Mh02-2D0*MW2)*SA2*(4D0*ALPHA*PI*(CA2*
     &  Mh02-2D0*MW2+MHH2*(1D0+SA2))-8D0*L12*MW2*SW2))/(MW2*PI*SW2)-
     &  (K(18)*CA2*(2D0*Mh02**3*(MHH2+2D0*MW2)-16D0*Mh02*MW2**2*(MHH2-
     &  3D0*MW2)+2D0*MHH2*MW2*(MHH2**2-2D0*MHH2*MW2+12D0*MW2**2)+
     &  Mh02**2*(MHH2**2-6D0*MHH2*MW2-16D0*MW2**2))*SA2*(-(4D0*ALPHA*
     &  CA2*(Mh02-MHH2)*PI)+8D0*L12*MW2*SW2))/((Mh0+MHH)*(Mh0-MHH)*MW2*
     &  PI*SW2)-(K(19)*CA2*(2D0*Mh02**3*(MHH2+2D0*MW2)-16D0*Mh02*MW2**
     &  2*(MHH2-3D0*MW2)+2D0*MHH2*MW2*(MHH2**2-2D0*MHH2*MW2+12D0*
     &  MW2**2)+Mh02**2*(MHH2**2-6D0*MHH2*MW2-16D0*MW2**2))*SA2*(-
     &  (4D0*ALPHA*CA2*(Mh02-MHH2)*PI)+8D0*L12*MW2*SW2))/((Mh0+MHH)*
     &  (Mh0-MHH)*MW2*PI*SW2)+(K(6)*CA2*(2D0*Mh02**3+3D0*Mh02**2*MHH2+
     &  2D0*MHH2*MW2*(MHH2-6D0*MW2)+Mh02*(MHH2**2+4D0*MHH2*MW2-24D0*
     &  MW2**2))*SA2*(-(4D0*ALPHA*CA2*(Mh02-MHH2)*PI)+8D0*L12*MW2*
     &  SW2))/((Mh0+MHH)*(Mh0-MHH)*MW2*PI*SW2)-(K(7)*CA2*(Mh02**2*
     &  (MHH2-MW2)+4D0*MHH2*MW2*(MHH2-3D0*MW2)+2D0*Mh02*(MHH2**2-3D0*
     &  MW2**2))*SA2*(4D0*ALPHA*(Mh02-MHH2)*PI*SA2+8D0*L12*MW2*SW2))/
     &  ((Mh0+MHH)*(Mh0-MHH)*MW2*PI*SW2)+(K(20)*CA2*(2D0*Mh02**3*MW2+
     &  4D0*MHH2*MW2*(MHH2**2-4D0*MHH2*MW2+12D0*MW2**2)+Mh02**2*
     &  (MHH2**2-4D0*MW2**2)+2D0*Mh02*(MHH2**3-3D0*MHH2**2*MW2-8D0*
     &  MHH2*MW2**2+12D0*MW2**3))*SA2*(4D0*ALPHA*(Mh02-MHH2)*PI*SA2+
     &  8D0*L12*MW2*SW2))/((Mh0+MHH)*(Mh0-MHH)*MW2*PI*SW2)-(8D0*K(12)*
     &  CA2*SA2*(-(4D0*ALPHA*PI*(CA2*Mh02**2+6D0*MW2**2+MHH2**2*SA2-
     &  MHH2*MW2*(2D0+SA2)-Mh02*MW2*(3D0-SA2)))+8D0*L12*MW2*(Mh02+
     &  MHH2-MW2)*SW2))/(PI*SW2)+(4D0*K(9)*ALPHA*CA2*(CW2*(96D0*
     &  MW2**3-36D0*MW2**2*MZ2+Mh02**2*(4D0*MW2-MZ2)+20D0*Mh02*(MW2**
     &  2-MW2*MZ2))-MW2*(-(3D0*Mh02**2)+4D0*MW2*MZ2+2D0*Mh02*(MW2+
     &  MZ2))*SW2))/(CW2*MW2*SW2)-(3D0*K(5)*CA2*Mh02*(Mh02**2+Mh02*MW2-
     &  6D0*MW2**2)*(4D0*ALPHA*CA2**2*(Mh02-MHH2)*PI+8D0*L12*MW2*SA2*
     &  SW2))/((Mh0+MHH)*(Mh0-MHH)*MW2*PI*SW2)+(3D0*K(17)*CA2*Mh02*
     &  (Mh02**3-12D0*Mh02*MW2**2+24D0*MW2**3)*(4D0*ALPHA*CA2**2*(Mh02-
     &  MHH2)*PI+8D0*L12*MW2*SA2*SW2))/((Mh0+MHH)*(Mh0-MHH)*MW2*PI*
     &  SW2)+(K(1)*CA2*Mh02*(Mh02-2D0*MW2)*(-(4D0*ALPHA*CA2*PI*(2D0*
     &  MW2-MHH2*SA2-Mh02*(2D0-SA2)))+8D0*L12*MW2*SA2*SW2))/(MW2*PI*
     &  SW2)+(4D0*K(11)*CA2*(-(4D0*ALPHA*CA2*PI*(-(12D0*MW2**2)-
     &  MHH2**2*SA2+2D0*MHH2*MW2*SA2-Mh02**2*(2D0-3D0*SA2)-2D0*Mh02*
     &  (MHH2*SA2-MW2*(5D0-SA2))))+8D0*L12*MW2*(3D0*Mh02+MHH2-2D0*
     &  MW2)*SA2*SW2))/(PI*SW2)+(4D0*K(21)*ALPHA*CA2*CW2**(-2)*
     &  (CW2**2*(2D0*Mh02**3*MW2+Mh02**2*(-(12D0*MW2*MZ2)+MZ2**2)-
     &  12D0*MW2**2*(20D0*MW2**2+16D0*MW2*MZ2-3D0*MZ2**2)+4D0*Mh02*
     &  (48D0*MW2**3-14D0*MW2**2*MZ2+5D0*MW2*MZ2**2))+2D0*CW2*MW2*(-
     &  (8D0*MW2**2*MZ2)+2D0*MW2*MZ2**2+Mh02**2*(4D0*MW2-2D0*MZ2)+
     &  Mh02*(-(4D0*MW2**2)+MZ2**2))*SW2+4D0*MW2**2*(Mh02**2-4D0*Mh02*
     &  MW2+12D0*MW2**2)*SW2**2))/(MW2*SW2)+(32D0*ALPHA*CA2*(CW2**2*
     &  (Mh02**2-4D0*Mh02*MW2+3D0*MW2**2)-MW2**2*SW2-CW2*(MHH2*MW2*
     &  SA2+Mh02**2*(1D0-SW2)+MW2**2*(22D0-3D0*SW2)-Mh02*MW2*(1D0+SA2-
     &  4D0*SW2))))/(CW2*SW2)+(8D0*K(3)*ALPHA*CA2*(Mh02-2D0*MW2)*
     &  (9D0*CW2**2*MW2-MW2*SW2-CW2*(CA2*Mh02+MHH2*SA2+MW2*(8D0-9D0*
     &  SW2))))/(CW2*SW2)+(4D0*K(8)*ALPHA*CA2*(CA2*Mh02**3+2D0*Mh02*
     &  MW2*(2D0*MHH2*SA2+MZ2*(1D0+9D0*CW2+SW2)-MW2*(23D0-13D0*CW2+
     &  2D0*SA2-13D0*SW2))-4D0*MW2**2*(-(9D0*CW2*MZ2)-MHH2*SA2-MZ2*
     &  SW2-MW2*(34D0-30D0*CW2-30D0*SW2))+Mh02**2*(MZ2+MHH2*SA2+MW2*
     &  (17D0-9D0*CW2-4D0*SA2-9D0*SW2))))/(MW2*SW2)+(4D0*K(22)*
     &  ALPHA*CA2*(2D0*CW2**2*MW2*(Mh02**3-6D0*Mh02**2*MW2-6D0*MW2*
     &  (20D0*MW2**2+16D0*MW2*MZ2-3D0*MZ2**2)+Mh02*(68D0*MW2**2+4D0*
     &  MW2*MZ2+9D0*MZ2**2))+2D0*Mh02*MW2*(Mh02**2-4D0*Mh02*MW2+12D0*
     &  MW2**2)*SW2**2+CW2*(-(4D0*Mh02**3*MW2*SW2)+4D0*MW2**2*(-
     &  (12D0*MW2**2)+8D0*MW2*MZ2+MZ2**2)*SW2+Mh02**2*(MZ2**2+28D0*
     &  MW2**2*SW2-8D0*MW2*MZ2*SW2)+2D0*Mh02*MW2*MZ2*(MZ2*(1D0+SW2)-
     &  4D0*MW2*(1D0-SW2)))))/(CW2*MW2*SW2)-(16D0*K(13)*ALPHA*CA2*
     &  (2D0*CW2**2*(Mh02**2-3D0*Mh02*MW2+6D0*MW2**2+9D0*MW2*MZ2)+CW2*
     &  (Mh02**2*(2D0-3D0*SW2)-2D0*Mh02*MW2*(2D0-3D0*SW2)+2D0*MW2*
     &  (24D0*MW2-MZ2*(9D0-SW2)))-SW2*(-(Mh02**2*(1D0-SW2))+2D0*Mh02*
     &  MW2*(1D0-2D0*SW2)+2D0*MW2*(MZ2-MW2*(2D0-6D0*SW2)))))/(CW2*
     &  SW2)))/(32D0*MW2*SW2))
	do i=1,3
        K(1) = XB0_(0D0,NULL,XMQM2(I),0)
        K(2) = XB0_(0D0,NULL,XML2(I),0)
        K(3) = XB0_(0D0,NULL,XMQP2(I),0)
        K(4) = XB0_(Mh02,XMQM2(I),XMQM2(I),0)
        K(5) = XB0_(Mh02,XML2(I),XML2(I),0)
        K(6) = XB0_(Mh02,XMQP2(I),XMQP2(I),0)
        K(7) = XB0_(MW2,NULL,XML2(I),0)
        K(8) = XB0_(MW2,XMQM2(I),XMQP2(I),0)
        K(9) = XC0_(MW2,Mh02,MW2,NULL,XML2(I),XML2(I),0)
        K(10) = XC0_(MW2,Mh02,MW2,XMQM2(I),XMQP2(I),XMQP2(I),0)
        K(11) = XC0_(MW2,Mh02,MW2,XMQP2(I),XMQM2(I),XMQM2(I),0)
        MAT2 = mat2 + 
     &	(ALPHA**2*CA2*SW2**(-2)*(2D0*K(2)*MW2**(-2)*(Mh02-2D0*
     &  MW2)*XML2(I)**2-(2D0*K(7)*XML2(I)*(Mh02-2D0*MW2-4D0*
     &  XML2(I)))/MW2+K(5)*MW2**(-2)*XML2(I)*(Mh02**2+8D0*MW2**2-4D0*
     &  MW2*XML2(I)-2D0*Mh02*(MW2+XML2(I)))-2D0*K(9)*MW2**(-2)*
     &  XML2(I)*(MW2-XML2(I))*(Mh02*(-(2D0*MW2)+XML2(I))+2D0*MW2*
     &  (2D0*MW2+XML2(I)))-6D0*K(3)*MW2**(-2)*(Mh02-2D0*MW2)*
     &  XMQP2(I)*(XMQM2(I)-XMQP2(I))-8D0*(XML2(I)+3D0*XMQM2(I)+3D0*
     &  XMQP2(I))+6D0*K(1)*MW2**(-2)*(Mh02-2D0*MW2)*(XMQM2(I)**2-
     &  XMQM2(I)*XMQP2(I))+3D0*K(4)*MW2**(-2)*XMQM2(I)*(Mh02**2+4D0*
     &  MW2*(2D0*MW2-XMQM2(I)+XMQP2(I))-2D0*Mh02*(MW2+XMQM2(I)-
     &  XMQP2(I)))+3D0*K(6)*MW2**(-2)*XMQP2(I)*(Mh02**2-2D0*Mh02*(MW2-
     &  XMQM2(I)+XMQP2(I))+4D0*MW2*(2D0*MW2+XMQM2(I)-XMQP2(I)))+6D0*
     &  K(11)*MW2**(-2)*XMQM2(I)*(Mh02**2*XMQP2(I)+2D0*MW2*(-(2D0*
     &  MW2**2)+MW2*(XMQM2(I)+XMQP2(I))+(XMQM2(I)-XMQP2(I))**2)+Mh02*
     &  (2D0*MW2**2-MW2*(3D0*XMQM2(I)+XMQP2(I))+(XMQM2(I)-
     &  XMQP2(I))**2))-(6D0*K(8)*(Mh02*(XMQM2(I)+XMQP2(I))-2D0*(MW2*
     &  (XMQM2(I)+XMQP2(I))+2D0*(XMQM2(I)-XMQP2(I))**2)))/MW2+6D0*
     &  K(10)*MW2**(-2)*XMQP2(I)*(Mh02**2*XMQM2(I)+2D0*MW2*(-(2D0*
     &  MW2**2)+MW2*(XMQM2(I)+XMQP2(I))+(XMQM2(I)-XMQP2(I))**2)+Mh02*
     &  (2D0*MW2**2+(XMQM2(I)-XMQP2(I))**2-MW2*(XMQM2(I)+3D0*
     &  XMQP2(I))))))/4D0
	enddo

	beta = sqrt(1d0-4d0*mw2/Mh02+dcmplx(0,1d-20))
      	G0 = Mh02**2-4D0*Mh02*MW2+12D0*MW2**2
        B1 = ((1D0-BETA)*Mh0)/(2D0*MW)
        brems = (2D0*ALPHA*(9D0*(Mh02-2D0*MW2)*LOG(B1)**2+(3D0*LOG(B1)*(-
     &  (G0*Mh02)+8D0*MW2**2*(Mh02-2D0*MW2)+2D0*G0*(Mh02-2D0*MW2)*
     &  LOG(BETA**(-2)*LAMBDA*Mh0**(-3)*MW2)))/G0+(-(3D0*G0*(Mh02-2D0*
     &  MW2)*cspen_dd(1D0-B1**2))+3D0*G0*(Mh02-2D0*MW2)*cspen_dd(1D0
     &  -B1**(-4))+BETA*Mh02*(6D0*G0+BETA**2*Mh02**2+12D0*MW2**2-3D0*G0*
     &  LOG((BETA**2*Mh0**3)/(LAMBDA*MW2))))/G0))/(3D0*BETA*Mh02*PI)

        Gh0WW_nlo = sqrt(1d0-4d0*mw2/Mh02)/16d0/pi/Mh0 * mat2
     &	            + Gh0WW_lo*(1d0+2d0*(ct_h0ww+ct_h0ww_f)+brems)

	endif

	if (MHH.gt.2d0*mw) then

	GHHWW_lo = sqrt(1d0-4d0*mw2/MHH2)/16d0/pi/MHH
     &	*(EL**2*(MHH2**2-4D0*MHH2*MW2+12D0*MW2**2)*SA2)/(4D0*MW2*SW2)

        K(1) = XB0_(0D0,NULL,XMh02,0)
        K(2) = XB0_(0D0,NULL,XMHH2,0)
        K(3) = XB0_(0D0,NULL,XMW2,0)
        K(4) = XB0_(0D0,NULL,XMZ2,0)
        K(5) = XB0_(MHH2,XMh02,XMh02,0)
        K(6) = XB0_(MHH2,XMh02,XMHH2,0)
        K(7) = XB0_(MHH2,XMHH2,XMHH2,0)
        K(8) = XB0_(MHH2,XMW2,XMW2,0)
        K(9) = XB0_(MHH2,XMZ2,XMZ2,0)
        K(10) = XB0_(MW2,NULL,XMW2,0)
        K(11) = XB0_(MW2,XMh02,XMW2,0)
        K(12) = XB0_(MW2,XMHH2,XMW2,0)
        K(13) = XB0_(MW2,XMW2,XMZ2,0)
        K(14) = XC0_(MW2,MHH2,MW2,NULL,XMW2,XMW2,0)
        K(15) = XC0_(MW2,MHH2,MW2,XMh02,XMW2,XMW2,0)
        K(16) = XC0_(MW2,MHH2,MW2,XMHH2,XMW2,XMW2,0)
        K(17) = XC0_(MW2,MHH2,MW2,XMW2,XMh02,XMh02,0)
        K(18) = XC0_(MW2,MHH2,MW2,XMW2,XMh02,XMHH2,0)
        K(19) = XC0_(MW2,MHH2,MW2,XMW2,XMHH2,XMh02,0)
        K(20) = XC0_(MW2,MHH2,MW2,XMW2,XMHH2,XMHH2,0)
        K(21) = XC0_(MW2,MHH2,MW2,XMW2,XMZ2,XMZ2,0)
        K(22) = XC0_(MW2,MHH2,MW2,XMZ2,XMW2,XMW2,0)
        MAT2 = (ALPHA*(64D0*K(10)*ALPHA*MHH2*(MHH2-2D0*MW2)*SA2-
     &  32D0*K(14)*ALPHA*(MHH2**3-6D0*MHH2**2*MW2+20D0*MHH2*MW2**2-
     &  24D0*MW2**3)*SA2-(4D0*K(16)*ALPHA*(MHH2**4+8D0*MHH2**3*MW2-
     &  8D0*MHH2**2*MW2**2-32D0*MHH2*MW2**3+48D0*MW2**4)*SA**4)/
     &  (MW2*SW2)-(4D0*K(15)*ALPHA*CA2*(Mh02**2*(MHH2+2D0*MW2)**2+
     &  4D0*MW2**2*(MHH2**2-4D0*MHH2*MW2+12D0*MW2**2)+4D0*Mh02*MW2*
     &  (MHH2**2-4D0*MHH2*MW2-4D0*MW2**2))*SA2)/(MW2*SW2)-(8D0*K(4)*
     &  ALPHA*(1D0-CW2)*(MHH2-2D0*MW2)*MZ2*SA2*(9D0*CW2+SW2))/(CW2*
     &  SW2)-(K(5)*CA2*(2D0*Mh02**2*(MHH2+2D0*MW2)-MHH2*MW2*(MHH2+
     &  6D0*MW2)+Mh02*(MHH2**2-12D0*MW2**2))*SA2*(-(4D0*ALPHA*CA2*
     &  (Mh02-MHH2)*PI)+8D0*L12*MW2*SW2))/((Mh0+MHH)*(Mh0-MHH)*MW2*PI*
     &  SW2)+(K(17)*CA2*(2D0*Mh02**3*(MHH2+2D0*MW2)-16D0*Mh02*MW2**2*
     &  (MHH2-3D0*MW2)+2D0*MHH2*MW2*(MHH2**2-2D0*MHH2*MW2+12D0*MW2**
     &  2)+Mh02**2*(MHH2**2-6D0*MHH2*MW2-16D0*MW2**2))*SA2*(-(4D0*
     &  ALPHA*CA2*(Mh02-MHH2)*PI)+8D0*L12*MW2*SW2))/((Mh0+MHH)*(Mh0-
     &  MHH)*MW2*PI*SW2)+(K(6)*CA2*(Mh02**2*(MHH2+2D0*MW2)+2D0*MHH2*
     &  (MHH2**2-12D0*MW2**2)+Mh02*(3D0*MHH2**2+4D0*MHH2*MW2-12D0*
     &  MW2**2))*SA2*(4D0*ALPHA*(Mh02-MHH2)*PI*SA2+8D0*L12*MW2*SW2))/
     &  ((Mh0+MHH)*(Mh0-MHH)*MW2*PI*SW2)-(K(18)*CA2*(2D0*Mh02**3*MW2+
     &  4D0*MHH2*MW2*(MHH2**2-4D0*MHH2*MW2+12D0*MW2**2)+Mh02**2*
     &  (MHH2**2-4D0*MW2**2)+2D0*Mh02*(MHH2**3-3D0*MHH2**2*MW2-8D0*
     &  MHH2*MW2**2+12D0*MW2**3))*SA2*(4D0*ALPHA*(Mh02-MHH2)*PI*SA2+
     &  8D0*L12*MW2*SW2))/((Mh0+MHH)*(Mh0-MHH)*MW2*PI*SW2)-(K(19)*CA2*
     &  (2D0*Mh02**3*MW2+4D0*MHH2*MW2*(MHH2**2-4D0*MHH2*MW2+12D0*
     &  MW2**2)+Mh02**2*(MHH2**2-4D0*MW2**2)+2D0*Mh02*(MHH2**3-3D0*
     &  MHH2**2*MW2-8D0*MHH2*MW2**2+12D0*MW2**3))*SA2*(4D0*ALPHA*
     &  (Mh02-MHH2)*PI*SA2+8D0*L12*MW2*SW2))/((Mh0+MHH)*(Mh0-MHH)*MW2*
     &  PI*SW2)+(K(1)*CA2*Mh02*(MHH2-2D0*MW2)*SA2*(4D0*ALPHA*PI*(2D0*
     &  MW2-MHH2*SA2-Mh02*(2D0-SA2))+8D0*L12*MW2*SW2))/(MW2*PI*SW2)+
     &  (3D0*K(7)*MHH2*(MHH2**2+MHH2*MW2-6D0*MW2**2)*SA2*(4D0*ALPHA*
     &  (Mh02-MHH2)*PI*SA**4-8D0*CA2*L12*MW2*SW2))/((Mh0+MHH)*(Mh0-
     &  MHH)*MW2*PI*SW2)-(3D0*K(20)*MHH2*(MHH2**3-12D0*MHH2*MW2**2+
     &  24D0*MW2**3)*SA2*(4D0*ALPHA*(Mh02-MHH2)*PI*SA**4-8D0*CA2*L12*
     &  MW2*SW2))/((Mh0+MHH)*(Mh0-MHH)*MW2*PI*SW2)-(K(2)*MHH2*(MHH2-
     &  2D0*MW2)*SA2*(4D0*ALPHA*PI*SA2*(CA2*Mh02-2D0*MW2+MHH2*(1D0+
     &  SA2))+8D0*CA2*L12*MW2*SW2))/(MW2*PI*SW2)+(8D0*K(11)*CA2*SA2*
     &  (-(4D0*ALPHA*PI*(CA2*Mh02**2+6D0*MW2**2+MHH2**2*SA2-MHH2*MW2*
     &  (2D0+SA2)-Mh02*MW2*(3D0-SA2)))+8D0*L12*MW2*(Mh02+MHH2-MW2)*
     &  SW2))/(PI*SW2)+(4D0*K(12)*SA2*(-(4D0*ALPHA*PI*SA2*(CA2*Mh02**
     &  2+12D0*MW2**2+2D0*CA2*Mh02*(MHH2-MW2)-2D0*MHH2*MW2*(4D0+SA2)-
     &  MHH2**2*(1D0-3D0*SA2)))-8D0*CA2*L12*MW2*(Mh02+3D0*MHH2-2D0*
     &  MW2)*SW2))/(PI*SW2)-(4D0*K(9)*ALPHA*SA2*(CW2*(96D0*MW2**3-
     &  36D0*MW2**2*MZ2+MHH2**2*(4D0*MW2-MZ2)+20D0*MHH2*(MW2**2-MW2*
     &  MZ2))-MW2*(-(3D0*MHH2**2)+4D0*MW2*MZ2+2D0*MHH2*(MW2+MZ2))*
     &  SW2))/(CW2*MW2*SW2)-(4D0*K(21)*ALPHA*CW2**(-2)*SA2*(CW2**2*
     &  (2D0*MHH2**3*MW2+MHH2**2*(-(12D0*MW2*MZ2)+MZ2**2)-12D0*MW2**
     &  2*(20D0*MW2**2+16D0*MW2*MZ2-3D0*MZ2**2)+4D0*MHH2*(48D0*MW2**
     &  3-14D0*MW2**2*MZ2+5D0*MW2*MZ2**2))+2D0*CW2*MW2*(-(8D0*MW2**
     &  2*MZ2)+2D0*MW2*MZ2**2+MHH2**2*(4D0*MW2-2D0*MZ2)+MHH2*(-(4D0*
     &  MW2**2)+MZ2**2))*SW2+4D0*MW2**2*(MHH2**2-4D0*MHH2*MW2+12D0*
     &  MW2**2)*SW2**2))/(MW2*SW2)+(8D0*K(3)*ALPHA*(MHH2-2D0*MW2)*
     &  SA2*(-(9D0*CW2**2*MW2)+MW2*SW2+CW2*(CA2*Mh02+MHH2*SA2+MW2*
     &  (8D0-9D0*SW2))))/(CW2*SW2)-(4D0*K(8)*ALPHA*SA2*(CA2*Mh02*
     &  (MHH2+2D0*MW2)**2+MHH2**3*SA2+2D0*MHH2*MW2*(MZ2*(1D0+9D0*
     &  CW2+SW2)-MW2*(25D0-13D0*CW2-2D0*SA2-13D0*SW2))+4D0*MW2**2*
     &  (MZ2*(9D0*CW2+SW2)+MW2*(34D0-30D0*CW2-30D0*SW2))+MHH2**2*
     &  (MZ2+MW2*(13D0-9D0*CW2+4D0*SA2-9D0*SW2))))/(MW2*SW2)-(32D0*
     &  ALPHA*(CW2**2*(MHH2**2-4D0*MHH2*MW2+3D0*MW2**2)*SA2-MW2**2*
     &  SA2*SW2-CW2*(-(Mh02*MW2*(SA**4-SA2))+MW2**2*SA2*(22D0-3D0*
     &  SW2)+MHH2**2*(SA2-SA2*SW2)+MHH2*MW2*(SA**4-2D0*SA2+4D0*SA2*
     &  SW2))))/(CW2*SW2)-(4D0*K(22)*ALPHA*SA2*(2D0*CW2**2*MW2*
     &  (MHH2**3-6D0*MHH2**2*MW2-6D0*MW2*(20D0*MW2**2+16D0*MW2*MZ2-
     &  3D0*MZ2**2)+MHH2*(68D0*MW2**2+4D0*MW2*MZ2+9D0*MZ2**2))+2D0*
     &  MHH2*MW2*(MHH2**2-4D0*MHH2*MW2+12D0*MW2**2)*SW2**2+CW2*(-
     &  (4D0*MHH2**3*MW2*SW2)+4D0*MW2**2*(-(12D0*MW2**2)+8D0*MW2*
     &  MZ2+MZ2**2)*SW2+MHH2**2*(MZ2**2+28D0*MW2**2*SW2-8D0*MW2*MZ2*
     &  SW2)+2D0*MHH2*MW2*MZ2*(MZ2*(1D0+SW2)-4D0*MW2*(1D0-SW2)))))/
     &  (CW2*MW2*SW2)+(16D0*K(13)*ALPHA*SA2*(2D0*CW2**2*(MHH2**2-
     &  3D0*MHH2*MW2+6D0*MW2**2+9D0*MW2*MZ2)+CW2*(MHH2**2*(2D0-3D0*
     &  SW2)-2D0*MHH2*MW2*(2D0-3D0*SW2)+2D0*MW2*(24D0*MW2-MZ2*(9D0-
     &  SW2)))-SW2*(-(MHH2**2*(1D0-SW2))+2D0*MHH2*MW2*(1D0-2D0*SW2)+
     &  2D0*MW2*(MZ2-MW2*(2D0-6D0*SW2)))))/(CW2*SW2)))/(32D0*MW2*
     &  SW2)
	do i=1,3
        K(1) = XB0_(0D0,NULL,XMQM2(I),0)
        K(2) = XB0_(0D0,NULL,XML2(I),0)
        K(3) = XB0_(0D0,NULL,XMQP2(I),0)
        K(4) = XB0_(MHH2,XMQM2(I),XMQM2(I),0)
        K(5) = XB0_(MHH2,XML2(I),XML2(I),0)
        K(6) = XB0_(MHH2,XMQP2(I),XMQP2(I),0)
        K(7) = XB0_(MW2,NULL,XML2(I),0)
        K(8) = XB0_(MW2,XMQM2(I),XMQP2(I),0)
        K(9) = XC0_(MW2,MHH2,MW2,NULL,XML2(I),XML2(I),0)
        K(10) = XC0_(MW2,MHH2,MW2,XMQM2(I),XMQP2(I),XMQP2(I),0)
        K(11) = XC0_(MW2,MHH2,MW2,XMQP2(I),XMQM2(I),XMQM2(I),0)
        MAT2 = mat2 + 
     &	(ALPHA**2*SA2*SW2**(-2)*(2D0*K(2)*MW2**(-2)*(MHH2-
     &  2D0*MW2)*XML2(I)**2-(2D0*K(7)*XML2(I)*(MHH2-2D0*MW2-4D0*
     &  XML2(I)))/MW2+K(5)*MW2**(-2)*XML2(I)*(MHH2**2+8D0*MW2**2-
     &  4D0*MW2*XML2(I)-2D0*MHH2*(MW2+XML2(I)))-2D0*K(9)*MW2**(-2)*
     &  XML2(I)*(MW2-XML2(I))*(MHH2*(-(2D0*MW2)+XML2(I))+2D0*MW2*
     &  (2D0*MW2+XML2(I)))+6D0*K(1)*MW2**(-2)*(MHH2-2D0*MW2)*
     &  XMQM2(I)*(XMQM2(I)-XMQP2(I))-6D0*K(3)*MW2**(-2)*(MHH2-2D0*
     &  MW2)*XMQP2(I)*(XMQM2(I)-XMQP2(I))-8D0*(XML2(I)+3D0*XMQM2(I)+
     &  3D0*XMQP2(I))+3D0*K(4)*MW2**(-2)*XMQM2(I)*(MHH2**2+4D0*MW2*
     &  (2D0*MW2-XMQM2(I)+XMQP2(I))-2D0*MHH2*(MW2+XMQM2(I)-
     &  XMQP2(I)))+3D0*K(6)*MW2**(-2)*XMQP2(I)*(MHH2**2-2D0*MHH2*
     &  (MW2-XMQM2(I)+XMQP2(I))+4D0*MW2*(2D0*MW2+XMQM2(I)-
     &  XMQP2(I)))+6D0*K(11)*MW2**(-2)*XMQM2(I)*(MHH2**2*XMQP2(I)+
     &  2D0*MW2*(-(2D0*MW2**2)+MW2*(XMQM2(I)+XMQP2(I))+(XMQM2(I)-
     &  XMQP2(I))**2)+MHH2*(2D0*MW2**2-MW2*(3D0*XMQM2(I)+XMQP2(I))+
     &  (XMQM2(I)-XMQP2(I))**2))-(6D0*K(8)*(MHH2*(XMQM2(I)+
     &  XMQP2(I))-2D0*(MW2*(XMQM2(I)+XMQP2(I))+2D0*(XMQM2(I)-
     &  XMQP2(I))**2)))/MW2+6D0*K(10)*MW2**(-2)*XMQP2(I)*(MHH2**2*
     &  XMQM2(I)+2D0*MW2*(-(2D0*MW2**2)+MW2*(XMQM2(I)+XMQP2(I))+
     &  (XMQM2(I)-XMQP2(I))**2)+MHH2*(2D0*MW2**2+(XMQM2(I)-
     &  XMQP2(I))**2-MW2*(XMQM2(I)+3D0*XMQP2(I))))))/4D0
	enddo

	beta = sqrt(1d0-4d0*mw2/MHH2+dcmplx(0,1d-20))
      	G0 = MHH2**2-4D0*MHH2*MW2+12D0*MW2**2
        B1 = ((1D0-BETA)*MHH)/(2D0*MW)
        brems = (2D0*ALPHA*(9D0*(MHH2-2D0*MW2)*LOG(B1)**2+(3D0*LOG(B1)*(-
     &  (G0*MHH2)+8D0*MW2**2*(MHH2-2D0*MW2)+2D0*G0*(MHH2-2D0*MW2)*
     &  LOG(BETA**(-2)*LAMBDA*MHH**(-3)*MW2)))/G0+(-(3D0*G0*(MHH2-2D0*
     &  MW2)*cspen_dd(1D0-B1**2))+3D0*G0*(MHH2-2D0*MW2)*cspen_dd(1D0
     &  -B1**(-4))+BETA*MHH2*(6D0*G0+BETA**2*MHH2**2+12D0*MW2**2-3D0*G0*
     &  LOG((BETA**2*MHH**3)/(LAMBDA*MW2))))/G0))/(3D0*BETA*MHH2*PI)

	GHHWW_nlo = sqrt(1d0-4d0*mw2/MHH2)/16d0/pi/MHH * mat2
     &	            + GHHWW_lo*(1d0+2d0*(ct_HHww+ct_HHww_f)+brems)

	endif

	if (Mh0.gt.2d0*mw) then

	Gh0ZZ_lo = sqrt(1d0-4d0*mz2/Mh02)/16d0/pi/Mh0 / 2d0
     &	*(CA2*CW2**(-2)*EL**2*MW2*MZ2**(-2)*(Mh02**2-4D0*Mh02*
     &  MZ2+12D0*MZ2**2))/(4D0*SW2)

        K(1) = XB0_(0D0,NULL,XMh02,0)
        K(2) = XB0_(0D0,NULL,XMHH2,0)
        K(3) = XB0_(0D0,NULL,XMZ2,0)
        K(4) = XB0_(Mh02,XMh02,XMh02,0)
        K(5) = XB0_(Mh02,XMh02,XMHH2,0)
        K(6) = XB0_(Mh02,XMHH2,XMHH2,0)
        K(7) = XB0_(Mh02,XMW2,XMW2,0)
        K(8) = XB0_(Mh02,XMZ2,XMZ2,0)
        K(9) = XB0_(MZ2,XMh02,XMZ2,0)
        K(10) = XB0_(MZ2,XMHH2,XMZ2,0)
        K(11) = XB0_(MZ2,XMW2,XMW2,0)
        K(12) = XC0_(MZ2,Mh02,MZ2,XMh02,XMZ2,XMZ2,0)
        K(13) = XC0_(MZ2,Mh02,MZ2,XMHH2,XMZ2,XMZ2,0)
        K(14) = XC0_(MZ2,Mh02,MZ2,XMW2,XMW2,XMW2,0)
        K(15) = XC0_(MZ2,Mh02,MZ2,XMZ2,XMh02,XMh02,0)
        K(16) = XC0_(MZ2,Mh02,MZ2,XMZ2,XMh02,XMHH2,0)
        K(17) = XC0_(MZ2,Mh02,MZ2,XMZ2,XMHH2,XMh02,0)
        K(18) = XC0_(MZ2,Mh02,MZ2,XMZ2,XMHH2,XMHH2,0)
        MAT2 = -((ALPHA*CW2**(-2)*SW2**(-2)*(4D0*K(12)*ALPHA*CA*
     &  CA2**(3D0/2D0)*CW2**(-2)*MZ2**(-2)*(4D0*MW2**2*(Mh02**2-4D0*
     &  Mh02*MZ2+12D0*MZ2**2)+2D0*CW2*Mh02*MW2*(3D0*Mh02**2-2D0*Mh02*
     &  MZ2-8D0*MZ2**2)+CW2**2*(Mh02**4+2D0*Mh02**3*MZ2-8D0*Mh02**2*
     &  MZ2**2))+4D0*K(13)*ALPHA*CA2*CW2**(-2)*MZ2**(-2)*(4D0*MW2**
     &  2*(Mh02**2-4D0*Mh02*MZ2+12D0*MZ2**2)+CW2**2*Mh02*MHH2*(Mh02*
     &  MHH2+2D0*MHH2*MZ2-8D0*MZ2**2)+2D0*CW2*MHH2*MW2*(2D0*Mh02**2+
     &  Mh02*(MHH2-4D0*MZ2)+2D0*MZ2*(MHH2-4D0*MZ2)))*SA2+(8D0*K(3)*
     &  ALPHA*CA2*(Mh02-2D0*MZ2)*(MW2-CW2*(CA2*Mh02+MHH2*SA2)))/(CW2*
     &  MZ2)+(4D0*K(8)*ALPHA*CA2*MZ2**(-2)*(MW2*(-(8D0*MZ2**2)+4D0*
     &  MHH2*MZ2*SA2+Mh02**2*(5D0-2D0*SA2)-2D0*Mh02*(MZ2-MHH2*SA2+2D0*
     &  MZ2*SA2))+CW2*Mh02*(CA2*Mh02**2+Mh02*(MZ2+MHH2*SA2-2D0*MZ2*
     &  SA2)+2D0*(MZ2**2+MHH2*MZ2*SA2))))/CW2+(K(5)*CA2*(2D0*Mh02+
     &  MHH2)*MZ2**(-2)*(Mh02**2+Mh02*MHH2+2D0*MZ2*(MHH2-6D0*MZ2))*
     &  SA2*(-(4D0*ALPHA*CA2*(Mh02-MHH2)*PI)+8D0*L12*MW2*SW2))/((Mh0+
     &  MHH)*(Mh0-MHH)*PI)-(K(16)*CA2*(2D0*Mh02+MHH2)*MZ2**(-2)*(2D0*
     &  MW2*(Mh02**2-4D0*Mh02*MZ2+12D0*MZ2**2)+CW2*MHH2*(Mh02**2-4D0*
     &  Mh02*MZ2+2D0*MHH2*MZ2-4D0*MZ2**2))*SA2*(-(4D0*ALPHA*CA2*(Mh02-
     &  MHH2)*PI)+8D0*L12*MW2*SW2))/(CW2*(Mh0+MHH)*(Mh0-MHH)*PI)-
     &  (K(17)*CA2*(2D0*Mh02+MHH2)*MZ2**(-2)*(2D0*MW2*(Mh02**2-4D0*
     &  Mh02*MZ2+12D0*MZ2**2)+CW2*MHH2*(Mh02**2-4D0*Mh02*MZ2+2D0*MHH2*
     &  MZ2-4D0*MZ2**2))*SA2*(-(4D0*ALPHA*CA2*(Mh02-MHH2)*PI)+8D0*
     &  L12*MW2*SW2))/(CW2*(Mh0+MHH)*(Mh0-MHH)*PI)-(K(6)*CA2*(Mh02+2D0*
     &  MHH2)*MZ2**(-2)*(Mh02*(MHH2-MZ2)+2D0*MZ2*(MHH2-3D0*MZ2))*SA2*
     &  (4D0*ALPHA*(Mh02-MHH2)*PI*SA2+8D0*L12*MW2*SW2))/((Mh0+MHH)*
     &  (Mh0-MHH)*PI)+(K(18)*CA2*(Mh02+2D0*MHH2)*MZ2**(-2)*(2D0*MW2*
     &  (Mh02**2-4D0*Mh02*MZ2+12D0*MZ2**2)+CW2*(Mh02*(MHH2-2D0*MZ2)**2+
     &  2D0*MHH2*MZ2*(MHH2-4D0*MZ2)))*SA2*(4D0*ALPHA*(Mh02-MHH2)*PI*
     &  SA2+8D0*L12*MW2*SW2))/(CW2*(Mh0+MHH)*(Mh0-MHH)*PI)-(3D0*K(4)*
     &  CA2*Mh02*MZ2**(-2)*(Mh02**2+Mh02*MZ2-6D0*MZ2**2)*(4D0*ALPHA*
     &  CA2**2*(Mh02-MHH2)*PI+8D0*L12*MW2*SA2*SW2))/((Mh0+MHH)*(Mh0-
     &  MHH)*PI)+(3D0*K(15)*CA2*Mh02*MZ2**(-2)*(2D0*MW2*(Mh02**2-4D0*
     &  Mh02*MZ2+12D0*MZ2**2)+CW2*(Mh02**3-2D0*Mh02**2*MZ2-4D0*Mh02*
     &  MZ2**2))*(4D0*ALPHA*CA2**2*(Mh02-MHH2)*PI+8D0*L12*MW2*SA2*
     &  SW2))/(CW2*(Mh0+MHH)*(Mh0-MHH)*PI)-32D0*K(11)*ALPHA*CA2*MZ2**
     &  (-2)*(CW2**2*(2D0*Mh02**2*MW2+30D0*MW2*MZ2**2+Mh02*(-(6D0*MW2*
     &  MZ2)+MZ2**2))+2D0*CW2*(Mh02**2*MW2-2D0*MW2*MZ2**2-Mh02*(2D0*
     &  MW2*MZ2+MZ2**2))*SW2+MZ2*(-(10D0*MW2*MZ2)+Mh02*(2D0*MW2+
     &  MZ2))*SW2**2)+8D0*K(14)*ALPHA*CA2*MZ2**(-2)*(CW2**2*(2D0*
     &  Mh02**3*MW2-12D0*MW2*MZ2**2*(20D0*MW2+13D0*MZ2)+Mh02**2*(-
     &  (8D0*MW2**2)-4D0*MW2*MZ2+MZ2**2)+2D0*Mh02*(16D0*MW2**2*MZ2+
     &  61D0*MW2*MZ2**2+MZ2**3))+2D0*CW2*(2D0*Mh02**3*MW2-8D0*MW2**2*
     &  MZ2**2+20D0*MW2*MZ2**3-Mh02**2*(2D0*MW2**2+10D0*MW2*MZ2+MZ2**
     &  2)+Mh02*(8D0*MW2**2*MZ2-2D0*MW2*MZ2**2-2D0*MZ2**3))*SW2+(2D0*
     &  Mh02**3*MW2+Mh02**2*(-(2D0*MW2)+MZ2)**2+4D0*MW2*MZ2**2*(8D0*
     &  MW2+MZ2)+2D0*Mh02*MZ2*(-(8D0*MW2**2)+5D0*MW2*MZ2+MZ2**2))*
     &  SW2**2)+8D0*K(7)*ALPHA*CA2*MZ2**(-2)*(CW2**2*(3D0*Mh02**2*
     &  MW2+60D0*MW2*MZ2**2+Mh02*(-(4D0*MW2*MZ2)+4D0*MZ2**2))+2D0*
     &  CW2*(3D0*Mh02**2*MW2-20D0*MW2*MZ2**2-4D0*Mh02*MZ2*(MW2+MZ2))*
     &  SW2+(3D0*Mh02**2*MW2-4D0*MW2*MZ2**2+Mh02*(-(4D0*MW2*MZ2)+4D0*
     &  MZ2**2))*SW2**2)+(K(2)*CA2*MHH2*MZ2**(-2)*(Mh02-2D0*MZ2)*SA2*
     &  (-(8D0*ALPHA*MW2*PI)+CW2*(4D0*ALPHA*PI*(CA2*Mh02+MHH2*(1D0+
     &  SA2))-8D0*L12*MW2*SW2)))/(CW2*PI)-(8D0*K(10)*CA2*SA2*(4D0*
     &  ALPHA*MW2*(Mh02+MHH2-6D0*MZ2)*PI+CW2*(-(4D0*ALPHA*PI*(CA2*
     &  Mh02**2-Mh02*MZ2*(2D0-SA2)+MHH2*(MHH2*SA2-MZ2*(1D0+SA2))))+
     &  8D0*L12*MW2*(Mh02+MHH2-MZ2)*SW2)))/(CW2*MZ2*PI)+(K(1)*CA2*
     &  Mh02*MZ2**(-2)*(Mh02-2D0*MZ2)*(-(8D0*ALPHA*CA2*MW2*PI)+CW2*(-
     &  (4D0*ALPHA*CA2*PI*(-(MHH2*SA2)-Mh02*(2D0-SA2)))+8D0*L12*MW2*
     &  SA2*SW2)))/(CW2*PI)-(4D0*K(9)*CA2*(16D0*ALPHA*CA2*MW2*(Mh02-
     &  3D0*MZ2)*PI+CW2*(-(4D0*ALPHA*CA2*PI*(MHH2*(MHH2-2D0*MZ2)*
     &  SA2+Mh02**2*(2D0-3D0*SA2)+2D0*Mh02*(MHH2*SA2-MZ2*(3D0-SA2))))-
     &  8D0*L12*MW2*(3D0*Mh02+MHH2-2D0*MZ2)*SA2*SW2)))/(CW2*MZ2*PI)-
     &  (32D0*ALPHA*CA2*(MW2+CW2**3*(Mh02+18D0*MW2)-2D0*CW2**2*(Mh02+
     &  2D0*MW2)*SW2+CW2*(MHH2*SA2+2D0*MW2*SW2**2+Mh02*(2D0-SA2+SW2**
     &  2))))/CW2))/32D0)
	do i=1,3
        K(1) = XB0_(Mh02,XMQM2(I),XMQM2(I),0)
        K(2) = XB0_(Mh02,XML2(I),XML2(I),0)
        K(3) = XB0_(Mh02,XMQP2(I),XMQP2(I),0)
        K(4) = XB0_(MZ2,XMQM2(I),XMQM2(I),0)
        K(5) = XB0_(MZ2,XML2(I),XML2(I),0)
        K(6) = XB0_(MZ2,XMQP2(I),XMQP2(I),0)
        K(7) = XC0_(MZ2,Mh02,MZ2,XMQM2(I),XMQM2(I),XMQM2(I),0)
        K(8) = XC0_(MZ2,Mh02,MZ2,XML2(I),XML2(I),XML2(I),0)
        K(9) = XC0_(MZ2,Mh02,MZ2,XMQP2(I),XMQP2(I),XMQP2(I),0)
        MAT2 = mat2 + 
     &	(ALPHA**2*CA2*CW2**(-2)*SW2**(-2)*(-((6D0*K(5)*(Mh02-
     &  2D0*MZ2*(1D0+8D0*SW2-16D0*SW2**2))*XML2(I))/MZ2)+3D0*K(2)*
     &  MZ2**(-2)*(Mh02**2-2D0*Mh02*MZ2+8D0*MZ2**2*(1D0-4D0*SW2+8D0*
     &  SW2**2))*XML2(I)+6D0*K(8)*MZ2**(-2)*XML2(I)*(Mh02**2*XML2(I)+
     &  2D0*Mh02*(MZ2**2*(1D0-4D0*SW2)**2-2D0*MZ2*XML2(I))-4D0*MZ2**
     &  2*(MZ2*(1D0-4D0*SW2+8D0*SW2**2)-(1D0+8D0*SW2-16D0*SW2**2)*
     &  XML2(I)))-(2D0*K(4)*(9D0*Mh02-2D0*MZ2*(9D0+24D0*SW2-16D0*
     &  SW2**2))*XMQM2(I))/MZ2+K(1)*MZ2**(-2)*(9D0*Mh02**2-18D0*Mh02*
     &  MZ2+8D0*MZ2**2*(9D0-12D0*SW2+8D0*SW2**2))*XMQM2(I)+2D0*K(7)*
     &  MZ2**(-2)*XMQM2(I)*(9D0*Mh02**2*XMQM2(I)+2D0*Mh02*(MZ2**2*
     &  (3D0-4D0*SW2)**2-18D0*MZ2*XMQM2(I))+4D0*MZ2**2*(-(MZ2*(9D0-
     &  12D0*SW2+8D0*SW2**2))+(9D0+24D0*SW2-16D0*SW2**2)*XMQM2(I)))+
     &  K(3)*MZ2**(-2)*(9D0*Mh02**2-18D0*Mh02*MZ2+8D0*MZ2**2*(9D0-
     &  24D0*SW2+32D0*SW2**2))*XMQP2(I)-(2D0*K(6)*(9D0*Mh02-2D0*MZ2*
     &  (9D0+48D0*SW2-64D0*SW2**2))*XMQP2(I))/MZ2-8D0*(3D0*(1D0-4D0*
     &  SW2+8D0*SW2**2)*XML2(I)+(9D0-12D0*SW2+8D0*SW2**2)*XMQM2(I)+
     &  (9D0-24D0*SW2+32D0*SW2**2)*XMQP2(I))+2D0*K(9)*MZ2**(-2)*
     &  XMQP2(I)*(9D0*Mh02**2*XMQP2(I)+2D0*Mh02*(MZ2**2*(3D0-8D0*
     &  SW2)**2-18D0*MZ2*XMQP2(I))-4D0*MZ2**2*(MZ2*(9D0-24D0*SW2+
     &  32D0*SW2**2)-(9D0+48D0*SW2-64D0*SW2**2)*XMQP2(I)))))/12D0
	enddo

	Gh0ZZ_nlo = sqrt(1d0-4d0*mz2/Mh02)/16d0/pi/Mh0 / 2d0 * mat2
     &	            + Gh0ZZ_lo*(1d0+2d0*(ct_h0zz+ct_h0zz_f))

	endif

	if (MHH.gt.2d0*mw) then

	GHHZZ_lo = sqrt(1d0-4d0*mz2/MHH2)/16d0/pi/MHH / 2d0
     &	*(CW2**(-2)*EL**2*MW2*MZ2**(-2)*(MHH2**2-4D0*MHH2*MZ2+
     &  12D0*MZ2**2)*SA2)/(4D0*SW2)

        K(1) = XB0_(0D0,NULL,XMh02,0)
        K(2) = XB0_(0D0,NULL,XMHH2,0)
        K(3) = XB0_(0D0,NULL,XMZ2,0)
        K(4) = XB0_(MHH2,XMh02,XMh02,0)
        K(5) = XB0_(MHH2,XMh02,XMHH2,0)
        K(6) = XB0_(MHH2,XMHH2,XMHH2,0)
        K(7) = XB0_(MHH2,XMW2,XMW2,0)
        K(8) = XB0_(MHH2,XMZ2,XMZ2,0)
        K(9) = XB0_(MZ2,XMh02,XMZ2,0)
        K(10) = XB0_(MZ2,XMHH2,XMZ2,0)
        K(11) = XB0_(MZ2,XMW2,XMW2,0)
        K(12) = XC0_(MZ2,MHH2,MZ2,XMh02,XMZ2,XMZ2,0)
        K(13) = XC0_(MZ2,MHH2,MZ2,XMHH2,XMZ2,XMZ2,0)
        K(14) = XC0_(MZ2,MHH2,MZ2,XMW2,XMW2,XMW2,0)
        K(15) = XC0_(MZ2,MHH2,MZ2,XMZ2,XMh02,XMh02,0)
        K(16) = XC0_(MZ2,MHH2,MZ2,XMZ2,XMh02,XMHH2,0)
        K(17) = XC0_(MZ2,MHH2,MZ2,XMZ2,XMHH2,XMh02,0)
        K(18) = XC0_(MZ2,MHH2,MZ2,XMZ2,XMHH2,XMHH2,0)
        MAT2 = (ALPHA*CW2**(-2)*SW2**(-2)*(-(4D0*K(13)*ALPHA*CW2**(-
     &  2)*MZ2**(-2)*(4D0*MW2**2*(MHH2**2-4D0*MHH2*MZ2+12D0*MZ2**2)+
     &  2D0*CW2*MHH2*MW2*(3D0*MHH2**2-2D0*MHH2*MZ2-8D0*MZ2**2)+CW2**
     &  2*(MHH2**4+2D0*MHH2**3*MZ2-8D0*MHH2**2*MZ2**2))*SA**4)-4D0*
     &  K(12)*ALPHA*CA2*CW2**(-2)*MZ2**(-2)*(4D0*MW2**2*(MHH2**2-
     &  4D0*MHH2*MZ2+12D0*MZ2**2)+CW2**2*Mh02*MHH2*(-(8D0*MZ2**2)+
     &  Mh02*(MHH2+2D0*MZ2))+2D0*CW2*Mh02*MW2*(Mh02*(MHH2+2D0*MZ2)+2D0*
     &  (MHH2**2-2D0*MHH2*MZ2-4D0*MZ2**2)))*SA2-(8D0*K(3)*ALPHA*
     &  (MHH2-2D0*MZ2)*SA2*(MW2-CW2*(CA2*Mh02+MHH2*SA2)))/(CW2*MZ2)-
     &  (4D0*K(8)*ALPHA*MZ2**(-2)*SA2*(CW2*MHH2*(2D0*MZ2**2+CA2*Mh02*
     &  (MHH2+2D0*MZ2)+MHH2**2*SA2-MHH2*MZ2*(1D0-2D0*SA2))+MW2*(-
     &  (8D0*MZ2**2)+2D0*CA2*Mh02*(MHH2+2D0*MZ2)-2D0*MHH2*MZ2*(3D0-
     &  2D0*SA2)+MHH2**2*(3D0+2D0*SA2))))/CW2-(K(4)*CA2*(2D0*Mh02+
     &  MHH2)*MZ2**(-2)*(Mh02*(MHH2+2D0*MZ2)-MZ2*(MHH2+6D0*MZ2))*SA2*
     &  (-(4D0*ALPHA*CA2*(Mh02-MHH2)*PI)+8D0*L12*MW2*SW2))/((Mh0+MHH)*
     &  (Mh0-MHH)*PI)+(K(15)*CA2*(2D0*Mh02+MHH2)*MZ2**(-2)*(2D0*MW2*
     &  (MHH2**2-4D0*MHH2*MZ2+12D0*MZ2**2)+CW2*(4D0*MHH2*MZ2**2+
     &  Mh02**2*(MHH2+2D0*MZ2)-4D0*Mh02*MZ2*(MHH2+2D0*MZ2)))*SA2*(-
     &  (4D0*ALPHA*CA2*(Mh02-MHH2)*PI)+8D0*L12*MW2*SW2))/(CW2*(Mh0+
     &  MHH)*(Mh0-MHH)*PI)+(K(5)*CA2*(Mh02+2D0*MHH2)*MZ2**(-2)*(MHH2**
     &  2-12D0*MZ2**2+Mh02*(MHH2+2D0*MZ2))*SA2*(4D0*ALPHA*(Mh02-MHH2)*
     &  PI*SA2+8D0*L12*MW2*SW2))/((Mh0+MHH)*(Mh0-MHH)*PI)-(K(16)*CA2*
     &  (Mh02+2D0*MHH2)*MZ2**(-2)*(2D0*MW2*(MHH2**2-4D0*MHH2*MZ2+
     &  12D0*MZ2**2)+CW2*Mh02*(MHH2**2+2D0*Mh02*MZ2-4D0*MHH2*MZ2-4D0*
     &  MZ2**2))*SA2*(4D0*ALPHA*(Mh02-MHH2)*PI*SA2+8D0*L12*MW2*SW2))/
     &  (CW2*(Mh0+MHH)*(Mh0-MHH)*PI)-(K(17)*CA2*(Mh02+2D0*MHH2)*MZ2**(-
     &  2)*(2D0*MW2*(MHH2**2-4D0*MHH2*MZ2+12D0*MZ2**2)+CW2*Mh02*
     &  (MHH2**2+2D0*Mh02*MZ2-4D0*MHH2*MZ2-4D0*MZ2**2))*SA2*(4D0*
     &  ALPHA*(Mh02-MHH2)*PI*SA2+8D0*L12*MW2*SW2))/(CW2*(Mh0+MHH)*(Mh0-
     &  MHH)*PI)+(3D0*K(6)*MHH2*MZ2**(-2)*(MHH2**2+MHH2*MZ2-6D0*
     &  MZ2**2)*SA2*(4D0*ALPHA*(Mh02-MHH2)*PI*SA**4-8D0*CA2*L12*MW2*
     &  SW2))/((Mh0+MHH)*(Mh0-MHH)*PI)-(3D0*K(18)*MHH2*MZ2**(-2)*(2D0*
     &  MW2*(MHH2**2-4D0*MHH2*MZ2+12D0*MZ2**2)+CW2*(MHH2**3-2D0*
     &  MHH2**2*MZ2-4D0*MHH2*MZ2**2))*SA2*(4D0*ALPHA*(Mh02-MHH2)*PI*
     &  SA**4-8D0*CA2*L12*MW2*SW2))/(CW2*(Mh0+MHH)*(Mh0-MHH)*PI)+32D0*
     &  K(11)*ALPHA*MZ2**(-2)*SA2*(CW2**2*(2D0*MHH2**2*MW2+30D0*MW2*
     &  MZ2**2+MHH2*(-(6D0*MW2*MZ2)+MZ2**2))+2D0*CW2*(MHH2**2*MW2-
     &  2D0*MW2*MZ2**2-MHH2*(2D0*MW2*MZ2+MZ2**2))*SW2+MZ2*(-(10D0*
     &  MW2*MZ2)+MHH2*(2D0*MW2+MZ2))*SW2**2)-8D0*K(14)*ALPHA*MZ2**(-
     &  2)*SA2*(CW2**2*(2D0*MHH2**3*MW2-12D0*MW2*MZ2**2*(20D0*MW2+
     &  13D0*MZ2)+MHH2**2*(-(8D0*MW2**2)-4D0*MW2*MZ2+MZ2**2)+2D0*
     &  MHH2*(16D0*MW2**2*MZ2+61D0*MW2*MZ2**2+MZ2**3))+2D0*CW2*(2D0*
     &  MHH2**3*MW2-8D0*MW2**2*MZ2**2+20D0*MW2*MZ2**3-MHH2**2*(2D0*
     &  MW2**2+10D0*MW2*MZ2+MZ2**2)+MHH2*(8D0*MW2**2*MZ2-2D0*MW2*
     &  MZ2**2-2D0*MZ2**3))*SW2+(2D0*MHH2**3*MW2+MHH2**2*(-(2D0*
     &  MW2)+MZ2)**2+4D0*MW2*MZ2**2*(8D0*MW2+MZ2)+2D0*MHH2*MZ2*(-
     &  (8D0*MW2**2)+5D0*MW2*MZ2+MZ2**2))*SW2**2)-8D0*K(7)*ALPHA*
     &  MZ2**(-2)*SA2*(CW2**2*(3D0*MHH2**2*MW2+60D0*MW2*MZ2**2+MHH2*
     &  (-(4D0*MW2*MZ2)+4D0*MZ2**2))+2D0*CW2*(3D0*MHH2**2*MW2-20D0*
     &  MW2*MZ2**2-4D0*MHH2*MZ2*(MW2+MZ2))*SW2+(3D0*MHH2**2*MW2-4D0*
     &  MW2*MZ2**2+MHH2*(-(4D0*MW2*MZ2)+4D0*MZ2**2))*SW2**2)+(K(1)*
     &  CA2*Mh02*MZ2**(-2)*(MHH2-2D0*MZ2)*SA2*(8D0*ALPHA*MW2*PI+CW2*
     &  (4D0*ALPHA*PI*(-(MHH2*SA2)-Mh02*(2D0-SA2))+8D0*L12*MW2*
     &  SW2)))/(CW2*PI)-(K(2)*MHH2*MZ2**(-2)*(MHH2-2D0*MZ2)*SA2*(-
     &  (8D0*ALPHA*MW2*PI*SA2)+CW2*(4D0*ALPHA*PI*SA2*(CA2*Mh02+MHH2*
     &  (1D0+SA2))+8D0*CA2*L12*MW2*SW2)))/(CW2*PI)+(8D0*K(9)*CA2*
     &  SA2*(4D0*ALPHA*MW2*(Mh02+MHH2-6D0*MZ2)*PI+CW2*(-(4D0*ALPHA*
     &  PI*(CA2*Mh02**2-Mh02*MZ2*(2D0-SA2)+MHH2*(MHH2*SA2-MZ2*(1D0+
     &  SA2))))+8D0*L12*MW2*(Mh02+MHH2-MZ2)*SW2)))/(CW2*MZ2*PI)+(4D0*
     &  K(10)*SA2*(16D0*ALPHA*MW2*(MHH2-3D0*MZ2)*PI*SA2+CW2*(-(4D0*
     &  ALPHA*PI*SA2*(CA2*Mh02**2+2D0*CA2*Mh02*(MHH2-MZ2)-MHH2*(2D0*
     &  MZ2*(2D0+SA2)+MHH2*(1D0-3D0*SA2))))-8D0*CA2*L12*MW2*(Mh02+
     &  3D0*MHH2-2D0*MZ2)*SW2)))/(CW2*MZ2*PI)+(32D0*ALPHA*(MW2*SA2+
     &  CW2**3*(MHH2+18D0*MW2)*SA2-2D0*CW2**2*(MHH2+2D0*MW2)*SA2*
     &  SW2+CW2*(-(Mh02*(SA**4-SA2))+2D0*MW2*SA2*SW2**2+MHH2*(SA**4+
     &  SA2+SA2*SW2**2))))/CW2))/32D0
	do i=1,3
        K(1) = XB0_(MHH2,XMQM2(I),XMQM2(I),0)
        K(2) = XB0_(MHH2,XML2(I),XML2(I),0)
        K(3) = XB0_(MHH2,XMQP2(I),XMQP2(I),0)
        K(4) = XB0_(MZ2,XMQM2(I),XMQM2(I),0)
        K(5) = XB0_(MZ2,XML2(I),XML2(I),0)
        K(6) = XB0_(MZ2,XMQP2(I),XMQP2(I),0)
        K(7) = XC0_(MZ2,MHH2,MZ2,XMQM2(I),XMQM2(I),XMQM2(I),0)
        K(8) = XC0_(MZ2,MHH2,MZ2,XML2(I),XML2(I),XML2(I),0)
        K(9) = XC0_(MZ2,MHH2,MZ2,XMQP2(I),XMQP2(I),XMQP2(I),0)
        MAT2 = mat2 +
     &	(ALPHA**2*CW2**(-2)*SA2*SW2**(-2)*(-((6D0*K(5)*(MHH2-
     &  2D0*MZ2*(1D0+8D0*SW2-16D0*SW2**2))*XML2(I))/MZ2)+3D0*K(2)*
     &  MZ2**(-2)*(MHH2**2-2D0*MHH2*MZ2+8D0*MZ2**2*(1D0-4D0*SW2+8D0*
     &  SW2**2))*XML2(I)+6D0*K(8)*MZ2**(-2)*XML2(I)*(MHH2**2*
     &  XML2(I)+2D0*MHH2*(MZ2**2*(1D0-4D0*SW2)**2-2D0*MZ2*XML2(I))-
     &  4D0*MZ2**2*(MZ2*(1D0-4D0*SW2+8D0*SW2**2)-(1D0+8D0*SW2-16D0*
     &  SW2**2)*XML2(I)))-(2D0*K(4)*(9D0*MHH2-2D0*MZ2*(9D0+24D0*SW2-
     &  16D0*SW2**2))*XMQM2(I))/MZ2+K(1)*MZ2**(-2)*(9D0*MHH2**2-
     &  18D0*MHH2*MZ2+8D0*MZ2**2*(9D0-12D0*SW2+8D0*SW2**2))*
     &  XMQM2(I)+2D0*K(7)*MZ2**(-2)*XMQM2(I)*(9D0*MHH2**2*XMQM2(I)+
     &  2D0*MHH2*(MZ2**2*(3D0-4D0*SW2)**2-18D0*MZ2*XMQM2(I))+4D0*
     &  MZ2**2*(-(MZ2*(9D0-12D0*SW2+8D0*SW2**2))+(9D0+24D0*SW2-16D0*
     &  SW2**2)*XMQM2(I)))+K(3)*MZ2**(-2)*(9D0*MHH2**2-18D0*MHH2*
     &  MZ2+8D0*MZ2**2*(9D0-24D0*SW2+32D0*SW2**2))*XMQP2(I)-(2D0*
     &  K(6)*(9D0*MHH2-2D0*MZ2*(9D0+48D0*SW2-64D0*SW2**2))*
     &  XMQP2(I))/MZ2-8D0*(3D0*(1D0-4D0*SW2+8D0*SW2**2)*XML2(I)+
     &  (9D0-12D0*SW2+8D0*SW2**2)*XMQM2(I)+(9D0-24D0*SW2+32D0*SW2**
     &  2)*XMQP2(I))+2D0*K(9)*MZ2**(-2)*XMQP2(I)*(9D0*MHH2**2*
     &  XMQP2(I)+2D0*MHH2*(MZ2**2*(3D0-8D0*SW2)**2-18D0*MZ2*
     &  XMQP2(I))-4D0*MZ2**2*(MZ2*(9D0-24D0*SW2+32D0*SW2**2)-(9D0+
     &  48D0*SW2-64D0*SW2**2)*XMQP2(I)))))/12D0
	enddo

	GHHZZ_nlo = sqrt(1d0-4d0*mz2/MHH2)/16d0/pi/MHH / 2d0 * mat2
     &	            + GHHZZ_lo*(1d0+2d0*(ct_HHzz+ct_HHzz_f))

	endif

c restore V widths
	call fix_param(0)

	end
