**********************************************************************
        subroutine  HHtoZZ1133_tree_thdm(F,pz12,pz34)
**********************************************************************
*       LO formfactors for HH -> ZZ -> uudd in the THDM
*---------------------------------------------------------------------
*       24.4.16 Stefan Dittmaier
**********************************************************************
	implicit none
	complex*16 pre,F(13,-1:1,-1:1),pz12,pz34

c mandelstam variables
      	real*8 s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
      	common/mandel/s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
c fermion charges of isospin duplets
	real*8 qf(4)
	common/fcharge/qf
c fermion masses as flag (i*1d-20)
      	complex*16 cme2,cmf2(5)
      	real*8 me2,rme2,mf2(5),rmf2(5)
      	common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2
	include '../COMMON/param.inc'
	include '../COMMON/xparam.inc'
        include '../COMMON/param_thdm.inc'
        include '../COMMON/param_bsm.inc'

C       Process: S2F21aF21F23aF23,   Model: THDM

C       G(T1,N1,FULL)

C       G(T1,N2,FULL)

C       G(T1,N3,FULL)

C       G(T1,N4,FULL)

        PRE = (CBA*PZ12*PZ34*XMZ)/(4D0*XCW*XCW2)

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*XSW

	end

**********************************************************************
        subroutine  HHtoZZ1133_count_bos_thdm(F,pz12,pz34)
**********************************************************************
*       HH -> ZZ -> uudd in the THDM
*       bosonic counterterms
*---------------------------------------------------------------------
*       2.6.16 Stefan Dittmaier
**********************************************************************
        implicit none
        complex*16 pre,F(13,-1:1,-1:1),pz12,pz34
        complex*16 ct,ct12,ct34,cazff12(-1:1),cazff34(-1:1)
c mandelstam variables
        real*8 s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
        common/mandel/s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
c fermion charges of isospin duplets
        real*8 qf(4)
        common/fcharge/qf
c fermion masses as flag (i*1d-20)
        complex*16 cme2,cmf2(5)
        real*8 me2,rme2,mf2(5),rmf2(5)
        common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2
        include '../COMMON/param.inc'
        include '../COMMON/xparam.inc'
        include '../COMMON/param_thdm.inc'
        include '../COMMON/param_bsm.inc'
c ren. constants
        complex*16 dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw
        complex*16 dmh02,dmHH2,dma02,dmhp2,dZh0,dZHH,dZh0HH,dZHHh0
        complex*16 dtb,dsa,dmh0HH2,dlam3,dlam5,dlam35
        complex*16 dZeer,dZeel,dZnnl,dZffr(4),dZffl(4)
        complex*16 ct_aww,ct_zww,ct_wen,ct_wf1f2,ct_wf3f4
        complex*16 ct_annl,ct_aeer,ct_aeel,ct_affr(4),ct_affl(4)
        complex*16 ct_znnl,ct_zeer,ct_zeel,ct_zffr(4),ct_zffl(4)
        complex*16 ct_h0ww,ct_HHww,ct_h0zz,ct_HHzz,ct_h0za,ct_HHza
        common/xrenc_thdm/
     &         dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw,
     &         dmh02,dmHH2,dma02,dmhp2,dZh0,dZHH,dZh0HH,dZHHh0,
     &         dtb,dsa,dmh0HH2,dlam3,dlam5,
     &         dZeer,dZeel,dZnnl,dZffr,dZffl,
     &         ct_aww,ct_zww,ct_wen,ct_wf1f2,ct_wf3f4,
     &         ct_annl,ct_aeer,ct_aeel,ct_affr,ct_affl,
     &         ct_znnl,ct_zeer,ct_zeel,ct_zffr,ct_zffl,
     &         ct_h0ww,ct_HHww,ct_h0zz,ct_HHzz,ct_h0za,ct_HHza

c Aff/Zff couplings
c note that qf is charge of isospin duplet (particle, not anti-particle)
c charges of outgoing fermions according to 2233/1133/1144
      cazff12(-1) = qf(1)/(-1d0+2d0*qf(1)*xsw2)*2d0*xsw*xcw
      cazff12(+1) = xcw/xsw
      cazff34(-1) = qf(3)/(1d0+2d0*qf(3)*xsw2)*2d0*xsw*xcw
      cazff34(+1) = xcw/xsw

c counterterms for self energies
      ct =  dmz2/(s12-xmz2) - dZzz
     &     +dmz2/(s34-xmz2) - dZzz

      PRE = CBA*(PZ12*PZ34*XCW2**(-2)*XMW)/4D0  *ct

      F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/(XSW*XSW2)
      F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW
      F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW
      F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*XSW

c ZA-mixing self energy counterterms
      ct12 = xmz2/s12*dZza/2d0 - (dZaz+dZza)/2d0
      ct34 = xmz2/s34*dZza/2d0 - (dZaz+dZza)/2d0

      PRE = CBA*(PZ12*PZ34*XCW2**(-2)*XMW)/4D0

      F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/(XSW*XSW2)    *(ct12*cazff12(-1)+ct34*cazff34(-1))
      F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW                        *(ct12*cazff12(-1)+ct34*cazff34(+1))
      F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW                        *(ct12*cazff12(+1)+ct34*cazff34(-1))
      F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*XSW
     &                             *(ct12*cazff12(+1)+ct34*cazff34(+1))

c counterterms for vertex diagrams
      PRE = CBA*(PZ12*PZ34*XCW2**(-2)*XMW)/4D0

      F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/(XSW*XSW2)      *(ct_HHzz+ct_Zffl(1)+ct_Zffl(3))
      F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW                          *(ct_HHzz+ct_Zffl(1)+ct_Zffr(3))
      F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW                          *(ct_HHzz+ct_Zffr(1)+ct_Zffl(3))
      F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*XSW
     &                               *(ct_HHzz+ct_Zffr(1)+ct_Zffr(3))

c ZA-mixing vertex counter terms
      PRE = CBA*(PZ12*PZ34*XCW2**(-2)*XMW)/4D0

      F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/(XSW*XSW2)
     &     *(ct_HHza*cazff12(-1)/pz12/s12 + ct_HHza*cazff34(-1)/pz34/s34)
      F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW
     &     *(ct_HHza*cazff12(-1)/pz12/s12 + ct_HHza*cazff34(+1)/pz34/s34)
      F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW
     &     *(ct_HHza*cazff12(+1)/pz12/s12 + ct_HHza*cazff34(-1)/pz34/s34)
      F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*XSW
     &     *(ct_HHza*cazff12(+1)/pz12/s12 + ct_HHza*cazff34(+1)/pz34/s34)

      end

**********************************************************************
        subroutine  HHtoZZ1133_count_ferm_thdm(F,pz12,pz34)
**********************************************************************
*       HH -> ZZ -> uudd in the THDM
*       fermion-loop counterterms
*---------------------------------------------------------------------
*       2.6.16 Stefan Dittmaier
**********************************************************************
        implicit none
        complex*16 pre,F(13,-1:1,-1:1),pz12,pz34
        complex*16 ct,ct12,ct34,cazff12(-1:1),cazff34(-1:1)
c mandelstam variables
        real*8 s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
        common/mandel/s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
c fermion charges of isospin duplets
        real*8 qf(4)
        common/fcharge/qf
c fermion masses as flag (i*1d-20)
        complex*16 cme2,cmf2(5)
        real*8 me2,rme2,mf2(5),rmf2(5)
        common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2
        include '../COMMON/param.inc'
        include '../COMMON/xparam.inc'
        include '../COMMON/param_thdm.inc'
        include '../COMMON/param_bsm.inc'
c ren. constants
        complex*16 dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw
        complex*16 dmh02,dmHH2,dma02,dmhp2,dZh0,dZHH,dZh0HH,dZHHh0
        complex*16 dtb,dsa,dmh0HH2,dlam3,dlam5,dlam35
        complex*16 dZeer,dZeel,dZnnl,dZffr(4),dZffl(4)
        complex*16 ct_aww,ct_zww,ct_wen,ct_wf1f2,ct_wf3f4
        complex*16 ct_annl,ct_aeer,ct_aeel,ct_affr(4),ct_affl(4)
        complex*16 ct_znnl,ct_zeer,ct_zeel,ct_zffr(4),ct_zffl(4)
        complex*16 ct_h0ww,ct_HHww,ct_h0zz,ct_HHzz,ct_h0za,ct_HHza
        common/xrenc_ferm_thdm/
     &         dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw,
     &         dmh02,dmHH2,dma02,dmhp2,dZh0,dZHH,dZh0HH,dZHHh0,
     &         dtb,dsa,dmh0HH2,dlam3,dlam5,
     &         dZeer,dZeel,dZnnl,dZffr,dZffl,
     &         ct_aww,ct_zww,ct_wen,ct_wf1f2,ct_wf3f4,
     &         ct_annl,ct_aeer,ct_aeel,ct_affr,ct_affl,
     &         ct_znnl,ct_zeer,ct_zeel,ct_zffr,ct_zffl,
     &         ct_h0ww,ct_HHww,ct_h0zz,ct_HHzz,ct_h0za,ct_HHza

c Aff/Zff couplings
c note that qf is charge of isospin duplet (particle, not anti-particle)
c charges of outgoing fermions according to 2233/1133/1144
      cazff12(-1) = qf(1)/(-1d0+2d0*qf(1)*xsw2)*2d0*xsw*xcw
      cazff12(+1) = xcw/xsw
      cazff34(-1) = qf(3)/(1d0+2d0*qf(3)*xsw2)*2d0*xsw*xcw
      cazff34(+1) = xcw/xsw

c counterterms for self energies
      ct =  dmz2/(s12-xmz2) - dZzz
     &     +dmz2/(s34-xmz2) - dZzz

      PRE = CBA*(PZ12*PZ34*XCW2**(-2)*XMW)/4D0  *ct

      F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/(XSW*XSW2)
      F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW
      F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW
      F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*XSW

c ZA-mixing self energy counterterms
      ct12 = xmz2/s12*dZza/2d0 - (dZaz+dZza)/2d0
      ct34 = xmz2/s34*dZza/2d0 - (dZaz+dZza)/2d0

      PRE = CBA*(PZ12*PZ34*XCW2**(-2)*XMW)/4D0

      F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/(XSW*XSW2)    *(ct12*cazff12(-1)+ct34*cazff34(-1))
      F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW                        *(ct12*cazff12(-1)+ct34*cazff34(+1))
      F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW                        *(ct12*cazff12(+1)+ct34*cazff34(-1))
      F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*XSW
     &                             *(ct12*cazff12(+1)+ct34*cazff34(+1))

c counterterms for vertex diagrams
      PRE = CBA*(PZ12*PZ34*XCW2**(-2)*XMW)/4D0

      F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/(XSW*XSW2)      *(ct_HHzz+ct_Zffl(1)+ct_Zffl(3))
      F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW                          *(ct_HHzz+ct_Zffl(1)+ct_Zffr(3))
      F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW                          *(ct_HHzz+ct_Zffr(1)+ct_Zffl(3))
      F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*XSW
     &                               *(ct_HHzz+ct_Zffr(1)+ct_Zffr(3))

c ZA-mixing vertex counter terms
      PRE = CBA*(PZ12*PZ34*XCW2**(-2)*XMW)/4D0

      F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/(XSW*XSW2)
     &     *(ct_HHza*cazff12(-1)/pz12/s12 + ct_HHza*cazff34(-1)/pz34/s34)
      F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW
     &     *(ct_HHza*cazff12(-1)/pz12/s12 + ct_HHza*cazff34(+1)/pz34/s34)
      F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW
     &     *(ct_HHza*cazff12(+1)/pz12/s12 + ct_HHza*cazff34(-1)/pz34/s34)
      F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*XSW
     &     *(ct_HHza*cazff12(+1)/pz12/s12 + ct_HHza*cazff34(+1)/pz34/s34)

      end

**********************************************************************
        subroutine  HHtoZZ1133_self_bos2_thdm(F,pz12,pz34)
**********************************************************************
*       self-energy contributions for HH -> ZZ -> uudd in the THDM
*       bosonic loops
*---------------------------------------------------------------------
*       24.4.16 Stefan Dittmaier
**********************************************************************
	implicit none
	complex*16 pre,F(13,-1:1,-1:1),pz12,pz34
	complex*16 A0,xA0_,B0_,xB0_,DB0_,xDB0_,B1_,xB1_,DB1_,xDB1_
        complex*16 B0,B1(1),B2(0:2,0:2),B3(0:2,0:2,2)
        complex*16 B4(0:2,0:2,0:2,0:2),B5(0:2,0:2,0:2,0:2,2)
        complex*16 C0_,C0,C1(2),C2(0:2,0:2),C3(0:2,0:2,2)
        complex*16 C4(0:2,0:2,0:2,0:2)
	complex*16 D0,D1(3),D2(0:3,0:3),D3(0:3,0:3,3)
        complex*16 D4(0:3,0:3,0:3,0:3),D5(0:3,0:3,0:3,0:3,3)
	complex*16 E0n,E1n(4),E2n(0:4,0:4),E3n(0:4,0:4,4)
	complex*16 E4n(0:4,0:4,0:4,0:4)
        complex*16 seaa,seaz,sezz

c mandelstam variables
      	real*8 s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
      	common/mandel/s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
c fermion charges of isospin duplets
	real*8 qf(4)
	common/fcharge/qf
c fermion masses as flag (i*1d-20)
      	complex*16 cme2,cmf2(5)
      	real*8 me2,rme2,mf2(5),rmf2(5)
      	common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2
	include '../COMMON/param.inc'
	include '../COMMON/xparam.inc'
        include '../COMMON/param_thdm.inc'
        include '../COMMON/param_bsm.inc'

        call xsevv_thdm(s12,seaa,seaz,sezz)

      PRE = CBA*(PZ12*PZ34*XCW2**(-2)*XMW)/4D0  *(-sezz)*pz12

      F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/(XSW*XSW2)
      F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW
      F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW
      F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*XSW

      PRE = CBA*(PZ12*PZ34/XCW**3/XSW*XMW)/4D0  *(-seaz)/s12

      F(1,-1,-1) = F(1,-1,-1)-(PRE*(-2D0*QF(1)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/(XSW*XSW2)
      F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(-2D0*QF(1)*XSW2))/
     &  XSW
      F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW
      F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*XSW

        call xsevv_thdm(s34,seaa,seaz,sezz)

      PRE = CBA*(PZ12*PZ34*XCW2**(-2)*XMW)/4D0  *(-sezz)*pz34

      F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/(XSW*XSW2)
      F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW
      F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW
      F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*XSW

      PRE = CBA*(PZ12*PZ34/XCW**3/XSW*XMW)/4D0  *(-seaz)/s34

      F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2)*(+2D0*
     &  QF(3)*XSW2))/(XSW*XSW2)
      F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW
      F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(2D0*QF(3)*XSW2))/
     &  XSW
      F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*XSW

	end

**********************************************************************
        subroutine  HHtoZZ1133_self_bos_thdm(F,pz12,pz34)
**********************************************************************
*       self-energy contributions for HH -> ZZ -> uudd in the THDM
*       bosonic loops
*---------------------------------------------------------------------
*       24.4.16 Stefan Dittmaier
**********************************************************************
	implicit none
	complex*16 pre,F(13,-1:1,-1:1),pz12,pz34
	complex*16 A0,xA0_,B0_,xB0_,DB0_,xDB0_,B1_,xB1_,DB1_,xDB1_
        complex*16 B0,B1(1),B2(0:2,0:2),B3(0:2,0:2,2)
        complex*16 B4(0:2,0:2,0:2,0:2),B5(0:2,0:2,0:2,0:2,2)
        complex*16 C0_,C0,C1(2),C2(0:2,0:2),C3(0:2,0:2,2)
        complex*16 C4(0:2,0:2,0:2,0:2)
	complex*16 D0,D1(3),D2(0:3,0:3),D3(0:3,0:3,3)
        complex*16 D4(0:3,0:3,0:3,0:3),D5(0:3,0:3,0:3,0:3,3)
	complex*16 E0n,E1n(4),E2n(0:4,0:4),E3n(0:4,0:4,4)
	complex*16 E4n(0:4,0:4,0:4,0:4)

c mandelstam variables
      	real*8 s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
      	common/mandel/s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
c fermion charges of isospin duplets
	real*8 qf(4)
	common/fcharge/qf
c fermion masses as flag (i*1d-20)
      	complex*16 cme2,cmf2(5)
      	real*8 me2,rme2,mf2(5),rmf2(5)
      	common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2
	include '../COMMON/param.inc'
	include '../COMMON/xparam.inc'
        include '../COMMON/param_thdm.inc'
        include '../COMMON/param_bsm.inc'

C       Process: S2F21aF21F23aF23,   Model: THDM

C       G(T1,N1,FULL)

C       G(T1,N2,FULL)

C       G(T1,N3,FULL)

C       G(T1,N4,FULL)

C       G(T1,N5,FULL)

C       G(T1,N6,FULL)

C       G(T1,N7,FULL)

C       G(T1,N8,FULL)

C       G(T1,N9,FULL)

C       G(T1,N10,FULL)

C       G(T1,N11,FULL)

C       G(T1,N12,FULL)

C       G(T1,N13,FULL)

C       G(T1,N14,FULL)

C       G(T1,N15,FULL)

C       G(T1,N16,FULL)

C       G(T1,N17,FULL)

C       G(T1,N18,FULL)

C       G(T1,N19,FULL)

C       G(T1,N20,FULL)

C       G(T1,N21,FULL)

C       G(T1,N22,FULL)

C       G(T1,N23,FULL)

C       G(T1,N24,FULL)

C       G(T1,N25,FULL)

C       G(T1,N26,FULL)

C       G(T1,N27,FULL)

C       G(T1,N28,FULL)

C       G(T1,N29,FULL)

C       G(T1,N30,FULL)

C       G(T1,N31,FULL)

C       G(T1,N32,FULL)
        A0 = xA0_(XMW2)

        PRE = (QF(1)*A0*ALPHA*CBA*PZ12*PZ34*XMZ*(XCW+XSW)*(XCW-
     &  XSW))/(8D0*PI*S12*XCW*XCW2*XSW)

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE
        F(1,1,-1) = F(1,1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,1,1) = F(1,1,1)+2D0*QF(3)*PRE

C       G(T1,N33,FULL)
        A0 = xA0_(XMHP2)

        PRE = (QF(1)*A0*ALPHA*CBA*PZ12*PZ34*XMZ*(XCW+XSW)*(XCW-
     &  XSW))/(8D0*PI*S12*XCW*XCW2*XSW)

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE
        F(1,1,-1) = F(1,1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,1,1) = F(1,1,1)+2D0*QF(3)*PRE

C       G(T1,N34,FULL)
        A0 = xA0_(XMW2)

        PRE = (QF(1)*ALPHA*CBA*PZ12*PZ34*(3D0*A0-2D0*XMW2)*XMZ)/
     &  (4D0*PI*S12*XCW*XSW)

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE
        F(1,1,-1) = F(1,1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,1,1) = F(1,1,1)+2D0*QF(3)*PRE

C       G(T1,N35,FULL)

C       G(T1,N36,FULL)

C       G(T1,N37,FULL)

C       G(T1,N38,FULL)

C       G(T1,N39,FULL)

C       G(T1,N40,FULL)

C       G(T1,N41,FULL)

C       G(T1,N42,FULL)
        A0 = xA0_(XMW2)

        PRE = -((A0*ALPHA*CBA*PZ12**2*PZ34*XCW2**(-2)*XMZ*(XCW+
     &  XSW)**2*(XCW-XSW)**2)/(32D0*PI*XCW*XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T1,N43,FULL)
        A0 = xA0_(XMHP2)

        PRE = -((A0*ALPHA*CBA*PZ12**2*PZ34*XCW2**(-2)*XMZ*(XCW+
     &  XSW)**2*(XCW-XSW)**2)/(32D0*PI*XCW*XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T1,N44,FULL)
        A0 = xA0_(XMH02)

        PRE = -((A0*ALPHA*CBA*PZ12**2*PZ34*XCW2**(-2)*XMZ)/(64D0*PI*
     &  XCW*XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T1,N45,FULL)
        A0 = xA0_(XMHH2)

        PRE = -((A0*ALPHA*CBA*PZ12**2*PZ34*XCW2**(-2)*XMZ)/(64D0*PI*
     &  XCW*XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T1,N46,FULL)
        A0 = xA0_(XMA02)

        PRE = -((A0*ALPHA*CBA*PZ12**2*PZ34*XCW2**(-2)*XMZ)/(64D0*PI*
     &  XCW*XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T1,N47,FULL)
        A0 = xA0_(XMZ2)

        PRE = -((A0*ALPHA*CBA*PZ12**2*PZ34*XCW2**(-2)*XMZ)/(64D0*PI*
     &  XCW*XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T1,N48,FULL)
        A0 = xA0_(XMW2)

        PRE = -((ALPHA*CBA*PZ12**2*PZ34*(3D0*A0-2D0*XMW2)*XMZ)/(8D0*
     &  PI*XCW*XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T2,N49,FULL)

C       G(T2,N50,FULL)

C       G(T2,N51,FULL)

C       G(T2,N52,FULL)

C       G(T2,N53,FULL)

C       G(T2,N54,FULL)

C       G(T2,N55,FULL)

C       G(T2,N56,FULL)

C       G(T2,N57,FULL)

C       G(T2,N58,FULL)

C       G(T2,N59,FULL)

C       G(T2,N60,FULL)

C       G(T2,N61,FULL)

C       G(T2,N62,FULL)

C       G(T2,N63,FULL)

C       G(T2,N64,FULL)

C       G(T2,N65,FULL)

C       G(T2,N66,FULL)

C       G(T2,N67,FULL)

C       G(T2,N68,FULL)

C       G(T2,N69,FULL)

C       G(T2,N70,FULL)

C       G(T2,N71,FULL)

C       G(T2,N72,FULL)

C       G(T2,N73,FULL)

C       G(T2,N74,FULL)

C       G(T2,N75,FULL)

C       G(T2,N76,FULL)

C       G(T2,N77,FULL)

C       G(T2,N78,FULL)

C       G(T2,N79,FULL)

C       G(T2,N80,FULL)

C       G(T2,N81,FULL)

C       G(T2,N82,FULL)

C       G(T2,N83,FULL)

C       G(T2,N84,FULL)

C       G(T2,N85,FULL)

C       G(T2,N86,FULL)

C       G(T2,N87,FULL)
        A0 = xA0_(XMW2)

        PRE = (QF(3)*A0*ALPHA*CBA*PZ12*PZ34*XMZ*(XCW+XSW)*(XCW-
     &  XSW))/(8D0*PI*S34*XCW*XCW2*XSW)

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE
        F(1,1,1) = F(1,1,1)+2D0*QF(1)*PRE

C       G(T2,N88,FULL)
        A0 = xA0_(XMHP2)

        PRE = (QF(3)*A0*ALPHA*CBA*PZ12*PZ34*XMZ*(XCW+XSW)*(XCW-
     &  XSW))/(8D0*PI*S34*XCW*XCW2*XSW)

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE
        F(1,1,1) = F(1,1,1)+2D0*QF(1)*PRE

C       G(T2,N89,FULL)
        A0 = xA0_(XMW2)

        PRE = (QF(3)*ALPHA*CBA*PZ12*PZ34*(3D0*A0-2D0*XMW2)*XMZ)/
     &  (4D0*PI*S34*XCW*XSW)

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE
        F(1,1,1) = F(1,1,1)+2D0*QF(1)*PRE

C       G(T2,N90,FULL)
        A0 = xA0_(XMW2)

        PRE = -((A0*ALPHA*CBA*PZ12*PZ34**2*XCW2**(-2)*XMZ*(XCW+
     &  XSW)**2*(XCW-XSW)**2)/(32D0*PI*XCW*XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T2,N91,FULL)
        A0 = xA0_(XMHP2)

        PRE = -((A0*ALPHA*CBA*PZ12*PZ34**2*XCW2**(-2)*XMZ*(XCW+
     &  XSW)**2*(XCW-XSW)**2)/(32D0*PI*XCW*XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T2,N92,FULL)
        A0 = xA0_(XMH02)

        PRE = -((A0*ALPHA*CBA*PZ12*PZ34**2*XCW2**(-2)*XMZ)/(64D0*PI*
     &  XCW*XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T2,N93,FULL)
        A0 = xA0_(XMHH2)

        PRE = -((A0*ALPHA*CBA*PZ12*PZ34**2*XCW2**(-2)*XMZ)/(64D0*PI*
     &  XCW*XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T2,N94,FULL)
        A0 = xA0_(XMA02)

        PRE = -((A0*ALPHA*CBA*PZ12*PZ34**2*XCW2**(-2)*XMZ)/(64D0*PI*
     &  XCW*XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T2,N95,FULL)
        A0 = xA0_(XMZ2)

        PRE = -((A0*ALPHA*CBA*PZ12*PZ34**2*XCW2**(-2)*XMZ)/(64D0*PI*
     &  XCW*XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T2,N96,FULL)
        A0 = xA0_(XMW2)

        PRE = -((ALPHA*CBA*PZ12*PZ34**2*(3D0*A0-2D0*XMW2)*XMZ)/(8D0*
     &  PI*XCW*XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T3,N97,FULL)

C       G(T3,N98,FULL)

C       G(T3,N99,FULL)

C       G(T3,N100,FULL)

C       G(T3,N101,FULL)

C       G(T3,N102,FULL)

C       G(T3,N103,FULL)

C       G(T3,N104,FULL)

C       G(T3,N105,FULL)

C       G(T3,N106,FULL)

C       G(T3,N107,FULL)

C       G(T3,N108,FULL)

C       G(T3,N109,FULL)

C       G(T3,N110,FULL)

C       G(T3,N111,FULL)

C       G(T3,N112,FULL)

C       G(T3,N113,FULL)

C       G(T3,N114,FULL)

C       G(T3,N115,FULL)

C       G(T3,N116,FULL)

C       G(T3,N117,FULL)

C       G(T3,N118,FULL)

C       G(T3,N119,FULL)

C       G(T3,N120,FULL)

C       G(T3,N128,FULL)

C       G(T3,N129,FULL)

C       G(T3,N130,FULL)

C       G(T3,N131,FULL)

C       G(T3,N132,FULL)

C       G(T3,N133,FULL)

C       G(T3,N134,FULL)

C       G(T3,N135,FULL)

C       G(T3,N136,FULL)

C       G(T3,N137,FULL)

C       G(T3,N145,FULL)

C       G(T3,N146,FULL)

C       G(T3,N147,FULL)

C       G(T3,N148,FULL)

C       G(T3,N149,FULL)

C       G(T3,N150,FULL)

C       G(T3,N151,FULL)

C       G(T3,N152,FULL)

C       G(T3,N153,FULL)

C       G(T3,N154,FULL)

C       G(T3,N162,FULL)

C       G(T3,N163,FULL)

C       G(T3,N164,FULL)

C       G(T3,N165,FULL)

C       G(T3,N173,FULL)

C       G(T3,N174,FULL)

C       G(T3,N175,FULL)

C       G(T3,N176,FULL)

C       G(T3,N184,FULL)

C       G(T3,N185,FULL)

C       G(T3,N186,FULL)

C       G(T3,N187,FULL)

C       G(T3,N188,FULL)

C       G(T3,N189,FULL)

C       G(T3,N190,FULL)

C       G(T3,N191,FULL)

C       G(T3,N192,FULL)

C       G(T3,N193,FULL)

C       G(T3,N201,FULL)

C       G(T3,N202,FULL)

C       G(T3,N203,FULL)

C       G(T3,N204,FULL)

C       G(T3,N205,FULL)

C       G(T3,N206,FULL)

C       G(T3,N207,FULL)

C       G(T3,N208,FULL)

C       G(T3,N209,FULL)

C       G(T3,N210,FULL)

C       G(T3,N218,FULL)

C       G(T3,N219,FULL)

C       G(T3,N220,FULL)

C       G(T3,N221,FULL)

C       G(T3,N222,FULL)

C       G(T3,N223,FULL)

C       G(T3,N224,FULL)

C       G(T3,N225,FULL)

C       G(T3,N226,FULL)

C       G(T3,N227,FULL)

C       G(T3,N235,FULL)

C       G(T3,N236,FULL)

C       G(T3,N237,FULL)

C       G(T3,N238,FULL)

C       G(T3,N239,FULL)

C       G(T3,N240,FULL)

C       G(T3,N241,FULL)

C       G(T3,N242,FULL)

C       G(T3,N243,FULL)

C       G(T3,N244,FULL)

C       G(T3,N252,FULL)

C       G(T3,N253,FULL)

C       G(T3,N254,FULL)

C       G(T3,N255,FULL)

C       G(T3,N256,FULL)

C       G(T3,N257,FULL)

C       G(T3,N258,FULL)

C       G(T3,N266,FULL)
        CALL xB012345_(S12,XMW2,XMW2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = -((B2(0,0)*QF(1)*ALPHA*CBA*PZ12*PZ34*XMZ*(XCW+XSW)*
     &  (XCW-XSW))/(4D0*PI*S12*XCW*XCW2*XSW))

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE
        F(1,1,-1) = F(1,1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,1,1) = F(1,1,1)+2D0*QF(3)*PRE

C       G(T3,N267,FULL)
        CALL xB012345_(S12,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((QF(1)*ALPHA*B0*CBA*PZ12*PZ34*XMW*XMZ2)/(8D0*PI*S12*
     &  XCW2))

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE*XSW
        F(1,1,-1) = F(1,1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW
        F(1,1,1) = F(1,1,1)+2D0*QF(3)*PRE*XSW

C       G(T3,N268,FULL)
        CALL xB012345_(S12,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((QF(1)*ALPHA*B0*CBA*PZ12*PZ34*XMW*XMZ2)/(8D0*PI*S12*
     &  XCW2))

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE*XSW
        F(1,1,-1) = F(1,1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW
        F(1,1,1) = F(1,1,1)+2D0*QF(3)*PRE*XSW

C       G(T3,N269,FULL)
        CALL xB012345_(S12,XMHP2,XMHP2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = -((B2(0,0)*QF(1)*ALPHA*CBA*PZ12*PZ34*XMZ*(XCW+XSW)*
     &  (XCW-XSW))/(4D0*PI*S12*XCW*XCW2*XSW))

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE
        F(1,1,-1) = F(1,1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,1,1) = F(1,1,1)+2D0*QF(3)*PRE

C       G(T3,N270,FULL)
        CALL xB012345_(S12,XMW2,XMW2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (B2(0,0)*QF(1)*ALPHA*CBA*PZ12*PZ34*XMZ)/(8D0*PI*S12*
     &  XCW*XSW)

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE
        F(1,1,-1) = F(1,1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,1,1) = F(1,1,1)+2D0*QF(3)*PRE

C       G(T3,N271,FULL)
        CALL xB012345_(S12,XMW2,XMW2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (B2(0,0)*QF(1)*ALPHA*CBA*PZ12*PZ34*XMZ)/(8D0*PI*S12*
     &  XCW*XSW)

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE
        F(1,1,-1) = F(1,1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,1,1) = F(1,1,1)+2D0*QF(3)*PRE

C       G(T3,N272,FULL)
        CALL xB012345_(S12,XMW2,XMW2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = -((QF(1)*ALPHA*CBA*PZ12*PZ34*(2D0*B1(1)+2D0*B2(1,1)+
     &  5D0*B0+(18D0*B2(0,0))/S12+(S12-6D0*XMW2)/S12)*XMZ)/(8D0*PI*
     &  XCW*XSW))

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE
        F(1,1,-1) = F(1,1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,1,1) = F(1,1,1)+2D0*QF(3)*PRE

C       G(T3,N281,FULL)

C       G(T3,N282,FULL)

C       G(T3,N283,FULL)

C       G(T3,N284,FULL)

C       G(T3,N285,FULL)

C       G(T3,N286,FULL)

C       G(T3,N287,FULL)

C       G(T3,N288,FULL)

C       G(T3,N289,FULL)

C       G(T3,N290,FULL)

C       G(T3,N291,FULL)

C       G(T3,N292,FULL)

C       G(T3,N293,FULL)

C       G(T3,N302,FULL)
        CALL xB012345_(S12,XMW2,XMW2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (B2(0,0)*ALPHA*CBA*PZ12**2*PZ34*XCW2**(-2)*XMZ*(XCW+
     &  XSW)**2*(XCW-XSW)**2)/(16D0*PI*XCW*XSW)

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T3,N303,FULL)
        CALL xB012345_(S12,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*CBA*PZ12**2*PZ34*XMZ*XMZ2)/(16D0*PI*XCW*
     &  XCW2))

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)-2D0*QF(3)*PRE*XSW*(1D0-2D0*QF(1)*XSW2)
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE*XSW*(1D0+2D0*QF(3)*XSW2)
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*XSW*XSW2

C       G(T3,N304,FULL)
        CALL xB012345_(S12,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*CBA*PZ12**2*PZ34*XMZ*XMZ2)/(16D0*PI*XCW*
     &  XCW2))

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)-2D0*QF(3)*PRE*XSW*(1D0-2D0*QF(1)*XSW2)
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE*XSW*(1D0+2D0*QF(3)*XSW2)
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*XSW*XSW2

C       G(T3,N305,FULL)
        CALL xB012345_(S12,XMHP2,XMHP2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (B2(0,0)*ALPHA*CBA*PZ12**2*PZ34*XCW2**(-2)*XMZ*(XCW+
     &  XSW)**2*(XCW-XSW)**2)/(16D0*PI*XCW*XSW)

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T3,N306,FULL)
        CALL xB012345_(S12,XMH02,XMA02,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (B2(0,0)*ALPHA*CBA**3*PZ12**2*PZ34*XCW2**(-2)*XMZ)/
     &  (16D0*PI*XCW*XSW)

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T3,N307,FULL)
        CALL xB012345_(S12,XMH02,XMZ2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (B2(0,0)*ALPHA*CBA*PZ12**2*PZ34*SBA**2*XCW2**(-2)*
     &  XMZ)/(16D0*PI*XCW*XSW)

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T3,N308,FULL)
        CALL xB012345_(S12,XMH02,XMZ2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*CBA*PZ12**2*PZ34*SBA**2*XCW2**(-2)*XMZ*
     &  XMZ2)/(16D0*PI*XCW*XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T3,N309,FULL)
        CALL xB012345_(S12,XMHH2,XMA02,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (B2(0,0)*ALPHA*CBA*PZ12**2*PZ34*SBA**2*XCW2**(-2)*
     &  XMZ)/(16D0*PI*XCW*XSW)

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T3,N310,FULL)
        CALL xB012345_(S12,XMHH2,XMZ2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (B2(0,0)*ALPHA*CBA**3*PZ12**2*PZ34*XCW2**(-2)*XMZ)/
     &  (16D0*PI*XCW*XSW)

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T3,N311,FULL)
        CALL xB012345_(S12,XMHH2,XMZ2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*CBA**3*PZ12**2*PZ34*XCW2**(-2)*XMZ*XMZ2)/
     &  (16D0*PI*XCW*XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T3,N312,FULL)
        CALL xB012345_(S12,XMW2,XMW2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = -((B2(0,0)*ALPHA*CBA*PZ12**2*PZ34*XMZ)/(16D0*PI*XCW*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T3,N313,FULL)
        CALL xB012345_(S12,XMW2,XMW2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = -((B2(0,0)*ALPHA*CBA*PZ12**2*PZ34*XMZ)/(16D0*PI*XCW*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T3,N314,FULL)
        CALL xB012345_(S12,XMW2,XMW2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (ALPHA*CBA*PZ12**2*PZ34*(18D0*B2(0,0)+S12+2D0*B1(1)*
     &  S12+2D0*B2(1,1)*S12+5D0*B0*S12-6D0*XMW2)*XMZ)/(16D0*PI*XCW*
     &  XSW)

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T4,N315,FULL)

C       G(T4,N316,FULL)

C       G(T4,N317,FULL)

C       G(T4,N318,FULL)

C       G(T4,N319,FULL)

C       G(T4,N320,FULL)

C       G(T4,N321,FULL)

C       G(T4,N322,FULL)

C       G(T4,N323,FULL)

C       G(T4,N324,FULL)

C       G(T4,N325,FULL)

C       G(T4,N326,FULL)

C       G(T4,N327,FULL)

C       G(T4,N328,FULL)

C       G(T4,N329,FULL)

C       G(T4,N330,FULL)

C       G(T4,N331,FULL)

C       G(T4,N332,FULL)

C       G(T4,N333,FULL)

C       G(T4,N334,FULL)

C       G(T4,N335,FULL)

C       G(T4,N336,FULL)

C       G(T4,N337,FULL)

C       G(T4,N338,FULL)

C       G(T4,N346,FULL)

C       G(T4,N347,FULL)

C       G(T4,N348,FULL)

C       G(T4,N349,FULL)

C       G(T4,N350,FULL)

C       G(T4,N351,FULL)

C       G(T4,N352,FULL)

C       G(T4,N353,FULL)

C       G(T4,N354,FULL)

C       G(T4,N355,FULL)

C       G(T4,N363,FULL)

C       G(T4,N364,FULL)

C       G(T4,N365,FULL)

C       G(T4,N366,FULL)

C       G(T4,N374,FULL)

C       G(T4,N375,FULL)

C       G(T4,N376,FULL)

C       G(T4,N377,FULL)

C       G(T4,N378,FULL)

C       G(T4,N379,FULL)

C       G(T4,N380,FULL)

C       G(T4,N381,FULL)

C       G(T4,N382,FULL)

C       G(T4,N383,FULL)

C       G(T4,N391,FULL)

C       G(T4,N392,FULL)

C       G(T4,N393,FULL)

C       G(T4,N394,FULL)

C       G(T4,N395,FULL)

C       G(T4,N396,FULL)

C       G(T4,N397,FULL)

C       G(T4,N398,FULL)

C       G(T4,N399,FULL)

C       G(T4,N400,FULL)

C       G(T4,N408,FULL)

C       G(T4,N409,FULL)

C       G(T4,N410,FULL)

C       G(T4,N411,FULL)

C       G(T4,N419,FULL)

C       G(T4,N420,FULL)

C       G(T4,N421,FULL)

C       G(T4,N422,FULL)

C       G(T4,N423,FULL)

C       G(T4,N424,FULL)

C       G(T4,N425,FULL)

C       G(T4,N426,FULL)

C       G(T4,N427,FULL)

C       G(T4,N428,FULL)

C       G(T4,N436,FULL)

C       G(T4,N437,FULL)

C       G(T4,N438,FULL)

C       G(T4,N439,FULL)

C       G(T4,N440,FULL)

C       G(T4,N441,FULL)

C       G(T4,N442,FULL)

C       G(T4,N443,FULL)

C       G(T4,N444,FULL)

C       G(T4,N445,FULL)

C       G(T4,N453,FULL)

C       G(T4,N454,FULL)

C       G(T4,N455,FULL)

C       G(T4,N456,FULL)

C       G(T4,N457,FULL)

C       G(T4,N458,FULL)

C       G(T4,N459,FULL)

C       G(T4,N468,FULL)

C       G(T4,N469,FULL)

C       G(T4,N470,FULL)

C       G(T4,N471,FULL)

C       G(T4,N472,FULL)

C       G(T4,N473,FULL)

C       G(T4,N474,FULL)

C       G(T4,N475,FULL)

C       G(T4,N476,FULL)

C       G(T4,N477,FULL)

C       G(T4,N478,FULL)

C       G(T4,N479,FULL)

C       G(T4,N480,FULL)

C       G(T4,N488,FULL)

C       G(T4,N489,FULL)

C       G(T4,N490,FULL)

C       G(T4,N491,FULL)

C       G(T4,N492,FULL)

C       G(T4,N493,FULL)

C       G(T4,N494,FULL)

C       G(T4,N495,FULL)

C       G(T4,N496,FULL)

C       G(T4,N497,FULL)

C       G(T4,N505,FULL)
        CALL xB012345_(S34,XMW2,XMW2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = -((B2(0,0)*QF(3)*ALPHA*CBA*PZ12*PZ34*XMZ*(XCW+XSW)*
     &  (XCW-XSW))/(4D0*PI*S34*XCW*XCW2*XSW))

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE
        F(1,1,1) = F(1,1,1)+2D0*QF(1)*PRE

C       G(T4,N506,FULL)
        CALL xB012345_(S34,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((QF(3)*ALPHA*B0*CBA*PZ12*PZ34*XMW*XMZ2)/(8D0*PI*S34*
     &  XCW2))

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE*XSW
        F(1,1,1) = F(1,1,1)+2D0*QF(1)*PRE*XSW

C       G(T4,N507,FULL)
        CALL xB012345_(S34,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((QF(3)*ALPHA*B0*CBA*PZ12*PZ34*XMW*XMZ2)/(8D0*PI*S34*
     &  XCW2))

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE*XSW
        F(1,1,1) = F(1,1,1)+2D0*QF(1)*PRE*XSW

C       G(T4,N508,FULL)
        CALL xB012345_(S34,XMHP2,XMHP2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = -((B2(0,0)*QF(3)*ALPHA*CBA*PZ12*PZ34*XMZ*(XCW+XSW)*
     &  (XCW-XSW))/(4D0*PI*S34*XCW*XCW2*XSW))

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE
        F(1,1,1) = F(1,1,1)+2D0*QF(1)*PRE

C       G(T4,N509,FULL)
        CALL xB012345_(S34,XMW2,XMW2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (B2(0,0)*QF(3)*ALPHA*CBA*PZ12*PZ34*XMZ)/(8D0*PI*S34*
     &  XCW*XSW)

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE
        F(1,1,1) = F(1,1,1)+2D0*QF(1)*PRE

C       G(T4,N510,FULL)
        CALL xB012345_(S34,XMW2,XMW2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (B2(0,0)*QF(3)*ALPHA*CBA*PZ12*PZ34*XMZ)/(8D0*PI*S34*
     &  XCW*XSW)

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE
        F(1,1,1) = F(1,1,1)+2D0*QF(1)*PRE

C       G(T4,N511,FULL)
        CALL xB012345_(S34,XMW2,XMW2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = -((QF(3)*ALPHA*CBA*PZ12*PZ34*(2D0*B1(1)+2D0*B2(1,1)+
     &  5D0*B0+(18D0*B2(0,0))/S34+(S34-6D0*XMW2)/S34)*XMZ)/(8D0*PI*
     &  XCW*XSW))

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE
        F(1,1,1) = F(1,1,1)+2D0*QF(1)*PRE

C       G(T4,N520,FULL)
        CALL xB012345_(S34,XMW2,XMW2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (B2(0,0)*ALPHA*CBA*PZ12*PZ34**2*XCW2**(-2)*XMZ*(XCW+
     &  XSW)**2*(XCW-XSW)**2)/(16D0*PI*XCW*XSW)

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T4,N521,FULL)
        CALL xB012345_(S34,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*CBA*PZ12*PZ34**2*XMZ*XMZ2)/(16D0*PI*XCW*
     &  XCW2))

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)-2D0*QF(3)*PRE*XSW*(1D0-2D0*QF(1)*XSW2)
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE*XSW*(1D0+2D0*QF(3)*XSW2)
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*XSW*XSW2

C       G(T4,N522,FULL)
        CALL xB012345_(S34,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*CBA*PZ12*PZ34**2*XMZ*XMZ2)/(16D0*PI*XCW*
     &  XCW2))

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)-2D0*QF(3)*PRE*XSW*(1D0-2D0*QF(1)*XSW2)
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE*XSW*(1D0+2D0*QF(3)*XSW2)
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*XSW*XSW2

C       G(T4,N523,FULL)
        CALL xB012345_(S34,XMHP2,XMHP2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (B2(0,0)*ALPHA*CBA*PZ12*PZ34**2*XCW2**(-2)*XMZ*(XCW+
     &  XSW)**2*(XCW-XSW)**2)/(16D0*PI*XCW*XSW)

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T4,N524,FULL)
        CALL xB012345_(S34,XMH02,XMA02,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (B2(0,0)*ALPHA*CBA**3*PZ12*PZ34**2*XCW2**(-2)*XMZ)/
     &  (16D0*PI*XCW*XSW)

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T4,N525,FULL)
        CALL xB012345_(S34,XMH02,XMZ2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (B2(0,0)*ALPHA*CBA*PZ12*PZ34**2*SBA**2*XCW2**(-2)*
     &  XMZ)/(16D0*PI*XCW*XSW)

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T4,N526,FULL)
        CALL xB012345_(S34,XMH02,XMZ2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*CBA*PZ12*PZ34**2*SBA**2*XCW2**(-2)*XMZ*
     &  XMZ2)/(16D0*PI*XCW*XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T4,N527,FULL)
        CALL xB012345_(S34,XMHH2,XMA02,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (B2(0,0)*ALPHA*CBA*PZ12*PZ34**2*SBA**2*XCW2**(-2)*
     &  XMZ)/(16D0*PI*XCW*XSW)

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T4,N528,FULL)
        CALL xB012345_(S34,XMHH2,XMZ2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (B2(0,0)*ALPHA*CBA**3*PZ12*PZ34**2*XCW2**(-2)*XMZ)/
     &  (16D0*PI*XCW*XSW)

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T4,N529,FULL)
        CALL xB012345_(S34,XMHH2,XMZ2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*CBA**3*PZ12*PZ34**2*XCW2**(-2)*XMZ*XMZ2)/
     &  (16D0*PI*XCW*XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T4,N530,FULL)
        CALL xB012345_(S34,XMW2,XMW2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = -((B2(0,0)*ALPHA*CBA*PZ12*PZ34**2*XMZ)/(16D0*PI*XCW*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T4,N531,FULL)
        CALL xB012345_(S34,XMW2,XMW2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = -((B2(0,0)*ALPHA*CBA*PZ12*PZ34**2*XMZ)/(16D0*PI*XCW*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T4,N532,FULL)
        CALL xB012345_(S34,XMW2,XMW2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (ALPHA*CBA*PZ12*PZ34**2*(18D0*B2(0,0)+S34+2D0*B1(1)*
     &  S34+2D0*B2(1,1)*S34+5D0*B0*S34-6D0*XMW2)*XMZ)/(16D0*PI*XCW*
     &  XSW)

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

	end

**********************************************************************
        subroutine  HHtoZZ1133_vert_bos_thdm(F,pz12,pz34)
**********************************************************************
*       vertex corrections for HH -> ZZ -> uudd in the THDM
*       bosonic loops
*---------------------------------------------------------------------
*       24.4.16 Stefan Dittmaier
**********************************************************************
	implicit none
	complex*16 pre,F(13,-1:1,-1:1),pz12,pz34
	complex*16 A0,xA0_,B0_,xB0_,DB0_,xDB0_,B1_,xB1_,DB1_,xDB1_
        complex*16 B0,B1(1),B2(0:2,0:2),B3(0:2,0:2,2)
        complex*16 B4(0:2,0:2,0:2,0:2),B5(0:2,0:2,0:2,0:2,2)
        complex*16 C0_,C0,C1(2),C2(0:2,0:2),C3(0:2,0:2,2)
        complex*16 C4(0:2,0:2,0:2,0:2)
	complex*16 D0,D1(3),D2(0:3,0:3),D3(0:3,0:3,3)
        complex*16 D4(0:3,0:3,0:3,0:3),D5(0:3,0:3,0:3,0:3,3)
	complex*16 E0n,E1n(4),E2n(0:4,0:4),E3n(0:4,0:4,4)
	complex*16 E4n(0:4,0:4,0:4,0:4)
        COMPLEX*16 K(8)

c mandelstam variables
      	real*8 s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
      	common/mandel/s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
c fermion charges of isospin duplets
	real*8 qf(4)
	common/fcharge/qf
c fermion masses as flag (i*1d-20)
      	complex*16 cme2,cmf2(5)
      	real*8 me2,rme2,mf2(5),rmf2(5)
      	common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2
	include '../COMMON/param.inc'
	include '../COMMON/xparam.inc'
        include '../COMMON/param_thdm.inc'
        include '../COMMON/param_bsm.inc'

C       Process: S2F21aF21F23aF23,   Model: THDM

C       G(T1,N7,FULL)

C       G(T1,N8,FULL)

C       G(T1,N9,FULL)

C       G(T1,N10,FULL)

C       G(T1,N11,FULL)

C       G(T1,N12,FULL)

C       G(T1,N13,FULL)

C       G(T1,N14,FULL)

C       G(T1,N15,FULL)

C       G(T1,N16,FULL)

C       G(T1,N19,FULL)

C       G(T1,N20,FULL)

C       G(T1,N21,FULL)

C       G(T1,N22,FULL)

C       G(T1,N29,FULL)

C       G(T1,N30,FULL)

C       G(T1,N31,FULL)

C       G(T1,N32,FULL)

C       G(T1,N33,FULL)

C       G(T1,N34,FULL)

C       G(T1,N35,FULL)

C       G(T1,N36,FULL)

C       G(T1,N37,FULL)

C       G(T1,N38,FULL)

C       G(T1,N41,FULL)

C       G(T1,N42,FULL)

C       G(T1,N43,FULL)

C       G(T1,N44,FULL)

C       G(T1,N51,FULL)

C       G(T1,N52,FULL)

C       G(T1,N53,FULL)

C       G(T1,N54,FULL)

C       G(T1,N55,FULL)

C       G(T1,N56,FULL)

C       G(T1,N57,FULL)

C       G(T1,N58,FULL)

C       G(T1,N59,FULL)

C       G(T1,N60,FULL)

C       G(T1,N63,FULL)

C       G(T1,N64,FULL)

C       G(T1,N65,FULL)

C       G(T1,N66,FULL)

C       G(T1,N73,FULL)

C       G(T1,N74,FULL)

C       G(T1,N75,FULL)

C       G(T1,N76,FULL)

C       G(T1,N77,FULL)

C       G(T1,N78,FULL)

C       G(T1,N79,FULL)

C       G(T1,N80,FULL)

C       G(T1,N81,FULL)

C       G(T1,N82,FULL)

C       G(T1,N85,FULL)

C       G(T1,N86,FULL)

C       G(T1,N87,FULL)

C       G(T1,N88,FULL)

C       G(T1,N92,FULL)

C       G(T1,N93,FULL)

C       G(T1,N94,FULL)

C       G(T1,N95,FULL)

C       G(T1,N96,FULL)

C       G(T1,N97,FULL)

C       G(T1,N98,FULL)

C       G(T1,N99,FULL)

C       G(T1,N100,FULL)

C       G(T1,N101,FULL)

C       G(T1,N103,FULL)

C       G(T1,N104,FULL)

C       G(T1,N108,FULL)

C       G(T1,N109,FULL)

C       G(T1,N110,FULL)

C       G(T1,N111,FULL)

C       G(T1,N112,FULL)

C       G(T1,N113,FULL)

C       G(T1,N114,FULL)

C       G(T1,N115,FULL)

C       G(T1,N116,FULL)

C       G(T1,N117,FULL)

C       G(T1,N119,FULL)

C       G(T1,N120,FULL)

C       G(T1,N124,FULL)

C       G(T1,N125,FULL)

C       G(T1,N126,FULL)

C       G(T1,N127,FULL)

C       G(T1,N128,FULL)

C       G(T1,N129,FULL)

C       G(T1,N130,FULL)

C       G(T1,N131,FULL)

C       G(T1,N132,FULL)

C       G(T1,N133,FULL)

C       G(T1,N135,FULL)

C       G(T1,N136,FULL)

C       G(T1,N138,FULL)

C       G(T1,N139,FULL)

C       G(T1,N140,FULL)

C       G(T1,N141,FULL)

C       G(T1,N142,FULL)

C       G(T1,N143,FULL)

C       G(T1,N144,FULL)

C       G(T1,N145,FULL)

C       G(T1,N146,FULL)

C       G(T1,N147,FULL)

C       G(T1,N149,FULL)

C       G(T1,N150,FULL)

C       G(T1,N152,FULL)

C       G(T1,N153,FULL)

C       G(T1,N154,FULL)

C       G(T1,N155,FULL)

C       G(T1,N156,FULL)

C       G(T1,N157,FULL)

C       G(T1,N158,FULL)

C       G(T1,N159,FULL)

C       G(T1,N160,FULL)

C       G(T1,N161,FULL)

C       G(T1,N163,FULL)

C       G(T1,N164,FULL)

C       G(T1,N166,FULL)

C       G(T1,N167,FULL)

C       G(T1,N168,FULL)

C       G(T1,N169,FULL)

C       G(T1,N170,FULL)

C       G(T1,N171,FULL)

C       G(T1,N172,FULL)

C       G(T1,N173,FULL)

C       G(T1,N174,FULL)

C       G(T1,N175,FULL)

C       G(T1,N177,FULL)

C       G(T1,N178,FULL)

C       G(T1,N182,FULL)

C       G(T1,N183,FULL)

C       G(T1,N184,FULL)

C       G(T1,N185,FULL)

C       G(T1,N186,FULL)

C       G(T1,N187,FULL)

C       G(T1,N188,FULL)

C       G(T1,N189,FULL)

C       G(T1,N190,FULL)

C       G(T1,N191,FULL)

C       G(T1,N193,FULL)

C       G(T1,N194,FULL)

C       G(T1,N195,FULL)

C       G(T1,N199,FULL)

C       G(T1,N200,FULL)

C       G(T1,N201,FULL)

C       G(T1,N202,FULL)

C       G(T1,N203,FULL)

C       G(T1,N204,FULL)

C       G(T1,N205,FULL)

C       G(T1,N206,FULL)

C       G(T1,N207,FULL)

C       G(T1,N208,FULL)

C       G(T1,N210,FULL)

C       G(T1,N211,FULL)

C       G(T1,N212,FULL)

C       G(T1,N216,FULL)

C       G(T1,N217,FULL)

C       G(T1,N218,FULL)

C       G(T1,N219,FULL)

C       G(T1,N220,FULL)

C       G(T1,N221,FULL)

C       G(T1,N222,FULL)

C       G(T1,N223,FULL)

C       G(T1,N224,FULL)

C       G(T1,N225,FULL)

C       G(T1,N227,FULL)
        CALL xC01234_(RMF2(1),S12,RMF2(1),CMF2(2),XMW2,XMW2,C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,1)

        PRE = (ALPHA*CBA*PZ12*PZ34*(1D0-6D0*C2(0,0)+C1(1)*S12+C1(2)*
     &  S12+C2(1,2)*S12)*XMZ)/(8D0*PI*XCW*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE

C       G(T1,N228,FULL)

C       G(T1,N229,FULL)

C       G(T1,N232,FULL)

C       G(T1,N235,FULL)

C       G(T1,N238,FULL)

C       G(T1,N241,FULL)

C       G(T1,N244,FULL)

C       G(T1,N247,FULL)

C       G(T1,N250,FULL)

C       G(T1,N253,FULL)

C       G(T1,N256,FULL)

C       G(T1,N259,FULL)

C       G(T1,N262,FULL)

C       G(T1,N265,FULL)

C       G(T1,N268,FULL)
        CALL xC01234_(S12,RMF2(1),RMF2(1),CMF2(2),CMF2(2),XMW2,C0,C1,C2,
     &  C3,C4,B0,B1,B2,B3,2,1)

        PRE = -((ALPHA*CBA*PZ12*PZ34*(1D0-2D0*C2(0,0)-C1(1)*S12-
     &  C1(2)*S12-C2(1,1)*S12-C2(1,2)*S12)*XMZ*(1D0+2D0*QF(2)*
     &  XSW2))/(16D0*PI*XCW*XCW2*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE

C       G(T1,N269,FULL)

C       G(T1,N270,FULL)

C       G(T1,N271,FULL)

C       G(T1,N272,FULL)

C       G(T1,N273,FULL)

C       G(T1,N274,FULL)

C       G(T1,N275,FULL)

C       G(T1,N276,FULL)

C       G(T1,N277,FULL)

C       G(T1,N278,FULL)

C       G(T1,N279,FULL)

C       G(T1,N280,FULL)

C       G(T1,N281,FULL)

C       G(T1,N282,FULL)

C       G(T1,N283,FULL)

C       G(T1,N284,FULL)

C       G(T1,N285,FULL)

C       G(T1,N286,FULL)

C       G(T1,N287,FULL)

C       G(T1,N288,FULL)

C       G(T1,N289,FULL)

C       G(T1,N290,FULL)

C       G(T1,N291,FULL)

C       G(T1,N292,FULL)

C       G(T1,N293,FULL)

C       G(T1,N294,FULL)

C       G(T1,N295,FULL)

C       G(T1,N296,FULL)

C       G(T1,N297,FULL)

C       G(T1,N298,FULL)

C       G(T1,N299,FULL)

C       G(T1,N300,FULL)

C       G(T1,N301,FULL)

C       G(T1,N302,FULL)

C       G(T1,N303,FULL)

C       G(T1,N304,FULL)

C       G(T1,N305,FULL)

C       G(T1,N306,FULL)

C       G(T1,N307,FULL)

C       G(T1,N308,FULL)

C       G(T1,N309,FULL)

C       G(T1,N310,FULL)

C       G(T1,N311,FULL)

C       G(T1,N312,FULL)

C       G(T1,N313,FULL)

C       G(T1,N314,FULL)

C       G(T1,N315,FULL)

C       G(T1,N316,FULL)

C       G(T1,N317,FULL)

C       G(T1,N318,FULL)

C       G(T1,N319,FULL)

C       G(T1,N320,FULL)

C       G(T1,N321,FULL)

C       G(T1,N322,FULL)

C       G(T1,N323,FULL)

C       G(T1,N324,FULL)

C       G(T1,N325,FULL)

C       G(T1,N326,FULL)

C       G(T1,N327,FULL)

C       G(T1,N328,FULL)

C       G(T1,N329,FULL)

C       G(T1,N330,FULL)

C       G(T1,N331,FULL)

C       G(T1,N332,FULL)

C       G(T1,N333,FULL)

C       G(T1,N334,FULL)

C       G(T1,N335,FULL)

C       G(T1,N336,FULL)

C       G(T1,N337,FULL)

C       G(T1,N338,FULL)

C       G(T1,N339,FULL)

C       G(T1,N340,FULL)

C       G(T1,N341,FULL)

C       G(T1,N342,FULL)

C       G(T1,N343,FULL)

C       G(T1,N344,FULL)

C       G(T1,N345,FULL)
        CALL xC01234_(RMF2(1),S12,RMF2(1),NULL,CMF2(1),CMF2(1),C0,C1,C2,
     &  C3,C4,B0,B1,B2,B3,2,1)

        PRE = -((QF(1)**2*ALPHA*CBA*PZ12*PZ34*(1D0-2D0*C2(0,0)+
     &  C1(1)*S12+C1(2)*S12+C2(1,2)*S12+C0*S12)*XMZ)/(8D0*PI*XCW*
     &  XCW2))

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*XSW

C       G(T1,N346,FULL)
        CALL xC01234_(S12,RMF2(1),RMF2(1),CMF2(1),CMF2(1),XMZ2,C0,C1,C2,
     &  C3,C4,B0,B1,B2,B3,2,1)

        PRE = -((ALPHA*CBA*PZ12*PZ34*(1D0-2D0*C2(0,0)-C1(1)*S12-
     &  C1(2)*S12-C2(1,1)*S12-C2(1,2)*S12)*XCW2**(-2)*XMZ)/(32D0*PI*
     &  XCW))

        F(1,-1,-1) = F(1,-1,-1)-(PRE*XSW2**(-2)*(1D0-2D0*QF(1)*
     &  XSW2)**3*(1D0+2D0*QF(3)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2)**
     &  3)/(XSW*XSW2)
        F(1,1,-1) = F(1,1,-1)+8D0*QF(1)**3*PRE*XSW*(1D0+2D0*QF(3)*
     &  XSW2)
        F(1,1,1) = F(1,1,1)+16D0*QF(1)**3*QF(3)*PRE*XSW*XSW2

C       G(T2,N353,FULL)

C       G(T2,N354,FULL)

C       G(T2,N355,FULL)

C       G(T2,N356,FULL)

C       G(T2,N357,FULL)

C       G(T2,N358,FULL)

C       G(T2,N359,FULL)

C       G(T2,N360,FULL)

C       G(T2,N361,FULL)

C       G(T2,N362,FULL)

C       G(T2,N365,FULL)

C       G(T2,N366,FULL)

C       G(T2,N367,FULL)

C       G(T2,N368,FULL)

C       G(T2,N375,FULL)

C       G(T2,N376,FULL)

C       G(T2,N377,FULL)

C       G(T2,N378,FULL)

C       G(T2,N379,FULL)

C       G(T2,N380,FULL)

C       G(T2,N381,FULL)

C       G(T2,N382,FULL)

C       G(T2,N383,FULL)

C       G(T2,N384,FULL)

C       G(T2,N387,FULL)

C       G(T2,N388,FULL)

C       G(T2,N389,FULL)

C       G(T2,N390,FULL)

C       G(T2,N394,FULL)

C       G(T2,N395,FULL)

C       G(T2,N396,FULL)

C       G(T2,N397,FULL)

C       G(T2,N398,FULL)

C       G(T2,N399,FULL)

C       G(T2,N400,FULL)

C       G(T2,N401,FULL)

C       G(T2,N402,FULL)

C       G(T2,N403,FULL)

C       G(T2,N405,FULL)

C       G(T2,N406,FULL)

C       G(T2,N408,FULL)

C       G(T2,N409,FULL)

C       G(T2,N410,FULL)

C       G(T2,N411,FULL)

C       G(T2,N412,FULL)

C       G(T2,N413,FULL)

C       G(T2,N414,FULL)

C       G(T2,N415,FULL)

C       G(T2,N416,FULL)

C       G(T2,N417,FULL)

C       G(T2,N419,FULL)

C       G(T2,N420,FULL)

C       G(T2,N425,FULL)

C       G(T2,N429,FULL)

C       G(T2,N430,FULL)

C       G(T2,N431,FULL)

C       G(T2,N432,FULL)

C       G(T2,N433,FULL)

C       G(T2,N434,FULL)

C       G(T2,N435,FULL)

C       G(T2,N436,FULL)

C       G(T2,N437,FULL)

C       G(T2,N438,FULL)

C       G(T2,N440,FULL)

C       G(T2,N441,FULL)

C       G(T2,N442,FULL)

C       G(T2,N445,FULL)

C       G(T2,N448,FULL)

C       G(T2,N451,FULL)

C       G(T2,N454,FULL)

C       G(T2,N457,FULL)

C       G(T2,N460,FULL)

C       G(T2,N461,FULL)

C       G(T2,N462,FULL)

C       G(T2,N463,FULL)

C       G(T2,N464,FULL)

C       G(T2,N465,FULL)

C       G(T2,N466,FULL)

C       G(T2,N467,FULL)

C       G(T2,N468,FULL)

C       G(T2,N469,FULL)

C       G(T2,N470,FULL)

C       G(T2,N471,FULL)

C       G(T2,N472,FULL)

C       G(T2,N473,FULL)

C       G(T2,N474,FULL)

C       G(T2,N475,FULL)

C       G(T2,N476,FULL)

C       G(T2,N477,FULL)

C       G(T2,N478,FULL)

C       G(T2,N479,FULL)

C       G(T2,N480,FULL)

C       G(T2,N481,FULL)

C       G(T2,N482,FULL)

C       G(T2,N483,FULL)

C       G(T2,N484,FULL)

C       G(T2,N485,FULL)

C       G(T2,N486,FULL)

C       G(T2,N487,FULL)

C       G(T2,N488,FULL)

C       G(T2,N489,FULL)

C       G(T2,N490,FULL)

C       G(T2,N491,FULL)

C       G(T2,N492,FULL)

C       G(T2,N493,FULL)

C       G(T2,N494,FULL)

C       G(T2,N495,FULL)

C       G(T2,N496,FULL)

C       G(T3,N503,FULL)

C       G(T3,N504,FULL)

C       G(T3,N505,FULL)

C       G(T3,N506,FULL)

C       G(T3,N507,FULL)

C       G(T3,N508,FULL)

C       G(T3,N509,FULL)

C       G(T3,N510,FULL)

C       G(T3,N511,FULL)

C       G(T3,N512,FULL)

C       G(T3,N515,FULL)

C       G(T3,N516,FULL)

C       G(T3,N517,FULL)

C       G(T3,N518,FULL)

C       G(T3,N525,FULL)

C       G(T3,N526,FULL)

C       G(T3,N527,FULL)

C       G(T3,N528,FULL)

C       G(T3,N529,FULL)

C       G(T3,N530,FULL)

C       G(T3,N531,FULL)

C       G(T3,N532,FULL)

C       G(T3,N533,FULL)

C       G(T3,N534,FULL)

C       G(T3,N537,FULL)

C       G(T3,N538,FULL)

C       G(T3,N539,FULL)

C       G(T3,N540,FULL)

C       G(T3,N544,FULL)

C       G(T3,N545,FULL)

C       G(T3,N546,FULL)

C       G(T3,N547,FULL)

C       G(T3,N548,FULL)

C       G(T3,N549,FULL)

C       G(T3,N550,FULL)

C       G(T3,N551,FULL)

C       G(T3,N552,FULL)

C       G(T3,N553,FULL)

C       G(T3,N555,FULL)

C       G(T3,N556,FULL)

C       G(T3,N558,FULL)

C       G(T3,N559,FULL)

C       G(T3,N560,FULL)

C       G(T3,N561,FULL)

C       G(T3,N562,FULL)

C       G(T3,N563,FULL)

C       G(T3,N564,FULL)

C       G(T3,N565,FULL)

C       G(T3,N566,FULL)

C       G(T3,N567,FULL)

C       G(T3,N569,FULL)

C       G(T3,N570,FULL)

C       G(T3,N575,FULL)

C       G(T3,N579,FULL)

C       G(T3,N580,FULL)

C       G(T3,N581,FULL)

C       G(T3,N582,FULL)

C       G(T3,N583,FULL)

C       G(T3,N584,FULL)

C       G(T3,N585,FULL)

C       G(T3,N586,FULL)

C       G(T3,N587,FULL)

C       G(T3,N588,FULL)

C       G(T3,N590,FULL)

C       G(T3,N591,FULL)

C       G(T3,N592,FULL)

C       G(T3,N595,FULL)

C       G(T3,N598,FULL)

C       G(T3,N601,FULL)

C       G(T3,N604,FULL)

C       G(T3,N607,FULL)

C       G(T3,N610,FULL)

C       G(T3,N611,FULL)

C       G(T3,N612,FULL)

C       G(T3,N613,FULL)

C       G(T3,N614,FULL)

C       G(T3,N615,FULL)

C       G(T3,N616,FULL)

C       G(T3,N617,FULL)

C       G(T3,N618,FULL)

C       G(T3,N619,FULL)

C       G(T3,N620,FULL)

C       G(T3,N621,FULL)

C       G(T3,N622,FULL)

C       G(T3,N623,FULL)

C       G(T3,N624,FULL)

C       G(T3,N625,FULL)

C       G(T3,N626,FULL)

C       G(T3,N627,FULL)

C       G(T3,N628,FULL)

C       G(T3,N629,FULL)

C       G(T3,N630,FULL)

C       G(T3,N631,FULL)

C       G(T3,N632,FULL)

C       G(T3,N633,FULL)

C       G(T3,N634,FULL)

C       G(T3,N635,FULL)

C       G(T3,N636,FULL)

C       G(T3,N637,FULL)

C       G(T3,N638,FULL)

C       G(T3,N639,FULL)

C       G(T3,N640,FULL)

C       G(T3,N641,FULL)

C       G(T3,N642,FULL)

C       G(T3,N643,FULL)

C       G(T3,N644,FULL)

C       G(T3,N645,FULL)

C       G(T3,N646,FULL)

C       G(T4,N653,FULL)

C       G(T4,N654,FULL)

C       G(T4,N655,FULL)

C       G(T4,N656,FULL)

C       G(T4,N657,FULL)

C       G(T4,N658,FULL)

C       G(T4,N659,FULL)

C       G(T4,N660,FULL)

C       G(T4,N661,FULL)

C       G(T4,N662,FULL)

C       G(T4,N665,FULL)

C       G(T4,N666,FULL)

C       G(T4,N667,FULL)

C       G(T4,N668,FULL)

C       G(T4,N675,FULL)

C       G(T4,N676,FULL)

C       G(T4,N677,FULL)

C       G(T4,N678,FULL)

C       G(T4,N679,FULL)

C       G(T4,N680,FULL)

C       G(T4,N681,FULL)

C       G(T4,N682,FULL)

C       G(T4,N683,FULL)

C       G(T4,N684,FULL)

C       G(T4,N687,FULL)

C       G(T4,N688,FULL)

C       G(T4,N689,FULL)

C       G(T4,N690,FULL)

C       G(T4,N697,FULL)

C       G(T4,N698,FULL)

C       G(T4,N699,FULL)

C       G(T4,N700,FULL)

C       G(T4,N701,FULL)

C       G(T4,N702,FULL)

C       G(T4,N703,FULL)

C       G(T4,N704,FULL)

C       G(T4,N705,FULL)

C       G(T4,N706,FULL)

C       G(T4,N709,FULL)

C       G(T4,N710,FULL)

C       G(T4,N711,FULL)

C       G(T4,N712,FULL)

C       G(T4,N719,FULL)

C       G(T4,N720,FULL)

C       G(T4,N721,FULL)

C       G(T4,N722,FULL)

C       G(T4,N723,FULL)

C       G(T4,N724,FULL)

C       G(T4,N725,FULL)

C       G(T4,N726,FULL)

C       G(T4,N727,FULL)

C       G(T4,N728,FULL)

C       G(T4,N731,FULL)

C       G(T4,N732,FULL)

C       G(T4,N733,FULL)

C       G(T4,N734,FULL)

C       G(T4,N741,FULL)

C       G(T4,N742,FULL)

C       G(T4,N743,FULL)

C       G(T4,N744,FULL)

C       G(T4,N745,FULL)

C       G(T4,N746,FULL)

C       G(T4,N747,FULL)

C       G(T4,N748,FULL)

C       G(T4,N749,FULL)

C       G(T4,N750,FULL)

C       G(T4,N753,FULL)
        CALL xC01234_(RMF2(1),MHH2,T12,CMF2(2),XMW2,XMW2,C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,1,1)

        PRE = (C1(2)*QF(1)*QF(3)*ALPHA*CBA*XMW)/(4D0*PI*S34*XSW*
     &  XSW2)

        F(1,-1,-1) = F(1,-1,-1)+PRE
        F(1,-1,1) = F(1,-1,1)+PRE

C       G(T4,N754,FULL)

C       G(T4,N755,FULL)

C       G(T4,N756,FULL)
        CALL xC01234_(T12,MHH2,RMF2(1),CMF2(1),XMZ2,XMZ2,C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,1,1)

        PRE = (C1(1)*QF(1)*QF(3)*ALPHA*CBA*XMZ)/(8D0*PI*S34*XCW*
     &  XCW2)

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0-2D0*QF(1)*XSW2)**2)/(XSW*
     &  XSW2)
        F(1,-1,1) = F(1,-1,1)+(PRE*(1D0-2D0*QF(1)*XSW2)**2)/(XSW*
     &  XSW2)
        F(1,1,-1) = F(1,1,-1)+4D0*QF(1)**2*PRE*XSW
        F(1,1,1) = F(1,1,1)+4D0*QF(1)**2*PRE*XSW

C       G(T4,N763,FULL)

C       G(T4,N764,FULL)

C       G(T4,N765,FULL)

C       G(T4,N766,FULL)

C       G(T4,N767,FULL)

C       G(T4,N768,FULL)

C       G(T4,N769,FULL)

C       G(T4,N770,FULL)

C       G(T4,N771,FULL)

C       G(T4,N772,FULL)

C       G(T4,N775,FULL)
        CALL xC01234_(RMF2(1),MHH2,T12,CMF2(2),XMW2,XMW2,C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,1,1)

        PRE = -((C1(2)*ALPHA*CBA*PZ34*XMW*(1D0-2D0*QF(1)*XSW2))/
     &  (16D0*PI*XCW2*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE

C       G(T4,N776,FULL)

C       G(T4,N777,FULL)

C       G(T4,N778,FULL)
        CALL xC01234_(T12,MHH2,RMF2(1),CMF2(1),XMZ2,XMZ2,C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,1,1)

        PRE = (C1(1)*ALPHA*CBA*PZ34*XCW2**(-2)*XMZ)/(32D0*PI*XCW)

        F(1,-1,-1) = F(1,-1,-1)-(PRE*XSW2**(-2)*(1D0-2D0*QF(1)*
     &  XSW2)**3*(1D0+2D0*QF(3)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2)**
     &  3)/(XSW*XSW2)
        F(1,1,-1) = F(1,1,-1)+8D0*QF(1)**3*PRE*XSW*(1D0+2D0*QF(3)*
     &  XSW2)
        F(1,1,1) = F(1,1,1)+16D0*QF(1)**3*QF(3)*PRE*XSW*XSW2

C       G(T4,N781,FULL)

C       G(T4,N784,FULL)

C       G(T4,N787,FULL)

C       G(T4,N790,FULL)

C       G(T4,N793,FULL)

C       G(T4,N796,FULL)

C       G(T4,N797,FULL)

C       G(T4,N798,FULL)

C       G(T4,N799,FULL)

C       G(T4,N800,FULL)

C       G(T4,N801,FULL)

C       G(T4,N802,FULL)

C       G(T4,N803,FULL)

C       G(T4,N804,FULL)

C       G(T4,N805,FULL)

C       G(T4,N806,FULL)

C       G(T4,N807,FULL)

C       G(T4,N808,FULL)

C       G(T4,N809,FULL)

C       G(T4,N810,FULL)

C       G(T4,N811,FULL)

C       G(T4,N812,FULL)

C       G(T4,N813,FULL)

C       G(T4,N814,FULL)

C       G(T4,N815,FULL)

C       G(T4,N816,FULL)

C       G(T4,N817,FULL)

C       G(T4,N818,FULL)

C       G(T4,N819,FULL)

C       G(T4,N820,FULL)

C       G(T4,N821,FULL)

C       G(T4,N822,FULL)

C       G(T4,N823,FULL)

C       G(T4,N824,FULL)

C       G(T4,N825,FULL)

C       G(T4,N826,FULL)

C       G(T4,N827,FULL)

C       G(T4,N828,FULL)

C       G(T4,N829,FULL)

C       G(T4,N830,FULL)

C       G(T4,N831,FULL)

C       G(T4,N832,FULL)

C       G(T5,N839,FULL)

C       G(T5,N840,FULL)

C       G(T5,N841,FULL)

C       G(T5,N842,FULL)

C       G(T5,N843,FULL)

C       G(T5,N844,FULL)

C       G(T5,N845,FULL)

C       G(T5,N846,FULL)

C       G(T5,N847,FULL)

C       G(T5,N848,FULL)

C       G(T5,N851,FULL)

C       G(T5,N852,FULL)

C       G(T5,N853,FULL)

C       G(T5,N854,FULL)

C       G(T5,N861,FULL)

C       G(T5,N862,FULL)

C       G(T5,N863,FULL)

C       G(T5,N864,FULL)

C       G(T5,N865,FULL)

C       G(T5,N866,FULL)

C       G(T5,N867,FULL)

C       G(T5,N868,FULL)

C       G(T5,N869,FULL)

C       G(T5,N870,FULL)

C       G(T5,N873,FULL)

C       G(T5,N874,FULL)

C       G(T5,N875,FULL)

C       G(T5,N876,FULL)

C       G(T5,N883,FULL)

C       G(T5,N884,FULL)

C       G(T5,N885,FULL)

C       G(T5,N886,FULL)

C       G(T5,N887,FULL)

C       G(T5,N888,FULL)

C       G(T5,N889,FULL)

C       G(T5,N890,FULL)

C       G(T5,N891,FULL)

C       G(T5,N892,FULL)

C       G(T5,N895,FULL)

C       G(T5,N896,FULL)

C       G(T5,N897,FULL)

C       G(T5,N898,FULL)

C       G(T5,N905,FULL)

C       G(T5,N906,FULL)

C       G(T5,N907,FULL)

C       G(T5,N908,FULL)

C       G(T5,N909,FULL)

C       G(T5,N910,FULL)

C       G(T5,N911,FULL)

C       G(T5,N912,FULL)

C       G(T5,N913,FULL)

C       G(T5,N914,FULL)

C       G(T5,N917,FULL)

C       G(T5,N918,FULL)

C       G(T5,N919,FULL)

C       G(T5,N920,FULL)

C       G(T5,N927,FULL)

C       G(T5,N928,FULL)

C       G(T5,N929,FULL)

C       G(T5,N930,FULL)

C       G(T5,N931,FULL)

C       G(T5,N932,FULL)

C       G(T5,N933,FULL)

C       G(T5,N934,FULL)

C       G(T5,N935,FULL)

C       G(T5,N936,FULL)

C       G(T5,N939,FULL)
        CALL xC01234_(RMF2(1),MHH2,T11,CMF2(2),XMW2,XMW2,C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,1,1)

        PRE = (C1(2)*QF(1)*QF(3)*ALPHA*CBA*XMW)/(4D0*PI*S34*XSW*
     &  XSW2)

        F(1,-1,-1) = F(1,-1,-1)+PRE
        F(1,-1,1) = F(1,-1,1)+PRE

C       G(T5,N940,FULL)

C       G(T5,N941,FULL)

C       G(T5,N942,FULL)
        CALL xC01234_(RMF2(1),MHH2,T11,CMF2(1),XMZ2,XMZ2,C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,1,1)

        PRE = (C1(2)*QF(1)*QF(3)*ALPHA*CBA*XMZ)/(8D0*PI*S34*XCW*
     &  XCW2)

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0-2D0*QF(1)*XSW2)**2)/(XSW*
     &  XSW2)
        F(1,-1,1) = F(1,-1,1)+(PRE*(1D0-2D0*QF(1)*XSW2)**2)/(XSW*
     &  XSW2)
        F(1,1,-1) = F(1,1,-1)+4D0*QF(1)**2*PRE*XSW
        F(1,1,1) = F(1,1,1)+4D0*QF(1)**2*PRE*XSW

C       G(T5,N949,FULL)

C       G(T5,N950,FULL)

C       G(T5,N951,FULL)

C       G(T5,N952,FULL)

C       G(T5,N953,FULL)

C       G(T5,N954,FULL)

C       G(T5,N955,FULL)

C       G(T5,N956,FULL)

C       G(T5,N957,FULL)

C       G(T5,N958,FULL)

C       G(T5,N961,FULL)
        CALL xC01234_(RMF2(1),MHH2,T11,CMF2(2),XMW2,XMW2,C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,1,1)

        PRE = -((C1(2)*ALPHA*CBA*PZ34*XMW*(1D0-2D0*QF(1)*XSW2))/
     &  (16D0*PI*XCW2*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE

C       G(T5,N962,FULL)

C       G(T5,N963,FULL)

C       G(T5,N964,FULL)
        CALL xC01234_(RMF2(1),MHH2,T11,CMF2(1),XMZ2,XMZ2,C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,1,1)

        PRE = (C1(2)*ALPHA*CBA*PZ34*XCW2**(-2)*XMZ)/(32D0*PI*XCW)

        F(1,-1,-1) = F(1,-1,-1)-(PRE*XSW2**(-2)*(1D0-2D0*QF(1)*
     &  XSW2)**3*(1D0+2D0*QF(3)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2)**
     &  3)/(XSW*XSW2)
        F(1,1,-1) = F(1,1,-1)+8D0*QF(1)**3*PRE*XSW*(1D0+2D0*QF(3)*
     &  XSW2)
        F(1,1,1) = F(1,1,1)+16D0*QF(1)**3*QF(3)*PRE*XSW*XSW2

C       G(T5,N967,FULL)

C       G(T5,N970,FULL)

C       G(T5,N973,FULL)

C       G(T5,N976,FULL)

C       G(T5,N979,FULL)

C       G(T5,N982,FULL)

C       G(T5,N983,FULL)

C       G(T5,N984,FULL)

C       G(T5,N985,FULL)

C       G(T5,N986,FULL)

C       G(T5,N987,FULL)

C       G(T5,N988,FULL)

C       G(T5,N989,FULL)

C       G(T5,N990,FULL)

C       G(T5,N991,FULL)

C       G(T5,N992,FULL)

C       G(T5,N993,FULL)

C       G(T5,N994,FULL)

C       G(T5,N995,FULL)

C       G(T5,N996,FULL)

C       G(T5,N997,FULL)

C       G(T5,N998,FULL)

C       G(T5,N999,FULL)

C       G(T5,N1000,FULL)

C       G(T5,N1001,FULL)

C       G(T5,N1002,FULL)

C       G(T5,N1003,FULL)

C       G(T5,N1004,FULL)

C       G(T5,N1005,FULL)

C       G(T5,N1006,FULL)

C       G(T5,N1007,FULL)

C       G(T5,N1008,FULL)

C       G(T5,N1009,FULL)

C       G(T5,N1010,FULL)

C       G(T5,N1011,FULL)

C       G(T5,N1012,FULL)

C       G(T5,N1013,FULL)

C       G(T5,N1014,FULL)

C       G(T5,N1015,FULL)

C       G(T5,N1016,FULL)

C       G(T5,N1017,FULL)

C       G(T5,N1018,FULL)

C       G(T6,N1019,FULL)

C       G(T6,N1020,FULL)

C       G(T6,N1021,FULL)

C       G(T6,N1022,FULL)

C       G(T6,N1023,FULL)

C       G(T6,N1024,FULL)

C       G(T6,N1027,FULL)

C       G(T6,N1028,FULL)

C       G(T6,N1029,FULL)

C       G(T6,N1030,FULL)

C       G(T6,N1031,FULL)

C       G(T6,N1032,FULL)

C       G(T6,N1033,FULL)

C       G(T6,N1036,FULL)

C       G(T6,N1037,FULL)

C       G(T6,N1038,FULL)

C       G(T6,N1039,FULL)

C       G(T6,N1040,FULL)

C       G(T6,N1041,FULL)

C       G(T6,N1042,FULL)

C       G(T6,N1045,FULL)

C       G(T6,N1048,FULL)

C       G(T6,N1049,FULL)

C       G(T6,N1050,FULL)

C       G(T6,N1051,FULL)

C       G(T6,N1052,FULL)

C       G(T6,N1053,FULL)

C       G(T6,N1056,FULL)

C       G(T6,N1059,FULL)

C       G(T6,N1060,FULL)

C       G(T6,N1061,FULL)

C       G(T6,N1062,FULL)

C       G(T6,N1063,FULL)

C       G(T6,N1064,FULL)

C       G(T6,N1067,FULL)

C       G(T6,N1069,FULL)

C       G(T6,N1070,FULL)

C       G(T6,N1071,FULL)

C       G(T6,N1072,FULL)

C       G(T6,N1073,FULL)

C       G(T6,N1074,FULL)

C       G(T6,N1077,FULL)

C       G(T6,N1079,FULL)

C       G(T6,N1080,FULL)

C       G(T6,N1081,FULL)

C       G(T6,N1082,FULL)

C       G(T6,N1083,FULL)

C       G(T6,N1084,FULL)

C       G(T6,N1085,FULL)

C       G(T6,N1086,FULL)

C       G(T6,N1087,FULL)

C       G(T6,N1088,FULL)

C       G(T6,N1089,FULL)

C       G(T6,N1090,FULL)

C       G(T6,N1093,FULL)

C       G(T6,N1094,FULL)

C       G(T6,N1095,FULL)

C       G(T6,N1096,FULL)

C       G(T6,N1097,FULL)

C       G(T6,N1098,FULL)

C       G(T6,N1099,FULL)

C       G(T6,N1100,FULL)

C       G(T6,N1104,FULL)

C       G(T6,N1105,FULL)

C       G(T6,N1106,FULL)

C       G(T6,N1107,FULL)

C       G(T6,N1108,FULL)

C       G(T6,N1111,FULL)

C       G(T6,N1112,FULL)

C       G(T6,N1114,FULL)

C       G(T6,N1115,FULL)

C       G(T6,N1116,FULL)

C       G(T6,N1117,FULL)

C       G(T6,N1118,FULL)

C       G(T6,N1119,FULL)

C       G(T6,N1120,FULL)

C       G(T6,N1127,FULL)

C       G(T6,N1128,FULL)

C       G(T6,N1129,FULL)

C       G(T6,N1132,FULL)

C       G(T6,N1133,FULL)

C       G(T6,N1134,FULL)

C       G(T6,N1135,FULL)

C       G(T6,N1136,FULL)

C       G(T6,N1137,FULL)

C       G(T6,N1138,FULL)

C       G(T6,N1145,FULL)

C       G(T6,N1146,FULL)

C       G(T6,N1147,FULL)

C       G(T6,N1150,FULL)

C       G(T6,N1151,FULL)

C       G(T6,N1152,FULL)

C       G(T6,N1153,FULL)

C       G(T6,N1154,FULL)

C       G(T6,N1155,FULL)

C       G(T6,N1156,FULL)

C       G(T6,N1157,FULL)

C       G(T6,N1158,FULL)

C       G(T6,N1159,FULL)

C       G(T6,N1160,FULL)

C       G(T6,N1161,FULL)

C       G(T6,N1162,FULL)

C       G(T6,N1163,FULL)

C       G(T6,N1164,FULL)

C       G(T6,N1165,FULL)

C       G(T6,N1166,FULL)

C       G(T6,N1167,FULL)

C       G(T6,N1168,FULL)

C       G(T7,N1175,FULL)

C       G(T7,N1176,FULL)

C       G(T7,N1177,FULL)

C       G(T7,N1178,FULL)

C       G(T7,N1179,FULL)

C       G(T7,N1180,FULL)

C       G(T7,N1181,FULL)

C       G(T7,N1182,FULL)

C       G(T7,N1183,FULL)

C       G(T7,N1184,FULL)

C       G(T7,N1187,FULL)

C       G(T7,N1188,FULL)

C       G(T7,N1189,FULL)

C       G(T7,N1190,FULL)

C       G(T7,N1197,FULL)

C       G(T7,N1198,FULL)

C       G(T7,N1199,FULL)

C       G(T7,N1200,FULL)

C       G(T7,N1201,FULL)

C       G(T7,N1202,FULL)

C       G(T7,N1203,FULL)

C       G(T7,N1204,FULL)

C       G(T7,N1205,FULL)

C       G(T7,N1206,FULL)

C       G(T7,N1209,FULL)

C       G(T7,N1210,FULL)

C       G(T7,N1211,FULL)

C       G(T7,N1212,FULL)

C       G(T7,N1219,FULL)

C       G(T7,N1220,FULL)

C       G(T7,N1221,FULL)

C       G(T7,N1222,FULL)

C       G(T7,N1223,FULL)

C       G(T7,N1224,FULL)

C       G(T7,N1225,FULL)

C       G(T7,N1226,FULL)

C       G(T7,N1227,FULL)

C       G(T7,N1228,FULL)

C       G(T7,N1231,FULL)

C       G(T7,N1232,FULL)

C       G(T7,N1233,FULL)

C       G(T7,N1234,FULL)

C       G(T7,N1241,FULL)

C       G(T7,N1242,FULL)

C       G(T7,N1243,FULL)

C       G(T7,N1244,FULL)

C       G(T7,N1245,FULL)

C       G(T7,N1246,FULL)

C       G(T7,N1247,FULL)

C       G(T7,N1248,FULL)

C       G(T7,N1249,FULL)

C       G(T7,N1250,FULL)

C       G(T7,N1253,FULL)

C       G(T7,N1254,FULL)

C       G(T7,N1255,FULL)

C       G(T7,N1256,FULL)

C       G(T7,N1263,FULL)

C       G(T7,N1264,FULL)

C       G(T7,N1265,FULL)

C       G(T7,N1266,FULL)

C       G(T7,N1267,FULL)

C       G(T7,N1268,FULL)

C       G(T7,N1269,FULL)

C       G(T7,N1270,FULL)

C       G(T7,N1271,FULL)

C       G(T7,N1272,FULL)

C       G(T7,N1275,FULL)
        CALL xC01234_(RMF2(3),MHH2,T13,CMF2(4),XMW2,XMW2,C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,1,1)

        PRE = (C1(2)*QF(1)*QF(3)*ALPHA*CBA*XMW)/(4D0*PI*S12*XSW*
     &  XSW2)

        F(1,-1,-1) = F(1,-1,-1)+PRE
        F(1,1,-1) = F(1,1,-1)+PRE

C       G(T7,N1276,FULL)

C       G(T7,N1277,FULL)

C       G(T7,N1278,FULL)
        CALL xC01234_(T13,MHH2,RMF2(3),CMF2(3),XMZ2,XMZ2,C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,1,1)

        PRE = (C1(1)*QF(1)*QF(3)*ALPHA*CBA*XMZ)/(8D0*PI*S12*XCW*
     &  XCW2)

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2)**2)/(XSW*
     &  XSW2)
        F(1,-1,1) = F(1,-1,1)+4D0*QF(3)**2*PRE*XSW
        F(1,1,-1) = F(1,1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2)**2)/(XSW*
     &  XSW2)
        F(1,1,1) = F(1,1,1)+4D0*QF(3)**2*PRE*XSW

C       G(T7,N1285,FULL)

C       G(T7,N1286,FULL)

C       G(T7,N1287,FULL)

C       G(T7,N1288,FULL)

C       G(T7,N1289,FULL)

C       G(T7,N1290,FULL)

C       G(T7,N1291,FULL)

C       G(T7,N1292,FULL)

C       G(T7,N1293,FULL)

C       G(T7,N1294,FULL)

C       G(T7,N1297,FULL)
        CALL xC01234_(RMF2(3),MHH2,T13,CMF2(4),XMW2,XMW2,C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,1,1)

        PRE = (C1(2)*ALPHA*CBA*PZ12*XMW*(1D0+2D0*QF(3)*XSW2))/(16D0*
     &  PI*XCW2*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE

C       G(T7,N1298,FULL)

C       G(T7,N1299,FULL)

C       G(T7,N1300,FULL)
        CALL xC01234_(T13,MHH2,RMF2(3),CMF2(3),XMZ2,XMZ2,C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,1,1)

        PRE = (C1(1)*ALPHA*CBA*PZ12*XCW2**(-2)*XMZ)/(32D0*PI*XCW)

        F(1,-1,-1) = F(1,-1,-1)-(PRE*XSW2**(-2)*(1D0-2D0*QF(1)*
     &  XSW2)*(1D0+2D0*QF(3)*XSW2)**3)/XSW
        F(1,-1,1) = F(1,-1,1)-8D0*QF(3)**3*PRE*XSW*(1D0-2D0*QF(1)*
     &  XSW2)
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2)**
     &  3)/(XSW*XSW2)
        F(1,1,1) = F(1,1,1)+16D0*QF(1)*QF(3)**3*PRE*XSW*XSW2

C       G(T7,N1303,FULL)

C       G(T7,N1306,FULL)

C       G(T7,N1309,FULL)

C       G(T7,N1312,FULL)

C       G(T7,N1315,FULL)

C       G(T7,N1318,FULL)

C       G(T7,N1319,FULL)

C       G(T7,N1320,FULL)

C       G(T7,N1321,FULL)

C       G(T7,N1322,FULL)

C       G(T7,N1323,FULL)

C       G(T7,N1324,FULL)

C       G(T7,N1325,FULL)

C       G(T7,N1326,FULL)

C       G(T7,N1327,FULL)

C       G(T7,N1328,FULL)

C       G(T7,N1329,FULL)

C       G(T7,N1330,FULL)

C       G(T7,N1331,FULL)

C       G(T7,N1332,FULL)

C       G(T7,N1333,FULL)

C       G(T7,N1334,FULL)

C       G(T7,N1335,FULL)

C       G(T7,N1336,FULL)

C       G(T7,N1337,FULL)

C       G(T7,N1338,FULL)

C       G(T7,N1339,FULL)

C       G(T7,N1340,FULL)

C       G(T7,N1341,FULL)

C       G(T7,N1342,FULL)

C       G(T7,N1343,FULL)

C       G(T7,N1344,FULL)

C       G(T7,N1345,FULL)

C       G(T7,N1346,FULL)

C       G(T7,N1347,FULL)

C       G(T7,N1348,FULL)

C       G(T7,N1349,FULL)

C       G(T7,N1350,FULL)

C       G(T7,N1351,FULL)

C       G(T7,N1352,FULL)

C       G(T7,N1353,FULL)

C       G(T7,N1354,FULL)

C       G(T8,N1357,FULL)

C       G(T8,N1358,FULL)

C       G(T8,N1359,FULL)

C       G(T8,N1360,FULL)

C       G(T8,N1361,FULL)

C       G(T8,N1362,FULL)

C       G(T8,N1363,FULL)

C       G(T8,N1366,FULL)

C       G(T8,N1367,FULL)

C       G(T8,N1368,FULL)

C       G(T8,N1369,FULL)

C       G(T8,N1370,FULL)

C       G(T8,N1371,FULL)

C       G(T8,N1372,FULL)

C       G(T8,N1377,FULL)

C       G(T8,N1378,FULL)

C       G(T8,N1379,FULL)

C       G(T8,N1380,FULL)

C       G(T8,N1381,FULL)

C       G(T8,N1382,FULL)

C       G(T8,N1383,FULL)

C       G(T8,N1388,FULL)

C       G(T8,N1389,FULL)

C       G(T8,N1390,FULL)

C       G(T8,N1391,FULL)

C       G(T8,N1392,FULL)

C       G(T8,N1393,FULL)

C       G(T8,N1394,FULL)

C       G(T8,N1398,FULL)

C       G(T8,N1399,FULL)

C       G(T8,N1400,FULL)

C       G(T8,N1401,FULL)

C       G(T8,N1402,FULL)

C       G(T8,N1403,FULL)

C       G(T8,N1404,FULL)

C       G(T8,N1408,FULL)

C       G(T8,N1409,FULL)

C       G(T8,N1410,FULL)

C       G(T8,N1411,FULL)

C       G(T8,N1412,FULL)

C       G(T8,N1413,FULL)

C       G(T8,N1414,FULL)

C       G(T8,N1415,FULL)

C       G(T8,N1416,FULL)

C       G(T8,N1417,FULL)

C       G(T8,N1418,FULL)

C       G(T8,N1419,FULL)

C       G(T8,N1420,FULL)

C       G(T8,N1421,FULL)

C       G(T8,N1422,FULL)

C       G(T8,N1423,FULL)

C       G(T8,N1424,FULL)

C       G(T8,N1425,FULL)

C       G(T8,N1426,FULL)

C       G(T8,N1427,FULL)

C       G(T8,N1428,FULL)

C       G(T8,N1431,FULL)

C       G(T8,N1432,FULL)

C       G(T8,N1433,FULL)

C       G(T8,N1434,FULL)

C       G(T8,N1435,FULL)

C       G(T8,N1436,FULL)

C       G(T8,N1440,FULL)

C       G(T8,N1441,FULL)

C       G(T8,N1442,FULL)

C       G(T8,N1443,FULL)

C       G(T8,N1444,FULL)

C       G(T8,N1445,FULL)

C       G(T8,N1446,FULL)

C       G(T8,N1450,FULL)

C       G(T8,N1451,FULL)

C       G(T8,N1452,FULL)

C       G(T8,N1453,FULL)

C       G(T8,N1454,FULL)

C       G(T8,N1455,FULL)

C       G(T8,N1456,FULL)

C       G(T8,N1457,FULL)

C       G(T8,N1458,FULL)

C       G(T8,N1459,FULL)

C       G(T8,N1468,FULL)

C       G(T8,N1469,FULL)

C       G(T8,N1470,FULL)

C       G(T8,N1471,FULL)

C       G(T8,N1472,FULL)

C       G(T8,N1473,FULL)

C       G(T8,N1474,FULL)

C       G(T8,N1475,FULL)

C       G(T8,N1476,FULL)

C       G(T8,N1477,FULL)

C       G(T8,N1486,FULL)

C       G(T8,N1487,FULL)

C       G(T8,N1488,FULL)

C       G(T8,N1489,FULL)

C       G(T8,N1490,FULL)

C       G(T8,N1491,FULL)

C       G(T8,N1492,FULL)

C       G(T8,N1493,FULL)

C       G(T8,N1494,FULL)

C       G(T8,N1495,FULL)

C       G(T8,N1496,FULL)

C       G(T8,N1497,FULL)

C       G(T8,N1498,FULL)

C       G(T8,N1499,FULL)

C       G(T8,N1500,FULL)

C       G(T8,N1501,FULL)

C       G(T8,N1502,FULL)

C       G(T8,N1503,FULL)

C       G(T8,N1504,FULL)

C       G(T9,N1519,FULL)

C       G(T9,N1520,FULL)

C       G(T9,N1521,FULL)

C       G(T9,N1522,FULL)

C       G(T9,N1523,FULL)

C       G(T9,N1524,FULL)

C       G(T9,N1539,FULL)

C       G(T9,N1540,FULL)

C       G(T9,N1541,FULL)

C       G(T9,N1542,FULL)

C       G(T9,N1543,FULL)

C       G(T9,N1544,FULL)

C       G(T9,N1559,FULL)

C       G(T9,N1560,FULL)

C       G(T9,N1561,FULL)

C       G(T9,N1562,FULL)

C       G(T9,N1563,FULL)

C       G(T9,N1564,FULL)

C       G(T9,N1565,FULL)

C       G(T9,N1566,FULL)

C       G(T9,N1567,FULL)

C       G(T9,N1568,FULL)

C       G(T9,N1569,FULL)

C       G(T9,N1570,FULL)

C       G(T9,N1585,FULL)

C       G(T9,N1586,FULL)

C       G(T9,N1587,FULL)

C       G(T9,N1588,FULL)

C       G(T9,N1589,FULL)

C       G(T9,N1590,FULL)

C       G(T9,N1591,FULL)

C       G(T9,N1592,FULL)

C       G(T9,N1593,FULL)

C       G(T9,N1594,FULL)

C       G(T9,N1595,FULL)

C       G(T9,N1596,FULL)

C       G(T9,N1597,FULL)

C       G(T9,N1598,FULL)

C       G(T9,N1599,FULL)

C       G(T9,N1600,FULL)

C       G(T9,N1615,FULL)

C       G(T9,N1616,FULL)

C       G(T9,N1617,FULL)

C       G(T9,N1618,FULL)

C       G(T9,N1619,FULL)

C       G(T9,N1620,FULL)

C       G(T9,N1621,FULL)

C       G(T9,N1622,FULL)

C       G(T9,N1623,FULL)

C       G(T9,N1624,FULL)

C       G(T9,N1639,FULL)

C       G(T9,N1640,FULL)

C       G(T9,N1641,FULL)

C       G(T9,N1642,FULL)

C       G(T9,N1643,FULL)

C       G(T9,N1644,FULL)

C       G(T9,N1645,FULL)

C       G(T9,N1646,FULL)

C       G(T9,N1647,FULL)

C       G(T9,N1648,FULL)

C       G(T9,N1663,FULL)

C       G(T9,N1664,FULL)

C       G(T9,N1665,FULL)

C       G(T9,N1666,FULL)

C       G(T9,N1667,FULL)

C       G(T9,N1668,FULL)

C       G(T9,N1683,FULL)

C       G(T9,N1684,FULL)

C       G(T9,N1685,FULL)

C       G(T9,N1686,FULL)

C       G(T9,N1687,FULL)

C       G(T9,N1688,FULL)

C       G(T9,N1703,FULL)

C       G(T9,N1704,FULL)

C       G(T9,N1705,FULL)

C       G(T9,N1706,FULL)

C       G(T9,N1707,FULL)

C       G(T9,N1708,FULL)

C       G(T9,N1709,FULL)

C       G(T9,N1710,FULL)

C       G(T9,N1711,FULL)

C       G(T9,N1712,FULL)

C       G(T9,N1713,FULL)

C       G(T9,N1714,FULL)

C       G(T9,N1729,FULL)

C       G(T9,N1730,FULL)

C       G(T9,N1731,FULL)

C       G(T9,N1732,FULL)

C       G(T9,N1733,FULL)

C       G(T9,N1734,FULL)

C       G(T9,N1735,FULL)

C       G(T9,N1736,FULL)

C       G(T9,N1737,FULL)

C       G(T9,N1738,FULL)

C       G(T9,N1739,FULL)

C       G(T9,N1740,FULL)

C       G(T9,N1741,FULL)

C       G(T9,N1742,FULL)

C       G(T9,N1743,FULL)

C       G(T9,N1744,FULL)

C       G(T9,N1759,FULL)

C       G(T9,N1760,FULL)

C       G(T9,N1761,FULL)

C       G(T9,N1762,FULL)

C       G(T9,N1763,FULL)

C       G(T9,N1764,FULL)

C       G(T9,N1765,FULL)

C       G(T9,N1766,FULL)

C       G(T9,N1767,FULL)

C       G(T9,N1768,FULL)

C       G(T9,N1783,FULL)

C       G(T9,N1784,FULL)

C       G(T9,N1785,FULL)

C       G(T9,N1786,FULL)

C       G(T9,N1787,FULL)

C       G(T9,N1788,FULL)

C       G(T9,N1789,FULL)

C       G(T9,N1790,FULL)

C       G(T9,N1791,FULL)

C       G(T9,N1792,FULL)

C       G(T9,N1807,FULL)

C       G(T9,N1808,FULL)

C       G(T9,N1809,FULL)

C       G(T9,N1810,FULL)

C       G(T9,N1811,FULL)

C       G(T9,N1812,FULL)

C       G(T9,N1813,FULL)

C       G(T9,N1814,FULL)

C       G(T9,N1815,FULL)

C       G(T9,N1816,FULL)

C       G(T9,N1817,FULL)

C       G(T9,N1818,FULL)

C       G(T9,N1833,FULL)

C       G(T9,N1834,FULL)

C       G(T9,N1835,FULL)

C       G(T9,N1836,FULL)

C       G(T9,N1837,FULL)

C       G(T9,N1838,FULL)

C       G(T9,N1839,FULL)

C       G(T9,N1840,FULL)

C       G(T9,N1841,FULL)

C       G(T9,N1842,FULL)

C       G(T9,N1843,FULL)

C       G(T9,N1844,FULL)

C       G(T9,N1859,FULL)

C       G(T9,N1860,FULL)

C       G(T9,N1861,FULL)

C       G(T9,N1862,FULL)

C       G(T9,N1863,FULL)

C       G(T9,N1864,FULL)

C       G(T9,N1865,FULL)

C       G(T9,N1866,FULL)

C       G(T9,N1881,FULL)

C       G(T9,N1882,FULL)

C       G(T9,N1883,FULL)

C       G(T9,N1884,FULL)

C       G(T9,N1899,FULL)

C       G(T9,N1900,FULL)

C       G(T9,N1901,FULL)

C       G(T9,N1902,FULL)

C       G(T9,N1917,FULL)

C       G(T9,N1918,FULL)

C       G(T9,N1919,FULL)

C       G(T9,N1920,FULL)

C       G(T9,N1935,FULL)

C       G(T9,N1936,FULL)

C       G(T9,N1937,FULL)

C       G(T9,N1938,FULL)

C       G(T9,N1939,FULL)

C       G(T9,N1940,FULL)

C       G(T9,N1941,FULL)

C       G(T9,N1942,FULL)

C       G(T9,N1943,FULL)

C       G(T9,N1944,FULL)

C       G(T9,N1945,FULL)

C       G(T9,N1946,FULL)

C       G(T9,N1947,FULL)

C       G(T9,N1948,FULL)

C       G(T9,N1949,FULL)

C       G(T9,N1950,FULL)

C       G(T9,N1965,FULL)

C       G(T9,N1966,FULL)

C       G(T9,N1967,FULL)

C       G(T9,N1968,FULL)

C       G(T9,N1969,FULL)

C       G(T9,N1970,FULL)

C       G(T9,N1971,FULL)

C       G(T9,N1972,FULL)

C       G(T9,N1973,FULL)

C       G(T9,N1974,FULL)

C       G(T9,N1975,FULL)

C       G(T9,N1976,FULL)

C       G(T9,N1977,FULL)

C       G(T9,N1978,FULL)

C       G(T9,N1979,FULL)

C       G(T9,N1980,FULL)

C       G(T9,N1995,FULL)

C       G(T9,N1996,FULL)

C       G(T9,N1997,FULL)

C       G(T9,N1998,FULL)

C       G(T9,N2013,FULL)

C       G(T9,N2014,FULL)

C       G(T9,N2015,FULL)

C       G(T9,N2016,FULL)

C       G(T9,N2017,FULL)

C       G(T9,N2018,FULL)

C       G(T9,N2019,FULL)

C       G(T9,N2020,FULL)

C       G(T9,N2035,FULL)

C       G(T9,N2036,FULL)

C       G(T9,N2037,FULL)

C       G(T9,N2038,FULL)

C       G(T9,N2039,FULL)

C       G(T9,N2040,FULL)

C       G(T9,N2041,FULL)

C       G(T9,N2042,FULL)

C       G(T9,N2043,FULL)

C       G(T9,N2044,FULL)

C       G(T9,N2045,FULL)

C       G(T9,N2046,FULL)

C       G(T9,N2061,FULL)

C       G(T9,N2062,FULL)

C       G(T9,N2063,FULL)

C       G(T9,N2064,FULL)

C       G(T9,N2065,FULL)

C       G(T9,N2066,FULL)

C       G(T9,N2067,FULL)

C       G(T9,N2068,FULL)

C       G(T9,N2069,FULL)

C       G(T9,N2070,FULL)

C       G(T9,N2071,FULL)

C       G(T9,N2072,FULL)

C       G(T9,N2087,FULL)

C       G(T9,N2088,FULL)

C       G(T9,N2089,FULL)

C       G(T9,N2090,FULL)

C       G(T9,N2091,FULL)

C       G(T9,N2092,FULL)

C       G(T9,N2093,FULL)

C       G(T9,N2094,FULL)

C       G(T9,N2095,FULL)

C       G(T9,N2096,FULL)

C       G(T9,N2111,FULL)

C       G(T9,N2112,FULL)

C       G(T9,N2113,FULL)

C       G(T9,N2114,FULL)

C       G(T9,N2115,FULL)

C       G(T9,N2116,FULL)

C       G(T9,N2117,FULL)

C       G(T9,N2118,FULL)

C       G(T9,N2119,FULL)

C       G(T9,N2120,FULL)

C       G(T9,N2135,FULL)

C       G(T9,N2136,FULL)

C       G(T9,N2137,FULL)

C       G(T9,N2138,FULL)

C       G(T9,N2153,FULL)

C       G(T9,N2154,FULL)

C       G(T9,N2155,FULL)

C       G(T9,N2156,FULL)

C       G(T9,N2157,FULL)

C       G(T9,N2158,FULL)

C       G(T9,N2159,FULL)

C       G(T9,N2160,FULL)

C       G(T9,N2161,FULL)

C       G(T9,N2162,FULL)

C       G(T9,N2163,FULL)

C       G(T9,N2164,FULL)

C       G(T9,N2179,FULL)
        CALL xC01234_(S12,MHH2,S34,XMHP2,XMHP2,XMHP2,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,2,0)

        PRE = (QF(1)*QF(3)*PI**(-2)*(4D0*ALPHA*CB**3*MHH2*PI*SA-4D0*
     &  ALPHA*MA02*PI*SAB+8D0*ALPHA*CB*CBA*MHP2*PI*SB+4D0*ALPHA*CA*
     &  MHH2*PI*SB**3-4D0*LAM5*SAB*XMW2*XSW2))/(8D0*CB*S12*S34*SB*
     &  XMW*XSW)

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(1,-1,1) = F(1,-1,1)+C2(0,0)*PRE
        F(1,1,-1) = F(1,1,-1)+C2(0,0)*PRE
        F(1,1,1) = F(1,1,1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)-C2(1,2)*PRE
        F(5,-1,1) = F(5,-1,1)-C2(1,2)*PRE
        F(5,1,-1) = F(5,1,-1)-C2(1,2)*PRE
        F(5,1,1) = F(5,1,1)-C2(1,2)*PRE
        F(6,-1,-1) = F(6,-1,-1)-C2(1,2)*PRE
        F(6,-1,1) = F(6,-1,1)-C2(1,2)*PRE
        F(6,1,-1) = F(6,1,-1)-C2(1,2)*PRE
        F(6,1,1) = F(6,1,1)-C2(1,2)*PRE
        F(7,-1,-1) = F(7,-1,-1)-C2(1,2)*PRE
        F(7,-1,1) = F(7,-1,1)-C2(1,2)*PRE
        F(7,1,-1) = F(7,1,-1)-C2(1,2)*PRE
        F(7,1,1) = F(7,1,1)-C2(1,2)*PRE
        F(8,-1,-1) = F(8,-1,-1)-C2(1,2)*PRE
        F(8,-1,1) = F(8,-1,1)-C2(1,2)*PRE
        F(8,1,-1) = F(8,1,-1)-C2(1,2)*PRE
        F(8,1,1) = F(8,1,1)-C2(1,2)*PRE

C       G(T9,N2180,FULL)
        CALL xC01234_(S12,MHH2,S34,XMHP2,XMHP2,XMHP2,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,2,0)

        PRE = (QF(1)*QF(3)*PI**(-2)*(4D0*ALPHA*CB**3*MHH2*PI*SA-4D0*
     &  ALPHA*MA02*PI*SAB+8D0*ALPHA*CB*CBA*MHP2*PI*SB+4D0*ALPHA*CA*
     &  MHH2*PI*SB**3-4D0*LAM5*SAB*XMW2*XSW2))/(8D0*CB*S12*S34*SB*
     &  XMW*XSW)

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(1,-1,1) = F(1,-1,1)+C2(0,0)*PRE
        F(1,1,-1) = F(1,1,-1)+C2(0,0)*PRE
        F(1,1,1) = F(1,1,1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)-C2(1,2)*PRE
        F(5,-1,1) = F(5,-1,1)-C2(1,2)*PRE
        F(5,1,-1) = F(5,1,-1)-C2(1,2)*PRE
        F(5,1,1) = F(5,1,1)-C2(1,2)*PRE
        F(6,-1,-1) = F(6,-1,-1)-C2(1,2)*PRE
        F(6,-1,1) = F(6,-1,1)-C2(1,2)*PRE
        F(6,1,-1) = F(6,1,-1)-C2(1,2)*PRE
        F(6,1,1) = F(6,1,1)-C2(1,2)*PRE
        F(7,-1,-1) = F(7,-1,-1)-C2(1,2)*PRE
        F(7,-1,1) = F(7,-1,1)-C2(1,2)*PRE
        F(7,1,-1) = F(7,1,-1)-C2(1,2)*PRE
        F(7,1,1) = F(7,1,1)-C2(1,2)*PRE
        F(8,-1,-1) = F(8,-1,-1)-C2(1,2)*PRE
        F(8,-1,1) = F(8,-1,1)-C2(1,2)*PRE
        F(8,1,-1) = F(8,1,-1)-C2(1,2)*PRE
        F(8,1,1) = F(8,1,1)-C2(1,2)*PRE

C       G(T9,N2181,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)

        PRE = -((QF(1)*QF(3)*ALPHA*CBA*XMW)/(8D0*PI*S12*S34*XSW))

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(1,-1,1) = F(1,-1,1)+C2(0,0)*PRE
        F(1,1,-1) = F(1,1,-1)+C2(0,0)*PRE
        F(1,1,1) = F(1,1,1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)-C2(1,2)*PRE
        F(5,-1,1) = F(5,-1,1)-C2(1,2)*PRE
        F(5,1,-1) = F(5,1,-1)-C2(1,2)*PRE
        F(5,1,1) = F(5,1,1)-C2(1,2)*PRE
        F(6,-1,-1) = F(6,-1,-1)-C2(1,2)*PRE
        F(6,-1,1) = F(6,-1,1)-C2(1,2)*PRE
        F(6,1,-1) = F(6,1,-1)-C2(1,2)*PRE
        F(6,1,1) = F(6,1,1)-C2(1,2)*PRE
        F(7,-1,-1) = F(7,-1,-1)-C2(1,2)*PRE
        F(7,-1,1) = F(7,-1,1)-C2(1,2)*PRE
        F(7,1,-1) = F(7,1,-1)-C2(1,2)*PRE
        F(7,1,1) = F(7,1,1)-C2(1,2)*PRE
        F(8,-1,-1) = F(8,-1,-1)-C2(1,2)*PRE
        F(8,-1,1) = F(8,-1,1)-C2(1,2)*PRE
        F(8,1,-1) = F(8,1,-1)-C2(1,2)*PRE
        F(8,1,1) = F(8,1,1)-C2(1,2)*PRE

C       G(T9,N2182,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)

        PRE = -((QF(1)*QF(3)*ALPHA*CBA*XMW)/(8D0*PI*S12*S34*XSW))

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(1,-1,1) = F(1,-1,1)+C2(0,0)*PRE
        F(1,1,-1) = F(1,1,-1)+C2(0,0)*PRE
        F(1,1,1) = F(1,1,1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)-C2(1,2)*PRE
        F(5,-1,1) = F(5,-1,1)-C2(1,2)*PRE
        F(5,1,-1) = F(5,1,-1)-C2(1,2)*PRE
        F(5,1,1) = F(5,1,1)-C2(1,2)*PRE
        F(6,-1,-1) = F(6,-1,-1)-C2(1,2)*PRE
        F(6,-1,1) = F(6,-1,1)-C2(1,2)*PRE
        F(6,1,-1) = F(6,1,-1)-C2(1,2)*PRE
        F(6,1,1) = F(6,1,1)-C2(1,2)*PRE
        F(7,-1,-1) = F(7,-1,-1)-C2(1,2)*PRE
        F(7,-1,1) = F(7,-1,1)-C2(1,2)*PRE
        F(7,1,-1) = F(7,1,-1)-C2(1,2)*PRE
        F(7,1,1) = F(7,1,1)-C2(1,2)*PRE
        F(8,-1,-1) = F(8,-1,-1)-C2(1,2)*PRE
        F(8,-1,1) = F(8,-1,1)-C2(1,2)*PRE
        F(8,1,-1) = F(8,1,-1)-C2(1,2)*PRE
        F(8,1,1) = F(8,1,1)-C2(1,2)*PRE

C       G(T9,N2183,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)

        PRE = -((QF(1)*QF(3)*ALPHA*CBA*XMW)/(8D0*PI*S12*S34*XSW))

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(1,-1,1) = F(1,-1,1)+C2(0,0)*PRE
        F(1,1,-1) = F(1,1,-1)+C2(0,0)*PRE
        F(1,1,1) = F(1,1,1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)-C2(1,2)*PRE
        F(5,-1,1) = F(5,-1,1)-C2(1,2)*PRE
        F(5,1,-1) = F(5,1,-1)-C2(1,2)*PRE
        F(5,1,1) = F(5,1,1)-C2(1,2)*PRE
        F(6,-1,-1) = F(6,-1,-1)-C2(1,2)*PRE
        F(6,-1,1) = F(6,-1,1)-C2(1,2)*PRE
        F(6,1,-1) = F(6,1,-1)-C2(1,2)*PRE
        F(6,1,1) = F(6,1,1)-C2(1,2)*PRE
        F(7,-1,-1) = F(7,-1,-1)-C2(1,2)*PRE
        F(7,-1,1) = F(7,-1,1)-C2(1,2)*PRE
        F(7,1,-1) = F(7,1,-1)-C2(1,2)*PRE
        F(7,1,1) = F(7,1,1)-C2(1,2)*PRE
        F(8,-1,-1) = F(8,-1,-1)-C2(1,2)*PRE
        F(8,-1,1) = F(8,-1,1)-C2(1,2)*PRE
        F(8,1,-1) = F(8,1,-1)-C2(1,2)*PRE
        F(8,1,1) = F(8,1,1)-C2(1,2)*PRE

C       G(T9,N2184,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)

        PRE = -((QF(1)*QF(3)*ALPHA*CBA*XMW)/(8D0*PI*S12*S34*XSW))

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(1,-1,1) = F(1,-1,1)+C2(0,0)*PRE
        F(1,1,-1) = F(1,1,-1)+C2(0,0)*PRE
        F(1,1,1) = F(1,1,1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)-C2(1,2)*PRE
        F(5,-1,1) = F(5,-1,1)-C2(1,2)*PRE
        F(5,1,-1) = F(5,1,-1)-C2(1,2)*PRE
        F(5,1,1) = F(5,1,1)-C2(1,2)*PRE
        F(6,-1,-1) = F(6,-1,-1)-C2(1,2)*PRE
        F(6,-1,1) = F(6,-1,1)-C2(1,2)*PRE
        F(6,1,-1) = F(6,1,-1)-C2(1,2)*PRE
        F(6,1,1) = F(6,1,1)-C2(1,2)*PRE
        F(7,-1,-1) = F(7,-1,-1)-C2(1,2)*PRE
        F(7,-1,1) = F(7,-1,1)-C2(1,2)*PRE
        F(7,1,-1) = F(7,1,-1)-C2(1,2)*PRE
        F(7,1,1) = F(7,1,1)-C2(1,2)*PRE
        F(8,-1,-1) = F(8,-1,-1)-C2(1,2)*PRE
        F(8,-1,1) = F(8,-1,1)-C2(1,2)*PRE
        F(8,1,-1) = F(8,1,-1)-C2(1,2)*PRE
        F(8,1,1) = F(8,1,1)-C2(1,2)*PRE

C       G(T9,N2199,FULL)
        CALL xC01234_(S12,MHH2,S34,XMHP2,XMHP2,XMHP2,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,2,0)
        K(1) = 1D0+2D0*QF(3)*XSW2

        PRE = -((QF(1)*PI**(-2)*PZ34*(XCW+XSW)*(XCW-XSW)*(4D0*ALPHA*
     &  CB**3*MHH2*PI*SA-4D0*ALPHA*MA02*PI*SAB+8D0*ALPHA*CB*CBA*
     &  MHP2*PI*SB+4D0*ALPHA*CA*MHH2*PI*SB**3-4D0*LAM5*SAB*XMW2*
     &  XSW2))/(32D0*CB*S12*SB*XCW2*XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)+(C2(0,0)*K(1)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*C2(0,0)*QF(3)*PRE
        F(1,1,-1) = F(1,1,-1)+(C2(0,0)*K(1)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+2D0*C2(0,0)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(5,-1,1) = F(5,-1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(5,1,-1) = F(5,1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(6,-1,1) = F(6,-1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(6,1,-1) = F(6,1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(7,-1,1) = F(7,-1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(7,1,-1) = F(7,1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(8,-1,1) = F(8,-1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(8,1,-1) = F(8,1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-2D0*C2(1,2)*QF(3)*PRE

C       G(T9,N2200,FULL)
        CALL xC01234_(S12,MHH2,S34,XMHP2,XMHP2,XMHP2,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,2,0)
        K(1) = 1D0+2D0*QF(3)*XSW2

        PRE = -((QF(1)*PI**(-2)*PZ34*(XCW+XSW)*(XCW-XSW)*(4D0*ALPHA*
     &  CB**3*MHH2*PI*SA-4D0*ALPHA*MA02*PI*SAB+8D0*ALPHA*CB*CBA*
     &  MHP2*PI*SB+4D0*ALPHA*CA*MHH2*PI*SB**3-4D0*LAM5*SAB*XMW2*
     &  XSW2))/(32D0*CB*S12*SB*XCW2*XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)+(C2(0,0)*K(1)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*C2(0,0)*QF(3)*PRE
        F(1,1,-1) = F(1,1,-1)+(C2(0,0)*K(1)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+2D0*C2(0,0)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(5,-1,1) = F(5,-1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(5,1,-1) = F(5,1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(6,-1,1) = F(6,-1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(6,1,-1) = F(6,1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(7,-1,1) = F(7,-1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(7,1,-1) = F(7,1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(8,-1,1) = F(8,-1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(8,1,-1) = F(8,1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-2D0*C2(1,2)*QF(3)*PRE

C       G(T9,N2201,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0+2D0*QF(3)*XSW2

        PRE = (QF(1)*ALPHA*CBA*PZ34*XMW)/(16D0*PI*S12*XSW)

        F(1,-1,-1) = F(1,-1,-1)+(C2(0,0)*K(1)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*C2(0,0)*QF(3)*PRE
        F(1,1,-1) = F(1,1,-1)+(C2(0,0)*K(1)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+2D0*C2(0,0)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(5,-1,1) = F(5,-1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(5,1,-1) = F(5,1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(6,-1,1) = F(6,-1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(6,1,-1) = F(6,1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(7,-1,1) = F(7,-1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(7,1,-1) = F(7,1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(8,-1,1) = F(8,-1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(8,1,-1) = F(8,1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-2D0*C2(1,2)*QF(3)*PRE

C       G(T9,N2202,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0+2D0*QF(3)*XSW2

        PRE = (QF(1)*ALPHA*CBA*PZ34*XMW)/(16D0*PI*S12*XSW)

        F(1,-1,-1) = F(1,-1,-1)+(C2(0,0)*K(1)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*C2(0,0)*QF(3)*PRE
        F(1,1,-1) = F(1,1,-1)+(C2(0,0)*K(1)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+2D0*C2(0,0)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(5,-1,1) = F(5,-1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(5,1,-1) = F(5,1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(6,-1,1) = F(6,-1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(6,1,-1) = F(6,1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(7,-1,1) = F(7,-1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(7,1,-1) = F(7,1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(8,-1,1) = F(8,-1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(8,1,-1) = F(8,1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-2D0*C2(1,2)*QF(3)*PRE

C       G(T9,N2203,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0+2D0*QF(3)*XSW2

        PRE = (QF(1)*ALPHA*CBA*PZ34*XMW)/(16D0*PI*S12*XSW)

        F(1,-1,-1) = F(1,-1,-1)+(C2(0,0)*K(1)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*C2(0,0)*QF(3)*PRE
        F(1,1,-1) = F(1,1,-1)+(C2(0,0)*K(1)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+2D0*C2(0,0)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(5,-1,1) = F(5,-1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(5,1,-1) = F(5,1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(6,-1,1) = F(6,-1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(6,1,-1) = F(6,1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(7,-1,1) = F(7,-1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(7,1,-1) = F(7,1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(8,-1,1) = F(8,-1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(8,1,-1) = F(8,1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-2D0*C2(1,2)*QF(3)*PRE

C       G(T9,N2204,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0+2D0*QF(3)*XSW2

        PRE = (QF(1)*ALPHA*CBA*PZ34*XMW)/(16D0*PI*S12*XSW)

        F(1,-1,-1) = F(1,-1,-1)+(C2(0,0)*K(1)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*C2(0,0)*QF(3)*PRE
        F(1,1,-1) = F(1,1,-1)+(C2(0,0)*K(1)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+2D0*C2(0,0)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(5,-1,1) = F(5,-1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(5,1,-1) = F(5,1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(6,-1,1) = F(6,-1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(6,1,-1) = F(6,1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(7,-1,1) = F(7,-1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(7,1,-1) = F(7,1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(8,-1,1) = F(8,-1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(8,1,-1) = F(8,1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-2D0*C2(1,2)*QF(3)*PRE

C       G(T9,N2219,FULL)

C       G(T9,N2220,FULL)

C       G(T9,N2221,FULL)

C       G(T9,N2222,FULL)

C       G(T9,N2223,FULL)

C       G(T9,N2224,FULL)

C       G(T9,N2225,FULL)

C       G(T9,N2226,FULL)

C       G(T9,N2227,FULL)

C       G(T9,N2228,FULL)

C       G(T9,N2243,FULL)

C       G(T9,N2244,FULL)

C       G(T9,N2245,FULL)

C       G(T9,N2246,FULL)

C       G(T9,N2247,FULL)

C       G(T9,N2248,FULL)

C       G(T9,N2249,FULL)

C       G(T9,N2250,FULL)

C       G(T9,N2251,FULL)

C       G(T9,N2252,FULL)

C       G(T9,N2267,FULL)

C       G(T9,N2268,FULL)

C       G(T9,N2269,FULL)

C       G(T9,N2270,FULL)

C       G(T9,N2285,FULL)

C       G(T9,N2286,FULL)

C       G(T9,N2287,FULL)

C       G(T9,N2288,FULL)

C       G(T9,N2289,FULL)

C       G(T9,N2290,FULL)

C       G(T9,N2291,FULL)

C       G(T9,N2292,FULL)

C       G(T9,N2293,FULL)

C       G(T9,N2294,FULL)

C       G(T9,N2295,FULL)

C       G(T9,N2296,FULL)

C       G(T9,N2311,FULL)
        CALL xC01234_(S12,MHH2,S34,XMHP2,XMHP2,XMHP2,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2

        PRE = -((QF(3)*PI**(-2)*PZ12*(XCW+XSW)*(XCW-XSW)*(4D0*ALPHA*
     &  CB**3*MHH2*PI*SA-4D0*ALPHA*MA02*PI*SAB+8D0*ALPHA*CB*CBA*
     &  MHP2*PI*SB+4D0*ALPHA*CA*MHH2*PI*SB**3-4D0*LAM5*SAB*XMW2*
     &  XSW2))/(32D0*CB*S34*SB*XCW2*XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)-(C2(0,0)*K(1)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)-(C2(0,0)*K(1)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*C2(0,0)*QF(1)*PRE
        F(1,1,1) = F(1,1,1)+2D0*C2(0,0)*QF(1)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(5,-1,1) = F(5,-1,1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-2D0*C2(1,2)*QF(1)*PRE
        F(5,1,1) = F(5,1,1)-2D0*C2(1,2)*QF(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(6,-1,1) = F(6,-1,1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-2D0*C2(1,2)*QF(1)*PRE
        F(6,1,1) = F(6,1,1)-2D0*C2(1,2)*QF(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(7,-1,1) = F(7,-1,1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-2D0*C2(1,2)*QF(1)*PRE
        F(7,1,1) = F(7,1,1)-2D0*C2(1,2)*QF(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(8,-1,1) = F(8,-1,1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-2D0*C2(1,2)*QF(1)*PRE
        F(8,1,1) = F(8,1,1)-2D0*C2(1,2)*QF(1)*PRE

C       G(T9,N2312,FULL)
        CALL xC01234_(S12,MHH2,S34,XMHP2,XMHP2,XMHP2,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2

        PRE = -((QF(3)*PI**(-2)*PZ12*(XCW+XSW)*(XCW-XSW)*(4D0*ALPHA*
     &  CB**3*MHH2*PI*SA-4D0*ALPHA*MA02*PI*SAB+8D0*ALPHA*CB*CBA*
     &  MHP2*PI*SB+4D0*ALPHA*CA*MHH2*PI*SB**3-4D0*LAM5*SAB*XMW2*
     &  XSW2))/(32D0*CB*S34*SB*XCW2*XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)-(C2(0,0)*K(1)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)-(C2(0,0)*K(1)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*C2(0,0)*QF(1)*PRE
        F(1,1,1) = F(1,1,1)+2D0*C2(0,0)*QF(1)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(5,-1,1) = F(5,-1,1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-2D0*C2(1,2)*QF(1)*PRE
        F(5,1,1) = F(5,1,1)-2D0*C2(1,2)*QF(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(6,-1,1) = F(6,-1,1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-2D0*C2(1,2)*QF(1)*PRE
        F(6,1,1) = F(6,1,1)-2D0*C2(1,2)*QF(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(7,-1,1) = F(7,-1,1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-2D0*C2(1,2)*QF(1)*PRE
        F(7,1,1) = F(7,1,1)-2D0*C2(1,2)*QF(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(8,-1,1) = F(8,-1,1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-2D0*C2(1,2)*QF(1)*PRE
        F(8,1,1) = F(8,1,1)-2D0*C2(1,2)*QF(1)*PRE

C       G(T9,N2313,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2

        PRE = (QF(3)*ALPHA*CBA*PZ12*XMW)/(16D0*PI*S34*XSW)

        F(1,-1,-1) = F(1,-1,-1)-(C2(0,0)*K(1)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)-(C2(0,0)*K(1)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*C2(0,0)*QF(1)*PRE
        F(1,1,1) = F(1,1,1)+2D0*C2(0,0)*QF(1)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(5,-1,1) = F(5,-1,1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-2D0*C2(1,2)*QF(1)*PRE
        F(5,1,1) = F(5,1,1)-2D0*C2(1,2)*QF(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(6,-1,1) = F(6,-1,1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-2D0*C2(1,2)*QF(1)*PRE
        F(6,1,1) = F(6,1,1)-2D0*C2(1,2)*QF(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(7,-1,1) = F(7,-1,1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-2D0*C2(1,2)*QF(1)*PRE
        F(7,1,1) = F(7,1,1)-2D0*C2(1,2)*QF(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(8,-1,1) = F(8,-1,1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-2D0*C2(1,2)*QF(1)*PRE
        F(8,1,1) = F(8,1,1)-2D0*C2(1,2)*QF(1)*PRE

C       G(T9,N2314,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2

        PRE = (QF(3)*ALPHA*CBA*PZ12*XMW)/(16D0*PI*S34*XSW)

        F(1,-1,-1) = F(1,-1,-1)-(C2(0,0)*K(1)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)-(C2(0,0)*K(1)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*C2(0,0)*QF(1)*PRE
        F(1,1,1) = F(1,1,1)+2D0*C2(0,0)*QF(1)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(5,-1,1) = F(5,-1,1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-2D0*C2(1,2)*QF(1)*PRE
        F(5,1,1) = F(5,1,1)-2D0*C2(1,2)*QF(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(6,-1,1) = F(6,-1,1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-2D0*C2(1,2)*QF(1)*PRE
        F(6,1,1) = F(6,1,1)-2D0*C2(1,2)*QF(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(7,-1,1) = F(7,-1,1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-2D0*C2(1,2)*QF(1)*PRE
        F(7,1,1) = F(7,1,1)-2D0*C2(1,2)*QF(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(8,-1,1) = F(8,-1,1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-2D0*C2(1,2)*QF(1)*PRE
        F(8,1,1) = F(8,1,1)-2D0*C2(1,2)*QF(1)*PRE

C       G(T9,N2315,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2

        PRE = (QF(3)*ALPHA*CBA*PZ12*XMW)/(16D0*PI*S34*XSW)

        F(1,-1,-1) = F(1,-1,-1)-(C2(0,0)*K(1)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)-(C2(0,0)*K(1)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*C2(0,0)*QF(1)*PRE
        F(1,1,1) = F(1,1,1)+2D0*C2(0,0)*QF(1)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(5,-1,1) = F(5,-1,1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-2D0*C2(1,2)*QF(1)*PRE
        F(5,1,1) = F(5,1,1)-2D0*C2(1,2)*QF(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(6,-1,1) = F(6,-1,1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-2D0*C2(1,2)*QF(1)*PRE
        F(6,1,1) = F(6,1,1)-2D0*C2(1,2)*QF(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(7,-1,1) = F(7,-1,1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-2D0*C2(1,2)*QF(1)*PRE
        F(7,1,1) = F(7,1,1)-2D0*C2(1,2)*QF(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(8,-1,1) = F(8,-1,1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-2D0*C2(1,2)*QF(1)*PRE
        F(8,1,1) = F(8,1,1)-2D0*C2(1,2)*QF(1)*PRE

C       G(T9,N2316,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2

        PRE = (QF(3)*ALPHA*CBA*PZ12*XMW)/(16D0*PI*S34*XSW)

        F(1,-1,-1) = F(1,-1,-1)-(C2(0,0)*K(1)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)-(C2(0,0)*K(1)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*C2(0,0)*QF(1)*PRE
        F(1,1,1) = F(1,1,1)+2D0*C2(0,0)*QF(1)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(5,-1,1) = F(5,-1,1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-2D0*C2(1,2)*QF(1)*PRE
        F(5,1,1) = F(5,1,1)-2D0*C2(1,2)*QF(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(6,-1,1) = F(6,-1,1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-2D0*C2(1,2)*QF(1)*PRE
        F(6,1,1) = F(6,1,1)-2D0*C2(1,2)*QF(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(7,-1,1) = F(7,-1,1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-2D0*C2(1,2)*QF(1)*PRE
        F(7,1,1) = F(7,1,1)-2D0*C2(1,2)*QF(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(8,-1,1) = F(8,-1,1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-2D0*C2(1,2)*QF(1)*PRE
        F(8,1,1) = F(8,1,1)-2D0*C2(1,2)*QF(1)*PRE

C       G(T9,N2331,FULL)
        CALL xC01234_(S12,MHH2,S34,XMHP2,XMHP2,XMHP2,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2

        PRE = (PI**(-2)*PZ12*PZ34*XCW2**(-2)*(XCW+XSW)**2*(XCW-
     &  XSW)**2*(4D0*ALPHA*CB**3*MHH2*PI*SA-4D0*ALPHA*MA02*PI*SAB+
     &  8D0*ALPHA*CB*CBA*MHP2*PI*SB+4D0*ALPHA*CA*MHH2*PI*SB**3-4D0*
     &  LAM5*SAB*XMW2*XSW2))/(128D0*CB*SB*XMW*XSW)

        F(1,-1,-1) = F(1,-1,-1)-C2(0,0)*K(1)*K(2)*PRE*XSW2**(-2)
        F(1,-1,1) = F(1,-1,1)-(2D0*C2(0,0)*K(1)*QF(3)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*C2(0,0)*K(2)*QF(1)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+4D0*C2(0,0)*QF(1)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(5,-1,1) = F(5,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(6,-1,1) = F(6,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(7,-1,1) = F(7,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(8,-1,1) = F(8,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE

C       G(T9,N2332,FULL)
        CALL xC01234_(S12,MHH2,S34,XMHP2,XMHP2,XMHP2,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2

        PRE = (PI**(-2)*PZ12*PZ34*XCW2**(-2)*(XCW+XSW)**2*(XCW-
     &  XSW)**2*(4D0*ALPHA*CB**3*MHH2*PI*SA-4D0*ALPHA*MA02*PI*SAB+
     &  8D0*ALPHA*CB*CBA*MHP2*PI*SB+4D0*ALPHA*CA*MHH2*PI*SB**3-4D0*
     &  LAM5*SAB*XMW2*XSW2))/(128D0*CB*SB*XMW*XSW)

        F(1,-1,-1) = F(1,-1,-1)-C2(0,0)*K(1)*K(2)*PRE*XSW2**(-2)
        F(1,-1,1) = F(1,-1,1)-(2D0*C2(0,0)*K(1)*QF(3)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*C2(0,0)*K(2)*QF(1)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+4D0*C2(0,0)*QF(1)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(5,-1,1) = F(5,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(6,-1,1) = F(6,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(7,-1,1) = F(7,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(8,-1,1) = F(8,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE

C       G(T9,N2333,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2

        PRE = -((ALPHA*CBA*PZ12*PZ34*XMW)/(32D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)-C2(0,0)*K(1)*K(2)*PRE*XSW2**(-2)
        F(1,-1,1) = F(1,-1,1)-(2D0*C2(0,0)*K(1)*QF(3)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*C2(0,0)*K(2)*QF(1)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+4D0*C2(0,0)*QF(1)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(5,-1,1) = F(5,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(6,-1,1) = F(6,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(7,-1,1) = F(7,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(8,-1,1) = F(8,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE

C       G(T9,N2334,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2

        PRE = -((ALPHA*CBA*PZ12*PZ34*XMW)/(32D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)-C2(0,0)*K(1)*K(2)*PRE*XSW2**(-2)
        F(1,-1,1) = F(1,-1,1)-(2D0*C2(0,0)*K(1)*QF(3)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*C2(0,0)*K(2)*QF(1)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+4D0*C2(0,0)*QF(1)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(5,-1,1) = F(5,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(6,-1,1) = F(6,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(7,-1,1) = F(7,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(8,-1,1) = F(8,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE

C       G(T9,N2335,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2

        PRE = -((ALPHA*CBA*PZ12*PZ34*XMW)/(32D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)-C2(0,0)*K(1)*K(2)*PRE*XSW2**(-2)
        F(1,-1,1) = F(1,-1,1)-(2D0*C2(0,0)*K(1)*QF(3)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*C2(0,0)*K(2)*QF(1)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+4D0*C2(0,0)*QF(1)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(5,-1,1) = F(5,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(6,-1,1) = F(6,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(7,-1,1) = F(7,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(8,-1,1) = F(8,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE

C       G(T9,N2336,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2

        PRE = -((ALPHA*CBA*PZ12*PZ34*XMW)/(32D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)-C2(0,0)*K(1)*K(2)*PRE*XSW2**(-2)
        F(1,-1,1) = F(1,-1,1)-(2D0*C2(0,0)*K(1)*QF(3)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*C2(0,0)*K(2)*QF(1)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+4D0*C2(0,0)*QF(1)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(5,-1,1) = F(5,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(6,-1,1) = F(6,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(7,-1,1) = F(7,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(8,-1,1) = F(8,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE

C       G(T9,N2337,FULL)

C       G(T9,N2338,FULL)

C       G(T9,N2339,FULL)

C       G(T9,N2340,FULL)

C       G(T9,N2341,FULL)

C       G(T9,N2342,FULL)

C       G(T9,N2343,FULL)

C       G(T9,N2344,FULL)

C       G(T9,N2345,FULL)

C       G(T9,N2346,FULL)

C       G(T9,N2347,FULL)

C       G(T9,N2348,FULL)

C       G(T9,N2349,FULL)

C       G(T9,N2350,FULL)

C       G(T9,N2351,FULL)

C       G(T9,N2352,FULL)

C       G(T9,N2353,FULL)

C       G(T9,N2354,FULL)

C       G(T9,N2355,FULL)

C       G(T9,N2356,FULL)

C       G(T9,N2357,FULL)

C       G(T9,N2358,FULL)

C       G(T9,N2359,FULL)

C       G(T9,N2360,FULL)

C       G(T9,N2361,FULL)

C       G(T9,N2362,FULL)

C       G(T9,N2363,FULL)

C       G(T9,N2364,FULL)

C       G(T9,N2365,FULL)

C       G(T9,N2366,FULL)

C       G(T9,N2367,FULL)

C       G(T9,N2368,FULL)

C       G(T9,N2369,FULL)

C       G(T9,N2370,FULL)

C       G(T9,N2371,FULL)

C       G(T9,N2372,FULL)

C       G(T9,N2373,FULL)

C       G(T9,N2374,FULL)

C       G(T9,N2375,FULL)

C       G(T9,N2376,FULL)

C       G(T9,N2377,FULL)

C       G(T9,N2378,FULL)

C       G(T9,N2379,FULL)

C       G(T9,N2380,FULL)

C       G(T9,N2381,FULL)

C       G(T9,N2382,FULL)

C       G(T9,N2383,FULL)

C       G(T9,N2384,FULL)

C       G(T9,N2385,FULL)

C       G(T9,N2386,FULL)

C       G(T9,N2387,FULL)

C       G(T9,N2388,FULL)

C       G(T9,N2389,FULL)

C       G(T9,N2390,FULL)

C       G(T9,N2391,FULL)

C       G(T9,N2392,FULL)

C       G(T9,N2393,FULL)

C       G(T9,N2394,FULL)

C       G(T9,N2395,FULL)

C       G(T9,N2396,FULL)

C       G(T9,N2397,FULL)

C       G(T9,N2398,FULL)

C       G(T9,N2399,FULL)

C       G(T9,N2400,FULL)

C       G(T9,N2401,FULL)

C       G(T9,N2402,FULL)

C       G(T9,N2403,FULL)

C       G(T9,N2404,FULL)

C       G(T9,N2405,FULL)

C       G(T9,N2406,FULL)

C       G(T9,N2407,FULL)

C       G(T9,N2408,FULL)

C       G(T9,N2409,FULL)

C       G(T9,N2410,FULL)

C       G(T9,N2411,FULL)

C       G(T9,N2412,FULL)

C       G(T9,N2413,FULL)

C       G(T9,N2414,FULL)

C       G(T9,N2415,FULL)

C       G(T9,N2416,FULL)

C       G(T9,N2417,FULL)

C       G(T9,N2418,FULL)

C       G(T9,N2419,FULL)

C       G(T9,N2420,FULL)

C       G(T9,N2421,FULL)

C       G(T9,N2422,FULL)

C       G(T9,N2423,FULL)

C       G(T9,N2424,FULL)

C       G(T9,N2425,FULL)

C       G(T9,N2426,FULL)

C       G(T9,N2427,FULL)

C       G(T9,N2428,FULL)

C       G(T9,N2429,FULL)

C       G(T9,N2430,FULL)

C       G(T9,N2431,FULL)

C       G(T9,N2432,FULL)

C       G(T9,N2433,FULL)

C       G(T9,N2434,FULL)

C       G(T9,N2435,FULL)

C       G(T9,N2436,FULL)

C       G(T9,N2437,FULL)

C       G(T9,N2438,FULL)

C       G(T9,N2439,FULL)

C       G(T9,N2440,FULL)

C       G(T9,N2441,FULL)

C       G(T9,N2442,FULL)

C       G(T9,N2443,FULL)

C       G(T9,N2444,FULL)

C       G(T9,N2445,FULL)

C       G(T9,N2446,FULL)

C       G(T9,N2447,FULL)

C       G(T9,N2448,FULL)

C       G(T9,N2449,FULL)

C       G(T9,N2450,FULL)

C       G(T9,N2451,FULL)

C       G(T9,N2452,FULL)

C       G(T9,N2453,FULL)

C       G(T9,N2454,FULL)

C       G(T9,N2455,FULL)

C       G(T9,N2456,FULL)

C       G(T9,N2457,FULL)

C       G(T9,N2458,FULL)

C       G(T9,N2459,FULL)

C       G(T9,N2460,FULL)

C       G(T9,N2461,FULL)

C       G(T9,N2462,FULL)

C       G(T9,N2463,FULL)

C       G(T9,N2464,FULL)

C       G(T9,N2465,FULL)

C       G(T9,N2466,FULL)

C       G(T9,N2467,FULL)

C       G(T9,N2468,FULL)

C       G(T9,N2469,FULL)

C       G(T9,N2470,FULL)

C       G(T9,N2471,FULL)

C       G(T9,N2472,FULL)

C       G(T9,N2473,FULL)

C       G(T9,N2474,FULL)

C       G(T9,N2475,FULL)

C       G(T9,N2476,FULL)

C       G(T9,N2477,FULL)

C       G(T9,N2478,FULL)

C       G(T9,N2479,FULL)

C       G(T9,N2480,FULL)

C       G(T9,N2481,FULL)

C       G(T9,N2482,FULL)

C       G(T9,N2483,FULL)

C       G(T9,N2484,FULL)

C       G(T9,N2485,FULL)

C       G(T9,N2486,FULL)

C       G(T9,N2487,FULL)

C       G(T9,N2488,FULL)

C       G(T9,N2489,FULL)

C       G(T9,N2490,FULL)

C       G(T9,N2491,FULL)

C       G(T9,N2492,FULL)

C       G(T9,N2493,FULL)

C       G(T9,N2494,FULL)

C       G(T9,N2495,FULL)

C       G(T9,N2496,FULL)

C       G(T9,N2497,FULL)

C       G(T9,N2498,FULL)

C       G(T9,N2499,FULL)

C       G(T9,N2500,FULL)

C       G(T9,N2501,FULL)

C       G(T9,N2502,FULL)

C       G(T9,N2503,FULL)

C       G(T9,N2504,FULL)

C       G(T9,N2505,FULL)

C       G(T9,N2506,FULL)

C       G(T9,N2507,FULL)

C       G(T9,N2508,FULL)

C       G(T9,N2509,FULL)

C       G(T9,N2510,FULL)

C       G(T9,N2511,FULL)

C       G(T9,N2512,FULL)

C       G(T9,N2513,FULL)

C       G(T9,N2514,FULL)

C       G(T9,N2515,FULL)

C       G(T9,N2516,FULL)

C       G(T9,N2517,FULL)

C       G(T9,N2518,FULL)

C       G(T9,N2519,FULL)

C       G(T9,N2520,FULL)

C       G(T9,N2521,FULL)

C       G(T9,N2522,FULL)

C       G(T9,N2523,FULL)

C       G(T9,N2524,FULL)

C       G(T9,N2525,FULL)

C       G(T9,N2526,FULL)

C       G(T9,N2527,FULL)

C       G(T9,N2528,FULL)

C       G(T9,N2529,FULL)

C       G(T9,N2530,FULL)

C       G(T9,N2531,FULL)

C       G(T9,N2532,FULL)

C       G(T9,N2533,FULL)

C       G(T9,N2534,FULL)

C       G(T9,N2535,FULL)

C       G(T9,N2536,FULL)

C       G(T9,N2537,FULL)

C       G(T9,N2538,FULL)

C       G(T9,N2539,FULL)

C       G(T9,N2540,FULL)

C       G(T9,N2541,FULL)

C       G(T9,N2542,FULL)

C       G(T9,N2543,FULL)

C       G(T9,N2544,FULL)

C       G(T9,N2545,FULL)

C       G(T9,N2546,FULL)

C       G(T9,N2547,FULL)

C       G(T9,N2548,FULL)

C       G(T9,N2549,FULL)

C       G(T9,N2550,FULL)

C       G(T9,N2551,FULL)

C       G(T9,N2552,FULL)

C       G(T9,N2553,FULL)

C       G(T9,N2554,FULL)

C       G(T9,N2555,FULL)

C       G(T9,N2556,FULL)

C       G(T9,N2557,FULL)

C       G(T9,N2558,FULL)

C       G(T9,N2559,FULL)

C       G(T9,N2560,FULL)

C       G(T9,N2561,FULL)

C       G(T9,N2562,FULL)

C       G(T9,N2563,FULL)

C       G(T9,N2564,FULL)

C       G(T9,N2565,FULL)

C       G(T9,N2566,FULL)

C       G(T9,N2567,FULL)

C       G(T9,N2568,FULL)

C       G(T9,N2569,FULL)

C       G(T9,N2570,FULL)

C       G(T9,N2571,FULL)

C       G(T9,N2572,FULL)

C       G(T9,N2573,FULL)

C       G(T9,N2574,FULL)

C       G(T9,N2575,FULL)

C       G(T9,N2576,FULL)

C       G(T9,N2577,FULL)

C       G(T9,N2578,FULL)

C       G(T9,N2579,FULL)

C       G(T9,N2580,FULL)

C       G(T9,N2581,FULL)

C       G(T9,N2582,FULL)

C       G(T9,N2583,FULL)

C       G(T9,N2584,FULL)

C       G(T9,N2585,FULL)

C       G(T9,N2586,FULL)

C       G(T9,N2587,FULL)

C       G(T9,N2588,FULL)

C       G(T9,N2589,FULL)

C       G(T9,N2590,FULL)

C       G(T9,N2591,FULL)

C       G(T9,N2592,FULL)

C       G(T9,N2593,FULL)

C       G(T9,N2594,FULL)

C       G(T9,N2595,FULL)

C       G(T9,N2596,FULL)

C       G(T9,N2597,FULL)

C       G(T9,N2598,FULL)

C       G(T9,N2599,FULL)

C       G(T9,N2600,FULL)

C       G(T9,N2601,FULL)

C       G(T9,N2602,FULL)

C       G(T9,N2603,FULL)

C       G(T9,N2604,FULL)

C       G(T9,N2605,FULL)

C       G(T9,N2606,FULL)

C       G(T9,N2607,FULL)

C       G(T9,N2608,FULL)

C       G(T9,N2609,FULL)

C       G(T9,N2610,FULL)

C       G(T9,N2611,FULL)

C       G(T9,N2612,FULL)

C       G(T9,N2613,FULL)

C       G(T9,N2614,FULL)

C       G(T9,N2615,FULL)

C       G(T9,N2616,FULL)

C       G(T9,N2617,FULL)

C       G(T9,N2618,FULL)

C       G(T9,N2619,FULL)

C       G(T9,N2620,FULL)

C       G(T9,N2621,FULL)

C       G(T9,N2622,FULL)

C       G(T9,N2623,FULL)

C       G(T9,N2624,FULL)

C       G(T9,N2625,FULL)

C       G(T9,N2626,FULL)

C       G(T9,N2627,FULL)

C       G(T9,N2628,FULL)

C       G(T9,N2629,FULL)

C       G(T9,N2630,FULL)

C       G(T9,N2631,FULL)

C       G(T9,N2632,FULL)

C       G(T9,N2633,FULL)

C       G(T9,N2634,FULL)

C       G(T9,N2635,FULL)

C       G(T9,N2636,FULL)

C       G(T9,N2637,FULL)

C       G(T9,N2638,FULL)

C       G(T9,N2639,FULL)

C       G(T9,N2640,FULL)

C       G(T9,N2641,FULL)

C       G(T9,N2642,FULL)

C       G(T9,N2643,FULL)

C       G(T9,N2644,FULL)

C       G(T9,N2645,FULL)

C       G(T9,N2646,FULL)

C       G(T9,N2647,FULL)

C       G(T9,N2648,FULL)

C       G(T9,N2649,FULL)

C       G(T9,N2650,FULL)

C       G(T9,N2651,FULL)

C       G(T9,N2652,FULL)

C       G(T9,N2653,FULL)

C       G(T9,N2654,FULL)

C       G(T9,N2655,FULL)

C       G(T9,N2656,FULL)

C       G(T9,N2657,FULL)

C       G(T9,N2658,FULL)

C       G(T9,N2659,FULL)

C       G(T9,N2660,FULL)

C       G(T9,N2661,FULL)

C       G(T9,N2662,FULL)

C       G(T9,N2663,FULL)

C       G(T9,N2664,FULL)

C       G(T9,N2665,FULL)

C       G(T9,N2666,FULL)

C       G(T9,N2667,FULL)

C       G(T9,N2668,FULL)

C       G(T9,N2669,FULL)

C       G(T9,N2670,FULL)

C       G(T9,N2671,FULL)

C       G(T9,N2672,FULL)

C       G(T9,N2673,FULL)

C       G(T9,N2674,FULL)

C       G(T9,N2675,FULL)

C       G(T9,N2676,FULL)

C       G(T9,N2677,FULL)

C       G(T9,N2678,FULL)

C       G(T9,N2679,FULL)

C       G(T9,N2680,FULL)

C       G(T9,N2681,FULL)

C       G(T9,N2682,FULL)

C       G(T9,N2683,FULL)

C       G(T9,N2684,FULL)

C       G(T9,N2685,FULL)

C       G(T9,N2686,FULL)

C       G(T9,N2687,FULL)

C       G(T9,N2688,FULL)

C       G(T9,N2689,FULL)

C       G(T9,N2690,FULL)

C       G(T9,N2691,FULL)

C       G(T9,N2692,FULL)

C       G(T9,N2693,FULL)

C       G(T9,N2694,FULL)

C       G(T9,N2695,FULL)

C       G(T9,N2696,FULL)

C       G(T9,N2697,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)

        PRE = (QF(1)*QF(3)*ALPHA*CBA*MHH2)/(2D0*PI*S12*S34*XMW*XSW)

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(1,-1,1) = F(1,-1,1)+C2(0,0)*PRE
        F(1,1,-1) = F(1,1,-1)+C2(0,0)*PRE
        F(1,1,1) = F(1,1,1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)-C2(1,2)*PRE
        F(5,-1,1) = F(5,-1,1)-C2(1,2)*PRE
        F(5,1,-1) = F(5,1,-1)-C2(1,2)*PRE
        F(5,1,1) = F(5,1,1)-C2(1,2)*PRE
        F(6,-1,-1) = F(6,-1,-1)-C2(1,2)*PRE
        F(6,-1,1) = F(6,-1,1)-C2(1,2)*PRE
        F(6,1,-1) = F(6,1,-1)-C2(1,2)*PRE
        F(6,1,1) = F(6,1,1)-C2(1,2)*PRE
        F(7,-1,-1) = F(7,-1,-1)-C2(1,2)*PRE
        F(7,-1,1) = F(7,-1,1)-C2(1,2)*PRE
        F(7,1,-1) = F(7,1,-1)-C2(1,2)*PRE
        F(7,1,1) = F(7,1,1)-C2(1,2)*PRE
        F(8,-1,-1) = F(8,-1,-1)-C2(1,2)*PRE
        F(8,-1,1) = F(8,-1,1)-C2(1,2)*PRE
        F(8,1,-1) = F(8,1,-1)-C2(1,2)*PRE
        F(8,1,1) = F(8,1,1)-C2(1,2)*PRE

C       G(T9,N2698,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,0,0)

        PRE = -((QF(1)*QF(3)*ALPHA*C0*CBA*MHH2*XMW)/(8D0*PI*S12*S34*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE
        F(1,-1,1) = F(1,-1,1)+PRE
        F(1,1,-1) = F(1,1,-1)+PRE
        F(1,1,1) = F(1,1,1)+PRE

C       G(T9,N2699,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 2D0*C1(2)+C2(1,2)

        PRE = (QF(1)*QF(3)*ALPHA*CBA*XMW)/(4D0*PI*S12*S34*XSW)

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(1,-1,1) = F(1,-1,1)+C2(0,0)*PRE
        F(1,1,-1) = F(1,1,-1)+C2(0,0)*PRE
        F(1,1,1) = F(1,1,1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)-K(1)*PRE
        F(5,-1,1) = F(5,-1,1)-K(1)*PRE
        F(5,1,-1) = F(5,1,-1)-K(1)*PRE
        F(5,1,1) = F(5,1,1)-K(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)-K(1)*PRE
        F(6,-1,1) = F(6,-1,1)-K(1)*PRE
        F(6,1,-1) = F(6,1,-1)-K(1)*PRE
        F(6,1,1) = F(6,1,1)-K(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)-K(1)*PRE
        F(7,-1,1) = F(7,-1,1)-K(1)*PRE
        F(7,1,-1) = F(7,1,-1)-K(1)*PRE
        F(7,1,1) = F(7,1,1)-K(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)-K(1)*PRE
        F(8,-1,1) = F(8,-1,1)-K(1)*PRE
        F(8,1,-1) = F(8,1,-1)-K(1)*PRE
        F(8,1,1) = F(8,1,1)-K(1)*PRE

C       G(T9,N2700,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = S23+S24+T12
        K(2) = 4D0*C1(1)+2D0*C1(2)-C2(1,2)+4D0*C0
        K(3) = S13+S14+S23+S24
        K(4) = 2D0*S12+S13+S14+S23+S24
        K(5) = S13+S14+S23+S24+2D0*S34
        K(6) = -((2D0*C2(2,2))/S12)-(2D0*C2(1,1))/S34+1/(S12*S34)-
     &  (6D0*C2(0,0))/(S12*S34)+(2D0*C2(1,2)*(S13+S14+S23+S24))/
     &  (S12*S34)-(2D0*C1(1)*(2D0*S12+S13+S14+S23+S24))/(S12*S34)+
     &  (2D0*C1(2)*(S13+S14+S23+S24+2D0*S34))/(S12*S34)-(2D0*C0*
     &  (S23+S24+T12))/(S12*S34)

        PRE = (QF(1)*QF(3)*ALPHA*CBA*XMW)/(16D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+K(6)*PRE
        F(1,-1,1) = F(1,-1,1)+K(6)*PRE
        F(1,1,-1) = F(1,1,-1)+K(6)*PRE
        F(1,1,1) = F(1,1,1)+K(6)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(2)*PRE)/(S12*S34)
        F(5,-1,1) = F(5,-1,1)+(2D0*K(2)*PRE)/(S12*S34)
        F(5,1,-1) = F(5,1,-1)+(2D0*K(2)*PRE)/(S12*S34)
        F(5,1,1) = F(5,1,1)+(2D0*K(2)*PRE)/(S12*S34)
        F(6,-1,-1) = F(6,-1,-1)+(2D0*K(2)*PRE)/(S12*S34)
        F(6,-1,1) = F(6,-1,1)+(2D0*K(2)*PRE)/(S12*S34)
        F(6,1,-1) = F(6,1,-1)+(2D0*K(2)*PRE)/(S12*S34)
        F(6,1,1) = F(6,1,1)+(2D0*K(2)*PRE)/(S12*S34)
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(2)*PRE)/(S12*S34)
        F(7,-1,1) = F(7,-1,1)+(2D0*K(2)*PRE)/(S12*S34)
        F(7,1,-1) = F(7,1,-1)+(2D0*K(2)*PRE)/(S12*S34)
        F(7,1,1) = F(7,1,1)+(2D0*K(2)*PRE)/(S12*S34)
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(2)*PRE)/(S12*S34)
        F(8,-1,1) = F(8,-1,1)+(2D0*K(2)*PRE)/(S12*S34)
        F(8,1,-1) = F(8,1,-1)+(2D0*K(2)*PRE)/(S12*S34)
        F(8,1,1) = F(8,1,1)+(2D0*K(2)*PRE)/(S12*S34)

C       G(T9,N2701,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)

        PRE = (QF(1)*QF(3)*ALPHA*CBA*MHH2)/(2D0*PI*S12*S34*XMW*XSW)

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(1,-1,1) = F(1,-1,1)+C2(0,0)*PRE
        F(1,1,-1) = F(1,1,-1)+C2(0,0)*PRE
        F(1,1,1) = F(1,1,1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)-C2(1,2)*PRE
        F(5,-1,1) = F(5,-1,1)-C2(1,2)*PRE
        F(5,1,-1) = F(5,1,-1)-C2(1,2)*PRE
        F(5,1,1) = F(5,1,1)-C2(1,2)*PRE
        F(6,-1,-1) = F(6,-1,-1)-C2(1,2)*PRE
        F(6,-1,1) = F(6,-1,1)-C2(1,2)*PRE
        F(6,1,-1) = F(6,1,-1)-C2(1,2)*PRE
        F(6,1,1) = F(6,1,1)-C2(1,2)*PRE
        F(7,-1,-1) = F(7,-1,-1)-C2(1,2)*PRE
        F(7,-1,1) = F(7,-1,1)-C2(1,2)*PRE
        F(7,1,-1) = F(7,1,-1)-C2(1,2)*PRE
        F(7,1,1) = F(7,1,1)-C2(1,2)*PRE
        F(8,-1,-1) = F(8,-1,-1)-C2(1,2)*PRE
        F(8,-1,1) = F(8,-1,1)-C2(1,2)*PRE
        F(8,1,-1) = F(8,1,-1)-C2(1,2)*PRE
        F(8,1,1) = F(8,1,1)-C2(1,2)*PRE

C       G(T9,N2702,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,0,0)

        PRE = -((QF(1)*QF(3)*ALPHA*C0*CBA*MHH2*XMW)/(8D0*PI*S12*S34*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE
        F(1,-1,1) = F(1,-1,1)+PRE
        F(1,1,-1) = F(1,1,-1)+PRE
        F(1,1,1) = F(1,1,1)+PRE

C       G(T9,N2703,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 2D0*C1(2)+C2(1,2)

        PRE = (QF(1)*QF(3)*ALPHA*CBA*XMW)/(4D0*PI*S12*S34*XSW)

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(1,-1,1) = F(1,-1,1)+C2(0,0)*PRE
        F(1,1,-1) = F(1,1,-1)+C2(0,0)*PRE
        F(1,1,1) = F(1,1,1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)-K(1)*PRE
        F(5,-1,1) = F(5,-1,1)-K(1)*PRE
        F(5,1,-1) = F(5,1,-1)-K(1)*PRE
        F(5,1,1) = F(5,1,1)-K(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)-K(1)*PRE
        F(6,-1,1) = F(6,-1,1)-K(1)*PRE
        F(6,1,-1) = F(6,1,-1)-K(1)*PRE
        F(6,1,1) = F(6,1,1)-K(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)-K(1)*PRE
        F(7,-1,1) = F(7,-1,1)-K(1)*PRE
        F(7,1,-1) = F(7,1,-1)-K(1)*PRE
        F(7,1,1) = F(7,1,1)-K(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)-K(1)*PRE
        F(8,-1,1) = F(8,-1,1)-K(1)*PRE
        F(8,1,-1) = F(8,1,-1)-K(1)*PRE
        F(8,1,1) = F(8,1,1)-K(1)*PRE

C       G(T9,N2704,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = S23+S24+T12
        K(2) = 4D0*C1(1)+2D0*C1(2)-C2(1,2)+4D0*C0
        K(3) = S13+S14+S23+S24
        K(4) = 2D0*S12+S13+S14+S23+S24
        K(5) = S13+S14+S23+S24+2D0*S34
        K(6) = -((2D0*C2(2,2))/S12)-(2D0*C2(1,1))/S34+1/(S12*S34)-
     &  (6D0*C2(0,0))/(S12*S34)+(2D0*C2(1,2)*(S13+S14+S23+S24))/
     &  (S12*S34)-(2D0*C1(1)*(2D0*S12+S13+S14+S23+S24))/(S12*S34)+
     &  (2D0*C1(2)*(S13+S14+S23+S24+2D0*S34))/(S12*S34)-(2D0*C0*
     &  (S23+S24+T12))/(S12*S34)

        PRE = (QF(1)*QF(3)*ALPHA*CBA*XMW)/(16D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+K(6)*PRE
        F(1,-1,1) = F(1,-1,1)+K(6)*PRE
        F(1,1,-1) = F(1,1,-1)+K(6)*PRE
        F(1,1,1) = F(1,1,1)+K(6)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(2)*PRE)/(S12*S34)
        F(5,-1,1) = F(5,-1,1)+(2D0*K(2)*PRE)/(S12*S34)
        F(5,1,-1) = F(5,1,-1)+(2D0*K(2)*PRE)/(S12*S34)
        F(5,1,1) = F(5,1,1)+(2D0*K(2)*PRE)/(S12*S34)
        F(6,-1,-1) = F(6,-1,-1)+(2D0*K(2)*PRE)/(S12*S34)
        F(6,-1,1) = F(6,-1,1)+(2D0*K(2)*PRE)/(S12*S34)
        F(6,1,-1) = F(6,1,-1)+(2D0*K(2)*PRE)/(S12*S34)
        F(6,1,1) = F(6,1,1)+(2D0*K(2)*PRE)/(S12*S34)
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(2)*PRE)/(S12*S34)
        F(7,-1,1) = F(7,-1,1)+(2D0*K(2)*PRE)/(S12*S34)
        F(7,1,-1) = F(7,1,-1)+(2D0*K(2)*PRE)/(S12*S34)
        F(7,1,1) = F(7,1,1)+(2D0*K(2)*PRE)/(S12*S34)
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(2)*PRE)/(S12*S34)
        F(8,-1,1) = F(8,-1,1)+(2D0*K(2)*PRE)/(S12*S34)
        F(8,1,-1) = F(8,1,-1)+(2D0*K(2)*PRE)/(S12*S34)
        F(8,1,1) = F(8,1,1)+(2D0*K(2)*PRE)/(S12*S34)

C       G(T9,N2705,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 2D0*C1(1)+C2(1,2)

        PRE = (QF(1)*QF(3)*ALPHA*CBA*XMW)/(4D0*PI*S12*S34*XSW)

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(1,-1,1) = F(1,-1,1)+C2(0,0)*PRE
        F(1,1,-1) = F(1,1,-1)+C2(0,0)*PRE
        F(1,1,1) = F(1,1,1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)-K(1)*PRE
        F(5,-1,1) = F(5,-1,1)-K(1)*PRE
        F(5,1,-1) = F(5,1,-1)-K(1)*PRE
        F(5,1,1) = F(5,1,1)-K(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)-K(1)*PRE
        F(6,-1,1) = F(6,-1,1)-K(1)*PRE
        F(6,1,-1) = F(6,1,-1)-K(1)*PRE
        F(6,1,1) = F(6,1,1)-K(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)-K(1)*PRE
        F(7,-1,1) = F(7,-1,1)-K(1)*PRE
        F(7,1,-1) = F(7,1,-1)-K(1)*PRE
        F(7,1,1) = F(7,1,1)-K(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)-K(1)*PRE
        F(8,-1,1) = F(8,-1,1)-K(1)*PRE
        F(8,1,-1) = F(8,1,-1)-K(1)*PRE
        F(8,1,1) = F(8,1,1)-K(1)*PRE

C       G(T9,N2706,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = S14+S24+T14
        K(2) = 2D0*C1(1)+4D0*C1(2)-C2(1,2)+4D0*C0
        K(3) = S13+S14+S23+S24
        K(4) = 2D0*S12+S13+S14+S23+S24
        K(5) = S13+S14+S23+S24+2D0*S34
        K(6) = -((2D0*C2(2,2))/S12)-(2D0*C2(1,1))/S34+1/(S12*S34)-
     &  (6D0*C2(0,0))/(S12*S34)+(2D0*C2(1,2)*(S13+S14+S23+S24))/
     &  (S12*S34)+(2D0*C1(1)*(2D0*S12+S13+S14+S23+S24))/(S12*S34)-
     &  (2D0*C1(2)*(S13+S14+S23+S24+2D0*S34))/(S12*S34)-(2D0*C0*
     &  (S14+S24+T14))/(S12*S34)

        PRE = (QF(1)*QF(3)*ALPHA*CBA*XMW)/(16D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+K(6)*PRE
        F(1,-1,1) = F(1,-1,1)+K(6)*PRE
        F(1,1,-1) = F(1,1,-1)+K(6)*PRE
        F(1,1,1) = F(1,1,1)+K(6)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(2)*PRE)/(S12*S34)
        F(5,-1,1) = F(5,-1,1)+(2D0*K(2)*PRE)/(S12*S34)
        F(5,1,-1) = F(5,1,-1)+(2D0*K(2)*PRE)/(S12*S34)
        F(5,1,1) = F(5,1,1)+(2D0*K(2)*PRE)/(S12*S34)
        F(6,-1,-1) = F(6,-1,-1)+(2D0*K(2)*PRE)/(S12*S34)
        F(6,-1,1) = F(6,-1,1)+(2D0*K(2)*PRE)/(S12*S34)
        F(6,1,-1) = F(6,1,-1)+(2D0*K(2)*PRE)/(S12*S34)
        F(6,1,1) = F(6,1,1)+(2D0*K(2)*PRE)/(S12*S34)
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(2)*PRE)/(S12*S34)
        F(7,-1,1) = F(7,-1,1)+(2D0*K(2)*PRE)/(S12*S34)
        F(7,1,-1) = F(7,1,-1)+(2D0*K(2)*PRE)/(S12*S34)
        F(7,1,1) = F(7,1,1)+(2D0*K(2)*PRE)/(S12*S34)
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(2)*PRE)/(S12*S34)
        F(8,-1,1) = F(8,-1,1)+(2D0*K(2)*PRE)/(S12*S34)
        F(8,1,-1) = F(8,1,-1)+(2D0*K(2)*PRE)/(S12*S34)
        F(8,1,1) = F(8,1,1)+(2D0*K(2)*PRE)/(S12*S34)

C       G(T9,N2707,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,0,0)

        PRE = -((QF(1)*QF(3)*ALPHA*C0*CBA*XMW*XMW2)/(4D0*PI*S12*S34*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE
        F(1,-1,1) = F(1,-1,1)+PRE
        F(1,1,-1) = F(1,1,-1)+PRE
        F(1,1,1) = F(1,1,1)+PRE

C       G(T9,N2708,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = -(C1(1))-C1(2)-10D0*C2(1,2)+4D0*C0
        K(2) = S13+S14+S23+S24
        K(3) = 2D0*S12-S13-S14-S23-S24
        K(4) = S13+S14+S23+S24-2D0*S34
        K(5) = -((4D0*C2(2,2))/S12)-(4D0*C2(1,1))/S34+6D0/(S12*S34)-
     &  (36D0*C2(0,0))/(S12*S34)+(4D0*C2(1,2)*(S13+S14+S23+S24))/
     &  (S12*S34)+(5D0*C0*(S13+S14+S23+S24))/(S12*S34)-(C1(1)*(2D0*
     &  S12-S13-S14-S23-S24))/(S12*S34)+(C1(2)*(S13+S14+S23+S24-2D0*
     &  S34))/(S12*S34)

        PRE = -((QF(1)*QF(3)*ALPHA*CBA*XMW)/(8D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+K(5)*PRE
        F(1,-1,1) = F(1,-1,1)+K(5)*PRE
        F(1,1,-1) = F(1,1,-1)+K(5)*PRE
        F(1,1,1) = F(1,1,1)+K(5)*PRE
        F(5,-1,-1) = F(5,-1,-1)-(2D0*K(1)*PRE)/(S12*S34)
        F(5,-1,1) = F(5,-1,1)-(2D0*K(1)*PRE)/(S12*S34)
        F(5,1,-1) = F(5,1,-1)-(2D0*K(1)*PRE)/(S12*S34)
        F(5,1,1) = F(5,1,1)-(2D0*K(1)*PRE)/(S12*S34)
        F(6,-1,-1) = F(6,-1,-1)-(2D0*K(1)*PRE)/(S12*S34)
        F(6,-1,1) = F(6,-1,1)-(2D0*K(1)*PRE)/(S12*S34)
        F(6,1,-1) = F(6,1,-1)-(2D0*K(1)*PRE)/(S12*S34)
        F(6,1,1) = F(6,1,1)-(2D0*K(1)*PRE)/(S12*S34)
        F(7,-1,-1) = F(7,-1,-1)-(2D0*K(1)*PRE)/(S12*S34)
        F(7,-1,1) = F(7,-1,1)-(2D0*K(1)*PRE)/(S12*S34)
        F(7,1,-1) = F(7,1,-1)-(2D0*K(1)*PRE)/(S12*S34)
        F(7,1,1) = F(7,1,1)-(2D0*K(1)*PRE)/(S12*S34)
        F(8,-1,-1) = F(8,-1,-1)-(2D0*K(1)*PRE)/(S12*S34)
        F(8,-1,1) = F(8,-1,1)-(2D0*K(1)*PRE)/(S12*S34)
        F(8,1,-1) = F(8,1,-1)-(2D0*K(1)*PRE)/(S12*S34)
        F(8,1,1) = F(8,1,1)-(2D0*K(1)*PRE)/(S12*S34)

C       G(T9,N2709,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 2D0*C1(1)+C2(1,2)

        PRE = (QF(1)*QF(3)*ALPHA*CBA*XMW)/(4D0*PI*S12*S34*XSW)

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(1,-1,1) = F(1,-1,1)+C2(0,0)*PRE
        F(1,1,-1) = F(1,1,-1)+C2(0,0)*PRE
        F(1,1,1) = F(1,1,1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)-K(1)*PRE
        F(5,-1,1) = F(5,-1,1)-K(1)*PRE
        F(5,1,-1) = F(5,1,-1)-K(1)*PRE
        F(5,1,1) = F(5,1,1)-K(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)-K(1)*PRE
        F(6,-1,1) = F(6,-1,1)-K(1)*PRE
        F(6,1,-1) = F(6,1,-1)-K(1)*PRE
        F(6,1,1) = F(6,1,1)-K(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)-K(1)*PRE
        F(7,-1,1) = F(7,-1,1)-K(1)*PRE
        F(7,1,-1) = F(7,1,-1)-K(1)*PRE
        F(7,1,1) = F(7,1,1)-K(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)-K(1)*PRE
        F(8,-1,1) = F(8,-1,1)-K(1)*PRE
        F(8,1,-1) = F(8,1,-1)-K(1)*PRE
        F(8,1,1) = F(8,1,1)-K(1)*PRE

C       G(T9,N2710,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = S14+S24+T14
        K(2) = 2D0*C1(1)+4D0*C1(2)-C2(1,2)+4D0*C0
        K(3) = S13+S14+S23+S24
        K(4) = 2D0*S12+S13+S14+S23+S24
        K(5) = S13+S14+S23+S24+2D0*S34
        K(6) = -((2D0*C2(2,2))/S12)-(2D0*C2(1,1))/S34+1/(S12*S34)-
     &  (6D0*C2(0,0))/(S12*S34)+(2D0*C2(1,2)*(S13+S14+S23+S24))/
     &  (S12*S34)+(2D0*C1(1)*(2D0*S12+S13+S14+S23+S24))/(S12*S34)-
     &  (2D0*C1(2)*(S13+S14+S23+S24+2D0*S34))/(S12*S34)-(2D0*C0*
     &  (S14+S24+T14))/(S12*S34)

        PRE = (QF(1)*QF(3)*ALPHA*CBA*XMW)/(16D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+K(6)*PRE
        F(1,-1,1) = F(1,-1,1)+K(6)*PRE
        F(1,1,-1) = F(1,1,-1)+K(6)*PRE
        F(1,1,1) = F(1,1,1)+K(6)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(2)*PRE)/(S12*S34)
        F(5,-1,1) = F(5,-1,1)+(2D0*K(2)*PRE)/(S12*S34)
        F(5,1,-1) = F(5,1,-1)+(2D0*K(2)*PRE)/(S12*S34)
        F(5,1,1) = F(5,1,1)+(2D0*K(2)*PRE)/(S12*S34)
        F(6,-1,-1) = F(6,-1,-1)+(2D0*K(2)*PRE)/(S12*S34)
        F(6,-1,1) = F(6,-1,1)+(2D0*K(2)*PRE)/(S12*S34)
        F(6,1,-1) = F(6,1,-1)+(2D0*K(2)*PRE)/(S12*S34)
        F(6,1,1) = F(6,1,1)+(2D0*K(2)*PRE)/(S12*S34)
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(2)*PRE)/(S12*S34)
        F(7,-1,1) = F(7,-1,1)+(2D0*K(2)*PRE)/(S12*S34)
        F(7,1,-1) = F(7,1,-1)+(2D0*K(2)*PRE)/(S12*S34)
        F(7,1,1) = F(7,1,1)+(2D0*K(2)*PRE)/(S12*S34)
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(2)*PRE)/(S12*S34)
        F(8,-1,1) = F(8,-1,1)+(2D0*K(2)*PRE)/(S12*S34)
        F(8,1,-1) = F(8,1,-1)+(2D0*K(2)*PRE)/(S12*S34)
        F(8,1,1) = F(8,1,1)+(2D0*K(2)*PRE)/(S12*S34)

C       G(T9,N2711,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,0,0)

        PRE = -((QF(1)*QF(3)*ALPHA*C0*CBA*XMW*XMW2)/(4D0*PI*S12*S34*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE
        F(1,-1,1) = F(1,-1,1)+PRE
        F(1,1,-1) = F(1,1,-1)+PRE
        F(1,1,1) = F(1,1,1)+PRE

C       G(T9,N2712,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = -(C1(1))-C1(2)-10D0*C2(1,2)+4D0*C0
        K(2) = S13+S14+S23+S24
        K(3) = 2D0*S12-S13-S14-S23-S24
        K(4) = S13+S14+S23+S24-2D0*S34
        K(5) = -((4D0*C2(2,2))/S12)-(4D0*C2(1,1))/S34+6D0/(S12*S34)-
     &  (36D0*C2(0,0))/(S12*S34)+(4D0*C2(1,2)*(S13+S14+S23+S24))/
     &  (S12*S34)+(5D0*C0*(S13+S14+S23+S24))/(S12*S34)-(C1(1)*(2D0*
     &  S12-S13-S14-S23-S24))/(S12*S34)+(C1(2)*(S13+S14+S23+S24-2D0*
     &  S34))/(S12*S34)

        PRE = -((QF(1)*QF(3)*ALPHA*CBA*XMW)/(8D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+K(5)*PRE
        F(1,-1,1) = F(1,-1,1)+K(5)*PRE
        F(1,1,-1) = F(1,1,-1)+K(5)*PRE
        F(1,1,1) = F(1,1,1)+K(5)*PRE
        F(5,-1,-1) = F(5,-1,-1)-(2D0*K(1)*PRE)/(S12*S34)
        F(5,-1,1) = F(5,-1,1)-(2D0*K(1)*PRE)/(S12*S34)
        F(5,1,-1) = F(5,1,-1)-(2D0*K(1)*PRE)/(S12*S34)
        F(5,1,1) = F(5,1,1)-(2D0*K(1)*PRE)/(S12*S34)
        F(6,-1,-1) = F(6,-1,-1)-(2D0*K(1)*PRE)/(S12*S34)
        F(6,-1,1) = F(6,-1,1)-(2D0*K(1)*PRE)/(S12*S34)
        F(6,1,-1) = F(6,1,-1)-(2D0*K(1)*PRE)/(S12*S34)
        F(6,1,1) = F(6,1,1)-(2D0*K(1)*PRE)/(S12*S34)
        F(7,-1,-1) = F(7,-1,-1)-(2D0*K(1)*PRE)/(S12*S34)
        F(7,-1,1) = F(7,-1,1)-(2D0*K(1)*PRE)/(S12*S34)
        F(7,1,-1) = F(7,1,-1)-(2D0*K(1)*PRE)/(S12*S34)
        F(7,1,1) = F(7,1,1)-(2D0*K(1)*PRE)/(S12*S34)
        F(8,-1,-1) = F(8,-1,-1)-(2D0*K(1)*PRE)/(S12*S34)
        F(8,-1,1) = F(8,-1,1)-(2D0*K(1)*PRE)/(S12*S34)
        F(8,1,-1) = F(8,1,-1)-(2D0*K(1)*PRE)/(S12*S34)
        F(8,1,1) = F(8,1,1)-(2D0*K(1)*PRE)/(S12*S34)

C       G(T9,N2713,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0+2D0*QF(3)*XSW2

        PRE = -((QF(1)*ALPHA*CBA*MHH2*PZ34*(XCW+XSW)*(XCW-XSW))/
     &  (8D0*PI*S12*XCW2*XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)+(C2(0,0)*K(1)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*C2(0,0)*QF(3)*PRE
        F(1,1,-1) = F(1,1,-1)+(C2(0,0)*K(1)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+2D0*C2(0,0)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(5,-1,1) = F(5,-1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(5,1,-1) = F(5,1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(6,-1,1) = F(6,-1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(6,1,-1) = F(6,1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(7,-1,1) = F(7,-1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(7,1,-1) = F(7,1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(8,-1,1) = F(8,-1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(8,1,-1) = F(8,1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-2D0*C2(1,2)*QF(3)*PRE

C       G(T9,N2714,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,0,0)

        PRE = -((QF(1)*ALPHA*C0*CBA*MHH2*PZ34*XMZ)/(16D0*PI*S12*
     &  XCW))

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE*XSW
        F(1,1,-1) = F(1,1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW
        F(1,1,1) = F(1,1,1)+2D0*QF(3)*PRE*XSW

C       G(T9,N2715,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0+2D0*QF(3)*XSW2
        K(2) = 2D0*C1(2)+C2(1,2)

        PRE = (QF(1)*ALPHA*CBA*PZ34*XMZ)/(8D0*PI*S12*XCW)

        F(1,-1,-1) = F(1,-1,-1)+(C2(0,0)*K(1)*PRE)/XSW
        F(1,-1,1) = F(1,-1,1)+2D0*C2(0,0)*QF(3)*PRE*XSW
        F(1,1,-1) = F(1,1,-1)+(C2(0,0)*K(1)*PRE)/XSW
        F(1,1,1) = F(1,1,1)+2D0*C2(0,0)*QF(3)*PRE*XSW
        F(5,-1,-1) = F(5,-1,-1)-(K(1)*K(2)*PRE)/XSW
        F(5,-1,1) = F(5,-1,1)-2D0*K(2)*QF(3)*PRE*XSW
        F(5,1,-1) = F(5,1,-1)-(K(1)*K(2)*PRE)/XSW
        F(5,1,1) = F(5,1,1)-2D0*K(2)*QF(3)*PRE*XSW
        F(6,-1,-1) = F(6,-1,-1)-(K(1)*K(2)*PRE)/XSW
        F(6,-1,1) = F(6,-1,1)-2D0*K(2)*QF(3)*PRE*XSW
        F(6,1,-1) = F(6,1,-1)-(K(1)*K(2)*PRE)/XSW
        F(6,1,1) = F(6,1,1)-2D0*K(2)*QF(3)*PRE*XSW
        F(7,-1,-1) = F(7,-1,-1)-(K(1)*K(2)*PRE)/XSW
        F(7,-1,1) = F(7,-1,1)-2D0*K(2)*QF(3)*PRE*XSW
        F(7,1,-1) = F(7,1,-1)-(K(1)*K(2)*PRE)/XSW
        F(7,1,1) = F(7,1,1)-2D0*K(2)*QF(3)*PRE*XSW
        F(8,-1,-1) = F(8,-1,-1)-(K(1)*K(2)*PRE)/XSW
        F(8,-1,1) = F(8,-1,1)-2D0*K(2)*QF(3)*PRE*XSW
        F(8,1,-1) = F(8,1,-1)-(K(1)*K(2)*PRE)/XSW
        F(8,1,1) = F(8,1,1)-2D0*K(2)*QF(3)*PRE*XSW

C       G(T9,N2716,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0+2D0*QF(3)*XSW2
        K(2) = S23+S24+T12
        K(3) = 4D0*C1(1)+2D0*C1(2)-C2(1,2)+4D0*C0
        K(4) = S13+S14+S23+S24
        K(5) = 2D0*S12+S13+S14+S23+S24
        K(6) = S13+S14+S23+S24+2D0*S34
        K(7) = -(2D0*C2(1,1))+S12**(-1)-(6D0*C2(0,0))/S12+(2D0*C2(1,
     &  2)*(S13+S14+S23+S24))/S12-(2D0*C1(1)*(2D0*S12+S13+S14+S23+
     &  S24))/S12-(2D0*C2(2,2)*S34)/S12+(2D0*C1(2)*(S13+S14+S23+S24+
     &  2D0*S34))/S12-(2D0*C0*(S23+S24+T12))/S12

        PRE = -((QF(1)*ALPHA*CBA*PZ34*XMW)/(32D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+(K(1)*K(7)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*K(7)*QF(3)*PRE
        F(1,1,-1) = F(1,1,-1)+(K(1)*K(7)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+2D0*K(7)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(1)*K(3)*PRE)/(S12*XSW2)
        F(5,-1,1) = F(5,-1,1)+(4D0*K(3)*QF(3)*PRE)/S12
        F(5,1,-1) = F(5,1,-1)+(2D0*K(1)*K(3)*PRE)/(S12*XSW2)
        F(5,1,1) = F(5,1,1)+(4D0*K(3)*QF(3)*PRE)/S12
        F(6,-1,-1) = F(6,-1,-1)+(2D0*K(1)*K(3)*PRE)/(S12*XSW2)
        F(6,-1,1) = F(6,-1,1)+(4D0*K(3)*QF(3)*PRE)/S12
        F(6,1,-1) = F(6,1,-1)+(2D0*K(1)*K(3)*PRE)/(S12*XSW2)
        F(6,1,1) = F(6,1,1)+(4D0*K(3)*QF(3)*PRE)/S12
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(1)*K(3)*PRE)/(S12*XSW2)
        F(7,-1,1) = F(7,-1,1)+(4D0*K(3)*QF(3)*PRE)/S12
        F(7,1,-1) = F(7,1,-1)+(2D0*K(1)*K(3)*PRE)/(S12*XSW2)
        F(7,1,1) = F(7,1,1)+(4D0*K(3)*QF(3)*PRE)/S12
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(1)*K(3)*PRE)/(S12*XSW2)
        F(8,-1,1) = F(8,-1,1)+(4D0*K(3)*QF(3)*PRE)/S12
        F(8,1,-1) = F(8,1,-1)+(2D0*K(1)*K(3)*PRE)/(S12*XSW2)
        F(8,1,1) = F(8,1,1)+(4D0*K(3)*QF(3)*PRE)/S12

C       G(T9,N2717,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0+2D0*QF(3)*XSW2

        PRE = -((QF(1)*ALPHA*CBA*MHH2*PZ34*(XCW+XSW)*(XCW-XSW))/
     &  (8D0*PI*S12*XCW2*XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)+(C2(0,0)*K(1)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*C2(0,0)*QF(3)*PRE
        F(1,1,-1) = F(1,1,-1)+(C2(0,0)*K(1)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+2D0*C2(0,0)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(5,-1,1) = F(5,-1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(5,1,-1) = F(5,1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(6,-1,1) = F(6,-1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(6,1,-1) = F(6,1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(7,-1,1) = F(7,-1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(7,1,-1) = F(7,1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(8,-1,1) = F(8,-1,1)-2D0*C2(1,2)*QF(3)*PRE
        F(8,1,-1) = F(8,1,-1)-(C2(1,2)*K(1)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-2D0*C2(1,2)*QF(3)*PRE

C       G(T9,N2718,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,0,0)

        PRE = -((QF(1)*ALPHA*C0*CBA*MHH2*PZ34*XMZ)/(16D0*PI*S12*
     &  XCW))

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE*XSW
        F(1,1,-1) = F(1,1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW
        F(1,1,1) = F(1,1,1)+2D0*QF(3)*PRE*XSW

C       G(T9,N2719,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0+2D0*QF(3)*XSW2
        K(2) = 2D0*C1(2)+C2(1,2)

        PRE = (QF(1)*ALPHA*CBA*PZ34*XMZ)/(8D0*PI*S12*XCW)

        F(1,-1,-1) = F(1,-1,-1)+(C2(0,0)*K(1)*PRE)/XSW
        F(1,-1,1) = F(1,-1,1)+2D0*C2(0,0)*QF(3)*PRE*XSW
        F(1,1,-1) = F(1,1,-1)+(C2(0,0)*K(1)*PRE)/XSW
        F(1,1,1) = F(1,1,1)+2D0*C2(0,0)*QF(3)*PRE*XSW
        F(5,-1,-1) = F(5,-1,-1)-(K(1)*K(2)*PRE)/XSW
        F(5,-1,1) = F(5,-1,1)-2D0*K(2)*QF(3)*PRE*XSW
        F(5,1,-1) = F(5,1,-1)-(K(1)*K(2)*PRE)/XSW
        F(5,1,1) = F(5,1,1)-2D0*K(2)*QF(3)*PRE*XSW
        F(6,-1,-1) = F(6,-1,-1)-(K(1)*K(2)*PRE)/XSW
        F(6,-1,1) = F(6,-1,1)-2D0*K(2)*QF(3)*PRE*XSW
        F(6,1,-1) = F(6,1,-1)-(K(1)*K(2)*PRE)/XSW
        F(6,1,1) = F(6,1,1)-2D0*K(2)*QF(3)*PRE*XSW
        F(7,-1,-1) = F(7,-1,-1)-(K(1)*K(2)*PRE)/XSW
        F(7,-1,1) = F(7,-1,1)-2D0*K(2)*QF(3)*PRE*XSW
        F(7,1,-1) = F(7,1,-1)-(K(1)*K(2)*PRE)/XSW
        F(7,1,1) = F(7,1,1)-2D0*K(2)*QF(3)*PRE*XSW
        F(8,-1,-1) = F(8,-1,-1)-(K(1)*K(2)*PRE)/XSW
        F(8,-1,1) = F(8,-1,1)-2D0*K(2)*QF(3)*PRE*XSW
        F(8,1,-1) = F(8,1,-1)-(K(1)*K(2)*PRE)/XSW
        F(8,1,1) = F(8,1,1)-2D0*K(2)*QF(3)*PRE*XSW

C       G(T9,N2720,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0+2D0*QF(3)*XSW2
        K(2) = S23+S24+T12
        K(3) = 4D0*C1(1)+2D0*C1(2)-C2(1,2)+4D0*C0
        K(4) = S13+S14+S23+S24
        K(5) = 2D0*S12+S13+S14+S23+S24
        K(6) = S13+S14+S23+S24+2D0*S34
        K(7) = -(2D0*C2(1,1))+S12**(-1)-(6D0*C2(0,0))/S12+(2D0*C2(1,
     &  2)*(S13+S14+S23+S24))/S12-(2D0*C1(1)*(2D0*S12+S13+S14+S23+
     &  S24))/S12-(2D0*C2(2,2)*S34)/S12+(2D0*C1(2)*(S13+S14+S23+S24+
     &  2D0*S34))/S12-(2D0*C0*(S23+S24+T12))/S12

        PRE = -((QF(1)*ALPHA*CBA*PZ34*XMW)/(32D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+(K(1)*K(7)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*K(7)*QF(3)*PRE
        F(1,1,-1) = F(1,1,-1)+(K(1)*K(7)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+2D0*K(7)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(1)*K(3)*PRE)/(S12*XSW2)
        F(5,-1,1) = F(5,-1,1)+(4D0*K(3)*QF(3)*PRE)/S12
        F(5,1,-1) = F(5,1,-1)+(2D0*K(1)*K(3)*PRE)/(S12*XSW2)
        F(5,1,1) = F(5,1,1)+(4D0*K(3)*QF(3)*PRE)/S12
        F(6,-1,-1) = F(6,-1,-1)+(2D0*K(1)*K(3)*PRE)/(S12*XSW2)
        F(6,-1,1) = F(6,-1,1)+(4D0*K(3)*QF(3)*PRE)/S12
        F(6,1,-1) = F(6,1,-1)+(2D0*K(1)*K(3)*PRE)/(S12*XSW2)
        F(6,1,1) = F(6,1,1)+(4D0*K(3)*QF(3)*PRE)/S12
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(1)*K(3)*PRE)/(S12*XSW2)
        F(7,-1,1) = F(7,-1,1)+(4D0*K(3)*QF(3)*PRE)/S12
        F(7,1,-1) = F(7,1,-1)+(2D0*K(1)*K(3)*PRE)/(S12*XSW2)
        F(7,1,1) = F(7,1,1)+(4D0*K(3)*QF(3)*PRE)/S12
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(1)*K(3)*PRE)/(S12*XSW2)
        F(8,-1,1) = F(8,-1,1)+(4D0*K(3)*QF(3)*PRE)/S12
        F(8,1,-1) = F(8,1,-1)+(2D0*K(1)*K(3)*PRE)/(S12*XSW2)
        F(8,1,1) = F(8,1,1)+(4D0*K(3)*QF(3)*PRE)/S12

C       G(T9,N2721,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0+2D0*QF(3)*XSW2
        K(2) = 2D0*C1(1)+C2(1,2)

        PRE = -((QF(1)*ALPHA*CBA*PZ34*XMW*(XCW+XSW)*(XCW-XSW))/
     &  (16D0*PI*S12*XCW2*XSW))

        F(1,-1,-1) = F(1,-1,-1)+(C2(0,0)*K(1)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*C2(0,0)*QF(3)*PRE
        F(1,1,-1) = F(1,1,-1)+(C2(0,0)*K(1)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+2D0*C2(0,0)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)-(K(1)*K(2)*PRE)/XSW2
        F(5,-1,1) = F(5,-1,1)-2D0*K(2)*QF(3)*PRE
        F(5,1,-1) = F(5,1,-1)-(K(1)*K(2)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-2D0*K(2)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)-(K(1)*K(2)*PRE)/XSW2
        F(6,-1,1) = F(6,-1,1)-2D0*K(2)*QF(3)*PRE
        F(6,1,-1) = F(6,1,-1)-(K(1)*K(2)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-2D0*K(2)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)-(K(1)*K(2)*PRE)/XSW2
        F(7,-1,1) = F(7,-1,1)-2D0*K(2)*QF(3)*PRE
        F(7,1,-1) = F(7,1,-1)-(K(1)*K(2)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-2D0*K(2)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)-(K(1)*K(2)*PRE)/XSW2
        F(8,-1,1) = F(8,-1,1)-2D0*K(2)*QF(3)*PRE
        F(8,1,-1) = F(8,1,-1)-(K(1)*K(2)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-2D0*K(2)*QF(3)*PRE

C       G(T9,N2722,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0+2D0*QF(3)*XSW2
        K(2) = S14+S24+T14
        K(3) = 2D0*C1(1)+4D0*C1(2)-C2(1,2)+4D0*C0
        K(4) = S13+S14+S23+S24
        K(5) = 2D0*S12+S13+S14+S23+S24
        K(6) = S13+S14+S23+S24+2D0*S34
        K(7) = -(2D0*C2(1,1))+S12**(-1)-(6D0*C2(0,0))/S12+(2D0*C2(1,
     &  2)*(S13+S14+S23+S24))/S12+(2D0*C1(1)*(2D0*S12+S13+S14+S23+
     &  S24))/S12-(2D0*C2(2,2)*S34)/S12-(2D0*C1(2)*(S13+S14+S23+S24+
     &  2D0*S34))/S12-(2D0*C0*(S14+S24+T14))/S12

        PRE = (QF(1)*ALPHA*CBA*PZ34*XMZ)/(32D0*PI*XCW)

        F(1,-1,-1) = F(1,-1,-1)+(K(1)*K(7)*PRE)/XSW
        F(1,-1,1) = F(1,-1,1)+2D0*K(7)*QF(3)*PRE*XSW
        F(1,1,-1) = F(1,1,-1)+(K(1)*K(7)*PRE)/XSW
        F(1,1,1) = F(1,1,1)+2D0*K(7)*QF(3)*PRE*XSW
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(1)*K(3)*PRE)/(S12*XSW)
        F(5,-1,1) = F(5,-1,1)+(4D0*K(3)*QF(3)*PRE*XSW)/S12
        F(5,1,-1) = F(5,1,-1)+(2D0*K(1)*K(3)*PRE)/(S12*XSW)
        F(5,1,1) = F(5,1,1)+(4D0*K(3)*QF(3)*PRE*XSW)/S12
        F(6,-1,-1) = F(6,-1,-1)+(2D0*K(1)*K(3)*PRE)/(S12*XSW)
        F(6,-1,1) = F(6,-1,1)+(4D0*K(3)*QF(3)*PRE*XSW)/S12
        F(6,1,-1) = F(6,1,-1)+(2D0*K(1)*K(3)*PRE)/(S12*XSW)
        F(6,1,1) = F(6,1,1)+(4D0*K(3)*QF(3)*PRE*XSW)/S12
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(1)*K(3)*PRE)/(S12*XSW)
        F(7,-1,1) = F(7,-1,1)+(4D0*K(3)*QF(3)*PRE*XSW)/S12
        F(7,1,-1) = F(7,1,-1)+(2D0*K(1)*K(3)*PRE)/(S12*XSW)
        F(7,1,1) = F(7,1,1)+(4D0*K(3)*QF(3)*PRE*XSW)/S12
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(1)*K(3)*PRE)/(S12*XSW)
        F(8,-1,1) = F(8,-1,1)+(4D0*K(3)*QF(3)*PRE*XSW)/S12
        F(8,1,-1) = F(8,1,-1)+(2D0*K(1)*K(3)*PRE)/(S12*XSW)
        F(8,1,1) = F(8,1,1)+(4D0*K(3)*QF(3)*PRE*XSW)/S12

C       G(T9,N2723,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,0,0)

        PRE = -((QF(1)*ALPHA*C0*CBA*PZ34*XMW2*XMZ)/(8D0*PI*S12*XCW))

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE*XSW
        F(1,1,-1) = F(1,1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW
        F(1,1,1) = F(1,1,1)+2D0*QF(3)*PRE*XSW

C       G(T9,N2724,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0+2D0*QF(3)*XSW2
        K(2) = -(C1(1))-C1(2)-10D0*C2(1,2)+4D0*C0
        K(3) = S13+S14+S23+S24
        K(4) = 2D0*S12-S13-S14-S23-S24
        K(5) = S13+S14+S23+S24-2D0*S34
        K(6) = -(4D0*C2(1,1))+6D0/S12-(36D0*C2(0,0))/S12+(4D0*C2(1,
     &  2)*(S13+S14+S23+S24))/S12+(5D0*C0*(S13+S14+S23+S24))/S12-
     &  (C1(1)*(2D0*S12-S13-S14-S23-S24))/S12-(4D0*C2(2,2)*S34)/S12+
     &  (C1(2)*(S13+S14+S23+S24-2D0*S34))/S12

        PRE = (QF(1)*ALPHA*CBA*PZ34*XMW)/(16D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+(K(1)*K(6)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*K(6)*QF(3)*PRE
        F(1,1,-1) = F(1,1,-1)+(K(1)*K(6)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+2D0*K(6)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)-(2D0*K(1)*K(2)*PRE)/(S12*XSW2)
        F(5,-1,1) = F(5,-1,1)-(4D0*K(2)*QF(3)*PRE)/S12
        F(5,1,-1) = F(5,1,-1)-(2D0*K(1)*K(2)*PRE)/(S12*XSW2)
        F(5,1,1) = F(5,1,1)-(4D0*K(2)*QF(3)*PRE)/S12
        F(6,-1,-1) = F(6,-1,-1)-(2D0*K(1)*K(2)*PRE)/(S12*XSW2)
        F(6,-1,1) = F(6,-1,1)-(4D0*K(2)*QF(3)*PRE)/S12
        F(6,1,-1) = F(6,1,-1)-(2D0*K(1)*K(2)*PRE)/(S12*XSW2)
        F(6,1,1) = F(6,1,1)-(4D0*K(2)*QF(3)*PRE)/S12
        F(7,-1,-1) = F(7,-1,-1)-(2D0*K(1)*K(2)*PRE)/(S12*XSW2)
        F(7,-1,1) = F(7,-1,1)-(4D0*K(2)*QF(3)*PRE)/S12
        F(7,1,-1) = F(7,1,-1)-(2D0*K(1)*K(2)*PRE)/(S12*XSW2)
        F(7,1,1) = F(7,1,1)-(4D0*K(2)*QF(3)*PRE)/S12
        F(8,-1,-1) = F(8,-1,-1)-(2D0*K(1)*K(2)*PRE)/(S12*XSW2)
        F(8,-1,1) = F(8,-1,1)-(4D0*K(2)*QF(3)*PRE)/S12
        F(8,1,-1) = F(8,1,-1)-(2D0*K(1)*K(2)*PRE)/(S12*XSW2)
        F(8,1,1) = F(8,1,1)-(4D0*K(2)*QF(3)*PRE)/S12

C       G(T9,N2725,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0+2D0*QF(3)*XSW2
        K(2) = 2D0*C1(1)+C2(1,2)

        PRE = -((QF(1)*ALPHA*CBA*PZ34*XMW*(XCW+XSW)*(XCW-XSW))/
     &  (16D0*PI*S12*XCW2*XSW))

        F(1,-1,-1) = F(1,-1,-1)+(C2(0,0)*K(1)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*C2(0,0)*QF(3)*PRE
        F(1,1,-1) = F(1,1,-1)+(C2(0,0)*K(1)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+2D0*C2(0,0)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)-(K(1)*K(2)*PRE)/XSW2
        F(5,-1,1) = F(5,-1,1)-2D0*K(2)*QF(3)*PRE
        F(5,1,-1) = F(5,1,-1)-(K(1)*K(2)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-2D0*K(2)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)-(K(1)*K(2)*PRE)/XSW2
        F(6,-1,1) = F(6,-1,1)-2D0*K(2)*QF(3)*PRE
        F(6,1,-1) = F(6,1,-1)-(K(1)*K(2)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-2D0*K(2)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)-(K(1)*K(2)*PRE)/XSW2
        F(7,-1,1) = F(7,-1,1)-2D0*K(2)*QF(3)*PRE
        F(7,1,-1) = F(7,1,-1)-(K(1)*K(2)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-2D0*K(2)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)-(K(1)*K(2)*PRE)/XSW2
        F(8,-1,1) = F(8,-1,1)-2D0*K(2)*QF(3)*PRE
        F(8,1,-1) = F(8,1,-1)-(K(1)*K(2)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-2D0*K(2)*QF(3)*PRE

C       G(T9,N2726,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0+2D0*QF(3)*XSW2
        K(2) = S14+S24+T14
        K(3) = 2D0*C1(1)+4D0*C1(2)-C2(1,2)+4D0*C0
        K(4) = S13+S14+S23+S24
        K(5) = 2D0*S12+S13+S14+S23+S24
        K(6) = S13+S14+S23+S24+2D0*S34
        K(7) = -(2D0*C2(1,1))+S12**(-1)-(6D0*C2(0,0))/S12+(2D0*C2(1,
     &  2)*(S13+S14+S23+S24))/S12+(2D0*C1(1)*(2D0*S12+S13+S14+S23+
     &  S24))/S12-(2D0*C2(2,2)*S34)/S12-(2D0*C1(2)*(S13+S14+S23+S24+
     &  2D0*S34))/S12-(2D0*C0*(S14+S24+T14))/S12

        PRE = (QF(1)*ALPHA*CBA*PZ34*XMZ)/(32D0*PI*XCW)

        F(1,-1,-1) = F(1,-1,-1)+(K(1)*K(7)*PRE)/XSW
        F(1,-1,1) = F(1,-1,1)+2D0*K(7)*QF(3)*PRE*XSW
        F(1,1,-1) = F(1,1,-1)+(K(1)*K(7)*PRE)/XSW
        F(1,1,1) = F(1,1,1)+2D0*K(7)*QF(3)*PRE*XSW
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(1)*K(3)*PRE)/(S12*XSW)
        F(5,-1,1) = F(5,-1,1)+(4D0*K(3)*QF(3)*PRE*XSW)/S12
        F(5,1,-1) = F(5,1,-1)+(2D0*K(1)*K(3)*PRE)/(S12*XSW)
        F(5,1,1) = F(5,1,1)+(4D0*K(3)*QF(3)*PRE*XSW)/S12
        F(6,-1,-1) = F(6,-1,-1)+(2D0*K(1)*K(3)*PRE)/(S12*XSW)
        F(6,-1,1) = F(6,-1,1)+(4D0*K(3)*QF(3)*PRE*XSW)/S12
        F(6,1,-1) = F(6,1,-1)+(2D0*K(1)*K(3)*PRE)/(S12*XSW)
        F(6,1,1) = F(6,1,1)+(4D0*K(3)*QF(3)*PRE*XSW)/S12
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(1)*K(3)*PRE)/(S12*XSW)
        F(7,-1,1) = F(7,-1,1)+(4D0*K(3)*QF(3)*PRE*XSW)/S12
        F(7,1,-1) = F(7,1,-1)+(2D0*K(1)*K(3)*PRE)/(S12*XSW)
        F(7,1,1) = F(7,1,1)+(4D0*K(3)*QF(3)*PRE*XSW)/S12
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(1)*K(3)*PRE)/(S12*XSW)
        F(8,-1,1) = F(8,-1,1)+(4D0*K(3)*QF(3)*PRE*XSW)/S12
        F(8,1,-1) = F(8,1,-1)+(2D0*K(1)*K(3)*PRE)/(S12*XSW)
        F(8,1,1) = F(8,1,1)+(4D0*K(3)*QF(3)*PRE*XSW)/S12

C       G(T9,N2727,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,0,0)

        PRE = -((QF(1)*ALPHA*C0*CBA*PZ34*XMW2*XMZ)/(8D0*PI*S12*XCW))

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE*XSW
        F(1,1,-1) = F(1,1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW
        F(1,1,1) = F(1,1,1)+2D0*QF(3)*PRE*XSW

C       G(T9,N2728,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0+2D0*QF(3)*XSW2
        K(2) = -(C1(1))-C1(2)-10D0*C2(1,2)+4D0*C0
        K(3) = S13+S14+S23+S24
        K(4) = 2D0*S12-S13-S14-S23-S24
        K(5) = S13+S14+S23+S24-2D0*S34
        K(6) = -(4D0*C2(1,1))+6D0/S12-(36D0*C2(0,0))/S12+(4D0*C2(1,
     &  2)*(S13+S14+S23+S24))/S12+(5D0*C0*(S13+S14+S23+S24))/S12-
     &  (C1(1)*(2D0*S12-S13-S14-S23-S24))/S12-(4D0*C2(2,2)*S34)/S12+
     &  (C1(2)*(S13+S14+S23+S24-2D0*S34))/S12

        PRE = (QF(1)*ALPHA*CBA*PZ34*XMW)/(16D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+(K(1)*K(6)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*K(6)*QF(3)*PRE
        F(1,1,-1) = F(1,1,-1)+(K(1)*K(6)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+2D0*K(6)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)-(2D0*K(1)*K(2)*PRE)/(S12*XSW2)
        F(5,-1,1) = F(5,-1,1)-(4D0*K(2)*QF(3)*PRE)/S12
        F(5,1,-1) = F(5,1,-1)-(2D0*K(1)*K(2)*PRE)/(S12*XSW2)
        F(5,1,1) = F(5,1,1)-(4D0*K(2)*QF(3)*PRE)/S12
        F(6,-1,-1) = F(6,-1,-1)-(2D0*K(1)*K(2)*PRE)/(S12*XSW2)
        F(6,-1,1) = F(6,-1,1)-(4D0*K(2)*QF(3)*PRE)/S12
        F(6,1,-1) = F(6,1,-1)-(2D0*K(1)*K(2)*PRE)/(S12*XSW2)
        F(6,1,1) = F(6,1,1)-(4D0*K(2)*QF(3)*PRE)/S12
        F(7,-1,-1) = F(7,-1,-1)-(2D0*K(1)*K(2)*PRE)/(S12*XSW2)
        F(7,-1,1) = F(7,-1,1)-(4D0*K(2)*QF(3)*PRE)/S12
        F(7,1,-1) = F(7,1,-1)-(2D0*K(1)*K(2)*PRE)/(S12*XSW2)
        F(7,1,1) = F(7,1,1)-(4D0*K(2)*QF(3)*PRE)/S12
        F(8,-1,-1) = F(8,-1,-1)-(2D0*K(1)*K(2)*PRE)/(S12*XSW2)
        F(8,-1,1) = F(8,-1,1)-(4D0*K(2)*QF(3)*PRE)/S12
        F(8,1,-1) = F(8,1,-1)-(2D0*K(1)*K(2)*PRE)/(S12*XSW2)
        F(8,1,1) = F(8,1,1)-(4D0*K(2)*QF(3)*PRE)/S12

C       G(T9,N2729,FULL)

C       G(T9,N2730,FULL)

C       G(T9,N2731,FULL)

C       G(T9,N2732,FULL)

C       G(T9,N2733,FULL)

C       G(T9,N2734,FULL)

C       G(T9,N2735,FULL)

C       G(T9,N2736,FULL)

C       G(T9,N2737,FULL)

C       G(T9,N2738,FULL)

C       G(T9,N2739,FULL)

C       G(T9,N2740,FULL)

C       G(T9,N2741,FULL)

C       G(T9,N2742,FULL)

C       G(T9,N2743,FULL)

C       G(T9,N2744,FULL)

C       G(T9,N2745,FULL)

C       G(T9,N2746,FULL)

C       G(T9,N2747,FULL)

C       G(T9,N2748,FULL)

C       G(T9,N2749,FULL)

C       G(T9,N2750,FULL)

C       G(T9,N2751,FULL)

C       G(T9,N2752,FULL)

C       G(T9,N2753,FULL)

C       G(T9,N2754,FULL)

C       G(T9,N2755,FULL)

C       G(T9,N2756,FULL)

C       G(T9,N2757,FULL)

C       G(T9,N2758,FULL)

C       G(T9,N2759,FULL)

C       G(T9,N2760,FULL)

C       G(T9,N2761,FULL)

C       G(T9,N2762,FULL)

C       G(T9,N2763,FULL)

C       G(T9,N2764,FULL)

C       G(T9,N2765,FULL)

C       G(T9,N2766,FULL)

C       G(T9,N2767,FULL)

C       G(T9,N2768,FULL)

C       G(T9,N2769,FULL)

C       G(T9,N2770,FULL)

C       G(T9,N2771,FULL)

C       G(T9,N2772,FULL)

C       G(T9,N2773,FULL)

C       G(T9,N2774,FULL)

C       G(T9,N2775,FULL)

C       G(T9,N2776,FULL)

C       G(T9,N2777,FULL)

C       G(T9,N2778,FULL)

C       G(T9,N2779,FULL)

C       G(T9,N2780,FULL)

C       G(T9,N2781,FULL)

C       G(T9,N2782,FULL)

C       G(T9,N2783,FULL)

C       G(T9,N2784,FULL)

C       G(T9,N2785,FULL)

C       G(T9,N2786,FULL)

C       G(T9,N2787,FULL)

C       G(T9,N2788,FULL)

C       G(T9,N2789,FULL)

C       G(T9,N2790,FULL)

C       G(T9,N2791,FULL)

C       G(T9,N2792,FULL)

C       G(T9,N2793,FULL)

C       G(T9,N2794,FULL)

C       G(T9,N2795,FULL)

C       G(T9,N2796,FULL)

C       G(T9,N2797,FULL)

C       G(T9,N2798,FULL)

C       G(T9,N2799,FULL)

C       G(T9,N2800,FULL)

C       G(T9,N2801,FULL)

C       G(T9,N2802,FULL)

C       G(T9,N2803,FULL)

C       G(T9,N2804,FULL)

C       G(T9,N2805,FULL)

C       G(T9,N2806,FULL)

C       G(T9,N2807,FULL)

C       G(T9,N2808,FULL)

C       G(T9,N2809,FULL)

C       G(T9,N2810,FULL)

C       G(T9,N2811,FULL)

C       G(T9,N2812,FULL)

C       G(T9,N2813,FULL)

C       G(T9,N2814,FULL)

C       G(T9,N2815,FULL)

C       G(T9,N2816,FULL)

C       G(T9,N2817,FULL)

C       G(T9,N2818,FULL)

C       G(T9,N2819,FULL)

C       G(T9,N2820,FULL)

C       G(T9,N2821,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2

        PRE = -((QF(3)*ALPHA*CBA*MHH2*PZ12*(XCW+XSW)*(XCW-XSW))/
     &  (8D0*PI*S34*XCW2*XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)-(C2(0,0)*K(1)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)-(C2(0,0)*K(1)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*C2(0,0)*QF(1)*PRE
        F(1,1,1) = F(1,1,1)+2D0*C2(0,0)*QF(1)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(5,-1,1) = F(5,-1,1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-2D0*C2(1,2)*QF(1)*PRE
        F(5,1,1) = F(5,1,1)-2D0*C2(1,2)*QF(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(6,-1,1) = F(6,-1,1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-2D0*C2(1,2)*QF(1)*PRE
        F(6,1,1) = F(6,1,1)-2D0*C2(1,2)*QF(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(7,-1,1) = F(7,-1,1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-2D0*C2(1,2)*QF(1)*PRE
        F(7,1,1) = F(7,1,1)-2D0*C2(1,2)*QF(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(8,-1,1) = F(8,-1,1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-2D0*C2(1,2)*QF(1)*PRE
        F(8,1,1) = F(8,1,1)-2D0*C2(1,2)*QF(1)*PRE

C       G(T9,N2822,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,0,0)

        PRE = -((QF(3)*ALPHA*C0*CBA*MHH2*PZ12*XMZ)/(16D0*PI*S34*
     &  XCW))

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE*XSW
        F(1,1,1) = F(1,1,1)+2D0*QF(1)*PRE*XSW

C       G(T9,N2823,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 2D0*C1(2)+C2(1,2)

        PRE = -((QF(3)*ALPHA*CBA*PZ12*XMW*(XCW+XSW)*(XCW-XSW))/
     &  (16D0*PI*S34*XCW2*XSW))

        F(1,-1,-1) = F(1,-1,-1)-(C2(0,0)*K(1)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)-(C2(0,0)*K(1)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*C2(0,0)*QF(1)*PRE
        F(1,1,1) = F(1,1,1)+2D0*C2(0,0)*QF(1)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(K(1)*K(2)*PRE)/XSW2
        F(5,-1,1) = F(5,-1,1)+(K(1)*K(2)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-2D0*K(2)*QF(1)*PRE
        F(5,1,1) = F(5,1,1)-2D0*K(2)*QF(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)+(K(1)*K(2)*PRE)/XSW2
        F(6,-1,1) = F(6,-1,1)+(K(1)*K(2)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-2D0*K(2)*QF(1)*PRE
        F(6,1,1) = F(6,1,1)-2D0*K(2)*QF(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)+(K(1)*K(2)*PRE)/XSW2
        F(7,-1,1) = F(7,-1,1)+(K(1)*K(2)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-2D0*K(2)*QF(1)*PRE
        F(7,1,1) = F(7,1,1)-2D0*K(2)*QF(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)+(K(1)*K(2)*PRE)/XSW2
        F(8,-1,1) = F(8,-1,1)+(K(1)*K(2)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-2D0*K(2)*QF(1)*PRE
        F(8,1,1) = F(8,1,1)-2D0*K(2)*QF(1)*PRE

C       G(T9,N2824,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = S23+S24+T12
        K(3) = 4D0*C1(1)+2D0*C1(2)-C2(1,2)+4D0*C0
        K(4) = S13+S14+S23+S24
        K(5) = 2D0*S12+S13+S14+S23+S24
        K(6) = S13+S14+S23+S24+2D0*S34
        K(7) = -(2D0*C2(2,2))+S34**(-1)-(6D0*C2(0,0))/S34-(2D0*C2(1,
     &  1)*S12)/S34+(2D0*C2(1,2)*(S13+S14+S23+S24))/S34-(2D0*C1(1)*
     &  (2D0*S12+S13+S14+S23+S24))/S34+(2D0*C1(2)*(S13+S14+S23+S24+
     &  2D0*S34))/S34-(2D0*C0*(S23+S24+T12))/S34

        PRE = (QF(3)*ALPHA*CBA*PZ12*XMZ)/(32D0*PI*XCW)

        F(1,-1,-1) = F(1,-1,-1)-(K(1)*K(7)*PRE)/XSW
        F(1,-1,1) = F(1,-1,1)-(K(1)*K(7)*PRE)/XSW
        F(1,1,-1) = F(1,1,-1)+2D0*K(7)*QF(1)*PRE*XSW
        F(1,1,1) = F(1,1,1)+2D0*K(7)*QF(1)*PRE*XSW
        F(5,-1,-1) = F(5,-1,-1)-(2D0*K(1)*K(3)*PRE)/(S34*XSW)
        F(5,-1,1) = F(5,-1,1)-(2D0*K(1)*K(3)*PRE)/(S34*XSW)
        F(5,1,-1) = F(5,1,-1)+(4D0*K(3)*QF(1)*PRE*XSW)/S34
        F(5,1,1) = F(5,1,1)+(4D0*K(3)*QF(1)*PRE*XSW)/S34
        F(6,-1,-1) = F(6,-1,-1)-(2D0*K(1)*K(3)*PRE)/(S34*XSW)
        F(6,-1,1) = F(6,-1,1)-(2D0*K(1)*K(3)*PRE)/(S34*XSW)
        F(6,1,-1) = F(6,1,-1)+(4D0*K(3)*QF(1)*PRE*XSW)/S34
        F(6,1,1) = F(6,1,1)+(4D0*K(3)*QF(1)*PRE*XSW)/S34
        F(7,-1,-1) = F(7,-1,-1)-(2D0*K(1)*K(3)*PRE)/(S34*XSW)
        F(7,-1,1) = F(7,-1,1)-(2D0*K(1)*K(3)*PRE)/(S34*XSW)
        F(7,1,-1) = F(7,1,-1)+(4D0*K(3)*QF(1)*PRE*XSW)/S34
        F(7,1,1) = F(7,1,1)+(4D0*K(3)*QF(1)*PRE*XSW)/S34
        F(8,-1,-1) = F(8,-1,-1)-(2D0*K(1)*K(3)*PRE)/(S34*XSW)
        F(8,-1,1) = F(8,-1,1)-(2D0*K(1)*K(3)*PRE)/(S34*XSW)
        F(8,1,-1) = F(8,1,-1)+(4D0*K(3)*QF(1)*PRE*XSW)/S34
        F(8,1,1) = F(8,1,1)+(4D0*K(3)*QF(1)*PRE*XSW)/S34

C       G(T9,N2825,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2

        PRE = -((QF(3)*ALPHA*CBA*MHH2*PZ12*(XCW+XSW)*(XCW-XSW))/
     &  (8D0*PI*S34*XCW2*XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)-(C2(0,0)*K(1)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)-(C2(0,0)*K(1)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*C2(0,0)*QF(1)*PRE
        F(1,1,1) = F(1,1,1)+2D0*C2(0,0)*QF(1)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(5,-1,1) = F(5,-1,1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-2D0*C2(1,2)*QF(1)*PRE
        F(5,1,1) = F(5,1,1)-2D0*C2(1,2)*QF(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(6,-1,1) = F(6,-1,1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-2D0*C2(1,2)*QF(1)*PRE
        F(6,1,1) = F(6,1,1)-2D0*C2(1,2)*QF(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(7,-1,1) = F(7,-1,1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-2D0*C2(1,2)*QF(1)*PRE
        F(7,1,1) = F(7,1,1)-2D0*C2(1,2)*QF(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(8,-1,1) = F(8,-1,1)+(C2(1,2)*K(1)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-2D0*C2(1,2)*QF(1)*PRE
        F(8,1,1) = F(8,1,1)-2D0*C2(1,2)*QF(1)*PRE

C       G(T9,N2826,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,0,0)

        PRE = -((QF(3)*ALPHA*C0*CBA*MHH2*PZ12*XMZ)/(16D0*PI*S34*
     &  XCW))

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE*XSW
        F(1,1,1) = F(1,1,1)+2D0*QF(1)*PRE*XSW

C       G(T9,N2827,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 2D0*C1(2)+C2(1,2)

        PRE = -((QF(3)*ALPHA*CBA*PZ12*XMW*(XCW+XSW)*(XCW-XSW))/
     &  (16D0*PI*S34*XCW2*XSW))

        F(1,-1,-1) = F(1,-1,-1)-(C2(0,0)*K(1)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)-(C2(0,0)*K(1)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*C2(0,0)*QF(1)*PRE
        F(1,1,1) = F(1,1,1)+2D0*C2(0,0)*QF(1)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(K(1)*K(2)*PRE)/XSW2
        F(5,-1,1) = F(5,-1,1)+(K(1)*K(2)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-2D0*K(2)*QF(1)*PRE
        F(5,1,1) = F(5,1,1)-2D0*K(2)*QF(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)+(K(1)*K(2)*PRE)/XSW2
        F(6,-1,1) = F(6,-1,1)+(K(1)*K(2)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-2D0*K(2)*QF(1)*PRE
        F(6,1,1) = F(6,1,1)-2D0*K(2)*QF(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)+(K(1)*K(2)*PRE)/XSW2
        F(7,-1,1) = F(7,-1,1)+(K(1)*K(2)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-2D0*K(2)*QF(1)*PRE
        F(7,1,1) = F(7,1,1)-2D0*K(2)*QF(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)+(K(1)*K(2)*PRE)/XSW2
        F(8,-1,1) = F(8,-1,1)+(K(1)*K(2)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-2D0*K(2)*QF(1)*PRE
        F(8,1,1) = F(8,1,1)-2D0*K(2)*QF(1)*PRE

C       G(T9,N2828,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = S23+S24+T12
        K(3) = 4D0*C1(1)+2D0*C1(2)-C2(1,2)+4D0*C0
        K(4) = S13+S14+S23+S24
        K(5) = 2D0*S12+S13+S14+S23+S24
        K(6) = S13+S14+S23+S24+2D0*S34
        K(7) = -(2D0*C2(2,2))+S34**(-1)-(6D0*C2(0,0))/S34-(2D0*C2(1,
     &  1)*S12)/S34+(2D0*C2(1,2)*(S13+S14+S23+S24))/S34-(2D0*C1(1)*
     &  (2D0*S12+S13+S14+S23+S24))/S34+(2D0*C1(2)*(S13+S14+S23+S24+
     &  2D0*S34))/S34-(2D0*C0*(S23+S24+T12))/S34

        PRE = (QF(3)*ALPHA*CBA*PZ12*XMZ)/(32D0*PI*XCW)

        F(1,-1,-1) = F(1,-1,-1)-(K(1)*K(7)*PRE)/XSW
        F(1,-1,1) = F(1,-1,1)-(K(1)*K(7)*PRE)/XSW
        F(1,1,-1) = F(1,1,-1)+2D0*K(7)*QF(1)*PRE*XSW
        F(1,1,1) = F(1,1,1)+2D0*K(7)*QF(1)*PRE*XSW
        F(5,-1,-1) = F(5,-1,-1)-(2D0*K(1)*K(3)*PRE)/(S34*XSW)
        F(5,-1,1) = F(5,-1,1)-(2D0*K(1)*K(3)*PRE)/(S34*XSW)
        F(5,1,-1) = F(5,1,-1)+(4D0*K(3)*QF(1)*PRE*XSW)/S34
        F(5,1,1) = F(5,1,1)+(4D0*K(3)*QF(1)*PRE*XSW)/S34
        F(6,-1,-1) = F(6,-1,-1)-(2D0*K(1)*K(3)*PRE)/(S34*XSW)
        F(6,-1,1) = F(6,-1,1)-(2D0*K(1)*K(3)*PRE)/(S34*XSW)
        F(6,1,-1) = F(6,1,-1)+(4D0*K(3)*QF(1)*PRE*XSW)/S34
        F(6,1,1) = F(6,1,1)+(4D0*K(3)*QF(1)*PRE*XSW)/S34
        F(7,-1,-1) = F(7,-1,-1)-(2D0*K(1)*K(3)*PRE)/(S34*XSW)
        F(7,-1,1) = F(7,-1,1)-(2D0*K(1)*K(3)*PRE)/(S34*XSW)
        F(7,1,-1) = F(7,1,-1)+(4D0*K(3)*QF(1)*PRE*XSW)/S34
        F(7,1,1) = F(7,1,1)+(4D0*K(3)*QF(1)*PRE*XSW)/S34
        F(8,-1,-1) = F(8,-1,-1)-(2D0*K(1)*K(3)*PRE)/(S34*XSW)
        F(8,-1,1) = F(8,-1,1)-(2D0*K(1)*K(3)*PRE)/(S34*XSW)
        F(8,1,-1) = F(8,1,-1)+(4D0*K(3)*QF(1)*PRE*XSW)/S34
        F(8,1,1) = F(8,1,1)+(4D0*K(3)*QF(1)*PRE*XSW)/S34

C       G(T9,N2829,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 2D0*C1(1)+C2(1,2)

        PRE = (QF(3)*ALPHA*CBA*PZ12*XMZ)/(8D0*PI*S34*XCW)

        F(1,-1,-1) = F(1,-1,-1)-(C2(0,0)*K(1)*PRE)/XSW
        F(1,-1,1) = F(1,-1,1)-(C2(0,0)*K(1)*PRE)/XSW
        F(1,1,-1) = F(1,1,-1)+2D0*C2(0,0)*QF(1)*PRE*XSW
        F(1,1,1) = F(1,1,1)+2D0*C2(0,0)*QF(1)*PRE*XSW
        F(5,-1,-1) = F(5,-1,-1)+(K(1)*K(2)*PRE)/XSW
        F(5,-1,1) = F(5,-1,1)+(K(1)*K(2)*PRE)/XSW
        F(5,1,-1) = F(5,1,-1)-2D0*K(2)*QF(1)*PRE*XSW
        F(5,1,1) = F(5,1,1)-2D0*K(2)*QF(1)*PRE*XSW
        F(6,-1,-1) = F(6,-1,-1)+(K(1)*K(2)*PRE)/XSW
        F(6,-1,1) = F(6,-1,1)+(K(1)*K(2)*PRE)/XSW
        F(6,1,-1) = F(6,1,-1)-2D0*K(2)*QF(1)*PRE*XSW
        F(6,1,1) = F(6,1,1)-2D0*K(2)*QF(1)*PRE*XSW
        F(7,-1,-1) = F(7,-1,-1)+(K(1)*K(2)*PRE)/XSW
        F(7,-1,1) = F(7,-1,1)+(K(1)*K(2)*PRE)/XSW
        F(7,1,-1) = F(7,1,-1)-2D0*K(2)*QF(1)*PRE*XSW
        F(7,1,1) = F(7,1,1)-2D0*K(2)*QF(1)*PRE*XSW
        F(8,-1,-1) = F(8,-1,-1)+(K(1)*K(2)*PRE)/XSW
        F(8,-1,1) = F(8,-1,1)+(K(1)*K(2)*PRE)/XSW
        F(8,1,-1) = F(8,1,-1)-2D0*K(2)*QF(1)*PRE*XSW
        F(8,1,1) = F(8,1,1)-2D0*K(2)*QF(1)*PRE*XSW

C       G(T9,N2830,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = S14+S24+T14
        K(3) = 2D0*C1(1)+4D0*C1(2)-C2(1,2)+4D0*C0
        K(4) = S13+S14+S23+S24
        K(5) = 2D0*S12+S13+S14+S23+S24
        K(6) = S13+S14+S23+S24+2D0*S34
        K(7) = -(2D0*C2(2,2))+S34**(-1)-(6D0*C2(0,0))/S34-(2D0*C2(1,
     &  1)*S12)/S34+(2D0*C2(1,2)*(S13+S14+S23+S24))/S34+(2D0*C1(1)*
     &  (2D0*S12+S13+S14+S23+S24))/S34-(2D0*C1(2)*(S13+S14+S23+S24+
     &  2D0*S34))/S34-(2D0*C0*(S14+S24+T14))/S34

        PRE = -((QF(3)*ALPHA*CBA*PZ12*XMW)/(32D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)-(K(1)*K(7)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)-(K(1)*K(7)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*K(7)*QF(1)*PRE
        F(1,1,1) = F(1,1,1)+2D0*K(7)*QF(1)*PRE
        F(5,-1,-1) = F(5,-1,-1)-(2D0*K(1)*K(3)*PRE)/(S34*XSW2)
        F(5,-1,1) = F(5,-1,1)-(2D0*K(1)*K(3)*PRE)/(S34*XSW2)
        F(5,1,-1) = F(5,1,-1)+(4D0*K(3)*QF(1)*PRE)/S34
        F(5,1,1) = F(5,1,1)+(4D0*K(3)*QF(1)*PRE)/S34
        F(6,-1,-1) = F(6,-1,-1)-(2D0*K(1)*K(3)*PRE)/(S34*XSW2)
        F(6,-1,1) = F(6,-1,1)-(2D0*K(1)*K(3)*PRE)/(S34*XSW2)
        F(6,1,-1) = F(6,1,-1)+(4D0*K(3)*QF(1)*PRE)/S34
        F(6,1,1) = F(6,1,1)+(4D0*K(3)*QF(1)*PRE)/S34
        F(7,-1,-1) = F(7,-1,-1)-(2D0*K(1)*K(3)*PRE)/(S34*XSW2)
        F(7,-1,1) = F(7,-1,1)-(2D0*K(1)*K(3)*PRE)/(S34*XSW2)
        F(7,1,-1) = F(7,1,-1)+(4D0*K(3)*QF(1)*PRE)/S34
        F(7,1,1) = F(7,1,1)+(4D0*K(3)*QF(1)*PRE)/S34
        F(8,-1,-1) = F(8,-1,-1)-(2D0*K(1)*K(3)*PRE)/(S34*XSW2)
        F(8,-1,1) = F(8,-1,1)-(2D0*K(1)*K(3)*PRE)/(S34*XSW2)
        F(8,1,-1) = F(8,1,-1)+(4D0*K(3)*QF(1)*PRE)/S34
        F(8,1,1) = F(8,1,1)+(4D0*K(3)*QF(1)*PRE)/S34

C       G(T9,N2831,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,0,0)

        PRE = -((QF(3)*ALPHA*C0*CBA*PZ12*XMW2*XMZ)/(8D0*PI*S34*XCW))

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE*XSW
        F(1,1,1) = F(1,1,1)+2D0*QF(1)*PRE*XSW

C       G(T9,N2832,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = -(C1(1))-C1(2)-10D0*C2(1,2)+4D0*C0
        K(3) = S13+S14+S23+S24
        K(4) = 2D0*S12-S13-S14-S23-S24
        K(5) = S13+S14+S23+S24-2D0*S34
        K(6) = -(4D0*C2(2,2))+6D0/S34-(36D0*C2(0,0))/S34-(4D0*C2(1,
     &  1)*S12)/S34+(4D0*C2(1,2)*(S13+S14+S23+S24))/S34+(5D0*C0*
     &  (S13+S14+S23+S24))/S34-(C1(1)*(2D0*S12-S13-S14-S23-S24))/
     &  S34+(C1(2)*(S13+S14+S23+S24-2D0*S34))/S34

        PRE = (QF(3)*ALPHA*CBA*PZ12*XMW)/(16D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)-(K(1)*K(6)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)-(K(1)*K(6)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*K(6)*QF(1)*PRE
        F(1,1,1) = F(1,1,1)+2D0*K(6)*QF(1)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(1)*K(2)*PRE)/(S34*XSW2)
        F(5,-1,1) = F(5,-1,1)+(2D0*K(1)*K(2)*PRE)/(S34*XSW2)
        F(5,1,-1) = F(5,1,-1)-(4D0*K(2)*QF(1)*PRE)/S34
        F(5,1,1) = F(5,1,1)-(4D0*K(2)*QF(1)*PRE)/S34
        F(6,-1,-1) = F(6,-1,-1)+(2D0*K(1)*K(2)*PRE)/(S34*XSW2)
        F(6,-1,1) = F(6,-1,1)+(2D0*K(1)*K(2)*PRE)/(S34*XSW2)
        F(6,1,-1) = F(6,1,-1)-(4D0*K(2)*QF(1)*PRE)/S34
        F(6,1,1) = F(6,1,1)-(4D0*K(2)*QF(1)*PRE)/S34
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(1)*K(2)*PRE)/(S34*XSW2)
        F(7,-1,1) = F(7,-1,1)+(2D0*K(1)*K(2)*PRE)/(S34*XSW2)
        F(7,1,-1) = F(7,1,-1)-(4D0*K(2)*QF(1)*PRE)/S34
        F(7,1,1) = F(7,1,1)-(4D0*K(2)*QF(1)*PRE)/S34
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(1)*K(2)*PRE)/(S34*XSW2)
        F(8,-1,1) = F(8,-1,1)+(2D0*K(1)*K(2)*PRE)/(S34*XSW2)
        F(8,1,-1) = F(8,1,-1)-(4D0*K(2)*QF(1)*PRE)/S34
        F(8,1,1) = F(8,1,1)-(4D0*K(2)*QF(1)*PRE)/S34

C       G(T9,N2833,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 2D0*C1(1)+C2(1,2)

        PRE = (QF(3)*ALPHA*CBA*PZ12*XMZ)/(8D0*PI*S34*XCW)

        F(1,-1,-1) = F(1,-1,-1)-(C2(0,0)*K(1)*PRE)/XSW
        F(1,-1,1) = F(1,-1,1)-(C2(0,0)*K(1)*PRE)/XSW
        F(1,1,-1) = F(1,1,-1)+2D0*C2(0,0)*QF(1)*PRE*XSW
        F(1,1,1) = F(1,1,1)+2D0*C2(0,0)*QF(1)*PRE*XSW
        F(5,-1,-1) = F(5,-1,-1)+(K(1)*K(2)*PRE)/XSW
        F(5,-1,1) = F(5,-1,1)+(K(1)*K(2)*PRE)/XSW
        F(5,1,-1) = F(5,1,-1)-2D0*K(2)*QF(1)*PRE*XSW
        F(5,1,1) = F(5,1,1)-2D0*K(2)*QF(1)*PRE*XSW
        F(6,-1,-1) = F(6,-1,-1)+(K(1)*K(2)*PRE)/XSW
        F(6,-1,1) = F(6,-1,1)+(K(1)*K(2)*PRE)/XSW
        F(6,1,-1) = F(6,1,-1)-2D0*K(2)*QF(1)*PRE*XSW
        F(6,1,1) = F(6,1,1)-2D0*K(2)*QF(1)*PRE*XSW
        F(7,-1,-1) = F(7,-1,-1)+(K(1)*K(2)*PRE)/XSW
        F(7,-1,1) = F(7,-1,1)+(K(1)*K(2)*PRE)/XSW
        F(7,1,-1) = F(7,1,-1)-2D0*K(2)*QF(1)*PRE*XSW
        F(7,1,1) = F(7,1,1)-2D0*K(2)*QF(1)*PRE*XSW
        F(8,-1,-1) = F(8,-1,-1)+(K(1)*K(2)*PRE)/XSW
        F(8,-1,1) = F(8,-1,1)+(K(1)*K(2)*PRE)/XSW
        F(8,1,-1) = F(8,1,-1)-2D0*K(2)*QF(1)*PRE*XSW
        F(8,1,1) = F(8,1,1)-2D0*K(2)*QF(1)*PRE*XSW

C       G(T9,N2834,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = S14+S24+T14
        K(3) = 2D0*C1(1)+4D0*C1(2)-C2(1,2)+4D0*C0
        K(4) = S13+S14+S23+S24
        K(5) = 2D0*S12+S13+S14+S23+S24
        K(6) = S13+S14+S23+S24+2D0*S34
        K(7) = -(2D0*C2(2,2))+S34**(-1)-(6D0*C2(0,0))/S34-(2D0*C2(1,
     &  1)*S12)/S34+(2D0*C2(1,2)*(S13+S14+S23+S24))/S34+(2D0*C1(1)*
     &  (2D0*S12+S13+S14+S23+S24))/S34-(2D0*C1(2)*(S13+S14+S23+S24+
     &  2D0*S34))/S34-(2D0*C0*(S14+S24+T14))/S34

        PRE = -((QF(3)*ALPHA*CBA*PZ12*XMW)/(32D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)-(K(1)*K(7)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)-(K(1)*K(7)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*K(7)*QF(1)*PRE
        F(1,1,1) = F(1,1,1)+2D0*K(7)*QF(1)*PRE
        F(5,-1,-1) = F(5,-1,-1)-(2D0*K(1)*K(3)*PRE)/(S34*XSW2)
        F(5,-1,1) = F(5,-1,1)-(2D0*K(1)*K(3)*PRE)/(S34*XSW2)
        F(5,1,-1) = F(5,1,-1)+(4D0*K(3)*QF(1)*PRE)/S34
        F(5,1,1) = F(5,1,1)+(4D0*K(3)*QF(1)*PRE)/S34
        F(6,-1,-1) = F(6,-1,-1)-(2D0*K(1)*K(3)*PRE)/(S34*XSW2)
        F(6,-1,1) = F(6,-1,1)-(2D0*K(1)*K(3)*PRE)/(S34*XSW2)
        F(6,1,-1) = F(6,1,-1)+(4D0*K(3)*QF(1)*PRE)/S34
        F(6,1,1) = F(6,1,1)+(4D0*K(3)*QF(1)*PRE)/S34
        F(7,-1,-1) = F(7,-1,-1)-(2D0*K(1)*K(3)*PRE)/(S34*XSW2)
        F(7,-1,1) = F(7,-1,1)-(2D0*K(1)*K(3)*PRE)/(S34*XSW2)
        F(7,1,-1) = F(7,1,-1)+(4D0*K(3)*QF(1)*PRE)/S34
        F(7,1,1) = F(7,1,1)+(4D0*K(3)*QF(1)*PRE)/S34
        F(8,-1,-1) = F(8,-1,-1)-(2D0*K(1)*K(3)*PRE)/(S34*XSW2)
        F(8,-1,1) = F(8,-1,1)-(2D0*K(1)*K(3)*PRE)/(S34*XSW2)
        F(8,1,-1) = F(8,1,-1)+(4D0*K(3)*QF(1)*PRE)/S34
        F(8,1,1) = F(8,1,1)+(4D0*K(3)*QF(1)*PRE)/S34

C       G(T9,N2835,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,0,0)

        PRE = -((QF(3)*ALPHA*C0*CBA*PZ12*XMW2*XMZ)/(8D0*PI*S34*XCW))

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE*XSW
        F(1,1,1) = F(1,1,1)+2D0*QF(1)*PRE*XSW

C       G(T9,N2836,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = -(C1(1))-C1(2)-10D0*C2(1,2)+4D0*C0
        K(3) = S13+S14+S23+S24
        K(4) = 2D0*S12-S13-S14-S23-S24
        K(5) = S13+S14+S23+S24-2D0*S34
        K(6) = -(4D0*C2(2,2))+6D0/S34-(36D0*C2(0,0))/S34-(4D0*C2(1,
     &  1)*S12)/S34+(4D0*C2(1,2)*(S13+S14+S23+S24))/S34+(5D0*C0*
     &  (S13+S14+S23+S24))/S34-(C1(1)*(2D0*S12-S13-S14-S23-S24))/
     &  S34+(C1(2)*(S13+S14+S23+S24-2D0*S34))/S34

        PRE = (QF(3)*ALPHA*CBA*PZ12*XMW)/(16D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)-(K(1)*K(6)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)-(K(1)*K(6)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*K(6)*QF(1)*PRE
        F(1,1,1) = F(1,1,1)+2D0*K(6)*QF(1)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(1)*K(2)*PRE)/(S34*XSW2)
        F(5,-1,1) = F(5,-1,1)+(2D0*K(1)*K(2)*PRE)/(S34*XSW2)
        F(5,1,-1) = F(5,1,-1)-(4D0*K(2)*QF(1)*PRE)/S34
        F(5,1,1) = F(5,1,1)-(4D0*K(2)*QF(1)*PRE)/S34
        F(6,-1,-1) = F(6,-1,-1)+(2D0*K(1)*K(2)*PRE)/(S34*XSW2)
        F(6,-1,1) = F(6,-1,1)+(2D0*K(1)*K(2)*PRE)/(S34*XSW2)
        F(6,1,-1) = F(6,1,-1)-(4D0*K(2)*QF(1)*PRE)/S34
        F(6,1,1) = F(6,1,1)-(4D0*K(2)*QF(1)*PRE)/S34
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(1)*K(2)*PRE)/(S34*XSW2)
        F(7,-1,1) = F(7,-1,1)+(2D0*K(1)*K(2)*PRE)/(S34*XSW2)
        F(7,1,-1) = F(7,1,-1)-(4D0*K(2)*QF(1)*PRE)/S34
        F(7,1,1) = F(7,1,1)-(4D0*K(2)*QF(1)*PRE)/S34
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(1)*K(2)*PRE)/(S34*XSW2)
        F(8,-1,1) = F(8,-1,1)+(2D0*K(1)*K(2)*PRE)/(S34*XSW2)
        F(8,1,-1) = F(8,1,-1)-(4D0*K(2)*QF(1)*PRE)/S34
        F(8,1,1) = F(8,1,1)-(4D0*K(2)*QF(1)*PRE)/S34

C       G(T9,N2837,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2

        PRE = (ALPHA*CBA*MHH2*PZ12*PZ34*XCW2**(-2)*(XCW+XSW)**2*
     &  (XCW-XSW)**2)/(32D0*PI*XMW*XSW)

        F(1,-1,-1) = F(1,-1,-1)-C2(0,0)*K(1)*K(2)*PRE*XSW2**(-2)
        F(1,-1,1) = F(1,-1,1)-(2D0*C2(0,0)*K(1)*QF(3)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*C2(0,0)*K(2)*QF(1)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+4D0*C2(0,0)*QF(1)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(5,-1,1) = F(5,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(6,-1,1) = F(6,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(7,-1,1) = F(7,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(8,-1,1) = F(8,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE

C       G(T9,N2838,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,0,0)

        PRE = -((ALPHA*C0*CBA*MHH2*PZ12*PZ34*XMZ2)/(32D0*PI*XCW2*
     &  XMW))

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)-2D0*QF(3)*PRE*XSW*(1D0-2D0*QF(1)*XSW2)
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE*XSW*(1D0+2D0*QF(3)*XSW2)
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*XSW*XSW2

C       G(T9,N2839,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = 2D0*C1(2)+C2(1,2)

        PRE = -((ALPHA*CBA*PZ12*PZ34*XMZ*(XCW+XSW)*(XCW-XSW))/(32D0*
     &  PI*XCW*XCW2))

        F(1,-1,-1) = F(1,-1,-1)-(C2(0,0)*K(1)*K(2)*PRE)/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*C2(0,0)*K(1)*QF(3)*PRE)/XSW
        F(1,1,-1) = F(1,1,-1)+(2D0*C2(0,0)*K(2)*QF(1)*PRE)/XSW
        F(1,1,1) = F(1,1,1)+4D0*C2(0,0)*QF(1)*QF(3)*PRE*XSW
        F(5,-1,-1) = F(5,-1,-1)+(K(1)*K(2)*K(3)*PRE)/(XSW*XSW2)
        F(5,-1,1) = F(5,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW
        F(5,1,-1) = F(5,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW
        F(5,1,1) = F(5,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE*XSW
        F(6,-1,-1) = F(6,-1,-1)+(K(1)*K(2)*K(3)*PRE)/(XSW*XSW2)
        F(6,-1,1) = F(6,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW
        F(6,1,-1) = F(6,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW
        F(6,1,1) = F(6,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE*XSW
        F(7,-1,-1) = F(7,-1,-1)+(K(1)*K(2)*K(3)*PRE)/(XSW*XSW2)
        F(7,-1,1) = F(7,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW
        F(7,1,-1) = F(7,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW
        F(7,1,1) = F(7,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE*XSW
        F(8,-1,-1) = F(8,-1,-1)+(K(1)*K(2)*K(3)*PRE)/(XSW*XSW2)
        F(8,-1,1) = F(8,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW
        F(8,1,-1) = F(8,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW
        F(8,1,1) = F(8,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE*XSW

C       G(T9,N2840,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = S23+S24+T12
        K(4) = 4D0*C1(1)+2D0*C1(2)-C2(1,2)+4D0*C0
        K(5) = S13+S14+S23+S24
        K(6) = 2D0*S12+S13+S14+S23+S24
        K(7) = S13+S14+S23+S24+2D0*S34
        K(8) = 1D0-6D0*C2(0,0)-2D0*C2(1,1)*S12+2D0*C2(1,2)*(S13+S14+
     &  S23+S24)-2D0*C1(1)*(2D0*S12+S13+S14+S23+S24)-2D0*C2(2,2)*
     &  S34+2D0*C1(2)*(S13+S14+S23+S24+2D0*S34)-2D0*C0*(S23+S24+T12)

        PRE = -((ALPHA*CBA*PZ12*PZ34*XMZ)/(64D0*PI*XCW))

        F(1,-1,-1) = F(1,-1,-1)-(K(1)*K(2)*K(8)*PRE)/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*K(1)*K(8)*QF(3)*PRE)/XSW
        F(1,1,-1) = F(1,1,-1)+(2D0*K(2)*K(8)*QF(1)*PRE)/XSW
        F(1,1,1) = F(1,1,1)+4D0*K(8)*QF(1)*QF(3)*PRE*XSW
        F(5,-1,-1) = F(5,-1,-1)-(2D0*K(1)*K(2)*K(4)*PRE)/(XSW*XSW2)
        F(5,-1,1) = F(5,-1,1)-(4D0*K(1)*K(4)*QF(3)*PRE)/XSW
        F(5,1,-1) = F(5,1,-1)+(4D0*K(2)*K(4)*QF(1)*PRE)/XSW
        F(5,1,1) = F(5,1,1)+8D0*K(4)*QF(1)*QF(3)*PRE*XSW
        F(6,-1,-1) = F(6,-1,-1)-(2D0*K(1)*K(2)*K(4)*PRE)/(XSW*XSW2)
        F(6,-1,1) = F(6,-1,1)-(4D0*K(1)*K(4)*QF(3)*PRE)/XSW
        F(6,1,-1) = F(6,1,-1)+(4D0*K(2)*K(4)*QF(1)*PRE)/XSW
        F(6,1,1) = F(6,1,1)+8D0*K(4)*QF(1)*QF(3)*PRE*XSW
        F(7,-1,-1) = F(7,-1,-1)-(2D0*K(1)*K(2)*K(4)*PRE)/(XSW*XSW2)
        F(7,-1,1) = F(7,-1,1)-(4D0*K(1)*K(4)*QF(3)*PRE)/XSW
        F(7,1,-1) = F(7,1,-1)+(4D0*K(2)*K(4)*QF(1)*PRE)/XSW
        F(7,1,1) = F(7,1,1)+8D0*K(4)*QF(1)*QF(3)*PRE*XSW
        F(8,-1,-1) = F(8,-1,-1)-(2D0*K(1)*K(2)*K(4)*PRE)/(XSW*XSW2)
        F(8,-1,1) = F(8,-1,1)-(4D0*K(1)*K(4)*QF(3)*PRE)/XSW
        F(8,1,-1) = F(8,1,-1)+(4D0*K(2)*K(4)*QF(1)*PRE)/XSW
        F(8,1,1) = F(8,1,1)+8D0*K(4)*QF(1)*QF(3)*PRE*XSW

C       G(T9,N2841,FULL)
        CALL xC01234_(S12,MHH2,S34,XMH02,XMA02,XMA02,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2

        PRE = (CBA**2*PI**(-2)*PZ12*PZ34*XCW2**(-2)*(4D0*ALPHA*CB**
     &  3*MHH2*PI*SA+4D0*ALPHA*CA*MHH2*PI*SB**3+4D0*ALPHA*C2B*MA02*
     &  PI*SBA-4D0*LAM5*SAB*XMW2*XSW2))/(128D0*CB*SB*XMW*XSW)

        F(1,-1,-1) = F(1,-1,-1)-C2(0,0)*K(1)*K(2)*PRE*XSW2**(-2)
        F(1,-1,1) = F(1,-1,1)-(2D0*C2(0,0)*K(1)*QF(3)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*C2(0,0)*K(2)*QF(1)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+4D0*C2(0,0)*QF(1)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(5,-1,1) = F(5,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(6,-1,1) = F(6,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(7,-1,1) = F(7,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(8,-1,1) = F(8,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE

C       G(T9,N2842,FULL)
        CALL xC01234_(S12,MHH2,S34,XMHH2,XMA02,XMA02,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2

        PRE = (PI**(-2)*PZ12*PZ34*SBA**2*XCW2**(-2)*(4D0*ALPHA*CB**
     &  3*MHH2*PI*SA+4D0*ALPHA*CA*MHH2*PI*SB**3+4D0*ALPHA*C2B*MA02*
     &  PI*SBA-4D0*LAM5*SAB*XMW2*XSW2))/(128D0*CB*SB*XMW*XSW)

        F(1,-1,-1) = F(1,-1,-1)-C2(0,0)*K(1)*K(2)*PRE*XSW2**(-2)
        F(1,-1,1) = F(1,-1,1)-(2D0*C2(0,0)*K(1)*QF(3)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*C2(0,0)*K(2)*QF(1)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+4D0*C2(0,0)*QF(1)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(5,-1,1) = F(5,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(6,-1,1) = F(6,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(7,-1,1) = F(7,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(8,-1,1) = F(8,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE

C       G(T9,N2843,FULL)
        CALL xC01234_(S12,MHH2,S34,XMH02,XMA02,XMZ2,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2

        PRE = (ALPHA*CBA*(MA02-MHH2)*PZ12*PZ34*SBA**2*XCW2**(-2))/
     &  (32D0*PI*XMW*XSW)

        F(1,-1,-1) = F(1,-1,-1)-C2(0,0)*K(1)*K(2)*PRE*XSW2**(-2)
        F(1,-1,1) = F(1,-1,1)-(2D0*C2(0,0)*K(1)*QF(3)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*C2(0,0)*K(2)*QF(1)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+4D0*C2(0,0)*QF(1)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(5,-1,1) = F(5,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(6,-1,1) = F(6,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(7,-1,1) = F(7,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(8,-1,1) = F(8,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE

C       G(T9,N2844,FULL)
        CALL xC01234_(S12,MHH2,S34,XMHH2,XMA02,XMZ2,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2

        PRE = -((ALPHA*CBA*(MA02-MHH2)*PZ12*PZ34*SBA**2*XCW2**(-2))/
     &  (32D0*PI*XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)-C2(0,0)*K(1)*K(2)*PRE*XSW2**(-2)
        F(1,-1,1) = F(1,-1,1)-(2D0*C2(0,0)*K(1)*QF(3)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*C2(0,0)*K(2)*QF(1)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+4D0*C2(0,0)*QF(1)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(5,-1,1) = F(5,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(6,-1,1) = F(6,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(7,-1,1) = F(7,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(8,-1,1) = F(8,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE

C       G(T9,N2845,FULL)
        CALL xC01234_(S12,MHH2,S34,XMH02,XMA02,XMZ2,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = 2D0*C1(2)+C2(1,2)

        PRE = -((ALPHA*CBA*PZ12*PZ34*SBA**2*XCW2**(-2)*XMZ)/(32D0*
     &  PI*XCW*XSW))

        F(1,-1,-1) = F(1,-1,-1)-C2(0,0)*K(1)*K(2)*PRE*XSW2**(-2)
        F(1,-1,1) = F(1,-1,1)-(2D0*C2(0,0)*K(1)*QF(3)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*C2(0,0)*K(2)*QF(1)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+4D0*C2(0,0)*QF(1)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+K(1)*K(2)*K(3)*PRE*XSW2**(-2)
        F(5,-1,1) = F(5,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)+K(1)*K(2)*K(3)*PRE*XSW2**(-2)
        F(6,-1,1) = F(6,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+K(1)*K(2)*K(3)*PRE*XSW2**(-2)
        F(7,-1,1) = F(7,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)+K(1)*K(2)*K(3)*PRE*XSW2**(-2)
        F(8,-1,1) = F(8,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE

C       G(T9,N2846,FULL)
        CALL xC01234_(S12,MHH2,S34,XMHH2,XMA02,XMZ2,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = 2D0*C1(2)+C2(1,2)

        PRE = (ALPHA*CBA*PZ12*PZ34*SBA**2*XCW2**(-2)*XMZ)/(32D0*PI*
     &  XCW*XSW)

        F(1,-1,-1) = F(1,-1,-1)-C2(0,0)*K(1)*K(2)*PRE*XSW2**(-2)
        F(1,-1,1) = F(1,-1,1)-(2D0*C2(0,0)*K(1)*QF(3)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*C2(0,0)*K(2)*QF(1)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+4D0*C2(0,0)*QF(1)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+K(1)*K(2)*K(3)*PRE*XSW2**(-2)
        F(5,-1,1) = F(5,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)+K(1)*K(2)*K(3)*PRE*XSW2**(-2)
        F(6,-1,1) = F(6,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+K(1)*K(2)*K(3)*PRE*XSW2**(-2)
        F(7,-1,1) = F(7,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)+K(1)*K(2)*K(3)*PRE*XSW2**(-2)
        F(8,-1,1) = F(8,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE

C       G(T9,N2847,FULL)
        CALL xC01234_(S12,MHH2,S34,XMH02,XMZ2,XMA02,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2

        PRE = (ALPHA*CBA*(MA02-MHH2)*PZ12*PZ34*SBA**2*XCW2**(-2))/
     &  (32D0*PI*XMW*XSW)

        F(1,-1,-1) = F(1,-1,-1)-C2(0,0)*K(1)*K(2)*PRE*XSW2**(-2)
        F(1,-1,1) = F(1,-1,1)-(2D0*C2(0,0)*K(1)*QF(3)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*C2(0,0)*K(2)*QF(1)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+4D0*C2(0,0)*QF(1)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(5,-1,1) = F(5,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(6,-1,1) = F(6,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(7,-1,1) = F(7,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(8,-1,1) = F(8,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE

C       G(T9,N2848,FULL)
        CALL xC01234_(S12,MHH2,S34,XMHH2,XMZ2,XMA02,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2

        PRE = -((ALPHA*CBA*(MA02-MHH2)*PZ12*PZ34*SBA**2*XCW2**(-2))/
     &  (32D0*PI*XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)-C2(0,0)*K(1)*K(2)*PRE*XSW2**(-2)
        F(1,-1,1) = F(1,-1,1)-(2D0*C2(0,0)*K(1)*QF(3)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*C2(0,0)*K(2)*QF(1)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+4D0*C2(0,0)*QF(1)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(5,-1,1) = F(5,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(6,-1,1) = F(6,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(7,-1,1) = F(7,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(8,-1,1) = F(8,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE

C       G(T9,N2849,FULL)
        CALL xC01234_(S12,MHH2,S34,XMH02,XMZ2,XMZ2,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2

        PRE = (ALPHA*CBA*MHH2*PZ12*PZ34*SBA**2*XCW2**(-2))/(32D0*PI*
     &  XMW*XSW)

        F(1,-1,-1) = F(1,-1,-1)-C2(0,0)*K(1)*K(2)*PRE*XSW2**(-2)
        F(1,-1,1) = F(1,-1,1)-(2D0*C2(0,0)*K(1)*QF(3)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*C2(0,0)*K(2)*QF(1)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+4D0*C2(0,0)*QF(1)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(5,-1,1) = F(5,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(6,-1,1) = F(6,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(7,-1,1) = F(7,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(8,-1,1) = F(8,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE

C       G(T9,N2850,FULL)
        CALL xC01234_(S12,MHH2,S34,XMHH2,XMZ2,XMZ2,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2

        PRE = (ALPHA*CBA**3*MHH2*PZ12*PZ34*XCW2**(-2))/(32D0*PI*XMW*
     &  XSW)

        F(1,-1,-1) = F(1,-1,-1)-C2(0,0)*K(1)*K(2)*PRE*XSW2**(-2)
        F(1,-1,1) = F(1,-1,1)-(2D0*C2(0,0)*K(1)*QF(3)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*C2(0,0)*K(2)*QF(1)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+4D0*C2(0,0)*QF(1)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(5,-1,1) = F(5,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(6,-1,1) = F(6,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(7,-1,1) = F(7,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(8,-1,1) = F(8,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE

C       G(T9,N2851,FULL)
        CALL xC01234_(S12,MHH2,S34,XMH02,XMZ2,XMZ2,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = 2D0*C1(2)+C2(1,2)

        PRE = (ALPHA*CBA*PZ12*PZ34*SBA**2*XCW2**(-2)*XMZ)/(32D0*PI*
     &  XCW*XSW)

        F(1,-1,-1) = F(1,-1,-1)-C2(0,0)*K(1)*K(2)*PRE*XSW2**(-2)
        F(1,-1,1) = F(1,-1,1)-(2D0*C2(0,0)*K(1)*QF(3)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*C2(0,0)*K(2)*QF(1)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+4D0*C2(0,0)*QF(1)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+K(1)*K(2)*K(3)*PRE*XSW2**(-2)
        F(5,-1,1) = F(5,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)+K(1)*K(2)*K(3)*PRE*XSW2**(-2)
        F(6,-1,1) = F(6,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+K(1)*K(2)*K(3)*PRE*XSW2**(-2)
        F(7,-1,1) = F(7,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)+K(1)*K(2)*K(3)*PRE*XSW2**(-2)
        F(8,-1,1) = F(8,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE

C       G(T9,N2852,FULL)
        CALL xC01234_(S12,MHH2,S34,XMHH2,XMZ2,XMZ2,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = 2D0*C1(2)+C2(1,2)

        PRE = (ALPHA*CBA**3*PZ12*PZ34*XCW2**(-2)*XMZ)/(32D0*PI*XCW*
     &  XSW)

        F(1,-1,-1) = F(1,-1,-1)-C2(0,0)*K(1)*K(2)*PRE*XSW2**(-2)
        F(1,-1,1) = F(1,-1,1)-(2D0*C2(0,0)*K(1)*QF(3)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*C2(0,0)*K(2)*QF(1)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+4D0*C2(0,0)*QF(1)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+K(1)*K(2)*K(3)*PRE*XSW2**(-2)
        F(5,-1,1) = F(5,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)+K(1)*K(2)*K(3)*PRE*XSW2**(-2)
        F(6,-1,1) = F(6,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+K(1)*K(2)*K(3)*PRE*XSW2**(-2)
        F(7,-1,1) = F(7,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)+K(1)*K(2)*K(3)*PRE*XSW2**(-2)
        F(8,-1,1) = F(8,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE

C       G(T9,N2853,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2

        PRE = (ALPHA*CBA*MHH2*PZ12*PZ34*XCW2**(-2)*(XCW+XSW)**2*
     &  (XCW-XSW)**2)/(32D0*PI*XMW*XSW)

        F(1,-1,-1) = F(1,-1,-1)-C2(0,0)*K(1)*K(2)*PRE*XSW2**(-2)
        F(1,-1,1) = F(1,-1,1)-(2D0*C2(0,0)*K(1)*QF(3)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*C2(0,0)*K(2)*QF(1)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+4D0*C2(0,0)*QF(1)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(5,-1,1) = F(5,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(6,-1,1) = F(6,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(7,-1,1) = F(7,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(8,-1,1) = F(8,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE

C       G(T9,N2854,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,0,0)

        PRE = -((ALPHA*C0*CBA*MHH2*PZ12*PZ34*XMZ2)/(32D0*PI*XCW2*
     &  XMW))

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)-2D0*QF(3)*PRE*XSW*(1D0-2D0*QF(1)*XSW2)
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE*XSW*(1D0+2D0*QF(3)*XSW2)
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*XSW*XSW2

C       G(T9,N2855,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = 2D0*C1(2)+C2(1,2)

        PRE = -((ALPHA*CBA*PZ12*PZ34*XMZ*(XCW+XSW)*(XCW-XSW))/(32D0*
     &  PI*XCW*XCW2))

        F(1,-1,-1) = F(1,-1,-1)-(C2(0,0)*K(1)*K(2)*PRE)/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*C2(0,0)*K(1)*QF(3)*PRE)/XSW
        F(1,1,-1) = F(1,1,-1)+(2D0*C2(0,0)*K(2)*QF(1)*PRE)/XSW
        F(1,1,1) = F(1,1,1)+4D0*C2(0,0)*QF(1)*QF(3)*PRE*XSW
        F(5,-1,-1) = F(5,-1,-1)+(K(1)*K(2)*K(3)*PRE)/(XSW*XSW2)
        F(5,-1,1) = F(5,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW
        F(5,1,-1) = F(5,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW
        F(5,1,1) = F(5,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE*XSW
        F(6,-1,-1) = F(6,-1,-1)+(K(1)*K(2)*K(3)*PRE)/(XSW*XSW2)
        F(6,-1,1) = F(6,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW
        F(6,1,-1) = F(6,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW
        F(6,1,1) = F(6,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE*XSW
        F(7,-1,-1) = F(7,-1,-1)+(K(1)*K(2)*K(3)*PRE)/(XSW*XSW2)
        F(7,-1,1) = F(7,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW
        F(7,1,-1) = F(7,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW
        F(7,1,1) = F(7,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE*XSW
        F(8,-1,-1) = F(8,-1,-1)+(K(1)*K(2)*K(3)*PRE)/(XSW*XSW2)
        F(8,-1,1) = F(8,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW
        F(8,1,-1) = F(8,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW
        F(8,1,1) = F(8,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE*XSW

C       G(T9,N2856,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = S23+S24+T12
        K(4) = 4D0*C1(1)+2D0*C1(2)-C2(1,2)+4D0*C0
        K(5) = S13+S14+S23+S24
        K(6) = 2D0*S12+S13+S14+S23+S24
        K(7) = S13+S14+S23+S24+2D0*S34
        K(8) = 1D0-6D0*C2(0,0)-2D0*C2(1,1)*S12+2D0*C2(1,2)*(S13+S14+
     &  S23+S24)-2D0*C1(1)*(2D0*S12+S13+S14+S23+S24)-2D0*C2(2,2)*
     &  S34+2D0*C1(2)*(S13+S14+S23+S24+2D0*S34)-2D0*C0*(S23+S24+T12)

        PRE = -((ALPHA*CBA*PZ12*PZ34*XMZ)/(64D0*PI*XCW))

        F(1,-1,-1) = F(1,-1,-1)-(K(1)*K(2)*K(8)*PRE)/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*K(1)*K(8)*QF(3)*PRE)/XSW
        F(1,1,-1) = F(1,1,-1)+(2D0*K(2)*K(8)*QF(1)*PRE)/XSW
        F(1,1,1) = F(1,1,1)+4D0*K(8)*QF(1)*QF(3)*PRE*XSW
        F(5,-1,-1) = F(5,-1,-1)-(2D0*K(1)*K(2)*K(4)*PRE)/(XSW*XSW2)
        F(5,-1,1) = F(5,-1,1)-(4D0*K(1)*K(4)*QF(3)*PRE)/XSW
        F(5,1,-1) = F(5,1,-1)+(4D0*K(2)*K(4)*QF(1)*PRE)/XSW
        F(5,1,1) = F(5,1,1)+8D0*K(4)*QF(1)*QF(3)*PRE*XSW
        F(6,-1,-1) = F(6,-1,-1)-(2D0*K(1)*K(2)*K(4)*PRE)/(XSW*XSW2)
        F(6,-1,1) = F(6,-1,1)-(4D0*K(1)*K(4)*QF(3)*PRE)/XSW
        F(6,1,-1) = F(6,1,-1)+(4D0*K(2)*K(4)*QF(1)*PRE)/XSW
        F(6,1,1) = F(6,1,1)+8D0*K(4)*QF(1)*QF(3)*PRE*XSW
        F(7,-1,-1) = F(7,-1,-1)-(2D0*K(1)*K(2)*K(4)*PRE)/(XSW*XSW2)
        F(7,-1,1) = F(7,-1,1)-(4D0*K(1)*K(4)*QF(3)*PRE)/XSW
        F(7,1,-1) = F(7,1,-1)+(4D0*K(2)*K(4)*QF(1)*PRE)/XSW
        F(7,1,1) = F(7,1,1)+8D0*K(4)*QF(1)*QF(3)*PRE*XSW
        F(8,-1,-1) = F(8,-1,-1)-(2D0*K(1)*K(2)*K(4)*PRE)/(XSW*XSW2)
        F(8,-1,1) = F(8,-1,1)-(4D0*K(1)*K(4)*QF(3)*PRE)/XSW
        F(8,1,-1) = F(8,1,-1)+(4D0*K(2)*K(4)*QF(1)*PRE)/XSW
        F(8,1,1) = F(8,1,1)+8D0*K(4)*QF(1)*QF(3)*PRE*XSW

C       G(T9,N2857,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = 2D0*C1(1)+C2(1,2)

        PRE = -((ALPHA*CBA*PZ12*PZ34*XMZ*(XCW+XSW)*(XCW-XSW))/(32D0*
     &  PI*XCW*XCW2))

        F(1,-1,-1) = F(1,-1,-1)-(C2(0,0)*K(1)*K(2)*PRE)/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*C2(0,0)*K(1)*QF(3)*PRE)/XSW
        F(1,1,-1) = F(1,1,-1)+(2D0*C2(0,0)*K(2)*QF(1)*PRE)/XSW
        F(1,1,1) = F(1,1,1)+4D0*C2(0,0)*QF(1)*QF(3)*PRE*XSW
        F(5,-1,-1) = F(5,-1,-1)+(K(1)*K(2)*K(3)*PRE)/(XSW*XSW2)
        F(5,-1,1) = F(5,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW
        F(5,1,-1) = F(5,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW
        F(5,1,1) = F(5,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE*XSW
        F(6,-1,-1) = F(6,-1,-1)+(K(1)*K(2)*K(3)*PRE)/(XSW*XSW2)
        F(6,-1,1) = F(6,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW
        F(6,1,-1) = F(6,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW
        F(6,1,1) = F(6,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE*XSW
        F(7,-1,-1) = F(7,-1,-1)+(K(1)*K(2)*K(3)*PRE)/(XSW*XSW2)
        F(7,-1,1) = F(7,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW
        F(7,1,-1) = F(7,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW
        F(7,1,1) = F(7,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE*XSW
        F(8,-1,-1) = F(8,-1,-1)+(K(1)*K(2)*K(3)*PRE)/(XSW*XSW2)
        F(8,-1,1) = F(8,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW
        F(8,1,-1) = F(8,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW
        F(8,1,1) = F(8,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE*XSW

C       G(T9,N2858,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = S14+S24+T14
        K(4) = 2D0*C1(1)+4D0*C1(2)-C2(1,2)+4D0*C0
        K(5) = S13+S14+S23+S24
        K(6) = 2D0*S12+S13+S14+S23+S24
        K(7) = S13+S14+S23+S24+2D0*S34
        K(8) = 1D0-6D0*C2(0,0)-2D0*C2(1,1)*S12+2D0*C2(1,2)*(S13+S14+
     &  S23+S24)+2D0*C1(1)*(2D0*S12+S13+S14+S23+S24)-2D0*C2(2,2)*
     &  S34-2D0*C1(2)*(S13+S14+S23+S24+2D0*S34)-2D0*C0*(S14+S24+T14)

        PRE = -((ALPHA*CBA*PZ12*PZ34*XMZ)/(64D0*PI*XCW))

        F(1,-1,-1) = F(1,-1,-1)-(K(1)*K(2)*K(8)*PRE)/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*K(1)*K(8)*QF(3)*PRE)/XSW
        F(1,1,-1) = F(1,1,-1)+(2D0*K(2)*K(8)*QF(1)*PRE)/XSW
        F(1,1,1) = F(1,1,1)+4D0*K(8)*QF(1)*QF(3)*PRE*XSW
        F(5,-1,-1) = F(5,-1,-1)-(2D0*K(1)*K(2)*K(4)*PRE)/(XSW*XSW2)
        F(5,-1,1) = F(5,-1,1)-(4D0*K(1)*K(4)*QF(3)*PRE)/XSW
        F(5,1,-1) = F(5,1,-1)+(4D0*K(2)*K(4)*QF(1)*PRE)/XSW
        F(5,1,1) = F(5,1,1)+8D0*K(4)*QF(1)*QF(3)*PRE*XSW
        F(6,-1,-1) = F(6,-1,-1)-(2D0*K(1)*K(2)*K(4)*PRE)/(XSW*XSW2)
        F(6,-1,1) = F(6,-1,1)-(4D0*K(1)*K(4)*QF(3)*PRE)/XSW
        F(6,1,-1) = F(6,1,-1)+(4D0*K(2)*K(4)*QF(1)*PRE)/XSW
        F(6,1,1) = F(6,1,1)+8D0*K(4)*QF(1)*QF(3)*PRE*XSW
        F(7,-1,-1) = F(7,-1,-1)-(2D0*K(1)*K(2)*K(4)*PRE)/(XSW*XSW2)
        F(7,-1,1) = F(7,-1,1)-(4D0*K(1)*K(4)*QF(3)*PRE)/XSW
        F(7,1,-1) = F(7,1,-1)+(4D0*K(2)*K(4)*QF(1)*PRE)/XSW
        F(7,1,1) = F(7,1,1)+8D0*K(4)*QF(1)*QF(3)*PRE*XSW
        F(8,-1,-1) = F(8,-1,-1)-(2D0*K(1)*K(2)*K(4)*PRE)/(XSW*XSW2)
        F(8,-1,1) = F(8,-1,1)-(4D0*K(1)*K(4)*QF(3)*PRE)/XSW
        F(8,1,-1) = F(8,1,-1)+(4D0*K(2)*K(4)*QF(1)*PRE)/XSW
        F(8,1,1) = F(8,1,1)+8D0*K(4)*QF(1)*QF(3)*PRE*XSW

C       G(T9,N2859,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,0,0)

        PRE = -((ALPHA*C0*CBA*PZ12*PZ34*XMW*XMZ2)/(16D0*PI*XCW2))

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)-2D0*QF(3)*PRE*XSW*(1D0-2D0*QF(1)*XSW2)
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE*XSW*(1D0+2D0*QF(3)*XSW2)
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*XSW*XSW2

C       G(T9,N2860,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = -(C1(1))-C1(2)-10D0*C2(1,2)+4D0*C0
        K(4) = S13+S14+S23+S24
        K(5) = 2D0*S12-S13-S14-S23-S24
        K(6) = S13+S14+S23+S24-2D0*S34
        K(7) = 6D0-36D0*C2(0,0)-4D0*C2(1,1)*S12+4D0*C2(1,2)*(S13+
     &  S14+S23+S24)+5D0*C0*(S13+S14+S23+S24)-C1(1)*(2D0*S12-S13-
     &  S14-S23-S24)-4D0*C2(2,2)*S34+C1(2)*(S13+S14+S23+S24-2D0*S34)

        PRE = -((ALPHA*CBA*PZ12*PZ34*XMW)/(32D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)-K(1)*K(2)*K(7)*PRE*XSW2**(-2)
        F(1,-1,1) = F(1,-1,1)-(2D0*K(1)*K(7)*QF(3)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*K(2)*K(7)*QF(1)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+4D0*K(7)*QF(1)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+2D0*K(1)*K(2)*K(3)*PRE*XSW2**(-2)
        F(5,-1,1) = F(5,-1,1)+(4D0*K(1)*K(3)*QF(3)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-(4D0*K(2)*K(3)*QF(1)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-8D0*K(3)*QF(1)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)+2D0*K(1)*K(2)*K(3)*PRE*XSW2**(-2)
        F(6,-1,1) = F(6,-1,1)+(4D0*K(1)*K(3)*QF(3)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-(4D0*K(2)*K(3)*QF(1)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-8D0*K(3)*QF(1)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+2D0*K(1)*K(2)*K(3)*PRE*XSW2**(-2)
        F(7,-1,1) = F(7,-1,1)+(4D0*K(1)*K(3)*QF(3)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-(4D0*K(2)*K(3)*QF(1)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-8D0*K(3)*QF(1)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)+2D0*K(1)*K(2)*K(3)*PRE*XSW2**(-2)
        F(8,-1,1) = F(8,-1,1)+(4D0*K(1)*K(3)*QF(3)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-(4D0*K(2)*K(3)*QF(1)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-8D0*K(3)*QF(1)*QF(3)*PRE

C       G(T9,N2861,FULL)
        CALL xC01234_(S12,MHH2,S34,XMH02,XMZ2,XMA02,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = 2D0*C1(1)+C2(1,2)

        PRE = -((ALPHA*CBA*PZ12*PZ34*SBA**2*XCW2**(-2)*XMZ)/(32D0*
     &  PI*XCW*XSW))

        F(1,-1,-1) = F(1,-1,-1)-C2(0,0)*K(1)*K(2)*PRE*XSW2**(-2)
        F(1,-1,1) = F(1,-1,1)-(2D0*C2(0,0)*K(1)*QF(3)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*C2(0,0)*K(2)*QF(1)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+4D0*C2(0,0)*QF(1)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+K(1)*K(2)*K(3)*PRE*XSW2**(-2)
        F(5,-1,1) = F(5,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)+K(1)*K(2)*K(3)*PRE*XSW2**(-2)
        F(6,-1,1) = F(6,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+K(1)*K(2)*K(3)*PRE*XSW2**(-2)
        F(7,-1,1) = F(7,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)+K(1)*K(2)*K(3)*PRE*XSW2**(-2)
        F(8,-1,1) = F(8,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE

C       G(T9,N2862,FULL)
        CALL xC01234_(S12,MHH2,S34,XMHH2,XMZ2,XMA02,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = 2D0*C1(1)+C2(1,2)

        PRE = (ALPHA*CBA*PZ12*PZ34*SBA**2*XCW2**(-2)*XMZ)/(32D0*PI*
     &  XCW*XSW)

        F(1,-1,-1) = F(1,-1,-1)-C2(0,0)*K(1)*K(2)*PRE*XSW2**(-2)
        F(1,-1,1) = F(1,-1,1)-(2D0*C2(0,0)*K(1)*QF(3)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*C2(0,0)*K(2)*QF(1)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+4D0*C2(0,0)*QF(1)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+K(1)*K(2)*K(3)*PRE*XSW2**(-2)
        F(5,-1,1) = F(5,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)+K(1)*K(2)*K(3)*PRE*XSW2**(-2)
        F(6,-1,1) = F(6,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+K(1)*K(2)*K(3)*PRE*XSW2**(-2)
        F(7,-1,1) = F(7,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)+K(1)*K(2)*K(3)*PRE*XSW2**(-2)
        F(8,-1,1) = F(8,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE

C       G(T9,N2863,FULL)
        CALL xC01234_(S12,MHH2,S34,XMH02,XMZ2,XMZ2,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = 2D0*C1(1)+C2(1,2)

        PRE = (ALPHA*CBA*PZ12*PZ34*SBA**2*XCW2**(-2)*XMZ)/(32D0*PI*
     &  XCW*XSW)

        F(1,-1,-1) = F(1,-1,-1)-C2(0,0)*K(1)*K(2)*PRE*XSW2**(-2)
        F(1,-1,1) = F(1,-1,1)-(2D0*C2(0,0)*K(1)*QF(3)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*C2(0,0)*K(2)*QF(1)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+4D0*C2(0,0)*QF(1)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+K(1)*K(2)*K(3)*PRE*XSW2**(-2)
        F(5,-1,1) = F(5,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)+K(1)*K(2)*K(3)*PRE*XSW2**(-2)
        F(6,-1,1) = F(6,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+K(1)*K(2)*K(3)*PRE*XSW2**(-2)
        F(7,-1,1) = F(7,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)+K(1)*K(2)*K(3)*PRE*XSW2**(-2)
        F(8,-1,1) = F(8,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE

C       G(T9,N2864,FULL)
        CALL xC01234_(S12,MHH2,S34,XMHH2,XMZ2,XMZ2,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = 2D0*C1(1)+C2(1,2)

        PRE = (ALPHA*CBA**3*PZ12*PZ34*XCW2**(-2)*XMZ)/(32D0*PI*XCW*
     &  XSW)

        F(1,-1,-1) = F(1,-1,-1)-C2(0,0)*K(1)*K(2)*PRE*XSW2**(-2)
        F(1,-1,1) = F(1,-1,1)-(2D0*C2(0,0)*K(1)*QF(3)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*C2(0,0)*K(2)*QF(1)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+4D0*C2(0,0)*QF(1)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+K(1)*K(2)*K(3)*PRE*XSW2**(-2)
        F(5,-1,1) = F(5,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)+K(1)*K(2)*K(3)*PRE*XSW2**(-2)
        F(6,-1,1) = F(6,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+K(1)*K(2)*K(3)*PRE*XSW2**(-2)
        F(7,-1,1) = F(7,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)+K(1)*K(2)*K(3)*PRE*XSW2**(-2)
        F(8,-1,1) = F(8,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE

C       G(T9,N2865,FULL)
        CALL xC01234_(S12,MHH2,S34,XMH02,XMZ2,XMZ2,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,0,0)

        PRE = -((ALPHA*C0*CBA*PZ12*PZ34*SBA**2*XCW2**(-2)*XMZ*XMZ2)/
     &  (16D0*PI*XCW*XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T9,N2866,FULL)
        CALL xC01234_(S12,MHH2,S34,XMHH2,XMZ2,XMZ2,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,0,0)

        PRE = -((ALPHA*C0*CBA**3*PZ12*PZ34*XCW2**(-2)*XMZ*XMZ2)/
     &  (16D0*PI*XCW*XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T9,N2867,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = 2D0*C1(1)+C2(1,2)

        PRE = -((ALPHA*CBA*PZ12*PZ34*XMZ*(XCW+XSW)*(XCW-XSW))/(32D0*
     &  PI*XCW*XCW2))

        F(1,-1,-1) = F(1,-1,-1)-(C2(0,0)*K(1)*K(2)*PRE)/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*C2(0,0)*K(1)*QF(3)*PRE)/XSW
        F(1,1,-1) = F(1,1,-1)+(2D0*C2(0,0)*K(2)*QF(1)*PRE)/XSW
        F(1,1,1) = F(1,1,1)+4D0*C2(0,0)*QF(1)*QF(3)*PRE*XSW
        F(5,-1,-1) = F(5,-1,-1)+(K(1)*K(2)*K(3)*PRE)/(XSW*XSW2)
        F(5,-1,1) = F(5,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW
        F(5,1,-1) = F(5,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW
        F(5,1,1) = F(5,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE*XSW
        F(6,-1,-1) = F(6,-1,-1)+(K(1)*K(2)*K(3)*PRE)/(XSW*XSW2)
        F(6,-1,1) = F(6,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW
        F(6,1,-1) = F(6,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW
        F(6,1,1) = F(6,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE*XSW
        F(7,-1,-1) = F(7,-1,-1)+(K(1)*K(2)*K(3)*PRE)/(XSW*XSW2)
        F(7,-1,1) = F(7,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW
        F(7,1,-1) = F(7,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW
        F(7,1,1) = F(7,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE*XSW
        F(8,-1,-1) = F(8,-1,-1)+(K(1)*K(2)*K(3)*PRE)/(XSW*XSW2)
        F(8,-1,1) = F(8,-1,1)+(2D0*K(1)*K(3)*QF(3)*PRE)/XSW
        F(8,1,-1) = F(8,1,-1)-(2D0*K(2)*K(3)*QF(1)*PRE)/XSW
        F(8,1,1) = F(8,1,1)-4D0*K(3)*QF(1)*QF(3)*PRE*XSW

C       G(T9,N2868,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = S14+S24+T14
        K(4) = 2D0*C1(1)+4D0*C1(2)-C2(1,2)+4D0*C0
        K(5) = S13+S14+S23+S24
        K(6) = 2D0*S12+S13+S14+S23+S24
        K(7) = S13+S14+S23+S24+2D0*S34
        K(8) = 1D0-6D0*C2(0,0)-2D0*C2(1,1)*S12+2D0*C2(1,2)*(S13+S14+
     &  S23+S24)+2D0*C1(1)*(2D0*S12+S13+S14+S23+S24)-2D0*C2(2,2)*
     &  S34-2D0*C1(2)*(S13+S14+S23+S24+2D0*S34)-2D0*C0*(S14+S24+T14)

        PRE = -((ALPHA*CBA*PZ12*PZ34*XMZ)/(64D0*PI*XCW))

        F(1,-1,-1) = F(1,-1,-1)-(K(1)*K(2)*K(8)*PRE)/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*K(1)*K(8)*QF(3)*PRE)/XSW
        F(1,1,-1) = F(1,1,-1)+(2D0*K(2)*K(8)*QF(1)*PRE)/XSW
        F(1,1,1) = F(1,1,1)+4D0*K(8)*QF(1)*QF(3)*PRE*XSW
        F(5,-1,-1) = F(5,-1,-1)-(2D0*K(1)*K(2)*K(4)*PRE)/(XSW*XSW2)
        F(5,-1,1) = F(5,-1,1)-(4D0*K(1)*K(4)*QF(3)*PRE)/XSW
        F(5,1,-1) = F(5,1,-1)+(4D0*K(2)*K(4)*QF(1)*PRE)/XSW
        F(5,1,1) = F(5,1,1)+8D0*K(4)*QF(1)*QF(3)*PRE*XSW
        F(6,-1,-1) = F(6,-1,-1)-(2D0*K(1)*K(2)*K(4)*PRE)/(XSW*XSW2)
        F(6,-1,1) = F(6,-1,1)-(4D0*K(1)*K(4)*QF(3)*PRE)/XSW
        F(6,1,-1) = F(6,1,-1)+(4D0*K(2)*K(4)*QF(1)*PRE)/XSW
        F(6,1,1) = F(6,1,1)+8D0*K(4)*QF(1)*QF(3)*PRE*XSW
        F(7,-1,-1) = F(7,-1,-1)-(2D0*K(1)*K(2)*K(4)*PRE)/(XSW*XSW2)
        F(7,-1,1) = F(7,-1,1)-(4D0*K(1)*K(4)*QF(3)*PRE)/XSW
        F(7,1,-1) = F(7,1,-1)+(4D0*K(2)*K(4)*QF(1)*PRE)/XSW
        F(7,1,1) = F(7,1,1)+8D0*K(4)*QF(1)*QF(3)*PRE*XSW
        F(8,-1,-1) = F(8,-1,-1)-(2D0*K(1)*K(2)*K(4)*PRE)/(XSW*XSW2)
        F(8,-1,1) = F(8,-1,1)-(4D0*K(1)*K(4)*QF(3)*PRE)/XSW
        F(8,1,-1) = F(8,1,-1)+(4D0*K(2)*K(4)*QF(1)*PRE)/XSW
        F(8,1,1) = F(8,1,1)+8D0*K(4)*QF(1)*QF(3)*PRE*XSW

C       G(T9,N2869,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,0,0)

        PRE = -((ALPHA*C0*CBA*PZ12*PZ34*XMW*XMZ2)/(16D0*PI*XCW2))

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)-2D0*QF(3)*PRE*XSW*(1D0-2D0*QF(1)*XSW2)
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE*XSW*(1D0+2D0*QF(3)*XSW2)
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*XSW*XSW2

C       G(T9,N2870,FULL)
        CALL xC01234_(S12,MHH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = -(C1(1))-C1(2)-10D0*C2(1,2)+4D0*C0
        K(4) = S13+S14+S23+S24
        K(5) = 2D0*S12-S13-S14-S23-S24
        K(6) = S13+S14+S23+S24-2D0*S34
        K(7) = 6D0-36D0*C2(0,0)-4D0*C2(1,1)*S12+4D0*C2(1,2)*(S13+
     &  S14+S23+S24)+5D0*C0*(S13+S14+S23+S24)-C1(1)*(2D0*S12-S13-
     &  S14-S23-S24)-4D0*C2(2,2)*S34+C1(2)*(S13+S14+S23+S24-2D0*S34)

        PRE = -((ALPHA*CBA*PZ12*PZ34*XMW)/(32D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)-K(1)*K(2)*K(7)*PRE*XSW2**(-2)
        F(1,-1,1) = F(1,-1,1)-(2D0*K(1)*K(7)*QF(3)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*K(2)*K(7)*QF(1)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+4D0*K(7)*QF(1)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+2D0*K(1)*K(2)*K(3)*PRE*XSW2**(-2)
        F(5,-1,1) = F(5,-1,1)+(4D0*K(1)*K(3)*QF(3)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-(4D0*K(2)*K(3)*QF(1)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-8D0*K(3)*QF(1)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)+2D0*K(1)*K(2)*K(3)*PRE*XSW2**(-2)
        F(6,-1,1) = F(6,-1,1)+(4D0*K(1)*K(3)*QF(3)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-(4D0*K(2)*K(3)*QF(1)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-8D0*K(3)*QF(1)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+2D0*K(1)*K(2)*K(3)*PRE*XSW2**(-2)
        F(7,-1,1) = F(7,-1,1)+(4D0*K(1)*K(3)*QF(3)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-(4D0*K(2)*K(3)*QF(1)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-8D0*K(3)*QF(1)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)+2D0*K(1)*K(2)*K(3)*PRE*XSW2**(-2)
        F(8,-1,1) = F(8,-1,1)+(4D0*K(1)*K(3)*QF(3)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-(4D0*K(2)*K(3)*QF(1)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-8D0*K(3)*QF(1)*QF(3)*PRE

C       G(T9,N2871,FULL)

C       G(T9,N2872,FULL)

C       G(T9,N2873,FULL)

C       G(T9,N2874,FULL)

C       G(T9,N2875,FULL)

C       G(T9,N2876,FULL)

C       G(T9,N2877,FULL)

C       G(T9,N2878,FULL)

C       G(T9,N2879,FULL)

C       G(T9,N2880,FULL)

C       G(T9,N2881,FULL)

C       G(T9,N2882,FULL)

C       G(T9,N2883,FULL)

C       G(T9,N2884,FULL)

C       G(T9,N2885,FULL)

C       G(T9,N2886,FULL)

C       G(T9,N2887,FULL)

C       G(T9,N2888,FULL)

C       G(T9,N2889,FULL)

C       G(T9,N2890,FULL)

C       G(T9,N2891,FULL)

C       G(T9,N2892,FULL)

C       G(T9,N2893,FULL)

C       G(T9,N2894,FULL)

C       G(T9,N2895,FULL)

C       G(T9,N2896,FULL)

C       G(T9,N2897,FULL)

C       G(T9,N2898,FULL)

C       G(T9,N2899,FULL)

C       G(T9,N2900,FULL)

C       G(T9,N2901,FULL)

C       G(T9,N2902,FULL)

C       G(T9,N2903,FULL)

C       G(T9,N2904,FULL)

C       G(T9,N2905,FULL)

C       G(T9,N2906,FULL)

C       G(T9,N2907,FULL)

C       G(T9,N2908,FULL)

C       G(T9,N2909,FULL)

C       G(T9,N2910,FULL)

C       G(T9,N2911,FULL)

C       G(T9,N2912,FULL)

C       G(T9,N2913,FULL)

C       G(T9,N2914,FULL)

C       G(T9,N2915,FULL)

C       G(T9,N2916,FULL)

C       G(T9,N2917,FULL)

C       G(T9,N2918,FULL)

C       G(T9,N2919,FULL)

C       G(T9,N2920,FULL)

C       G(T9,N2921,FULL)

C       G(T9,N2922,FULL)

C       G(T9,N2923,FULL)

C       G(T9,N2924,FULL)

C       G(T9,N2925,FULL)

C       G(T9,N2926,FULL)

C       G(T9,N2927,FULL)

C       G(T9,N2928,FULL)

C       G(T9,N2929,FULL)

C       G(T9,N2930,FULL)

C       G(T9,N2931,FULL)

C       G(T9,N2932,FULL)

C       G(T9,N2933,FULL)

C       G(T9,N2934,FULL)

C       G(T9,N2935,FULL)

C       G(T9,N2936,FULL)

C       G(T9,N2937,FULL)

C       G(T9,N2938,FULL)

C       G(T9,N2939,FULL)

C       G(T9,N2940,FULL)

C       G(T9,N2941,FULL)

C       G(T9,N2942,FULL)

C       G(T9,N2943,FULL)

C       G(T9,N2944,FULL)

C       G(T9,N2945,FULL)

C       G(T9,N2946,FULL)

C       G(T9,N2947,FULL)

C       G(T9,N2948,FULL)

C       G(T9,N2949,FULL)

C       G(T9,N2950,FULL)

C       G(T9,N2951,FULL)

C       G(T9,N2952,FULL)

C       G(T9,N2953,FULL)

C       G(T9,N2954,FULL)

C       G(T9,N2955,FULL)

C       G(T9,N2956,FULL)

C       G(T9,N2957,FULL)

C       G(T9,N2958,FULL)

C       G(T9,N2959,FULL)

C       G(T9,N2960,FULL)

C       G(T9,N2961,FULL)

C       G(T9,N2962,FULL)

C       G(T9,N2963,FULL)

C       G(T9,N2964,FULL)

C       G(T9,N2965,FULL)

C       G(T9,N2966,FULL)

C       G(T9,N2967,FULL)

C       G(T9,N2968,FULL)

C       G(T9,N2969,FULL)

C       G(T9,N2970,FULL)

C       G(T9,N2971,FULL)

C       G(T9,N2972,FULL)

C       G(T9,N2973,FULL)

C       G(T9,N2974,FULL)

C       G(T9,N2975,FULL)

C       G(T9,N2976,FULL)

C       G(T9,N2977,FULL)

C       G(T9,N2978,FULL)

C       G(T9,N2979,FULL)

C       G(T9,N2980,FULL)

C       G(T9,N2981,FULL)

C       G(T9,N2982,FULL)

C       G(T9,N2983,FULL)

C       G(T9,N2984,FULL)

C       G(T9,N2985,FULL)

C       G(T9,N2986,FULL)

C       G(T9,N2987,FULL)

C       G(T9,N2988,FULL)

C       G(T9,N2989,FULL)

C       G(T9,N2990,FULL)

C       G(T9,N2991,FULL)

C       G(T9,N2992,FULL)

C       G(T9,N2993,FULL)

C       G(T9,N2994,FULL)

C       G(T9,N2995,FULL)

C       G(T9,N2996,FULL)

C       G(T9,N2997,FULL)

C       G(T9,N2998,FULL)

C       G(T9,N2999,FULL)

C       G(T9,N3000,FULL)

C       G(T9,N3001,FULL)

C       G(T9,N3002,FULL)

C       G(T9,N3003,FULL)

C       G(T9,N3004,FULL)

C       G(T9,N3005,FULL)

C       G(T9,N3006,FULL)

C       G(T9,N3007,FULL)

C       G(T9,N3008,FULL)

C       G(T9,N3009,FULL)

C       G(T9,N3010,FULL)

C       G(T9,N3011,FULL)

C       G(T9,N3012,FULL)

C       G(T9,N3013,FULL)

C       G(T9,N3014,FULL)

C       G(T9,N3015,FULL)

C       G(T9,N3016,FULL)

C       G(T9,N3017,FULL)

C       G(T9,N3018,FULL)

C       G(T9,N3019,FULL)

C       G(T9,N3020,FULL)

C       G(T9,N3021,FULL)

C       G(T9,N3022,FULL)

C       G(T9,N3023,FULL)

C       G(T9,N3024,FULL)

C       G(T9,N3025,FULL)

C       G(T9,N3026,FULL)

C       G(T9,N3027,FULL)

C       G(T9,N3028,FULL)

C       G(T9,N3029,FULL)

C       G(T9,N3030,FULL)

C       G(T9,N3031,FULL)

C       G(T9,N3032,FULL)

C       G(T9,N3033,FULL)

C       G(T9,N3034,FULL)

C       G(T9,N3035,FULL)

C       G(T9,N3036,FULL)

C       G(T9,N3037,FULL)

C       G(T9,N3038,FULL)

C       G(T9,N3039,FULL)

C       G(T9,N3040,FULL)

C       G(T9,N3041,FULL)

C       G(T9,N3042,FULL)

C       G(T9,N3043,FULL)

C       G(T9,N3044,FULL)

C       G(T9,N3045,FULL)

C       G(T9,N3046,FULL)

C       G(T9,N3047,FULL)

C       G(T9,N3048,FULL)

C       G(T9,N3049,FULL)

C       G(T9,N3050,FULL)

C       G(T9,N3051,FULL)

C       G(T9,N3052,FULL)

C       G(T9,N3053,FULL)

C       G(T9,N3054,FULL)

C       G(T9,N3055,FULL)

C       G(T9,N3056,FULL)

C       G(T9,N3057,FULL)

C       G(T9,N3058,FULL)

C       G(T9,N3059,FULL)

C       G(T9,N3060,FULL)

C       G(T9,N3061,FULL)

C       G(T9,N3062,FULL)

C       G(T9,N3063,FULL)

C       G(T9,N3064,FULL)

C       G(T9,N3065,FULL)

C       G(T9,N3066,FULL)

C       G(T9,N3067,FULL)

C       G(T9,N3068,FULL)

C       G(T9,N3069,FULL)

C       G(T9,N3070,FULL)

C       G(T9,N3071,FULL)

C       G(T9,N3072,FULL)

C       G(T9,N3073,FULL)

C       G(T9,N3074,FULL)

C       G(T9,N3075,FULL)

C       G(T9,N3076,FULL)

C       G(T9,N3077,FULL)

C       G(T9,N3078,FULL)

C       G(T9,N3079,FULL)

C       G(T9,N3080,FULL)

C       G(T9,N3081,FULL)

C       G(T9,N3082,FULL)

C       G(T9,N3083,FULL)

C       G(T9,N3084,FULL)

C       G(T9,N3085,FULL)

C       G(T9,N3086,FULL)

C       G(T9,N3087,FULL)

C       G(T9,N3088,FULL)

C       G(T9,N3089,FULL)

C       G(T9,N3090,FULL)

C       G(T9,N3091,FULL)

C       G(T9,N3092,FULL)

C       G(T9,N3093,FULL)

C       G(T9,N3094,FULL)

C       G(T9,N3095,FULL)

C       G(T9,N3096,FULL)

C       G(T9,N3097,FULL)

C       G(T9,N3098,FULL)

C       G(T9,N3099,FULL)

C       G(T9,N3100,FULL)

C       G(T9,N3101,FULL)

C       G(T9,N3102,FULL)

C       G(T9,N3103,FULL)

C       G(T9,N3104,FULL)

C       G(T9,N3105,FULL)

C       G(T9,N3106,FULL)

C       G(T9,N3107,FULL)

C       G(T9,N3108,FULL)

C       G(T9,N3109,FULL)

C       G(T9,N3110,FULL)

C       G(T9,N3111,FULL)

C       G(T9,N3112,FULL)

C       G(T9,N3113,FULL)

C       G(T9,N3114,FULL)

C       G(T9,N3115,FULL)

C       G(T9,N3116,FULL)

C       G(T9,N3117,FULL)

C       G(T9,N3118,FULL)

C       G(T9,N3119,FULL)

C       G(T9,N3120,FULL)

C       G(T9,N3121,FULL)

C       G(T9,N3122,FULL)

C       G(T9,N3123,FULL)

C       G(T9,N3124,FULL)

C       G(T9,N3125,FULL)

C       G(T9,N3126,FULL)

C       G(T9,N3127,FULL)

C       G(T9,N3128,FULL)

C       G(T9,N3129,FULL)

C       G(T9,N3130,FULL)

C       G(T9,N3131,FULL)

C       G(T9,N3132,FULL)

C       G(T9,N3133,FULL)

C       G(T9,N3134,FULL)

C       G(T9,N3135,FULL)

C       G(T9,N3136,FULL)

C       G(T9,N3137,FULL)

C       G(T9,N3138,FULL)

C       G(T9,N3139,FULL)

C       G(T9,N3140,FULL)

C       G(T9,N3141,FULL)

C       G(T9,N3142,FULL)

C       G(T9,N3143,FULL)

C       G(T9,N3144,FULL)

C       G(T9,N3145,FULL)

C       G(T9,N3146,FULL)

C       G(T9,N3147,FULL)

C       G(T9,N3148,FULL)

C       G(T9,N3149,FULL)

C       G(T9,N3150,FULL)

C       G(T9,N3151,FULL)

C       G(T9,N3152,FULL)

C       G(T9,N3153,FULL)

C       G(T9,N3154,FULL)

C       G(T9,N3155,FULL)

C       G(T9,N3156,FULL)

C       G(T9,N3157,FULL)

C       G(T9,N3158,FULL)

C       G(T9,N3159,FULL)

C       G(T9,N3160,FULL)

C       G(T9,N3161,FULL)

C       G(T9,N3162,FULL)

C       G(T9,N3163,FULL)

C       G(T9,N3164,FULL)

C       G(T9,N3165,FULL)

C       G(T9,N3166,FULL)

C       G(T9,N3167,FULL)

C       G(T9,N3168,FULL)

C       G(T9,N3169,FULL)

C       G(T9,N3170,FULL)

C       G(T9,N3171,FULL)

C       G(T9,N3172,FULL)

C       G(T9,N3173,FULL)

C       G(T9,N3174,FULL)

C       G(T9,N3175,FULL)

C       G(T9,N3176,FULL)

C       G(T9,N3177,FULL)

C       G(T9,N3178,FULL)

C       G(T9,N3179,FULL)

C       G(T9,N3180,FULL)

C       G(T9,N3181,FULL)

C       G(T9,N3182,FULL)

C       G(T9,N3183,FULL)

C       G(T9,N3184,FULL)

C       G(T9,N3185,FULL)

C       G(T9,N3186,FULL)

C       G(T9,N3187,FULL)

C       G(T9,N3188,FULL)

C       G(T9,N3189,FULL)

C       G(T9,N3190,FULL)

C       G(T9,N3191,FULL)

C       G(T9,N3192,FULL)

C       G(T9,N3193,FULL)

C       G(T9,N3194,FULL)

C       G(T9,N3195,FULL)

C       G(T9,N3196,FULL)

C       G(T9,N3197,FULL)

C       G(T9,N3198,FULL)

C       G(T9,N3199,FULL)

C       G(T9,N3200,FULL)

C       G(T9,N3201,FULL)

C       G(T9,N3202,FULL)

C       G(T9,N3203,FULL)

C       G(T9,N3204,FULL)

C       G(T9,N3205,FULL)

C       G(T9,N3206,FULL)

C       G(T9,N3207,FULL)

C       G(T9,N3208,FULL)

C       G(T9,N3209,FULL)

C       G(T9,N3210,FULL)

C       G(T9,N3211,FULL)

C       G(T9,N3212,FULL)

C       G(T9,N3213,FULL)

C       G(T9,N3214,FULL)

C       G(T9,N3215,FULL)

C       G(T9,N3216,FULL)

C       G(T9,N3217,FULL)

C       G(T9,N3218,FULL)

C       G(T9,N3219,FULL)

C       G(T9,N3220,FULL)

C       G(T9,N3221,FULL)

C       G(T9,N3222,FULL)

C       G(T9,N3223,FULL)

C       G(T9,N3224,FULL)

C       G(T9,N3225,FULL)

C       G(T9,N3226,FULL)

C       G(T9,N3227,FULL)

C       G(T9,N3228,FULL)

C       G(T9,N3229,FULL)

C       G(T9,N3230,FULL)

C       G(T9,N3231,FULL)

C       G(T9,N3232,FULL)

C       G(T9,N3233,FULL)

C       G(T9,N3234,FULL)

C       G(T9,N3235,FULL)

C       G(T9,N3236,FULL)

C       G(T9,N3237,FULL)

C       G(T9,N3238,FULL)

C       G(T9,N3239,FULL)

C       G(T9,N3240,FULL)

C       G(T9,N3241,FULL)

C       G(T9,N3242,FULL)

C       G(T9,N3243,FULL)

C       G(T9,N3244,FULL)

C       G(T9,N3245,FULL)

C       G(T9,N3246,FULL)

C       G(T9,N3247,FULL)

C       G(T9,N3248,FULL)

C       G(T9,N3249,FULL)

C       G(T9,N3250,FULL)

C       G(T9,N3251,FULL)

C       G(T9,N3252,FULL)

C       G(T9,N3253,FULL)

C       G(T9,N3254,FULL)

C       G(T9,N3255,FULL)

C       G(T9,N3256,FULL)

C       G(T9,N3257,FULL)

C       G(T9,N3258,FULL)

C       G(T9,N3259,FULL)

C       G(T9,N3260,FULL)

C       G(T9,N3261,FULL)

C       G(T9,N3262,FULL)

C       G(T9,N3263,FULL)

C       G(T9,N3264,FULL)

C       G(T9,N3265,FULL)

C       G(T9,N3266,FULL)

C       G(T9,N3267,FULL)

C       G(T9,N3268,FULL)

C       G(T9,N3269,FULL)

C       G(T9,N3270,FULL)

C       G(T9,N3271,FULL)

C       G(T9,N3272,FULL)

C       G(T9,N3273,FULL)

C       G(T9,N3274,FULL)

C       G(T9,N3275,FULL)

C       G(T9,N3276,FULL)

C       G(T9,N3277,FULL)

C       G(T9,N3278,FULL)

C       G(T9,N3279,FULL)

C       G(T9,N3280,FULL)

C       G(T9,N3281,FULL)

C       G(T9,N3282,FULL)

C       G(T9,N3283,FULL)

C       G(T9,N3284,FULL)

C       G(T9,N3285,FULL)

C       G(T9,N3286,FULL)

C       G(T9,N3287,FULL)

C       G(T9,N3288,FULL)

C       G(T9,N3289,FULL)

C       G(T9,N3290,FULL)

C       G(T9,N3291,FULL)
        CALL xC01234_(S12,MHH2,S34,XMA02,XMH02,XMH02,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2

        PRE = -((CBA**2*PI**(-2)*PZ12*PZ34*XCW2**(-2)*(12D0*ALPHA*
     &  CBA*MA02*PI*S2A-16D0*ALPHA*CBA*MH02*PI*S2A-8D0*ALPHA*CBA*
     &  MHH2*PI*S2A-4D0*ALPHA*CBA*MA02*PI*S2B+8D0*ALPHA*MA02*PI*SAB-
     &  12D0*ALPHA*C2A*MA02*PI*SBA-4D0*ALPHA*C2B*MA02*PI*SBA+12D0*
     &  CBA*LAM5*S2A*XMW2*XSW2-4D0*CBA*LAM5*S2B*XMW2*XSW2+8D0*LAM5*
     &  SAB*XMW2*XSW2-12D0*C2A*LAM5*SBA*XMW2*XSW2-4D0*C2B*LAM5*SBA*
     &  XMW2*XSW2))/(512D0*CB*SB*XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)-C2(0,0)*K(1)*K(2)*PRE*XSW2**(-2)
        F(1,-1,1) = F(1,-1,1)-(2D0*C2(0,0)*K(1)*QF(3)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*C2(0,0)*K(2)*QF(1)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+4D0*C2(0,0)*QF(1)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(5,-1,1) = F(5,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(6,-1,1) = F(6,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(7,-1,1) = F(7,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(8,-1,1) = F(8,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE

C       G(T9,N3292,FULL)
        CALL xC01234_(S12,MHH2,S34,XMZ2,XMH02,XMH02,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2

        PRE = -((PI**(-2)*PZ12*PZ34*SBA**2*XCW2**(-2)*(12D0*ALPHA*
     &  CBA*MA02*PI*S2A-16D0*ALPHA*CBA*MH02*PI*S2A-8D0*ALPHA*CBA*
     &  MHH2*PI*S2A-4D0*ALPHA*CBA*MA02*PI*S2B+8D0*ALPHA*MA02*PI*SAB-
     &  12D0*ALPHA*C2A*MA02*PI*SBA-4D0*ALPHA*C2B*MA02*PI*SBA+12D0*
     &  CBA*LAM5*S2A*XMW2*XSW2-4D0*CBA*LAM5*S2B*XMW2*XSW2+8D0*LAM5*
     &  SAB*XMW2*XSW2-12D0*C2A*LAM5*SBA*XMW2*XSW2-4D0*C2B*LAM5*SBA*
     &  XMW2*XSW2))/(512D0*CB*SB*XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)-C2(0,0)*K(1)*K(2)*PRE*XSW2**(-2)
        F(1,-1,1) = F(1,-1,1)-(2D0*C2(0,0)*K(1)*QF(3)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*C2(0,0)*K(2)*QF(1)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+4D0*C2(0,0)*QF(1)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(5,-1,1) = F(5,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(6,-1,1) = F(6,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(7,-1,1) = F(7,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(8,-1,1) = F(8,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE

C       G(T9,N3293,FULL)
        CALL xC01234_(S12,MHH2,S34,XMZ2,XMH02,XMH02,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,0,0)

        PRE = (C0*PI**(-2)*PZ12*PZ34*SBA**2*XCW2**(-2)*XMZ2*(12D0*
     &  ALPHA*CBA*MA02*PI*S2A-16D0*ALPHA*CBA*MH02*PI*S2A-8D0*ALPHA*
     &  CBA*MHH2*PI*S2A-4D0*ALPHA*CBA*MA02*PI*S2B+8D0*ALPHA*MA02*PI*
     &  SAB-12D0*ALPHA*C2A*MA02*PI*SBA-4D0*ALPHA*C2B*MA02*PI*SBA+
     &  12D0*CBA*LAM5*S2A*XMW2*XSW2-4D0*CBA*LAM5*S2B*XMW2*XSW2+8D0*
     &  LAM5*SAB*XMW2*XSW2-12D0*C2A*LAM5*SBA*XMW2*XSW2-4D0*C2B*LAM5*
     &  SBA*XMW2*XSW2))/(512D0*CB*SB*XMW*XSW)

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T9,N3294,FULL)
        CALL xC01234_(S12,MHH2,S34,XMA02,XMH02,XMHH2,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2

        PRE = (CBA*PI**(-2)*PZ12*PZ34*SBA*XCW2**(-2)*(8D0*ALPHA*CAB*
     &  MA02*PI-12D0*ALPHA*C2A*CBA*MA02*PI+4D0*ALPHA*C2B*CBA*MA02*
     &  PI-12D0*ALPHA*MA02*PI*S2A*SBA+8D0*ALPHA*MH02*PI*S2A*SBA+
     &  16D0*ALPHA*MHH2*PI*S2A*SBA-4D0*ALPHA*MA02*PI*S2B*SBA+8D0*
     &  CAB*LAM5*XMW2*XSW2-12D0*C2A*CBA*LAM5*XMW2*XSW2+4D0*C2B*CBA*
     &  LAM5*XMW2*XSW2-12D0*LAM5*S2A*SBA*XMW2*XSW2-4D0*LAM5*S2B*SBA*
     &  XMW2*XSW2))/(512D0*CB*SB*XMW*XSW)

        F(1,-1,-1) = F(1,-1,-1)-C2(0,0)*K(1)*K(2)*PRE*XSW2**(-2)
        F(1,-1,1) = F(1,-1,1)-(2D0*C2(0,0)*K(1)*QF(3)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*C2(0,0)*K(2)*QF(1)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+4D0*C2(0,0)*QF(1)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(5,-1,1) = F(5,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(6,-1,1) = F(6,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(7,-1,1) = F(7,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(8,-1,1) = F(8,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE

C       G(T9,N3295,FULL)
        CALL xC01234_(S12,MHH2,S34,XMZ2,XMH02,XMHH2,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2

        PRE = -((CBA*PI**(-2)*PZ12*PZ34*SBA*XCW2**(-2)*(8D0*ALPHA*
     &  CAB*MA02*PI-12D0*ALPHA*C2A*CBA*MA02*PI+4D0*ALPHA*C2B*CBA*
     &  MA02*PI-12D0*ALPHA*MA02*PI*S2A*SBA+8D0*ALPHA*MH02*PI*S2A*
     &  SBA+16D0*ALPHA*MHH2*PI*S2A*SBA-4D0*ALPHA*MA02*PI*S2B*SBA+
     &  8D0*CAB*LAM5*XMW2*XSW2-12D0*C2A*CBA*LAM5*XMW2*XSW2+4D0*C2B*
     &  CBA*LAM5*XMW2*XSW2-12D0*LAM5*S2A*SBA*XMW2*XSW2-4D0*LAM5*S2B*
     &  SBA*XMW2*XSW2))/(512D0*CB*SB*XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)-C2(0,0)*K(1)*K(2)*PRE*XSW2**(-2)
        F(1,-1,1) = F(1,-1,1)-(2D0*C2(0,0)*K(1)*QF(3)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*C2(0,0)*K(2)*QF(1)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+4D0*C2(0,0)*QF(1)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(5,-1,1) = F(5,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(6,-1,1) = F(6,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(7,-1,1) = F(7,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(8,-1,1) = F(8,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE

C       G(T9,N3296,FULL)
        CALL xC01234_(S12,MHH2,S34,XMZ2,XMH02,XMHH2,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,0,0)

        PRE = (C0*CBA*PI**(-2)*PZ12*PZ34*SBA*XCW2**(-2)*XMZ2*(8D0*
     &  ALPHA*CAB*MA02*PI-12D0*ALPHA*C2A*CBA*MA02*PI+4D0*ALPHA*C2B*
     &  CBA*MA02*PI-12D0*ALPHA*MA02*PI*S2A*SBA+8D0*ALPHA*MH02*PI*
     &  S2A*SBA+16D0*ALPHA*MHH2*PI*S2A*SBA-4D0*ALPHA*MA02*PI*S2B*
     &  SBA+8D0*CAB*LAM5*XMW2*XSW2-12D0*C2A*CBA*LAM5*XMW2*XSW2+4D0*
     &  C2B*CBA*LAM5*XMW2*XSW2-12D0*LAM5*S2A*SBA*XMW2*XSW2-4D0*LAM5*
     &  S2B*SBA*XMW2*XSW2))/(512D0*CB*SB*XMW*XSW)

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T9,N3297,FULL)
        CALL xC01234_(S12,MHH2,S34,XMA02,XMHH2,XMH02,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2

        PRE = (CBA*PI**(-2)*PZ12*PZ34*SBA*XCW2**(-2)*(8D0*ALPHA*CAB*
     &  MA02*PI-12D0*ALPHA*C2A*CBA*MA02*PI+4D0*ALPHA*C2B*CBA*MA02*
     &  PI-12D0*ALPHA*MA02*PI*S2A*SBA+8D0*ALPHA*MH02*PI*S2A*SBA+
     &  16D0*ALPHA*MHH2*PI*S2A*SBA-4D0*ALPHA*MA02*PI*S2B*SBA+8D0*
     &  CAB*LAM5*XMW2*XSW2-12D0*C2A*CBA*LAM5*XMW2*XSW2+4D0*C2B*CBA*
     &  LAM5*XMW2*XSW2-12D0*LAM5*S2A*SBA*XMW2*XSW2-4D0*LAM5*S2B*SBA*
     &  XMW2*XSW2))/(512D0*CB*SB*XMW*XSW)

        F(1,-1,-1) = F(1,-1,-1)-C2(0,0)*K(1)*K(2)*PRE*XSW2**(-2)
        F(1,-1,1) = F(1,-1,1)-(2D0*C2(0,0)*K(1)*QF(3)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*C2(0,0)*K(2)*QF(1)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+4D0*C2(0,0)*QF(1)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(5,-1,1) = F(5,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(6,-1,1) = F(6,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(7,-1,1) = F(7,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(8,-1,1) = F(8,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE

C       G(T9,N3298,FULL)
        CALL xC01234_(S12,MHH2,S34,XMZ2,XMHH2,XMH02,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2

        PRE = -((CBA*PI**(-2)*PZ12*PZ34*SBA*XCW2**(-2)*(8D0*ALPHA*
     &  CAB*MA02*PI-12D0*ALPHA*C2A*CBA*MA02*PI+4D0*ALPHA*C2B*CBA*
     &  MA02*PI-12D0*ALPHA*MA02*PI*S2A*SBA+8D0*ALPHA*MH02*PI*S2A*
     &  SBA+16D0*ALPHA*MHH2*PI*S2A*SBA-4D0*ALPHA*MA02*PI*S2B*SBA+
     &  8D0*CAB*LAM5*XMW2*XSW2-12D0*C2A*CBA*LAM5*XMW2*XSW2+4D0*C2B*
     &  CBA*LAM5*XMW2*XSW2-12D0*LAM5*S2A*SBA*XMW2*XSW2-4D0*LAM5*S2B*
     &  SBA*XMW2*XSW2))/(512D0*CB*SB*XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)-C2(0,0)*K(1)*K(2)*PRE*XSW2**(-2)
        F(1,-1,1) = F(1,-1,1)-(2D0*C2(0,0)*K(1)*QF(3)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*C2(0,0)*K(2)*QF(1)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+4D0*C2(0,0)*QF(1)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(5,-1,1) = F(5,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(6,-1,1) = F(6,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(7,-1,1) = F(7,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(8,-1,1) = F(8,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE

C       G(T9,N3299,FULL)
        CALL xC01234_(S12,MHH2,S34,XMZ2,XMHH2,XMH02,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,0,0)

        PRE = (C0*CBA*PI**(-2)*PZ12*PZ34*SBA*XCW2**(-2)*XMZ2*(8D0*
     &  ALPHA*CAB*MA02*PI-12D0*ALPHA*C2A*CBA*MA02*PI+4D0*ALPHA*C2B*
     &  CBA*MA02*PI-12D0*ALPHA*MA02*PI*S2A*SBA+8D0*ALPHA*MH02*PI*
     &  S2A*SBA+16D0*ALPHA*MHH2*PI*S2A*SBA-4D0*ALPHA*MA02*PI*S2B*
     &  SBA+8D0*CAB*LAM5*XMW2*XSW2-12D0*C2A*CBA*LAM5*XMW2*XSW2+4D0*
     &  C2B*CBA*LAM5*XMW2*XSW2-12D0*LAM5*S2A*SBA*XMW2*XSW2-4D0*LAM5*
     &  S2B*SBA*XMW2*XSW2))/(512D0*CB*SB*XMW*XSW)

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T9,N3300,FULL)
        CALL xC01234_(S12,MHH2,S34,XMA02,XMHH2,XMHH2,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2

        PRE = (3D0*PI**(-2)*PZ12*PZ34*SBA**2*XCW2**(-2)*(4D0*ALPHA*
     &  CB*MHH2*PI*SA**3+4D0*ALPHA*CA**3*MHH2*PI*SB-4D0*ALPHA*MA02*
     &  PI*SAB*SBA**2-4D0*LAM5*SAB*SBA**2*XMW2*XSW2))/(128D0*CB*SB*
     &  XMW*XSW)

        F(1,-1,-1) = F(1,-1,-1)-C2(0,0)*K(1)*K(2)*PRE*XSW2**(-2)
        F(1,-1,1) = F(1,-1,1)-(2D0*C2(0,0)*K(1)*QF(3)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*C2(0,0)*K(2)*QF(1)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+4D0*C2(0,0)*QF(1)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(5,-1,1) = F(5,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(6,-1,1) = F(6,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(7,-1,1) = F(7,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(8,-1,1) = F(8,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE

C       G(T9,N3301,FULL)
        CALL xC01234_(S12,MHH2,S34,XMZ2,XMHH2,XMHH2,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2

        PRE = (3D0*CBA**2*PI**(-2)*PZ12*PZ34*XCW2**(-2)*(4D0*ALPHA*
     &  CB*MHH2*PI*SA**3+4D0*ALPHA*CA**3*MHH2*PI*SB-4D0*ALPHA*MA02*
     &  PI*SAB*SBA**2-4D0*LAM5*SAB*SBA**2*XMW2*XSW2))/(128D0*CB*SB*
     &  XMW*XSW)

        F(1,-1,-1) = F(1,-1,-1)-C2(0,0)*K(1)*K(2)*PRE*XSW2**(-2)
        F(1,-1,1) = F(1,-1,1)-(2D0*C2(0,0)*K(1)*QF(3)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*C2(0,0)*K(2)*QF(1)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+4D0*C2(0,0)*QF(1)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(5,-1,1) = F(5,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(6,-1,1) = F(6,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(7,-1,1) = F(7,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)+C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2)
        F(8,-1,1) = F(8,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-(2D0*C2(1,2)*K(2)*QF(1)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-4D0*C2(1,2)*QF(1)*QF(3)*PRE

C       G(T9,N3302,FULL)
        CALL xC01234_(S12,MHH2,S34,XMZ2,XMHH2,XMHH2,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,0,0)

        PRE = -((3D0*C0*CBA**2*PI**(-2)*PZ12*PZ34*XCW2**(-2)*XMZ2*
     &  (4D0*ALPHA*CB*MHH2*PI*SA**3+4D0*ALPHA*CA**3*MHH2*PI*SB-4D0*
     &  ALPHA*MA02*PI*SAB*SBA**2-4D0*LAM5*SAB*SBA**2*XMW2*XSW2))/
     &  (128D0*CB*SB*XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T10,N3303,FULL)

C       G(T10,N3304,FULL)

C       G(T10,N3305,FULL)

C       G(T10,N3306,FULL)

C       G(T10,N3309,FULL)

C       G(T10,N3310,FULL)

C       G(T10,N3311,FULL)

C       G(T10,N3312,FULL)

C       G(T10,N3313,FULL)

C       G(T10,N3314,FULL)

C       G(T10,N3315,FULL)

C       G(T10,N3318,FULL)

C       G(T10,N3319,FULL)

C       G(T10,N3320,FULL)

C       G(T10,N3323,FULL)

C       G(T10,N3324,FULL)

C       G(T10,N3325,FULL)

C       G(T10,N3326,FULL)

C       G(T10,N3329,FULL)

C       G(T10,N3330,FULL)

C       G(T10,N3331,FULL)

C       G(T10,N3334,FULL)

C       G(T10,N3335,FULL)

C       G(T10,N3336,FULL)

C       G(T10,N3337,FULL)

C       G(T10,N3340,FULL)

C       G(T10,N3341,FULL)

C       G(T10,N3342,FULL)

C       G(T10,N3344,FULL)

C       G(T10,N3345,FULL)

C       G(T10,N3346,FULL)

C       G(T10,N3347,FULL)

C       G(T10,N3350,FULL)

C       G(T10,N3351,FULL)

C       G(T10,N3352,FULL)

C       G(T10,N3354,FULL)

C       G(T10,N3355,FULL)

C       G(T10,N3356,FULL)

C       G(T10,N3357,FULL)

C       G(T10,N3360,FULL)

C       G(T10,N3361,FULL)

C       G(T10,N3362,FULL)

C       G(T10,N3363,FULL)

C       G(T10,N3364,FULL)

C       G(T10,N3365,FULL)

C       G(T10,N3366,FULL)

C       G(T10,N3367,FULL)

C       G(T10,N3368,FULL)

C       G(T10,N3369,FULL)

C       G(T10,N3370,FULL)

C       G(T10,N3373,FULL)

C       G(T10,N3374,FULL)

C       G(T10,N3375,FULL)

C       G(T10,N3376,FULL)

C       G(T10,N3377,FULL)

C       G(T10,N3378,FULL)

C       G(T10,N3379,FULL)

C       G(T10,N3380,FULL)

C       G(T10,N3381,FULL)

C       G(T10,N3382,FULL)

C       G(T10,N3383,FULL)

C       G(T10,N3384,FULL)

C       G(T10,N3388,FULL)

C       G(T10,N3392,FULL)

C       G(T10,N3393,FULL)

C       G(T10,N3394,FULL)

C       G(T10,N3395,FULL)

C       G(T10,N3396,FULL)

C       G(T10,N3397,FULL)

C       G(T10,N3398,FULL)

C       G(T10,N3407,FULL)

C       G(T10,N3408,FULL)

C       G(T10,N3409,FULL)

C       G(T10,N3410,FULL)

C       G(T10,N3411,FULL)

C       G(T10,N3412,FULL)

C       G(T10,N3413,FULL)

C       G(T10,N3414,FULL)

C       G(T10,N3415,FULL)

C       G(T10,N3416,FULL)

C       G(T10,N3425,FULL)

C       G(T10,N3426,FULL)

C       G(T10,N3427,FULL)

C       G(T10,N3428,FULL)

C       G(T10,N3429,FULL)

C       G(T10,N3430,FULL)

C       G(T10,N3431,FULL)

C       G(T10,N3432,FULL)

C       G(T10,N3433,FULL)

C       G(T10,N3434,FULL)

C       G(T10,N3435,FULL)

C       G(T10,N3436,FULL)

C       G(T10,N3437,FULL)

C       G(T10,N3438,FULL)

C       G(T10,N3439,FULL)

C       G(T10,N3440,FULL)

C       G(T10,N3441,FULL)

C       G(T10,N3442,FULL)

C       G(T10,N3443,FULL)

C       G(T10,N3444,FULL)

C       G(T10,N3445,FULL)

C       G(T10,N3446,FULL)

C       G(T10,N3447,FULL)

C       G(T10,N3448,FULL)

C       G(T10,N3449,FULL)

C       G(T10,N3450,FULL)

C       G(T10,N3451,FULL)

C       G(T10,N3452,FULL)

C       G(T11,N3455,FULL)

C       G(T11,N3456,FULL)

C       G(T11,N3457,FULL)

C       G(T11,N3458,FULL)

C       G(T11,N3459,FULL)

C       G(T11,N3460,FULL)

C       G(T11,N3461,FULL)

C       G(T11,N3464,FULL)

C       G(T11,N3465,FULL)

C       G(T11,N3466,FULL)

C       G(T11,N3467,FULL)

C       G(T11,N3468,FULL)

C       G(T11,N3469,FULL)

C       G(T11,N3470,FULL)

C       G(T11,N3473,FULL)

C       G(T11,N3474,FULL)

C       G(T11,N3475,FULL)

C       G(T11,N3476,FULL)

C       G(T11,N3477,FULL)

C       G(T11,N3478,FULL)

C       G(T11,N3479,FULL)

C       G(T11,N3484,FULL)

C       G(T11,N3485,FULL)

C       G(T11,N3486,FULL)

C       G(T11,N3487,FULL)

C       G(T11,N3488,FULL)

C       G(T11,N3489,FULL)

C       G(T11,N3490,FULL)

C       G(T11,N3495,FULL)

C       G(T11,N3496,FULL)

C       G(T11,N3497,FULL)

C       G(T11,N3498,FULL)

C       G(T11,N3499,FULL)

C       G(T11,N3500,FULL)

C       G(T11,N3501,FULL)

C       G(T11,N3505,FULL)

C       G(T11,N3506,FULL)

C       G(T11,N3507,FULL)

C       G(T11,N3508,FULL)

C       G(T11,N3509,FULL)

C       G(T11,N3510,FULL)

C       G(T11,N3511,FULL)

C       G(T11,N3513,FULL)

C       G(T11,N3514,FULL)

C       G(T11,N3515,FULL)

C       G(T11,N3516,FULL)

C       G(T11,N3517,FULL)

C       G(T11,N3518,FULL)

C       G(T11,N3519,FULL)

C       G(T11,N3520,FULL)

C       G(T11,N3523,FULL)

C       G(T11,N3524,FULL)

C       G(T11,N3525,FULL)

C       G(T11,N3526,FULL)

C       G(T11,N3527,FULL)

C       G(T11,N3528,FULL)

C       G(T11,N3529,FULL)

C       G(T11,N3530,FULL)

C       G(T11,N3531,FULL)

C       G(T11,N3532,FULL)

C       G(T11,N3533,FULL)

C       G(T11,N3534,FULL)

C       G(T11,N3538,FULL)

C       G(T11,N3541,FULL)

C       G(T11,N3542,FULL)

C       G(T11,N3543,FULL)

C       G(T11,N3544,FULL)

C       G(T11,N3546,FULL)

C       G(T11,N3547,FULL)

C       G(T11,N3548,FULL)

C       G(T11,N3555,FULL)

C       G(T11,N3556,FULL)

C       G(T11,N3557,FULL)

C       G(T11,N3558,FULL)

C       G(T11,N3559,FULL)

C       G(T11,N3560,FULL)

C       G(T11,N3563,FULL)

C       G(T11,N3564,FULL)

C       G(T11,N3565,FULL)

C       G(T11,N3566,FULL)

C       G(T11,N3573,FULL)

C       G(T11,N3574,FULL)

C       G(T11,N3575,FULL)

C       G(T11,N3576,FULL)

C       G(T11,N3577,FULL)

C       G(T11,N3578,FULL)

C       G(T11,N3581,FULL)

C       G(T11,N3582,FULL)

C       G(T11,N3583,FULL)

C       G(T11,N3584,FULL)

C       G(T11,N3585,FULL)

C       G(T11,N3586,FULL)

C       G(T11,N3587,FULL)

C       G(T11,N3588,FULL)

C       G(T11,N3589,FULL)

C       G(T11,N3590,FULL)

C       G(T11,N3591,FULL)

C       G(T11,N3592,FULL)

C       G(T11,N3593,FULL)

C       G(T11,N3594,FULL)

C       G(T11,N3595,FULL)

C       G(T11,N3596,FULL)

C       G(T11,N3597,FULL)

C       G(T11,N3598,FULL)

C       G(T11,N3599,FULL)

C       G(T11,N3600,FULL)

C       G(T11,N3601,FULL)

C       G(T11,N3602,FULL)

C       G(T12,N3603,FULL)

C       G(T12,N3604,FULL)

C       G(T12,N3605,FULL)

C       G(T12,N3606,FULL)

C       G(T12,N3607,FULL)

C       G(T12,N3608,FULL)

C       G(T12,N3609,FULL)

C       G(T12,N3610,FULL)

C       G(T12,N3611,FULL)

C       G(T12,N3612,FULL)

C       G(T12,N3619,FULL)

C       G(T12,N3620,FULL)

C       G(T12,N3621,FULL)

C       G(T12,N3624,FULL)

C       G(T12,N3625,FULL)

C       G(T12,N3626,FULL)

C       G(T12,N3627,FULL)

C       G(T12,N3628,FULL)

C       G(T12,N3629,FULL)

C       G(T12,N3630,FULL)

C       G(T12,N3631,FULL)

C       G(T12,N3632,FULL)

C       G(T12,N3633,FULL)

C       G(T12,N3634,FULL)

C       G(T12,N3641,FULL)

C       G(T12,N3642,FULL)

C       G(T12,N3643,FULL)

C       G(T12,N3646,FULL)

C       G(T12,N3647,FULL)

C       G(T12,N3648,FULL)

C       G(T12,N3649,FULL)

C       G(T12,N3650,FULL)

C       G(T12,N3651,FULL)

C       G(T12,N3652,FULL)

C       G(T12,N3653,FULL)

C       G(T12,N3654,FULL)

C       G(T12,N3655,FULL)

C       G(T12,N3656,FULL)

C       G(T12,N3663,FULL)

C       G(T12,N3664,FULL)

C       G(T12,N3665,FULL)

C       G(T12,N3668,FULL)

C       G(T12,N3669,FULL)

C       G(T12,N3670,FULL)

C       G(T12,N3671,FULL)

C       G(T12,N3672,FULL)

C       G(T12,N3673,FULL)

C       G(T12,N3674,FULL)

C       G(T12,N3675,FULL)

C       G(T12,N3676,FULL)

C       G(T12,N3677,FULL)

C       G(T12,N3678,FULL)

C       G(T12,N3685,FULL)

C       G(T12,N3686,FULL)

C       G(T12,N3687,FULL)

C       G(T12,N3690,FULL)

C       G(T12,N3691,FULL)

C       G(T12,N3692,FULL)

C       G(T12,N3693,FULL)

C       G(T12,N3694,FULL)

C       G(T12,N3695,FULL)

C       G(T12,N3696,FULL)

C       G(T12,N3697,FULL)

C       G(T12,N3698,FULL)

C       G(T12,N3699,FULL)

C       G(T12,N3700,FULL)

C       G(T12,N3707,FULL)

C       G(T12,N3708,FULL)

C       G(T12,N3709,FULL)
        CALL xC01234_(T14,MHH2,RMF2(3),CMF2(3),XMZ2,XMZ2,C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,1,1)

        PRE = (C1(1)*QF(1)*QF(3)*ALPHA*CBA*XMZ)/(8D0*PI*S12*XCW*
     &  XCW2)

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2)**2)/(XSW*
     &  XSW2)
        F(1,-1,1) = F(1,-1,1)+4D0*QF(3)**2*PRE*XSW
        F(1,1,-1) = F(1,1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2)**2)/(XSW*
     &  XSW2)
        F(1,1,1) = F(1,1,1)+4D0*QF(3)**2*PRE*XSW

C       G(T12,N3712,FULL)
        CALL xC01234_(T14,MHH2,RMF2(3),CMF2(4),XMW2,XMW2,C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,1,1)

        PRE = (C1(1)*QF(1)*QF(3)*ALPHA*CBA*XMW)/(4D0*PI*S12*XSW*
     &  XSW2)

        F(1,-1,-1) = F(1,-1,-1)+PRE
        F(1,1,-1) = F(1,1,-1)+PRE

C       G(T12,N3713,FULL)

C       G(T12,N3714,FULL)

C       G(T12,N3715,FULL)

C       G(T12,N3716,FULL)

C       G(T12,N3717,FULL)

C       G(T12,N3718,FULL)

C       G(T12,N3719,FULL)

C       G(T12,N3720,FULL)

C       G(T12,N3721,FULL)

C       G(T12,N3722,FULL)

C       G(T12,N3729,FULL)

C       G(T12,N3730,FULL)

C       G(T12,N3731,FULL)
        CALL xC01234_(T14,MHH2,RMF2(3),CMF2(3),XMZ2,XMZ2,C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,1,1)

        PRE = (C1(1)*ALPHA*CBA*PZ12*XCW2**(-2)*XMZ)/(32D0*PI*XCW)

        F(1,-1,-1) = F(1,-1,-1)-(PRE*XSW2**(-2)*(1D0-2D0*QF(1)*
     &  XSW2)*(1D0+2D0*QF(3)*XSW2)**3)/XSW
        F(1,-1,1) = F(1,-1,1)-8D0*QF(3)**3*PRE*XSW*(1D0-2D0*QF(1)*
     &  XSW2)
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2)**
     &  3)/(XSW*XSW2)
        F(1,1,1) = F(1,1,1)+16D0*QF(1)*QF(3)**3*PRE*XSW*XSW2

C       G(T12,N3734,FULL)
        CALL xC01234_(T14,MHH2,RMF2(3),CMF2(4),XMW2,XMW2,C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,1,1)

        PRE = (C1(1)*ALPHA*CBA*PZ12*XMW*(1D0+2D0*QF(3)*XSW2))/(16D0*
     &  PI*XCW2*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE

C       G(T12,N3737,FULL)

C       G(T12,N3740,FULL)

C       G(T12,N3743,FULL)

C       G(T12,N3746,FULL)

C       G(T12,N3749,FULL)

C       G(T12,N3752,FULL)

C       G(T12,N3753,FULL)

C       G(T12,N3754,FULL)

C       G(T12,N3755,FULL)

C       G(T12,N3756,FULL)

C       G(T12,N3757,FULL)

C       G(T12,N3758,FULL)

C       G(T12,N3759,FULL)

C       G(T12,N3760,FULL)

C       G(T12,N3761,FULL)

C       G(T12,N3762,FULL)

C       G(T12,N3763,FULL)

C       G(T12,N3764,FULL)

C       G(T12,N3765,FULL)

C       G(T12,N3766,FULL)

C       G(T12,N3767,FULL)

C       G(T12,N3768,FULL)

C       G(T12,N3769,FULL)

C       G(T12,N3770,FULL)

C       G(T12,N3771,FULL)

C       G(T12,N3772,FULL)

C       G(T12,N3773,FULL)

C       G(T12,N3774,FULL)

C       G(T12,N3775,FULL)

C       G(T12,N3776,FULL)

C       G(T12,N3777,FULL)

C       G(T12,N3778,FULL)

C       G(T12,N3779,FULL)

C       G(T12,N3780,FULL)

C       G(T12,N3781,FULL)

C       G(T12,N3782,FULL)

C       G(T12,N3783,FULL)

C       G(T12,N3784,FULL)

C       G(T12,N3785,FULL)

C       G(T12,N3786,FULL)

C       G(T12,N3787,FULL)

C       G(T12,N3788,FULL)

C       G(T13,N3789,FULL)

C       G(T13,N3790,FULL)

C       G(T13,N3791,FULL)

C       G(T13,N3792,FULL)

C       G(T13,N3793,FULL)

C       G(T13,N3794,FULL)

C       G(T13,N3795,FULL)

C       G(T13,N3796,FULL)

C       G(T13,N3797,FULL)

C       G(T13,N3798,FULL)

C       G(T13,N3805,FULL)

C       G(T13,N3806,FULL)

C       G(T13,N3807,FULL)

C       G(T13,N3810,FULL)

C       G(T13,N3811,FULL)

C       G(T13,N3812,FULL)

C       G(T13,N3813,FULL)

C       G(T13,N3814,FULL)

C       G(T13,N3815,FULL)

C       G(T13,N3816,FULL)

C       G(T13,N3817,FULL)

C       G(T13,N3818,FULL)

C       G(T13,N3819,FULL)

C       G(T13,N3820,FULL)

C       G(T13,N3827,FULL)

C       G(T13,N3828,FULL)

C       G(T13,N3829,FULL)

C       G(T13,N3832,FULL)

C       G(T13,N3833,FULL)

C       G(T13,N3834,FULL)

C       G(T13,N3835,FULL)

C       G(T13,N3836,FULL)

C       G(T13,N3837,FULL)

C       G(T13,N3838,FULL)

C       G(T13,N3839,FULL)

C       G(T13,N3840,FULL)

C       G(T13,N3841,FULL)

C       G(T13,N3842,FULL)

C       G(T13,N3849,FULL)

C       G(T13,N3850,FULL)

C       G(T13,N3851,FULL)

C       G(T13,N3854,FULL)

C       G(T13,N3855,FULL)

C       G(T13,N3856,FULL)

C       G(T13,N3857,FULL)

C       G(T13,N3858,FULL)

C       G(T13,N3859,FULL)

C       G(T13,N3860,FULL)

C       G(T13,N3861,FULL)

C       G(T13,N3862,FULL)

C       G(T13,N3863,FULL)

C       G(T13,N3864,FULL)

C       G(T13,N3871,FULL)

C       G(T13,N3872,FULL)

C       G(T13,N3873,FULL)

C       G(T13,N3876,FULL)

C       G(T13,N3877,FULL)

C       G(T13,N3878,FULL)

C       G(T13,N3879,FULL)

C       G(T13,N3880,FULL)

C       G(T13,N3881,FULL)

C       G(T13,N3882,FULL)

C       G(T13,N3883,FULL)

C       G(T13,N3884,FULL)

C       G(T13,N3885,FULL)

C       G(T13,N3886,FULL)

C       G(T13,N3890,FULL)

C       G(T13,N3891,FULL)

C       G(T13,N3893,FULL)

C       G(T13,N3894,FULL)

C       G(T13,N3895,FULL)

C       G(T13,N3896,FULL)

C       G(T13,N3897,FULL)

C       G(T13,N3898,FULL)

C       G(T13,N3899,FULL)

C       G(T13,N3900,FULL)

C       G(T13,N3901,FULL)

C       G(T13,N3902,FULL)

C       G(T13,N3906,FULL)

C       G(T13,N3907,FULL)

C       G(T13,N3909,FULL)

C       G(T13,N3910,FULL)

C       G(T13,N3911,FULL)

C       G(T13,N3912,FULL)

C       G(T13,N3913,FULL)

C       G(T13,N3914,FULL)

C       G(T13,N3915,FULL)

C       G(T13,N3916,FULL)

C       G(T13,N3917,FULL)

C       G(T13,N3918,FULL)

C       G(T13,N3922,FULL)

C       G(T13,N3923,FULL)

C       G(T13,N3925,FULL)

C       G(T13,N3926,FULL)

C       G(T13,N3927,FULL)

C       G(T13,N3928,FULL)

C       G(T13,N3929,FULL)

C       G(T13,N3930,FULL)

C       G(T13,N3931,FULL)

C       G(T13,N3932,FULL)

C       G(T13,N3933,FULL)

C       G(T13,N3934,FULL)

C       G(T13,N3936,FULL)

C       G(T13,N3937,FULL)

C       G(T13,N3939,FULL)

C       G(T13,N3940,FULL)

C       G(T13,N3941,FULL)

C       G(T13,N3942,FULL)

C       G(T13,N3943,FULL)

C       G(T13,N3944,FULL)

C       G(T13,N3945,FULL)

C       G(T13,N3946,FULL)

C       G(T13,N3947,FULL)

C       G(T13,N3948,FULL)

C       G(T13,N3950,FULL)

C       G(T13,N3951,FULL)

C       G(T13,N3953,FULL)

C       G(T13,N3954,FULL)

C       G(T13,N3955,FULL)

C       G(T13,N3956,FULL)

C       G(T13,N3957,FULL)

C       G(T13,N3958,FULL)

C       G(T13,N3959,FULL)

C       G(T13,N3960,FULL)

C       G(T13,N3961,FULL)

C       G(T13,N3962,FULL)

C       G(T13,N3964,FULL)

C       G(T13,N3965,FULL)

C       G(T13,N3967,FULL)

C       G(T13,N3968,FULL)

C       G(T13,N3969,FULL)

C       G(T13,N3970,FULL)

C       G(T13,N3971,FULL)

C       G(T13,N3972,FULL)

C       G(T13,N3973,FULL)

C       G(T13,N3974,FULL)

C       G(T13,N3975,FULL)

C       G(T13,N3976,FULL)

C       G(T13,N3980,FULL)

C       G(T13,N3981,FULL)

C       G(T13,N3983,FULL)

C       G(T13,N3984,FULL)

C       G(T13,N3985,FULL)

C       G(T13,N3986,FULL)

C       G(T13,N3987,FULL)

C       G(T13,N3988,FULL)

C       G(T13,N3989,FULL)

C       G(T13,N3990,FULL)

C       G(T13,N3991,FULL)

C       G(T13,N3992,FULL)

C       G(T13,N3993,FULL)

C       G(T13,N3997,FULL)

C       G(T13,N3998,FULL)

C       G(T13,N4000,FULL)

C       G(T13,N4001,FULL)

C       G(T13,N4002,FULL)

C       G(T13,N4003,FULL)

C       G(T13,N4004,FULL)

C       G(T13,N4005,FULL)

C       G(T13,N4006,FULL)

C       G(T13,N4007,FULL)

C       G(T13,N4008,FULL)

C       G(T13,N4009,FULL)

C       G(T13,N4010,FULL)

C       G(T13,N4014,FULL)

C       G(T13,N4015,FULL)

C       G(T13,N4017,FULL)
        CALL xC01234_(RMF2(3),S34,RMF2(3),CMF2(4),XMW2,XMW2,C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,1)

        PRE = -((ALPHA*CBA*PZ12*PZ34*(1D0-6D0*C2(0,0)+C1(1)*S34+
     &  C1(2)*S34+C2(1,2)*S34)*XMZ)/(8D0*PI*XCW*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE

C       G(T13,N4020,FULL)

C       G(T13,N4023,FULL)

C       G(T13,N4026,FULL)

C       G(T13,N4029,FULL)

C       G(T13,N4032,FULL)

C       G(T13,N4035,FULL)

C       G(T13,N4038,FULL)

C       G(T13,N4041,FULL)

C       G(T13,N4044,FULL)

C       G(T13,N4047,FULL)

C       G(T13,N4050,FULL)

C       G(T13,N4053,FULL)

C       G(T13,N4056,FULL)
        CALL xC01234_(S34,RMF2(3),RMF2(3),CMF2(4),CMF2(4),XMW2,C0,C1,C2,
     &  C3,C4,B0,B1,B2,B3,2,1)

        PRE = (ALPHA*CBA*PZ12*PZ34*(1D0-2D0*C2(0,0)-C1(1)*S34-C1(2)*
     &  S34-C2(1,1)*S34-C2(1,2)*S34)*XMZ*(1D0-2D0*QF(4)*XSW2))/
     &  (16D0*PI*XCW*XCW2*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE

C       G(T13,N4057,FULL)

C       G(T13,N4058,FULL)

C       G(T13,N4059,FULL)

C       G(T13,N4060,FULL)

C       G(T13,N4061,FULL)

C       G(T13,N4062,FULL)

C       G(T13,N4063,FULL)

C       G(T13,N4064,FULL)

C       G(T13,N4065,FULL)

C       G(T13,N4066,FULL)

C       G(T13,N4067,FULL)

C       G(T13,N4068,FULL)

C       G(T13,N4069,FULL)

C       G(T13,N4070,FULL)

C       G(T13,N4071,FULL)

C       G(T13,N4072,FULL)

C       G(T13,N4073,FULL)

C       G(T13,N4074,FULL)

C       G(T13,N4075,FULL)

C       G(T13,N4076,FULL)

C       G(T13,N4077,FULL)

C       G(T13,N4078,FULL)

C       G(T13,N4079,FULL)

C       G(T13,N4080,FULL)

C       G(T13,N4081,FULL)

C       G(T13,N4082,FULL)

C       G(T13,N4083,FULL)

C       G(T13,N4084,FULL)

C       G(T13,N4085,FULL)

C       G(T13,N4086,FULL)

C       G(T13,N4087,FULL)

C       G(T13,N4088,FULL)

C       G(T13,N4089,FULL)

C       G(T13,N4090,FULL)

C       G(T13,N4091,FULL)

C       G(T13,N4092,FULL)

C       G(T13,N4093,FULL)

C       G(T13,N4094,FULL)

C       G(T13,N4095,FULL)

C       G(T13,N4096,FULL)

C       G(T13,N4097,FULL)

C       G(T13,N4098,FULL)

C       G(T13,N4099,FULL)

C       G(T13,N4100,FULL)

C       G(T13,N4101,FULL)

C       G(T13,N4102,FULL)

C       G(T13,N4103,FULL)

C       G(T13,N4104,FULL)

C       G(T13,N4105,FULL)

C       G(T13,N4106,FULL)

C       G(T13,N4107,FULL)

C       G(T13,N4108,FULL)

C       G(T13,N4109,FULL)

C       G(T13,N4110,FULL)

C       G(T13,N4111,FULL)

C       G(T13,N4112,FULL)

C       G(T13,N4113,FULL)

C       G(T13,N4114,FULL)

C       G(T13,N4115,FULL)

C       G(T13,N4116,FULL)

C       G(T13,N4117,FULL)

C       G(T13,N4118,FULL)

C       G(T13,N4119,FULL)

C       G(T13,N4120,FULL)

C       G(T13,N4121,FULL)

C       G(T13,N4122,FULL)

C       G(T13,N4123,FULL)

C       G(T13,N4124,FULL)

C       G(T13,N4125,FULL)

C       G(T13,N4126,FULL)

C       G(T13,N4127,FULL)

C       G(T13,N4128,FULL)

C       G(T13,N4129,FULL)

C       G(T13,N4130,FULL)

C       G(T13,N4131,FULL)

C       G(T13,N4132,FULL)

C       G(T13,N4133,FULL)
        CALL xC01234_(RMF2(3),S34,RMF2(3),NULL,CMF2(3),CMF2(3),C0,C1,C2,
     &  C3,C4,B0,B1,B2,B3,2,1)

        PRE = -((QF(3)**2*ALPHA*CBA*PZ12*PZ34*(1D0-2D0*C2(0,0)+
     &  C1(1)*S34+C1(2)*S34+C2(1,2)*S34+C0*S34)*XMZ)/(8D0*PI*XCW*
     &  XCW2))

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*XSW

C       G(T13,N4134,FULL)
        CALL xC01234_(S34,RMF2(3),RMF2(3),CMF2(3),CMF2(3),XMZ2,C0,C1,C2,
     &  C3,C4,B0,B1,B2,B3,2,1)

        PRE = -((ALPHA*CBA*PZ12*PZ34*(1D0-2D0*C2(0,0)-C1(1)*S34-
     &  C1(2)*S34-C2(1,1)*S34-C2(1,2)*S34)*XCW2**(-2)*XMZ)/(32D0*PI*
     &  XCW))

        F(1,-1,-1) = F(1,-1,-1)-(PRE*XSW2**(-2)*(1D0-2D0*QF(1)*
     &  XSW2)*(1D0+2D0*QF(3)*XSW2)**3)/XSW
        F(1,-1,1) = F(1,-1,1)-8D0*QF(3)**3*PRE*XSW*(1D0-2D0*QF(1)*
     &  XSW2)
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2)**
     &  3)/(XSW*XSW2)
        F(1,1,1) = F(1,1,1)+16D0*QF(1)*QF(3)**3*PRE*XSW*XSW2

C       G(T14,N4135,FULL)

C       G(T14,N4136,FULL)

C       G(T14,N4137,FULL)

C       G(T14,N4138,FULL)

C       G(T14,N4139,FULL)

C       G(T14,N4140,FULL)

C       G(T14,N4141,FULL)

C       G(T14,N4142,FULL)

C       G(T14,N4143,FULL)

C       G(T14,N4144,FULL)

C       G(T14,N4151,FULL)

C       G(T14,N4152,FULL)

C       G(T14,N4153,FULL)

C       G(T14,N4156,FULL)

C       G(T14,N4157,FULL)

C       G(T14,N4158,FULL)

C       G(T14,N4159,FULL)

C       G(T14,N4160,FULL)

C       G(T14,N4161,FULL)

C       G(T14,N4162,FULL)

C       G(T14,N4163,FULL)

C       G(T14,N4164,FULL)

C       G(T14,N4165,FULL)

C       G(T14,N4166,FULL)

C       G(T14,N4173,FULL)

C       G(T14,N4174,FULL)

C       G(T14,N4175,FULL)

C       G(T14,N4178,FULL)

C       G(T14,N4179,FULL)

C       G(T14,N4180,FULL)

C       G(T14,N4181,FULL)

C       G(T14,N4182,FULL)

C       G(T14,N4183,FULL)

C       G(T14,N4184,FULL)

C       G(T14,N4185,FULL)

C       G(T14,N4186,FULL)

C       G(T14,N4187,FULL)

C       G(T14,N4188,FULL)

C       G(T14,N4192,FULL)

C       G(T14,N4193,FULL)

C       G(T14,N4195,FULL)

C       G(T14,N4196,FULL)

C       G(T14,N4197,FULL)

C       G(T14,N4198,FULL)

C       G(T14,N4199,FULL)

C       G(T14,N4200,FULL)

C       G(T14,N4201,FULL)

C       G(T14,N4202,FULL)

C       G(T14,N4203,FULL)

C       G(T14,N4204,FULL)

C       G(T14,N4206,FULL)

C       G(T14,N4207,FULL)

C       G(T14,N4213,FULL)

C       G(T14,N4214,FULL)

C       G(T14,N4215,FULL)

C       G(T14,N4216,FULL)

C       G(T14,N4217,FULL)

C       G(T14,N4218,FULL)

C       G(T14,N4219,FULL)

C       G(T14,N4220,FULL)

C       G(T14,N4221,FULL)

C       G(T14,N4222,FULL)

C       G(T14,N4223,FULL)

C       G(T14,N4227,FULL)

C       G(T14,N4228,FULL)

C       G(T14,N4230,FULL)

C       G(T14,N4233,FULL)

C       G(T14,N4236,FULL)

C       G(T14,N4239,FULL)

C       G(T14,N4242,FULL)

C       G(T14,N4245,FULL)

C       G(T14,N4248,FULL)

C       G(T14,N4249,FULL)

C       G(T14,N4250,FULL)

C       G(T14,N4251,FULL)

C       G(T14,N4252,FULL)

C       G(T14,N4253,FULL)

C       G(T14,N4254,FULL)

C       G(T14,N4255,FULL)

C       G(T14,N4256,FULL)

C       G(T14,N4257,FULL)

C       G(T14,N4258,FULL)

C       G(T14,N4259,FULL)

C       G(T14,N4260,FULL)

C       G(T14,N4261,FULL)

C       G(T14,N4262,FULL)

C       G(T14,N4263,FULL)

C       G(T14,N4264,FULL)

C       G(T14,N4265,FULL)

C       G(T14,N4266,FULL)

C       G(T14,N4267,FULL)

C       G(T14,N4268,FULL)

C       G(T14,N4269,FULL)

C       G(T14,N4270,FULL)

C       G(T14,N4271,FULL)

C       G(T14,N4272,FULL)

C       G(T14,N4273,FULL)

C       G(T14,N4274,FULL)

C       G(T14,N4275,FULL)

C       G(T14,N4276,FULL)

C       G(T14,N4277,FULL)

C       G(T14,N4278,FULL)

C       G(T14,N4279,FULL)

C       G(T14,N4280,FULL)

C       G(T14,N4281,FULL)

C       G(T14,N4282,FULL)

C       G(T14,N4283,FULL)

C       G(T14,N4284,FULL)

C       G(T15,N4285,FULL)

C       G(T15,N4286,FULL)

C       G(T15,N4287,FULL)

C       G(T15,N4288,FULL)

C       G(T15,N4289,FULL)

C       G(T15,N4290,FULL)

C       G(T15,N4291,FULL)

C       G(T15,N4292,FULL)

C       G(T15,N4293,FULL)

C       G(T15,N4294,FULL)

C       G(T15,N4301,FULL)

C       G(T15,N4302,FULL)

C       G(T15,N4303,FULL)

C       G(T15,N4306,FULL)

C       G(T15,N4307,FULL)

C       G(T15,N4308,FULL)

C       G(T15,N4309,FULL)

C       G(T15,N4310,FULL)

C       G(T15,N4311,FULL)

C       G(T15,N4312,FULL)

C       G(T15,N4313,FULL)

C       G(T15,N4314,FULL)

C       G(T15,N4315,FULL)

C       G(T15,N4316,FULL)

C       G(T15,N4323,FULL)

C       G(T15,N4324,FULL)

C       G(T15,N4325,FULL)

C       G(T15,N4328,FULL)

C       G(T15,N4329,FULL)

C       G(T15,N4330,FULL)

C       G(T15,N4331,FULL)

C       G(T15,N4332,FULL)

C       G(T15,N4333,FULL)

C       G(T15,N4334,FULL)

C       G(T15,N4335,FULL)

C       G(T15,N4336,FULL)

C       G(T15,N4337,FULL)

C       G(T15,N4338,FULL)

C       G(T15,N4342,FULL)

C       G(T15,N4343,FULL)

C       G(T15,N4345,FULL)

C       G(T15,N4346,FULL)

C       G(T15,N4347,FULL)

C       G(T15,N4348,FULL)

C       G(T15,N4349,FULL)

C       G(T15,N4350,FULL)

C       G(T15,N4351,FULL)

C       G(T15,N4352,FULL)

C       G(T15,N4353,FULL)

C       G(T15,N4354,FULL)

C       G(T15,N4356,FULL)

C       G(T15,N4357,FULL)

C       G(T15,N4363,FULL)

C       G(T15,N4364,FULL)

C       G(T15,N4365,FULL)

C       G(T15,N4366,FULL)

C       G(T15,N4367,FULL)

C       G(T15,N4368,FULL)

C       G(T15,N4369,FULL)

C       G(T15,N4370,FULL)

C       G(T15,N4371,FULL)

C       G(T15,N4372,FULL)

C       G(T15,N4373,FULL)

C       G(T15,N4377,FULL)

C       G(T15,N4378,FULL)

C       G(T15,N4380,FULL)

C       G(T15,N4383,FULL)

C       G(T15,N4386,FULL)

C       G(T15,N4389,FULL)

C       G(T15,N4392,FULL)

C       G(T15,N4395,FULL)

C       G(T15,N4398,FULL)

C       G(T15,N4399,FULL)

C       G(T15,N4400,FULL)

C       G(T15,N4401,FULL)

C       G(T15,N4402,FULL)

C       G(T15,N4403,FULL)

C       G(T15,N4404,FULL)

C       G(T15,N4405,FULL)

C       G(T15,N4406,FULL)

C       G(T15,N4407,FULL)

C       G(T15,N4408,FULL)

C       G(T15,N4409,FULL)

C       G(T15,N4410,FULL)

C       G(T15,N4411,FULL)

C       G(T15,N4412,FULL)

C       G(T15,N4413,FULL)

C       G(T15,N4414,FULL)

C       G(T15,N4415,FULL)

C       G(T15,N4416,FULL)

C       G(T15,N4417,FULL)

C       G(T15,N4418,FULL)

C       G(T15,N4419,FULL)

C       G(T15,N4420,FULL)

C       G(T15,N4421,FULL)

C       G(T15,N4422,FULL)

C       G(T15,N4423,FULL)

C       G(T15,N4424,FULL)

C       G(T15,N4425,FULL)

C       G(T15,N4426,FULL)

C       G(T15,N4427,FULL)

C       G(T15,N4428,FULL)

C       G(T15,N4429,FULL)

C       G(T15,N4430,FULL)

C       G(T15,N4431,FULL)

C       G(T15,N4432,FULL)

C       G(T15,N4433,FULL)

C       G(T15,N4434,FULL)

C       G(T16,N4435,FULL)

C       G(T16,N4436,FULL)

C       G(T16,N4437,FULL)

C       G(T16,N4438,FULL)

C       G(T16,N4439,FULL)

C       G(T16,N4440,FULL)

C       G(T16,N4441,FULL)

C       G(T16,N4442,FULL)

C       G(T16,N4443,FULL)

C       G(T16,N4444,FULL)

C       G(T16,N4445,FULL)

C       G(T16,N4446,FULL)

C       G(T16,N4447,FULL)

C       G(T16,N4448,FULL)

C       G(T16,N4449,FULL)

C       G(T16,N4450,FULL)

C       G(T16,N4451,FULL)

C       G(T16,N4452,FULL)

C       G(T16,N4453,FULL)

C       G(T16,N4454,FULL)

C       G(T16,N4455,FULL)

C       G(T16,N4456,FULL)

C       G(T16,N4457,FULL)

C       G(T16,N4458,FULL)

C       G(T16,N4459,FULL)

C       G(T16,N4460,FULL)

C       G(T16,N4461,FULL)

C       G(T16,N4462,FULL)

C       G(T16,N4463,FULL)

C       G(T16,N4464,FULL)

C       G(T16,N4465,FULL)

C       G(T16,N4466,FULL)

C       G(T16,N4467,FULL)

C       G(T16,N4468,FULL)

C       G(T16,N4469,FULL)

C       G(T16,N4470,FULL)

C       G(T16,N4471,FULL)

C       G(T16,N4472,FULL)

C       G(T16,N4473,FULL)

C       G(T16,N4474,FULL)

C       G(T16,N4475,FULL)

C       G(T16,N4476,FULL)

C       G(T16,N4477,FULL)

C       G(T16,N4478,FULL)

C       G(T16,N4479,FULL)

C       G(T16,N4480,FULL)

C       G(T16,N4481,FULL)

C       G(T16,N4482,FULL)

C       G(T16,N4483,FULL)

C       G(T16,N4484,FULL)

C       G(T16,N4485,FULL)

C       G(T16,N4486,FULL)

C       G(T16,N4487,FULL)

C       G(T16,N4488,FULL)

C       G(T16,N4489,FULL)

C       G(T16,N4490,FULL)

C       G(T16,N4491,FULL)

C       G(T16,N4492,FULL)

C       G(T16,N4493,FULL)

C       G(T16,N4494,FULL)

C       G(T16,N4495,FULL)

C       G(T16,N4496,FULL)

C       G(T16,N4497,FULL)

C       G(T16,N4498,FULL)

C       G(T16,N4499,FULL)

C       G(T16,N4500,FULL)

C       G(T16,N4501,FULL)

C       G(T16,N4502,FULL)

C       G(T16,N4503,FULL)

C       G(T16,N4504,FULL)

C       G(T16,N4505,FULL)

C       G(T16,N4506,FULL)

C       G(T16,N4507,FULL)

C       G(T16,N4508,FULL)

C       G(T16,N4509,FULL)

C       G(T16,N4510,FULL)

C       G(T16,N4511,FULL)

C       G(T16,N4512,FULL)

C       G(T16,N4513,FULL)

C       G(T16,N4514,FULL)

C       G(T16,N4515,FULL)

C       G(T16,N4516,FULL)

C       G(T16,N4517,FULL)

C       G(T16,N4518,FULL)

C       G(T16,N4519,FULL)

C       G(T16,N4520,FULL)

C       G(T16,N4521,FULL)

C       G(T16,N4522,FULL)

C       G(T16,N4523,FULL)

C       G(T16,N4524,FULL)

C       G(T16,N4525,FULL)

C       G(T16,N4526,FULL)

C       G(T16,N4527,FULL)

C       G(T16,N4528,FULL)

C       G(T16,N4529,FULL)

C       G(T16,N4530,FULL)

C       G(T16,N4531,FULL)

C       G(T16,N4532,FULL)

C       G(T16,N4533,FULL)

C       G(T16,N4534,FULL)

C       G(T16,N4535,FULL)

C       G(T16,N4536,FULL)

C       G(T16,N4537,FULL)

C       G(T16,N4538,FULL)

C       G(T16,N4539,FULL)

C       G(T16,N4540,FULL)

C       G(T16,N4541,FULL)

C       G(T16,N4542,FULL)

C       G(T16,N4543,FULL)

C       G(T16,N4544,FULL)

C       G(T16,N4545,FULL)

C       G(T16,N4546,FULL)

C       G(T16,N4547,FULL)

C       G(T16,N4548,FULL)

C       G(T16,N4549,FULL)

C       G(T16,N4550,FULL)

C       G(T16,N4551,FULL)

C       G(T16,N4552,FULL)

C       G(T16,N4553,FULL)

C       G(T16,N4554,FULL)

C       G(T16,N4555,FULL)

C       G(T16,N4556,FULL)

C       G(T16,N4557,FULL)

C       G(T16,N4558,FULL)

C       G(T16,N4559,FULL)

C       G(T16,N4560,FULL)

C       G(T16,N4561,FULL)

C       G(T16,N4562,FULL)

C       G(T16,N4563,FULL)

C       G(T16,N4564,FULL)

C       G(T16,N4565,FULL)

C       G(T16,N4566,FULL)

C       G(T16,N4567,FULL)

C       G(T16,N4568,FULL)

C       G(T16,N4569,FULL)

C       G(T16,N4570,FULL)

C       G(T16,N4571,FULL)

C       G(T16,N4572,FULL)

C       G(T16,N4573,FULL)

C       G(T16,N4574,FULL)

C       G(T16,N4575,FULL)

C       G(T16,N4576,FULL)

C       G(T16,N4577,FULL)
        CALL xB012345_(MHH2,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((QF(1)*QF(3)*ALPHA*B0*CBA*MHH2)/(4D0*PI*S12*S34*XMW*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE
        F(1,-1,1) = F(1,-1,1)+PRE
        F(1,1,-1) = F(1,1,-1)+PRE
        F(1,1,1) = F(1,1,1)+PRE

C       G(T16,N4578,FULL)
        CALL xB012345_(MHH2,XMHP2,XMHP2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((QF(1)*QF(3)*B0*PI**(-2)*(4D0*ALPHA*CB**3*MHH2*PI*
     &  SA-4D0*ALPHA*MA02*PI*SAB+8D0*ALPHA*CB*CBA*MHP2*PI*SB+4D0*
     &  ALPHA*CA*MHH2*PI*SB**3-4D0*LAM5*SAB*XMW2*XSW2))/(16D0*CB*
     &  S12*S34*SB*XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE
        F(1,-1,1) = F(1,-1,1)+PRE
        F(1,1,-1) = F(1,1,-1)+PRE
        F(1,1,1) = F(1,1,1)+PRE

C       G(T16,N4579,FULL)
        CALL xB012345_(MHH2,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = (QF(1)*QF(3)*ALPHA*(2D0-3D0*B0)*CBA*XMW)/(2D0*PI*S12*
     &  S34*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE
        F(1,-1,1) = F(1,-1,1)+PRE
        F(1,1,-1) = F(1,1,-1)+PRE
        F(1,1,1) = F(1,1,1)+PRE

C       G(T16,N4580,FULL)
        CALL xB012345_(MHH2,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = (QF(1)*ALPHA*B0*CBA*MHH2*PZ34*(XCW+XSW)*(XCW-XSW))/
     &  (16D0*PI*S12*XCW2*XMW*XSW)

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE
        F(1,1,-1) = F(1,1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,1,1) = F(1,1,1)+2D0*QF(3)*PRE

C       G(T16,N4581,FULL)
        CALL xB012345_(MHH2,XMHP2,XMHP2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = (QF(1)*B0*PI**(-2)*PZ34*(XCW+XSW)*(XCW-XSW)*(4D0*
     &  ALPHA*CB**3*MHH2*PI*SA-4D0*ALPHA*MA02*PI*SAB+8D0*ALPHA*CB*
     &  CBA*MHP2*PI*SB+4D0*ALPHA*CA*MHH2*PI*SB**3-4D0*LAM5*SAB*XMW2*
     &  XSW2))/(64D0*CB*S12*SB*XCW2*XMW*XSW)

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE
        F(1,1,-1) = F(1,1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,1,1) = F(1,1,1)+2D0*QF(3)*PRE

C       G(T16,N4582,FULL)
        CALL xB012345_(MHH2,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((QF(1)*ALPHA*(2D0-3D0*B0)*CBA*PZ34*XMW)/(4D0*PI*S12*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE
        F(1,1,-1) = F(1,1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,1,1) = F(1,1,1)+2D0*QF(3)*PRE

C       G(T16,N4583,FULL)

C       G(T16,N4584,FULL)

C       G(T16,N4585,FULL)

C       G(T16,N4586,FULL)

C       G(T16,N4587,FULL)

C       G(T16,N4588,FULL)

C       G(T16,N4589,FULL)

C       G(T16,N4590,FULL)

C       G(T16,N4591,FULL)

C       G(T16,N4592,FULL)

C       G(T16,N4593,FULL)

C       G(T16,N4594,FULL)

C       G(T16,N4595,FULL)

C       G(T16,N4596,FULL)

C       G(T16,N4597,FULL)
        CALL xB012345_(MHH2,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = (QF(3)*ALPHA*B0*CBA*MHH2*PZ12*(XCW+XSW)*(XCW-XSW))/
     &  (16D0*PI*S34*XCW2*XMW*XSW)

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE
        F(1,1,1) = F(1,1,1)+2D0*QF(1)*PRE

C       G(T16,N4598,FULL)
        CALL xB012345_(MHH2,XMHP2,XMHP2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = (QF(3)*B0*PI**(-2)*PZ12*(XCW+XSW)*(XCW-XSW)*(4D0*
     &  ALPHA*CB**3*MHH2*PI*SA-4D0*ALPHA*MA02*PI*SAB+8D0*ALPHA*CB*
     &  CBA*MHP2*PI*SB+4D0*ALPHA*CA*MHH2*PI*SB**3-4D0*LAM5*SAB*XMW2*
     &  XSW2))/(64D0*CB*S34*SB*XCW2*XMW*XSW)

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE
        F(1,1,1) = F(1,1,1)+2D0*QF(1)*PRE

C       G(T16,N4599,FULL)
        CALL xB012345_(MHH2,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((QF(3)*ALPHA*(2D0-3D0*B0)*CBA*PZ12*XMW)/(4D0*PI*S34*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE
        F(1,1,1) = F(1,1,1)+2D0*QF(1)*PRE

C       G(T16,N4600,FULL)
        CALL xB012345_(MHH2,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*CBA*MHH2*PZ12*PZ34*XCW2**(-2)*(XCW+XSW)**
     &  2*(XCW-XSW)**2)/(64D0*PI*XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T16,N4601,FULL)
        CALL xB012345_(MHH2,XMHP2,XMHP2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((B0*PI**(-2)*PZ12*PZ34*XCW2**(-2)*(XCW+XSW)**2*(XCW-
     &  XSW)**2*(4D0*ALPHA*CB**3*MHH2*PI*SA-4D0*ALPHA*MA02*PI*SAB+
     &  8D0*ALPHA*CB*CBA*MHP2*PI*SB+4D0*ALPHA*CA*MHH2*PI*SB**3-4D0*
     &  LAM5*SAB*XMW2*XSW2))/(256D0*CB*SB*XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T16,N4602,FULL)
        CALL xB012345_(MHH2,XMH02,XMH02,B0,B1,B2,B3,B4,B5,0,0)

        PRE = (B0*PI**(-2)*PZ12*PZ34*XCW2**(-2)*(12D0*ALPHA*CBA*
     &  MA02*PI*S2A-16D0*ALPHA*CBA*MH02*PI*S2A-8D0*ALPHA*CBA*MHH2*
     &  PI*S2A-4D0*ALPHA*CBA*MA02*PI*S2B+8D0*ALPHA*MA02*PI*SAB-12D0*
     &  ALPHA*C2A*MA02*PI*SBA-4D0*ALPHA*C2B*MA02*PI*SBA+12D0*CBA*
     &  LAM5*S2A*XMW2*XSW2-4D0*CBA*LAM5*S2B*XMW2*XSW2+8D0*LAM5*SAB*
     &  XMW2*XSW2-12D0*C2A*LAM5*SBA*XMW2*XSW2-4D0*C2B*LAM5*SBA*XMW2*
     &  XSW2))/(2048D0*CB*SB*XMW*XSW)

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T16,N4603,FULL)
        CALL xB012345_(MHH2,XMHH2,XMHH2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((3D0*B0*PI**(-2)*PZ12*PZ34*XCW2**(-2)*(4D0*ALPHA*CB*
     &  MHH2*PI*SA**3+4D0*ALPHA*CA**3*MHH2*PI*SB-4D0*ALPHA*MA02*PI*
     &  SAB*SBA**2-4D0*LAM5*SAB*SBA**2*XMW2*XSW2))/(512D0*CB*SB*XMW*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T16,N4604,FULL)
        CALL xB012345_(MHH2,XMA02,XMA02,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((B0*PI**(-2)*PZ12*PZ34*XCW2**(-2)*(4D0*ALPHA*CB**3*
     &  MHH2*PI*SA+4D0*ALPHA*CA*MHH2*PI*SB**3+4D0*ALPHA*C2B*MA02*PI*
     &  SBA-4D0*LAM5*SAB*XMW2*XSW2))/(512D0*CB*SB*XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T16,N4605,FULL)
        CALL xB012345_(MHH2,XMZ2,XMZ2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*CBA*MHH2*PZ12*PZ34*XCW2**(-2))/(128D0*PI*
     &  XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T16,N4606,FULL)
        CALL xB012345_(MHH2,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = (ALPHA*(2D0-3D0*B0)*CBA*PZ12*PZ34*XMW)/(8D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T17,N4607,FULL)

C       G(T17,N4608,FULL)

C       G(T17,N4609,FULL)

C       G(T17,N4610,FULL)

C       G(T17,N4611,FULL)

C       G(T17,N4612,FULL)

C       G(T17,N4613,FULL)

C       G(T17,N4614,FULL)

C       G(T17,N4615,FULL)

C       G(T17,N4616,FULL)

C       G(T17,N4617,FULL)

C       G(T17,N4618,FULL)

C       G(T17,N4619,FULL)

C       G(T17,N4620,FULL)

C       G(T17,N4621,FULL)

C       G(T17,N4622,FULL)

C       G(T17,N4623,FULL)

C       G(T17,N4624,FULL)

C       G(T17,N4625,FULL)

C       G(T17,N4626,FULL)

C       G(T17,N4627,FULL)

C       G(T17,N4628,FULL)

C       G(T17,N4629,FULL)

C       G(T17,N4630,FULL)

C       G(T17,N4631,FULL)

C       G(T17,N4632,FULL)

C       G(T17,N4633,FULL)

C       G(T17,N4634,FULL)

C       G(T17,N4635,FULL)

C       G(T17,N4636,FULL)

C       G(T17,N4637,FULL)

C       G(T17,N4638,FULL)

C       G(T17,N4639,FULL)

C       G(T17,N4640,FULL)

C       G(T17,N4641,FULL)

C       G(T17,N4642,FULL)

C       G(T17,N4643,FULL)

C       G(T17,N4644,FULL)

C       G(T17,N4645,FULL)

C       G(T17,N4646,FULL)

C       G(T17,N4647,FULL)

C       G(T17,N4648,FULL)

C       G(T17,N4649,FULL)

C       G(T17,N4650,FULL)

C       G(T17,N4651,FULL)

C       G(T17,N4652,FULL)

C       G(T17,N4653,FULL)

C       G(T17,N4654,FULL)

C       G(T17,N4655,FULL)

C       G(T17,N4656,FULL)

C       G(T17,N4657,FULL)

C       G(T17,N4658,FULL)

C       G(T17,N4659,FULL)

C       G(T17,N4660,FULL)

C       G(T17,N4661,FULL)

C       G(T17,N4662,FULL)

C       G(T17,N4663,FULL)

C       G(T17,N4664,FULL)

C       G(T17,N4665,FULL)

C       G(T17,N4666,FULL)

C       G(T17,N4667,FULL)

C       G(T17,N4668,FULL)

C       G(T17,N4669,FULL)

C       G(T17,N4670,FULL)

C       G(T17,N4671,FULL)

C       G(T17,N4672,FULL)

C       G(T17,N4673,FULL)

C       G(T17,N4674,FULL)

C       G(T17,N4675,FULL)

C       G(T17,N4676,FULL)

C       G(T17,N4677,FULL)

C       G(T17,N4678,FULL)

C       G(T17,N4679,FULL)

C       G(T17,N4680,FULL)

C       G(T17,N4681,FULL)

C       G(T17,N4682,FULL)

C       G(T17,N4683,FULL)

C       G(T17,N4684,FULL)

C       G(T17,N4685,FULL)

C       G(T17,N4686,FULL)

C       G(T17,N4687,FULL)

C       G(T17,N4688,FULL)

C       G(T17,N4689,FULL)

C       G(T17,N4690,FULL)

C       G(T17,N4691,FULL)

C       G(T17,N4692,FULL)

C       G(T17,N4693,FULL)

C       G(T17,N4694,FULL)

C       G(T17,N4695,FULL)

C       G(T17,N4696,FULL)

C       G(T17,N4697,FULL)

C       G(T17,N4698,FULL)

C       G(T17,N4699,FULL)

C       G(T17,N4700,FULL)

C       G(T17,N4701,FULL)

C       G(T17,N4702,FULL)

C       G(T17,N4703,FULL)

C       G(T17,N4704,FULL)

C       G(T17,N4705,FULL)

C       G(T17,N4706,FULL)

C       G(T17,N4707,FULL)

C       G(T17,N4708,FULL)

C       G(T17,N4709,FULL)

C       G(T17,N4710,FULL)

C       G(T17,N4711,FULL)

C       G(T17,N4712,FULL)

C       G(T17,N4713,FULL)
        CALL xB012345_(S34,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((QF(1)*QF(3)*ALPHA*B0*CBA*XMW)/(8D0*PI*S12*S34*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE
        F(1,-1,1) = F(1,-1,1)+PRE
        F(1,1,-1) = F(1,1,-1)+PRE
        F(1,1,1) = F(1,1,1)+PRE

C       G(T17,N4714,FULL)
        CALL xB012345_(S34,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((QF(1)*QF(3)*ALPHA*B0*CBA*XMW)/(8D0*PI*S12*S34*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE
        F(1,-1,1) = F(1,-1,1)+PRE
        F(1,1,-1) = F(1,1,-1)+PRE
        F(1,1,1) = F(1,1,1)+PRE

C       G(T17,N4715,FULL)
        CALL xB012345_(S34,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((QF(1)*ALPHA*B0*CBA*PZ34*XMZ)/(16D0*PI*S12*XCW))

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE*XSW
        F(1,1,-1) = F(1,1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW
        F(1,1,1) = F(1,1,1)+2D0*QF(3)*PRE*XSW

C       G(T17,N4716,FULL)
        CALL xB012345_(S34,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((QF(1)*ALPHA*B0*CBA*PZ34*XMZ)/(16D0*PI*S12*XCW))

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE*XSW
        F(1,1,-1) = F(1,1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW
        F(1,1,1) = F(1,1,1)+2D0*QF(3)*PRE*XSW

C       G(T17,N4717,FULL)

C       G(T17,N4718,FULL)

C       G(T17,N4719,FULL)

C       G(T17,N4720,FULL)

C       G(T17,N4721,FULL)

C       G(T17,N4722,FULL)

C       G(T17,N4723,FULL)

C       G(T17,N4724,FULL)

C       G(T17,N4725,FULL)

C       G(T17,N4726,FULL)

C       G(T17,N4727,FULL)

C       G(T17,N4728,FULL)

C       G(T17,N4729,FULL)

C       G(T17,N4730,FULL)

C       G(T17,N4731,FULL)
        CALL xB012345_(S34,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((QF(3)*ALPHA*B0*CBA*PZ12*XMW)/(16D0*PI*S34*XCW2))

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE*XSW
        F(1,1,1) = F(1,1,1)+2D0*QF(1)*PRE*XSW

C       G(T17,N4732,FULL)
        CALL xB012345_(S34,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((QF(3)*ALPHA*B0*CBA*PZ12*XMW)/(16D0*PI*S34*XCW2))

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE*XSW
        F(1,1,1) = F(1,1,1)+2D0*QF(1)*PRE*XSW

C       G(T17,N4733,FULL)
        CALL xB012345_(S34,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*CBA*PZ12*PZ34*XMZ)/(32D0*PI*XCW*XCW2))

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)-2D0*QF(3)*PRE*XSW*(1D0-2D0*QF(1)*XSW2)
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE*XSW*(1D0+2D0*QF(3)*XSW2)
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*XSW*XSW2

C       G(T17,N4734,FULL)
        CALL xB012345_(S34,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*CBA*PZ12*PZ34*XMZ)/(32D0*PI*XCW*XCW2))

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)-2D0*QF(3)*PRE*XSW*(1D0-2D0*QF(1)*XSW2)
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE*XSW*(1D0+2D0*QF(3)*XSW2)
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*XSW*XSW2

C       G(T17,N4735,FULL)
        CALL xB012345_(S34,XMZ2,XMHH2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*CBA*PZ12*PZ34*XCW2**(-2)*XMZ)/(32D0*PI*
     &  XCW*XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T18,N4736,FULL)

C       G(T18,N4737,FULL)

C       G(T18,N4738,FULL)

C       G(T18,N4739,FULL)

C       G(T18,N4740,FULL)

C       G(T18,N4741,FULL)

C       G(T18,N4742,FULL)

C       G(T18,N4743,FULL)

C       G(T18,N4744,FULL)

C       G(T18,N4745,FULL)

C       G(T18,N4746,FULL)

C       G(T18,N4747,FULL)

C       G(T18,N4748,FULL)

C       G(T18,N4749,FULL)

C       G(T18,N4750,FULL)

C       G(T18,N4751,FULL)

C       G(T18,N4752,FULL)

C       G(T18,N4753,FULL)

C       G(T18,N4754,FULL)

C       G(T18,N4755,FULL)

C       G(T18,N4756,FULL)

C       G(T18,N4757,FULL)

C       G(T18,N4758,FULL)

C       G(T18,N4759,FULL)

C       G(T18,N4760,FULL)

C       G(T18,N4761,FULL)

C       G(T18,N4762,FULL)

C       G(T18,N4763,FULL)

C       G(T18,N4764,FULL)

C       G(T18,N4765,FULL)

C       G(T18,N4766,FULL)

C       G(T18,N4767,FULL)

C       G(T18,N4768,FULL)

C       G(T18,N4769,FULL)

C       G(T18,N4770,FULL)

C       G(T18,N4771,FULL)

C       G(T18,N4772,FULL)

C       G(T18,N4773,FULL)

C       G(T18,N4774,FULL)

C       G(T18,N4775,FULL)

C       G(T18,N4776,FULL)

C       G(T18,N4777,FULL)

C       G(T18,N4778,FULL)

C       G(T18,N4779,FULL)

C       G(T18,N4780,FULL)

C       G(T18,N4781,FULL)

C       G(T18,N4782,FULL)

C       G(T18,N4783,FULL)

C       G(T18,N4784,FULL)

C       G(T18,N4785,FULL)

C       G(T18,N4786,FULL)

C       G(T18,N4787,FULL)

C       G(T18,N4788,FULL)

C       G(T18,N4789,FULL)

C       G(T18,N4790,FULL)

C       G(T18,N4791,FULL)

C       G(T18,N4792,FULL)

C       G(T18,N4793,FULL)

C       G(T18,N4794,FULL)

C       G(T18,N4795,FULL)

C       G(T18,N4796,FULL)

C       G(T18,N4797,FULL)

C       G(T18,N4798,FULL)

C       G(T18,N4799,FULL)

C       G(T18,N4800,FULL)

C       G(T18,N4801,FULL)

C       G(T18,N4802,FULL)

C       G(T18,N4803,FULL)

C       G(T18,N4804,FULL)

C       G(T18,N4805,FULL)

C       G(T18,N4806,FULL)

C       G(T18,N4807,FULL)

C       G(T18,N4808,FULL)

C       G(T18,N4809,FULL)

C       G(T18,N4810,FULL)

C       G(T18,N4811,FULL)

C       G(T18,N4812,FULL)

C       G(T18,N4813,FULL)

C       G(T18,N4814,FULL)

C       G(T18,N4815,FULL)

C       G(T18,N4816,FULL)

C       G(T18,N4817,FULL)

C       G(T18,N4818,FULL)

C       G(T18,N4819,FULL)

C       G(T18,N4820,FULL)

C       G(T18,N4821,FULL)

C       G(T18,N4822,FULL)

C       G(T18,N4823,FULL)

C       G(T18,N4824,FULL)

C       G(T18,N4825,FULL)

C       G(T18,N4826,FULL)

C       G(T18,N4827,FULL)

C       G(T18,N4828,FULL)

C       G(T18,N4829,FULL)

C       G(T18,N4830,FULL)

C       G(T18,N4831,FULL)

C       G(T18,N4832,FULL)

C       G(T18,N4833,FULL)

C       G(T18,N4834,FULL)

C       G(T18,N4835,FULL)

C       G(T18,N4836,FULL)

C       G(T18,N4837,FULL)

C       G(T18,N4838,FULL)

C       G(T18,N4839,FULL)

C       G(T18,N4840,FULL)

C       G(T18,N4841,FULL)

C       G(T18,N4842,FULL)

C       G(T18,N4843,FULL)
        CALL xB012345_(S12,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((QF(1)*QF(3)*ALPHA*B0*CBA*XMW)/(8D0*PI*S12*S34*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE
        F(1,-1,1) = F(1,-1,1)+PRE
        F(1,1,-1) = F(1,1,-1)+PRE
        F(1,1,1) = F(1,1,1)+PRE

C       G(T18,N4844,FULL)
        CALL xB012345_(S12,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((QF(1)*QF(3)*ALPHA*B0*CBA*XMW)/(8D0*PI*S12*S34*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE
        F(1,-1,1) = F(1,-1,1)+PRE
        F(1,1,-1) = F(1,1,-1)+PRE
        F(1,1,1) = F(1,1,1)+PRE

C       G(T18,N4845,FULL)
        CALL xB012345_(S12,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((QF(1)*ALPHA*B0*CBA*PZ34*XMW)/(16D0*PI*S12*XCW2))

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE*XSW
        F(1,1,-1) = F(1,1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW
        F(1,1,1) = F(1,1,1)+2D0*QF(3)*PRE*XSW

C       G(T18,N4846,FULL)
        CALL xB012345_(S12,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((QF(1)*ALPHA*B0*CBA*PZ34*XMW)/(16D0*PI*S12*XCW2))

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE*XSW
        F(1,1,-1) = F(1,1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW
        F(1,1,1) = F(1,1,1)+2D0*QF(3)*PRE*XSW

C       G(T18,N4847,FULL)

C       G(T18,N4848,FULL)

C       G(T18,N4849,FULL)

C       G(T18,N4850,FULL)

C       G(T18,N4851,FULL)

C       G(T18,N4852,FULL)

C       G(T18,N4853,FULL)

C       G(T18,N4854,FULL)

C       G(T18,N4855,FULL)

C       G(T18,N4856,FULL)

C       G(T18,N4857,FULL)

C       G(T18,N4858,FULL)

C       G(T18,N4859,FULL)

C       G(T18,N4860,FULL)
        CALL xB012345_(S12,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((QF(3)*ALPHA*B0*CBA*PZ12*XMZ)/(16D0*PI*S34*XCW))

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE*XSW
        F(1,1,1) = F(1,1,1)+2D0*QF(1)*PRE*XSW

C       G(T18,N4861,FULL)
        CALL xB012345_(S12,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((QF(3)*ALPHA*B0*CBA*PZ12*XMZ)/(16D0*PI*S34*XCW))

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE*XSW
        F(1,1,1) = F(1,1,1)+2D0*QF(1)*PRE*XSW

C       G(T18,N4862,FULL)
        CALL xB012345_(S12,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*CBA*PZ12*PZ34*XMZ)/(32D0*PI*XCW*XCW2))

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)-2D0*QF(3)*PRE*XSW*(1D0-2D0*QF(1)*XSW2)
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE*XSW*(1D0+2D0*QF(3)*XSW2)
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*XSW*XSW2

C       G(T18,N4863,FULL)
        CALL xB012345_(S12,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*CBA*PZ12*PZ34*XMZ)/(32D0*PI*XCW*XCW2))

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)-2D0*QF(3)*PRE*XSW*(1D0-2D0*QF(1)*XSW2)
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE*XSW*(1D0+2D0*QF(3)*XSW2)
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*XSW*XSW2

C       G(T18,N4864,FULL)
        CALL xB012345_(S12,XMZ2,XMHH2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*CBA*PZ12*PZ34*XCW2**(-2)*XMZ)/(32D0*PI*
     &  XCW*XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

	end

**********************************************************************
        subroutine  HHtoZZ1133_box_thdm(F,pz12,pz34)
**********************************************************************
*       box corrections for HH -> ZZ -> uudd in the THDM
*---------------------------------------------------------------------
*       24.4.16 Stefan Dittmaier
**********************************************************************
	implicit none
	complex*16 pre,F(13,-1:1,-1:1),pz12,pz34
	complex*16 A0,xA0_,B0_,xB0_,DB0_,xDB0_,B1_,xB1_,DB1_,xDB1_
        complex*16 B0,B1(1),B2(0:2,0:2),B3(0:2,0:2,2)
        complex*16 B4(0:2,0:2,0:2,0:2),B5(0:2,0:2,0:2,0:2,2)
        complex*16 C0_,C0,C1(2),C2(0:2,0:2),C3(0:2,0:2,2)
        complex*16 C4(0:2,0:2,0:2,0:2)
	complex*16 D0,D1(3),D2(0:3,0:3),D3(0:3,0:3,3)
        complex*16 D4(0:3,0:3,0:3,0:3),D5(0:3,0:3,0:3,0:3,3)
	complex*16 E0n,E1n(4),E2n(0:4,0:4),E3n(0:4,0:4,4)
	complex*16 E4n(0:4,0:4,0:4,0:4)
        COMPLEX*16 K(7)

c mandelstam variables
      	real*8 s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
      	common/mandel/s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
c fermion charges of isospin duplets
	real*8 qf(4)
	common/fcharge/qf
c fermion masses as flag (i*1d-20)
      	complex*16 cme2,cmf2(5)
      	real*8 me2,rme2,mf2(5),rmf2(5)
      	common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2
	include '../COMMON/param.inc'
	include '../COMMON/xparam.inc'
        include '../COMMON/param_thdm.inc'
        include '../COMMON/param_bsm.inc'

C       Process: S2F21aF21F23aF23,   Model: THDM

C       G(T3,N25,FULL)

C       G(T3,N42,FULL)
        CALL xD012345_(RMF2(1),MHH2,S34,RMF2(1),S12,T12,CMF2(2),XMW2,
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = -(4D0*D2(0,0))+D2(1,3)*S12-D2(2,3)*(S13+S14)-2D0*
     &  D1(2)*T12-D2(2,2)*T12+2D0*D1(1)*(MHH2-T12)+D2(1,2)*(MHH2-
     &  T12)

        PRE = (QF(3)*ALPHA*CBA*XMW)/(16D0*PI*S34*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+K(1)*PRE
        F(1,-1,1) = F(1,-1,1)+K(1)*PRE
        F(5,-1,-1) = F(5,-1,-1)-4D0*D1(3)*PRE
        F(5,-1,1) = F(5,-1,1)-4D0*D1(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)-4D0*D1(3)*PRE
        F(7,-1,1) = F(7,-1,1)-4D0*D1(3)*PRE

C       G(T3,N44,FULL)
        CALL xD012345_(RMF2(1),MHH2,S34,RMF2(1),S12,T12,CMF2(2),XMW2,
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = D1(3)-2D0*D2(2,2)-2D0*D2(2,3)
        K(2) = -(12D0*D2(0,0))+2D0*D2(1,3)*S12-2D0*D1(3)*(S13+S14)-
     &  2D0*D2(2,3)*(S13+S14)+D1(1)*(S12-S23-S24)-D1(2)*(3D0*S13+
     &  3D0*S14+S34)-2D0*D2(2,2)*T12+2D0*D2(1,2)*(MHH2-T12)

        PRE = -((QF(3)*ALPHA*CBA*XMW)/(8D0*PI*S34*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+K(2)*PRE
        F(1,-1,1) = F(1,-1,1)+K(2)*PRE
        F(5,-1,-1) = F(5,-1,-1)+2D0*K(1)*PRE
        F(5,-1,1) = F(5,-1,1)+2D0*K(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)+4D0*(D1(1)+D2(1,2))*PRE
        F(6,-1,1) = F(6,-1,1)+4D0*(D1(1)+D2(1,2))*PRE
        F(7,-1,-1) = F(7,-1,-1)+2D0*K(1)*PRE
        F(7,-1,1) = F(7,-1,1)+2D0*K(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)+4D0*(D1(1)+D2(1,2))*PRE
        F(8,-1,1) = F(8,-1,1)+4D0*(D1(1)+D2(1,2))*PRE

C       G(T3,N54,FULL)
        CALL xD012345_(RMF2(1),MHH2,S34,RMF2(1),S12,T12,CMF2(2),XMW2,
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = -(4D0*D2(0,0))+D2(1,3)*S12-D2(2,3)*(S13+S14)-2D0*
     &  D1(2)*T12-D2(2,2)*T12+2D0*D1(1)*(MHH2-T12)+D2(1,2)*(MHH2-
     &  T12)

        PRE = -((ALPHA*CBA*PZ34*XMZ)/(32D0*PI*XCW*XSW))

        F(1,-1,-1) = F(1,-1,-1)-(K(1)*PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)-2D0*K(1)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(4D0*D1(3)*PRE*(1D0+2D0*QF(3)*
     &  XSW2))/XSW2
        F(5,-1,1) = F(5,-1,1)+8D0*D1(3)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+(4D0*D1(3)*PRE*(1D0+2D0*QF(3)*
     &  XSW2))/XSW2
        F(7,-1,1) = F(7,-1,1)+8D0*D1(3)*QF(3)*PRE

C       G(T3,N56,FULL)
        CALL xD012345_(RMF2(1),MHH2,S34,RMF2(1),S12,T12,CMF2(2),XMW2,
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = D1(3)-2D0*D2(2,2)-2D0*D2(2,3)
        K(2) = -(12D0*D2(0,0))+2D0*D2(1,3)*S12-2D0*D1(3)*(S13+S14)-
     &  2D0*D2(2,3)*(S13+S14)+D1(1)*(S12-S23-S24)-D1(2)*(3D0*S13+
     &  3D0*S14+S34)-2D0*D2(2,2)*T12+2D0*D2(1,2)*(MHH2-T12)

        PRE = (ALPHA*CBA*PZ34*XMW)/(16D0*PI*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+(K(2)*PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*K(2)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(5,-1,1) = F(5,-1,1)+4D0*K(1)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)+(4D0*(D1(1)+D2(1,2))*PRE*(1D0+2D0*
     &  QF(3)*XSW2))/XSW2
        F(6,-1,1) = F(6,-1,1)+8D0*(D1(1)+D2(1,2))*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(7,-1,1) = F(7,-1,1)+4D0*K(1)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)+(4D0*(D1(1)+D2(1,2))*PRE*(1D0+2D0*
     &  QF(3)*XSW2))/XSW2
        F(8,-1,1) = F(8,-1,1)+8D0*(D1(1)+D2(1,2))*QF(3)*PRE

C       G(T6,N114,FULL)

C       G(T6,N115,FULL)

C       G(T6,N118,FULL)

C       G(T6,N119,FULL)

C       G(T6,N120,FULL)

C       G(T6,N127,FULL)

C       G(T6,N128,FULL)

C       G(T6,N131,FULL)
        CALL xD012345_(S34,RMF2(1),MHH2,RMF2(1),T12,T11,CMF2(2),
     &  CMF2(2),XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = D1(3)+D2(1,3)+D2(2,3)
        K(2) = D1(1)+D1(2)+D2(1,1)+(2D0*D2(0,0))/S34-(D1(3)*(S13+
     &  S14))/S34-(D2(1,3)*(S13+S14))/S34+(D2(1,2)*(S23+S24+2D0*
     &  S34))/S34+(D2(2,2)*T11)/S34-(D2(2,3)*(MHH2-T11))/S34

        PRE = (QF(2)*QF(3)*ALPHA*CBA*XMW)/(4D0*PI*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+K(2)*PRE
        F(1,-1,1) = F(1,-1,1)+K(2)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(1)*PRE)/S34
        F(5,-1,1) = F(5,-1,1)+(2D0*K(1)*PRE)/S34
        F(6,-1,-1) = F(6,-1,-1)-(2D0*(D2(1,2)+D2(2,2))*PRE)/S34
        F(6,-1,1) = F(6,-1,1)-(2D0*(D2(1,2)+D2(2,2))*PRE)/S34
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(1)*PRE)/S34
        F(7,-1,1) = F(7,-1,1)+(2D0*K(1)*PRE)/S34
        F(8,-1,-1) = F(8,-1,-1)-(2D0*(D2(1,2)+D2(2,2))*PRE)/S34
        F(8,-1,1) = F(8,-1,1)-(2D0*(D2(1,2)+D2(2,2))*PRE)/S34

C       G(T6,N132,FULL)

C       G(T6,N133,FULL)
        CALL xD012345_(S34,RMF2(1),MHH2,RMF2(1),T12,T11,CMF2(1),
     &  CMF2(1),XMZ2,XMZ2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = S13+S14
        K(3) = D2(1,2)+D2(2,2)
        K(4) = S23+S24+2D0*S34
        K(5) = D1(3)+D2(1,3)+D2(2,3)
        K(6) = D1(1)+D1(2)+D2(1,1)+(2D0*D2(0,0))/S34-(D1(3)*(S13+
     &  S14))/S34-(D2(1,3)*(S13+S14))/S34+(D2(1,2)*(S23+S24+2D0*
     &  S34))/S34+(D2(2,2)*T11)/S34-(D2(2,3)*(MHH2-T11))/S34

        PRE = (QF(1)*QF(3)*ALPHA*CBA*XMZ)/(8D0*PI*XCW*XCW2)

        F(1,-1,-1) = F(1,-1,-1)+(K(1)**2*K(6)*PRE)/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)+(K(1)**2*K(6)*PRE)/(XSW*XSW2)
        F(1,1,-1) = F(1,1,-1)+4D0*K(6)*QF(1)**2*PRE*XSW
        F(1,1,1) = F(1,1,1)+4D0*K(6)*QF(1)**2*PRE*XSW
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(1)**2*K(5)*PRE)/(S34*XSW*
     &  XSW2)
        F(5,-1,1) = F(5,-1,1)+(2D0*K(1)**2*K(5)*PRE)/(S34*XSW*XSW2)
        F(5,1,-1) = F(5,1,-1)+(8D0*K(5)*QF(1)**2*PRE*XSW)/S34
        F(5,1,1) = F(5,1,1)+(8D0*K(5)*QF(1)**2*PRE*XSW)/S34
        F(6,-1,-1) = F(6,-1,-1)-(2D0*K(1)**2*K(3)*PRE)/(S34*XSW*
     &  XSW2)
        F(6,-1,1) = F(6,-1,1)-(2D0*K(1)**2*K(3)*PRE)/(S34*XSW*XSW2)
        F(6,1,-1) = F(6,1,-1)-(8D0*K(3)*QF(1)**2*PRE*XSW)/S34
        F(6,1,1) = F(6,1,1)-(8D0*K(3)*QF(1)**2*PRE*XSW)/S34
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(1)**2*K(5)*PRE)/(S34*XSW*
     &  XSW2)
        F(7,-1,1) = F(7,-1,1)+(2D0*K(1)**2*K(5)*PRE)/(S34*XSW*XSW2)
        F(7,1,-1) = F(7,1,-1)+(8D0*K(5)*QF(1)**2*PRE*XSW)/S34
        F(7,1,1) = F(7,1,1)+(8D0*K(5)*QF(1)**2*PRE*XSW)/S34
        F(8,-1,-1) = F(8,-1,-1)-(2D0*K(1)**2*K(3)*PRE)/(S34*XSW*
     &  XSW2)
        F(8,-1,1) = F(8,-1,1)-(2D0*K(1)**2*K(3)*PRE)/(S34*XSW*XSW2)
        F(8,1,-1) = F(8,1,-1)-(8D0*K(3)*QF(1)**2*PRE*XSW)/S34
        F(8,1,1) = F(8,1,1)-(8D0*K(3)*QF(1)**2*PRE*XSW)/S34

C       G(T6,N140,FULL)

C       G(T6,N141,FULL)

C       G(T6,N144,FULL)
        CALL xD012345_(S34,RMF2(1),MHH2,RMF2(1),T12,T11,CMF2(2),
     &  CMF2(2),XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = D1(3)+D2(1,3)+D2(2,3)
        K(2) = 2D0*D2(0,0)-D1(3)*(S13+S14)-D2(1,3)*(S13+S14)+D1(1)*
     &  S34+D1(2)*S34+D2(1,1)*S34+D2(1,2)*(S23+S24+2D0*S34)+D2(2,2)*
     &  T11-D2(2,3)*(MHH2-T11)

        PRE = (ALPHA*CBA*PZ34*XMW*(1D0+2D0*QF(2)*XSW2))/(16D0*PI*
     &  XCW2*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+(K(2)*PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*K(2)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(5,-1,1) = F(5,-1,1)+4D0*K(1)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)-(2D0*(D2(1,2)+D2(2,2))*PRE*(1D0+2D0*
     &  QF(3)*XSW2))/XSW2
        F(6,-1,1) = F(6,-1,1)-4D0*(D2(1,2)+D2(2,2))*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(7,-1,1) = F(7,-1,1)+4D0*K(1)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)-(2D0*(D2(1,2)+D2(2,2))*PRE*(1D0+2D0*
     &  QF(3)*XSW2))/XSW2
        F(8,-1,1) = F(8,-1,1)-4D0*(D2(1,2)+D2(2,2))*QF(3)*PRE

C       G(T6,N145,FULL)

C       G(T6,N146,FULL)
        CALL xD012345_(S34,RMF2(1),MHH2,RMF2(1),T12,T11,CMF2(1),
     &  CMF2(1),XMZ2,XMZ2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = S13+S14
        K(4) = D2(1,2)+D2(2,2)
        K(5) = S23+S24+2D0*S34
        K(6) = D1(3)+D2(1,3)+D2(2,3)
        K(7) = 2D0*D2(0,0)-D1(3)*(S13+S14)-D2(1,3)*(S13+S14)+D1(1)*
     &  S34+D1(2)*S34+D2(1,1)*S34+D2(1,2)*(S23+S24+2D0*S34)+D2(2,2)*
     &  T11-D2(2,3)*(MHH2-T11)

        PRE = (ALPHA*CBA*PZ34*XCW2**(-2)*XMZ)/(32D0*PI*XCW)

        F(1,-1,-1) = F(1,-1,-1)-(K(1)**3*K(2)*K(7)*PRE*XSW2**(-2))/
     &  XSW
        F(1,-1,1) = F(1,-1,1)-(2D0*K(1)**3*K(7)*QF(3)*PRE)/(XSW*
     &  XSW2)
        F(1,1,-1) = F(1,1,-1)+8D0*K(2)*K(7)*QF(1)**3*PRE*XSW
        F(1,1,1) = F(1,1,1)+16D0*K(7)*QF(1)**3*QF(3)*PRE*XSW*XSW2
        F(5,-1,-1) = F(5,-1,-1)-(2D0*K(1)**3*K(2)*K(6)*PRE*XSW2**(-
     &  2))/XSW
        F(5,-1,1) = F(5,-1,1)-(4D0*K(1)**3*K(6)*QF(3)*PRE)/(XSW*
     &  XSW2)
        F(5,1,-1) = F(5,1,-1)+16D0*K(2)*K(6)*QF(1)**3*PRE*XSW
        F(5,1,1) = F(5,1,1)+32D0*K(6)*QF(1)**3*QF(3)*PRE*XSW*XSW2
        F(6,-1,-1) = F(6,-1,-1)+(2D0*K(1)**3*K(2)*K(4)*PRE*XSW2**(-
     &  2))/XSW
        F(6,-1,1) = F(6,-1,1)+(4D0*K(1)**3*K(4)*QF(3)*PRE)/(XSW*
     &  XSW2)
        F(6,1,-1) = F(6,1,-1)-16D0*K(2)*K(4)*QF(1)**3*PRE*XSW
        F(6,1,1) = F(6,1,1)-32D0*K(4)*QF(1)**3*QF(3)*PRE*XSW*XSW2
        F(7,-1,-1) = F(7,-1,-1)-(2D0*K(1)**3*K(2)*K(6)*PRE*XSW2**(-
     &  2))/XSW
        F(7,-1,1) = F(7,-1,1)-(4D0*K(1)**3*K(6)*QF(3)*PRE)/(XSW*
     &  XSW2)
        F(7,1,-1) = F(7,1,-1)+16D0*K(2)*K(6)*QF(1)**3*PRE*XSW
        F(7,1,1) = F(7,1,1)+32D0*K(6)*QF(1)**3*QF(3)*PRE*XSW*XSW2
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(1)**3*K(2)*K(4)*PRE*XSW2**(-
     &  2))/XSW
        F(8,-1,1) = F(8,-1,1)+(4D0*K(1)**3*K(4)*QF(3)*PRE)/(XSW*
     &  XSW2)
        F(8,1,-1) = F(8,1,-1)-16D0*K(2)*K(4)*QF(1)**3*PRE*XSW
        F(8,1,1) = F(8,1,1)-32D0*K(4)*QF(1)**3*QF(3)*PRE*XSW*XSW2

C       G(T7,N147,FULL)

C       G(T7,N148,FULL)

C       G(T7,N155,FULL)

C       G(T7,N156,FULL)

C       G(T7,N159,FULL)

C       G(T7,N160,FULL)

C       G(T7,N161,FULL)

C       G(T7,N168,FULL)

C       G(T7,N169,FULL)
        CALL xD012345_(S12,RMF2(3),MHH2,RMF2(3),T13,T14,CMF2(3),
     &  CMF2(3),XMZ2,XMZ2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = 1D0+2D0*QF(3)*XSW2
        K(2) = S14+S24
        K(3) = D2(1,2)+D2(2,2)
        K(4) = 2D0*S12+S13+S23
        K(5) = D1(3)+D2(1,3)+D2(2,3)
        K(6) = D1(1)+D1(2)+D2(1,1)+(2D0*D2(0,0))/S12+(D2(1,2)*(2D0*
     &  S12+S13+S23))/S12-(D1(3)*(S14+S24))/S12-(D2(1,3)*(S14+S24))/
     &  S12+(D2(2,2)*T14)/S12-(D2(2,3)*(MHH2-T14))/S12

        PRE = (QF(1)*QF(3)*ALPHA*CBA*XMZ)/(8D0*PI*XCW*XCW2)

        F(1,-1,-1) = F(1,-1,-1)+(K(1)**2*K(6)*PRE)/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)+4D0*K(6)*QF(3)**2*PRE*XSW
        F(1,1,-1) = F(1,1,-1)+(K(1)**2*K(6)*PRE)/(XSW*XSW2)
        F(1,1,1) = F(1,1,1)+4D0*K(6)*QF(3)**2*PRE*XSW
        F(5,-1,-1) = F(5,-1,-1)-(2D0*K(1)**2*K(3)*PRE)/(S12*XSW*
     &  XSW2)
        F(5,-1,1) = F(5,-1,1)-(8D0*K(3)*QF(3)**2*PRE*XSW)/S12
        F(5,1,-1) = F(5,1,-1)-(2D0*K(1)**2*K(3)*PRE)/(S12*XSW*XSW2)
        F(5,1,1) = F(5,1,1)-(8D0*K(3)*QF(3)**2*PRE*XSW)/S12
        F(6,-1,-1) = F(6,-1,-1)-(2D0*K(1)**2*K(3)*PRE)/(S12*XSW*
     &  XSW2)
        F(6,-1,1) = F(6,-1,1)-(8D0*K(3)*QF(3)**2*PRE*XSW)/S12
        F(6,1,-1) = F(6,1,-1)-(2D0*K(1)**2*K(3)*PRE)/(S12*XSW*XSW2)
        F(6,1,1) = F(6,1,1)-(8D0*K(3)*QF(3)**2*PRE*XSW)/S12
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(1)**2*K(5)*PRE)/(S12*XSW*
     &  XSW2)
        F(7,-1,1) = F(7,-1,1)+(8D0*K(5)*QF(3)**2*PRE*XSW)/S12
        F(7,1,-1) = F(7,1,-1)+(2D0*K(1)**2*K(5)*PRE)/(S12*XSW*XSW2)
        F(7,1,1) = F(7,1,1)+(8D0*K(5)*QF(3)**2*PRE*XSW)/S12
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(1)**2*K(5)*PRE)/(S12*XSW*
     &  XSW2)
        F(8,-1,1) = F(8,-1,1)+(8D0*K(5)*QF(3)**2*PRE*XSW)/S12
        F(8,1,-1) = F(8,1,-1)+(2D0*K(1)**2*K(5)*PRE)/(S12*XSW*XSW2)
        F(8,1,1) = F(8,1,1)+(8D0*K(5)*QF(3)**2*PRE*XSW)/S12

C       G(T7,N172,FULL)
        CALL xD012345_(S12,RMF2(3),MHH2,RMF2(3),T13,T14,CMF2(4),
     &  CMF2(4),XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = D1(3)+D2(1,3)+D2(2,3)
        K(2) = D1(1)+D1(2)+D2(1,1)+(2D0*D2(0,0))/S12+(D2(1,2)*(2D0*
     &  S12+S13+S23))/S12-(D1(3)*(S14+S24))/S12-(D2(1,3)*(S14+S24))/
     &  S12+(D2(2,2)*T14)/S12-(D2(2,3)*(MHH2-T14))/S12

        PRE = (QF(1)*QF(4)*ALPHA*CBA*XMW)/(4D0*PI*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+K(2)*PRE
        F(1,1,-1) = F(1,1,-1)+K(2)*PRE
        F(5,-1,-1) = F(5,-1,-1)-(2D0*(D2(1,2)+D2(2,2))*PRE)/S12
        F(5,1,-1) = F(5,1,-1)-(2D0*(D2(1,2)+D2(2,2))*PRE)/S12
        F(6,-1,-1) = F(6,-1,-1)-(2D0*(D2(1,2)+D2(2,2))*PRE)/S12
        F(6,1,-1) = F(6,1,-1)-(2D0*(D2(1,2)+D2(2,2))*PRE)/S12
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(1)*PRE)/S12
        F(7,1,-1) = F(7,1,-1)+(2D0*K(1)*PRE)/S12
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(1)*PRE)/S12
        F(8,1,-1) = F(8,1,-1)+(2D0*K(1)*PRE)/S12

C       G(T7,N173,FULL)

C       G(T7,N174,FULL)

C       G(T7,N181,FULL)

C       G(T7,N182,FULL)
        CALL xD012345_(S12,RMF2(3),MHH2,RMF2(3),T13,T14,CMF2(3),
     &  CMF2(3),XMZ2,XMZ2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = S14+S24
        K(4) = D2(1,2)+D2(2,2)
        K(5) = 2D0*S12+S13+S23
        K(6) = D1(3)+D2(1,3)+D2(2,3)
        K(7) = 2D0*D2(0,0)+D1(1)*S12+D1(2)*S12+D2(1,1)*S12+D2(1,2)*
     &  (2D0*S12+S13+S23)-D1(3)*(S14+S24)-D2(1,3)*(S14+S24)+D2(2,2)*
     &  T14-D2(2,3)*(MHH2-T14)

        PRE = (ALPHA*CBA*PZ12*XCW2**(-2)*XMZ)/(32D0*PI*XCW)

        F(1,-1,-1) = F(1,-1,-1)-(K(1)*K(2)**3*K(7)*PRE*XSW2**(-2))/
     &  XSW
        F(1,-1,1) = F(1,-1,1)-8D0*K(1)*K(7)*QF(3)**3*PRE*XSW
        F(1,1,-1) = F(1,1,-1)+(2D0*K(2)**3*K(7)*QF(1)*PRE)/(XSW*
     &  XSW2)
        F(1,1,1) = F(1,1,1)+16D0*K(7)*QF(1)*QF(3)**3*PRE*XSW*XSW2
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(1)*K(2)**3*K(4)*PRE*XSW2**(-
     &  2))/XSW
        F(5,-1,1) = F(5,-1,1)+16D0*K(1)*K(4)*QF(3)**3*PRE*XSW
        F(5,1,-1) = F(5,1,-1)-(4D0*K(2)**3*K(4)*QF(1)*PRE)/(XSW*
     &  XSW2)
        F(5,1,1) = F(5,1,1)-32D0*K(4)*QF(1)*QF(3)**3*PRE*XSW*XSW2
        F(6,-1,-1) = F(6,-1,-1)+(2D0*K(1)*K(2)**3*K(4)*PRE*XSW2**(-
     &  2))/XSW
        F(6,-1,1) = F(6,-1,1)+16D0*K(1)*K(4)*QF(3)**3*PRE*XSW
        F(6,1,-1) = F(6,1,-1)-(4D0*K(2)**3*K(4)*QF(1)*PRE)/(XSW*
     &  XSW2)
        F(6,1,1) = F(6,1,1)-32D0*K(4)*QF(1)*QF(3)**3*PRE*XSW*XSW2
        F(7,-1,-1) = F(7,-1,-1)-(2D0*K(1)*K(2)**3*K(6)*PRE*XSW2**(-
     &  2))/XSW
        F(7,-1,1) = F(7,-1,1)-16D0*K(1)*K(6)*QF(3)**3*PRE*XSW
        F(7,1,-1) = F(7,1,-1)+(4D0*K(2)**3*K(6)*QF(1)*PRE)/(XSW*
     &  XSW2)
        F(7,1,1) = F(7,1,1)+32D0*K(6)*QF(1)*QF(3)**3*PRE*XSW*XSW2
        F(8,-1,-1) = F(8,-1,-1)-(2D0*K(1)*K(2)**3*K(6)*PRE*XSW2**(-
     &  2))/XSW
        F(8,-1,1) = F(8,-1,1)-16D0*K(1)*K(6)*QF(3)**3*PRE*XSW
        F(8,1,-1) = F(8,1,-1)+(4D0*K(2)**3*K(6)*QF(1)*PRE)/(XSW*
     &  XSW2)
        F(8,1,1) = F(8,1,1)+32D0*K(6)*QF(1)*QF(3)**3*PRE*XSW*XSW2

C       G(T7,N185,FULL)
        CALL xD012345_(S12,RMF2(3),MHH2,RMF2(3),T13,T14,CMF2(4),
     &  CMF2(4),XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = D1(3)+D2(1,3)+D2(2,3)
        K(2) = 2D0*D2(0,0)+D1(1)*S12+D1(2)*S12+D2(1,1)*S12+D2(1,2)*
     &  (2D0*S12+S13+S23)-D1(3)*(S14+S24)-D2(1,3)*(S14+S24)+D2(2,2)*
     &  T14-D2(2,3)*(MHH2-T14)

        PRE = -((ALPHA*CBA*PZ12*XMW*(1D0-2D0*QF(4)*XSW2))/(16D0*PI*
     &  XCW2*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)-(K(2)*PRE*(1D0-2D0*QF(1)*XSW2))/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*K(2)*QF(1)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(2D0*(D2(1,2)+D2(2,2))*PRE*(1D0-2D0*
     &  QF(1)*XSW2))/XSW2
        F(5,1,-1) = F(5,1,-1)-4D0*(D2(1,2)+D2(2,2))*QF(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)+(2D0*(D2(1,2)+D2(2,2))*PRE*(1D0-2D0*
     &  QF(1)*XSW2))/XSW2
        F(6,1,-1) = F(6,1,-1)-4D0*(D2(1,2)+D2(2,2))*QF(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)-(2D0*K(1)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(7,1,-1) = F(7,1,-1)+4D0*K(1)*QF(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)-(2D0*K(1)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(8,1,-1) = F(8,1,-1)+4D0*K(1)*QF(1)*PRE

C       G(T8,N190,FULL)

C       G(T8,N207,FULL)
        CALL xD012345_(RMF2(1),MHH2,S34,RMF2(1),S12,T11,CMF2(2),XMW2,
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = -(4D0*D2(0,0))+D2(1,3)*S12-D2(2,3)*(S23+S24)-2D0*
     &  D1(2)*T11-D2(2,2)*T11+2D0*D1(1)*(MHH2-T11)+D2(1,2)*(MHH2-
     &  T11)

        PRE = (QF(3)*ALPHA*CBA*XMW)/(16D0*PI*S34*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+K(1)*PRE
        F(1,-1,1) = F(1,-1,1)+K(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)-4D0*D1(3)*PRE
        F(6,-1,1) = F(6,-1,1)-4D0*D1(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)-4D0*D1(3)*PRE
        F(8,-1,1) = F(8,-1,1)-4D0*D1(3)*PRE

C       G(T8,N209,FULL)
        CALL xD012345_(RMF2(1),MHH2,S34,RMF2(1),S12,T11,CMF2(2),XMW2,
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = D1(3)-2D0*D2(2,2)-2D0*D2(2,3)
        K(2) = -(12D0*D2(0,0))+2D0*D2(1,3)*S12+D1(1)*(S12-S13-S14)-
     &  2D0*D1(3)*(S23+S24)-2D0*D2(2,3)*(S23+S24)-D1(2)*(3D0*S23+
     &  3D0*S24+S34)-2D0*D2(2,2)*T11+2D0*D2(1,2)*(MHH2-T11)

        PRE = -((QF(3)*ALPHA*CBA*XMW)/(8D0*PI*S34*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+K(2)*PRE
        F(1,-1,1) = F(1,-1,1)+K(2)*PRE
        F(5,-1,-1) = F(5,-1,-1)+4D0*(D1(1)+D2(1,2))*PRE
        F(5,-1,1) = F(5,-1,1)+4D0*(D1(1)+D2(1,2))*PRE
        F(6,-1,-1) = F(6,-1,-1)+2D0*K(1)*PRE
        F(6,-1,1) = F(6,-1,1)+2D0*K(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)+4D0*(D1(1)+D2(1,2))*PRE
        F(7,-1,1) = F(7,-1,1)+4D0*(D1(1)+D2(1,2))*PRE
        F(8,-1,-1) = F(8,-1,-1)+2D0*K(1)*PRE
        F(8,-1,1) = F(8,-1,1)+2D0*K(1)*PRE

C       G(T8,N219,FULL)
        CALL xD012345_(RMF2(1),MHH2,S34,RMF2(1),S12,T11,CMF2(2),XMW2,
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = -(4D0*D2(0,0))+D2(1,3)*S12-D2(2,3)*(S23+S24)-2D0*
     &  D1(2)*T11-D2(2,2)*T11+2D0*D1(1)*(MHH2-T11)+D2(1,2)*(MHH2-
     &  T11)

        PRE = -((ALPHA*CBA*PZ34*XMZ)/(32D0*PI*XCW*XSW))

        F(1,-1,-1) = F(1,-1,-1)-(K(1)*PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)-2D0*K(1)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)+(4D0*D1(3)*PRE*(1D0+2D0*QF(3)*
     &  XSW2))/XSW2
        F(6,-1,1) = F(6,-1,1)+8D0*D1(3)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)+(4D0*D1(3)*PRE*(1D0+2D0*QF(3)*
     &  XSW2))/XSW2
        F(8,-1,1) = F(8,-1,1)+8D0*D1(3)*QF(3)*PRE

C       G(T8,N221,FULL)
        CALL xD012345_(RMF2(1),MHH2,S34,RMF2(1),S12,T11,CMF2(2),XMW2,
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = D1(3)-2D0*D2(2,2)-2D0*D2(2,3)
        K(2) = -(12D0*D2(0,0))+2D0*D2(1,3)*S12+D1(1)*(S12-S13-S14)-
     &  2D0*D1(3)*(S23+S24)-2D0*D2(2,3)*(S23+S24)-D1(2)*(3D0*S23+
     &  3D0*S24+S34)-2D0*D2(2,2)*T11+2D0*D2(1,2)*(MHH2-T11)

        PRE = (ALPHA*CBA*PZ34*XMW)/(16D0*PI*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+(K(2)*PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*K(2)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(4D0*(D1(1)+D2(1,2))*PRE*(1D0+2D0*
     &  QF(3)*XSW2))/XSW2
        F(5,-1,1) = F(5,-1,1)+8D0*(D1(1)+D2(1,2))*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)+(2D0*K(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(6,-1,1) = F(6,-1,1)+4D0*K(1)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+(4D0*(D1(1)+D2(1,2))*PRE*(1D0+2D0*
     &  QF(3)*XSW2))/XSW2
        F(7,-1,1) = F(7,-1,1)+8D0*(D1(1)+D2(1,2))*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(8,-1,1) = F(8,-1,1)+4D0*K(1)*QF(3)*PRE

C       G(T9,N224,FULL)

C       G(T9,N233,FULL)
        CALL xD012345_(RMF2(3),MHH2,S12,RMF2(3),S34,T13,CMF2(4),XMW2,
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = -(4D0*D2(0,0))-D2(2,3)*(S14+S24)+D2(1,3)*S34-2D0*
     &  D1(2)*T13-D2(2,2)*T13+2D0*D1(1)*(MHH2-T13)+D2(1,2)*(MHH2-
     &  T13)

        PRE = -((QF(1)*ALPHA*CBA*XMW)/(16D0*PI*S12*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+K(1)*PRE
        F(1,1,-1) = F(1,1,-1)+K(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)-4D0*D1(3)*PRE
        F(7,1,-1) = F(7,1,-1)-4D0*D1(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)-4D0*D1(3)*PRE
        F(8,1,-1) = F(8,1,-1)-4D0*D1(3)*PRE

C       G(T9,N242,FULL)
        CALL xD012345_(RMF2(3),MHH2,S12,RMF2(3),S34,T13,CMF2(4),XMW2,
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = D1(3)-2D0*D2(2,2)-2D0*D2(2,3)
        K(2) = 12D0*D2(0,0)+2D0*D1(3)*(S14+S24)+2D0*D2(2,3)*(S14+
     &  S24)+D1(2)*(S12+3D0*S14+3D0*S24)-2D0*D2(1,3)*S34+D1(1)*(S13+
     &  S23-S34)+2D0*D2(2,2)*T13-2D0*D2(1,2)*(MHH2-T13)

        PRE = -((QF(1)*ALPHA*CBA*XMW)/(8D0*PI*S12*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+K(2)*PRE
        F(1,1,-1) = F(1,1,-1)+K(2)*PRE
        F(5,-1,-1) = F(5,-1,-1)-4D0*(D1(1)+D2(1,2))*PRE
        F(5,1,-1) = F(5,1,-1)-4D0*(D1(1)+D2(1,2))*PRE
        F(6,-1,-1) = F(6,-1,-1)-4D0*(D1(1)+D2(1,2))*PRE
        F(6,1,-1) = F(6,1,-1)-4D0*(D1(1)+D2(1,2))*PRE
        F(7,-1,-1) = F(7,-1,-1)-2D0*K(1)*PRE
        F(7,1,-1) = F(7,1,-1)-2D0*K(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)-2D0*K(1)*PRE
        F(8,1,-1) = F(8,1,-1)-2D0*K(1)*PRE

C       G(T9,N248,FULL)
        CALL xD012345_(RMF2(3),MHH2,S12,RMF2(3),S34,T13,CMF2(4),XMW2,
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = -(4D0*D2(0,0))-D2(2,3)*(S14+S24)+D2(1,3)*S34-2D0*
     &  D1(2)*T13-D2(2,2)*T13+2D0*D1(1)*(MHH2-T13)+D2(1,2)*(MHH2-
     &  T13)

        PRE = (ALPHA*CBA*PZ12*XMZ)/(32D0*PI*XCW*XSW)

        F(1,-1,-1) = F(1,-1,-1)+(K(1)*PRE*(1D0-2D0*QF(1)*XSW2))/XSW2
        F(1,1,-1) = F(1,1,-1)-2D0*K(1)*QF(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)-(4D0*D1(3)*PRE*(1D0-2D0*QF(1)*
     &  XSW2))/XSW2
        F(7,1,-1) = F(7,1,-1)+8D0*D1(3)*QF(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)-(4D0*D1(3)*PRE*(1D0-2D0*QF(1)*
     &  XSW2))/XSW2
        F(8,1,-1) = F(8,1,-1)+8D0*D1(3)*QF(1)*PRE

C       G(T9,N257,FULL)
        CALL xD012345_(RMF2(3),MHH2,S12,RMF2(3),S34,T13,CMF2(4),XMW2,
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = D1(3)-2D0*D2(2,2)-2D0*D2(2,3)
        K(2) = 12D0*D2(0,0)+2D0*D1(3)*(S14+S24)+2D0*D2(2,3)*(S14+
     &  S24)+D1(2)*(S12+3D0*S14+3D0*S24)-2D0*D2(1,3)*S34+D1(1)*(S13+
     &  S23-S34)+2D0*D2(2,2)*T13-2D0*D2(1,2)*(MHH2-T13)

        PRE = (ALPHA*CBA*PZ12*XMW)/(16D0*PI*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)-(K(2)*PRE*(1D0-2D0*QF(1)*XSW2))/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*K(2)*QF(1)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(4D0*(D1(1)+D2(1,2))*PRE*(1D0-2D0*
     &  QF(1)*XSW2))/XSW2
        F(5,1,-1) = F(5,1,-1)-8D0*(D1(1)+D2(1,2))*QF(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)+(4D0*(D1(1)+D2(1,2))*PRE*(1D0-2D0*
     &  QF(1)*XSW2))/XSW2
        F(6,1,-1) = F(6,1,-1)-8D0*(D1(1)+D2(1,2))*QF(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(1)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(7,1,-1) = F(7,1,-1)-4D0*K(1)*QF(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(1)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(8,1,-1) = F(8,1,-1)-4D0*K(1)*QF(1)*PRE

C       G(T11,N299,FULL)

C       G(T11,N311,FULL)
        CALL xD012345_(RMF2(3),S12,MHH2,RMF2(3),S34,T14,CMF2(4),XMW2,
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = -(4D0*D2(0,0))-D2(1,2)*(S13+S23)+D2(1,3)*S34-2D0*
     &  D1(2)*T14-D2(2,2)*T14+2D0*D1(3)*(MHH2-T14)+D2(2,3)*(MHH2-
     &  T14)

        PRE = -((QF(1)*ALPHA*CBA*XMW)/(16D0*PI*S12*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+K(1)*PRE
        F(1,1,-1) = F(1,1,-1)+K(1)*PRE
        F(5,-1,-1) = F(5,-1,-1)-4D0*D1(1)*PRE
        F(5,1,-1) = F(5,1,-1)-4D0*D1(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)-4D0*D1(1)*PRE
        F(6,1,-1) = F(6,1,-1)-4D0*D1(1)*PRE

C       G(T11,N317,FULL)
        CALL xD012345_(RMF2(3),S12,MHH2,RMF2(3),S34,T14,CMF2(4),XMW2,
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = D1(1)-2D0*D2(1,2)-2D0*D2(2,2)
        K(2) = -(12D0*D2(0,0))-2D0*D1(1)*(S13+S23)-2D0*D2(1,2)*(S13+
     &  S23)-D1(2)*(S12+3D0*S13+3D0*S23)+2D0*D2(1,3)*S34-D1(3)*(S14+
     &  S24-S34)-2D0*D2(2,2)*T14+2D0*D2(2,3)*(MHH2-T14)

        PRE = (QF(1)*ALPHA*CBA*XMW)/(8D0*PI*S12*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+K(2)*PRE
        F(1,1,-1) = F(1,1,-1)+K(2)*PRE
        F(5,-1,-1) = F(5,-1,-1)+2D0*K(1)*PRE
        F(5,1,-1) = F(5,1,-1)+2D0*K(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)+2D0*K(1)*PRE
        F(6,1,-1) = F(6,1,-1)+2D0*K(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)+4D0*(D1(3)+D2(2,3))*PRE
        F(7,1,-1) = F(7,1,-1)+4D0*(D1(3)+D2(2,3))*PRE
        F(8,-1,-1) = F(8,-1,-1)+4D0*(D1(3)+D2(2,3))*PRE
        F(8,1,-1) = F(8,1,-1)+4D0*(D1(3)+D2(2,3))*PRE

C       G(T11,N326,FULL)
        CALL xD012345_(RMF2(3),S12,MHH2,RMF2(3),S34,T14,CMF2(4),XMW2,
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = -(4D0*D2(0,0))-D2(1,2)*(S13+S23)+D2(1,3)*S34-2D0*
     &  D1(2)*T14-D2(2,2)*T14+2D0*D1(3)*(MHH2-T14)+D2(2,3)*(MHH2-
     &  T14)

        PRE = (ALPHA*CBA*PZ12*XMZ)/(32D0*PI*XCW*XSW)

        F(1,-1,-1) = F(1,-1,-1)+(K(1)*PRE*(1D0-2D0*QF(1)*XSW2))/XSW2
        F(1,1,-1) = F(1,1,-1)-2D0*K(1)*QF(1)*PRE
        F(5,-1,-1) = F(5,-1,-1)-(4D0*D1(1)*PRE*(1D0-2D0*QF(1)*
     &  XSW2))/XSW2
        F(5,1,-1) = F(5,1,-1)+8D0*D1(1)*QF(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)-(4D0*D1(1)*PRE*(1D0-2D0*QF(1)*
     &  XSW2))/XSW2
        F(6,1,-1) = F(6,1,-1)+8D0*D1(1)*QF(1)*PRE

C       G(T11,N332,FULL)
        CALL xD012345_(RMF2(3),S12,MHH2,RMF2(3),S34,T14,CMF2(4),XMW2,
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = D1(1)-2D0*D2(1,2)-2D0*D2(2,2)
        K(2) = -(12D0*D2(0,0))-2D0*D1(1)*(S13+S23)-2D0*D2(1,2)*(S13+
     &  S23)-D1(2)*(S12+3D0*S13+3D0*S23)+2D0*D2(1,3)*S34-D1(3)*(S14+
     &  S24-S34)-2D0*D2(2,2)*T14+2D0*D2(2,3)*(MHH2-T14)

        PRE = -((ALPHA*CBA*PZ12*XMW)/(16D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)-(K(2)*PRE*(1D0-2D0*QF(1)*XSW2))/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*K(2)*QF(1)*PRE
        F(5,-1,-1) = F(5,-1,-1)-(2D0*K(1)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(5,1,-1) = F(5,1,-1)+4D0*K(1)*QF(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)-(2D0*K(1)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(6,1,-1) = F(6,1,-1)+4D0*K(1)*QF(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)-(4D0*(D1(3)+D2(2,3))*PRE*(1D0-2D0*
     &  QF(1)*XSW2))/XSW2
        F(7,1,-1) = F(7,1,-1)+8D0*(D1(3)+D2(2,3))*QF(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)-(4D0*(D1(3)+D2(2,3))*PRE*(1D0-2D0*
     &  QF(1)*XSW2))/XSW2
        F(8,1,-1) = F(8,1,-1)+8D0*(D1(3)+D2(2,3))*QF(1)*PRE

	end

**********************************************************************
        subroutine  HHtoZZ1133_pent_thdm(F,pz12,pz34)
**********************************************************************
*       pentagon corrections for HH -> ZZ -> uudd in the THDM
*---------------------------------------------------------------------
*       24.4.16 Stefan Dittmaier
**********************************************************************
	implicit none
	complex*16 pre,F(13,-1:1,-1:1),pz12,pz34
	complex*16 A0,xA0_,B0_,xB0_,DB0_,xDB0_,B1_,xB1_,DB1_,xDB1_
        complex*16 B0,B1(1),B2(0:2,0:2),B3(0:2,0:2,2)
        complex*16 B4(0:2,0:2,0:2,0:2),B5(0:2,0:2,0:2,0:2,2)
        complex*16 C0_,C0,C1(2),C2(0:2,0:2),C3(0:2,0:2,2)
        complex*16 C4(0:2,0:2,0:2,0:2)
	complex*16 D0,D1(3),D2(0:3,0:3),D3(0:3,0:3,3)
        complex*16 D4(0:3,0:3,0:3,0:3),D5(0:3,0:3,0:3,0:3,3)
	complex*16 E0n,E1n(4),E2n(0:4,0:4),E3n(0:4,0:4,4)
	complex*16 E4n(0:4,0:4,0:4,0:4)
        COMPLEX*16 K(10)

c mandelstam variables
      	real*8 s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
      	common/mandel/s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
c fermion charges of isospin duplets
	real*8 qf(4)
	common/fcharge/qf
c fermion masses as flag (i*1d-20)
      	complex*16 cme2,cmf2(5)
      	real*8 me2,rme2,mf2(5),rmf2(5)
      	common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2
	include '../COMMON/param.inc'
	include '../COMMON/xparam.inc'
        include '../COMMON/param_thdm.inc'
        include '../COMMON/param_bsm.inc'

C       Process: S2F21aF21F23aF23,   Model: THDM

C       G(T4,N57,FULL)

C       G(T4,N58,FULL)

C       G(T4,N59,FULL)

C       G(T4,N60,FULL)

C       G(T4,N61,FULL)

C       G(T4,N62,FULL)

C       G(T4,N81,FULL)

C       G(T4,N82,FULL)

C       G(T4,N83,FULL)

C       G(T4,N84,FULL)

C       G(T4,N85,FULL)
        CALL xE01234_NEW(RMF2(3),RMF2(1),RMF2(1),MHH2,RMF2(3),S13,
     &  S12,T12,T14,S34,CMF2(3),NULL,CMF2(1),XMZ2,XMZ2,E0N,E1N,E2N,
     &  E3N,E4N,D0,D1,D2,D3,2,1)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,3)
        K(4) = E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,3)
        K(5) = E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,4)+2D0*E2N(3,4)
        K(6) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)
        K(7) = E1N(1)+2D0*E1N(2)+2D0*E1N(3)+2D0*E2N(1,2)+2D0*E2N(1,
     &  3)+2D0*E2N(2,2)+4D0*E2N(2,3)+2D0*E2N(3,3)

        PRE = -((QF(1)*QF(3)*ALPHA*CBA*XMZ)/(16D0*PI*XCW*XCW2))

        F(1,-1,-1) = F(1,-1,-1)-(2D0*K(1)*K(2)*K(7)*PRE*S13)/(XSW*
     &  XSW2)
        F(1,-1,1) = F(1,-1,1)-(4D0*K(1)*K(7)*QF(3)*PRE*S13)/XSW
        F(1,1,-1) = F(1,1,-1)+(4D0*K(2)*K(7)*QF(1)*PRE*S13)/XSW
        F(1,1,1) = F(1,1,1)+8D0*K(7)*QF(1)*QF(3)*PRE*S13*XSW
        F(2,-1,-1) = F(2,-1,-1)-(2D0*K(1)*K(2)*K(3)*PRE)/(XSW*XSW2)
        F(2,-1,1) = F(2,-1,1)-(4D0*K(1)*K(3)*QF(3)*PRE)/XSW
        F(2,1,-1) = F(2,1,-1)+(4D0*K(2)*K(3)*QF(1)*PRE)/XSW
        F(2,1,1) = F(2,1,1)+8D0*K(3)*QF(1)*QF(3)*PRE*XSW
        F(3,-1,-1) = F(3,-1,-1)+(2D0*K(1)*K(2)*K(5)*PRE)/(XSW*XSW2)
        F(3,-1,1) = F(3,-1,1)+(4D0*K(1)*K(5)*QF(3)*PRE)/XSW
        F(3,1,-1) = F(3,1,-1)-(4D0*K(2)*K(5)*QF(1)*PRE)/XSW
        F(3,1,1) = F(3,1,1)-8D0*K(5)*QF(1)*QF(3)*PRE*XSW
        F(5,-1,-1) = F(5,-1,-1)+(8D0*K(1)*K(2)*K(6)*PRE)/(XSW*XSW2)
        F(5,-1,1) = F(5,-1,1)+(16D0*K(1)*K(6)*QF(3)*PRE)/XSW
        F(5,1,-1) = F(5,1,-1)-(16D0*K(2)*K(6)*QF(1)*PRE)/XSW
        F(5,1,1) = F(5,1,1)-32D0*K(6)*QF(1)*QF(3)*PRE*XSW
        F(6,-1,-1) = F(6,-1,-1)+(4D0*E1N(3)*K(1)*K(2)*PRE)/(XSW*
     &  XSW2)
        F(6,-1,1) = F(6,-1,1)+(8D0*E1N(3)*K(1)*QF(3)*PRE)/XSW
        F(6,1,-1) = F(6,1,-1)-(8D0*E1N(3)*K(2)*QF(1)*PRE)/XSW
        F(6,1,1) = F(6,1,1)-16D0*E1N(3)*QF(1)*QF(3)*PRE*XSW
        F(7,-1,-1) = F(7,-1,-1)+(4D0*E1N(4)*K(1)*K(2)*PRE)/(XSW*
     &  XSW2)
        F(7,-1,1) = F(7,-1,1)+(8D0*E1N(4)*K(1)*QF(3)*PRE)/XSW
        F(7,1,-1) = F(7,1,-1)-(8D0*E1N(4)*K(2)*QF(1)*PRE)/XSW
        F(7,1,1) = F(7,1,1)-16D0*E1N(4)*QF(1)*QF(3)*PRE*XSW
        F(9,-1,-1) = F(9,-1,-1)-(K(1)*K(2)*K(6)*PRE)/(XSW*XSW2)
        F(9,-1,1) = F(9,-1,1)-(2D0*K(1)*K(6)*QF(3)*PRE)/XSW
        F(9,1,-1) = F(9,1,-1)+(2D0*K(2)*K(6)*QF(1)*PRE)/XSW
        F(9,1,1) = F(9,1,1)+4D0*K(6)*QF(1)*QF(3)*PRE*XSW
        F(10,-1,-1) = F(10,-1,-1)-(K(1)*K(2)*K(4)*PRE)/(XSW*XSW2)
        F(10,-1,1) = F(10,-1,1)-(2D0*K(1)*K(4)*QF(3)*PRE)/XSW
        F(10,1,-1) = F(10,1,-1)+(2D0*K(2)*K(4)*QF(1)*PRE)/XSW
        F(10,1,1) = F(10,1,1)+4D0*K(4)*QF(1)*QF(3)*PRE*XSW
        F(11,-1,-1) = F(11,-1,-1)+((E2N(2,4)+E2N(3,4))*K(1)*K(2)*
     &  PRE)/(XSW*XSW2)
        F(11,-1,1) = F(11,-1,1)+(2D0*(E2N(2,4)+E2N(3,4))*K(1)*QF(3)*
     &  PRE)/XSW
        F(11,1,-1) = F(11,1,-1)-(2D0*(E2N(2,4)+E2N(3,4))*K(2)*QF(1)*
     &  PRE)/XSW
        F(11,1,1) = F(11,1,1)-4D0*(E2N(2,4)+E2N(3,4))*QF(1)*QF(3)*
     &  PRE*XSW
        F(12,-1,-1) = F(12,-1,-1)+(E2N(3,4)*K(1)*K(2)*PRE)/(XSW*
     &  XSW2)
        F(12,-1,1) = F(12,-1,1)+(2D0*E2N(3,4)*K(1)*QF(3)*PRE)/XSW
        F(12,1,-1) = F(12,1,-1)-(2D0*E2N(3,4)*K(2)*QF(1)*PRE)/XSW
        F(12,1,1) = F(12,1,1)-4D0*E2N(3,4)*QF(1)*QF(3)*PRE*XSW
        F(13,-1,-1) = F(13,-1,-1)-(E2N(0,0)*K(1)*K(2)*PRE)/(XSW*
     &  XSW2)
        F(13,-1,1) = F(13,-1,1)-(2D0*E2N(0,0)*K(1)*QF(3)*PRE)/XSW
        F(13,1,-1) = F(13,1,-1)+(2D0*E2N(0,0)*K(2)*QF(1)*PRE)/XSW
        F(13,1,1) = F(13,1,1)+4D0*E2N(0,0)*QF(1)*QF(3)*PRE*XSW

C       G(T4,N86,FULL)
        CALL xE01234_NEW(RMF2(3),RMF2(1),RMF2(1),MHH2,RMF2(3),S13,
     &  S12,T12,T14,S34,CMF2(3),XMZ2,CMF2(1),XMZ2,XMZ2,E0N,E1N,E2N,
     &  E3N,E4N,D0,D1,D2,D3,2,1)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,3)
        K(4) = E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,3)
        K(5) = E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,4)+2D0*E2N(3,4)
        K(6) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)
        K(7) = E1N(1)+2D0*E1N(2)+2D0*E1N(3)+2D0*E2N(1,2)+2D0*E2N(1,
     &  3)+2D0*E2N(2,2)+4D0*E2N(2,3)+2D0*E2N(3,3)

        PRE = -((ALPHA*CBA*XCW2**(-2)*XMZ)/(64D0*PI*XCW))

        F(1,-1,-1) = F(1,-1,-1)+(2D0*K(1)**2*K(2)**2*K(7)*PRE*S13*
     &  XSW2**(-2))/XSW
        F(1,-1,1) = F(1,-1,1)+(8D0*K(1)**2*K(7)*QF(3)**2*PRE*S13)/
     &  XSW
        F(1,1,-1) = F(1,1,-1)+(8D0*K(2)**2*K(7)*QF(1)**2*PRE*S13)/
     &  XSW
        F(1,1,1) = F(1,1,1)+32D0*K(7)*QF(1)**2*QF(3)**2*PRE*S13*XSW*
     &  XSW2
        F(2,-1,-1) = F(2,-1,-1)+(2D0*K(1)**2*K(2)**2*K(3)*PRE*XSW2**
     &  (-2))/XSW
        F(2,-1,1) = F(2,-1,1)+(8D0*K(1)**2*K(3)*QF(3)**2*PRE)/XSW
        F(2,1,-1) = F(2,1,-1)+(8D0*K(2)**2*K(3)*QF(1)**2*PRE)/XSW
        F(2,1,1) = F(2,1,1)+32D0*K(3)*QF(1)**2*QF(3)**2*PRE*XSW*XSW2
        F(3,-1,-1) = F(3,-1,-1)-(2D0*K(1)**2*K(2)**2*K(5)*PRE*XSW2**
     &  (-2))/XSW
        F(3,-1,1) = F(3,-1,1)-(8D0*K(1)**2*K(5)*QF(3)**2*PRE)/XSW
        F(3,1,-1) = F(3,1,-1)-(8D0*K(2)**2*K(5)*QF(1)**2*PRE)/XSW
        F(3,1,1) = F(3,1,1)-32D0*K(5)*QF(1)**2*QF(3)**2*PRE*XSW*XSW2
        F(5,-1,-1) = F(5,-1,-1)-(8D0*K(1)**2*K(2)**2*K(6)*PRE*XSW2**
     &  (-2))/XSW
        F(5,-1,1) = F(5,-1,1)-(32D0*K(1)**2*K(6)*QF(3)**2*PRE)/XSW
        F(5,1,-1) = F(5,1,-1)-(32D0*K(2)**2*K(6)*QF(1)**2*PRE)/XSW
        F(5,1,1) = F(5,1,1)-128D0*K(6)*QF(1)**2*QF(3)**2*PRE*XSW*
     &  XSW2
        F(6,-1,-1) = F(6,-1,-1)-(4D0*E1N(3)*K(1)**2*K(2)**2*PRE*
     &  XSW2**(-2))/XSW
        F(6,-1,1) = F(6,-1,1)-(16D0*E1N(3)*K(1)**2*QF(3)**2*PRE)/XSW
        F(6,1,-1) = F(6,1,-1)-(16D0*E1N(3)*K(2)**2*QF(1)**2*PRE)/XSW
        F(6,1,1) = F(6,1,1)-64D0*E1N(3)*QF(1)**2*QF(3)**2*PRE*XSW*
     &  XSW2
        F(7,-1,-1) = F(7,-1,-1)-(4D0*E1N(4)*K(1)**2*K(2)**2*PRE*
     &  XSW2**(-2))/XSW
        F(7,-1,1) = F(7,-1,1)-(16D0*E1N(4)*K(1)**2*QF(3)**2*PRE)/XSW
        F(7,1,-1) = F(7,1,-1)-(16D0*E1N(4)*K(2)**2*QF(1)**2*PRE)/XSW
        F(7,1,1) = F(7,1,1)-64D0*E1N(4)*QF(1)**2*QF(3)**2*PRE*XSW*
     &  XSW2
        F(9,-1,-1) = F(9,-1,-1)+(K(1)**2*K(2)**2*K(6)*PRE*XSW2**(-
     &  2))/XSW
        F(9,-1,1) = F(9,-1,1)+(4D0*K(1)**2*K(6)*QF(3)**2*PRE)/XSW
        F(9,1,-1) = F(9,1,-1)+(4D0*K(2)**2*K(6)*QF(1)**2*PRE)/XSW
        F(9,1,1) = F(9,1,1)+16D0*K(6)*QF(1)**2*QF(3)**2*PRE*XSW*XSW2
        F(10,-1,-1) = F(10,-1,-1)+(K(1)**2*K(2)**2*K(4)*PRE*XSW2**(-
     &  2))/XSW
        F(10,-1,1) = F(10,-1,1)+(4D0*K(1)**2*K(4)*QF(3)**2*PRE)/XSW
        F(10,1,-1) = F(10,1,-1)+(4D0*K(2)**2*K(4)*QF(1)**2*PRE)/XSW
        F(10,1,1) = F(10,1,1)+16D0*K(4)*QF(1)**2*QF(3)**2*PRE*XSW*
     &  XSW2
        F(11,-1,-1) = F(11,-1,-1)-((E2N(2,4)+E2N(3,4))*K(1)**2*
     &  K(2)**2*PRE*XSW2**(-2))/XSW
        F(11,-1,1) = F(11,-1,1)-(4D0*(E2N(2,4)+E2N(3,4))*K(1)**2*
     &  QF(3)**2*PRE)/XSW
        F(11,1,-1) = F(11,1,-1)-(4D0*(E2N(2,4)+E2N(3,4))*K(2)**2*
     &  QF(1)**2*PRE)/XSW
        F(11,1,1) = F(11,1,1)-16D0*(E2N(2,4)+E2N(3,4))*QF(1)**2*
     &  QF(3)**2*PRE*XSW*XSW2
        F(12,-1,-1) = F(12,-1,-1)-(E2N(3,4)*K(1)**2*K(2)**2*PRE*
     &  XSW2**(-2))/XSW
        F(12,-1,1) = F(12,-1,1)-(4D0*E2N(3,4)*K(1)**2*QF(3)**2*PRE)/
     &  XSW
        F(12,1,-1) = F(12,1,-1)-(4D0*E2N(3,4)*K(2)**2*QF(1)**2*PRE)/
     &  XSW
        F(12,1,1) = F(12,1,1)-16D0*E2N(3,4)*QF(1)**2*QF(3)**2*PRE*
     &  XSW*XSW2
        F(13,-1,-1) = F(13,-1,-1)+(E2N(0,0)*K(1)**2*K(2)**2*PRE*
     &  XSW2**(-2))/XSW
        F(13,-1,1) = F(13,-1,1)+(4D0*E2N(0,0)*K(1)**2*QF(3)**2*PRE)/
     &  XSW
        F(13,1,-1) = F(13,1,-1)+(4D0*E2N(0,0)*K(2)**2*QF(1)**2*PRE)/
     &  XSW
        F(13,1,1) = F(13,1,1)+16D0*E2N(0,0)*QF(1)**2*QF(3)**2*PRE*
     &  XSW*XSW2

C       G(T4,N95,FULL)
        CALL xE01234_NEW(RMF2(3),RMF2(1),RMF2(1),MHH2,RMF2(3),S13,
     &  S12,T12,T14,S34,CMF2(4),XMW2,CMF2(2),XMW2,XMW2,E0N,E1N,E2N,
     &  E3N,E4N,D0,D1,D2,D3,2,1)
        K(1) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)

        PRE = -((ALPHA*CBA*XMW*XSW2**(-2))/(16D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+2D0*(E1N(1)+2D0*E1N(2)+2D0*E1N(3)+
     &  2D0*E2N(1,2)+2D0*E2N(1,3)+2D0*E2N(2,2)+4D0*E2N(2,3)+2D0*
     &  E2N(3,3))*PRE*S13
        F(2,-1,-1) = F(2,-1,-1)+2D0*(E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,
     &  3))*PRE
        F(3,-1,-1) = F(3,-1,-1)-2D0*(E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,
     &  4)+2D0*E2N(3,4))*PRE
        F(5,-1,-1) = F(5,-1,-1)-8D0*K(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)-4D0*E1N(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)-4D0*E1N(4)*PRE
        F(9,-1,-1) = F(9,-1,-1)+K(1)*PRE
        F(10,-1,-1) = F(10,-1,-1)+(E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,
     &  3))*PRE
        F(11,-1,-1) = F(11,-1,-1)+(-(E2N(2,4))-E2N(3,4))*PRE
        F(12,-1,-1) = F(12,-1,-1)-E2N(3,4)*PRE
        F(13,-1,-1) = F(13,-1,-1)+E2N(0,0)*PRE

C       G(T5,N96,FULL)

C       G(T5,N97,FULL)

C       G(T5,N98,FULL)

C       G(T5,N99,FULL)

C       G(T5,N100,FULL)

C       G(T5,N101,FULL)

C       G(T5,N102,FULL)

C       G(T5,N103,FULL)

C       G(T5,N104,FULL)

C       G(T5,N105,FULL)

C       G(T5,N106,FULL)
        CALL xE01234_NEW(RMF2(1),RMF2(3),RMF2(3),MHH2,RMF2(1),S14,
     &  S34,T13,T12,S12,CMF2(1),NULL,CMF2(3),XMZ2,XMZ2,E0N,E1N,E2N,
     &  E3N,E4N,D0,D1,D2,D3,2,1)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = 2D0*S14+S34
        K(4) = E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,3)
        K(5) = E1N(4)+E2N(2,4)+E2N(3,4)
        K(6) = E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,3)
        K(7) = 2D0*E1N(3)+3D0*E2N(1,3)+3D0*E2N(2,3)+3D0*E2N(3,3)
        K(8) = E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,4)+2D0*E2N(3,4)
        K(9) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)
        K(10) = 10D0*E2N(0,0)-E1N(4)*S12-2D0*E2N(1,4)*S12+E1N(1)*
     &  S14+2D0*E1N(2)*S14+2D0*E2N(1,2)*S14+2D0*E2N(1,3)*S14+2D0*
     &  E2N(2,2)*S14-2D0*E2N(2,4)*(S12+S24)+2D0*E2N(3,3)*(S14+S34)+
     &  E1N(3)*(2D0*S14+S34)+2D0*E2N(2,3)*(2D0*S14+S34)-2D0*E2N(3,
     &  4)*(MHH2-T12)

        PRE = -((QF(1)*QF(3)*ALPHA*CBA*XMZ)/(16D0*PI*XCW*XCW2))

        F(1,-1,-1) = F(1,-1,-1)+(2D0*K(1)*K(10)*K(2)*PRE)/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)+(4D0*K(1)*K(10)*QF(3)*PRE)/XSW
        F(1,1,-1) = F(1,1,-1)-(4D0*K(10)*K(2)*QF(1)*PRE)/XSW
        F(1,1,1) = F(1,1,1)-8D0*K(10)*QF(1)*QF(3)*PRE*XSW
        F(2,-1,-1) = F(2,-1,-1)+(2D0*K(1)*K(2)*K(8)*PRE)/(XSW*XSW2)
        F(2,-1,1) = F(2,-1,1)+(4D0*K(1)*K(8)*QF(3)*PRE)/XSW
        F(2,1,-1) = F(2,1,-1)-(4D0*K(2)*K(8)*QF(1)*PRE)/XSW
        F(2,1,1) = F(2,1,1)-8D0*K(8)*QF(1)*QF(3)*PRE*XSW
        F(3,-1,-1) = F(3,-1,-1)-(2D0*K(1)*K(2)*K(4)*PRE)/(XSW*XSW2)
        F(3,-1,1) = F(3,-1,1)-(4D0*K(1)*K(4)*QF(3)*PRE)/XSW
        F(3,1,-1) = F(3,1,-1)+(4D0*K(2)*K(4)*QF(1)*PRE)/XSW
        F(3,1,1) = F(3,1,1)+8D0*K(4)*QF(1)*QF(3)*PRE*XSW
        F(5,-1,-1) = F(5,-1,-1)+(4D0*K(1)*K(2)*K(7)*PRE)/(XSW*XSW2)
        F(5,-1,1) = F(5,-1,1)+(8D0*K(1)*K(7)*QF(3)*PRE)/XSW
        F(5,1,-1) = F(5,1,-1)-(8D0*K(2)*K(7)*QF(1)*PRE)/XSW
        F(5,1,1) = F(5,1,1)-16D0*K(7)*QF(1)*QF(3)*PRE*XSW
        F(6,-1,-1) = F(6,-1,-1)-(4D0*E2N(3,4)*K(1)*K(2)*PRE)/(XSW*
     &  XSW2)
        F(6,-1,1) = F(6,-1,1)-(8D0*E2N(3,4)*K(1)*QF(3)*PRE)/XSW
        F(6,1,-1) = F(6,1,-1)+(8D0*E2N(3,4)*K(2)*QF(1)*PRE)/XSW
        F(6,1,1) = F(6,1,1)+16D0*E2N(3,4)*QF(1)*QF(3)*PRE*XSW
        F(7,-1,-1) = F(7,-1,-1)+(4D0*K(1)*K(2)*K(9)*PRE)/(XSW*XSW2)
        F(7,-1,1) = F(7,-1,1)+(8D0*K(1)*K(9)*QF(3)*PRE)/XSW
        F(7,1,-1) = F(7,1,-1)-(8D0*K(2)*K(9)*QF(1)*PRE)/XSW
        F(7,1,1) = F(7,1,1)-16D0*K(9)*QF(1)*QF(3)*PRE*XSW
        F(8,-1,-1) = F(8,-1,-1)-(4D0*K(1)*K(2)*K(5)*PRE)/(XSW*XSW2)
        F(8,-1,1) = F(8,-1,1)-(8D0*K(1)*K(5)*QF(3)*PRE)/XSW
        F(8,1,-1) = F(8,1,-1)+(8D0*K(2)*K(5)*QF(1)*PRE)/XSW
        F(8,1,1) = F(8,1,1)+16D0*K(5)*QF(1)*QF(3)*PRE*XSW
        F(9,-1,-1) = F(9,-1,-1)-(K(1)*K(2)*K(6)*PRE)/(XSW*XSW2)
        F(9,-1,1) = F(9,-1,1)-(2D0*K(1)*K(6)*QF(3)*PRE)/XSW
        F(9,1,-1) = F(9,1,-1)+(2D0*K(2)*K(6)*QF(1)*PRE)/XSW
        F(9,1,1) = F(9,1,1)+4D0*K(6)*QF(1)*QF(3)*PRE*XSW
        F(10,-1,-1) = F(10,-1,-1)+(E2N(3,4)*K(1)*K(2)*PRE)/(XSW*
     &  XSW2)
        F(10,-1,1) = F(10,-1,1)+(2D0*E2N(3,4)*K(1)*QF(3)*PRE)/XSW
        F(10,1,-1) = F(10,1,-1)-(2D0*E2N(3,4)*K(2)*QF(1)*PRE)/XSW
        F(10,1,1) = F(10,1,1)-4D0*E2N(3,4)*QF(1)*QF(3)*PRE*XSW
        F(11,-1,-1) = F(11,-1,-1)-(K(1)*K(2)*K(9)*PRE)/(XSW*XSW2)
        F(11,-1,1) = F(11,-1,1)-(2D0*K(1)*K(9)*QF(3)*PRE)/XSW
        F(11,1,-1) = F(11,1,-1)+(2D0*K(2)*K(9)*QF(1)*PRE)/XSW
        F(11,1,1) = F(11,1,1)+4D0*K(9)*QF(1)*QF(3)*PRE*XSW
        F(12,-1,-1) = F(12,-1,-1)+((E2N(2,4)+E2N(3,4))*K(1)*K(2)*
     &  PRE)/(XSW*XSW2)
        F(12,-1,1) = F(12,-1,1)+(2D0*(E2N(2,4)+E2N(3,4))*K(1)*QF(3)*
     &  PRE)/XSW
        F(12,1,-1) = F(12,1,-1)-(2D0*(E2N(2,4)+E2N(3,4))*K(2)*QF(1)*
     &  PRE)/XSW
        F(12,1,1) = F(12,1,1)-4D0*(E2N(2,4)+E2N(3,4))*QF(1)*QF(3)*
     &  PRE*XSW
        F(13,-1,-1) = F(13,-1,-1)-(E2N(0,0)*K(1)*K(2)*PRE)/(XSW*
     &  XSW2)
        F(13,-1,1) = F(13,-1,1)-(2D0*E2N(0,0)*K(1)*QF(3)*PRE)/XSW
        F(13,1,-1) = F(13,1,-1)+(2D0*E2N(0,0)*K(2)*QF(1)*PRE)/XSW
        F(13,1,1) = F(13,1,1)+4D0*E2N(0,0)*QF(1)*QF(3)*PRE*XSW

C       G(T5,N107,FULL)
        CALL xE01234_NEW(RMF2(1),RMF2(3),RMF2(3),MHH2,RMF2(1),S14,
     &  S34,T13,T12,S12,CMF2(1),XMZ2,CMF2(3),XMZ2,XMZ2,E0N,E1N,E2N,
     &  E3N,E4N,D0,D1,D2,D3,2,1)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = 2D0*S14+S34
        K(4) = E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,3)
        K(5) = E1N(4)+E2N(2,4)+E2N(3,4)
        K(6) = E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,3)
        K(7) = 2D0*E1N(3)+3D0*E2N(1,3)+3D0*E2N(2,3)+3D0*E2N(3,3)
        K(8) = E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,4)+2D0*E2N(3,4)
        K(9) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)
        K(10) = 10D0*E2N(0,0)-E1N(4)*S12-2D0*E2N(1,4)*S12+E1N(1)*
     &  S14+2D0*E1N(2)*S14+2D0*E2N(1,2)*S14+2D0*E2N(1,3)*S14+2D0*
     &  E2N(2,2)*S14-2D0*E2N(2,4)*(S12+S24)+2D0*E2N(3,3)*(S14+S34)+
     &  E1N(3)*(2D0*S14+S34)+2D0*E2N(2,3)*(2D0*S14+S34)-2D0*E2N(3,
     &  4)*(MHH2-T12)

        PRE = -((ALPHA*CBA*XCW2**(-2)*XMZ)/(64D0*PI*XCW))

        F(1,-1,-1) = F(1,-1,-1)-(2D0*K(1)**2*K(10)*K(2)**2*PRE*
     &  XSW2**(-2))/XSW
        F(1,-1,1) = F(1,-1,1)-(8D0*K(1)**2*K(10)*QF(3)**2*PRE)/XSW
        F(1,1,-1) = F(1,1,-1)-(8D0*K(10)*K(2)**2*QF(1)**2*PRE)/XSW
        F(1,1,1) = F(1,1,1)-32D0*K(10)*QF(1)**2*QF(3)**2*PRE*XSW*
     &  XSW2
        F(2,-1,-1) = F(2,-1,-1)-(2D0*K(1)**2*K(2)**2*K(8)*PRE*XSW2**
     &  (-2))/XSW
        F(2,-1,1) = F(2,-1,1)-(8D0*K(1)**2*K(8)*QF(3)**2*PRE)/XSW
        F(2,1,-1) = F(2,1,-1)-(8D0*K(2)**2*K(8)*QF(1)**2*PRE)/XSW
        F(2,1,1) = F(2,1,1)-32D0*K(8)*QF(1)**2*QF(3)**2*PRE*XSW*XSW2
        F(3,-1,-1) = F(3,-1,-1)+(2D0*K(1)**2*K(2)**2*K(4)*PRE*XSW2**
     &  (-2))/XSW
        F(3,-1,1) = F(3,-1,1)+(8D0*K(1)**2*K(4)*QF(3)**2*PRE)/XSW
        F(3,1,-1) = F(3,1,-1)+(8D0*K(2)**2*K(4)*QF(1)**2*PRE)/XSW
        F(3,1,1) = F(3,1,1)+32D0*K(4)*QF(1)**2*QF(3)**2*PRE*XSW*XSW2
        F(5,-1,-1) = F(5,-1,-1)-(4D0*K(1)**2*K(2)**2*K(7)*PRE*XSW2**
     &  (-2))/XSW
        F(5,-1,1) = F(5,-1,1)-(16D0*K(1)**2*K(7)*QF(3)**2*PRE)/XSW
        F(5,1,-1) = F(5,1,-1)-(16D0*K(2)**2*K(7)*QF(1)**2*PRE)/XSW
        F(5,1,1) = F(5,1,1)-64D0*K(7)*QF(1)**2*QF(3)**2*PRE*XSW*XSW2
        F(6,-1,-1) = F(6,-1,-1)+(4D0*E2N(3,4)*K(1)**2*K(2)**2*PRE*
     &  XSW2**(-2))/XSW
        F(6,-1,1) = F(6,-1,1)+(16D0*E2N(3,4)*K(1)**2*QF(3)**2*PRE)/
     &  XSW
        F(6,1,-1) = F(6,1,-1)+(16D0*E2N(3,4)*K(2)**2*QF(1)**2*PRE)/
     &  XSW
        F(6,1,1) = F(6,1,1)+64D0*E2N(3,4)*QF(1)**2*QF(3)**2*PRE*XSW*
     &  XSW2
        F(7,-1,-1) = F(7,-1,-1)-(4D0*K(1)**2*K(2)**2*K(9)*PRE*XSW2**
     &  (-2))/XSW
        F(7,-1,1) = F(7,-1,1)-(16D0*K(1)**2*K(9)*QF(3)**2*PRE)/XSW
        F(7,1,-1) = F(7,1,-1)-(16D0*K(2)**2*K(9)*QF(1)**2*PRE)/XSW
        F(7,1,1) = F(7,1,1)-64D0*K(9)*QF(1)**2*QF(3)**2*PRE*XSW*XSW2
        F(8,-1,-1) = F(8,-1,-1)+(4D0*K(1)**2*K(2)**2*K(5)*PRE*XSW2**
     &  (-2))/XSW
        F(8,-1,1) = F(8,-1,1)+(16D0*K(1)**2*K(5)*QF(3)**2*PRE)/XSW
        F(8,1,-1) = F(8,1,-1)+(16D0*K(2)**2*K(5)*QF(1)**2*PRE)/XSW
        F(8,1,1) = F(8,1,1)+64D0*K(5)*QF(1)**2*QF(3)**2*PRE*XSW*XSW2
        F(9,-1,-1) = F(9,-1,-1)+(K(1)**2*K(2)**2*K(6)*PRE*XSW2**(-
     &  2))/XSW
        F(9,-1,1) = F(9,-1,1)+(4D0*K(1)**2*K(6)*QF(3)**2*PRE)/XSW
        F(9,1,-1) = F(9,1,-1)+(4D0*K(2)**2*K(6)*QF(1)**2*PRE)/XSW
        F(9,1,1) = F(9,1,1)+16D0*K(6)*QF(1)**2*QF(3)**2*PRE*XSW*XSW2
        F(10,-1,-1) = F(10,-1,-1)-(E2N(3,4)*K(1)**2*K(2)**2*PRE*
     &  XSW2**(-2))/XSW
        F(10,-1,1) = F(10,-1,1)-(4D0*E2N(3,4)*K(1)**2*QF(3)**2*PRE)/
     &  XSW
        F(10,1,-1) = F(10,1,-1)-(4D0*E2N(3,4)*K(2)**2*QF(1)**2*PRE)/
     &  XSW
        F(10,1,1) = F(10,1,1)-16D0*E2N(3,4)*QF(1)**2*QF(3)**2*PRE*
     &  XSW*XSW2
        F(11,-1,-1) = F(11,-1,-1)+(K(1)**2*K(2)**2*K(9)*PRE*XSW2**(-
     &  2))/XSW
        F(11,-1,1) = F(11,-1,1)+(4D0*K(1)**2*K(9)*QF(3)**2*PRE)/XSW
        F(11,1,-1) = F(11,1,-1)+(4D0*K(2)**2*K(9)*QF(1)**2*PRE)/XSW
        F(11,1,1) = F(11,1,1)+16D0*K(9)*QF(1)**2*QF(3)**2*PRE*XSW*
     &  XSW2
        F(12,-1,-1) = F(12,-1,-1)-((E2N(2,4)+E2N(3,4))*K(1)**2*
     &  K(2)**2*PRE*XSW2**(-2))/XSW
        F(12,-1,1) = F(12,-1,1)-(4D0*(E2N(2,4)+E2N(3,4))*K(1)**2*
     &  QF(3)**2*PRE)/XSW
        F(12,1,-1) = F(12,1,-1)-(4D0*(E2N(2,4)+E2N(3,4))*K(2)**2*
     &  QF(1)**2*PRE)/XSW
        F(12,1,1) = F(12,1,1)-16D0*(E2N(2,4)+E2N(3,4))*QF(1)**2*
     &  QF(3)**2*PRE*XSW*XSW2
        F(13,-1,-1) = F(13,-1,-1)+(E2N(0,0)*K(1)**2*K(2)**2*PRE*
     &  XSW2**(-2))/XSW
        F(13,-1,1) = F(13,-1,1)+(4D0*E2N(0,0)*K(1)**2*QF(3)**2*PRE)/
     &  XSW
        F(13,1,-1) = F(13,1,-1)+(4D0*E2N(0,0)*K(2)**2*QF(1)**2*PRE)/
     &  XSW
        F(13,1,1) = F(13,1,1)+16D0*E2N(0,0)*QF(1)**2*QF(3)**2*PRE*
     &  XSW*XSW2

C       G(T10,N276,FULL)

C       G(T10,N277,FULL)

C       G(T10,N278,FULL)

C       G(T10,N279,FULL)

C       G(T10,N280,FULL)

C       G(T10,N281,FULL)

C       G(T10,N290,FULL)
        CALL xE01234_NEW(RMF2(1),RMF2(3),RMF2(3),MHH2,RMF2(1),S24,
     &  S34,T13,T11,S12,CMF2(2),XMW2,CMF2(4),XMW2,XMW2,E0N,E1N,E2N,
     &  E3N,E4N,D0,D1,D2,D3,2,1)

        PRE = (ALPHA*CBA*XMW*XSW2**(-2))/(16D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)-2D0*PRE*(-(2D0*E2N(3,4)*S13)+E1N(1)*
     &  S24)
        F(2,-1,-1) = F(2,-1,-1)+2D0*(E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,
     &  4)+2D0*E2N(3,4))*PRE
        F(3,-1,-1) = F(3,-1,-1)-2D0*(E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,
     &  3))*PRE
        F(5,-1,-1) = F(5,-1,-1)-8D0*E2N(3,4)*PRE
        F(6,-1,-1) = F(6,-1,-1)+4D0*E1N(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+4D0*E1N(4)*PRE
        F(9,-1,-1) = F(9,-1,-1)+E2N(3,4)*PRE
        F(10,-1,-1) = F(10,-1,-1)+(-(E1N(3))-E2N(1,3)-E2N(2,3)-
     &  E2N(3,3))*PRE
        F(11,-1,-1) = F(11,-1,-1)+(E2N(2,4)+E2N(3,4))*PRE
        F(12,-1,-1) = F(12,-1,-1)+(-(E1N(2))-E1N(3)-E2N(1,2)-E2N(1,
     &  3)-E2N(2,2)-2D0*E2N(2,3)-E2N(3,3))*PRE
        F(13,-1,-1) = F(13,-1,-1)-E2N(0,0)*PRE

C       G(T10,N291,FULL)

C       G(T10,N292,FULL)

C       G(T10,N293,FULL)

C       G(T10,N294,FULL)

C       G(T10,N295,FULL)
        CALL xE01234_NEW(RMF2(1),RMF2(3),RMF2(3),MHH2,RMF2(1),S24,
     &  S34,T13,T11,S12,CMF2(1),NULL,CMF2(3),XMZ2,XMZ2,E0N,E1N,E2N,
     &  E3N,E4N,D0,D1,D2,D3,2,1)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,3)
        K(4) = E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,3)
        K(5) = E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,4)+2D0*E2N(3,4)
        K(6) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)

        PRE = (QF(1)*QF(3)*ALPHA*CBA*XMZ)/(16D0*PI*XCW*XCW2)

        F(1,-1,-1) = F(1,-1,-1)+(2D0*K(1)*K(2)*PRE*(-(2D0*E2N(3,4)*
     &  S13)+E1N(1)*S24))/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)+(4D0*K(1)*QF(3)*PRE*(-(2D0*E2N(3,4)*
     &  S13)+E1N(1)*S24))/XSW
        F(1,1,-1) = F(1,1,-1)-(4D0*K(2)*QF(1)*PRE*(-(2D0*E2N(3,4)*
     &  S13)+E1N(1)*S24))/XSW
        F(1,1,1) = F(1,1,1)-8D0*QF(1)*QF(3)*PRE*(-(2D0*E2N(3,4)*
     &  S13)+E1N(1)*S24)*XSW
        F(2,-1,-1) = F(2,-1,-1)-(2D0*K(1)*K(2)*K(5)*PRE)/(XSW*XSW2)
        F(2,-1,1) = F(2,-1,1)-(4D0*K(1)*K(5)*QF(3)*PRE)/XSW
        F(2,1,-1) = F(2,1,-1)+(4D0*K(2)*K(5)*QF(1)*PRE)/XSW
        F(2,1,1) = F(2,1,1)+8D0*K(5)*QF(1)*QF(3)*PRE*XSW
        F(3,-1,-1) = F(3,-1,-1)+(2D0*K(1)*K(2)*K(3)*PRE)/(XSW*XSW2)
        F(3,-1,1) = F(3,-1,1)+(4D0*K(1)*K(3)*QF(3)*PRE)/XSW
        F(3,1,-1) = F(3,1,-1)-(4D0*K(2)*K(3)*QF(1)*PRE)/XSW
        F(3,1,1) = F(3,1,1)-8D0*K(3)*QF(1)*QF(3)*PRE*XSW
        F(5,-1,-1) = F(5,-1,-1)+(8D0*E2N(3,4)*K(1)*K(2)*PRE)/(XSW*
     &  XSW2)
        F(5,-1,1) = F(5,-1,1)+(16D0*E2N(3,4)*K(1)*QF(3)*PRE)/XSW
        F(5,1,-1) = F(5,1,-1)-(16D0*E2N(3,4)*K(2)*QF(1)*PRE)/XSW
        F(5,1,1) = F(5,1,1)-32D0*E2N(3,4)*QF(1)*QF(3)*PRE*XSW
        F(6,-1,-1) = F(6,-1,-1)-(4D0*E1N(3)*K(1)*K(2)*PRE)/(XSW*
     &  XSW2)
        F(6,-1,1) = F(6,-1,1)-(8D0*E1N(3)*K(1)*QF(3)*PRE)/XSW
        F(6,1,-1) = F(6,1,-1)+(8D0*E1N(3)*K(2)*QF(1)*PRE)/XSW
        F(6,1,1) = F(6,1,1)+16D0*E1N(3)*QF(1)*QF(3)*PRE*XSW
        F(7,-1,-1) = F(7,-1,-1)-(4D0*E1N(4)*K(1)*K(2)*PRE)/(XSW*
     &  XSW2)
        F(7,-1,1) = F(7,-1,1)-(8D0*E1N(4)*K(1)*QF(3)*PRE)/XSW
        F(7,1,-1) = F(7,1,-1)+(8D0*E1N(4)*K(2)*QF(1)*PRE)/XSW
        F(7,1,1) = F(7,1,1)+16D0*E1N(4)*QF(1)*QF(3)*PRE*XSW
        F(9,-1,-1) = F(9,-1,-1)-(E2N(3,4)*K(1)*K(2)*PRE)/(XSW*XSW2)
        F(9,-1,1) = F(9,-1,1)-(2D0*E2N(3,4)*K(1)*QF(3)*PRE)/XSW
        F(9,1,-1) = F(9,1,-1)+(2D0*E2N(3,4)*K(2)*QF(1)*PRE)/XSW
        F(9,1,1) = F(9,1,1)+4D0*E2N(3,4)*QF(1)*QF(3)*PRE*XSW
        F(10,-1,-1) = F(10,-1,-1)+(K(1)*K(2)*K(4)*PRE)/(XSW*XSW2)
        F(10,-1,1) = F(10,-1,1)+(2D0*K(1)*K(4)*QF(3)*PRE)/XSW
        F(10,1,-1) = F(10,1,-1)-(2D0*K(2)*K(4)*QF(1)*PRE)/XSW
        F(10,1,1) = F(10,1,1)-4D0*K(4)*QF(1)*QF(3)*PRE*XSW
        F(11,-1,-1) = F(11,-1,-1)-((E2N(2,4)+E2N(3,4))*K(1)*K(2)*
     &  PRE)/(XSW*XSW2)
        F(11,-1,1) = F(11,-1,1)-(2D0*(E2N(2,4)+E2N(3,4))*K(1)*QF(3)*
     &  PRE)/XSW
        F(11,1,-1) = F(11,1,-1)+(2D0*(E2N(2,4)+E2N(3,4))*K(2)*QF(1)*
     &  PRE)/XSW
        F(11,1,1) = F(11,1,1)+4D0*(E2N(2,4)+E2N(3,4))*QF(1)*QF(3)*
     &  PRE*XSW
        F(12,-1,-1) = F(12,-1,-1)+(K(1)*K(2)*K(6)*PRE)/(XSW*XSW2)
        F(12,-1,1) = F(12,-1,1)+(2D0*K(1)*K(6)*QF(3)*PRE)/XSW
        F(12,1,-1) = F(12,1,-1)-(2D0*K(2)*K(6)*QF(1)*PRE)/XSW
        F(12,1,1) = F(12,1,1)-4D0*K(6)*QF(1)*QF(3)*PRE*XSW
        F(13,-1,-1) = F(13,-1,-1)+(E2N(0,0)*K(1)*K(2)*PRE)/(XSW*
     &  XSW2)
        F(13,-1,1) = F(13,-1,1)+(2D0*E2N(0,0)*K(1)*QF(3)*PRE)/XSW
        F(13,1,-1) = F(13,1,-1)-(2D0*E2N(0,0)*K(2)*QF(1)*PRE)/XSW
        F(13,1,1) = F(13,1,1)-4D0*E2N(0,0)*QF(1)*QF(3)*PRE*XSW

C       G(T10,N296,FULL)
        CALL xE01234_NEW(RMF2(1),RMF2(3),RMF2(3),MHH2,RMF2(1),S24,
     &  S34,T13,T11,S12,CMF2(1),XMZ2,CMF2(3),XMZ2,XMZ2,E0N,E1N,E2N,
     &  E3N,E4N,D0,D1,D2,D3,2,1)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,3)
        K(4) = E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,3)
        K(5) = E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,4)+2D0*E2N(3,4)
        K(6) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)

        PRE = (ALPHA*CBA*XCW2**(-2)*XMZ)/(64D0*PI*XCW)

        F(1,-1,-1) = F(1,-1,-1)-(2D0*K(1)**2*K(2)**2*PRE*(-(2D0*
     &  E2N(3,4)*S13)+E1N(1)*S24)*XSW2**(-2))/XSW
        F(1,-1,1) = F(1,-1,1)-(8D0*K(1)**2*QF(3)**2*PRE*(-(2D0*
     &  E2N(3,4)*S13)+E1N(1)*S24))/XSW
        F(1,1,-1) = F(1,1,-1)-(8D0*K(2)**2*QF(1)**2*PRE*(-(2D0*
     &  E2N(3,4)*S13)+E1N(1)*S24))/XSW
        F(1,1,1) = F(1,1,1)-32D0*QF(1)**2*QF(3)**2*PRE*(-(2D0*E2N(3,
     &  4)*S13)+E1N(1)*S24)*XSW*XSW2
        F(2,-1,-1) = F(2,-1,-1)+(2D0*K(1)**2*K(2)**2*K(5)*PRE*XSW2**
     &  (-2))/XSW
        F(2,-1,1) = F(2,-1,1)+(8D0*K(1)**2*K(5)*QF(3)**2*PRE)/XSW
        F(2,1,-1) = F(2,1,-1)+(8D0*K(2)**2*K(5)*QF(1)**2*PRE)/XSW
        F(2,1,1) = F(2,1,1)+32D0*K(5)*QF(1)**2*QF(3)**2*PRE*XSW*XSW2
        F(3,-1,-1) = F(3,-1,-1)-(2D0*K(1)**2*K(2)**2*K(3)*PRE*XSW2**
     &  (-2))/XSW
        F(3,-1,1) = F(3,-1,1)-(8D0*K(1)**2*K(3)*QF(3)**2*PRE)/XSW
        F(3,1,-1) = F(3,1,-1)-(8D0*K(2)**2*K(3)*QF(1)**2*PRE)/XSW
        F(3,1,1) = F(3,1,1)-32D0*K(3)*QF(1)**2*QF(3)**2*PRE*XSW*XSW2
        F(5,-1,-1) = F(5,-1,-1)-(8D0*E2N(3,4)*K(1)**2*K(2)**2*PRE*
     &  XSW2**(-2))/XSW
        F(5,-1,1) = F(5,-1,1)-(32D0*E2N(3,4)*K(1)**2*QF(3)**2*PRE)/
     &  XSW
        F(5,1,-1) = F(5,1,-1)-(32D0*E2N(3,4)*K(2)**2*QF(1)**2*PRE)/
     &  XSW
        F(5,1,1) = F(5,1,1)-128D0*E2N(3,4)*QF(1)**2*QF(3)**2*PRE*
     &  XSW*XSW2
        F(6,-1,-1) = F(6,-1,-1)+(4D0*E1N(3)*K(1)**2*K(2)**2*PRE*
     &  XSW2**(-2))/XSW
        F(6,-1,1) = F(6,-1,1)+(16D0*E1N(3)*K(1)**2*QF(3)**2*PRE)/XSW
        F(6,1,-1) = F(6,1,-1)+(16D0*E1N(3)*K(2)**2*QF(1)**2*PRE)/XSW
        F(6,1,1) = F(6,1,1)+64D0*E1N(3)*QF(1)**2*QF(3)**2*PRE*XSW*
     &  XSW2
        F(7,-1,-1) = F(7,-1,-1)+(4D0*E1N(4)*K(1)**2*K(2)**2*PRE*
     &  XSW2**(-2))/XSW
        F(7,-1,1) = F(7,-1,1)+(16D0*E1N(4)*K(1)**2*QF(3)**2*PRE)/XSW
        F(7,1,-1) = F(7,1,-1)+(16D0*E1N(4)*K(2)**2*QF(1)**2*PRE)/XSW
        F(7,1,1) = F(7,1,1)+64D0*E1N(4)*QF(1)**2*QF(3)**2*PRE*XSW*
     &  XSW2
        F(9,-1,-1) = F(9,-1,-1)+(E2N(3,4)*K(1)**2*K(2)**2*PRE*XSW2**
     &  (-2))/XSW
        F(9,-1,1) = F(9,-1,1)+(4D0*E2N(3,4)*K(1)**2*QF(3)**2*PRE)/
     &  XSW
        F(9,1,-1) = F(9,1,-1)+(4D0*E2N(3,4)*K(2)**2*QF(1)**2*PRE)/
     &  XSW
        F(9,1,1) = F(9,1,1)+16D0*E2N(3,4)*QF(1)**2*QF(3)**2*PRE*XSW*
     &  XSW2
        F(10,-1,-1) = F(10,-1,-1)-(K(1)**2*K(2)**2*K(4)*PRE*XSW2**(-
     &  2))/XSW
        F(10,-1,1) = F(10,-1,1)-(4D0*K(1)**2*K(4)*QF(3)**2*PRE)/XSW
        F(10,1,-1) = F(10,1,-1)-(4D0*K(2)**2*K(4)*QF(1)**2*PRE)/XSW
        F(10,1,1) = F(10,1,1)-16D0*K(4)*QF(1)**2*QF(3)**2*PRE*XSW*
     &  XSW2
        F(11,-1,-1) = F(11,-1,-1)+((E2N(2,4)+E2N(3,4))*K(1)**2*
     &  K(2)**2*PRE*XSW2**(-2))/XSW
        F(11,-1,1) = F(11,-1,1)+(4D0*(E2N(2,4)+E2N(3,4))*K(1)**2*
     &  QF(3)**2*PRE)/XSW
        F(11,1,-1) = F(11,1,-1)+(4D0*(E2N(2,4)+E2N(3,4))*K(2)**2*
     &  QF(1)**2*PRE)/XSW
        F(11,1,1) = F(11,1,1)+16D0*(E2N(2,4)+E2N(3,4))*QF(1)**2*
     &  QF(3)**2*PRE*XSW*XSW2
        F(12,-1,-1) = F(12,-1,-1)-(K(1)**2*K(2)**2*K(6)*PRE*XSW2**(-
     &  2))/XSW
        F(12,-1,1) = F(12,-1,1)-(4D0*K(1)**2*K(6)*QF(3)**2*PRE)/XSW
        F(12,1,-1) = F(12,1,-1)-(4D0*K(2)**2*K(6)*QF(1)**2*PRE)/XSW
        F(12,1,1) = F(12,1,1)-16D0*K(6)*QF(1)**2*QF(3)**2*PRE*XSW*
     &  XSW2
        F(13,-1,-1) = F(13,-1,-1)-(E2N(0,0)*K(1)**2*K(2)**2*PRE*
     &  XSW2**(-2))/XSW
        F(13,-1,1) = F(13,-1,1)-(4D0*E2N(0,0)*K(1)**2*QF(3)**2*PRE)/
     &  XSW
        F(13,1,-1) = F(13,1,-1)-(4D0*E2N(0,0)*K(2)**2*QF(1)**2*PRE)/
     &  XSW
        F(13,1,1) = F(13,1,1)-16D0*E2N(0,0)*QF(1)**2*QF(3)**2*PRE*
     &  XSW*XSW2

C       G(T12,N333,FULL)

C       G(T12,N334,FULL)

C       G(T12,N335,FULL)

C       G(T12,N336,FULL)

C       G(T12,N337,FULL)

C       G(T12,N338,FULL)

C       G(T12,N339,FULL)

C       G(T12,N340,FULL)

C       G(T12,N341,FULL)

C       G(T12,N342,FULL)

C       G(T12,N343,FULL)
        CALL xE01234_NEW(RMF2(3),RMF2(1),RMF2(1),MHH2,RMF2(3),S23,
     &  S12,T11,T14,S34,CMF2(3),NULL,CMF2(1),XMZ2,XMZ2,E0N,E1N,E2N,
     &  E3N,E4N,D0,D1,D2,D3,2,1)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = S12+2D0*S23
        K(4) = E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,3)
        K(5) = E1N(4)+E2N(2,4)+E2N(3,4)
        K(6) = E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,3)
        K(7) = 2D0*E1N(3)+3D0*E2N(1,3)+3D0*E2N(2,3)+3D0*E2N(3,3)
        K(8) = E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,4)+2D0*E2N(3,4)
        K(9) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)
        K(10) = 10D0*E2N(0,0)+E1N(1)*S23+2D0*E1N(2)*S23+2D0*E2N(1,
     &  2)*S23+2D0*E2N(1,3)*S23+2D0*E2N(2,2)*S23+2D0*E2N(3,3)*(S12+
     &  S23)+E1N(3)*(S12+2D0*S23)+2D0*E2N(2,3)*(S12+2D0*S23)-E1N(4)*
     &  S34-2D0*E2N(1,4)*S34-2D0*E2N(2,4)*(S24+S34)-2D0*E2N(3,4)*
     &  (MHH2-T14)

        PRE = -((QF(1)*QF(3)*ALPHA*CBA*XMZ)/(16D0*PI*XCW*XCW2))

        F(1,-1,-1) = F(1,-1,-1)+(2D0*K(1)*K(10)*K(2)*PRE)/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)+(4D0*K(1)*K(10)*QF(3)*PRE)/XSW
        F(1,1,-1) = F(1,1,-1)-(4D0*K(10)*K(2)*QF(1)*PRE)/XSW
        F(1,1,1) = F(1,1,1)-8D0*K(10)*QF(1)*QF(3)*PRE*XSW
        F(2,-1,-1) = F(2,-1,-1)-(2D0*K(1)*K(2)*K(4)*PRE)/(XSW*XSW2)
        F(2,-1,1) = F(2,-1,1)-(4D0*K(1)*K(4)*QF(3)*PRE)/XSW
        F(2,1,-1) = F(2,1,-1)+(4D0*K(2)*K(4)*QF(1)*PRE)/XSW
        F(2,1,1) = F(2,1,1)+8D0*K(4)*QF(1)*QF(3)*PRE*XSW
        F(3,-1,-1) = F(3,-1,-1)+(2D0*K(1)*K(2)*K(8)*PRE)/(XSW*XSW2)
        F(3,-1,1) = F(3,-1,1)+(4D0*K(1)*K(8)*QF(3)*PRE)/XSW
        F(3,1,-1) = F(3,1,-1)-(4D0*K(2)*K(8)*QF(1)*PRE)/XSW
        F(3,1,1) = F(3,1,1)-8D0*K(8)*QF(1)*QF(3)*PRE*XSW
        F(5,-1,-1) = F(5,-1,-1)+(4D0*K(1)*K(2)*K(7)*PRE)/(XSW*XSW2)
        F(5,-1,1) = F(5,-1,1)+(8D0*K(1)*K(7)*QF(3)*PRE)/XSW
        F(5,1,-1) = F(5,1,-1)-(8D0*K(2)*K(7)*QF(1)*PRE)/XSW
        F(5,1,1) = F(5,1,1)-16D0*K(7)*QF(1)*QF(3)*PRE*XSW
        F(6,-1,-1) = F(6,-1,-1)+(4D0*K(1)*K(2)*K(9)*PRE)/(XSW*XSW2)
        F(6,-1,1) = F(6,-1,1)+(8D0*K(1)*K(9)*QF(3)*PRE)/XSW
        F(6,1,-1) = F(6,1,-1)-(8D0*K(2)*K(9)*QF(1)*PRE)/XSW
        F(6,1,1) = F(6,1,1)-16D0*K(9)*QF(1)*QF(3)*PRE*XSW
        F(7,-1,-1) = F(7,-1,-1)-(4D0*E2N(3,4)*K(1)*K(2)*PRE)/(XSW*
     &  XSW2)
        F(7,-1,1) = F(7,-1,1)-(8D0*E2N(3,4)*K(1)*QF(3)*PRE)/XSW
        F(7,1,-1) = F(7,1,-1)+(8D0*E2N(3,4)*K(2)*QF(1)*PRE)/XSW
        F(7,1,1) = F(7,1,1)+16D0*E2N(3,4)*QF(1)*QF(3)*PRE*XSW
        F(8,-1,-1) = F(8,-1,-1)-(4D0*K(1)*K(2)*K(5)*PRE)/(XSW*XSW2)
        F(8,-1,1) = F(8,-1,1)-(8D0*K(1)*K(5)*QF(3)*PRE)/XSW
        F(8,1,-1) = F(8,1,-1)+(8D0*K(2)*K(5)*QF(1)*PRE)/XSW
        F(8,1,1) = F(8,1,1)+16D0*K(5)*QF(1)*QF(3)*PRE*XSW
        F(9,-1,-1) = F(9,-1,-1)-(K(1)*K(2)*K(6)*PRE)/(XSW*XSW2)
        F(9,-1,1) = F(9,-1,1)-(2D0*K(1)*K(6)*QF(3)*PRE)/XSW
        F(9,1,-1) = F(9,1,-1)+(2D0*K(2)*K(6)*QF(1)*PRE)/XSW
        F(9,1,1) = F(9,1,1)+4D0*K(6)*QF(1)*QF(3)*PRE*XSW
        F(10,-1,-1) = F(10,-1,-1)-(K(1)*K(2)*K(9)*PRE)/(XSW*XSW2)
        F(10,-1,1) = F(10,-1,1)-(2D0*K(1)*K(9)*QF(3)*PRE)/XSW
        F(10,1,-1) = F(10,1,-1)+(2D0*K(2)*K(9)*QF(1)*PRE)/XSW
        F(10,1,1) = F(10,1,1)+4D0*K(9)*QF(1)*QF(3)*PRE*XSW
        F(11,-1,-1) = F(11,-1,-1)+(E2N(3,4)*K(1)*K(2)*PRE)/(XSW*
     &  XSW2)
        F(11,-1,1) = F(11,-1,1)+(2D0*E2N(3,4)*K(1)*QF(3)*PRE)/XSW
        F(11,1,-1) = F(11,1,-1)-(2D0*E2N(3,4)*K(2)*QF(1)*PRE)/XSW
        F(11,1,1) = F(11,1,1)-4D0*E2N(3,4)*QF(1)*QF(3)*PRE*XSW
        F(12,-1,-1) = F(12,-1,-1)+((E2N(2,4)+E2N(3,4))*K(1)*K(2)*
     &  PRE)/(XSW*XSW2)
        F(12,-1,1) = F(12,-1,1)+(2D0*(E2N(2,4)+E2N(3,4))*K(1)*QF(3)*
     &  PRE)/XSW
        F(12,1,-1) = F(12,1,-1)-(2D0*(E2N(2,4)+E2N(3,4))*K(2)*QF(1)*
     &  PRE)/XSW
        F(12,1,1) = F(12,1,1)-4D0*(E2N(2,4)+E2N(3,4))*QF(1)*QF(3)*
     &  PRE*XSW
        F(13,-1,-1) = F(13,-1,-1)-(E2N(0,0)*K(1)*K(2)*PRE)/(XSW*
     &  XSW2)
        F(13,-1,1) = F(13,-1,1)-(2D0*E2N(0,0)*K(1)*QF(3)*PRE)/XSW
        F(13,1,-1) = F(13,1,-1)+(2D0*E2N(0,0)*K(2)*QF(1)*PRE)/XSW
        F(13,1,1) = F(13,1,1)+4D0*E2N(0,0)*QF(1)*QF(3)*PRE*XSW

C       G(T12,N344,FULL)
        CALL xE01234_NEW(RMF2(3),RMF2(1),RMF2(1),MHH2,RMF2(3),S23,
     &  S12,T11,T14,S34,CMF2(3),XMZ2,CMF2(1),XMZ2,XMZ2,E0N,E1N,E2N,
     &  E3N,E4N,D0,D1,D2,D3,2,1)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = S12+2D0*S23
        K(4) = E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,3)
        K(5) = E1N(4)+E2N(2,4)+E2N(3,4)
        K(6) = E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,3)
        K(7) = 2D0*E1N(3)+3D0*E2N(1,3)+3D0*E2N(2,3)+3D0*E2N(3,3)
        K(8) = E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,4)+2D0*E2N(3,4)
        K(9) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)
        K(10) = 10D0*E2N(0,0)+E1N(1)*S23+2D0*E1N(2)*S23+2D0*E2N(1,
     &  2)*S23+2D0*E2N(1,3)*S23+2D0*E2N(2,2)*S23+2D0*E2N(3,3)*(S12+
     &  S23)+E1N(3)*(S12+2D0*S23)+2D0*E2N(2,3)*(S12+2D0*S23)-E1N(4)*
     &  S34-2D0*E2N(1,4)*S34-2D0*E2N(2,4)*(S24+S34)-2D0*E2N(3,4)*
     &  (MHH2-T14)

        PRE = -((ALPHA*CBA*XCW2**(-2)*XMZ)/(64D0*PI*XCW))

        F(1,-1,-1) = F(1,-1,-1)-(2D0*K(1)**2*K(10)*K(2)**2*PRE*
     &  XSW2**(-2))/XSW
        F(1,-1,1) = F(1,-1,1)-(8D0*K(1)**2*K(10)*QF(3)**2*PRE)/XSW
        F(1,1,-1) = F(1,1,-1)-(8D0*K(10)*K(2)**2*QF(1)**2*PRE)/XSW
        F(1,1,1) = F(1,1,1)-32D0*K(10)*QF(1)**2*QF(3)**2*PRE*XSW*
     &  XSW2
        F(2,-1,-1) = F(2,-1,-1)+(2D0*K(1)**2*K(2)**2*K(4)*PRE*XSW2**
     &  (-2))/XSW
        F(2,-1,1) = F(2,-1,1)+(8D0*K(1)**2*K(4)*QF(3)**2*PRE)/XSW
        F(2,1,-1) = F(2,1,-1)+(8D0*K(2)**2*K(4)*QF(1)**2*PRE)/XSW
        F(2,1,1) = F(2,1,1)+32D0*K(4)*QF(1)**2*QF(3)**2*PRE*XSW*XSW2
        F(3,-1,-1) = F(3,-1,-1)-(2D0*K(1)**2*K(2)**2*K(8)*PRE*XSW2**
     &  (-2))/XSW
        F(3,-1,1) = F(3,-1,1)-(8D0*K(1)**2*K(8)*QF(3)**2*PRE)/XSW
        F(3,1,-1) = F(3,1,-1)-(8D0*K(2)**2*K(8)*QF(1)**2*PRE)/XSW
        F(3,1,1) = F(3,1,1)-32D0*K(8)*QF(1)**2*QF(3)**2*PRE*XSW*XSW2
        F(5,-1,-1) = F(5,-1,-1)-(4D0*K(1)**2*K(2)**2*K(7)*PRE*XSW2**
     &  (-2))/XSW
        F(5,-1,1) = F(5,-1,1)-(16D0*K(1)**2*K(7)*QF(3)**2*PRE)/XSW
        F(5,1,-1) = F(5,1,-1)-(16D0*K(2)**2*K(7)*QF(1)**2*PRE)/XSW
        F(5,1,1) = F(5,1,1)-64D0*K(7)*QF(1)**2*QF(3)**2*PRE*XSW*XSW2
        F(6,-1,-1) = F(6,-1,-1)-(4D0*K(1)**2*K(2)**2*K(9)*PRE*XSW2**
     &  (-2))/XSW
        F(6,-1,1) = F(6,-1,1)-(16D0*K(1)**2*K(9)*QF(3)**2*PRE)/XSW
        F(6,1,-1) = F(6,1,-1)-(16D0*K(2)**2*K(9)*QF(1)**2*PRE)/XSW
        F(6,1,1) = F(6,1,1)-64D0*K(9)*QF(1)**2*QF(3)**2*PRE*XSW*XSW2
        F(7,-1,-1) = F(7,-1,-1)+(4D0*E2N(3,4)*K(1)**2*K(2)**2*PRE*
     &  XSW2**(-2))/XSW
        F(7,-1,1) = F(7,-1,1)+(16D0*E2N(3,4)*K(1)**2*QF(3)**2*PRE)/
     &  XSW
        F(7,1,-1) = F(7,1,-1)+(16D0*E2N(3,4)*K(2)**2*QF(1)**2*PRE)/
     &  XSW
        F(7,1,1) = F(7,1,1)+64D0*E2N(3,4)*QF(1)**2*QF(3)**2*PRE*XSW*
     &  XSW2
        F(8,-1,-1) = F(8,-1,-1)+(4D0*K(1)**2*K(2)**2*K(5)*PRE*XSW2**
     &  (-2))/XSW
        F(8,-1,1) = F(8,-1,1)+(16D0*K(1)**2*K(5)*QF(3)**2*PRE)/XSW
        F(8,1,-1) = F(8,1,-1)+(16D0*K(2)**2*K(5)*QF(1)**2*PRE)/XSW
        F(8,1,1) = F(8,1,1)+64D0*K(5)*QF(1)**2*QF(3)**2*PRE*XSW*XSW2
        F(9,-1,-1) = F(9,-1,-1)+(K(1)**2*K(2)**2*K(6)*PRE*XSW2**(-
     &  2))/XSW
        F(9,-1,1) = F(9,-1,1)+(4D0*K(1)**2*K(6)*QF(3)**2*PRE)/XSW
        F(9,1,-1) = F(9,1,-1)+(4D0*K(2)**2*K(6)*QF(1)**2*PRE)/XSW
        F(9,1,1) = F(9,1,1)+16D0*K(6)*QF(1)**2*QF(3)**2*PRE*XSW*XSW2
        F(10,-1,-1) = F(10,-1,-1)+(K(1)**2*K(2)**2*K(9)*PRE*XSW2**(-
     &  2))/XSW
        F(10,-1,1) = F(10,-1,1)+(4D0*K(1)**2*K(9)*QF(3)**2*PRE)/XSW
        F(10,1,-1) = F(10,1,-1)+(4D0*K(2)**2*K(9)*QF(1)**2*PRE)/XSW
        F(10,1,1) = F(10,1,1)+16D0*K(9)*QF(1)**2*QF(3)**2*PRE*XSW*
     &  XSW2
        F(11,-1,-1) = F(11,-1,-1)-(E2N(3,4)*K(1)**2*K(2)**2*PRE*
     &  XSW2**(-2))/XSW
        F(11,-1,1) = F(11,-1,1)-(4D0*E2N(3,4)*K(1)**2*QF(3)**2*PRE)/
     &  XSW
        F(11,1,-1) = F(11,1,-1)-(4D0*E2N(3,4)*K(2)**2*QF(1)**2*PRE)/
     &  XSW
        F(11,1,1) = F(11,1,1)-16D0*E2N(3,4)*QF(1)**2*QF(3)**2*PRE*
     &  XSW*XSW2
        F(12,-1,-1) = F(12,-1,-1)-((E2N(2,4)+E2N(3,4))*K(1)**2*
     &  K(2)**2*PRE*XSW2**(-2))/XSW
        F(12,-1,1) = F(12,-1,1)-(4D0*(E2N(2,4)+E2N(3,4))*K(1)**2*
     &  QF(3)**2*PRE)/XSW
        F(12,1,-1) = F(12,1,-1)-(4D0*(E2N(2,4)+E2N(3,4))*K(2)**2*
     &  QF(1)**2*PRE)/XSW
        F(12,1,1) = F(12,1,1)-16D0*(E2N(2,4)+E2N(3,4))*QF(1)**2*
     &  QF(3)**2*PRE*XSW*XSW2
        F(13,-1,-1) = F(13,-1,-1)+(E2N(0,0)*K(1)**2*K(2)**2*PRE*
     &  XSW2**(-2))/XSW
        F(13,-1,1) = F(13,-1,1)+(4D0*E2N(0,0)*K(1)**2*QF(3)**2*PRE)/
     &  XSW
        F(13,1,-1) = F(13,1,-1)+(4D0*E2N(0,0)*K(2)**2*QF(1)**2*PRE)/
     &  XSW
        F(13,1,1) = F(13,1,1)+16D0*E2N(0,0)*QF(1)**2*QF(3)**2*PRE*
     &  XSW*XSW2

	end

**********************************************************************
        subroutine  HHtoZZ1133_self_ferm2_thdm(F,pz12,pz34)
**********************************************************************
*       self-energy contributions for HH -> ZZ -> uudd in the THDM
*       fermionic loops
*---------------------------------------------------------------------
*       24.4.16 Stefan Dittmaier
**********************************************************************
	implicit none
	complex*16 pre,F(13,-1:1,-1:1),pz12,pz34
	complex*16 A0,xA0_,B0_,xB0_,DB0_,xDB0_,B1_,xB1_,DB1_,xDB1_
        complex*16 B0,B1(1),B2(0:2,0:2),B3(0:2,0:2,2)
        complex*16 B4(0:2,0:2,0:2,0:2),B5(0:2,0:2,0:2,0:2,2)
        complex*16 C0_,C0,C1(2),C2(0:2,0:2),C3(0:2,0:2,2)
        complex*16 C4(0:2,0:2,0:2,0:2)
	complex*16 D0,D1(3),D2(0:3,0:3),D3(0:3,0:3,3)
        complex*16 D4(0:3,0:3,0:3,0:3),D5(0:3,0:3,0:3,0:3,3)
	complex*16 E0n,E1n(4),E2n(0:4,0:4),E3n(0:4,0:4,4)
	complex*16 E4n(0:4,0:4,0:4,0:4)
        complex*16 seaa,seaz,sezz

c mandelstam variables
      	real*8 s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
      	common/mandel/s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
c fermion charges of isospin duplets
	real*8 qf(4)
	common/fcharge/qf
c fermion masses as flag (i*1d-20)
      	complex*16 cme2,cmf2(5)
      	real*8 me2,rme2,mf2(5),rmf2(5)
      	common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2
	include '../COMMON/param.inc'
	include '../COMMON/xparam.inc'
        include '../COMMON/param_thdm.inc'
        include '../COMMON/param_bsm.inc'

        call xsevv_ferm(s12,seaa,seaz,sezz)

      PRE = CBA*(PZ12*PZ34*XCW2**(-2)*XMW)/4D0  *(-sezz)*pz12

      F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/(XSW*XSW2)
      F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW
      F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW
      F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*XSW

      PRE = CBA*(PZ12*PZ34/XCW**3/XSW*XMW)/4D0  *(-seaz)/s12

      F(1,-1,-1) = F(1,-1,-1)-(PRE*(-2D0*QF(1)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/(XSW*XSW2)
      F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(-2D0*QF(1)*XSW2))/
     &  XSW
      F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW
      F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*XSW

        call xsevv_ferm(s34,seaa,seaz,sezz)

      PRE = CBA*(PZ12*PZ34*XCW2**(-2)*XMW)/4D0  *(-sezz)*pz34

      F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/(XSW*XSW2)
      F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW
      F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW
      F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*XSW

      PRE = CBA*(PZ12*PZ34/XCW**3/XSW*XMW)/4D0  *(-seaz)/s34

      F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2)*(+2D0*
     &  QF(3)*XSW2))/(XSW*XSW2)
      F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW
      F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(2D0*QF(3)*XSW2))/
     &  XSW
      F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*XSW

	end

**********************************************************************
        subroutine  HHtoZZ1133_self_ferm_thdm(F,pz12,pz34)
**********************************************************************
*       self-energy contributions for HH -> ZZ -> uudd in the THDM
*       closed fermion loops
*---------------------------------------------------------------------
*       24.4.16 Stefan Dittmaier
**********************************************************************
	implicit none
	complex*16 pre,F(13,-1:1,-1:1),pz12,pz34
	complex*16 A0,xA0_,B0_,xB0_,DB0_,xDB0_,B1_,xB1_,DB1_,xDB1_
        complex*16 B0,B1(1),B2(0:2,0:2),B3(0:2,0:2,2)
        complex*16 B4(0:2,0:2,0:2,0:2),B5(0:2,0:2,0:2,0:2,2)
        complex*16 C0_,C0,C1(2),C2(0:2,0:2),C3(0:2,0:2,2)
        complex*16 C4(0:2,0:2,0:2,0:2)
	complex*16 D0,D1(3),D2(0:3,0:3),D3(0:3,0:3,3)
        complex*16 D4(0:3,0:3,0:3,0:3),D5(0:3,0:3,0:3,0:3,3)
	complex*16 E0n,E1n(4),E2n(0:4,0:4),E3n(0:4,0:4,4)
	complex*16 E4n(0:4,0:4,0:4,0:4)
        COMPLEX*16 K(2)
	integer i

c mandelstam variables
      	real*8 s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
      	common/mandel/s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
c fermion charges of isospin duplets
	real*8 qf(4)
	common/fcharge/qf
c fermion masses as flag (i*1d-20)
      	complex*16 cme2,cmf2(5)
      	real*8 me2,rme2,mf2(5),rmf2(5)
      	common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2
	include '../COMMON/param.inc'
	include '../COMMON/xparam.inc'
        include '../COMMON/param_thdm.inc'
        include '../COMMON/param_bsm.inc'

	do 100 i=1,3

C       Process: S2F21aF21F23aF23,   Model: THDM

C       G(T3,N125,FULL)

C       G(T3,N126,FULL)

C       G(T3,N127,FULL)

C       G(T3,N142,FULL)

C       G(T3,N143,FULL)

C       G(T3,N144,FULL)

C       G(T3,N159,FULL)

C       G(T3,N160,FULL)

C       G(T3,N161,FULL)

C       G(T3,N170,FULL)

C       G(T3,N171,FULL)

C       G(T3,N172,FULL)

C       G(T3,N181,FULL)

C       G(T3,N182,FULL)

C       G(T3,N183,FULL)

C       G(T3,N198,FULL)

C       G(T3,N199,FULL)

C       G(T3,N200,FULL)

C       G(T3,N215,FULL)

C       G(T3,N216,FULL)

C       G(T3,N217,FULL)

C       G(T3,N232,FULL)

C       G(T3,N233,FULL)

C       G(T3,N234,FULL)

C       G(T3,N249,FULL)

C       G(T3,N250,FULL)

C       G(T3,N251,FULL)

C       G(T3,N263,FULL)
        CALL xB012345_(S12,XMQM2(I),XMQM2(I),B0,B1,B2,B3,B4,B5,2,0)

        PRE = (QF(1)*ALPHA*CBA*PZ12*PZ34*XMZ*(3D0-4D0*XSW2)*(-(6D0*
     &  B1(1))-6D0*B2(1,1)-(12D0*B2(0,0))/S12+(6D0*B0*XMQM2(I))/S12-
     &  ((S12-6D0*XMQM2(I)))/S12))/(144D0*PI*XCW*XCW2*XSW)

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE
        F(1,1,-1) = F(1,1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,1,1) = F(1,1,1)+2D0*QF(3)*PRE

C       G(T3,N264,FULL)
        CALL xB012345_(S12,XMQP2(I),XMQP2(I),B0,B1,B2,B3,B4,B5,2,0)

        PRE = (QF(1)*ALPHA*CBA*PZ12*PZ34*XMZ*(3D0-8D0*XSW2)*(-(6D0*
     &  B1(1))-6D0*B2(1,1)-(12D0*B2(0,0))/S12+(6D0*B0*XMQP2(I))/S12-
     &  ((S12-6D0*XMQP2(I)))/S12))/(72D0*PI*XCW*XCW2*XSW)

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE
        F(1,1,-1) = F(1,1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,1,1) = F(1,1,1)+2D0*QF(3)*PRE

C       G(T3,N265,FULL)
        CALL xB012345_(S12,XML2(I),XML2(I),B0,B1,B2,B3,B4,B5,2,0)

        PRE = (QF(1)*ALPHA*CBA*PZ12*PZ34*XMZ*(1D0-2D0*XSW)*(1D0+2D0*
     &  XSW)*(-(6D0*B1(1))-6D0*B2(1,1)-(12D0*B2(0,0))/S12+(6D0*B0*
     &  XML2(I))/S12-((S12-6D0*XML2(I)))/S12))/(48D0*PI*XCW*XCW2*
     &  XSW)

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE
        F(1,1,-1) = F(1,1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,1,1) = F(1,1,1)+2D0*QF(3)*PRE

C       G(T3,N277,FULL)

C       G(T3,N278,FULL)

C       G(T3,N279,FULL)

C       G(T3,N280,FULL)

C       G(T3,N298,FULL)
        CALL xB012345_(S12,XMQM2(I),XMQM2(I),B0,B1,B2,B3,B4,B5,2,0)
        K(1) = 9D0-12D0*XSW2+8D0*XSW2**2
        K(2) = (12D0*B2(0,0)*(9D0-12D0*XSW2+8D0*XSW2**2))/XSW2+(6D0*
     &  B1(1)*S12*(9D0-12D0*XSW2+8D0*XSW2**2))/XSW2+(6D0*B2(1,1)*
     &  S12*(9D0-12D0*XSW2+8D0*XSW2**2))/XSW2+24D0*B0*(3D0-2D0*
     &  XSW2)*XMQM2(I)+((9D0-12D0*XSW2+8D0*XSW2**2)*(S12-6D0*
     &  XMQM2(I)))/XSW2

        PRE = (ALPHA*CBA*PZ12**2*PZ34*XCW2**(-2)*XMZ)/(576D0*PI*XCW)

        F(1,-1,-1) = F(1,-1,-1)-(K(2)*PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+
     &  2D0*QF(3)*XSW2))/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*K(2)*QF(3)*PRE*(1D0-2D0*QF(1)*
     &  XSW2))/XSW
        F(1,1,-1) = F(1,1,-1)+(2D0*K(2)*QF(1)*PRE*(1D0+2D0*QF(3)*
     &  XSW2))/XSW
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*((12D0*B2(0,0)*
     &  K(1))/XSW+(6D0*B1(1)*K(1)*S12)/XSW+(6D0*B2(1,1)*K(1)*S12)/
     &  XSW+24D0*B0*XSW*(3D0-2D0*XSW2)*XMQM2(I)+(K(1)*(S12-6D0*
     &  XMQM2(I)))/XSW)

C       G(T3,N299,FULL)
        CALL xB012345_(S12,XMQP2(I),XMQP2(I),B0,B1,B2,B3,B4,B5,2,0)
        K(1) = 9D0-24D0*XSW2+32D0*XSW2**2
        K(2) = (12D0*B2(0,0)*(9D0-24D0*XSW2+32D0*XSW2**2))/XSW2+
     &  (6D0*B1(1)*S12*(9D0-24D0*XSW2+32D0*XSW2**2))/XSW2+(6D0*B2(1,
     &  1)*S12*(9D0-24D0*XSW2+32D0*XSW2**2))/XSW2+48D0*B0*(3D0-4D0*
     &  XSW2)*XMQP2(I)+((9D0-24D0*XSW2+32D0*XSW2**2)*(S12-6D0*
     &  XMQP2(I)))/XSW2

        PRE = (ALPHA*CBA*PZ12**2*PZ34*XCW2**(-2)*XMZ)/(576D0*PI*XCW)

        F(1,-1,-1) = F(1,-1,-1)-(K(2)*PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+
     &  2D0*QF(3)*XSW2))/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*K(2)*QF(3)*PRE*(1D0-2D0*QF(1)*
     &  XSW2))/XSW
        F(1,1,-1) = F(1,1,-1)+(2D0*K(2)*QF(1)*PRE*(1D0+2D0*QF(3)*
     &  XSW2))/XSW
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*((12D0*B2(0,0)*
     &  K(1))/XSW+(6D0*B1(1)*K(1)*S12)/XSW+(6D0*B2(1,1)*K(1)*S12)/
     &  XSW+48D0*B0*XSW*(3D0-4D0*XSW2)*XMQP2(I)+(K(1)*(S12-6D0*
     &  XMQP2(I)))/XSW)

C       G(T3,N300,FULL)
        CALL xB012345_(S12,NULL,NULL,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (ALPHA*CBA*PZ12**2*PZ34*(12D0*B2(0,0)+S12+6D0*B1(1)*
     &  S12+6D0*B2(1,1)*S12)*XCW2**(-2)*XMZ)/(192D0*PI*XCW*XSW)

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T3,N301,FULL)
        CALL xB012345_(S12,XML2(I),XML2(I),B0,B1,B2,B3,B4,B5,2,0)
        K(1) = 1D0-4D0*XSW2+8D0*XSW2**2
        K(2) = (12D0*B2(0,0)*(1D0-4D0*XSW2+8D0*XSW2**2))/XSW2+(6D0*
     &  B1(1)*S12*(1D0-4D0*XSW2+8D0*XSW2**2))/XSW2+(6D0*B2(1,1)*S12*
     &  (1D0-4D0*XSW2+8D0*XSW2**2))/XSW2+24D0*B0*(1D0-2D0*XSW2)*
     &  XML2(I)+((1D0-4D0*XSW2+8D0*XSW2**2)*(S12-6D0*XML2(I)))/XSW2

        PRE = (ALPHA*CBA*PZ12**2*PZ34*XCW2**(-2)*XMZ)/(192D0*PI*XCW)

        F(1,-1,-1) = F(1,-1,-1)-(K(2)*PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+
     &  2D0*QF(3)*XSW2))/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*K(2)*QF(3)*PRE*(1D0-2D0*QF(1)*
     &  XSW2))/XSW
        F(1,1,-1) = F(1,1,-1)+(2D0*K(2)*QF(1)*PRE*(1D0+2D0*QF(3)*
     &  XSW2))/XSW
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*((12D0*B2(0,0)*
     &  K(1))/XSW+(6D0*B1(1)*K(1)*S12)/XSW+(6D0*B2(1,1)*K(1)*S12)/
     &  XSW+24D0*B0*XSW*(1D0-2D0*XSW2)*XML2(I)+(K(1)*(S12-6D0*
     &  XML2(I)))/XSW)

C       G(T4,N343,FULL)

C       G(T4,N344,FULL)

C       G(T4,N345,FULL)

C       G(T4,N360,FULL)

C       G(T4,N361,FULL)

C       G(T4,N362,FULL)

C       G(T4,N371,FULL)

C       G(T4,N372,FULL)

C       G(T4,N373,FULL)

C       G(T4,N388,FULL)

C       G(T4,N389,FULL)

C       G(T4,N390,FULL)

C       G(T4,N405,FULL)

C       G(T4,N406,FULL)

C       G(T4,N407,FULL)

C       G(T4,N416,FULL)

C       G(T4,N417,FULL)

C       G(T4,N418,FULL)

C       G(T4,N433,FULL)

C       G(T4,N434,FULL)

C       G(T4,N435,FULL)

C       G(T4,N450,FULL)

C       G(T4,N451,FULL)

C       G(T4,N452,FULL)

C       G(T4,N464,FULL)

C       G(T4,N465,FULL)

C       G(T4,N466,FULL)

C       G(T4,N467,FULL)

C       G(T4,N485,FULL)

C       G(T4,N486,FULL)

C       G(T4,N487,FULL)

C       G(T4,N502,FULL)
        CALL xB012345_(S34,XMQM2(I),XMQM2(I),B0,B1,B2,B3,B4,B5,2,0)

        PRE = (QF(3)*ALPHA*CBA*PZ12*PZ34*XMZ*(3D0-4D0*XSW2)*(-(6D0*
     &  B1(1))-6D0*B2(1,1)-(12D0*B2(0,0))/S34+(6D0*B0*XMQM2(I))/S34-
     &  ((S34-6D0*XMQM2(I)))/S34))/(144D0*PI*XCW*XCW2*XSW)

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE
        F(1,1,1) = F(1,1,1)+2D0*QF(1)*PRE

C       G(T4,N503,FULL)
        CALL xB012345_(S34,XMQP2(I),XMQP2(I),B0,B1,B2,B3,B4,B5,2,0)

        PRE = (QF(3)*ALPHA*CBA*PZ12*PZ34*XMZ*(3D0-8D0*XSW2)*(-(6D0*
     &  B1(1))-6D0*B2(1,1)-(12D0*B2(0,0))/S34+(6D0*B0*XMQP2(I))/S34-
     &  ((S34-6D0*XMQP2(I)))/S34))/(72D0*PI*XCW*XCW2*XSW)

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE
        F(1,1,1) = F(1,1,1)+2D0*QF(1)*PRE

C       G(T4,N504,FULL)
        CALL xB012345_(S34,XML2(I),XML2(I),B0,B1,B2,B3,B4,B5,2,0)

        PRE = (QF(3)*ALPHA*CBA*PZ12*PZ34*XMZ*(1D0-2D0*XSW)*(1D0+2D0*
     &  XSW)*(-(6D0*B1(1))-6D0*B2(1,1)-(12D0*B2(0,0))/S34+(6D0*B0*
     &  XML2(I))/S34-((S34-6D0*XML2(I)))/S34))/(48D0*PI*XCW*XCW2*
     &  XSW)

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE
        F(1,1,1) = F(1,1,1)+2D0*QF(1)*PRE

C       G(T4,N516,FULL)
        CALL xB012345_(S34,XMQM2(I),XMQM2(I),B0,B1,B2,B3,B4,B5,2,0)
        K(1) = 9D0-12D0*XSW2+8D0*XSW2**2
        K(2) = (12D0*B2(0,0)*(9D0-12D0*XSW2+8D0*XSW2**2))/XSW2+(6D0*
     &  B1(1)*S34*(9D0-12D0*XSW2+8D0*XSW2**2))/XSW2+(6D0*B2(1,1)*
     &  S34*(9D0-12D0*XSW2+8D0*XSW2**2))/XSW2+24D0*B0*(3D0-2D0*
     &  XSW2)*XMQM2(I)+((9D0-12D0*XSW2+8D0*XSW2**2)*(S34-6D0*
     &  XMQM2(I)))/XSW2

        PRE = (ALPHA*CBA*PZ12*PZ34**2*XCW2**(-2)*XMZ)/(576D0*PI*XCW)

        F(1,-1,-1) = F(1,-1,-1)-(K(2)*PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+
     &  2D0*QF(3)*XSW2))/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*K(2)*QF(3)*PRE*(1D0-2D0*QF(1)*
     &  XSW2))/XSW
        F(1,1,-1) = F(1,1,-1)+(2D0*K(2)*QF(1)*PRE*(1D0+2D0*QF(3)*
     &  XSW2))/XSW
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*((12D0*B2(0,0)*
     &  K(1))/XSW+(6D0*B1(1)*K(1)*S34)/XSW+(6D0*B2(1,1)*K(1)*S34)/
     &  XSW+24D0*B0*XSW*(3D0-2D0*XSW2)*XMQM2(I)+(K(1)*(S34-6D0*
     &  XMQM2(I)))/XSW)

C       G(T4,N517,FULL)
        CALL xB012345_(S34,XMQP2(I),XMQP2(I),B0,B1,B2,B3,B4,B5,2,0)
        K(1) = 9D0-24D0*XSW2+32D0*XSW2**2
        K(2) = (12D0*B2(0,0)*(9D0-24D0*XSW2+32D0*XSW2**2))/XSW2+
     &  (6D0*B1(1)*S34*(9D0-24D0*XSW2+32D0*XSW2**2))/XSW2+(6D0*B2(1,
     &  1)*S34*(9D0-24D0*XSW2+32D0*XSW2**2))/XSW2+48D0*B0*(3D0-4D0*
     &  XSW2)*XMQP2(I)+((9D0-24D0*XSW2+32D0*XSW2**2)*(S34-6D0*
     &  XMQP2(I)))/XSW2

        PRE = (ALPHA*CBA*PZ12*PZ34**2*XCW2**(-2)*XMZ)/(576D0*PI*XCW)

        F(1,-1,-1) = F(1,-1,-1)-(K(2)*PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+
     &  2D0*QF(3)*XSW2))/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*K(2)*QF(3)*PRE*(1D0-2D0*QF(1)*
     &  XSW2))/XSW
        F(1,1,-1) = F(1,1,-1)+(2D0*K(2)*QF(1)*PRE*(1D0+2D0*QF(3)*
     &  XSW2))/XSW
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*((12D0*B2(0,0)*
     &  K(1))/XSW+(6D0*B1(1)*K(1)*S34)/XSW+(6D0*B2(1,1)*K(1)*S34)/
     &  XSW+48D0*B0*XSW*(3D0-4D0*XSW2)*XMQP2(I)+(K(1)*(S34-6D0*
     &  XMQP2(I)))/XSW)

C       G(T4,N518,FULL)
        CALL xB012345_(S34,NULL,NULL,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (ALPHA*CBA*PZ12*PZ34**2*(12D0*B2(0,0)+S34+6D0*B1(1)*
     &  S34+6D0*B2(1,1)*S34)*XCW2**(-2)*XMZ)/(192D0*PI*XCW*XSW)

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T4,N519,FULL)
        CALL xB012345_(S34,XML2(I),XML2(I),B0,B1,B2,B3,B4,B5,2,0)
        K(1) = 1D0-4D0*XSW2+8D0*XSW2**2
        K(2) = (12D0*B2(0,0)*(1D0-4D0*XSW2+8D0*XSW2**2))/XSW2+(6D0*
     &  B1(1)*S34*(1D0-4D0*XSW2+8D0*XSW2**2))/XSW2+(6D0*B2(1,1)*S34*
     &  (1D0-4D0*XSW2+8D0*XSW2**2))/XSW2+24D0*B0*(1D0-2D0*XSW2)*
     &  XML2(I)+((1D0-4D0*XSW2+8D0*XSW2**2)*(S34-6D0*XML2(I)))/XSW2

        PRE = (ALPHA*CBA*PZ12*PZ34**2*XCW2**(-2)*XMZ)/(192D0*PI*XCW)

        F(1,-1,-1) = F(1,-1,-1)-(K(2)*PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+
     &  2D0*QF(3)*XSW2))/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*K(2)*QF(3)*PRE*(1D0-2D0*QF(1)*
     &  XSW2))/XSW
        F(1,1,-1) = F(1,1,-1)+(2D0*K(2)*QF(1)*PRE*(1D0+2D0*QF(3)*
     &  XSW2))/XSW
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*((12D0*B2(0,0)*
     &  K(1))/XSW+(6D0*B1(1)*K(1)*S34)/XSW+(6D0*B2(1,1)*K(1)*S34)/
     &  XSW+24D0*B0*XSW*(1D0-2D0*XSW2)*XML2(I)+(K(1)*(S34-6D0*
     &  XML2(I)))/XSW)

100	continue

	end

**********************************************************************
        subroutine  HHtoZZ1133_vert_ferm_thdm(F,pz12,pz34)
**********************************************************************
*       self-energy contributions for HH -> ZZ -> uudd in the THDM
*       closed fermion loops
*---------------------------------------------------------------------
*       24.4.16 Stefan Dittmaier
**********************************************************************
	implicit none
	complex*16 pre,F(13,-1:1,-1:1),pz12,pz34
	complex*16 A0,xA0_,B0_,xB0_,DB0_,xDB0_,B1_,xB1_,DB1_,xDB1_
        complex*16 B0,B1(1),B2(0:2,0:2),B3(0:2,0:2,2)
        complex*16 B4(0:2,0:2,0:2,0:2),B5(0:2,0:2,0:2,0:2,2)
        complex*16 C0_,C0,C1(2),C2(0:2,0:2),C3(0:2,0:2,2)
        complex*16 C4(0:2,0:2,0:2,0:2)
	complex*16 D0,D1(3),D2(0:3,0:3),D3(0:3,0:3,3)
        complex*16 D4(0:3,0:3,0:3,0:3),D5(0:3,0:3,0:3,0:3,3)
	complex*16 E0n,E1n(4),E2n(0:4,0:4),E3n(0:4,0:4,4)
	complex*16 E4n(0:4,0:4,0:4,0:4)
        COMPLEX*16 K(17)
	real *8 qeps
	integer i

c mandelstam variables
      	real*8 s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
      	common/mandel/s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
c fermion charges of isospin duplets
	real*8 qf(4)
	common/fcharge/qf
c fermion masses as flag (i*1d-20)
      	complex*16 cme2,cmf2(5)
      	real*8 me2,rme2,mf2(5),rmf2(5)
      	common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2
	include '../COMMON/param.inc'
	include '../COMMON/xparam.inc'
        include '../COMMON/param_thdm.inc'
        include '../COMMON/param_bsm.inc'

	qeps = 1d0

	do 100 i=1,3

C       Process: S2F21aF21F23aF23,   Model: THDM

C       G(T9,N1505,FULL)

C       G(T9,N1506,FULL)

C       G(T9,N1507,FULL)

C       G(T9,N1508,FULL)

C       G(T9,N1509,FULL)

C       G(T9,N1510,FULL)

C       G(T9,N1511,FULL)

C       G(T9,N1512,FULL)

C       G(T9,N1513,FULL)

C       G(T9,N1514,FULL)

C       G(T9,N1515,FULL)

C       G(T9,N1516,FULL)

C       G(T9,N1517,FULL)

C       G(T9,N1518,FULL)

C       G(T9,N1525,FULL)

C       G(T9,N1526,FULL)

C       G(T9,N1527,FULL)

C       G(T9,N1528,FULL)

C       G(T9,N1529,FULL)

C       G(T9,N1530,FULL)

C       G(T9,N1531,FULL)

C       G(T9,N1532,FULL)

C       G(T9,N1533,FULL)

C       G(T9,N1534,FULL)

C       G(T9,N1535,FULL)

C       G(T9,N1536,FULL)

C       G(T9,N1537,FULL)

C       G(T9,N1538,FULL)

C       G(T9,N1545,FULL)

C       G(T9,N1546,FULL)

C       G(T9,N1547,FULL)

C       G(T9,N1548,FULL)

C       G(T9,N1549,FULL)

C       G(T9,N1550,FULL)

C       G(T9,N1551,FULL)

C       G(T9,N1552,FULL)

C       G(T9,N1553,FULL)

C       G(T9,N1554,FULL)

C       G(T9,N1555,FULL)

C       G(T9,N1556,FULL)

C       G(T9,N1557,FULL)

C       G(T9,N1558,FULL)

C       G(T9,N1571,FULL)

C       G(T9,N1572,FULL)

C       G(T9,N1573,FULL)

C       G(T9,N1574,FULL)

C       G(T9,N1575,FULL)

C       G(T9,N1576,FULL)

C       G(T9,N1577,FULL)

C       G(T9,N1578,FULL)

C       G(T9,N1579,FULL)

C       G(T9,N1580,FULL)

C       G(T9,N1581,FULL)

C       G(T9,N1582,FULL)

C       G(T9,N1583,FULL)

C       G(T9,N1584,FULL)

C       G(T9,N1601,FULL)

C       G(T9,N1602,FULL)

C       G(T9,N1603,FULL)

C       G(T9,N1604,FULL)

C       G(T9,N1605,FULL)

C       G(T9,N1606,FULL)

C       G(T9,N1607,FULL)

C       G(T9,N1608,FULL)

C       G(T9,N1609,FULL)

C       G(T9,N1610,FULL)

C       G(T9,N1611,FULL)

C       G(T9,N1612,FULL)

C       G(T9,N1613,FULL)

C       G(T9,N1614,FULL)

C       G(T9,N1625,FULL)

C       G(T9,N1626,FULL)

C       G(T9,N1627,FULL)

C       G(T9,N1628,FULL)

C       G(T9,N1629,FULL)

C       G(T9,N1630,FULL)

C       G(T9,N1631,FULL)

C       G(T9,N1632,FULL)

C       G(T9,N1633,FULL)

C       G(T9,N1634,FULL)

C       G(T9,N1635,FULL)

C       G(T9,N1636,FULL)

C       G(T9,N1637,FULL)

C       G(T9,N1638,FULL)

C       G(T9,N1649,FULL)

C       G(T9,N1650,FULL)

C       G(T9,N1651,FULL)

C       G(T9,N1652,FULL)

C       G(T9,N1653,FULL)

C       G(T9,N1654,FULL)

C       G(T9,N1655,FULL)

C       G(T9,N1656,FULL)

C       G(T9,N1657,FULL)

C       G(T9,N1658,FULL)

C       G(T9,N1659,FULL)

C       G(T9,N1660,FULL)

C       G(T9,N1661,FULL)

C       G(T9,N1662,FULL)

C       G(T9,N1669,FULL)

C       G(T9,N1670,FULL)

C       G(T9,N1671,FULL)

C       G(T9,N1672,FULL)

C       G(T9,N1673,FULL)

C       G(T9,N1674,FULL)

C       G(T9,N1675,FULL)

C       G(T9,N1676,FULL)

C       G(T9,N1677,FULL)

C       G(T9,N1678,FULL)

C       G(T9,N1679,FULL)

C       G(T9,N1680,FULL)

C       G(T9,N1681,FULL)

C       G(T9,N1682,FULL)

C       G(T9,N1689,FULL)

C       G(T9,N1690,FULL)

C       G(T9,N1691,FULL)

C       G(T9,N1692,FULL)

C       G(T9,N1693,FULL)

C       G(T9,N1694,FULL)

C       G(T9,N1695,FULL)

C       G(T9,N1696,FULL)

C       G(T9,N1697,FULL)

C       G(T9,N1698,FULL)

C       G(T9,N1699,FULL)

C       G(T9,N1700,FULL)

C       G(T9,N1701,FULL)

C       G(T9,N1702,FULL)

C       G(T9,N1715,FULL)

C       G(T9,N1716,FULL)

C       G(T9,N1717,FULL)

C       G(T9,N1718,FULL)

C       G(T9,N1719,FULL)

C       G(T9,N1720,FULL)

C       G(T9,N1721,FULL)

C       G(T9,N1722,FULL)

C       G(T9,N1723,FULL)

C       G(T9,N1724,FULL)

C       G(T9,N1725,FULL)

C       G(T9,N1726,FULL)

C       G(T9,N1727,FULL)

C       G(T9,N1728,FULL)

C       G(T9,N1745,FULL)

C       G(T9,N1746,FULL)

C       G(T9,N1747,FULL)

C       G(T9,N1748,FULL)

C       G(T9,N1749,FULL)

C       G(T9,N1750,FULL)

C       G(T9,N1751,FULL)

C       G(T9,N1752,FULL)

C       G(T9,N1753,FULL)

C       G(T9,N1754,FULL)

C       G(T9,N1755,FULL)

C       G(T9,N1756,FULL)

C       G(T9,N1757,FULL)

C       G(T9,N1758,FULL)

C       G(T9,N1769,FULL)

C       G(T9,N1770,FULL)

C       G(T9,N1771,FULL)

C       G(T9,N1772,FULL)

C       G(T9,N1773,FULL)

C       G(T9,N1774,FULL)

C       G(T9,N1775,FULL)

C       G(T9,N1776,FULL)

C       G(T9,N1777,FULL)

C       G(T9,N1778,FULL)

C       G(T9,N1779,FULL)

C       G(T9,N1780,FULL)

C       G(T9,N1781,FULL)

C       G(T9,N1782,FULL)

C       G(T9,N1793,FULL)

C       G(T9,N1794,FULL)

C       G(T9,N1795,FULL)

C       G(T9,N1796,FULL)

C       G(T9,N1797,FULL)

C       G(T9,N1798,FULL)

C       G(T9,N1799,FULL)

C       G(T9,N1800,FULL)

C       G(T9,N1801,FULL)

C       G(T9,N1802,FULL)

C       G(T9,N1803,FULL)

C       G(T9,N1804,FULL)

C       G(T9,N1805,FULL)

C       G(T9,N1806,FULL)

C       G(T9,N1819,FULL)

C       G(T9,N1820,FULL)

C       G(T9,N1821,FULL)

C       G(T9,N1822,FULL)

C       G(T9,N1823,FULL)

C       G(T9,N1824,FULL)

C       G(T9,N1825,FULL)

C       G(T9,N1826,FULL)

C       G(T9,N1827,FULL)

C       G(T9,N1828,FULL)

C       G(T9,N1829,FULL)

C       G(T9,N1830,FULL)

C       G(T9,N1831,FULL)

C       G(T9,N1832,FULL)

C       G(T9,N1845,FULL)

C       G(T9,N1846,FULL)

C       G(T9,N1847,FULL)

C       G(T9,N1848,FULL)

C       G(T9,N1849,FULL)

C       G(T9,N1850,FULL)

C       G(T9,N1851,FULL)

C       G(T9,N1852,FULL)

C       G(T9,N1853,FULL)

C       G(T9,N1854,FULL)

C       G(T9,N1855,FULL)

C       G(T9,N1856,FULL)

C       G(T9,N1857,FULL)

C       G(T9,N1858,FULL)

C       G(T9,N1867,FULL)

C       G(T9,N1868,FULL)

C       G(T9,N1869,FULL)

C       G(T9,N1870,FULL)

C       G(T9,N1871,FULL)

C       G(T9,N1872,FULL)

C       G(T9,N1873,FULL)

C       G(T9,N1874,FULL)

C       G(T9,N1875,FULL)

C       G(T9,N1876,FULL)

C       G(T9,N1877,FULL)

C       G(T9,N1878,FULL)

C       G(T9,N1879,FULL)

C       G(T9,N1880,FULL)

C       G(T9,N1885,FULL)

C       G(T9,N1886,FULL)

C       G(T9,N1887,FULL)

C       G(T9,N1888,FULL)

C       G(T9,N1889,FULL)

C       G(T9,N1890,FULL)

C       G(T9,N1891,FULL)

C       G(T9,N1892,FULL)

C       G(T9,N1893,FULL)

C       G(T9,N1894,FULL)

C       G(T9,N1895,FULL)

C       G(T9,N1896,FULL)

C       G(T9,N1897,FULL)

C       G(T9,N1898,FULL)

C       G(T9,N1903,FULL)

C       G(T9,N1904,FULL)

C       G(T9,N1905,FULL)

C       G(T9,N1906,FULL)

C       G(T9,N1907,FULL)

C       G(T9,N1908,FULL)

C       G(T9,N1909,FULL)

C       G(T9,N1910,FULL)

C       G(T9,N1911,FULL)

C       G(T9,N1912,FULL)

C       G(T9,N1913,FULL)

C       G(T9,N1914,FULL)

C       G(T9,N1915,FULL)

C       G(T9,N1916,FULL)

C       G(T9,N1921,FULL)

C       G(T9,N1922,FULL)

C       G(T9,N1923,FULL)

C       G(T9,N1924,FULL)

C       G(T9,N1925,FULL)

C       G(T9,N1926,FULL)

C       G(T9,N1927,FULL)

C       G(T9,N1928,FULL)

C       G(T9,N1929,FULL)

C       G(T9,N1930,FULL)

C       G(T9,N1931,FULL)

C       G(T9,N1932,FULL)

C       G(T9,N1933,FULL)

C       G(T9,N1934,FULL)

C       G(T9,N1951,FULL)

C       G(T9,N1952,FULL)

C       G(T9,N1953,FULL)

C       G(T9,N1954,FULL)

C       G(T9,N1955,FULL)

C       G(T9,N1956,FULL)

C       G(T9,N1957,FULL)

C       G(T9,N1958,FULL)

C       G(T9,N1959,FULL)

C       G(T9,N1960,FULL)

C       G(T9,N1961,FULL)

C       G(T9,N1962,FULL)

C       G(T9,N1963,FULL)

C       G(T9,N1964,FULL)

C       G(T9,N1981,FULL)

C       G(T9,N1982,FULL)

C       G(T9,N1983,FULL)

C       G(T9,N1984,FULL)

C       G(T9,N1985,FULL)

C       G(T9,N1986,FULL)

C       G(T9,N1987,FULL)

C       G(T9,N1988,FULL)

C       G(T9,N1989,FULL)

C       G(T9,N1990,FULL)

C       G(T9,N1991,FULL)

C       G(T9,N1992,FULL)

C       G(T9,N1993,FULL)

C       G(T9,N1994,FULL)

C       G(T9,N1999,FULL)

C       G(T9,N2000,FULL)

C       G(T9,N2001,FULL)

C       G(T9,N2002,FULL)

C       G(T9,N2003,FULL)

C       G(T9,N2004,FULL)

C       G(T9,N2005,FULL)

C       G(T9,N2006,FULL)

C       G(T9,N2007,FULL)

C       G(T9,N2008,FULL)

C       G(T9,N2009,FULL)

C       G(T9,N2010,FULL)

C       G(T9,N2011,FULL)

C       G(T9,N2012,FULL)

C       G(T9,N2021,FULL)

C       G(T9,N2022,FULL)

C       G(T9,N2023,FULL)

C       G(T9,N2024,FULL)

C       G(T9,N2025,FULL)

C       G(T9,N2026,FULL)

C       G(T9,N2027,FULL)

C       G(T9,N2028,FULL)

C       G(T9,N2029,FULL)

C       G(T9,N2030,FULL)

C       G(T9,N2031,FULL)

C       G(T9,N2032,FULL)

C       G(T9,N2033,FULL)

C       G(T9,N2034,FULL)

C       G(T9,N2047,FULL)

C       G(T9,N2048,FULL)

C       G(T9,N2049,FULL)

C       G(T9,N2050,FULL)

C       G(T9,N2051,FULL)

C       G(T9,N2052,FULL)

C       G(T9,N2053,FULL)

C       G(T9,N2054,FULL)

C       G(T9,N2055,FULL)

C       G(T9,N2056,FULL)

C       G(T9,N2057,FULL)

C       G(T9,N2058,FULL)

C       G(T9,N2059,FULL)

C       G(T9,N2060,FULL)

C       G(T9,N2073,FULL)

C       G(T9,N2074,FULL)

C       G(T9,N2075,FULL)

C       G(T9,N2076,FULL)

C       G(T9,N2077,FULL)

C       G(T9,N2078,FULL)

C       G(T9,N2079,FULL)

C       G(T9,N2080,FULL)

C       G(T9,N2081,FULL)

C       G(T9,N2082,FULL)

C       G(T9,N2083,FULL)

C       G(T9,N2084,FULL)

C       G(T9,N2085,FULL)

C       G(T9,N2086,FULL)

C       G(T9,N2097,FULL)

C       G(T9,N2098,FULL)

C       G(T9,N2099,FULL)

C       G(T9,N2100,FULL)

C       G(T9,N2101,FULL)

C       G(T9,N2102,FULL)

C       G(T9,N2103,FULL)

C       G(T9,N2104,FULL)

C       G(T9,N2105,FULL)

C       G(T9,N2106,FULL)

C       G(T9,N2107,FULL)

C       G(T9,N2108,FULL)

C       G(T9,N2109,FULL)

C       G(T9,N2110,FULL)

C       G(T9,N2121,FULL)

C       G(T9,N2122,FULL)

C       G(T9,N2123,FULL)

C       G(T9,N2124,FULL)

C       G(T9,N2125,FULL)

C       G(T9,N2126,FULL)

C       G(T9,N2127,FULL)

C       G(T9,N2128,FULL)

C       G(T9,N2129,FULL)

C       G(T9,N2130,FULL)

C       G(T9,N2131,FULL)

C       G(T9,N2132,FULL)

C       G(T9,N2133,FULL)

C       G(T9,N2134,FULL)

C       G(T9,N2139,FULL)

C       G(T9,N2140,FULL)

C       G(T9,N2141,FULL)

C       G(T9,N2142,FULL)

C       G(T9,N2143,FULL)

C       G(T9,N2144,FULL)

C       G(T9,N2145,FULL)

C       G(T9,N2146,FULL)

C       G(T9,N2147,FULL)

C       G(T9,N2148,FULL)

C       G(T9,N2149,FULL)

C       G(T9,N2150,FULL)

C       G(T9,N2151,FULL)

C       G(T9,N2152,FULL)

C       G(T9,N2165,FULL)

C       G(T9,N2166,FULL)

C       G(T9,N2167,FULL)

C       G(T9,N2168,FULL)

C       G(T9,N2169,FULL)
        CALL xC01234_(S12,MHH2,S34,XMQM2(I),XMQM2(I),XMQM2(I),C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,0)
        K(1) = -(4D0*C2(1,2))+C0
        K(2) = S13+S14+S23+S24
        K(3) = S13+S14+S23+S24-2D0*XMQM2(I)
        K(4) = -((2D0*C2(2,2))/S12)-(2D0*C2(1,1))/S34+1/(S12*S34)+
     &  (2D0*C2(1,2)*(S13+S14+S23+S24))/(S12*S34)-(C0*(S13+S14+S23+
     &  S24-2D0*XMQM2(I)))/(S12*S34)

        PRE = -((QF(1)*QF(3)*ALPHA*CDOH*XMQM2(I))/(12D0*PI*XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)+K(4)*PRE
        F(1,-1,1) = F(1,-1,1)+K(4)*PRE
        F(1,1,-1) = F(1,1,-1)+K(4)*PRE
        F(1,1,1) = F(1,1,1)+K(4)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(5,-1,1) = F(5,-1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(5,1,-1) = F(5,1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(5,1,1) = F(5,1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(6,-1,-1) = F(6,-1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(6,-1,1) = F(6,-1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(6,1,-1) = F(6,1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(6,1,1) = F(6,1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(7,-1,1) = F(7,-1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(7,1,-1) = F(7,1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(7,1,1) = F(7,1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(8,-1,1) = F(8,-1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(8,1,-1) = F(8,1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(8,1,1) = F(8,1,1)+(2D0*K(1)*PRE)/(S12*S34)

C       G(T9,N2170,FULL)
        CALL xC01234_(S12,MHH2,S34,XMQP2(I),XMQP2(I),XMQP2(I),C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,0)
        K(1) = -(4D0*C2(1,2))+C0
        K(2) = S13+S14+S23+S24
        K(3) = S13+S14+S23+S24-2D0*XMQP2(I)
        K(4) = -((2D0*C2(2,2))/S12)-(2D0*C2(1,1))/S34+1/(S12*S34)+
     &  (2D0*C2(1,2)*(S13+S14+S23+S24))/(S12*S34)-(C0*(S13+S14+S23+
     &  S24-2D0*XMQP2(I)))/(S12*S34)

        PRE = -((QF(1)*QF(3)*ALPHA*CUPH*XMQP2(I))/(3D0*PI*XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)+K(4)*PRE
        F(1,-1,1) = F(1,-1,1)+K(4)*PRE
        F(1,1,-1) = F(1,1,-1)+K(4)*PRE
        F(1,1,1) = F(1,1,1)+K(4)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(5,-1,1) = F(5,-1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(5,1,-1) = F(5,1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(5,1,1) = F(5,1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(6,-1,-1) = F(6,-1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(6,-1,1) = F(6,-1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(6,1,-1) = F(6,1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(6,1,1) = F(6,1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(7,-1,1) = F(7,-1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(7,1,-1) = F(7,1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(7,1,1) = F(7,1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(8,-1,1) = F(8,-1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(8,1,-1) = F(8,1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(8,1,1) = F(8,1,1)+(2D0*K(1)*PRE)/(S12*S34)

C       G(T9,N2171,FULL)
        CALL xC01234_(S12,MHH2,S34,XML2(I),XML2(I),XML2(I),C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,2,0)
        K(1) = -(4D0*C2(1,2))+C0
        K(2) = S13+S14+S23+S24
        K(3) = S13+S14+S23+S24-2D0*XML2(I)
        K(4) = -((2D0*C2(2,2))/S12)-(2D0*C2(1,1))/S34+1/(S12*S34)+
     &  (2D0*C2(1,2)*(S13+S14+S23+S24))/(S12*S34)-(C0*(S13+S14+S23+
     &  S24-2D0*XML2(I)))/(S12*S34)

        PRE = -((QF(1)*QF(3)*ALPHA*CLEPH*XML2(I))/(4D0*PI*XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)+K(4)*PRE
        F(1,-1,1) = F(1,-1,1)+K(4)*PRE
        F(1,1,-1) = F(1,1,-1)+K(4)*PRE
        F(1,1,1) = F(1,1,1)+K(4)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(5,-1,1) = F(5,-1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(5,1,-1) = F(5,1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(5,1,1) = F(5,1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(6,-1,-1) = F(6,-1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(6,-1,1) = F(6,-1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(6,1,-1) = F(6,1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(6,1,1) = F(6,1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(7,-1,1) = F(7,-1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(7,1,-1) = F(7,1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(7,1,1) = F(7,1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(8,-1,1) = F(8,-1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(8,1,-1) = F(8,1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(8,1,1) = F(8,1,1)+(2D0*K(1)*PRE)/(S12*S34)

C       G(T9,N2172,FULL)
        CALL xC01234_(S12,MHH2,S34,XML2(I),XML2(I),XML2(I),C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,2,0)
        K(1) = -(4D0*C2(1,2))+C0
        K(2) = S13+S14+S23+S24
        K(3) = S13+S14+S23+S24-2D0*XML2(I)
        K(4) = -((2D0*C2(2,2))/S12)-(2D0*C2(1,1))/S34+1/(S12*S34)+
     &  (2D0*C2(1,2)*(S13+S14+S23+S24))/(S12*S34)-(C0*(S13+S14+S23+
     &  S24-2D0*XML2(I)))/(S12*S34)

        PRE = -((QF(1)*QF(3)*ALPHA*CLEPH*XML2(I))/(4D0*PI*XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)+K(4)*PRE
        F(1,-1,1) = F(1,-1,1)+K(4)*PRE
        F(1,1,-1) = F(1,1,-1)+K(4)*PRE
        F(1,1,1) = F(1,1,1)+K(4)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(5,-1,1) = F(5,-1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(5,1,-1) = F(5,1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(5,1,1) = F(5,1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(6,-1,-1) = F(6,-1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(6,-1,1) = F(6,-1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(6,1,-1) = F(6,1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(6,1,1) = F(6,1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(7,-1,1) = F(7,-1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(7,1,-1) = F(7,1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(7,1,1) = F(7,1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(8,-1,1) = F(8,-1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(8,1,-1) = F(8,1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(8,1,1) = F(8,1,1)+(2D0*K(1)*PRE)/(S12*S34)

C       G(T9,N2173,FULL)
        CALL xC01234_(S12,MHH2,S34,XMQP2(I),XMQP2(I),XMQP2(I),C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,0)
        K(1) = -(4D0*C2(1,2))+C0
        K(2) = S13+S14+S23+S24
        K(3) = S13+S14+S23+S24-2D0*XMQP2(I)
        K(4) = -((2D0*C2(2,2))/S12)-(2D0*C2(1,1))/S34+1/(S12*S34)+
     &  (2D0*C2(1,2)*(S13+S14+S23+S24))/(S12*S34)-(C0*(S13+S14+S23+
     &  S24-2D0*XMQP2(I)))/(S12*S34)

        PRE = -((QF(1)*QF(3)*ALPHA*CUPH*XMQP2(I))/(3D0*PI*XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)+K(4)*PRE
        F(1,-1,1) = F(1,-1,1)+K(4)*PRE
        F(1,1,-1) = F(1,1,-1)+K(4)*PRE
        F(1,1,1) = F(1,1,1)+K(4)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(5,-1,1) = F(5,-1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(5,1,-1) = F(5,1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(5,1,1) = F(5,1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(6,-1,-1) = F(6,-1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(6,-1,1) = F(6,-1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(6,1,-1) = F(6,1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(6,1,1) = F(6,1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(7,-1,1) = F(7,-1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(7,1,-1) = F(7,1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(7,1,1) = F(7,1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(8,-1,1) = F(8,-1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(8,1,-1) = F(8,1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(8,1,1) = F(8,1,1)+(2D0*K(1)*PRE)/(S12*S34)

C       G(T9,N2174,FULL)
        CALL xC01234_(S12,MHH2,S34,XMQM2(I),XMQM2(I),XMQM2(I),C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,0)
        K(1) = -(4D0*C2(1,2))+C0
        K(2) = S13+S14+S23+S24
        K(3) = S13+S14+S23+S24-2D0*XMQM2(I)
        K(4) = -((2D0*C2(2,2))/S12)-(2D0*C2(1,1))/S34+1/(S12*S34)+
     &  (2D0*C2(1,2)*(S13+S14+S23+S24))/(S12*S34)-(C0*(S13+S14+S23+
     &  S24-2D0*XMQM2(I)))/(S12*S34)

        PRE = -((QF(1)*QF(3)*ALPHA*CDOH*XMQM2(I))/(12D0*PI*XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)+K(4)*PRE
        F(1,-1,1) = F(1,-1,1)+K(4)*PRE
        F(1,1,-1) = F(1,1,-1)+K(4)*PRE
        F(1,1,1) = F(1,1,1)+K(4)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(5,-1,1) = F(5,-1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(5,1,-1) = F(5,1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(5,1,1) = F(5,1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(6,-1,-1) = F(6,-1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(6,-1,1) = F(6,-1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(6,1,-1) = F(6,1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(6,1,1) = F(6,1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(7,-1,1) = F(7,-1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(7,1,-1) = F(7,1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(7,1,1) = F(7,1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(8,-1,1) = F(8,-1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(8,1,-1) = F(8,1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(8,1,1) = F(8,1,1)+(2D0*K(1)*PRE)/(S12*S34)

C       G(T9,N2175,FULL)

C       G(T9,N2176,FULL)

C       G(T9,N2177,FULL)

C       G(T9,N2178,FULL)

C       G(T9,N2185,FULL)

C       G(T9,N2186,FULL)

C       G(T9,N2187,FULL)

C       G(T9,N2188,FULL)

C       G(T9,N2189,FULL)
        CALL xC01234_(S12,MHH2,S34,XMQM2(I),XMQM2(I),XMQM2(I),C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,0)
        K(1) = 1D0+2D0*QF(3)*XSW2
        K(2) = 3D0-4D0*XSW2
        K(3) = 3D0-3D0*QEPS-4D0*XSW2
        K(4) = 3D0+3D0*QEPS-4D0*XSW2
        K(5) = -(6D0*C1(2)*QEPS)-4D0*C2(1,2)*(3D0-4D0*XSW2)+C0*(3D0-
     &  3D0*QEPS-4D0*XSW2)
        K(6) = 6D0*C1(2)*QEPS-4D0*C2(1,2)*(3D0-4D0*XSW2)+C0*(3D0+
     &  3D0*QEPS-4D0*XSW2)
        K(7) = S13+S14-S23-S24
        K(8) = S13+S14+S23+S24
        K(9) = -((6D0*C1(2)*QEPS*(S13+S14-S23-S24))/S12)-2D0*C2(1,
     &  1)*(3D0-4D0*XSW2)+(3D0-4D0*XSW2)/S12+(2D0*C2(1,2)*(S13+S14+
     &  S23+S24)*(3D0-4D0*XSW2))/S12-(2D0*C2(2,2)*S34*(3D0-4D0*
     &  XSW2))/S12+(C0*(-(3D0*S13)-3D0*QEPS*S13-3D0*S14-3D0*QEPS*
     &  S14-3D0*S23+3D0*QEPS*S23-3D0*S24+3D0*QEPS*S24+4D0*S13*XSW2+
     &  4D0*S14*XSW2+4D0*S23*XSW2+4D0*S24*XSW2+6D0*XMQM2(I)-8D0*
     &  XSW2*XMQM2(I)))/S12
        K(10) = (6D0*C1(2)*QEPS*(S13+S14-S23-S24))/S12-2D0*C2(1,1)*
     &  (3D0-4D0*XSW2)+(3D0-4D0*XSW2)/S12+(2D0*C2(1,2)*(S13+S14+S23+
     &  S24)*(3D0-4D0*XSW2))/S12-(2D0*C2(2,2)*S34*(3D0-4D0*XSW2))/
     &  S12+(C0*(-(3D0*S13)+3D0*QEPS*S13-3D0*S14+3D0*QEPS*S14-3D0*
     &  S23-3D0*QEPS*S23-3D0*S24-3D0*QEPS*S24+4D0*S13*XSW2+4D0*S14*
     &  XSW2+4D0*S23*XSW2+4D0*S24*XSW2+6D0*XMQM2(I)-8D0*XSW2*
     &  XMQM2(I)))/S12
        K(11) = -(3D0*S13)-3D0*QEPS*S13-3D0*S14-3D0*QEPS*S14-3D0*
     &  S23+3D0*QEPS*S23-3D0*S24+3D0*QEPS*S24+4D0*S13*XSW2+4D0*S14*
     &  XSW2+4D0*S23*XSW2+4D0*S24*XSW2+6D0*XMQM2(I)-8D0*XSW2*
     &  XMQM2(I)
        K(12) = -(3D0*S13)+3D0*QEPS*S13-3D0*S14+3D0*QEPS*S14-3D0*
     &  S23-3D0*QEPS*S23-3D0*S24-3D0*QEPS*S24+4D0*S13*XSW2+4D0*S14*
     &  XSW2+4D0*S23*XSW2+4D0*S24*XSW2+6D0*XMQM2(I)-8D0*XSW2*
     &  XMQM2(I)

        PRE = (QF(1)*ALPHA*CDOH*PZ34*XMQM2(I))/(96D0*PI*XCW2*XMW*
     &  XSW)

        F(1,-1,-1) = F(1,-1,-1)+(K(1)*K(9)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*K(9)*QF(3)*PRE
        F(1,1,-1) = F(1,1,-1)+(K(1)*K(10)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+2D0*K(10)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(1)*K(6)*PRE)/(S12*XSW2)
        F(5,-1,1) = F(5,-1,1)+(4D0*K(6)*QF(3)*PRE)/S12
        F(5,1,-1) = F(5,1,-1)+(2D0*K(1)*K(5)*PRE)/(S12*XSW2)
        F(5,1,1) = F(5,1,1)+(4D0*K(5)*QF(3)*PRE)/S12
        F(6,-1,-1) = F(6,-1,-1)+(2D0*K(1)*K(5)*PRE)/(S12*XSW2)
        F(6,-1,1) = F(6,-1,1)+(4D0*K(5)*QF(3)*PRE)/S12
        F(6,1,-1) = F(6,1,-1)+(2D0*K(1)*K(6)*PRE)/(S12*XSW2)
        F(6,1,1) = F(6,1,1)+(4D0*K(6)*QF(3)*PRE)/S12
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(1)*K(6)*PRE)/(S12*XSW2)
        F(7,-1,1) = F(7,-1,1)+(4D0*K(6)*QF(3)*PRE)/S12
        F(7,1,-1) = F(7,1,-1)+(2D0*K(1)*K(5)*PRE)/(S12*XSW2)
        F(7,1,1) = F(7,1,1)+(4D0*K(5)*QF(3)*PRE)/S12
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(1)*K(5)*PRE)/(S12*XSW2)
        F(8,-1,1) = F(8,-1,1)+(4D0*K(5)*QF(3)*PRE)/S12
        F(8,1,-1) = F(8,1,-1)+(2D0*K(1)*K(6)*PRE)/(S12*XSW2)
        F(8,1,1) = F(8,1,1)+(4D0*K(6)*QF(3)*PRE)/S12

C       G(T9,N2190,FULL)
        CALL xC01234_(S12,MHH2,S34,XMQP2(I),XMQP2(I),XMQP2(I),C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,0)
        K(1) = 1D0+2D0*QF(3)*XSW2
        K(2) = 3D0-8D0*XSW2
        K(3) = 3D0-3D0*QEPS-8D0*XSW2
        K(4) = 3D0+3D0*QEPS-8D0*XSW2
        K(5) = -(6D0*C1(2)*QEPS)-4D0*C2(1,2)*(3D0-8D0*XSW2)+C0*(3D0-
     &  3D0*QEPS-8D0*XSW2)
        K(6) = 6D0*C1(2)*QEPS-4D0*C2(1,2)*(3D0-8D0*XSW2)+C0*(3D0+
     &  3D0*QEPS-8D0*XSW2)
        K(7) = S13+S14-S23-S24
        K(8) = S13+S14+S23+S24
        K(9) = -((6D0*C1(2)*QEPS*(S13+S14-S23-S24))/S12)-2D0*C2(1,
     &  1)*(3D0-8D0*XSW2)+(3D0-8D0*XSW2)/S12+(2D0*C2(1,2)*(S13+S14+
     &  S23+S24)*(3D0-8D0*XSW2))/S12-(2D0*C2(2,2)*S34*(3D0-8D0*
     &  XSW2))/S12+(C0*(-(3D0*S13)-3D0*QEPS*S13-3D0*S14-3D0*QEPS*
     &  S14-3D0*S23+3D0*QEPS*S23-3D0*S24+3D0*QEPS*S24+8D0*S13*XSW2+
     &  8D0*S14*XSW2+8D0*S23*XSW2+8D0*S24*XSW2+6D0*XMQP2(I)-16D0*
     &  XSW2*XMQP2(I)))/S12
        K(10) = (6D0*C1(2)*QEPS*(S13+S14-S23-S24))/S12-2D0*C2(1,1)*
     &  (3D0-8D0*XSW2)+(3D0-8D0*XSW2)/S12+(2D0*C2(1,2)*(S13+S14+S23+
     &  S24)*(3D0-8D0*XSW2))/S12-(2D0*C2(2,2)*S34*(3D0-8D0*XSW2))/
     &  S12+(C0*(-(3D0*S13)+3D0*QEPS*S13-3D0*S14+3D0*QEPS*S14-3D0*
     &  S23-3D0*QEPS*S23-3D0*S24-3D0*QEPS*S24+8D0*S13*XSW2+8D0*S14*
     &  XSW2+8D0*S23*XSW2+8D0*S24*XSW2+6D0*XMQP2(I)-16D0*XSW2*
     &  XMQP2(I)))/S12
        K(11) = -(3D0*S13)-3D0*QEPS*S13-3D0*S14-3D0*QEPS*S14-3D0*
     &  S23+3D0*QEPS*S23-3D0*S24+3D0*QEPS*S24+8D0*S13*XSW2+8D0*S14*
     &  XSW2+8D0*S23*XSW2+8D0*S24*XSW2+6D0*XMQP2(I)-16D0*XSW2*
     &  XMQP2(I)
        K(12) = -(3D0*S13)+3D0*QEPS*S13-3D0*S14+3D0*QEPS*S14-3D0*
     &  S23-3D0*QEPS*S23-3D0*S24-3D0*QEPS*S24+8D0*S13*XSW2+8D0*S14*
     &  XSW2+8D0*S23*XSW2+8D0*S24*XSW2+6D0*XMQP2(I)-16D0*XSW2*
     &  XMQP2(I)

        PRE = (QF(1)*ALPHA*CUPH*PZ34*XMQP2(I))/(48D0*PI*XCW2*XMW*
     &  XSW)

        F(1,-1,-1) = F(1,-1,-1)+(K(1)*K(9)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*K(9)*QF(3)*PRE
        F(1,1,-1) = F(1,1,-1)+(K(1)*K(10)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+2D0*K(10)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(1)*K(6)*PRE)/(S12*XSW2)
        F(5,-1,1) = F(5,-1,1)+(4D0*K(6)*QF(3)*PRE)/S12
        F(5,1,-1) = F(5,1,-1)+(2D0*K(1)*K(5)*PRE)/(S12*XSW2)
        F(5,1,1) = F(5,1,1)+(4D0*K(5)*QF(3)*PRE)/S12
        F(6,-1,-1) = F(6,-1,-1)+(2D0*K(1)*K(5)*PRE)/(S12*XSW2)
        F(6,-1,1) = F(6,-1,1)+(4D0*K(5)*QF(3)*PRE)/S12
        F(6,1,-1) = F(6,1,-1)+(2D0*K(1)*K(6)*PRE)/(S12*XSW2)
        F(6,1,1) = F(6,1,1)+(4D0*K(6)*QF(3)*PRE)/S12
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(1)*K(6)*PRE)/(S12*XSW2)
        F(7,-1,1) = F(7,-1,1)+(4D0*K(6)*QF(3)*PRE)/S12
        F(7,1,-1) = F(7,1,-1)+(2D0*K(1)*K(5)*PRE)/(S12*XSW2)
        F(7,1,1) = F(7,1,1)+(4D0*K(5)*QF(3)*PRE)/S12
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(1)*K(5)*PRE)/(S12*XSW2)
        F(8,-1,1) = F(8,-1,1)+(4D0*K(5)*QF(3)*PRE)/S12
        F(8,1,-1) = F(8,1,-1)+(2D0*K(1)*K(6)*PRE)/(S12*XSW2)
        F(8,1,1) = F(8,1,1)+(4D0*K(6)*QF(3)*PRE)/S12

C       G(T9,N2191,FULL)
        CALL xC01234_(S12,MHH2,S34,XML2(I),XML2(I),XML2(I),C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,2,0)
        K(1) = 1D0-2D0*XSW
        K(2) = 1D0+2D0*XSW
        K(3) = 1D0+2D0*QF(3)*XSW2
        K(4) = 1D0-QEPS-4D0*XSW2
        K(5) = 1D0+QEPS-4D0*XSW2
        K(6) = -(2D0*C1(2)*QEPS)-4D0*C2(1,2)*(1D0-2D0*XSW)*(1D0+2D0*
     &  XSW)+C0*(1D0-QEPS-4D0*XSW2)
        K(7) = 2D0*C1(2)*QEPS-4D0*C2(1,2)*(1D0-2D0*XSW)*(1D0+2D0*
     &  XSW)+C0*(1D0+QEPS-4D0*XSW2)
        K(8) = S13+S14-S23-S24
        K(9) = S13+S14+S23+S24
        K(10) = -((2D0*C1(2)*QEPS*(S13+S14-S23-S24))/S12)-2D0*C2(1,
     &  1)*(1D0-2D0*XSW)*(1D0+2D0*XSW)+((1D0-2D0*XSW)*(1D0+2D0*
     &  XSW))/S12+(2D0*C2(1,2)*(S13+S14+S23+S24)*(1D0-2D0*XSW)*(1D0+
     &  2D0*XSW))/S12-(2D0*C2(2,2)*S34*(1D0-2D0*XSW)*(1D0+2D0*XSW))/
     &  S12-(C0*(S13+QEPS*S13+S14+QEPS*S14+S23-QEPS*S23+S24-QEPS*
     &  S24-4D0*S13*XSW2-4D0*S14*XSW2-4D0*S23*XSW2-4D0*S24*XSW2-2D0*
     &  XML2(I)+8D0*XSW2*XML2(I)))/S12
        K(11) = (2D0*C1(2)*QEPS*(S13+S14-S23-S24))/S12-2D0*C2(1,1)*
     &  (1D0-2D0*XSW)*(1D0+2D0*XSW)+((1D0-2D0*XSW)*(1D0+2D0*XSW))/
     &  S12+(2D0*C2(1,2)*(S13+S14+S23+S24)*(1D0-2D0*XSW)*(1D0+2D0*
     &  XSW))/S12-(2D0*C2(2,2)*S34*(1D0-2D0*XSW)*(1D0+2D0*XSW))/S12-
     &  (C0*(S13-QEPS*S13+S14-QEPS*S14+S23+QEPS*S23+S24+QEPS*S24-
     &  4D0*S13*XSW2-4D0*S14*XSW2-4D0*S23*XSW2-4D0*S24*XSW2-2D0*
     &  XML2(I)+8D0*XSW2*XML2(I)))/S12
        K(12) = S13-QEPS*S13+S14-QEPS*S14+S23+QEPS*S23+S24+QEPS*S24-
     &  4D0*S13*XSW2-4D0*S14*XSW2-4D0*S23*XSW2-4D0*S24*XSW2-2D0*
     &  XML2(I)+8D0*XSW2*XML2(I)
        K(13) = S13+QEPS*S13+S14+QEPS*S14+S23-QEPS*S23+S24-QEPS*S24-
     &  4D0*S13*XSW2-4D0*S14*XSW2-4D0*S23*XSW2-4D0*S24*XSW2-2D0*
     &  XML2(I)+8D0*XSW2*XML2(I)

        PRE = (QF(1)*ALPHA*CLEPH*PZ34*XML2(I))/(32D0*PI*XCW2*XMW*
     &  XSW)

        F(1,-1,-1) = F(1,-1,-1)+(K(10)*K(3)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*K(10)*QF(3)*PRE
        F(1,1,-1) = F(1,1,-1)+(K(11)*K(3)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+2D0*K(11)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(3)*K(7)*PRE)/(S12*XSW2)
        F(5,-1,1) = F(5,-1,1)+(4D0*K(7)*QF(3)*PRE)/S12
        F(5,1,-1) = F(5,1,-1)+(2D0*K(3)*K(6)*PRE)/(S12*XSW2)
        F(5,1,1) = F(5,1,1)+(4D0*K(6)*QF(3)*PRE)/S12
        F(6,-1,-1) = F(6,-1,-1)+(2D0*K(3)*K(6)*PRE)/(S12*XSW2)
        F(6,-1,1) = F(6,-1,1)+(4D0*K(6)*QF(3)*PRE)/S12
        F(6,1,-1) = F(6,1,-1)+(2D0*K(3)*K(7)*PRE)/(S12*XSW2)
        F(6,1,1) = F(6,1,1)+(4D0*K(7)*QF(3)*PRE)/S12
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(3)*K(7)*PRE)/(S12*XSW2)
        F(7,-1,1) = F(7,-1,1)+(4D0*K(7)*QF(3)*PRE)/S12
        F(7,1,-1) = F(7,1,-1)+(2D0*K(3)*K(6)*PRE)/(S12*XSW2)
        F(7,1,1) = F(7,1,1)+(4D0*K(6)*QF(3)*PRE)/S12
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(3)*K(6)*PRE)/(S12*XSW2)
        F(8,-1,1) = F(8,-1,1)+(4D0*K(6)*QF(3)*PRE)/S12
        F(8,1,-1) = F(8,1,-1)+(2D0*K(3)*K(7)*PRE)/(S12*XSW2)
        F(8,1,1) = F(8,1,1)+(4D0*K(7)*QF(3)*PRE)/S12

C       G(T9,N2192,FULL)
        CALL xC01234_(S12,MHH2,S34,XML2(I),XML2(I),XML2(I),C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,2,0)
        K(1) = 1D0-2D0*XSW
        K(2) = 1D0+2D0*XSW
        K(3) = 1D0+2D0*QF(3)*XSW2
        K(4) = 1D0-QEPS-4D0*XSW2
        K(5) = 1D0+QEPS-4D0*XSW2
        K(6) = -(2D0*C1(2)*QEPS)-4D0*C2(1,2)*(1D0-2D0*XSW)*(1D0+2D0*
     &  XSW)+C0*(1D0-QEPS-4D0*XSW2)
        K(7) = 2D0*C1(2)*QEPS-4D0*C2(1,2)*(1D0-2D0*XSW)*(1D0+2D0*
     &  XSW)+C0*(1D0+QEPS-4D0*XSW2)
        K(8) = S13+S14-S23-S24
        K(9) = S13+S14+S23+S24
        K(10) = -((2D0*C1(2)*QEPS*(S13+S14-S23-S24))/S12)-2D0*C2(1,
     &  1)*(1D0-2D0*XSW)*(1D0+2D0*XSW)+((1D0-2D0*XSW)*(1D0+2D0*
     &  XSW))/S12+(2D0*C2(1,2)*(S13+S14+S23+S24)*(1D0-2D0*XSW)*(1D0+
     &  2D0*XSW))/S12-(2D0*C2(2,2)*S34*(1D0-2D0*XSW)*(1D0+2D0*XSW))/
     &  S12-(C0*(S13+QEPS*S13+S14+QEPS*S14+S23-QEPS*S23+S24-QEPS*
     &  S24-4D0*S13*XSW2-4D0*S14*XSW2-4D0*S23*XSW2-4D0*S24*XSW2-2D0*
     &  XML2(I)+8D0*XSW2*XML2(I)))/S12
        K(11) = (2D0*C1(2)*QEPS*(S13+S14-S23-S24))/S12-2D0*C2(1,1)*
     &  (1D0-2D0*XSW)*(1D0+2D0*XSW)+((1D0-2D0*XSW)*(1D0+2D0*XSW))/
     &  S12+(2D0*C2(1,2)*(S13+S14+S23+S24)*(1D0-2D0*XSW)*(1D0+2D0*
     &  XSW))/S12-(2D0*C2(2,2)*S34*(1D0-2D0*XSW)*(1D0+2D0*XSW))/S12-
     &  (C0*(S13-QEPS*S13+S14-QEPS*S14+S23+QEPS*S23+S24+QEPS*S24-
     &  4D0*S13*XSW2-4D0*S14*XSW2-4D0*S23*XSW2-4D0*S24*XSW2-2D0*
     &  XML2(I)+8D0*XSW2*XML2(I)))/S12
        K(12) = S13-QEPS*S13+S14-QEPS*S14+S23+QEPS*S23+S24+QEPS*S24-
     &  4D0*S13*XSW2-4D0*S14*XSW2-4D0*S23*XSW2-4D0*S24*XSW2-2D0*
     &  XML2(I)+8D0*XSW2*XML2(I)
        K(13) = S13+QEPS*S13+S14+QEPS*S14+S23-QEPS*S23+S24-QEPS*S24-
     &  4D0*S13*XSW2-4D0*S14*XSW2-4D0*S23*XSW2-4D0*S24*XSW2-2D0*
     &  XML2(I)+8D0*XSW2*XML2(I)

        PRE = (QF(1)*ALPHA*CLEPH*PZ34*XML2(I))/(32D0*PI*XCW2*XMW*
     &  XSW)

        F(1,-1,-1) = F(1,-1,-1)+(K(11)*K(3)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*K(11)*QF(3)*PRE
        F(1,1,-1) = F(1,1,-1)+(K(10)*K(3)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+2D0*K(10)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(3)*K(6)*PRE)/(S12*XSW2)
        F(5,-1,1) = F(5,-1,1)+(4D0*K(6)*QF(3)*PRE)/S12
        F(5,1,-1) = F(5,1,-1)+(2D0*K(3)*K(7)*PRE)/(S12*XSW2)
        F(5,1,1) = F(5,1,1)+(4D0*K(7)*QF(3)*PRE)/S12
        F(6,-1,-1) = F(6,-1,-1)+(2D0*K(3)*K(7)*PRE)/(S12*XSW2)
        F(6,-1,1) = F(6,-1,1)+(4D0*K(7)*QF(3)*PRE)/S12
        F(6,1,-1) = F(6,1,-1)+(2D0*K(3)*K(6)*PRE)/(S12*XSW2)
        F(6,1,1) = F(6,1,1)+(4D0*K(6)*QF(3)*PRE)/S12
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(3)*K(6)*PRE)/(S12*XSW2)
        F(7,-1,1) = F(7,-1,1)+(4D0*K(6)*QF(3)*PRE)/S12
        F(7,1,-1) = F(7,1,-1)+(2D0*K(3)*K(7)*PRE)/(S12*XSW2)
        F(7,1,1) = F(7,1,1)+(4D0*K(7)*QF(3)*PRE)/S12
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(3)*K(7)*PRE)/(S12*XSW2)
        F(8,-1,1) = F(8,-1,1)+(4D0*K(7)*QF(3)*PRE)/S12
        F(8,1,-1) = F(8,1,-1)+(2D0*K(3)*K(6)*PRE)/(S12*XSW2)
        F(8,1,1) = F(8,1,1)+(4D0*K(6)*QF(3)*PRE)/S12

C       G(T9,N2193,FULL)
        CALL xC01234_(S12,MHH2,S34,XMQP2(I),XMQP2(I),XMQP2(I),C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,0)
        K(1) = 1D0+2D0*QF(3)*XSW2
        K(2) = 3D0-8D0*XSW2
        K(3) = 3D0-3D0*QEPS-8D0*XSW2
        K(4) = 3D0+3D0*QEPS-8D0*XSW2
        K(5) = -(6D0*C1(2)*QEPS)-4D0*C2(1,2)*(3D0-8D0*XSW2)+C0*(3D0-
     &  3D0*QEPS-8D0*XSW2)
        K(6) = 6D0*C1(2)*QEPS-4D0*C2(1,2)*(3D0-8D0*XSW2)+C0*(3D0+
     &  3D0*QEPS-8D0*XSW2)
        K(7) = S13+S14-S23-S24
        K(8) = S13+S14+S23+S24
        K(9) = -((6D0*C1(2)*QEPS*(S13+S14-S23-S24))/S12)-2D0*C2(1,
     &  1)*(3D0-8D0*XSW2)+(3D0-8D0*XSW2)/S12+(2D0*C2(1,2)*(S13+S14+
     &  S23+S24)*(3D0-8D0*XSW2))/S12-(2D0*C2(2,2)*S34*(3D0-8D0*
     &  XSW2))/S12+(C0*(-(3D0*S13)-3D0*QEPS*S13-3D0*S14-3D0*QEPS*
     &  S14-3D0*S23+3D0*QEPS*S23-3D0*S24+3D0*QEPS*S24+8D0*S13*XSW2+
     &  8D0*S14*XSW2+8D0*S23*XSW2+8D0*S24*XSW2+6D0*XMQP2(I)-16D0*
     &  XSW2*XMQP2(I)))/S12
        K(10) = (6D0*C1(2)*QEPS*(S13+S14-S23-S24))/S12-2D0*C2(1,1)*
     &  (3D0-8D0*XSW2)+(3D0-8D0*XSW2)/S12+(2D0*C2(1,2)*(S13+S14+S23+
     &  S24)*(3D0-8D0*XSW2))/S12-(2D0*C2(2,2)*S34*(3D0-8D0*XSW2))/
     &  S12+(C0*(-(3D0*S13)+3D0*QEPS*S13-3D0*S14+3D0*QEPS*S14-3D0*
     &  S23-3D0*QEPS*S23-3D0*S24-3D0*QEPS*S24+8D0*S13*XSW2+8D0*S14*
     &  XSW2+8D0*S23*XSW2+8D0*S24*XSW2+6D0*XMQP2(I)-16D0*XSW2*
     &  XMQP2(I)))/S12
        K(11) = -(3D0*S13)-3D0*QEPS*S13-3D0*S14-3D0*QEPS*S14-3D0*
     &  S23+3D0*QEPS*S23-3D0*S24+3D0*QEPS*S24+8D0*S13*XSW2+8D0*S14*
     &  XSW2+8D0*S23*XSW2+8D0*S24*XSW2+6D0*XMQP2(I)-16D0*XSW2*
     &  XMQP2(I)
        K(12) = -(3D0*S13)+3D0*QEPS*S13-3D0*S14+3D0*QEPS*S14-3D0*
     &  S23-3D0*QEPS*S23-3D0*S24-3D0*QEPS*S24+8D0*S13*XSW2+8D0*S14*
     &  XSW2+8D0*S23*XSW2+8D0*S24*XSW2+6D0*XMQP2(I)-16D0*XSW2*
     &  XMQP2(I)

        PRE = (QF(1)*ALPHA*CUPH*PZ34*XMQP2(I))/(48D0*PI*XCW2*XMW*
     &  XSW)

        F(1,-1,-1) = F(1,-1,-1)+(K(1)*K(10)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*K(10)*QF(3)*PRE
        F(1,1,-1) = F(1,1,-1)+(K(1)*K(9)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+2D0*K(9)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(1)*K(5)*PRE)/(S12*XSW2)
        F(5,-1,1) = F(5,-1,1)+(4D0*K(5)*QF(3)*PRE)/S12
        F(5,1,-1) = F(5,1,-1)+(2D0*K(1)*K(6)*PRE)/(S12*XSW2)
        F(5,1,1) = F(5,1,1)+(4D0*K(6)*QF(3)*PRE)/S12
        F(6,-1,-1) = F(6,-1,-1)+(2D0*K(1)*K(6)*PRE)/(S12*XSW2)
        F(6,-1,1) = F(6,-1,1)+(4D0*K(6)*QF(3)*PRE)/S12
        F(6,1,-1) = F(6,1,-1)+(2D0*K(1)*K(5)*PRE)/(S12*XSW2)
        F(6,1,1) = F(6,1,1)+(4D0*K(5)*QF(3)*PRE)/S12
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(1)*K(5)*PRE)/(S12*XSW2)
        F(7,-1,1) = F(7,-1,1)+(4D0*K(5)*QF(3)*PRE)/S12
        F(7,1,-1) = F(7,1,-1)+(2D0*K(1)*K(6)*PRE)/(S12*XSW2)
        F(7,1,1) = F(7,1,1)+(4D0*K(6)*QF(3)*PRE)/S12
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(1)*K(6)*PRE)/(S12*XSW2)
        F(8,-1,1) = F(8,-1,1)+(4D0*K(6)*QF(3)*PRE)/S12
        F(8,1,-1) = F(8,1,-1)+(2D0*K(1)*K(5)*PRE)/(S12*XSW2)
        F(8,1,1) = F(8,1,1)+(4D0*K(5)*QF(3)*PRE)/S12

C       G(T9,N2194,FULL)
        CALL xC01234_(S12,MHH2,S34,XMQM2(I),XMQM2(I),XMQM2(I),C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,0)
        K(1) = 1D0+2D0*QF(3)*XSW2
        K(2) = 3D0-4D0*XSW2
        K(3) = 3D0-3D0*QEPS-4D0*XSW2
        K(4) = 3D0+3D0*QEPS-4D0*XSW2
        K(5) = -(6D0*C1(2)*QEPS)-4D0*C2(1,2)*(3D0-4D0*XSW2)+C0*(3D0-
     &  3D0*QEPS-4D0*XSW2)
        K(6) = 6D0*C1(2)*QEPS-4D0*C2(1,2)*(3D0-4D0*XSW2)+C0*(3D0+
     &  3D0*QEPS-4D0*XSW2)
        K(7) = S13+S14-S23-S24
        K(8) = S13+S14+S23+S24
        K(9) = -((6D0*C1(2)*QEPS*(S13+S14-S23-S24))/S12)-2D0*C2(1,
     &  1)*(3D0-4D0*XSW2)+(3D0-4D0*XSW2)/S12+(2D0*C2(1,2)*(S13+S14+
     &  S23+S24)*(3D0-4D0*XSW2))/S12-(2D0*C2(2,2)*S34*(3D0-4D0*
     &  XSW2))/S12+(C0*(-(3D0*S13)-3D0*QEPS*S13-3D0*S14-3D0*QEPS*
     &  S14-3D0*S23+3D0*QEPS*S23-3D0*S24+3D0*QEPS*S24+4D0*S13*XSW2+
     &  4D0*S14*XSW2+4D0*S23*XSW2+4D0*S24*XSW2+6D0*XMQM2(I)-8D0*
     &  XSW2*XMQM2(I)))/S12
        K(10) = (6D0*C1(2)*QEPS*(S13+S14-S23-S24))/S12-2D0*C2(1,1)*
     &  (3D0-4D0*XSW2)+(3D0-4D0*XSW2)/S12+(2D0*C2(1,2)*(S13+S14+S23+
     &  S24)*(3D0-4D0*XSW2))/S12-(2D0*C2(2,2)*S34*(3D0-4D0*XSW2))/
     &  S12+(C0*(-(3D0*S13)+3D0*QEPS*S13-3D0*S14+3D0*QEPS*S14-3D0*
     &  S23-3D0*QEPS*S23-3D0*S24-3D0*QEPS*S24+4D0*S13*XSW2+4D0*S14*
     &  XSW2+4D0*S23*XSW2+4D0*S24*XSW2+6D0*XMQM2(I)-8D0*XSW2*
     &  XMQM2(I)))/S12
        K(11) = -(3D0*S13)-3D0*QEPS*S13-3D0*S14-3D0*QEPS*S14-3D0*
     &  S23+3D0*QEPS*S23-3D0*S24+3D0*QEPS*S24+4D0*S13*XSW2+4D0*S14*
     &  XSW2+4D0*S23*XSW2+4D0*S24*XSW2+6D0*XMQM2(I)-8D0*XSW2*
     &  XMQM2(I)
        K(12) = -(3D0*S13)+3D0*QEPS*S13-3D0*S14+3D0*QEPS*S14-3D0*
     &  S23-3D0*QEPS*S23-3D0*S24-3D0*QEPS*S24+4D0*S13*XSW2+4D0*S14*
     &  XSW2+4D0*S23*XSW2+4D0*S24*XSW2+6D0*XMQM2(I)-8D0*XSW2*
     &  XMQM2(I)

        PRE = (QF(1)*ALPHA*CDOH*PZ34*XMQM2(I))/(96D0*PI*XCW2*XMW*
     &  XSW)

        F(1,-1,-1) = F(1,-1,-1)+(K(1)*K(10)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*K(10)*QF(3)*PRE
        F(1,1,-1) = F(1,1,-1)+(K(1)*K(9)*PRE)/XSW2
        F(1,1,1) = F(1,1,1)+2D0*K(9)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(1)*K(5)*PRE)/(S12*XSW2)
        F(5,-1,1) = F(5,-1,1)+(4D0*K(5)*QF(3)*PRE)/S12
        F(5,1,-1) = F(5,1,-1)+(2D0*K(1)*K(6)*PRE)/(S12*XSW2)
        F(5,1,1) = F(5,1,1)+(4D0*K(6)*QF(3)*PRE)/S12
        F(6,-1,-1) = F(6,-1,-1)+(2D0*K(1)*K(6)*PRE)/(S12*XSW2)
        F(6,-1,1) = F(6,-1,1)+(4D0*K(6)*QF(3)*PRE)/S12
        F(6,1,-1) = F(6,1,-1)+(2D0*K(1)*K(5)*PRE)/(S12*XSW2)
        F(6,1,1) = F(6,1,1)+(4D0*K(5)*QF(3)*PRE)/S12
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(1)*K(5)*PRE)/(S12*XSW2)
        F(7,-1,1) = F(7,-1,1)+(4D0*K(5)*QF(3)*PRE)/S12
        F(7,1,-1) = F(7,1,-1)+(2D0*K(1)*K(6)*PRE)/(S12*XSW2)
        F(7,1,1) = F(7,1,1)+(4D0*K(6)*QF(3)*PRE)/S12
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(1)*K(6)*PRE)/(S12*XSW2)
        F(8,-1,1) = F(8,-1,1)+(4D0*K(6)*QF(3)*PRE)/S12
        F(8,1,-1) = F(8,1,-1)+(2D0*K(1)*K(5)*PRE)/(S12*XSW2)
        F(8,1,1) = F(8,1,1)+(4D0*K(5)*QF(3)*PRE)/S12

C       G(T9,N2195,FULL)

C       G(T9,N2196,FULL)

C       G(T9,N2197,FULL)

C       G(T9,N2198,FULL)

C       G(T9,N2205,FULL)

C       G(T9,N2206,FULL)

C       G(T9,N2207,FULL)

C       G(T9,N2208,FULL)

C       G(T9,N2209,FULL)

C       G(T9,N2210,FULL)

C       G(T9,N2211,FULL)

C       G(T9,N2212,FULL)

C       G(T9,N2213,FULL)

C       G(T9,N2214,FULL)

C       G(T9,N2215,FULL)

C       G(T9,N2216,FULL)

C       G(T9,N2217,FULL)

C       G(T9,N2218,FULL)

C       G(T9,N2229,FULL)

C       G(T9,N2230,FULL)

C       G(T9,N2231,FULL)

C       G(T9,N2232,FULL)

C       G(T9,N2233,FULL)

C       G(T9,N2234,FULL)

C       G(T9,N2235,FULL)

C       G(T9,N2236,FULL)

C       G(T9,N2237,FULL)

C       G(T9,N2238,FULL)

C       G(T9,N2239,FULL)

C       G(T9,N2240,FULL)

C       G(T9,N2241,FULL)

C       G(T9,N2242,FULL)

C       G(T9,N2253,FULL)

C       G(T9,N2254,FULL)

C       G(T9,N2255,FULL)

C       G(T9,N2256,FULL)

C       G(T9,N2257,FULL)

C       G(T9,N2258,FULL)

C       G(T9,N2259,FULL)

C       G(T9,N2260,FULL)

C       G(T9,N2261,FULL)

C       G(T9,N2262,FULL)

C       G(T9,N2263,FULL)

C       G(T9,N2264,FULL)

C       G(T9,N2265,FULL)

C       G(T9,N2266,FULL)

C       G(T9,N2271,FULL)

C       G(T9,N2272,FULL)

C       G(T9,N2273,FULL)

C       G(T9,N2274,FULL)

C       G(T9,N2275,FULL)

C       G(T9,N2276,FULL)

C       G(T9,N2277,FULL)

C       G(T9,N2278,FULL)

C       G(T9,N2279,FULL)

C       G(T9,N2280,FULL)

C       G(T9,N2281,FULL)

C       G(T9,N2282,FULL)

C       G(T9,N2283,FULL)

C       G(T9,N2284,FULL)

C       G(T9,N2297,FULL)

C       G(T9,N2298,FULL)

C       G(T9,N2299,FULL)

C       G(T9,N2300,FULL)

C       G(T9,N2301,FULL)
        CALL xC01234_(S12,MHH2,S34,XMQM2(I),XMQM2(I),XMQM2(I),C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 3D0-4D0*XSW2
        K(3) = 3D0-3D0*QEPS-4D0*XSW2
        K(4) = 3D0+3D0*QEPS-4D0*XSW2
        K(5) = -(6D0*C1(1)*QEPS)-4D0*C2(1,2)*(3D0-4D0*XSW2)+C0*(3D0-
     &  3D0*QEPS-4D0*XSW2)
        K(6) = 6D0*C1(1)*QEPS-4D0*C2(1,2)*(3D0-4D0*XSW2)+C0*(3D0+
     &  3D0*QEPS-4D0*XSW2)
        K(7) = S13+S14-S23-S24
        K(8) = S13+S14+S23+S24
        K(9) = -((6D0*C1(1)*QEPS*(S13+S14-S23-S24))/S34)-2D0*C2(2,
     &  2)*(3D0-4D0*XSW2)+(3D0-4D0*XSW2)/S34-(2D0*C2(1,1)*S12*(3D0-
     &  4D0*XSW2))/S34+(2D0*C2(1,2)*(S13+S14+S23+S24)*(3D0-4D0*
     &  XSW2))/S34+(C0*(-(3D0*S13)-3D0*QEPS*S13-3D0*S14-3D0*QEPS*
     &  S14-3D0*S23+3D0*QEPS*S23-3D0*S24+3D0*QEPS*S24+4D0*S13*XSW2+
     &  4D0*S14*XSW2+4D0*S23*XSW2+4D0*S24*XSW2+6D0*XMQM2(I)-8D0*
     &  XSW2*XMQM2(I)))/S34
        K(10) = (6D0*C1(1)*QEPS*(S13+S14-S23-S24))/S34-2D0*C2(2,2)*
     &  (3D0-4D0*XSW2)+(3D0-4D0*XSW2)/S34-(2D0*C2(1,1)*S12*(3D0-4D0*
     &  XSW2))/S34+(2D0*C2(1,2)*(S13+S14+S23+S24)*(3D0-4D0*XSW2))/
     &  S34+(C0*(-(3D0*S13)+3D0*QEPS*S13-3D0*S14+3D0*QEPS*S14-3D0*
     &  S23-3D0*QEPS*S23-3D0*S24-3D0*QEPS*S24+4D0*S13*XSW2+4D0*S14*
     &  XSW2+4D0*S23*XSW2+4D0*S24*XSW2+6D0*XMQM2(I)-8D0*XSW2*
     &  XMQM2(I)))/S34
        K(11) = -(3D0*S13)-3D0*QEPS*S13-3D0*S14-3D0*QEPS*S14-3D0*
     &  S23+3D0*QEPS*S23-3D0*S24+3D0*QEPS*S24+4D0*S13*XSW2+4D0*S14*
     &  XSW2+4D0*S23*XSW2+4D0*S24*XSW2+6D0*XMQM2(I)-8D0*XSW2*
     &  XMQM2(I)
        K(12) = -(3D0*S13)+3D0*QEPS*S13-3D0*S14+3D0*QEPS*S14-3D0*
     &  S23-3D0*QEPS*S23-3D0*S24-3D0*QEPS*S24+4D0*S13*XSW2+4D0*S14*
     &  XSW2+4D0*S23*XSW2+4D0*S24*XSW2+6D0*XMQM2(I)-8D0*XSW2*
     &  XMQM2(I)

        PRE = (QF(3)*ALPHA*CDOH*PZ12*XMQM2(I))/(96D0*PI*XCW2*XMW*
     &  XSW)

        F(1,-1,-1) = F(1,-1,-1)-(K(1)*K(10)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)-(K(1)*K(10)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*K(9)*QF(1)*PRE
        F(1,1,1) = F(1,1,1)+2D0*K(9)*QF(1)*PRE
        F(5,-1,-1) = F(5,-1,-1)-(2D0*K(1)*K(5)*PRE)/(S34*XSW2)
        F(5,-1,1) = F(5,-1,1)-(2D0*K(1)*K(5)*PRE)/(S34*XSW2)
        F(5,1,-1) = F(5,1,-1)+(4D0*K(6)*QF(1)*PRE)/S34
        F(5,1,1) = F(5,1,1)+(4D0*K(6)*QF(1)*PRE)/S34
        F(6,-1,-1) = F(6,-1,-1)-(2D0*K(1)*K(6)*PRE)/(S34*XSW2)
        F(6,-1,1) = F(6,-1,1)-(2D0*K(1)*K(6)*PRE)/(S34*XSW2)
        F(6,1,-1) = F(6,1,-1)+(4D0*K(5)*QF(1)*PRE)/S34
        F(6,1,1) = F(6,1,1)+(4D0*K(5)*QF(1)*PRE)/S34
        F(7,-1,-1) = F(7,-1,-1)-(2D0*K(1)*K(5)*PRE)/(S34*XSW2)
        F(7,-1,1) = F(7,-1,1)-(2D0*K(1)*K(5)*PRE)/(S34*XSW2)
        F(7,1,-1) = F(7,1,-1)+(4D0*K(6)*QF(1)*PRE)/S34
        F(7,1,1) = F(7,1,1)+(4D0*K(6)*QF(1)*PRE)/S34
        F(8,-1,-1) = F(8,-1,-1)-(2D0*K(1)*K(6)*PRE)/(S34*XSW2)
        F(8,-1,1) = F(8,-1,1)-(2D0*K(1)*K(6)*PRE)/(S34*XSW2)
        F(8,1,-1) = F(8,1,-1)+(4D0*K(5)*QF(1)*PRE)/S34
        F(8,1,1) = F(8,1,1)+(4D0*K(5)*QF(1)*PRE)/S34

C       G(T9,N2302,FULL)
        CALL xC01234_(S12,MHH2,S34,XMQP2(I),XMQP2(I),XMQP2(I),C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 3D0-8D0*XSW2
        K(3) = 3D0-3D0*QEPS-8D0*XSW2
        K(4) = 3D0+3D0*QEPS-8D0*XSW2
        K(5) = -(6D0*C1(1)*QEPS)-4D0*C2(1,2)*(3D0-8D0*XSW2)+C0*(3D0-
     &  3D0*QEPS-8D0*XSW2)
        K(6) = 6D0*C1(1)*QEPS-4D0*C2(1,2)*(3D0-8D0*XSW2)+C0*(3D0+
     &  3D0*QEPS-8D0*XSW2)
        K(7) = S13+S14-S23-S24
        K(8) = S13+S14+S23+S24
        K(9) = -((6D0*C1(1)*QEPS*(S13+S14-S23-S24))/S34)-2D0*C2(2,
     &  2)*(3D0-8D0*XSW2)+(3D0-8D0*XSW2)/S34-(2D0*C2(1,1)*S12*(3D0-
     &  8D0*XSW2))/S34+(2D0*C2(1,2)*(S13+S14+S23+S24)*(3D0-8D0*
     &  XSW2))/S34+(C0*(-(3D0*S13)-3D0*QEPS*S13-3D0*S14-3D0*QEPS*
     &  S14-3D0*S23+3D0*QEPS*S23-3D0*S24+3D0*QEPS*S24+8D0*S13*XSW2+
     &  8D0*S14*XSW2+8D0*S23*XSW2+8D0*S24*XSW2+6D0*XMQP2(I)-16D0*
     &  XSW2*XMQP2(I)))/S34
        K(10) = (6D0*C1(1)*QEPS*(S13+S14-S23-S24))/S34-2D0*C2(2,2)*
     &  (3D0-8D0*XSW2)+(3D0-8D0*XSW2)/S34-(2D0*C2(1,1)*S12*(3D0-8D0*
     &  XSW2))/S34+(2D0*C2(1,2)*(S13+S14+S23+S24)*(3D0-8D0*XSW2))/
     &  S34+(C0*(-(3D0*S13)+3D0*QEPS*S13-3D0*S14+3D0*QEPS*S14-3D0*
     &  S23-3D0*QEPS*S23-3D0*S24-3D0*QEPS*S24+8D0*S13*XSW2+8D0*S14*
     &  XSW2+8D0*S23*XSW2+8D0*S24*XSW2+6D0*XMQP2(I)-16D0*XSW2*
     &  XMQP2(I)))/S34
        K(11) = -(3D0*S13)-3D0*QEPS*S13-3D0*S14-3D0*QEPS*S14-3D0*
     &  S23+3D0*QEPS*S23-3D0*S24+3D0*QEPS*S24+8D0*S13*XSW2+8D0*S14*
     &  XSW2+8D0*S23*XSW2+8D0*S24*XSW2+6D0*XMQP2(I)-16D0*XSW2*
     &  XMQP2(I)
        K(12) = -(3D0*S13)+3D0*QEPS*S13-3D0*S14+3D0*QEPS*S14-3D0*
     &  S23-3D0*QEPS*S23-3D0*S24-3D0*QEPS*S24+8D0*S13*XSW2+8D0*S14*
     &  XSW2+8D0*S23*XSW2+8D0*S24*XSW2+6D0*XMQP2(I)-16D0*XSW2*
     &  XMQP2(I)

        PRE = (QF(3)*ALPHA*CUPH*PZ12*XMQP2(I))/(48D0*PI*XCW2*XMW*
     &  XSW)

        F(1,-1,-1) = F(1,-1,-1)-(K(1)*K(10)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)-(K(1)*K(10)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*K(9)*QF(1)*PRE
        F(1,1,1) = F(1,1,1)+2D0*K(9)*QF(1)*PRE
        F(5,-1,-1) = F(5,-1,-1)-(2D0*K(1)*K(5)*PRE)/(S34*XSW2)
        F(5,-1,1) = F(5,-1,1)-(2D0*K(1)*K(5)*PRE)/(S34*XSW2)
        F(5,1,-1) = F(5,1,-1)+(4D0*K(6)*QF(1)*PRE)/S34
        F(5,1,1) = F(5,1,1)+(4D0*K(6)*QF(1)*PRE)/S34
        F(6,-1,-1) = F(6,-1,-1)-(2D0*K(1)*K(6)*PRE)/(S34*XSW2)
        F(6,-1,1) = F(6,-1,1)-(2D0*K(1)*K(6)*PRE)/(S34*XSW2)
        F(6,1,-1) = F(6,1,-1)+(4D0*K(5)*QF(1)*PRE)/S34
        F(6,1,1) = F(6,1,1)+(4D0*K(5)*QF(1)*PRE)/S34
        F(7,-1,-1) = F(7,-1,-1)-(2D0*K(1)*K(5)*PRE)/(S34*XSW2)
        F(7,-1,1) = F(7,-1,1)-(2D0*K(1)*K(5)*PRE)/(S34*XSW2)
        F(7,1,-1) = F(7,1,-1)+(4D0*K(6)*QF(1)*PRE)/S34
        F(7,1,1) = F(7,1,1)+(4D0*K(6)*QF(1)*PRE)/S34
        F(8,-1,-1) = F(8,-1,-1)-(2D0*K(1)*K(6)*PRE)/(S34*XSW2)
        F(8,-1,1) = F(8,-1,1)-(2D0*K(1)*K(6)*PRE)/(S34*XSW2)
        F(8,1,-1) = F(8,1,-1)+(4D0*K(5)*QF(1)*PRE)/S34
        F(8,1,1) = F(8,1,1)+(4D0*K(5)*QF(1)*PRE)/S34

C       G(T9,N2303,FULL)
        CALL xC01234_(S12,MHH2,S34,XML2(I),XML2(I),XML2(I),C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,2,0)
        K(1) = 1D0-2D0*XSW
        K(2) = 1D0+2D0*XSW
        K(3) = 1D0-2D0*QF(1)*XSW2
        K(4) = 1D0-QEPS-4D0*XSW2
        K(5) = 1D0+QEPS-4D0*XSW2
        K(6) = -(2D0*C1(1)*QEPS)-4D0*C2(1,2)*(1D0-2D0*XSW)*(1D0+2D0*
     &  XSW)+C0*(1D0-QEPS-4D0*XSW2)
        K(7) = 2D0*C1(1)*QEPS-4D0*C2(1,2)*(1D0-2D0*XSW)*(1D0+2D0*
     &  XSW)+C0*(1D0+QEPS-4D0*XSW2)
        K(8) = S13+S14-S23-S24
        K(9) = S13+S14+S23+S24
        K(10) = -((2D0*C1(1)*QEPS*(S13+S14-S23-S24))/S34)-2D0*C2(2,
     &  2)*(1D0-2D0*XSW)*(1D0+2D0*XSW)+((1D0-2D0*XSW)*(1D0+2D0*
     &  XSW))/S34-(2D0*C2(1,1)*S12*(1D0-2D0*XSW)*(1D0+2D0*XSW))/S34+
     &  (2D0*C2(1,2)*(S13+S14+S23+S24)*(1D0-2D0*XSW)*(1D0+2D0*XSW))/
     &  S34-(C0*(S13+QEPS*S13+S14+QEPS*S14+S23-QEPS*S23+S24-QEPS*
     &  S24-4D0*S13*XSW2-4D0*S14*XSW2-4D0*S23*XSW2-4D0*S24*XSW2-2D0*
     &  XML2(I)+8D0*XSW2*XML2(I)))/S34
        K(11) = (2D0*C1(1)*QEPS*(S13+S14-S23-S24))/S34-2D0*C2(2,2)*
     &  (1D0-2D0*XSW)*(1D0+2D0*XSW)+((1D0-2D0*XSW)*(1D0+2D0*XSW))/
     &  S34-(2D0*C2(1,1)*S12*(1D0-2D0*XSW)*(1D0+2D0*XSW))/S34+(2D0*
     &  C2(1,2)*(S13+S14+S23+S24)*(1D0-2D0*XSW)*(1D0+2D0*XSW))/S34-
     &  (C0*(S13-QEPS*S13+S14-QEPS*S14+S23+QEPS*S23+S24+QEPS*S24-
     &  4D0*S13*XSW2-4D0*S14*XSW2-4D0*S23*XSW2-4D0*S24*XSW2-2D0*
     &  XML2(I)+8D0*XSW2*XML2(I)))/S34
        K(12) = S13-QEPS*S13+S14-QEPS*S14+S23+QEPS*S23+S24+QEPS*S24-
     &  4D0*S13*XSW2-4D0*S14*XSW2-4D0*S23*XSW2-4D0*S24*XSW2-2D0*
     &  XML2(I)+8D0*XSW2*XML2(I)
        K(13) = S13+QEPS*S13+S14+QEPS*S14+S23-QEPS*S23+S24-QEPS*S24-
     &  4D0*S13*XSW2-4D0*S14*XSW2-4D0*S23*XSW2-4D0*S24*XSW2-2D0*
     &  XML2(I)+8D0*XSW2*XML2(I)

        PRE = (QF(3)*ALPHA*CLEPH*PZ12*XML2(I))/(32D0*PI*XCW2*XMW*
     &  XSW)

        F(1,-1,-1) = F(1,-1,-1)-(K(11)*K(3)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)-(K(11)*K(3)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*K(10)*QF(1)*PRE
        F(1,1,1) = F(1,1,1)+2D0*K(10)*QF(1)*PRE
        F(5,-1,-1) = F(5,-1,-1)-(2D0*K(3)*K(6)*PRE)/(S34*XSW2)
        F(5,-1,1) = F(5,-1,1)-(2D0*K(3)*K(6)*PRE)/(S34*XSW2)
        F(5,1,-1) = F(5,1,-1)+(4D0*K(7)*QF(1)*PRE)/S34
        F(5,1,1) = F(5,1,1)+(4D0*K(7)*QF(1)*PRE)/S34
        F(6,-1,-1) = F(6,-1,-1)-(2D0*K(3)*K(7)*PRE)/(S34*XSW2)
        F(6,-1,1) = F(6,-1,1)-(2D0*K(3)*K(7)*PRE)/(S34*XSW2)
        F(6,1,-1) = F(6,1,-1)+(4D0*K(6)*QF(1)*PRE)/S34
        F(6,1,1) = F(6,1,1)+(4D0*K(6)*QF(1)*PRE)/S34
        F(7,-1,-1) = F(7,-1,-1)-(2D0*K(3)*K(6)*PRE)/(S34*XSW2)
        F(7,-1,1) = F(7,-1,1)-(2D0*K(3)*K(6)*PRE)/(S34*XSW2)
        F(7,1,-1) = F(7,1,-1)+(4D0*K(7)*QF(1)*PRE)/S34
        F(7,1,1) = F(7,1,1)+(4D0*K(7)*QF(1)*PRE)/S34
        F(8,-1,-1) = F(8,-1,-1)-(2D0*K(3)*K(7)*PRE)/(S34*XSW2)
        F(8,-1,1) = F(8,-1,1)-(2D0*K(3)*K(7)*PRE)/(S34*XSW2)
        F(8,1,-1) = F(8,1,-1)+(4D0*K(6)*QF(1)*PRE)/S34
        F(8,1,1) = F(8,1,1)+(4D0*K(6)*QF(1)*PRE)/S34

C       G(T9,N2304,FULL)
        CALL xC01234_(S12,MHH2,S34,XML2(I),XML2(I),XML2(I),C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,2,0)
        K(1) = 1D0-2D0*XSW
        K(2) = 1D0+2D0*XSW
        K(3) = 1D0-2D0*QF(1)*XSW2
        K(4) = 1D0-QEPS-4D0*XSW2
        K(5) = 1D0+QEPS-4D0*XSW2
        K(6) = -(2D0*C1(1)*QEPS)-4D0*C2(1,2)*(1D0-2D0*XSW)*(1D0+2D0*
     &  XSW)+C0*(1D0-QEPS-4D0*XSW2)
        K(7) = 2D0*C1(1)*QEPS-4D0*C2(1,2)*(1D0-2D0*XSW)*(1D0+2D0*
     &  XSW)+C0*(1D0+QEPS-4D0*XSW2)
        K(8) = S13+S14-S23-S24
        K(9) = S13+S14+S23+S24
        K(10) = -((2D0*C1(1)*QEPS*(S13+S14-S23-S24))/S34)-2D0*C2(2,
     &  2)*(1D0-2D0*XSW)*(1D0+2D0*XSW)+((1D0-2D0*XSW)*(1D0+2D0*
     &  XSW))/S34-(2D0*C2(1,1)*S12*(1D0-2D0*XSW)*(1D0+2D0*XSW))/S34+
     &  (2D0*C2(1,2)*(S13+S14+S23+S24)*(1D0-2D0*XSW)*(1D0+2D0*XSW))/
     &  S34-(C0*(S13+QEPS*S13+S14+QEPS*S14+S23-QEPS*S23+S24-QEPS*
     &  S24-4D0*S13*XSW2-4D0*S14*XSW2-4D0*S23*XSW2-4D0*S24*XSW2-2D0*
     &  XML2(I)+8D0*XSW2*XML2(I)))/S34
        K(11) = (2D0*C1(1)*QEPS*(S13+S14-S23-S24))/S34-2D0*C2(2,2)*
     &  (1D0-2D0*XSW)*(1D0+2D0*XSW)+((1D0-2D0*XSW)*(1D0+2D0*XSW))/
     &  S34-(2D0*C2(1,1)*S12*(1D0-2D0*XSW)*(1D0+2D0*XSW))/S34+(2D0*
     &  C2(1,2)*(S13+S14+S23+S24)*(1D0-2D0*XSW)*(1D0+2D0*XSW))/S34-
     &  (C0*(S13-QEPS*S13+S14-QEPS*S14+S23+QEPS*S23+S24+QEPS*S24-
     &  4D0*S13*XSW2-4D0*S14*XSW2-4D0*S23*XSW2-4D0*S24*XSW2-2D0*
     &  XML2(I)+8D0*XSW2*XML2(I)))/S34
        K(12) = S13-QEPS*S13+S14-QEPS*S14+S23+QEPS*S23+S24+QEPS*S24-
     &  4D0*S13*XSW2-4D0*S14*XSW2-4D0*S23*XSW2-4D0*S24*XSW2-2D0*
     &  XML2(I)+8D0*XSW2*XML2(I)
        K(13) = S13+QEPS*S13+S14+QEPS*S14+S23-QEPS*S23+S24-QEPS*S24-
     &  4D0*S13*XSW2-4D0*S14*XSW2-4D0*S23*XSW2-4D0*S24*XSW2-2D0*
     &  XML2(I)+8D0*XSW2*XML2(I)

        PRE = (QF(3)*ALPHA*CLEPH*PZ12*XML2(I))/(32D0*PI*XCW2*XMW*
     &  XSW)

        F(1,-1,-1) = F(1,-1,-1)-(K(10)*K(3)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)-(K(10)*K(3)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*K(11)*QF(1)*PRE
        F(1,1,1) = F(1,1,1)+2D0*K(11)*QF(1)*PRE
        F(5,-1,-1) = F(5,-1,-1)-(2D0*K(3)*K(7)*PRE)/(S34*XSW2)
        F(5,-1,1) = F(5,-1,1)-(2D0*K(3)*K(7)*PRE)/(S34*XSW2)
        F(5,1,-1) = F(5,1,-1)+(4D0*K(6)*QF(1)*PRE)/S34
        F(5,1,1) = F(5,1,1)+(4D0*K(6)*QF(1)*PRE)/S34
        F(6,-1,-1) = F(6,-1,-1)-(2D0*K(3)*K(6)*PRE)/(S34*XSW2)
        F(6,-1,1) = F(6,-1,1)-(2D0*K(3)*K(6)*PRE)/(S34*XSW2)
        F(6,1,-1) = F(6,1,-1)+(4D0*K(7)*QF(1)*PRE)/S34
        F(6,1,1) = F(6,1,1)+(4D0*K(7)*QF(1)*PRE)/S34
        F(7,-1,-1) = F(7,-1,-1)-(2D0*K(3)*K(7)*PRE)/(S34*XSW2)
        F(7,-1,1) = F(7,-1,1)-(2D0*K(3)*K(7)*PRE)/(S34*XSW2)
        F(7,1,-1) = F(7,1,-1)+(4D0*K(6)*QF(1)*PRE)/S34
        F(7,1,1) = F(7,1,1)+(4D0*K(6)*QF(1)*PRE)/S34
        F(8,-1,-1) = F(8,-1,-1)-(2D0*K(3)*K(6)*PRE)/(S34*XSW2)
        F(8,-1,1) = F(8,-1,1)-(2D0*K(3)*K(6)*PRE)/(S34*XSW2)
        F(8,1,-1) = F(8,1,-1)+(4D0*K(7)*QF(1)*PRE)/S34
        F(8,1,1) = F(8,1,1)+(4D0*K(7)*QF(1)*PRE)/S34

C       G(T9,N2305,FULL)
        CALL xC01234_(S12,MHH2,S34,XMQP2(I),XMQP2(I),XMQP2(I),C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 3D0-8D0*XSW2
        K(3) = 3D0-3D0*QEPS-8D0*XSW2
        K(4) = 3D0+3D0*QEPS-8D0*XSW2
        K(5) = -(6D0*C1(1)*QEPS)-4D0*C2(1,2)*(3D0-8D0*XSW2)+C0*(3D0-
     &  3D0*QEPS-8D0*XSW2)
        K(6) = 6D0*C1(1)*QEPS-4D0*C2(1,2)*(3D0-8D0*XSW2)+C0*(3D0+
     &  3D0*QEPS-8D0*XSW2)
        K(7) = S13+S14-S23-S24
        K(8) = S13+S14+S23+S24
        K(9) = -((6D0*C1(1)*QEPS*(S13+S14-S23-S24))/S34)-2D0*C2(2,
     &  2)*(3D0-8D0*XSW2)+(3D0-8D0*XSW2)/S34-(2D0*C2(1,1)*S12*(3D0-
     &  8D0*XSW2))/S34+(2D0*C2(1,2)*(S13+S14+S23+S24)*(3D0-8D0*
     &  XSW2))/S34+(C0*(-(3D0*S13)-3D0*QEPS*S13-3D0*S14-3D0*QEPS*
     &  S14-3D0*S23+3D0*QEPS*S23-3D0*S24+3D0*QEPS*S24+8D0*S13*XSW2+
     &  8D0*S14*XSW2+8D0*S23*XSW2+8D0*S24*XSW2+6D0*XMQP2(I)-16D0*
     &  XSW2*XMQP2(I)))/S34
        K(10) = (6D0*C1(1)*QEPS*(S13+S14-S23-S24))/S34-2D0*C2(2,2)*
     &  (3D0-8D0*XSW2)+(3D0-8D0*XSW2)/S34-(2D0*C2(1,1)*S12*(3D0-8D0*
     &  XSW2))/S34+(2D0*C2(1,2)*(S13+S14+S23+S24)*(3D0-8D0*XSW2))/
     &  S34+(C0*(-(3D0*S13)+3D0*QEPS*S13-3D0*S14+3D0*QEPS*S14-3D0*
     &  S23-3D0*QEPS*S23-3D0*S24-3D0*QEPS*S24+8D0*S13*XSW2+8D0*S14*
     &  XSW2+8D0*S23*XSW2+8D0*S24*XSW2+6D0*XMQP2(I)-16D0*XSW2*
     &  XMQP2(I)))/S34
        K(11) = -(3D0*S13)-3D0*QEPS*S13-3D0*S14-3D0*QEPS*S14-3D0*
     &  S23+3D0*QEPS*S23-3D0*S24+3D0*QEPS*S24+8D0*S13*XSW2+8D0*S14*
     &  XSW2+8D0*S23*XSW2+8D0*S24*XSW2+6D0*XMQP2(I)-16D0*XSW2*
     &  XMQP2(I)
        K(12) = -(3D0*S13)+3D0*QEPS*S13-3D0*S14+3D0*QEPS*S14-3D0*
     &  S23-3D0*QEPS*S23-3D0*S24-3D0*QEPS*S24+8D0*S13*XSW2+8D0*S14*
     &  XSW2+8D0*S23*XSW2+8D0*S24*XSW2+6D0*XMQP2(I)-16D0*XSW2*
     &  XMQP2(I)

        PRE = (QF(3)*ALPHA*CUPH*PZ12*XMQP2(I))/(48D0*PI*XCW2*XMW*
     &  XSW)

        F(1,-1,-1) = F(1,-1,-1)-(K(1)*K(9)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)-(K(1)*K(9)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*K(10)*QF(1)*PRE
        F(1,1,1) = F(1,1,1)+2D0*K(10)*QF(1)*PRE
        F(5,-1,-1) = F(5,-1,-1)-(2D0*K(1)*K(6)*PRE)/(S34*XSW2)
        F(5,-1,1) = F(5,-1,1)-(2D0*K(1)*K(6)*PRE)/(S34*XSW2)
        F(5,1,-1) = F(5,1,-1)+(4D0*K(5)*QF(1)*PRE)/S34
        F(5,1,1) = F(5,1,1)+(4D0*K(5)*QF(1)*PRE)/S34
        F(6,-1,-1) = F(6,-1,-1)-(2D0*K(1)*K(5)*PRE)/(S34*XSW2)
        F(6,-1,1) = F(6,-1,1)-(2D0*K(1)*K(5)*PRE)/(S34*XSW2)
        F(6,1,-1) = F(6,1,-1)+(4D0*K(6)*QF(1)*PRE)/S34
        F(6,1,1) = F(6,1,1)+(4D0*K(6)*QF(1)*PRE)/S34
        F(7,-1,-1) = F(7,-1,-1)-(2D0*K(1)*K(6)*PRE)/(S34*XSW2)
        F(7,-1,1) = F(7,-1,1)-(2D0*K(1)*K(6)*PRE)/(S34*XSW2)
        F(7,1,-1) = F(7,1,-1)+(4D0*K(5)*QF(1)*PRE)/S34
        F(7,1,1) = F(7,1,1)+(4D0*K(5)*QF(1)*PRE)/S34
        F(8,-1,-1) = F(8,-1,-1)-(2D0*K(1)*K(5)*PRE)/(S34*XSW2)
        F(8,-1,1) = F(8,-1,1)-(2D0*K(1)*K(5)*PRE)/(S34*XSW2)
        F(8,1,-1) = F(8,1,-1)+(4D0*K(6)*QF(1)*PRE)/S34
        F(8,1,1) = F(8,1,1)+(4D0*K(6)*QF(1)*PRE)/S34

C       G(T9,N2306,FULL)
        CALL xC01234_(S12,MHH2,S34,XMQM2(I),XMQM2(I),XMQM2(I),C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 3D0-4D0*XSW2
        K(3) = 3D0-3D0*QEPS-4D0*XSW2
        K(4) = 3D0+3D0*QEPS-4D0*XSW2
        K(5) = -(6D0*C1(1)*QEPS)-4D0*C2(1,2)*(3D0-4D0*XSW2)+C0*(3D0-
     &  3D0*QEPS-4D0*XSW2)
        K(6) = 6D0*C1(1)*QEPS-4D0*C2(1,2)*(3D0-4D0*XSW2)+C0*(3D0+
     &  3D0*QEPS-4D0*XSW2)
        K(7) = S13+S14-S23-S24
        K(8) = S13+S14+S23+S24
        K(9) = -((6D0*C1(1)*QEPS*(S13+S14-S23-S24))/S34)-2D0*C2(2,
     &  2)*(3D0-4D0*XSW2)+(3D0-4D0*XSW2)/S34-(2D0*C2(1,1)*S12*(3D0-
     &  4D0*XSW2))/S34+(2D0*C2(1,2)*(S13+S14+S23+S24)*(3D0-4D0*
     &  XSW2))/S34+(C0*(-(3D0*S13)-3D0*QEPS*S13-3D0*S14-3D0*QEPS*
     &  S14-3D0*S23+3D0*QEPS*S23-3D0*S24+3D0*QEPS*S24+4D0*S13*XSW2+
     &  4D0*S14*XSW2+4D0*S23*XSW2+4D0*S24*XSW2+6D0*XMQM2(I)-8D0*
     &  XSW2*XMQM2(I)))/S34
        K(10) = (6D0*C1(1)*QEPS*(S13+S14-S23-S24))/S34-2D0*C2(2,2)*
     &  (3D0-4D0*XSW2)+(3D0-4D0*XSW2)/S34-(2D0*C2(1,1)*S12*(3D0-4D0*
     &  XSW2))/S34+(2D0*C2(1,2)*(S13+S14+S23+S24)*(3D0-4D0*XSW2))/
     &  S34+(C0*(-(3D0*S13)+3D0*QEPS*S13-3D0*S14+3D0*QEPS*S14-3D0*
     &  S23-3D0*QEPS*S23-3D0*S24-3D0*QEPS*S24+4D0*S13*XSW2+4D0*S14*
     &  XSW2+4D0*S23*XSW2+4D0*S24*XSW2+6D0*XMQM2(I)-8D0*XSW2*
     &  XMQM2(I)))/S34
        K(11) = -(3D0*S13)-3D0*QEPS*S13-3D0*S14-3D0*QEPS*S14-3D0*
     &  S23+3D0*QEPS*S23-3D0*S24+3D0*QEPS*S24+4D0*S13*XSW2+4D0*S14*
     &  XSW2+4D0*S23*XSW2+4D0*S24*XSW2+6D0*XMQM2(I)-8D0*XSW2*
     &  XMQM2(I)
        K(12) = -(3D0*S13)+3D0*QEPS*S13-3D0*S14+3D0*QEPS*S14-3D0*
     &  S23-3D0*QEPS*S23-3D0*S24-3D0*QEPS*S24+4D0*S13*XSW2+4D0*S14*
     &  XSW2+4D0*S23*XSW2+4D0*S24*XSW2+6D0*XMQM2(I)-8D0*XSW2*
     &  XMQM2(I)

        PRE = (QF(3)*ALPHA*CDOH*PZ12*XMQM2(I))/(96D0*PI*XCW2*XMW*
     &  XSW)

        F(1,-1,-1) = F(1,-1,-1)-(K(1)*K(9)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)-(K(1)*K(9)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*K(10)*QF(1)*PRE
        F(1,1,1) = F(1,1,1)+2D0*K(10)*QF(1)*PRE
        F(5,-1,-1) = F(5,-1,-1)-(2D0*K(1)*K(6)*PRE)/(S34*XSW2)
        F(5,-1,1) = F(5,-1,1)-(2D0*K(1)*K(6)*PRE)/(S34*XSW2)
        F(5,1,-1) = F(5,1,-1)+(4D0*K(5)*QF(1)*PRE)/S34
        F(5,1,1) = F(5,1,1)+(4D0*K(5)*QF(1)*PRE)/S34
        F(6,-1,-1) = F(6,-1,-1)-(2D0*K(1)*K(5)*PRE)/(S34*XSW2)
        F(6,-1,1) = F(6,-1,1)-(2D0*K(1)*K(5)*PRE)/(S34*XSW2)
        F(6,1,-1) = F(6,1,-1)+(4D0*K(6)*QF(1)*PRE)/S34
        F(6,1,1) = F(6,1,1)+(4D0*K(6)*QF(1)*PRE)/S34
        F(7,-1,-1) = F(7,-1,-1)-(2D0*K(1)*K(6)*PRE)/(S34*XSW2)
        F(7,-1,1) = F(7,-1,1)-(2D0*K(1)*K(6)*PRE)/(S34*XSW2)
        F(7,1,-1) = F(7,1,-1)+(4D0*K(5)*QF(1)*PRE)/S34
        F(7,1,1) = F(7,1,1)+(4D0*K(5)*QF(1)*PRE)/S34
        F(8,-1,-1) = F(8,-1,-1)-(2D0*K(1)*K(5)*PRE)/(S34*XSW2)
        F(8,-1,1) = F(8,-1,1)-(2D0*K(1)*K(5)*PRE)/(S34*XSW2)
        F(8,1,-1) = F(8,1,-1)+(4D0*K(6)*QF(1)*PRE)/S34
        F(8,1,1) = F(8,1,1)+(4D0*K(6)*QF(1)*PRE)/S34

C       G(T9,N2307,FULL)

C       G(T9,N2308,FULL)

C       G(T9,N2309,FULL)

C       G(T9,N2310,FULL)

C       G(T9,N2317,FULL)

C       G(T9,N2318,FULL)

C       G(T9,N2319,FULL)

C       G(T9,N2320,FULL)

C       G(T9,N2321,FULL)
        CALL xC01234_(S12,MHH2,S34,XMQM2(I),XMQM2(I),XMQM2(I),C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = 3D0-2D0*XSW2
        K(4) = 3D0-3D0*QEPS+4D0*QEPS*XSW2
        K(5) = 3D0+3D0*QEPS-4D0*QEPS*XSW2
        K(6) = 9D0-12D0*XSW2+8D0*XSW2**2
        K(7) = 9D0-6D0*XSW2+4D0*XSW2**2
        K(8) = S13+S14+S23+S24
        K(9) = 4D0*C0*(3D0-2D0*XSW2)+(3D0*C1(2)*(3D0+3D0*QEPS-4D0*
     &  QEPS*XSW2))/XSW2+(3D0*C1(1)*(3D0-3D0*QEPS+4D0*QEPS*XSW2))/
     &  XSW2+(4D0*C2(1,2)*(9D0-12D0*XSW2+8D0*XSW2**2))/XSW2
        K(10) = 4D0*C0*(3D0-2D0*XSW2)+(3D0*C1(1)*(3D0+3D0*QEPS-4D0*
     &  QEPS*XSW2))/XSW2+(3D0*C1(2)*(3D0-3D0*QEPS+4D0*QEPS*XSW2))/
     &  XSW2+(4D0*C2(1,2)*(9D0-12D0*XSW2+8D0*XSW2**2))/XSW2
        K(11) = S13+S14+S23+S24-2D0*XMQM2(I)
        K(12) = -((72D0*C2(0,0))/XSW2)-(3D0*C1(1)*(6D0*S12-3D0*S13-
     &  3D0*QEPS*S13-3D0*S14-3D0*QEPS*S14-3D0*S23+3D0*QEPS*S23-3D0*
     &  S24+3D0*QEPS*S24+4D0*QEPS*S13*XSW2+4D0*QEPS*S14*XSW2-4D0*
     &  QEPS*S23*XSW2-4D0*QEPS*S24*XSW2))/XSW2+(3D0*C1(2)*(3D0*S13-
     &  3D0*QEPS*S13+3D0*S14-3D0*QEPS*S14+3D0*S23+3D0*QEPS*S23+3D0*
     &  S24+3D0*QEPS*S24-6D0*S34+4D0*QEPS*S13*XSW2+4D0*QEPS*S14*
     &  XSW2-4D0*QEPS*S23*XSW2-4D0*QEPS*S24*XSW2))/XSW2+(2D0*(9D0-
     &  6D0*XSW2+4D0*XSW2**2))/XSW2-(4D0*C2(1,1)*S12*(9D0-6D0*XSW2+
     &  4D0*XSW2**2))/XSW2+(4D0*C2(1,2)*(S13+S14+S23+S24)*(9D0-6D0*
     &  XSW2+4D0*XSW2**2))/XSW2-(4D0*C2(2,2)*S34*(9D0-6D0*XSW2+4D0*
     &  XSW2**2))/XSW2+4D0*C0*(3D0-2D0*XSW2)*(S13+S14+S23+S24-2D0*
     &  XMQM2(I))
        K(13) = 6D0*S12-3D0*S13-3D0*QEPS*S13-3D0*S14-3D0*QEPS*S14-
     &  3D0*S23+3D0*QEPS*S23-3D0*S24+3D0*QEPS*S24+4D0*QEPS*S13*XSW2+
     &  4D0*QEPS*S14*XSW2-4D0*QEPS*S23*XSW2-4D0*QEPS*S24*XSW2
        K(14) = 6D0*S12-3D0*S13+3D0*QEPS*S13-3D0*S14+3D0*QEPS*S14-
     &  3D0*S23-3D0*QEPS*S23-3D0*S24-3D0*QEPS*S24-4D0*QEPS*S13*XSW2-
     &  4D0*QEPS*S14*XSW2+4D0*QEPS*S23*XSW2+4D0*QEPS*S24*XSW2
        K(15) = -(3D0*S13)-3D0*QEPS*S13-3D0*S14-3D0*QEPS*S14-3D0*
     &  S23+3D0*QEPS*S23-3D0*S24+3D0*QEPS*S24+6D0*S34+4D0*QEPS*S13*
     &  XSW2+4D0*QEPS*S14*XSW2-4D0*QEPS*S23*XSW2-4D0*QEPS*S24*XSW2
        K(16) = 3D0*S13-3D0*QEPS*S13+3D0*S14-3D0*QEPS*S14+3D0*S23+
     &  3D0*QEPS*S23+3D0*S24+3D0*QEPS*S24-6D0*S34+4D0*QEPS*S13*XSW2+
     &  4D0*QEPS*S14*XSW2-4D0*QEPS*S23*XSW2-4D0*QEPS*S24*XSW2

        PRE = -((ALPHA*CDOH*PZ12*PZ34*XCW2**(-2)*XMQM2(I))/(384D0*
     &  PI*XMW))

        F(1,-1,-1) = F(1,-1,-1)-(K(1)*K(12)*K(2)*PRE)/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*K(1)*K(12)*QF(3)*PRE)/XSW
        F(1,1,-1) = F(1,1,-1)+(2D0*K(2)*QF(1)*PRE*(-((72D0*C2(0,0))/
     &  XSW2)-(3D0*C1(1)*K(14))/XSW2-(3D0*C1(2)*K(15))/XSW2+(2D0*
     &  K(7))/XSW2+(4D0*C2(1,2)*K(7)*K(8))/XSW2-(4D0*C2(1,1)*K(7)*
     &  S12)/XSW2-(4D0*C2(2,2)*K(7)*S34)/XSW2+4D0*K(3)*C0*(K(8)-2D0*
     &  XMQM2(I))))/XSW
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*(-((72D0*C2(0,0))/
     &  XSW)-(3D0*C1(1)*K(14))/XSW-(3D0*C1(2)*K(15))/XSW+(2D0*K(7))/
     &  XSW+(4D0*C2(1,2)*K(7)*K(8))/XSW-(4D0*C2(1,1)*K(7)*S12)/XSW-
     &  (4D0*C2(2,2)*K(7)*S34)/XSW+4D0*K(3)*C0*XSW*(K(8)-2D0*
     &  XMQM2(I)))
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(1)*K(10)*K(2)*PRE)/(XSW*XSW2)
        F(5,-1,1) = F(5,-1,1)+(4D0*K(1)*K(10)*QF(3)*PRE)/XSW
        F(5,1,-1) = F(5,1,-1)-(4D0*K(2)*K(9)*QF(1)*PRE)/XSW
        F(5,1,1) = F(5,1,1)-8D0*QF(1)*QF(3)*PRE*(4D0*K(3)*C0*XSW+
     &  (3D0*C1(1)*K(4))/XSW+(3D0*C1(2)*K(5))/XSW+(4D0*C2(1,2)*
     &  K(6))/XSW)
        F(6,-1,-1) = F(6,-1,-1)+(2D0*K(1)*K(2)*K(9)*PRE)/(XSW*XSW2)
        F(6,-1,1) = F(6,-1,1)+(4D0*K(1)*K(9)*QF(3)*PRE)/XSW
        F(6,1,-1) = F(6,1,-1)-(4D0*K(10)*K(2)*QF(1)*PRE)/XSW
        F(6,1,1) = F(6,1,1)-8D0*QF(1)*QF(3)*PRE*(4D0*K(3)*C0*XSW+
     &  (3D0*C1(2)*K(4))/XSW+(3D0*C1(1)*K(5))/XSW+(4D0*C2(1,2)*
     &  K(6))/XSW)
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(1)*K(10)*K(2)*PRE)/(XSW*XSW2)
        F(7,-1,1) = F(7,-1,1)+(4D0*K(1)*K(10)*QF(3)*PRE)/XSW
        F(7,1,-1) = F(7,1,-1)-(4D0*K(2)*K(9)*QF(1)*PRE)/XSW
        F(7,1,1) = F(7,1,1)-8D0*QF(1)*QF(3)*PRE*(4D0*K(3)*C0*XSW+
     &  (3D0*C1(1)*K(4))/XSW+(3D0*C1(2)*K(5))/XSW+(4D0*C2(1,2)*
     &  K(6))/XSW)
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(1)*K(2)*K(9)*PRE)/(XSW*XSW2)
        F(8,-1,1) = F(8,-1,1)+(4D0*K(1)*K(9)*QF(3)*PRE)/XSW
        F(8,1,-1) = F(8,1,-1)-(4D0*K(10)*K(2)*QF(1)*PRE)/XSW
        F(8,1,1) = F(8,1,1)-8D0*QF(1)*QF(3)*PRE*(4D0*K(3)*C0*XSW+
     &  (3D0*C1(2)*K(4))/XSW+(3D0*C1(1)*K(5))/XSW+(4D0*C2(1,2)*
     &  K(6))/XSW)

C       G(T9,N2322,FULL)
        CALL xC01234_(S12,MHH2,S34,XMQP2(I),XMQP2(I),XMQP2(I),C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = 3D0-4D0*XSW2
        K(4) = 3D0-3D0*QEPS+8D0*QEPS*XSW2
        K(5) = 3D0+3D0*QEPS-8D0*QEPS*XSW2
        K(6) = 3D0-6D0*XSW+4D0*XSW2
        K(7) = 3D0+6D0*XSW+4D0*XSW2
        K(8) = 9D0-24D0*XSW2+32D0*XSW2**2
        K(9) = S13+S14+S23+S24
        K(10) = 8D0*C0*(3D0-4D0*XSW2)+(3D0*C1(2)*(3D0+3D0*QEPS-8D0*
     &  QEPS*XSW2))/XSW2+(3D0*C1(1)*(3D0-3D0*QEPS+8D0*QEPS*XSW2))/
     &  XSW2+(4D0*C2(1,2)*(9D0-24D0*XSW2+32D0*XSW2**2))/XSW2
        K(11) = 8D0*C0*(3D0-4D0*XSW2)+(3D0*C1(1)*(3D0+3D0*QEPS-8D0*
     &  QEPS*XSW2))/XSW2+(3D0*C1(2)*(3D0-3D0*QEPS+8D0*QEPS*XSW2))/
     &  XSW2+(4D0*C2(1,2)*(9D0-24D0*XSW2+32D0*XSW2**2))/XSW2
        K(12) = S13+S14+S23+S24-2D0*XMQP2(I)
        K(13) = -((72D0*C2(0,0))/XSW2)+(2D0*(3D0-6D0*XSW+4D0*XSW2)*
     &  (3D0+6D0*XSW+4D0*XSW2))/XSW2-(4D0*C2(1,1)*S12*(3D0-6D0*XSW+
     &  4D0*XSW2)*(3D0+6D0*XSW+4D0*XSW2))/XSW2+(4D0*C2(1,2)*(S13+
     &  S14+S23+S24)*(3D0-6D0*XSW+4D0*XSW2)*(3D0+6D0*XSW+4D0*XSW2))/
     &  XSW2-(4D0*C2(2,2)*S34*(3D0-6D0*XSW+4D0*XSW2)*(3D0+6D0*XSW+
     &  4D0*XSW2))/XSW2-(3D0*C1(1)*(6D0*S12-3D0*S13-3D0*QEPS*S13-
     &  3D0*S14-3D0*QEPS*S14-3D0*S23+3D0*QEPS*S23-3D0*S24+3D0*QEPS*
     &  S24+8D0*QEPS*S13*XSW2+8D0*QEPS*S14*XSW2-8D0*QEPS*S23*XSW2-
     &  8D0*QEPS*S24*XSW2))/XSW2+(3D0*C1(2)*(3D0*S13-3D0*QEPS*S13+
     &  3D0*S14-3D0*QEPS*S14+3D0*S23+3D0*QEPS*S23+3D0*S24+3D0*QEPS*
     &  S24-6D0*S34+8D0*QEPS*S13*XSW2+8D0*QEPS*S14*XSW2-8D0*QEPS*
     &  S23*XSW2-8D0*QEPS*S24*XSW2))/XSW2+8D0*C0*(3D0-4D0*XSW2)*
     &  (S13+S14+S23+S24-2D0*XMQP2(I))
        K(14) = 6D0*S12-3D0*S13-3D0*QEPS*S13-3D0*S14-3D0*QEPS*S14-
     &  3D0*S23+3D0*QEPS*S23-3D0*S24+3D0*QEPS*S24+8D0*QEPS*S13*XSW2+
     &  8D0*QEPS*S14*XSW2-8D0*QEPS*S23*XSW2-8D0*QEPS*S24*XSW2
        K(15) = 6D0*S12-3D0*S13+3D0*QEPS*S13-3D0*S14+3D0*QEPS*S14-
     &  3D0*S23-3D0*QEPS*S23-3D0*S24-3D0*QEPS*S24-8D0*QEPS*S13*XSW2-
     &  8D0*QEPS*S14*XSW2+8D0*QEPS*S23*XSW2+8D0*QEPS*S24*XSW2
        K(16) = -(3D0*S13)-3D0*QEPS*S13-3D0*S14-3D0*QEPS*S14-3D0*
     &  S23+3D0*QEPS*S23-3D0*S24+3D0*QEPS*S24+6D0*S34+8D0*QEPS*S13*
     &  XSW2+8D0*QEPS*S14*XSW2-8D0*QEPS*S23*XSW2-8D0*QEPS*S24*XSW2
        K(17) = 3D0*S13-3D0*QEPS*S13+3D0*S14-3D0*QEPS*S14+3D0*S23+
     &  3D0*QEPS*S23+3D0*S24+3D0*QEPS*S24-6D0*S34+8D0*QEPS*S13*XSW2+
     &  8D0*QEPS*S14*XSW2-8D0*QEPS*S23*XSW2-8D0*QEPS*S24*XSW2

        PRE = -((ALPHA*CUPH*PZ12*PZ34*XCW2**(-2)*XMQP2(I))/(384D0*
     &  PI*XMW))

        F(1,-1,-1) = F(1,-1,-1)-(K(1)*K(13)*K(2)*PRE)/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*K(1)*K(13)*QF(3)*PRE)/XSW
        F(1,1,-1) = F(1,1,-1)+(2D0*K(2)*QF(1)*PRE*(-((72D0*C2(0,0))/
     &  XSW2)-(3D0*C1(1)*K(15))/XSW2-(3D0*C1(2)*K(16))/XSW2+(2D0*
     &  K(6)*K(7))/XSW2+(4D0*C2(1,2)*K(6)*K(7)*K(9))/XSW2-(4D0*C2(1,
     &  1)*K(6)*K(7)*S12)/XSW2-(4D0*C2(2,2)*K(6)*K(7)*S34)/XSW2+8D0*
     &  K(3)*C0*(K(9)-2D0*XMQP2(I))))/XSW
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*(-((72D0*C2(0,0))/
     &  XSW)-(3D0*C1(1)*K(15))/XSW-(3D0*C1(2)*K(16))/XSW+(2D0*K(6)*
     &  K(7))/XSW+(4D0*C2(1,2)*K(6)*K(7)*K(9))/XSW-(4D0*C2(1,1)*
     &  K(6)*K(7)*S12)/XSW-(4D0*C2(2,2)*K(6)*K(7)*S34)/XSW+8D0*K(3)*
     &  C0*XSW*(K(9)-2D0*XMQP2(I)))
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(1)*K(11)*K(2)*PRE)/(XSW*XSW2)
        F(5,-1,1) = F(5,-1,1)+(4D0*K(1)*K(11)*QF(3)*PRE)/XSW
        F(5,1,-1) = F(5,1,-1)-(4D0*K(10)*K(2)*QF(1)*PRE)/XSW
        F(5,1,1) = F(5,1,1)-8D0*QF(1)*QF(3)*PRE*(8D0*K(3)*C0*XSW+
     &  (3D0*C1(1)*K(4))/XSW+(3D0*C1(2)*K(5))/XSW+(4D0*C2(1,2)*
     &  K(8))/XSW)
        F(6,-1,-1) = F(6,-1,-1)+(2D0*K(1)*K(10)*K(2)*PRE)/(XSW*XSW2)
        F(6,-1,1) = F(6,-1,1)+(4D0*K(1)*K(10)*QF(3)*PRE)/XSW
        F(6,1,-1) = F(6,1,-1)-(4D0*K(11)*K(2)*QF(1)*PRE)/XSW
        F(6,1,1) = F(6,1,1)-8D0*QF(1)*QF(3)*PRE*(8D0*K(3)*C0*XSW+
     &  (3D0*C1(2)*K(4))/XSW+(3D0*C1(1)*K(5))/XSW+(4D0*C2(1,2)*
     &  K(8))/XSW)
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(1)*K(11)*K(2)*PRE)/(XSW*XSW2)
        F(7,-1,1) = F(7,-1,1)+(4D0*K(1)*K(11)*QF(3)*PRE)/XSW
        F(7,1,-1) = F(7,1,-1)-(4D0*K(10)*K(2)*QF(1)*PRE)/XSW
        F(7,1,1) = F(7,1,1)-8D0*QF(1)*QF(3)*PRE*(8D0*K(3)*C0*XSW+
     &  (3D0*C1(1)*K(4))/XSW+(3D0*C1(2)*K(5))/XSW+(4D0*C2(1,2)*
     &  K(8))/XSW)
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(1)*K(10)*K(2)*PRE)/(XSW*XSW2)
        F(8,-1,1) = F(8,-1,1)+(4D0*K(1)*K(10)*QF(3)*PRE)/XSW
        F(8,1,-1) = F(8,1,-1)-(4D0*K(11)*K(2)*QF(1)*PRE)/XSW
        F(8,1,1) = F(8,1,1)-8D0*QF(1)*QF(3)*PRE*(8D0*K(3)*C0*XSW+
     &  (3D0*C1(2)*K(4))/XSW+(3D0*C1(1)*K(5))/XSW+(4D0*C2(1,2)*
     &  K(8))/XSW)

C       G(T9,N2323,FULL)
        CALL xC01234_(S12,MHH2,S34,XML2(I),XML2(I),XML2(I),C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,2,0)
        K(1) = 1D0-2D0*XSW2
        K(2) = 1D0-2D0*QF(1)*XSW2
        K(3) = 1D0+2D0*QF(3)*XSW2
        K(4) = 1D0-QEPS+4D0*QEPS*XSW2
        K(5) = 1D0+QEPS-4D0*QEPS*XSW2
        K(6) = 1D0-4D0*XSW2+8D0*XSW2**2
        K(7) = 1D0-2D0*XSW2+4D0*XSW2**2
        K(8) = S13+S14+S23+S24
        K(9) = 4D0*C0*(1D0-2D0*XSW2)+(C1(2)*(1D0+QEPS-4D0*QEPS*
     &  XSW2))/XSW2+(C1(1)*(1D0-QEPS+4D0*QEPS*XSW2))/XSW2+(4D0*C2(1,
     &  2)*(1D0-4D0*XSW2+8D0*XSW2**2))/XSW2
        K(10) = 4D0*C0*(1D0-2D0*XSW2)+(C1(1)*(1D0+QEPS-4D0*QEPS*
     &  XSW2))/XSW2+(C1(2)*(1D0-QEPS+4D0*QEPS*XSW2))/XSW2+(4D0*C2(1,
     &  2)*(1D0-4D0*XSW2+8D0*XSW2**2))/XSW2
        K(11) = S13+S14+S23+S24-2D0*XML2(I)
        K(12) = -((8D0*C2(0,0))/XSW2)-(C1(1)*(2D0*S12-S13-QEPS*S13-
     &  S14-QEPS*S14-S23+QEPS*S23-S24+QEPS*S24+4D0*QEPS*S13*XSW2+
     &  4D0*QEPS*S14*XSW2-4D0*QEPS*S23*XSW2-4D0*QEPS*S24*XSW2))/
     &  XSW2+(C1(2)*(S13-QEPS*S13+S14-QEPS*S14+S23+QEPS*S23+S24+
     &  QEPS*S24-2D0*S34+4D0*QEPS*S13*XSW2+4D0*QEPS*S14*XSW2-4D0*
     &  QEPS*S23*XSW2-4D0*QEPS*S24*XSW2))/XSW2+(2D0*(1D0-2D0*XSW2+
     &  4D0*XSW2**2))/XSW2-(4D0*C2(1,1)*S12*(1D0-2D0*XSW2+4D0*XSW2**
     &  2))/XSW2+(4D0*C2(1,2)*(S13+S14+S23+S24)*(1D0-2D0*XSW2+4D0*
     &  XSW2**2))/XSW2-(4D0*C2(2,2)*S34*(1D0-2D0*XSW2+4D0*XSW2**2))/
     &  XSW2+4D0*C0*(1D0-2D0*XSW2)*(S13+S14+S23+S24-2D0*XML2(I))
        K(13) = 2D0*S12-S13-QEPS*S13-S14-QEPS*S14-S23+QEPS*S23-S24+
     &  QEPS*S24+4D0*QEPS*S13*XSW2+4D0*QEPS*S14*XSW2-4D0*QEPS*S23*
     &  XSW2-4D0*QEPS*S24*XSW2
        K(14) = 2D0*S12-S13+QEPS*S13-S14+QEPS*S14-S23-QEPS*S23-S24-
     &  QEPS*S24-4D0*QEPS*S13*XSW2-4D0*QEPS*S14*XSW2+4D0*QEPS*S23*
     &  XSW2+4D0*QEPS*S24*XSW2
        K(15) = S13-QEPS*S13+S14-QEPS*S14+S23+QEPS*S23+S24+QEPS*S24-
     &  2D0*S34+4D0*QEPS*S13*XSW2+4D0*QEPS*S14*XSW2-4D0*QEPS*S23*
     &  XSW2-4D0*QEPS*S24*XSW2
        K(16) = S13+QEPS*S13+S14+QEPS*S14+S23-QEPS*S23+S24-QEPS*S24-
     &  2D0*S34-4D0*QEPS*S13*XSW2-4D0*QEPS*S14*XSW2+4D0*QEPS*S23*
     &  XSW2+4D0*QEPS*S24*XSW2

        PRE = -((ALPHA*CLEPH*PZ12*PZ34*XCW2**(-2)*XML2(I))/(128D0*
     &  PI*XMW))

        F(1,-1,-1) = F(1,-1,-1)-(K(12)*K(2)*K(3)*PRE)/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*K(12)*K(2)*QF(3)*PRE)/XSW
        F(1,1,-1) = F(1,1,-1)+(2D0*K(3)*QF(1)*PRE*(-((8D0*C2(0,0))/
     &  XSW2)-(C1(1)*K(14))/XSW2+(C1(2)*(K(8)+QEPS*S13+QEPS*S14-
     &  QEPS*S23-QEPS*S24-2D0*S34-4D0*QEPS*S13*XSW2-4D0*QEPS*S14*
     &  XSW2+4D0*QEPS*S23*XSW2+4D0*QEPS*S24*XSW2))/XSW2+(2D0*(K(1)+
     &  4D0*XSW2**2))/XSW2+(4D0*C2(1,2)*K(8)*(K(1)+4D0*XSW2**2))/
     &  XSW2-(4D0*C2(1,1)*S12*(K(1)+4D0*XSW2**2))/XSW2-(4D0*C2(2,2)*
     &  S34*(K(1)+4D0*XSW2**2))/XSW2+4D0*K(1)*C0*(K(8)-2D0*
     &  XML2(I))))/XSW
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*(-((8D0*C2(0,0))/
     &  XSW)-(C1(1)*K(14))/XSW+(C1(2)*(K(8)+QEPS*S13+QEPS*S14-QEPS*
     &  S23-QEPS*S24-2D0*S34-4D0*QEPS*S13*XSW2-4D0*QEPS*S14*XSW2+
     &  4D0*QEPS*S23*XSW2+4D0*QEPS*S24*XSW2))/XSW+(2D0*(K(1)+4D0*
     &  XSW2**2))/XSW+(4D0*C2(1,2)*K(8)*(K(1)+4D0*XSW2**2))/XSW-
     &  (4D0*C2(1,1)*S12*(K(1)+4D0*XSW2**2))/XSW-(4D0*C2(2,2)*S34*
     &  (K(1)+4D0*XSW2**2))/XSW+4D0*K(1)*C0*XSW*(K(8)-2D0*XML2(I)))
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(10)*K(2)*K(3)*PRE)/(XSW*XSW2)
        F(5,-1,1) = F(5,-1,1)+(4D0*K(10)*K(2)*QF(3)*PRE)/XSW
        F(5,1,-1) = F(5,1,-1)-(4D0*K(3)*K(9)*QF(1)*PRE)/XSW
        F(5,1,1) = F(5,1,1)-8D0*QF(1)*QF(3)*PRE*(4D0*K(1)*C0*XSW+
     &  (C1(1)*K(4))/XSW+(C1(2)*K(5))/XSW+(4D0*C2(1,2)*K(6))/XSW)
        F(6,-1,-1) = F(6,-1,-1)+(2D0*K(2)*K(3)*K(9)*PRE)/(XSW*XSW2)
        F(6,-1,1) = F(6,-1,1)+(4D0*K(2)*K(9)*QF(3)*PRE)/XSW
        F(6,1,-1) = F(6,1,-1)-(4D0*K(10)*K(3)*QF(1)*PRE)/XSW
        F(6,1,1) = F(6,1,1)-8D0*QF(1)*QF(3)*PRE*(4D0*K(1)*C0*XSW+
     &  (C1(2)*K(4))/XSW+(C1(1)*K(5))/XSW+(4D0*C2(1,2)*K(6))/XSW)
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(10)*K(2)*K(3)*PRE)/(XSW*XSW2)
        F(7,-1,1) = F(7,-1,1)+(4D0*K(10)*K(2)*QF(3)*PRE)/XSW
        F(7,1,-1) = F(7,1,-1)-(4D0*K(3)*K(9)*QF(1)*PRE)/XSW
        F(7,1,1) = F(7,1,1)-8D0*QF(1)*QF(3)*PRE*(4D0*K(1)*C0*XSW+
     &  (C1(1)*K(4))/XSW+(C1(2)*K(5))/XSW+(4D0*C2(1,2)*K(6))/XSW)
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(2)*K(3)*K(9)*PRE)/(XSW*XSW2)
        F(8,-1,1) = F(8,-1,1)+(4D0*K(2)*K(9)*QF(3)*PRE)/XSW
        F(8,1,-1) = F(8,1,-1)-(4D0*K(10)*K(3)*QF(1)*PRE)/XSW
        F(8,1,1) = F(8,1,1)-8D0*QF(1)*QF(3)*PRE*(4D0*K(1)*C0*XSW+
     &  (C1(2)*K(4))/XSW+(C1(1)*K(5))/XSW+(4D0*C2(1,2)*K(6))/XSW)

C       G(T9,N2324,FULL)
        CALL xC01234_(S12,MHH2,S34,XML2(I),XML2(I),XML2(I),C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,2,0)
        K(1) = 1D0-2D0*XSW2
        K(2) = 1D0-2D0*QF(1)*XSW2
        K(3) = 1D0+2D0*QF(3)*XSW2
        K(4) = 1D0-QEPS+4D0*QEPS*XSW2
        K(5) = 1D0+QEPS-4D0*QEPS*XSW2
        K(6) = 1D0-4D0*XSW2+8D0*XSW2**2
        K(7) = 1D0-2D0*XSW2+4D0*XSW2**2
        K(8) = S13+S14+S23+S24
        K(9) = 4D0*C0*(1D0-2D0*XSW2)+(C1(2)*(1D0+QEPS-4D0*QEPS*
     &  XSW2))/XSW2+(C1(1)*(1D0-QEPS+4D0*QEPS*XSW2))/XSW2+(4D0*C2(1,
     &  2)*(1D0-4D0*XSW2+8D0*XSW2**2))/XSW2
        K(10) = 4D0*C0*(1D0-2D0*XSW2)+(C1(1)*(1D0+QEPS-4D0*QEPS*
     &  XSW2))/XSW2+(C1(2)*(1D0-QEPS+4D0*QEPS*XSW2))/XSW2+(4D0*C2(1,
     &  2)*(1D0-4D0*XSW2+8D0*XSW2**2))/XSW2
        K(11) = S13+S14+S23+S24-2D0*XML2(I)
        K(12) = -((8D0*C2(0,0))/XSW2)-(C1(1)*(2D0*S12-S13+QEPS*S13-
     &  S14+QEPS*S14-S23-QEPS*S23-S24-QEPS*S24-4D0*QEPS*S13*XSW2-
     &  4D0*QEPS*S14*XSW2+4D0*QEPS*S23*XSW2+4D0*QEPS*S24*XSW2))/
     &  XSW2+(C1(2)*(S13+QEPS*S13+S14+QEPS*S14+S23-QEPS*S23+S24-
     &  QEPS*S24-2D0*S34-4D0*QEPS*S13*XSW2-4D0*QEPS*S14*XSW2+4D0*
     &  QEPS*S23*XSW2+4D0*QEPS*S24*XSW2))/XSW2+(2D0*(1D0-2D0*XSW2+
     &  4D0*XSW2**2))/XSW2-(4D0*C2(1,1)*S12*(1D0-2D0*XSW2+4D0*XSW2**
     &  2))/XSW2+(4D0*C2(1,2)*(S13+S14+S23+S24)*(1D0-2D0*XSW2+4D0*
     &  XSW2**2))/XSW2-(4D0*C2(2,2)*S34*(1D0-2D0*XSW2+4D0*XSW2**2))/
     &  XSW2+4D0*C0*(1D0-2D0*XSW2)*(S13+S14+S23+S24-2D0*XML2(I))
        K(13) = 2D0*S12-S13-QEPS*S13-S14-QEPS*S14-S23+QEPS*S23-S24+
     &  QEPS*S24+4D0*QEPS*S13*XSW2+4D0*QEPS*S14*XSW2-4D0*QEPS*S23*
     &  XSW2-4D0*QEPS*S24*XSW2
        K(14) = 2D0*S12-S13+QEPS*S13-S14+QEPS*S14-S23-QEPS*S23-S24-
     &  QEPS*S24-4D0*QEPS*S13*XSW2-4D0*QEPS*S14*XSW2+4D0*QEPS*S23*
     &  XSW2+4D0*QEPS*S24*XSW2
        K(15) = S13-QEPS*S13+S14-QEPS*S14+S23+QEPS*S23+S24+QEPS*S24-
     &  2D0*S34+4D0*QEPS*S13*XSW2+4D0*QEPS*S14*XSW2-4D0*QEPS*S23*
     &  XSW2-4D0*QEPS*S24*XSW2
        K(16) = S13+QEPS*S13+S14+QEPS*S14+S23-QEPS*S23+S24-QEPS*S24-
     &  2D0*S34-4D0*QEPS*S13*XSW2-4D0*QEPS*S14*XSW2+4D0*QEPS*S23*
     &  XSW2+4D0*QEPS*S24*XSW2

        PRE = -((ALPHA*CLEPH*PZ12*PZ34*XCW2**(-2)*XML2(I))/(128D0*
     &  PI*XMW))

        F(1,-1,-1) = F(1,-1,-1)-(K(12)*K(2)*K(3)*PRE)/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*K(12)*K(2)*QF(3)*PRE)/XSW
        F(1,1,-1) = F(1,1,-1)+(2D0*K(3)*QF(1)*PRE*(-((8D0*C2(0,0))/
     &  XSW2)-(C1(1)*K(13))/XSW2+(C1(2)*(K(8)-QEPS*S13-QEPS*S14+
     &  QEPS*S23+QEPS*S24-2D0*S34+4D0*QEPS*S13*XSW2+4D0*QEPS*S14*
     &  XSW2-4D0*QEPS*S23*XSW2-4D0*QEPS*S24*XSW2))/XSW2+(2D0*(K(1)+
     &  4D0*XSW2**2))/XSW2+(4D0*C2(1,2)*K(8)*(K(1)+4D0*XSW2**2))/
     &  XSW2-(4D0*C2(1,1)*S12*(K(1)+4D0*XSW2**2))/XSW2-(4D0*C2(2,2)*
     &  S34*(K(1)+4D0*XSW2**2))/XSW2+4D0*K(1)*C0*(K(8)-2D0*
     &  XML2(I))))/XSW
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*(-((8D0*C2(0,0))/
     &  XSW)-(C1(1)*K(13))/XSW+(C1(2)*(K(8)-QEPS*S13-QEPS*S14+QEPS*
     &  S23+QEPS*S24-2D0*S34+4D0*QEPS*S13*XSW2+4D0*QEPS*S14*XSW2-
     &  4D0*QEPS*S23*XSW2-4D0*QEPS*S24*XSW2))/XSW+(2D0*(K(1)+4D0*
     &  XSW2**2))/XSW+(4D0*C2(1,2)*K(8)*(K(1)+4D0*XSW2**2))/XSW-
     &  (4D0*C2(1,1)*S12*(K(1)+4D0*XSW2**2))/XSW-(4D0*C2(2,2)*S34*
     &  (K(1)+4D0*XSW2**2))/XSW+4D0*K(1)*C0*XSW*(K(8)-2D0*XML2(I)))
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(2)*K(3)*K(9)*PRE)/(XSW*XSW2)
        F(5,-1,1) = F(5,-1,1)+(4D0*K(2)*K(9)*QF(3)*PRE)/XSW
        F(5,1,-1) = F(5,1,-1)-(4D0*K(10)*K(3)*QF(1)*PRE)/XSW
        F(5,1,1) = F(5,1,1)-8D0*QF(1)*QF(3)*PRE*(4D0*K(1)*C0*XSW+
     &  (C1(2)*K(4))/XSW+(C1(1)*K(5))/XSW+(4D0*C2(1,2)*K(6))/XSW)
        F(6,-1,-1) = F(6,-1,-1)+(2D0*K(10)*K(2)*K(3)*PRE)/(XSW*XSW2)
        F(6,-1,1) = F(6,-1,1)+(4D0*K(10)*K(2)*QF(3)*PRE)/XSW
        F(6,1,-1) = F(6,1,-1)-(4D0*K(3)*K(9)*QF(1)*PRE)/XSW
        F(6,1,1) = F(6,1,1)-8D0*QF(1)*QF(3)*PRE*(4D0*K(1)*C0*XSW+
     &  (C1(1)*K(4))/XSW+(C1(2)*K(5))/XSW+(4D0*C2(1,2)*K(6))/XSW)
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(2)*K(3)*K(9)*PRE)/(XSW*XSW2)
        F(7,-1,1) = F(7,-1,1)+(4D0*K(2)*K(9)*QF(3)*PRE)/XSW
        F(7,1,-1) = F(7,1,-1)-(4D0*K(10)*K(3)*QF(1)*PRE)/XSW
        F(7,1,1) = F(7,1,1)-8D0*QF(1)*QF(3)*PRE*(4D0*K(1)*C0*XSW+
     &  (C1(2)*K(4))/XSW+(C1(1)*K(5))/XSW+(4D0*C2(1,2)*K(6))/XSW)
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(10)*K(2)*K(3)*PRE)/(XSW*XSW2)
        F(8,-1,1) = F(8,-1,1)+(4D0*K(10)*K(2)*QF(3)*PRE)/XSW
        F(8,1,-1) = F(8,1,-1)-(4D0*K(3)*K(9)*QF(1)*PRE)/XSW
        F(8,1,1) = F(8,1,1)-8D0*QF(1)*QF(3)*PRE*(4D0*K(1)*C0*XSW+
     &  (C1(1)*K(4))/XSW+(C1(2)*K(5))/XSW+(4D0*C2(1,2)*K(6))/XSW)

C       G(T9,N2325,FULL)
        CALL xC01234_(S12,MHH2,S34,XMQP2(I),XMQP2(I),XMQP2(I),C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = 3D0-4D0*XSW2
        K(4) = 3D0-3D0*QEPS+8D0*QEPS*XSW2
        K(5) = 3D0+3D0*QEPS-8D0*QEPS*XSW2
        K(6) = 3D0-6D0*XSW+4D0*XSW2
        K(7) = 3D0+6D0*XSW+4D0*XSW2
        K(8) = 9D0-24D0*XSW2+32D0*XSW2**2
        K(9) = S13+S14+S23+S24
        K(10) = 8D0*C0*(3D0-4D0*XSW2)+(3D0*C1(2)*(3D0+3D0*QEPS-8D0*
     &  QEPS*XSW2))/XSW2+(3D0*C1(1)*(3D0-3D0*QEPS+8D0*QEPS*XSW2))/
     &  XSW2+(4D0*C2(1,2)*(9D0-24D0*XSW2+32D0*XSW2**2))/XSW2
        K(11) = 8D0*C0*(3D0-4D0*XSW2)+(3D0*C1(1)*(3D0+3D0*QEPS-8D0*
     &  QEPS*XSW2))/XSW2+(3D0*C1(2)*(3D0-3D0*QEPS+8D0*QEPS*XSW2))/
     &  XSW2+(4D0*C2(1,2)*(9D0-24D0*XSW2+32D0*XSW2**2))/XSW2
        K(12) = S13+S14+S23+S24-2D0*XMQP2(I)
        K(13) = -((72D0*C2(0,0))/XSW2)+(2D0*(3D0-6D0*XSW+4D0*XSW2)*
     &  (3D0+6D0*XSW+4D0*XSW2))/XSW2-(4D0*C2(1,1)*S12*(3D0-6D0*XSW+
     &  4D0*XSW2)*(3D0+6D0*XSW+4D0*XSW2))/XSW2+(4D0*C2(1,2)*(S13+
     &  S14+S23+S24)*(3D0-6D0*XSW+4D0*XSW2)*(3D0+6D0*XSW+4D0*XSW2))/
     &  XSW2-(4D0*C2(2,2)*S34*(3D0-6D0*XSW+4D0*XSW2)*(3D0+6D0*XSW+
     &  4D0*XSW2))/XSW2-(3D0*C1(2)*(-(3D0*S13)-3D0*QEPS*S13-3D0*S14-
     &  3D0*QEPS*S14-3D0*S23+3D0*QEPS*S23-3D0*S24+3D0*QEPS*S24+6D0*
     &  S34+8D0*QEPS*S13*XSW2+8D0*QEPS*S14*XSW2-8D0*QEPS*S23*XSW2-
     &  8D0*QEPS*S24*XSW2))/XSW2-(3D0*C1(1)*(6D0*S12-3D0*S13+3D0*
     &  QEPS*S13-3D0*S14+3D0*QEPS*S14-3D0*S23-3D0*QEPS*S23-3D0*S24-
     &  3D0*QEPS*S24-8D0*QEPS*S13*XSW2-8D0*QEPS*S14*XSW2+8D0*QEPS*
     &  S23*XSW2+8D0*QEPS*S24*XSW2))/XSW2+8D0*C0*(3D0-4D0*XSW2)*
     &  (S13+S14+S23+S24-2D0*XMQP2(I))
        K(14) = 6D0*S12-3D0*S13-3D0*QEPS*S13-3D0*S14-3D0*QEPS*S14-
     &  3D0*S23+3D0*QEPS*S23-3D0*S24+3D0*QEPS*S24+8D0*QEPS*S13*XSW2+
     &  8D0*QEPS*S14*XSW2-8D0*QEPS*S23*XSW2-8D0*QEPS*S24*XSW2
        K(15) = 6D0*S12-3D0*S13+3D0*QEPS*S13-3D0*S14+3D0*QEPS*S14-
     &  3D0*S23-3D0*QEPS*S23-3D0*S24-3D0*QEPS*S24-8D0*QEPS*S13*XSW2-
     &  8D0*QEPS*S14*XSW2+8D0*QEPS*S23*XSW2+8D0*QEPS*S24*XSW2
        K(16) = -(3D0*S13)-3D0*QEPS*S13-3D0*S14-3D0*QEPS*S14-3D0*
     &  S23+3D0*QEPS*S23-3D0*S24+3D0*QEPS*S24+6D0*S34+8D0*QEPS*S13*
     &  XSW2+8D0*QEPS*S14*XSW2-8D0*QEPS*S23*XSW2-8D0*QEPS*S24*XSW2
        K(17) = 3D0*S13-3D0*QEPS*S13+3D0*S14-3D0*QEPS*S14+3D0*S23+
     &  3D0*QEPS*S23+3D0*S24+3D0*QEPS*S24-6D0*S34+8D0*QEPS*S13*XSW2+
     &  8D0*QEPS*S14*XSW2-8D0*QEPS*S23*XSW2-8D0*QEPS*S24*XSW2

        PRE = -((ALPHA*CUPH*PZ12*PZ34*XCW2**(-2)*XMQP2(I))/(384D0*
     &  PI*XMW))

        F(1,-1,-1) = F(1,-1,-1)-(K(1)*K(13)*K(2)*PRE)/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*K(1)*K(13)*QF(3)*PRE)/XSW
        F(1,1,-1) = F(1,1,-1)+(2D0*K(2)*QF(1)*PRE*(-((72D0*C2(0,0))/
     &  XSW2)-(3D0*C1(1)*K(14))/XSW2+(3D0*C1(2)*K(17))/XSW2+(2D0*
     &  K(6)*K(7))/XSW2+(4D0*C2(1,2)*K(6)*K(7)*K(9))/XSW2-(4D0*C2(1,
     &  1)*K(6)*K(7)*S12)/XSW2-(4D0*C2(2,2)*K(6)*K(7)*S34)/XSW2+8D0*
     &  K(3)*C0*(K(9)-2D0*XMQP2(I))))/XSW
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*(-((72D0*C2(0,0))/
     &  XSW)-(3D0*C1(1)*K(14))/XSW+(3D0*C1(2)*K(17))/XSW+(2D0*K(6)*
     &  K(7))/XSW+(4D0*C2(1,2)*K(6)*K(7)*K(9))/XSW-(4D0*C2(1,1)*
     &  K(6)*K(7)*S12)/XSW-(4D0*C2(2,2)*K(6)*K(7)*S34)/XSW+8D0*K(3)*
     &  C0*XSW*(K(9)-2D0*XMQP2(I)))
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(1)*K(10)*K(2)*PRE)/(XSW*XSW2)
        F(5,-1,1) = F(5,-1,1)+(4D0*K(1)*K(10)*QF(3)*PRE)/XSW
        F(5,1,-1) = F(5,1,-1)-(4D0*K(11)*K(2)*QF(1)*PRE)/XSW
        F(5,1,1) = F(5,1,1)-8D0*QF(1)*QF(3)*PRE*(8D0*K(3)*C0*XSW+
     &  (3D0*C1(2)*K(4))/XSW+(3D0*C1(1)*K(5))/XSW+(4D0*C2(1,2)*
     &  K(8))/XSW)
        F(6,-1,-1) = F(6,-1,-1)+(2D0*K(1)*K(11)*K(2)*PRE)/(XSW*XSW2)
        F(6,-1,1) = F(6,-1,1)+(4D0*K(1)*K(11)*QF(3)*PRE)/XSW
        F(6,1,-1) = F(6,1,-1)-(4D0*K(10)*K(2)*QF(1)*PRE)/XSW
        F(6,1,1) = F(6,1,1)-8D0*QF(1)*QF(3)*PRE*(8D0*K(3)*C0*XSW+
     &  (3D0*C1(1)*K(4))/XSW+(3D0*C1(2)*K(5))/XSW+(4D0*C2(1,2)*
     &  K(8))/XSW)
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(1)*K(10)*K(2)*PRE)/(XSW*XSW2)
        F(7,-1,1) = F(7,-1,1)+(4D0*K(1)*K(10)*QF(3)*PRE)/XSW
        F(7,1,-1) = F(7,1,-1)-(4D0*K(11)*K(2)*QF(1)*PRE)/XSW
        F(7,1,1) = F(7,1,1)-8D0*QF(1)*QF(3)*PRE*(8D0*K(3)*C0*XSW+
     &  (3D0*C1(2)*K(4))/XSW+(3D0*C1(1)*K(5))/XSW+(4D0*C2(1,2)*
     &  K(8))/XSW)
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(1)*K(11)*K(2)*PRE)/(XSW*XSW2)
        F(8,-1,1) = F(8,-1,1)+(4D0*K(1)*K(11)*QF(3)*PRE)/XSW
        F(8,1,-1) = F(8,1,-1)-(4D0*K(10)*K(2)*QF(1)*PRE)/XSW
        F(8,1,1) = F(8,1,1)-8D0*QF(1)*QF(3)*PRE*(8D0*K(3)*C0*XSW+
     &  (3D0*C1(1)*K(4))/XSW+(3D0*C1(2)*K(5))/XSW+(4D0*C2(1,2)*
     &  K(8))/XSW)

C       G(T9,N2326,FULL)
        CALL xC01234_(S12,MHH2,S34,XMQM2(I),XMQM2(I),XMQM2(I),C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = 3D0-2D0*XSW2
        K(4) = 3D0-3D0*QEPS+4D0*QEPS*XSW2
        K(5) = 3D0+3D0*QEPS-4D0*QEPS*XSW2
        K(6) = 9D0-12D0*XSW2+8D0*XSW2**2
        K(7) = 9D0-6D0*XSW2+4D0*XSW2**2
        K(8) = S13+S14+S23+S24
        K(9) = 4D0*C0*(3D0-2D0*XSW2)+(3D0*C1(2)*(3D0+3D0*QEPS-4D0*
     &  QEPS*XSW2))/XSW2+(3D0*C1(1)*(3D0-3D0*QEPS+4D0*QEPS*XSW2))/
     &  XSW2+(4D0*C2(1,2)*(9D0-12D0*XSW2+8D0*XSW2**2))/XSW2
        K(10) = 4D0*C0*(3D0-2D0*XSW2)+(3D0*C1(1)*(3D0+3D0*QEPS-4D0*
     &  QEPS*XSW2))/XSW2+(3D0*C1(2)*(3D0-3D0*QEPS+4D0*QEPS*XSW2))/
     &  XSW2+(4D0*C2(1,2)*(9D0-12D0*XSW2+8D0*XSW2**2))/XSW2
        K(11) = S13+S14+S23+S24-2D0*XMQM2(I)
        K(12) = -((72D0*C2(0,0))/XSW2)-(3D0*C1(2)*(-(3D0*S13)-3D0*
     &  QEPS*S13-3D0*S14-3D0*QEPS*S14-3D0*S23+3D0*QEPS*S23-3D0*S24+
     &  3D0*QEPS*S24+6D0*S34+4D0*QEPS*S13*XSW2+4D0*QEPS*S14*XSW2-
     &  4D0*QEPS*S23*XSW2-4D0*QEPS*S24*XSW2))/XSW2-(3D0*C1(1)*(6D0*
     &  S12-3D0*S13+3D0*QEPS*S13-3D0*S14+3D0*QEPS*S14-3D0*S23-3D0*
     &  QEPS*S23-3D0*S24-3D0*QEPS*S24-4D0*QEPS*S13*XSW2-4D0*QEPS*
     &  S14*XSW2+4D0*QEPS*S23*XSW2+4D0*QEPS*S24*XSW2))/XSW2+(2D0*
     &  (9D0-6D0*XSW2+4D0*XSW2**2))/XSW2-(4D0*C2(1,1)*S12*(9D0-6D0*
     &  XSW2+4D0*XSW2**2))/XSW2+(4D0*C2(1,2)*(S13+S14+S23+S24)*(9D0-
     &  6D0*XSW2+4D0*XSW2**2))/XSW2-(4D0*C2(2,2)*S34*(9D0-6D0*XSW2+
     &  4D0*XSW2**2))/XSW2+4D0*C0*(3D0-2D0*XSW2)*(S13+S14+S23+S24-
     &  2D0*XMQM2(I))
        K(13) = 6D0*S12-3D0*S13-3D0*QEPS*S13-3D0*S14-3D0*QEPS*S14-
     &  3D0*S23+3D0*QEPS*S23-3D0*S24+3D0*QEPS*S24+4D0*QEPS*S13*XSW2+
     &  4D0*QEPS*S14*XSW2-4D0*QEPS*S23*XSW2-4D0*QEPS*S24*XSW2
        K(14) = 6D0*S12-3D0*S13+3D0*QEPS*S13-3D0*S14+3D0*QEPS*S14-
     &  3D0*S23-3D0*QEPS*S23-3D0*S24-3D0*QEPS*S24-4D0*QEPS*S13*XSW2-
     &  4D0*QEPS*S14*XSW2+4D0*QEPS*S23*XSW2+4D0*QEPS*S24*XSW2
        K(15) = -(3D0*S13)-3D0*QEPS*S13-3D0*S14-3D0*QEPS*S14-3D0*
     &  S23+3D0*QEPS*S23-3D0*S24+3D0*QEPS*S24+6D0*S34+4D0*QEPS*S13*
     &  XSW2+4D0*QEPS*S14*XSW2-4D0*QEPS*S23*XSW2-4D0*QEPS*S24*XSW2
        K(16) = 3D0*S13-3D0*QEPS*S13+3D0*S14-3D0*QEPS*S14+3D0*S23+
     &  3D0*QEPS*S23+3D0*S24+3D0*QEPS*S24-6D0*S34+4D0*QEPS*S13*XSW2+
     &  4D0*QEPS*S14*XSW2-4D0*QEPS*S23*XSW2-4D0*QEPS*S24*XSW2

        PRE = -((ALPHA*CDOH*PZ12*PZ34*XCW2**(-2)*XMQM2(I))/(384D0*
     &  PI*XMW))

        F(1,-1,-1) = F(1,-1,-1)-(K(1)*K(12)*K(2)*PRE)/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*K(1)*K(12)*QF(3)*PRE)/XSW
        F(1,1,-1) = F(1,1,-1)+(2D0*K(2)*QF(1)*PRE*(-((72D0*C2(0,0))/
     &  XSW2)-(3D0*C1(1)*K(13))/XSW2+(3D0*C1(2)*K(16))/XSW2+(2D0*
     &  K(7))/XSW2+(4D0*C2(1,2)*K(7)*K(8))/XSW2-(4D0*C2(1,1)*K(7)*
     &  S12)/XSW2-(4D0*C2(2,2)*K(7)*S34)/XSW2+4D0*K(3)*C0*(K(8)-2D0*
     &  XMQM2(I))))/XSW
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*(-((72D0*C2(0,0))/
     &  XSW)-(3D0*C1(1)*K(13))/XSW+(3D0*C1(2)*K(16))/XSW+(2D0*K(7))/
     &  XSW+(4D0*C2(1,2)*K(7)*K(8))/XSW-(4D0*C2(1,1)*K(7)*S12)/XSW-
     &  (4D0*C2(2,2)*K(7)*S34)/XSW+4D0*K(3)*C0*XSW*(K(8)-2D0*
     &  XMQM2(I)))
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(1)*K(2)*K(9)*PRE)/(XSW*XSW2)
        F(5,-1,1) = F(5,-1,1)+(4D0*K(1)*K(9)*QF(3)*PRE)/XSW
        F(5,1,-1) = F(5,1,-1)-(4D0*K(10)*K(2)*QF(1)*PRE)/XSW
        F(5,1,1) = F(5,1,1)-8D0*QF(1)*QF(3)*PRE*(4D0*K(3)*C0*XSW+
     &  (3D0*C1(2)*K(4))/XSW+(3D0*C1(1)*K(5))/XSW+(4D0*C2(1,2)*
     &  K(6))/XSW)
        F(6,-1,-1) = F(6,-1,-1)+(2D0*K(1)*K(10)*K(2)*PRE)/(XSW*XSW2)
        F(6,-1,1) = F(6,-1,1)+(4D0*K(1)*K(10)*QF(3)*PRE)/XSW
        F(6,1,-1) = F(6,1,-1)-(4D0*K(2)*K(9)*QF(1)*PRE)/XSW
        F(6,1,1) = F(6,1,1)-8D0*QF(1)*QF(3)*PRE*(4D0*K(3)*C0*XSW+
     &  (3D0*C1(1)*K(4))/XSW+(3D0*C1(2)*K(5))/XSW+(4D0*C2(1,2)*
     &  K(6))/XSW)
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(1)*K(2)*K(9)*PRE)/(XSW*XSW2)
        F(7,-1,1) = F(7,-1,1)+(4D0*K(1)*K(9)*QF(3)*PRE)/XSW
        F(7,1,-1) = F(7,1,-1)-(4D0*K(10)*K(2)*QF(1)*PRE)/XSW
        F(7,1,1) = F(7,1,1)-8D0*QF(1)*QF(3)*PRE*(4D0*K(3)*C0*XSW+
     &  (3D0*C1(2)*K(4))/XSW+(3D0*C1(1)*K(5))/XSW+(4D0*C2(1,2)*
     &  K(6))/XSW)
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(1)*K(10)*K(2)*PRE)/(XSW*XSW2)
        F(8,-1,1) = F(8,-1,1)+(4D0*K(1)*K(10)*QF(3)*PRE)/XSW
        F(8,1,-1) = F(8,1,-1)-(4D0*K(2)*K(9)*QF(1)*PRE)/XSW
        F(8,1,1) = F(8,1,1)-8D0*QF(1)*QF(3)*PRE*(4D0*K(3)*C0*XSW+
     &  (3D0*C1(1)*K(4))/XSW+(3D0*C1(2)*K(5))/XSW+(4D0*C2(1,2)*
     &  K(6))/XSW)

C       G(T9,N2327,FULL)

C       G(T9,N2328,FULL)

C       G(T9,N2329,FULL)

C       G(T9,N2330,FULL)

100	continue

	end

